diff -pruN 2.6.1-1/debian/changelog 2.7.0-1/debian/changelog
--- 2.6.1-1/debian/changelog	2021-10-22 10:46:07.000000000 +0000
+++ 2.7.0-1/debian/changelog	2022-08-06 10:56:15.000000000 +0000
@@ -1,3 +1,10 @@
+hsqldb (2.7.0-1) unstable; urgency=medium
+
+  * New upstream version 2.7.0.
+  * Declare compliance with Debian Policy 4.6.1.
+
+ -- Markus Koschany <apo@debian.org>  Sat, 06 Aug 2022 12:56:15 +0200
+
 hsqldb (2.6.1-1) unstable; urgency=medium
 
   * New upstream version 2.6.1.
diff -pruN 2.6.1-1/debian/control 2.7.0-1/debian/control
--- 2.6.1-1/debian/control	2021-10-22 10:46:07.000000000 +0000
+++ 2.7.0-1/debian/control	2022-08-06 10:56:15.000000000 +0000
@@ -11,7 +11,7 @@ Build-Depends:
  javahelper,
  libservlet-api-java,
  maven-repo-helper
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Git: https://salsa.debian.org/java-team/hsqldb.git
 Vcs-Browser: https://salsa.debian.org/java-team/hsqldb
 Homepage: http://hsqldb.org/
diff -pruN 2.6.1-1/debian/copyright 2.7.0-1/debian/copyright
--- 2.6.1-1/debian/copyright	2021-10-22 10:46:07.000000000 +0000
+++ 2.7.0-1/debian/copyright	2022-08-06 10:56:15.000000000 +0000
@@ -5,6 +5,8 @@ Files-Excluded:
  *.jar
  *.zip
  */apidocs/*
+ hsqldb/doc/apidocssqltool/jquery/*
+ hsqldb/doc/apidocssqltool/member-search-index.js
 
 Files: *
 Copyright: The HSQL Development Group
@@ -46,11 +48,15 @@ Files: hsqldb/integration/jackrabbit/res
 Copyright: Apache Software Foundation
 License: Apache-2.0
 
+Files: hsqldb/doc/apidocssqltool/script.js
+Copyright: Oracle and or its affiliates
+License: GPL-2-with-classpath-exception
+
 Files: debian/*
 Copyright: 2005-2007, Peter Eisentraut <petere@debian.org>
            2007-2013, Rene Engelhard <rene@debian.org>
            2013,      Niels Thykier <niels@thykier.net>
-           2015-2021, Markus Koschany <apo@debian.org>
+           2015-2022, Markus Koschany <apo@debian.org>
 License: BSD-3-clause-HSQLDB
 
 License: BSD-3-clause-HSQLDB
@@ -142,3 +148,42 @@ License: Apache-2.0
  On Debian systems, the full text of the Apache license 2.0
  can be found in the file '/usr/share/common-licenses/Apache-2.0'
 
+License: GPL-2-with-classpath-exception
+ This package is free software; you can redistribute it and/or modify
+ it under the terms of the GNU General Public License 2 as published by
+ the Free Software Foundation.
+ .
+ This package is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ GNU General Public License for more details.
+ .
+ You should have received a copy of the GNU General Public License
+ along with this program. If not, see <http://www.gnu.org/licenses/>
+ .
+ On Debian systems, the complete text of the GNU General
+ Public License version 2 can be found in "/usr/share/common-licenses/GPL-2".
+ .
+ "CLASSPATH" EXCEPTION TO THE GPL
+ .
+ Certain source files distributed by Oracle America and/or its affiliates are
+ subject to the following clarification and special exception to the GPL, but
+ only where Oracle has expressly included in the particular source file's header
+ the words "Oracle designates this particular file as subject to the "Classpath"
+ exception as provided by Oracle in the LICENSE file that accompanied this code."
+ .
+    Linking this library statically or dynamically with other modules is making
+    a combined work based on this library.  Thus, the terms and conditions of
+    the GNU General Public License cover the whole combination.
+ .
+    As a special exception, the copyright holders of this library give you
+    permission to link this library with independent modules to produce an
+    executable, regardless of the license terms of these independent modules,
+    and to copy and distribute the resulting executable under terms of your
+    choice, provided that you also meet, for each linked independent module,
+    the terms and conditions of the license of that module.  An independent
+    module is a module which is not derived from or based on this library.  If
+    you modify this library, you may extend this exception to your version of
+    the library, but you are not obligated to do so.  If you do not wish to do
+    so, delete this exception statement from your version.
+
diff -pruN 2.6.1-1/debian/patches/build.patch 2.7.0-1/debian/patches/build.patch
--- 2.6.1-1/debian/patches/build.patch	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/debian/patches/build.patch	2022-08-06 10:56:15.000000000 +0000
@@ -0,0 +1,22 @@
+From: Markus Koschany <apo@debian.org>
+Date: Sat, 6 Aug 2022 13:13:17 +0200
+Subject: build
+
+---
+ hsqldb/build/build.xml | 3 +--
+ 1 file changed, 1 insertion(+), 2 deletions(-)
+
+diff --git a/hsqldb/build/build.xml b/hsqldb/build/build.xml
+index f277928..35a28c1 100644
+--- a/hsqldb/build/build.xml
++++ b/hsqldb/build/build.xml
+@@ -256,8 +256,7 @@ examples:
+ 
+     <target name="mdesc-hsqldbmin" depends="sw-hsqldbmin" if="ant.java.iscjava11" >
+         <javac srcdir="${swsrcmin}"
+-               bootclasspath="${javac.bootcp.override}"
+-               sourcepath=""
++               sourcepath="${javac.bootcp.override}"
+                includeantruntime="false"
+                encoding="${javac.encoding}"
+                destdir="classes"
diff -pruN 2.6.1-1/debian/patches/series 2.7.0-1/debian/patches/series
--- 2.6.1-1/debian/patches/series	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/debian/patches/series	2022-08-06 10:56:15.000000000 +0000
@@ -0,0 +1 @@
+build.patch
diff -pruN 2.6.1-1/debian/rules 2.7.0-1/debian/rules
--- 2.6.1-1/debian/rules	2021-10-22 10:46:07.000000000 +0000
+++ 2.7.0-1/debian/rules	2022-08-06 10:56:15.000000000 +0000
@@ -7,8 +7,6 @@ export JAVA_HOME=/usr/lib/jvm/default-ja
 override_dh_auto_build:
 	dh_auto_build -- \
 		-f hsqldb/build/build.xml \
-		-Dant.build.javac.target=1.9 \
-		-Dant.build.javac.source=1.9 \
 		hsqldb hsqldbutil
 	$(MAKE) -C debian/bin all
 
diff -pruN 2.6.1-1/hsqldb/bin/runManager.bat 2.7.0-1/hsqldb/bin/runManager.bat
--- 2.6.1-1/hsqldb/bin/runManager.bat	2021-05-11 23:10:32.000000000 +0000
+++ 2.7.0-1/hsqldb/bin/runManager.bat	1970-01-01 00:00:00.000000000 +0000
@@ -1,2 +0,0 @@
-cd ..\data
-@java -classpath ..\lib\hsqldb-2.6.0-jdk8.jar org.hsqldb.util.DatabaseManager %1 %2 %3 %4 %5 %6 %7 %8 %9
diff -pruN 2.6.1-1/hsqldb/build/build-dist.gradle 2.7.0-1/hsqldb/build/build-dist.gradle
--- 2.6.1-1/hsqldb/build/build-dist.gradle	2021-04-27 13:18:48.000000000 +0000
+++ 2.7.0-1/hsqldb/build/build-dist.gradle	2022-07-09 23:41:50.000000000 +0000
@@ -1,5 +1,5 @@
 /**
- * $Id: build-dist.gradle 6338 2021-04-07 19:42:24Z fredt $
+ * $Id: build-dist.gradle 6575 2022-07-09 15:12:31Z unsaved $
  *
  * Invoke this build file with Gradle's -b switch for zip and jar
  * distribution building.
@@ -40,9 +40,8 @@
  *     11: Make a release tag.
  *
  *   USAGE:
- *       1: Set up your desired build environment (JAVA_HOME set, etc.).
- *       2: Do a Subversion export with the release tag to a NEW directory
- *       3: If you don't have a .properties file set up for this purpose
+ *       1: Do a Subversion export with the release tag to a NEW directory
+ *       2: If you don't have a .properties file set up for this purpose
  *          already, then make one outside of this work area with a distinctive
  *          name (for auditing and so you can archive it and/or re-use it for
  *          future distribution builds), then copy it to "build.properties"
@@ -51,10 +50,19 @@
  *          "dbimage.path".  (See following section about optional properties).
  *          Set property "doc.pubtime" to the current date/time in
  *          format like 2019-01-27 18:55:44.
- *       4: Run
- *              gradlew -i -b build-dist.gradle  # Gradle users
+ *       3: Set up your desired build environment (JAVA_HOME of JDK11, etc.).
+ *       4: For additional Java 8 jars, use regular late-model java (prev. step)
+ *          and cross-compile by setting build properties ant.build.javac and
+ *          javac.bootcp.override.  Make sure that build.debug=false.
+ *              gradlew hsqldb sqltool
  *          from the build directory.
- *       5: If you used a properties file shared with other environments,
+ *          After the jars are built, COMMENT OUT the cross-compile properties.
+ *       5: Run
+ *              gradlew -i -b build-dist.gradle
+ *          from the build directory..
+ *          After the distribution zip is built, it resides in /dist/ and will
+ *          be retained there if you proceed with the mvn-pub procedure.
+ *       6: If you used a properties file shared with other environments,
  *          then comment out distribution-specific build properties, including
  *          "doc.pubtime" (otherwise future document builds will label
  *          incorrectly).
diff -pruN 2.6.1-1/hsqldb/build/build-dist.xml 2.7.0-1/hsqldb/build/build-dist.xml
--- 2.6.1-1/hsqldb/build/build-dist.xml	2021-10-20 09:29:12.000000000 +0000
+++ 2.7.0-1/hsqldb/build/build-dist.xml	2022-06-12 15:00:02.000000000 +0000
@@ -1,6 +1,6 @@
 <?xml version="1.0"?>
 <!--
-$Id: build-dist.xml 6365 2021-07-19 09:10:13Z fredt $
+$Id: build-dist.xml 6560 2022-06-12 16:00:01Z fredt $
 -->
 
 <!-- N.b. the clean targets, even 'clean-all', do not clean the "dist"
@@ -68,8 +68,12 @@ and re-export.</fail>
   </target>
 
   <target name="dist"
-          depends="state-check, clean-all, gen-docs, sqltool, osgi, javadoc"
+          depends="state-check, clean-all, gen-docs"
           description="Build joint binary + source distribution zip package">
+    <antcall target="javadoc" inheritrefs="true"/>
+    <antcall target="osgi" inheritrefs="true"/>
+    <antcall target="javadocsqltool" inheritrefs="true"/>
+    <antcall target="sqltool" inheritrefs="true"/>
     <mkdir dir="dist"/>
     <property name="app.basedir" value="hsqldb-${hsqldb.version}"/>
 
@@ -156,7 +160,7 @@ and re-export.</fail>
       <zipfileset prefix="${app.basedir}/hsqldb/doc-src" dir="doc-src"
                   includes="changelist_2_0.txt,hsqldb_lic.txt,hypersonic_lic.txt"/>
       <zipfileset prefix="${app.basedir}/hsqldb/lib" dir="lib"
-                  includes="sqltool*.jar, servlet*.zip"/>
+                  includes="sqltool*.jar, javax.servlet-api*.jar"/>
       <zipfileset prefix="${app.basedir}/hsqldb/lib" dir="lib"
                   includes="hsqldb*.jar"/>
     </zip>
diff -pruN 2.6.1-1/hsqldb/build/build-docbook.xml 2.7.0-1/hsqldb/build/build-docbook.xml
--- 2.6.1-1/hsqldb/build/build-docbook.xml	2019-02-03 16:13:42.000000000 +0000
+++ 2.7.0-1/hsqldb/build/build-docbook.xml	2022-02-27 19:08:44.000000000 +0000
@@ -462,7 +462,8 @@ file.</echo>
     <fail unless="doc.name"
           message="Ant property 'doc.name' is required by target 'validate'."/>
     <pathconvert property="msvjar.file" refid="xcsde-rngval-jar.cpref"/>
-    <java fork="true" failonerror="true" dir="doc-src/${doc.name}"
+    <java fork="true" dir="doc-src/${doc.name}"
+          outputproperty="out" errorproperty="err" resultproperty="exec.val"
           classpath="${msvjar.file}" classpathref="xcsde-rngval-deps.cpref"
           classname="com.admc.xml.ResolvingSchematronDriver">
       <sysproperty key="xml.catalog.verbosity"
@@ -479,6 +480,14 @@ file.</echo>
       <arg value="${dbxirng.url}"/>
       <arg value="${doc.name}.xml"/>
     </java>
+    <condition property="_do-abort" value="DUMMY">
+      <not> <equals arg1="0" arg2="${exec.val}"/> </not>
+    </condition>
+    <fail if="_do-abort">Exiting due to Schematron JVM exit value ${exec.val}.
+JVM stdout: ---------------------------------------------------
+${out}
+JVM stderr: ---------------------------------------------------
+${err}</fail>
   </target>
 
   <target name="refresh-verbatim"
diff -pruN 2.6.1-1/hsqldb/build/build.gradle 2.7.0-1/hsqldb/build/build.gradle
--- 2.6.1-1/hsqldb/build/build.gradle	2020-11-30 11:01:58.000000000 +0000
+++ 2.7.0-1/hsqldb/build/build.gradle	2022-07-26 16:32:00.000000000 +0000
@@ -626,18 +626,18 @@ installDbImages.description = 'Install D
     tasks[it].group = 'Help'
 }
 ['hsqldb', 'hsqldbmin', 'hsqldbmain', 'hsqldbsources',
- 'hsqldbutil', 'osgi', 'preprocessor', 'sqltool', 'hsqldbtest',
+ 'hsqldbutil', 'osgi', 'preprocessor', 'sqltool', 'sqltoolsources',
  'dbmanswing'].each {
     tasks[it].group = 'HyperSQL Jar Generation'
 }
 ['checkTabs', 'serialver', 'standaloneValidation'].each {
     tasks[it].group = 'Utilities'
 }
-['gen-docs', 'regen-docs', 'installDbImages', 'javadoc', 'javadocdev',
- 'validate-doc', 'validate-docs'].each {
+['gen-docs', 'regen-docs', 'installDbImages', 'javadoc', 'javadocsqltool', 'javadocdev',
+ 'validate-doc', 'validate-docs', 'javadochsqldbjar', 'javadocsqltooljar'].each {
     tasks[it].group = 'Documentation System'
 }
-['classes', 'test', 'clean', 'clean-all', 'clean-docs'].each {
+['classes', 'clean', 'clean-all', 'clean-docs'].each {
     tasks[it].group = 'Lifecycle'
 }
 
diff -pruN 2.6.1-1/hsqldb/build/build.hsqldb.cmd 2.7.0-1/hsqldb/build/build.hsqldb.cmd
--- 2.6.1-1/hsqldb/build/build.hsqldb.cmd	2018-10-23 07:24:44.000000000 +0000
+++ 2.7.0-1/hsqldb/build/build.hsqldb.cmd	2022-02-21 14:42:10.000000000 +0000
@@ -1,2 +1,2 @@
 call setenv.cmd
-ant clean hsqldb
+call ant clean hsqldb
diff -pruN 2.6.1-1/hsqldb/build/build.hsqldbtest.cmd 2.7.0-1/hsqldb/build/build.hsqldbtest.cmd
--- 2.6.1-1/hsqldb/build/build.hsqldbtest.cmd	2018-10-23 07:24:42.000000000 +0000
+++ 2.7.0-1/hsqldb/build/build.hsqldbtest.cmd	2022-02-21 14:42:10.000000000 +0000
@@ -1,2 +1,2 @@
 call setenv.cmd
-ant clean hsqldb hsqldbtest
+call ant clean hsqldb hsqldbtest
diff -pruN 2.6.1-1/hsqldb/build/build.sqltool.cmd 2.7.0-1/hsqldb/build/build.sqltool.cmd
--- 2.6.1-1/hsqldb/build/build.sqltool.cmd	2018-10-23 07:24:42.000000000 +0000
+++ 2.7.0-1/hsqldb/build/build.sqltool.cmd	2022-02-21 14:42:10.000000000 +0000
@@ -1,2 +1,2 @@
 call setenv.cmd
-ant clean sqltool
+call ant clean sqltool
diff -pruN 2.6.1-1/hsqldb/build/build.test.suite.cmd 2.7.0-1/hsqldb/build/build.test.suite.cmd
--- 2.6.1-1/hsqldb/build/build.test.suite.cmd	2018-10-23 07:24:42.000000000 +0000
+++ 2.7.0-1/hsqldb/build/build.test.suite.cmd	2022-02-21 14:42:10.000000000 +0000
@@ -1,3 +1,3 @@
 call setenv.cmd
-ant clean hsqldb preprocessor sqltool
-ant -f test.xml clean.test.suite make.test.suite
+call ant clean hsqldb preprocessor sqltool
+call ant -f test.xml clean.test.suite make.test.suite
diff -pruN 2.6.1-1/hsqldb/build/build.xml 2.7.0-1/hsqldb/build/build.xml
--- 2.6.1-1/hsqldb/build/build.xml	2021-07-19 08:09:56.000000000 +0000
+++ 2.7.0-1/hsqldb/build/build.xml	2022-07-26 19:27:18.000000000 +0000
@@ -1,7 +1,7 @@
 <?xml version="1.0"?>
-<!-- $Id: build.xml 6365 2021-07-19 09:10:13Z fredt $ -->
-<!-- author fredt@users.sourceforge.net 2001 - 2021 -->
-<!-- additional targets 2004-2021: blaine (dot) simpson (at) admc (dot) com -->
+<!-- $Id: build.xml 6586 2022-07-26 19:49:29Z fredt $ -->
+<!-- author fredt@users.sourceforge.net 2001-2022 -->
+<!-- additional targets 2004-2022: blaine (dot) simpson (at) admc (dot) com -->
 <project name="hsqldb" default="help" basedir="../">
   <!--  To see what build properties you can change, see the property elements
         below.
@@ -16,22 +16,19 @@
         rephrase the question to yourself as "Can I run 'ant -Dx=...?"
         Do not address questions about property file(s) to the
         hsqldb community.
-        -->
 
-  <!-- TODO:
-        Use multiple class directories (javac dest dirs).
-        Current tactic requires tons of complicated includes and exludes
-        and still often bundles arbitrary extra stuff (determined by what
-        happened to be built previously). Mostly fixed in 2.5.1 and .2
-  -->
+    Example cross-compile settings for targeting Java 8.
+    This is syntax for inclusion in a build.properties file.
+    Can also set them in the build command with Ant or Gradle -D switches;
+    or an IDE's Ant or Gradle build settings.
+
+ant.build.javac.target=8
+javac.bootcp.override=/usr/lib/jvm/java-8-openjdk/jre/lib/rt.jar:/usr/lib/jvm/java-8-openjdk/jre/lib/jce.jar
+        -->
 
     <property file='build/build.properties'/>
 
-    <condition property="hsqldb.version" value="2.6.1">
-      <available classname="java.sql.JDBCType"/>
-    </condition>
-    <!-- hsqldb.version is set only once - if it is set above for Java 8 and greater, the next line is a no-op -->
-    <property name="hsqldb.version" value="2.3.9"/>
+    <property name="hsqldb.version" value="2.7.0"/>
 
     <tstamp>
       <format property="timestamp" pattern="yyyy/MM/dd-HH:mm:ss" locale="en"/>
@@ -48,12 +45,12 @@
 
     <!-- "switch.inplace" can be set in build.properties for in-place switching of source files-->
     <property name="tmpsrc" value="${basedir}/tmp/switchedsrc/"/>
-    <condition property="swsrc" value="${basedir}/src/" else="${tmpsrc}">
-      <istrue value="${switch.inplace}"/>
-    </condition>
-
-    <property name="libclonesrc" value="${swsrc}org/hsqldb/cmdline/libclone"/>
-    <property name="utilclonesrc" value="${swsrc}org/hsqldb/cmdline/utilclone"/>
+    <property name="modinfosrc" value="${basedir}/modinfo-src/"/>
+    <property name="swsrc" value="${tmpsrc}/org.hsqldb/src/main/java/"/>
+    <property name="swsrcmin" value="${tmpsrc}/org.hsqldb.min/src/main/java/"/>
+    <property name="swsrctool" value="${tmpsrc}/org.hsqldb.sqltool/src/main/java/"/>
+    <property name="libclonesrc" value="${swsrctool}org/hsqldb/cmdline/libclone"/>
+    <property name="utilclonesrc" value="${swsrctool}org/hsqldb/cmdline/utilclone"/>
 
     <!-- Hosting Junit 3.8.2 JavaDocs at hsqldb.org since it's not available
          expanded anywhere on Internet that I can find. -->
@@ -64,7 +61,7 @@
          build.properties file. -->
     <property name="build.debug" value="false"/>
 
-    <property name="servletapi.lib" value="lib/servlet-2_3-fcs-classfiles.zip"/>
+    <property name="servletapi.lib" value="lib/javax.servlet-api-3.1.0.jar"/>
     <property name="junit38.lib" value="lib/junit.jar"/>
     <property name='jflex.lib' value='lib/JFlex.jar'/>
 
@@ -114,25 +111,55 @@ examples:
          this target eliminates the redundancy in those methods by making a
          single class-existence-test definitively responsible for determining if
          JVM X is supported.
-         It is sufficient for this purposes if the test classes used are
+         It is sufficient for this purpose if the test classes used are
          verified to be present in version X and in all newer versions (> X)
          (i.e. that the class is not removed from some higher JVM). -->
-      <available classname="java.net.IDN" property="ant.java.iscjava06"/>
-      <available classname="java.sql.JDBCType" property="ant.java.iscjava08"/>
-      <available classname="java.sql.ShardingKey" property="ant.java.iscjava09"/>
+      <condition property="_crosswithoutbcp"> <and>
+        <isset property="ant.build.javac.target"/>
+        <not> <isset property="javac.bootcp.override"/> </not>
+      </and> </condition>
+      <fail if="_crosswithoutbcp">
+        If cross-compiling, you  must set property 'javac.bootcp.override'
+      </fail>
+      <echo>src originally {${ant.build.javac.source}}</echo>
+      <condition property="ant.build.javac.source"
+                 value="${ant.build.javac.target}">
+        <isset property="ant.build.javac.target"/>
+      </condition>
+      <condition property="ant.java.iscjava08"><and>
+        <available classname="java.sql.JDBCType" property="ant.java.iscjava08"/>
+        <!-- only need to check for EARLIER javac.target values, not later -->
+        <not><matches string="${ant.build.javac.target}"
+                      pattern="^(?:1[.])?(1|2|3|4|5|6|7)$"/></not>
+      </and></condition>
+      <condition property="ant.java.iscjava11"><and>
+        <available classname="java.sql.ShardingKey" property="ant.java.iscjava11"/>
+        <!-- only need to check for EARLIER javac.target values, not later -->
+        <not><matches string="${ant.build.javac.target}"
+                      pattern="^(?:1[.])?(1|2|3|4|5|6|7|8)$"/></not>
+      </and></condition>
+      <fail if="debug.targetjvm">
+        specified compile target: ${ant.build.javac.target}
+        derived version:  8?${ant.java.iscjava08}  11?${ant.java.iscjava11}
+        src (${ant.build.javac.source})
+        targ (${ant.build.javac.target})
+        bcp (${javac.bootcp.override})
+      </fail>
     </target>
 
     <target name="-prepare" depends="-set-jvmvars">
       <mkdir dir="classes" />
-      <mkdir dir="classes/modules/org.hsqldb" />
-      <delete dir="classes/modules/org.hsqldb" includes="**/*"/>
-      <mkdir dir="classes/modules/org.hsqldb.sqltool" />
-      <delete dir="classes/modules/org.hsqldb.sqltool" includes="**/*"/>
-      <mkdir dir="classes/modules/org.hsqldb.min" />
-      <delete dir="classes/modules/org.hsqldb.min" includes="**/*"/>
+      <mkdir dir="${swsrc}" />
+      <mkdir dir="${swsrcmin}" />
+      <mkdir dir="${swsrctool}" />
+
+      <condition property='jdk8string' value='' else='-jdk8'>
+        <isset property='ant.java.iscjava11'/>
+      </condition>
+
     </target>
 
-    <target name="-prepare-javadoc" depends="switches">
+    <target name="-prepare-javadoc" depends="sw-hsqldb">
       <delete dir="doc/apidocs"/>
       <!-- Must be vigilant about cleaning up from previous runs, since this
            same directory is used for both public API spec, and the full
@@ -145,22 +172,21 @@ examples:
              Add a fixcrlf if we add non-binary files to doc-src/apidocs. -->
         <fileset dir="doc-src/apidocs"/>
       </copy>
-      <copy todir="${swsrc}">
-          <fileset dir="src/modules/org.hsqldb/"/>
-      </copy>
-      <delete file="${swsrc}org/hsqldb/server/Servlet.java"/>
     </target>
 
-    <target name="reinit"
-        description="Just like 'clean' target, except overwrites switched source files to prevent need for a complete re-copy">
-        <!-- Beware this will refresh a copy of removed artifacts under swsrc.
-             You must use the real 'clean' target to really purge everything. -->
-      <fail message="Just use 'clean' for inplace-switching setups"
-              if="switch.inplace"/>
-      <delete dir="classes"/>
-      <copy todir='${swsrc}' preservelastmodified='true'>
-        <fileset dir='src' includes='**/*.java'/>
-      </copy>
+    <target name="-prepare-javadoc-sqltool" depends="sw-sqltool">
+        <delete dir="doc/apidocssqltool"/>
+        <!-- Must be vigilant about cleaning up from previous runs, since this
+             same directory is used for both public API spec, and the full
+             code-base API spec.
+             There is no performance penalty, since the javadoc task regenerates
+             everything each run.
+         -->
+        <copy todir="doc/apidocssqltool">
+            <!-- IMPORTANT:
+                 Add a fixcrlf if we add non-binary files to doc-src/apidocs. -->
+            <fileset dir="doc-src/apidocs"/>
+        </copy>
     </target>
 
     <target name="clean" depends="-clean, -clean-switch-branch"
@@ -179,132 +205,77 @@ examples:
     <target name="clean-all" depends="-clean, -clean-switch-branch, clean-docs"
             description="Same as clean but delete the jar and doc files as well">
       <delete>
-        <fileset dir="lib" includes="sqltool.jar, hsqldb.jar, testsuite.jar"/>
+        <fileset dir="lib" includes="sqltool.jar, hsqldb.jar, hsqldb-osgi.jar"/>
       </delete>
     </target>
 
-    <target name="codeswitcher" depends="-prepare"
-            description="uses +-JAVA6 +-JAVA8 etc">
-      <javac destdir="classes" includeantruntime="false">
-        <src path="src"/>
-        <include name="org/hsqldb/util/CodeSwitcher.java"/>
-      </javac>
-      <antcall target="-update-switch-branch"/>
-    </target>
+    <target name="sw-sqltool" depends="-prepare">
+        <delete file="classes/module-info.class"/>
+        <delete file="${swsrctool}/module-info.java"/>
+        <mkdir dir='${swsrctool}/org/hsqldb/cmdline'/>
+        <copy todir='${swsrctool}/org/hsqldb/cmdline' preservelastmodified='true'>
+            <fileset dir='src/org/hsqldb/cmdline' includes='**/*'/>
+        </copy>
+        <antcall target="-clone-shared-sources" inheritrefs="true"/>
 
-    <target name="switchtodeprecatedjdbc" depends="codeswitcher"
-            description="self explanatory">
-      <java classname="org.hsqldb.util.CodeSwitcher" classpath="classes" >
-        <arg file="${swsrc}/org/hsqldb/jdbc/JDBCCallableStatement.java"/>
-        <arg file="${swsrc}/org/hsqldb/jdbc/JDBCPreparedStatement.java"/>
-        <arg file="${swsrc}/org/hsqldb/jdbc/JDBCResultSet.java"/>
-        <arg value="+DEPRECATEDJDBC"/>
-      </java>
+        <antcall target="-copy-mdescriptor" inheritrefs="true">
+            <param name="module.name" value="org.hsqldb.sqltool"/>
+        </antcall>
     </target>
 
-    <target name="switchoffdeprecatedjdbc" depends="codeswitcher"
-            description="self explanatory">
-      <java classname="org.hsqldb.util.CodeSwitcher" classpath="classes" >
-        <arg file="${swsrc}/org/hsqldb/jdbc/JDBCCallableStatement.java"/>
-        <arg file="${swsrc}/org/hsqldb/jdbc/JDBCPreparedStatement.java"/>
-        <arg file="${swsrc}/org/hsqldb/jdbc/JDBCResultSet.java"/>
-        <arg value="-DEPRECATEDJDBC"/>
-      </java>
+    <target name="sw-hsqldb-exclude" if="ant.java.iscjava11">
+        <delete file="${swsrc}/org/hsqldb/server/Servlet.java"/>
     </target>
 
-    <!-- If this should not be called externally, rename to -switches
-         and remove the description attribute -->
-    <target name="switches" depends="codeswitcher, -autoswitch"
-            description="execute code switchers for current JVM version">
-    </target>
-
-    <!-- the args for default code switching are set and used -->
-    <condition property="switchargone" value="+JAVA8" else="-JAVA8">
-      <available classname="java.sql.JDBCType"/>
-    </condition>
-
-    <condition property="switchargtwo" value="+JAVA9" else="-JAVA9">
-      <available classname="java.sql.ShardingKey"/>
-    </condition>
-
-    <target name="-autoswitch" description="switch code to current JVM">
-      <java classname="org.hsqldb.util.CodeSwitcher" classpath="classes" >
-        <arg value="${switchargone}"/>
-        <arg value="${switchargtwo}"/>
-        <arg value="--pathlist=${basedir}/build/jdkcodeswitch.list"/>
-        <arg value="--basedir=${swsrc}"/>
-        <!-- Since these paths are interpreted by the JVM, not ant,
-             the path must be relative to run dir (build), not the
-             Ant basedir -->
-      </java>
-      <echo> "${basedir}/build/jdkcodeswitch.list"</echo>
-    </target>
 
-    <!-- these are used for checking the correctness of switched code blocks -->
-    <target name="switchtojdk6" depends="codeswitcher"
-            description="self explanatory">
-      <java classname="org.hsqldb.util.CodeSwitcher" classpath="classes" >
-        <arg value="-JAVA8"/>
-        <arg value="-JAVA9"/>
-        <arg value="--pathlist=${basedir}/build/jdkcodeswitch.list"/>
-        <arg value="--basedir=${swsrc}"/>
-        <!-- Since these paths are interpreted by the JVM, not ant,
-             the path must be relative to run dir (build), not the
-             Ant basedir -->
-      </java>
-    </target>
+    <target name="sw-hsqldb" depends="-prepare">
+        <delete file="classes/module-info.class"/>
+        <delete file="${swsrc}/module-info.java"/>
+        <copy todir='${swsrc}' preservelastmodified='true'>
+            <fileset dir='src' includes='**/*'
+                     excludes="org/hsqldb/cmdline org/hsqldb/sample/**/*
+                     org/hsqldb/test/**/*"
+            />
+        </copy>
 
-    <target name="switchtojdk8" depends="codeswitcher"
-            description="self explanatory" if="ant.java.iscjava08">
-      <java classname="org.hsqldb.util.CodeSwitcher" classpath="classes" >
-        <arg value="+JAVA8"/>
-        <arg value="-JAVA9"/>
-        <arg value="--pathlist=jdkcodeswitch.list"/>
-        <arg value="--basedir=${swsrc}"/>
-        <!-- Since these paths are interpreted by the JVM, not ant,
-             the path must be relative to run dir (build), not the
-             Ant basedir -->
-      </java>
+        <antcall target="sw-hsqldb-exclude" inheritrefs="true"/>
+
+        <antcall target="-copy-mdescriptor" inheritrefs="true">
+            <param name="module.name" value="org.hsqldb"/>
+        </antcall>
     </target>
 
-    <target name="switchtojdk9" depends="codeswitcher"
-            description="self explanatory" if="ant.java.iscjava09">
-      <java classname="org.hsqldb.util.CodeSwitcher" classpath="classes" >
-        <arg value="+JAVA8"/>
-        <arg value="+JAVA9"/>
-        <arg value="--pathlist=jdkcodeswitch.list"/>
-        <arg value="--basedir=${swsrc}"/>
-        <!-- Since these paths are interpreted by the JVM, not ant,
-             the path must be relative to run dir (build), not the
-             Ant basedir -->
-      </java>
+    <!-- an optional target that uses the same src dir as sw-hsqldb -->
+    <target name="sw-hsqldbmin" depends="-prepare">
+        <delete file="${swsrcmin}/module-info.java"/>
+
+        <antcall target="-copy-mdescriptor" inheritrefs="true">
+            <param name="module.name" value="org.hsqldb.min"/>
+        </antcall>
     </target>
 
-    <target name="-lib" depends="switches"
-            description="compiles the JVM-independent lib and map classes">
-      <javac srcdir="${swsrc}"
-             includeantruntime="false"
-             destdir="classes"
-             debug="${build.debug}"
-             encoding="${javac.encoding}"
-      >
-        <include name="org/hsqldb/map/**"/>
-        <include name="org/hsqldb/lib/**"/>
-        <exclude name="org/hsqldb/lib/AppendableException.java"/>
-        <exclude name="org/hsqldb/lib/RefCapablePropertyResourceBundle.java"/>
-        <exclude name="org/hsqldb/lib/RefCapableRBInterface.java"/>
-        <exclude name="org/hsqldb/lib/ValidatingResourceBundle.java"/>
-        <exclude name="org/hsqldb/lib/tar/**"/>
-      </javac>
+    <target name="mdesc-hsqldbmin" depends="sw-hsqldbmin" if="ant.java.iscjava11" >
+        <javac srcdir="${swsrcmin}"
+               bootclasspath="${javac.bootcp.override}"
+               sourcepath=""
+               includeantruntime="false"
+               encoding="${javac.encoding}"
+               destdir="classes"
+               debug="${build.debug}"
+               classpath="${servletapi.lib}">
+            <include name="module-info.java"/>
+        </javac>
+
     </target>
 
-    <target name="classes-servlet" description="compiles Servlet class" unless="ant.java.iscjava09">
+    <target name="classes-servlet" description="compiles Servlet class" unless="ant.java.iscjava11">
       <!-- 'unless' above should be removed once learn how to include in named module-->
       <available property='_servlet_available' classpath='${servletapi.lib}'
                  classname='javax.servlet.ServletException'/>
       <fail unless='_servlet_available'
             message="Place Jar file for Servlet API at '${servletapi.lib}', or set property 'servletapi.lib'"/>
       <javac srcdir="${swsrc}"
+             bootclasspath="${javac.bootcp.override}"
              sourcepath=""
              includeantruntime="false"
              encoding="${javac.encoding}"
@@ -315,9 +286,10 @@ examples:
       </javac>
     </target>
 
-    <target name="classes" depends="switches,-javajsse"
+    <target name="classes" depends="sw-hsqldb,-javajsse"
     description="compiles JVM-independent non-lib/util/cmdline/servlet classes">
       <javac srcdir="${swsrc}"
+             bootclasspath="${javac.bootcp.override}"
              includeantruntime="false"
              encoding="${javac.encoding}"
              destdir="classes"
@@ -355,9 +327,10 @@ examples:
                                                - blaine
 
    -->
-    <target name="-util" depends="-prepare"
+    <target name="-util" depends="-prepare, sw-hsqldb"
             description="compiles the util folder">
       <javac srcdir="${swsrc}"
+             bootclasspath="${javac.bootcp.override}"
              includeantruntime="false"
              encoding="${javac.encoding}"
              destdir="classes"
@@ -372,12 +345,13 @@ examples:
     </target>
 
     <target name="-preprocessor">
-      <!-- This javac is dependent upon default attr. includeAntRuntime=true -->
+      <!-- This javac is no longer dependent upon default attr. includeAntRuntime=true -->
+      <!-- Ant resolver and preprocessor moved to trunk/integration/ant/prepocessor/src -->
       <javac srcdir="src"
+             bootclasspath="${javac.bootcp.override}"
              encoding="${javac.encoding}"
              destdir="classes"
              debug="${build.debug}"
-             classpath="${ant.home}/lib/ant.jar"
       >
         <include name="org/hsqldb/util/preprocessor/**"/>
       </javac>
@@ -385,16 +359,17 @@ examples:
 
     <!-- compiles the cmdline classes -->
     <target name="-cmdline"
-            depends="-prepare, -update-switch-branch, -clone-shared-sources,
+            depends="-prepare, sw-sqltool,
                      -conditionalize-sqlfile-scanner, -sqlfile-scanner">
 
-      <javac srcdir="${swsrc}"
+      <javac srcdir="${swsrctool}"
+             bootclasspath="${javac.bootcp.override}"
              includeantruntime="false"
              encoding="${javac.encoding}"
              destdir="classes"
              debug="${build.debug}"
       >
-        <include name="org/hsqldb/cmdline/**"/>
+        <include name="**/*"/>
       </javac>
       <fixcrlf destdir="classes" preservelastmodified='true' eol="lf"
                encoding="ISO-8859-1" srcdir="src"
@@ -411,9 +386,10 @@ examples:
                value="org.hsqldb.cmdline.libclone"/>
     </target>
 
-    <target name="-swing" depends="switches"
+    <target name="-swing" depends="sw-hsqldb"
             description="compiles the swing based classes in the util folder">
       <javac srcdir="${swsrc}"
+             bootclasspath="${javac.bootcp.override}"
              includeantruntime="false"
              encoding="${javac.encoding}"
              destdir="classes"
@@ -423,6 +399,8 @@ examples:
         <include name="org/hsqldb/util/TableSorter.java"/>
         <include name="org/hsqldb/util/DatabaseManagerCommon.java"/>
         <include name="org/hsqldb/util/ConnectionSetting.java"/>
+        <include name="org/hsqldb/util/CSVWriter.java"/>
+        <include name="org/hsqldb/util/RCData.java"/>
       </javac>
     </target>
 
@@ -436,6 +414,7 @@ examples:
     <target name="scanner-driver" depends="-cmdline"
             description="Build Scanner Driver.  For SqlTool scanner developers.">
       <javac srcdir="${swsrc}"
+             bootclasspath="${javac.bootcp.override}"
              includeantruntime="false"
              encoding="${javac.encoding}"
              includes="org/hsqldb/test/SqlFileScannerDriver.java"
@@ -444,51 +423,26 @@ examples:
              />
     </target>
 
-    <target name="test" depends="-requireJunit, classes"
-            description="compiles the test package classes">
-      <javac srcdir="${swsrc}"
-             includeantruntime="false"
-             encoding="${javac.encoding}"
-             destdir="classes"
-             debug="${build.debug}"
-         >
-         <classpath>
-           <pathelement location="${junit38.lib}"/>
-           <pathelement location="lib/dbunit.jar"/>
-         </classpath>
-         <include name="org/hsqldb/test/**"/>
-         <!-- odbc tests require Junit 4.10-->
-         <exclude name="org/hsqldb/test/odbc/**"/>
-         <exclude name="org/hsqldb/test/SqlFileScannerDriver.java"/>
-      </javac>
-    </target>
-
-    <!--jar with (jdkversion-switched) sources, useful for reading/debugging the code from other projects, can be specified via maven too-->
+    <!--jar with sources for hsqldb.jar, useful for reading/debugging the code from other projects, can be specified via maven too-->
     <target name="hsqldbsources" description="builds jar file containing source code"
-            depends="switches">
-        <jar jarfile="lib/hsqldb-sources.jar" basedir="tmp/switchedsrc">
+            depends="sw-hsqldb">
+        <jar jarfile="lib/hsqldb-sources.jar" basedir="${swsrc}">
         </jar>
     </target>
 
-    <target name="hsqldbtest" depends="test, -prep-license-files"
-            description="Build the hsqldbtest.jar (default plus test classes)">
-      <jar jarfile="lib/hsqldbtest.jar" basedir="classes">
-        <metainf dir="doc" includes="*_lic.txt"/>
-        <service type="java.sql.Driver" provider="org.hsqldb.jdbc.JDBCDriver"/>
-        <manifest>
-          <attribute name='Specification-Title' value='${hsqldb.title}'/>
-          <attribute name='Specification-Version' value='${hsqldb.version}'/>
-          <attribute name='Specification-Vendor' value='${hsqldb.vendor}'/>
-          <attribute name='Implementation-Title' value='Test runtime'/>
-          <attribute name='Implementation-Version' value='${build.label}'/>
-          <attribute name='Implementation-Vendor' value='${build.vendor}'/>
-        </manifest>
-        <exclude name="org/hsqldb/sample/*"/>
-      </jar>
+    <!--jar with sources for sqltool.jar, useful for reading/debugging the code from other projects, can be specified via maven too-->
+    <target name="sqltoolsources" description="builds jar file containing SqlTool source code"
+            depends="sw-sqltool">
+        <jar jarfile="lib/sqltool-sources.jar" basedir="${swsrctool}">
+        </jar>
     </target>
 
     <fileset id='empty.fileset' dir='z:y:w:/nosuch' erroronmissingdir="false"/>
 
+    <fileset id='modinfoclass' dir='classes'
+        includes='module-info.class'
+    />
+
     <fileset id='minclasses' dir='classes'
         includes='
             org/hsqldb/*.class
@@ -567,12 +521,9 @@ examples:
             '
     />
 
-    <target name="hsqldbmin" depends="classes, -prep-license-files"
+    <target name="hsqldbmin" depends="classes, mdesc-hsqldbmin, -prep-license-files"
             description="Build the hsqldbmin.jar (no servers)">
-      <antcall target="-compile-mdescriptor" inheritrefs="true">
-        <param name="module.name" value="org.hsqldb.min"/>
-      </antcall>
-      <jar jarfile="lib/hsqldbmin.jar" duplicate='preserve'>
+      <jar jarfile="lib/hsqldbmin${jdk8string}.jar" duplicate='preserve'>
         <metainf dir="doc" includes="*_lic.txt"/>
         <service type="java.sql.Driver" provider="org.hsqldb.jdbc.JDBCDriver"/>
         <manifest>
@@ -586,13 +537,13 @@ examples:
           <attribute name='Sealed' value='true'/>
         </manifest>
         <fileset refid='minclasses' />
-        <fileset dir="classes/modules/org.hsqldb.min"/>
+        <fileset refid='modinfoclass'/>
       </jar>
     </target>
 
     <target name="hsqldbmain" depends="classes, -prep-license-files"
             description="Build the hsqldbmain.jar (no utilities)">
-      <jar jarfile="lib/hsqldbmain.jar" duplicate='preserve'>
+      <jar jarfile="lib/hsqldbmain${jdk8string}.jar" duplicate='preserve'>
         <metainf dir="doc" includes="*_lic.txt"/>
         <service type="java.sql.Driver" provider="org.hsqldb.jdbc.JDBCDriver"/>
         <manifest>
@@ -613,16 +564,12 @@ examples:
     <target name="hsqldb"
             depends="classes, -util, -prep-license-files, classes-servlet, -set-jar.exec.path"
             description="Build the default hsqldb.jar">
-      <antcall target="-compile-mdescriptor" inheritrefs="true">
-        <param name="module.name" value="org.hsqldb"/>
-      </antcall>
-      <condition property="fileset.ref" value="empty.fileset">
-        <isset property="ant.java.iscjava09"/>
+      <condition property="filesetawt.ref" value="empty.fileset">
+        <isset property="ant.java.iscjava11"/>
       </condition>
-      <property name="fileset.ref" value="dbmanagerawtaddedclasses"/>
+      <property name="filesetawt.ref" value="dbmanagerawtaddedclasses"/>
 
-      <property name="hsqldb.module.dir" value="classes/modules/org.hsqldb"/>
-      <jar jarfile="lib/hsqldb.jar" duplicate='preserve'>
+      <jar jarfile="lib/hsqldb${jdk8string}.jar" duplicate='preserve'>
         <metainf dir="doc" includes="*_lic.txt"/>
         <service type="java.sql.Driver" provider="org.hsqldb.jdbc.JDBCDriver"/>
         <manifest>
@@ -639,21 +586,31 @@ examples:
         <fileset refid='mainaddedclasses' />
         <fileset refid='dbmanagerswingclasses' />
 
-        <fileset refid='${fileset.ref}' />
-        <fileset dir='${hsqldb.module.dir}'/>
+        <fileset refid='${filesetawt.ref}' />
+        <fileset refid='modinfoclass'/>
       </jar>
 
       <!-- Ant jar task doesn't support -e / -Main-Class switch! -->
-      <exec executable="${jar.exec.path}" dir="lib" failonerror="true">
+      <exec executable="${jar.exec.path}" dir="lib"
+            outputproperty="out.1" errorproperty="err.1"
+            resultproperty="exec.val.1">
         <arg value="-ufe"/>
-        <arg value="hsqldb.jar"/>
+        <arg value="hsqldb${jdk8string}.jar"/>
         <arg value="org.hsqldb.util.DatabaseManagerSwing"/>
       </exec>
+      <condition property="_do-abort" value="DUMMY">
+        <not> <equals arg1="0" arg2="${exec.val.1}"/> </not>
+      </condition>
+      <fail if="_do-abort">Exiting due to 'jar' exit value ${exec.val.1}.
+JVM stdout: ---------------------------------------------------
+${out.1}
+JVM stderr: ---------------------------------------------------
+${err.1}</fail>
     </target>
 
-    <target name="dbmanswing" depends="-swing, -lib, -prep-license-files"
+    <target name="dbmanswing" depends="-swing, -prep-license-files"
             description="Build the dbmanagerswing.jar">
-      <jar jarfile="lib/dbmanagerswing.jar" duplicate='preserve' filesonly="true">
+      <jar jarfile="lib/dbmanagerswing${jdk8string}.jar" duplicate='preserve' filesonly="true">
         <metainf dir="doc" includes="*_lic.txt"/>
         <manifest>
           <attribute name='Specification-Title' value='${hsqldb.title}'/>
@@ -664,23 +621,22 @@ examples:
           <attribute name='Implementation-Version' value='${build.label}'/>
           <attribute name='Implementation-Vendor' value='${build.vendor}'/>
           <attribute name='Main-Class' value='org.hsqldb.util.DatabaseManagerSwing'/>
+          <attribute name='Class-Path'
+                     value='hsqldb-${hsqldb.version}.jar hsqldb.jar hsqldbmin.jar hsqldbmain.jar'/>
           <attribute name='Sealed' value='true'/>
         </manifest>
         <fileset refid='dbmanagerswingclasses'/>
       </jar>
     </target>
 
-    <target name="-compile-mdescriptor" if="ant.java.iscjava09">
-      <fail unless='module.name'
-            message="Target '-compile-mdescriptor' called when prop 'module.name'not set"/>
-      <mkdir dir='classes/modules/${module.name}'/>
-      <javac srcdir="${swsrc}/modules/${module.name}"
-             sourcepath="${swsrc}"
-             includeantruntime="false"
-             encoding="${javac.encoding}"
-             destdir="classes/modules/${module.name}"
-             debug="${build.debug}"
-      />
+    <target name="-copy-mdescriptor" if="ant.java.iscjava11">
+        <fail unless='module.name'
+              message="Target '-copy-mdescriptor' called when prop 'module.name'not set"/>
+        <!-- Ant apparently has a low resolution for distinguishing time
+             differences: -->
+        <sleep seconds="1"/>
+        <copy todir="${tmpsrc}/${module.name}/src/main/java/" overwrite="true"
+              file="${modinfosrc}${module.name}/module-info.java"/>
     </target>
 
     <target name="-set-jar.exec.path">
@@ -696,12 +652,9 @@ examples:
     </target>
 
     <target name="sqltool"
-            depends="-lib, -cmdline, -prep-license-files, -set-jar.exec.path"
+            depends="-cmdline, -prep-license-files, -set-jar.exec.path"
             description="Build 'sqltool.jar' file">
-      <antcall target="-compile-mdescriptor" inheritrefs="true">
-        <param name="module.name" value="org.hsqldb.sqltool"/>
-      </antcall>
-      <jar jarfile="lib/sqltool.jar" duplicate='preserve' filesonly="true">
+      <jar jarfile="lib/sqltool${jdk8string}.jar" duplicate='preserve' filesonly="true">
         <metainf dir="doc" includes="*hsqldb_lic.txt"/>
         <manifest>
           <attribute name='Specification-Title' value='${hsqldb.title}'/>
@@ -711,20 +664,30 @@ examples:
           <attribute name='Implementation-Version' value='${build.label}'/>
           <attribute name='Implementation-Vendor' value='${build.vendor}'/>
           <attribute name='Class-Path'
-              value='hsqldb-${hsqldb.version}.jar hsqldb.jar hsqldbmain.jar'/>
+              value='hsqldb-${hsqldb.version}.jar hsqldb.jar hsqldbmin.jar hsqldbmain.jar'/>
           <attribute name='Sealed' value='true'/>
         </manifest>
         <fileset refid='sqltoolclasses'/>
         <fileset refid='sqltoolres'/>
-        <fileset dir="classes/modules/org.hsqldb.sqltool"/>
+        <fileset refid='modinfoclass'/>
       </jar>
 
       <!-- Ant jar task doesn't support -e switch! -->
-      <exec executable="${jar.exec.path}" dir="lib" failonerror="true">
+      <exec executable="${jar.exec.path}" dir="lib"
+            outputproperty="out.2" errorproperty="err.2"
+            resultproperty="exec.val.2">
         <arg value="-ufe"/>
-        <arg value="sqltool.jar"/>
+        <arg value="sqltool${jdk8string}.jar"/>
         <arg value="org.hsqldb.cmdline.SqlTool"/>
       </exec>
+      <condition property="_do-abort" value="DUMMY">
+        <not> <equals arg1="0" arg2="${exec.val.2}"/> </not>
+      </condition>
+      <fail if="_do-abort">Exiting due to 'jar' exit value ${exec.val.2}.
+JVM stdout: ---------------------------------------------------
+${out.2}
+JVM stderr: ---------------------------------------------------
+${err.2}</fail>
     </target>
 
     <target name="-clone-shared-sources">
@@ -772,8 +735,8 @@ examples:
     </target>
 
     <target name="hsqldbutil" depends="-util, -prep-license-files"
-            description="Build the utility hsqldbutil.jar">
-      <jar jarfile="lib/hsqldbutil.jar" compress="true">
+            description="Build the Database Managers jar">
+      <jar jarfile="lib/hsqldbutil${jdk8string}.jar" compress="true">
         <metainf dir="doc" includes="*_lic.txt"/>
         <manifest>
           <attribute name='Specification-Title' value='${hsqldb.title}'/>
@@ -783,9 +746,9 @@ examples:
           value='Utilities runtime, without JDBC driver'/>
           <attribute name='Implementation-Version' value='${build.label}'/>
           <attribute name='Implementation-Vendor' value='${build.vendor}'/>
-          <attribute name='Main-Class' value='org.hsqldb.cmdline.SqlTool'/>
+          <attribute name='Main-Class' value='org.hsqldb.util.DatabaseManagerSwing'/>
           <attribute name='Class-Path'
-          value='hsqldb-${hsqldb.version}.jar hsqldbmain.jar hsqldb.jar'/>
+          value='hsqldb-${hsqldb.version}.jar hsqldb.jar hsqldbmin.jar hsqldbmain.jar'/>
           <attribute name='Sealed' value='true'/>
         </manifest>
         <fileset refid='utilclasses'/>
@@ -795,13 +758,26 @@ examples:
     <!-- We use this target to create hsqldb-jdk8.jar and sqltool-jdk8.jar for the zip distro -->
     <target name="jdk8jars" depends="osgi, sqltool"
             description="Build hsqldb-osgi.jar and sqltool.jar for jdk 8 targets and rename"
-            if="ant.java.iscjava08" unless="ant.java.iscjava09">
-        <move file="lib/hsqldb-osgi.jar" tofile="lib/hsqldb-jdk8.jar"/>
-        <move file="lib/sqltool.jar" tofile="lib/sqltool-jdk8.jar"/>
+            if="ant.java.iscjava08" unless="ant.java.iscjava11">
+        <move file="lib/hsqldb-osgi-jdk8.jar" tofile="lib/hsqldb-jdk8.jar"/>
+    </target>
+
+    <!--jar with javadoc-->
+    <target name="javadochsqldbjar" description="builds jar file containing javadoc">
+        <jar jarfile="lib/hsqldb-javadoc.jar" basedir="${basedir}/doc/apidocs/">
+        </jar>
+    </target>
+
+    <!--jar with javadoc for sqltool-->
+    <target name="javadocsqltooljar" description="builds jar file containing SqlTool javadoc">
+        <jar jarfile="lib/sqltool-javadoc.jar" basedir="${basedir}/doc/apidocssqltool/">
+        </jar>
     </target>
 
-    <target name="javadoc" depends="-prepare-javadoc, -clone-shared-sources, -set-jvmvars"
-            description="Create javadoc for the distribution package">
+
+    <target name="javadoc" depends="-prepare-javadoc, -set-jvmvars"
+            description="Create javadoc for the org.hsqldb module">
+      <delete file="${swsrc}org/hsqldb/server/Servlet.java"/>
       <javadoc
            destdir="doc/apidocs"
            stylesheetfile="doc-src/apidocs/javadoc.css"
@@ -815,11 +791,7 @@ examples:
            verbose="false"
            windowtitle="${hsqldb.title} ${hsqldb.version} API"
            doctitle="${hsqldb.title} ${hsqldb.version}"
-           bottom="&lt;i&gt;Copyright &#169; 2001 - 2021 HSQL Development Group.&lt;/i&gt;">
-           <classpath>
-             <pathelement location="${servletapi.lib}"/>
-             <pathelement location="${junit38.lib}"/>
-           </classpath>
+           bottom="&lt;i&gt;Copyright &#169; 2001 - 2022 HSQL Development Group.&lt;/i&gt;">
            <packageset dir="${swsrc}">
               <include name='org/hsqldb/auth'/>
               <include name='org/hsqldb/jdbc'/>
@@ -842,15 +814,48 @@ examples:
          srcdir="doc/apidocs" includes="**/*.css, **/*.html, **/package-list"/>
     </target>
 
+    <target name="javadocsqltool" depends="-prepare-javadoc-sqltool, -set-jvmvars"
+            description="Create javadoc for the org.hsqldb.sqltool module">
+        <javadoc
+                destdir="doc/apidocssqltool"
+                stylesheetfile="doc-src/apidocs/javadoc.css"
+                docencoding="UTF-8"
+                charset="UTF-8"
+                author="true"
+                version="false"
+                use="true"
+                public="true"
+                failonerror="false"
+                verbose="false"
+                windowtitle="${hsqldb.title} ${hsqldb.version} API"
+                doctitle="${hsqldb.title} ${hsqldb.version}"
+                bottom="&lt;i&gt;Copyright &#169; 2001 - 2022 HSQL Development Group.&lt;/i&gt;">
+            <packageset dir="${swsrctool}">
+                <include name='org/hsqldb/cmdline'/>
+                <include name='org/hsqldb/libclone'/>
+                <include name='org/hsqldb/utilclone'/>
+            </packageset>
+            <tag name="todo" enabled="false"/>
+            <tag name="revised" enabled="false"/>
+            <tag name="jboss.xmbean" enabled="false"/>
+            <tag name="jmx.mbean" enabled="false"/>
+            <tag name="jmx.managed-attribute" enabled="false"/>
+            <tag name="jmx.managed-operation" enabled="false"/>
+            <tag name="jmx.managed-operation-parameter" enabled="false"/>
+        </javadoc>
+        <fixcrlf preservelastmodified='true' eol="lf" encoding="UTF-8"
+                 srcdir="doc/apidocssqltool" includes="**/*.css, **/*.html, **/package-list"/>
+    </target>
+
     <target name="javadocdev"
-            depends="-prepare-javadoc, -clone-shared-sources,-set-jvmvars"
+            depends="-prepare-javadoc,-set-jvmvars"
             description="Create javadoc for all HSQLDB code-base classes">
       <!-- Since our preprocessor package compilatoin depends on the
            env-specific ant runtime lib via includeAntRuntime=true, Javadoc
            will fail to resolve Ant classes and produce error messages
            accordingly. -->
       <javadoc
-           destdir="doc/apidocs"
+           destdir="doc/apidocsdev"
            docencoding="UTF-8"
            stylesheetfile="doc-src/apidocs/javadoc.css"
            charset="UTF-8"
@@ -862,8 +867,9 @@ examples:
            failonerror="true"
            windowtitle="${hsqldb.title} ${hsqldb.version} Product Dev. API"
            doctitle="${hsqldb.title} ${hsqldb.version} Product"
-           bottom="&lt;i&gt;Copyright &#169; 2001 - 2021 HSQL Development Group.&lt;/i&gt;">
-           <fileset dir="${swsrc}" includes="org/**/*.java"/>
+           bottom="&lt;i&gt;Copyright &#169; 2001 - 2022 HSQL Development Group.&lt;/i&gt;">
+           <fileset dir="src" includes="org/**/*.java" excludes="org/hsqldb/test/**
+                org/hsqldb/sample/** org/hsqldb/cmdline/**"/>
            <!-- Fileset is really good for maintenance and control purposes,
                 but it makes the generator produce an incredible amount of
                 output when there are no errors.  The verbose attribute
@@ -916,7 +922,7 @@ examples:
         </targetfilelist>
       </dependset>
       -->
-      <copy todir="${swsrc}/org/hsqldb/cmdline/sqltool"
+      <copy todir="${swsrctool}/org/hsqldb/cmdline/sqltool"
             file="src/org/hsqldb/cmdline/sqltool/SqlFileScanner.java"/>
     </target>
 
@@ -937,19 +943,12 @@ examples:
     </target>
 
     <target name="-conditionalize-jflex" depends="-set-jvmvars">
-      <!-- JFlex will only run if SqlFileScanner.java does not exist
-           and ant.java.iscjava06 -->
+      <!-- JFlex will only run if SqlFileScanner.java does not exist -->
       <available property="jflex.skip" type="file"
                  file="src/org/hsqldb/cmdline/sqltool/SqlFileScanner.java"/>
-      <condition property="jflex.skip"> <not>
-        <isset property="ant.java.iscjava06"/>
-      </not> </condition>
     </target>
 
     <target name="-conditionalize-sqlfile-scanner" depends="-set-jvmvars">
-      <condition property="-sqlfile-scanner.skip"> <not>
-        <isset property="ant.java.iscjava06"/>
-      </not> </condition>
     </target>
 
     <!-- If called internally, always call the -conditionalize-flex target
@@ -1092,7 +1091,7 @@ optimizations) manually.
     <!-- See comments at top of "build-docbook.xml" about doc.target property -->
     <target name="validate-docs" depends="-ivy-setup"
           description="Validate project DocBook source files">
-    <!-- The depends above would be redundant, except that Gradle needs
+    <!-- The 'depends' above would be redundant, except that Gradle needs
          -ivy-setup to execute BEFORE the first antcall executes -->
 
       <!-- These doc-skip properties can be simplified once we require Ant 1.8 -->
@@ -1152,7 +1151,9 @@ optimizations) manually.
       <!-- Purposefully not using the bndwrap task available for this purpose,
            because the docs don't explain how to use the attributes clearly enough
            to figure out how to use it. -->
-      <java failonerror="true" fork="true" dir="lib" classpath="${bndjar.file}"
+      <java fork="true" dir="lib" classpath="${bndjar.file}"
+            outputproperty="out.0" errorproperty="err.0"
+            resultproperty="exec.val.0"
             classname="aQute.bnd.main.bnd">
         <sysproperty key="hsqldb.version" value="${hsqldb.version}"/>
         <sysproperty key="build.vendor" value="${user.name}"/>
@@ -1160,11 +1161,19 @@ optimizations) manually.
         <sysproperty key="hsqldb.title" value="${hsqldb.title}"/>
         <arg value="wrap"/>
         <arg value="--output"/>
-        <arg value="hsqldb-osgi.jar"/>
+        <arg value="hsqldb-osgi${jdk8string}.jar"/>
         <arg value="--properties"/>
         <arg file="build/hsqldb.bnd"/>
-        <arg value="hsqldb.jar"/>
+        <arg value="hsqldb${jdk8string}.jar"/>
       </java>
-      <delete file="lib/hsqldb.jar"/>
+      <condition property="_do-abort" value="DUMMY">
+        <not> <equals arg1="0" arg2="${exec.val.0}"/> </not>
+      </condition>
+      <fail if="_do-abort">Exiting due to BND JVM exit value ${exec.val.0}.
+JVM stdout: ---------------------------------------------------
+${out.0}
+JVM stderr: ---------------------------------------------------
+${err.0}</fail>
+      <delete file="lib/hsqldb${jdk8string}.jar"/>
     </target>
 </project>
diff -pruN 2.6.1-1/hsqldb/build/clean.test.suite.cmd 2.7.0-1/hsqldb/build/clean.test.suite.cmd
--- 2.6.1-1/hsqldb/build/clean.test.suite.cmd	2018-10-23 07:24:44.000000000 +0000
+++ 2.7.0-1/hsqldb/build/clean.test.suite.cmd	2022-02-21 14:42:10.000000000 +0000
@@ -1,2 +1,2 @@
 call setenv.cmd
-ant -f test.xml clean.test.suite
+call ant -f test.xml clean.test.suite
diff -pruN 2.6.1-1/hsqldb/build/mvn-pub.gradle 2.7.0-1/hsqldb/build/mvn-pub.gradle
--- 2.6.1-1/hsqldb/build/mvn-pub.gradle	2020-11-24 00:38:10.000000000 +0000
+++ 2.7.0-1/hsqldb/build/mvn-pub.gradle	2022-07-17 10:32:06.000000000 +0000
@@ -20,14 +20,26 @@
  * by 'build-dist' not by 'mvn-pub'.
  *
  * <PRE><CODE>
- *     gradlew -x sqltool -x osgi -b mvn-pub.gradle
+ *     gradlew -x sqltool -x hsqldb -b mvn-pub.gradle
  * </CODE></PRE>
  *
  * Now, for each alternative, adjust environment and build properties, like
- * by setting env var JAVA_HOME or build property 'build.debug', and run
+ * by setting build property 'build.debug', and run
  *
  * <PRE><CODE>
- *   gradlew -Pclassifier=NEW_CLASSIFIER -b mvn-pub.gradle clean-all uploadArchives
+ *   [single-command no longer works due to broken inter-dependencies:
+ *   gradlew -Pclassifier=NEW_CLASSIFIER -b mvn-pub.gradle clean-all uploadArchives]
+ *   gradlew -b mvn-pub.gradle clean-all
+ *   gradlew -Pclassifier=NEW_CLASSIFIER -b mvn-pub.gradle sqltool
+ *   gradlew -Pclassifier=NEW_CLASSIFIER -b mvn-pub.gradle hsqldb
+ *   gradlew -Pclassifier=NEW_CLASSIFIER -b mvn-pub.gradle -x sqltool -x hsqldb
+ *
+ *   # Restore regular build property values
+ *   pushd ../lib; mkdir ../safe.d; mv -v hsqldb.jar sqltool.jar ../safe.d/
+ *   mv -v hsqldb-jdk8.jar hsqldb.jar && mv -v sqltool-jdk8.jar sqltool.jar
+ *   popd
+ *   gradlew -Pclassifier=jdk8 -b mvn-pub.gradle -x sqltool -x hsqldb
+ *   
  * </CODE></PRE>
  * The clean-all will wipe .../doc, but the .../doc and everything else from
  * your original dist build will be retained in .../dist/*.zip.
@@ -197,18 +209,18 @@ uploadArchives { doFirst {
 // Funny name is work-around for Gradle sequencing bug
 task zJarDep { doLast {
     if (jar.archivePath.exists() && jar.archivePath.lastModified()
-            < file('../lib/hsqldb-osgi.jar').lastModified()) {
+            < file('../lib/hsqldb.jar').lastModified()) {
         logger.warn "Deleting $jar.archivePath.absolutePath"
         jar.archivePath.delete()
     }
 } }
 
 jar { doLast {
-    File srcFile = file('../lib/hsqldb-osgi.jar')
+    File srcFile = file('../lib/hsqldb.jar')
     jar.archivePath.setBytes(srcFile.bytes)
 } }
 
-jar.dependsOn = [osgi, zJarDep]
+jar.dependsOn = [hsqldb, zJarDep]
 if (project.hasProperty('classifier')) jar.classifier = project.classifier
 
 clean.dependsOn = [prohibitionMap['clean']]
@@ -233,10 +245,10 @@ sqltoolJar { doLast {
     sqltoolJar.archivePath.setBytes(srcFile.bytes)
 } }
 
-task sourcesJar(type: Jar, dependsOn:classes) {
-     classifier = 'sources'
-     //from sourceSets.main.allSource
-     from fileTree(dir: '../src')
+task sourcesJar(type: Jar, dependsOn:hsqldbsources) {
+    classifier = 'sources'
+    //from sourceSets.main.allSource
+    from { zipTree '../lib/hsqldb-sources.jar' }
 }
 sourcesJar.description = 'Build sources jar file'
 
@@ -247,11 +259,11 @@ task javadocJar(type: Jar, dependsOn:jav
 }
 javadocJar.description = 'Build javadoc jar file'
 
-task sqltoolSourcesJar(type: Jar, dependsOn:classes) {
+task sqltoolSourcesJar(type: Jar, dependsOn:sqltoolsources) {
     archiveBaseName = 'sqltool'
     classifier = 'sources'
     //from sourceSets.main.allSource
-    from fileTree(dir: '../src')
+    from { zipTree '../lib/sqltool-sources.jar' }
 }
 sqltoolSourcesJar.description = 'Build Sqltool sources jar file'
 
@@ -259,7 +271,7 @@ task sqltoolJavadocJar(type: Jar, depend
     archiveBaseName = 'sqltool'
     classifier = 'javadoc'
     //from javadoc.destinationDir
-    from fileTree(dir: '../doc/apidocs')
+    from fileTree(dir: '../doc/apidocssqltool')
 }
 sqltoolJavadocJar.description = 'Build Sqltool javadoc jar file'
  
diff -pruN 2.6.1-1/hsqldb/build/setenv.cmd 2.7.0-1/hsqldb/build/setenv.cmd
--- 2.6.1-1/hsqldb/build/setenv.cmd	2018-10-23 07:24:42.000000000 +0000
+++ 2.7.0-1/hsqldb/build/setenv.cmd	2022-02-21 14:42:08.000000000 +0000
@@ -1,7 +1,7 @@
 REM basic environment setup
 REM change as needed
 
-set JAVA_HOME=C:\Program Files\Java\jdk7
-set ANT_HOME=C:\java\lib\ant
+set JAVA_HOME=C:\Program Files\Java\jdk8
+set ANT_HOME=C:\Program Files\NetBeans-12.6\netbeans\extide\ant
 set ANT_OPTS=-Xmx512m
 set PATH=%JAVA_HOME%\bin;%ANT_HOME%\bin;%PATH%
diff -pruN 2.6.1-1/hsqldb/build/test.xml 2.7.0-1/hsqldb/build/test.xml
--- 2.6.1-1/hsqldb/build/test.xml	2021-03-20 09:02:12.000000000 +0000
+++ 2.7.0-1/hsqldb/build/test.xml	2022-05-18 09:38:44.000000000 +0000
@@ -21,7 +21,7 @@
    <!-- D E F A U L T  B U I L D  P R O P E R T I E S                        -->
    <!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
    <property name="test.suite.version"
-             value="2.2.3"/>
+             value="2.7.0"/>
 
    <property name="test.suite.title"
              value="HSQLDB Test Suite"/>
@@ -30,7 +30,7 @@
              value="The HSQL Development Group"/>
 
    <property name="test.suite.implementation.title"
-             value="SQL:2008 / JDBC 4.1 Conformance and Supporing Library Test Cases"/>
+             value="SQL:2016 / JDBC 4.3 Conformance and Supporing Library Test Cases"/>
 
    <property name="test.suite.implementation.label"
              value="private-${_tmpstamp}"/>
@@ -258,7 +258,9 @@
              errorproperty="tests.failed" >
           <batchtest todir="${test.results.dir}">
               <fileset dir="${test.src.dir}"
-                       includes="org/hsqldb/jdbc/**/*Test.java"/>
+                       includes="org/hsqldb/jdbc/**/*Test.java"
+					   excludes="org/hsqldb/jdbc/ScriptedTest.java"
+					   />
               <fileset dir="${test.src.dir}"
                        includes="org/hsqldb/lib/**/*Test.java"/>
               <fileset dir="${test.src.dir}"
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/allclasses.html 2.7.0-1/hsqldb/doc/apidocssqltool/allclasses.html
--- 2.6.1-1/hsqldb/doc/apidocssqltool/allclasses.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/allclasses.html	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,34 @@
+<!DOCTYPE HTML>
+<!-- NewPage -->
+<html lang="en">
+<head>
+<!-- Generated by javadoc (11.0.14.1) on Tue Jul 26 22:23:00 BST 2022 -->
+<title>All Classes (HSQLDB 2.7.0 API)</title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+<meta name="dc.created" content="2022-07-26">
+<link rel="stylesheet" type="text/css" href="javadoc.css" title="Style">
+<link rel="stylesheet" type="text/css" href="jquery/jquery-ui.css" title="Style">
+<script type="text/javascript" src="script.js"></script>
+<script type="text/javascript" src="jquery/jszip/dist/jszip.min.js"></script>
+<script type="text/javascript" src="jquery/jszip-utils/dist/jszip-utils.min.js"></script>
+<!--[if IE]>
+<script type="text/javascript" src="jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
+<![endif]-->
+<script type="text/javascript" src="jquery/jquery-3.5.1.js"></script>
+<script type="text/javascript" src="jquery/jquery-ui.js"></script>
+</head>
+<body>
+<h1 class="bar">All&nbsp;Classes</h1>
+<main role="main" class="indexContainer">
+<ul>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.BadSpecial.html" title="class in org.hsqldb.cmdline">SqlFile.BadSpecial</a></li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html" title="class in org.hsqldb.cmdline">SqlTool</a></li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.SqlToolException.html" title="class in org.hsqldb.cmdline">SqlTool.SqlToolException</a></li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolError.html" title="class in org.hsqldb.cmdline">SqlToolError</a></li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolSprayer.html" title="class in org.hsqldb.cmdline">SqlToolSprayer</a></li>
+</ul>
+</main>
+</body>
+</html>
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/allclasses-index.html 2.7.0-1/hsqldb/doc/apidocssqltool/allclasses-index.html
--- 2.6.1-1/hsqldb/doc/apidocssqltool/allclasses-index.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/allclasses-index.html	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,209 @@
+<!DOCTYPE HTML>
+<!-- NewPage -->
+<html lang="en">
+<head>
+<!-- Generated by javadoc (11.0.14.1) on Tue Jul 26 22:23:00 BST 2022 -->
+<title>All Classes (HSQLDB 2.7.0 API)</title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+<meta name="dc.created" content="2022-07-26">
+<link rel="stylesheet" type="text/css" href="javadoc.css" title="Style">
+<link rel="stylesheet" type="text/css" href="jquery/jquery-ui.css" title="Style">
+<script type="text/javascript" src="script.js"></script>
+<script type="text/javascript" src="jquery/jszip/dist/jszip.min.js"></script>
+<script type="text/javascript" src="jquery/jszip-utils/dist/jszip-utils.min.js"></script>
+<!--[if IE]>
+<script type="text/javascript" src="jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
+<![endif]-->
+<script type="text/javascript" src="jquery/jquery-3.5.1.js"></script>
+<script type="text/javascript" src="jquery/jquery-ui.js"></script>
+</head>
+<body>
+<script type="text/javascript"><!--
+    try {
+        if (location.href.indexOf('is-external=true') == -1) {
+            parent.document.title="All Classes (HSQLDB 2.7.0 API)";
+        }
+    }
+    catch(err) {
+    }
+//-->
+var data = {"i0":2,"i1":8,"i2":2,"i3":8,"i4":8,"i5":4,"i6":2};
+var tabs = {65535:["t0","All Classes"],2:["t2","Class Summary"],4:["t3","Enum Summary"],8:["t4","Exception Summary"]};
+var altColor = "altColor";
+var rowColor = "rowColor";
+var tableTab = "tableTab";
+var activeTableTab = "activeTableTab";
+var pathtoroot = "./";
+var useModuleDirectories = true;
+loadScripts(document, 'script');</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+<header role="banner">
+<nav role="navigation">
+<div class="fixedNav">
+<!-- ========= START OF TOP NAVBAR ======= -->
+<div class="topNav"><a id="navbar.top">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.top.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="org.hsqldb.sqltool/module-summary.html">Module</a></li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-summary.html">Package</a></li>
+<li>Class</li>
+<li>Use</li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-tree.html">Tree</a></li>
+<li><a href="deprecated-list.html">Deprecated</a></li>
+<li><a href="index-all.html">Index</a></li>
+<li><a href="help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_top">
+<li><a href="allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<ul class="navListSearch">
+<li><label for="search">SEARCH:</label>
+<input type="text" id="search" value="search" disabled="disabled">
+<input type="reset" id="reset" value="reset" disabled="disabled">
+</li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_top");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.top">
+<!--   -->
+</a></div>
+<!-- ========= END OF TOP NAVBAR ========= -->
+</div>
+<div class="navPadding">&nbsp;</div>
+<script type="text/javascript"><!--
+$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
+//-->
+</script>
+</nav>
+</header>
+<main role="main">
+<div class="header">
+<h1 title="All&amp;nbsp;Classes" class="title">All&nbsp;Classes</h1>
+</div>
+<div class="allClassesContainer">
+<ul class="blockList">
+<li class="blockList">
+<table class="typeSummary">
+<caption><span id="t0" class="activeTableTab"><span>All Classes</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Class Summary</a></span><span class="tabEnd">&nbsp;</span></span><span id="t3" class="tableTab"><span><a href="javascript:show(4);">Enum Summary</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Exception Summary</a></span><span class="tabEnd">&nbsp;</span></span></caption>
+<tr>
+<th class="colFirst" scope="col">Class</th>
+<th class="colLast" scope="col">Description</th>
+</tr>
+<tr id="i0" class="altColor">
+<td class="colFirst"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></td>
+<th class="colLast" scope="row">
+<div class="block">Encapsulation of SQL text and the environment under which it will be
+ executed with a JDBC Connection.</div>
+</th>
+</tr>
+<tr id="i1" class="rowColor">
+<td class="colFirst"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.BadSpecial.html" title="class in org.hsqldb.cmdline">SqlFile.BadSpecial</a></td>
+<th class="colLast" scope="row">
+<div class="block">Utility nested Exception class for internal use only.</div>
+</th>
+</tr>
+<tr id="i2" class="altColor">
+<td class="colFirst"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html" title="class in org.hsqldb.cmdline">SqlTool</a></td>
+<th class="colLast" scope="row">
+<div class="block">A command-line JDBC SQL tool supporting both interactive and
+ non-interactive usage.</div>
+</th>
+</tr>
+<tr id="i3" class="rowColor">
+<td class="colFirst"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.SqlToolException.html" title="class in org.hsqldb.cmdline">SqlTool.SqlToolException</a></td>
+<th class="colLast" scope="row">&nbsp;</th>
+</tr>
+<tr id="i4" class="altColor">
+<td class="colFirst"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolError.html" title="class in org.hsqldb.cmdline">SqlToolError</a></td>
+<th class="colLast" scope="row">
+<div class="block">Exceptions thrown by the SqlTool system externally to SqlFile.</div>
+</th>
+</tr>
+<tr id="i5" class="rowColor">
+<td class="colFirst"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></td>
+<th class="colLast" scope="row">
+<div class="block">Resource Bundle for SqlTool and associated classes.</div>
+</th>
+</tr>
+<tr id="i6" class="altColor">
+<td class="colFirst"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolSprayer.html" title="class in org.hsqldb.cmdline">SqlToolSprayer</a></td>
+<th class="colLast" scope="row">
+<div class="block">Sql Tool Sprayer.</div>
+</th>
+</tr>
+</table>
+</li>
+</ul>
+</div>
+</main>
+<footer role="contentinfo">
+<nav role="navigation">
+<!-- ======= START OF BOTTOM NAVBAR ====== -->
+<div class="bottomNav"><a id="navbar.bottom">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.bottom.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="org.hsqldb.sqltool/module-summary.html">Module</a></li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-summary.html">Package</a></li>
+<li>Class</li>
+<li>Use</li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-tree.html">Tree</a></li>
+<li><a href="deprecated-list.html">Deprecated</a></li>
+<li><a href="index-all.html">Index</a></li>
+<li><a href="help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_bottom">
+<li><a href="allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_bottom");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.bottom">
+<!--   -->
+</a></div>
+<!-- ======== END OF BOTTOM NAVBAR ======= -->
+</nav>
+<p class="legalCopy"><small><i>Copyright © 2001 - 2022 HSQL Development Group.</i></small></p>
+</footer>
+</body>
+</html>
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/allpackages-index.html 2.7.0-1/hsqldb/doc/apidocssqltool/allpackages-index.html
--- 2.6.1-1/hsqldb/doc/apidocssqltool/allpackages-index.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/allpackages-index.html	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,169 @@
+<!DOCTYPE HTML>
+<!-- NewPage -->
+<html lang="en">
+<head>
+<!-- Generated by javadoc (11.0.14.1) on Tue Jul 26 22:23:00 BST 2022 -->
+<title>All Packages (HSQLDB 2.7.0 API)</title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+<meta name="dc.created" content="2022-07-26">
+<link rel="stylesheet" type="text/css" href="javadoc.css" title="Style">
+<link rel="stylesheet" type="text/css" href="jquery/jquery-ui.css" title="Style">
+<script type="text/javascript" src="script.js"></script>
+<script type="text/javascript" src="jquery/jszip/dist/jszip.min.js"></script>
+<script type="text/javascript" src="jquery/jszip-utils/dist/jszip-utils.min.js"></script>
+<!--[if IE]>
+<script type="text/javascript" src="jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
+<![endif]-->
+<script type="text/javascript" src="jquery/jquery-3.5.1.js"></script>
+<script type="text/javascript" src="jquery/jquery-ui.js"></script>
+</head>
+<body>
+<script type="text/javascript"><!--
+    try {
+        if (location.href.indexOf('is-external=true') == -1) {
+            parent.document.title="All Packages (HSQLDB 2.7.0 API)";
+        }
+    }
+    catch(err) {
+    }
+//-->
+var pathtoroot = "./";
+var useModuleDirectories = true;
+loadScripts(document, 'script');</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+<header role="banner">
+<nav role="navigation">
+<div class="fixedNav">
+<!-- ========= START OF TOP NAVBAR ======= -->
+<div class="topNav"><a id="navbar.top">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.top.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="org.hsqldb.sqltool/module-summary.html">Module</a></li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-summary.html">Package</a></li>
+<li>Class</li>
+<li>Use</li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-tree.html">Tree</a></li>
+<li><a href="deprecated-list.html">Deprecated</a></li>
+<li><a href="index-all.html">Index</a></li>
+<li><a href="help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_top">
+<li><a href="allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<ul class="navListSearch">
+<li><label for="search">SEARCH:</label>
+<input type="text" id="search" value="search" disabled="disabled">
+<input type="reset" id="reset" value="reset" disabled="disabled">
+</li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_top");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.top">
+<!--   -->
+</a></div>
+<!-- ========= END OF TOP NAVBAR ========= -->
+</div>
+<div class="navPadding">&nbsp;</div>
+<script type="text/javascript"><!--
+$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
+//-->
+</script>
+</nav>
+</header>
+<main role="main">
+<div class="header">
+<h1 title="All&amp;nbsp;Packages" class="title">All&nbsp;Packages</h1>
+</div>
+<div class="allPackagesContainer">
+<ul class="blockList">
+<li class="blockList">
+<table class="packagesSummary">
+<caption><span>Package Summary</span><span class="tabEnd">&nbsp;</span></caption>
+<tr>
+<th class="colFirst" scope="col">Package</th>
+<th class="colLast" scope="col">Description</th>
+</tr>
+<tbody>
+<tr class="altColor">
+<th class="colFirst" scope="row"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-summary.html">org.hsqldb.cmdline</a></th>
+<td class="colLast">
+<div class="block">Contains the SqlTool command-line tool</div>
+</td>
+</tr>
+</tbody>
+</table>
+</li>
+</ul>
+</div>
+</main>
+<footer role="contentinfo">
+<nav role="navigation">
+<!-- ======= START OF BOTTOM NAVBAR ====== -->
+<div class="bottomNav"><a id="navbar.bottom">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.bottom.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="org.hsqldb.sqltool/module-summary.html">Module</a></li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-summary.html">Package</a></li>
+<li>Class</li>
+<li>Use</li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-tree.html">Tree</a></li>
+<li><a href="deprecated-list.html">Deprecated</a></li>
+<li><a href="index-all.html">Index</a></li>
+<li><a href="help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_bottom">
+<li><a href="allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_bottom");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.bottom">
+<!--   -->
+</a></div>
+<!-- ======== END OF BOTTOM NAVBAR ======= -->
+</nav>
+<p class="legalCopy"><small><i>Copyright © 2001 - 2022 HSQL Development Group.</i></small></p>
+</footer>
+</body>
+</html>
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/constant-values.html 2.7.0-1/hsqldb/doc/apidocssqltool/constant-values.html
--- 2.6.1-1/hsqldb/doc/apidocssqltool/constant-values.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/constant-values.html	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,231 @@
+<!DOCTYPE HTML>
+<!-- NewPage -->
+<html lang="en">
+<head>
+<!-- Generated by javadoc (11.0.14.1) on Tue Jul 26 22:23:00 BST 2022 -->
+<title>Constant Field Values (HSQLDB 2.7.0 API)</title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+<meta name="dc.created" content="2022-07-26">
+<link rel="stylesheet" type="text/css" href="javadoc.css" title="Style">
+<link rel="stylesheet" type="text/css" href="jquery/jquery-ui.css" title="Style">
+<script type="text/javascript" src="script.js"></script>
+<script type="text/javascript" src="jquery/jszip/dist/jszip.min.js"></script>
+<script type="text/javascript" src="jquery/jszip-utils/dist/jszip-utils.min.js"></script>
+<!--[if IE]>
+<script type="text/javascript" src="jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
+<![endif]-->
+<script type="text/javascript" src="jquery/jquery-3.5.1.js"></script>
+<script type="text/javascript" src="jquery/jquery-ui.js"></script>
+</head>
+<body>
+<script type="text/javascript"><!--
+    try {
+        if (location.href.indexOf('is-external=true') == -1) {
+            parent.document.title="Constant Field Values (HSQLDB 2.7.0 API)";
+        }
+    }
+    catch(err) {
+    }
+//-->
+var pathtoroot = "./";
+var useModuleDirectories = true;
+loadScripts(document, 'script');</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+<header role="banner">
+<nav role="navigation">
+<div class="fixedNav">
+<!-- ========= START OF TOP NAVBAR ======= -->
+<div class="topNav"><a id="navbar.top">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.top.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="org.hsqldb.sqltool/module-summary.html">Module</a></li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-summary.html">Package</a></li>
+<li>Class</li>
+<li>Use</li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-tree.html">Tree</a></li>
+<li><a href="deprecated-list.html">Deprecated</a></li>
+<li><a href="index-all.html">Index</a></li>
+<li><a href="help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_top">
+<li><a href="allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<ul class="navListSearch">
+<li><label for="search">SEARCH:</label>
+<input type="text" id="search" value="search" disabled="disabled">
+<input type="reset" id="reset" value="reset" disabled="disabled">
+</li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_top");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.top">
+<!--   -->
+</a></div>
+<!-- ========= END OF TOP NAVBAR ========= -->
+</div>
+<div class="navPadding">&nbsp;</div>
+<script type="text/javascript"><!--
+$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
+//-->
+</script>
+</nav>
+</header>
+<main role="main">
+<div class="header">
+<h1 title="Constant Field Values" class="title">Constant Field Values</h1>
+<section role="region">
+<h2 title="Contents">Contents</h2>
+<ul>
+<li><a href="#org.hsqldb">org.hsqldb.*</a></li>
+</ul>
+</section>
+</div>
+<div class="constantValuesContainer"><a id="org.hsqldb">
+<!--   -->
+</a>
+<section role="region">
+<h2 title="org.hsqldb">org.hsqldb.*</h2>
+<ul class="blockList">
+<li class="blockList">
+<table class="constantsSummary">
+<caption><span>org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html" title="class in org.hsqldb.cmdline">SqlTool</a></span><span class="tabEnd">&nbsp;</span></caption>
+<tr>
+<th class="colFirst" scope="col">Modifier and Type</th>
+<th class="colSecond" scope="col">Constant Field</th>
+<th class="colLast" scope="col">Value</th>
+</tr>
+<tbody>
+<tr class="altColor">
+<td class="colFirst"><a id="org.hsqldb.cmdline.SqlTool.CONNECTERR_EXITVAL">
+<!--   -->
+</a><code>public&nbsp;static&nbsp;final&nbsp;int</code></td>
+<th class="colSecond" scope="row"><code><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html#CONNECTERR_EXITVAL">CONNECTERR_EXITVAL</a></code></th>
+<td class="colLast"><code>7</code></td>
+</tr>
+<tr class="rowColor">
+<td class="colFirst"><a id="org.hsqldb.cmdline.SqlTool.FILEERR_EXITVAL">
+<!--   -->
+</a><code>public&nbsp;static&nbsp;final&nbsp;int</code></td>
+<th class="colSecond" scope="row"><code><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html#FILEERR_EXITVAL">FILEERR_EXITVAL</a></code></th>
+<td class="colLast"><code>5</code></td>
+</tr>
+<tr class="altColor">
+<td class="colFirst"><a id="org.hsqldb.cmdline.SqlTool.INPUTERR_EXITVAL">
+<!--   -->
+</a><code>public&nbsp;static&nbsp;final&nbsp;int</code></td>
+<th class="colSecond" scope="row"><code><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html#INPUTERR_EXITVAL">INPUTERR_EXITVAL</a></code></th>
+<td class="colLast"><code>6</code></td>
+</tr>
+<tr class="rowColor">
+<td class="colFirst"><a id="org.hsqldb.cmdline.SqlTool.IOERR_EXITVAL">
+<!--   -->
+</a><code>public&nbsp;static&nbsp;final&nbsp;int</code></td>
+<th class="colSecond" scope="row"><code><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html#IOERR_EXITVAL">IOERR_EXITVAL</a></code></th>
+<td class="colLast"><code>4</code></td>
+</tr>
+<tr class="altColor">
+<td class="colFirst"><a id="org.hsqldb.cmdline.SqlTool.RCERR_EXITVAL">
+<!--   -->
+</a><code>public&nbsp;static&nbsp;final&nbsp;int</code></td>
+<th class="colSecond" scope="row"><code><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html#RCERR_EXITVAL">RCERR_EXITVAL</a></code></th>
+<td class="colLast"><code>2</code></td>
+</tr>
+<tr class="rowColor">
+<td class="colFirst"><a id="org.hsqldb.cmdline.SqlTool.SQLERR_EXITVAL">
+<!--   -->
+</a><code>public&nbsp;static&nbsp;final&nbsp;int</code></td>
+<th class="colSecond" scope="row"><code><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html#SQLERR_EXITVAL">SQLERR_EXITVAL</a></code></th>
+<td class="colLast"><code>3</code></td>
+</tr>
+<tr class="altColor">
+<td class="colFirst"><a id="org.hsqldb.cmdline.SqlTool.SQLTOOLERR_EXITVAL">
+<!--   -->
+</a><code>public&nbsp;static&nbsp;final&nbsp;int</code></td>
+<th class="colSecond" scope="row"><code><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html#SQLTOOLERR_EXITVAL">SQLTOOLERR_EXITVAL</a></code></th>
+<td class="colLast"><code>1</code></td>
+</tr>
+<tr class="rowColor">
+<td class="colFirst"><a id="org.hsqldb.cmdline.SqlTool.SYNTAXERR_EXITVAL">
+<!--   -->
+</a><code>public&nbsp;static&nbsp;final&nbsp;int</code></td>
+<th class="colSecond" scope="row"><code><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html#SYNTAXERR_EXITVAL">SYNTAXERR_EXITVAL</a></code></th>
+<td class="colLast"><code>11</code></td>
+</tr>
+</tbody>
+</table>
+</li>
+</ul>
+</section>
+</div>
+</main>
+<footer role="contentinfo">
+<nav role="navigation">
+<!-- ======= START OF BOTTOM NAVBAR ====== -->
+<div class="bottomNav"><a id="navbar.bottom">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.bottom.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="org.hsqldb.sqltool/module-summary.html">Module</a></li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-summary.html">Package</a></li>
+<li>Class</li>
+<li>Use</li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-tree.html">Tree</a></li>
+<li><a href="deprecated-list.html">Deprecated</a></li>
+<li><a href="index-all.html">Index</a></li>
+<li><a href="help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_bottom">
+<li><a href="allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_bottom");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.bottom">
+<!--   -->
+</a></div>
+<!-- ======== END OF BOTTOM NAVBAR ======= -->
+</nav>
+<p class="legalCopy"><small><i>Copyright © 2001 - 2022 HSQL Development Group.</i></small></p>
+</footer>
+</body>
+</html>
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/deprecated-list.html 2.7.0-1/hsqldb/doc/apidocssqltool/deprecated-list.html
--- 2.6.1-1/hsqldb/doc/apidocssqltool/deprecated-list.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/deprecated-list.html	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,149 @@
+<!DOCTYPE HTML>
+<!-- NewPage -->
+<html lang="en">
+<head>
+<!-- Generated by javadoc (11.0.14.1) on Tue Jul 26 22:23:00 BST 2022 -->
+<title>Deprecated List (HSQLDB 2.7.0 API)</title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+<meta name="dc.created" content="2022-07-26">
+<link rel="stylesheet" type="text/css" href="javadoc.css" title="Style">
+<link rel="stylesheet" type="text/css" href="jquery/jquery-ui.css" title="Style">
+<script type="text/javascript" src="script.js"></script>
+<script type="text/javascript" src="jquery/jszip/dist/jszip.min.js"></script>
+<script type="text/javascript" src="jquery/jszip-utils/dist/jszip-utils.min.js"></script>
+<!--[if IE]>
+<script type="text/javascript" src="jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
+<![endif]-->
+<script type="text/javascript" src="jquery/jquery-3.5.1.js"></script>
+<script type="text/javascript" src="jquery/jquery-ui.js"></script>
+</head>
+<body>
+<script type="text/javascript"><!--
+    try {
+        if (location.href.indexOf('is-external=true') == -1) {
+            parent.document.title="Deprecated List (HSQLDB 2.7.0 API)";
+        }
+    }
+    catch(err) {
+    }
+//-->
+var pathtoroot = "./";
+var useModuleDirectories = true;
+loadScripts(document, 'script');</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+<header role="banner">
+<nav role="navigation">
+<div class="fixedNav">
+<!-- ========= START OF TOP NAVBAR ======= -->
+<div class="topNav"><a id="navbar.top">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.top.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="org.hsqldb.sqltool/module-summary.html">Module</a></li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-summary.html">Package</a></li>
+<li>Class</li>
+<li>Use</li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-tree.html">Tree</a></li>
+<li class="navBarCell1Rev">Deprecated</li>
+<li><a href="index-all.html">Index</a></li>
+<li><a href="help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_top">
+<li><a href="allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<ul class="navListSearch">
+<li><label for="search">SEARCH:</label>
+<input type="text" id="search" value="search" disabled="disabled">
+<input type="reset" id="reset" value="reset" disabled="disabled">
+</li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_top");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.top">
+<!--   -->
+</a></div>
+<!-- ========= END OF TOP NAVBAR ========= -->
+</div>
+<div class="navPadding">&nbsp;</div>
+<script type="text/javascript"><!--
+$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
+//-->
+</script>
+</nav>
+</header>
+<main role="main">
+<div class="header">
+<h1 title="Deprecated API" class="title">Deprecated API</h1>
+<h2 title="Contents">Contents</h2>
+</div>
+</main>
+<footer role="contentinfo">
+<nav role="navigation">
+<!-- ======= START OF BOTTOM NAVBAR ====== -->
+<div class="bottomNav"><a id="navbar.bottom">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.bottom.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="org.hsqldb.sqltool/module-summary.html">Module</a></li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-summary.html">Package</a></li>
+<li>Class</li>
+<li>Use</li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-tree.html">Tree</a></li>
+<li class="navBarCell1Rev">Deprecated</li>
+<li><a href="index-all.html">Index</a></li>
+<li><a href="help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_bottom">
+<li><a href="allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_bottom");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.bottom">
+<!--   -->
+</a></div>
+<!-- ======== END OF BOTTOM NAVBAR ======= -->
+</nav>
+<p class="legalCopy"><small><i>Copyright © 2001 - 2022 HSQL Development Group.</i></small></p>
+</footer>
+</body>
+</html>
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/element-list 2.7.0-1/hsqldb/doc/apidocssqltool/element-list
--- 2.6.1-1/hsqldb/doc/apidocssqltool/element-list	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/element-list	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,2 @@
+module:org.hsqldb.sqltool
+org.hsqldb.cmdline
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/help-doc.html 2.7.0-1/hsqldb/doc/apidocssqltool/help-doc.html
--- 2.6.1-1/hsqldb/doc/apidocssqltool/help-doc.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/help-doc.html	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,286 @@
+<!DOCTYPE HTML>
+<!-- NewPage -->
+<html lang="en">
+<head>
+<!-- Generated by javadoc (11.0.14.1) on Tue Jul 26 22:23:00 BST 2022 -->
+<title>API Help (HSQLDB 2.7.0 API)</title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+<meta name="dc.created" content="2022-07-26">
+<link rel="stylesheet" type="text/css" href="javadoc.css" title="Style">
+<link rel="stylesheet" type="text/css" href="jquery/jquery-ui.css" title="Style">
+<script type="text/javascript" src="script.js"></script>
+<script type="text/javascript" src="jquery/jszip/dist/jszip.min.js"></script>
+<script type="text/javascript" src="jquery/jszip-utils/dist/jszip-utils.min.js"></script>
+<!--[if IE]>
+<script type="text/javascript" src="jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
+<![endif]-->
+<script type="text/javascript" src="jquery/jquery-3.5.1.js"></script>
+<script type="text/javascript" src="jquery/jquery-ui.js"></script>
+</head>
+<body>
+<script type="text/javascript"><!--
+    try {
+        if (location.href.indexOf('is-external=true') == -1) {
+            parent.document.title="API Help (HSQLDB 2.7.0 API)";
+        }
+    }
+    catch(err) {
+    }
+//-->
+var pathtoroot = "./";
+var useModuleDirectories = true;
+loadScripts(document, 'script');</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+<header role="banner">
+<nav role="navigation">
+<div class="fixedNav">
+<!-- ========= START OF TOP NAVBAR ======= -->
+<div class="topNav"><a id="navbar.top">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.top.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="org.hsqldb.sqltool/module-summary.html">Module</a></li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-summary.html">Package</a></li>
+<li>Class</li>
+<li>Use</li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-tree.html">Tree</a></li>
+<li><a href="deprecated-list.html">Deprecated</a></li>
+<li><a href="index-all.html">Index</a></li>
+<li class="navBarCell1Rev">Help</li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_top">
+<li><a href="allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<ul class="navListSearch">
+<li><label for="search">SEARCH:</label>
+<input type="text" id="search" value="search" disabled="disabled">
+<input type="reset" id="reset" value="reset" disabled="disabled">
+</li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_top");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.top">
+<!--   -->
+</a></div>
+<!-- ========= END OF TOP NAVBAR ========= -->
+</div>
+<div class="navPadding">&nbsp;</div>
+<script type="text/javascript"><!--
+$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
+//-->
+</script>
+</nav>
+</header>
+<main role="main">
+<div class="header">
+<h1 class="title">How This API Document Is Organized</h1>
+<div class="subTitle">This API (Application Programming Interface) document has pages corresponding to the items in the navigation bar, described as follows.</div>
+</div>
+<div class="contentContainer">
+<ul class="blockList">
+<li class="blockList">
+<section role="region">
+<h2>Module</h2>
+<p>Each module has a page that contains a list of its packages, dependencies on other modules, and services, with a summary for each. These page may contain three categories:</p>
+<ul>
+<li>Packages</li>
+<li>Modules</li>
+<li>Services</li>
+</ul>
+</section>
+</li>
+<li class="blockList">
+<section role="region">
+<h2>Package</h2>
+<p>Each package has a page that contains a list of its classes and interfaces, with a summary for each. These pages may contain six categories:</p>
+<ul>
+<li>Interfaces</li>
+<li>Classes</li>
+<li>Enums</li>
+<li>Exceptions</li>
+<li>Errors</li>
+<li>Annotation Types</li>
+</ul>
+</section>
+</li>
+<li class="blockList">
+<section role="region">
+<h2>Class or Interface</h2>
+<p>Each class, interface, nested class and nested interface has its own separate page. Each of these pages has three sections consisting of a class/interface description, summary tables, and detailed member descriptions:</p>
+<ul>
+<li>Class Inheritance Diagram</li>
+<li>Direct Subclasses</li>
+<li>All Known Subinterfaces</li>
+<li>All Known Implementing Classes</li>
+<li>Class or Interface Declaration</li>
+<li>Class or Interface Description</li>
+</ul>
+<br>
+<ul>
+<li>Nested Class Summary</li>
+<li>Field Summary</li>
+<li>Property Summary</li>
+<li>Constructor Summary</li>
+<li>Method Summary</li>
+</ul>
+<br>
+<ul>
+<li>Field Detail</li>
+<li>Property Detail</li>
+<li>Constructor Detail</li>
+<li>Method Detail</li>
+</ul>
+<p>Each summary entry contains the first sentence from the detailed description for that item. The summary entries are alphabetical, while the detailed descriptions are in the order they appear in the source code. This preserves the logical groupings established by the programmer.</p>
+</section>
+</li>
+<li class="blockList">
+<section role="region">
+<h2>Annotation Type</h2>
+<p>Each annotation type has its own separate page with the following sections:</p>
+<ul>
+<li>Annotation Type Declaration</li>
+<li>Annotation Type Description</li>
+<li>Required Element Summary</li>
+<li>Optional Element Summary</li>
+<li>Element Detail</li>
+</ul>
+</section>
+</li>
+<li class="blockList">
+<section role="region">
+<h2>Enum</h2>
+<p>Each enum has its own separate page with the following sections:</p>
+<ul>
+<li>Enum Declaration</li>
+<li>Enum Description</li>
+<li>Enum Constant Summary</li>
+<li>Enum Constant Detail</li>
+</ul>
+</section>
+</li>
+<li class="blockList">
+<section role="region">
+<h2>Use</h2>
+<p>Each documented package, class and interface has its own Use page.  This page describes what packages, classes, methods, constructors and fields use any part of the given class or package. Given a class or interface A, its "Use" page includes subclasses of A, fields declared as A, methods that return A, and methods and constructors with parameters of type A.  You can access this page by first going to the package, class or interface, then clicking on the "Use" link in the navigation bar.</p>
+</section>
+</li>
+<li class="blockList">
+<section role="region">
+<h2>Tree (Class Hierarchy)</h2>
+<p>There is a <a href="overview-tree.html">Class Hierarchy</a> page for all packages, plus a hierarchy for each package. Each hierarchy page contains a list of classes and a list of interfaces. Classes are organized by inheritance structure starting with <code>java.lang.Object</code>. Interfaces do not inherit from <code>java.lang.Object</code>.</p>
+<ul>
+<li>When viewing the Overview page, clicking on "Tree" displays the hierarchy for all packages.</li>
+<li>When viewing a particular package, class or interface page, clicking on "Tree" displays the hierarchy for only that package.</li>
+</ul>
+</section>
+</li>
+<li class="blockList">
+<section role="region">
+<h2>Deprecated API</h2>
+<p>The <a href="deprecated-list.html">Deprecated API</a> page lists all of the API that have been deprecated. A deprecated API is not recommended for use, generally due to improvements, and a replacement API is usually given. Deprecated APIs may be removed in future implementations.</p>
+</section>
+</li>
+<li class="blockList">
+<section role="region">
+<h2>Index</h2>
+<p>The <a href="index-all.html">Index</a> contains an alphabetic index of all classes, interfaces, constructors, methods, and fields, as well as lists of all packages and all classes.</p>
+</section>
+</li>
+<li class="blockList">
+<section role="region">
+<h2>All&nbsp;Classes</h2>
+<p>The <a href="allclasses.html">All Classes</a> link shows all classes and interfaces except non-static nested types.</p>
+</section>
+</li>
+<li class="blockList">
+<section role="region">
+<h2>Serialized Form</h2>
+<p>Each serializable or externalizable class has a description of its serialization fields and methods. This information is of interest to re-implementors, not to developers using the API. While there is no link in the navigation bar, you can get to this information by going to any serialized class and clicking "Serialized Form" in the "See also" section of the class description.</p>
+</section>
+</li>
+<li class="blockList">
+<section role="region">
+<h2>Constant Field Values</h2>
+<p>The <a href="constant-values.html">Constant Field Values</a> page lists the static final fields and their values.</p>
+</section>
+</li>
+<li class="blockList">
+<section role="region">
+<h2>Search</h2>
+<p>You can search for definitions of modules, packages, types, fields, methods and other terms defined in the API, using some or all of the name. "Camel-case" abbreviations are supported: for example, "InpStr" will find "InputStream" and "InputStreamReader".</p>
+</section>
+</li>
+</ul>
+<hr>
+<span class="emphasizedPhrase">This help file applies to API documentation generated by the standard doclet.</span></div>
+</main>
+<footer role="contentinfo">
+<nav role="navigation">
+<!-- ======= START OF BOTTOM NAVBAR ====== -->
+<div class="bottomNav"><a id="navbar.bottom">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.bottom.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="org.hsqldb.sqltool/module-summary.html">Module</a></li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-summary.html">Package</a></li>
+<li>Class</li>
+<li>Use</li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-tree.html">Tree</a></li>
+<li><a href="deprecated-list.html">Deprecated</a></li>
+<li><a href="index-all.html">Index</a></li>
+<li class="navBarCell1Rev">Help</li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_bottom">
+<li><a href="allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_bottom");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.bottom">
+<!--   -->
+</a></div>
+<!-- ======== END OF BOTTOM NAVBAR ======= -->
+</nav>
+<p class="legalCopy"><small><i>Copyright © 2001 - 2022 HSQL Development Group.</i></small></p>
+</footer>
+</body>
+</html>
Binary files 2.6.1-1/hsqldb/doc/apidocssqltool/hsqldbs.png and 2.7.0-1/hsqldb/doc/apidocssqltool/hsqldbs.png differ
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/index-all.html 2.7.0-1/hsqldb/doc/apidocssqltool/index-all.html
--- 2.6.1-1/hsqldb/doc/apidocssqltool/index-all.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/index-all.html	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,952 @@
+<!DOCTYPE HTML>
+<!-- NewPage -->
+<html lang="en">
+<head>
+<!-- Generated by javadoc (11.0.14.1) on Tue Jul 26 22:23:00 BST 2022 -->
+<title>Index (HSQLDB 2.7.0 API)</title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+<meta name="dc.created" content="2022-07-26">
+<link rel="stylesheet" type="text/css" href="javadoc.css" title="Style">
+<link rel="stylesheet" type="text/css" href="jquery/jquery-ui.css" title="Style">
+<script type="text/javascript" src="script.js"></script>
+<script type="text/javascript" src="jquery/jszip/dist/jszip.min.js"></script>
+<script type="text/javascript" src="jquery/jszip-utils/dist/jszip-utils.min.js"></script>
+<!--[if IE]>
+<script type="text/javascript" src="jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
+<![endif]-->
+<script type="text/javascript" src="jquery/jquery-3.5.1.js"></script>
+<script type="text/javascript" src="jquery/jquery-ui.js"></script>
+</head>
+<body>
+<script type="text/javascript"><!--
+    try {
+        if (location.href.indexOf('is-external=true') == -1) {
+            parent.document.title="Index (HSQLDB 2.7.0 API)";
+        }
+    }
+    catch(err) {
+    }
+//-->
+var pathtoroot = "./";
+var useModuleDirectories = true;
+loadScripts(document, 'script');</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+<header role="banner">
+<nav role="navigation">
+<div class="fixedNav">
+<!-- ========= START OF TOP NAVBAR ======= -->
+<div class="topNav"><a id="navbar.top">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.top.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="org.hsqldb.sqltool/module-summary.html">Module</a></li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-summary.html">Package</a></li>
+<li>Class</li>
+<li>Use</li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-tree.html">Tree</a></li>
+<li><a href="deprecated-list.html">Deprecated</a></li>
+<li class="navBarCell1Rev">Index</li>
+<li><a href="help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_top">
+<li><a href="allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<ul class="navListSearch">
+<li><label for="search">SEARCH:</label>
+<input type="text" id="search" value="search" disabled="disabled">
+<input type="reset" id="reset" value="reset" disabled="disabled">
+</li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_top");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.top">
+<!--   -->
+</a></div>
+<!-- ========= END OF TOP NAVBAR ========= -->
+</div>
+<div class="navPadding">&nbsp;</div>
+<script type="text/javascript"><!--
+$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
+//-->
+</script>
+</nav>
+</header>
+<main role="main">
+<div class="contentContainer"><a href="#I:A">A</a>&nbsp;<a href="#I:B">B</a>&nbsp;<a href="#I:C">C</a>&nbsp;<a href="#I:D">D</a>&nbsp;<a href="#I:E">E</a>&nbsp;<a href="#I:F">F</a>&nbsp;<a href="#I:G">G</a>&nbsp;<a href="#I:H">H</a>&nbsp;<a href="#I:I">I</a>&nbsp;<a href="#I:J">J</a>&nbsp;<a href="#I:L">L</a>&nbsp;<a href="#I:M">M</a>&nbsp;<a href="#I:N">N</a>&nbsp;<a href="#I:O">O</a>&nbsp;<a href="#I:P">P</a>&nbsp;<a href="#I:Q">Q</a>&nbsp;<a href="#I:R">R</a>&nbsp;<a href="#I:S">S</a>&nbsp;<a href="#I:T">T</a>&nbsp;<a href="#I:V">V</a>&nbsp;<br><a href="allclasses-index.html">All&nbsp;Classes</a>&nbsp;<a href="allpackages-index.html">All&nbsp;Packages</a><a id="I:A">
+<!--   -->
+</a>
+<h2 class="title">A</h2>
+<dl>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#a_setting">a_setting</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#aborting">aborting</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#addMacros(java.util.Map)">addMacros(Map&lt;String, Token&gt;)</a></span> - Method in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#addUserVars(java.util.Map)">addUserVars(Map&lt;String, String&gt;)</a></span> - Method in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#append_empty">append_empty</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#arrayimp_jvmreq">arrayimp_jvmreq</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#arrayval_malformat">arrayval_malformat</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#auto_unset_warning">auto_unset_warning</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#autocommit_fetchfail">autocommit_fetchfail</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+</dl>
+<a id="I:B">
+<!--   -->
+</a>
+<h2 class="title">B</h2>
+<dl>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#bad_time_format">bad_time_format</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#bang_command_fail">bang_command_fail</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#bang_incomplete">bang_incomplete</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#binary_filefail">binary_filefail</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#binary_loadedbytesinto">binary_loadedbytesinto</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#binbuf_write">binbuf_write</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#binbuffer_empty">binbuffer_empty</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#bitCharsToBytes(java.lang.String)">bitCharsToBytes(String)</a></span> - Static method in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>
+<div class="block">Just a stub for now.</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#boolean_bad">boolean_bad</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#break_syntax">break_syntax</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#break_unsatisfied">break_unsatisfied</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#buffer_empty">buffer_empty</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#buffer_executing">buffer_executing</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#buffer_extrachars">buffer_extrachars</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#buffer_help">buffer_help</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#buffer_instructions">buffer_instructions</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#buffer_restored">buffer_restored</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#buffer_unknown">buffer_unknown</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#bufhist_unspecified">bufhist_unspecified</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+</dl>
+<a id="I:C">
+<!--   -->
+</a>
+<h2 class="title">C</h2>
+<dl>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#c_setting">c_setting</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#canDisplayType(int)">canDisplayType(int)</a></span> - Static method in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>
+<div class="block">This method is used to tell SqlFile whether this Sql Type must
+ ALWAYS be loaded to the binary buffer without displaying.</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#causereport">causereport</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#closeReader()">closeReader()</a></span> - Method in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>
+<div class="block">Close the reader.</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#commandnum_malformat">commandnum_malformat</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#committed">committed</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#conndata_retrieval_fail">conndata_retrieval_fail</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#connect_failure">connect_failure</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#connected_fallbackmsg">connected_fallbackmsg</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html#CONNECTERR_EXITVAL">CONNECTERR_EXITVAL</a></span> - Static variable in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html" title="class in org.hsqldb.cmdline">SqlTool</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#connection_fail">connection_fail</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#continue_syntax">continue_syntax</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#continue_unsatisfied">continue_unsatisfied</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#convertEscapes(java.lang.String)">convertEscapes(String)</a></span> - Static method in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>
+<div class="block">Translates user-supplied escapes into the traditionaly
+ corresponding binary characters.</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#csv_coldelim_present">csv_coldelim_present</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#csv_quote_unterminated">csv_quote_unterminated</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+</dl>
+<a id="I:D">
+<!--   -->
+</a>
+<h2 class="title">D</h2>
+<dl>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#d_options">d_options</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html#DEFAULT_RCFILE">DEFAULT_RCFILE</a></span> - Static variable in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html" title="class in org.hsqldb.cmdline">SqlTool</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#deprecated_noop">deprecated_noop</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#describe_table_datatype">describe_table_datatype</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#describe_table_name">describe_table_name</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#describe_table_nonulls">describe_table_nonulls</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#describe_table_precision">describe_table_precision</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#describe_table_scale">describe_table_scale</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#describe_table_width">describe_table_width</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#destfile_demand">destfile_demand</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#desturl_nowrite">desturl_nowrite</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#disconnect_failure">disconnect_failure</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#disconnect_success">disconnect_success</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#disconnected_msg">disconnected_msg</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#dsv_bincol">dsv_bincol</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#dsv_colcount_mismatch">dsv_colcount_mismatch</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#dsv_coldelim_present">dsv_coldelim_present</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#dsv_constcols_nullcol">dsv_constcols_nullcol</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#dsv_header_matchernonhead">dsv_header_matchernonhead</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#dsv_header_none">dsv_header_none</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#dsv_header_nonswitched">dsv_header_nonswitched</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#dsv_header_noswitchmatch">dsv_header_noswitchmatch</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#dsv_header_noswitchtarg">dsv_header_noswitchtarg</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#dsv_import_summary">dsv_import_summary</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#dsv_insertcol_mismatch">dsv_insertcol_mismatch</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#dsv_m_syntax">dsv_m_syntax</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#dsv_metadata_mismatch">dsv_metadata_mismatch</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#dsv_nocolheader">dsv_nocolheader</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#dsv_nocolsleft">dsv_nocolsleft</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#dsv_nullrep_present">dsv_nullrep_present</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#dsv_options">dsv_options</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#dsv_q_nodblquote">dsv_q_nodblquote</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#dsv_recin_fail">dsv_recin_fail</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#dsv_rejectfile_purgefail">dsv_rejectfile_purgefail</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#dsv_rejectfile_setupfail">dsv_rejectfile_setupfail</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#dsv_rejectreport_purgefail">dsv_rejectreport_purgefail</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#dsv_rejectreport_setupfail">dsv_rejectreport_setupfail</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#dsv_rowdelim_present">dsv_rowdelim_present</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#dsv_skipcols_missing">dsv_skipcols_missing</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#dsv_targetfile_demand">dsv_targetfile_demand</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#dsv_x_syntax">dsv_x_syntax</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#dsvSafe(java.lang.String)">dsvSafe(String)</a></span> - Method in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>
+<div class="block">Validate that String is safe to write TO DSV file.</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#dumpload_fail">dumpload_fail</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#dumpload_malformat">dumpload_malformat</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+</dl>
+<a id="I:E">
+<!--   -->
+</a>
+<h2 class="title">E</h2>
+<dl>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#edit_malformat">edit_malformat</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#editbuffer_contents">editbuffer_contents</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#else_without_if">else_without_if</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#encode_fail">encode_fail</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#end_noblock">end_noblock</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#errorat">errorat</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#escapeHtml(java.lang.String)">escapeHtml(String)</a></span> - Static method in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>
+<div class="block">Escaping rules taken from 'Reserved Characters in HTML table at
+ <a href="http://www.w3schools.com/tags/ref_entities.asp">http://www.w3schools.com/tags/ref_entities.asp</a></div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#exectime_report">exectime_report</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#exectime_reporting">exectime_reporting</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#execute()">execute()</a></span> - Method in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>
+<div class="block">Process all the commands from the file or Reader associated with
+ "this" object.</div>
+</dd>
+</dl>
+<a id="I:F">
+<!--   -->
+</a>
+<h2 class="title">F</h2>
+<dl>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#file_appendfail">file_appendfail</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#file_readfail">file_readfail</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#file_writefail">file_writefail</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#file_wrotechars">file_wrotechars</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html#FILEERR_EXITVAL">FILEERR_EXITVAL</a></span> - Static variable in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html" title="class in org.hsqldb.cmdline">SqlTool</a></dt>
+<dd>&nbsp;</dd>
+</dl>
+<a id="I:G">
+<!--   -->
+</a>
+<h2 class="title">G</h2>
+<dl>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#getBanner(java.sql.Connection)">getBanner(Connection)</a></span> - Static method in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>
+<div class="block">Returns a String report for the specified JDBC Connection.</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#getConnection()">getConnection()</a></span> - Method in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#getCurrentSchema()">getCurrentSchema()</a></span> - Method in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#getExpandedString()">getExpandedString()</a></span> - Method in enum org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#getExpandedString(java.lang.String...)">getExpandedString(String...)</a></span> - Method in enum org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#getMacros()">getMacros()</a></span> - Method in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#getString()">getString()</a></span> - Method in enum org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#getString(int)">getString(int)</a></span> - Method in enum org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#getString(int,int)">getString(int, int)</a></span> - Method in enum org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#getString(int,int,int)">getString(int, int, int)</a></span> - Method in enum org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#getString(int,int,java.lang.String)">getString(int, int, String)</a></span> - Method in enum org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#getString(int,java.lang.String)">getString(int, String)</a></span> - Method in enum org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#getString(int,java.lang.String,int)">getString(int, String, int)</a></span> - Method in enum org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#getString(int,java.lang.String,java.lang.String)">getString(int, String, String)</a></span> - Method in enum org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#getString(java.lang.String...)">getString(String...)</a></span> - Method in enum org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#getString(java.lang.String,int)">getString(String, int)</a></span> - Method in enum org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#getString(java.lang.String,int,int)">getString(String, int, int)</a></span> - Method in enum org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#getString(java.lang.String,int,java.lang.String)">getString(String, int, String)</a></span> - Method in enum org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#getString(java.lang.String,java.lang.String,int)">getString(String, String, int)</a></span> - Method in enum org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#getString(java.lang.Throwable)">getString(Throwable)</a></span> - Method in enum org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#getUserVars()">getUserVars()</a></span> - Method in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>
+<div class="block">Get a reference to the user variable map.</div>
+</dd>
+</dl>
+<a id="I:H">
+<!--   -->
+</a>
+<h2 class="title">H</h2>
+<dl>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#hexCharOctetsToBytes(java.lang.String)">hexCharOctetsToBytes(String)</a></span> - Static method in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>
+<div class="block">Convert a String to a byte array by interpreting every 2 characters as an
+ octal byte value.</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#history_back">history_back</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#history_backto">history_backto</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#history_none">history_none</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#history_number_req">history_number_req</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#history_unavailable">history_unavailable</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#history_upto">history_upto</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#html_mode">html_mode</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+</dl>
+<a id="I:I">
+<!--   -->
+</a>
+<h2 class="title">I</h2>
+<dl>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#ifwhile_malformat">ifwhile_malformat</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#illegal_at">illegal_at</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#import_col_dup">import_col_dup</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#importDsv(java.net.URL,java.lang.String)">importDsv(URL, String)</a></span> - Method in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>
+<div class="block">Name is self-explanatory.</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#input_malformat">input_malformat</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#input_movedtobuffer">input_movedtobuffer</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#input_unterminated">input_unterminated</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html#INPUTERR_EXITVAL">INPUTERR_EXITVAL</a></span> - Static variable in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html" title="class in org.hsqldb.cmdline">SqlTool</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#inputfile_closefail">inputfile_closefail</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#inputrec_modified">inputrec_modified</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#insertion_preparefail">insertion_preparefail</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#insertions_notcommitted">insertions_notcommitted</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html#IOERR_EXITVAL">IOERR_EXITVAL</a></span> - Static variable in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html" title="class in org.hsqldb.cmdline">SqlTool</a></dt>
+<dd>&nbsp;</dd>
+</dl>
+<a id="I:J">
+<!--   -->
+</a>
+<h2 class="title">J</h2>
+<dl>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#jdbc_established">jdbc_established</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+</dl>
+<a id="I:L">
+<!--   -->
+</a>
+<h2 class="title">L</h2>
+<dl>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#loadBinary(java.io.File)">loadBinary(File)</a></span> - Static method in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>
+<div class="block">Legacy function.</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#loadBinary(java.net.URL)">loadBinary(URL)</a></span> - Static method in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>
+<div class="block">Binary file load</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#log_syntax">log_syntax</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#log_syntax_error">log_syntax_error</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#logical_unrecognized">logical_unrecognized</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#LS">LS</a></span> - Static variable in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>
+<div class="block">Platform-specific line separator</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html#LS">LS</a></span> - Static variable in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html" title="class in org.hsqldb.cmdline">SqlTool</a></dt>
+<dd>
+<div class="block">Platform-specific line separator</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolSprayer.html#LS">LS</a></span> - Static variable in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolSprayer.html" title="class in org.hsqldb.cmdline">SqlToolSprayer</a></dt>
+<dd>&nbsp;</dd>
+</dl>
+<a id="I:M">
+<!--   -->
+</a>
+<h2 class="title">M</h2>
+<dl>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#macro_help">macro_help</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#macro_malformat">macro_malformat</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#macro_tip">macro_tip</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#macro_undefined">macro_undefined</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#macrodef_empty">macrodef_empty</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#macrodef_malformat">macrodef_malformat</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#macrodef_semi">macrodef_semi</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html#main(java.lang.String%5B%5D)">main(String[])</a></span> - Static method in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html" title="class in org.hsqldb.cmdline">SqlTool</a></dt>
+<dd>
+<div class="block">A static wrapper for objectMain, so that that method may be executed
+ as a Java "program".</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolSprayer.html#main(java.lang.String%5B%5D)">main(String[])</a></span> - Static method in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolSprayer.html" title="class in org.hsqldb.cmdline">SqlToolSprayer</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#math_expr_fail">math_expr_fail</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#metadata_fetch_fail">metadata_fetch_fail</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#metadata_fetch_failfor">metadata_fetch_failfor</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+</dl>
+<a id="I:N">
+<!--   -->
+</a>
+<h2 class="title">N</h2>
+<dl>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#no_required_conn">no_required_conn</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#no_timestamp_format">no_timestamp_format</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#no_vendor_schemaspt">no_vendor_schemaspt</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#nobuffer_yet">nobuffer_yet</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#none">none</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#noresult">noresult</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#null_assignment">null_assignment</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+</dl>
+<a id="I:O">
+<!--   -->
+</a>
+<h2 class="title">O</h2>
+<dl>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html#objectMain(java.lang.String%5B%5D)">objectMain(String[])</a></span> - Static method in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html" title="class in org.hsqldb.cmdline">SqlTool</a></dt>
+<dd>
+<div class="block">Connect to a JDBC Database and execute the commands given on
+ stdin or in SQL file(s).</div>
+</dd>
+<dt><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-summary.html">org.hsqldb.cmdline</a> - package org.hsqldb.cmdline</dt>
+<dd>
+<div class="block">Contains the SqlTool command-line tool</div>
+</dd>
+<dt><a href="org.hsqldb.sqltool/module-summary.html">org.hsqldb.sqltool</a> - module org.hsqldb.sqltool</dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#outputfile_header">outputfile_header</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#outputfile_nonetoclose">outputfile_nonetoclose</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#outputfile_reopening">outputfile_reopening</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+</dl>
+<a id="I:P">
+<!--   -->
+</a>
+<h2 class="title">P</h2>
+<dl>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#password_readfail">password_readfail</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#passwordFor_prompt">passwordFor_prompt</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#pipeclose_failure">pipeclose_failure</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#pl_assign">pl_assign</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#pl_block_fail">pl_block_fail</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#pl_block_unterminated">pl_block_unterminated</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#pl_control">pl_control</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#pl_help">pl_help</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#pl_list_lengths">pl_list_lengths</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#pl_list_parens">pl_list_parens</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#pl_malformat">pl_malformat</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#pl_malformat_specific">pl_malformat_specific</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#pl_unknown">pl_unknown</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#pl_unset_nomoreargs">pl_unset_nomoreargs</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#plalias_malformat">plalias_malformat</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#plvar_nameempty">plvar_nameempty</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#plvar_nocolon">plvar_nocolon</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#plvar_set_incomplete">plvar_set_incomplete</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#plvar_tildedash_nomoreargs">plvar_tildedash_nomoreargs</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#plvar_undefined">plvar_undefined</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#plvar_unterminated">plvar_unterminated</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#prepare_demandqm">prepare_demandqm</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#primaryinput_accessfail">primaryinput_accessfail</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+</dl>
+<a id="I:Q">
+<!--   -->
+</a>
+<h2 class="title">Q</h2>
+<dl>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#query_metadatafail">query_metadatafail</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+</dl>
+<a id="I:R">
+<!--   -->
+</a>
+<h2 class="title">R</h2>
+<dl>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#raw_empty">raw_empty</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#raw_leadin">raw_leadin</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#raw_movedtobuffer">raw_movedtobuffer</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#rawmode_prompt">rawmode_prompt</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#rcdata_driver_conflict">rcdata_driver_conflict</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#rcdata_genfromvalues_fail">rcdata_genfromvalues_fail</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#rcdata_inline_extravars">rcdata_inline_extravars</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#rcdata_inlineurl_missing">rcdata_inlineurl_missing</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#rcdata_password_visible">rcdata_password_visible</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html#RCERR_EXITVAL">RCERR_EXITVAL</a></span> - Static variable in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html" title="class in org.hsqldb.cmdline">SqlTool</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#read_convertfail">read_convertfail</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#read_partial">read_partial</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#read_toobig">read_toobig</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#regex_malformat">regex_malformat</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#reject_rpc">reject_rpc</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#rejectreport_bottom">rejectreport_bottom</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#rejectreport_row">rejectreport_row</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#rejectreport_top">rejectreport_top</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#remove_empty_vars_suggestset">remove_empty_vars_suggestset</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#rollingback">rollingback</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#row_update_multiple">row_update_multiple</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#row_update_singular">row_update_singular</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#rows_fetched">rows_fetched</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#rows_fetched_dsv">rows_fetched_dsv</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#rpc_autocommit_failure">rpc_autocommit_failure</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#rpc_commit_failure">rpc_commit_failure</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+</dl>
+<a id="I:S">
+<!--   -->
+</a>
+<h2 class="title">S</h2>
+<dl>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#schemaname_retrieval_fail">schemaname_retrieval_fail</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#setAutoClose(boolean)">setAutoClose(boolean)</a></span> - Method in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>
+<div class="block">Specify whether the supplied or generated input Reader should
+ automatically be closed by the execute() method.</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#setConnection(java.sql.Connection)">setConnection(Connection)</a></span> - Method in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#setContinueOnError(boolean)">setContinueOnError(boolean)</a></span> - Method in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#setMaxHistoryLength(int)">setMaxHistoryLength(int)</a></span> - Method in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#special_b_malformat">special_b_malformat</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#special_d_like">special_d_like</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#special_d_unknown">special_d_unknown</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#special_extrachars">special_extrachars</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#special_help">special_help</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#special_malformat">special_malformat</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#special_unknown">special_unknown</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#special_unspecified">special_unspecified</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#sqlarray_badjvm">sqlarray_badjvm</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html#SQLERR_EXITVAL">SQLERR_EXITVAL</a></span> - Static variable in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html" title="class in org.hsqldb.cmdline">SqlTool</a></dt>
+<dd>&nbsp;</dd>
+<dt><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline"><span class="typeNameLink">SqlFile</span></a> - Class in <a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-summary.html">org.hsqldb.cmdline</a></dt>
+<dd>
+<div class="block">Encapsulation of SQL text and the environment under which it will be
+ executed with a JDBC Connection.</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#%3Cinit%3E(java.io.File)">SqlFile(File)</a></span> - Constructor for class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>
+<div class="block">Convenience wrapper for the SqlFile(File, String) constructor</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#%3Cinit%3E(java.io.File,java.lang.String)">SqlFile(File, String)</a></span> - Constructor for class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>
+<div class="block">Convenience wrapper for the SqlFile(File, String, boolean) constructor</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#%3Cinit%3E(java.io.File,java.lang.String,boolean)">SqlFile(File, String, boolean)</a></span> - Constructor for class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>
+<div class="block">Constructor for non-interactive usage with a SQL file, using the
+ specified encoding and sending normal output to stdout.</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#%3Cinit%3E(java.io.Reader,java.lang.String,java.io.PrintStream,java.lang.String,boolean,java.io.File)">SqlFile(Reader, String, PrintStream, String, boolean, File)</a></span> - Constructor for class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>
+<div class="block">Legacy constructor.</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#%3Cinit%3E(java.io.Reader,java.lang.String,java.io.PrintStream,java.lang.String,boolean,java.net.URL)">SqlFile(Reader, String, PrintStream, String, boolean, URL)</a></span> - Constructor for class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>
+<div class="block">Instantiate a SqlFile instance for SQL input from 'reader'.</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#%3Cinit%3E(java.lang.String,boolean)">SqlFile(String, boolean)</a></span> - Constructor for class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>
+<div class="block">Constructor for interactive usage with stdin/stdout</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#%3Cinit%3E(java.net.URL)">SqlFile(URL)</a></span> - Constructor for class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#%3Cinit%3E(java.net.URL,java.lang.String)">SqlFile(URL, String)</a></span> - Constructor for class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#%3Cinit%3E(java.net.URL,java.lang.String,boolean)">SqlFile(URL, String, boolean)</a></span> - Constructor for class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#SqlFile_banner">SqlFile_banner</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#sqlfile_execute_fail">sqlfile_execute_fail</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#sqlfile_name_demand">sqlfile_name_demand</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.BadSpecial.html" title="class in org.hsqldb.cmdline"><span class="typeNameLink">SqlFile.BadSpecial</span></a> - Exception in <a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-summary.html">org.hsqldb.cmdline</a></dt>
+<dd>
+<div class="block">Utility nested Exception class for internal use only.</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#sqlstatement_empty">sqlstatement_empty</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#sqltempfile_fail">sqltempfile_fail</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html" title="class in org.hsqldb.cmdline"><span class="typeNameLink">SqlTool</span></a> - Class in <a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-summary.html">org.hsqldb.cmdline</a></dt>
+<dd>
+<div class="block">A command-line JDBC SQL tool supporting both interactive and
+ non-interactive usage.</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html#%3Cinit%3E()">SqlTool()</a></span> - Constructor for class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html" title="class in org.hsqldb.cmdline">SqlTool</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#SqlTool_abort_continue_mutuallyexclusive">SqlTool_abort_continue_mutuallyexclusive</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#SqlTool_params_redundant">SqlTool_params_redundant</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#SqlTool_syntax">SqlTool_syntax</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#SqlTool_varset_badformat">SqlTool_varset_badformat</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.SqlToolException.html" title="class in org.hsqldb.cmdline"><span class="typeNameLink">SqlTool.SqlToolException</span></a> - Exception in <a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-summary.html">org.hsqldb.cmdline</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html#SQLTOOLERR_EXITVAL">SQLTOOLERR_EXITVAL</a></span> - Static variable in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html" title="class in org.hsqldb.cmdline">SqlTool</a></dt>
+<dd>&nbsp;</dd>
+<dt><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolError.html" title="class in org.hsqldb.cmdline"><span class="typeNameLink">SqlToolError</span></a> - Exception in <a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-summary.html">org.hsqldb.cmdline</a></dt>
+<dd>
+<div class="block">Exceptions thrown by the SqlTool system externally to SqlFile.</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolError.html#%3Cinit%3E()">SqlToolError()</a></span> - Constructor for exception org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolError.html" title="class in org.hsqldb.cmdline">SqlToolError</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolError.html#%3Cinit%3E(java.lang.String)">SqlToolError(String)</a></span> - Constructor for exception org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolError.html" title="class in org.hsqldb.cmdline">SqlToolError</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolError.html#%3Cinit%3E(java.lang.String,java.lang.Throwable)">SqlToolError(String, Throwable)</a></span> - Constructor for exception org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolError.html" title="class in org.hsqldb.cmdline">SqlToolError</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolError.html#%3Cinit%3E(java.lang.Throwable)">SqlToolError(Throwable)</a></span> - Constructor for exception org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolError.html" title="class in org.hsqldb.cmdline">SqlToolError</a></dt>
+<dd>&nbsp;</dd>
+<dt><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline"><span class="typeNameLink">SqltoolRB</span></a> - Enum in <a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-summary.html">org.hsqldb.cmdline</a></dt>
+<dd>
+<div class="block">Resource Bundle for SqlTool and associated classes.</div>
+</dd>
+<dt><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolSprayer.html" title="class in org.hsqldb.cmdline"><span class="typeNameLink">SqlToolSprayer</span></a> - Class in <a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-summary.html">org.hsqldb.cmdline</a></dt>
+<dd>
+<div class="block">Sql Tool Sprayer.</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolSprayer.html#%3Cinit%3E()">SqlToolSprayer()</a></span> - Constructor for class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolSprayer.html" title="class in org.hsqldb.cmdline">SqlToolSprayer</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#sqlTypeToString(int)">sqlTypeToString(int)</a></span> - Static method in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>
+<div class="block">Return a String representation of the specified java.sql.Types type.</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#streamread_failure">streamread_failure</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#streamToBytes(java.io.InputStream)">streamToBytes(InputStream)</a></span> - Static method in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>
+<div class="block">As the name says...</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#streamToString(java.io.InputStream,java.lang.String)">streamToString(InputStream, String)</a></span> - Method in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>
+<div class="block">As the name says...</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#substitution_malformat">substitution_malformat</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#substitution_nomatch">substitution_nomatch</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#substitution_syntax">substitution_syntax</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#suggest_j">suggest_j</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html#SYNTAXERR_EXITVAL">SYNTAXERR_EXITVAL</a></span> - Static variable in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html" title="class in org.hsqldb.cmdline">SqlTool</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#sysprop_empty">sysprop_empty</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#sysprop_undefined">sysprop_undefined</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#sysprop_unterminated">sysprop_unterminated</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+</dl>
+<a id="I:T">
+<!--   -->
+</a>
+<h2 class="title">T</h2>
+<dl>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#time_bad">time_bad</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html#toPaddedString(java.lang.String,int,char,boolean)">toPaddedString(String, int, char, boolean)</a></span> - Static method in class org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#toString()">toString()</a></span> - Method in enum org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#transiso_report">transiso_report</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+</dl>
+<a id="I:V">
+<!--   -->
+</a>
+<h2 class="title">V</h2>
+<dl>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#valueOf(java.lang.String)">valueOf(String)</a></span> - Static method in enum org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>
+<div class="block">Returns the enum constant of this type with the specified name.</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#values()">values()</a></span> - Static method in enum org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>
+<div class="block">Returns an array containing the constants of this enum type, in
+the order they are declared.</div>
+</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#var_infinite">var_infinite</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#varname_warning">varname_warning</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#vendor_derby_dr">vendor_derby_dr</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#vendor_derby_du">vendor_derby_du</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#vendor_nosup_d">vendor_nosup_d</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#vendor_nosup_sysschemas">vendor_nosup_sysschemas</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+<dt><span class="memberNameLink"><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html#vendor_oracle_dS">vendor_oracle_dS</a></span> - org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></dt>
+<dd>&nbsp;</dd>
+</dl>
+<a href="#I:A">A</a>&nbsp;<a href="#I:B">B</a>&nbsp;<a href="#I:C">C</a>&nbsp;<a href="#I:D">D</a>&nbsp;<a href="#I:E">E</a>&nbsp;<a href="#I:F">F</a>&nbsp;<a href="#I:G">G</a>&nbsp;<a href="#I:H">H</a>&nbsp;<a href="#I:I">I</a>&nbsp;<a href="#I:J">J</a>&nbsp;<a href="#I:L">L</a>&nbsp;<a href="#I:M">M</a>&nbsp;<a href="#I:N">N</a>&nbsp;<a href="#I:O">O</a>&nbsp;<a href="#I:P">P</a>&nbsp;<a href="#I:Q">Q</a>&nbsp;<a href="#I:R">R</a>&nbsp;<a href="#I:S">S</a>&nbsp;<a href="#I:T">T</a>&nbsp;<a href="#I:V">V</a>&nbsp;<br><a href="allclasses-index.html">All&nbsp;Classes</a>&nbsp;<a href="allpackages-index.html">All&nbsp;Packages</a></div>
+</main>
+<footer role="contentinfo">
+<nav role="navigation">
+<!-- ======= START OF BOTTOM NAVBAR ====== -->
+<div class="bottomNav"><a id="navbar.bottom">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.bottom.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="org.hsqldb.sqltool/module-summary.html">Module</a></li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-summary.html">Package</a></li>
+<li>Class</li>
+<li>Use</li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-tree.html">Tree</a></li>
+<li><a href="deprecated-list.html">Deprecated</a></li>
+<li class="navBarCell1Rev">Index</li>
+<li><a href="help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_bottom">
+<li><a href="allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_bottom");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.bottom">
+<!--   -->
+</a></div>
+<!-- ======== END OF BOTTOM NAVBAR ======= -->
+</nav>
+<p class="legalCopy"><small><i>Copyright © 2001 - 2022 HSQL Development Group.</i></small></p>
+</footer>
+</body>
+</html>
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/index.html 2.7.0-1/hsqldb/doc/apidocssqltool/index.html
--- 2.6.1-1/hsqldb/doc/apidocssqltool/index.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/index.html	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,23 @@
+<!DOCTYPE HTML>
+<!-- NewPage -->
+<html lang="en">
+<head>
+<!-- Generated by javadoc (11.0.14.1) on Tue Jul 26 22:23:00 BST 2022 -->
+<title>HSQLDB 2.7.0 API</title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+<script type="text/javascript">window.location.replace('org.hsqldb.sqltool/module-summary.html')</script>
+<noscript>
+<meta http-equiv="Refresh" content="0;org.hsqldb.sqltool/module-summary.html">
+</noscript>
+<link rel="canonical" href="org.hsqldb.sqltool/module-summary.html">
+<link rel="stylesheet" type="text/css" href="stylesheet.css" title="Style">
+</head>
+<body>
+<main role="main">
+<noscript>
+<p>JavaScript is disabled on your browser.</p>
+</noscript>
+<p><a href="org.hsqldb.sqltool/module-summary.html">org.hsqldb.sqltool/module-summary.html</a></p>
+</main>
+</body>
+</html>
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/javadoc.css 2.7.0-1/hsqldb/doc/apidocssqltool/javadoc.css
--- 2.6.1-1/hsqldb/doc/apidocssqltool/javadoc.css	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/javadoc.css	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,600 @@
+/* Javadoc style sheet */
+/*
+Overall document style
+*/
+
+@import url('resources/fonts/dejavu.css');
+
+body {
+    background-color:#ffffff;
+    color:#353833;
+    font-family:'DejaVu Sans', Arial, Helvetica, sans-serif;
+    font-size:14px;
+    margin:0;
+}
+a:link, a:visited {
+    text-decoration:none;
+    color:#4A6782;
+}
+a:hover, a:focus {
+    text-decoration:none;
+    color:#bb7a2a;
+}
+a:active {
+    text-decoration:none;
+    color:#4A6782;
+}
+a[name] {
+    color:#353833;
+}
+a[name]:hover {
+    text-decoration:none;
+    color:#353833;
+}
+pre {
+    font-family:'DejaVu Sans Mono', monospace;
+    font-size:14px;
+}
+h1 {
+    font-size:16px;
+}
+h2 {
+    font-size:15px;
+}
+h3 {
+    font-size:14px;
+    font-style:italic;
+}
+h4 {
+    font-size:13px;
+}
+h5 {
+    font-size:12px;
+}
+h6 {
+    font-size:11px;
+}
+ul {
+    list-style-type:disc;
+}
+code, tt {
+    font-family:'DejaVu Sans Mono', monospace;
+    font-size:14px;
+    padding-top:4px;
+    margin-top:8px;
+    line-height:1.4em;
+}
+dt code {
+    font-family:'DejaVu Sans Mono', monospace;
+    font-size:14px;
+    padding-top:4px;
+}
+table tr td dt code {
+    font-family:'DejaVu Sans Mono', monospace;
+    font-size:14px;
+    vertical-align:top;
+    padding-top:4px;
+}
+sup {
+    font-size:8px;
+}
+/*
+Document title and Copyright styles
+*/
+.clear {
+    clear:both;
+    height:0px;
+    overflow:hidden;
+}
+.aboutLanguage {
+    float:right;
+    padding:0px 21px;
+    font-size:11px;
+    z-index:200;
+    margin-top:-9px;
+}
+.legalCopy {
+    margin-left:.5em;
+}
+.bar a, .bar a:link, .bar a:visited, .bar a:active {
+    color:#FFFFFF;
+    text-decoration:none;
+}
+.bar a:hover, .bar a:focus {
+    color:#bb7a2a;
+}
+.tab {
+    background-color:#0066FF;
+    color:#ffffff;
+    padding:8px;
+    width:5em;
+    font-weight:bold;
+}
+/*
+Navigation bar styles
+*/
+.bar {
+    background-color:#4D7A97;
+    color:#FFFFFF;
+    padding:.8em .5em .4em .8em;
+    height:auto;/*height:1.8em;*/
+    font-size:11px;
+    margin:0;
+}
+.topNav {
+    background-color:#4D7A97;
+    color:#FFFFFF;
+    float:left;
+    padding:0;
+    width:100%;
+    clear:right;
+    height:2.8em;
+    padding-top:10px;
+    overflow:hidden;
+    font-size:12px; 
+}
+.bottomNav {
+    margin-top:10px;
+    background-color:#4D7A97;
+    color:#FFFFFF;
+    float:left;
+    padding:0;
+    width:100%;
+    clear:right;
+    height:2.8em;
+    padding-top:10px;
+    overflow:hidden;
+    font-size:12px;
+}
+.subNav {
+    background-color:#dee3e9;
+    float:left;
+    width:100%;
+    overflow:hidden;
+    font-size:12px;
+}
+.subNav div {
+    clear:left;
+    float:left;
+    padding:0 0 5px 6px;
+    text-transform:uppercase;
+}
+ul.navList, ul.subNavList {
+    float:left;
+    margin:0 25px 0 0;
+    padding:0;
+}
+ul.navList li{
+    list-style:none;
+    float:left;
+    padding: 5px 6px;
+    text-transform:uppercase;
+}
+ul.subNavList li{
+    list-style:none;
+    float:left;
+}
+.topNav a:link, .topNav a:active, .topNav a:visited, .bottomNav a:link, .bottomNav a:active, .bottomNav a:visited {
+    color:#FFFFFF;
+    text-decoration:none;
+    text-transform:uppercase;
+}
+.topNav a:hover, .bottomNav a:hover {
+    text-decoration:none;
+    color:#bb7a2a;
+    text-transform:uppercase;
+}
+.navBarCell1Rev {
+    background-color:#F8981D;
+    color:#253441;
+    margin: auto 5px;
+}
+.skipNav {
+    position:absolute;
+    top:auto;
+    left:-9999px;
+    overflow:hidden;
+}
+/*
+Page header and footer styles
+*/
+.header, .footer {
+    clear:both;
+    margin:0 20px;
+    padding:5px 0 0 0;
+}
+.indexHeader {
+    margin:10px;
+    position:relative;
+}
+.indexHeader span{
+    margin-right:15px;
+}
+.indexHeader h1 {
+    font-size:13px;
+}
+.title {
+    color:#2c4557;
+    margin:10px 0;
+}
+.subTitle {
+    margin:5px 0 0 0;
+}
+.header ul {
+    margin:0 0 15px 0;
+    padding:0;
+}
+.footer ul {
+    margin:20px 0 5px 0;
+}
+.header ul li, .footer ul li {
+    list-style:none;
+    font-size:13px;
+}
+/*
+Heading styles
+*/
+div.details ul.blockList ul.blockList ul.blockList li.blockList h4, div.details ul.blockList ul.blockList ul.blockListLast li.blockList h4 {
+    background-color:#dee3e9;
+    border:1px solid #d0d9e0;
+    margin:0 0 6px -8px;
+    padding:7px 5px;
+}
+ul.blockList ul.blockList ul.blockList li.blockList h3 {
+    background-color:#dee3e9;
+    border:1px solid #d0d9e0;
+    margin:0 0 6px -8px;
+    padding:7px 5px;
+}
+ul.blockList ul.blockList li.blockList h3 {
+    padding:0;
+    margin:15px 0;
+}
+ul.blockList li.blockList h2 {
+    padding:0px 0 20px 0;
+}
+/*
+Page layout container styles
+*/
+.contentContainer, .sourceContainer, .classUseContainer, .serializedFormContainer, .constantValuesContainer {
+    clear:both;
+    padding:10px 20px;
+    position:relative;
+}
+.indexContainer {
+    margin:10px;
+    position:relative;
+    font-size:12px;
+}
+.indexContainer h2 {
+    font-size:13px;
+    padding:0 0 3px 0;
+}
+.indexContainer ul {
+    margin:0;
+    padding:0;
+}
+.indexContainer ul li {
+    list-style:none;
+    padding-top:2px;
+}
+.contentContainer .description dl dt, .contentContainer .details dl dt, .serializedFormContainer dl dt {
+    font-size:12px;
+    font-weight:bold;
+    margin:10px 0 0 0;
+    color:#4E4E4E;
+}
+.contentContainer .description dl dd, .contentContainer .details dl dd, .serializedFormContainer dl dd {
+    margin:5px 0 10px 0px;
+    font-size:14px;
+    font-family:'DejaVu Sans Mono',monospace;
+}
+.serializedFormContainer dl.nameValue dt {
+    margin-left:1px;
+    font-size:1.1em;
+    display:inline;
+    font-weight:bold;
+}
+.serializedFormContainer dl.nameValue dd {
+    margin:0 0 0 1px;
+    font-size:1.1em;
+    display:inline;
+}
+/*
+List styles
+*/
+ul.horizontal li {
+    display:inline;
+    font-size:0.9em;
+}
+ul.inheritance {
+    margin:0;
+    padding:0;
+}
+ul.inheritance li {
+    display:inline;
+    list-style:none;
+}
+ul.inheritance li ul.inheritance {
+    margin-left:15px;
+    padding-left:15px;
+    padding-top:1px;
+}
+ul.blockList, ul.blockListLast {
+    margin:10px 0 10px 0;
+    padding:0;
+}
+ul.blockList li.blockList, ul.blockListLast li.blockList {
+    list-style:none;
+    margin-bottom:15px;
+    line-height:1.4;
+}
+ul.blockList ul.blockList li.blockList, ul.blockList ul.blockListLast li.blockList {
+    padding:0px 20px 5px 10px;
+    border:1px solid #ededed; 
+    background-color:#f8f8f8;
+}
+ul.blockList ul.blockList ul.blockList li.blockList, ul.blockList ul.blockList ul.blockListLast li.blockList {
+    padding:0 0 5px 8px;
+    background-color:#ffffff;
+    border:none;
+}
+ul.blockList ul.blockList ul.blockList ul.blockList li.blockList {
+    margin-left:0;
+    padding-left:0;
+    padding-bottom:15px;
+    border:none;
+}
+ul.blockList ul.blockList ul.blockList ul.blockList li.blockListLast {
+    list-style:none;
+    border-bottom:none;
+    padding-bottom:0;
+}
+table tr td dl, table tr td dl dt, table tr td dl dd {
+    margin-top:0;
+    margin-bottom:1px;
+}
+/*
+Table styles
+*/
+.overviewSummary, .memberSummary, .typeSummary, .useSummary, .constantsSummary, .deprecatedSummary {
+    width:100%;
+    border-left:1px solid #EEE; 
+    border-right:1px solid #EEE; 
+    border-bottom:1px solid #EEE; 
+}
+.overviewSummary, .memberSummary  {
+    padding:0px;
+}
+.overviewSummary caption, .memberSummary caption, .typeSummary caption,
+.useSummary caption, .constantsSummary caption, .deprecatedSummary caption {
+    position:relative;
+    text-align:left;
+    background-repeat:no-repeat;
+    color:#253441;
+    font-weight:bold;
+    clear:none;
+    overflow:hidden;
+    padding:0px;
+    padding-top:10px;
+    padding-left:1px;
+    margin:0px;
+    white-space:pre;
+}
+.overviewSummary caption a:link, .memberSummary caption a:link, .typeSummary caption a:link,
+.useSummary caption a:link, .constantsSummary caption a:link, .deprecatedSummary caption a:link,
+.overviewSummary caption a:hover, .memberSummary caption a:hover, .typeSummary caption a:hover,
+.useSummary caption a:hover, .constantsSummary caption a:hover, .deprecatedSummary caption a:hover,
+.overviewSummary caption a:active, .memberSummary caption a:active, .typeSummary caption a:active,
+.useSummary caption a:active, .constantsSummary caption a:active, .deprecatedSummary caption a:active,
+.overviewSummary caption a:visited, .memberSummary caption a:visited, .typeSummary caption a:visited,
+.useSummary caption a:visited, .constantsSummary caption a:visited, .deprecatedSummary caption a:visited {
+    color:#FFFFFF;
+}
+.overviewSummary caption span, .memberSummary caption span, .typeSummary caption span,
+.useSummary caption span, .constantsSummary caption span, .deprecatedSummary caption span {
+    white-space:nowrap;
+    padding-top:5px;
+    padding-left:12px;
+    padding-right:12px;
+    padding-bottom:7px;
+    display:inline-block;
+    float:left;
+    background-color:#F8981D;
+    border: none;
+    height:16px;
+}
+.memberSummary caption span.activeTableTab span {
+    white-space:nowrap;
+    padding-top:5px;
+    padding-left:12px;
+    padding-right:12px;
+    margin-right:3px;
+    display:inline-block;
+    float:left;
+    background-color:#F8981D;
+    height:16px;
+}
+.memberSummary caption span.tableTab span {
+    white-space:nowrap;
+    padding-top:5px;
+    padding-left:12px;
+    padding-right:12px;
+    margin-right:3px;
+    display:inline-block;
+    float:left;
+    background-color:#4D7A97;
+    height:16px;
+}
+.memberSummary caption span.tableTab, .memberSummary caption span.activeTableTab {
+    padding-top:0px;
+    padding-left:0px;
+    padding-right:0px;
+    background-image:none;
+    float:none;
+    display:inline;
+}
+.overviewSummary .tabEnd, .memberSummary .tabEnd, .typeSummary .tabEnd,
+.useSummary .tabEnd, .constantsSummary .tabEnd, .deprecatedSummary .tabEnd {
+    display:none;
+    width:5px;
+    position:relative;
+    float:left;
+    background-color:#F8981D;
+}
+.memberSummary .activeTableTab .tabEnd {
+    display:none;
+    width:5px;
+    margin-right:3px;
+    position:relative; 
+    float:left;
+    background-color:#F8981D;
+}
+.memberSummary .tableTab .tabEnd {
+    display:none;
+    width:5px;
+    margin-right:3px;
+    position:relative;
+    background-color:#4D7A97;
+    float:left;
+
+}
+.overviewSummary td, .memberSummary td, .typeSummary td,
+.useSummary td, .constantsSummary td, .deprecatedSummary td {
+    text-align:left;
+    padding:0px 0px 12px 10px;
+}
+th.colOne, th.colFirst, th.colLast, .useSummary th, .constantsSummary th,
+td.colOne, td.colFirst, td.colLast, .useSummary td, .constantsSummary td{
+    vertical-align:top;
+    padding-right:0px;
+    padding-top:8px;
+    padding-bottom:3px;
+}
+th.colFirst, th.colLast, th.colOne, .constantsSummary th {
+    background:#dee3e9;
+    text-align:left;
+    padding:8px 3px 3px 7px;
+}
+td.colFirst, th.colFirst {
+    white-space:nowrap;
+    font-size:13px;
+}
+td.colLast, th.colLast {
+    font-size:13px;
+}
+td.colOne, th.colOne {
+    font-size:13px;
+}
+.overviewSummary td.colFirst, .overviewSummary th.colFirst,
+.useSummary td.colFirst, .useSummary th.colFirst,
+.overviewSummary td.colOne, .overviewSummary th.colOne,
+.memberSummary td.colFirst, .memberSummary th.colFirst,
+.memberSummary td.colOne, .memberSummary th.colOne,
+.typeSummary td.colFirst{
+    width:25%;
+    vertical-align:top;
+}
+td.colOne a:link, td.colOne a:active, td.colOne a:visited, td.colOne a:hover, td.colFirst a:link, td.colFirst a:active, td.colFirst a:visited, td.colFirst a:hover, td.colLast a:link, td.colLast a:active, td.colLast a:visited, td.colLast a:hover, .constantValuesContainer td a:link, .constantValuesContainer td a:active, .constantValuesContainer td a:visited, .constantValuesContainer td a:hover {
+    font-weight:bold;
+}
+.tableSubHeadingColor {
+    background-color:#EEEEFF;
+}
+.altColor {
+    background-color:#FFFFFF;
+}
+.rowColor {
+    background-color:#EEEEEF;
+}
+/*
+Content styles
+*/
+.description pre {
+    margin-top:0;
+}
+.deprecatedContent {
+    margin:0;
+    padding:10px 0;
+}
+.docSummary {
+    padding:0;
+}
+
+ul.blockList ul.blockList ul.blockList li.blockList h3 {
+    font-style:normal;
+}
+
+div.block {
+    font-size:14px;
+    font-family:'DejaVu Serif', Georgia, "Times New Roman", Times, serif;
+}
+
+td.colLast div {
+    padding-top:0px;
+}
+
+
+td.colLast a {
+    padding-bottom:3px;
+}
+/*
+Formatting effect styles
+*/
+.sourceLineNo {
+    color:green;
+    padding:0 30px 0 0;
+}
+h1.hidden {
+    visibility:hidden;
+    overflow:hidden;
+    font-size:10px;
+}
+.block {
+    display:block;
+    margin:3px 10px 2px 0px;
+    color:#474747;
+}
+.deprecatedLabel, .descfrmTypeLabel, .memberNameLabel, .memberNameLink,
+.overrideSpecifyLabel, .packageHierarchyLabel, .paramLabel, .returnLabel,
+.seeLabel, .simpleTagLabel, .throwsLabel, .typeNameLabel, .typeNameLink {
+    font-weight:bold;
+}
+.deprecationComment, .emphasizedPhrase, .interfaceName {
+    font-style:italic;
+}
+
+div.block div.block span.deprecationComment, div.block div.block span.emphasizedPhrase,
+div.block div.block span.interfaceName {
+    font-style:normal;
+}
+
+div.contentContainer ul.blockList li.blockList h2{
+    padding-bottom:0px;
+}
+
+/* HyperSQL Javadoc styles */
+DIV.ReleaseSpecificDocumentation { 
+    color:              #006A00;
+    background-color:   #EEEEFF;
+	border:             none;
+    padding-top:        5px;
+    padding-right:      10px;
+    padding-bottom:     5px;
+    padding-left:       10px;
+}
+
+DIV.ReleaseSpecificDocumentation h1 {
+	margin-top:         0px;
+	margin-left:        0px;
+	margin-right:       0px;
+    padding-top:        14px;
+    padding-right:      0px;
+    padding-bottom:     15px;
+    padding-left:       50px;
+    background:         url(hsqldbs.png) #E6E6FF no-repeat left center;
+	border:             none;
+    font-size:          14px;
+		
+}
+
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/module-search-index.js 2.7.0-1/hsqldb/doc/apidocssqltool/module-search-index.js
--- 2.6.1-1/hsqldb/doc/apidocssqltool/module-search-index.js	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/module-search-index.js	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1 @@
+moduleSearchIndex = [{"l":"org.hsqldb.sqltool"}]
\ No newline at end of file
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/module-summary.html 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/module-summary.html
--- 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/module-summary.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/module-summary.html	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,196 @@
+<!DOCTYPE HTML>
+<!-- NewPage -->
+<html lang="en">
+<head>
+<!-- Generated by javadoc (11.0.14.1) on Tue Jul 26 22:23:00 BST 2022 -->
+<title>org.hsqldb.sqltool (HSQLDB 2.7.0 API)</title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+<meta name="dc.created" content="2022-07-26">
+<link rel="stylesheet" type="text/css" href="../javadoc.css" title="Style">
+<link rel="stylesheet" type="text/css" href="../jquery/jquery-ui.css" title="Style">
+<script type="text/javascript" src="../script.js"></script>
+<script type="text/javascript" src="../jquery/jszip/dist/jszip.min.js"></script>
+<script type="text/javascript" src="../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
+<!--[if IE]>
+<script type="text/javascript" src="../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
+<![endif]-->
+<script type="text/javascript" src="../jquery/jquery-3.5.1.js"></script>
+<script type="text/javascript" src="../jquery/jquery-ui.js"></script>
+</head>
+<body>
+<script type="text/javascript"><!--
+    try {
+        if (location.href.indexOf('is-external=true') == -1) {
+            parent.document.title="org.hsqldb.sqltool (HSQLDB 2.7.0 API)";
+        }
+    }
+    catch(err) {
+    }
+//-->
+var pathtoroot = "../";
+var useModuleDirectories = true;
+loadScripts(document, 'script');</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+<header role="banner">
+<nav role="navigation">
+<div class="fixedNav">
+<!-- ========= START OF TOP NAVBAR ======= -->
+<div class="topNav"><a id="navbar.top">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.top.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li class="navBarCell1Rev">Module</li>
+<li><a href="org/hsqldb/cmdline/package-summary.html">Package</a></li>
+<li>Class</li>
+<li>Use</li>
+<li><a href="org/hsqldb/cmdline/package-tree.html">Tree</a></li>
+<li><a href="../deprecated-list.html">Deprecated</a></li>
+<li><a href="../index-all.html">Index</a></li>
+<li><a href="../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_top">
+<li><a href="../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<ul class="navListSearch">
+<li><label for="search">SEARCH:</label>
+<input type="text" id="search" value="search" disabled="disabled">
+<input type="reset" id="reset" value="reset" disabled="disabled">
+</li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_top");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<div>
+<ul class="subNavList">
+<li>Module:&nbsp;</li>
+<li>Description&nbsp;|&nbsp;</li>
+<li>Modules&nbsp;|&nbsp;</li>
+<li><a href="#packages.summary">Packages</a>&nbsp;|&nbsp;</li>
+<li>Services</li>
+</ul>
+</div>
+<a id="skip.navbar.top">
+<!--   -->
+</a></div>
+<!-- ========= END OF TOP NAVBAR ========= -->
+</div>
+<div class="navPadding">&nbsp;</div>
+<script type="text/javascript"><!--
+$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
+//-->
+</script>
+</nav>
+</header>
+<main role="main">
+<div class="header">
+<h1 title="Module" class="title">Module&nbsp;org.hsqldb.sqltool</h1>
+</div>
+<div class="contentContainer">
+<ul class="blockList">
+<li class="blockList">
+<ul class="blockList">
+<li class="blockList">
+<!-- ============ PACKAGES SUMMARY =========== -->
+<a id="packages.summary">
+<!--   -->
+</a>
+<h3>Packages</h3>
+<table class="packagesSummary">
+<caption><span>Exports</span><span class="tabEnd">&nbsp;</span></caption>
+<tr>
+<th class="colFirst" scope="col">Package</th>
+<th class="colLast" scope="col">Description</th>
+</tr>
+<tbody>
+<tr class="altColor" id="i0">
+<th class="colFirst" scope="row"><a href="org/hsqldb/cmdline/package-summary.html">org.hsqldb.cmdline</a></th>
+<td class="colLast">
+<div class="block">Contains the SqlTool command-line tool</div>
+</td>
+</tr>
+</tbody>
+</table>
+</li>
+</ul>
+</li>
+</ul>
+</div>
+</main>
+<footer role="contentinfo">
+<nav role="navigation">
+<!-- ======= START OF BOTTOM NAVBAR ====== -->
+<div class="bottomNav"><a id="navbar.bottom">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.bottom.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li class="navBarCell1Rev">Module</li>
+<li><a href="org/hsqldb/cmdline/package-summary.html">Package</a></li>
+<li>Class</li>
+<li>Use</li>
+<li><a href="org/hsqldb/cmdline/package-tree.html">Tree</a></li>
+<li><a href="../deprecated-list.html">Deprecated</a></li>
+<li><a href="../index-all.html">Index</a></li>
+<li><a href="../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_bottom">
+<li><a href="../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_bottom");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<div>
+<ul class="subNavList">
+<li>Module:&nbsp;</li>
+<li>Description&nbsp;|&nbsp;</li>
+<li>Modules&nbsp;|&nbsp;</li>
+<li><a href="#packages.summary">Packages</a>&nbsp;|&nbsp;</li>
+<li>Services</li>
+</ul>
+</div>
+<a id="skip.navbar.bottom">
+<!--   -->
+</a></div>
+<!-- ======== END OF BOTTOM NAVBAR ======= -->
+</nav>
+<p class="legalCopy"><small><i>Copyright © 2001 - 2022 HSQL Development Group.</i></small></p>
+</footer>
+</body>
+</html>
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/class-use/SqlFile.BadSpecial.html 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/class-use/SqlFile.BadSpecial.html
--- 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/class-use/SqlFile.BadSpecial.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/class-use/SqlFile.BadSpecial.html	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,178 @@
+<!DOCTYPE HTML>
+<!-- NewPage -->
+<html lang="en">
+<head>
+<!-- Generated by javadoc (11.0.14.1) on Tue Jul 26 22:23:00 BST 2022 -->
+<title>Uses of Class org.hsqldb.cmdline.SqlFile.BadSpecial (HSQLDB 2.7.0 API)</title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+<meta name="dc.created" content="2022-07-26">
+<link rel="stylesheet" type="text/css" href="../../../../../javadoc.css" title="Style">
+<link rel="stylesheet" type="text/css" href="../../../../../jquery/jquery-ui.css" title="Style">
+<script type="text/javascript" src="../../../../../script.js"></script>
+<script type="text/javascript" src="../../../../../jquery/jszip/dist/jszip.min.js"></script>
+<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
+<!--[if IE]>
+<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
+<![endif]-->
+<script type="text/javascript" src="../../../../../jquery/jquery-3.5.1.js"></script>
+<script type="text/javascript" src="../../../../../jquery/jquery-ui.js"></script>
+</head>
+<body>
+<script type="text/javascript"><!--
+    try {
+        if (location.href.indexOf('is-external=true') == -1) {
+            parent.document.title="Uses of Class org.hsqldb.cmdline.SqlFile.BadSpecial (HSQLDB 2.7.0 API)";
+        }
+    }
+    catch(err) {
+    }
+//-->
+var pathtoroot = "../../../../../";
+var useModuleDirectories = true;
+loadScripts(document, 'script');</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+<header role="banner">
+<nav role="navigation">
+<div class="fixedNav">
+<!-- ========= START OF TOP NAVBAR ======= -->
+<div class="topNav"><a id="navbar.top">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.top.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../../module-summary.html">Module</a></li>
+<li><a href="../package-summary.html">Package</a></li>
+<li><a href="../SqlFile.BadSpecial.html" title="class in org.hsqldb.cmdline">Class</a></li>
+<li class="navBarCell1Rev">Use</li>
+<li><a href="../package-tree.html">Tree</a></li>
+<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../../index-all.html">Index</a></li>
+<li><a href="../../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_top">
+<li><a href="../../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<ul class="navListSearch">
+<li><label for="search">SEARCH:</label>
+<input type="text" id="search" value="search" disabled="disabled">
+<input type="reset" id="reset" value="reset" disabled="disabled">
+</li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_top");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.top">
+<!--   -->
+</a></div>
+<!-- ========= END OF TOP NAVBAR ========= -->
+</div>
+<div class="navPadding">&nbsp;</div>
+<script type="text/javascript"><!--
+$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
+//-->
+</script>
+</nav>
+</header>
+<main role="main">
+<div class="header">
+<h2 title="Uses of Class org.hsqldb.cmdline.SqlFile.BadSpecial" class="title">Uses of Class<br>org.hsqldb.cmdline.SqlFile.BadSpecial</h2>
+</div>
+<div class="classUseContainer">
+<ul class="blockList">
+<li class="blockList">
+<ul class="blockList">
+<li class="blockList">
+<section role="region"><a id="org.hsqldb.cmdline">
+<!--   -->
+</a>
+<h3>Uses of <a href="../SqlFile.BadSpecial.html" title="class in org.hsqldb.cmdline">SqlFile.BadSpecial</a> in <a href="../package-summary.html">org.hsqldb.cmdline</a></h3>
+<table class="useSummary">
+<caption><span>Methods in <a href="../package-summary.html">org.hsqldb.cmdline</a> that throw <a href="../SqlFile.BadSpecial.html" title="class in org.hsqldb.cmdline">SqlFile.BadSpecial</a></span><span class="tabEnd">&nbsp;</span></caption>
+<tr>
+<th class="colFirst" scope="col">Modifier and Type</th>
+<th class="colSecond" scope="col">Method</th>
+<th class="colLast" scope="col">Description</th>
+</tr>
+<tbody>
+<tr class="altColor">
+<td class="colFirst"><code>java.lang.String</code></td>
+<th class="colSecond" scope="row"><span class="typeNameLabel">SqlFile.</span><code><span class="memberNameLink"><a href="../SqlFile.html#getCurrentSchema()">getCurrentSchema</a></span>()</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+</tbody>
+</table>
+</section>
+</li>
+</ul>
+</li>
+</ul>
+</div>
+</main>
+<footer role="contentinfo">
+<nav role="navigation">
+<!-- ======= START OF BOTTOM NAVBAR ====== -->
+<div class="bottomNav"><a id="navbar.bottom">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.bottom.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../../module-summary.html">Module</a></li>
+<li><a href="../package-summary.html">Package</a></li>
+<li><a href="../SqlFile.BadSpecial.html" title="class in org.hsqldb.cmdline">Class</a></li>
+<li class="navBarCell1Rev">Use</li>
+<li><a href="../package-tree.html">Tree</a></li>
+<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../../index-all.html">Index</a></li>
+<li><a href="../../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_bottom">
+<li><a href="../../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_bottom");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.bottom">
+<!--   -->
+</a></div>
+<!-- ======== END OF BOTTOM NAVBAR ======= -->
+</nav>
+<p class="legalCopy"><small><i>Copyright © 2001 - 2022 HSQL Development Group.</i></small></p>
+</footer>
+</body>
+</html>
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/class-use/SqlFile.html 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/class-use/SqlFile.html
--- 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/class-use/SqlFile.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/class-use/SqlFile.html	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,149 @@
+<!DOCTYPE HTML>
+<!-- NewPage -->
+<html lang="en">
+<head>
+<!-- Generated by javadoc (11.0.14.1) on Tue Jul 26 22:23:00 BST 2022 -->
+<title>Uses of Class org.hsqldb.cmdline.SqlFile (HSQLDB 2.7.0 API)</title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+<meta name="dc.created" content="2022-07-26">
+<link rel="stylesheet" type="text/css" href="../../../../../javadoc.css" title="Style">
+<link rel="stylesheet" type="text/css" href="../../../../../jquery/jquery-ui.css" title="Style">
+<script type="text/javascript" src="../../../../../script.js"></script>
+<script type="text/javascript" src="../../../../../jquery/jszip/dist/jszip.min.js"></script>
+<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
+<!--[if IE]>
+<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
+<![endif]-->
+<script type="text/javascript" src="../../../../../jquery/jquery-3.5.1.js"></script>
+<script type="text/javascript" src="../../../../../jquery/jquery-ui.js"></script>
+</head>
+<body>
+<script type="text/javascript"><!--
+    try {
+        if (location.href.indexOf('is-external=true') == -1) {
+            parent.document.title="Uses of Class org.hsqldb.cmdline.SqlFile (HSQLDB 2.7.0 API)";
+        }
+    }
+    catch(err) {
+    }
+//-->
+var pathtoroot = "../../../../../";
+var useModuleDirectories = true;
+loadScripts(document, 'script');</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+<header role="banner">
+<nav role="navigation">
+<div class="fixedNav">
+<!-- ========= START OF TOP NAVBAR ======= -->
+<div class="topNav"><a id="navbar.top">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.top.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../../module-summary.html">Module</a></li>
+<li><a href="../package-summary.html">Package</a></li>
+<li><a href="../SqlFile.html" title="class in org.hsqldb.cmdline">Class</a></li>
+<li class="navBarCell1Rev">Use</li>
+<li><a href="../package-tree.html">Tree</a></li>
+<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../../index-all.html">Index</a></li>
+<li><a href="../../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_top">
+<li><a href="../../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<ul class="navListSearch">
+<li><label for="search">SEARCH:</label>
+<input type="text" id="search" value="search" disabled="disabled">
+<input type="reset" id="reset" value="reset" disabled="disabled">
+</li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_top");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.top">
+<!--   -->
+</a></div>
+<!-- ========= END OF TOP NAVBAR ========= -->
+</div>
+<div class="navPadding">&nbsp;</div>
+<script type="text/javascript"><!--
+$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
+//-->
+</script>
+</nav>
+</header>
+<main role="main">
+<div class="header">
+<h2 title="Uses of Class org.hsqldb.cmdline.SqlFile" class="title">Uses of Class<br>org.hsqldb.cmdline.SqlFile</h2>
+</div>
+<div class="classUseContainer">No usage of org.hsqldb.cmdline.SqlFile</div>
+</main>
+<footer role="contentinfo">
+<nav role="navigation">
+<!-- ======= START OF BOTTOM NAVBAR ====== -->
+<div class="bottomNav"><a id="navbar.bottom">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.bottom.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../../module-summary.html">Module</a></li>
+<li><a href="../package-summary.html">Package</a></li>
+<li><a href="../SqlFile.html" title="class in org.hsqldb.cmdline">Class</a></li>
+<li class="navBarCell1Rev">Use</li>
+<li><a href="../package-tree.html">Tree</a></li>
+<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../../index-all.html">Index</a></li>
+<li><a href="../../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_bottom">
+<li><a href="../../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_bottom");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.bottom">
+<!--   -->
+</a></div>
+<!-- ======== END OF BOTTOM NAVBAR ======= -->
+</nav>
+<p class="legalCopy"><small><i>Copyright © 2001 - 2022 HSQL Development Group.</i></small></p>
+</footer>
+</body>
+</html>
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/class-use/SqlToolError.html 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/class-use/SqlToolError.html
--- 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/class-use/SqlToolError.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/class-use/SqlToolError.html	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,201 @@
+<!DOCTYPE HTML>
+<!-- NewPage -->
+<html lang="en">
+<head>
+<!-- Generated by javadoc (11.0.14.1) on Tue Jul 26 22:23:00 BST 2022 -->
+<title>Uses of Class org.hsqldb.cmdline.SqlToolError (HSQLDB 2.7.0 API)</title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+<meta name="dc.created" content="2022-07-26">
+<link rel="stylesheet" type="text/css" href="../../../../../javadoc.css" title="Style">
+<link rel="stylesheet" type="text/css" href="../../../../../jquery/jquery-ui.css" title="Style">
+<script type="text/javascript" src="../../../../../script.js"></script>
+<script type="text/javascript" src="../../../../../jquery/jszip/dist/jszip.min.js"></script>
+<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
+<!--[if IE]>
+<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
+<![endif]-->
+<script type="text/javascript" src="../../../../../jquery/jquery-3.5.1.js"></script>
+<script type="text/javascript" src="../../../../../jquery/jquery-ui.js"></script>
+</head>
+<body>
+<script type="text/javascript"><!--
+    try {
+        if (location.href.indexOf('is-external=true') == -1) {
+            parent.document.title="Uses of Class org.hsqldb.cmdline.SqlToolError (HSQLDB 2.7.0 API)";
+        }
+    }
+    catch(err) {
+    }
+//-->
+var pathtoroot = "../../../../../";
+var useModuleDirectories = true;
+loadScripts(document, 'script');</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+<header role="banner">
+<nav role="navigation">
+<div class="fixedNav">
+<!-- ========= START OF TOP NAVBAR ======= -->
+<div class="topNav"><a id="navbar.top">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.top.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../../module-summary.html">Module</a></li>
+<li><a href="../package-summary.html">Package</a></li>
+<li><a href="../SqlToolError.html" title="class in org.hsqldb.cmdline">Class</a></li>
+<li class="navBarCell1Rev">Use</li>
+<li><a href="../package-tree.html">Tree</a></li>
+<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../../index-all.html">Index</a></li>
+<li><a href="../../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_top">
+<li><a href="../../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<ul class="navListSearch">
+<li><label for="search">SEARCH:</label>
+<input type="text" id="search" value="search" disabled="disabled">
+<input type="reset" id="reset" value="reset" disabled="disabled">
+</li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_top");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.top">
+<!--   -->
+</a></div>
+<!-- ========= END OF TOP NAVBAR ========= -->
+</div>
+<div class="navPadding">&nbsp;</div>
+<script type="text/javascript"><!--
+$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
+//-->
+</script>
+</nav>
+</header>
+<main role="main">
+<div class="header">
+<h2 title="Uses of Class org.hsqldb.cmdline.SqlToolError" class="title">Uses of Class<br>org.hsqldb.cmdline.SqlToolError</h2>
+</div>
+<div class="classUseContainer">
+<ul class="blockList">
+<li class="blockList">
+<ul class="blockList">
+<li class="blockList">
+<section role="region"><a id="org.hsqldb.cmdline">
+<!--   -->
+</a>
+<h3>Uses of <a href="../SqlToolError.html" title="class in org.hsqldb.cmdline">SqlToolError</a> in <a href="../package-summary.html">org.hsqldb.cmdline</a></h3>
+<table class="useSummary">
+<caption><span>Methods in <a href="../package-summary.html">org.hsqldb.cmdline</a> that throw <a href="../SqlToolError.html" title="class in org.hsqldb.cmdline">SqlToolError</a></span><span class="tabEnd">&nbsp;</span></caption>
+<tr>
+<th class="colFirst" scope="col">Modifier and Type</th>
+<th class="colSecond" scope="col">Method</th>
+<th class="colLast" scope="col">Description</th>
+</tr>
+<tbody>
+<tr class="altColor">
+<td class="colFirst"><code>void</code></td>
+<th class="colSecond" scope="row"><span class="typeNameLabel">SqlFile.</span><code><span class="memberNameLink"><a href="../SqlFile.html#dsvSafe(java.lang.String)">dsvSafe</a></span>&#8203;(java.lang.String&nbsp;s)</code></th>
+<td class="colLast">
+<div class="block">Validate that String is safe to write TO DSV file.</div>
+</td>
+</tr>
+<tr class="rowColor">
+<td class="colFirst"><code>void</code></td>
+<th class="colSecond" scope="row"><span class="typeNameLabel">SqlFile.</span><code><span class="memberNameLink"><a href="../SqlFile.html#execute()">execute</a></span>()</code></th>
+<td class="colLast">
+<div class="block">Process all the commands from the file or Reader associated with
+ "this" object.</div>
+</td>
+</tr>
+<tr class="altColor">
+<td class="colFirst"><code>java.lang.String</code></td>
+<th class="colSecond" scope="row"><span class="typeNameLabel">SqlFile.</span><code><span class="memberNameLink"><a href="../SqlFile.html#getCurrentSchema()">getCurrentSchema</a></span>()</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<td class="colFirst"><code>void</code></td>
+<th class="colSecond" scope="row"><span class="typeNameLabel">SqlFile.</span><code><span class="memberNameLink"><a href="../SqlFile.html#importDsv(java.net.URL,java.lang.String)">importDsv</a></span>&#8203;(java.net.URL&nbsp;fileUrl,
+         java.lang.String&nbsp;skipPrefix)</code></th>
+<td class="colLast">
+<div class="block">Name is self-explanatory.</div>
+</td>
+</tr>
+</tbody>
+</table>
+</section>
+</li>
+</ul>
+</li>
+</ul>
+</div>
+</main>
+<footer role="contentinfo">
+<nav role="navigation">
+<!-- ======= START OF BOTTOM NAVBAR ====== -->
+<div class="bottomNav"><a id="navbar.bottom">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.bottom.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../../module-summary.html">Module</a></li>
+<li><a href="../package-summary.html">Package</a></li>
+<li><a href="../SqlToolError.html" title="class in org.hsqldb.cmdline">Class</a></li>
+<li class="navBarCell1Rev">Use</li>
+<li><a href="../package-tree.html">Tree</a></li>
+<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../../index-all.html">Index</a></li>
+<li><a href="../../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_bottom">
+<li><a href="../../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_bottom");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.bottom">
+<!--   -->
+</a></div>
+<!-- ======== END OF BOTTOM NAVBAR ======= -->
+</nav>
+<p class="legalCopy"><small><i>Copyright © 2001 - 2022 HSQL Development Group.</i></small></p>
+</footer>
+</body>
+</html>
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/class-use/SqlTool.html 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/class-use/SqlTool.html
--- 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/class-use/SqlTool.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/class-use/SqlTool.html	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,149 @@
+<!DOCTYPE HTML>
+<!-- NewPage -->
+<html lang="en">
+<head>
+<!-- Generated by javadoc (11.0.14.1) on Tue Jul 26 22:23:00 BST 2022 -->
+<title>Uses of Class org.hsqldb.cmdline.SqlTool (HSQLDB 2.7.0 API)</title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+<meta name="dc.created" content="2022-07-26">
+<link rel="stylesheet" type="text/css" href="../../../../../javadoc.css" title="Style">
+<link rel="stylesheet" type="text/css" href="../../../../../jquery/jquery-ui.css" title="Style">
+<script type="text/javascript" src="../../../../../script.js"></script>
+<script type="text/javascript" src="../../../../../jquery/jszip/dist/jszip.min.js"></script>
+<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
+<!--[if IE]>
+<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
+<![endif]-->
+<script type="text/javascript" src="../../../../../jquery/jquery-3.5.1.js"></script>
+<script type="text/javascript" src="../../../../../jquery/jquery-ui.js"></script>
+</head>
+<body>
+<script type="text/javascript"><!--
+    try {
+        if (location.href.indexOf('is-external=true') == -1) {
+            parent.document.title="Uses of Class org.hsqldb.cmdline.SqlTool (HSQLDB 2.7.0 API)";
+        }
+    }
+    catch(err) {
+    }
+//-->
+var pathtoroot = "../../../../../";
+var useModuleDirectories = true;
+loadScripts(document, 'script');</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+<header role="banner">
+<nav role="navigation">
+<div class="fixedNav">
+<!-- ========= START OF TOP NAVBAR ======= -->
+<div class="topNav"><a id="navbar.top">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.top.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../../module-summary.html">Module</a></li>
+<li><a href="../package-summary.html">Package</a></li>
+<li><a href="../SqlTool.html" title="class in org.hsqldb.cmdline">Class</a></li>
+<li class="navBarCell1Rev">Use</li>
+<li><a href="../package-tree.html">Tree</a></li>
+<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../../index-all.html">Index</a></li>
+<li><a href="../../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_top">
+<li><a href="../../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<ul class="navListSearch">
+<li><label for="search">SEARCH:</label>
+<input type="text" id="search" value="search" disabled="disabled">
+<input type="reset" id="reset" value="reset" disabled="disabled">
+</li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_top");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.top">
+<!--   -->
+</a></div>
+<!-- ========= END OF TOP NAVBAR ========= -->
+</div>
+<div class="navPadding">&nbsp;</div>
+<script type="text/javascript"><!--
+$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
+//-->
+</script>
+</nav>
+</header>
+<main role="main">
+<div class="header">
+<h2 title="Uses of Class org.hsqldb.cmdline.SqlTool" class="title">Uses of Class<br>org.hsqldb.cmdline.SqlTool</h2>
+</div>
+<div class="classUseContainer">No usage of org.hsqldb.cmdline.SqlTool</div>
+</main>
+<footer role="contentinfo">
+<nav role="navigation">
+<!-- ======= START OF BOTTOM NAVBAR ====== -->
+<div class="bottomNav"><a id="navbar.bottom">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.bottom.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../../module-summary.html">Module</a></li>
+<li><a href="../package-summary.html">Package</a></li>
+<li><a href="../SqlTool.html" title="class in org.hsqldb.cmdline">Class</a></li>
+<li class="navBarCell1Rev">Use</li>
+<li><a href="../package-tree.html">Tree</a></li>
+<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../../index-all.html">Index</a></li>
+<li><a href="../../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_bottom">
+<li><a href="../../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_bottom");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.bottom">
+<!--   -->
+</a></div>
+<!-- ======== END OF BOTTOM NAVBAR ======= -->
+</nav>
+<p class="legalCopy"><small><i>Copyright © 2001 - 2022 HSQL Development Group.</i></small></p>
+</footer>
+</body>
+</html>
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/class-use/SqltoolRB.html 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/class-use/SqltoolRB.html
--- 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/class-use/SqltoolRB.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/class-use/SqltoolRB.html	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,188 @@
+<!DOCTYPE HTML>
+<!-- NewPage -->
+<html lang="en">
+<head>
+<!-- Generated by javadoc (11.0.14.1) on Tue Jul 26 22:23:00 BST 2022 -->
+<title>Uses of Class org.hsqldb.cmdline.SqltoolRB (HSQLDB 2.7.0 API)</title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+<meta name="dc.created" content="2022-07-26">
+<link rel="stylesheet" type="text/css" href="../../../../../javadoc.css" title="Style">
+<link rel="stylesheet" type="text/css" href="../../../../../jquery/jquery-ui.css" title="Style">
+<script type="text/javascript" src="../../../../../script.js"></script>
+<script type="text/javascript" src="../../../../../jquery/jszip/dist/jszip.min.js"></script>
+<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
+<!--[if IE]>
+<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
+<![endif]-->
+<script type="text/javascript" src="../../../../../jquery/jquery-3.5.1.js"></script>
+<script type="text/javascript" src="../../../../../jquery/jquery-ui.js"></script>
+</head>
+<body>
+<script type="text/javascript"><!--
+    try {
+        if (location.href.indexOf('is-external=true') == -1) {
+            parent.document.title="Uses of Class org.hsqldb.cmdline.SqltoolRB (HSQLDB 2.7.0 API)";
+        }
+    }
+    catch(err) {
+    }
+//-->
+var pathtoroot = "../../../../../";
+var useModuleDirectories = true;
+loadScripts(document, 'script');</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+<header role="banner">
+<nav role="navigation">
+<div class="fixedNav">
+<!-- ========= START OF TOP NAVBAR ======= -->
+<div class="topNav"><a id="navbar.top">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.top.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../../module-summary.html">Module</a></li>
+<li><a href="../package-summary.html">Package</a></li>
+<li><a href="../SqltoolRB.html" title="enum in org.hsqldb.cmdline">Class</a></li>
+<li class="navBarCell1Rev">Use</li>
+<li><a href="../package-tree.html">Tree</a></li>
+<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../../index-all.html">Index</a></li>
+<li><a href="../../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_top">
+<li><a href="../../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<ul class="navListSearch">
+<li><label for="search">SEARCH:</label>
+<input type="text" id="search" value="search" disabled="disabled">
+<input type="reset" id="reset" value="reset" disabled="disabled">
+</li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_top");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.top">
+<!--   -->
+</a></div>
+<!-- ========= END OF TOP NAVBAR ========= -->
+</div>
+<div class="navPadding">&nbsp;</div>
+<script type="text/javascript"><!--
+$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
+//-->
+</script>
+</nav>
+</header>
+<main role="main">
+<div class="header">
+<h2 title="Uses of Class org.hsqldb.cmdline.SqltoolRB" class="title">Uses of Class<br>org.hsqldb.cmdline.SqltoolRB</h2>
+</div>
+<div class="classUseContainer">
+<ul class="blockList">
+<li class="blockList">
+<ul class="blockList">
+<li class="blockList">
+<section role="region"><a id="org.hsqldb.cmdline">
+<!--   -->
+</a>
+<h3>Uses of <a href="../SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> in <a href="../package-summary.html">org.hsqldb.cmdline</a></h3>
+<table class="useSummary">
+<caption><span>Methods in <a href="../package-summary.html">org.hsqldb.cmdline</a> that return <a href="../SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></span><span class="tabEnd">&nbsp;</span></caption>
+<tr>
+<th class="colFirst" scope="col">Modifier and Type</th>
+<th class="colSecond" scope="col">Method</th>
+<th class="colLast" scope="col">Description</th>
+</tr>
+<tbody>
+<tr class="altColor">
+<td class="colFirst"><code>static <a href="../SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></code></td>
+<th class="colSecond" scope="row"><span class="typeNameLabel">SqltoolRB.</span><code><span class="memberNameLink"><a href="../SqltoolRB.html#valueOf(java.lang.String)">valueOf</a></span>&#8203;(java.lang.String&nbsp;name)</code></th>
+<td class="colLast">
+<div class="block">Returns the enum constant of this type with the specified name.</div>
+</td>
+</tr>
+<tr class="rowColor">
+<td class="colFirst"><code>static <a href="../SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a>[]</code></td>
+<th class="colSecond" scope="row"><span class="typeNameLabel">SqltoolRB.</span><code><span class="memberNameLink"><a href="../SqltoolRB.html#values()">values</a></span>()</code></th>
+<td class="colLast">
+<div class="block">Returns an array containing the constants of this enum type, in
+the order they are declared.</div>
+</td>
+</tr>
+</tbody>
+</table>
+</section>
+</li>
+</ul>
+</li>
+</ul>
+</div>
+</main>
+<footer role="contentinfo">
+<nav role="navigation">
+<!-- ======= START OF BOTTOM NAVBAR ====== -->
+<div class="bottomNav"><a id="navbar.bottom">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.bottom.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../../module-summary.html">Module</a></li>
+<li><a href="../package-summary.html">Package</a></li>
+<li><a href="../SqltoolRB.html" title="enum in org.hsqldb.cmdline">Class</a></li>
+<li class="navBarCell1Rev">Use</li>
+<li><a href="../package-tree.html">Tree</a></li>
+<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../../index-all.html">Index</a></li>
+<li><a href="../../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_bottom">
+<li><a href="../../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_bottom");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.bottom">
+<!--   -->
+</a></div>
+<!-- ======== END OF BOTTOM NAVBAR ======= -->
+</nav>
+<p class="legalCopy"><small><i>Copyright © 2001 - 2022 HSQL Development Group.</i></small></p>
+</footer>
+</body>
+</html>
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/class-use/SqlToolSprayer.html 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/class-use/SqlToolSprayer.html
--- 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/class-use/SqlToolSprayer.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/class-use/SqlToolSprayer.html	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,149 @@
+<!DOCTYPE HTML>
+<!-- NewPage -->
+<html lang="en">
+<head>
+<!-- Generated by javadoc (11.0.14.1) on Tue Jul 26 22:23:00 BST 2022 -->
+<title>Uses of Class org.hsqldb.cmdline.SqlToolSprayer (HSQLDB 2.7.0 API)</title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+<meta name="dc.created" content="2022-07-26">
+<link rel="stylesheet" type="text/css" href="../../../../../javadoc.css" title="Style">
+<link rel="stylesheet" type="text/css" href="../../../../../jquery/jquery-ui.css" title="Style">
+<script type="text/javascript" src="../../../../../script.js"></script>
+<script type="text/javascript" src="../../../../../jquery/jszip/dist/jszip.min.js"></script>
+<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
+<!--[if IE]>
+<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
+<![endif]-->
+<script type="text/javascript" src="../../../../../jquery/jquery-3.5.1.js"></script>
+<script type="text/javascript" src="../../../../../jquery/jquery-ui.js"></script>
+</head>
+<body>
+<script type="text/javascript"><!--
+    try {
+        if (location.href.indexOf('is-external=true') == -1) {
+            parent.document.title="Uses of Class org.hsqldb.cmdline.SqlToolSprayer (HSQLDB 2.7.0 API)";
+        }
+    }
+    catch(err) {
+    }
+//-->
+var pathtoroot = "../../../../../";
+var useModuleDirectories = true;
+loadScripts(document, 'script');</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+<header role="banner">
+<nav role="navigation">
+<div class="fixedNav">
+<!-- ========= START OF TOP NAVBAR ======= -->
+<div class="topNav"><a id="navbar.top">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.top.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../../module-summary.html">Module</a></li>
+<li><a href="../package-summary.html">Package</a></li>
+<li><a href="../SqlToolSprayer.html" title="class in org.hsqldb.cmdline">Class</a></li>
+<li class="navBarCell1Rev">Use</li>
+<li><a href="../package-tree.html">Tree</a></li>
+<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../../index-all.html">Index</a></li>
+<li><a href="../../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_top">
+<li><a href="../../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<ul class="navListSearch">
+<li><label for="search">SEARCH:</label>
+<input type="text" id="search" value="search" disabled="disabled">
+<input type="reset" id="reset" value="reset" disabled="disabled">
+</li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_top");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.top">
+<!--   -->
+</a></div>
+<!-- ========= END OF TOP NAVBAR ========= -->
+</div>
+<div class="navPadding">&nbsp;</div>
+<script type="text/javascript"><!--
+$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
+//-->
+</script>
+</nav>
+</header>
+<main role="main">
+<div class="header">
+<h2 title="Uses of Class org.hsqldb.cmdline.SqlToolSprayer" class="title">Uses of Class<br>org.hsqldb.cmdline.SqlToolSprayer</h2>
+</div>
+<div class="classUseContainer">No usage of org.hsqldb.cmdline.SqlToolSprayer</div>
+</main>
+<footer role="contentinfo">
+<nav role="navigation">
+<!-- ======= START OF BOTTOM NAVBAR ====== -->
+<div class="bottomNav"><a id="navbar.bottom">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.bottom.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../../module-summary.html">Module</a></li>
+<li><a href="../package-summary.html">Package</a></li>
+<li><a href="../SqlToolSprayer.html" title="class in org.hsqldb.cmdline">Class</a></li>
+<li class="navBarCell1Rev">Use</li>
+<li><a href="../package-tree.html">Tree</a></li>
+<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../../index-all.html">Index</a></li>
+<li><a href="../../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_bottom">
+<li><a href="../../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_bottom");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.bottom">
+<!--   -->
+</a></div>
+<!-- ======== END OF BOTTOM NAVBAR ======= -->
+</nav>
+<p class="legalCopy"><small><i>Copyright © 2001 - 2022 HSQL Development Group.</i></small></p>
+</footer>
+</body>
+</html>
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/class-use/SqlTool.SqlToolException.html 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/class-use/SqlTool.SqlToolException.html
--- 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/class-use/SqlTool.SqlToolException.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/class-use/SqlTool.SqlToolException.html	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,181 @@
+<!DOCTYPE HTML>
+<!-- NewPage -->
+<html lang="en">
+<head>
+<!-- Generated by javadoc (11.0.14.1) on Tue Jul 26 22:23:00 BST 2022 -->
+<title>Uses of Class org.hsqldb.cmdline.SqlTool.SqlToolException (HSQLDB 2.7.0 API)</title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+<meta name="dc.created" content="2022-07-26">
+<link rel="stylesheet" type="text/css" href="../../../../../javadoc.css" title="Style">
+<link rel="stylesheet" type="text/css" href="../../../../../jquery/jquery-ui.css" title="Style">
+<script type="text/javascript" src="../../../../../script.js"></script>
+<script type="text/javascript" src="../../../../../jquery/jszip/dist/jszip.min.js"></script>
+<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
+<!--[if IE]>
+<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
+<![endif]-->
+<script type="text/javascript" src="../../../../../jquery/jquery-3.5.1.js"></script>
+<script type="text/javascript" src="../../../../../jquery/jquery-ui.js"></script>
+</head>
+<body>
+<script type="text/javascript"><!--
+    try {
+        if (location.href.indexOf('is-external=true') == -1) {
+            parent.document.title="Uses of Class org.hsqldb.cmdline.SqlTool.SqlToolException (HSQLDB 2.7.0 API)";
+        }
+    }
+    catch(err) {
+    }
+//-->
+var pathtoroot = "../../../../../";
+var useModuleDirectories = true;
+loadScripts(document, 'script');</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+<header role="banner">
+<nav role="navigation">
+<div class="fixedNav">
+<!-- ========= START OF TOP NAVBAR ======= -->
+<div class="topNav"><a id="navbar.top">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.top.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../../module-summary.html">Module</a></li>
+<li><a href="../package-summary.html">Package</a></li>
+<li><a href="../SqlTool.SqlToolException.html" title="class in org.hsqldb.cmdline">Class</a></li>
+<li class="navBarCell1Rev">Use</li>
+<li><a href="../package-tree.html">Tree</a></li>
+<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../../index-all.html">Index</a></li>
+<li><a href="../../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_top">
+<li><a href="../../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<ul class="navListSearch">
+<li><label for="search">SEARCH:</label>
+<input type="text" id="search" value="search" disabled="disabled">
+<input type="reset" id="reset" value="reset" disabled="disabled">
+</li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_top");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.top">
+<!--   -->
+</a></div>
+<!-- ========= END OF TOP NAVBAR ========= -->
+</div>
+<div class="navPadding">&nbsp;</div>
+<script type="text/javascript"><!--
+$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
+//-->
+</script>
+</nav>
+</header>
+<main role="main">
+<div class="header">
+<h2 title="Uses of Class org.hsqldb.cmdline.SqlTool.SqlToolException" class="title">Uses of Class<br>org.hsqldb.cmdline.SqlTool.SqlToolException</h2>
+</div>
+<div class="classUseContainer">
+<ul class="blockList">
+<li class="blockList">
+<ul class="blockList">
+<li class="blockList">
+<section role="region"><a id="org.hsqldb.cmdline">
+<!--   -->
+</a>
+<h3>Uses of <a href="../SqlTool.SqlToolException.html" title="class in org.hsqldb.cmdline">SqlTool.SqlToolException</a> in <a href="../package-summary.html">org.hsqldb.cmdline</a></h3>
+<table class="useSummary">
+<caption><span>Methods in <a href="../package-summary.html">org.hsqldb.cmdline</a> that throw <a href="../SqlTool.SqlToolException.html" title="class in org.hsqldb.cmdline">SqlTool.SqlToolException</a></span><span class="tabEnd">&nbsp;</span></caption>
+<tr>
+<th class="colFirst" scope="col">Modifier and Type</th>
+<th class="colSecond" scope="col">Method</th>
+<th class="colLast" scope="col">Description</th>
+</tr>
+<tbody>
+<tr class="altColor">
+<td class="colFirst"><code>static void</code></td>
+<th class="colSecond" scope="row"><span class="typeNameLabel">SqlTool.</span><code><span class="memberNameLink"><a href="../SqlTool.html#objectMain(java.lang.String%5B%5D)">objectMain</a></span>&#8203;(java.lang.String[]&nbsp;arg)</code></th>
+<td class="colLast">
+<div class="block">Connect to a JDBC Database and execute the commands given on
+ stdin or in SQL file(s).</div>
+</td>
+</tr>
+</tbody>
+</table>
+</section>
+</li>
+</ul>
+</li>
+</ul>
+</div>
+</main>
+<footer role="contentinfo">
+<nav role="navigation">
+<!-- ======= START OF BOTTOM NAVBAR ====== -->
+<div class="bottomNav"><a id="navbar.bottom">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.bottom.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../../module-summary.html">Module</a></li>
+<li><a href="../package-summary.html">Package</a></li>
+<li><a href="../SqlTool.SqlToolException.html" title="class in org.hsqldb.cmdline">Class</a></li>
+<li class="navBarCell1Rev">Use</li>
+<li><a href="../package-tree.html">Tree</a></li>
+<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../../index-all.html">Index</a></li>
+<li><a href="../../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_bottom">
+<li><a href="../../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_bottom");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.bottom">
+<!--   -->
+</a></div>
+<!-- ======== END OF BOTTOM NAVBAR ======= -->
+</nav>
+<p class="legalCopy"><small><i>Copyright © 2001 - 2022 HSQL Development Group.</i></small></p>
+</footer>
+</body>
+</html>
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/package-summary.html 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/package-summary.html
--- 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/package-summary.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/package-summary.html	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,233 @@
+<!DOCTYPE HTML>
+<!-- NewPage -->
+<html lang="en">
+<head>
+<!-- Generated by javadoc (11.0.14.1) on Tue Jul 26 22:23:00 BST 2022 -->
+<title>org.hsqldb.cmdline (HSQLDB 2.7.0 API)</title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+<meta name="dc.created" content="2022-07-26">
+<link rel="stylesheet" type="text/css" href="../../../../javadoc.css" title="Style">
+<link rel="stylesheet" type="text/css" href="../../../../jquery/jquery-ui.css" title="Style">
+<script type="text/javascript" src="../../../../script.js"></script>
+<script type="text/javascript" src="../../../../jquery/jszip/dist/jszip.min.js"></script>
+<script type="text/javascript" src="../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
+<!--[if IE]>
+<script type="text/javascript" src="../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
+<![endif]-->
+<script type="text/javascript" src="../../../../jquery/jquery-3.5.1.js"></script>
+<script type="text/javascript" src="../../../../jquery/jquery-ui.js"></script>
+</head>
+<body>
+<script type="text/javascript"><!--
+    try {
+        if (location.href.indexOf('is-external=true') == -1) {
+            parent.document.title="org.hsqldb.cmdline (HSQLDB 2.7.0 API)";
+        }
+    }
+    catch(err) {
+    }
+//-->
+var pathtoroot = "../../../../";
+var useModuleDirectories = true;
+loadScripts(document, 'script');</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+<header role="banner">
+<nav role="navigation">
+<div class="fixedNav">
+<!-- ========= START OF TOP NAVBAR ======= -->
+<div class="topNav"><a id="navbar.top">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.top.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../module-summary.html">Module</a></li>
+<li class="navBarCell1Rev">Package</li>
+<li>Class</li>
+<li><a href="package-use.html">Use</a></li>
+<li><a href="package-tree.html">Tree</a></li>
+<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../index-all.html">Index</a></li>
+<li><a href="../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_top">
+<li><a href="../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<ul class="navListSearch">
+<li><label for="search">SEARCH:</label>
+<input type="text" id="search" value="search" disabled="disabled">
+<input type="reset" id="reset" value="reset" disabled="disabled">
+</li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_top");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.top">
+<!--   -->
+</a></div>
+<!-- ========= END OF TOP NAVBAR ========= -->
+</div>
+<div class="navPadding">&nbsp;</div>
+<script type="text/javascript"><!--
+$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
+//-->
+</script>
+</nav>
+</header>
+<main role="main">
+<div class="header">
+<div class="subTitle"><span class="moduleLabelInPackage">Module</span>&nbsp;<a href="../../../module-summary.html">org.hsqldb.sqltool</a></div>
+<h1 title="Package" class="title">Package&nbsp;org.hsqldb.cmdline</h1>
+</div>
+<div class="contentContainer">
+<section role="region"><a id="package.description">
+<!--   -->
+</a>
+<div class="block">Contains the SqlTool command-line tool</div>
+</section>
+<ul class="blockList">
+<li class="blockList">
+<table class="typeSummary">
+<caption><span>Class Summary</span><span class="tabEnd">&nbsp;</span></caption>
+<tr>
+<th class="colFirst" scope="col">Class</th>
+<th class="colLast" scope="col">Description</th>
+</tr>
+<tbody>
+<tr class="altColor">
+<th class="colFirst" scope="row"><a href="SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></th>
+<td class="colLast">
+<div class="block">Encapsulation of SQL text and the environment under which it will be
+ executed with a JDBC Connection.</div>
+</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><a href="SqlTool.html" title="class in org.hsqldb.cmdline">SqlTool</a></th>
+<td class="colLast">
+<div class="block">A command-line JDBC SQL tool supporting both interactive and
+ non-interactive usage.</div>
+</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><a href="SqlToolSprayer.html" title="class in org.hsqldb.cmdline">SqlToolSprayer</a></th>
+<td class="colLast">
+<div class="block">Sql Tool Sprayer.</div>
+</td>
+</tr>
+</tbody>
+</table>
+</li>
+<li class="blockList">
+<table class="typeSummary">
+<caption><span>Enum Summary</span><span class="tabEnd">&nbsp;</span></caption>
+<tr>
+<th class="colFirst" scope="col">Enum</th>
+<th class="colLast" scope="col">Description</th>
+</tr>
+<tbody>
+<tr class="altColor">
+<th class="colFirst" scope="row"><a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></th>
+<td class="colLast">
+<div class="block">Resource Bundle for SqlTool and associated classes.</div>
+</td>
+</tr>
+</tbody>
+</table>
+</li>
+<li class="blockList">
+<table class="typeSummary">
+<caption><span>Exception Summary</span><span class="tabEnd">&nbsp;</span></caption>
+<tr>
+<th class="colFirst" scope="col">Exception</th>
+<th class="colLast" scope="col">Description</th>
+</tr>
+<tbody>
+<tr class="altColor">
+<th class="colFirst" scope="row"><a href="SqlFile.BadSpecial.html" title="class in org.hsqldb.cmdline">SqlFile.BadSpecial</a></th>
+<td class="colLast">
+<div class="block">Utility nested Exception class for internal use only.</div>
+</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><a href="SqlTool.SqlToolException.html" title="class in org.hsqldb.cmdline">SqlTool.SqlToolException</a></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><a href="SqlToolError.html" title="class in org.hsqldb.cmdline">SqlToolError</a></th>
+<td class="colLast">
+<div class="block">Exceptions thrown by the SqlTool system externally to SqlFile.</div>
+</td>
+</tr>
+</tbody>
+</table>
+</li>
+</ul>
+</div>
+</main>
+<footer role="contentinfo">
+<nav role="navigation">
+<!-- ======= START OF BOTTOM NAVBAR ====== -->
+<div class="bottomNav"><a id="navbar.bottom">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.bottom.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../module-summary.html">Module</a></li>
+<li class="navBarCell1Rev">Package</li>
+<li>Class</li>
+<li><a href="package-use.html">Use</a></li>
+<li><a href="package-tree.html">Tree</a></li>
+<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../index-all.html">Index</a></li>
+<li><a href="../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_bottom">
+<li><a href="../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_bottom");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.bottom">
+<!--   -->
+</a></div>
+<!-- ======== END OF BOTTOM NAVBAR ======= -->
+</nav>
+<p class="legalCopy"><small><i>Copyright © 2001 - 2022 HSQL Development Group.</i></small></p>
+</footer>
+</body>
+</html>
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/package-tree.html 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/package-tree.html
--- 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/package-tree.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/package-tree.html	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,191 @@
+<!DOCTYPE HTML>
+<!-- NewPage -->
+<html lang="en">
+<head>
+<!-- Generated by javadoc (11.0.14.1) on Tue Jul 26 22:23:00 BST 2022 -->
+<title>org.hsqldb.cmdline Class Hierarchy (HSQLDB 2.7.0 API)</title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+<meta name="dc.created" content="2022-07-26">
+<link rel="stylesheet" type="text/css" href="../../../../javadoc.css" title="Style">
+<link rel="stylesheet" type="text/css" href="../../../../jquery/jquery-ui.css" title="Style">
+<script type="text/javascript" src="../../../../script.js"></script>
+<script type="text/javascript" src="../../../../jquery/jszip/dist/jszip.min.js"></script>
+<script type="text/javascript" src="../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
+<!--[if IE]>
+<script type="text/javascript" src="../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
+<![endif]-->
+<script type="text/javascript" src="../../../../jquery/jquery-3.5.1.js"></script>
+<script type="text/javascript" src="../../../../jquery/jquery-ui.js"></script>
+</head>
+<body>
+<script type="text/javascript"><!--
+    try {
+        if (location.href.indexOf('is-external=true') == -1) {
+            parent.document.title="org.hsqldb.cmdline Class Hierarchy (HSQLDB 2.7.0 API)";
+        }
+    }
+    catch(err) {
+    }
+//-->
+var pathtoroot = "../../../../";
+var useModuleDirectories = true;
+loadScripts(document, 'script');</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+<header role="banner">
+<nav role="navigation">
+<div class="fixedNav">
+<!-- ========= START OF TOP NAVBAR ======= -->
+<div class="topNav"><a id="navbar.top">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.top.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../module-summary.html">Module</a></li>
+<li><a href="package-summary.html">Package</a></li>
+<li>Class</li>
+<li>Use</li>
+<li class="navBarCell1Rev">Tree</li>
+<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../index-all.html">Index</a></li>
+<li><a href="../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_top">
+<li><a href="../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<ul class="navListSearch">
+<li><label for="search">SEARCH:</label>
+<input type="text" id="search" value="search" disabled="disabled">
+<input type="reset" id="reset" value="reset" disabled="disabled">
+</li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_top");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.top">
+<!--   -->
+</a></div>
+<!-- ========= END OF TOP NAVBAR ========= -->
+</div>
+<div class="navPadding">&nbsp;</div>
+<script type="text/javascript"><!--
+$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
+//-->
+</script>
+</nav>
+</header>
+<main role="main">
+<div class="header">
+<h1 class="title">Hierarchy For Package org.hsqldb.cmdline</h1>
+</div>
+<div class="contentContainer">
+<section role="region">
+<h2 title="Class Hierarchy">Class Hierarchy</h2>
+<ul>
+<li class="circle">java.lang.Object
+<ul>
+<li class="circle">org.hsqldb.cmdline.<a href="SqlFile.html" title="class in org.hsqldb.cmdline"><span class="typeNameLink">SqlFile</span></a></li>
+<li class="circle">org.hsqldb.cmdline.<a href="SqlTool.html" title="class in org.hsqldb.cmdline"><span class="typeNameLink">SqlTool</span></a></li>
+<li class="circle">org.hsqldb.cmdline.<a href="SqlToolSprayer.html" title="class in org.hsqldb.cmdline"><span class="typeNameLink">SqlToolSprayer</span></a></li>
+<li class="circle">java.lang.Throwable (implements java.io.Serializable)
+<ul>
+<li class="circle">java.lang.Exception
+<ul>
+<li class="circle">org.hsqldb.cmdline.libclone.AppendableException
+<ul>
+<li class="circle">org.hsqldb.cmdline.<a href="SqlFile.BadSpecial.html" title="class in org.hsqldb.cmdline"><span class="typeNameLink">SqlFile.BadSpecial</span></a></li>
+<li class="circle">org.hsqldb.cmdline.<a href="SqlToolError.html" title="class in org.hsqldb.cmdline"><span class="typeNameLink">SqlToolError</span></a></li>
+</ul>
+</li>
+<li class="circle">org.hsqldb.cmdline.<a href="SqlTool.SqlToolException.html" title="class in org.hsqldb.cmdline"><span class="typeNameLink">SqlTool.SqlToolException</span></a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</section>
+<section role="region">
+<h2 title="Enum Hierarchy">Enum Hierarchy</h2>
+<ul>
+<li class="circle">java.lang.Object
+<ul>
+<li class="circle">java.lang.Enum&lt;E&gt; (implements java.lang.Comparable&lt;T&gt;, java.io.Serializable)
+<ul>
+<li class="circle">org.hsqldb.cmdline.<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline"><span class="typeNameLink">SqltoolRB</span></a> (implements org.hsqldb.cmdline.libclone.RefCapableRBInterface)</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</section>
+</div>
+</main>
+<footer role="contentinfo">
+<nav role="navigation">
+<!-- ======= START OF BOTTOM NAVBAR ====== -->
+<div class="bottomNav"><a id="navbar.bottom">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.bottom.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../module-summary.html">Module</a></li>
+<li><a href="package-summary.html">Package</a></li>
+<li>Class</li>
+<li>Use</li>
+<li class="navBarCell1Rev">Tree</li>
+<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../index-all.html">Index</a></li>
+<li><a href="../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_bottom">
+<li><a href="../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_bottom");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.bottom">
+<!--   -->
+</a></div>
+<!-- ======== END OF BOTTOM NAVBAR ======= -->
+</nav>
+<p class="legalCopy"><small><i>Copyright © 2001 - 2022 HSQL Development Group.</i></small></p>
+</footer>
+</body>
+</html>
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/package-use.html 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/package-use.html
--- 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/package-use.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/package-use.html	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,187 @@
+<!DOCTYPE HTML>
+<!-- NewPage -->
+<html lang="en">
+<head>
+<!-- Generated by javadoc (11.0.14.1) on Tue Jul 26 22:23:00 BST 2022 -->
+<title>Uses of Package org.hsqldb.cmdline (HSQLDB 2.7.0 API)</title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+<meta name="dc.created" content="2022-07-26">
+<link rel="stylesheet" type="text/css" href="../../../../javadoc.css" title="Style">
+<link rel="stylesheet" type="text/css" href="../../../../jquery/jquery-ui.css" title="Style">
+<script type="text/javascript" src="../../../../script.js"></script>
+<script type="text/javascript" src="../../../../jquery/jszip/dist/jszip.min.js"></script>
+<script type="text/javascript" src="../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
+<!--[if IE]>
+<script type="text/javascript" src="../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
+<![endif]-->
+<script type="text/javascript" src="../../../../jquery/jquery-3.5.1.js"></script>
+<script type="text/javascript" src="../../../../jquery/jquery-ui.js"></script>
+</head>
+<body>
+<script type="text/javascript"><!--
+    try {
+        if (location.href.indexOf('is-external=true') == -1) {
+            parent.document.title="Uses of Package org.hsqldb.cmdline (HSQLDB 2.7.0 API)";
+        }
+    }
+    catch(err) {
+    }
+//-->
+var pathtoroot = "../../../../";
+var useModuleDirectories = true;
+loadScripts(document, 'script');</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+<header role="banner">
+<nav role="navigation">
+<div class="fixedNav">
+<!-- ========= START OF TOP NAVBAR ======= -->
+<div class="topNav"><a id="navbar.top">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.top.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../module-summary.html">Module</a></li>
+<li><a href="package-summary.html">Package</a></li>
+<li>Class</li>
+<li class="navBarCell1Rev">Use</li>
+<li><a href="package-tree.html">Tree</a></li>
+<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../index-all.html">Index</a></li>
+<li><a href="../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_top">
+<li><a href="../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<ul class="navListSearch">
+<li><label for="search">SEARCH:</label>
+<input type="text" id="search" value="search" disabled="disabled">
+<input type="reset" id="reset" value="reset" disabled="disabled">
+</li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_top");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.top">
+<!--   -->
+</a></div>
+<!-- ========= END OF TOP NAVBAR ========= -->
+</div>
+<div class="navPadding">&nbsp;</div>
+<script type="text/javascript"><!--
+$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
+//-->
+</script>
+</nav>
+</header>
+<main role="main">
+<div class="header">
+<h1 title="Uses of Package org.hsqldb.cmdline" class="title">Uses of Package<br>org.hsqldb.cmdline</h1>
+</div>
+<div class="contentContainer">
+<ul class="blockList">
+<li class="blockList"><a id="org.hsqldb.cmdline">
+<!--   -->
+</a>
+<table class="useSummary">
+<caption><span>Classes in <a href="package-summary.html">org.hsqldb.cmdline</a> used by <a href="package-summary.html">org.hsqldb.cmdline</a></span><span class="tabEnd">&nbsp;</span></caption>
+<tr>
+<th class="colFirst" scope="col">Class</th>
+<th class="colLast" scope="col">Description</th>
+</tr>
+<tbody>
+<tr class="altColor">
+<th class="colFirst" scope="row"><a href="class-use/SqlFile.BadSpecial.html#org.hsqldb.cmdline">SqlFile.BadSpecial</a></th>
+<td class="colLast">
+<div class="block">Utility nested Exception class for internal use only.</div>
+</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><a href="class-use/SqlTool.SqlToolException.html#org.hsqldb.cmdline">SqlTool.SqlToolException</a></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><a href="class-use/SqlToolError.html#org.hsqldb.cmdline">SqlToolError</a></th>
+<td class="colLast">
+<div class="block">Exceptions thrown by the SqlTool system externally to SqlFile.</div>
+</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><a href="class-use/SqltoolRB.html#org.hsqldb.cmdline">SqltoolRB</a></th>
+<td class="colLast">
+<div class="block">Resource Bundle for SqlTool and associated classes.</div>
+</td>
+</tr>
+</tbody>
+</table>
+</li>
+</ul>
+</div>
+</main>
+<footer role="contentinfo">
+<nav role="navigation">
+<!-- ======= START OF BOTTOM NAVBAR ====== -->
+<div class="bottomNav"><a id="navbar.bottom">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.bottom.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../module-summary.html">Module</a></li>
+<li><a href="package-summary.html">Package</a></li>
+<li>Class</li>
+<li class="navBarCell1Rev">Use</li>
+<li><a href="package-tree.html">Tree</a></li>
+<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../index-all.html">Index</a></li>
+<li><a href="../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_bottom">
+<li><a href="../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_bottom");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.bottom">
+<!--   -->
+</a></div>
+<!-- ======== END OF BOTTOM NAVBAR ======= -->
+</nav>
+<p class="legalCopy"><small><i>Copyright © 2001 - 2022 HSQL Development Group.</i></small></p>
+</footer>
+</body>
+</html>
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.BadSpecial.html 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.BadSpecial.html
--- 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.BadSpecial.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.BadSpecial.html	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,285 @@
+<!DOCTYPE HTML>
+<!-- NewPage -->
+<html lang="en">
+<head>
+<!-- Generated by javadoc (11.0.14.1) on Tue Jul 26 22:23:00 BST 2022 -->
+<title>SqlFile.BadSpecial (HSQLDB 2.7.0 API)</title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+<meta name="dc.created" content="2022-07-26">
+<link rel="stylesheet" type="text/css" href="../../../../javadoc.css" title="Style">
+<link rel="stylesheet" type="text/css" href="../../../../jquery/jquery-ui.css" title="Style">
+<script type="text/javascript" src="../../../../script.js"></script>
+<script type="text/javascript" src="../../../../jquery/jszip/dist/jszip.min.js"></script>
+<script type="text/javascript" src="../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
+<!--[if IE]>
+<script type="text/javascript" src="../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
+<![endif]-->
+<script type="text/javascript" src="../../../../jquery/jquery-3.5.1.js"></script>
+<script type="text/javascript" src="../../../../jquery/jquery-ui.js"></script>
+</head>
+<body>
+<script type="text/javascript"><!--
+    try {
+        if (location.href.indexOf('is-external=true') == -1) {
+            parent.document.title="SqlFile.BadSpecial (HSQLDB 2.7.0 API)";
+        }
+    }
+    catch(err) {
+    }
+//-->
+var pathtoroot = "../../../../";
+var useModuleDirectories = true;
+loadScripts(document, 'script');</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+<header role="banner">
+<nav role="navigation">
+<div class="fixedNav">
+<!-- ========= START OF TOP NAVBAR ======= -->
+<div class="topNav"><a id="navbar.top">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.top.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../module-summary.html">Module</a></li>
+<li><a href="package-summary.html">Package</a></li>
+<li class="navBarCell1Rev">Class</li>
+<li><a href="class-use/SqlFile.BadSpecial.html">Use</a></li>
+<li><a href="package-tree.html">Tree</a></li>
+<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../index-all.html">Index</a></li>
+<li><a href="../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_top">
+<li><a href="../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<ul class="navListSearch">
+<li><label for="search">SEARCH:</label>
+<input type="text" id="search" value="search" disabled="disabled">
+<input type="reset" id="reset" value="reset" disabled="disabled">
+</li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_top");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<div>
+<ul class="subNavList">
+<li>Summary:&nbsp;</li>
+<li>Nested&nbsp;|&nbsp;</li>
+<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
+<li>Constr&nbsp;|&nbsp;</li>
+<li><a href="#method.summary">Method</a></li>
+</ul>
+<ul class="subNavList">
+<li>Detail:&nbsp;</li>
+<li>Field&nbsp;|&nbsp;</li>
+<li>Constr&nbsp;|&nbsp;</li>
+<li>Method</li>
+</ul>
+</div>
+<a id="skip.navbar.top">
+<!--   -->
+</a></div>
+<!-- ========= END OF TOP NAVBAR ========= -->
+</div>
+<div class="navPadding">&nbsp;</div>
+<script type="text/javascript"><!--
+$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
+//-->
+</script>
+</nav>
+</header>
+<!-- ======== START OF CLASS DATA ======== -->
+<main role="main">
+<div class="header">
+<div class="subTitle"><span class="moduleLabelInType">Module</span>&nbsp;<a href="../../../module-summary.html">org.hsqldb.sqltool</a></div>
+<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">org.hsqldb.cmdline</a></div>
+<h2 title="Class SqlFile.BadSpecial" class="title">Class SqlFile.BadSpecial</h2>
+</div>
+<div class="contentContainer">
+<ul class="inheritance">
+<li>java.lang.Object</li>
+<li>
+<ul class="inheritance">
+<li>java.lang.Throwable</li>
+<li>
+<ul class="inheritance">
+<li>java.lang.Exception</li>
+<li>
+<ul class="inheritance">
+<li>org.hsqldb.cmdline.libclone.AppendableException</li>
+<li>
+<ul class="inheritance">
+<li>org.hsqldb.cmdline.SqlFile.BadSpecial</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<div class="description">
+<ul class="blockList">
+<li class="blockList">
+<dl>
+<dt>All Implemented Interfaces:</dt>
+<dd><code>java.io.Serializable</code></dd>
+</dl>
+<dl>
+<dt>Enclosing class:</dt>
+<dd><a href="SqlFile.html" title="class in org.hsqldb.cmdline">SqlFile</a></dd>
+</dl>
+<hr>
+<pre>public static class <span class="typeNameLabel">SqlFile.BadSpecial</span>
+extends org.hsqldb.cmdline.libclone.AppendableException</pre>
+<div class="block">Utility nested Exception class for internal use only.
+
+ Do not instantiate with null message.</div>
+<dl>
+<dt><span class="seeLabel">See Also:</span></dt>
+<dd><a href="../../../../serialized-form.html#org.hsqldb.cmdline.SqlFile.BadSpecial">Serialized Form</a></dd>
+</dl>
+</li>
+</ul>
+</div>
+<div class="summary">
+<ul class="blockList">
+<li class="blockList">
+<!-- =========== FIELD SUMMARY =========== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="field.summary">
+<!--   -->
+</a>
+<h3>Field Summary</h3>
+<ul class="blockList">
+<li class="blockList"><a id="fields.inherited.from.class.org.hsqldb.cmdline.libclone.AppendableException">
+<!--   -->
+</a>
+<h3>Fields inherited from class&nbsp;org.hsqldb.cmdline.libclone.AppendableException</h3>
+<code>appendages, LS</code></li>
+</ul>
+</li>
+</ul>
+</section>
+<!-- ========== METHOD SUMMARY =========== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="method.summary">
+<!--   -->
+</a>
+<h3>Method Summary</h3>
+<ul class="blockList">
+<li class="blockList"><a id="methods.inherited.from.class.org.hsqldb.cmdline.libclone.AppendableException">
+<!--   -->
+</a>
+<h3>Methods inherited from class&nbsp;org.hsqldb.cmdline.libclone.AppendableException</h3>
+<code>appendMessage, getMessage</code></li>
+</ul>
+<ul class="blockList">
+<li class="blockList"><a id="methods.inherited.from.class.java.lang.Throwable">
+<!--   -->
+</a>
+<h3>Methods inherited from class&nbsp;java.lang.Throwable</h3>
+<code>addSuppressed, fillInStackTrace, getCause, getLocalizedMessage, getStackTrace, getSuppressed, initCause, printStackTrace, printStackTrace, printStackTrace, setStackTrace, toString</code></li>
+</ul>
+<ul class="blockList">
+<li class="blockList"><a id="methods.inherited.from.class.java.lang.Object">
+<!--   -->
+</a>
+<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
+<code>equals, getClass, hashCode, notify, notifyAll, wait, wait, wait</code></li>
+</ul>
+</li>
+</ul>
+</section>
+</li>
+</ul>
+</div>
+</div>
+</main>
+<!-- ========= END OF CLASS DATA ========= -->
+<footer role="contentinfo">
+<nav role="navigation">
+<!-- ======= START OF BOTTOM NAVBAR ====== -->
+<div class="bottomNav"><a id="navbar.bottom">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.bottom.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../module-summary.html">Module</a></li>
+<li><a href="package-summary.html">Package</a></li>
+<li class="navBarCell1Rev">Class</li>
+<li><a href="class-use/SqlFile.BadSpecial.html">Use</a></li>
+<li><a href="package-tree.html">Tree</a></li>
+<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../index-all.html">Index</a></li>
+<li><a href="../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_bottom">
+<li><a href="../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_bottom");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<div>
+<ul class="subNavList">
+<li>Summary:&nbsp;</li>
+<li>Nested&nbsp;|&nbsp;</li>
+<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
+<li>Constr&nbsp;|&nbsp;</li>
+<li><a href="#method.summary">Method</a></li>
+</ul>
+<ul class="subNavList">
+<li>Detail:&nbsp;</li>
+<li>Field&nbsp;|&nbsp;</li>
+<li>Constr&nbsp;|&nbsp;</li>
+<li>Method</li>
+</ul>
+</div>
+<a id="skip.navbar.bottom">
+<!--   -->
+</a></div>
+<!-- ======== END OF BOTTOM NAVBAR ======= -->
+</nav>
+<p class="legalCopy"><small><i>Copyright © 2001 - 2022 HSQL Development Group.</i></small></p>
+</footer>
+</body>
+</html>
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html
--- 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,1289 @@
+<!DOCTYPE HTML>
+<!-- NewPage -->
+<html lang="en">
+<head>
+<!-- Generated by javadoc (11.0.14.1) on Tue Jul 26 22:23:00 BST 2022 -->
+<title>SqlFile (HSQLDB 2.7.0 API)</title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+<meta name="dc.created" content="2022-07-26">
+<link rel="stylesheet" type="text/css" href="../../../../javadoc.css" title="Style">
+<link rel="stylesheet" type="text/css" href="../../../../jquery/jquery-ui.css" title="Style">
+<script type="text/javascript" src="../../../../script.js"></script>
+<script type="text/javascript" src="../../../../jquery/jszip/dist/jszip.min.js"></script>
+<script type="text/javascript" src="../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
+<!--[if IE]>
+<script type="text/javascript" src="../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
+<![endif]-->
+<script type="text/javascript" src="../../../../jquery/jquery-3.5.1.js"></script>
+<script type="text/javascript" src="../../../../jquery/jquery-ui.js"></script>
+</head>
+<body>
+<script type="text/javascript"><!--
+    try {
+        if (location.href.indexOf('is-external=true') == -1) {
+            parent.document.title="SqlFile (HSQLDB 2.7.0 API)";
+        }
+    }
+    catch(err) {
+    }
+//-->
+var data = {"i0":10,"i1":10,"i2":9,"i3":9,"i4":10,"i5":9,"i6":10,"i7":9,"i8":10,"i9":9,"i10":10,"i11":10,"i12":10,"i13":10,"i14":9,"i15":10,"i16":9,"i17":9,"i18":10,"i19":10,"i20":10,"i21":10,"i22":9,"i23":9,"i24":10,"i25":9};
+var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
+var altColor = "altColor";
+var rowColor = "rowColor";
+var tableTab = "tableTab";
+var activeTableTab = "activeTableTab";
+var pathtoroot = "../../../../";
+var useModuleDirectories = true;
+loadScripts(document, 'script');</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+<header role="banner">
+<nav role="navigation">
+<div class="fixedNav">
+<!-- ========= START OF TOP NAVBAR ======= -->
+<div class="topNav"><a id="navbar.top">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.top.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../module-summary.html">Module</a></li>
+<li><a href="package-summary.html">Package</a></li>
+<li class="navBarCell1Rev">Class</li>
+<li><a href="class-use/SqlFile.html">Use</a></li>
+<li><a href="package-tree.html">Tree</a></li>
+<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../index-all.html">Index</a></li>
+<li><a href="../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_top">
+<li><a href="../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<ul class="navListSearch">
+<li><label for="search">SEARCH:</label>
+<input type="text" id="search" value="search" disabled="disabled">
+<input type="reset" id="reset" value="reset" disabled="disabled">
+</li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_top");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<div>
+<ul class="subNavList">
+<li>Summary:&nbsp;</li>
+<li><a href="#nested.class.summary">Nested</a>&nbsp;|&nbsp;</li>
+<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
+<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
+<li><a href="#method.summary">Method</a></li>
+</ul>
+<ul class="subNavList">
+<li>Detail:&nbsp;</li>
+<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
+<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
+<li><a href="#method.detail">Method</a></li>
+</ul>
+</div>
+<a id="skip.navbar.top">
+<!--   -->
+</a></div>
+<!-- ========= END OF TOP NAVBAR ========= -->
+</div>
+<div class="navPadding">&nbsp;</div>
+<script type="text/javascript"><!--
+$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
+//-->
+</script>
+</nav>
+</header>
+<!-- ======== START OF CLASS DATA ======== -->
+<main role="main">
+<div class="header">
+<div class="subTitle"><span class="moduleLabelInType">Module</span>&nbsp;<a href="../../../module-summary.html">org.hsqldb.sqltool</a></div>
+<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">org.hsqldb.cmdline</a></div>
+<h2 title="Class SqlFile" class="title">Class SqlFile</h2>
+</div>
+<div class="contentContainer">
+<ul class="inheritance">
+<li>java.lang.Object</li>
+<li>
+<ul class="inheritance">
+<li>org.hsqldb.cmdline.SqlFile</li>
+</ul>
+</li>
+</ul>
+<div class="description">
+<ul class="blockList">
+<li class="blockList">
+<hr>
+<pre>public class <span class="typeNameLabel">SqlFile</span>
+extends java.lang.Object</pre>
+<div class="block">Encapsulation of SQL text and the environment under which it will be
+ executed with a JDBC Connection.
+ 'SqlInputStream' would be a more precise name, but the content we are
+ talking about here is what is colloqially known as the contents of
+ "SQL file"s.
+ <P>
+ The file <CODE>src/org/hsqldb/sample/SqlFileEmbedder.java</CODE>
+ in the HSQLDB distribution provides an example for using SqlFile to
+ execute SQL files directly from your own Java classes.
+ <P>
+ The complexities of passing userVars and macros maps are to facilitate
+ strong scoping (among blocks and nested scripts).
+ <P>
+ Some implementation comments and variable names use keywords based
+ on the following definitions.  <UL>
+ <LI> COMMAND = Statement || SpecialCommand || BufferCommand
+ <LI>Statement = SQL statement like "SQL Statement;"
+ <LI>SpecialCommand =  Special Command like "\x arg..."
+ <LI>BufferCommand =  Editing/buffer command like ":s/this/that/"
+ </UL>
+ <P>
+ When entering SQL statements, you are always "appending" to the
+ "immediate" command (not the "buffer", which is a different thing).
+ All you can do to the immediate command is append new lines to it,
+ execute it, or save it to buffer.
+ When you are entering a buffer edit command like ":s/this/that/",
+ your immediate command is the buffer-edit-command.  The buffer
+ is the command string that you are editing.
+ The buffer usually contains either an exact copy of the last command
+ executed or sent to buffer by entering a blank line,
+ but BUFFER commands can change the contents of the buffer.
+ <P>
+ In general, the special commands mirror those of Postgresql's psql,
+ but SqlFile handles command editing very differently than Postgresql
+ does, in part because of Java's lack of support for raw tty I/O.
+ The \p special command, in particular, is very different from psql's.
+ <P>
+ Buffer commands are unique to SQLFile.  The ":" commands allow
+ you to edit the buffer and to execute the buffer.
+ <P>
+ \d commands are very poorly supported for Mysql because
+ (a) Mysql lacks most of the most basic JDBC support elements, and
+ the most basic role and schema features, and
+ (b) to access the Mysql data dictionary, one must change the database
+ instance (to do that would require work to restore the original state
+ and could have disastrous effects upon transactions).
+ <P>
+ The process*() methods, other than processBuffHist() ALWAYS execute
+ on "buffer", and expect it to contain the method specific prefix
+ (if any).
+ <P>
+ The input/output Reader/Stream are generally managed by the caller.
+ An exception is that the input reader may be closed automatically or on
+ demand by the user, since in some cases this class builds the Reader.
+ There is no corresponding functionality for output since the user always
+ has control over that object (which may be null or System.out).</div>
+<dl>
+<dt><span class="simpleTagLabel">Author:</span></dt>
+<dd>Blaine Simpson (blaine dot simpson at admc dot com)</dd>
+<dt><span class="seeLabel">See Also:</span></dt>
+<dd><a href="../../../../util-guide/sqltool-chapt.html" target="guide">
+     The SqlTool chapter of the
+     HyperSQL Utilities Guide</a></dd>
+</dl>
+</li>
+</ul>
+</div>
+<div class="summary">
+<ul class="blockList">
+<li class="blockList">
+<!-- ======== NESTED CLASS SUMMARY ======== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="nested.class.summary">
+<!--   -->
+</a>
+<h3>Nested Class Summary</h3>
+<table class="memberSummary">
+<caption><span>Nested Classes</span><span class="tabEnd">&nbsp;</span></caption>
+<tr>
+<th class="colFirst" scope="col">Modifier and Type</th>
+<th class="colSecond" scope="col">Class</th>
+<th class="colLast" scope="col">Description</th>
+</tr>
+<tr class="altColor">
+<td class="colFirst"><code>static class&nbsp;</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="SqlFile.BadSpecial.html" title="class in org.hsqldb.cmdline">SqlFile.BadSpecial</a></span></code></th>
+<td class="colLast">
+<div class="block">Utility nested Exception class for internal use only.</div>
+</td>
+</tr>
+</table>
+</li>
+</ul>
+</section>
+<!-- =========== FIELD SUMMARY =========== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="field.summary">
+<!--   -->
+</a>
+<h3>Field Summary</h3>
+<table class="memberSummary">
+<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
+<tr>
+<th class="colFirst" scope="col">Modifier and Type</th>
+<th class="colSecond" scope="col">Field</th>
+<th class="colLast" scope="col">Description</th>
+</tr>
+<tr class="altColor">
+<td class="colFirst"><code>static java.lang.String</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#LS">LS</a></span></code></th>
+<td class="colLast">
+<div class="block">Platform-specific line separator</div>
+</td>
+</tr>
+</table>
+</li>
+</ul>
+</section>
+<!-- ======== CONSTRUCTOR SUMMARY ======== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="constructor.summary">
+<!--   -->
+</a>
+<h3>Constructor Summary</h3>
+<table class="memberSummary">
+<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
+<tr>
+<th class="colFirst" scope="col">Constructor</th>
+<th class="colLast" scope="col">Description</th>
+</tr>
+<tr class="altColor">
+<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E(java.io.File)">SqlFile</a></span>&#8203;(java.io.File&nbsp;inputFile)</code></th>
+<td class="colLast">
+<div class="block">Convenience wrapper for the SqlFile(File, String) constructor</div>
+</td>
+</tr>
+<tr class="rowColor">
+<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E(java.io.File,java.lang.String)">SqlFile</a></span>&#8203;(java.io.File&nbsp;inputFile,
+       java.lang.String&nbsp;encoding)</code></th>
+<td class="colLast">
+<div class="block">Convenience wrapper for the SqlFile(File, String, boolean) constructor</div>
+</td>
+</tr>
+<tr class="altColor">
+<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E(java.io.File,java.lang.String,boolean)">SqlFile</a></span>&#8203;(java.io.File&nbsp;inputFile,
+       java.lang.String&nbsp;encoding,
+       boolean&nbsp;interactive)</code></th>
+<td class="colLast">
+<div class="block">Constructor for non-interactive usage with a SQL file, using the
+ specified encoding and sending normal output to stdout.</div>
+</td>
+</tr>
+<tr class="rowColor">
+<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E(java.io.Reader,java.lang.String,java.io.PrintStream,java.lang.String,boolean,java.io.File)">SqlFile</a></span>&#8203;(java.io.Reader&nbsp;reader,
+       java.lang.String&nbsp;inputStreamLabel,
+       java.io.PrintStream&nbsp;psStd,
+       java.lang.String&nbsp;encoding,
+       boolean&nbsp;interactive,
+       java.io.File&nbsp;atBaseFile)</code></th>
+<td class="colLast">
+<div class="block">Legacy constructor.</div>
+</td>
+</tr>
+<tr class="altColor">
+<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E(java.io.Reader,java.lang.String,java.io.PrintStream,java.lang.String,boolean,java.net.URL)">SqlFile</a></span>&#8203;(java.io.Reader&nbsp;reader,
+       java.lang.String&nbsp;inputStreamLabel,
+       java.io.PrintStream&nbsp;psStd,
+       java.lang.String&nbsp;encoding,
+       boolean&nbsp;interactive,
+       java.net.URL&nbsp;atBase)</code></th>
+<td class="colLast">
+<div class="block">Instantiate a SqlFile instance for SQL input from 'reader'.</div>
+</td>
+</tr>
+<tr class="rowColor">
+<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E(java.lang.String,boolean)">SqlFile</a></span>&#8203;(java.lang.String&nbsp;encoding,
+       boolean&nbsp;interactive)</code></th>
+<td class="colLast">
+<div class="block">Constructor for interactive usage with stdin/stdout</div>
+</td>
+</tr>
+<tr class="altColor">
+<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E(java.net.URL)">SqlFile</a></span>&#8203;(java.net.URL&nbsp;inputUrl)</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E(java.net.URL,java.lang.String)">SqlFile</a></span>&#8203;(java.net.URL&nbsp;inputUrl,
+       java.lang.String&nbsp;encoding)</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E(java.net.URL,java.lang.String,boolean)">SqlFile</a></span>&#8203;(java.net.URL&nbsp;inputUrl,
+       java.lang.String&nbsp;encoding,
+       boolean&nbsp;interactive)</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+</table>
+</li>
+</ul>
+</section>
+<!-- ========== METHOD SUMMARY =========== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="method.summary">
+<!--   -->
+</a>
+<h3>Method Summary</h3>
+<table class="memberSummary">
+<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t1" class="tableTab"><span><a href="javascript:show(1);">Static Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
+<tr>
+<th class="colFirst" scope="col">Modifier and Type</th>
+<th class="colSecond" scope="col">Method</th>
+<th class="colLast" scope="col">Description</th>
+</tr>
+<tr id="i0" class="altColor">
+<td class="colFirst"><code>void</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#addMacros(java.util.Map)">addMacros</a></span>&#8203;(java.util.Map&lt;java.lang.String,&#8203;org.hsqldb.cmdline.sqltool.Token&gt;&nbsp;newMacros)</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr id="i1" class="rowColor">
+<td class="colFirst"><code>void</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#addUserVars(java.util.Map)">addUserVars</a></span>&#8203;(java.util.Map&lt;java.lang.String,&#8203;java.lang.String&gt;&nbsp;newUserVars)</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr id="i2" class="altColor">
+<td class="colFirst"><code>static byte[]</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#bitCharsToBytes(java.lang.String)">bitCharsToBytes</a></span>&#8203;(java.lang.String&nbsp;hexChars)</code></th>
+<td class="colLast">
+<div class="block">Just a stub for now.</div>
+</td>
+</tr>
+<tr id="i3" class="rowColor">
+<td class="colFirst"><code>static boolean</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#canDisplayType(int)">canDisplayType</a></span>&#8203;(int&nbsp;i)</code></th>
+<td class="colLast">
+<div class="block">This method is used to tell SqlFile whether this Sql Type must
+ ALWAYS be loaded to the binary buffer without displaying.</div>
+</td>
+</tr>
+<tr id="i4" class="altColor">
+<td class="colFirst"><code>void</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#closeReader()">closeReader</a></span>()</code></th>
+<td class="colLast">
+<div class="block">Close the reader.</div>
+</td>
+</tr>
+<tr id="i5" class="rowColor">
+<td class="colFirst"><code>static java.lang.String</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#convertEscapes(java.lang.String)">convertEscapes</a></span>&#8203;(java.lang.String&nbsp;inString)</code></th>
+<td class="colLast">
+<div class="block">Translates user-supplied escapes into the traditionaly
+ corresponding binary characters.</div>
+</td>
+</tr>
+<tr id="i6" class="altColor">
+<td class="colFirst"><code>void</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#dsvSafe(java.lang.String)">dsvSafe</a></span>&#8203;(java.lang.String&nbsp;s)</code></th>
+<td class="colLast">
+<div class="block">Validate that String is safe to write TO DSV file.</div>
+</td>
+</tr>
+<tr id="i7" class="rowColor">
+<td class="colFirst"><code>static java.lang.String</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#escapeHtml(java.lang.String)">escapeHtml</a></span>&#8203;(java.lang.String&nbsp;s)</code></th>
+<td class="colLast">
+<div class="block">Escaping rules taken from 'Reserved Characters in HTML table at
+ <a href="http://www.w3schools.com/tags/ref_entities.asp">http://www.w3schools.com/tags/ref_entities.asp</a></div>
+</td>
+</tr>
+<tr id="i8" class="altColor">
+<td class="colFirst"><code>void</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#execute()">execute</a></span>()</code></th>
+<td class="colLast">
+<div class="block">Process all the commands from the file or Reader associated with
+ "this" object.</div>
+</td>
+</tr>
+<tr id="i9" class="rowColor">
+<td class="colFirst"><code>static java.lang.String</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getBanner(java.sql.Connection)">getBanner</a></span>&#8203;(java.sql.Connection&nbsp;c)</code></th>
+<td class="colLast">
+<div class="block">Returns a String report for the specified JDBC Connection.</div>
+</td>
+</tr>
+<tr id="i10" class="altColor">
+<td class="colFirst"><code>java.sql.Connection</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getConnection()">getConnection</a></span>()</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr id="i11" class="rowColor">
+<td class="colFirst"><code>java.lang.String</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getCurrentSchema()">getCurrentSchema</a></span>()</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr id="i12" class="altColor">
+<td class="colFirst"><code>java.util.Map&lt;java.lang.String,&#8203;org.hsqldb.cmdline.sqltool.Token&gt;</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getMacros()">getMacros</a></span>()</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr id="i13" class="rowColor">
+<td class="colFirst"><code>java.util.Map&lt;java.lang.String,&#8203;java.lang.String&gt;</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getUserVars()">getUserVars</a></span>()</code></th>
+<td class="colLast">
+<div class="block">Get a reference to the user variable map.</div>
+</td>
+</tr>
+<tr id="i14" class="altColor">
+<td class="colFirst"><code>static byte[]</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#hexCharOctetsToBytes(java.lang.String)">hexCharOctetsToBytes</a></span>&#8203;(java.lang.String&nbsp;hexChars)</code></th>
+<td class="colLast">
+<div class="block">Convert a String to a byte array by interpreting every 2 characters as an
+ octal byte value.</div>
+</td>
+</tr>
+<tr id="i15" class="rowColor">
+<td class="colFirst"><code>void</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#importDsv(java.net.URL,java.lang.String)">importDsv</a></span>&#8203;(java.net.URL&nbsp;fileUrl,
+         java.lang.String&nbsp;skipPrefix)</code></th>
+<td class="colLast">
+<div class="block">Name is self-explanatory.</div>
+</td>
+</tr>
+<tr id="i16" class="altColor">
+<td class="colFirst"><code>static byte[]</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#loadBinary(java.io.File)">loadBinary</a></span>&#8203;(java.io.File&nbsp;binFile)</code></th>
+<td class="colLast">
+<div class="block">Legacy function.</div>
+</td>
+</tr>
+<tr id="i17" class="rowColor">
+<td class="colFirst"><code>static byte[]</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#loadBinary(java.net.URL)">loadBinary</a></span>&#8203;(java.net.URL&nbsp;binUrl)</code></th>
+<td class="colLast">
+<div class="block">Binary file load</div>
+</td>
+</tr>
+<tr id="i18" class="altColor">
+<td class="colFirst"><code>void</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setAutoClose(boolean)">setAutoClose</a></span>&#8203;(boolean&nbsp;autoClose)</code></th>
+<td class="colLast">
+<div class="block">Specify whether the supplied or generated input Reader should
+ automatically be closed by the execute() method.</div>
+</td>
+</tr>
+<tr id="i19" class="rowColor">
+<td class="colFirst"><code>void</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setConnection(java.sql.Connection)">setConnection</a></span>&#8203;(java.sql.Connection&nbsp;jdbcConn)</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr id="i20" class="altColor">
+<td class="colFirst"><code>void</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setContinueOnError(boolean)">setContinueOnError</a></span>&#8203;(boolean&nbsp;continueOnError)</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr id="i21" class="rowColor">
+<td class="colFirst"><code>void</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setMaxHistoryLength(int)">setMaxHistoryLength</a></span>&#8203;(int&nbsp;maxHistoryLength)</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr id="i22" class="altColor">
+<td class="colFirst"><code>static java.lang.String</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#sqlTypeToString(int)">sqlTypeToString</a></span>&#8203;(int&nbsp;i)</code></th>
+<td class="colLast">
+<div class="block">Return a String representation of the specified java.sql.Types type.</div>
+</td>
+</tr>
+<tr id="i23" class="rowColor">
+<td class="colFirst"><code>static byte[]</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#streamToBytes(java.io.InputStream)">streamToBytes</a></span>&#8203;(java.io.InputStream&nbsp;is)</code></th>
+<td class="colLast">
+<div class="block">As the name says...</div>
+</td>
+</tr>
+<tr id="i24" class="altColor">
+<td class="colFirst"><code>java.lang.String</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#streamToString(java.io.InputStream,java.lang.String)">streamToString</a></span>&#8203;(java.io.InputStream&nbsp;is,
+              java.lang.String&nbsp;cs)</code></th>
+<td class="colLast">
+<div class="block">As the name says...</div>
+</td>
+</tr>
+<tr id="i25" class="rowColor">
+<td class="colFirst"><code>static java.lang.String</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#toPaddedString(java.lang.String,int,char,boolean)">toPaddedString</a></span>&#8203;(java.lang.String&nbsp;source,
+              int&nbsp;length,
+              char&nbsp;pad,
+              boolean&nbsp;trailing)</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+</table>
+<ul class="blockList">
+<li class="blockList"><a id="methods.inherited.from.class.java.lang.Object">
+<!--   -->
+</a>
+<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
+<code>equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
+</ul>
+</li>
+</ul>
+</section>
+</li>
+</ul>
+</div>
+<div class="details">
+<ul class="blockList">
+<li class="blockList">
+<!-- ============ FIELD DETAIL =========== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="field.detail">
+<!--   -->
+</a>
+<h3>Field Detail</h3>
+<a id="LS">
+<!--   -->
+</a>
+<ul class="blockListLast">
+<li class="blockList">
+<h4>LS</h4>
+<pre>public static final&nbsp;java.lang.String LS</pre>
+<div class="block">Platform-specific line separator</div>
+</li>
+</ul>
+</li>
+</ul>
+</section>
+<!-- ========= CONSTRUCTOR DETAIL ======== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="constructor.detail">
+<!--   -->
+</a>
+<h3>Constructor Detail</h3>
+<a id="&lt;init&gt;(java.io.File)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>SqlFile</h4>
+<pre>public&nbsp;SqlFile&#8203;(java.io.File&nbsp;inputFile)
+        throws java.io.IOException</pre>
+<div class="block">Convenience wrapper for the SqlFile(File, String) constructor</div>
+<dl>
+<dt><span class="paramLabel">Parameters:</span></dt>
+<dd><code>inputFile</code> - input file</dd>
+<dt><span class="throwsLabel">Throws:</span></dt>
+<dd><code>java.io.IOException</code> - on read errors</dd>
+<dt><span class="seeLabel">See Also:</span></dt>
+<dd><a href="#%3Cinit%3E(java.io.File,java.lang.String)"><code>SqlFile(File, String)</code></a></dd>
+</dl>
+</li>
+</ul>
+<a id="&lt;init&gt;(java.net.URL)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>SqlFile</h4>
+<pre>public&nbsp;SqlFile&#8203;(java.net.URL&nbsp;inputUrl)
+        throws java.io.IOException</pre>
+<dl>
+<dt><span class="throwsLabel">Throws:</span></dt>
+<dd><code>java.io.IOException</code></dd>
+</dl>
+</li>
+</ul>
+<a id="&lt;init&gt;(java.io.File,java.lang.String)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>SqlFile</h4>
+<pre>public&nbsp;SqlFile&#8203;(java.io.File&nbsp;inputFile,
+               java.lang.String&nbsp;encoding)
+        throws java.io.IOException</pre>
+<div class="block">Convenience wrapper for the SqlFile(File, String, boolean) constructor</div>
+<dl>
+<dt><span class="paramLabel">Parameters:</span></dt>
+<dd><code>inputFile</code> - the input File</dd>
+<dd><code>encoding</code> - is applied to both the given File and other files read
+   in or written out. Null will use your env+JVM settings.</dd>
+<dt><span class="throwsLabel">Throws:</span></dt>
+<dd><code>java.io.IOException</code> - on read errors</dd>
+<dt><span class="seeLabel">See Also:</span></dt>
+<dd><a href="#%3Cinit%3E(java.io.File,java.lang.String,boolean)"><code>SqlFile(File, String, boolean)</code></a></dd>
+</dl>
+</li>
+</ul>
+<a id="&lt;init&gt;(java.net.URL,java.lang.String)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>SqlFile</h4>
+<pre>public&nbsp;SqlFile&#8203;(java.net.URL&nbsp;inputUrl,
+               java.lang.String&nbsp;encoding)
+        throws java.io.IOException</pre>
+<dl>
+<dt><span class="throwsLabel">Throws:</span></dt>
+<dd><code>java.io.IOException</code></dd>
+</dl>
+</li>
+</ul>
+<a id="&lt;init&gt;(java.io.File,java.lang.String,boolean)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>SqlFile</h4>
+<pre>public&nbsp;SqlFile&#8203;(java.io.File&nbsp;inputFile,
+               java.lang.String&nbsp;encoding,
+               boolean&nbsp;interactive)
+        throws java.io.IOException</pre>
+<div class="block">Constructor for non-interactive usage with a SQL file, using the
+ specified encoding and sending normal output to stdout.</div>
+<dl>
+<dt><span class="paramLabel">Parameters:</span></dt>
+<dd><code>inputFile</code> - the input File</dd>
+<dd><code>encoding</code> - is applied to the given File and other files
+        read in or written out. Null will use your env+JVM settings.</dd>
+<dd><code>interactive</code> - If true, prompts are printed, the interactive
+                     Special commands are enabled, and
+                     continueOnError defaults to true.</dd>
+<dt><span class="throwsLabel">Throws:</span></dt>
+<dd><code>java.io.IOException</code> - on read errors</dd>
+<dt><span class="seeLabel">See Also:</span></dt>
+<dd><a href="#%3Cinit%3E(java.io.Reader,java.lang.String,java.io.PrintStream,java.lang.String,boolean,java.io.File)"><code>SqlFile(Reader, String, PrintStream, String, boolean, File)</code></a></dd>
+</dl>
+</li>
+</ul>
+<a id="&lt;init&gt;(java.net.URL,java.lang.String,boolean)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>SqlFile</h4>
+<pre>public&nbsp;SqlFile&#8203;(java.net.URL&nbsp;inputUrl,
+               java.lang.String&nbsp;encoding,
+               boolean&nbsp;interactive)
+        throws java.io.IOException</pre>
+<dl>
+<dt><span class="throwsLabel">Throws:</span></dt>
+<dd><code>java.io.IOException</code></dd>
+</dl>
+</li>
+</ul>
+<a id="&lt;init&gt;(java.lang.String,boolean)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>SqlFile</h4>
+<pre>public&nbsp;SqlFile&#8203;(java.lang.String&nbsp;encoding,
+               boolean&nbsp;interactive)
+        throws java.io.IOException</pre>
+<div class="block">Constructor for interactive usage with stdin/stdout</div>
+<dl>
+<dt><span class="paramLabel">Parameters:</span></dt>
+<dd><code>encoding</code> - is applied to other files read in or written out (but
+                     not to stdin or stdout).
+                     Null will use your env+JVM settings.</dd>
+<dd><code>interactive</code> - If true, prompts are printed, the interactive
+                     Special commands are enabled, and
+                     continueOnError defaults to true.</dd>
+<dt><span class="throwsLabel">Throws:</span></dt>
+<dd><code>java.io.IOException</code> - on read errors</dd>
+<dt><span class="seeLabel">See Also:</span></dt>
+<dd><a href="#%3Cinit%3E(java.io.Reader,java.lang.String,java.io.PrintStream,java.lang.String,boolean,java.io.File)"><code>SqlFile(Reader, String, PrintStream, String, boolean, File)</code></a></dd>
+</dl>
+</li>
+</ul>
+<a id="&lt;init&gt;(java.io.Reader,java.lang.String,java.io.PrintStream,java.lang.String,boolean,java.io.File)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>SqlFile</h4>
+<pre>public&nbsp;SqlFile&#8203;(java.io.Reader&nbsp;reader,
+               java.lang.String&nbsp;inputStreamLabel,
+               java.io.PrintStream&nbsp;psStd,
+               java.lang.String&nbsp;encoding,
+               boolean&nbsp;interactive,
+               java.io.File&nbsp;atBaseFile)
+        throws java.io.IOException</pre>
+<div class="block">Legacy constructor.  See following constructor for documentation.</div>
+<dl>
+<dt><span class="throwsLabel">Throws:</span></dt>
+<dd><code>java.io.IOException</code></dd>
+</dl>
+</li>
+</ul>
+<a id="&lt;init&gt;(java.io.Reader,java.lang.String,java.io.PrintStream,java.lang.String,boolean,java.net.URL)">
+<!--   -->
+</a>
+<ul class="blockListLast">
+<li class="blockList">
+<h4>SqlFile</h4>
+<pre>public&nbsp;SqlFile&#8203;(java.io.Reader&nbsp;reader,
+               java.lang.String&nbsp;inputStreamLabel,
+               java.io.PrintStream&nbsp;psStd,
+               java.lang.String&nbsp;encoding,
+               boolean&nbsp;interactive,
+               java.net.URL&nbsp;atBase)
+        throws java.io.IOException</pre>
+<div class="block">Instantiate a SqlFile instance for SQL input from 'reader'.
+
+ After any needed customization, the SQL can be executed by the
+ execute method.
+ <P>
+ Most Special Commands and many Buffer commands are only for
+ interactive use.
+ </P> <P>
+ This program never writes to an error stream (stderr or alternative).
+ All meta messages and error messages are written using the logging
+ facility.
+ </P></div>
+<dl>
+<dt><span class="paramLabel">Parameters:</span></dt>
+<dd><code>reader</code> - Source for the SQL to be executed.
+                     Caller is responsible for setting up encoding.
+                     (the 'encoding' parameter will NOT be applied
+                     to this reader).</dd>
+<dd><code>inputStreamLabel</code> - the lable</dd>
+<dd><code>psStd</code> - PrintStream for normal output.
+                     If null, normal output will be discarded.
+                     Caller is responsible for settingup encoding
+                     (the 'encoding' parameter will NOT be applied
+                     to this stream).</dd>
+<dd><code>encoding</code> - the encoding</dd>
+<dd><code>interactive</code> - If true, prompts are printed, the interactive
+                     Special commands are enabled, and
+                     continueOnError defaults to true.</dd>
+<dd><code>atBase</code> - the base dir</dd>
+<dt><span class="throwsLabel">Throws:</span></dt>
+<dd><code>java.io.IOException</code> - on read errors</dd>
+<dt><span class="seeLabel">See Also:</span></dt>
+<dd><a href="#execute()"><code>execute()</code></a></dd>
+</dl>
+</li>
+</ul>
+</li>
+</ul>
+</section>
+<!-- ============ METHOD DETAIL ========== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="method.detail">
+<!--   -->
+</a>
+<h3>Method Detail</h3>
+<a id="setConnection(java.sql.Connection)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>setConnection</h4>
+<pre class="methodSignature">public&nbsp;void&nbsp;setConnection&#8203;(java.sql.Connection&nbsp;jdbcConn)</pre>
+</li>
+</ul>
+<a id="getConnection()">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>getConnection</h4>
+<pre class="methodSignature">public&nbsp;java.sql.Connection&nbsp;getConnection()</pre>
+</li>
+</ul>
+<a id="setContinueOnError(boolean)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>setContinueOnError</h4>
+<pre class="methodSignature">public&nbsp;void&nbsp;setContinueOnError&#8203;(boolean&nbsp;continueOnError)</pre>
+</li>
+</ul>
+<a id="setMaxHistoryLength(int)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>setMaxHistoryLength</h4>
+<pre class="methodSignature">public&nbsp;void&nbsp;setMaxHistoryLength&#8203;(int&nbsp;maxHistoryLength)</pre>
+</li>
+</ul>
+<a id="addMacros(java.util.Map)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>addMacros</h4>
+<pre class="methodSignature">public&nbsp;void&nbsp;addMacros&#8203;(java.util.Map&lt;java.lang.String,&#8203;org.hsqldb.cmdline.sqltool.Token&gt;&nbsp;newMacros)</pre>
+</li>
+</ul>
+<a id="addUserVars(java.util.Map)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>addUserVars</h4>
+<pre class="methodSignature">public&nbsp;void&nbsp;addUserVars&#8203;(java.util.Map&lt;java.lang.String,&#8203;java.lang.String&gt;&nbsp;newUserVars)</pre>
+</li>
+</ul>
+<a id="getUserVars()">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>getUserVars</h4>
+<pre class="methodSignature">public&nbsp;java.util.Map&lt;java.lang.String,&#8203;java.lang.String&gt;&nbsp;getUserVars()</pre>
+<div class="block">Get a reference to the user variable map.
+
+ Since you are getting a reference to the private map used inside this
+ class, update this map with great caution and attention to lifecycle
+ handling of the variable map.</div>
+<dl>
+<dt><span class="returnLabel">Returns:</span></dt>
+<dd>user variable map</dd>
+</dl>
+</li>
+</ul>
+<a id="getMacros()">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>getMacros</h4>
+<pre class="methodSignature">public&nbsp;java.util.Map&lt;java.lang.String,&#8203;org.hsqldb.cmdline.sqltool.Token&gt;&nbsp;getMacros()</pre>
+</li>
+</ul>
+<a id="setAutoClose(boolean)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>setAutoClose</h4>
+<pre class="methodSignature">public&nbsp;void&nbsp;setAutoClose&#8203;(boolean&nbsp;autoClose)</pre>
+<div class="block">Specify whether the supplied or generated input Reader should
+ automatically be closed by the execute() method.
+ <P>
+ execute() will close the Reader by default (i.e. 'autoClose' defaults
+ to true).
+ You may want to set this to false if you want to stop execution with
+ \q or similar, then continue using the Reader or underlying Stream.
+ <P>
+ The caller is always responsible for closing the output object (if any)
+ used by SqlFile.</div>
+<dl>
+<dt><span class="paramLabel">Parameters:</span></dt>
+<dd><code>autoClose</code> - boolean</dd>
+</dl>
+</li>
+</ul>
+<a id="execute()">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>execute</h4>
+<pre class="methodSignature">public&nbsp;void&nbsp;execute()
+             throws <a href="SqlToolError.html" title="class in org.hsqldb.cmdline">SqlToolError</a>,
+                    java.sql.SQLException</pre>
+<div class="block">Process all the commands from the file or Reader associated with
+ "this" object.
+ SQL commands in the content get executed against the current JDBC
+ data source connection.</div>
+<dl>
+<dt><span class="throwsLabel">Throws:</span></dt>
+<dd><code>java.sql.SQLException</code> - thrown by JDBC driver.
+                       Only possible if in "\c false" mode.</dd>
+<dd><code><a href="SqlToolError.html" title="class in org.hsqldb.cmdline">SqlToolError</a></code> - all other errors.
+               This includes QuitNow, BreakException,
+               ContinueException for recursive calls only.</dd>
+</dl>
+</li>
+</ul>
+<a id="closeReader()">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>closeReader</h4>
+<pre class="methodSignature">public&nbsp;void&nbsp;closeReader()</pre>
+<div class="block">Close the reader.
+
+ The execute method will run this automatically, by default.</div>
+</li>
+</ul>
+<a id="getCurrentSchema()">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>getCurrentSchema</h4>
+<pre class="methodSignature">public&nbsp;java.lang.String&nbsp;getCurrentSchema()
+                                  throws <a href="SqlFile.BadSpecial.html" title="class in org.hsqldb.cmdline">SqlFile.BadSpecial</a>,
+                                         <a href="SqlToolError.html" title="class in org.hsqldb.cmdline">SqlToolError</a></pre>
+<dl>
+<dt><span class="throwsLabel">Throws:</span></dt>
+<dd><code><a href="SqlFile.BadSpecial.html" title="class in org.hsqldb.cmdline">SqlFile.BadSpecial</a></code></dd>
+<dd><code><a href="SqlToolError.html" title="class in org.hsqldb.cmdline">SqlToolError</a></code></dd>
+</dl>
+</li>
+</ul>
+<a id="streamToString(java.io.InputStream,java.lang.String)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>streamToString</h4>
+<pre class="methodSignature">public&nbsp;java.lang.String&nbsp;streamToString&#8203;(java.io.InputStream&nbsp;is,
+                                       java.lang.String&nbsp;cs)
+                                throws java.io.IOException</pre>
+<div class="block">As the name says...
+
+ This method always closes the input stream.</div>
+<dl>
+<dt><span class="paramLabel">Parameters:</span></dt>
+<dd><code>is</code> - InputStream</dd>
+<dd><code>cs</code> - String</dd>
+<dt><span class="returnLabel">Returns:</span></dt>
+<dd>String</dd>
+<dt><span class="throwsLabel">Throws:</span></dt>
+<dd><code>java.io.IOException</code> - on read errors</dd>
+</dl>
+</li>
+</ul>
+<a id="streamToBytes(java.io.InputStream)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>streamToBytes</h4>
+<pre class="methodSignature">public static&nbsp;byte[]&nbsp;streamToBytes&#8203;(java.io.InputStream&nbsp;is)
+                            throws java.io.IOException</pre>
+<div class="block">As the name says...</div>
+<dl>
+<dt><span class="paramLabel">Parameters:</span></dt>
+<dd><code>is</code> - input</dd>
+<dt><span class="returnLabel">Returns:</span></dt>
+<dd>byte[]</dd>
+<dt><span class="throwsLabel">Throws:</span></dt>
+<dd><code>java.io.IOException</code> - on read errors</dd>
+</dl>
+</li>
+</ul>
+<a id="loadBinary(java.io.File)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>loadBinary</h4>
+<pre class="methodSignature">public static&nbsp;byte[]&nbsp;loadBinary&#8203;(java.io.File&nbsp;binFile)
+                         throws java.io.IOException</pre>
+<div class="block">Legacy function.
+ See following function for documentation.</div>
+<dl>
+<dt><span class="throwsLabel">Throws:</span></dt>
+<dd><code>java.io.IOException</code></dd>
+</dl>
+</li>
+</ul>
+<a id="loadBinary(java.net.URL)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>loadBinary</h4>
+<pre class="methodSignature">public static&nbsp;byte[]&nbsp;loadBinary&#8203;(java.net.URL&nbsp;binUrl)
+                         throws java.io.IOException</pre>
+<div class="block">Binary file load</div>
+<dl>
+<dt><span class="paramLabel">Parameters:</span></dt>
+<dd><code>binUrl</code> - url</dd>
+<dt><span class="returnLabel">Returns:</span></dt>
+<dd>The bytes which are the content of the file</dd>
+<dt><span class="throwsLabel">Throws:</span></dt>
+<dd><code>java.io.IOException</code> - on read errors</dd>
+</dl>
+</li>
+</ul>
+<a id="canDisplayType(int)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>canDisplayType</h4>
+<pre class="methodSignature">public static&nbsp;boolean&nbsp;canDisplayType&#8203;(int&nbsp;i)</pre>
+<div class="block">This method is used to tell SqlFile whether this Sql Type must
+ ALWAYS be loaded to the binary buffer without displaying.
+ <P>
+ N.b.:  If this returns "true" for a type, then the user can never
+ "see" values for these columns.
+ Therefore, if a type may-or-may-not-be displayable, better to return
+ false here and let the user choose.
+ In general, if there is a toString() operator for this Sql Type
+ then return false, since the JDBC driver should know how to make the
+ value displayable.
+ </P></div>
+<dl>
+<dt><span class="paramLabel">Parameters:</span></dt>
+<dd><code>i</code> - JDBC type number</dd>
+<dt><span class="returnLabel">Returns:</span></dt>
+<dd>boolean</dd>
+<dt><span class="seeLabel">See Also:</span></dt>
+<dd><a href="http://java.sun.com/docs/books/tutorial/jdbc/basics/retrieving.html">http://java.sun.com/docs/books/tutorial/jdbc/basics/retrieving.html</a>
+      The table on this page lists the most common SqlTypes, all of which
+      must implement toString(), 
+<code>Types</code></dd>
+</dl>
+</li>
+</ul>
+<a id="sqlTypeToString(int)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>sqlTypeToString</h4>
+<pre class="methodSignature">public static&nbsp;java.lang.String&nbsp;sqlTypeToString&#8203;(int&nbsp;i)</pre>
+<div class="block">Return a String representation of the specified java.sql.Types type.</div>
+<dl>
+<dt><span class="paramLabel">Parameters:</span></dt>
+<dd><code>i</code> - int</dd>
+<dt><span class="returnLabel">Returns:</span></dt>
+<dd>String</dd>
+</dl>
+</li>
+</ul>
+<a id="dsvSafe(java.lang.String)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dsvSafe</h4>
+<pre class="methodSignature">public&nbsp;void&nbsp;dsvSafe&#8203;(java.lang.String&nbsp;s)
+             throws <a href="SqlToolError.html" title="class in org.hsqldb.cmdline">SqlToolError</a></pre>
+<div class="block">Validate that String is safe to write TO DSV file.</div>
+<dl>
+<dt><span class="paramLabel">Parameters:</span></dt>
+<dd><code>s</code> - String</dd>
+<dt><span class="throwsLabel">Throws:</span></dt>
+<dd><code><a href="SqlToolError.html" title="class in org.hsqldb.cmdline">SqlToolError</a></code> - if validation fails.</dd>
+</dl>
+</li>
+</ul>
+<a id="convertEscapes(java.lang.String)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>convertEscapes</h4>
+<pre class="methodSignature">public static&nbsp;java.lang.String&nbsp;convertEscapes&#8203;(java.lang.String&nbsp;inString)</pre>
+<div class="block">Translates user-supplied escapes into the traditionaly
+ corresponding binary characters.
+
+ Allowed sequences:
+ <UL>
+  <LI>\0\d+   (an octal digit)
+  <LI>\[0-9]\d*  (a decimal digit)
+  <LI>\[Xx][0-9]{2}  (a hex digit)
+  <LI>\n  Newline  (Ctrl-J)
+  <LI>\r  Carriage return  (Ctrl-M)
+  <LI>\t  Horizontal tab  (Ctrl-I)
+  <LI>\f  Form feed  (Ctrl-L)
+ </UL>
+
+ Java 1.4 String methods will make this into a 1 or 2 line task.</div>
+<dl>
+<dt><span class="paramLabel">Parameters:</span></dt>
+<dd><code>inString</code> - input string</dd>
+<dt><span class="returnLabel">Returns:</span></dt>
+<dd>converted string</dd>
+</dl>
+</li>
+</ul>
+<a id="importDsv(java.net.URL,java.lang.String)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>importDsv</h4>
+<pre class="methodSignature">public&nbsp;void&nbsp;importDsv&#8203;(java.net.URL&nbsp;fileUrl,
+                      java.lang.String&nbsp;skipPrefix)
+               throws <a href="SqlToolError.html" title="class in org.hsqldb.cmdline">SqlToolError</a></pre>
+<div class="block">Name is self-explanatory.</div>
+<dl>
+<dt><span class="paramLabel">Parameters:</span></dt>
+<dd><code>fileUrl</code> - String</dd>
+<dd><code>skipPrefix</code> - String</dd>
+<dt><span class="throwsLabel">Throws:</span></dt>
+<dd><code><a href="SqlToolError.html" title="class in org.hsqldb.cmdline">SqlToolError</a></code> - Would prefer to throw an internal exception,
+                       but we want this method to have external
+                       visibility.</dd>
+</dl>
+</li>
+</ul>
+<a id="hexCharOctetsToBytes(java.lang.String)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>hexCharOctetsToBytes</h4>
+<pre class="methodSignature">public static&nbsp;byte[]&nbsp;hexCharOctetsToBytes&#8203;(java.lang.String&nbsp;hexChars)</pre>
+<div class="block">Convert a String to a byte array by interpreting every 2 characters as an
+ octal byte value.</div>
+<dl>
+<dt><span class="paramLabel">Parameters:</span></dt>
+<dd><code>hexChars</code> - String</dd>
+<dt><span class="returnLabel">Returns:</span></dt>
+<dd>byte[]</dd>
+</dl>
+</li>
+</ul>
+<a id="bitCharsToBytes(java.lang.String)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>bitCharsToBytes</h4>
+<pre class="methodSignature">public static&nbsp;byte[]&nbsp;bitCharsToBytes&#8203;(java.lang.String&nbsp;hexChars)</pre>
+<div class="block">Just a stub for now.</div>
+<dl>
+<dt><span class="paramLabel">Parameters:</span></dt>
+<dd><code>hexChars</code> - String</dd>
+<dt><span class="returnLabel">Returns:</span></dt>
+<dd>byte[]</dd>
+</dl>
+</li>
+</ul>
+<a id="getBanner(java.sql.Connection)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>getBanner</h4>
+<pre class="methodSignature">public static&nbsp;java.lang.String&nbsp;getBanner&#8203;(java.sql.Connection&nbsp;c)</pre>
+<div class="block">Returns a String report for the specified JDBC Connection. For databases
+ with poor JDBC support, you won't get much detail.</div>
+<dl>
+<dt><span class="paramLabel">Parameters:</span></dt>
+<dd><code>c</code> - Connection</dd>
+<dt><span class="returnLabel">Returns:</span></dt>
+<dd>String</dd>
+</dl>
+</li>
+</ul>
+<a id="escapeHtml(java.lang.String)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>escapeHtml</h4>
+<pre class="methodSignature">public static&nbsp;java.lang.String&nbsp;escapeHtml&#8203;(java.lang.String&nbsp;s)</pre>
+<div class="block">Escaping rules taken from 'Reserved Characters in HTML table at
+ <a href="http://www.w3schools.com/tags/ref_entities.asp">http://www.w3schools.com/tags/ref_entities.asp</a></div>
+<dl>
+<dt><span class="paramLabel">Parameters:</span></dt>
+<dd><code>s</code> - String</dd>
+<dt><span class="returnLabel">Returns:</span></dt>
+<dd>String</dd>
+</dl>
+</li>
+</ul>
+<a id="toPaddedString(java.lang.String,int,char,boolean)">
+<!--   -->
+</a>
+<ul class="blockListLast">
+<li class="blockList">
+<h4>toPaddedString</h4>
+<pre class="methodSignature">public static&nbsp;java.lang.String&nbsp;toPaddedString&#8203;(java.lang.String&nbsp;source,
+                                              int&nbsp;length,
+                                              char&nbsp;pad,
+                                              boolean&nbsp;trailing)</pre>
+</li>
+</ul>
+</li>
+</ul>
+</section>
+</li>
+</ul>
+</div>
+</div>
+</main>
+<!-- ========= END OF CLASS DATA ========= -->
+<footer role="contentinfo">
+<nav role="navigation">
+<!-- ======= START OF BOTTOM NAVBAR ====== -->
+<div class="bottomNav"><a id="navbar.bottom">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.bottom.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../module-summary.html">Module</a></li>
+<li><a href="package-summary.html">Package</a></li>
+<li class="navBarCell1Rev">Class</li>
+<li><a href="class-use/SqlFile.html">Use</a></li>
+<li><a href="package-tree.html">Tree</a></li>
+<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../index-all.html">Index</a></li>
+<li><a href="../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_bottom">
+<li><a href="../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_bottom");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<div>
+<ul class="subNavList">
+<li>Summary:&nbsp;</li>
+<li><a href="#nested.class.summary">Nested</a>&nbsp;|&nbsp;</li>
+<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
+<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
+<li><a href="#method.summary">Method</a></li>
+</ul>
+<ul class="subNavList">
+<li>Detail:&nbsp;</li>
+<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
+<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
+<li><a href="#method.detail">Method</a></li>
+</ul>
+</div>
+<a id="skip.navbar.bottom">
+<!--   -->
+</a></div>
+<!-- ======== END OF BOTTOM NAVBAR ======= -->
+</nav>
+<p class="legalCopy"><small><i>Copyright © 2001 - 2022 HSQL Development Group.</i></small></p>
+</footer>
+</body>
+</html>
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolError.html 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolError.html
--- 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolError.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolError.html	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,373 @@
+<!DOCTYPE HTML>
+<!-- NewPage -->
+<html lang="en">
+<head>
+<!-- Generated by javadoc (11.0.14.1) on Tue Jul 26 22:23:00 BST 2022 -->
+<title>SqlToolError (HSQLDB 2.7.0 API)</title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+<meta name="dc.created" content="2022-07-26">
+<link rel="stylesheet" type="text/css" href="../../../../javadoc.css" title="Style">
+<link rel="stylesheet" type="text/css" href="../../../../jquery/jquery-ui.css" title="Style">
+<script type="text/javascript" src="../../../../script.js"></script>
+<script type="text/javascript" src="../../../../jquery/jszip/dist/jszip.min.js"></script>
+<script type="text/javascript" src="../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
+<!--[if IE]>
+<script type="text/javascript" src="../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
+<![endif]-->
+<script type="text/javascript" src="../../../../jquery/jquery-3.5.1.js"></script>
+<script type="text/javascript" src="../../../../jquery/jquery-ui.js"></script>
+</head>
+<body>
+<script type="text/javascript"><!--
+    try {
+        if (location.href.indexOf('is-external=true') == -1) {
+            parent.document.title="SqlToolError (HSQLDB 2.7.0 API)";
+        }
+    }
+    catch(err) {
+    }
+//-->
+var pathtoroot = "../../../../";
+var useModuleDirectories = true;
+loadScripts(document, 'script');</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+<header role="banner">
+<nav role="navigation">
+<div class="fixedNav">
+<!-- ========= START OF TOP NAVBAR ======= -->
+<div class="topNav"><a id="navbar.top">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.top.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../module-summary.html">Module</a></li>
+<li><a href="package-summary.html">Package</a></li>
+<li class="navBarCell1Rev">Class</li>
+<li><a href="class-use/SqlToolError.html">Use</a></li>
+<li><a href="package-tree.html">Tree</a></li>
+<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../index-all.html">Index</a></li>
+<li><a href="../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_top">
+<li><a href="../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<ul class="navListSearch">
+<li><label for="search">SEARCH:</label>
+<input type="text" id="search" value="search" disabled="disabled">
+<input type="reset" id="reset" value="reset" disabled="disabled">
+</li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_top");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<div>
+<ul class="subNavList">
+<li>Summary:&nbsp;</li>
+<li>Nested&nbsp;|&nbsp;</li>
+<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
+<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
+<li><a href="#method.summary">Method</a></li>
+</ul>
+<ul class="subNavList">
+<li>Detail:&nbsp;</li>
+<li>Field&nbsp;|&nbsp;</li>
+<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
+<li>Method</li>
+</ul>
+</div>
+<a id="skip.navbar.top">
+<!--   -->
+</a></div>
+<!-- ========= END OF TOP NAVBAR ========= -->
+</div>
+<div class="navPadding">&nbsp;</div>
+<script type="text/javascript"><!--
+$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
+//-->
+</script>
+</nav>
+</header>
+<!-- ======== START OF CLASS DATA ======== -->
+<main role="main">
+<div class="header">
+<div class="subTitle"><span class="moduleLabelInType">Module</span>&nbsp;<a href="../../../module-summary.html">org.hsqldb.sqltool</a></div>
+<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">org.hsqldb.cmdline</a></div>
+<h2 title="Class SqlToolError" class="title">Class SqlToolError</h2>
+</div>
+<div class="contentContainer">
+<ul class="inheritance">
+<li>java.lang.Object</li>
+<li>
+<ul class="inheritance">
+<li>java.lang.Throwable</li>
+<li>
+<ul class="inheritance">
+<li>java.lang.Exception</li>
+<li>
+<ul class="inheritance">
+<li>org.hsqldb.cmdline.libclone.AppendableException</li>
+<li>
+<ul class="inheritance">
+<li>org.hsqldb.cmdline.SqlToolError</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<div class="description">
+<ul class="blockList">
+<li class="blockList">
+<dl>
+<dt>All Implemented Interfaces:</dt>
+<dd><code>java.io.Serializable</code></dd>
+</dl>
+<hr>
+<pre>public class <span class="typeNameLabel">SqlToolError</span>
+extends org.hsqldb.cmdline.libclone.AppendableException</pre>
+<div class="block">Exceptions thrown by the SqlTool system externally to SqlFile.
+ (As opposed to the nested Exceptions within those classes).
+ This class is misnamed, because it is not only errors.
+ When there is time, this file and class should be renamed.
+ <P>
+ This class has a misleading name and should really be renamed.
+ It is Java Exception, not a Java Error.
+ </P></div>
+<dl>
+<dt><span class="seeLabel">See Also:</span></dt>
+<dd><a href="../../../../serialized-form.html#org.hsqldb.cmdline.SqlToolError">Serialized Form</a></dd>
+</dl>
+</li>
+</ul>
+</div>
+<div class="summary">
+<ul class="blockList">
+<li class="blockList">
+<!-- =========== FIELD SUMMARY =========== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="field.summary">
+<!--   -->
+</a>
+<h3>Field Summary</h3>
+<ul class="blockList">
+<li class="blockList"><a id="fields.inherited.from.class.org.hsqldb.cmdline.libclone.AppendableException">
+<!--   -->
+</a>
+<h3>Fields inherited from class&nbsp;org.hsqldb.cmdline.libclone.AppendableException</h3>
+<code>appendages, LS</code></li>
+</ul>
+</li>
+</ul>
+</section>
+<!-- ======== CONSTRUCTOR SUMMARY ======== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="constructor.summary">
+<!--   -->
+</a>
+<h3>Constructor Summary</h3>
+<table class="memberSummary">
+<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
+<tr>
+<th class="colFirst" scope="col">Constructor</th>
+<th class="colLast" scope="col">Description</th>
+</tr>
+<tr class="altColor">
+<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E()">SqlToolError</a></span>()</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E(java.lang.String)">SqlToolError</a></span>&#8203;(java.lang.String&nbsp;s)</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E(java.lang.String,java.lang.Throwable)">SqlToolError</a></span>&#8203;(java.lang.String&nbsp;string,
+            java.lang.Throwable&nbsp;cause)</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E(java.lang.Throwable)">SqlToolError</a></span>&#8203;(java.lang.Throwable&nbsp;cause)</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+</table>
+</li>
+</ul>
+</section>
+<!-- ========== METHOD SUMMARY =========== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="method.summary">
+<!--   -->
+</a>
+<h3>Method Summary</h3>
+<ul class="blockList">
+<li class="blockList"><a id="methods.inherited.from.class.org.hsqldb.cmdline.libclone.AppendableException">
+<!--   -->
+</a>
+<h3>Methods inherited from class&nbsp;org.hsqldb.cmdline.libclone.AppendableException</h3>
+<code>appendMessage, getMessage</code></li>
+</ul>
+<ul class="blockList">
+<li class="blockList"><a id="methods.inherited.from.class.java.lang.Throwable">
+<!--   -->
+</a>
+<h3>Methods inherited from class&nbsp;java.lang.Throwable</h3>
+<code>addSuppressed, fillInStackTrace, getCause, getLocalizedMessage, getStackTrace, getSuppressed, initCause, printStackTrace, printStackTrace, printStackTrace, setStackTrace, toString</code></li>
+</ul>
+<ul class="blockList">
+<li class="blockList"><a id="methods.inherited.from.class.java.lang.Object">
+<!--   -->
+</a>
+<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
+<code>equals, getClass, hashCode, notify, notifyAll, wait, wait, wait</code></li>
+</ul>
+</li>
+</ul>
+</section>
+</li>
+</ul>
+</div>
+<div class="details">
+<ul class="blockList">
+<li class="blockList">
+<!-- ========= CONSTRUCTOR DETAIL ======== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="constructor.detail">
+<!--   -->
+</a>
+<h3>Constructor Detail</h3>
+<a id="&lt;init&gt;(java.lang.Throwable)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>SqlToolError</h4>
+<pre>public&nbsp;SqlToolError&#8203;(java.lang.Throwable&nbsp;cause)</pre>
+</li>
+</ul>
+<a id="&lt;init&gt;()">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>SqlToolError</h4>
+<pre>public&nbsp;SqlToolError()</pre>
+</li>
+</ul>
+<a id="&lt;init&gt;(java.lang.String)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>SqlToolError</h4>
+<pre>public&nbsp;SqlToolError&#8203;(java.lang.String&nbsp;s)</pre>
+</li>
+</ul>
+<a id="&lt;init&gt;(java.lang.String,java.lang.Throwable)">
+<!--   -->
+</a>
+<ul class="blockListLast">
+<li class="blockList">
+<h4>SqlToolError</h4>
+<pre>public&nbsp;SqlToolError&#8203;(java.lang.String&nbsp;string,
+                    java.lang.Throwable&nbsp;cause)</pre>
+</li>
+</ul>
+</li>
+</ul>
+</section>
+</li>
+</ul>
+</div>
+</div>
+</main>
+<!-- ========= END OF CLASS DATA ========= -->
+<footer role="contentinfo">
+<nav role="navigation">
+<!-- ======= START OF BOTTOM NAVBAR ====== -->
+<div class="bottomNav"><a id="navbar.bottom">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.bottom.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../module-summary.html">Module</a></li>
+<li><a href="package-summary.html">Package</a></li>
+<li class="navBarCell1Rev">Class</li>
+<li><a href="class-use/SqlToolError.html">Use</a></li>
+<li><a href="package-tree.html">Tree</a></li>
+<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../index-all.html">Index</a></li>
+<li><a href="../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_bottom">
+<li><a href="../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_bottom");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<div>
+<ul class="subNavList">
+<li>Summary:&nbsp;</li>
+<li>Nested&nbsp;|&nbsp;</li>
+<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
+<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
+<li><a href="#method.summary">Method</a></li>
+</ul>
+<ul class="subNavList">
+<li>Detail:&nbsp;</li>
+<li>Field&nbsp;|&nbsp;</li>
+<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
+<li>Method</li>
+</ul>
+</div>
+<a id="skip.navbar.bottom">
+<!--   -->
+</a></div>
+<!-- ======== END OF BOTTOM NAVBAR ======= -->
+</nav>
+<p class="legalCopy"><small><i>Copyright © 2001 - 2022 HSQL Development Group.</i></small></p>
+</footer>
+</body>
+</html>
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html
--- 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,606 @@
+<!DOCTYPE HTML>
+<!-- NewPage -->
+<html lang="en">
+<head>
+<!-- Generated by javadoc (11.0.14.1) on Tue Jul 26 22:23:00 BST 2022 -->
+<title>SqlTool (HSQLDB 2.7.0 API)</title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+<meta name="dc.created" content="2022-07-26">
+<link rel="stylesheet" type="text/css" href="../../../../javadoc.css" title="Style">
+<link rel="stylesheet" type="text/css" href="../../../../jquery/jquery-ui.css" title="Style">
+<script type="text/javascript" src="../../../../script.js"></script>
+<script type="text/javascript" src="../../../../jquery/jszip/dist/jszip.min.js"></script>
+<script type="text/javascript" src="../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
+<!--[if IE]>
+<script type="text/javascript" src="../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
+<![endif]-->
+<script type="text/javascript" src="../../../../jquery/jquery-3.5.1.js"></script>
+<script type="text/javascript" src="../../../../jquery/jquery-ui.js"></script>
+</head>
+<body>
+<script type="text/javascript"><!--
+    try {
+        if (location.href.indexOf('is-external=true') == -1) {
+            parent.document.title="SqlTool (HSQLDB 2.7.0 API)";
+        }
+    }
+    catch(err) {
+    }
+//-->
+var data = {"i0":9,"i1":9};
+var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],8:["t4","Concrete Methods"]};
+var altColor = "altColor";
+var rowColor = "rowColor";
+var tableTab = "tableTab";
+var activeTableTab = "activeTableTab";
+var pathtoroot = "../../../../";
+var useModuleDirectories = true;
+loadScripts(document, 'script');</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+<header role="banner">
+<nav role="navigation">
+<div class="fixedNav">
+<!-- ========= START OF TOP NAVBAR ======= -->
+<div class="topNav"><a id="navbar.top">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.top.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../module-summary.html">Module</a></li>
+<li><a href="package-summary.html">Package</a></li>
+<li class="navBarCell1Rev">Class</li>
+<li><a href="class-use/SqlTool.html">Use</a></li>
+<li><a href="package-tree.html">Tree</a></li>
+<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../index-all.html">Index</a></li>
+<li><a href="../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_top">
+<li><a href="../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<ul class="navListSearch">
+<li><label for="search">SEARCH:</label>
+<input type="text" id="search" value="search" disabled="disabled">
+<input type="reset" id="reset" value="reset" disabled="disabled">
+</li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_top");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<div>
+<ul class="subNavList">
+<li>Summary:&nbsp;</li>
+<li><a href="#nested.class.summary">Nested</a>&nbsp;|&nbsp;</li>
+<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
+<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
+<li><a href="#method.summary">Method</a></li>
+</ul>
+<ul class="subNavList">
+<li>Detail:&nbsp;</li>
+<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
+<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
+<li><a href="#method.detail">Method</a></li>
+</ul>
+</div>
+<a id="skip.navbar.top">
+<!--   -->
+</a></div>
+<!-- ========= END OF TOP NAVBAR ========= -->
+</div>
+<div class="navPadding">&nbsp;</div>
+<script type="text/javascript"><!--
+$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
+//-->
+</script>
+</nav>
+</header>
+<!-- ======== START OF CLASS DATA ======== -->
+<main role="main">
+<div class="header">
+<div class="subTitle"><span class="moduleLabelInType">Module</span>&nbsp;<a href="../../../module-summary.html">org.hsqldb.sqltool</a></div>
+<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">org.hsqldb.cmdline</a></div>
+<h2 title="Class SqlTool" class="title">Class SqlTool</h2>
+</div>
+<div class="contentContainer">
+<ul class="inheritance">
+<li>java.lang.Object</li>
+<li>
+<ul class="inheritance">
+<li>org.hsqldb.cmdline.SqlTool</li>
+</ul>
+</li>
+</ul>
+<div class="description">
+<ul class="blockList">
+<li class="blockList">
+<hr>
+<pre>public class <span class="typeNameLabel">SqlTool</span>
+extends java.lang.Object</pre>
+<div class="block">A command-line JDBC SQL tool supporting both interactive and
+ non-interactive usage.
+ <P>
+ See JavaDocs for the main method for syntax of how to run from the
+ command-line.
+ <P>
+ Programmatic users will usually want to use the objectMain(String[]) method
+ if they want arguments and behavior exactly like command-line SqlTool.
+ But in many cases, you will have better control and efficiency by using
+ the SqlFile class directly.  The file
+ <CODE>src/org/hsqldb/sample/SqlFileEmbedder.java</CODE>
+ in the HSQLDB distribution provides an example for this latter strategy.</div>
+<dl>
+<dt><span class="simpleTagLabel">Author:</span></dt>
+<dd>Blaine Simpson (blaine dot simpson at admc dot com)</dd>
+<dt><span class="seeLabel">See Also:</span></dt>
+<dd><a href="../../../../util-guide/sqltool-chapt.html" target="guide">
+     The SqlTool chapter of the
+     HyperSQL Utilities Guide</a>, 
+<a href="#main(java.lang.String%5B%5D)"><code>main(String[])</code></a>, 
+<a href="#objectMain(java.lang.String%5B%5D)"><code>objectMain(String[])</code></a>, 
+<a href="SqlFile.html" title="class in org.hsqldb.cmdline"><code>SqlFile</code></a></dd>
+</dl>
+</li>
+</ul>
+</div>
+<div class="summary">
+<ul class="blockList">
+<li class="blockList">
+<!-- ======== NESTED CLASS SUMMARY ======== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="nested.class.summary">
+<!--   -->
+</a>
+<h3>Nested Class Summary</h3>
+<table class="memberSummary">
+<caption><span>Nested Classes</span><span class="tabEnd">&nbsp;</span></caption>
+<tr>
+<th class="colFirst" scope="col">Modifier and Type</th>
+<th class="colSecond" scope="col">Class</th>
+<th class="colLast" scope="col">Description</th>
+</tr>
+<tr class="altColor">
+<td class="colFirst"><code>static class&nbsp;</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="SqlTool.SqlToolException.html" title="class in org.hsqldb.cmdline">SqlTool.SqlToolException</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+</table>
+</li>
+</ul>
+</section>
+<!-- =========== FIELD SUMMARY =========== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="field.summary">
+<!--   -->
+</a>
+<h3>Field Summary</h3>
+<table class="memberSummary">
+<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
+<tr>
+<th class="colFirst" scope="col">Modifier and Type</th>
+<th class="colSecond" scope="col">Field</th>
+<th class="colLast" scope="col">Description</th>
+</tr>
+<tr class="altColor">
+<td class="colFirst"><code>static int</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#CONNECTERR_EXITVAL">CONNECTERR_EXITVAL</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<td class="colFirst"><code>static java.lang.String</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#DEFAULT_RCFILE">DEFAULT_RCFILE</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<td class="colFirst"><code>static int</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#FILEERR_EXITVAL">FILEERR_EXITVAL</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<td class="colFirst"><code>static int</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#INPUTERR_EXITVAL">INPUTERR_EXITVAL</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<td class="colFirst"><code>static int</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#IOERR_EXITVAL">IOERR_EXITVAL</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<td class="colFirst"><code>static java.lang.String</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#LS">LS</a></span></code></th>
+<td class="colLast">
+<div class="block">Platform-specific line separator</div>
+</td>
+</tr>
+<tr class="altColor">
+<td class="colFirst"><code>static int</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#RCERR_EXITVAL">RCERR_EXITVAL</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<td class="colFirst"><code>static int</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#SQLERR_EXITVAL">SQLERR_EXITVAL</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<td class="colFirst"><code>static int</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#SQLTOOLERR_EXITVAL">SQLTOOLERR_EXITVAL</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<td class="colFirst"><code>static int</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#SYNTAXERR_EXITVAL">SYNTAXERR_EXITVAL</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+</table>
+</li>
+</ul>
+</section>
+<!-- ======== CONSTRUCTOR SUMMARY ======== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="constructor.summary">
+<!--   -->
+</a>
+<h3>Constructor Summary</h3>
+<table class="memberSummary">
+<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
+<tr>
+<th class="colFirst" scope="col">Constructor</th>
+<th class="colLast" scope="col">Description</th>
+</tr>
+<tr class="altColor">
+<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E()">SqlTool</a></span>()</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+</table>
+</li>
+</ul>
+</section>
+<!-- ========== METHOD SUMMARY =========== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="method.summary">
+<!--   -->
+</a>
+<h3>Method Summary</h3>
+<table class="memberSummary">
+<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t1" class="tableTab"><span><a href="javascript:show(1);">Static Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
+<tr>
+<th class="colFirst" scope="col">Modifier and Type</th>
+<th class="colSecond" scope="col">Method</th>
+<th class="colLast" scope="col">Description</th>
+</tr>
+<tr id="i0" class="altColor">
+<td class="colFirst"><code>static void</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#main(java.lang.String%5B%5D)">main</a></span>&#8203;(java.lang.String[]&nbsp;args)</code></th>
+<td class="colLast">
+<div class="block">A static wrapper for objectMain, so that that method may be executed
+ as a Java "program".</div>
+</td>
+</tr>
+<tr id="i1" class="rowColor">
+<td class="colFirst"><code>static void</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#objectMain(java.lang.String%5B%5D)">objectMain</a></span>&#8203;(java.lang.String[]&nbsp;arg)</code></th>
+<td class="colLast">
+<div class="block">Connect to a JDBC Database and execute the commands given on
+ stdin or in SQL file(s).</div>
+</td>
+</tr>
+</table>
+<ul class="blockList">
+<li class="blockList"><a id="methods.inherited.from.class.java.lang.Object">
+<!--   -->
+</a>
+<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
+<code>equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
+</ul>
+</li>
+</ul>
+</section>
+</li>
+</ul>
+</div>
+<div class="details">
+<ul class="blockList">
+<li class="blockList">
+<!-- ============ FIELD DETAIL =========== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="field.detail">
+<!--   -->
+</a>
+<h3>Field Detail</h3>
+<a id="DEFAULT_RCFILE">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>DEFAULT_RCFILE</h4>
+<pre>public static final&nbsp;java.lang.String DEFAULT_RCFILE</pre>
+</li>
+</ul>
+<a id="SQLTOOLERR_EXITVAL">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>SQLTOOLERR_EXITVAL</h4>
+<pre>public static final&nbsp;int SQLTOOLERR_EXITVAL</pre>
+<dl>
+<dt><span class="seeLabel">See Also:</span></dt>
+<dd><a href="../../../../constant-values.html#org.hsqldb.cmdline.SqlTool.SQLTOOLERR_EXITVAL">Constant Field Values</a></dd>
+</dl>
+</li>
+</ul>
+<a id="SYNTAXERR_EXITVAL">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>SYNTAXERR_EXITVAL</h4>
+<pre>public static final&nbsp;int SYNTAXERR_EXITVAL</pre>
+<dl>
+<dt><span class="seeLabel">See Also:</span></dt>
+<dd><a href="../../../../constant-values.html#org.hsqldb.cmdline.SqlTool.SYNTAXERR_EXITVAL">Constant Field Values</a></dd>
+</dl>
+</li>
+</ul>
+<a id="RCERR_EXITVAL">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>RCERR_EXITVAL</h4>
+<pre>public static final&nbsp;int RCERR_EXITVAL</pre>
+<dl>
+<dt><span class="seeLabel">See Also:</span></dt>
+<dd><a href="../../../../constant-values.html#org.hsqldb.cmdline.SqlTool.RCERR_EXITVAL">Constant Field Values</a></dd>
+</dl>
+</li>
+</ul>
+<a id="SQLERR_EXITVAL">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>SQLERR_EXITVAL</h4>
+<pre>public static final&nbsp;int SQLERR_EXITVAL</pre>
+<dl>
+<dt><span class="seeLabel">See Also:</span></dt>
+<dd><a href="../../../../constant-values.html#org.hsqldb.cmdline.SqlTool.SQLERR_EXITVAL">Constant Field Values</a></dd>
+</dl>
+</li>
+</ul>
+<a id="IOERR_EXITVAL">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>IOERR_EXITVAL</h4>
+<pre>public static final&nbsp;int IOERR_EXITVAL</pre>
+<dl>
+<dt><span class="seeLabel">See Also:</span></dt>
+<dd><a href="../../../../constant-values.html#org.hsqldb.cmdline.SqlTool.IOERR_EXITVAL">Constant Field Values</a></dd>
+</dl>
+</li>
+</ul>
+<a id="FILEERR_EXITVAL">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>FILEERR_EXITVAL</h4>
+<pre>public static final&nbsp;int FILEERR_EXITVAL</pre>
+<dl>
+<dt><span class="seeLabel">See Also:</span></dt>
+<dd><a href="../../../../constant-values.html#org.hsqldb.cmdline.SqlTool.FILEERR_EXITVAL">Constant Field Values</a></dd>
+</dl>
+</li>
+</ul>
+<a id="INPUTERR_EXITVAL">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>INPUTERR_EXITVAL</h4>
+<pre>public static final&nbsp;int INPUTERR_EXITVAL</pre>
+<dl>
+<dt><span class="seeLabel">See Also:</span></dt>
+<dd><a href="../../../../constant-values.html#org.hsqldb.cmdline.SqlTool.INPUTERR_EXITVAL">Constant Field Values</a></dd>
+</dl>
+</li>
+</ul>
+<a id="CONNECTERR_EXITVAL">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>CONNECTERR_EXITVAL</h4>
+<pre>public static final&nbsp;int CONNECTERR_EXITVAL</pre>
+<dl>
+<dt><span class="seeLabel">See Also:</span></dt>
+<dd><a href="../../../../constant-values.html#org.hsqldb.cmdline.SqlTool.CONNECTERR_EXITVAL">Constant Field Values</a></dd>
+</dl>
+</li>
+</ul>
+<a id="LS">
+<!--   -->
+</a>
+<ul class="blockListLast">
+<li class="blockList">
+<h4>LS</h4>
+<pre>public static final&nbsp;java.lang.String LS</pre>
+<div class="block">Platform-specific line separator</div>
+</li>
+</ul>
+</li>
+</ul>
+</section>
+<!-- ========= CONSTRUCTOR DETAIL ======== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="constructor.detail">
+<!--   -->
+</a>
+<h3>Constructor Detail</h3>
+<a id="&lt;init&gt;()">
+<!--   -->
+</a>
+<ul class="blockListLast">
+<li class="blockList">
+<h4>SqlTool</h4>
+<pre>public&nbsp;SqlTool()</pre>
+</li>
+</ul>
+</li>
+</ul>
+</section>
+<!-- ============ METHOD DETAIL ========== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="method.detail">
+<!--   -->
+</a>
+<h3>Method Detail</h3>
+<a id="main(java.lang.String[])">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>main</h4>
+<pre class="methodSignature">public static&nbsp;void&nbsp;main&#8203;(java.lang.String[]&nbsp;args)</pre>
+<div class="block">A static wrapper for objectMain, so that that method may be executed
+ as a Java "program".
+ <P>
+ Throws only RuntimeExceptions or Errors, because this method is intended
+ to System.exit() for all but disastrous system problems, for which
+ the inconvenience of a stack trace would be the least of your worries.
+ <P>
+ If you don't want SqlTool to System.exit(), then use the method
+ objectMain() instead of this method.</div>
+<dl>
+<dt><span class="paramLabel">Parameters:</span></dt>
+<dd><code>args</code> - arguments</dd>
+<dt><span class="seeLabel">See Also:</span></dt>
+<dd><a href="#objectMain(java.lang.String%5B%5D)"><code>objectMain(String[])</code></a></dd>
+</dl>
+</li>
+</ul>
+<a id="objectMain(java.lang.String[])">
+<!--   -->
+</a>
+<ul class="blockListLast">
+<li class="blockList">
+<h4>objectMain</h4>
+<pre class="methodSignature">public static&nbsp;void&nbsp;objectMain&#8203;(java.lang.String[]&nbsp;arg)
+                       throws <a href="SqlTool.SqlToolException.html" title="class in org.hsqldb.cmdline">SqlTool.SqlToolException</a></pre>
+<div class="block">Connect to a JDBC Database and execute the commands given on
+ stdin or in SQL file(s).
+ <P>
+ This method is changed for HSQLDB 1.8.0.8 and later to never
+ System.exit().
+ Developers may catch Throwables to handle all fatal situations.</div>
+<dl>
+<dt><span class="paramLabel">Parameters:</span></dt>
+<dd><code>arg</code> - Run "java... org.hsqldb.cmdline.SqlTool --help" for syntax.</dd>
+<dt><span class="throwsLabel">Throws:</span></dt>
+<dd><code><a href="SqlTool.SqlToolException.html" title="class in org.hsqldb.cmdline">SqlTool.SqlToolException</a></code> - Upon any fatal error, with useful
+                          reason as the exception's message.</dd>
+</dl>
+</li>
+</ul>
+</li>
+</ul>
+</section>
+</li>
+</ul>
+</div>
+</div>
+</main>
+<!-- ========= END OF CLASS DATA ========= -->
+<footer role="contentinfo">
+<nav role="navigation">
+<!-- ======= START OF BOTTOM NAVBAR ====== -->
+<div class="bottomNav"><a id="navbar.bottom">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.bottom.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../module-summary.html">Module</a></li>
+<li><a href="package-summary.html">Package</a></li>
+<li class="navBarCell1Rev">Class</li>
+<li><a href="class-use/SqlTool.html">Use</a></li>
+<li><a href="package-tree.html">Tree</a></li>
+<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../index-all.html">Index</a></li>
+<li><a href="../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_bottom">
+<li><a href="../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_bottom");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<div>
+<ul class="subNavList">
+<li>Summary:&nbsp;</li>
+<li><a href="#nested.class.summary">Nested</a>&nbsp;|&nbsp;</li>
+<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
+<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
+<li><a href="#method.summary">Method</a></li>
+</ul>
+<ul class="subNavList">
+<li>Detail:&nbsp;</li>
+<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
+<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
+<li><a href="#method.detail">Method</a></li>
+</ul>
+</div>
+<a id="skip.navbar.bottom">
+<!--   -->
+</a></div>
+<!-- ======== END OF BOTTOM NAVBAR ======= -->
+</nav>
+<p class="legalCopy"><small><i>Copyright © 2001 - 2022 HSQL Development Group.</i></small></p>
+</footer>
+</body>
+</html>
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html
--- 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,3519 @@
+<!DOCTYPE HTML>
+<!-- NewPage -->
+<html lang="en">
+<head>
+<!-- Generated by javadoc (11.0.14.1) on Tue Jul 26 22:23:00 BST 2022 -->
+<title>SqltoolRB (HSQLDB 2.7.0 API)</title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+<meta name="dc.created" content="2022-07-26">
+<link rel="stylesheet" type="text/css" href="../../../../javadoc.css" title="Style">
+<link rel="stylesheet" type="text/css" href="../../../../jquery/jquery-ui.css" title="Style">
+<script type="text/javascript" src="../../../../script.js"></script>
+<script type="text/javascript" src="../../../../jquery/jszip/dist/jszip.min.js"></script>
+<script type="text/javascript" src="../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
+<!--[if IE]>
+<script type="text/javascript" src="../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
+<![endif]-->
+<script type="text/javascript" src="../../../../jquery/jquery-3.5.1.js"></script>
+<script type="text/javascript" src="../../../../jquery/jquery-ui.js"></script>
+</head>
+<body>
+<script type="text/javascript"><!--
+    try {
+        if (location.href.indexOf('is-external=true') == -1) {
+            parent.document.title="SqltoolRB (HSQLDB 2.7.0 API)";
+        }
+    }
+    catch(err) {
+    }
+//-->
+var data = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10,"i11":10,"i12":10,"i13":10,"i14":10,"i15":10,"i16":10,"i17":9,"i18":9};
+var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
+var altColor = "altColor";
+var rowColor = "rowColor";
+var tableTab = "tableTab";
+var activeTableTab = "activeTableTab";
+var pathtoroot = "../../../../";
+var useModuleDirectories = true;
+loadScripts(document, 'script');</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+<header role="banner">
+<nav role="navigation">
+<div class="fixedNav">
+<!-- ========= START OF TOP NAVBAR ======= -->
+<div class="topNav"><a id="navbar.top">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.top.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../module-summary.html">Module</a></li>
+<li><a href="package-summary.html">Package</a></li>
+<li class="navBarCell1Rev">Class</li>
+<li><a href="class-use/SqltoolRB.html">Use</a></li>
+<li><a href="package-tree.html">Tree</a></li>
+<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../index-all.html">Index</a></li>
+<li><a href="../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_top">
+<li><a href="../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<ul class="navListSearch">
+<li><label for="search">SEARCH:</label>
+<input type="text" id="search" value="search" disabled="disabled">
+<input type="reset" id="reset" value="reset" disabled="disabled">
+</li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_top");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<div>
+<ul class="subNavList">
+<li>Summary:&nbsp;</li>
+<li>Nested&nbsp;|&nbsp;</li>
+<li><a href="#enum.constant.summary">Enum Constants</a>&nbsp;|&nbsp;</li>
+<li>Field&nbsp;|&nbsp;</li>
+<li><a href="#method.summary">Method</a></li>
+</ul>
+<ul class="subNavList">
+<li>Detail:&nbsp;</li>
+<li><a href="#enum.constant.detail">Enum Constants</a>&nbsp;|&nbsp;</li>
+<li>Field&nbsp;|&nbsp;</li>
+<li><a href="#method.detail">Method</a></li>
+</ul>
+</div>
+<a id="skip.navbar.top">
+<!--   -->
+</a></div>
+<!-- ========= END OF TOP NAVBAR ========= -->
+</div>
+<div class="navPadding">&nbsp;</div>
+<script type="text/javascript"><!--
+$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
+//-->
+</script>
+</nav>
+</header>
+<!-- ======== START OF CLASS DATA ======== -->
+<main role="main">
+<div class="header">
+<div class="subTitle"><span class="moduleLabelInType">Module</span>&nbsp;<a href="../../../module-summary.html">org.hsqldb.sqltool</a></div>
+<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">org.hsqldb.cmdline</a></div>
+<h2 title="Enum SqltoolRB" class="title">Enum SqltoolRB</h2>
+</div>
+<div class="contentContainer">
+<ul class="inheritance">
+<li>java.lang.Object</li>
+<li>
+<ul class="inheritance">
+<li>java.lang.Enum&lt;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a>&gt;</li>
+<li>
+<ul class="inheritance">
+<li>org.hsqldb.cmdline.SqltoolRB</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<div class="description">
+<ul class="blockList">
+<li class="blockList">
+<dl>
+<dt>All Implemented Interfaces:</dt>
+<dd><code>java.io.Serializable</code>, <code>java.lang.Comparable&lt;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a>&gt;</code>, <code>org.hsqldb.cmdline.libclone.RefCapableRBInterface</code></dd>
+</dl>
+<hr>
+<pre>public enum <span class="typeNameLabel">SqltoolRB</span>
+extends java.lang.Enum&lt;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a>&gt;
+implements org.hsqldb.cmdline.libclone.RefCapableRBInterface</pre>
+<div class="block">Resource Bundle for SqlTool and associated classes.
+
+ Purpose of this class is to wrap a RefCapablePropertyResourceBundle to
+  reliably detect any possible use of a missing property key as soon as
+  this class is clinitted.
+ The reason for this is to allow us developers to detect all such errors
+  before end-users ever use this class.</div>
+</li>
+</ul>
+</div>
+<div class="summary">
+<ul class="blockList">
+<li class="blockList">
+<!-- =========== ENUM CONSTANT SUMMARY =========== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="enum.constant.summary">
+<!--   -->
+</a>
+<h3>Enum Constant Summary</h3>
+<table class="memberSummary">
+<caption><span>Enum Constants</span><span class="tabEnd">&nbsp;</span></caption>
+<tr>
+<th class="colFirst" scope="col">Enum Constant</th>
+<th class="colLast" scope="col">Description</th>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#a_setting">a_setting</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#aborting">aborting</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#append_empty">append_empty</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#arrayimp_jvmreq">arrayimp_jvmreq</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#arrayval_malformat">arrayval_malformat</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#auto_unset_warning">auto_unset_warning</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#autocommit_fetchfail">autocommit_fetchfail</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#bad_time_format">bad_time_format</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#bang_command_fail">bang_command_fail</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#bang_incomplete">bang_incomplete</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#binary_filefail">binary_filefail</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#binary_loadedbytesinto">binary_loadedbytesinto</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#binbuf_write">binbuf_write</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#binbuffer_empty">binbuffer_empty</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#boolean_bad">boolean_bad</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#break_syntax">break_syntax</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#break_unsatisfied">break_unsatisfied</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#buffer_empty">buffer_empty</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#buffer_executing">buffer_executing</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#buffer_extrachars">buffer_extrachars</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#buffer_help">buffer_help</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#buffer_instructions">buffer_instructions</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#buffer_restored">buffer_restored</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#buffer_unknown">buffer_unknown</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#bufhist_unspecified">bufhist_unspecified</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#c_setting">c_setting</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#causereport">causereport</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#commandnum_malformat">commandnum_malformat</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#committed">committed</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#conndata_retrieval_fail">conndata_retrieval_fail</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#connect_failure">connect_failure</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#connected_fallbackmsg">connected_fallbackmsg</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#connection_fail">connection_fail</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#continue_syntax">continue_syntax</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#continue_unsatisfied">continue_unsatisfied</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#csv_coldelim_present">csv_coldelim_present</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#csv_quote_unterminated">csv_quote_unterminated</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#d_options">d_options</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#deprecated_noop">deprecated_noop</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#describe_table_datatype">describe_table_datatype</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#describe_table_name">describe_table_name</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#describe_table_nonulls">describe_table_nonulls</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#describe_table_precision">describe_table_precision</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#describe_table_scale">describe_table_scale</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#describe_table_width">describe_table_width</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#destfile_demand">destfile_demand</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#desturl_nowrite">desturl_nowrite</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#disconnect_failure">disconnect_failure</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#disconnect_success">disconnect_success</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#disconnected_msg">disconnected_msg</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#dsv_bincol">dsv_bincol</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#dsv_colcount_mismatch">dsv_colcount_mismatch</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#dsv_coldelim_present">dsv_coldelim_present</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#dsv_constcols_nullcol">dsv_constcols_nullcol</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#dsv_header_matchernonhead">dsv_header_matchernonhead</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#dsv_header_none">dsv_header_none</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#dsv_header_nonswitched">dsv_header_nonswitched</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#dsv_header_noswitchmatch">dsv_header_noswitchmatch</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#dsv_header_noswitchtarg">dsv_header_noswitchtarg</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#dsv_import_summary">dsv_import_summary</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#dsv_insertcol_mismatch">dsv_insertcol_mismatch</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#dsv_m_syntax">dsv_m_syntax</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#dsv_metadata_mismatch">dsv_metadata_mismatch</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#dsv_nocolheader">dsv_nocolheader</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#dsv_nocolsleft">dsv_nocolsleft</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#dsv_nullrep_present">dsv_nullrep_present</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#dsv_options">dsv_options</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#dsv_q_nodblquote">dsv_q_nodblquote</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#dsv_recin_fail">dsv_recin_fail</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#dsv_rejectfile_purgefail">dsv_rejectfile_purgefail</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#dsv_rejectfile_setupfail">dsv_rejectfile_setupfail</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#dsv_rejectreport_purgefail">dsv_rejectreport_purgefail</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#dsv_rejectreport_setupfail">dsv_rejectreport_setupfail</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#dsv_rowdelim_present">dsv_rowdelim_present</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#dsv_skipcols_missing">dsv_skipcols_missing</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#dsv_targetfile_demand">dsv_targetfile_demand</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#dsv_x_syntax">dsv_x_syntax</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#dumpload_fail">dumpload_fail</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#dumpload_malformat">dumpload_malformat</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#edit_malformat">edit_malformat</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#editbuffer_contents">editbuffer_contents</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#else_without_if">else_without_if</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#encode_fail">encode_fail</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#end_noblock">end_noblock</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#errorat">errorat</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#exectime_report">exectime_report</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#exectime_reporting">exectime_reporting</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#file_appendfail">file_appendfail</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#file_readfail">file_readfail</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#file_writefail">file_writefail</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#file_wrotechars">file_wrotechars</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#history_back">history_back</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#history_backto">history_backto</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#history_none">history_none</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#history_number_req">history_number_req</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#history_unavailable">history_unavailable</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#history_upto">history_upto</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#html_mode">html_mode</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#ifwhile_malformat">ifwhile_malformat</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#illegal_at">illegal_at</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#import_col_dup">import_col_dup</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#input_malformat">input_malformat</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#input_movedtobuffer">input_movedtobuffer</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#input_unterminated">input_unterminated</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#inputfile_closefail">inputfile_closefail</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#inputrec_modified">inputrec_modified</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#insertion_preparefail">insertion_preparefail</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#insertions_notcommitted">insertions_notcommitted</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#jdbc_established">jdbc_established</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#log_syntax">log_syntax</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#log_syntax_error">log_syntax_error</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#logical_unrecognized">logical_unrecognized</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#macro_help">macro_help</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#macro_malformat">macro_malformat</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#macro_tip">macro_tip</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#macro_undefined">macro_undefined</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#macrodef_empty">macrodef_empty</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#macrodef_malformat">macrodef_malformat</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#macrodef_semi">macrodef_semi</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#math_expr_fail">math_expr_fail</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#metadata_fetch_fail">metadata_fetch_fail</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#metadata_fetch_failfor">metadata_fetch_failfor</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#no_required_conn">no_required_conn</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#no_timestamp_format">no_timestamp_format</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#no_vendor_schemaspt">no_vendor_schemaspt</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#nobuffer_yet">nobuffer_yet</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#none">none</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#noresult">noresult</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#null_assignment">null_assignment</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#outputfile_header">outputfile_header</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#outputfile_nonetoclose">outputfile_nonetoclose</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#outputfile_reopening">outputfile_reopening</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#password_readfail">password_readfail</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#passwordFor_prompt">passwordFor_prompt</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#pipeclose_failure">pipeclose_failure</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#pl_assign">pl_assign</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#pl_block_fail">pl_block_fail</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#pl_block_unterminated">pl_block_unterminated</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#pl_control">pl_control</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#pl_help">pl_help</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#pl_list_lengths">pl_list_lengths</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#pl_list_parens">pl_list_parens</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#pl_malformat">pl_malformat</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#pl_malformat_specific">pl_malformat_specific</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#pl_unknown">pl_unknown</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#pl_unset_nomoreargs">pl_unset_nomoreargs</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#plalias_malformat">plalias_malformat</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#plvar_nameempty">plvar_nameempty</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#plvar_nocolon">plvar_nocolon</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#plvar_set_incomplete">plvar_set_incomplete</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#plvar_tildedash_nomoreargs">plvar_tildedash_nomoreargs</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#plvar_undefined">plvar_undefined</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#plvar_unterminated">plvar_unterminated</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#prepare_demandqm">prepare_demandqm</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#primaryinput_accessfail">primaryinput_accessfail</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#query_metadatafail">query_metadatafail</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#raw_empty">raw_empty</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#raw_leadin">raw_leadin</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#raw_movedtobuffer">raw_movedtobuffer</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#rawmode_prompt">rawmode_prompt</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#rcdata_driver_conflict">rcdata_driver_conflict</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#rcdata_genfromvalues_fail">rcdata_genfromvalues_fail</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#rcdata_inline_extravars">rcdata_inline_extravars</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#rcdata_inlineurl_missing">rcdata_inlineurl_missing</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#rcdata_password_visible">rcdata_password_visible</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#read_convertfail">read_convertfail</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#read_partial">read_partial</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#read_toobig">read_toobig</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#regex_malformat">regex_malformat</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#reject_rpc">reject_rpc</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#rejectreport_bottom">rejectreport_bottom</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#rejectreport_row">rejectreport_row</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#rejectreport_top">rejectreport_top</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#remove_empty_vars_suggestset">remove_empty_vars_suggestset</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#rollingback">rollingback</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#row_update_multiple">row_update_multiple</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#row_update_singular">row_update_singular</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#rows_fetched">rows_fetched</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#rows_fetched_dsv">rows_fetched_dsv</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#rpc_autocommit_failure">rpc_autocommit_failure</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#rpc_commit_failure">rpc_commit_failure</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#schemaname_retrieval_fail">schemaname_retrieval_fail</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#special_b_malformat">special_b_malformat</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#special_d_like">special_d_like</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#special_d_unknown">special_d_unknown</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#special_extrachars">special_extrachars</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#special_help">special_help</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#special_malformat">special_malformat</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#special_unknown">special_unknown</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#special_unspecified">special_unspecified</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#sqlarray_badjvm">sqlarray_badjvm</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#SqlFile_banner">SqlFile_banner</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#sqlfile_execute_fail">sqlfile_execute_fail</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#sqlfile_name_demand">sqlfile_name_demand</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#sqlstatement_empty">sqlstatement_empty</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#sqltempfile_fail">sqltempfile_fail</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#SqlTool_abort_continue_mutuallyexclusive">SqlTool_abort_continue_mutuallyexclusive</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#SqlTool_params_redundant">SqlTool_params_redundant</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#SqlTool_syntax">SqlTool_syntax</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#SqlTool_varset_badformat">SqlTool_varset_badformat</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#streamread_failure">streamread_failure</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#substitution_malformat">substitution_malformat</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#substitution_nomatch">substitution_nomatch</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#substitution_syntax">substitution_syntax</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#suggest_j">suggest_j</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#sysprop_empty">sysprop_empty</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#sysprop_undefined">sysprop_undefined</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#sysprop_unterminated">sysprop_unterminated</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#time_bad">time_bad</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#transiso_report">transiso_report</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#var_infinite">var_infinite</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#varname_warning">varname_warning</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#vendor_derby_dr">vendor_derby_dr</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#vendor_derby_du">vendor_derby_du</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#vendor_nosup_d">vendor_nosup_d</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="rowColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#vendor_nosup_sysschemas">vendor_nosup_sysschemas</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr class="altColor">
+<th class="colFirst" scope="row"><code><span class="memberNameLink"><a href="#vendor_oracle_dS">vendor_oracle_dS</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+</table>
+</li>
+</ul>
+</section>
+<!-- ========== METHOD SUMMARY =========== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="method.summary">
+<!--   -->
+</a>
+<h3>Method Summary</h3>
+<table class="memberSummary">
+<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t1" class="tableTab"><span><a href="javascript:show(1);">Static Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
+<tr>
+<th class="colFirst" scope="col">Modifier and Type</th>
+<th class="colSecond" scope="col">Method</th>
+<th class="colLast" scope="col">Description</th>
+</tr>
+<tr id="i0" class="altColor">
+<td class="colFirst"><code>java.lang.String</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getExpandedString()">getExpandedString</a></span>()</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr id="i1" class="rowColor">
+<td class="colFirst"><code>java.lang.String</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getExpandedString(java.lang.String...)">getExpandedString</a></span>&#8203;(java.lang.String...&nbsp;strings)</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr id="i2" class="altColor">
+<td class="colFirst"><code>java.lang.String</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getString()">getString</a></span>()</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr id="i3" class="rowColor">
+<td class="colFirst"><code>java.lang.String</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getString(int)">getString</a></span>&#8203;(int&nbsp;i1)</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr id="i4" class="altColor">
+<td class="colFirst"><code>java.lang.String</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getString(int,int)">getString</a></span>&#8203;(int&nbsp;i1,
+         int&nbsp;i2)</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr id="i5" class="rowColor">
+<td class="colFirst"><code>java.lang.String</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getString(int,int,int)">getString</a></span>&#8203;(int&nbsp;i1,
+         int&nbsp;i2,
+         int&nbsp;i3)</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr id="i6" class="altColor">
+<td class="colFirst"><code>java.lang.String</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getString(int,int,java.lang.String)">getString</a></span>&#8203;(int&nbsp;i1,
+         int&nbsp;i2,
+         java.lang.String&nbsp;s3)</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr id="i7" class="rowColor">
+<td class="colFirst"><code>java.lang.String</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getString(int,java.lang.String)">getString</a></span>&#8203;(int&nbsp;i1,
+         java.lang.String&nbsp;s2)</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr id="i8" class="altColor">
+<td class="colFirst"><code>java.lang.String</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getString(int,java.lang.String,int)">getString</a></span>&#8203;(int&nbsp;i1,
+         java.lang.String&nbsp;s2,
+         int&nbsp;i3)</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr id="i9" class="rowColor">
+<td class="colFirst"><code>java.lang.String</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getString(int,java.lang.String,java.lang.String)">getString</a></span>&#8203;(int&nbsp;i1,
+         java.lang.String&nbsp;s2,
+         java.lang.String&nbsp;s3)</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr id="i10" class="altColor">
+<td class="colFirst"><code>java.lang.String</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getString(java.lang.String...)">getString</a></span>&#8203;(java.lang.String...&nbsp;strings)</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr id="i11" class="rowColor">
+<td class="colFirst"><code>java.lang.String</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getString(java.lang.String,int)">getString</a></span>&#8203;(java.lang.String&nbsp;s1,
+         int&nbsp;i2)</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr id="i12" class="altColor">
+<td class="colFirst"><code>java.lang.String</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getString(java.lang.String,int,int)">getString</a></span>&#8203;(java.lang.String&nbsp;s1,
+         int&nbsp;i2,
+         int&nbsp;i3)</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr id="i13" class="rowColor">
+<td class="colFirst"><code>java.lang.String</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getString(java.lang.String,int,java.lang.String)">getString</a></span>&#8203;(java.lang.String&nbsp;s1,
+         int&nbsp;i2,
+         java.lang.String&nbsp;s3)</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr id="i14" class="altColor">
+<td class="colFirst"><code>java.lang.String</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getString(java.lang.String,java.lang.String,int)">getString</a></span>&#8203;(java.lang.String&nbsp;s1,
+         java.lang.String&nbsp;s2,
+         int&nbsp;i3)</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr id="i15" class="rowColor">
+<td class="colFirst"><code>java.lang.String</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getString(java.lang.Throwable)">getString</a></span>&#8203;(java.lang.Throwable&nbsp;t)</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr id="i16" class="altColor">
+<td class="colFirst"><code>java.lang.String</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#toString()">toString</a></span>()</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+<tr id="i17" class="rowColor">
+<td class="colFirst"><code>static <a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a></code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#valueOf(java.lang.String)">valueOf</a></span>&#8203;(java.lang.String&nbsp;name)</code></th>
+<td class="colLast">
+<div class="block">Returns the enum constant of this type with the specified name.</div>
+</td>
+</tr>
+<tr id="i18" class="altColor">
+<td class="colFirst"><code>static <a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a>[]</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#values()">values</a></span>()</code></th>
+<td class="colLast">
+<div class="block">Returns an array containing the constants of this enum type, in
+the order they are declared.</div>
+</td>
+</tr>
+</table>
+<ul class="blockList">
+<li class="blockList"><a id="methods.inherited.from.class.java.lang.Enum">
+<!--   -->
+</a>
+<h3>Methods inherited from class&nbsp;java.lang.Enum</h3>
+<code>compareTo, equals, getDeclaringClass, hashCode, name, ordinal, valueOf</code></li>
+</ul>
+<ul class="blockList">
+<li class="blockList"><a id="methods.inherited.from.class.java.lang.Object">
+<!--   -->
+</a>
+<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
+<code>getClass, notify, notifyAll, wait, wait, wait</code></li>
+</ul>
+</li>
+</ul>
+</section>
+</li>
+</ul>
+</div>
+<div class="details">
+<ul class="blockList">
+<li class="blockList">
+<!-- ============ ENUM CONSTANT DETAIL =========== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="enum.constant.detail">
+<!--   -->
+</a>
+<h3>Enum Constant Detail</h3>
+<a id="SqlTool_syntax">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>SqlTool_syntax</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> SqlTool_syntax</pre>
+</li>
+</ul>
+<a id="passwordFor_prompt">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>passwordFor_prompt</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> passwordFor_prompt</pre>
+</li>
+</ul>
+<a id="SqlTool_varset_badformat">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>SqlTool_varset_badformat</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> SqlTool_varset_badformat</pre>
+</li>
+</ul>
+<a id="SqlTool_abort_continue_mutuallyexclusive">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>SqlTool_abort_continue_mutuallyexclusive</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> SqlTool_abort_continue_mutuallyexclusive</pre>
+</li>
+</ul>
+<a id="sqltempfile_fail">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>sqltempfile_fail</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> sqltempfile_fail</pre>
+</li>
+</ul>
+<a id="rcdata_inlineurl_missing">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>rcdata_inlineurl_missing</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> rcdata_inlineurl_missing</pre>
+</li>
+</ul>
+<a id="rcdata_inline_extravars">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>rcdata_inline_extravars</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> rcdata_inline_extravars</pre>
+</li>
+</ul>
+<a id="rcdata_driver_conflict">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>rcdata_driver_conflict</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> rcdata_driver_conflict</pre>
+</li>
+</ul>
+<a id="rcdata_password_visible">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>rcdata_password_visible</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> rcdata_password_visible</pre>
+</li>
+</ul>
+<a id="password_readfail">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>password_readfail</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> password_readfail</pre>
+</li>
+</ul>
+<a id="connection_fail">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>connection_fail</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> connection_fail</pre>
+</li>
+</ul>
+<a id="rcdata_genfromvalues_fail">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>rcdata_genfromvalues_fail</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> rcdata_genfromvalues_fail</pre>
+</li>
+</ul>
+<a id="conndata_retrieval_fail">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>conndata_retrieval_fail</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> conndata_retrieval_fail</pre>
+</li>
+</ul>
+<a id="jdbc_established">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>jdbc_established</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> jdbc_established</pre>
+</li>
+</ul>
+<a id="SqlTool_params_redundant">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>SqlTool_params_redundant</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> SqlTool_params_redundant</pre>
+</li>
+</ul>
+<a id="SqlFile_banner">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>SqlFile_banner</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> SqlFile_banner</pre>
+</li>
+</ul>
+<a id="buffer_help">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>buffer_help</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> buffer_help</pre>
+</li>
+</ul>
+<a id="special_help">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>special_help</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> special_help</pre>
+</li>
+</ul>
+<a id="pl_help">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>pl_help</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> pl_help</pre>
+</li>
+</ul>
+<a id="pl_control">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>pl_control</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> pl_control</pre>
+</li>
+</ul>
+<a id="pl_assign">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>pl_assign</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> pl_assign</pre>
+</li>
+</ul>
+<a id="dsv_options">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dsv_options</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> dsv_options</pre>
+</li>
+</ul>
+<a id="d_options">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>d_options</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> d_options</pre>
+</li>
+</ul>
+<a id="raw_leadin">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>raw_leadin</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> raw_leadin</pre>
+</li>
+</ul>
+<a id="errorat">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>errorat</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> errorat</pre>
+</li>
+</ul>
+<a id="rejectreport_top">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>rejectreport_top</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> rejectreport_top</pre>
+</li>
+</ul>
+<a id="rejectreport_row">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>rejectreport_row</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> rejectreport_row</pre>
+</li>
+</ul>
+<a id="rejectreport_bottom">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>rejectreport_bottom</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> rejectreport_bottom</pre>
+</li>
+</ul>
+<a id="macro_help">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>macro_help</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> macro_help</pre>
+</li>
+</ul>
+<a id="rawmode_prompt">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>rawmode_prompt</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> rawmode_prompt</pre>
+</li>
+</ul>
+<a id="raw_movedtobuffer">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>raw_movedtobuffer</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> raw_movedtobuffer</pre>
+</li>
+</ul>
+<a id="input_movedtobuffer">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>input_movedtobuffer</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> input_movedtobuffer</pre>
+</li>
+</ul>
+<a id="sqlstatement_empty">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>sqlstatement_empty</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> sqlstatement_empty</pre>
+</li>
+</ul>
+<a id="causereport">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>causereport</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> causereport</pre>
+</li>
+</ul>
+<a id="break_unsatisfied">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>break_unsatisfied</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> break_unsatisfied</pre>
+</li>
+</ul>
+<a id="continue_unsatisfied">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>continue_unsatisfied</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> continue_unsatisfied</pre>
+</li>
+</ul>
+<a id="primaryinput_accessfail">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>primaryinput_accessfail</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> primaryinput_accessfail</pre>
+</li>
+</ul>
+<a id="input_unterminated">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>input_unterminated</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> input_unterminated</pre>
+</li>
+</ul>
+<a id="plvar_set_incomplete">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>plvar_set_incomplete</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> plvar_set_incomplete</pre>
+</li>
+</ul>
+<a id="aborting">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>aborting</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> aborting</pre>
+</li>
+</ul>
+<a id="rollingback">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>rollingback</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> rollingback</pre>
+</li>
+</ul>
+<a id="special_unspecified">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>special_unspecified</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> special_unspecified</pre>
+</li>
+</ul>
+<a id="bufhist_unspecified">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>bufhist_unspecified</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> bufhist_unspecified</pre>
+</li>
+</ul>
+<a id="buffer_executing">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>buffer_executing</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> buffer_executing</pre>
+</li>
+</ul>
+<a id="nobuffer_yet">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>nobuffer_yet</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> nobuffer_yet</pre>
+</li>
+</ul>
+<a id="commandnum_malformat">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>commandnum_malformat</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> commandnum_malformat</pre>
+</li>
+</ul>
+<a id="buffer_restored">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>buffer_restored</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> buffer_restored</pre>
+</li>
+</ul>
+<a id="substitution_malformat">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>substitution_malformat</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> substitution_malformat</pre>
+</li>
+</ul>
+<a id="substitution_nomatch">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>substitution_nomatch</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> substitution_nomatch</pre>
+</li>
+</ul>
+<a id="substitution_syntax">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>substitution_syntax</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> substitution_syntax</pre>
+</li>
+</ul>
+<a id="buffer_unknown">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>buffer_unknown</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> buffer_unknown</pre>
+</li>
+</ul>
+<a id="special_extrachars">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>special_extrachars</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> special_extrachars</pre>
+</li>
+</ul>
+<a id="buffer_extrachars">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>buffer_extrachars</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> buffer_extrachars</pre>
+</li>
+</ul>
+<a id="special_malformat">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>special_malformat</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> special_malformat</pre>
+</li>
+</ul>
+<a id="html_mode">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>html_mode</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> html_mode</pre>
+</li>
+</ul>
+<a id="dsv_targetfile_demand">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dsv_targetfile_demand</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> dsv_targetfile_demand</pre>
+</li>
+</ul>
+<a id="file_wrotechars">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>file_wrotechars</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> file_wrotechars</pre>
+</li>
+</ul>
+<a id="file_writefail">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>file_writefail</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> file_writefail</pre>
+</li>
+</ul>
+<a id="special_d_like">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>special_d_like</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> special_d_like</pre>
+</li>
+</ul>
+<a id="outputfile_nonetoclose">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>outputfile_nonetoclose</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> outputfile_nonetoclose</pre>
+</li>
+</ul>
+<a id="outputfile_reopening">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>outputfile_reopening</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> outputfile_reopening</pre>
+</li>
+</ul>
+<a id="outputfile_header">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>outputfile_header</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> outputfile_header</pre>
+</li>
+</ul>
+<a id="destfile_demand">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>destfile_demand</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> destfile_demand</pre>
+</li>
+</ul>
+<a id="buffer_empty">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>buffer_empty</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> buffer_empty</pre>
+</li>
+</ul>
+<a id="file_appendfail">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>file_appendfail</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> file_appendfail</pre>
+</li>
+</ul>
+<a id="sqlfile_name_demand">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>sqlfile_name_demand</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> sqlfile_name_demand</pre>
+</li>
+</ul>
+<a id="sqlfile_execute_fail">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>sqlfile_execute_fail</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> sqlfile_execute_fail</pre>
+</li>
+</ul>
+<a id="a_setting">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>a_setting</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> a_setting</pre>
+</li>
+</ul>
+<a id="committed">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>committed</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> committed</pre>
+</li>
+</ul>
+<a id="special_b_malformat">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>special_b_malformat</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> special_b_malformat</pre>
+</li>
+</ul>
+<a id="binary_loadedbytesinto">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>binary_loadedbytesinto</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> binary_loadedbytesinto</pre>
+</li>
+</ul>
+<a id="binary_filefail">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>binary_filefail</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> binary_filefail</pre>
+</li>
+</ul>
+<a id="c_setting">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>c_setting</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> c_setting</pre>
+</li>
+</ul>
+<a id="bang_incomplete">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>bang_incomplete</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> bang_incomplete</pre>
+</li>
+</ul>
+<a id="bang_command_fail">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>bang_command_fail</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> bang_command_fail</pre>
+</li>
+</ul>
+<a id="special_unknown">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>special_unknown</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> special_unknown</pre>
+</li>
+</ul>
+<a id="dsv_m_syntax">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dsv_m_syntax</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> dsv_m_syntax</pre>
+</li>
+</ul>
+<a id="dsv_x_syntax">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dsv_x_syntax</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> dsv_x_syntax</pre>
+</li>
+</ul>
+<a id="raw_empty">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>raw_empty</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> raw_empty</pre>
+</li>
+</ul>
+<a id="dsv_nocolsleft">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dsv_nocolsleft</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> dsv_nocolsleft</pre>
+</li>
+</ul>
+<a id="dsv_skipcols_missing">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dsv_skipcols_missing</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> dsv_skipcols_missing</pre>
+</li>
+</ul>
+<a id="plalias_malformat">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>plalias_malformat</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> plalias_malformat</pre>
+</li>
+</ul>
+<a id="plvar_undefined">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>plvar_undefined</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> plvar_undefined</pre>
+</li>
+</ul>
+<a id="sysprop_empty">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>sysprop_empty</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> sysprop_empty</pre>
+</li>
+</ul>
+<a id="sysprop_unterminated">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>sysprop_unterminated</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> sysprop_unterminated</pre>
+</li>
+</ul>
+<a id="sysprop_undefined">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>sysprop_undefined</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> sysprop_undefined</pre>
+</li>
+</ul>
+<a id="var_infinite">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>var_infinite</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> var_infinite</pre>
+</li>
+</ul>
+<a id="plvar_nameempty">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>plvar_nameempty</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> plvar_nameempty</pre>
+</li>
+</ul>
+<a id="plvar_unterminated">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>plvar_unterminated</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> plvar_unterminated</pre>
+</li>
+</ul>
+<a id="pl_malformat">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>pl_malformat</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> pl_malformat</pre>
+</li>
+</ul>
+<a id="deprecated_noop">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>deprecated_noop</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> deprecated_noop</pre>
+</li>
+</ul>
+<a id="end_noblock">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>end_noblock</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> end_noblock</pre>
+</li>
+</ul>
+<a id="continue_syntax">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>continue_syntax</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> continue_syntax</pre>
+</li>
+</ul>
+<a id="break_syntax">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>break_syntax</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> break_syntax</pre>
+</li>
+</ul>
+<a id="pl_list_parens">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>pl_list_parens</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> pl_list_parens</pre>
+</li>
+</ul>
+<a id="pl_list_lengths">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>pl_list_lengths</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> pl_list_lengths</pre>
+</li>
+</ul>
+<a id="dumpload_malformat">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dumpload_malformat</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> dumpload_malformat</pre>
+</li>
+</ul>
+<a id="plvar_nocolon">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>plvar_nocolon</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> plvar_nocolon</pre>
+</li>
+</ul>
+<a id="plvar_tildedash_nomoreargs">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>plvar_tildedash_nomoreargs</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> plvar_tildedash_nomoreargs</pre>
+</li>
+</ul>
+<a id="dumpload_fail">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dumpload_fail</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> dumpload_fail</pre>
+</li>
+</ul>
+<a id="pl_malformat_specific">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>pl_malformat_specific</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> pl_malformat_specific</pre>
+</li>
+</ul>
+<a id="pl_block_fail">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>pl_block_fail</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> pl_block_fail</pre>
+</li>
+</ul>
+<a id="ifwhile_malformat">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>ifwhile_malformat</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> ifwhile_malformat</pre>
+</li>
+</ul>
+<a id="pl_unknown">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>pl_unknown</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> pl_unknown</pre>
+</li>
+</ul>
+<a id="pl_block_unterminated">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>pl_block_unterminated</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> pl_block_unterminated</pre>
+</li>
+</ul>
+<a id="vendor_oracle_dS">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>vendor_oracle_dS</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> vendor_oracle_dS</pre>
+</li>
+</ul>
+<a id="vendor_derby_dr">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>vendor_derby_dr</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> vendor_derby_dr</pre>
+</li>
+</ul>
+<a id="vendor_nosup_d">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>vendor_nosup_d</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> vendor_nosup_d</pre>
+</li>
+</ul>
+<a id="vendor_derby_du">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>vendor_derby_du</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> vendor_derby_du</pre>
+</li>
+</ul>
+<a id="special_d_unknown">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>special_d_unknown</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> special_d_unknown</pre>
+</li>
+</ul>
+<a id="metadata_fetch_fail">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>metadata_fetch_fail</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> metadata_fetch_fail</pre>
+</li>
+</ul>
+<a id="metadata_fetch_failfor">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>metadata_fetch_failfor</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> metadata_fetch_failfor</pre>
+</li>
+</ul>
+<a id="prepare_demandqm">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>prepare_demandqm</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> prepare_demandqm</pre>
+</li>
+</ul>
+<a id="binbuffer_empty">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>binbuffer_empty</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> binbuffer_empty</pre>
+</li>
+</ul>
+<a id="vendor_nosup_sysschemas">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>vendor_nosup_sysschemas</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> vendor_nosup_sysschemas</pre>
+</li>
+</ul>
+<a id="noresult">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>noresult</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> noresult</pre>
+</li>
+</ul>
+<a id="dsv_bincol">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dsv_bincol</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> dsv_bincol</pre>
+</li>
+</ul>
+<a id="binbuf_write">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>binbuf_write</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> binbuf_write</pre>
+</li>
+</ul>
+<a id="rows_fetched">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>rows_fetched</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> rows_fetched</pre>
+</li>
+</ul>
+<a id="rows_fetched_dsv">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>rows_fetched_dsv</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> rows_fetched_dsv</pre>
+</li>
+</ul>
+<a id="row_update_singular">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>row_update_singular</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> row_update_singular</pre>
+</li>
+</ul>
+<a id="row_update_multiple">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>row_update_multiple</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> row_update_multiple</pre>
+</li>
+</ul>
+<a id="history_unavailable">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>history_unavailable</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> history_unavailable</pre>
+</li>
+</ul>
+<a id="history_none">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>history_none</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> history_none</pre>
+</li>
+</ul>
+<a id="editbuffer_contents">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>editbuffer_contents</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> editbuffer_contents</pre>
+</li>
+</ul>
+<a id="buffer_instructions">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>buffer_instructions</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> buffer_instructions</pre>
+</li>
+</ul>
+<a id="history_number_req">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>history_number_req</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> history_number_req</pre>
+</li>
+</ul>
+<a id="history_backto">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>history_backto</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> history_backto</pre>
+</li>
+</ul>
+<a id="history_upto">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>history_upto</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> history_upto</pre>
+</li>
+</ul>
+<a id="history_back">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>history_back</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> history_back</pre>
+</li>
+</ul>
+<a id="describe_table_name">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>describe_table_name</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> describe_table_name</pre>
+</li>
+</ul>
+<a id="describe_table_datatype">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>describe_table_datatype</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> describe_table_datatype</pre>
+</li>
+</ul>
+<a id="describe_table_width">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>describe_table_width</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> describe_table_width</pre>
+</li>
+</ul>
+<a id="describe_table_nonulls">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>describe_table_nonulls</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> describe_table_nonulls</pre>
+</li>
+</ul>
+<a id="describe_table_precision">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>describe_table_precision</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> describe_table_precision</pre>
+</li>
+</ul>
+<a id="describe_table_scale">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>describe_table_scale</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> describe_table_scale</pre>
+</li>
+</ul>
+<a id="logical_unrecognized">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>logical_unrecognized</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> logical_unrecognized</pre>
+</li>
+</ul>
+<a id="read_toobig">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>read_toobig</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> read_toobig</pre>
+</li>
+</ul>
+<a id="read_partial">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>read_partial</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> read_partial</pre>
+</li>
+</ul>
+<a id="read_convertfail">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>read_convertfail</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> read_convertfail</pre>
+</li>
+</ul>
+<a id="dsv_coldelim_present">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dsv_coldelim_present</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> dsv_coldelim_present</pre>
+</li>
+</ul>
+<a id="dsv_rowdelim_present">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dsv_rowdelim_present</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> dsv_rowdelim_present</pre>
+</li>
+</ul>
+<a id="dsv_nullrep_present">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dsv_nullrep_present</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> dsv_nullrep_present</pre>
+</li>
+</ul>
+<a id="dsv_constcols_nullcol">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dsv_constcols_nullcol</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> dsv_constcols_nullcol</pre>
+</li>
+</ul>
+<a id="file_readfail">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>file_readfail</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> file_readfail</pre>
+</li>
+</ul>
+<a id="inputfile_closefail">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>inputfile_closefail</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> inputfile_closefail</pre>
+</li>
+</ul>
+<a id="dsv_header_none">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dsv_header_none</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> dsv_header_none</pre>
+</li>
+</ul>
+<a id="dsv_header_noswitchtarg">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dsv_header_noswitchtarg</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> dsv_header_noswitchtarg</pre>
+</li>
+</ul>
+<a id="dsv_header_noswitchmatch">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dsv_header_noswitchmatch</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> dsv_header_noswitchmatch</pre>
+</li>
+</ul>
+<a id="dsv_header_nonswitched">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dsv_header_nonswitched</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> dsv_header_nonswitched</pre>
+</li>
+</ul>
+<a id="dsv_nocolheader">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dsv_nocolheader</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> dsv_nocolheader</pre>
+</li>
+</ul>
+<a id="dsv_metadata_mismatch">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dsv_metadata_mismatch</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> dsv_metadata_mismatch</pre>
+</li>
+</ul>
+<a id="query_metadatafail">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>query_metadatafail</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> query_metadatafail</pre>
+</li>
+</ul>
+<a id="dsv_rejectfile_setupfail">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dsv_rejectfile_setupfail</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> dsv_rejectfile_setupfail</pre>
+</li>
+</ul>
+<a id="dsv_rejectreport_setupfail">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dsv_rejectreport_setupfail</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> dsv_rejectreport_setupfail</pre>
+</li>
+</ul>
+<a id="none">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>none</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> none</pre>
+</li>
+</ul>
+<a id="insertion_preparefail">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>insertion_preparefail</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> insertion_preparefail</pre>
+</li>
+</ul>
+<a id="dsv_header_matchernonhead">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dsv_header_matchernonhead</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> dsv_header_matchernonhead</pre>
+</li>
+</ul>
+<a id="dsv_colcount_mismatch">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dsv_colcount_mismatch</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> dsv_colcount_mismatch</pre>
+</li>
+</ul>
+<a id="dsv_insertcol_mismatch">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dsv_insertcol_mismatch</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> dsv_insertcol_mismatch</pre>
+</li>
+</ul>
+<a id="time_bad">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>time_bad</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> time_bad</pre>
+</li>
+</ul>
+<a id="boolean_bad">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>boolean_bad</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> boolean_bad</pre>
+</li>
+</ul>
+<a id="inputrec_modified">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>inputrec_modified</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> inputrec_modified</pre>
+</li>
+</ul>
+<a id="dsv_recin_fail">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dsv_recin_fail</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> dsv_recin_fail</pre>
+</li>
+</ul>
+<a id="dsv_import_summary">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dsv_import_summary</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> dsv_import_summary</pre>
+</li>
+</ul>
+<a id="insertions_notcommitted">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>insertions_notcommitted</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> insertions_notcommitted</pre>
+</li>
+</ul>
+<a id="autocommit_fetchfail">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>autocommit_fetchfail</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> autocommit_fetchfail</pre>
+</li>
+</ul>
+<a id="dsv_rejectfile_purgefail">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dsv_rejectfile_purgefail</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> dsv_rejectfile_purgefail</pre>
+</li>
+</ul>
+<a id="dsv_rejectreport_purgefail">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dsv_rejectreport_purgefail</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> dsv_rejectreport_purgefail</pre>
+</li>
+</ul>
+<a id="edit_malformat">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>edit_malformat</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> edit_malformat</pre>
+</li>
+</ul>
+<a id="input_malformat">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>input_malformat</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> input_malformat</pre>
+</li>
+</ul>
+<a id="append_empty">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>append_empty</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> append_empty</pre>
+</li>
+</ul>
+<a id="transiso_report">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>transiso_report</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> transiso_report</pre>
+</li>
+</ul>
+<a id="exectime_reporting">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>exectime_reporting</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> exectime_reporting</pre>
+</li>
+</ul>
+<a id="exectime_report">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>exectime_report</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> exectime_report</pre>
+</li>
+</ul>
+<a id="regex_malformat">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>regex_malformat</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> regex_malformat</pre>
+</li>
+</ul>
+<a id="encode_fail">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>encode_fail</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> encode_fail</pre>
+</li>
+</ul>
+<a id="macro_tip">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>macro_tip</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> macro_tip</pre>
+</li>
+</ul>
+<a id="macrodef_malformat">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>macrodef_malformat</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> macrodef_malformat</pre>
+</li>
+</ul>
+<a id="macrodef_empty">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>macrodef_empty</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> macrodef_empty</pre>
+</li>
+</ul>
+<a id="macrodef_semi">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>macrodef_semi</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> macrodef_semi</pre>
+</li>
+</ul>
+<a id="macro_malformat">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>macro_malformat</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> macro_malformat</pre>
+</li>
+</ul>
+<a id="macro_undefined">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>macro_undefined</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> macro_undefined</pre>
+</li>
+</ul>
+<a id="log_syntax">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>log_syntax</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> log_syntax</pre>
+</li>
+</ul>
+<a id="log_syntax_error">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>log_syntax_error</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> log_syntax_error</pre>
+</li>
+</ul>
+<a id="reject_rpc">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>reject_rpc</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> reject_rpc</pre>
+</li>
+</ul>
+<a id="rpc_autocommit_failure">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>rpc_autocommit_failure</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> rpc_autocommit_failure</pre>
+</li>
+</ul>
+<a id="rpc_commit_failure">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>rpc_commit_failure</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> rpc_commit_failure</pre>
+</li>
+</ul>
+<a id="disconnect_success">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>disconnect_success</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> disconnect_success</pre>
+</li>
+</ul>
+<a id="disconnect_failure">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>disconnect_failure</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> disconnect_failure</pre>
+</li>
+</ul>
+<a id="no_required_conn">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>no_required_conn</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> no_required_conn</pre>
+</li>
+</ul>
+<a id="disconnected_msg">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>disconnected_msg</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> disconnected_msg</pre>
+</li>
+</ul>
+<a id="connected_fallbackmsg">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>connected_fallbackmsg</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> connected_fallbackmsg</pre>
+</li>
+</ul>
+<a id="no_vendor_schemaspt">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>no_vendor_schemaspt</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> no_vendor_schemaspt</pre>
+</li>
+</ul>
+<a id="schemaname_retrieval_fail">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>schemaname_retrieval_fail</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> schemaname_retrieval_fail</pre>
+</li>
+</ul>
+<a id="remove_empty_vars_suggestset">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>remove_empty_vars_suggestset</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> remove_empty_vars_suggestset</pre>
+</li>
+</ul>
+<a id="auto_unset_warning">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>auto_unset_warning</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> auto_unset_warning</pre>
+</li>
+</ul>
+<a id="pl_unset_nomoreargs">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>pl_unset_nomoreargs</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> pl_unset_nomoreargs</pre>
+</li>
+</ul>
+<a id="dsv_q_nodblquote">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>dsv_q_nodblquote</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> dsv_q_nodblquote</pre>
+</li>
+</ul>
+<a id="connect_failure">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>connect_failure</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> connect_failure</pre>
+</li>
+</ul>
+<a id="streamread_failure">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>streamread_failure</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> streamread_failure</pre>
+</li>
+</ul>
+<a id="illegal_at">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>illegal_at</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> illegal_at</pre>
+</li>
+</ul>
+<a id="suggest_j">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>suggest_j</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> suggest_j</pre>
+</li>
+</ul>
+<a id="pipeclose_failure">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>pipeclose_failure</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> pipeclose_failure</pre>
+</li>
+</ul>
+<a id="arrayimp_jvmreq">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>arrayimp_jvmreq</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> arrayimp_jvmreq</pre>
+</li>
+</ul>
+<a id="arrayval_malformat">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>arrayval_malformat</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> arrayval_malformat</pre>
+</li>
+</ul>
+<a id="sqlarray_badjvm">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>sqlarray_badjvm</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> sqlarray_badjvm</pre>
+</li>
+</ul>
+<a id="csv_coldelim_present">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>csv_coldelim_present</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> csv_coldelim_present</pre>
+</li>
+</ul>
+<a id="csv_quote_unterminated">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>csv_quote_unterminated</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> csv_quote_unterminated</pre>
+</li>
+</ul>
+<a id="math_expr_fail">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>math_expr_fail</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> math_expr_fail</pre>
+</li>
+</ul>
+<a id="varname_warning">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>varname_warning</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> varname_warning</pre>
+</li>
+</ul>
+<a id="null_assignment">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>null_assignment</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> null_assignment</pre>
+</li>
+</ul>
+<a id="bad_time_format">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>bad_time_format</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> bad_time_format</pre>
+</li>
+</ul>
+<a id="no_timestamp_format">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>no_timestamp_format</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> no_timestamp_format</pre>
+</li>
+</ul>
+<a id="else_without_if">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>else_without_if</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> else_without_if</pre>
+</li>
+</ul>
+<a id="import_col_dup">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>import_col_dup</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> import_col_dup</pre>
+</li>
+</ul>
+<a id="desturl_nowrite">
+<!--   -->
+</a>
+<ul class="blockListLast">
+<li class="blockList">
+<h4>desturl_nowrite</h4>
+<pre>public static final&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a> desturl_nowrite</pre>
+</li>
+</ul>
+</li>
+</ul>
+</section>
+<!-- ============ METHOD DETAIL ========== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="method.detail">
+<!--   -->
+</a>
+<h3>Method Detail</h3>
+<a id="values()">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>values</h4>
+<pre class="methodSignature">public static&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a>[]&nbsp;values()</pre>
+<div class="block">Returns an array containing the constants of this enum type, in
+the order they are declared. This method may be used to iterate
+over the constants as follows:
+<pre>
+for (SqltoolRB c : SqltoolRB.values())
+&nbsp;   System.out.println(c);
+</pre></div>
+<dl>
+<dt><span class="returnLabel">Returns:</span></dt>
+<dd>an array containing the constants of this enum type, in the order they are declared</dd>
+</dl>
+</li>
+</ul>
+<a id="valueOf(java.lang.String)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>valueOf</h4>
+<pre class="methodSignature">public static&nbsp;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a>&nbsp;valueOf&#8203;(java.lang.String&nbsp;name)</pre>
+<div class="block">Returns the enum constant of this type with the specified name.
+The string must match <i>exactly</i> an identifier used to declare an
+enum constant in this type.  (Extraneous whitespace characters are 
+not permitted.)</div>
+<dl>
+<dt><span class="paramLabel">Parameters:</span></dt>
+<dd><code>name</code> - the name of the enum constant to be returned.</dd>
+<dt><span class="returnLabel">Returns:</span></dt>
+<dd>the enum constant with the specified name</dd>
+<dt><span class="throwsLabel">Throws:</span></dt>
+<dd><code>java.lang.IllegalArgumentException</code> - if this enum type has no constant with the specified name</dd>
+<dd><code>java.lang.NullPointerException</code> - if the argument is null</dd>
+</dl>
+</li>
+</ul>
+<a id="getString()">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>getString</h4>
+<pre class="methodSignature">public&nbsp;java.lang.String&nbsp;getString()</pre>
+<dl>
+<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
+<dd><code>getString</code>&nbsp;in interface&nbsp;<code>org.hsqldb.cmdline.libclone.RefCapableRBInterface</code></dd>
+</dl>
+</li>
+</ul>
+<a id="toString()">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>toString</h4>
+<pre class="methodSignature">public&nbsp;java.lang.String&nbsp;toString()</pre>
+<dl>
+<dt><span class="overrideSpecifyLabel">Overrides:</span></dt>
+<dd><code>toString</code>&nbsp;in class&nbsp;<code>java.lang.Enum&lt;<a href="SqltoolRB.html" title="enum in org.hsqldb.cmdline">SqltoolRB</a>&gt;</code></dd>
+</dl>
+</li>
+</ul>
+<a id="getExpandedString()">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>getExpandedString</h4>
+<pre class="methodSignature">public&nbsp;java.lang.String&nbsp;getExpandedString()</pre>
+<dl>
+<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
+<dd><code>getExpandedString</code>&nbsp;in interface&nbsp;<code>org.hsqldb.cmdline.libclone.RefCapableRBInterface</code></dd>
+</dl>
+</li>
+</ul>
+<a id="getExpandedString(java.lang.String...)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>getExpandedString</h4>
+<pre class="methodSignature">public&nbsp;java.lang.String&nbsp;getExpandedString&#8203;(java.lang.String...&nbsp;strings)</pre>
+<dl>
+<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
+<dd><code>getExpandedString</code>&nbsp;in interface&nbsp;<code>org.hsqldb.cmdline.libclone.RefCapableRBInterface</code></dd>
+</dl>
+</li>
+</ul>
+<a id="getString(java.lang.Throwable)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>getString</h4>
+<pre class="methodSignature">public&nbsp;java.lang.String&nbsp;getString&#8203;(java.lang.Throwable&nbsp;t)</pre>
+</li>
+</ul>
+<a id="getString(java.lang.String...)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>getString</h4>
+<pre class="methodSignature">public&nbsp;java.lang.String&nbsp;getString&#8203;(java.lang.String...&nbsp;strings)</pre>
+<dl>
+<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
+<dd><code>getString</code>&nbsp;in interface&nbsp;<code>org.hsqldb.cmdline.libclone.RefCapableRBInterface</code></dd>
+</dl>
+</li>
+</ul>
+<a id="getString(int)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>getString</h4>
+<pre class="methodSignature">public&nbsp;java.lang.String&nbsp;getString&#8203;(int&nbsp;i1)</pre>
+<dl>
+<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
+<dd><code>getString</code>&nbsp;in interface&nbsp;<code>org.hsqldb.cmdline.libclone.RefCapableRBInterface</code></dd>
+</dl>
+</li>
+</ul>
+<a id="getString(int,int)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>getString</h4>
+<pre class="methodSignature">public&nbsp;java.lang.String&nbsp;getString&#8203;(int&nbsp;i1,
+                                  int&nbsp;i2)</pre>
+<dl>
+<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
+<dd><code>getString</code>&nbsp;in interface&nbsp;<code>org.hsqldb.cmdline.libclone.RefCapableRBInterface</code></dd>
+</dl>
+</li>
+</ul>
+<a id="getString(int,int,int)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>getString</h4>
+<pre class="methodSignature">public&nbsp;java.lang.String&nbsp;getString&#8203;(int&nbsp;i1,
+                                  int&nbsp;i2,
+                                  int&nbsp;i3)</pre>
+<dl>
+<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
+<dd><code>getString</code>&nbsp;in interface&nbsp;<code>org.hsqldb.cmdline.libclone.RefCapableRBInterface</code></dd>
+</dl>
+</li>
+</ul>
+<a id="getString(int,java.lang.String)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>getString</h4>
+<pre class="methodSignature">public&nbsp;java.lang.String&nbsp;getString&#8203;(int&nbsp;i1,
+                                  java.lang.String&nbsp;s2)</pre>
+<dl>
+<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
+<dd><code>getString</code>&nbsp;in interface&nbsp;<code>org.hsqldb.cmdline.libclone.RefCapableRBInterface</code></dd>
+</dl>
+</li>
+</ul>
+<a id="getString(java.lang.String,int)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>getString</h4>
+<pre class="methodSignature">public&nbsp;java.lang.String&nbsp;getString&#8203;(java.lang.String&nbsp;s1,
+                                  int&nbsp;i2)</pre>
+<dl>
+<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
+<dd><code>getString</code>&nbsp;in interface&nbsp;<code>org.hsqldb.cmdline.libclone.RefCapableRBInterface</code></dd>
+</dl>
+</li>
+</ul>
+<a id="getString(int,int,java.lang.String)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>getString</h4>
+<pre class="methodSignature">public&nbsp;java.lang.String&nbsp;getString&#8203;(int&nbsp;i1,
+                                  int&nbsp;i2,
+                                  java.lang.String&nbsp;s3)</pre>
+<dl>
+<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
+<dd><code>getString</code>&nbsp;in interface&nbsp;<code>org.hsqldb.cmdline.libclone.RefCapableRBInterface</code></dd>
+</dl>
+</li>
+</ul>
+<a id="getString(int,java.lang.String,int)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>getString</h4>
+<pre class="methodSignature">public&nbsp;java.lang.String&nbsp;getString&#8203;(int&nbsp;i1,
+                                  java.lang.String&nbsp;s2,
+                                  int&nbsp;i3)</pre>
+<dl>
+<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
+<dd><code>getString</code>&nbsp;in interface&nbsp;<code>org.hsqldb.cmdline.libclone.RefCapableRBInterface</code></dd>
+</dl>
+</li>
+</ul>
+<a id="getString(java.lang.String,int,int)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>getString</h4>
+<pre class="methodSignature">public&nbsp;java.lang.String&nbsp;getString&#8203;(java.lang.String&nbsp;s1,
+                                  int&nbsp;i2,
+                                  int&nbsp;i3)</pre>
+<dl>
+<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
+<dd><code>getString</code>&nbsp;in interface&nbsp;<code>org.hsqldb.cmdline.libclone.RefCapableRBInterface</code></dd>
+</dl>
+</li>
+</ul>
+<a id="getString(int,java.lang.String,java.lang.String)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>getString</h4>
+<pre class="methodSignature">public&nbsp;java.lang.String&nbsp;getString&#8203;(int&nbsp;i1,
+                                  java.lang.String&nbsp;s2,
+                                  java.lang.String&nbsp;s3)</pre>
+<dl>
+<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
+<dd><code>getString</code>&nbsp;in interface&nbsp;<code>org.hsqldb.cmdline.libclone.RefCapableRBInterface</code></dd>
+</dl>
+</li>
+</ul>
+<a id="getString(java.lang.String,java.lang.String,int)">
+<!--   -->
+</a>
+<ul class="blockList">
+<li class="blockList">
+<h4>getString</h4>
+<pre class="methodSignature">public&nbsp;java.lang.String&nbsp;getString&#8203;(java.lang.String&nbsp;s1,
+                                  java.lang.String&nbsp;s2,
+                                  int&nbsp;i3)</pre>
+<dl>
+<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
+<dd><code>getString</code>&nbsp;in interface&nbsp;<code>org.hsqldb.cmdline.libclone.RefCapableRBInterface</code></dd>
+</dl>
+</li>
+</ul>
+<a id="getString(java.lang.String,int,java.lang.String)">
+<!--   -->
+</a>
+<ul class="blockListLast">
+<li class="blockList">
+<h4>getString</h4>
+<pre class="methodSignature">public&nbsp;java.lang.String&nbsp;getString&#8203;(java.lang.String&nbsp;s1,
+                                  int&nbsp;i2,
+                                  java.lang.String&nbsp;s3)</pre>
+<dl>
+<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
+<dd><code>getString</code>&nbsp;in interface&nbsp;<code>org.hsqldb.cmdline.libclone.RefCapableRBInterface</code></dd>
+</dl>
+</li>
+</ul>
+</li>
+</ul>
+</section>
+</li>
+</ul>
+</div>
+</div>
+</main>
+<!-- ========= END OF CLASS DATA ========= -->
+<footer role="contentinfo">
+<nav role="navigation">
+<!-- ======= START OF BOTTOM NAVBAR ====== -->
+<div class="bottomNav"><a id="navbar.bottom">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.bottom.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../module-summary.html">Module</a></li>
+<li><a href="package-summary.html">Package</a></li>
+<li class="navBarCell1Rev">Class</li>
+<li><a href="class-use/SqltoolRB.html">Use</a></li>
+<li><a href="package-tree.html">Tree</a></li>
+<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../index-all.html">Index</a></li>
+<li><a href="../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_bottom">
+<li><a href="../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_bottom");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<div>
+<ul class="subNavList">
+<li>Summary:&nbsp;</li>
+<li>Nested&nbsp;|&nbsp;</li>
+<li><a href="#enum.constant.summary">Enum Constants</a>&nbsp;|&nbsp;</li>
+<li>Field&nbsp;|&nbsp;</li>
+<li><a href="#method.summary">Method</a></li>
+</ul>
+<ul class="subNavList">
+<li>Detail:&nbsp;</li>
+<li><a href="#enum.constant.detail">Enum Constants</a>&nbsp;|&nbsp;</li>
+<li>Field&nbsp;|&nbsp;</li>
+<li><a href="#method.detail">Method</a></li>
+</ul>
+</div>
+<a id="skip.navbar.bottom">
+<!--   -->
+</a></div>
+<!-- ======== END OF BOTTOM NAVBAR ======= -->
+</nav>
+<p class="legalCopy"><small><i>Copyright © 2001 - 2022 HSQL Development Group.</i></small></p>
+</footer>
+</body>
+</html>
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolSprayer.html 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolSprayer.html
--- 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolSprayer.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolSprayer.html	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,368 @@
+<!DOCTYPE HTML>
+<!-- NewPage -->
+<html lang="en">
+<head>
+<!-- Generated by javadoc (11.0.14.1) on Tue Jul 26 22:23:00 BST 2022 -->
+<title>SqlToolSprayer (HSQLDB 2.7.0 API)</title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+<meta name="dc.created" content="2022-07-26">
+<link rel="stylesheet" type="text/css" href="../../../../javadoc.css" title="Style">
+<link rel="stylesheet" type="text/css" href="../../../../jquery/jquery-ui.css" title="Style">
+<script type="text/javascript" src="../../../../script.js"></script>
+<script type="text/javascript" src="../../../../jquery/jszip/dist/jszip.min.js"></script>
+<script type="text/javascript" src="../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
+<!--[if IE]>
+<script type="text/javascript" src="../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
+<![endif]-->
+<script type="text/javascript" src="../../../../jquery/jquery-3.5.1.js"></script>
+<script type="text/javascript" src="../../../../jquery/jquery-ui.js"></script>
+</head>
+<body>
+<script type="text/javascript"><!--
+    try {
+        if (location.href.indexOf('is-external=true') == -1) {
+            parent.document.title="SqlToolSprayer (HSQLDB 2.7.0 API)";
+        }
+    }
+    catch(err) {
+    }
+//-->
+var data = {"i0":9};
+var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],8:["t4","Concrete Methods"]};
+var altColor = "altColor";
+var rowColor = "rowColor";
+var tableTab = "tableTab";
+var activeTableTab = "activeTableTab";
+var pathtoroot = "../../../../";
+var useModuleDirectories = true;
+loadScripts(document, 'script');</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+<header role="banner">
+<nav role="navigation">
+<div class="fixedNav">
+<!-- ========= START OF TOP NAVBAR ======= -->
+<div class="topNav"><a id="navbar.top">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.top.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../module-summary.html">Module</a></li>
+<li><a href="package-summary.html">Package</a></li>
+<li class="navBarCell1Rev">Class</li>
+<li><a href="class-use/SqlToolSprayer.html">Use</a></li>
+<li><a href="package-tree.html">Tree</a></li>
+<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../index-all.html">Index</a></li>
+<li><a href="../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_top">
+<li><a href="../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<ul class="navListSearch">
+<li><label for="search">SEARCH:</label>
+<input type="text" id="search" value="search" disabled="disabled">
+<input type="reset" id="reset" value="reset" disabled="disabled">
+</li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_top");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<div>
+<ul class="subNavList">
+<li>Summary:&nbsp;</li>
+<li>Nested&nbsp;|&nbsp;</li>
+<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
+<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
+<li><a href="#method.summary">Method</a></li>
+</ul>
+<ul class="subNavList">
+<li>Detail:&nbsp;</li>
+<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
+<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
+<li><a href="#method.detail">Method</a></li>
+</ul>
+</div>
+<a id="skip.navbar.top">
+<!--   -->
+</a></div>
+<!-- ========= END OF TOP NAVBAR ========= -->
+</div>
+<div class="navPadding">&nbsp;</div>
+<script type="text/javascript"><!--
+$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
+//-->
+</script>
+</nav>
+</header>
+<!-- ======== START OF CLASS DATA ======== -->
+<main role="main">
+<div class="header">
+<div class="subTitle"><span class="moduleLabelInType">Module</span>&nbsp;<a href="../../../module-summary.html">org.hsqldb.sqltool</a></div>
+<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">org.hsqldb.cmdline</a></div>
+<h2 title="Class SqlToolSprayer" class="title">Class SqlToolSprayer</h2>
+</div>
+<div class="contentContainer">
+<ul class="inheritance">
+<li>java.lang.Object</li>
+<li>
+<ul class="inheritance">
+<li>org.hsqldb.cmdline.SqlToolSprayer</li>
+</ul>
+</li>
+</ul>
+<div class="description">
+<ul class="blockList">
+<li class="blockList">
+<hr>
+<pre>public class <span class="typeNameLabel">SqlToolSprayer</span>
+extends java.lang.Object</pre>
+<div class="block">Sql Tool Sprayer.
+ Invokes SqlTool.objectMain() multiple times with the same SQL.
+ Invokes for multiple urlids and/or retries.
+
+ See JavaDocs for the main method for syntax of how to run.
+
+ System properties used if set:
+ <UL>
+      <LI>sqltoolsprayer.period (in ms.)</LI>
+      <LI>sqltoolsprayer.maxtime (in ms.)</LI>
+      <LI>sqltoolsprayer.rcfile (filepath)</LI>
+ </UL></div>
+<dl>
+<dt><span class="simpleTagLabel">Author:</span></dt>
+<dd>Blaine Simpson (blaine dot simpson at admc dot com)</dd>
+<dt><span class="seeLabel">See Also:</span></dt>
+<dd><a href="#main(java.lang.String%5B%5D)"><code>main(String[])</code></a></dd>
+</dl>
+</li>
+</ul>
+</div>
+<div class="summary">
+<ul class="blockList">
+<li class="blockList">
+<!-- =========== FIELD SUMMARY =========== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="field.summary">
+<!--   -->
+</a>
+<h3>Field Summary</h3>
+<table class="memberSummary">
+<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
+<tr>
+<th class="colFirst" scope="col">Modifier and Type</th>
+<th class="colSecond" scope="col">Field</th>
+<th class="colLast" scope="col">Description</th>
+</tr>
+<tr class="altColor">
+<td class="colFirst"><code>static java.lang.String</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#LS">LS</a></span></code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+</table>
+</li>
+</ul>
+</section>
+<!-- ======== CONSTRUCTOR SUMMARY ======== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="constructor.summary">
+<!--   -->
+</a>
+<h3>Constructor Summary</h3>
+<table class="memberSummary">
+<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
+<tr>
+<th class="colFirst" scope="col">Constructor</th>
+<th class="colLast" scope="col">Description</th>
+</tr>
+<tr class="altColor">
+<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E()">SqlToolSprayer</a></span>()</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+</table>
+</li>
+</ul>
+</section>
+<!-- ========== METHOD SUMMARY =========== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="method.summary">
+<!--   -->
+</a>
+<h3>Method Summary</h3>
+<table class="memberSummary">
+<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t1" class="tableTab"><span><a href="javascript:show(1);">Static Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
+<tr>
+<th class="colFirst" scope="col">Modifier and Type</th>
+<th class="colSecond" scope="col">Method</th>
+<th class="colLast" scope="col">Description</th>
+</tr>
+<tr id="i0" class="altColor">
+<td class="colFirst"><code>static void</code></td>
+<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#main(java.lang.String%5B%5D)">main</a></span>&#8203;(java.lang.String[]&nbsp;sa)</code></th>
+<td class="colLast">&nbsp;</td>
+</tr>
+</table>
+<ul class="blockList">
+<li class="blockList"><a id="methods.inherited.from.class.java.lang.Object">
+<!--   -->
+</a>
+<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
+<code>equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
+</ul>
+</li>
+</ul>
+</section>
+</li>
+</ul>
+</div>
+<div class="details">
+<ul class="blockList">
+<li class="blockList">
+<!-- ============ FIELD DETAIL =========== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="field.detail">
+<!--   -->
+</a>
+<h3>Field Detail</h3>
+<a id="LS">
+<!--   -->
+</a>
+<ul class="blockListLast">
+<li class="blockList">
+<h4>LS</h4>
+<pre>public static final&nbsp;java.lang.String LS</pre>
+</li>
+</ul>
+</li>
+</ul>
+</section>
+<!-- ========= CONSTRUCTOR DETAIL ======== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="constructor.detail">
+<!--   -->
+</a>
+<h3>Constructor Detail</h3>
+<a id="&lt;init&gt;()">
+<!--   -->
+</a>
+<ul class="blockListLast">
+<li class="blockList">
+<h4>SqlToolSprayer</h4>
+<pre>public&nbsp;SqlToolSprayer()</pre>
+</li>
+</ul>
+</li>
+</ul>
+</section>
+<!-- ============ METHOD DETAIL ========== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="method.detail">
+<!--   -->
+</a>
+<h3>Method Detail</h3>
+<a id="main(java.lang.String[])">
+<!--   -->
+</a>
+<ul class="blockListLast">
+<li class="blockList">
+<h4>main</h4>
+<pre class="methodSignature">public static&nbsp;void&nbsp;main&#8203;(java.lang.String[]&nbsp;sa)</pre>
+</li>
+</ul>
+</li>
+</ul>
+</section>
+</li>
+</ul>
+</div>
+</div>
+</main>
+<!-- ========= END OF CLASS DATA ========= -->
+<footer role="contentinfo">
+<nav role="navigation">
+<!-- ======= START OF BOTTOM NAVBAR ====== -->
+<div class="bottomNav"><a id="navbar.bottom">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.bottom.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../module-summary.html">Module</a></li>
+<li><a href="package-summary.html">Package</a></li>
+<li class="navBarCell1Rev">Class</li>
+<li><a href="class-use/SqlToolSprayer.html">Use</a></li>
+<li><a href="package-tree.html">Tree</a></li>
+<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../index-all.html">Index</a></li>
+<li><a href="../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_bottom">
+<li><a href="../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_bottom");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<div>
+<ul class="subNavList">
+<li>Summary:&nbsp;</li>
+<li>Nested&nbsp;|&nbsp;</li>
+<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
+<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
+<li><a href="#method.summary">Method</a></li>
+</ul>
+<ul class="subNavList">
+<li>Detail:&nbsp;</li>
+<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
+<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
+<li><a href="#method.detail">Method</a></li>
+</ul>
+</div>
+<a id="skip.navbar.bottom">
+<!--   -->
+</a></div>
+<!-- ======== END OF BOTTOM NAVBAR ======= -->
+</nav>
+<p class="legalCopy"><small><i>Copyright © 2001 - 2022 HSQL Development Group.</i></small></p>
+</footer>
+</body>
+</html>
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.SqlToolException.html 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.SqlToolException.html
--- 2.6.1-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.SqlToolException.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.SqlToolException.html	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,253 @@
+<!DOCTYPE HTML>
+<!-- NewPage -->
+<html lang="en">
+<head>
+<!-- Generated by javadoc (11.0.14.1) on Tue Jul 26 22:23:00 BST 2022 -->
+<title>SqlTool.SqlToolException (HSQLDB 2.7.0 API)</title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+<meta name="dc.created" content="2022-07-26">
+<link rel="stylesheet" type="text/css" href="../../../../javadoc.css" title="Style">
+<link rel="stylesheet" type="text/css" href="../../../../jquery/jquery-ui.css" title="Style">
+<script type="text/javascript" src="../../../../script.js"></script>
+<script type="text/javascript" src="../../../../jquery/jszip/dist/jszip.min.js"></script>
+<script type="text/javascript" src="../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
+<!--[if IE]>
+<script type="text/javascript" src="../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
+<![endif]-->
+<script type="text/javascript" src="../../../../jquery/jquery-3.5.1.js"></script>
+<script type="text/javascript" src="../../../../jquery/jquery-ui.js"></script>
+</head>
+<body>
+<script type="text/javascript"><!--
+    try {
+        if (location.href.indexOf('is-external=true') == -1) {
+            parent.document.title="SqlTool.SqlToolException (HSQLDB 2.7.0 API)";
+        }
+    }
+    catch(err) {
+    }
+//-->
+var pathtoroot = "../../../../";
+var useModuleDirectories = true;
+loadScripts(document, 'script');</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+<header role="banner">
+<nav role="navigation">
+<div class="fixedNav">
+<!-- ========= START OF TOP NAVBAR ======= -->
+<div class="topNav"><a id="navbar.top">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.top.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../module-summary.html">Module</a></li>
+<li><a href="package-summary.html">Package</a></li>
+<li class="navBarCell1Rev">Class</li>
+<li><a href="class-use/SqlTool.SqlToolException.html">Use</a></li>
+<li><a href="package-tree.html">Tree</a></li>
+<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../index-all.html">Index</a></li>
+<li><a href="../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_top">
+<li><a href="../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<ul class="navListSearch">
+<li><label for="search">SEARCH:</label>
+<input type="text" id="search" value="search" disabled="disabled">
+<input type="reset" id="reset" value="reset" disabled="disabled">
+</li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_top");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<div>
+<ul class="subNavList">
+<li>Summary:&nbsp;</li>
+<li>Nested&nbsp;|&nbsp;</li>
+<li>Field&nbsp;|&nbsp;</li>
+<li>Constr&nbsp;|&nbsp;</li>
+<li><a href="#method.summary">Method</a></li>
+</ul>
+<ul class="subNavList">
+<li>Detail:&nbsp;</li>
+<li>Field&nbsp;|&nbsp;</li>
+<li>Constr&nbsp;|&nbsp;</li>
+<li>Method</li>
+</ul>
+</div>
+<a id="skip.navbar.top">
+<!--   -->
+</a></div>
+<!-- ========= END OF TOP NAVBAR ========= -->
+</div>
+<div class="navPadding">&nbsp;</div>
+<script type="text/javascript"><!--
+$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
+//-->
+</script>
+</nav>
+</header>
+<!-- ======== START OF CLASS DATA ======== -->
+<main role="main">
+<div class="header">
+<div class="subTitle"><span class="moduleLabelInType">Module</span>&nbsp;<a href="../../../module-summary.html">org.hsqldb.sqltool</a></div>
+<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">org.hsqldb.cmdline</a></div>
+<h2 title="Class SqlTool.SqlToolException" class="title">Class SqlTool.SqlToolException</h2>
+</div>
+<div class="contentContainer">
+<ul class="inheritance">
+<li>java.lang.Object</li>
+<li>
+<ul class="inheritance">
+<li>java.lang.Throwable</li>
+<li>
+<ul class="inheritance">
+<li>java.lang.Exception</li>
+<li>
+<ul class="inheritance">
+<li>org.hsqldb.cmdline.SqlTool.SqlToolException</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+<div class="description">
+<ul class="blockList">
+<li class="blockList">
+<dl>
+<dt>All Implemented Interfaces:</dt>
+<dd><code>java.io.Serializable</code></dd>
+</dl>
+<dl>
+<dt>Enclosing class:</dt>
+<dd><a href="SqlTool.html" title="class in org.hsqldb.cmdline">SqlTool</a></dd>
+</dl>
+<hr>
+<pre>public static class <span class="typeNameLabel">SqlTool.SqlToolException</span>
+extends java.lang.Exception</pre>
+<dl>
+<dt><span class="seeLabel">See Also:</span></dt>
+<dd><a href="../../../../serialized-form.html#org.hsqldb.cmdline.SqlTool.SqlToolException">Serialized Form</a></dd>
+</dl>
+</li>
+</ul>
+</div>
+<div class="summary">
+<ul class="blockList">
+<li class="blockList">
+<!-- ========== METHOD SUMMARY =========== -->
+<section role="region">
+<ul class="blockList">
+<li class="blockList"><a id="method.summary">
+<!--   -->
+</a>
+<h3>Method Summary</h3>
+<ul class="blockList">
+<li class="blockList"><a id="methods.inherited.from.class.java.lang.Throwable">
+<!--   -->
+</a>
+<h3>Methods inherited from class&nbsp;java.lang.Throwable</h3>
+<code>addSuppressed, fillInStackTrace, getCause, getLocalizedMessage, getMessage, getStackTrace, getSuppressed, initCause, printStackTrace, printStackTrace, printStackTrace, setStackTrace, toString</code></li>
+</ul>
+<ul class="blockList">
+<li class="blockList"><a id="methods.inherited.from.class.java.lang.Object">
+<!--   -->
+</a>
+<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
+<code>equals, getClass, hashCode, notify, notifyAll, wait, wait, wait</code></li>
+</ul>
+</li>
+</ul>
+</section>
+</li>
+</ul>
+</div>
+</div>
+</main>
+<!-- ========= END OF CLASS DATA ========= -->
+<footer role="contentinfo">
+<nav role="navigation">
+<!-- ======= START OF BOTTOM NAVBAR ====== -->
+<div class="bottomNav"><a id="navbar.bottom">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.bottom.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="../../../module-summary.html">Module</a></li>
+<li><a href="package-summary.html">Package</a></li>
+<li class="navBarCell1Rev">Class</li>
+<li><a href="class-use/SqlTool.SqlToolException.html">Use</a></li>
+<li><a href="package-tree.html">Tree</a></li>
+<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
+<li><a href="../../../../index-all.html">Index</a></li>
+<li><a href="../../../../help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_bottom">
+<li><a href="../../../../allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_bottom");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<div>
+<ul class="subNavList">
+<li>Summary:&nbsp;</li>
+<li>Nested&nbsp;|&nbsp;</li>
+<li>Field&nbsp;|&nbsp;</li>
+<li>Constr&nbsp;|&nbsp;</li>
+<li><a href="#method.summary">Method</a></li>
+</ul>
+<ul class="subNavList">
+<li>Detail:&nbsp;</li>
+<li>Field&nbsp;|&nbsp;</li>
+<li>Constr&nbsp;|&nbsp;</li>
+<li>Method</li>
+</ul>
+</div>
+<a id="skip.navbar.bottom">
+<!--   -->
+</a></div>
+<!-- ======== END OF BOTTOM NAVBAR ======= -->
+</nav>
+<p class="legalCopy"><small><i>Copyright © 2001 - 2022 HSQL Development Group.</i></small></p>
+</footer>
+</body>
+</html>
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/overview-tree.html 2.7.0-1/hsqldb/doc/apidocssqltool/overview-tree.html
--- 2.6.1-1/hsqldb/doc/apidocssqltool/overview-tree.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/overview-tree.html	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,195 @@
+<!DOCTYPE HTML>
+<!-- NewPage -->
+<html lang="en">
+<head>
+<!-- Generated by javadoc (11.0.14.1) on Tue Jul 26 22:23:00 BST 2022 -->
+<title>Class Hierarchy (HSQLDB 2.7.0 API)</title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+<meta name="dc.created" content="2022-07-26">
+<link rel="stylesheet" type="text/css" href="javadoc.css" title="Style">
+<link rel="stylesheet" type="text/css" href="jquery/jquery-ui.css" title="Style">
+<script type="text/javascript" src="script.js"></script>
+<script type="text/javascript" src="jquery/jszip/dist/jszip.min.js"></script>
+<script type="text/javascript" src="jquery/jszip-utils/dist/jszip-utils.min.js"></script>
+<!--[if IE]>
+<script type="text/javascript" src="jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
+<![endif]-->
+<script type="text/javascript" src="jquery/jquery-3.5.1.js"></script>
+<script type="text/javascript" src="jquery/jquery-ui.js"></script>
+</head>
+<body>
+<script type="text/javascript"><!--
+    try {
+        if (location.href.indexOf('is-external=true') == -1) {
+            parent.document.title="Class Hierarchy (HSQLDB 2.7.0 API)";
+        }
+    }
+    catch(err) {
+    }
+//-->
+var pathtoroot = "./";
+var useModuleDirectories = true;
+loadScripts(document, 'script');</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+<header role="banner">
+<nav role="navigation">
+<div class="fixedNav">
+<!-- ========= START OF TOP NAVBAR ======= -->
+<div class="topNav"><a id="navbar.top">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.top.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li>Module</li>
+<li>Package</li>
+<li>Class</li>
+<li>Use</li>
+<li class="navBarCell1Rev">Tree</li>
+<li><a href="deprecated-list.html">Deprecated</a></li>
+<li><a href="index-all.html">Index</a></li>
+<li><a href="help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_top">
+<li><a href="allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<ul class="navListSearch">
+<li><label for="search">SEARCH:</label>
+<input type="text" id="search" value="search" disabled="disabled">
+<input type="reset" id="reset" value="reset" disabled="disabled">
+</li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_top");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.top">
+<!--   -->
+</a></div>
+<!-- ========= END OF TOP NAVBAR ========= -->
+</div>
+<div class="navPadding">&nbsp;</div>
+<script type="text/javascript"><!--
+$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
+//-->
+</script>
+</nav>
+</header>
+<main role="main">
+<div class="header">
+<h1 class="title">Hierarchy For All Packages</h1>
+<span class="packageHierarchyLabel">Package Hierarchies:</span>
+<ul class="horizontal">
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-tree.html">org.hsqldb.cmdline</a></li>
+</ul>
+</div>
+<div class="contentContainer">
+<section role="region">
+<h2 title="Class Hierarchy">Class Hierarchy</h2>
+<ul>
+<li class="circle">java.lang.Object
+<ul>
+<li class="circle">org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.html" title="class in org.hsqldb.cmdline"><span class="typeNameLink">SqlFile</span></a></li>
+<li class="circle">org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.html" title="class in org.hsqldb.cmdline"><span class="typeNameLink">SqlTool</span></a></li>
+<li class="circle">org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolSprayer.html" title="class in org.hsqldb.cmdline"><span class="typeNameLink">SqlToolSprayer</span></a></li>
+<li class="circle">java.lang.Throwable (implements java.io.Serializable)
+<ul>
+<li class="circle">java.lang.Exception
+<ul>
+<li class="circle">org.hsqldb.cmdline.libclone.AppendableException
+<ul>
+<li class="circle">org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.BadSpecial.html" title="class in org.hsqldb.cmdline"><span class="typeNameLink">SqlFile.BadSpecial</span></a></li>
+<li class="circle">org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolError.html" title="class in org.hsqldb.cmdline"><span class="typeNameLink">SqlToolError</span></a></li>
+</ul>
+</li>
+<li class="circle">org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.SqlToolException.html" title="class in org.hsqldb.cmdline"><span class="typeNameLink">SqlTool.SqlToolException</span></a></li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</section>
+<section role="region">
+<h2 title="Enum Hierarchy">Enum Hierarchy</h2>
+<ul>
+<li class="circle">java.lang.Object
+<ul>
+<li class="circle">java.lang.Enum&lt;E&gt; (implements java.lang.Comparable&lt;T&gt;, java.io.Serializable)
+<ul>
+<li class="circle">org.hsqldb.cmdline.<a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqltoolRB.html" title="enum in org.hsqldb.cmdline"><span class="typeNameLink">SqltoolRB</span></a> (implements org.hsqldb.cmdline.libclone.RefCapableRBInterface)</li>
+</ul>
+</li>
+</ul>
+</li>
+</ul>
+</section>
+</div>
+</main>
+<footer role="contentinfo">
+<nav role="navigation">
+<!-- ======= START OF BOTTOM NAVBAR ====== -->
+<div class="bottomNav"><a id="navbar.bottom">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.bottom.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li>Module</li>
+<li>Package</li>
+<li>Class</li>
+<li>Use</li>
+<li class="navBarCell1Rev">Tree</li>
+<li><a href="deprecated-list.html">Deprecated</a></li>
+<li><a href="index-all.html">Index</a></li>
+<li><a href="help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_bottom">
+<li><a href="allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_bottom");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.bottom">
+<!--   -->
+</a></div>
+<!-- ======== END OF BOTTOM NAVBAR ======= -->
+</nav>
+<p class="legalCopy"><small><i>Copyright © 2001 - 2022 HSQL Development Group.</i></small></p>
+</footer>
+</body>
+</html>
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/package-search-index.js 2.7.0-1/hsqldb/doc/apidocssqltool/package-search-index.js
--- 2.6.1-1/hsqldb/doc/apidocssqltool/package-search-index.js	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/package-search-index.js	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1 @@
+packageSearchIndex = [{"l":"All Packages","url":"allpackages-index.html"},{"m":"org.hsqldb.sqltool","l":"org.hsqldb.cmdline"}]
\ No newline at end of file
Binary files 2.6.1-1/hsqldb/doc/apidocssqltool/resources/glass.png and 2.7.0-1/hsqldb/doc/apidocssqltool/resources/glass.png differ
Binary files 2.6.1-1/hsqldb/doc/apidocssqltool/resources/x.png and 2.7.0-1/hsqldb/doc/apidocssqltool/resources/x.png differ
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/script.js 2.7.0-1/hsqldb/doc/apidocssqltool/script.js
--- 2.6.1-1/hsqldb/doc/apidocssqltool/script.js	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/script.js	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,149 @@
+/*
+ * Copyright (c) 2013, 2018, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.  Oracle designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+var moduleSearchIndex;
+var packageSearchIndex;
+var typeSearchIndex;
+var memberSearchIndex;
+var tagSearchIndex;
+function loadScripts(doc, tag) {
+    createElem(doc, tag, 'jquery/jszip/dist/jszip.js');
+    createElem(doc, tag, 'jquery/jszip-utils/dist/jszip-utils.js');
+    if (window.navigator.userAgent.indexOf('MSIE ') > 0 || window.navigator.userAgent.indexOf('Trident/') > 0 ||
+            window.navigator.userAgent.indexOf('Edge/') > 0) {
+        createElem(doc, tag, 'jquery/jszip-utils/dist/jszip-utils-ie.js');
+    }
+    createElem(doc, tag, 'search.js');
+
+    $.get(pathtoroot + "module-search-index.zip")
+            .done(function() {
+                JSZipUtils.getBinaryContent(pathtoroot + "module-search-index.zip", function(e, data) {
+                    JSZip.loadAsync(data).then(function(zip){
+                        zip.file("module-search-index.json").async("text").then(function(content){
+                            moduleSearchIndex = JSON.parse(content);
+                        });
+                    });
+                });
+            });
+    $.get(pathtoroot + "package-search-index.zip")
+            .done(function() {
+                JSZipUtils.getBinaryContent(pathtoroot + "package-search-index.zip", function(e, data) {
+                    JSZip.loadAsync(data).then(function(zip){
+                        zip.file("package-search-index.json").async("text").then(function(content){
+                            packageSearchIndex = JSON.parse(content);
+                        });
+                    });
+                });
+            });
+    $.get(pathtoroot + "type-search-index.zip")
+            .done(function() {
+                JSZipUtils.getBinaryContent(pathtoroot + "type-search-index.zip", function(e, data) {
+                    JSZip.loadAsync(data).then(function(zip){
+                        zip.file("type-search-index.json").async("text").then(function(content){
+                            typeSearchIndex = JSON.parse(content);
+                        });
+                    });
+                });
+            });
+    $.get(pathtoroot + "member-search-index.zip")
+            .done(function() {
+                JSZipUtils.getBinaryContent(pathtoroot + "member-search-index.zip", function(e, data) {
+                    JSZip.loadAsync(data).then(function(zip){
+                        zip.file("member-search-index.json").async("text").then(function(content){
+                            memberSearchIndex = JSON.parse(content);
+                        });
+                    });
+                });
+            });
+    $.get(pathtoroot + "tag-search-index.zip")
+            .done(function() {
+                JSZipUtils.getBinaryContent(pathtoroot + "tag-search-index.zip", function(e, data) {
+                    JSZip.loadAsync(data).then(function(zip){
+                        zip.file("tag-search-index.json").async("text").then(function(content){
+                            tagSearchIndex = JSON.parse(content);
+                        });
+                    });
+                });
+            });
+    if (!moduleSearchIndex) {
+        createElem(doc, tag, 'module-search-index.js');
+    }
+    if (!packageSearchIndex) {
+        createElem(doc, tag, 'package-search-index.js');
+    }
+    if (!typeSearchIndex) {
+        createElem(doc, tag, 'type-search-index.js');
+    }
+    if (!memberSearchIndex) {
+        createElem(doc, tag, 'member-search-index.js');
+    }
+    if (!tagSearchIndex) {
+        createElem(doc, tag, 'tag-search-index.js');
+    }
+    $(window).resize(function() {
+        $('.navPadding').css('padding-top', $('.fixedNav').css("height"));
+    });
+}
+
+function createElem(doc, tag, path) {
+    var script = doc.createElement(tag);
+    var scriptElement = doc.getElementsByTagName(tag)[0];
+    script.src = pathtoroot + path;
+    scriptElement.parentNode.insertBefore(script, scriptElement);
+}
+
+function show(type) {
+    count = 0;
+    for (var key in data) {
+        var row = document.getElementById(key);
+        if ((data[key] &  type) !== 0) {
+            row.style.display = '';
+            row.className = (count++ % 2) ? rowColor : altColor;
+        }
+        else
+            row.style.display = 'none';
+    }
+    updateTabs(type);
+}
+
+function updateTabs(type) {
+    for (var value in tabs) {
+        var sNode = document.getElementById(tabs[value][0]);
+        var spanNode = sNode.firstChild;
+        if (value == type) {
+            sNode.className = activeTableTab;
+            spanNode.innerHTML = tabs[value][1];
+        }
+        else {
+            sNode.className = tableTab;
+            spanNode.innerHTML = "<a href=\"javascript:show("+ value + ");\">" + tabs[value][1] + "</a>";
+        }
+    }
+}
+
+function updateModuleFrame(pFrame, cFrame) {
+    top.packageFrame.location = pFrame;
+    top.classFrame.location = cFrame;
+}
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/search.js 2.7.0-1/hsqldb/doc/apidocssqltool/search.js
--- 2.6.1-1/hsqldb/doc/apidocssqltool/search.js	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/search.js	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,326 @@
+/*
+ * Copyright (c) 2015, 2018, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.  Oracle designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+var noResult = {l: "No results found"};
+var catModules = "Modules";
+var catPackages = "Packages";
+var catTypes = "Types";
+var catMembers = "Members";
+var catSearchTags = "SearchTags";
+var highlight = "<span class=\"resultHighlight\">$&</span>";
+var camelCaseRegexp = "";
+var secondaryMatcher = "";
+function getHighlightedText(item) {
+    var ccMatcher = new RegExp(camelCaseRegexp);
+    var label = item.replace(ccMatcher, highlight);
+    if (label === item) {
+        label = item.replace(secondaryMatcher, highlight);
+    }
+    return label;
+}
+function getURLPrefix(ui) {
+    var urlPrefix="";
+    if (useModuleDirectories) {
+        var slash = "/";
+        if (ui.item.category === catModules) {
+            return ui.item.l + slash;
+        } else if (ui.item.category === catPackages && ui.item.m) {
+            return ui.item.m + slash;
+        } else if ((ui.item.category === catTypes && ui.item.p) || ui.item.category === catMembers) {
+            $.each(packageSearchIndex, function(index, item) {
+                if (ui.item.p == item.l) {
+                    urlPrefix = item.m + slash;
+                }
+            });
+            return urlPrefix;
+        } else {
+            return urlPrefix;
+        }
+    }
+    return urlPrefix;
+}
+var watermark = 'Search';
+$(function() {
+    $("#search").val('');
+    $("#search").prop("disabled", false);
+    $("#reset").prop("disabled", false);
+    $("#search").val(watermark).addClass('watermark');
+    $("#search").blur(function() {
+        if ($(this).val().length == 0) {
+            $(this).val(watermark).addClass('watermark');
+        }
+    });
+    $("#search").on('click keydown', function() {
+        if ($(this).val() == watermark) {
+            $(this).val('').removeClass('watermark');
+        }
+    });
+    $("#reset").click(function() {
+        $("#search").val('');
+        $("#search").focus();
+    });
+    $("#search").focus();
+    $("#search")[0].setSelectionRange(0, 0);
+});
+$.widget("custom.catcomplete", $.ui.autocomplete, {
+    _create: function() {
+        this._super();
+        this.widget().menu("option", "items", "> :not(.ui-autocomplete-category)");
+    },
+    _renderMenu: function(ul, items) {
+        var rMenu = this,
+                currentCategory = "";
+        rMenu.menu.bindings = $();
+        $.each(items, function(index, item) {
+            var li;
+            if (item.l !== noResult.l && item.category !== currentCategory) {
+                ul.append("<li class=\"ui-autocomplete-category\">" + item.category + "</li>");
+                currentCategory = item.category;
+            }
+            li = rMenu._renderItemData(ul, item);
+            if (item.category) {
+                li.attr("aria-label", item.category + " : " + item.l);
+                li.attr("class", "resultItem");
+            } else {
+                li.attr("aria-label", item.l);
+                li.attr("class", "resultItem");
+            }
+        });
+    },
+    _renderItem: function(ul, item) {
+        var label = "";
+        if (item.category === catModules) {
+            label = getHighlightedText(item.l);
+        } else if (item.category === catPackages) {
+            label = (item.m)
+                    ? getHighlightedText(item.m + "/" + item.l)
+                    : getHighlightedText(item.l);
+        } else if (item.category === catTypes) {
+            label = (item.p)
+                    ? getHighlightedText(item.p + "." + item.l)
+                    : getHighlightedText(item.l);
+        } else if (item.category === catMembers) {
+            label = getHighlightedText(item.p + "." + (item.c + "." + item.l));
+        } else if (item.category === catSearchTags) {
+            label = getHighlightedText(item.l);
+        } else {
+            label = item.l;
+        }
+        var li = $("<li/>").appendTo(ul);
+        var div = $("<div/>").appendTo(li);
+        if (item.category === catSearchTags) {
+            if (item.d) {
+                div.html(label + "<span class=\"searchTagHolderResult\"> (" + item.h + ")</span><br><span class=\"searchTagDescResult\">"
+                                + item.d + "</span><br>");
+            } else {
+                div.html(label + "<span class=\"searchTagHolderResult\"> (" + item.h + ")</span>");
+            }
+        } else {
+            div.html(label);
+        }
+        return li;
+    }
+});
+$(function() {
+    $("#search").catcomplete({
+        minLength: 1,
+        delay: 100,
+        source: function(request, response) {
+            var result = new Array();
+            var presult = new Array();
+            var tresult = new Array();
+            var mresult = new Array();
+            var tgresult = new Array();
+            var secondaryresult = new Array();
+            var displayCount = 0;
+            var exactMatcher = new RegExp("^" + $.ui.autocomplete.escapeRegex(request.term) + "$", "i");
+            camelCaseRegexp = ($.ui.autocomplete.escapeRegex(request.term)).split(/(?=[A-Z])/).join("([a-z0-9_$]*?)");
+            var camelCaseMatcher = new RegExp("^" + camelCaseRegexp);
+            secondaryMatcher = new RegExp($.ui.autocomplete.escapeRegex(request.term), "i");
+
+            // Return the nested innermost name from the specified object
+            function nestedName(e) {
+                return e.l.substring(e.l.lastIndexOf(".") + 1);
+            }
+
+            function concatResults(a1, a2) {
+                a1 = a1.concat(a2);
+                a2.length = 0;
+                return a1;
+            }
+
+            if (moduleSearchIndex) {
+                var mdleCount = 0;
+                $.each(moduleSearchIndex, function(index, item) {
+                    item.category = catModules;
+                    if (exactMatcher.test(item.l)) {
+                        result.push(item);
+                        mdleCount++;
+                    } else if (camelCaseMatcher.test(item.l)) {
+                        result.push(item);
+                    } else if (secondaryMatcher.test(item.l)) {
+                        secondaryresult.push(item);
+                    }
+                });
+                displayCount = mdleCount;
+                result = concatResults(result, secondaryresult);
+            }
+            if (packageSearchIndex) {
+                var pCount = 0;
+                var pkg = "";
+                $.each(packageSearchIndex, function(index, item) {
+                    item.category = catPackages;
+                    pkg = (item.m)
+                            ? (item.m + "/" + item.l)
+                            : item.l;
+                    if (exactMatcher.test(item.l)) {
+                        presult.push(item);
+                        pCount++;
+                    } else if (camelCaseMatcher.test(pkg)) {
+                        presult.push(item);
+                    } else if (secondaryMatcher.test(pkg)) {
+                        secondaryresult.push(item);
+                    }
+                });
+                result = result.concat(concatResults(presult, secondaryresult));
+                displayCount = (pCount > displayCount) ? pCount : displayCount;
+            }
+            if (typeSearchIndex) {
+                var tCount = 0;
+                $.each(typeSearchIndex, function(index, item) {
+                    item.category = catTypes;
+                    var s = nestedName(item);
+                    if (exactMatcher.test(s)) {
+                        tresult.push(item);
+                        tCount++;
+                    } else if (camelCaseMatcher.test(s)) {
+                        tresult.push(item);
+                    } else if (secondaryMatcher.test(item.p + "." + item.l)) {
+                        secondaryresult.push(item);
+                    }
+                });
+                result = result.concat(concatResults(tresult, secondaryresult));
+                displayCount = (tCount > displayCount) ? tCount : displayCount;
+            }
+            if (memberSearchIndex) {
+                var mCount = 0;
+                $.each(memberSearchIndex, function(index, item) {
+                    item.category = catMembers;
+                    var s = nestedName(item);
+                    if (exactMatcher.test(s)) {
+                        mresult.push(item);
+                        mCount++;
+                    } else if (camelCaseMatcher.test(s)) {
+                        mresult.push(item);
+                    } else if (secondaryMatcher.test(item.c + "." + item.l)) {
+                        secondaryresult.push(item);
+                    }
+                });
+                result = result.concat(concatResults(mresult, secondaryresult));
+                displayCount = (mCount > displayCount) ? mCount : displayCount;
+            }
+            if (tagSearchIndex) {
+                var tgCount = 0;
+                $.each(tagSearchIndex, function(index, item) {
+                    item.category = catSearchTags;
+                    if (exactMatcher.test(item.l)) {
+                        tgresult.push(item);
+                        tgCount++;
+                    } else if (secondaryMatcher.test(item.l)) {
+                        secondaryresult.push(item);
+                    }
+                });
+                result = result.concat(concatResults(tgresult, secondaryresult));
+                displayCount = (tgCount > displayCount) ? tgCount : displayCount;
+            }
+            displayCount = (displayCount > 500) ? displayCount : 500;
+            var counter = function() {
+                var count = {Modules: 0, Packages: 0, Types: 0, Members: 0, SearchTags: 0};
+                var f = function(item) {
+                    count[item.category] += 1;
+                    return (count[item.category] <= displayCount);
+                };
+                return f;
+            }();
+            response(result.filter(counter));
+        },
+        response: function(event, ui) {
+            if (!ui.content.length) {
+                ui.content.push(noResult);
+            } else {
+                $("#search").empty();
+            }
+        },
+        autoFocus: true,
+        position: {
+            collision: "flip"
+        },
+        select: function(event, ui) {
+            if (ui.item.l !== noResult.l) {
+                var url = getURLPrefix(ui);
+                if (ui.item.category === catModules) {
+                    if (useModuleDirectories) {
+                        url += "module-summary.html";
+                    } else {
+                        url = ui.item.l + "-summary.html";
+                    }
+                } else if (ui.item.category === catPackages) {
+                    if (ui.item.url) {
+                        url = ui.item.url;
+                    } else {
+                    url += ui.item.l.replace(/\./g, '/') + "/package-summary.html";
+                    }
+                } else if (ui.item.category === catTypes) {
+                    if (ui.item.url) {
+                        url = ui.item.url;
+                    } else if (ui.item.p === "<Unnamed>") {
+                        url += ui.item.l + ".html";
+                    } else {
+                        url += ui.item.p.replace(/\./g, '/') + "/" + ui.item.l + ".html";
+                    }
+                } else if (ui.item.category === catMembers) {
+                    if (ui.item.p === "<Unnamed>") {
+                        url += ui.item.c + ".html" + "#";
+                    } else {
+                        url += ui.item.p.replace(/\./g, '/') + "/" + ui.item.c + ".html" + "#";
+                    }
+                    if (ui.item.url) {
+                        url += ui.item.url;
+                    } else {
+                        url += ui.item.l;
+                    }
+                } else if (ui.item.category === catSearchTags) {
+                    url += ui.item.u;
+                }
+                if (top !== window) {
+                    parent.classFrame.location = pathtoroot + url;
+                } else {
+                    window.location.href = pathtoroot + url;
+                }
+                $("#search").focus();
+            }
+        }
+    });
+});
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/serialized-form.html 2.7.0-1/hsqldb/doc/apidocssqltool/serialized-form.html
--- 2.6.1-1/hsqldb/doc/apidocssqltool/serialized-form.html	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/serialized-form.html	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1,197 @@
+<!DOCTYPE HTML>
+<!-- NewPage -->
+<html lang="en">
+<head>
+<!-- Generated by javadoc (11.0.14.1) on Tue Jul 26 22:23:00 BST 2022 -->
+<title>Serialized Form (HSQLDB 2.7.0 API)</title>
+<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
+<meta name="dc.created" content="2022-07-26">
+<link rel="stylesheet" type="text/css" href="javadoc.css" title="Style">
+<link rel="stylesheet" type="text/css" href="jquery/jquery-ui.css" title="Style">
+<script type="text/javascript" src="script.js"></script>
+<script type="text/javascript" src="jquery/jszip/dist/jszip.min.js"></script>
+<script type="text/javascript" src="jquery/jszip-utils/dist/jszip-utils.min.js"></script>
+<!--[if IE]>
+<script type="text/javascript" src="jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
+<![endif]-->
+<script type="text/javascript" src="jquery/jquery-3.5.1.js"></script>
+<script type="text/javascript" src="jquery/jquery-ui.js"></script>
+</head>
+<body>
+<script type="text/javascript"><!--
+    try {
+        if (location.href.indexOf('is-external=true') == -1) {
+            parent.document.title="Serialized Form (HSQLDB 2.7.0 API)";
+        }
+    }
+    catch(err) {
+    }
+//-->
+var pathtoroot = "./";
+var useModuleDirectories = true;
+loadScripts(document, 'script');</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+<header role="banner">
+<nav role="navigation">
+<div class="fixedNav">
+<!-- ========= START OF TOP NAVBAR ======= -->
+<div class="topNav"><a id="navbar.top">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.top.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="org.hsqldb.sqltool/module-summary.html">Module</a></li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-summary.html">Package</a></li>
+<li>Class</li>
+<li>Use</li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-tree.html">Tree</a></li>
+<li><a href="deprecated-list.html">Deprecated</a></li>
+<li><a href="index-all.html">Index</a></li>
+<li><a href="help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_top">
+<li><a href="allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<ul class="navListSearch">
+<li><label for="search">SEARCH:</label>
+<input type="text" id="search" value="search" disabled="disabled">
+<input type="reset" id="reset" value="reset" disabled="disabled">
+</li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_top");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.top">
+<!--   -->
+</a></div>
+<!-- ========= END OF TOP NAVBAR ========= -->
+</div>
+<div class="navPadding">&nbsp;</div>
+<script type="text/javascript"><!--
+$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
+//-->
+</script>
+</nav>
+</header>
+<main role="main">
+<div class="header">
+<h1 title="Serialized Form" class="title">Serialized Form</h1>
+</div>
+<div class="serializedFormContainer">
+<ul class="blockList">
+<li class="blockList">
+<section role="region">
+<h2 title="Package">Package&nbsp;org.hsqldb.cmdline</h2>
+<ul class="blockList">
+<li class="blockList"><a id="org.hsqldb.cmdline.SqlFile.BadSpecial">
+<!--   -->
+</a>
+<h3>Class <a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlFile.BadSpecial.html" title="class in org.hsqldb.cmdline">org.hsqldb.cmdline.SqlFile.BadSpecial</a> extends org.hsqldb.cmdline.libclone.AppendableException implements Serializable</h3>
+<dl class="nameValue">
+<dt>serialVersionUID:</dt>
+<dd>7162440064026570590L</dd>
+</dl>
+</li>
+<li class="blockList"><a id="org.hsqldb.cmdline.SqlTool.SqlToolException">
+<!--   -->
+</a>
+<h3>Class <a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlTool.SqlToolException.html" title="class in org.hsqldb.cmdline">org.hsqldb.cmdline.SqlTool.SqlToolException</a> extends java.lang.Exception implements Serializable</h3>
+<dl class="nameValue">
+<dt>serialVersionUID:</dt>
+<dd>1424909871915188519L</dd>
+</dl>
+<ul class="blockList">
+<li class="blockList">
+<h3>Serialized Fields</h3>
+<ul class="blockList">
+<li class="blockListLast">
+<h4>exitValue</h4>
+<pre>int exitValue</pre>
+</li>
+</ul>
+</li>
+</ul>
+</li>
+<li class="blockList"><a id="org.hsqldb.cmdline.SqlToolError">
+<!--   -->
+</a>
+<h3>Class <a href="org.hsqldb.sqltool/org/hsqldb/cmdline/SqlToolError.html" title="class in org.hsqldb.cmdline">org.hsqldb.cmdline.SqlToolError</a> extends org.hsqldb.cmdline.libclone.AppendableException implements Serializable</h3>
+<dl class="nameValue">
+<dt>serialVersionUID:</dt>
+<dd>1792522673702223649L</dd>
+</dl>
+</li>
+</ul>
+</section>
+</li>
+</ul>
+</div>
+</main>
+<footer role="contentinfo">
+<nav role="navigation">
+<!-- ======= START OF BOTTOM NAVBAR ====== -->
+<div class="bottomNav"><a id="navbar.bottom">
+<!--   -->
+</a>
+<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
+<a id="navbar.bottom.firstrow">
+<!--   -->
+</a>
+<ul class="navList" title="Navigation">
+<li><a href="org.hsqldb.sqltool/module-summary.html">Module</a></li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-summary.html">Package</a></li>
+<li>Class</li>
+<li>Use</li>
+<li><a href="org.hsqldb.sqltool/org/hsqldb/cmdline/package-tree.html">Tree</a></li>
+<li><a href="deprecated-list.html">Deprecated</a></li>
+<li><a href="index-all.html">Index</a></li>
+<li><a href="help-doc.html">Help</a></li>
+</ul>
+</div>
+<div class="subNav">
+<ul class="navList" id="allclasses_navbar_bottom">
+<li><a href="allclasses.html">All&nbsp;Classes</a></li>
+</ul>
+<div>
+<script type="text/javascript"><!--
+  allClassesLink = document.getElementById("allclasses_navbar_bottom");
+  if(window==top) {
+    allClassesLink.style.display = "block";
+  }
+  else {
+    allClassesLink.style.display = "none";
+  }
+  //-->
+</script>
+<noscript>
+<div>JavaScript is disabled on your browser.</div>
+</noscript>
+</div>
+<a id="skip.navbar.bottom">
+<!--   -->
+</a></div>
+<!-- ======== END OF BOTTOM NAVBAR ======= -->
+</nav>
+<p class="legalCopy"><small><i>Copyright © 2001 - 2022 HSQL Development Group.</i></small></p>
+</footer>
+</body>
+</html>
diff -pruN 2.6.1-1/hsqldb/doc/apidocssqltool/type-search-index.js 2.7.0-1/hsqldb/doc/apidocssqltool/type-search-index.js
--- 2.6.1-1/hsqldb/doc/apidocssqltool/type-search-index.js	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/apidocssqltool/type-search-index.js	2022-07-26 20:23:02.000000000 +0000
@@ -0,0 +1 @@
+typeSearchIndex = [{"l":"All Classes","url":"allclasses-index.html"},{"p":"org.hsqldb.cmdline","l":"SqlFile.BadSpecial"},{"p":"org.hsqldb.cmdline","l":"SqlFile"},{"p":"org.hsqldb.cmdline","l":"SqlTool"},{"p":"org.hsqldb.cmdline","l":"SqlToolError"},{"p":"org.hsqldb.cmdline","l":"SqlTool.SqlToolException"},{"p":"org.hsqldb.cmdline","l":"SqltoolRB"},{"p":"org.hsqldb.cmdline","l":"SqlToolSprayer"}]
\ No newline at end of file
diff -pruN 2.6.1-1/hsqldb/doc/changelist_2_0.txt 2.7.0-1/hsqldb/doc/changelist_2_0.txt
--- 2.6.1-1/hsqldb/doc/changelist_2_0.txt	2021-10-20 09:34:48.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/changelist_2_0.txt	2022-07-26 20:22:38.000000000 +0000
@@ -1,3 +1,20 @@
+30 May 2022 - version 2.7.0
+-- version 2.7.0 jar requires JRE 11 or later - tested up to Java 17
+-- version 2.7.0 alternative jar requires JRE 8 or later
+-- added support for JSON constructor functions
+-- added support for microsecond precision CURRENT_TIMESTAMP and similar functions
+-- added support for GRANT and REVOKE on all objects in a schema
+-- added support for CSV file data import and export
+-- added support for regional time zones such as 'America/New_York' in conversions
+-- added SET DATABASE SQL MAX RECURSIVE (sql.max_recursive) setting
+-- changed the default for SET DATABASE SQL SYS INDEX NAMES (sql.sys_index_names) to true
+-- changed the properties reported by JDBC DatabaseMetaDat::getClientInfoProperties() method
+-- improved  JDBC DatabaseMetaDat::getTablePrivileges() method to cover fine-grained privileges
+-- improved error messages for SQL settings statements
+-- improved documentation
+-- added some minor enhancements
+-- fixed a number of reported regressions and bugs (see tracker)
+
 21 October 2021 - version 2.6.1
 -- version 2.6.1 is a bug fix release
 -- added sql.lowercase_ident property for extra compatibility with PostgreSQL and MySQL unquoted identifier names
diff -pruN 2.6.1-1/hsqldb/doc/guide/accesscontrol-chapt.html 2.7.0-1/hsqldb/doc/guide/accesscontrol-chapt.html
--- 2.6.1-1/hsqldb/doc/guide/accesscontrol-chapt.html	2021-10-20 09:33:34.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/guide/accesscontrol-chapt.html	2022-07-26 20:21:48.000000000 +0000
@@ -48,8 +48,8 @@
 </div>
 <div>
 <div class="legalnotice">
-<a name="N14029"></a>
-<p>Copyright 2010-2021 Fred Toussi. Permission is granted to
+<a name="N14140"></a>
+<p>Copyright 2010-2022 Fred Toussi. Permission is granted to
       distribute this document without any alteration under the terms of the
       HSQLDB license. Additional permission is granted to the HSQL Development
       Group to distribute this document with or without alterations under the
@@ -57,7 +57,7 @@
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -84,6 +84,9 @@
 <span class="section"><a href="accesscontrol-chapt.html#acc_access_rights">Access Rights</a></span>
 </dt>
 <dt>
+<span class="section"><a href="accesscontrol-chapt.html#N1425C">Simple Access Control</a></span>
+</dt>
+<dt>
 <span class="section"><a href="accesscontrol-chapt.html#acc_fine_grained_access">Fine-Grained Data Access Control</a></span>
 </dt>
 </dl>
@@ -103,24 +106,27 @@
 </div>
 </div>
 </div>
-<p>This chapter is about access control to database objects such as
-    tables, inside the database engine. Other issues related to security
-    include user authentication, password complexity and secure connections
+<p>This chapter is about controlling access to database objects such as
+    tables and routines. Other topics related to security include user
+    authentication, password complexity and secure connections. These topics
     are covered in the <a class="link" href="management-chapt.html" title="Chapter&nbsp;11.&nbsp;System Management">System Management</a> chapter and the <a class="link" href="listeners-chapt.html" title="Chapter&nbsp;15.&nbsp;HyperSQL Network Listeners (Servers)">HyperSQL Network Listeners
     (Servers)</a> chapter.</p>
 <p>Apart from schemas and their object, each HyperSQL catalog has USER
     and ROLE objects. These objects are collectively called
     <span class="emphasis"><em>authorizations</em></span>. Each AUTHORIZATION has some access
-    rights on some of the schemas or the objects they contain. The persistent
-    elements of an SQL environment are database objects</p>
-<p>Authorization names are stored in the database in the case-normal
-    form. When connecting to a database via JDBC, the user name and password
-    must match the case of this case-normal form.</p>
-<p>When a user is created with the CREATE USER statement, if the user
-    name is enclosed in double quotes, the exact name is used as the
-    case-normal form. But if it is not enclosed in double quotes, the name is
-    converted to uppercase and this uppercase version is stored in the
-    database as the case-normal form.</p>
+    rights on some of the schemas and the database objects such as tables and
+    routines contained in those schemas.</p>
+<p>Authorization names are stored in the database in case-normal form.
+    When a user is created with the CREATE USER statement, if the user name is
+    enclosed in double quotes, the exact name is used as the case-normal form.
+    But if it is not enclosed in double quotes, the name is converted to
+    uppercase and this uppercase version is stored in the database as the
+    case-normal form. When connecting to a database via JDBC, the user name
+    and password must match the case of the stored form.</p>
+<p>Each database has at least one admin user. When the first connection
+    to a non-existent database is made, the admin user is created with the the
+    user name for the connection. The user name <code class="literal">SA</code> is
+    suggested in the documentation but you can use any name.</p>
 </div>
 <div class="section">
 <div class="titlepage">
@@ -131,41 +137,45 @@
 </div>
 </div>
 </div>
+<a name="N14162" class="indexterm"></a>
 <p>In general, ROLE and USER objects simply control access to schema
-    objects. This is the scope of the SQL Standard. However, there are special
-    roles that allow the creation of USER and ROLE objects and also allow some
-    special operations on the database as a whole. These roles are not defined
-    by the Standard, which has left it to implementers to define such roles as
-    they are needed for the particular SQL implementation.</p>
+    objects. There is the built-in DBA role that allows full access to all
+    possible operations on the database, including the creation of USER and
+    ROLE objects and schemas. There are other built-in roles that allow some
+    special operations on the database as a whole. Admin users have the DBA
+    role.</p>
 <p>A ROLE has a name, a collection of zero or more other roles, plus
     some privileges (access rights). A USER has a name and a password. It
     similarly has a collection of zero or more roles plus some
     privileges.</p>
-<p>USER objects existed in the SQL-92, but ROLE objects were introduced
-    in SQL:1999. Originally it was intended that USER objects would normally
-    be the same as the operating system USER objects and their authentication
-    would be handled outside the SQL environment. The co-existence of ROLE and
-    USER objects results in complexity. With the addition of ROLE objects,
-    there is no rationale, other than legacy support, for granting privileges
-    to USER objects directly. It is better to create roles and grant
-    privileges to them, then grant the roles to USER objects.</p>
+<p>USER objects existed in SQL-92, but ROLE objects were introduced in
+    SQL:1999. The co-existence of ROLE and USER objects results in complexity.
+    With the addition of ROLE objects, there is no rationale, other than
+    legacy support, for granting privileges to USER objects directly. It is
+    better to create roles and grant privileges to them, then grant the roles
+    to USER objects.</p>
 <p>The Standard effectively defines a special ROLE, named PUBLIC. All
     authorizations have the PUBLIC role, which cannot be removed from them.
     Therefore, any access right assigned to the PUBLIC role applies to all
     authorizations in the database. For many simple databases, it is adequate
-    to create a single, non-admin user, then assign access rights to the
-    pre-existing PUBLIC role. Access to INFORMATION_SCHEMA views is granted to
+    to create one or more non-admin user, then assign access rights to the
+    tables and sequences to the PUBLIC role.</p>
+<p>The PUBLIC role is separate from the default PUBLIC schema. The
+    contents of this schema is not visible to non-admin users unless access is
+    granted by the DBA role.</p>
+<p>Access to INFORMATION_SCHEMA views is automatically granted to
     PUBLIC; therefore these views are accessible to all. However, the contents
     of each view depend on the ROLE or USER (AUTHORIZATION) that is in force
-    while accessing the view.</p>
+    while accessing the view. This means a user cannot even see the existence
+    of tables and other objects when it has no access rights on those
+    objects.</p>
 <p>Each schema has a single AUTHORIZATION. This is commonly known as
     the <span class="emphasis"><em>owner</em></span> of the schema. All the objects in the
     schema inherit the schema owner. The schema owner can add objects to the
-    schema, drop them or alter them.</p>
-<p>By default, the objects in a schema can only be accessed by the
-    schema owner. The schema owner can grant access rights on the objects to
-    other users or roles.</p>
-<a name="N14057" class="indexterm"></a>
+    schema, drop them or alter them. By default, the objects in a schema can
+    only be accessed by the schema owner. The schema owner can grant access
+    rights on the objects to other users or roles.</p>
+<a name="N14178" class="indexterm"></a>
 <p>
 <span class="bold"><strong>authorization
     identifier</strong></span>
@@ -188,29 +198,31 @@
 </div>
 </div>
 </div>
+<a name="N1418D" class="indexterm"></a>
 <p>There are some pre-defined roles in each database; some defined by
       the SQL Standard, some by HyperSQL. These roles can be assigned to users
       (directly or via other, user-defined roles). In addition, there is the
-      initial SYS user created with each new database. The initial user name
+      initial admin user created with each new database. The initial user name
       and password is defined in the connection properties when the first
       connection to the database is made. In older versions of HSQLDB, this
       name was always SA. But in the latest version, the name can be defined
       as a different string.</p>
-<a name="N1406E" class="indexterm"></a>
+<a name="N14194" class="indexterm"></a>
 <p>
-<span class="bold"><strong>SYS User</strong></span>
+<span class="bold"><strong>Admin User</strong></span>
 </p>
 <p>
-<span class="emphasis"><em>the SYS user (HyperSQL-specific)</em></span>
+<span class="emphasis"><em>the Admin user
+      (HyperSQL-specific)</em></span>
 </p>
 <p>This user is automatically created with a new database and has
       the DBA role. This user name and its password are defined in the
       connection properties when connecting to the new database to create the
-      database. As this user, it is possible to change the password, create
-      other users and created new schema objects. The initial SYS user can be
+      database. This user can change the password, create other users and
+      create new schemas and other objects. The initial admin user can be
       dropped by another user that has the DBA role. As a result, there is
-      always at least one SYS user in the database.</p>
-<a name="N1407C" class="indexterm"></a>
+      always at least one admin user in the database.</p>
+<a name="N141A2" class="indexterm"></a>
 <p>
 <span class="bold"><strong>PUBLIC</strong></span>
 </p>
@@ -222,7 +234,7 @@
       the INFORMATION_SCHEMA with limited visibility. Any roles or rights
       granted to this role, are in effect granted to all users of the
       database.</p>
-<a name="N1408A" class="indexterm"></a>
+<a name="N141B0" class="indexterm"></a>
 <p>
 <span class="bold"><strong>_SYSTEM</strong></span>
 </p>
@@ -232,7 +244,7 @@
 <p>This role is the authorization for the pre-defined (system)
       objects in the database, including the INFORMATION_SCHEMA. This role
       cannot be assigned to any authorization (user or role).</p>
-<a name="N14098" class="indexterm"></a>
+<a name="N141BE" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DBA</strong></span>
 </p>
@@ -244,8 +256,9 @@
       role can also act as a proxy for all the roles and users in the
       database. This means it can do everything the authorization for a schema
       can do, including dropping the schema or its objects, or granting rights
-      on the schema objects to a grantee.</p>
-<a name="N140A6" class="indexterm"></a>
+      on the schema objects to a grantee. All admin users have this
+      role.</p>
+<a name="N141CC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE_SCHEMA</strong></span>
 </p>
@@ -256,7 +269,7 @@
 <p>An authorization that has this role, can create schemas. The
       DBA authorization has this role and can grant it to other
       authorizations.</p>
-<a name="N140B4" class="indexterm"></a>
+<a name="N141DA" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CHANGE_AUTHORIZATION</strong></span>
 </p>
@@ -269,7 +282,7 @@
       (otherwise, the original user would gain DBA privileges). The DBA
       authorization has this role and can grant it to other
       authorizations.</p>
-<a name="N140C2" class="indexterm"></a>
+<a name="N141E8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SCRIPT_OPS</strong></span>
 </p>
@@ -290,8 +303,10 @@
 </div>
 </div>
 </div>
+<a name="N141FA" class="indexterm"></a>
 <p>Tables in the INFORMATION_SCHEMA contain the list of users and
-      roles for the database.</p>
+      roles for the database. Only admin users can see the full contents of
+      these tables.</p>
 <p>The SYSTEM_USERS tables contains the list of users, with some
       extra settings for each user. The AUTHORIZATIONS table contains a list
       of both users and roles.</p>
@@ -314,10 +329,19 @@
 </div>
 </div>
 </div>
-<p>By default, the objects in a schema can only be accessed by the
-      schema owner. But the schema owner can grant privileges (access rights)
-      on the objects to other users or roles.</p>
-<p>Things can get far more complex, because the grant of privileges
+<a name="N14211" class="indexterm"></a>
+<p>The create schema statements has an optional AUTHORIZATION clause:
+      For example:</p>
+<div class="informalexample">
+<pre class="programlisting"> CREATE SCHEMA mySchema AUTHORIZATION aUserOrRole
+</pre>
+</div>
+<p>If the authorization is not specified, the DBA role becomes the
+      authorization. This authorization is the owner of the schema. By
+      default, the objects in a schema can only be accessed by the schema
+      owner. But the schema owner can grant privileges (access rights) on the
+      objects to other users or roles.</p>
+<p>Things can get far more complex because the grant of privileges
       can be made WITH GRANT OPTION. In this case, the role or user that has
       been granted the privilege can grant the privilege to other roles and
       users.</p>
@@ -325,9 +349,9 @@
 <p>The statements for granting and revoking privileges normally
       specify which privileges are granted or revoked. However, there is a
       shortcut, ALL PRIVILEGES, which means all the privileges that the
-      <code class="literal">&lt;grantor&gt;</code> has on the schema object. The
-      <code class="literal">&lt;grantor&gt;</code> is normally the CURRENT_USER of the
-      session that issues the statement.</p>
+      <code class="literal">&lt;grantor&gt;</code> has on the specified schema object.
+      The <code class="literal">&lt;grantor&gt;</code> is normally the CURRENT_USER of
+      the session that issues the statement.</p>
 <p>The user or role that is granted privileges is referred to as
       <code class="literal">&lt;grantee&gt;</code> for the granted privileges.</p>
 <p>
@@ -385,16 +409,75 @@
 <div>
 <div>
 <h3 class="title">
+<a name="N1425C"></a>Simple Access Control</h3>
+</div>
+</div>
+</div>
+<a name="N1425F" class="indexterm"></a>
+<p>The simplest form of access control is when the DBA user creates a
+      single non-admin user, then creates the tables and other objects in the
+      PUBLIC schema, and grants access to the objects to PUBLIC. A grant to
+      PUBLIC applies to all non-admin users, including any users that are
+      created later.</p>
+<div class="informalexample">
+<pre class="programlisting">CREATE USER generalUser PASSWORD 'aPassword'
+
+-- the objects are created one by one in the PUBLIC schema 
+SET SCHEMA PUBLIC
+CREATE TABLE aTable ...
+CREATE TABLE anotherTable ...
+...
+CREATE SEQUENCE aSequence ...
+CREATE PROCECURE aProc ...
+'''
+
+-- access rights are granted to PUBLIC, which includes the generalUser
+GRANT ALL ON ALL TABLES IN SCHEMA public TO PUBLIC
+GRANT ALL ON ALL SEQUENCES IN SCHEMA public TO PUBLIC
+GRANT ALL ON ALL ROUTINES IN SCHEMA public TO PUBLIC
+</pre>
+</div>
+<p>When different users need to have different levels of access, the
+      privileges are granted to individual users as opposed to PUBLIC. In the
+      example below there are 2 users with different access rights to the
+      objects in the schema.</p>
+<div class="informalexample">
+<pre class="programlisting">-- two users are created first
+CREATE USER generalUser PASSWORD 'aPassword'
+CREATE USER auditUser PASSWORD 'anotherPassword'
+
+-- the schema and its objects are created with a single compound statement 
+CREATE SCHEMA mySchema AUTHORIZATION DBA
+    CREATE TABLE aTable ...
+    CREATE TABLE anotherTable ...
+    ...
+    CREATE SEQUENCE aSequence ...
+    CREATE PROCECURE aProc ...
+    ''';
+
+-- different access rights are granted to the users
+GRANT ALL ON ALL TABLES IN SCHEMA mySchema TO generalUser
+GRANT USAGE ON ALL SEQUENCES IN SCHEMA mySchema TO generalUser
+GRANT EXECUTE ON ALL ROUTINES IN SCHEMA mySchema TO generalUser
+GRANT SELECT ON ALL TABLES IN SCHEMA mySchema TO auditUser;
+</pre>
+</div>
+</div>
+<div class="section">
+<div class="titlepage">
+<div>
+<div>
+<h3 class="title">
 <a name="acc_fine_grained_access"></a>Fine-Grained Data Access Control</h3>
 </div>
 </div>
 </div>
-<a name="N1412B" class="indexterm"></a>
-<p>As mentioned above, a USER or ROLE that does not own a schema can
-      be granted access to individual columns of a table in the schema.
-      HyperSQL adds a feature that is not part of the SQL Standard to allow
-      this access to be granted to a ROLE only for certain rows of a table,
-      based on a FILTER condition.</p>
+<a name="N14272" class="indexterm"></a>
+<p>A USER or ROLE that does not own a schema can be granted access to
+      individual columns of a table in the schema. HyperSQL adds a feature
+      that is not part of the SQL Standard to allow access to be granted to a
+      ROLE only for certain rows of a table, based on a FILTER
+      condition.</p>
 <p>When the GRANT statement contains a FILTER condition, the
       condition is applied to each row of the table that a SELECT, INSERT,
       UPDATE, DELETE or MERGE statement tries to access. Only the rows that
@@ -407,7 +490,7 @@
       A group of ordinary users with the <code class="literal">eu_admin</code> role is
       only allowed to access the data for a certain region. Another group with
       the <code class="literal">eu_user</code> role is only allowed to access the rows
-      before the expiration date. </p>
+      before the expiration date.</p>
 <div class="informalexample">
 <pre class="programlisting">CREATE TABLE info(id INT PRIMARY KEY, info VARCHAR(100), region VARCHAR(32) NOT NULL, expires DATE NOT NULL)
 -- there is also a foreign key constraint on the REGION column to reference a list of valid region names.
@@ -430,11 +513,11 @@ GRANT eu_user TO emma, john
       rows they cannot access.</p>
 <p>The <code class="literal">&lt;filter clause&gt;</code> can be used for other
       forms of fine-grained access control. In the example below, the
-      COMMON_USER role is defined and granted access during office hours
+      COMMON_ROLE role is defined and granted access during office hours
       only.</p>
 <div class="informalexample">
-<pre class="programlisting">CREATE ROLE common_user
-GRANT SELECT FILTER (WHERE EXTRACT(HOUR FROM CURRENT_TIMESTAMP) BETWEEN 9 AND 17) ON TABLE info TO common_user
+<pre class="programlisting">CREATE ROLE common_role
+GRANT SELECT FILTER (WHERE EXTRACT(HOUR FROM CURRENT_TIMESTAMP) BETWEEN 9 AND 17) ON TABLE info TO common_role
 </pre>
 </div>
 <p>Fine-grained data access control can also be used to implement
@@ -467,7 +550,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     assigned to other roles or to users. The same statements are also used in
     a different form to assign privileges on schema objects to users and
     roles.</p>
-<a name="N1415A" class="indexterm"></a>
+<a name="N142A1" class="indexterm"></a>
 <p>
 <a name="create_user-sql"></a><span class="bold"><strong>CREATE
     USER</strong></span>
@@ -486,7 +569,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     characters and is case-sensitive. If <code class="literal">ADMIN</code> is
     specified, the DBA role is granted to the new user. Only a user with the
     DBA role can execute this statement.</p>
-<a name="N14175" class="indexterm"></a>
+<a name="N142BC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP USER</strong></span>
 </p>
@@ -501,7 +584,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     authorization for a schema, the schema is destroyed.</p>
 <p>Only a user with the DBA role can execute this
     statement.</p>
-<a name="N14188" class="indexterm"></a>
+<a name="N142CF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ALTER USER ... SET
     PASSWORD</strong></span>
@@ -520,7 +603,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     <code class="literal">&lt;password&gt;</code> is a string enclosed with single quote
     characters and is case-sensitive.</p>
 <p>Only a user with the DBA role can execute this command.</p>
-<a name="N141A1" class="indexterm"></a>
+<a name="N142E8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ALTER USER ... SET INITIAL
     SCHEMA</strong></span>
@@ -542,7 +625,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     session.</p>
 <p>Only a user with the DBA role can execute this
     statement.</p>
-<a name="N141B7" class="indexterm"></a>
+<a name="N142FE" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ALTER USER ... SET
     LOCAL</strong></span>
@@ -563,7 +646,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     authentication for a specific user.</p>
 <p>Only a user with the DBA role can execute this
     statement.</p>
-<a name="N141CA" class="indexterm"></a>
+<a name="N14311" class="indexterm"></a>
 <p>
 <a name="set_password-sql"></a><span class="bold"><strong>SET
     PASSWORD</strong></span>
@@ -578,7 +661,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <p>Set the password for the current user.
     <code class="literal">&lt;password&gt;</code> is a string enclosed with single quote
     characters and is case-sensitive.</p>
-<a name="N141DF" class="indexterm"></a>
+<a name="N14326" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET INITIAL SCHEMA</strong></span>
 </p>
@@ -596,7 +679,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     for all users is used as the initial schema for the current user. The
     separate SET SCHEMA command allows the user to change the schema for the
     duration of the session. See also the <a class="link" href="sessions-chapt.html" title="Chapter&nbsp;6.&nbsp;Sessions and Transactions">Sessions and Transactions</a> chapter.</p>
-<a name="N141F8" class="indexterm"></a>
+<a name="N1433F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE DEFAULT INITIAL
     SCHEMA</strong></span>
@@ -613,7 +696,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <p>Sets the initial schema for new users. This schema can later be
     changed with the <code class="literal">&lt;set initial schema statement&gt;</code>
     command.</p>
-<a name="N1420C" class="indexterm"></a>
+<a name="N14353" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE ROLE</strong></span>
 </p>
@@ -627,7 +710,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <p>Defines a new role. Initially the role has no rights, except
     those of the PUBLIC role. Only a user with the DBA role can execute this
     command.</p>
-<a name="N1421D" class="indexterm"></a>
+<a name="N14364" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP ROLE</strong></span>
 </p>
@@ -641,7 +724,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <p>Drop (destroy) a role. If the specified role is the authorization
     for a schema, the schema is destroyed. Only a user with the DBA role can
     execute this statement.</p>
-<a name="N1422E" class="indexterm"></a>
+<a name="N14375" class="indexterm"></a>
 <p>
 <span class="bold"><strong>GRANTED BY</strong></span>
 </p>
@@ -660,7 +743,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     clause can be used in various statements that perform GRANT or REVOKE
     actions. If the clause is not used, the authorization is CURRENT_USER.
     Otherwise, it is the specified authorization.</p>
-<a name="N14245" class="indexterm"></a>
+<a name="N1438C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>GRANT</strong></span>
 </p>
@@ -697,13 +780,21 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     EXECUTE</code>
 </p>
 <p>
-<code class="literal">&lt;object name&gt; ::= [ TABLE ] &lt;table name&gt; |
-    DOMAIN &lt;domain name&gt; | COLLATION &lt;collation name&gt; | CHARACTER
-    SET &lt;character set name&gt; | TRANSLATION &lt;transliteration name&gt;
-    | TYPE &lt;user-defined type name&gt; | SEQUENCE &lt;sequence generator
-    name&gt; | &lt;specific routine designator&gt; | ROUTINE &lt;routine
-    name&gt; | FUNCTION &lt;function name&gt; | PROCEDURE &lt;procedure
-    name&gt;</code>
+<code class="literal">&lt;object name&gt; ::= { &lt;single object name&gt; |
+    &lt;schema object set name&gt; }</code>
+</p>
+<p>
+<code class="literal">&lt;simple object name&gt; ::= [ TABLE ] &lt;table
+    name&gt; | DOMAIN &lt;domain name&gt; | COLLATION &lt;collation name&gt; |
+    CHARACTER SET &lt;character set name&gt; | TRANSLATION &lt;transliteration
+    name&gt; | TYPE &lt;user-defined type name&gt; | SEQUENCE &lt;sequence
+    generator name&gt; | &lt;specific routine designator&gt; | ROUTINE
+    &lt;routine name&gt; | FUNCTION &lt;function name&gt; | PROCEDURE
+    &lt;procedure name&gt;</code>
+</p>
+<p>
+<code class="literal">&lt;schema object set name&gt; ::= ALL { TABLES |
+    SEQUENCES | ROUTINES } IN SCHEMA &lt;schema name&gt;</code>
 </p>
 <p>
 <code class="literal">&lt;privilege column list&gt; ::= &lt;column name
@@ -722,27 +813,33 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     are discussed in the previous section. For a table or view, if
     <code class="literal">&lt;privilege column list&gt;</code> is not specified, then
     the privilege is granted on the table, which includes all of its columns
-    and any column that may be added to it in the future. For routines, the
-    name of the routine can be specified in two ways, either as the generic
-    name, or as the specific name for a signature. HyperSQL allows referencing
-    the generic name which covers all overloaded versions of a routine at the
-    same time. This is an extension to the SQL Standard which requires the use
-    of <code class="literal">&lt;specific routine designator&gt;</code> to grant
-    privileges separately on each different signature of the
-    routine.</p>
+    and any column that may be added to it in the future.</p>
+<p>For routines, the name of the routine can be specified in two
+    ways, either as the generic name, or as the specific name for a signature.
+    HyperSQL allows referencing the generic name which covers all overloaded
+    versions of a routine at the same time. This is an extension to the SQL
+    Standard, which requires the use of <code class="literal">&lt;specific routine
+    designator&gt;</code> to grant privileges separately on each different
+    signature of the routine.</p>
+<p>HyperSQL also adds the <code class="literal">&lt;schema object set
+    name&gt;</code> option as an extension to the SQL Standard. This form
+    grants the privileges to all the tables of the schema with a single GRANT
+    statement.</p>
 <p>The <code class="literal">&lt;filter clause&gt;</code> can be specified
     after the <code class="literal">&lt;object name&gt;</code> to limit access for all
-    the granted privileges, or it can be used after individual privileges.
-    </p>
+    the granted privileges, or it can be used after individual
+    privileges.</p>
 <p>Each <code class="literal">&lt;grantee&gt;</code> is the name of a role or
     a user. Examples of GRANT statement are given below:</p>
 <div class="informalexample">
 <pre class="programlisting"> GRANT ALL ON SEQUENCE aSequence TO roleOrUser 
- GRANT SELECT ON aTable TO roleOrUser  
+ GRANT SELECT ON aTable TO roleOrUser
+ GRANT SELECT(col3, col5) ON aTable TO aRole  
  GRANT SELECT, UPDATE FILTER(WHERE aColumn &gt; 2) ON aTABLE TO role1 -- filter only for update
  GRANT SELECT, UPDATE ON aTable FILTER(WHERE aColumn &gt; 2) TO role2 -- filter for both select and update
  GRANT SELECT(columnA, columnB), UPDATE(columnA, columnB) ON TABLE aTable TO user1, role1, role2
  GRANT EXECUTE ON SPECIFIC ROUTINE aroutine_1234 TO roleOrUser
+ GRANT SELECT ON ALL TABLES IN SCHEMA mySchema TO PUBLIC
 </pre>
 </div>
 <p>As mentioned in the general discussion, it is better to define a
@@ -751,7 +848,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     privileges of this role, they are automatically reflected in all the users
     that have the role. Fine-grained privileges (those with a FILTER clause)
     can be granted to roles only.</p>
-<a name="N14297" class="indexterm"></a>
+<a name="N143EB" class="indexterm"></a>
 <p>
 <span class="bold"><strong>GRANT</strong></span>
 </p>
@@ -780,7 +877,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
  GRANT EXECUTE ON ROUTINE aroutine TO approle
 </pre>
 </div>
-<a name="N142B7" class="indexterm"></a>
+<a name="N1440B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>REVOKE privilege</strong></span>
 </p>
@@ -793,8 +890,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     &lt;grantee&gt; }... ] [ GRANTED BY &lt;grantor&gt; ] RESTRICT |
     CASCADE</code>
 </p>
-<p>Revoke privileges from a user or role.</p>
-<a name="N142C8" class="indexterm"></a>
+<p>Revoke privileges from a user or role. The syntax elements are
+    similar to the GRANT statements.</p>
+<a name="N1441C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>REVOKE role</strong></span>
 </p>
@@ -815,7 +913,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 <HR xmlns:xi="http://www.w3.org/2001/XInclude">
-<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6369 $</P>
+<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6474 $</P>
 <div class="navfooter">
 <hr>
 <table summary="Navigation footer" width="100%">
diff -pruN 2.6.1-1/hsqldb/doc/guide/book-ind.html 2.7.0-1/hsqldb/doc/guide/book-ind.html
--- 2.6.1-1/hsqldb/doc/guide/book-ind.html	2021-10-20 09:33:34.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/guide/book-ind.html	2022-07-26 20:21:48.000000000 +0000
@@ -34,7 +34,7 @@
 <div class="indexdiv">
 <h3>Symbols</h3>
 <dl>
-<dt>_SYSTEM ROLE, <a class="indexterm" href="accesscontrol-chapt.html#acc_built_in_roles_users">Built-In Roles and Users</a>
+<dt>_SYSTEM Role, <a class="indexterm" href="accesscontrol-chapt.html#acc_built_in_roles_users">Built-In Roles and Users</a>
 </dt>
 </dl>
 </div>
@@ -43,6 +43,8 @@
 <dl>
 <dt>ABS function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_numeric_functions">Numeric Functions</a>
 </dt>
+<dt>Access Rights, <a class="indexterm" href="accesscontrol-chapt.html#acc_access_rights">Access Rights</a>
+</dt>
 <dt>ACL, <a class="indexterm" href="listeners-chapt.html#lsc_acl">Network Access Control</a>
 </dt>
 <dt>ACOS function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_numeric_functions">Numeric Functions</a>
@@ -65,6 +67,8 @@
 </dt>
 <dt>ADMINISTRABLE_ROLE_AUTHORIZATIONS, <a class="indexterm" href="databaseobjects-chapt.html#dbc_standard_views_info_schema">SQL Standard Views</a>
 </dt>
+<dt>Admin USER, <a class="indexterm" href="accesscontrol-chapt.html#acc_built_in_roles_users">Built-In Roles and Users</a>
+</dt>
 <dt>aggregate function, <a class="indexterm" href="dataaccess-chapt.html#dac_aggregate_funcs">Aggregate Functions</a>
 </dt>
 <dt>ALL and ANY predicates, <a class="indexterm" href="dataaccess-chapt.html#dac_sql_predicates">Predicates</a>
@@ -118,6 +122,8 @@
 </dt>
 <dt>ATAN function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_numeric_functions">Numeric Functions</a>
 </dt>
+<dt>Authorisation and Access Control, <a class="indexterm" href="accesscontrol-chapt.html#acc_auth_and_access_ctrl">Authorizations and Access Control</a>
+</dt>
 <dt>AUTHORIZATION IDENTIFIER, <a class="indexterm" href="accesscontrol-chapt.html#acc_auth_and_access_ctrl">Authorizations and Access Control</a>
 </dt>
 <dt>AUTHORIZATIONS, <a class="indexterm" href="databaseobjects-chapt.html#dbc_standard_views_info_schema">SQL Standard Views</a>
@@ -159,6 +165,8 @@
 </dt>
 <dt>boolean value expression, <a class="indexterm" href="dataaccess-chapt.html#dac_value_expression">Value Expression</a>
 </dt>
+<dt>Built-in Roles and Users, <a class="indexterm" href="accesscontrol-chapt.html#acc_built_in_roles_users">Built-In Roles and Users</a>
+</dt>
 </dl>
 </div>
 <div class="indexdiv">
@@ -264,7 +272,7 @@
 </dt>
 <dt>COT function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_numeric_functions">Numeric Functions</a>
 </dt>
-<dt>CREATE_SCHEMA ROLE, <a class="indexterm" href="accesscontrol-chapt.html#acc_built_in_roles_users">Built-In Roles and Users</a>
+<dt>CREATE_SCHEMA Role, <a class="indexterm" href="accesscontrol-chapt.html#acc_built_in_roles_users">Built-In Roles and Users</a>
 </dt>
 <dt>CREATE AGGREGATE FUNCTION, <a class="indexterm" href="sqlroutines-chapt.html#src_aggregate_function_definition">Definition of Aggregate Functions</a>
 </dt>
@@ -377,7 +385,7 @@
 </dt>
 <dt>DAYS function datetime, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_extract_datetime">Functions to Extract an Element of a Datetime</a>
 </dt>
-<dt>DBA ROLE, <a class="indexterm" href="accesscontrol-chapt.html#acc_built_in_roles_users">Built-In Roles and Users</a>
+<dt>DBA Role, <a class="indexterm" href="accesscontrol-chapt.html#acc_built_in_roles_users">Built-In Roles and Users</a>
 </dt>
 <dt>DECLARE CURSOR, <a class="indexterm" href="dataaccess-chapt.html#dac_declare_cursor">Cursor Declaration</a>
 </dt>
@@ -501,6 +509,8 @@
 </dt>
 <dt>FROM_BASE64 function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_string_binary_functions">String and Binary String Functions</a>
 </dt>
+<dt>FROM_TZ function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_datetime_format">Functions to Convert or Format a Datetime</a>
+</dt>
 </dl>
 </div>
 <div class="indexdiv">
@@ -515,7 +525,7 @@
 <dt>GRANTED BY, <a class="indexterm" href="accesscontrol-chapt.html#acc_statements">Statements for
     Authorization and Access Control</a>
 </dt>
-<dt>GRANT privilege, <a class="indexterm" href="accesscontrol-chapt.html#acc_statements">Statements for
+<dt>GRANT privileges, <a class="indexterm" href="accesscontrol-chapt.html#acc_statements">Statements for
     Authorization and Access Control</a>
 </dt>
 <dt>GRANT role, <a class="indexterm" href="accesscontrol-chapt.html#acc_statements">Statements for
@@ -602,6 +612,12 @@
 </dt>
 <dt>JOIN with condition, <a class="indexterm" href="dataaccess-chapt.html#dac_joined_table">Joined Table</a>
 </dt>
+<dt>JSON_ARRAY_AGG function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_JSON_functions">JSON Functions</a>
+</dt>
+<dt>JSON_ARRAY function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_JSON_functions">JSON Functions</a>
+</dt>
+<dt>JSON_OBJECT function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_JSON_functions">JSON Functions</a>
+</dt>
 </dl>
 </div>
 <div class="indexdiv">
@@ -634,6 +650,8 @@
 </dt>
 <dt>LIKE predicate, <a class="indexterm" href="dataaccess-chapt.html#dac_sql_predicates">Predicates</a>
 </dt>
+<dt>Listing Users and Roles, <a class="indexterm" href="accesscontrol-chapt.html#acc_listing">Listing Users and Roles</a>
+</dt>
 <dt>LN function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_numeric_functions">Numeric Functions</a>
 </dt>
 <dt>LOAD_FILE function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_general_functions">General Functions</a>
@@ -754,8 +772,12 @@
 </dt>
 <dt>PERFORM CHECK INDEX, <a class="indexterm" href="management-chapt.html#mtc_data_management_statements">Data Management Statements</a>
 </dt>
+<dt>PERFORM EXPORT DSV, <a class="indexterm" href="management-chapt.html#mtc_data_management_statements">Data Management Statements</a>
+</dt>
 <dt>PERFORM EXPORT SCRIPT, <a class="indexterm" href="management-chapt.html#mtc_data_management_statements">Data Management Statements</a>
 </dt>
+<dt>PERFORM IMPORT DSV file, <a class="indexterm" href="management-chapt.html#mtc_data_management_statements">Data Management Statements</a>
+</dt>
 <dt>PERFORM IMPORT SCRIPT, <a class="indexterm" href="management-chapt.html#mtc_data_management_statements">Data Management Statements</a>
 </dt>
 <dt>PERIODS, <a class="indexterm" href="databaseobjects-chapt.html#dbc_standard_views_info_schema">SQL Standard Views</a>
@@ -772,7 +794,7 @@
 </dt>
 <dt>PRIMARY KEY constraint, <a class="indexterm" href="databaseobjects-chapt.html#dbc_table_creation">Table Creation</a>
 </dt>
-<dt>PUBLIC ROLE, <a class="indexterm" href="accesscontrol-chapt.html#acc_built_in_roles_users">Built-In Roles and Users</a>
+<dt>PUBLIC Role, <a class="indexterm" href="accesscontrol-chapt.html#acc_built_in_roles_users">Built-In Roles and Users</a>
 </dt>
 </dl>
 </div>
@@ -830,7 +852,7 @@
 </dt>
 <dt>REVERSE function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_string_binary_functions">String and Binary String Functions</a>
 </dt>
-<dt>REVOKE, <a class="indexterm" href="accesscontrol-chapt.html#acc_statements">Statements for
+<dt>REVOKE privileges, <a class="indexterm" href="accesscontrol-chapt.html#acc_statements">Statements for
     Authorization and Access Control</a>
 </dt>
 <dt>REVOKE ROLE, <a class="indexterm" href="accesscontrol-chapt.html#acc_statements">Statements for
@@ -903,7 +925,7 @@
 </dt>
 <dt>SCRIPT, <a class="indexterm" href="management-chapt.html#mtc_system_operation_statements">System Operations</a>
 </dt>
-<dt>SCRIPT_OPS, <a class="indexterm" href="accesscontrol-chapt.html#acc_built_in_roles_users">Built-In Roles and Users</a>
+<dt>SCRIPT_OPS Role, <a class="indexterm" href="accesscontrol-chapt.html#acc_built_in_roles_users">Built-In Roles and Users</a>
 </dt>
 <dt>search condition, <a class="indexterm" href="dataaccess-chapt.html#dac_other_syntax_elements">Other Syntax Elements</a>
 </dt>
@@ -1004,6 +1026,8 @@
 </dt>
 <dt>SET DATABASE SQL TRANSLATE TTI TYPES, <a class="indexterm" href="management-chapt.html#mtc_sql_settings">SQL Conformance Settings</a>
 </dt>
+<dt>SET DATABASE SQL TRUNCATE TRAILING, <a class="indexterm" href="management-chapt.html#mtc_sql_settings">SQL Conformance Settings</a>
+</dt>
 <dt>SET DATABASE SQL TYPES, <a class="indexterm" href="management-chapt.html#mtc_sql_settings">SQL Conformance Settings</a>
 </dt>
 <dt>SET DATABASE SQL UNIQUE NULLS, <a class="indexterm" href="management-chapt.html#mtc_sql_settings">SQL Conformance Settings</a>
@@ -1102,6 +1126,8 @@
 </dt>
 <dt>SIGN function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_numeric_functions">Numeric Functions</a>
 </dt>
+<dt>Simple Data Access Control, <a class="indexterm" href="accesscontrol-chapt.html#N1425C">Simple Access Control</a>
+</dt>
 <dt>SIN function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_numeric_functions">Numeric Functions</a>
 </dt>
 <dt>SINH function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_numeric_functions">Numeric Functions</a>
@@ -1210,8 +1236,6 @@
 </dt>
 <dt>SYSTIMESTAMP function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_current_datetime">Functions to Report the Current Datetime</a>
 </dt>
-<dt>SYS USER, <a class="indexterm" href="accesscontrol-chapt.html#acc_built_in_roles_users">Built-In Roles and Users</a>
-</dt>
 </dl>
 </div>
 <div class="indexdiv">
@@ -1384,7 +1408,7 @@
 </div>
 </div>
 <HR xmlns:xi="http://www.w3.org/2001/XInclude">
-<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6369 $</P>
+<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6474 $</P>
 <div class="navfooter">
 <hr>
 <table summary="Navigation footer" width="100%">
diff -pruN 2.6.1-1/hsqldb/doc/guide/book-pref.html 2.7.0-1/hsqldb/doc/guide/book-pref.html
--- 2.6.1-1/hsqldb/doc/guide/book-pref.html	2021-10-20 09:33:34.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/guide/book-pref.html	2022-07-26 20:21:48.000000000 +0000
@@ -48,7 +48,7 @@
 <p>The first versions of HSQLDB were released in 2001. Version 2, first
     released in 2010, was a complete rewrite of most parts of the database
     engine.</p>
-<p>This documentation covers HyperSQL version 2.6.1 and has been
+<p>This documentation covers HyperSQL version 2.7.0 and has been
     regularly improved and updated. The latest, updated version can be found
     at http://hsqldb.org/doc/2.0/</p>
 <p>If you notice any mistakes in this document, or if you have problems
@@ -144,7 +144,7 @@
 </div>
 </div>
 <HR xmlns:xi="http://www.w3.org/2001/XInclude">
-<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6369 $</P>
+<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6474 $</P>
 <div class="navfooter">
 <hr>
 <table summary="Navigation footer" width="100%">
diff -pruN 2.6.1-1/hsqldb/doc/guide/building-app.html 2.7.0-1/hsqldb/doc/guide/building-app.html
--- 2.6.1-1/hsqldb/doc/guide/building-app.html	2021-10-20 09:33:34.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/guide/building-app.html	2022-07-26 20:21:48.000000000 +0000
@@ -61,7 +61,7 @@
 <p class="releaseinfo">$Revision: 6366 $</p>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -136,7 +136,7 @@
 </div>
 </div>
 </div>
-<a name="N17B38" class="indexterm"></a>
+<a name="N17DBA" class="indexterm"></a>
 <p>Unlike most software build systems, you do not need to have the
     Gradle system installed on your computer to use it. You don't need to
     understand the details to use it, but this is the purpose of the
@@ -246,7 +246,7 @@
 </div>
 </div>
 </div>
-<a name="N17BAE" class="indexterm"></a>
+<a name="N17E30" class="indexterm"></a>
 <p>You should use version 1.9 or 1.10 of Ant (Another Neat Tool) to
     do Ant builds with HyperSQL.</p>
 <div class="section">
@@ -418,7 +418,7 @@
 <p>The command displays a list of different options for building
       different sizes of the HSQLDB Jar. The default is built using:</p>
 <div class="example">
-<a name="N17C62"></a>
+<a name="N17EE4"></a>
 <p class="title">
 <b>Example&nbsp;C.1.&nbsp;Buiding the standard HSQLDB jar file with Ant</b>
 </p>
@@ -471,7 +471,7 @@
     particular version of the file. This operation is done for all files of a
     defined directory, and all subdirectories.</p>
 <div class="example">
-<a name="N17C7B"></a>
+<a name="N17EFD"></a>
 <p class="title">
 <b>Example&nbsp;C.2.&nbsp;Example source code before CodeSwitcher is run</b>
 </p>
@@ -499,7 +499,7 @@
 <br class="example-break">
 <p>The next step is to run CodeSwitcher.</p>
 <div class="example">
-<a name="N17C82"></a>
+<a name="N17F04"></a>
 <p class="title">
 <b>Example&nbsp;C.3.&nbsp;CodeSwitcher command line invocation</b>
 </p>
@@ -513,7 +513,7 @@
     subdirectories are processed recursively). <code class="literal">-JAVA8</code> means
     the code labelled with JAVA8 must be switched off.</p>
 <div class="example">
-<a name="N17C8C"></a>
+<a name="N17F0E"></a>
 <p class="title">
 <b>Example&nbsp;C.4.&nbsp;Source code after CodeSwitcher processing</b>
 </p>
@@ -650,7 +650,7 @@
 </div>
 </div>
 <HR xmlns:xi="http://www.w3.org/2001/XInclude">
-<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6369 $</P>
+<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6474 $</P>
 <div class="navfooter">
 <hr>
 <table summary="Navigation footer" width="100%">
diff -pruN 2.6.1-1/hsqldb/doc/guide/builtinfunctions-chapt.html 2.7.0-1/hsqldb/doc/guide/builtinfunctions-chapt.html
--- 2.6.1-1/hsqldb/doc/guide/builtinfunctions-chapt.html	2021-10-20 09:33:34.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/guide/builtinfunctions-chapt.html	2022-07-26 20:21:48.000000000 +0000
@@ -44,12 +44,12 @@
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6358 $</p>
+<p class="releaseinfo">$Revision: 6583 $</p>
 </div>
 <div>
 <div class="legalnotice">
-<a name="N11B86"></a>
-<p>Copyright 2010-2021 Fred Toussi. Permission is granted to
+<a name="N11B9A"></a>
+<p>Copyright 2010-2022 Fred Toussi. Permission is granted to
       distribute this document without any alteration under the terms of the
       HSQLDB license. Additional permission is granted to the HSQL Development
       Group to distribute this document with or without alterations under the
@@ -57,7 +57,7 @@
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -73,6 +73,9 @@
 <span class="section"><a href="builtinfunctions-chapt.html#bfc_string_binary_functions">String and Binary String Functions</a></span>
 </dt>
 <dt>
+<span class="section"><a href="builtinfunctions-chapt.html#bfc_JSON_functions">JSON Functions</a></span>
+</dt>
+<dt>
 <span class="section"><a href="builtinfunctions-chapt.html#bfc_numeric_functions">Numeric Functions</a></span>
 </dt>
 <dt>
@@ -183,7 +186,7 @@
     tokens are separated with the vertical bar ( <code class="literal">&lt;vertical
     bar&gt;</code> ). At the end of each function definition, the standard
     which specifies the function is noted in parentheses as JDBC or HyperSQL,
-    or the SQL/Foundation part of the SQL Standard.</p>
+    or the SQL:2016 Standard.</p>
 </div>
 <div class="section">
 <div class="titlepage">
@@ -206,7 +209,7 @@
     <code class="literal">&lt;binary value expr&gt; </code>indicates a binary type
     and<code class="literal"> &lt;num value expr&gt; </code>indicates a numeric
     type.</p>
-<a name="N11BF7" class="indexterm"></a>
+<a name="N11C0B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ASCII</strong></span>
 </p>
@@ -215,7 +218,7 @@
 </p>
 <p>Returns an INTEGER equal to the ASCII code value of the first
     character of <code class="literal">&lt;char value expr&gt;</code>. (JDBC)</p>
-<a name="N11C08" class="indexterm"></a>
+<a name="N11C1C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ASCIISTR</strong></span>
 </p>
@@ -225,7 +228,7 @@
 <p>Returns the ASCII representation of the string argument with all
     characters outside the range 32-126 replaced with Unicode escape codes.
     (HyperSQL)</p>
-<a name="N11C16" class="indexterm"></a>
+<a name="N11C2A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>BIT_LENGTH</strong></span>
 </p>
@@ -235,9 +238,9 @@
 </p>
 <p>BIT_LENGTH can be used with character, binary and bit strings. It
     return a BIGINT value that measures the bit length of the string.
-    (Foundation)</p>
+    (SQL:2016)</p>
 <p>See also CHARACTER_LENGTH and OCTET_LENGTH.</p>
-<a name="N11C26" class="indexterm"></a>
+<a name="N11C3A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CHAR</strong></span>
 </p>
@@ -248,7 +251,7 @@
     single character that has the specified<code class="literal"> &lt;UNICODE
     code&gt;</code>, which is an integer. ASCII codes are a subset of the
     allowed values for <code class="literal">&lt;UNICODE code&gt;</code>. (JDBC)</p>
-<a name="N11C3A" class="indexterm"></a><a name="N11C3F" class="indexterm"></a>
+<a name="N11C4E" class="indexterm"></a><a name="N11C53" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CHARACTER_LENGTH</strong></span>
 </p>
@@ -264,8 +267,8 @@
     string in the given unit. CHAR_LENGTH counts characters, OCTET_LENGTH
     counts octets and BIT_LENGTH counts bits in the string. For CHAR_LENGTH,
     if <code class="literal">[ USING OCTETS ] </code>is specified, the octet count is
-    returned, which is twice the normal length. (Foundation)</p>
-<a name="N11C52" class="indexterm"></a>
+    returned, which is twice the normal length. (SQL:2016)</p>
+<a name="N11C66" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CONCAT</strong></span>
 </p>
@@ -289,7 +292,7 @@
     property is set false, then NULL values are replaced with empty
     strings.</p>
 <p>(JDBC)</p>
-<a name="N11C70" class="indexterm"></a>
+<a name="N11C84" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CONCAT_WS</strong></span>
 </p>
@@ -307,7 +310,7 @@
 <p>This function is similar to a MySQL function of the same
     name.</p>
 <p>(HyperSQL)</p>
-<a name="N11C85" class="indexterm"></a>
+<a name="N11C99" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DIFFERENCE</strong></span>
 </p>
@@ -320,7 +323,7 @@
     similar the two SOUNDEX value are. If the values are the same, it returns
     4, if the values have no similarity, it returns 0. In-between values are
     returned for partial similarity. (JDBC)</p>
-<a name="N11C93" class="indexterm"></a>
+<a name="N11CA7" class="indexterm"></a>
 <p>
 <span class="bold"><strong>FROM_BASE64</strong></span>
 </p>
@@ -330,7 +333,7 @@
 </p>
 <p>Returns a binary string by converting from the base64
     <code class="literal">&lt;character value expr&gt;</code>. (HyperSQL)</p>
-<a name="N11CA4" class="indexterm"></a>
+<a name="N11CB8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>INSERT</strong></span>
 </p>
@@ -345,7 +348,7 @@
     copied. Equivalent to SQL/Foundation <code class="literal">OVERLAY( &lt;char value
     expr1&gt; PLACING &lt; char value expr2&gt; FROM &lt;offset&gt; FOR
     &lt;length&gt; )</code> . (JDBC)</p>
-<a name="N11CC1" class="indexterm"></a>
+<a name="N11CD5" class="indexterm"></a>
 <p>
 <span class="bold"><strong>INSTR</strong></span>
 </p>
@@ -360,7 +363,7 @@
     position indicated by <code class="literal">&lt;offset&gt;</code>. If the search is
     not successful, 0 is returned. Similar to the <code class="literal">LOCATE</code>
     function but the order of the arguments is reversed. (HyperSQL)</p>
-<a name="N11CDE" class="indexterm"></a>
+<a name="N11CF2" class="indexterm"></a>
 <p>
 <span class="bold"><strong>HEX</strong></span>
 </p>
@@ -375,7 +378,7 @@
     same as the <code class="literal">RAWTOHEX</code> function. With
     <code class="literal">&lt;numeric value expr&gt;</code> the hexadecimal digits
     represent the number in base 16 (HyperSQL)</p>
-<a name="N11CF8" class="indexterm"></a>
+<a name="N11D0C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>HEXTORAW</strong></span>
 </p>
@@ -388,7 +391,7 @@
     digit or a letter in the A | B | C | D | E | F set. Each byte of the
     retired binary string is formed by translating two hex digits into one
     byte. (HyperSQL)</p>
-<a name="N11D0C" class="indexterm"></a>
+<a name="N11D20" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LCASE</strong></span>
 </p>
@@ -398,7 +401,7 @@
 <p>Returns a character string that is the lower-case version of the
     <code class="literal">&lt;char value expr&gt;</code>. Equivalent to SQL/Foundation
     <code class="literal">LOWER (&lt;char value expr&gt;)</code>. (JDBC)</p>
-<a name="N11D20" class="indexterm"></a>
+<a name="N11D34" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LEFT</strong></span>
 </p>
@@ -411,7 +414,7 @@
     expr&gt;</code>. Equivalent to SQL/Foundation<code class="literal">
     SUBSTRING(&lt;char value expr&gt; FROM 0 FOR &lt;count&gt;)</code>.
     (JDBC)</p>
-<a name="N11D37" class="indexterm"></a>
+<a name="N11D4B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LENGTH</strong></span>
 </p>
@@ -421,7 +424,7 @@
 <p>Returns as a BIGINT value the number of characters in
     <code class="literal">&lt;char value expr&gt;</code>. Equivalent to SQL/Foundation
     <code class="literal">CHAR_LENGTH(&lt;char value expr&gt;)</code>. (JDBC)</p>
-<a name="N11D4B" class="indexterm"></a>
+<a name="N11D5F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LOCATE</strong></span>
 </p>
@@ -438,7 +441,7 @@
     LOCATE</code> is equivalent to the SQL Standard function
     <code class="literal">POSITION(&lt;char value expr 1&gt; IN &lt;char value expr
     2&gt;)</code>. (JDBC)</p>
-<a name="N11D6B" class="indexterm"></a>
+<a name="N11D7F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LOWER</strong></span>
 </p>
@@ -446,8 +449,8 @@
 <code class="literal">LOWER ( &lt;char value expr&gt; ) </code>
 </p>
 <p>Returns a character string that is the lower-case version of the
-    <code class="literal">&lt;char value expr&gt;</code>. (Foundation)</p>
-<a name="N11D7C" class="indexterm"></a>
+    <code class="literal">&lt;char value expr&gt;</code>. (SQL:2016)</p>
+<a name="N11D90" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LPAD</strong></span>
 </p>
@@ -462,7 +465,7 @@
     length of the string argument, the argument is truncated. If the optional
     <code class="literal">&lt;char value expr 2&gt;</code> is specified, this string is
     used for padding, instead of spaces. (HyperSQL)</p>
-<a name="N11D96" class="indexterm"></a>
+<a name="N11DAA" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LTRIM</strong></span>
 </p>
@@ -476,7 +479,7 @@
     ' FROM &lt;char value expr1&gt; )</code>. When called with two
     arguments, <code class="literal">&lt;char value expr 2&gt;</code> represents the
     leading character to be removed. (JDBC)</p>
-<a name="N11DAD" class="indexterm"></a>
+<a name="N11DC1" class="indexterm"></a>
 <p>
 <span class="bold"><strong>OCTET_LENGTH</strong></span>
 </p>
@@ -488,8 +491,8 @@
     strings.</p>
 <p>Return a BIGINT value that measures the length of the string in
     octets<code class="literal">. When used with character strings</code>, the octet
-    count is returned, which is twice the normal length. (Foundation)</p>
-<a name="N11DC0" class="indexterm"></a>
+    count is returned, which is twice the normal length. (SQL:2016)</p>
+<a name="N11DD4" class="indexterm"></a>
 <p>
 <span class="bold"><strong>OVERLAY</strong></span>
 </p>
@@ -515,8 +518,8 @@
     <code class="literal">&lt;start position&gt;</code> and in their place, the whole
     <code class="literal">&lt;char value expr 2&gt;</code> is copied.</p>
 <p>The binary version of OVERLAY returns a binary string formed in the
-    same manner as the character version. (Foundation)</p>
-<a name="N11DE5" class="indexterm"></a>
+    same manner as the character version. (SQL:2016)</p>
+<a name="N11DF9" class="indexterm"></a>
 <p>
 <span class="bold"><strong>POSITION</strong></span>
 </p>
@@ -531,8 +534,8 @@
 <p>The character and binary versions of POSITION search the string
     value of the second argument for the first occurrence of the first
     argument string. If the search is successful, the position in the string
-    is returned as a BIGINT. Otherwise zero is returned. (Foundation)</p>
-<a name="N11DF6" class="indexterm"></a>
+    is returned as a BIGINT. Otherwise zero is returned. (SQL:2016)</p>
+<a name="N11E0A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>RAWTOHEX</strong></span>
 </p>
@@ -543,7 +546,7 @@
     representing the bytes in the <code class="literal">&lt;binary value
     expr&gt;</code>. Each byte of the <code class="literal">&lt;binary value
     expr&gt;</code> is translated into two hex digits. (HyperSQL)</p>
-<a name="N11E0A" class="indexterm"></a>
+<a name="N11E1E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>REGEXP_COUNT</strong></span>
 </p>
@@ -556,7 +559,7 @@
     <code class="literal">&lt;regular expression&gt;</code>. The <code class="literal">&lt;regular
     expression&gt;</code> is defined according to Java language regular
     expression rules. Returns 0 if no match is found. (HyperSQL)</p>
-<a name="N11E21" class="indexterm"></a>
+<a name="N11E35" class="indexterm"></a>
 <p>
 <span class="bold"><strong>REGEXP_INSTR</strong></span>
 </p>
@@ -569,7 +572,7 @@
     <code class="literal">&lt;regular expression&gt;</code>. The <code class="literal">&lt;regular
     expression&gt;</code> is defined according to Java language regular
     expression rules. Returns 0 if no match is found. (HyperSQL)</p>
-<a name="N11E38" class="indexterm"></a>
+<a name="N11E4C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>REGEXP_LIKE</strong></span>
 </p>
@@ -577,7 +580,7 @@
 <code class="literal">REGEXP_LIKE ( &lt;char value expr&gt;, &lt;regular
     expression&gt; ) </code>
 </p>
-<a name="N11E44" class="indexterm"></a>
+<a name="N11E58" class="indexterm"></a>
 <p>
 <span class="bold"><strong>REGEXP_MATCHES</strong></span>
 </p>
@@ -590,7 +593,7 @@
     expression&gt;</code> as a whole. The <code class="literal">&lt;regular
     expression&gt;</code> is defined according to Java language regular
     expression rules. (HyperSQL)</p>
-<a name="N11E5B" class="indexterm"></a>
+<a name="N11E6F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>REGEXP_REPLACE</strong></span>
 </p>
@@ -613,7 +616,7 @@
     'n' for the '.' also to match any line terminator, and 'm' for multi-line
     matches. The <code class="literal">&lt;regular expression&gt;</code> is defined
     according to Java language regular expression rules. (HyperSQL)</p>
-<a name="N11E7E" class="indexterm"></a>
+<a name="N11E92" class="indexterm"></a>
 <p>
 <span class="bold"><strong>REGEXP_SUBSTR</strong></span>
 </p>
@@ -621,7 +624,7 @@
 <code class="literal">REGEXP_SUBSTR ( &lt;char value expr&gt;, &lt;regular
     expression&gt; ) </code>
 </p>
-<a name="N11E8A" class="indexterm"></a>
+<a name="N11E9E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>REGEXP_SUBSTRING</strong></span>
 </p>
@@ -634,7 +637,7 @@
     expression&gt;</code>. The <code class="literal">&lt;regular
     expression&gt;</code> is defined according to Java language regular
     expression rules. (HyperSQL)</p>
-<a name="N11EA1" class="indexterm"></a>
+<a name="N11EB5" class="indexterm"></a>
 <p>
 <span class="bold"><strong>REGEXP_SUBSTRING_ARRAY</strong></span>
 </p>
@@ -648,7 +651,7 @@
     expression&gt;</code> is defined according to Java language regular
     expression rules. Returns an array containing the matching regions
     (HyperSQL)</p>
-<a name="N11EB8" class="indexterm"></a>
+<a name="N11ECC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>REPEAT</strong></span>
 </p>
@@ -659,7 +662,7 @@
 <p>Returns a character string based on<code class="literal"> &lt;char value
     expr&gt;</code>, repeated <code class="literal">&lt;count&gt;</code> times.
     (JDBC)</p>
-<a name="N11ECC" class="indexterm"></a>
+<a name="N11EE0" class="indexterm"></a>
 <p>
 <span class="bold"><strong>REPLACE</strong></span>
 </p>
@@ -674,7 +677,7 @@
     the &lt;char value expr 3&gt; defaults to the empty string and calling the
     function simply removes the occurrences of <code class="literal">&lt;char value expr
     2&gt;</code> from the first string.(JDBC)</p>
-<a name="N11EE6" class="indexterm"></a>
+<a name="N11EFA" class="indexterm"></a>
 <p>
 <span class="bold"><strong>REVERSE</strong></span>
 </p>
@@ -683,7 +686,7 @@
 </p>
 <p>Returns a character string based on <code class="literal">&lt;char value
     expr&gt;</code> with characters in the reverse order. (HyperSQL)</p>
-<a name="N11EF7" class="indexterm"></a>
+<a name="N11F0B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>RIGHT</strong></span>
 </p>
@@ -694,7 +697,7 @@
 <p>Returns a character string consisting of the last
     <code class="literal">&lt;count&gt;</code> characters of <code class="literal">&lt;char value
     expr&gt;</code>. (JDBC)</p>
-<a name="N11F0B" class="indexterm"></a>
+<a name="N11F1F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>RPAD</strong></span>
 </p>
@@ -709,7 +712,7 @@
     the length of the string argument, the argument is truncated. If the
     optional <code class="literal">&lt;char value expr 2&gt;</code> is specified, this
     string is used for padding, instead of spaces. (HyperSQL)</p>
-<a name="N11F25" class="indexterm"></a>
+<a name="N11F39" class="indexterm"></a>
 <p>
 <span class="bold"><strong>RTRIM</strong></span>
 </p>
@@ -723,7 +726,7 @@
     ' FROM &lt;character string&gt;)</code>. When called with two
     arguments, <code class="literal">&lt;char value expr 2&gt;</code> represents the
     trailing character to be removed. (JDBC)</p>
-<a name="N11F3C" class="indexterm"></a>
+<a name="N11F50" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SOUNDEX</strong></span>
 </p>
@@ -732,9 +735,12 @@
 </p>
 <p>Returns a four-character code representing the sound of
     <code class="literal">&lt;char value expr&gt;</code>. The US census algorithm is
-    used. For example, the soundex value for "Washington" is W252.
-    (JDBC)</p>
-<a name="N11F4D" class="indexterm"></a>
+    used. For example, the soundex value for "Washington" is W252. This
+    function is used for storing the soundex of names in a column of a table,
+    then searching this column for strings matching the soundex of the search
+    string, then comparing the actual names stored in the database with the
+    search string. (JDBC)</p>
+<a name="N11F61" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SPACE</strong></span>
 </p>
@@ -743,7 +749,7 @@
 </p>
 <p>Returns a character string consisting of <code class="literal">&lt;count&gt;
     </code>spaces. (JDBC)</p>
-<a name="N11F5E" class="indexterm"></a>
+<a name="N11F72" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SUBSTR</strong></span>
 </p>
@@ -756,7 +762,7 @@
     <code class="literal">&lt;length&gt;</code> characters from <code class="literal">&lt;char value
     expr&gt; </code>starting at the <code class="literal">&lt;offset&gt;</code>
     position. (JDBC)</p>
-<a name="N11F78" class="indexterm"></a>
+<a name="N11F8C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SUBSTRING</strong></span>
 </p>
@@ -775,8 +781,8 @@
     optional<code class="literal"> &lt;string length&gt;</code> is specified, only
     <code class="literal">&lt;string length&gt; </code>characters are returned.</p>
 <p>The binary version of SUBSTRING returns a binary string in the same
-    manner. (Foundation)</p>
-<a name="N11F97" class="indexterm"></a>
+    manner. (SQL:2016)</p>
+<a name="N11FAB" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TO_BASE64</strong></span>
 </p>
@@ -785,7 +791,7 @@
 </p>
 <p>Returns a character string as a base 64 representation of the bytes
     in the <code class="literal">&lt;binary value expr&gt;</code>. (HyperSQL)</p>
-<a name="N11FA8" class="indexterm"></a>
+<a name="N11FBC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TRIM</strong></span>
 </p>
@@ -810,8 +816,8 @@
     <code class="literal">&lt;binary value expr&gt;</code>. Consecutive instances of
     <code class="literal">&lt;trim octet&gt; </code>are removed in the same manner as in
     the character version. If<code class="literal"> [ &lt;trim octet&gt; ]</code> is not
-    specified, the 0 octet is used as default. (Foundation)</p>
-<a name="N11FD6" class="indexterm"></a>
+    specified, the 0 octet is used as default. (SQL:2016)</p>
+<a name="N11FEA" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TRANSLATE</strong></span>
 </p>
@@ -834,7 +840,7 @@
  TRANSLATE( acolumn, '&Aacute;&Ccedil;&Eacute;&Iacute;&Oacute;&Uacute;&Agrave;&Egrave;&Igrave;&Ograve;&Ugrave;&Acirc;&Ecirc;&Icirc;&Ocirc;&Ucirc;&Atilde;&Otilde;&Euml;&Uuml;&aacute;&ccedil;&eacute;&iacute;&oacute;&uacute;&agrave;&egrave;&igrave;&ograve;&ugrave;&acirc;&ecirc;&icirc;&ocirc;&ucirc;&atilde;&otilde;&euml;&uuml;', 'ACEIOUAEIOUAEIOUAOEUaceiouaeiouaeiouaoeu');
 </pre>
 </div>
-<a name="N11FF9" class="indexterm"></a>
+<a name="N1200D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>UCASE</strong></span>
 </p>
@@ -844,7 +850,7 @@
 <p>Returns a character string that is the upper case version of the
     <code class="literal">&lt;char value expr&gt;</code>. Equivalent to SQL/Foundation
     <code class="literal">UPPER( &lt;char value expr&gt; )</code>. (JDBC)</p>
-<a name="N1200D" class="indexterm"></a>
+<a name="N12021" class="indexterm"></a>
 <p>
 <span class="bold"><strong>UPPER</strong></span>
 </p>
@@ -852,8 +858,8 @@
 <code class="literal">UPPER ( &lt;char value expr&gt; ) </code>
 </p>
 <p>Returns a character string that is the upper case version of the
-    <code class="literal">&lt;char value expr&gt;</code> . (Foundation)</p>
-<a name="N1201E" class="indexterm"></a>
+    <code class="literal">&lt;char value expr&gt;</code> . (SQL:2016)</p>
+<a name="N12032" class="indexterm"></a>
 <p>
 <span class="bold"><strong>UNHEX</strong></span>
 </p>
@@ -863,7 +869,7 @@
 <p>Returns a binary string formed by translation of hexadecimal digits
     and letters in the &lt;<code class="literal">char value expr&gt;</code>. Exactly the
     same as the <code class="literal">HEXTORAW</code> function. (HyperSQL)</p>
-<a name="N12032" class="indexterm"></a>
+<a name="N12046" class="indexterm"></a>
 <p>
 <span class="bold"><strong>UNISTR</strong></span>
 </p>
@@ -880,11 +886,177 @@
 <div>
 <div>
 <h2 class="title" style="clear: both">
+<a name="bfc_JSON_functions"></a>JSON Functions</h2>
+</div>
+</div>
+</div>
+<p>JSON constructor functions convert SQL data into JSON values, These
+    functions are supported by HyperSQL according to the SQL:2016 Standard.
+    Each function returns a JSON object or JSON array as a string. The format
+    conforms to the IETF rfc:7159 document, The JavaScript Object Notation
+    (JSON) Data Interchange Format.</p>
+<p>In the BNF, <code class="literal">&lt;JSON value expr&gt;</code> indicates any
+    valid SQL expression that evaluates to a single value. This includes
+    strings, numbers and booleans. Binary values are represented as
+    hexadecimal strings. All other types, including dates and timestamps, are
+    represented as strings. An optional <code class="literal">FORMAT JSON</code> is used
+    when the result of the value expression is already a string in the JSON
+    format.</p>
+<p>
+<code class="literal">&lt;JSON value expr&gt; ::= &lt;value expression&gt; [
+    FORMAT JSON ]</code>
+</p>
+<p>The optional <code class="literal">&lt;JSON constructor null clause&gt;</code>
+    indicates whether NULL values are represented as JSON nulls or are omitted
+    from the result. The default behaviour is <code class="literal">ABSENT ON
+    NULL</code> for <code class="literal">JSON_ARRAY</code>, and <code class="literal">NULL ON
+    NULL</code> for <code class="literal">JSON_OBJECT</code>.</p>
+<p>
+<code class="literal">&lt;JSON null clause&gt; ::= NULL ON NULL | ABSENT ON
+    NULL</code>
+</p>
+<p>The optional <code class="literal">&lt;JSON output clause&gt;</code> allows
+    you to change the maximum length of the returned string from the default
+    32K bytes.</p>
+<p>
+<code class="literal">&lt;JSON output clause&gt; ::= RETURNING
+    VARCHAR(N)</code>
+</p>
+<p>JSON function calls can be nested to construct more complex objects
+    containing arrays, objects, and arrays of objects.</p>
+<a name="N12089" class="indexterm"></a>
+<p>
+<span class="bold"><strong>JSON_ARRAY</strong></span>
+</p>
+<p>
+<code class="literal">JSON_ARRAY ( &lt;JSON value expr&gt;, ... [&lt;JSON null
+    caluse&gt;] [&lt;JSON output caluse&gt;])</code>
+</p>
+<p>The first form of <code class="literal">JSON_ARRAY</code> is a variable
+    argument function, It converts the values from a series of value
+    expression into a single JSON array.</p>
+<p>
+<code class="literal">JSON_ARRAY ( &lt;query expression&gt; [ FORMAT JSON ]
+    [&lt;JSON null caluse&gt;] [&lt;JSON output caluse&gt;])</code>
+</p>
+<p>The second form of <code class="literal">JSON_ARRAY</code> converts the values
+    from a single &lt;query expression&gt; into a JSON array.
+    (SQL:2016)</p>
+<div class="informalexample">
+<pre class="programlisting">-- a JSON array is constructed from a single row of the table
+
+SELECT JSON_ARRAY( country_id , name, local_name ) FROM places.countries WHERE country_id = 'ESP'
+ 
+C1                       
+------------------------ 
+["ESP","Spain","Espa&ntilde;a"]
+
+-- a JSON array is constructed from all rows of the table
+
+VALUES JSON_ARRAY(SELECT name FROM countries)
+  
+C1                                                                    
+--------------------------------------------------------------------- 
+["Austria","Switzerland","Germany","Spain","France","Italy","Sweden"]
+</pre>
+</div>
+<a name="N120A5" class="indexterm"></a>
+<p>
+<span class="bold"><strong>JSON_ARRAYAGG</strong></span>
+</p>
+<p>
+<code class="literal">JSON_ARRAYAGG ( &lt;JSON value expr&gt; [&lt;order by
+    clause&gt;] [&lt;JSON null caluse&gt;] )</code>
+</p>
+<p>
+<code class="literal">JSON_ARRAYAGG</code> is an aggregate function similar to
+    the <code class="literal">ARRAY_AGG</code> SQL function, It evaluates a value
+    expression over a series of rows and combines the values, separated by
+    commas, into a single JSON array. Returns a JSON string. (SQL:2016)</p>
+<div class="informalexample">
+<pre class="programlisting">-- a JSON array is constructed from all rows of the table
+
+SELECT JSON_ARRAYAGG( country_id ) FROM places.countries
+ 
+C1                                          
+------------------------------------------- 
+["AUT","CHE","DEU","ESP","FRA","ITA","SWE"]
+</pre>
+</div>
+<a name="N120BB" class="indexterm"></a>
+<p>
+<span class="bold"><strong>JSON_OBJECT</strong></span>
+</p>
+<p>
+<code class="literal">JSON_OBJECT ( &lt;JSON name and value&gt;, ... [&lt;JSON
+    null caluse&gt;] [ { WITH | WITHOUT } UNIQUE [ KEYS] ] )</code>
+</p>
+<p>
+<code class="literal">JSON_OBJECT</code> is a variable argument function, It
+    combines a series of keys and values into a single JSON object. Returns a
+    JSON string.</p>
+<p>There are two supported syntax forms for key:value pairs.</p>
+<p>
+<code class="literal">&lt;JSON name and value&gt; ::= &lt;JSON name&gt;
+    &lt;colon&gt; &lt;JSON value expression&gt; | [ KEY ] &lt;JSON name&gt;
+    VALUE &lt;JSON value expression&gt; </code>
+</p>
+<p>The optional <code class="literal">WITH UNIQUE KEYS</code> clause forces an
+    error if the keys within the JSON object are not unique. The default is
+    <code class="literal">WITHOUT UNIQUE KEYS</code>. (SQL:2016)</p>
+<div class="informalexample">
+<pre class="programlisting">-- a JSON object is constructed from each row of the table; both syntax options are shown
+
+SELECT country_id, JSON_OBJECT( country_id : name ) FROM places.countries
+
+SELECT country_id, JSON_OBJECT( KEY country_id  VALUE name ) FROM places.countries
+ 
+ 
+COUNTRY_ID C2                    
+---------- --------------------- 
+AUT        {"AUT":"Austria"}     
+CHE        {"CHE":"Switzerland"} 
+DEU        {"DEU":"Germany"}     
+ESP        {"ESP":"Spain"}       
+FRA        {"FRA":"France"}      
+ITA        {"ITA":"Italy"}       
+SWE        {"SWE":"Sweden"}
+</pre>
+</div>
+<a name="N120DB" class="indexterm"></a>
+<p>
+<span class="bold"><strong>JSON_OBJECTAGG</strong></span>
+</p>
+<p>
+<code class="literal">JSON_OBJECTAGG ( &lt;JSON name and value&gt; [&lt;JSON null
+    caluse&gt;] [ { WITH | WITHOUT } UNIQUE [ KEYS] ] )</code>
+</p>
+<p>
+<code class="literal">JSON_OBJECTAGG</code> is an aggregate function similar
+    to the <code class="literal">ARRAY_AGG</code> SQL function, It constructs a JSON
+    object by using keys and values from the aggregated rows.
+    (SQL:2016)</p>
+<div class="informalexample">
+<pre class="programlisting">-- a JSON object is constructed from multiple rows of the table
+
+SELECT JSON_OBJECTAGG( country_id : name ) FROM places.countries
+ 
+C1                                                                                                                                                 
+--------------------------------------------------------------------------------------------------------------- 
+{"AUT":"Austria","CHE":"Switzerland","DEU":"Germany","ESP":"Spain","FRA":"France","ITA":"Italy","SWE":"Sweden"}
+</pre>
+</div>
+</div>
+<div class="section">
+<div class="titlepage">
+<div>
+<div>
+<h2 class="title" style="clear: both">
 <a name="bfc_numeric_functions"></a>Numeric Functions</h2>
 </div>
 </div>
 </div>
-<a name="N1204A" class="indexterm"></a>
+<a name="N120F5" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ABS</strong></span>
 </p>
@@ -893,8 +1065,8 @@
     ) </code>
 </p>
 <p>Returns the absolute value of the argument as a value of the same
-    type. (JDBC and Foundation)</p>
-<a name="N12058" class="indexterm"></a>
+    type. (JDBC and SQL:2016)</p>
+<a name="N12103" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ACOS</strong></span>
 </p>
@@ -903,7 +1075,7 @@
 </p>
 <p>Returns the arc-cosine of the argument in radians as a value of
     DOUBLE type. (JDBC)</p>
-<a name="N12066" class="indexterm"></a>
+<a name="N12111" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ASIN</strong></span>
 </p>
@@ -912,7 +1084,7 @@
 </p>
 <p>Returns the arc-sine of the argument in radians as a value of DOUBLE
     type. (JDBC)</p>
-<a name="N12074" class="indexterm"></a>
+<a name="N1211F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ATAN</strong></span>
 </p>
@@ -921,7 +1093,7 @@
 </p>
 <p>Returns the arc-tangent of the argument in radians as a value of
     DOUBLE type. (JDBC)</p>
-<a name="N12082" class="indexterm"></a>
+<a name="N1212D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ATAN2</strong></span>
 </p>
@@ -934,7 +1106,7 @@
     <code class="varname">y</code> coordinates of a point. Returns the angle, in
     radians, representing the angle coordinate of the point in polar
     coordinates, as a value of DOUBLE type. (JDBC)</p>
-<a name="N1209C" class="indexterm"></a>
+<a name="N12147" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CEILING</strong></span>
 </p>
@@ -945,8 +1117,8 @@
 <p>Returns the smallest integer greater than or equal to the argument.
     If the argument is exact numeric then the result is exact numeric with a
     scale of 0. If the argument is approximate numeric, then the result is of
-    DOUBLE type. (JDBC and Foundation)</p>
-<a name="N120AA" class="indexterm"></a>
+    DOUBLE type. (JDBC and SQL:2016)</p>
+<a name="N12155" class="indexterm"></a>
 <p>
 <span class="bold"><strong>BITAND</strong></span>
 </p>
@@ -958,7 +1130,7 @@
 <code class="literal">BITAND ( &lt;bit value expr 1&gt;, &lt;bit value expr 2&gt;
     )</code>
 </p>
-<a name="N120B9" class="indexterm"></a>
+<a name="N12164" class="indexterm"></a>
 <p>
 <span class="bold"><strong>BITANDNOT</strong></span>
 </p>
@@ -970,7 +1142,7 @@
 <code class="literal">BITANDNOT ( &lt;bit value expr 1&gt;, &lt;bit value expr
     2&gt; )</code>
 </p>
-<a name="N120C8" class="indexterm"></a>
+<a name="N12173" class="indexterm"></a>
 <p>
 <span class="bold"><strong>BITNOT</strong></span>
 </p>
@@ -980,7 +1152,7 @@
 <p>
 <code class="literal">BITNOT ( &lt;bit value expr 1&gt; )</code>
 </p>
-<a name="N120D7" class="indexterm"></a>
+<a name="N12182" class="indexterm"></a>
 <p>
 <span class="bold"><strong>BITOR</strong></span>
 </p>
@@ -992,7 +1164,7 @@
 <code class="literal">BITOR ( &lt;bit value expr 1&gt;, &lt;bit value expr 2&gt;
     )</code>
 </p>
-<a name="N120E6" class="indexterm"></a>
+<a name="N12191" class="indexterm"></a>
 <p>
 <span class="bold"><strong>BITXOR</strong></span>
 </p>
@@ -1012,7 +1184,7 @@
     arguments. The names of the function indicate NOT, OR, AND, XOR
     operations. The BITANDNOT performs NOT on the second argument, then
     performs AND on result and the first argument. (HyperSQL)</p>
-<a name="N120F7" class="indexterm"></a>
+<a name="N121A2" class="indexterm"></a>
 <p>
 <span class="bold"><strong>COS</strong></span>
 </p>
@@ -1021,7 +1193,7 @@
 </p>
 <p>Returns the cosine of the argument (an angle expressed in radians)
     as a value of DOUBLE type. (JDBC)</p>
-<a name="N12105" class="indexterm"></a>
+<a name="N121B0" class="indexterm"></a>
 <p>
 <span class="bold"><strong>COSH</strong></span>
 </p>
@@ -1030,7 +1202,7 @@
 </p>
 <p>Returns the hyperbolic cosine of the argument as a value of DOUBLE
     type. (HyperSQL)</p>
-<a name="N12113" class="indexterm"></a>
+<a name="N121BE" class="indexterm"></a>
 <p>
 <span class="bold"><strong>COT</strong></span>
 </p>
@@ -1040,7 +1212,7 @@
 <p>Returns the cotangent of the argument as a value of DOUBLE type. The
     <code class="literal">&lt;num value expr&gt;</code> represents an angle expressed in
     radians. (JDBC)</p>
-<a name="N12124" class="indexterm"></a>
+<a name="N121CF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DEGREES</strong></span>
 </p>
@@ -1050,7 +1222,7 @@
 <p>Converts the argument (an angle expressed in<code class="literal">
     radians</code>) into degrees and returns the value in the DOUBLE type.
     (JDBC)</p>
-<a name="N12135" class="indexterm"></a>
+<a name="N121E0" class="indexterm"></a>
 <p>
 <span class="bold"><strong>EXP</strong></span>
 </p>
@@ -1058,8 +1230,8 @@
 <code class="literal">EXP ( &lt;num value expr&gt; ) </code>
 </p>
 <p>Returns the exponential value of the argument as a value of DOUBLE
-    type. (JDBC and Foundation)</p>
-<a name="N12143" class="indexterm"></a>
+    type. (JDBC and SQL:2016)</p>
+<a name="N121EE" class="indexterm"></a>
 <p>
 <span class="bold"><strong>FLOOR</strong></span>
 </p>
@@ -1069,8 +1241,8 @@
 <p>Returns the largest integer that is less than or equal to the
     argument. If the argument is exact numeric then the result is exact
     numeric with a scale of 0. If the argument is approximate numeric, then
-    the result is of DOUBLE type. (JDBC and Foundation)</p>
-<a name="N12151" class="indexterm"></a>
+    the result is of DOUBLE type. (JDBC and SQL:2016)</p>
+<a name="N121FC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LN</strong></span>
 </p>
@@ -1078,8 +1250,8 @@
 <code class="literal">LN ( &lt;num value expr&gt; ) </code>
 </p>
 <p>Returns the natural logarithm of the argument, as a value of DOUBLE
-    type. (Foundation)</p>
-<a name="N1215F" class="indexterm"></a>
+    type. (SQL:2016)</p>
+<a name="N1220A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LOG</strong></span>
 </p>
@@ -1088,7 +1260,7 @@
 </p>
 <p>Returns the natural logarithm of the argument, as a value of DOUBLE
     type. (JDBC)</p>
-<a name="N1216D" class="indexterm"></a>
+<a name="N12218" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LOG10</strong></span>
 </p>
@@ -1097,7 +1269,7 @@
 </p>
 <p>Returns the base 10 logarithm of the argument as a value of DOUBLE
     type. (JDBC)</p>
-<a name="N1217B" class="indexterm"></a>
+<a name="N12226" class="indexterm"></a>
 <p>
 <span class="bold"><strong>MOD</strong></span>
 </p>
@@ -1108,8 +1280,8 @@
 <p>Returns the remainder (modulus) of <code class="literal">&lt;num value expr
     1&gt;</code> divided by <code class="literal">&lt;num value expr 2&gt;.</code>
     The data type of the returned value is the same as the second argument.
-    (JDBC and Foundation)</p>
-<a name="N1218F" class="indexterm"></a>
+    (JDBC and SQL:2016)</p>
+<a name="N1223A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>NANVL</strong></span>
 </p>
@@ -1121,7 +1293,7 @@
     <code class="literal">&lt;num value expr 1&gt;</code> as <code class="literal">&lt;num value expr
     2&gt;.</code>, otherwise returns the first argument. The data type of
     the returned value is DOUBLE. (HyperSQL)</p>
-<a name="N121A3" class="indexterm"></a>
+<a name="N1224E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>PI</strong></span>
 </p>
@@ -1129,7 +1301,7 @@
 <code class="literal">PI () </code>
 </p>
 <p>Returns the constant pi as a value of DOUBLE type. (JDBC)</p>
-<a name="N121B1" class="indexterm"></a>
+<a name="N1225C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>POWER</strong></span>
 </p>
@@ -1139,8 +1311,8 @@
 </p>
 <p>Returns the value of <code class="literal">&lt;num value expr 1&gt;</code>
     raised to the power of <code class="literal">&lt;int value expr 2&gt;</code> as a
-    value of DOUBLE type. (JDBC and Foundation)</p>
-<a name="N121C5" class="indexterm"></a>
+    value of DOUBLE type. (JDBC and SQL:2016)</p>
+<a name="N12270" class="indexterm"></a>
 <p>
 <span class="bold"><strong>RADIANS</strong></span>
 </p>
@@ -1150,7 +1322,7 @@
 <p>Converts the argument (an angle expressed in<code class="literal">
     degrees</code>) into radians and returns the value in the DOUBLE type.
     (JDBC)</p>
-<a name="N121D6" class="indexterm"></a>
+<a name="N12281" class="indexterm"></a>
 <p>
 <span class="bold"><strong>RAND</strong></span>
 </p>
@@ -1162,7 +1334,7 @@
     session has a separate random number generator. The first call that uses a
     seed parameter sets the seed for subsequent calls that do not include a
     parameter. (JDBC)</p>
-<a name="N121E7" class="indexterm"></a>
+<a name="N12292" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ROUND</strong></span>
 </p>
@@ -1182,7 +1354,7 @@
     and the argument and result are DOUBLE, It rounds the value towards the
     closest even value.</p>
 <p>The datetime version is discussed in the next section. (JDBC)</p>
-<a name="N12205" class="indexterm"></a>
+<a name="N122B0" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SIGN</strong></span>
 </p>
@@ -1192,7 +1364,7 @@
 <p>Returns an INTEGER, indicating the sign of the argument. If the
     argument is negative then -1 is returned. If it is equal to zero then 0 is
     returned. If the argument is positive then 1 is returned. (JDBC)</p>
-<a name="N12213" class="indexterm"></a>
+<a name="N122BE" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SIN</strong></span>
 </p>
@@ -1201,7 +1373,7 @@
 </p>
 <p>Returns the sine of the argument (an angle expressed in radians) as
     a value of DOUBLE type. (JDBC)</p>
-<a name="N12221" class="indexterm"></a>
+<a name="N122CC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SINH</strong></span>
 </p>
@@ -1210,7 +1382,7 @@
 </p>
 <p>Returns the hyperbolic sine of the argument as a value of DOUBLE
     type. (HyperSQL)</p>
-<a name="N1222F" class="indexterm"></a>
+<a name="N122DA" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SQRT</strong></span>
 </p>
@@ -1218,8 +1390,8 @@
 <code class="literal">SQRT ( &lt;num value expr&gt; ) </code>
 </p>
 <p>Returns the square root of the argument as a value of DOUBLE type.
-    (JDBC and Foundation)</p>
-<a name="N1223D" class="indexterm"></a>
+    (JDBC and SQL:2016)</p>
+<a name="N122E8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TAN</strong></span>
 </p>
@@ -1228,7 +1400,7 @@
 </p>
 <p>Returns the tangent of the argument (an angle expressed in radians)
     as a value of DOUBLE type. (JDBC)</p>
-<a name="N1224B" class="indexterm"></a>
+<a name="N122F6" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TANH</strong></span>
 </p>
@@ -1237,7 +1409,7 @@
 </p>
 <p>Returns the hyperbolic tangent of the argument as a value of DOUBLE
     type. (HyperSQL)</p>
-<a name="N12259" class="indexterm"></a>
+<a name="N12304" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TO_NUMBER</strong></span>
 </p>
@@ -1248,7 +1420,7 @@
     string must consist of digits and can have a decimal point. Use the SQL
     Standard CAST expression instead of this non-standard function.
     (HyperSQL)</p>
-<a name="N12267" class="indexterm"></a>
+<a name="N12312" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TRUNC</strong></span>
 </p>
@@ -1261,7 +1433,7 @@
     used in its place.</p>
 <p>The datetime version is discussed in the next section.
     (HyperSQL)</p>
-<a name="N1227A" class="indexterm"></a>
+<a name="N12325" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TRUNCATE</strong></span>
 </p>
@@ -1284,7 +1456,7 @@
     column reference) then the type of the return value is always the same as
     the type of the first argument. In this case, the discarded digits are
     replaced with zeros. (JDBC)</p>
-<a name="N12296" class="indexterm"></a>
+<a name="N12341" class="indexterm"></a>
 <p>
 <span class="bold"><strong>WIDTH_BUCKET</strong></span>
 </p>
@@ -1305,7 +1477,7 @@
     arguments, including <code class="literal">&lt;int value expr&gt;</code> smaller
     than 1, or equal values for <code class="literal">&lt;value expr 2&gt;</code> and
     <code class="literal">&lt;value expr 3&gt;</code> will cause an exception.
-    (Foundation)</p>
+    (SQL:2016)</p>
 <p>An example is given below:</p>
 <div class="informalexample">
 <pre class="programlisting"> WIDTH_BUCKET( 5, 10, 110, 10)
@@ -1341,33 +1513,36 @@
 </div>
 </div>
 </div>
-<a name="N122D0" class="indexterm"></a>
+<a name="N1237B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TIMEZONE</strong></span>
 </p>
 <p>
 <code class="literal">TIMEZONE()</code>
 </p>
-<p>Returns the current time zone for the session. Returns an INTERVAL
-      HOUR TO MINUTE value. (HyperSQL)</p>
-<a name="N122DE" class="indexterm"></a>
+<p>Returns the current time zone for the session. This value is the
+      same as SESSION_TIMEZONE if the user has not changed the TIME ZONE of
+      the session. Returns an INTERVAL HOUR TO MINUTE value. (HyperSQL)</p>
+<a name="N12389" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SESSION_TIMEZONE</strong></span>
 </p>
 <p>
 <code class="literal">SESSION_TIMEZONE()</code>
 </p>
-<p>Returns the default time zone for the current session. Returns an
-      INTERVAL HOUR TO MINUTE value. (HyperSQL)</p>
-<a name="N122EC" class="indexterm"></a>
+<p>Returns the default time zone for the current session. This value
+      is based on the default Java Calendar for the current session. Returns
+      an INTERVAL HOUR TO MINUTE value. (HyperSQL)</p>
+<a name="N12397" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SESSIONTIMEZONE</strong></span>
 </p>
 <p>
 <code class="literal">SESSIONTIMEZONE()</code>
 </p>
-<p>Same as SESSION_TIMEZONE. (HyperSQL)</p>
-<a name="N122FA" class="indexterm"></a>
+<p>Similar to SESSION_TIMEZONE but converts the INTERVAL to a
+      VARCHAR. (HyperSQL)</p>
+<a name="N123A5" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DATABASE_TIMEZONE</strong></span>
 </p>
@@ -1395,14 +1570,14 @@
 </div>
 </div>
 </div>
-<a name="N12315" class="indexterm"></a>
+<a name="N123C0" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CURRENT_DATE</strong></span>
 </p>
 <p>
 <code class="literal">CURRENT_DATE</code>
 </p>
-<a name="N12321" class="indexterm"></a>
+<a name="N123CC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CURRENT_TIME</strong></span>
 </p>
@@ -1410,14 +1585,14 @@
 <code class="literal">CURRENT_TIME [ ( &lt;time precision&gt; )
       ]</code>
 </p>
-<a name="N1232D" class="indexterm"></a>
+<a name="N123D8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LOCALTIME</strong></span>
 </p>
 <p>
 <code class="literal">LOCALTIME [ ( &lt;time precision&gt; ) ]</code>
 </p>
-<a name="N12339" class="indexterm"></a>
+<a name="N123E4" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CURRENT_TIMESTAMP</strong></span>
 </p>
@@ -1425,7 +1600,7 @@
 <code class="literal">CURRENT_TIMESTAMP [ ( &lt;timestamp precision&gt; )
       ]</code>
 </p>
-<a name="N12345" class="indexterm"></a>
+<a name="N123F0" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LOCALTIMESTAMP</strong></span>
 </p>
@@ -1434,17 +1609,22 @@
       ]</code>
 </p>
 <p>These datetime functions return the datetime value representing
-      the moment the function is called. CURRENT_DATE returns a value of DATE
-      type. CURRENT_TIME returns a value of TIME WITH TIME ZONE type.
-      LOCALTIME returns a value of TIME type. CURRENT_TIMESTAMP returns a
-      value of TIMESTAMP WITH TIME ZONE type. LOCALTIMESTAMP returns a value
-      of TIMESTAMP type. If the optional <code class="literal">[ ( &lt;time precision&gt; )
-      ]</code> or<code class="literal"> [ ( &lt;timestamp precision&gt; ) ]</code> is
-      used, then the returned value has the specified fraction of the second
-      precision. When the functions are used multiple times in a single SQL
-      statement, the returned values represent the same point of time.
-      (Foundation)</p>
-<a name="N12359" class="indexterm"></a>
+      the moment the function is called. <code class="literal">CURRENT_DATE</code>
+      returns a value of DATE type. <code class="literal">CURRENT_TIME</code> returns a
+      value of TIME WITH TIME ZONE type. <code class="literal">LOCALTIME</code> returns
+      a value of TIME type. <code class="literal">CURRENT_TIMESTAMP</code> returns a
+      value of TIMESTAMP WITH TIME ZONE type.
+      <code class="literal">LOCALTIMESTAMP</code> returns a value of TIMESTAMP type. The
+      time zone of the SQL session is used. If the optional <code class="literal">[ (
+      &lt;time precision&gt; ) ]</code> or<code class="literal"> [ ( &lt;timestamp
+      precision&gt; ) ]</code> is used, then the returned value has the
+      specified fraction of the second precision. When the functions are used
+      multiple times in a single SQL statement, the returned values represent
+      the same point of time.</p>
+<p>From version 2.7.0 the functions return values with microsecond
+      precision. Previous versions returned values with millisecond precision.
+      (SQL:2016)</p>
+<a name="N12415" class="indexterm"></a>
 <p>
 <span class="bold"><strong>NOW</strong></span>
 </p>
@@ -1454,7 +1634,7 @@
 <p>This function is equivalent to <code class="literal">LOCALTIMESTAMP</code>.
       It can be used as a no-arg function as the parens are optional.
       (HyperSQL)</p>
-<a name="N1236A" class="indexterm"></a>
+<a name="N12426" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CURDATE</strong></span>
 </p>
@@ -1463,7 +1643,7 @@
 </p>
 <p>This function is equivalent to<code class="literal"> CURRENT_DATE</code>.
       (JDBC)</p>
-<a name="N1237B" class="indexterm"></a>
+<a name="N12437" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CURTIME</strong></span>
 </p>
@@ -1472,7 +1652,7 @@
 </p>
 <p>This function is equivalent to<code class="literal"> LOCALTIME</code>.
       (JDBC)</p>
-<a name="N1238C" class="indexterm"></a>
+<a name="N12448" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SYSDATE</strong></span>
 </p>
@@ -1482,7 +1662,7 @@
 <p>This no-arg function is similar to <code class="literal">LOCALTIMESTAMP
       </code>but it returns the timestamp without fraction of second.
       (HyperSQL)</p>
-<a name="N1239D" class="indexterm"></a>
+<a name="N12459" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SYSTIMESTAMP</strong></span>
 </p>
@@ -1492,7 +1672,7 @@
 <p>This no-arg function is similar to
       <code class="literal">CURRENT_TIMESTAMP</code> and is enabled in ORA syntax mode
       only. It returns the timestamp when it is called. (HyperSQL)</p>
-<a name="N123AE" class="indexterm"></a>
+<a name="N1246A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TODAY</strong></span>
 </p>
@@ -1511,15 +1691,15 @@
 </div>
 </div>
 </div>
-<a name="N123C3" class="indexterm"></a>
+<a name="N1247F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DATENAME, DATEPART and
       EOMONTH</strong></span>
 </p>
 <p>These functions are available in the MSS compatibility mode and
-      perform the equivalent of EXTRACT function or the LAST_DAY function.
-      (HyperSQL)</p>
-<a name="N123CE" class="indexterm"></a>
+      perform the equivalent of <code class="literal">EXTRACT</code> function or the
+      <code class="literal">LAST_DAY</code> function. (HyperSQL)</p>
+<a name="N12490" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DAYNAME</strong></span>
 </p>
@@ -1529,7 +1709,7 @@
 <p>This function is equivalent to<code class="literal"> EXTRACT ( DAY_NAME FROM
       ... ) </code>Returns a string in the range of Sunday - Saturday.
       (JDBC)</p>
-<a name="N123DF" class="indexterm"></a>
+<a name="N124A1" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DAYOFMONTH</strong></span>
 </p>
@@ -1540,7 +1720,7 @@
 <p>This function is equivalent to<code class="literal"> EXTRACT ( DAY_OF_MONTH
       FROM ... ) </code>Returns an integer value in the range of 1-31.
       (JDBC)</p>
-<a name="N123F0" class="indexterm"></a>
+<a name="N124B2" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DAYOFWEEK</strong></span>
 </p>
@@ -1551,7 +1731,7 @@
 <p>This function is equivalent to <code class="literal">EXTRACT ( DAY_OF_WEEK FROM
       ... ) </code>Returns an integer value in the range of 1-7. The first
       day of the week is Sunday. (JDBC)</p>
-<a name="N12401" class="indexterm"></a>
+<a name="N124C3" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DAYOFYEAR</strong></span>
 </p>
@@ -1562,7 +1742,7 @@
 <p>This function is equivalent to <code class="literal">EXTRACT ( DAY_OF_YEAR FROM
       ... ) </code>Returns an integer value in the range of 1-366.
       (JDBC)</p>
-<a name="N12412" class="indexterm"></a>
+<a name="N124D4" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DAYS</strong></span>
 </p>
@@ -1572,7 +1752,7 @@
 <p>The <code class="literal">&lt;datetime value expr&gt; </code>is of DATE or
       TIMESTAMP type. This function returns the DAY number since the first day
       of the calendar. The first day is numbered 1. (HyperSQL)</p>
-<a name="N12423" class="indexterm"></a>
+<a name="N124E5" class="indexterm"></a>
 <p>
 <span class="bold"><strong>HOUR</strong></span>
 </p>
@@ -1581,7 +1761,7 @@
 </p>
 <p>This function is equivalent to <code class="literal">EXTRACT ( HOUR FROM ... )
       </code>Returns an integer value in the range of 0-23. (JDBC)</p>
-<a name="N12434" class="indexterm"></a>
+<a name="N124F6" class="indexterm"></a>
 <p>
 <span class="bold"><strong>MINUTE</strong></span>
 </p>
@@ -1591,7 +1771,7 @@
 <p>This function is equivalent to<code class="literal"> EXTRACT ( MINUTE FROM ...
       ) </code>Returns an integer value in the range of 0 - 59.
       (JDBC)</p>
-<a name="N12445" class="indexterm"></a>
+<a name="N12507" class="indexterm"></a>
 <p>
 <span class="bold"><strong>MONTH</strong></span>
 </p>
@@ -1600,7 +1780,7 @@
 </p>
 <p>This function is equivalent to <code class="literal">EXTRACT ( MONTH FROM ... )
       </code>Returns an integer value in the range of 1-12. (JDBC)</p>
-<a name="N12456" class="indexterm"></a>
+<a name="N12518" class="indexterm"></a>
 <p>
 <span class="bold"><strong>MONTHNAME</strong></span>
 </p>
@@ -1611,7 +1791,7 @@
 <p>This function is equivalent to <code class="literal">EXTRACT ( NAME_OF_MONTH
       FROM ... ) </code>Returns a string in the range of January -
       December. (JDBC)</p>
-<a name="N12467" class="indexterm"></a>
+<a name="N12529" class="indexterm"></a>
 <p>
 <span class="bold"><strong>QUARTER</strong></span>
 </p>
@@ -1620,7 +1800,7 @@
 </p>
 <p>This function is equivalent to <code class="literal">EXTRACT ( QUARTER FROM ...
       ) </code>Returns an integer in the range of 1 - 4. (JDBC)</p>
-<a name="N12478" class="indexterm"></a>
+<a name="N1253A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SECOND</strong></span>
 </p>
@@ -1628,9 +1808,9 @@
 <code class="literal">SECOND ( &lt;datetime value expr&gt; )</code>
 </p>
 <p>This function is equivalent to <code class="literal">EXTRACT ( SECOND FROM ...
-      ) </code>Returns an integer or decimal in the range of 0 - 59, with
-      the same precision as the &lt;datetime value expr&gt;. (JDBC)</p>
-<a name="N12489" class="indexterm"></a>
+      ) </code>Returns a decimal in the range of 0 - 60, with the same
+      precision as the &lt;datetime value expr&gt;. (JDBC)</p>
+<a name="N1254B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SECONDS_SINCE_MIDNIGHT</strong></span>
 </p>
@@ -1641,7 +1821,7 @@
 <p>This function is equivalent to<code class="literal"> EXTRACT (
       SECONDS_SINCE_MIDNIGHT FROM ... ) </code>Returns an integer in the
       range of 0 - 86399. (HyperSQL)</p>
-<a name="N1249A" class="indexterm"></a>
+<a name="N1255C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>UNIX_MILLIS</strong></span>
 </p>
@@ -1653,7 +1833,7 @@
       returns the number of milliseconds since 1970-01-01. With a DATE or
       TIMESTAMP parameter, it converts the argument into number of
       milliseconds since 1970-01-01. (HyperSQL)</p>
-<a name="N124A8" class="indexterm"></a>
+<a name="N1256A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>UNIX_TIMESTAMP</strong></span>
 </p>
@@ -1664,9 +1844,10 @@
 <p>This function returns a BIGINT value. With no parameter, it
       returns the number of seconds since 1970-01-01. With a DATE or TIMESTAMP
       parameter, it converts the argument into number of seconds since
-      1970-01-01. See also the TIMESTAMP ( &lt;num value expression&gt;)
-      function to return a TIMESTAMP from a Unix timestamp. (HyperSQL)</p>
-<a name="N124B6" class="indexterm"></a>
+      1970-01-01. See also the <code class="literal">TIMESTAMP ( &lt;num value
+      expression&gt; )</code> function to return a TIMESTAMP from a Unix
+      timestamp. (HyperSQL)</p>
+<a name="N1257B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>WEEK</strong></span>
 </p>
@@ -1676,7 +1857,7 @@
 <p>This function is equivalent to<code class="literal"> EXTRACT ( WEEK_OF_YEAR
       FROM ... ) </code>Returns an integer in the range of 1 - 54.
       (JDBC)</p>
-<a name="N124C7" class="indexterm"></a>
+<a name="N1258C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>YEAR</strong></span>
 </p>
@@ -1685,7 +1866,7 @@
 </p>
 <p>This function is equivalent to<code class="literal"> EXTRACT ( YEAR FROM ... )
       </code>Returns an integer in the range of 1 - 9999. (JDBC)</p>
-<a name="N124D8" class="indexterm"></a>
+<a name="N1259D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>EXTRACT</strong></span>
 </p>
@@ -1737,7 +1918,7 @@
       MINUTE | SECOND | SECONDS_MIDNIGHT</code> options may be valid for
       INTERVAL types based on seconds. For example,<code class="literal"> DAY | HOUR |
       MINUTE</code> are the only valid fields for the INTERVAL DAY TO
-      MINUTE data type. (Foundation with HyperSQL extensions)</p>
+      MINUTE data type. (SQL:2016 with HyperSQL extensions)</p>
 </div>
 <div class="section">
 <div class="titlepage">
@@ -1748,7 +1929,7 @@
 </div>
 </div>
 </div>
-<a name="N12533" class="indexterm"></a>
+<a name="N125F8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>NEXT_DAY</strong></span>
 </p>
@@ -1761,7 +1942,7 @@
       occurs after the first date. For example, next Wednesday is expressed as
       <code class="literal">NEXT_DAY(CURRENT_DATE, 'WEDNESDAY')</code>.
       (HyperSQL)</p>
-<a name="N12544" class="indexterm"></a>
+<a name="N12609" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ADD_MONTHS</strong></span>
 </p>
@@ -1769,8 +1950,8 @@
 <code class="literal">ADD_MONTHS ( &lt;datetime value expr&gt;, &lt;numeric
       value expr&gt;)</code>
 </p>
-<p>This function is similar but different to simple addition a MONTH
-      interval to a datetime value. The SQL Standard expression,
+<p>This function is similar but different to simple addition of a
+      MONTH interval to a datetime value. The SQL Standard expression,
       <code class="literal">&lt;datetime value expr&gt; + n MONTH</code>, when used with
       the last day of a short month such as February, returns a date that has
       the same day of the month in the target month. The
@@ -1788,7 +1969,7 @@
  2012-03-31 00:00:00 2012-03-29 
 </pre>
 </div>
-<a name="N1255E" class="indexterm"></a>
+<a name="N12623" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LAST_DAY</strong></span>
 </p>
@@ -1808,7 +1989,7 @@
  2012-02-29 12:30:44 
 </pre>
 </div>
-<a name="N12573" class="indexterm"></a>
+<a name="N12638" class="indexterm"></a>
 <p>
 <span class="bold"><strong>MONTHS_BETWEEN</strong></span>
 </p>
@@ -1819,7 +2000,7 @@
 <p>Returns a number (not an INTERVAL) possibly with a fraction,
       representing the number of months between two days. If both dates have
       the same day of month, or are on the last day of the month, the result
-      is an exact numeric. Otherwise, the fraction is calculated base on 31
+      is an exact numeric. Otherwise, the fraction is calculated based on 31
       days per month. You can cast the resulting value into INTERVAL MONTH and
       use it for datetime arithmetic. (HyperSQL)</p>
 <div class="informalexample">
@@ -1830,7 +2011,7 @@
  13.32258064516129000000000000000000 
 </pre>
 </div>
-<a name="N12585" class="indexterm"></a>
+<a name="N1264A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TIMESTAMPADD</strong></span>
 </p>
@@ -1838,7 +2019,7 @@
 <code class="literal">TIMESTAMPADD ( &lt;tsi datetime field&gt;, &lt;numeric
       value expression&gt;, &lt;datetime value expr&gt;)</code>
 </p>
-<a name="N12591" class="indexterm"></a>
+<a name="N12656" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TIMESTAMPDIFF</strong></span>
 </p>
@@ -1866,18 +2047,20 @@
 <p>The two JDBC functions, <code class="literal">TIMESTAMPADD </code>and
       <code class="literal">TIMESTAMPDIFF</code> perform a similar function to the above
       SQL expressions. The &lt;tsi datetime field&gt; names are keywords and
-      are different from those used in the EXTRACT functions. These names are
-      valid for use only when calling these two functions. With TIMESTAMPDIFF,
-      the names indicate the unit of time used to compute the difference
-      between two datetime fields. With TIMESTAMPADD they represent the unit
-      of time used for the &lt;numeric value expression&gt;. The unit of time
-      for each name is self-explanatory. In the case of SQL_TSI_FRAC_SECOND,
-      the unit is nanosecond.</p>
+      are different from those used in the <code class="literal">EXTRACT</code>
+      functions. These names are valid for use only when calling these two
+      functions. With <code class="literal">TIMESTAMPDIFF</code>, the names indicate the
+      unit of time used to compute the difference between two datetime fields.
+      With TIMESTAMPADD they represent the unit of time used for the
+      &lt;numeric value expression&gt;. The unit of time for each name is
+      self-explanatory. In the case of SQL_TSI_FRAC_SECOND, the unit is
+      nanosecond.</p>
 <p>The return value for TIMESTAMPADD is of the same type as the
-      datetime argument used. The return type for TIMESTAMPDIFF is always
-      BIGINT, regardless of the type of arguments. The two datetime arguments
-      of TIMESTAMPDIFF should be of the same type. The TIME type is not
-      supported for the arguments to these functions.</p>
+      datetime argument used. The return type for
+      <code class="literal">TIMESTAMPDIFF</code> is always BIGINT, regardless of the
+      type of arguments. The two datetime arguments of
+      <code class="literal">TIMESTAMPDIFF</code> should be of the same type. The TIME
+      type is not supported for the arguments to these functions.</p>
 <p>
 <code class="literal">TIMESTAMPDIFF</code> is evaluated as &lt;datetime
       value expr 2&gt; - &lt;datetime value expr 1&gt;. (JDBC)</p>
@@ -1887,7 +2070,7 @@
  TIMESTAMPDIFF ( SQL_TSI_HOUR, TIMESTAMP '2008-11-20 20:30:40', TIMESTAMP '2008-11-21 21:30:40' )
 </pre>
 </div>
-<a name="N125C2" class="indexterm"></a>
+<a name="N12693" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DATE_ADD</strong></span>
 </p>
@@ -1895,7 +2078,7 @@
 <code class="literal">DATE_ADD ( &lt;datetime value expr&gt; , &lt;interval
       value expr&gt; )</code>
 </p>
-<a name="N125CE" class="indexterm"></a>
+<a name="N1269F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DATE_SUB</strong></span>
 </p>
@@ -1916,7 +2099,7 @@
  DATE_SUB ( TIMESTAMP '2008-11-22 20:30:40', INTERVAL 20 HOUR )
 </pre>
 </div>
-<a name="N125DF" class="indexterm"></a>
+<a name="N126B0" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DATEADD</strong></span>
 </p>
@@ -1924,7 +2107,7 @@
 <code class="literal">DATEADD ( &lt;field&gt;, &lt;numeric value expr&gt;,
       &lt;datetime value expr&gt; )</code>
 </p>
-<a name="N125EB" class="indexterm"></a>
+<a name="N126BC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DATEDIFF</strong></span>
 </p>
@@ -1941,9 +2124,10 @@
 <code class="literal">&lt;field&gt; ::= YY | YEAR | MM | MONTH | DD | DAY | HH
       | HOUR | MI | MINUTE | SS | SECOND | MS | MILLISECOND</code>
 </p>
-<p>The DATEADD and DATEDIFF functions are alternatives to
-      TIMESTAMPADD and TIMESTAMPDIFF, with fewer available field options. The
-      field names are specified as strings or as keywords. The short field
+<p>The <code class="literal">DATEADD</code> and <code class="literal">DATEDIFF</code>
+      functions are alternatives to <code class="literal">TIMESTAMPADD</code> and
+      <code class="literal">TIMESTAMPDIFF</code>, with fewer available field options.
+      The field names are specified as strings or as keywords. The short field
       names translate to YEAR, MONTH, DAY, HOUR, MINUTE, SECOND and
       MILLISECOND. <code class="literal">DATEDIFF</code> is evaluated as &lt;datetime
       value expr 2&gt; - &lt;datetime value expr 1&gt;. (HyperSQL}</p>
@@ -1964,7 +2148,7 @@
  DATEDIFF ( 'hour', TIMESTAMP '2008-11-22 20:30:40', TIMESTAMP '2008-11-22 00:30:40' )
 </pre>
 </div>
-<a name="N12610" class="indexterm"></a>
+<a name="N126ED" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ROUND</strong></span>
 </p>
@@ -1983,7 +2167,7 @@
       date or midnight the next day if the time is at or after 12 noon. If the
       second argument is omitted, the datetime value is rounded to the nearest
       day. (HyperSQL)</p>
-<a name="N12624" class="indexterm"></a>
+<a name="N12701" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TRUNC</strong></span>
 </p>
@@ -1998,8 +2182,9 @@
       table for TO_CHAR and TO_DATE format elements (see below). The datetime
       value is truncated after the specified field and the rest of the fields
       to the right are set to one for MONTH and DAY, or zero, for the rest of
-      the fields. For example, applying TRUNC to a timestamp value on the DAY
-      field results in midnight the same date. Examples of ROUND and TRUNC
+      the fields. For example, applying <code class="literal">TRUNC</code> to a
+      timestamp value on the DAY field results in midnight the same date.
+      Examples of <code class="literal">ROUND</code> and <code class="literal">TRUNC</code>
       functions are given below. If the second argument is omitted, the
       datetime value is truncated to midnight the same date. (HyperSQL)</p>
 <div class="informalexample">
@@ -2022,7 +2207,32 @@
 </div>
 </div>
 </div>
-<a name="N1263F" class="indexterm"></a>
+<a name="N12725" class="indexterm"></a>
+<p>
+<span class="bold"><strong>FROM_TZ</strong></span>
+</p>
+<p>
+<code class="literal">FROM_TZ ( &lt;timestamp value expr&gt;, &lt;zone or
+      interval spec string&gt; )</code>
+</p>
+<p>This function takes the date-time (year, month, day, hour, minute,
+      second, fraction) from the first argument and the time zone from the
+      second argument to construct a TIMESTAMP WITH TIME ZONE value. The
+      output can represent a different point of universal time (UTC) than the
+      input. This is different from the AT TIME ZONE expression which keeps
+      the UTC value and changes the zone. (HyperSQL)</p>
+<div class="informalexample">
+<pre class="programlisting">-- the output shows the same timestamp as the input, but with the time zone of the specified region
+VALUES FROM_TZ(TIMESTAMP'2022-03-28 11:00:00+4:00','America/Chicago')
+ C1                              
+ ------------------------------- 
+ 2022-03-28 11:00:00.000000-5:00 
+
+-- this example has the same output as the previous one
+VALUES FROM_TZ(TIMESTAMP'2022-03-28 11:00:00','-5:00')
+</pre>
+</div>
+<a name="N12736" class="indexterm"></a>
 <p>
 <span class="bold"><strong>NUMTODSINTERVAL</strong></span>
 </p>
@@ -2033,7 +2243,7 @@
 <p>This function converts the numeric value to an interval, exactly
       like CAST. The interval spec string is one of 'DAY', 'HOUR', 'MINUTE',
       'SECOND'. (HyperSQL)</p>
-<a name="N1264D" class="indexterm"></a>
+<a name="N12744" class="indexterm"></a>
 <p>
 <span class="bold"><strong>NUMTOYMINTERVAL</strong></span>
 </p>
@@ -2044,7 +2254,7 @@
 <p>This function converts the numeric value to an interval, exactly
       like CAST. The interval spec string is 'YEAR' or 'MONTH'.
       (HyperSQL)</p>
-<a name="N1265B" class="indexterm"></a>
+<a name="N12752" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TIMESTAMP</strong></span>
 </p>
@@ -2062,7 +2272,7 @@
 <code class="literal">TIMESTAMP ( &lt;date value expr&gt;, &lt;time value
       expr&gt; )</code>
 </p>
-<p>This function translates the arguments into a TIMESTAMP WIHOUT
+<p>This function translates the arguments into a TIMESTAMP WITHOUT
       TIME ZONE value.</p>
 <p>When the single argument is a numeric value, it is interpreted as
       a Unix timestamp in seconds.</p>
@@ -2079,7 +2289,7 @@
  TIMESTAMP '2008-11-22 20:30:40.000000'
 </pre>
 </div>
-<a name="N1267B" class="indexterm"></a>
+<a name="N12772" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TIMESTAMP_WITH_ZONE</strong></span>
 </p>
@@ -2096,7 +2306,7 @@
       For example, if the local time zone was +4:00 at the time of the given
       Unix timestamp, the returned value is local timestamp at the time with
       time zone +4:00.</p>
-<a name="N12690" class="indexterm"></a>
+<a name="N12787" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TO_CHAR</strong></span>
 </p>
@@ -2125,7 +2335,7 @@
       format strings should not be used. You can include a string literal
       inside the format string by enclosing it in double quotes (see the
       second example above). (HyperSQL)</p>
-<a name="N126A6" class="indexterm"></a>
+<a name="N1279D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TO_DATE</strong></span>
 </p>
@@ -2136,7 +2346,7 @@
 <p>This function translates a formatted datetime sting to a
       TIMESTAMP(0) according to the format given in the second argument. See
       TO_TIMESTAMP below for further details.</p>
-<a name="N126B4" class="indexterm"></a>
+<a name="N127AB" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TO_TIMESTAMP</strong></span>
 </p>
@@ -2171,7 +2381,7 @@
 <p>The supported format components are all uppercase as
       follows:</p>
 <div class="table">
-<a name="N126CE"></a>
+<a name="N127C5"></a>
 <p class="title">
 <b>Table&nbsp;4.1.&nbsp;TO_CHAR, TO_DATE and TO_TIMESTAMP format elements</b>
 </p>
@@ -2320,7 +2530,7 @@
 <p>Array functions are specialised functions with ARRAY parameters or
     return values. For the ARRAY_AGG aggregate function, see the <a class="link" href="dataaccess-chapt.html" title="Chapter&nbsp;5.&nbsp;Data Access and Change">Data Access and Change</a>
     chapter.</p>
-<a name="N12783" class="indexterm"></a>
+<a name="N1287A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CARDINALITY</strong></span>
 </p>
@@ -2328,8 +2538,8 @@
 <code class="literal">CARDINALITY( &lt;array value expr&gt; )</code>
 </p>
 <p>Returns the element count for the given array argument.
-    (Foundation)</p>
-<a name="N12791" class="indexterm"></a>
+    (SQL:2016)</p>
+<a name="N12888" class="indexterm"></a>
 <p>
 <span class="bold"><strong>MAX_CARDINALITY</strong></span>
 </p>
@@ -2338,8 +2548,8 @@
     )</code>
 </p>
 <p>Returns the maximum allowed element count for the given array
-    argument. (Foundation)</p>
-<a name="N1279F" class="indexterm"></a>
+    argument. (SQL:2016)</p>
+<a name="N12896" class="indexterm"></a>
 <p>
 <span class="bold"><strong>POSITION_ARRAY</strong></span>
 </p>
@@ -2352,7 +2562,7 @@
     the beginning of the array. The optional <code class="literal">&lt;int value
     expr&gt;</code> specifies the start position. Positions are counted
     from 1. Returns zero if no match is found. (HyperSQL)</p>
-<a name="N127B3" class="indexterm"></a>
+<a name="N128AA" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SORT_ARRAY</strong></span>
 </p>
@@ -2362,7 +2572,7 @@
 </p>
 <p>Returns a sorted copy of the array. By default, sort is performed in
     ascending order and NULL elements are sorted first. (HyperSQL)</p>
-<a name="N127C1" class="indexterm"></a>
+<a name="N128B8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TRIM_ARRAY</strong></span>
 </p>
@@ -2373,8 +2583,8 @@
 <p>Returns a new array that contains the elements of the
     <code class="literal">&lt;array value expr&gt;</code> minus the number of elements
     specified by the <code class="literal">&lt;num value expr&gt;. </code>Elements are
-    discarded from the end of the array. (Foundation)</p>
-<a name="N127D5" class="indexterm"></a>
+    discarded from the end of the array. (SQL:2016)</p>
+<a name="N128CC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SEQUENCE_ARRAY</strong></span>
 </p>
@@ -2436,8 +2646,9 @@
 <p>General functions can take different types of arguments. Some
     General Functions accept a variable number of arguments.</p>
 <p>Also see the <a class="link" href="dataaccess-chapt.html" title="Chapter&nbsp;5.&nbsp;Data Access and Change">Data Access and Change</a> chapter for SQL expressions that are
-    similar to functions, for example CAST and NULLIF.</p>
-<a name="N12801" class="indexterm"></a>
+    similar to functions, for example <code class="literal">CAST</code> and
+    <code class="literal">NULLIF</code>.</p>
+<a name="N128FE" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CASEWHEN</strong></span>
 </p>
@@ -2448,9 +2659,9 @@
 <p>If the <code class="literal">&lt;boolean value expr&gt;</code> is true,
     returns <code class="literal">&lt;value expr 2&gt;</code> otherwise returns
     <code class="literal">&lt;value expr 3&gt;. Use a CASE WHEN expression instead for more
-    extensive capabilities and options.</code> CASE WHEN is documented in
-    the <a class="link" href="dataaccess-chapt.html" title="Chapter&nbsp;5.&nbsp;Data Access and Change">Data Access and Change</a> chapter. (HyperSQL)</p>
-<a name="N1281D" class="indexterm"></a>
+    extensive capabilities and options.</code> <code class="literal">CASE WHEN</code>
+    is documented in the <a class="link" href="dataaccess-chapt.html" title="Chapter&nbsp;5.&nbsp;Data Access and Change">Data Access and Change</a> chapter. (HyperSQL)</p>
+<a name="N1291D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>COALESCE</strong></span>
 </p>
@@ -2460,8 +2671,8 @@
 </p>
 <p>Returns <code class="literal">&lt;value expr 1&gt;</code> if it is not null,
     otherwise returns <code class="literal">&lt;value expr 2&gt;</code> if not null and
-    so on. The type of both arguments must be comparable. (Foundation)</p>
-<a name="N12831" class="indexterm"></a>
+    so on. The type of both arguments must be comparable. (SQL:2016)</p>
+<a name="N12931" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CONVERT</strong></span>
 </p>
@@ -2500,7 +2711,7 @@
 <p>When MS SQL Server compatibility mode is on, the parameters of
     CONVERT are switched and only the real type names with required precision,
     scale or length are allowed. (JDBC)</p>
-<a name="N1285D" class="indexterm"></a>
+<a name="N1295D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DECODE</strong></span>
 </p>
@@ -2520,7 +2731,7 @@
     returned. The type of the return value is a combination of the types of
     the <code class="literal">&lt;value expr result ... &gt;</code> arguments.
     (HyperSQL)</p>
-<a name="N12880" class="indexterm"></a>
+<a name="N12980" class="indexterm"></a>
 <p>
 <span class="bold"><strong>GREATEST</strong></span>
 </p>
@@ -2532,11 +2743,11 @@
     arguments with each other and returns the greatest argument. The return
     type is the combined type of the arguments. Arguments can be of any type,
     so long as they are comparable. (HyperSQL)</p>
-<a name="N1288E" class="indexterm"></a>
+<a name="N1298E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>IFNULL</strong></span>
 </p>
-<a name="N12897" class="indexterm"></a>
+<a name="N12997" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ISNULL</strong></span>
 </p>
@@ -2550,7 +2761,7 @@
     Almost equivalent to SQL Standard <code class="literal">COALESCE(&lt;value expr 1&gt;,
     &lt;value expr 2&gt;)</code> function, but without type modification.
     (JDBC)</p>
-<a name="N128B1" class="indexterm"></a>
+<a name="N129B1" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LEAST</strong></span>
 </p>
@@ -2562,7 +2773,7 @@
     arguments with each other and returns the smallest argument. The return
     type is the combined type of the arguments. Arguments can be of any type,
     so long as they are comparable. (HyperSQL)</p>
-<a name="N128BF" class="indexterm"></a>
+<a name="N129BF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LOAD_FILE</strong></span>
 </p>
@@ -2579,7 +2790,7 @@
     property must be set <code class="literal">true</code> in order to access files
     outside the directory structure of the database files.</p>
 <p>(HyperSQL)</p>
-<a name="N128D7" class="indexterm"></a>
+<a name="N129D7" class="indexterm"></a>
 <p>
 <span class="bold"><strong>NULLIF</strong></span>
 </p>
@@ -2590,8 +2801,8 @@
 <p>Returns <code class="literal">&lt;value expr 1&gt;</code> if it is not equal
     to <code class="literal">&lt;value expr 2&gt;</code>, otherwise returns null. The
     type of both arguments must be the same. This function is a shorthand for
-    a specific CASE expression. (Foundation)</p>
-<a name="N128EB" class="indexterm"></a>
+    a specific CASE expression. (SQL:2016)</p>
+<a name="N129EB" class="indexterm"></a>
 <p>
 <span class="bold"><strong>NVL</strong></span>
 </p>
@@ -2606,7 +2817,7 @@
     and <code class="literal">&lt;value expr 2&gt;</code> is a DOUBLE constant, the
     return type is cast into INTEGER. This function is similar to IFNULL.
     (HyperSQL)</p>
-<a name="N12908" class="indexterm"></a>
+<a name="N12A08" class="indexterm"></a>
 <p>
 <span class="bold"><strong>NVL2</strong></span>
 </p>
@@ -2619,7 +2830,7 @@
     <code class="literal">&lt;value expr 3&gt;</code>. The type of the return value is
     the type of <code class="literal">&lt;value expr 2&gt;</code> unless it is null.
     (HyperSQL)</p>
-<a name="N12922" class="indexterm"></a>
+<a name="N12A22" class="indexterm"></a>
 <p>
 <span class="bold"><strong>UUID</strong></span>
 </p>
@@ -2660,7 +2871,7 @@
 </div>
 </div>
 </div>
-<a name="N12946" class="indexterm"></a>
+<a name="N12A46" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CRYPT_KEY</strong></span>
 </p>
@@ -2674,7 +2885,7 @@
     <code class="literal">&lt;value expr 2&gt;</code>. To use the default provider,
     specify null for <code class="literal">&lt;value expr 2&gt;</code>.
     (HyperSQL)</p>
-<a name="N1295D" class="indexterm"></a>
+<a name="N12A5D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DIAGNOSTICS</strong></span>
 </p>
@@ -2689,7 +2900,7 @@
     statements. Calling this function immediately after executing an INSERT,
     UPDATE, DELETE or MERGE statement returns the row count for the last
     statement, as it is returned by the JDBC statement. (HyperSQL)</p>
-<a name="N12971" class="indexterm"></a>
+<a name="N12A71" class="indexterm"></a>
 <p>
 <span class="bold"><strong>IDENTITY</strong></span>
 </p>
@@ -2704,7 +2915,7 @@
     function call separately and is not affected by inserts in other sessions.
     The statement can be executed as a direct statement or a prepared
     statement. (HyperSQL)</p>
-<a name="N1297F" class="indexterm"></a>
+<a name="N12A7F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DATABASE</strong></span>
 </p>
@@ -2713,7 +2924,7 @@
 </p>
 <p>Returns the file name (without directory information) of the
     database. (JDBC)</p>
-<a name="N1298D" class="indexterm"></a>
+<a name="N12A8D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DATABASE_NAME</strong></span>
 </p>
@@ -2726,7 +2937,7 @@
     by an admin user but the new name must be all uppercase and 16 characters
     long. This name is used in log messages with external logging frameworks.
     (HyperSQL)</p>
-<a name="N1299B" class="indexterm"></a>
+<a name="N12A9B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DATABASE_VERSION</strong></span>
 </p>
@@ -2734,8 +2945,8 @@
 <code class="literal">DATABASE_VERSION ()</code>
 </p>
 <p>Returns the full version string for the database engine. For
-    example, 2.5.0. (JDBC)</p>
-<a name="N129A9" class="indexterm"></a>
+    example, 2.7.0. (JDBC)</p>
+<a name="N12AA9" class="indexterm"></a>
 <p>
 <span class="bold"><strong>USER</strong></span>
 </p>
@@ -2744,42 +2955,42 @@
 </p>
 <p>Equivalent to the SQL function <code class="literal">CURRENT_USER</code>.
     (JDBC)</p>
-<a name="N129BA" class="indexterm"></a>
+<a name="N12ABA" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CURRENT_USER</strong></span>
 </p>
 <p>
 <code class="literal">CURRENT_USER</code>
 </p>
-<a name="N129C6" class="indexterm"></a>
+<a name="N12AC6" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CURRENT_ROLE</strong></span>
 </p>
 <p>
 <code class="literal">CURRENT_ROLE</code>
 </p>
-<a name="N129D2" class="indexterm"></a>
+<a name="N12AD2" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SESSION_USER</strong></span>
 </p>
 <p>
 <code class="literal">SESSION_USER</code>
 </p>
-<a name="N129DE" class="indexterm"></a>
+<a name="N12ADE" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SYSTEM_USER</strong></span>
 </p>
 <p>
 <code class="literal">SYSTEM_USER</code>
 </p>
-<a name="N129EA" class="indexterm"></a>
+<a name="N12AEA" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CURRENT_SCHEMA</strong></span>
 </p>
 <p>
 <code class="literal">CURRENT_SCHEMA</code>
 </p>
-<a name="N129F6" class="indexterm"></a>
+<a name="N12AF6" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CURRENT_CATALOG</strong></span>
 </p>
@@ -2788,16 +2999,23 @@
 </p>
 <p>These functions return the named current session attribute. They are
     all SQL Standard functions.</p>
-<p>The CURRENT_USER is the user that connected to the database, or a
-    user subsequently set by the SET AUTHORIZATION statement.</p>
-<p>SESSION_USER is the same as CURRENT_USER</p>
-<p>SYSTEM_USER is the user that connected to the database. It is not
-    changed with any command until the session is closed.</p>
-<p>CURRENT_SCHEMA is default schema of the user, or a schema
-    subsequently set by the SET SCHEMA command.</p>
-<p>CURRENT_CATALOG is always the same within a given HyperSQL database
-    and indicates the name of the catalog.</p>
-<a name="N12A0E" class="indexterm"></a>
+<p>The <code class="literal">CURRENT_USER</code> is the user that connected to
+    the database, or a user subsequently set by the <code class="literal">SET
+    AUTHORIZATION</code> statement.</p>
+<p>
+<code class="literal">SESSION_USER</code> is the same as CURRENT_USER</p>
+<p>
+<code class="literal">SYSTEM_USER</code> is the user that connected to the
+    database. It is not changed with any command until the session is
+    closed.</p>
+<p>
+<code class="literal">CURRENT_SCHEMA</code> is default schema of the user, or
+    a schema subsequently set by the <code class="literal">SET SCHEMA</code>
+    command.</p>
+<p>
+<code class="literal">CURRENT_CATALOG</code> is always the same within a given
+    HyperSQL database and indicates the name of the catalog.</p>
+<a name="N12B1F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>IS_AUTOCOMMIT</strong></span>
 </p>
@@ -2806,7 +3024,7 @@
 </p>
 <p>Returns TRUE if the session is in auto-commit mode.
     (HyperSQL)</p>
-<a name="N12A1C" class="indexterm"></a>
+<a name="N12B2D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>IS_READONLY_SESSION</strong></span>
 </p>
@@ -2814,7 +3032,7 @@
 <code class="literal">IS_READONLY_SESSION()</code>
 </p>
 <p>Returns TRUE if the session is in read only mode. (HyperSQL)</p>
-<a name="N12A2A" class="indexterm"></a>
+<a name="N12B3B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>IS_READONLY_DATABASE</strong></span>
 </p>
@@ -2823,7 +3041,7 @@
 </p>
 <p>Returns TRUE if the database is a read only database.
     (HyperSQL)</p>
-<a name="N12A38" class="indexterm"></a>
+<a name="N12B49" class="indexterm"></a>
 <p>
 <span class="bold"><strong>IS_READONLY_DATABASE_FILES</strong></span>
 </p>
@@ -2833,7 +3051,7 @@
 <p>Returns TRUE if the database is a read-only files database. In this
     kind of database, it is possible to modify the data, but the changes are
     not persisted to the database files. (HyperSQL)</p>
-<a name="N12A46" class="indexterm"></a>
+<a name="N12B57" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ISOLATION_LEVEL</strong></span>
 </p>
@@ -2843,7 +3061,7 @@
 <p>Returns the current transaction isolation level for the session.
     Returns either READ COMMITTED or SERIALIZABLE as a string.
     (HyperSQL)</p>
-<a name="N12A54" class="indexterm"></a>
+<a name="N12B65" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SESSION_ID</strong></span>
 </p>
@@ -2853,7 +3071,7 @@
 <p>Returns the id of the session as a BIGINT value. Each session id is
     unique during the operational lifetime of the database. Id's are restarted
     after a shutdown and restart. (HyperSQL)</p>
-<a name="N12A62" class="indexterm"></a>
+<a name="N12B73" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SESSION_ISOLATION_LEVEL</strong></span>
 </p>
@@ -2863,7 +3081,7 @@
 <p>Returns the default transaction isolation level for the current
     session. Returns either READ COMMITTED or SERIALIZABLE as a string.
     (HyperSQL)</p>
-<a name="N12A70" class="indexterm"></a>
+<a name="N12B81" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DATABASE_ISOLATION_LEVEL</strong></span>
 </p>
@@ -2873,7 +3091,7 @@
 <p>Returns the default transaction isolation level for the database.
     Returns either READ COMMITTED or SERIALIZABLE as a string.
     (HyperSQL)</p>
-<a name="N12A7E" class="indexterm"></a>
+<a name="N12B8F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TRANSACTION_SIZE</strong></span>
 </p>
@@ -2883,7 +3101,7 @@
 <p>Returns the row change count for the current transaction. Each row
     change represents a row INSERT or a row DELETE operation. There will be a
     pair of row change operations for each row that is updated.</p>
-<a name="N12A8C" class="indexterm"></a>
+<a name="N12B9D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TRANSACTION_ID</strong></span>
 </p>
@@ -2895,7 +3113,7 @@
     to new transactions and new actions (statement executions) in different
     sessions. This value is unique to the current transaction.
     (HyperSQL)</p>
-<a name="N12A9A" class="indexterm"></a>
+<a name="N12BAB" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TRANSACTION_UTC</strong></span>
 </p>
@@ -2905,7 +3123,7 @@
 <p>Returns the transaction timestamp in UTC time zone for the session.
     This timestamp is used in updates made to system-versioned tables during
     the transaction. (HyperSQL)</p>
-<a name="N12AA8" class="indexterm"></a>
+<a name="N12BB9" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ACTION_ID</strong></span>
 </p>
@@ -2916,7 +3134,7 @@
     database maintains a global incremental id which is allocated to new
     transactions and new actions (statement executions) in different sessions.
     This value is unique to the current action. (HyperSQL)</p>
-<a name="N12AB6" class="indexterm"></a>
+<a name="N12BC7" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TRANSACTION_CONTROL</strong></span>
 </p>
@@ -2925,7 +3143,7 @@
 </p>
 <p>Returns the current transaction model for the database. Returns
     LOCKS, MVLOCKS or MVCC as a string. (HyperSQL)</p>
-<a name="N12AC4" class="indexterm"></a>
+<a name="N12BD5" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LOB_ID</strong></span>
 </p>
@@ -2936,14 +3154,14 @@
     and never reused. The &lt;column reference&gt; is the name of the column
     (or variable, or argument) which is a CLOB or BLOB. Returns null if the
     value is null. (HyperSQL)</p>
-<a name="N12AD2" class="indexterm"></a>
+<a name="N12BE3" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ROWNUM</strong></span>
 </p>
 <p>
 <code class="literal">ROWNUM()</code>
 </p>
-<a name="N12ADE" class="indexterm"></a>
+<a name="N12BEF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ROW_NUMBER</strong></span>
 </p>
@@ -2962,7 +3180,7 @@
 </div>
 </div>
 <HR xmlns:xi="http://www.w3.org/2001/XInclude">
-<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6369 $</P>
+<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6474 $</P>
 <div class="navfooter">
 <hr>
 <table summary="Navigation footer" width="100%">
diff -pruN 2.6.1-1/hsqldb/doc/guide/compatibility-chapt.html 2.7.0-1/hsqldb/doc/guide/compatibility-chapt.html
--- 2.6.1-1/hsqldb/doc/guide/compatibility-chapt.html	2021-10-20 09:33:34.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/guide/compatibility-chapt.html	2022-07-26 20:21:48.000000000 +0000
@@ -48,8 +48,8 @@
 </div>
 <div>
 <div class="legalnotice">
-<a name="N15CFE"></a>
-<p>Copyright 2010-2021 Fred Toussi. Permission is granted to
+<a name="N15EC1"></a>
+<p>Copyright 2010-2022 Fred Toussi. Permission is granted to
       distribute this document without any alteration under the terms of the
       HSQLDB license. Additional permission is granted to the HSQL Development
       Group to distribute this document with or without alterations under the
@@ -57,7 +57,7 @@
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -257,7 +257,7 @@
 </div>
 </div>
 </div>
-<p>HyperSQL version 2.6 is highly compatible with MySQL and supports
+<p>HyperSQL version 2.7 is highly compatible with MySQL and supports
       most of its non-standard syntax. The latest versions of MySQL have
       introduced better Standard compatibility but some of these features have
       to be turned on via properties. You should therefore check the current
@@ -669,7 +669,7 @@
           their SQL Standard equivalents.</p>
 </li>
 <li class="listitem">
-<p>HyperSQL 2.6 supports several datetime functions in MSS
+<p>HyperSQL 2.7 supports several datetime functions in MSS
           compatibility mode. These include DATEPART, DATENAME, EOMONTH and
           compatible DATEADD and DATEDIFF behaviour.</p>
 </li>
@@ -689,7 +689,7 @@
 </div>
 </div>
 <HR xmlns:xi="http://www.w3.org/2001/XInclude">
-<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6369 $</P>
+<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6474 $</P>
 <div class="navfooter">
 <hr>
 <table summary="Navigation footer" width="100%">
diff -pruN 2.6.1-1/hsqldb/doc/guide/dataaccess-chapt.html 2.7.0-1/hsqldb/doc/guide/dataaccess-chapt.html
--- 2.6.1-1/hsqldb/doc/guide/dataaccess-chapt.html	2021-10-20 09:33:34.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/guide/dataaccess-chapt.html	2022-07-26 20:21:48.000000000 +0000
@@ -44,12 +44,12 @@
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6369 $</p>
+<p class="releaseinfo">$Revision: 6535 $</p>
 </div>
 <div>
 <div class="legalnotice">
-<a name="N12B13"></a>
-<p>Copyright 2010-2021 Fred Toussi. Permission is granted to
+<a name="N12C24"></a>
+<p>Copyright 2010-2022 Fred Toussi. Permission is granted to
       distribute this document without any alteration under the terms of the
       HSQLDB license. Additional permission is granted to the HSQL Development
       Group to distribute this document with or without alterations under the
@@ -57,7 +57,7 @@
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -698,7 +698,7 @@
       In the current version of HyperSQL, the cursor is used only to return a
       result set from the procedure. Therefore, the cursor must be declared
       WITH RETURN and can only be READ ONLY.</p>
-<a name="N12CA3" class="indexterm"></a>
+<a name="N12DB4" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DECLARE CURSOR</strong></span>
 </p>
@@ -764,7 +764,7 @@
 <p>Literals are used to express constant values. The general type of
       a literal is known by its format. The specific type is based on
       conventions.</p>
-<a name="N12CD2" class="indexterm"></a>
+<a name="N12DE3" class="indexterm"></a>
 <p>
 <span class="bold"><strong>unicode escape
       elements</strong></span>
@@ -802,7 +802,7 @@
       &lt;quote&gt;, &lt;double quote&gt;, or &lt;white
       space&gt;</code>
 </p>
-<a name="N12CF0" class="indexterm"></a>
+<a name="N12E01" class="indexterm"></a>
 <p>
 <span class="bold"><strong>character literal</strong></span>
 </p>
@@ -869,7 +869,7 @@
  U&amp;'Unicode string with forward slash // as custom escape character'UESCAPE'/'
 </pre>
 </div>
-<a name="N12D1D" class="indexterm"></a>
+<a name="N12E2E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>binary literal</strong></span>
 </p>
@@ -897,7 +897,7 @@
 <div class="informalexample">
 <pre class="programlisting"> X'1abACD34' 'Af'</pre>
 </div>
-<a name="N12D34" class="indexterm"></a>
+<a name="N12E45" class="indexterm"></a>
 <p>
 <span class="bold"><strong>bit literal</strong></span>
 </p>
@@ -919,7 +919,7 @@
 <div class="informalexample">
 <pre class="programlisting"> B'10001001' '00010'</pre>
 </div>
-<a name="N12D4B" class="indexterm"></a>
+<a name="N12E5C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>numeric literal</strong></span>
 </p>
@@ -979,7 +979,7 @@
  +12E-2
 </pre>
 </div>
-<a name="N12D7B" class="indexterm"></a>
+<a name="N12E8C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>boolean literal</strong></span>
 </p>
@@ -991,7 +991,7 @@
       UNKNOWN</code>
 </p>
 <p>The boolean literal is one of the specified keywords.</p>
-<a name="N12D8C" class="indexterm"></a>
+<a name="N12E9D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>datetime and interval
       literal</strong></span>
@@ -1150,7 +1150,7 @@
 <p>References are identifier chains, which can be a single
       identifiers or identifiers chains composed of single identifiers chained
       together with the period symbol.</p>
-<a name="N12DFE" class="indexterm"></a>
+<a name="N12F0F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>identifier chain</strong></span>
 </p>
@@ -1180,7 +1180,7 @@
  ALTER SEQUENCE MYCATALOG.MYSCHEMA.MYSEQUENCE RESTART WITH 100
 </pre>
 </div>
-<a name="N12E1D" class="indexterm"></a>
+<a name="N12F2E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>column reference</strong></span>
 </p>
@@ -1193,7 +1193,7 @@
       &lt;period&gt; &lt;column name&gt;</code>
 </p>
 <p>Reference a column or a routine variable.</p>
-<a name="N12E2E" class="indexterm"></a>
+<a name="N12F3F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SQL parameter
       reference</strong></span>
@@ -1206,7 +1206,7 @@
       identifier chain&gt;</code>
 </p>
 <p>Reference an SQL routine parameter.</p>
-<a name="N12E3F" class="indexterm"></a>
+<a name="N12F50" class="indexterm"></a>
 <p>
 <span class="bold"><strong>contextually typed value
       specification</strong></span>
@@ -1251,7 +1251,7 @@
 <p>Value expression is a general name for all expressions that return
       a value. Different types of expressions are allowed in different
       contexts.</p>
-<a name="N12E60" class="indexterm"></a>
+<a name="N12F71" class="indexterm"></a>
 <p>
 <span class="bold"><strong>value expression
       primary</strong></span>
@@ -1278,7 +1278,7 @@
       invocation&gt;</code>
 </p>
 <p>Specify a value that is syntactically self-delimited.</p>
-<a name="N12E77" class="indexterm"></a>
+<a name="N12F88" class="indexterm"></a>
 <p>
 <span class="bold"><strong>value specification</strong></span>
 </p>
@@ -1315,7 +1315,7 @@
 </p>
 <p>Specify one or more values, host parameters, SQL parameters,
       dynamic parameters, or host variables.</p>
-<a name="N12E97" class="indexterm"></a>
+<a name="N12FA8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>row value expression</strong></span>
 </p>
@@ -1349,7 +1349,7 @@
       separated list of expressions, enclosed in brackets, with the optional
       keyword ROW. In SQL, a row containing a single element can often be used
       where a single value is expected.</p>
-<a name="N12EB4" class="indexterm"></a>
+<a name="N12FC5" class="indexterm"></a>
 <p>
 <span class="bold"><strong>set function
       specification</strong></span>
@@ -1370,7 +1370,7 @@
       of the column in the current row of the result of GROUPING SETS.
       HyperSQL supports <code class="literal">&lt;grouping operation&gt;</code> from
       version 2.5.1.</p>
-<a name="N12ECB" class="indexterm"></a>
+<a name="N12FDC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>COALESCE</strong></span>
 </p>
@@ -1393,7 +1393,7 @@
       expression&gt;</code> instances. Therefore, any value returned is
       implicitly cast to this type. HyperSQL also features built-in functions
       with similar functionality.</p>
-<a name="N12EE4" class="indexterm"></a>
+<a name="N12FF5" class="indexterm"></a>
 <p>
 <span class="bold"><strong>NULLIF</strong></span>
 </p>
@@ -1413,7 +1413,7 @@
 <div class="informalexample">
 <pre class="programlisting"> SELECT i, NULLIF(n, 'not defined') FROM t</pre>
 </div>
-<a name="N12EFE" class="indexterm"></a>
+<a name="N1300F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CASE</strong></span>
 </p>
@@ -1491,7 +1491,7 @@
 </div>
 <p>The case statement can be far more complex and involve several
       conditions.</p>
-<a name="N12F34" class="indexterm"></a>
+<a name="N13045" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CAST</strong></span>
 </p>
@@ -1534,7 +1534,7 @@
  CAST ('1992-04-21' AS DATE) = DATE '1992-04-21'
 </pre>
 </div>
-<a name="N12F52" class="indexterm"></a>
+<a name="N13063" class="indexterm"></a>
 <p>
 <span class="bold"><strong>NEXT VALUE FOR</strong></span>
 </p>
@@ -1560,7 +1560,7 @@
 <pre class="programlisting">INSERT INTO MYTABLE(COL1, COL2) VALUES 2, NEXT VALUE FOR MYSEQUENCE
 </pre>
 </div>
-<a name="N12F66" class="indexterm"></a>
+<a name="N13077" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CURRENT VALUE FOR</strong></span>
 </p>
@@ -1580,7 +1580,7 @@
  INSERT INTO CHILDTABLE(COL1, COL2) VALUES 10, CURRENT VALUE FOR MYSEQUENCE;
 </pre>
 </div>
-<a name="N12F7A" class="indexterm"></a>
+<a name="N1308B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>value expression</strong></span>
 </p>
@@ -1595,7 +1595,7 @@
 </p>
 <p>An expression that returns a value. The value can be a single
       value, or a row consisting more than one value.</p>
-<a name="N12F8B" class="indexterm"></a>
+<a name="N1309C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>numeric value
       expression</strong></span>
@@ -1627,7 +1627,7 @@
       <code class="literal">&lt;solidus&gt;</code> (the operators for multiplication and
       division) have precedence over <code class="literal">&lt;minus sign&gt;</code> and
       <code class="literal">&lt;plus sign&gt;</code>.</p>
-<a name="N12FB1" class="indexterm"></a>
+<a name="N130C2" class="indexterm"></a>
 <p>
 <span class="bold"><strong>numeric value
       function</strong></span>
@@ -1643,7 +1643,7 @@
 <p>Specify a function yielding a value of type numeric. The
       supported numeric value functions are listed and described in the <a class="link" href="builtinfunctions-chapt.html" title="Chapter&nbsp;4.&nbsp;Built In Functions">Built In Functions</a>
       chapter.</p>
-<a name="N12FC6" class="indexterm"></a>
+<a name="N130D7" class="indexterm"></a>
 <p>
 <span class="bold"><strong>string value
       expression</strong></span>
@@ -1674,7 +1674,7 @@
       primary&gt;</code>. The types of the <code class="literal">&lt;value expression
       primary&gt;</code> elements must be compatible, that is, all must be
       string, or binary or bit string values.</p>
-<a name="N12FE6" class="indexterm"></a>
+<a name="N130F7" class="indexterm"></a>
 <p>
 <span class="bold"><strong>character value
       function</strong></span>
@@ -1689,7 +1689,7 @@
 <p>Specify a function that returns a character string or binary
       string. The supported character value functions are listed and described
       in the <a class="link" href="builtinfunctions-chapt.html" title="Chapter&nbsp;4.&nbsp;Built In Functions">Built In Functions</a> chapter.</p>
-<a name="N12FFB" class="indexterm"></a>
+<a name="N1310C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>datetime value
       expression</strong></span>
@@ -1721,12 +1721,12 @@
       specifier&gt;</code>
 </p>
 <p>
-<code class="literal">&lt;time zone specifier&gt; ::= LOCAL | TIME ZONE
-      &lt;interval primary&gt;</code>
+<code class="literal">&lt;time zone specifier&gt; ::= LOCAL | TIME ZONE {
+      &lt;interval primary&gt; | &lt;time zone name&gt; }</code>
 </p>
 <p>Specify a datetime value. Details are described in the <a class="link" href="sqlgeneral-chapt.html" title="Chapter&nbsp;2.&nbsp;SQL Language">SQL Language</a>
       chapter.</p>
-<a name="N1301F" class="indexterm"></a>
+<a name="N13130" class="indexterm"></a>
 <p>
 <span class="bold"><strong>datetime value
       function</strong></span>
@@ -1740,7 +1740,7 @@
 </p>
 <p>Specify a function that returns a datetime value. The supported
       datetime value functions are listed and described in the <a class="link" href="builtinfunctions-chapt.html" title="Chapter&nbsp;4.&nbsp;Built In Functions">Built In Functions</a> chapter.</p>
-<a name="N13035" class="indexterm"></a>
+<a name="N13146" class="indexterm"></a>
 <p>
 <span class="bold"><strong>interval term</strong></span>
 </p>
@@ -1784,7 +1784,7 @@
 </p>
 <p>Specify an interval value. Details are described in the <a class="link" href="sqlgeneral-chapt.html" title="Chapter&nbsp;2.&nbsp;SQL Language">SQL Language</a>
       chapter.</p>
-<a name="N1305C" class="indexterm"></a>
+<a name="N1316D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>interval absolute value
       function</strong></span>
@@ -1804,7 +1804,7 @@
 <p>Specify a function that returns the absolute value of an
       interval. If the interval is negative, it is negated, otherwise the
       original value is returned.</p>
-<a name="N13070" class="indexterm"></a>
+<a name="N13181" class="indexterm"></a>
 <p>
 <span class="bold"><strong>boolean value
       expression</strong></span>
@@ -1885,7 +1885,7 @@
       predicand&gt;</code> has more than one element, and one or more of
       the fields evaluate to NULL, the result depends on the particular
       predicate.</p>
-<a name="N130BD" class="indexterm"></a>
+<a name="N131CE" class="indexterm"></a>
 <p>
 <span class="bold"><strong>comparison predicand</strong></span>
 </p>
@@ -1954,7 +1954,7 @@
  ((2, NULL, ...) &lt; (1, NULL, ...)) IS FALSE
 </pre>
 </div>
-<a name="N1310B" class="indexterm"></a>
+<a name="N1321C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>BETWEEN</strong></span>
 </p>
@@ -1980,7 +1980,7 @@
       BETWEEN ...)</code>. If any of the three <code class="literal">&lt;row value
       predicand&gt;</code> evaluates to NULL, the result is
       UNKNOWN.</p>
-<a name="N13134" class="indexterm"></a>
+<a name="N13245" class="indexterm"></a>
 <p>
 <span class="bold"><strong>IN</strong></span>
 </p>
@@ -2037,7 +2037,7 @@
  ResultSet rs = ps.executeQuery();
 </pre>
 </div>
-<a name="N13175" class="indexterm"></a>
+<a name="N13286" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LIKE</strong></span>
 </p>
@@ -2097,7 +2097,7 @@
       (A LIKE B)</code>. If the length of the escape is not 1 or it is used
       in the pattern not immediately before an underscore or a percent
       character, an exception is raised.</p>
-<a name="N131C2" class="indexterm"></a>
+<a name="N132D3" class="indexterm"></a>
 <p>
 <span class="bold"><strong>IS NULL</strong></span>
 </p>
@@ -2117,7 +2117,7 @@
       IS NULL</code> and <code class="literal">X IS NOT NULL</code> are FALSE. If all
       fields are not null, <code class="literal">X IS NULL</code> is FALSE and
       <code class="literal">X IS NOT NULL</code> is TRUE.</p>
-<a name="N131EE" class="indexterm"></a>
+<a name="N132FF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ALL and ANY</strong></span>
 </p>
@@ -2171,7 +2171,7 @@
  invoice_date &lt; ALL (SELECT holiday_date FROM holidays)
 </pre>
 </div>
-<a name="N13231" class="indexterm"></a>
+<a name="N13342" class="indexterm"></a>
 <p>
 <span class="bold"><strong>EXISTS</strong></span>
 </p>
@@ -2185,7 +2185,7 @@
 <p>Specify a test for a non-empty set. If the evaluation of
       <code class="literal">&lt;table subquery&gt;</code> results in one or more rows,
       then the expression is TRUE, otherwise FALSE.</p>
-<a name="N13245" class="indexterm"></a>
+<a name="N13356" class="indexterm"></a>
 <p>
 <span class="bold"><strong>UNIQUE</strong></span>
 </p>
@@ -2203,7 +2203,7 @@
       distinct from each other, the result of the test is TRUE, otherwise it
       is FALSE. The distinctness of rows X and Y is tested with the predicate
       <code class="literal">X IS DISTINCT FROM Y</code>.</p>
-<a name="N1325C" class="indexterm"></a>
+<a name="N1336D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>MATCH</strong></span>
 </p>
@@ -2245,7 +2245,7 @@
 <p>Note that MATCH can also be used in FOREIGN KEY constraint
       definitions. The exact meaning is described in the <a class="link" href="databaseobjects-chapt.html" title="Chapter&nbsp;3.&nbsp;Schemas and Database Objects">Schemas and Database Objects</a>
       chapter.</p>
-<a name="N1329E" class="indexterm"></a>
+<a name="N133AF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CONTAINS</strong></span>
 </p>
@@ -2270,7 +2270,7 @@
       result is TRUE. Otherwise it is false.</p>
 <p>If any of the values is NULL, the result is
       UNDEFINED.</p>
-<a name="N132BB" class="indexterm"></a>
+<a name="N133CC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>EQUALS</strong></span>
 </p>
@@ -2288,7 +2288,7 @@
       TRUE. Otherwise it is false.</p>
 <p>If any of the values is NULL, the result is
       UNDEFINED.</p>
-<a name="N132CE" class="indexterm"></a>
+<a name="N133DF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>IS DISTINCT</strong></span>
 </p>
@@ -2317,7 +2317,7 @@
 <div class="informalexample">
 <pre class="programlisting"> startdate IS DISTINCT FROM enddate</pre>
 </div>
-<a name="N132F4" class="indexterm"></a>
+<a name="N13405" class="indexterm"></a>
 <p>
 <span class="bold"><strong>OVERLAPS</strong></span>
 </p>
@@ -2345,7 +2345,7 @@
 <div class="informalexample">
 <pre class="programlisting"> (startdate, enddate) OVERLAPS (CURRENT_DATE - 7 DAY, CURRENT_DATE - 1 DAY)</pre>
 </div>
-<a name="N13311" class="indexterm"></a>
+<a name="N13422" class="indexterm"></a>
 <p>
 <span class="bold"><strong>PRECEDES</strong></span>
 </p>
@@ -2367,7 +2367,7 @@
       period.</p>
 <p>If any of the values is NULL, the result is
       UNDEFINED.</p>
-<a name="N13326" class="indexterm"></a>
+<a name="N13437" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SUCCEEDS</strong></span>
 </p>
@@ -2400,7 +2400,7 @@
 </div>
 </div>
 </div>
-<a name="N13344" class="indexterm"></a>
+<a name="N13455" class="indexterm"></a>
 <p>
 <span class="bold"><strong>aggregate function</strong></span>
 </p>
@@ -2567,7 +2567,7 @@
 </div>
 </div>
 </div>
-<a name="N133E2" class="indexterm"></a>
+<a name="N134F3" class="indexterm"></a>
 <p>
 <span class="bold"><strong>search condition</strong></span>
 </p>
@@ -2580,7 +2580,7 @@
 </p>
 <p>Specify a condition that is TRUE, FALSE, or UNKNOWN. A search
       condition is often a predicate.</p>
-<a name="N133F3" class="indexterm"></a>
+<a name="N13504" class="indexterm"></a>
 <p>
 <span class="bold"><strong>PATH</strong></span>
 </p>
@@ -2597,7 +2597,7 @@
 </p>
 <p>Specify an order for searching for a user-defined SQL-invoked
       routine. This is not currently supported by HyperSQL.</p>
-<a name="N13407" class="indexterm"></a>
+<a name="N13518" class="indexterm"></a>
 <p>
 <span class="bold"><strong>routine invocation</strong></span>
 </p>
@@ -2623,7 +2623,7 @@
 </p>
 <p>Invoke an SQL-invoked routine. Examples are given in the <a class="link" href="sqlroutines-chapt.html" title="Chapter&nbsp;9.&nbsp;SQL-Invoked Routines">SQL-Invoked Routines</a>
       chapter.</p>
-<a name="N13425" class="indexterm"></a>
+<a name="N13536" class="indexterm"></a>
 <p>
 <span class="bold"><strong>COLLATE</strong></span>
 </p>
@@ -2640,7 +2640,7 @@
       UPDATE or DELETE statements, when a UNIQUE constraint or index is
       defined on the column, or when the rows are sorted by an ORDER BY
       clause.</p>
-<a name="N13436" class="indexterm"></a>
+<a name="N13547" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CONSTRAINT</strong></span>
 </p>
@@ -2768,7 +2768,7 @@
       access statements, which may combine multiple SELECT statements. The
       <code class="literal">&lt;query specification&gt;</code> is the most common data
       access statement and begins with the SELECT keyword.</p>
-<a name="N13490" class="indexterm"></a>
+<a name="N135A1" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SELECT STATEMENT</strong></span>
 </p>
@@ -3077,7 +3077,7 @@ SELECT DISTINCT firstname, lastname, ema
 </div>
 </div>
 </div>
-<a name="N13587" class="indexterm"></a>
+<a name="N13698" class="indexterm"></a>
 <p>
 <span class="bold"><strong>derived table</strong></span>
 </p>
@@ -3101,7 +3101,7 @@ SELECT DISTINCT firstname, lastname, ema
 </div>
 </div>
 </div>
-<a name="N135A2" class="indexterm"></a>
+<a name="N136B3" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LATERAL</strong></span>
 </p>
@@ -3137,7 +3137,7 @@ SELECT firstname, lastname, a.c FROM cus
 </div>
 </div>
 </div>
-<a name="N135BF" class="indexterm"></a>
+<a name="N136D0" class="indexterm"></a>
 <p>
 <span class="bold"><strong>UNNEST</strong></span>
 </p>
@@ -3215,7 +3215,7 @@ SELECT firstname, lastname, a.c FROM cus
 </div>
 </div>
 </div>
-<a name="N135DB" class="indexterm"></a>
+<a name="N136EC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>Table Function Derived
         Table</strong></span>
@@ -3260,7 +3260,7 @@ SELECT firstname, lastname, a.c FROM cus
 </div>
 </div>
 </div>
-<a name="N135F9" class="indexterm"></a>
+<a name="N1370A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>column name list</strong></span>
 </p>
@@ -3335,7 +3335,7 @@ SELECT firstname, lastname, a.c FROM cus
 <code class="literal">&lt;join column list&gt; ::= &lt;column name
       list&gt;</code>
 </p>
-<a name="N1362E" class="indexterm"></a>
+<a name="N1373F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CROSS JOIN</strong></span>
 </p>
@@ -3357,7 +3357,7 @@ SELECT firstname, lastname, a.c FROM cus
       before they are joined.</p>
 <p>CROSS JOIN is not is not generally very useful, as it returns
       large result tables unless WHERE conditions are used.</p>
-<a name="N13645" class="indexterm"></a>
+<a name="N13756" class="indexterm"></a>
 <p>
 <span class="bold"><strong>UNION JOIN</strong></span>
 </p>
@@ -3369,7 +3369,7 @@ SELECT firstname, lastname, a.c FROM cus
       This should not be confused with <code class="literal">A UNION B</code>, which is
       a set operation. Union join is for special applications and is not
       commonly used.</p>
-<a name="N13656" class="indexterm"></a>
+<a name="N13767" class="indexterm"></a>
 <p>
 <span class="bold"><strong>JOIN ... ON</strong></span>
 </p>
@@ -3384,11 +3384,11 @@ SELECT firstname, lastname, a.c FROM cus
 <pre class="programlisting">SELECT a.*, b.* FROM a INNER JOIN b ON a.col_one = b.col_two
 </pre>
 </div>
-<a name="N13669" class="indexterm"></a>
+<a name="N1377A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>JOIN ... USING</strong></span>
 </p>
-<a name="N13672" class="indexterm"></a>
+<a name="N13783" class="indexterm"></a>
 <p>
 <span class="bold"><strong>NATURAL JOIN</strong></span>
 </p>
@@ -3427,7 +3427,7 @@ SELECT firstname, lastname, a.c FROM cus
  SELECT * FROM a INNER JOIN b USING (col_two)
 </pre>
 </div>
-<a name="N1368C" class="indexterm"></a>
+<a name="N1379D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>OUTER JOIN</strong></span>
 </p>
@@ -3524,7 +3524,7 @@ SELECT firstname, lastname, a.c FROM cus
       as C1, C2, etc. As generated naming is implementation defined according
       to the SQL Standard, it is better to explicitly name the computed and
       derived columns in your applications.</p>
-<a name="N136C1" class="indexterm"></a>
+<a name="N137D2" class="indexterm"></a>
 <p>
 <span class="bold"><strong>Naming in Joined
       Table</strong></span>
@@ -3557,7 +3557,7 @@ SELECT firstname, lastname, a.c FROM cus
  SELECT d, e, f FROM atable WHERE a + b = c
  SELECT x, y, z FROM atable AS t (u, v, w, x, y, z)  WHERE u + v = w</pre>
 </div>
-<a name="N136DD" class="indexterm"></a>
+<a name="N137EE" class="indexterm"></a>
 <p>
 <span class="bold"><strong>Naming in Select
       List</strong></span>
@@ -3577,7 +3577,7 @@ SELECT firstname, lastname, a.c FROM cus
 <p>If the names <code class="literal">xysum</code> or <code class="literal">yzsum</code>
       are not used, the computed columns cannot be referenced in the ORDER BY
       list.</p>
-<a name="N136F5" class="indexterm"></a>
+<a name="N13806" class="indexterm"></a>
 <p>
 <span class="bold"><strong>Name Resolution</strong></span>
 </p>
@@ -3594,7 +3594,7 @@ SELECT firstname, lastname, a.c FROM cus
 </div>
 </div>
 </div>
-<a name="N13704" class="indexterm"></a>
+<a name="N13815" class="indexterm"></a>
 <p>
 <span class="bold"><strong>Grouping Operations</strong></span>
 </p>
@@ -3605,7 +3605,7 @@ SELECT firstname, lastname, a.c FROM cus
       of their columns when compared to another row). The other form of
       grouping is performed with the GROUP BY clause. This form is usually
       used together with aggregation.</p>
-<a name="N1370F" class="indexterm"></a>
+<a name="N13820" class="indexterm"></a>
 <p>
 <span class="bold"><strong>GROUP BY</strong></span>
 </p>
@@ -3749,7 +3749,7 @@ DIRECT SALES (null) (null)  3778500
       DISTINCT eliminates the duplicate groups.</p>
 <p>Note any ordering of the rows returned by GROUP BY in incidental.
       You need to use ORDER BY for the ordering you require.</p>
-<a name="N1378D" class="indexterm"></a>
+<a name="N1389E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>HAVING</strong></span>
 </p>
@@ -3758,7 +3758,7 @@ DIRECT SALES (null) (null)  3778500
       clause&gt;</code> using its search condition. The search condition
       must be an expression based on the expressions in the GROUP BY list or
       the aggregate functions used.</p>
-<a name="N1379E" class="indexterm"></a>
+<a name="N138AF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DISTINCT</strong></span>
 </p>
@@ -3802,7 +3802,7 @@ DIRECT SALES (null) (null)  3778500
 </div>
 </div>
 </div>
-<a name="N137BE" class="indexterm"></a>
+<a name="N138CF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>Set and Multiset
       Operations</strong></span>
@@ -3903,7 +3903,7 @@ DIRECT SALES (null) (null)  3778500
       body&gt;</code> that follows the WITH clause.</p>
 <p>HyperSQL limits recursion to 256 rounds. If this is exceeded, an
       error is raised.</p>
-<p>From version 2.6.0, HyperSQL extends recursive query processing by
+<p>From version 2.6, HyperSQL extends recursive query processing by
       allowing the use of <code class="literal">RECURSIVE_TABLE</code> to reference the
       current general result of the <code class="literal">&lt;query
       expression&gt;</code>. This table name can be used in subqueries with
@@ -4096,7 +4096,7 @@ DIRECT SALES (null) (null)  3778500
       when it can use the same index for accessing the table data and
       ordering. Optimisation can happen both with DESC + NULLS LAST and ASC +
       NULLS FIRST.</p>
-<a name="N13897" class="indexterm"></a>
+<a name="N139A8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>sort specification
       list</strong></span>
@@ -4185,7 +4185,7 @@ DIRECT SALES (null) (null)  3778500
       indexes used, together with other useful information about the query.
       EXPLAIN PLAN can also be used for data manipulation statements such as
       UPDATE.</p>
-<a name="N138D8" class="indexterm"></a>
+<a name="N139E9" class="indexterm"></a>
 <p>
 <span class="bold"><strong>EXPLAIN PLAN</strong></span>
 </p>
@@ -4218,7 +4218,7 @@ DIRECT SALES (null) (null)  3778500
 </div>
 </div>
 </div>
-<a name="N138F4" class="indexterm"></a>
+<a name="N13A05" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DELETE FROM</strong></span>
 </p>
@@ -4268,7 +4268,7 @@ DIRECT SALES (null) (null)  3778500
 </div>
 </div>
 </div>
-<a name="N13918" class="indexterm"></a>
+<a name="N13A29" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TRUNCATE TABLE</strong></span>
 </p>
@@ -4318,7 +4318,7 @@ DIRECT SALES (null) (null)  3778500
       statement&gt;</code> is for removing old history rows from a
       system-versioned table. All history rows that expired before the given
       timestamp are removed. No current row is removed.</p>
-<a name="N13944" class="indexterm"></a>
+<a name="N13A55" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TRUNCATE SCHEMA</strong></span>
 </p>
@@ -4350,7 +4350,7 @@ DIRECT SALES (null) (null)  3778500
 </div>
 </div>
 </div>
-<a name="N1395D" class="indexterm"></a>
+<a name="N13A6E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>INSERT INTO</strong></span>
 </p>
@@ -4501,7 +4501,7 @@ DIRECT SALES (null) (null)  3778500
 </div>
 </div>
 </div>
-<a name="N139C3" class="indexterm"></a>
+<a name="N13AD4" class="indexterm"></a>
 <p>
 <span class="bold"><strong>UPDATE</strong></span>
 </p>
@@ -4541,7 +4541,7 @@ DIRECT SALES (null) (null)  3778500
       this situation, you can perform the operation is chunks and commit after
       each chunk to reduce memory usage and the total time of the
       operation.</p>
-<a name="N139E7" class="indexterm"></a>
+<a name="N13AF8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>set clause list</strong></span>
 </p>
@@ -4609,7 +4609,7 @@ DIRECT SALES (null) (null)  3778500
 </div>
 </div>
 </div>
-<a name="N13A15" class="indexterm"></a>
+<a name="N13B26" class="indexterm"></a>
 <p>
 <span class="bold"><strong>MERGE INTO</strong></span>
 </p>
@@ -4760,7 +4760,7 @@ DIRECT SALES (null) (null)  3778500
     limited extent. The built-in function <code class="literal">DIAGNOSTICS()</code> is
     an alternative. These are normally used in SQL/PSM routines to check the
     result of the last data update operation.</p>
-<a name="N13A9B" class="indexterm"></a>
+<a name="N13BAC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>GET DIAGNOSTICS</strong></span>
 </p>
@@ -4787,7 +4787,7 @@ DIRECT SALES (null) (null)  3778500
 </div>
 </div>
 <HR xmlns:xi="http://www.w3.org/2001/XInclude">
-<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6369 $</P>
+<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6474 $</P>
 <div class="navfooter">
 <hr>
 <table summary="Navigation footer" width="100%">
diff -pruN 2.6.1-1/hsqldb/doc/guide/databaseobjects-chapt.html 2.7.0-1/hsqldb/doc/guide/databaseobjects-chapt.html
--- 2.6.1-1/hsqldb/doc/guide/databaseobjects-chapt.html	2021-10-20 09:33:34.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/guide/databaseobjects-chapt.html	2022-07-26 20:21:48.000000000 +0000
@@ -44,12 +44,12 @@
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6319 $</p>
+<p class="releaseinfo">$Revision: 6425 $</p>
 </div>
 <div>
 <div class="legalnotice">
-<a name="N10B34"></a>
-<p>Copyright 2009-2021 Fred Toussi. Permission is granted to
+<a name="N10B48"></a>
+<p>Copyright 2009-2022 Fred Toussi. Permission is granted to
       distribute this document without any alteration under the terms of the
       HSQLDB license. Additional permission is granted to the HSQL Development
       Group to distribute this document with or without alterations under the
@@ -57,7 +57,7 @@
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -283,9 +283,9 @@
 </div>
 <p>A new HyperSQL catalog contains an empty schema called PUBLIC. By
     default, this schema is the initial schema when a new session is started.
-    New schemas and schema objects can be defined and used in the PUBLIC
-    schema, as well as any new schema that is created by the user. You can
-    rename the PUBLIC schema.</p>
+    Additional schemas can be defined. Schema objects can be defined and used
+    in the PUBLIC schema, as well as any new schema that is created by the
+    user. You can rename the PUBLIC schema.</p>
 <p>HyperSQL allows all schemas to be dropped, except the schema that is
     the default initial schema for new sessions (by default, the PUBLIC
     schema). For this schema, a DROP SCHEMA ... CASCADE statement will succeed
@@ -531,7 +531,7 @@
       &lt;name&gt;</code> expression. This expression can be used for
       inserting and updating table rows.</p>
 <div class="example">
-<a name="N10C0E"></a>
+<a name="N10C22"></a>
 <p class="title">
 <b>Example&nbsp;3.1.&nbsp;inserting the next sequence value into a table row</b>
 </p>
@@ -544,7 +544,7 @@
       to number the returned rows of a SELECT in sequential order, you can
       use:</p>
 <div class="example">
-<a name="N10C15"></a>
+<a name="N10C29"></a>
 <p class="title">
 <b>Example&nbsp;3.2.&nbsp;numbering returned rows of a SELECT in sequential order</b>
 </p>
@@ -570,7 +570,7 @@
       returned by the sequence, the same value 15 is inserted in the three
       rows.</p>
 <div class="example">
-<a name="N10C21"></a>
+<a name="N10C35"></a>
 <p class="title">
 <b>Example&nbsp;3.3.&nbsp;using the last value of a sequence</b>
 </p>
@@ -824,7 +824,7 @@
       values in different rows. The following example satisfies a UNIQUE
       constraint on the two columns</p>
 <div class="example">
-<a name="N10CC6"></a>
+<a name="N10CDA"></a>
 <p class="title">
 <b>Example&nbsp;3.4.&nbsp;Column values which satisfy a 2-column UNIQUE
         constraint</b>
@@ -1006,7 +1006,7 @@
 <p>These elements and statements are used for different types of
       object. They are described here, before the statements that can use
       them.</p>
-<a name="N10D4F" class="indexterm"></a>
+<a name="N10D63" class="indexterm"></a>
 <p>
 <span class="bold"><strong>identifier</strong></span>
 </p>
@@ -1084,7 +1084,7 @@
 </li>
 </ul>
 </div>
-<a name="N10D98" class="indexterm"></a>
+<a name="N10DAC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CASCADE or RESTRICT</strong></span>
 </p>
@@ -1105,7 +1105,7 @@
       referencing objects are modified or dropped with cascading effect.
       Whether a referencing object is modified or dropped, depends on the kind
       of schema object that is dropped.</p>
-<a name="N10DB2" class="indexterm"></a>
+<a name="N10DC6" class="indexterm"></a>
 <p>
 <span class="bold"><strong>IF EXISTS</strong></span>
 </p>
@@ -1121,7 +1121,7 @@
       sequences, and indexes). If it is specified, then the statement does not
       return an error if the drop statement is issued on a non-existent
       object.</p>
-<a name="N10DC3" class="indexterm"></a>
+<a name="N10DD7" class="indexterm"></a>
 <p>
 <span class="bold"><strong>IF NOT EXISTS</strong></span>
 </p>
@@ -1138,7 +1138,7 @@
       COLUMN statements. If it is specified, then the statement does not
       return an error if the CREATE or ALTER statement is for an object name
       that already exists.</p>
-<a name="N10DD4" class="indexterm"></a>
+<a name="N10DE8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SPECIFIC</strong></span>
 </p>
@@ -1169,7 +1169,7 @@
 </div>
 </div>
 </div>
-<a name="N10DFB" class="indexterm"></a>
+<a name="N10E0F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>RENAME</strong></span>
 </p>
@@ -1205,7 +1205,7 @@
 </div>
 </div>
 </div>
-<a name="N10E1C" class="indexterm"></a>
+<a name="N10E30" class="indexterm"></a>
 <p>
 <span class="bold"><strong>COMMENT</strong></span>
 </p>
@@ -1244,7 +1244,7 @@
 </div>
 </div>
 </div>
-<a name="N10E42" class="indexterm"></a>
+<a name="N10E56" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE SCHEMA</strong></span>
 </p>
@@ -1306,7 +1306,7 @@
 <p>It is not really necessary to create a schema and all its objects
       as one command. The schema can be created first, and its objects can be
       created one by one.</p>
-<a name="N10E7D" class="indexterm"></a>
+<a name="N10E91" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP SCHEMA</strong></span>
 </p>
@@ -1334,7 +1334,7 @@
 </div>
 </div>
 </div>
-<a name="N10E9E" class="indexterm"></a>
+<a name="N10EB2" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE TABLE</strong></span>
 </p>
@@ -1369,7 +1369,7 @@
       &lt;table period definition&gt; | &lt;table constraint definition&gt; |
       &lt;like clause&gt; </code>
 </p>
-<a name="N10EBC" class="indexterm"></a>
+<a name="N10ED0" class="indexterm"></a>
 <p>
 <span class="emphasis"><em>like clause</em></span>
 </p>
@@ -1415,7 +1415,7 @@
 <code class="literal">&lt;generation option&gt; ::= INCLUDING GENERATED |
       EXCLUDING GENERATED</code>
 </p>
-<a name="N10EF0" class="indexterm"></a>
+<a name="N10F04" class="indexterm"></a>
 <p>
 <span class="emphasis"><em>as subquery clause</em></span>
 </p>
@@ -1435,7 +1435,7 @@
 <pre class="programlisting"> CREATE TABLE t (a, b, c) AS (SELECT * FROM atable) WITH DATA
 </pre>
 </div>
-<a name="N10F0C" class="indexterm"></a>
+<a name="N10F20" class="indexterm"></a>
 <p>
 <span class="emphasis"><em>column definition</em></span>
 </p>
@@ -1476,7 +1476,7 @@
       then a UNIQUE or PRIMARY KEY constraint or an INDEX on the column will
       use the specified collation. Otherwise the default collation for the
       database is used.</p>
-<a name="N10F3E" class="indexterm"></a>
+<a name="N10F52" class="indexterm"></a>
 <p>
 <span class="bold"><strong>GENERATED</strong></span>
 </p>
@@ -1584,7 +1584,7 @@
  INSERT INTO t (id, firstname, lastname, fullname) VALUES (2, 'Pink', 'Panther', DEFAULT)
 </pre>
 </div>
-<a name="N10F95" class="indexterm"></a>
+<a name="N10FA9" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DEFAULT</strong></span>
 </p>
@@ -1610,7 +1610,7 @@
 <p>In PGS (PostgreSQL) compatibility mode, a NEXTVAL function can be
       used. Also, in MSS compatibility mode, the default value can be enclosed
       in parentheses.</p>
-<a name="N10FB3" class="indexterm"></a>
+<a name="N10FC7" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ON UPDATE</strong></span>
 </p>
@@ -1631,7 +1631,7 @@
       ZONE.</p>
 <p>This feature is not part of the SQL Standard and is similar to
       MySQL's ON UPDATE clause.</p>
-<a name="N10FCB" class="indexterm"></a>
+<a name="N10FDF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CONSTRAINT</strong></span>
 </p>
@@ -1663,7 +1663,7 @@
       This feature of the SQL Standard has been criticised because it allows a
       session to read uncommitted data that violates database integrity
       constraints but has not yet been checked.</p>
-<a name="N10FEB" class="indexterm"></a>
+<a name="N10FFF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CONSTRAINT</strong></span>
 </p>
@@ -1684,7 +1684,7 @@
       (including PRIMARY KEY), FOREIGN KEY and CHECK. Each kind has its own
       rules to limit the values that can be specified for different columns in
       each row of the table.</p>
-<a name="N10FFF" class="indexterm"></a><a name="N11004" class="indexterm"></a>
+<a name="N11013" class="indexterm"></a><a name="N11018" class="indexterm"></a>
 <p>
 <span class="bold"><strong>UNIQUE</strong></span>
 </p>
@@ -1710,7 +1710,7 @@
       an implicit NOT NULL constraint.</p>
 <p>If <code class="literal">UNIQUE( VALUE )</code> is specified, the
       constraint created on all columns of the table.</p>
-<a name="N11020" class="indexterm"></a>
+<a name="N11034" class="indexterm"></a>
 <p>
 <span class="bold"><strong>FOREIGN KEY</strong></span>
 </p>
@@ -1798,7 +1798,7 @@
       referencing rows to be set to NULL. Similarly, the SET DEFAULT option
       results in the columns of the referencing rows to be set to their
       default values.</p>
-<a name="N1106B" class="indexterm"></a>
+<a name="N1107F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CHECK</strong></span>
 </p>
@@ -1841,7 +1841,7 @@
       inserted into the database belongs to the future (at the time of
       insertion), or any similar constraint, then use a TRIGGER with the
       desired condition.</p>
-<a name="N11094" class="indexterm"></a>
+<a name="N110A8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP TABLE</strong></span>
 </p>
@@ -1871,7 +1871,7 @@
 </div>
 </div>
 </div>
-<a name="N110AF" class="indexterm"></a>
+<a name="N110C3" class="indexterm"></a>
 <p>System-versioned tables are tables that contain a SYSTEM_TIME
       period consisting of pair of columns defined as auto-generated TIMESTAMP
       WITH TIME ZONE, together with the SYSTEM VERSIONING clause.</p>
@@ -1941,7 +1941,7 @@
 <p>Table settings statements change the attributes of tables. These
       attributes are specific to HyperSQL and are not part of the SQL
       Standard.</p>
-<a name="N110E5" class="indexterm"></a>
+<a name="N110F9" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET TABLE CLUSTERED</strong></span>
 </p>
@@ -1972,7 +1972,7 @@
       all future reordering of rows. Note that if extensive inserts or updates
       are performed on the tables, the rows will get out of order until the
       next reordering.</p>
-<a name="N110FA" class="indexterm"></a>
+<a name="N1110E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET TABLE TYPE</strong></span>
 </p>
@@ -1987,7 +1987,7 @@
       and MEMORY types.</p>
 <p>Only a user with the DBA role can execute this
       statement.</p>
-<a name="N1110D" class="indexterm"></a>
+<a name="N11121" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET TABLE
       writability</strong></span>
@@ -2003,7 +2003,7 @@
       default. This statement can be used to change the property between
       <code class="literal">READ ONLY</code> and <code class="literal">READ WRITE</code>. This is
       a feature of HyperSQL.</p>
-<a name="N11124" class="indexterm"></a>
+<a name="N11138" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET TABLE SOURCE</strong></span>
 </p>
@@ -2237,7 +2237,7 @@
 </div>
 <p>Only a user with the DBA role can execute this
       statement.</p>
-<a name="N111B7" class="indexterm"></a>
+<a name="N111CB" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET TABLE SOURCE
       HEADER</strong></span>
@@ -2256,7 +2256,7 @@
       the first line of the source file of the text table. This line is not
       part of the table data. Only a user with the DBA role can execute this
       statement.</p>
-<a name="N111CB" class="indexterm"></a>
+<a name="N111DF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET TABLE SOURCE
       on-off</strong></span>
@@ -2290,7 +2290,7 @@
 <p>Table manipulation statements modify the objects such as columns
       and constraints. Some of these statements are defined by the SQL
       Standard. Others are HyperSQL extensions.</p>
-<a name="N111E2" class="indexterm"></a>
+<a name="N111F6" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ALTER TABLE</strong></span>
 </p>
@@ -2311,7 +2311,7 @@
 </p>
 <p>Change the definition of a table. Specific types of this
       statement are covered below.</p>
-<a name="N111F6" class="indexterm"></a>
+<a name="N1120A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ADD COLUMN</strong></span>
 </p>
@@ -2333,7 +2333,7 @@
       GENERATED. The column values for each row is then filled with the result
       of the <code class="literal">&lt;default clause&gt;</code> or the generated
       value.</p>
-<a name="N11218" class="indexterm"></a>
+<a name="N1122C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP COLUMN</strong></span>
 </p>
@@ -2353,7 +2353,7 @@
       specified. If <code class="literal">CASCADE</code> is specified, then any
       CONSTRAINT, VIEW or TRIGGER object that references the column is dropped
       with a cascading effect.</p>
-<a name="N11238" class="indexterm"></a>
+<a name="N1124C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ADD CONSTRAINT</strong></span>
 </p>
@@ -2367,7 +2367,7 @@
 <p>Add a constraint to a table. The existing rows of the table
       must conform to the added constraint, otherwise the statement will not
       succeed.</p>
-<a name="N11249" class="indexterm"></a>
+<a name="N1125D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP CONSTRAINT</strong></span>
 </p>
@@ -2389,7 +2389,7 @@
       relationship exists between these columns and the other columns in that
       query expression, then the VIEW or other schema object will be dropped
       when <code class="literal">CASCADE</code> is specified.</p>
-<a name="N11263" class="indexterm"></a>
+<a name="N11277" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ADD SYSTEM PERIOD</strong></span>
 </p>
@@ -2413,7 +2413,7 @@
 <pre class="programlisting"> ALTER TABLE t ADD PERIOD FOR SYSTEM_TIME(rs, re) ADD COLUMN rs TIMESTAMP GENERATED ALWAYS AS ROW START ADD COLUMN re TIMESTAMP GENERATED ALWAYS AS ROW END
 </pre>
 </div>
-<a name="N11277" class="indexterm"></a>
+<a name="N1128B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP SYSTEM PERIOD</strong></span>
 </p>
@@ -2433,7 +2433,7 @@
       is specified, then any such VIEW or other database object that
       references the period or its columns is dropped with a cascading
       effect</p>
-<a name="N11297" class="indexterm"></a>
+<a name="N112AB" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ADD SYSTEM
       VERSIONING</strong></span>
@@ -2451,7 +2451,7 @@
 <pre class="programlisting"> ALTER TABLE t ADD SYSTEM VERSIONING
 </pre>
 </div>
-<a name="N112AB" class="indexterm"></a>
+<a name="N112BF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP SYSTEM
       VERSIONING</strong></span>
@@ -2475,7 +2475,7 @@
       of this statement, all the history rows in the table are deleted and
       only the current versions of rows survive. The period for SYSTEM_TIME,
       and its columns, survive after dropping versioning.</p>
-<a name="N112CB" class="indexterm"></a>
+<a name="N112DF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ALTER COLUMN</strong></span>
 </p>
@@ -2497,7 +2497,7 @@
 <p>Change a column and its definition. Specific types of this
       statement are covered below. See also the RENAME statement
       above.</p>
-<a name="N112DF" class="indexterm"></a>
+<a name="N112F3" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DEFAULT</strong></span>
 </p>
@@ -2510,7 +2510,7 @@
 </p>
 <p>Set the default clause for a column. This can be used if the
       column is not defined as GENERATED.</p>
-<a name="N112F0" class="indexterm"></a>
+<a name="N11304" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP DEFAULT</strong></span>
 </p>
@@ -2522,7 +2522,7 @@
       DEFAULT</code>
 </p>
 <p>Drop the default clause from a column.</p>
-<a name="N11301" class="indexterm"></a>
+<a name="N11315" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATA TYPE</strong></span>
 </p>
@@ -2539,7 +2539,7 @@
       enlarge. HyperSQL allows changing the type if all the existing values
       can be cast into the new type without string truncation or loss of
       significant digits.</p>
-<a name="N11312" class="indexterm"></a>
+<a name="N11326" class="indexterm"></a>
 <p>
 <span class="bold"><strong>alter column add identity generator or
       sequence</strong></span>
@@ -2563,7 +2563,7 @@
 <pre class="programlisting"> ALTER TABLE mytable ALTER COLUMN id GENERATED ALWAYS AS IDENTITY (START WITH 20000)</pre>
 <pre class="programlisting"> ALTER TABLE mytable ALTER COLUMN id GENERATED BY DEFAULT AS SEQUENCE seq</pre>
 </div>
-<a name="N1132B" class="indexterm"></a>
+<a name="N1133F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>alter column identity
       generator</strong></span>
@@ -2589,7 +2589,7 @@
  ALTER TABLE mytable ALTER COLUMN id SET INCREMENT BY 5
 </pre>
 </div>
-<a name="N11342" class="indexterm"></a>
+<a name="N11356" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP GENERATED</strong></span>
 </p>
@@ -2607,7 +2607,7 @@
 <pre class="programlisting">  ALTER TABLE mytable ALTER COLUMN id DROP GENERATED
 </pre>
 </div>
-<a name="N11356" class="indexterm"></a>
+<a name="N1136A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET [ NOT ] NULL</strong></span>
 </p>
@@ -2630,7 +2630,7 @@
 </div>
 </div>
 </div>
-<a name="N1136B" class="indexterm"></a>
+<a name="N1137F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE VIEW</strong></span>
 </p>
@@ -2670,7 +2670,7 @@
       <code class="literal">&lt;query expression&gt;</code> of the view references
       another view, then the search condition of the underlying view should
       also be satisfied by the update or insert operation.</p>
-<a name="N1139F" class="indexterm"></a>
+<a name="N113B3" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP VIEW</strong></span>
 </p>
@@ -2684,7 +2684,7 @@
 </p>
 <p>Destroy a view. The <code class="literal">&lt;drop behavior&gt;</code> is
       similar to dropping a table.</p>
-<a name="N113B3" class="indexterm"></a>
+<a name="N113C7" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ALTER VIEW</strong></span>
 </p>
@@ -2711,7 +2711,7 @@
 </div>
 </div>
 </div>
-<a name="N113C8" class="indexterm"></a>
+<a name="N113DC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE DOMAIN</strong></span>
 </p>
@@ -2747,7 +2747,7 @@
 <pre class="programlisting"> CREATE DOMAIN valid_string AS VARCHAR(20) DEFAULT 'NO VALUE' CHECK (VALUE IS NOT NULL AND CHARACTER_LENGTH(VALUE) &gt; 2) 
 </pre>
 </div>
-<a name="N113EA" class="indexterm"></a>
+<a name="N113FE" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ALTER DOMAIN</strong></span>
 </p>
@@ -2765,7 +2765,7 @@
       definition&gt;</code>
 </p>
 <p>Change a domain and its definition.</p>
-<a name="N113FE" class="indexterm"></a>
+<a name="N11412" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DEFAULT</strong></span>
 </p>
@@ -2778,7 +2778,7 @@
 </p>
 <p>Set the default value in a domain. This is allowed if the
       domain is already used in a table definition.</p>
-<a name="N1140F" class="indexterm"></a>
+<a name="N11423" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP DEFAULT</strong></span>
 </p>
@@ -2794,7 +2794,7 @@
       domain as its type, the domain default is removed. If there is no
       existing column default clause, the default clause of the domain becomes
       the column default clause.</p>
-<a name="N11420" class="indexterm"></a>
+<a name="N11434" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ADD CONSTRAINT</strong></span>
 </p>
@@ -2808,7 +2808,7 @@
 <p>Add a constraint to a domain. This is allowed if the domain is
       already used in a table definition and the table data satisfies the
       constraint.</p>
-<a name="N11431" class="indexterm"></a>
+<a name="N11445" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP CONSTRAINT</strong></span>
 </p>
@@ -2823,7 +2823,7 @@
 <p>Remove a constraint on a domain. This is allowed if the domain is
       already used in a table definition. The constraint no longer applies to
       a column that uses the domain as its type.</p>
-<a name="N11442" class="indexterm"></a>
+<a name="N11456" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP DOMAIN</strong></span>
 </p>
@@ -2852,7 +2852,7 @@
 </div>
 </div>
 </div>
-<a name="N11460" class="indexterm"></a>
+<a name="N11474" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE TRIGGER</strong></span>
 </p>
@@ -2960,7 +2960,7 @@
       interface.</p>
 <p>HyperSQL does not yet allow the use of OLD TABLE or NEW TABLE in
       statement level trigger definitions.</p>
-<a name="N114C8" class="indexterm"></a>
+<a name="N114DC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP TRIGGER</strong></span>
 </p>
@@ -2982,7 +2982,7 @@
 </div>
 </div>
 </div>
-<a name="N114DD" class="indexterm"></a>
+<a name="N114F1" class="indexterm"></a>
 <p>
 <span class="bold"><strong>schema routine</strong></span>
 </p>
@@ -3154,7 +3154,7 @@
 <p>Define an SQL-invoked routine. A few of the options are not used
       by HyperSQL and have default behaviours. See the <a class="link" href="sqlroutines-chapt.html" title="Chapter&nbsp;9.&nbsp;SQL-Invoked Routines">SQL-Invoked Routines</a>
       chapter for more details of various options and examples.</p>
-<a name="N1155C" class="indexterm"></a>
+<a name="N11570" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ALTER routine</strong></span>
 </p>
@@ -3207,7 +3207,7 @@
   END
 </pre>
 </div>
-<a name="N11580" class="indexterm"></a>
+<a name="N11594" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP</strong></span>
 </p>
@@ -3229,7 +3229,7 @@
 </div>
 </div>
 </div>
-<a name="N11595" class="indexterm"></a>
+<a name="N115A9" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE SEQUENCE</strong></span>
 </p>
@@ -3324,7 +3324,7 @@
 <p>The integer types: SMALLINT, INTEGER, BIGINT, DECIMAL and NUMERIC
       can be used as the type of the sequence. DECIMAL and NUMERIC types must
       have a scale of 0 and a precision not exceeding 18.</p>
-<a name="N115E4" class="indexterm"></a>
+<a name="N115F8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ALTER SEQUENCE</strong></span>
 </p>
@@ -3362,7 +3362,7 @@
 <p>If RESTART is used by itself (without a value), then the current
       value of the sequence is reset to the start value. Otherwise, the
       current value is reset to the given restart value.</p>
-<a name="N11606" class="indexterm"></a>
+<a name="N1161A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP SEQUENCE</strong></span>
 </p>
@@ -3389,7 +3389,7 @@
 </div>
 </div>
 </div>
-<a name="N11622" class="indexterm"></a>
+<a name="N11636" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SQL procedure
       statement</strong></span>
@@ -3453,7 +3453,7 @@
 </div>
 </div>
 </div>
-<a name="N11646" class="indexterm"></a>
+<a name="N1165A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE SYNONYM</strong></span>
 </p>
@@ -3469,7 +3469,7 @@
       the name is qualified with a different schema name. The target object
       name can be a schema object in the current schema or in another schema.
       The synonym can be used only without the schema name.</p>
-<a name="N1165A" class="indexterm"></a>
+<a name="N1166E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP SYNONYM</strong></span>
 </p>
@@ -3483,7 +3483,7 @@
 <p>Drops the synonym. The <code class="literal">&lt;synonym name&gt;</code> can
       be the simple name of the synonym or qualified with the schema
       name.</p>
-<a name="N1166E" class="indexterm"></a>
+<a name="N11682" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE INDEX</strong></span>
 </p>
@@ -3504,7 +3504,7 @@
       not duplicate the columns of PRIMARY KEY, UNIQUE or FOREIGN key
       constraints as each of these constraints creates an index
       automatically.</p>
-<a name="N1167F" class="indexterm"></a>
+<a name="N11693" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP INDEX</strong></span>
 </p>
@@ -3516,7 +3516,7 @@
       EXISTS ] &lt;index name&gt; [ IF EXISTS ]</code>
 </p>
 <p>Destroy an index.</p>
-<a name="N11690" class="indexterm"></a>
+<a name="N116A4" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ALTER INDEX</strong></span>
 </p>
@@ -3531,7 +3531,7 @@
 <p>Redefine an index with a new column list. This statement is
       more efficient than dropping an existing index and creating a new
       one.</p>
-<a name="N116A1" class="indexterm"></a>
+<a name="N116B5" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ALTER CONSTRAINT</strong></span>
 </p>
@@ -3549,7 +3549,7 @@
       does not change. If the statement is used again, the previous extra
       columns of the index are replaced with the new extra columns. The
       FOREIGN KEY must have a user-defined name.</p>
-<a name="N116B2" class="indexterm"></a>
+<a name="N116C6" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE TYPE</strong></span>
 </p>
@@ -3571,7 +3571,7 @@
 </p>
 <p>Define a user-defined type. Currently only simple distinct
       types can be defined without further attributes.</p>
-<a name="N116C9" class="indexterm"></a>
+<a name="N116DD" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE CAST</strong></span>
 </p>
@@ -3598,7 +3598,7 @@
 </p>
 <p>Define a user-defined cast. This feature may be supported in a
       future version of HyperSQL.</p>
-<a name="N116E3" class="indexterm"></a>
+<a name="N116F7" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP CAST</strong></span>
 </p>
@@ -3612,7 +3612,7 @@
 </p>
 <p>Destroy a user-defined cast. This feature may be supported in a
       future version of HyperSQL.</p>
-<a name="N116F4" class="indexterm"></a>
+<a name="N11708" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE CHARACTER SET</strong></span>
 </p>
@@ -3635,7 +3635,7 @@
       CHARACTER SET. Currently this statement has no effect, as the character
       set used by HyperSQL is Unicode and there is no need for subset
       character sets.</p>
-<a name="N1170B" class="indexterm"></a>
+<a name="N1171F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP CHARACTER SET</strong></span>
 </p>
@@ -3650,7 +3650,7 @@
       referenced in any database object, the command fails. Note that
       <code class="literal">CASCADE</code> or <code class="literal">RESTRICT</code> cannot be
       specified for this command.</p>
-<a name="N11722" class="indexterm"></a>
+<a name="N11736" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE COLLATION</strong></span>
 </p>
@@ -3684,7 +3684,7 @@
       FROM "French" NO PAD</code>, results in a French collation without
       padding. This collation can be used for sorting or for individual
       columns of tables.</p>
-<a name="N11747" class="indexterm"></a>
+<a name="N1175B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP COLLATION</strong></span>
 </p>
@@ -3699,7 +3699,7 @@
       behavior&gt;</code> is <code class="literal">CASCADE</code>, then all
       references to the collation revert to the default collation that would
       be in force if the dropped collation was not specified.</p>
-<a name="N1175E" class="indexterm"></a>
+<a name="N11772" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE TRANSLATION</strong></span>
 </p>
@@ -3735,7 +3735,7 @@
 </p>
 <p>Define a character transliteration. This feature may be supported
       in a future version of HyperSQL.</p>
-<a name="N1177E" class="indexterm"></a>
+<a name="N11792" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP TRANSLATION</strong></span>
 </p>
@@ -3748,7 +3748,7 @@
 </p>
 <p>Destroy a character transliteration. This feature may be
       supported in a future version of HyperSQL.</p>
-<a name="N1178F" class="indexterm"></a>
+<a name="N117A3" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE ASSERTION</strong></span>
 </p>
@@ -3763,7 +3763,7 @@
 </p>
 <p>Specify an integrity constraint. This feature may be supported
       in a future version of HyperSQL.</p>
-<a name="N117A0" class="indexterm"></a>
+<a name="N117B4" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP ASSERTION</strong></span>
 </p>
@@ -3821,7 +3821,7 @@
       objects that use (reference) a particular database object.
       Alternatively, the statement lists all the database object that are used
       (referenced) by a particular database object.</p>
-<a name="N117C5" class="indexterm"></a>
+<a name="N117D9" class="indexterm"></a>
 <p>
 <span class="bold"><strong>EXPLAIN REFERENCES</strong></span>
 </p>
@@ -3989,252 +3989,252 @@
 <p>The following views are defined by the SQL Standard and supported
       by HyperSQL. The columns and contents exactly match the Standard
       requirements.</p>
-<a name="N11823" class="indexterm"></a>
+<a name="N11837" class="indexterm"></a>
 <p>ADMINISTRABLE_ROLE_AUTHORIZATIONS</p>
 <p>Information on ROLE authorizations, all granted by the admin
       role.</p>
-<a name="N1182C" class="indexterm"></a>
+<a name="N11840" class="indexterm"></a>
 <p>APPLICABLE_ROLES</p>
 <p>Information on ROLE authorizations for the current user</p>
-<a name="N11835" class="indexterm"></a>
+<a name="N11849" class="indexterm"></a>
 <p>ASSERTIONS</p>
 <p>Empty view as ASSERTION objects are not yet supported.</p>
-<a name="N1183E" class="indexterm"></a>
+<a name="N11852" class="indexterm"></a>
 <p>AUTHORIZATIONS</p>
 <p>Top level information on USER and ROLE objects in the
       database</p>
-<a name="N11847" class="indexterm"></a>
+<a name="N1185B" class="indexterm"></a>
 <p>CHARACTER_SETS</p>
 <p>List of supported CHARACTER SET objects</p>
-<a name="N11850" class="indexterm"></a>
+<a name="N11864" class="indexterm"></a>
 <p>CHECK_CONSTRAINTS</p>
 <p>Additional information specific to each CHECK constraint,
       including the search condition</p>
-<a name="N11859" class="indexterm"></a>
+<a name="N1186D" class="indexterm"></a>
 <p>CHECK_CONSTRAINT_ROUTINE_USAGE</p>
 <p>Information on FUNCTION objects referenced in CHECK constraints
       search conditions</p>
-<a name="N11862" class="indexterm"></a>
+<a name="N11876" class="indexterm"></a>
 <p>COLLATIONS</p>
 <p>Information on collations supported by the database.</p>
-<a name="N1186B" class="indexterm"></a>
+<a name="N1187F" class="indexterm"></a>
 <p>COLUMNS</p>
 <p>Information on COLUMN objects in TABLE and VIEW definitions</p>
-<a name="N11874" class="indexterm"></a>
+<a name="N11888" class="indexterm"></a>
 <p>COLUMN_COLUMN_USAGE</p>
 <p>Information on references to COLUMN objects from other, GENERATED,
       COLUMN objects</p>
-<a name="N1187D" class="indexterm"></a>
+<a name="N11891" class="indexterm"></a>
 <p>COLUMN_DOMAIN_USAGE</p>
 <p>Information on DOMAIN objects used in type definition of COLUMN
       objects</p>
-<a name="N11886" class="indexterm"></a>
+<a name="N1189A" class="indexterm"></a>
 <p>COLUMN_PRIVILEGES</p>
 <p>Information on privileges on each COLUMN object, granted to
       different ROLE and USER authorizations</p>
-<a name="N1188F" class="indexterm"></a>
+<a name="N118A3" class="indexterm"></a>
 <p>COLUMN_UDT_USAGE</p>
 <p>Information on distinct TYPE objects used in type definition of
       COLUMN objects</p>
-<a name="N11898" class="indexterm"></a>
+<a name="N118AC" class="indexterm"></a>
 <p>CONSTRAINT_COLUMN_USAGE</p>
 <p>Information on COLUMN objects referenced by CONSTRAINT objects in
       the database</p>
-<a name="N118A1" class="indexterm"></a>
+<a name="N118B5" class="indexterm"></a>
 <p>CONSTRAINT_PERIOD_USAGE</p>
 <p>Information on application PERIOD objects referenced by CONSTRAINT
       objects in the database</p>
-<a name="N118AA" class="indexterm"></a>
+<a name="N118BE" class="indexterm"></a>
 <p>CONSTRAINT_TABLE_USAGE</p>
 <p>Information on TABLE and VIEW objects referenced by CONSTRAINT
       objects in the database</p>
-<a name="N118B3" class="indexterm"></a>
+<a name="N118C7" class="indexterm"></a>
 <p>DATA_TYPE_PRIVILEGES</p>
 <p>Information on top level schema objects of various kinds that
       reference TYPE objects</p>
-<a name="N118BC" class="indexterm"></a>
+<a name="N118D0" class="indexterm"></a>
 <p>DOMAINS</p>
 <p>Top level information on DOMAIN objects in the database.</p>
-<a name="N118C5" class="indexterm"></a>
+<a name="N118D9" class="indexterm"></a>
 <p>DOMAIN_CONSTRAINTS</p>
 <p>Information on CONSTRAINT definitions used for DOMAIN
       objects</p>
-<a name="N118CE" class="indexterm"></a>
+<a name="N118E2" class="indexterm"></a>
 <p>ELEMENT_TYPES</p>
 <p>Information on the type of elements of ARRAY used in database
       columns or routine parameters and return values</p>
-<a name="N118D7" class="indexterm"></a>
+<a name="N118EB" class="indexterm"></a>
 <p>ENABLED_ROLES</p>
 <p>Information on ROLE privileges enabled for the current
       session</p>
-<a name="N118E0" class="indexterm"></a>
+<a name="N118F4" class="indexterm"></a>
 <p>INFORMATION_SCHEMA_CATALOG_NAME</p>
 <p>Information on the single CATALOG object of the database</p>
-<a name="N118E9" class="indexterm"></a>
+<a name="N118FD" class="indexterm"></a>
 <p>KEY_COLUMN_USAGE</p>
 <p>Information on COLUMN objects of tables that are used by PRIMARY
       KEY, UNIQUE and FOREIGN KEY constraints</p>
-<a name="N118F2" class="indexterm"></a>
+<a name="N11906" class="indexterm"></a>
 <p>KEY_PERIOD_USAGE</p>
 <p>Information on application PERIOD objects that are used by PRIMARY
       KEY, UNIQUE and FOREIGN KEY constraints</p>
-<a name="N118FB" class="indexterm"></a>
+<a name="N1190F" class="indexterm"></a>
 <p>PARAMETERS</p>
 <p>Information on parameters of each FUNCTION or PROCEDURE</p>
-<a name="N11904" class="indexterm"></a>
+<a name="N11918" class="indexterm"></a>
 <p>PERIODS</p>
 <p>Information on PERIOD objects defined in tables</p>
-<a name="N1190D" class="indexterm"></a>
+<a name="N11921" class="indexterm"></a>
 <p>REFERENTIAL_CONSTRAINTS</p>
 <p>Additional information on FOREIGN KEY constraints, including
       triggered action and name of UNIQUE constraint they refer to</p>
-<a name="N11916" class="indexterm"></a>
+<a name="N1192A" class="indexterm"></a>
 <p>ROLE_AUTHORIZATION_DESCRIPTORS</p>
-<a name="N1191D" class="indexterm"></a>
+<a name="N11931" class="indexterm"></a>
 <p>ROLE_COLUMN_GRANTS</p>
 <p>Information on privileges on COLUMN objects granted to or by the
       current session roles</p>
-<a name="N11926" class="indexterm"></a>
+<a name="N1193A" class="indexterm"></a>
 <p>ROLE_ROUTINE_GRANTS</p>
 <p>Information on privileges on FUNCTION and PROCEDURE objects
       granted to or by the current session roles</p>
-<a name="N1192F" class="indexterm"></a>
+<a name="N11943" class="indexterm"></a>
 <p>ROLE_TABLE_GRANTS</p>
 <p>Information on privileges on TABLE and VIEW objects granted to or
       by the current session roles</p>
-<a name="N11938" class="indexterm"></a>
+<a name="N1194C" class="indexterm"></a>
 <p>ROLE_UDT_GRANTS</p>
 <p>Information on privileges on TYPE objects granted to or by the
       current session roles</p>
-<a name="N11941" class="indexterm"></a>
+<a name="N11955" class="indexterm"></a>
 <p>ROLE_USAGE_GRANTS</p>
 <p>Information on privileges on USAGE privileges granted to or by the
       current session roles</p>
-<a name="N1194A" class="indexterm"></a>
+<a name="N1195E" class="indexterm"></a>
 <p>ROUTINE_COLUMN_USAGE</p>
 <p>Information on COLUMN objects of different tables that are
       referenced in FUNCTION and PROCEDURE definitions</p>
-<a name="N11953" class="indexterm"></a>
+<a name="N11967" class="indexterm"></a>
 <p>ROUTINE_JAR_USAGE</p>
 <p>Information on JAR usage by Java language FUNCTION and PROCEDURE
       objects.</p>
-<a name="N1195C" class="indexterm"></a>
+<a name="N11970" class="indexterm"></a>
 <p>ROUTINE_PERIOD_USAGE</p>
 <p>Information on table PERIOD objects referenced in FUNCTION and
       PROCEDURE objects.</p>
-<a name="N11965" class="indexterm"></a>
+<a name="N11979" class="indexterm"></a>
 <p>ROUTINE_PRIVILEGES</p>
 <p>Information on EXECUTE privileges granted on PROCEDURE and
       FUNCTION objects</p>
-<a name="N1196E" class="indexterm"></a>
+<a name="N11982" class="indexterm"></a>
 <p>ROUTINE_ROUTINE_USAGE</p>
 <p>Information on PROCEDURE and FUNCTION objects that are referenced
       in FUNCTION and PROCEDURE definitions</p>
-<a name="N11977" class="indexterm"></a>
+<a name="N1198B" class="indexterm"></a>
 <p>ROUTINE_SEQUENCE_USAGE</p>
 <p>Information on SEQUENCE objects that are referenced in FUNCTION
       and PROCEDURE definitions</p>
-<a name="N11980" class="indexterm"></a>
+<a name="N11994" class="indexterm"></a>
 <p>ROUTINE_TABLE_USAGE</p>
 <p>Information on TABLE and VIEW objects that are referenced in
       FUNCTION and PROCEDURE definitions</p>
-<a name="N11989" class="indexterm"></a>
+<a name="N1199D" class="indexterm"></a>
 <p>ROUTINES</p>
 <p>Top level information on all PROCEDURE and FUNCTION objects in the
       database</p>
-<a name="N11992" class="indexterm"></a>
+<a name="N119A6" class="indexterm"></a>
 <p>SCHEMATA</p>
 <p>Information on all the SCHEMA objects in the database</p>
-<a name="N1199B" class="indexterm"></a>
+<a name="N119AF" class="indexterm"></a>
 <p>SEQUENCES</p>
 <p>Information on SEQUENCE objects</p>
-<a name="N119A4" class="indexterm"></a>
+<a name="N119B8" class="indexterm"></a>
 <p>SQL_FEATURES</p>
 <p>List of all SQL:2011 standard features, including information on
       whether they are supported or not supported by HyperSQL</p>
-<a name="N119AD" class="indexterm"></a>
+<a name="N119C1" class="indexterm"></a>
 <p>SQL_IMPLEMENTATION_INFO</p>
 <p>Information on name, capabilities and defaults of the database
       engine software.</p>
-<a name="N119B6" class="indexterm"></a>
+<a name="N119CA" class="indexterm"></a>
 <p>SQL_PACKAGES</p>
 <p>List of SQL:2011 Standard packages, including information on
       whether they are supported or not supported by HyperSQL</p>
-<a name="N119BF" class="indexterm"></a>
+<a name="N119D3" class="indexterm"></a>
 <p>SQL_PARTS</p>
 <p>List of the SQL:2011 Standard parts, including information on
       whether they are supported or not supported by HyperSQL</p>
-<a name="N119C8" class="indexterm"></a>
+<a name="N119DC" class="indexterm"></a>
 <p>SQL_SIZING</p>
 <p>List of the SQL:2011 Standard maximum supported sizes for
       different features as supported by HyperSQL</p>
-<a name="N119D1" class="indexterm"></a>
+<a name="N119E5" class="indexterm"></a>
 <p>SQL_SIZING_PROFILES</p>
-<a name="N119D8" class="indexterm"></a>
+<a name="N119EC" class="indexterm"></a>
 <p>TABLES</p>
 <p>Information on all TABLE and VIEW object, including the
       INFORMATION_SCHEMA views themselves</p>
-<a name="N119E1" class="indexterm"></a>
+<a name="N119F5" class="indexterm"></a>
 <p>TABLE_CONSTRAINTS</p>
 <p>Information on all table level constraints, including PRIMARY KEY,
       UNIQUE, FOREIGN KEY and CHECK constraints</p>
-<a name="N119EA" class="indexterm"></a>
+<a name="N119FE" class="indexterm"></a>
 <p>TABLE_PRIVILEGES</p>
 <p>Information on privileges on TABLE and VIEW objects owned or given
       to the current user</p>
-<a name="N119F3" class="indexterm"></a>
+<a name="N11A07" class="indexterm"></a>
 <p>TRANSLATIONS</p>
-<a name="N119FA" class="indexterm"></a>
+<a name="N11A0E" class="indexterm"></a>
 <p>TRIGGERED_UPDATE_COLUMNS</p>
 <p>Information on columns that have been used in TRIGGER definitions
       in the ON UPDATE clause</p>
-<a name="N11A03" class="indexterm"></a>
+<a name="N11A17" class="indexterm"></a>
 <p>TRIGGERS</p>
 <p>Top level information on the TRIGGER definitions in the
       databases</p>
-<a name="N11A0C" class="indexterm"></a>
+<a name="N11A20" class="indexterm"></a>
 <p>TRIGGER_COLUMN_USAGE</p>
 <p>Information on COLUMN objects that have been referenced in the
       body of TRIGGER definitions</p>
-<a name="N11A15" class="indexterm"></a>
+<a name="N11A29" class="indexterm"></a>
 <p>TRIGGER_PERIOD_USAGE</p>
 <p>Information on PERIOD objects that have been referenced in the
       body of TRIGGER definitions</p>
-<a name="N11A1E" class="indexterm"></a>
+<a name="N11A32" class="indexterm"></a>
 <p>TRIGGER_ROUTINE_USAGE</p>
 <p>Information on FUNCTION and PROCEDURE objects that have been used
       in TRIGGER definitions</p>
-<a name="N11A27" class="indexterm"></a>
+<a name="N11A3B" class="indexterm"></a>
 <p>TRIGGER_SEQUENCE_USAGE</p>
 <p>Information on SEQUENCE objects that been referenced in TRIGGER
       definitions</p>
-<a name="N11A30" class="indexterm"></a>
+<a name="N11A44" class="indexterm"></a>
 <p>TRIGGER_TABLE_USAGE</p>
 <p>Information on TABLE and VIEW objects that have been referenced in
       TRIGGER definitions</p>
-<a name="N11A39" class="indexterm"></a>
+<a name="N11A4D" class="indexterm"></a>
 <p>USAGE_PRIVILEGES</p>
 <p>Information on USAGE privileges granted to or owned by the current
       user</p>
-<a name="N11A42" class="indexterm"></a>
+<a name="N11A56" class="indexterm"></a>
 <p>USER_DEFINED_TYPES</p>
 <p>Top level information on TYPE objects in the database</p>
-<a name="N11A4B" class="indexterm"></a>
+<a name="N11A5F" class="indexterm"></a>
 <p>VIEWS</p>
 <p>Top Level information on VIEW objects in the database</p>
-<a name="N11A54" class="indexterm"></a>
+<a name="N11A68" class="indexterm"></a>
 <p>VIEW_COLUMN_USAGE</p>
 <p>Information on COLUMN objects referenced in the query expressions
       of the VIEW objects</p>
-<a name="N11A5D" class="indexterm"></a>
+<a name="N11A71" class="indexterm"></a>
 <p>VIEW_PERIOD_USAGE</p>
 <p>Information on PERIOD objects referenced in the query expressions
       of the VIEW objects</p>
-<a name="N11A66" class="indexterm"></a>
+<a name="N11A7A" class="indexterm"></a>
 <p>VIEW_ROUTINE_USAGE</p>
 <p>Information on FUNCTION and PROCEDURE objects that have been used
       in the query expressions of the VIEW objects</p>
-<a name="N11A6F" class="indexterm"></a>
+<a name="N11A83" class="indexterm"></a>
 <p>VIEW_TABLE_USAGE</p>
 <p>Information on TABLE and VIEW objects that have been referenced in
       the query expressions of the VIEW objects</p>
@@ -4251,53 +4251,53 @@
         views are used directly by JDBC DatabaseMetaData method calls and are
         indicated as such. Some views contain information that is specific to
         HyperSQL and is not covered by the SQL Standard views.</p>
-<a name="N11A7E" class="indexterm"></a>
+<a name="N11A92" class="indexterm"></a>
 <p>SYSTEM_BESTROWIDENTIFIER</p>
 <p>For DatabaseMetaData.getBestRowIdentifier</p>
-<a name="N11A87" class="indexterm"></a>
+<a name="N11A9B" class="indexterm"></a>
 <p>SYSTEM_CACHEINFO</p>
 <p>Contains the current settings and variables of the data cache
         used for all CACHED tables, and the data cache of each TEXT
         table.</p>
-<a name="N11A90" class="indexterm"></a>
+<a name="N11AA4" class="indexterm"></a>
 <p>SYSTEM_COLUMN_SEQUENCE_USAGE</p>
 <p>Contains a row for each column that is defined as GENERATED BY
         DEFAULT AS SEQUENCE with the column name and sequence name</p>
-<a name="N11A99" class="indexterm"></a>
+<a name="N11AAD" class="indexterm"></a>
 <p>SYSTEM_COLUMNS</p>
 <p>For DatabaseMetaData.getColumns, contains a row for each
         column</p>
-<a name="N11AA2" class="indexterm"></a>
+<a name="N11AB6" class="indexterm"></a>
 <p>SYSTEM_COMMENTS</p>
 <p>Contains the user-defined comments added to tables and their
         columns. Also informational comments on INFORMATION_SCHEMA
         views</p>
-<a name="N11AAB" class="indexterm"></a>
+<a name="N11ABF" class="indexterm"></a>
 <p>SYSTEM_CONNECTION_PROPERTIES</p>
 <p>For DatabaseMetaData.getClientInfoProperties</p>
-<a name="N11AB4" class="indexterm"></a>
+<a name="N11AC8" class="indexterm"></a>
 <p>SYSTEM_CROSSREFERENCE</p>
 <p>Full list of all columns referenced by FOREIGN KEY constraints.
         For DatabaseMetaData.getCrossReference, getExportedKeys and
         getImportedKeys.</p>
-<a name="N11ABD" class="indexterm"></a>
+<a name="N11AD1" class="indexterm"></a>
 <p>SYSTEM_INDEXINFO</p>
 <p>For DatabaseMetaData.getIndexInfo</p>
-<a name="N11AC6" class="indexterm"></a>
+<a name="N11ADA" class="indexterm"></a>
 <p>SYSTEM_KEY_INDEX_USAGE</p>
 <p>List of system-generated index names for each PRIMARY KEY,
         UNIQUE and FOREIGN KEY constraint.</p>
-<a name="N11ACF" class="indexterm"></a>
+<a name="N11AE3" class="indexterm"></a>
 <p>SYSTEM_PRIMARYKEYS</p>
 <p>For DatabaseMetaData.getPrimaryKeys</p>
-<a name="N11AD8" class="indexterm"></a>
+<a name="N11AEC" class="indexterm"></a>
 <p>SYSTEM_PROCEDURECOLUMNS</p>
 <p>For DatabaseMetaData.getProcedureColumns</p>
-<a name="N11AE1" class="indexterm"></a>
+<a name="N11AF5" class="indexterm"></a>
 <p>SYSTEM_PROCEDURES</p>
 <p>For DatabaseMetaData.getFunctionColumns, getFunctions and
         getProcedures</p>
-<a name="N11AEA" class="indexterm"></a>
+<a name="N11AFE" class="indexterm"></a>
 <p>SYSTEM_PROPERTIES</p>
 <p>Contains the current values of all the database level
         properties. Settings such as SQL rule enforcement, database
@@ -4305,45 +4305,45 @@
         this view. The names of the properties are listed in the <a class="link" href="dbproperties-chapt.html" title="Chapter&nbsp;14.&nbsp;Properties">Properties</a>
         chapter together with the corresponding SQL statements used to change
         the properties.</p>
-<a name="N11AF8" class="indexterm"></a>
+<a name="N11B0C" class="indexterm"></a>
 <p>SYSTEM_SCHEMAS</p>
 <p>For DatabaseMetaData.getSchemas</p>
-<a name="N11B01" class="indexterm"></a>
+<a name="N11B15" class="indexterm"></a>
 <p>SYSTEM_SEQUENCES</p>
-<a name="N11B08" class="indexterm"></a>
+<a name="N11B1C" class="indexterm"></a>
 <p>SYSTEM_SESSIONINFO</p>
 <p>Information on the settings and properties of the current
         session.</p>
-<a name="N11B11" class="indexterm"></a>
+<a name="N11B25" class="indexterm"></a>
 <p>SYSTEM_SESSIONS</p>
 <p>Information on all open sessions in the database (when used by a
         DBA user), or just the current session. Includes the current
         transaction state of each session.</p>
-<a name="N11B1A" class="indexterm"></a>
+<a name="N11B2E" class="indexterm"></a>
 <p>SYSTEM_TABLES</p>
 <p>Information on tables and views for
         DatabaseMetaData.getTables</p>
-<a name="N11B23" class="indexterm"></a>
+<a name="N11B37" class="indexterm"></a>
 <p>SYSTEM_TABLESTATS</p>
 <p>Information on table spaces and cardinality for each
         table</p>
-<a name="N11B2C" class="indexterm"></a>
+<a name="N11B40" class="indexterm"></a>
 <p>SYSTEM_TABLETYPES</p>
 <p>For DatabaseMetaData.getTableTypes</p>
-<a name="N11B35" class="indexterm"></a>
+<a name="N11B49" class="indexterm"></a>
 <p>SYSTEM_TEXTTABLES</p>
 <p>Information on the settings of each text table.</p>
-<a name="N11B3E" class="indexterm"></a>
+<a name="N11B52" class="indexterm"></a>
 <p>SYSTEM_TYPEINFO</p>
 <p>For DatabaseMetaData.getTypeInfo</p>
-<a name="N11B47" class="indexterm"></a>
+<a name="N11B5B" class="indexterm"></a>
 <p>SYSTEM_UDTS</p>
 <p>For DatabaseMetaData.getUDTs</p>
-<a name="N11B50" class="indexterm"></a>
+<a name="N11B64" class="indexterm"></a>
 <p>SYSTEM_USERS</p>
 <p>Contains the list of all users in the database (when used by a
         DBA user), or just the current user.</p>
-<a name="N11B59" class="indexterm"></a>
+<a name="N11B6D" class="indexterm"></a>
 <p>SYSTEM_VERSIONCOLUMNS</p>
 <p>For DatabaseMetaData.getVersionColumns. Contains list of columns
         of system PERIOD and those with ON UPDATE CURRENT TIMESTAMP.</p>
@@ -4352,7 +4352,7 @@
 </div>
 </div>
 <HR xmlns:xi="http://www.w3.org/2001/XInclude">
-<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6369 $</P>
+<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6474 $</P>
 <div class="navfooter">
 <hr>
 <table summary="Navigation footer" width="100%">
diff -pruN 2.6.1-1/hsqldb/doc/guide/dbfiles-app.html 2.7.0-1/hsqldb/doc/guide/dbfiles-app.html
--- 2.6.1-1/hsqldb/doc/guide/dbfiles-app.html	2021-10-20 09:33:34.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/guide/dbfiles-app.html	2022-07-26 20:21:48.000000000 +0000
@@ -34,7 +34,7 @@
 <p class="releaseinfo">$Revision: 5925 $</p>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -294,7 +294,7 @@
 </div>
 </div>
 <div class="procedure">
-<a name="N17A2A"></a>
+<a name="N17CAC"></a>
 <p class="title">
 <b>Procedure&nbsp;B.1.&nbsp;Clean HyperSQL database shutdown</b>
 </p>
@@ -356,7 +356,7 @@
 </div>
 </div>
 <div class="procedure">
-<a name="N17A74"></a>
+<a name="N17CF6"></a>
 <p class="title">
 <b>Procedure&nbsp;B.2.&nbsp;Opening the Database</b>
 </p>
@@ -410,7 +410,7 @@
 <p>The current <code class="filename">test.data</code> file is not necessarily
       consistent. The database engine takes these steps:</p>
 <div class="procedure">
-<a name="N17AB6"></a>
+<a name="N17D38"></a>
 <p class="title">
 <b>Procedure&nbsp;B.3.&nbsp;Restore a Database</b>
 </p>
@@ -445,7 +445,7 @@
 </div>
 </div>
 <HR xmlns:xi="http://www.w3.org/2001/XInclude">
-<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6369 $</P>
+<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6474 $</P>
 <div class="navfooter">
 <hr>
 <table summary="Navigation footer" width="100%">
diff -pruN 2.6.1-1/hsqldb/doc/guide/dbproperties-chapt.html 2.7.0-1/hsqldb/doc/guide/dbproperties-chapt.html
--- 2.6.1-1/hsqldb/doc/guide/dbproperties-chapt.html	2021-10-20 09:33:34.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/guide/dbproperties-chapt.html	2022-07-26 20:21:48.000000000 +0000
@@ -45,12 +45,12 @@
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6366 $</p>
+<p class="releaseinfo">$Revision: 6491 $</p>
 </div>
 <div>
 <div class="legalnotice">
-<a name="N15EE4"></a>
-<p>Copyright 2002-2021 Fred Toussi. Permission is granted to
+<a name="N160A7"></a>
+<p>Copyright 2002-2022 Fred Toussi. Permission is granted to
       distribute this document without any alteration under the terms of the
       HSQLDB license. Additional permission is granted to the HSQL Development
       Group to distribute this document with or without alterations under the
@@ -58,7 +58,7 @@
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -74,7 +74,7 @@
 <span class="section"><a href="dbproperties-chapt.html#dpc_variables_url">Variables in Connection URL</a></span>
 </dt>
 <dt>
-<span class="section"><a href="dbproperties-chapt.html#N16054">Connection Properties</a></span>
+<span class="section"><a href="dbproperties-chapt.html#N16217">Connection Properties</a></span>
 </dt>
 <dt>
 <span class="section"><a href="dbproperties-chapt.html#dpc_connection_props">Properties for Individual Connections</a></span>
@@ -114,9 +114,9 @@
 </div>
 <p>The normal method of accessing a HyperSQL catalog is via the JDBC
     Connection interface. An introduction to different methods of providing
-    database services and accessing them can be found in the <a class="link" href="sqlgeneral-chapt.html" title="Chapter&nbsp;2.&nbsp;SQL Language">SQL Language</a> chapter.
-    Details and examples of how to connect via JDBC are provided in our
-    JavaDoc for <code class="classname"><a class="classname" href="filelinks-app.html#JDBCConnection.html-link">JDBCConnection</a></code>.</p>
+    database services and accessing them can be found in the <a class="link" href="running-chapt.html" title="Chapter&nbsp;1.&nbsp;Running and Using HyperSQL">Running and Using HyperSQL</a> chapter. Details and
+    examples of how to connect via JDBC are provided in our JavaDoc for
+    <code class="classname"><a class="classname" href="filelinks-app.html#JDBCConnection.html-link">JDBCConnection</a></code>.</p>
 <p>A uniform method is used to distinguish between different types of
     connection. The common driver identifier is
     <code class="literal">jdbc:hsqldb:</code> followed by a protocol identifier
@@ -128,7 +128,7 @@
     property / value pairs can be appended to the end of the URL, separated
     with semicolons.</p>
 <div class="table">
-<a name="N15F0F"></a>
+<a name="N160D2"></a>
 <p class="title">
 <b>Table&nbsp;14.1.&nbsp;Memory Database URL</b>
 </p>
@@ -188,7 +188,7 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N15F50"></a>
+<a name="N16113"></a>
 <p class="title">
 <b>Table&nbsp;14.2.&nbsp;File Database URL</b>
 </p>
@@ -249,7 +249,7 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N15F96"></a>
+<a name="N16159"></a>
 <p class="title">
 <b>Table&nbsp;14.3.&nbsp;Resource Database URL</b>
 </p>
@@ -296,7 +296,7 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N15FCA"></a>
+<a name="N1618D"></a>
 <p class="title">
 <b>Table&nbsp;14.4.&nbsp;Server Database URL</b>
 </p>
@@ -426,12 +426,12 @@
 <div>
 <div>
 <h2 class="title" style="clear: both">
-<a name="N16054"></a>Connection Properties</h2>
+<a name="N16217"></a>Connection Properties</h2>
 </div>
 </div>
 </div>
 <p>There are two types of connection properties: properties for
-    individual connections, and Properties for the whole database.</p>
+    individual connections, and properties for the whole database.</p>
 <p>The properties for individual connections apply only to the
     connection that uses them and can be different for different connections.
     These properties can be used when connecting to in-process and server
@@ -442,9 +442,14 @@
     <em class="glossterm">mem:</em> database. For the connection that creates a
     new database all the user-defined database properties can be specified as
     URL properties.</p>
+<p>A few of the properties for the database can be applied to an
+    existing database when the database is reopened after a shutdown.</p>
 <p>When running a server, these properties are not used on the
     connection URL but can be appended to the database path URL in
     <code class="literal">server.properties</code> or the server command line.</p>
+<p>Almost all properties for the database listed in this chapter have
+    corresponding SQL statements which can be used after connecting to the
+    database. The SQL statement for each property is listed here.</p>
 </div>
 <div class="section">
 <div class="titlepage">
@@ -465,7 +470,7 @@
     Connection URL.</p>
 <pre class="programlisting"> DriverManager.getConnection (String url, Properties info);</pre>
 <div class="table">
-<a name="N1607B"></a>
+<a name="N16242"></a>
 <p class="title">
 <b>Table&nbsp;14.5.&nbsp;User and Password</b>
 </p>
@@ -515,73 +520,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N160BC"></a>
+<a name="N16283"></a>
 <p class="title">
-<b>Table&nbsp;14.6.&nbsp;Creating New Database</b>
-</p>
-<div class="table-contents">
-<table summary="Creating New Database" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
-<colgroup>
-<col width="6.5cm" align="left" class="c1">
-<col width="1.5cm" align="left" class="c2">
-<col align="left" class="c3">
-</colgroup>
-<thead>
-<tr>
-<th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Name</th><th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Default</th><th style="border-bottom: 0.5pt solid ; " align="left">Description</th>
-</tr>
-</thead>
-<tbody valign="top">
-<tr>
-<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">ifexists</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">false</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">connect only if database already exists</td>
-</tr>
-<tr>
-<td style="border-bottom: 0.5pt solid ; " colspan="3" align="left" valign="top">
-<p>Has an effect only with
-            <em class="glossterm">mem:</em> and <em class="glossterm">file:</em>
-            database. When true, will not create a new database if one does
-            not already exist for the URL.</p>
-<p>When the property is
-            false (the default), a new <em class="glossterm">mem:</em> or
-            <em class="glossterm">file:</em> database will be created if it does
-            not exist.</p>
-<p>Setting the property to true is useful when
-            troubleshooting as no database is created if the URL is malformed.
-            Example below:</p>
-<pre class="programlisting"> jdbc:hsqldb:file:accounts;ifexists=true</pre>
-</td>
-</tr>
-<tr>
-<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">create</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">true</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">create the database if it does not exist</td>
-</tr>
-<tr>
-<td style="" colspan="3" align="left" valign="top">
-<p>Similar to the ifexists
-            property, but with opposite meaning.</p>
-<p>Has an effect
-            only with <em class="glossterm">mem:</em> and
-            <em class="glossterm">file:</em> databases. When false, will not
-            create a new database if one does not already exist for the
-            URL.</p>
-<p>When the property is true (the default), a new
-            <em class="glossterm">mem:</em> or <em class="glossterm">file:</em>
-            database will be created if it does not exist.</p>
-<p>Setting
-            the property to true is useful when troubleshooting as no database
-            is created if the URL is malformed. Example
-            below:</p>
-<pre class="programlisting"> jdbc:hsqldb:file:enrolments;create=false</pre>
-</td>
-</tr>
-</tbody>
-</table>
-</div>
-</div>
-<br class="table-break">
-<div class="table">
-<a name="N1611B"></a>
-<p class="title">
-<b>Table&nbsp;14.7.&nbsp;Closing old ResultSet when Statement is reused</b>
+<b>Table&nbsp;14.6.&nbsp;Closing old ResultSet when Statement is reused</b>
 </p>
 <div class="table-contents">
 <table summary="Closing old ResultSet when Statement is reused" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -632,9 +573,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16162"></a>
+<a name="N162CA"></a>
 <p class="title">
-<b>Table&nbsp;14.8.&nbsp;Column Names in JDBC ResultSet</b>
+<b>Table&nbsp;14.7.&nbsp;Column Names in JDBC ResultSet</b>
 </p>
 <div class="table-contents">
 <table summary="Column Names in JDBC ResultSet" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -677,9 +618,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N1619B"></a>
+<a name="N16303"></a>
 <p class="title">
-<b>Table&nbsp;14.9.&nbsp;In-memory LOBs from JDBC ResultSet</b>
+<b>Table&nbsp;14.8.&nbsp;In-memory LOBs from JDBC ResultSet</b>
 </p>
 <div class="table-contents">
 <table summary="In-memory LOBs from JDBC ResultSet" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -717,9 +658,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N161CC"></a>
+<a name="N16334"></a>
 <p class="title">
-<b>Table&nbsp;14.10.&nbsp;Empty batch in JDBC PreparedStatement</b>
+<b>Table&nbsp;14.9.&nbsp;Empty batch in JDBC PreparedStatement</b>
 </p>
 <div class="table-contents">
 <table summary="Empty batch in JDBC PreparedStatement" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -762,9 +703,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16202"></a>
+<a name="N1636A"></a>
 <p class="title">
-<b>Table&nbsp;14.11.&nbsp;Automatic Shutdown</b>
+<b>Table&nbsp;14.10.&nbsp;Automatic Shutdown</b>
 </p>
 <div class="table-contents">
 <table summary="Automatic Shutdown" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -815,6 +756,44 @@
 </div>
 </div>
 <br class="table-break">
+<div class="table">
+<a name="N163A1"></a>
+<p class="title">
+<b>Table&nbsp;14.11.&nbsp;OpenOffice and Libre Office usage</b>
+</p>
+<div class="table-contents">
+<table summary="OpenOffice and Libre Office usage" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
+<colgroup>
+<col width="7cm" align="left" class="c1">
+<col width="1.5cm" align="left" class="c2">
+<col align="left" class="c3">
+</colgroup>
+<thead>
+<tr>
+<th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Name</th><th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Default</th><th style="border-bottom: 0.5pt solid ; " align="left">Description</th>
+</tr>
+</thead>
+<tbody valign="top">
+<tr>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">default_schema</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">false</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">OpenOffice and LibreOffice connections</td>
+</tr>
+<tr>
+<td style="" colspan="3" align="left" valign="top">
+<p>When HyperSQL is used with
+            OpenOffice.org as an external database, the property
+            "default_schema=true" must be set on the URL, otherwise the
+            program will not operate correctly as it does with its built-in
+            hsqldb instance.</p>
+<p>The default is
+            false.</p>
+<pre class="programlisting"> jdbc:hsqldb:hsql://localhost/enrolments;default_schema=true</pre>
+</td>
+</tr>
+</tbody>
+</table>
+</div>
+</div>
+<br class="table-break">
 </div>
 <div class="section">
 <div class="titlepage">
@@ -835,11 +814,16 @@
     corresponding SQL command is given for each property. For a server, these
     properties can be appended to the database path URL in server.properties
     or the server command line.</p>
+<p>When connecting to an <em class="glossterm">in-process</em> database
+    creates a new database, or opens an existing database (i.e. it is the
+    first connection made to the database by the application), all the
+    user-defined database properties listed in this section can be specified
+    as URL properties.</p>
 <p>Note the preferred method of setting database properties is by using
     a set of SQL statements. These statements can be used both for a new
     database or an existing database, unlike URL properties that are generally
     effective for new databases only.</p>
-<p>If the properties are used for connection to an existing database,
+<p>If these properties are used for connection to an existing database,
     they are ignored.</p>
 <p>The exceptions are the following property settings that are allowed
     for the first connection to an existing database (the connection which
@@ -865,7 +849,7 @@
     statements are described more extensively in the <a class="link" href="management-chapt.html" title="Chapter&nbsp;11.&nbsp;System Management">System Management</a>
     chapter.</p>
 <div class="table">
-<a name="N1626C"></a>
+<a name="N16407"></a>
 <p class="title">
 <b>Table&nbsp;14.12.&nbsp;Validity Check Property</b>
 </p>
@@ -899,6 +883,70 @@
 </div>
 </div>
 <br class="table-break">
+<div class="table">
+<a name="N16434"></a>
+<p class="title">
+<b>Table&nbsp;14.13.&nbsp;Creating New Database Check Property</b>
+</p>
+<div class="table-contents">
+<table summary="Creating New Database Check Property" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
+<colgroup>
+<col width="6.5cm" align="left" class="c1">
+<col width="1.5cm" align="left" class="c2">
+<col align="left" class="c3">
+</colgroup>
+<thead>
+<tr>
+<th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Name</th><th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Default</th><th style="border-bottom: 0.5pt solid ; " align="left">Description</th>
+</tr>
+</thead>
+<tbody valign="top">
+<tr>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">ifexists</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">false</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">connect only if database already exists</td>
+</tr>
+<tr>
+<td style="border-bottom: 0.5pt solid ; " colspan="3" align="left" valign="top">
+<p>Has an effect only with
+            <em class="glossterm">mem:</em> and <em class="glossterm">file:</em>
+            database. When true, will not create a new database if one does
+            not already exist for the URL.</p>
+<p>When the property is
+            false (the default), a new <em class="glossterm">mem:</em> or
+            <em class="glossterm">file:</em> database will be created if it does
+            not exist.</p>
+<p>Setting the property to true is useful when
+            troubleshooting as no database is created if the URL is malformed.
+            Example below:</p>
+<pre class="programlisting"> jdbc:hsqldb:file:accounts;ifexists=true</pre>
+</td>
+</tr>
+<tr>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">create</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">true</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">create the database if it does not exist</td>
+</tr>
+<tr>
+<td style="" colspan="3" align="left" valign="top">
+<p>Similar to the ifexists
+            property, but with opposite meaning.</p>
+<p>Has an effect
+            only with <em class="glossterm">mem:</em> and
+            <em class="glossterm">file:</em> databases. When false, will not
+            create a new database if one does not already exist for the
+            URL.</p>
+<p>When the property is true (the default), a new
+            <em class="glossterm">mem:</em> or <em class="glossterm">file:</em>
+            database will be created if it does not exist.</p>
+<p>Setting
+            the property to true is useful when troubleshooting as no database
+            is created if the URL is malformed. Example
+            below:</p>
+<pre class="programlisting"> jdbc:hsqldb:file:enrolments;create=false</pre>
+</td>
+</tr>
+</tbody>
+</table>
+</div>
+</div>
+<br class="table-break">
 <div class="section">
 <div class="titlepage">
 <div>
@@ -909,9 +957,9 @@
 </div>
 </div>
 <div class="table">
-<a name="N1629D"></a>
+<a name="N16497"></a>
 <p class="title">
-<b>Table&nbsp;14.13.&nbsp;Execution of Multiple SQL Statements etc.</b>
+<b>Table&nbsp;14.14.&nbsp;Execution of Multiple SQL Statements etc.</b>
 </p>
 <div class="table-contents">
 <table summary="Execution of Multiple SQL Statements etc." cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -957,9 +1005,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N162DD"></a>
+<a name="N164D7"></a>
 <p class="title">
-<b>Table&nbsp;14.14.&nbsp;SQL Keyword Use as Identifier</b>
+<b>Table&nbsp;14.15.&nbsp;SQL Keyword Use as Identifier</b>
 </p>
 <div class="table-contents">
 <table summary="SQL Keyword Use as Identifier" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -991,9 +1039,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N1630A"></a>
+<a name="N16504"></a>
 <p class="title">
-<b>Table&nbsp;14.15.&nbsp;SQL Keyword Starting with the Underscore or Containing Dollar
+<b>Table&nbsp;14.16.&nbsp;SQL Keyword Starting with the Underscore or Containing Dollar
         Characters</b>
 </p>
 <div class="table-contents">
@@ -1028,9 +1076,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16337"></a>
+<a name="N16531"></a>
 <p class="title">
-<b>Table&nbsp;14.16.&nbsp;Reference to Columns Names</b>
+<b>Table&nbsp;14.17.&nbsp;Reference to Columns Names</b>
 </p>
 <div class="table-contents">
 <table summary="Reference to Columns Names" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -1065,9 +1113,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16364"></a>
+<a name="N1655E"></a>
 <p class="title">
-<b>Table&nbsp;14.17.&nbsp;String Size Declaration</b>
+<b>Table&nbsp;14.18.&nbsp;String Size Declaration</b>
 </p>
 <div class="table-contents">
 <table summary="String Size Declaration" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -1103,9 +1151,46 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16391"></a>
+<a name="N1658B"></a>
+<p class="title">
+<b>Table&nbsp;14.19.&nbsp;Truncation of trailing spaces from string</b>
+</p>
+<div class="table-contents">
+<table summary="Truncation of trailing spaces from string" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
+<colgroup>
+<col width="6.5cm" align="left" class="c1">
+<col width="1.5cm" align="left" class="c2">
+<col align="left" class="c3">
+</colgroup>
+<thead>
+<tr>
+<th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Name</th><th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Default</th><th style="border-bottom: 0.5pt solid ; " align="left">Description</th>
+</tr>
+</thead>
+<tbody valign="top">
+<tr>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">sql.truncate_trailing</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">true</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">truncation of long strings with trailing spaces</td>
+</tr>
+<tr>
+<td style="" colspan="3" align="left" valign="top">
+<p>When a string that is
+              longer than the maximum size of a column is inserted, the
+              default behaviour is to remove any trailing spaces until the
+              length of the string equals the maximum size of the column. When
+              this property is set to false, long strings are always rejected
+              and an exception is raised.</p>
+<pre class="programlisting">SET DATABASE SQL TRUNCATE TRAILING { TRUE | FALSE }</pre>
+</td>
+</tr>
+</tbody>
+</table>
+</div>
+</div>
+<br class="table-break">
+<div class="table">
+<a name="N165B8"></a>
 <p class="title">
-<b>Table&nbsp;14.18.&nbsp;Type Enforcement in Comparison and Assignment</b>
+<b>Table&nbsp;14.20.&nbsp;Type Enforcement in Comparison and Assignment</b>
 </p>
 <div class="table-contents">
 <table summary="Type Enforcement in Comparison and Assignment" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -1142,9 +1227,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N163BE"></a>
+<a name="N165E5"></a>
 <p class="title">
-<b>Table&nbsp;14.19.&nbsp;Foreign Key Triggered Data Change</b>
+<b>Table&nbsp;14.21.&nbsp;Foreign Key Triggered Data Change</b>
 </p>
 <div class="table-contents">
 <table summary="Foreign Key Triggered Data Change" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -1204,9 +1289,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16401"></a>
+<a name="N16628"></a>
 <p class="title">
-<b>Table&nbsp;14.20.&nbsp;Use of LOB for LONGVAR Types</b>
+<b>Table&nbsp;14.22.&nbsp;Use of LOB for LONGVAR Types</b>
 </p>
 <div class="table-contents">
 <table summary="Use of LOB for LONGVAR Types" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -1240,9 +1325,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N1642E"></a>
+<a name="N16655"></a>
 <p class="title">
-<b>Table&nbsp;14.21.&nbsp;Type of string literals in CASE WHEN</b>
+<b>Table&nbsp;14.23.&nbsp;Type of string literals in CASE WHEN</b>
 </p>
 <div class="table-contents">
 <table summary="Type of string literals in CASE WHEN" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -1277,9 +1362,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N1645B"></a>
+<a name="N16682"></a>
 <p class="title">
-<b>Table&nbsp;14.22.&nbsp;Concatenation with NULL</b>
+<b>Table&nbsp;14.24.&nbsp;Concatenation with NULL</b>
 </p>
 <div class="table-contents">
 <table summary="Concatenation with NULL" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -1312,9 +1397,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16488"></a>
+<a name="N166AF"></a>
 <p class="title">
-<b>Table&nbsp;14.23.&nbsp;NULL in Multi-Column UNIQUE Constraints</b>
+<b>Table&nbsp;14.25.&nbsp;NULL in Multi-Column UNIQUE Constraints</b>
 </p>
 <div class="table-contents">
 <table summary="NULL in Multi-Column UNIQUE Constraints" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -1348,9 +1433,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N164B5"></a>
+<a name="N166DC"></a>
 <p class="title">
-<b>Table&nbsp;14.24.&nbsp;Truncation or Rounding in Type Conversion</b>
+<b>Table&nbsp;14.26.&nbsp;Truncation or Rounding in Type Conversion</b>
 </p>
 <div class="table-contents">
 <table summary="Truncation or Rounding in Type Conversion" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -1384,9 +1469,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N164E2"></a>
+<a name="N16709"></a>
 <p class="title">
-<b>Table&nbsp;14.25.&nbsp;Decimal Scale of Division and AVG Values</b>
+<b>Table&nbsp;14.27.&nbsp;Decimal Scale of Division and AVG Values</b>
 </p>
 <div class="table-contents">
 <table summary="Decimal Scale of Division and AVG Values" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -1424,9 +1509,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N1650F"></a>
+<a name="N16736"></a>
 <p class="title">
-<b>Table&nbsp;14.26.&nbsp;Support for NaN values</b>
+<b>Table&nbsp;14.28.&nbsp;Support for NaN values</b>
 </p>
 <div class="table-contents">
 <table summary="Support for NaN values" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -1459,9 +1544,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N1653C"></a>
+<a name="N16763"></a>
 <p class="title">
-<b>Table&nbsp;14.27.&nbsp;Sort order of NULL values</b>
+<b>Table&nbsp;14.29.&nbsp;Sort order of NULL values</b>
 </p>
 <div class="table-contents">
 <table summary="Sort order of NULL values" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -1495,9 +1580,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16569"></a>
+<a name="N16790"></a>
 <p class="title">
-<b>Table&nbsp;14.28.&nbsp;Sort order of NULL values with DESC</b>
+<b>Table&nbsp;14.30.&nbsp;Sort order of NULL values with DESC</b>
 </p>
 <div class="table-contents">
 <table summary="Sort order of NULL values with DESC" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -1533,9 +1618,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16599"></a>
+<a name="N167C0"></a>
 <p class="title">
-<b>Table&nbsp;14.29.&nbsp;String Comparison with Padding</b>
+<b>Table&nbsp;14.31.&nbsp;String Comparison with Padding</b>
 </p>
 <div class="table-contents">
 <table summary="String Comparison with Padding" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -1573,9 +1658,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N165C8"></a>
+<a name="N167EF"></a>
 <p class="title">
-<b>Table&nbsp;14.30.&nbsp;Default Locale Language Collation</b>
+<b>Table&nbsp;14.32.&nbsp;Default Locale Language Collation</b>
 </p>
 <div class="table-contents">
 <table summary="Default Locale Language Collation" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -1608,9 +1693,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N165F5"></a>
+<a name="N1681C"></a>
 <p class="title">
-<b>Table&nbsp;14.31.&nbsp;Case-Insensitive Varchar columns</b>
+<b>Table&nbsp;14.33.&nbsp;Case-Insensitive Varchar columns</b>
 </p>
 <div class="table-contents">
 <table summary="Case-Insensitive Varchar columns" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -1646,9 +1731,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16622"></a>
+<a name="N16849"></a>
 <p class="title">
-<b>Table&nbsp;14.32.&nbsp;Lowercase column identifiers in ResultSet</b>
+<b>Table&nbsp;14.34.&nbsp;Lowercase column identifiers in ResultSet</b>
 </p>
 <div class="table-contents">
 <table summary="Lowercase column identifiers in ResultSet" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -1685,9 +1770,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N1664F"></a>
+<a name="N16876"></a>
 <p class="title">
-<b>Table&nbsp;14.33.&nbsp;Storage of Live Java Objects</b>
+<b>Table&nbsp;14.35.&nbsp;Storage of Live Java Objects</b>
 </p>
 <div class="table-contents">
 <table summary="Storage of Live Java Objects" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -1722,9 +1807,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N1667C"></a>
+<a name="N168A3"></a>
 <p class="title">
-<b>Table&nbsp;14.34.&nbsp;Names of System Indexes Used for Constraints</b>
+<b>Table&nbsp;14.36.&nbsp;Names of System Indexes Used for Constraints</b>
 </p>
 <div class="table-contents">
 <table summary="Names of System Indexes Used for Constraints" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -1740,16 +1825,21 @@
 </thead>
 <tbody valign="top">
 <tr>
-<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">sql.sys_index_names</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">false</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">name of system generated indexes for constraints</td>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">sql.sys_index_names</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">true</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">name of system generated indexes for constraints</td>
 </tr>
 <tr>
 <td style="" colspan="3" align="left" valign="top">
 <p>HSQLDB automatically
               creates a system index for each PRIMARY KEY, UNIQUE and FOREIGN
-              KEY constraint. By default the names of those indexes are
-              generated the system as a string beginning with SYS_. When the
-              setting is changed to true, the names will be the same as the
-              constraint names.</p>
+              KEY constraint. If a constraint is not defined with a name, the
+              system generates a name. By default, the names of these indexes
+              will be the same as the constraint names. This helps associating
+              the index name with the user-defined constraint name. When this
+              property is false, the names of those indexes are generated the
+              system as a string beginning with SYS_. </p>
+<p>The default
+              value for this property was false before version
+              2.7.0.</p>
 <pre class="programlisting">SET DATABASE SQL SYS INDEX NAMES { TRUE | FALSE }</pre>
 </td>
 </tr>
@@ -1759,9 +1849,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N166A9"></a>
+<a name="N168D2"></a>
 <p class="title">
-<b>Table&nbsp;14.35.&nbsp;DB2 Style Syntax</b>
+<b>Table&nbsp;14.37.&nbsp;DB2 Style Syntax</b>
 </p>
 <div class="table-contents">
 <table summary="DB2 Style Syntax" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -1793,9 +1883,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N166D5"></a>
+<a name="N168FE"></a>
 <p class="title">
-<b>Table&nbsp;14.36.&nbsp;MSSQL Style Syntax</b>
+<b>Table&nbsp;14.38.&nbsp;MSSQL Style Syntax</b>
 </p>
 <div class="table-contents">
 <table summary="MSSQL Style Syntax" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -1828,9 +1918,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16701"></a>
+<a name="N1692A"></a>
 <p class="title">
-<b>Table&nbsp;14.37.&nbsp;MySQL Style Syntax</b>
+<b>Table&nbsp;14.39.&nbsp;MySQL Style Syntax</b>
 </p>
 <div class="table-contents">
 <table summary="MySQL Style Syntax" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -1863,9 +1953,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N1672E"></a>
+<a name="N16957"></a>
 <p class="title">
-<b>Table&nbsp;14.38.&nbsp;Oracle Style Syntax</b>
+<b>Table&nbsp;14.40.&nbsp;Oracle Style Syntax</b>
 </p>
 <div class="table-contents">
 <table summary="Oracle Style Syntax" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -1899,9 +1989,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N1675B"></a>
+<a name="N16984"></a>
 <p class="title">
-<b>Table&nbsp;14.39.&nbsp;PostgreSQL Style Syntax</b>
+<b>Table&nbsp;14.41.&nbsp;PostgreSQL Style Syntax</b>
 </p>
 <div class="table-contents">
 <table summary="PostgreSQL Style Syntax" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -1933,6 +2023,44 @@
 </div>
 </div>
 <br class="table-break">
+<div class="table">
+<a name="N169B0"></a>
+<p class="title">
+<b>Table&nbsp;14.42.&nbsp;Maximum Iterations of Recursive Queries</b>
+</p>
+<div class="table-contents">
+<table summary="Maximum Iterations of Recursive Queries" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
+<colgroup>
+<col width="6.5cm" align="left" class="c1">
+<col width="1.5cm" align="left" class="c2">
+<col align="left" class="c3">
+</colgroup>
+<thead>
+<tr>
+<th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Name</th><th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Default</th><th style="border-bottom: 0.5pt solid ; " align="left">Description</th>
+</tr>
+</thead>
+<tbody valign="top">
+<tr>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">sql.max_recursive</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">256</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">maximum number of iterations of a recursive query</td>
+</tr>
+<tr>
+<td style="" colspan="3" align="left" valign="top">
+<p>Recursive queries
+              terminate if they are not completed when the maximum number of
+              iterations is reached. This is to avoid long-running queries
+              that may never actually finish.</p>
+<p>The default value is
+              fine for most use-cases. You can change the default if you need
+              to.</p>
+<pre class="programlisting">SET DATABASE SQL MAX RECURSIVE &lt;count&gt;</pre>
+</td>
+</tr>
+</tbody>
+</table>
+</div>
+</div>
+<br class="table-break">
 </div>
 <div class="section">
 <div class="titlepage">
@@ -1944,9 +2072,9 @@
 </div>
 </div>
 <div class="table">
-<a name="N1678B"></a>
+<a name="N169E3"></a>
 <p class="title">
-<b>Table&nbsp;14.40.&nbsp;Default Table Type</b>
+<b>Table&nbsp;14.43.&nbsp;Default Table Type</b>
 </p>
 <div class="table-contents">
 <table summary="Default Table Type" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -1982,9 +2110,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N167BB"></a>
+<a name="N16A13"></a>
 <p class="title">
-<b>Table&nbsp;14.41.&nbsp;Transaction Control Mode</b>
+<b>Table&nbsp;14.44.&nbsp;Transaction Control Mode</b>
 </p>
 <div class="table-contents">
 <table summary="Transaction Control Mode" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -2018,9 +2146,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N167F1"></a>
+<a name="N16A49"></a>
 <p class="title">
-<b>Table&nbsp;14.42.&nbsp;Default Isolation Level for Sessions</b>
+<b>Table&nbsp;14.45.&nbsp;Default Isolation Level for Sessions</b>
 </p>
 <div class="table-contents">
 <table summary="Default Isolation Level for Sessions" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -2054,9 +2182,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16824"></a>
+<a name="N16A7C"></a>
 <p class="title">
-<b>Table&nbsp;14.43.&nbsp;Transaction Rollback in Deadlock</b>
+<b>Table&nbsp;14.46.&nbsp;Transaction Rollback in Deadlock</b>
 </p>
 <div class="table-contents">
 <table summary="Transaction Rollback in Deadlock" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -2097,9 +2225,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16851"></a>
+<a name="N16AA9"></a>
 <p class="title">
-<b>Table&nbsp;14.44.&nbsp;Transaction Rollback on Interrupt</b>
+<b>Table&nbsp;14.47.&nbsp;Transaction Rollback on Interrupt</b>
 </p>
 <div class="table-contents">
 <table summary="Transaction Rollback on Interrupt" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -2135,9 +2263,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N1687E"></a>
+<a name="N16AD6"></a>
 <p class="title">
-<b>Table&nbsp;14.45.&nbsp;Time Zone and Interval Types</b>
+<b>Table&nbsp;14.48.&nbsp;Time Zone and Interval Types</b>
 </p>
 <div class="table-contents">
 <table summary="Time Zone and Interval Types" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -2153,18 +2281,20 @@
 </thead>
 <tbody valign="top">
 <tr>
-<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.translate_tti_types</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">true</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">usage of type codes for advanced datetime and interval
-              types</td>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.translate_tti_types</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">true</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">usage of type codes for advanced interval types</td>
 </tr>
 <tr>
 <td style="" colspan="3" align="left" valign="top">
 <p>If the property is true,
-              the TIME / TIMESTAMP WITH TIME ZONE types and INTERVAL types are
-              represented in JDBC methods of
+              the INTERVAL types are represented in JDBC methods of
               <code class="classname">ResultSetMetaData</code> and
-              <code class="classname">DatabaseMetaData</code> as JDBC datetime types
-              without time zone and the VARCHAR type respectively. The
+              <code class="classname">DatabaseMetaData</code> as the VARCHAR type. The
               original type names are preserved.</p>
+<p>JDBC does not
+              have direct support for names and codes of INTERVAL types. From
+              Java 8, getting and setting INTERVAL values is possible via
+              getObject() and setObject() methods of ResultSet and
+              PreparedStatement.</p>
 <pre class="programlisting">SET DATABASE SQL TRANSLATE TTI TYPES { TRUE | FALSE }</pre>
 </td>
 </tr>
@@ -2173,6 +2303,44 @@
 </div>
 </div>
 <br class="table-break">
+<div class="table">
+<a name="N16B0B"></a>
+<p class="title">
+<b>Table&nbsp;14.49.&nbsp;Temporary Result Rows in Memory</b>
+</p>
+<div class="table-contents">
+<table summary="Temporary Result Rows in Memory" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
+<colgroup>
+<col width="6.5cm" align="left" class="c1">
+<col width="1.5cm" align="left" class="c2">
+<col align="left" class="c3">
+</colgroup>
+<thead>
+<tr>
+<th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Name</th><th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Default</th><th style="border-bottom: 0.5pt solid ; " align="left">Description</th>
+</tr>
+</thead>
+<tbody valign="top">
+<tr>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.result_max_memory_rows</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">0</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">storage of temporary results and tables in memory or on
+              disk</td>
+</tr>
+<tr>
+<td style="" colspan="3" align="left" valign="top">
+<p>This property can be set
+              to specify how many rows of each results or temporary table are
+              stored in memory before the table is written to disk. The
+              default is zero and means data is always stored in memory. If
+              this setting is used, it should be set above
+              1000.</p>
+<pre class="programlisting">SET DATABASE DEFAULT RESULT MEMORY ROWS &lt;numeric value&gt;</pre>
+</td>
+</tr>
+</tbody>
+</table>
+</div>
+</div>
+<br class="table-break">
 </div>
 <div class="section">
 <div class="titlepage">
@@ -2184,9 +2352,9 @@
 </div>
 </div>
 <div class="table">
-<a name="N168B5"></a>
+<a name="N16B3C"></a>
 <p class="title">
-<b>Table&nbsp;14.46.&nbsp;Opening Database as Read Only</b>
+<b>Table&nbsp;14.50.&nbsp;Opening Database as Read Only</b>
 </p>
 <div class="table-contents">
 <table summary="Opening Database as Read Only" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -2222,9 +2390,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N168E5"></a>
+<a name="N16B6C"></a>
 <p class="title">
-<b>Table&nbsp;14.47.&nbsp;Opening Database Without Modifying the Files</b>
+<b>Table&nbsp;14.51.&nbsp;Opening Database Without Modifying the Files</b>
 </p>
 <div class="table-contents">
 <table summary="Opening Database Without Modifying the Files" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -2259,12 +2427,12 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16915"></a>
+<a name="N16B9C"></a>
 <p class="title">
-<b>Table&nbsp;14.48.&nbsp;Huge database files and tables</b>
+<b>Table&nbsp;14.52.&nbsp;Event Logging</b>
 </p>
 <div class="table-contents">
-<table summary="Huge database files and tables" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
+<table summary="Event Logging" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
 <colgroup>
 <col width="6.5cm" align="left" class="c1">
 <col width="1.5cm" align="left" class="c2">
@@ -2277,31 +2445,32 @@
 </thead>
 <tbody valign="top">
 <tr>
-<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.large_data</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">false</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">enable huge database files - can also be used to open an
-              existing <em class="glossterm">file:</em> database</td>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.applog</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">0</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">application logging level - can also be used when opening
+              an existing <em class="glossterm">file:</em> database</td>
 </tr>
 <tr>
 <td style="" colspan="3" align="left" valign="top">
-<p>By default, up to 2
-              billion rows can be stored in all disk-based CACHED tables.
-              Setting this property to true increases the limit to 256 billion
-              rows. This property is used as a connection
-              property.</p>
-<pre class="programlisting">this property cannot be set with an SQL statement - it can be used as a connection property for the connection that opens the database</pre>
-</td>
-</tr>
-</tbody>
-</table>
+<p>The default level 0
+              indicates no logging. Level 1 results in minimal logging,
+              including any failures. Level 2 indicates all events, including
+              ordinary events. LEVEL 3 adds details of some of the normal
+              operations. The events are logged in a file ending with
+              ".app.log".</p>
+<pre class="programlisting">SET DATABASE EVENT LOG LEVEL { 0 | 1 | 2 | 3}</pre>
+</td>
+</tr>
+</tbody>
+</table>
 </div>
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16945"></a>
+<a name="N16BCC"></a>
 <p class="title">
-<b>Table&nbsp;14.49.&nbsp;Event Logging</b>
+<b>Table&nbsp;14.53.&nbsp;SQL Logging</b>
 </p>
 <div class="table-contents">
-<table summary="Event Logging" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
+<table summary="SQL Logging" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
 <colgroup>
 <col width="6.5cm" align="left" class="c1">
 <col width="1.5cm" align="left" class="c2">
@@ -2314,18 +2483,20 @@
 </thead>
 <tbody valign="top">
 <tr>
-<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.applog</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">0</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">application logging level - can also be used when opening
-              an existing <em class="glossterm">file:</em> database</td>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.sqllog</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">0</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">sql logging level - can also be used when opening an
+              existing <em class="glossterm">file:</em> database</td>
 </tr>
 <tr>
 <td style="" colspan="3" align="left" valign="top">
 <p>The default level 0
-              indicates no logging. Level 1 results in minimal logging,
-              including any failures. Level 2 indicates all events, including
-              ordinary events. LEVEL 3 adds details of some of the normal
-              operations. The events are logged in a file ending with
-              ".app.log".</p>
-<pre class="programlisting">SET DATABASE EVENT LOG LEVEL { 0 | 1 | 2 | 3}</pre>
+              indicates no logging. Level 1 logs only commits and rollbacks.
+              Level 2 logs all the SQL statements executed, together with
+              their parameter values. Long statements and parameter values are
+              truncated. Level 3 is similar to Level 2 but does not truncate
+              long statements and values. The events are logged in a file
+              ending with ".sql.log". This property applies to existing file:
+              databases as well as new databases.</p>
+<pre class="programlisting">SET DATABASE EVENT LOG SQL LEVEL { 0 | 1 | 2 | 3}</pre>
 </td>
 </tr>
 </tbody>
@@ -2334,12 +2505,12 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16975"></a>
+<a name="N16BFC"></a>
 <p class="title">
-<b>Table&nbsp;14.50.&nbsp;SQL Logging</b>
+<b>Table&nbsp;14.54.&nbsp;Table Spaces for Cached Tables</b>
 </p>
 <div class="table-contents">
-<table summary="SQL Logging" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
+<table summary="Table Spaces for Cached Tables" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
 <colgroup>
 <col width="6.5cm" align="left" class="c1">
 <col width="1.5cm" align="left" class="c2">
@@ -2352,20 +2523,54 @@
 </thead>
 <tbody valign="top">
 <tr>
-<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.sqllog</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">0</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">sql logging level - can also be used when opening an
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.files_space</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">false</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">use of separate table spaces for each CACHED
+              table</td>
+</tr>
+<tr>
+<td style="" colspan="3" align="left" valign="top">
+<p>The default value is
+              false, indicating table space management is not used. When the
+              value is true at the time of creation of a new database, the
+              directory structures are created inside the .data file and table
+              space support is enabled</p>
+<pre class="programlisting">SET FILES SPACE { TRUE | FALSE }</pre>
+</td>
+</tr>
+</tbody>
+</table>
+</div>
+</div>
+<br class="table-break">
+<div class="table">
+<a name="N16C29"></a>
+<p class="title">
+<b>Table&nbsp;14.55.&nbsp;Huge database files and tables</b>
+</p>
+<div class="table-contents">
+<table summary="Huge database files and tables" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
+<colgroup>
+<col width="6.5cm" align="left" class="c1">
+<col width="1.5cm" align="left" class="c2">
+<col align="left" class="c3">
+</colgroup>
+<thead>
+<tr>
+<th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Name</th><th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Default</th><th style="border-bottom: 0.5pt solid ; " align="left">Description</th>
+</tr>
+</thead>
+<tbody valign="top">
+<tr>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.large_data</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">false</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">enable huge database files - can also be used to open an
               existing <em class="glossterm">file:</em> database</td>
 </tr>
 <tr>
 <td style="" colspan="3" align="left" valign="top">
-<p>The default level 0
-              indicates no logging. Level 1 logs only commits and rollbacks.
-              Level 2 logs all the SQL statements executed, together with
-              their parameter values. Long statements and parameter values are
-              truncated. Level 3 is similar to Level 2 but does not truncate
-              long statements and values. The events are logged in a file
-              ending with ".sql.log". This property applies to existing file:
-              databases as well as new databases.</p>
-<pre class="programlisting">SET DATABASE EVENT LOG SQL LEVEL { 0 | 1 | 2 | 3}</pre>
+<p>By default, up to 2
+              billion rows can be stored in all disk-based CACHED tables.
+              Setting this property to true increases the limit to 256 billion
+              rows. This property is used as a connection
+              property.</p>
+<pre class="programlisting">this property cannot be set with an SQL statement - it can be used as a connection property for the connection that opens the database</pre>
 </td>
 </tr>
 </tbody>
@@ -2374,12 +2579,12 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N169A5"></a>
+<a name="N16C59"></a>
 <p class="title">
-<b>Table&nbsp;14.51.&nbsp;Temporary Result Rows in Memory</b>
+<b>Table&nbsp;14.56.&nbsp;Use of NIO for Disk Table Storage</b>
 </p>
 <div class="table-contents">
-<table summary="Temporary Result Rows in Memory" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
+<table summary="Use of NIO for Disk Table Storage" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
 <colgroup>
 <col width="6.5cm" align="left" class="c1">
 <col width="1.5cm" align="left" class="c2">
@@ -2392,18 +2597,99 @@
 </thead>
 <tbody valign="top">
 <tr>
-<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.result_max_memory_rows</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">0</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">storage of temporary results and tables in memory or on
-              disk</td>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.nio_data_file</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">true</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">use of nio access methods for the .data file</td>
 </tr>
 <tr>
 <td style="" colspan="3" align="left" valign="top">
-<p>This property can be set
-              to specify how many rows of each results or temporary table are
-              stored in memory before the table is written to disk. The
-              default is zero and means data is always stored in memory. If
-              this setting is used, it should be set above
-              1000.</p>
-<pre class="programlisting">SET DATABASE DEFAULT RESULT MEMORY ROWS &lt;numeric value&gt;</pre>
+<p>Setting this property to
+              <code class="literal">false</code> will avoid the use of nio access
+              methods, resulting in somewhat reduced speed. If the data file
+              is larger than <code class="literal">hsqldb.nio_max_size</code> (default
+              256MB) when it is first opened (or when its size is increased),
+              nio access methods are not used. Also, if the file gets larger
+              than the amount of available computer memory that needs to be
+              allocated for nio access, non-nio access methods are
+              used.</p>
+<pre class="programlisting">SET FILES NIO { TRUE | FALSE }</pre>
+</td>
+</tr>
+</tbody>
+</table>
+</div>
+</div>
+<br class="table-break">
+<div class="table">
+<a name="N16C8C"></a>
+<p class="title">
+<b>Table&nbsp;14.57.&nbsp;Use of NIO for Disk Table Storage</b>
+</p>
+<div class="table-contents">
+<table summary="Use of NIO for Disk Table Storage" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
+<colgroup>
+<col width="6.5cm" align="left" class="c1">
+<col width="1.5cm" align="left" class="c2">
+<col align="left" class="c3">
+</colgroup>
+<thead>
+<tr>
+<th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Name</th><th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Default</th><th style="border-bottom: 0.5pt solid ; " align="left">Description</th>
+</tr>
+</thead>
+<tbody valign="top">
+<tr>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.nio_max_size</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">256</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">nio buffer size limit</td>
+</tr>
+<tr>
+<td style="" colspan="3" align="left" valign="top">
+<p>The maximum size of .data
+              file in mega bytes that can use the nio access method. When the
+              file gets larger than this limit, non-nio access methods are
+              used. Values 64, 128, 256, 512, 1024, and larger multiples of
+              512 can be used. The default is
+              256MB.</p>
+<pre class="programlisting">SET FILES NIO SIZE &lt;numeric value&gt;</pre>
+</td>
+</tr>
+</tbody>
+</table>
+</div>
+</div>
+<br class="table-break">
+<div class="table">
+<a name="N16CB9"></a>
+<p class="title">
+<b>Table&nbsp;14.58.&nbsp;Internal Backup of the .data File</b>
+</p>
+<div class="table-contents">
+<table summary="Internal Backup of the .data File" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
+<colgroup>
+<col width="6.5cm" align="left" class="c1">
+<col width="1.5cm" align="left" class="c2">
+<col align="left" class="c3">
+</colgroup>
+<thead>
+<tr>
+<th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Name</th><th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Default</th><th style="border-bottom: 0.5pt solid ; " align="left">Description</th>
+</tr>
+</thead>
+<tbody valign="top">
+<tr>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.inc_backup</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">true</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">incremental backup of data file - NOW OBSOLETE</td>
+</tr>
+<tr>
+<td style="" colspan="3" align="left" valign="top">
+<p>As the contents of the
+              .data file are modified during database operation, the original
+              contents are backed up gradually. This allows fast checkpoint
+              and shutdown.</p>
+<p>With HSQLDB up to version 2.5 it was
+              possible to set the property false in order to have the .data
+              file backed up entirely at the time of checkpoint and
+              shutdown.</p>
+<p>From version 2.5.1, this property has no
+              effect and backup is always
+              incremental.</p>
+<pre class="programlisting">SET FILES BACKUP INCREMENT { TRUE | FALSE }</pre>
 </td>
 </tr>
 </tbody>
@@ -2412,9 +2698,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N169D2"></a>
+<a name="N16CEA"></a>
 <p class="title">
-<b>Table&nbsp;14.52.&nbsp;Unused Space Recovery</b>
+<b>Table&nbsp;14.59.&nbsp;Unused Space Recovery</b>
 </p>
 <div class="table-contents">
 <table summary="Unused Space Recovery" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -2444,6 +2730,10 @@
               are deleted, the smaller recovered spaces are lost and the
               largest ones are retained for later use. Normally there is no
               need to set this property.</p>
+<p>When table space
+              management is turned on (see hsqldb.files_space property) this
+              property has little effect as unused spaces are always
+              recovered.</p>
 <pre class="programlisting">this property cannot be set with an SQL statement</pre>
 </td>
 </tr>
@@ -2453,9 +2743,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16A04"></a>
+<a name="N16D1E"></a>
 <p class="title">
-<b>Table&nbsp;14.53.&nbsp;Rows Cached In Memory</b>
+<b>Table&nbsp;14.60.&nbsp;Rows Cached In Memory</b>
 </p>
 <div class="table-contents">
 <table summary="Rows Cached In Memory" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -2491,9 +2781,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16A33"></a>
+<a name="N16D4D"></a>
 <p class="title">
-<b>Table&nbsp;14.54.&nbsp;Size of Rows Cached in Memory</b>
+<b>Table&nbsp;14.61.&nbsp;Size of Rows Cached in Memory</b>
 </p>
 <div class="table-contents">
 <table summary="Size of Rows Cached in Memory" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -2536,9 +2826,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16A62"></a>
+<a name="N16D7C"></a>
 <p class="title">
-<b>Table&nbsp;14.55.&nbsp;Size Scale of Disk Table Storage</b>
+<b>Table&nbsp;14.62.&nbsp;Size Scale of Disk Table Storage</b>
 </p>
 <div class="table-contents">
 <table summary="Size Scale of Disk Table Storage" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -2572,9 +2862,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16A8F"></a>
+<a name="N16DA9"></a>
 <p class="title">
-<b>Table&nbsp;14.56.&nbsp;Size Scale of LOB Storage</b>
+<b>Table&nbsp;14.63.&nbsp;Size Scale of LOB Storage</b>
 </p>
 <div class="table-contents">
 <table summary="Size Scale of LOB Storage" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -2608,9 +2898,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16ABC"></a>
+<a name="N16DD6"></a>
 <p class="title">
-<b>Table&nbsp;14.57.&nbsp;Compression of BLOB and CLOB data</b>
+<b>Table&nbsp;14.64.&nbsp;Compression of BLOB and CLOB data</b>
 </p>
 <div class="table-contents">
 <table summary="Compression of BLOB and CLOB data" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -2643,51 +2933,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16AE9"></a>
+<a name="N16E03"></a>
 <p class="title">
-<b>Table&nbsp;14.58.&nbsp;Internal Backup of Database Files</b>
-</p>
-<div class="table-contents">
-<table summary="Internal Backup of Database Files" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
-<colgroup>
-<col width="6.5cm" align="left" class="c1">
-<col width="1.5cm" align="left" class="c2">
-<col align="left" class="c3">
-</colgroup>
-<thead>
-<tr>
-<th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Name</th><th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Default</th><th style="border-bottom: 0.5pt solid ; " align="left">Description</th>
-</tr>
-</thead>
-<tbody valign="top">
-<tr>
-<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.inc_backup</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">true</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">incremental backup of data file</td>
-</tr>
-<tr>
-<td style="" colspan="3" align="left" valign="top">
-<p>As the contents of the
-              .data file are modified during database operation, the original
-              contents are backed up gradually. This allows fast checkpoint
-              and shutdown.</p>
-<p>With HSQLDB up to version 2.5.0 it was
-              possible to set the property false in order to have the .data
-              file backed up entirely at the time of checkpoint and
-              shutdown.</p>
-<p>From version 2.5.1, this property has no
-              effect and backup is always
-              incremental.</p>
-<pre class="programlisting">SET FILES BACKUP INCREMENT { TRUE | FALSE }</pre>
-</td>
-</tr>
-</tbody>
-</table>
-</div>
-</div>
-<br class="table-break">
-<div class="table">
-<a name="N16B1A"></a>
-<p class="title">
-<b>Table&nbsp;14.59.&nbsp;Use of Lock File</b>
+<b>Table&nbsp;14.65.&nbsp;Use of Lock File</b>
 </p>
 <div class="table-contents">
 <table summary="Use of Lock File" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -2724,9 +2972,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16B4A"></a>
+<a name="N16E33"></a>
 <p class="title">
-<b>Table&nbsp;14.60.&nbsp;Logging Data Change Statements</b>
+<b>Table&nbsp;14.66.&nbsp;Logging Data Change Statements</b>
 </p>
 <div class="table-contents">
 <table summary="Logging Data Change Statements" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -2750,11 +2998,10 @@
               to <code class="literal">false</code> when database recovery in the event
               of an unexpected crash is not necessary. A database that is used
               as a temporary cache is an example. Regardless of the value of
-              this property, if there is a proper shutdown of the database,
-              all the changed data is stored. A checkpoint or shutdown still
-              rewrites the <code class="literal">.script</code> file and saves the
-              <code class="literal">.backup</code> file according to the other
-              settings.</p>
+              this property, a checkpoint or shutdown still writes the
+              <code class="literal">.script</code> file and saves the
+              <code class="literal">.data</code> file in full, therefore persisting all
+              the changes.</p>
 <pre class="programlisting">SET FILES LOG  { TRUE | FALSE }</pre>
 </td>
 </tr>
@@ -2764,9 +3011,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16B80"></a>
+<a name="N16E69"></a>
 <p class="title">
-<b>Table&nbsp;14.61.&nbsp;Automatic Checkpoint Frequency</b>
+<b>Table&nbsp;14.67.&nbsp;Automatic Checkpoint Frequency</b>
 </p>
 <div class="table-contents">
 <table summary="Automatic Checkpoint Frequency" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -2800,9 +3047,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16BB6"></a>
+<a name="N16E9F"></a>
 <p class="title">
-<b>Table&nbsp;14.62.&nbsp;Automatic Defrag at Checkpoint</b>
+<b>Table&nbsp;14.68.&nbsp;Automatic Defrag at Checkpoint</b>
 </p>
 <div class="table-contents">
 <table summary="Automatic Defrag at Checkpoint" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -2840,9 +3087,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16BE3"></a>
+<a name="N16ECC"></a>
 <p class="title">
-<b>Table&nbsp;14.63.&nbsp;Compression of the .script file</b>
+<b>Table&nbsp;14.69.&nbsp;Compression of the .script file</b>
 </p>
 <div class="table-contents">
 <table summary="Compression of the .script file" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -2877,9 +3124,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16C13"></a>
+<a name="N16EFC"></a>
 <p class="title">
-<b>Table&nbsp;14.64.&nbsp;Logging Data Change Statements Frequency</b>
+<b>Table&nbsp;14.70.&nbsp;Logging Data Change Statements Frequency</b>
 </p>
 <div class="table-contents">
 <table summary="Logging Data Change Statements Frequency" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -2916,9 +3163,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16C40"></a>
+<a name="N16F29"></a>
 <p class="title">
-<b>Table&nbsp;14.65.&nbsp;Logging Data Change Statements Frequency</b>
+<b>Table&nbsp;14.71.&nbsp;Logging Data Change Statements Frequency</b>
 </p>
 <div class="table-contents">
 <table summary="Logging Data Change Statements Frequency" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -2954,86 +3201,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16C6D"></a>
+<a name="N16F56"></a>
 <p class="title">
-<b>Table&nbsp;14.66.&nbsp;Use of NIO for Disk Table Storage</b>
-</p>
-<div class="table-contents">
-<table summary="Use of NIO for Disk Table Storage" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
-<colgroup>
-<col width="6.5cm" align="left" class="c1">
-<col width="1.5cm" align="left" class="c2">
-<col align="left" class="c3">
-</colgroup>
-<thead>
-<tr>
-<th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Name</th><th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Default</th><th style="border-bottom: 0.5pt solid ; " align="left">Description</th>
-</tr>
-</thead>
-<tbody valign="top">
-<tr>
-<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.nio_data_file</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">true</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">use of nio access methods for the .data file</td>
-</tr>
-<tr>
-<td style="" colspan="3" align="left" valign="top">
-<p>Setting this property to
-              <code class="literal">false</code> will avoid the use of nio access
-              methods, resulting in somewhat reduced speed. If the data file
-              is larger than <code class="literal">hsqldb.nio_max_size</code> (default
-              256MB) when it is first opened (or when its size is increased),
-              nio access methods are not used. Also, if the file gets larger
-              than the amount of available computer memory that needs to be
-              allocated for nio access, non-nio access methods are
-              used.</p>
-<pre class="programlisting">SET FILES NIO { TRUE | FALSE }</pre>
-</td>
-</tr>
-</tbody>
-</table>
-</div>
-</div>
-<br class="table-break">
-<div class="table">
-<a name="N16CA0"></a>
-<p class="title">
-<b>Table&nbsp;14.67.&nbsp;Use of NIO for Disk Table Storage</b>
-</p>
-<div class="table-contents">
-<table summary="Use of NIO for Disk Table Storage" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
-<colgroup>
-<col width="6.5cm" align="left" class="c1">
-<col width="1.5cm" align="left" class="c2">
-<col align="left" class="c3">
-</colgroup>
-<thead>
-<tr>
-<th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Name</th><th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Default</th><th style="border-bottom: 0.5pt solid ; " align="left">Description</th>
-</tr>
-</thead>
-<tbody valign="top">
-<tr>
-<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.nio_max_size</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">256</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">nio buffer size limit</td>
-</tr>
-<tr>
-<td style="" colspan="3" align="left" valign="top">
-<p>The maximum size of .data
-              file in mega bytes that can use the nio access method. When the
-              file gets larger than this limit, non-nio access methods are
-              used. Values 64, 128, 256, 512, 1024, and larger multiples of
-              512 can be used. The default is
-              256MB.</p>
-<pre class="programlisting">SET FILES NIO SIZE &lt;numeric value&gt;</pre>
-</td>
-</tr>
-</tbody>
-</table>
-</div>
-</div>
-<br class="table-break">
-<div class="table">
-<a name="N16CCD"></a>
-<p class="title">
-<b>Table&nbsp;14.68.&nbsp;Recovery Log Processing</b>
+<b>Table&nbsp;14.72.&nbsp;Recovery Log Processing</b>
 </p>
 <div class="table-contents">
 <table summary="Recovery Log Processing" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -3071,9 +3241,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16CFA"></a>
+<a name="N16F83"></a>
 <p class="title">
-<b>Table&nbsp;14.69.&nbsp;Default Properties for TEXT Tables</b>
+<b>Table&nbsp;14.73.&nbsp;Default Properties for TEXT Tables</b>
 </p>
 <div class="table-contents">
 <table summary="Default Properties for TEXT Tables" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -3108,9 +3278,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16D2E"></a>
+<a name="N16FB7"></a>
 <p class="title">
-<b>Table&nbsp;14.70.&nbsp;Forcing Garbage Collection</b>
+<b>Table&nbsp;14.74.&nbsp;Forcing Garbage Collection</b>
 </p>
 <div class="table-contents">
 <table summary="Forcing Garbage Collection" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -3126,14 +3296,14 @@
 </thead>
 <tbody valign="top">
 <tr>
-<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">runtime.gc_interval</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">0</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">forced garbage collection</td>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">runtime.gc_interval</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">0</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">forced garbage collection - NOW OBSOLETE</td>
 </tr>
 <tr>
 <td style="" colspan="3" align="left" valign="top">
 <p>No-op setting previously
               used to forces garbage collection each time a set number of
               result set row or cache row objects are created. This setting
-              has no effect in version 2.5.0 or
+              has no effect in version 2.5 or
               later,</p>
 <pre class="programlisting">SET DATABASE GC &lt;numeric value&gt;</pre>
 </td>
@@ -3154,9 +3324,9 @@
 </div>
 </div>
 <div class="table">
-<a name="N16D5F"></a>
+<a name="N16FE8"></a>
 <p class="title">
-<b>Table&nbsp;14.71.&nbsp;Crypt Property For LOBs</b>
+<b>Table&nbsp;14.75.&nbsp;Crypt Property For LOBs</b>
 </p>
 <div class="table-contents">
 <table summary="Crypt Property For LOBs" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -3191,9 +3361,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16D8C"></a>
+<a name="N17015"></a>
 <p class="title">
-<b>Table&nbsp;14.72.&nbsp;Cipher Key for Encrypted Database</b>
+<b>Table&nbsp;14.76.&nbsp;Cipher Key for Encrypted Database</b>
 </p>
 <div class="table-contents">
 <table summary="Cipher Key for Encrypted Database" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -3224,9 +3394,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16DB9"></a>
+<a name="N17042"></a>
 <p class="title">
-<b>Table&nbsp;14.73.&nbsp;Cipher Initialization Vector for Encrypted Database</b>
+<b>Table&nbsp;14.77.&nbsp;Cipher Initialization Vector for Encrypted Database</b>
 </p>
 <div class="table-contents">
 <table summary="Cipher Initialization Vector for Encrypted Database" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -3258,9 +3428,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16DE6"></a>
+<a name="N1706F"></a>
 <p class="title">
-<b>Table&nbsp;14.74.&nbsp;Crypt Provider Encrypted Database</b>
+<b>Table&nbsp;14.78.&nbsp;Crypt Provider Encrypted Database</b>
 </p>
 <div class="table-contents">
 <table summary="Crypt Provider Encrypted Database" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -3292,9 +3462,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16E13"></a>
+<a name="N1709C"></a>
 <p class="title">
-<b>Table&nbsp;14.75.&nbsp;Cipher Specification for Encrypted Database</b>
+<b>Table&nbsp;14.79.&nbsp;Cipher Specification for Encrypted Database</b>
 </p>
 <div class="table-contents">
 <table summary="Cipher Specification for Encrypted Database" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -3324,15 +3494,6 @@
 </div>
 </div>
 <br class="table-break">
-<p>When connecting to an <em class="glossterm">in-process</em> database
-      creates a new database, or opens an existing database (i.e. it is the
-      first connection made to the database by the application), all the
-      user-defined database properties listed in this section can be specified
-      as URL properties.</p>
-<p>When HyperSQL is used with OpenOffice.org as an external
-      database, the property "default_schema=true" must be set on the URL,
-      otherwise the program will not operate correctly as it does with its
-      built-in hsqldb instance.</p>
 </div>
 </div>
 <div class="section">
@@ -3348,9 +3509,9 @@
     Java command line or by calling System.setProperty() from the user's
     program. They are not valid as URL or connection properties.</p>
 <div class="table">
-<a name="N16E4D"></a>
+<a name="N170CF"></a>
 <p class="title">
-<b>Table&nbsp;14.76.&nbsp;Logging Framework</b>
+<b>Table&nbsp;14.80.&nbsp;Logging Framework</b>
 </p>
 <div class="table-contents">
 <table summary="Logging Framework" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -3382,9 +3543,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16E77"></a>
+<a name="N170F9"></a>
 <p class="title">
-<b>Table&nbsp;14.77.&nbsp;Text Tables</b>
+<b>Table&nbsp;14.81.&nbsp;Text Tables</b>
 </p>
 <div class="table-contents">
 <table summary="Text Tables" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -3418,9 +3579,9 @@
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16EA4"></a>
+<a name="N17126"></a>
 <p class="title">
-<b>Table&nbsp;14.78.&nbsp;Java Functions</b>
+<b>Table&nbsp;14.82.&nbsp;Java Functions</b>
 </p>
 <div class="table-contents">
 <table summary="Java Functions" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -3454,7 +3615,7 @@
 </div>
 </div>
 <HR xmlns:xi="http://www.w3.org/2001/XInclude">
-<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6369 $</P>
+<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6474 $</P>
 <div class="navfooter">
 <hr>
 <table summary="Navigation footer" width="100%">
diff -pruN 2.6.1-1/hsqldb/doc/guide/deployment-chapt.html 2.7.0-1/hsqldb/doc/guide/deployment-chapt.html
--- 2.6.1-1/hsqldb/doc/guide/deployment-chapt.html	2021-10-20 09:33:34.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/guide/deployment-chapt.html	2022-07-26 20:21:48.000000000 +0000
@@ -44,12 +44,12 @@
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6279 $</p>
+<p class="releaseinfo">$Revision: 6556 $</p>
 </div>
 <div>
 <div class="legalnotice">
-<a name="N159AE"></a>
-<p>Copyright 2002-2021 Fred Toussi. Permission is granted to
+<a name="N15B64"></a>
+<p>Copyright 2002-2022 Fred Toussi. Permission is granted to
       distribute this document without any alteration under the terms of the
       HSQLDB license. Additional permission is granted to the HSQL Development
       Group to distribute this document with or without alterations under the
@@ -57,7 +57,7 @@
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -165,7 +165,7 @@
 </div>
 </div>
 </div>
-<a name="N159B5" class="indexterm"></a>
+<a name="N15B6B" class="indexterm"></a>
 <p>Memory used by the program can be thought of as two distinct pools:
     memory used for table data which is not released unless the data is
     deleted and memory that can be released or is released automatically,
@@ -342,7 +342,7 @@
       change the lob schema storage to CACHED tables with the following
       statements:</p>
 <div class="example">
-<a name="N15A25"></a>
+<a name="N15BDB"></a>
 <p class="title">
 <b>Example&nbsp;12.1.&nbsp;Using CACHED tables for the LOB schema</b>
 </p>
@@ -717,7 +717,7 @@
       arguments (if any), then an empty string to separate it from the next
       main class.</p>
 <div class="example">
-<a name="N15B37"></a>
+<a name="N15CED"></a>
 <p class="title">
 <b>Example&nbsp;12.2.&nbsp;MainInvoker Example</b>
 </p>
@@ -769,17 +769,15 @@
 </div>
 </div>
 </div>
-<a name="N15B5F" class="indexterm"></a>
-<p>HSQLDB version 2.6.0 and later can open databases created with
-    version 2.0 and above. It will not open databases created with older
-    versions. It is a good idea to perform SHUTDOWN COMPACT after the
-    upgrade.</p>
-<p>Downgrading is also possible. Once a database is upgraded to 2.6.0,
-    you need to perform SHUTDOWN SCRIPT before you open it with previous 2.x.x
-    versions of HyperSQL.</p>
+<a name="N15D15" class="indexterm"></a>
+<p>HSQLDB can open databases created with version 2.0 and above. It is
+    a good idea to perform SHUTDOWN COMPACT to complete the upgrade.</p>
+<p>Downgrading is also possible. A database created with the current
+    version can be closed with SHUTDOWN SCRIPT before you open it with
+    previous 2.x.x versions of HyperSQL.</p>
 <p>To upgrade an old database created with version 1.8.x, you can use
-    HSQLDB version 2.3.x to 2.5.0 to open the database and perform SHUTDOWN
-    SCRIPT. You can then open the database with version 2.6.0 or later.</p>
+    HSQLDB version 2.3.x to 2.5 to open the database and perform SHUTDOWN
+    SCRIPT. You can then open the database with version 2.6 or later.</p>
 <p>If the 1.8.x database script format is set to BINARY or COMPRESSED
     (ZIPPED), you must open the database with version 1.8.x and issue the SET
     SCRIPTFORMAT TEXT and SHUTDOWN SCRIPT commands with the old version, prior
@@ -930,7 +928,7 @@
 </div>
 </div>
 </div>
-<p>HyperSQL 2 conforms to the SQL Standard better than previous
+<p>HyperSQL 2.7.0 conforms to the SQL Standard better than previous
     versions and has many more features. For these reasons, there may be some
     compatibility issues when converting old database, or using applications
     that were written for version 1.8.x or earlier. Some of the potential
@@ -939,16 +937,17 @@
 <div class="itemizedlist">
 <ul class="itemizedlist" style="list-style-type: disc; ">
 <li class="listitem">
-<p>By default, when comparison strings, the shorter string is
-        padded with spaces. This has an effect on comparing
-        <code class="literal">'test'</code> and <code class="literal">'test '</code> which are now
-        considered equal, despite the length difference. This behaviour is
-        controlled by the default PAD SPACE property of collations, which can
-        be changed to NO PAD. See the statement <code class="literal">SET DATABASE
-        COLLATION &lt;name&gt; [ PAD SPACE | NO PAD ]</code>.</p>
+<p>By default, when comparing strings, the shorter string is padded
+        with spaces. This has an effect on comparing <code class="literal">'test'</code>
+        and <code class="literal">'test '</code> which are now considered equal, despite
+        the length difference. This behaviour is controlled by the default PAD
+        SPACE property of collations, which can be changed to NO PAD. See the
+        statement <code class="literal">SET DATABASE COLLATION &lt;name&gt; [ PAD SPACE |
+        NO PAD ]</code>.</p>
 </li>
 <li class="listitem">
-<p>User names and passwords are case-sensitive. Check the
+<p>User names and passwords are case-sensitive. The only exception
+        is the username 'SA' which is always converted to uppercase. Check the
         <code class="literal">.script</code> file of a database for the correct case of
         user name and password and use this form in the connection properties
         or on connection URL.</p>
@@ -1012,8 +1011,8 @@
         T (ID IDENTITY, DAT VARCHAR(20))</code> is translated into
         <code class="literal">CREATE TABLE T(ID INTEGER GENERATED BY DEFAULT AS IDENTITY
         PRIMARY KEY, DAT VARCHAR(20))</code>. This last form is the correct
-        way of defining both autoincrement and primary key in versions 1.8 and
-        2.x.</p>
+        way of defining both auto-increment and primary key in versions 1.8
+        and 2.x.</p>
 </li>
 <li class="listitem">
 <p>CREATE ALIAS is now obsolete. Use the new function definition
@@ -1057,11 +1056,21 @@
 <a name="dec_dependency_applications"></a>HyperSQL Dependency Settings for Applications</h2>
 </div>
 <div>
-<h3 class="subtitle">Dependency settings using Gradle, Ivy, Maven, Groovy</h3>
+<h3 class="subtitle">Java Module Dependency and Dependency settings using Gradle,
+    Ivy, Maven, Groovy</h3>
 </div>
 </div>
 </div>
-<p>This section is about building applications that have build-time
+<p>HyperSQL and SqlTool version 2.7.0 jars are Java Module jars
+    compiled with JDK 11. The module name for HyperSQL is
+    <code class="literal">org.hsqldb</code> and for SqlTool,
+    <code class="literal">org.hsqldb.sqltool</code>. In a modular application, these
+    names are referenced in the <code class="literal">module-info.java</code> file for
+    the user application that accesses these jars.</p>
+<p>For non-modular applications, the jars are simply included the
+    the classpath. Jars compiled with JDK8 are also provided and can be used
+    for applications that must run on a JVM older than 11,</p>
+<p>This section is about building applications that have
     dependencies upon HyperSQL, and for executions that use a dependency
     library system. Examples of the second type are unit test runs, job runs
     triggered by a build system, or systems like Grape that pull libraries
@@ -1103,7 +1112,7 @@
       the suggestions in the appropriate sections below. If you need to
       specify a specific version, follow the instructions in the
       range-versioning section but change the version range specifications to
-      literal versions like <code class="literal">2.6.0</code>.</p>
+      literal versions like <code class="literal">2.7.0</code>.</p>
 </div>
 <div class="section">
 <div class="titlepage">
@@ -1161,7 +1170,7 @@
 </table>
 </div>
 <div class="example">
-<a name="N15C9B"></a>
+<a name="N15E5E"></a>
 <p class="title">
 <b>Example&nbsp;12.3.&nbsp;Sample Range Ivy Dependency</b>
 </p>
@@ -1173,15 +1182,15 @@
           because I have so far failed to get that to succeed. Classifiers in
           in <code class="filename">ivy.xml</code> are supported if using Gradle, as
           covered below.</p>
-<p>At the time that I'm writing this, our builds are only
-          providing one classifier (besides the default no-classifier, of
-          course) and its name is "debug". Therefore in all examples for using
-          a classifier I am using classifier name "debug".</p>
+<p>At the time that I'm writing this, our builds are providing
+          two classifiers (besides the default no-classifier, of course) named
+          "debug" and "jdk8". In all examples for using a classifier I am
+          using classifier name "debug".</p>
 </div>
 </div>
 <br class="example-break">
 <div class="example">
-<a name="N15CAD"></a>
+<a name="N15E70"></a>
 <p class="title">
 <b>Example&nbsp;12.4.&nbsp;Sample Range Maven Dependency</b>
 </p>
@@ -1203,7 +1212,7 @@
 </div>
 <br class="example-break">
 <div class="example">
-<a name="N15CB8"></a>
+<a name="N15E7B"></a>
 <p class="title">
 <b>Example&nbsp;12.5.&nbsp;Sample Range Gradle Dependency</b>
 </p>
@@ -1224,7 +1233,7 @@
         <code class="literal">ivyxml</code>. See the <a class="link" href="https://github.com/unsaved/gradle-ivyxml-plugin/raw/master/README.txt" target="_top">
         Ivyxml documentation</a> to see exactly how. </p>
 <div class="example">
-<a name="N15CD0"></a>
+<a name="N15E93"></a>
 <p class="title">
 <b>Example&nbsp;12.6.&nbsp;Sample Range ivy.xml loaded by Ivyxml plugin</b>
 </p>
@@ -1239,7 +1248,7 @@
 <br class="example-break">
 </p>
 <div class="example">
-<a name="N15CD5"></a>
+<a name="N15E98"></a>
 <p class="title">
 <b>Example&nbsp;12.7.&nbsp;Sample Range Groovy Dependency, using Grape</b>
 </p>
@@ -1254,7 +1263,7 @@
 </div>
 </div>
 <HR xmlns:xi="http://www.w3.org/2001/XInclude">
-<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6369 $</P>
+<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6474 $</P>
 <div class="navfooter">
 <hr>
 <table summary="Navigation footer" width="100%">
diff -pruN 2.6.1-1/hsqldb/doc/guide/filelinks-app.html 2.7.0-1/hsqldb/doc/guide/filelinks-app.html
--- 2.6.1-1/hsqldb/doc/guide/filelinks-app.html	2021-10-20 09:33:34.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/guide/filelinks-app.html	2022-07-26 20:21:48.000000000 +0000
@@ -67,12 +67,12 @@
 <a name="JDBCConnection.html-link"></a>
 <p class="simpara">
         Local:
-        <a class="link" href="../apidocs/org/hsqldb/jdbc/JDBCConnection.html" target="_top">../apidocs/org/hsqldb/jdbc/JDBCConnection.html</a>
+        <a class="link" href="../apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCConnection.html" target="_top">../apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCConnection.html</a>
       
 </p>
 <p class="simpara">
         
-<a class="link" href="http://hsqldb.org/doc/2.0/apidocs/org/hsqldb/jdbc/JDBCConnection.html" target="_top">http://hsqldb.org/doc/2.0/apidocs/org/hsqldb/jdbc/JDBCConnection.html</a>
+<a class="link" href="http://hsqldb.org/doc/2.0/apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCConnection.html" target="_top">http://hsqldb.org/doc/2.0/apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCConnection.html</a>
       
 </p>
 </li>
@@ -80,12 +80,12 @@
 <a name="JDBCDriver.html-link"></a>
 <p class="simpara">
         Local:
-        <a class="link" href="../apidocs/org/hsqldb/jdbc/JDBCDriver.html" target="_top">../apidocs/org/hsqldb/jdbc/JDBCDriver.html</a>
+        <a class="link" href="../apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCDriver.html" target="_top">../apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCDriver.html</a>
       
 </p>
 <p class="simpara">
         
-<a class="link" href="http://hsqldb.org/doc/2.0/apidocs/org/hsqldb/jdbc/JDBCDriver.html" target="_top">http://hsqldb.org/doc/2.0/apidocs/org/hsqldb/jdbc/JDBCDriver.html</a>
+<a class="link" href="http://hsqldb.org/doc/2.0/apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCDriver.html" target="_top">http://hsqldb.org/doc/2.0/apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCDriver.html</a>
       
 </p>
 </li>
@@ -93,12 +93,12 @@
 <a name="JDBCDatabaseMetaData.html-link"></a>
 <p class="simpara">
         Local:
-        <a class="link" href="../apidocs/org/hsqldb/jdbc/JDBCDatabaseMetaData.html" target="_top">../apidocs/org/hsqldb/jdbc/JDBCDatabaseMetaData.html</a>
+        <a class="link" href="../apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCDatabaseMetaData.html" target="_top">../apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCDatabaseMetaData.html</a>
       
 </p>
 <p class="simpara">
         
-<a class="link" href="http://hsqldb.org/doc/2.0/apidocs/org/hsqldb/jdbc/JDBCDatabaseMetaData.html" target="_top">http://hsqldb.org/doc/2.0/apidocs/org/hsqldb/jdbc/JDBCDatabaseMetaData.html</a>
+<a class="link" href="http://hsqldb.org/doc/2.0/apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCDatabaseMetaData.html" target="_top">http://hsqldb.org/doc/2.0/apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCDatabaseMetaData.html</a>
       
 </p>
 </li>
@@ -106,12 +106,12 @@
 <a name="JDBCResultSet.html-link"></a>
 <p class="simpara">
         Local:
-        <a class="link" href="../apidocs/org/hsqldb/jdbc/JDBCResultSet.html" target="_top">../apidocs/org/hsqldb/jdbc/JDBCResultSet.html</a>
+        <a class="link" href="../apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCResultSet.html" target="_top">../apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCResultSet.html</a>
       
 </p>
 <p class="simpara">
         
-<a class="link" href="http://hsqldb.org/doc/2.0/apidocs/org/hsqldb/jdbc/JDBCResultSet.html" target="_top">http://hsqldb.org/doc/2.0/apidocs/org/hsqldb/jdbc/JDBCResultSet.html</a>
+<a class="link" href="http://hsqldb.org/doc/2.0/apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCResultSet.html" target="_top">http://hsqldb.org/doc/2.0/apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCResultSet.html</a>
       
 </p>
 </li>
@@ -119,12 +119,12 @@
 <a name="JDBCStatement.html-link"></a>
 <p class="simpara">
         Local:
-        <a class="link" href="../apidocs/org/hsqldb/jdbc/JDBCStatement.html" target="_top">../apidocs/org/hsqldb/jdbc/JDBCStatement.html</a>
+        <a class="link" href="../apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCStatement.html" target="_top">../apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCStatement.html</a>
       
 </p>
 <p class="simpara">
         
-<a class="link" href="http://hsqldb.org/doc/2.0/apidocs/org/hsqldb/jdbc/JDBCStatement.html" target="_top">http://hsqldb.org/doc/2.0/apidocs/org/hsqldb/jdbc/JDBCStatement.html</a>
+<a class="link" href="http://hsqldb.org/doc/2.0/apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCStatement.html" target="_top">http://hsqldb.org/doc/2.0/apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCStatement.html</a>
       
 </p>
 </li>
@@ -132,12 +132,12 @@
 <a name="JDBCPreparedStatement.html-link"></a>
 <p class="simpara">
         Local:
-        <a class="link" href="../apidocs/org/hsqldb/jdbc/JDBCPreparedStatement.html" target="_top">../apidocs/org/hsqldb/jdbc/JDBCPreparedStatement.html</a>
+        <a class="link" href="../apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCPreparedStatement.html" target="_top">../apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCPreparedStatement.html</a>
       
 </p>
 <p class="simpara">
         
-<a class="link" href="http://hsqldb.org/doc/2.0/apidocs/org/hsqldb/jdbc/JDBCPreparedStatement.html" target="_top">http://hsqldb.org/doc/2.0/apidocs/org/hsqldb/jdbc/JDBCPreparedStatement.html</a>
+<a class="link" href="http://hsqldb.org/doc/2.0/apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCPreparedStatement.html" target="_top">http://hsqldb.org/doc/2.0/apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCPreparedStatement.html</a>
       
 </p>
 </li>
@@ -145,12 +145,12 @@
 <a name="MainInvoker.html-link"></a>
 <p class="simpara">
         Local:
-        <a class="link" href="../apidocs/org/hsqldb/util/MainInvoker.html" target="_top">../apidocs/org/hsqldb/util/MainInvoker.html</a>
+        <a class="link" href="../apidocs/org.hsqldb/org/hsqldb/util/MainInvoker.html" target="_top">../apidocs/org.hsqldb/org/hsqldb/util/MainInvoker.html</a>
       
 </p>
 <p class="simpara">
       
-<a class="link" href="http://hsqldb.org/doc/2.0/apidocs/org/hsqldb/util/MainInvoker.html" target="_top">http://hsqldb.org/doc/2.0/apidocs/org/hsqldb/util/MainInvoker.html</a>
+<a class="link" href="http://hsqldb.org/doc/2.0/apidocs/org.hsqldb/org/hsqldb/util/MainInvoker.html" target="_top">http://hsqldb.org/doc/2.0/apidocs/org.hsqldb/org/hsqldb/util/MainInvoker.html</a>
       
 </p>
 </li>
@@ -259,15 +259,15 @@
 </p>
 </li>
 <li class="listitem">
-<a name="hsqldb.cfg-link"></a>
+<a name="hsqldb.conf-link"></a>
 <p class="simpara">
         Local:
-        <a class="link" href="../verbatim/sample/hsqldb.cfg" target="_top">../verbatim/sample/hsqldb.cfg</a>
+        <a class="link" href="../verbatim/sample/hsqldb.conf" target="_top">../verbatim/sample/hsqldb.conf</a>
       
 </p>
 <p class="simpara">
         
-<a class="link" href="http://hsqldb.org/doc/2.0/verbatim/sample/hsqldb.cfg" target="_top">http://hsqldb.org/doc/2.0/verbatim/sample/hsqldb.cfg</a>
+<a class="link" href="http://hsqldb.org/doc/2.0/verbatim/sample/hsqldb.conf" target="_top">http://hsqldb.org/doc/2.0/verbatim/sample/hsqldb.conf</a>
       
 </p>
 </li>
@@ -327,7 +327,7 @@
 </div>
 </div>
 <HR xmlns:xi="http://www.w3.org/2001/XInclude">
-<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6369 $</P>
+<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6474 $</P>
 <div class="navfooter">
 <hr>
 <table summary="Navigation footer" width="100%">
diff -pruN 2.6.1-1/hsqldb/doc/guide/guide.html 2.7.0-1/hsqldb/doc/guide/guide.html
--- 2.6.1-1/hsqldb/doc/guide/guide.html	2021-10-20 09:35:06.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/guide/guide.html	2022-07-26 20:23:04.000000000 +0000
@@ -15,7 +15,7 @@
 <a name="guide"></a>HyperSQL User Guide</h1>
 </div>
 <div>
-<h2 class="subtitle">HyperSQL Database Engine 2.6.1</h2>
+<h2 class="subtitle">HyperSQL Database Engine 2.7.0</h2>
 </div>
 <table xmlns:xi="http://www.w3.org/2001/XInclude" class="titlead" cellspacing="0">
 <tr>
@@ -53,7 +53,7 @@
 <div>
 <div class="legalnotice">
 <a name="N1003E"></a>
-<p>Copyright 2002-2021 Blaine Simpson, Fred Toussi and The HSQL
+<p>Copyright 2002-2022 Blaine Simpson, Fred Toussi and The HSQL
       Development Group. Permission is granted to distribute this document
       without any alteration under the terms of the HSQLDB license. You are
       not allowed to distribute or display this document on the web in an
@@ -61,7 +61,7 @@
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </td><td class="sponsorad">
 <div xml:base="../doc-src/branding-frag.xhtml" class="branding">
@@ -188,7 +188,7 @@
 <dd>
 <dl>
 <dt>
-<span class="section"><a href="#N10485">Case Sensitivity</a></span>
+<span class="section"><a href="#N1048B">Case Sensitivity</a></span>
 </dt>
 <dt>
 <span class="section"><a href="#sgc_persist_tables">Persistent Tables</a></span>
@@ -413,6 +413,9 @@
 <span class="section"><a href="#bfc_string_binary_functions">String and Binary String Functions</a></span>
 </dt>
 <dt>
+<span class="section"><a href="#bfc_JSON_functions">JSON Functions</a></span>
+</dt>
+<dt>
 <span class="section"><a href="#bfc_numeric_functions">Numeric Functions</a></span>
 </dt>
 <dt>
@@ -739,6 +742,9 @@
 <span class="section"><a href="#acc_access_rights">Access Rights</a></span>
 </dt>
 <dt>
+<span class="section"><a href="#N1425C">Simple Access Control</a></span>
+</dt>
+<dt>
 <span class="section"><a href="#acc_fine_grained_access">Fine-Grained Data Access Control</a></span>
 </dt>
 </dl>
@@ -1244,7 +1250,7 @@
 <span class="section"><a href="#dpc_variables_url">Variables in Connection URL</a></span>
 </dt>
 <dt>
-<span class="section"><a href="#N16054">Connection Properties</a></span>
+<span class="section"><a href="#N16217">Connection Properties</a></span>
 </dt>
 <dt>
 <span class="section"><a href="#dpc_connection_props">Properties for Individual Connections</a></span>
@@ -1521,174 +1527,182 @@
 <dl>
 <dt>1. <a href="#altformats-tbl">Available formats of this document</a>
 </dt>
-<dt>2.1. <a href="#N10531">List of SQL types</a>
+<dt>2.1. <a href="#N10537">List of SQL types</a>
 </dt>
-<dt>4.1. <a href="#N126CE">TO_CHAR, TO_DATE and TO_TIMESTAMP format elements</a>
+<dt>4.1. <a href="#N127C5">TO_CHAR, TO_DATE and TO_TIMESTAMP format elements</a>
 </dt>
-<dt>14.1. <a href="#N15F0F">Memory Database URL</a>
+<dt>14.1. <a href="#N160D2">Memory Database URL</a>
 </dt>
-<dt>14.2. <a href="#N15F50">File Database URL</a>
+<dt>14.2. <a href="#N16113">File Database URL</a>
 </dt>
-<dt>14.3. <a href="#N15F96">Resource Database URL</a>
+<dt>14.3. <a href="#N16159">Resource Database URL</a>
 </dt>
-<dt>14.4. <a href="#N15FCA">Server Database URL</a>
+<dt>14.4. <a href="#N1618D">Server Database URL</a>
 </dt>
-<dt>14.5. <a href="#N1607B">User and Password</a>
+<dt>14.5. <a href="#N16242">User and Password</a>
 </dt>
-<dt>14.6. <a href="#N160BC">Creating New Database</a>
+<dt>14.6. <a href="#N16283">Closing old ResultSet when Statement is reused</a>
 </dt>
-<dt>14.7. <a href="#N1611B">Closing old ResultSet when Statement is reused</a>
+<dt>14.7. <a href="#N162CA">Column Names in JDBC ResultSet</a>
 </dt>
-<dt>14.8. <a href="#N16162">Column Names in JDBC ResultSet</a>
+<dt>14.8. <a href="#N16303">In-memory LOBs from JDBC ResultSet</a>
 </dt>
-<dt>14.9. <a href="#N1619B">In-memory LOBs from JDBC ResultSet</a>
+<dt>14.9. <a href="#N16334">Empty batch in JDBC PreparedStatement</a>
 </dt>
-<dt>14.10. <a href="#N161CC">Empty batch in JDBC PreparedStatement</a>
+<dt>14.10. <a href="#N1636A">Automatic Shutdown</a>
 </dt>
-<dt>14.11. <a href="#N16202">Automatic Shutdown</a>
+<dt>14.11. <a href="#N163A1">OpenOffice and Libre Office usage</a>
 </dt>
-<dt>14.12. <a href="#N1626C">Validity Check Property</a>
+<dt>14.12. <a href="#N16407">Validity Check Property</a>
 </dt>
-<dt>14.13. <a href="#N1629D">Execution of Multiple SQL Statements etc.</a>
+<dt>14.13. <a href="#N16434">Creating New Database Check Property</a>
 </dt>
-<dt>14.14. <a href="#N162DD">SQL Keyword Use as Identifier</a>
+<dt>14.14. <a href="#N16497">Execution of Multiple SQL Statements etc.</a>
 </dt>
-<dt>14.15. <a href="#N1630A">SQL Keyword Starting with the Underscore or Containing Dollar
+<dt>14.15. <a href="#N164D7">SQL Keyword Use as Identifier</a>
+</dt>
+<dt>14.16. <a href="#N16504">SQL Keyword Starting with the Underscore or Containing Dollar
         Characters</a>
 </dt>
-<dt>14.16. <a href="#N16337">Reference to Columns Names</a>
+<dt>14.17. <a href="#N16531">Reference to Columns Names</a>
+</dt>
+<dt>14.18. <a href="#N1655E">String Size Declaration</a>
+</dt>
+<dt>14.19. <a href="#N1658B">Truncation of trailing spaces from string</a>
 </dt>
-<dt>14.17. <a href="#N16364">String Size Declaration</a>
+<dt>14.20. <a href="#N165B8">Type Enforcement in Comparison and Assignment</a>
 </dt>
-<dt>14.18. <a href="#N16391">Type Enforcement in Comparison and Assignment</a>
+<dt>14.21. <a href="#N165E5">Foreign Key Triggered Data Change</a>
 </dt>
-<dt>14.19. <a href="#N163BE">Foreign Key Triggered Data Change</a>
+<dt>14.22. <a href="#N16628">Use of LOB for LONGVAR Types</a>
 </dt>
-<dt>14.20. <a href="#N16401">Use of LOB for LONGVAR Types</a>
+<dt>14.23. <a href="#N16655">Type of string literals in CASE WHEN</a>
 </dt>
-<dt>14.21. <a href="#N1642E">Type of string literals in CASE WHEN</a>
+<dt>14.24. <a href="#N16682">Concatenation with NULL</a>
 </dt>
-<dt>14.22. <a href="#N1645B">Concatenation with NULL</a>
+<dt>14.25. <a href="#N166AF">NULL in Multi-Column UNIQUE Constraints</a>
 </dt>
-<dt>14.23. <a href="#N16488">NULL in Multi-Column UNIQUE Constraints</a>
+<dt>14.26. <a href="#N166DC">Truncation or Rounding in Type Conversion</a>
 </dt>
-<dt>14.24. <a href="#N164B5">Truncation or Rounding in Type Conversion</a>
+<dt>14.27. <a href="#N16709">Decimal Scale of Division and AVG Values</a>
 </dt>
-<dt>14.25. <a href="#N164E2">Decimal Scale of Division and AVG Values</a>
+<dt>14.28. <a href="#N16736">Support for NaN values</a>
 </dt>
-<dt>14.26. <a href="#N1650F">Support for NaN values</a>
+<dt>14.29. <a href="#N16763">Sort order of NULL values</a>
 </dt>
-<dt>14.27. <a href="#N1653C">Sort order of NULL values</a>
+<dt>14.30. <a href="#N16790">Sort order of NULL values with DESC</a>
 </dt>
-<dt>14.28. <a href="#N16569">Sort order of NULL values with DESC</a>
+<dt>14.31. <a href="#N167C0">String Comparison with Padding</a>
 </dt>
-<dt>14.29. <a href="#N16599">String Comparison with Padding</a>
+<dt>14.32. <a href="#N167EF">Default Locale Language Collation</a>
 </dt>
-<dt>14.30. <a href="#N165C8">Default Locale Language Collation</a>
+<dt>14.33. <a href="#N1681C">Case-Insensitive Varchar columns</a>
 </dt>
-<dt>14.31. <a href="#N165F5">Case-Insensitive Varchar columns</a>
+<dt>14.34. <a href="#N16849">Lowercase column identifiers in ResultSet</a>
 </dt>
-<dt>14.32. <a href="#N16622">Lowercase column identifiers in ResultSet</a>
+<dt>14.35. <a href="#N16876">Storage of Live Java Objects</a>
 </dt>
-<dt>14.33. <a href="#N1664F">Storage of Live Java Objects</a>
+<dt>14.36. <a href="#N168A3">Names of System Indexes Used for Constraints</a>
 </dt>
-<dt>14.34. <a href="#N1667C">Names of System Indexes Used for Constraints</a>
+<dt>14.37. <a href="#N168D2">DB2 Style Syntax</a>
 </dt>
-<dt>14.35. <a href="#N166A9">DB2 Style Syntax</a>
+<dt>14.38. <a href="#N168FE">MSSQL Style Syntax</a>
 </dt>
-<dt>14.36. <a href="#N166D5">MSSQL Style Syntax</a>
+<dt>14.39. <a href="#N1692A">MySQL Style Syntax</a>
 </dt>
-<dt>14.37. <a href="#N16701">MySQL Style Syntax</a>
+<dt>14.40. <a href="#N16957">Oracle Style Syntax</a>
 </dt>
-<dt>14.38. <a href="#N1672E">Oracle Style Syntax</a>
+<dt>14.41. <a href="#N16984">PostgreSQL Style Syntax</a>
 </dt>
-<dt>14.39. <a href="#N1675B">PostgreSQL Style Syntax</a>
+<dt>14.42. <a href="#N169B0">Maximum Iterations of Recursive Queries</a>
 </dt>
-<dt>14.40. <a href="#N1678B">Default Table Type</a>
+<dt>14.43. <a href="#N169E3">Default Table Type</a>
 </dt>
-<dt>14.41. <a href="#N167BB">Transaction Control Mode</a>
+<dt>14.44. <a href="#N16A13">Transaction Control Mode</a>
 </dt>
-<dt>14.42. <a href="#N167F1">Default Isolation Level for Sessions</a>
+<dt>14.45. <a href="#N16A49">Default Isolation Level for Sessions</a>
 </dt>
-<dt>14.43. <a href="#N16824">Transaction Rollback in Deadlock</a>
+<dt>14.46. <a href="#N16A7C">Transaction Rollback in Deadlock</a>
 </dt>
-<dt>14.44. <a href="#N16851">Transaction Rollback on Interrupt</a>
+<dt>14.47. <a href="#N16AA9">Transaction Rollback on Interrupt</a>
 </dt>
-<dt>14.45. <a href="#N1687E">Time Zone and Interval Types</a>
+<dt>14.48. <a href="#N16AD6">Time Zone and Interval Types</a>
 </dt>
-<dt>14.46. <a href="#N168B5">Opening Database as Read Only</a>
+<dt>14.49. <a href="#N16B0B">Temporary Result Rows in Memory</a>
 </dt>
-<dt>14.47. <a href="#N168E5">Opening Database Without Modifying the Files</a>
+<dt>14.50. <a href="#N16B3C">Opening Database as Read Only</a>
 </dt>
-<dt>14.48. <a href="#N16915">Huge database files and tables</a>
+<dt>14.51. <a href="#N16B6C">Opening Database Without Modifying the Files</a>
 </dt>
-<dt>14.49. <a href="#N16945">Event Logging</a>
+<dt>14.52. <a href="#N16B9C">Event Logging</a>
 </dt>
-<dt>14.50. <a href="#N16975">SQL Logging</a>
+<dt>14.53. <a href="#N16BCC">SQL Logging</a>
 </dt>
-<dt>14.51. <a href="#N169A5">Temporary Result Rows in Memory</a>
+<dt>14.54. <a href="#N16BFC">Table Spaces for Cached Tables</a>
 </dt>
-<dt>14.52. <a href="#N169D2">Unused Space Recovery</a>
+<dt>14.55. <a href="#N16C29">Huge database files and tables</a>
 </dt>
-<dt>14.53. <a href="#N16A04">Rows Cached In Memory</a>
+<dt>14.56. <a href="#N16C59">Use of NIO for Disk Table Storage</a>
 </dt>
-<dt>14.54. <a href="#N16A33">Size of Rows Cached in Memory</a>
+<dt>14.57. <a href="#N16C8C">Use of NIO for Disk Table Storage</a>
 </dt>
-<dt>14.55. <a href="#N16A62">Size Scale of Disk Table Storage</a>
+<dt>14.58. <a href="#N16CB9">Internal Backup of the .data File</a>
 </dt>
-<dt>14.56. <a href="#N16A8F">Size Scale of LOB Storage</a>
+<dt>14.59. <a href="#N16CEA">Unused Space Recovery</a>
 </dt>
-<dt>14.57. <a href="#N16ABC">Compression of BLOB and CLOB data</a>
+<dt>14.60. <a href="#N16D1E">Rows Cached In Memory</a>
 </dt>
-<dt>14.58. <a href="#N16AE9">Internal Backup of Database Files</a>
+<dt>14.61. <a href="#N16D4D">Size of Rows Cached in Memory</a>
 </dt>
-<dt>14.59. <a href="#N16B1A">Use of Lock File</a>
+<dt>14.62. <a href="#N16D7C">Size Scale of Disk Table Storage</a>
 </dt>
-<dt>14.60. <a href="#N16B4A">Logging Data Change Statements</a>
+<dt>14.63. <a href="#N16DA9">Size Scale of LOB Storage</a>
 </dt>
-<dt>14.61. <a href="#N16B80">Automatic Checkpoint Frequency</a>
+<dt>14.64. <a href="#N16DD6">Compression of BLOB and CLOB data</a>
 </dt>
-<dt>14.62. <a href="#N16BB6">Automatic Defrag at Checkpoint</a>
+<dt>14.65. <a href="#N16E03">Use of Lock File</a>
 </dt>
-<dt>14.63. <a href="#N16BE3">Compression of the .script file</a>
+<dt>14.66. <a href="#N16E33">Logging Data Change Statements</a>
 </dt>
-<dt>14.64. <a href="#N16C13">Logging Data Change Statements Frequency</a>
+<dt>14.67. <a href="#N16E69">Automatic Checkpoint Frequency</a>
 </dt>
-<dt>14.65. <a href="#N16C40">Logging Data Change Statements Frequency</a>
+<dt>14.68. <a href="#N16E9F">Automatic Defrag at Checkpoint</a>
 </dt>
-<dt>14.66. <a href="#N16C6D">Use of NIO for Disk Table Storage</a>
+<dt>14.69. <a href="#N16ECC">Compression of the .script file</a>
 </dt>
-<dt>14.67. <a href="#N16CA0">Use of NIO for Disk Table Storage</a>
+<dt>14.70. <a href="#N16EFC">Logging Data Change Statements Frequency</a>
 </dt>
-<dt>14.68. <a href="#N16CCD">Recovery Log Processing</a>
+<dt>14.71. <a href="#N16F29">Logging Data Change Statements Frequency</a>
 </dt>
-<dt>14.69. <a href="#N16CFA">Default Properties for TEXT Tables</a>
+<dt>14.72. <a href="#N16F56">Recovery Log Processing</a>
 </dt>
-<dt>14.70. <a href="#N16D2E">Forcing Garbage Collection</a>
+<dt>14.73. <a href="#N16F83">Default Properties for TEXT Tables</a>
 </dt>
-<dt>14.71. <a href="#N16D5F">Crypt Property For LOBs</a>
+<dt>14.74. <a href="#N16FB7">Forcing Garbage Collection</a>
 </dt>
-<dt>14.72. <a href="#N16D8C">Cipher Key for Encrypted Database</a>
+<dt>14.75. <a href="#N16FE8">Crypt Property For LOBs</a>
 </dt>
-<dt>14.73. <a href="#N16DB9">Cipher Initialization Vector for Encrypted Database</a>
+<dt>14.76. <a href="#N17015">Cipher Key for Encrypted Database</a>
 </dt>
-<dt>14.74. <a href="#N16DE6">Crypt Provider Encrypted Database</a>
+<dt>14.77. <a href="#N17042">Cipher Initialization Vector for Encrypted Database</a>
 </dt>
-<dt>14.75. <a href="#N16E13">Cipher Specification for Encrypted Database</a>
+<dt>14.78. <a href="#N1706F">Crypt Provider Encrypted Database</a>
 </dt>
-<dt>14.76. <a href="#N16E4D">Logging Framework</a>
+<dt>14.79. <a href="#N1709C">Cipher Specification for Encrypted Database</a>
 </dt>
-<dt>14.77. <a href="#N16E77">Text Tables</a>
+<dt>14.80. <a href="#N170CF">Logging Framework</a>
 </dt>
-<dt>14.78. <a href="#N16EA4">Java Functions</a>
+<dt>14.81. <a href="#N170F9">Text Tables</a>
 </dt>
-<dt>15.1. <a href="#N16F70">common server and webserver properties</a>
+<dt>14.82. <a href="#N17126">Java Functions</a>
 </dt>
-<dt>15.2. <a href="#N1700D">server properties</a>
+<dt>15.1. <a href="#N171F2">common server and webserver properties</a>
 </dt>
-<dt>15.3. <a href="#N1703F">webserver properties</a>
+<dt>15.2. <a href="#N1728F">server properties</a>
 </dt>
-<dt>17.1. <a href="#N17791">Settings List</a>
+<dt>15.3. <a href="#N172C1">webserver properties</a>
+</dt>
+<dt>17.1. <a href="#N17A13">Settings List</a>
 </dt>
 </dl>
 </div>
@@ -1697,94 +1711,94 @@
 <b>List of Examples</b>
 </p>
 <dl>
-<dt>1.1. <a href="#N10236">Java code to connect to the local hsql Server</a>
+<dt>1.1. <a href="#N1023C">Java code to connect to the local hsql Server</a>
 </dt>
-<dt>1.2. <a href="#N10240">Java code to connect to the local http Server</a>
+<dt>1.2. <a href="#N10246">Java code to connect to the local http Server</a>
 </dt>
-<dt>1.3. <a href="#N10264">Java code to connect to the local secure SSL hsqls: and
+<dt>1.3. <a href="#N1026A">Java code to connect to the local secure SSL hsqls: and
           https: Servers</a>
 </dt>
-<dt>1.4. <a href="#N1030A">specifying a connection property to shutdown the database when
+<dt>1.4. <a href="#N10310">specifying a connection property to shutdown the database when
         the last connection is closed</a>
 </dt>
-<dt>1.5. <a href="#N10327">specifying a connection property to disallow creating a new
+<dt>1.5. <a href="#N1032D">specifying a connection property to disallow creating a new
         database</a>
 </dt>
-<dt>3.1. <a href="#N10C0E">inserting the next sequence value into a table row</a>
+<dt>3.1. <a href="#N10C22">inserting the next sequence value into a table row</a>
 </dt>
-<dt>3.2. <a href="#N10C15">numbering returned rows of a SELECT in sequential order</a>
+<dt>3.2. <a href="#N10C29">numbering returned rows of a SELECT in sequential order</a>
 </dt>
-<dt>3.3. <a href="#N10C21">using the last value of a sequence</a>
+<dt>3.3. <a href="#N10C35">using the last value of a sequence</a>
 </dt>
-<dt>3.4. <a href="#N10CC6">Column values which satisfy a 2-column UNIQUE
+<dt>3.4. <a href="#N10CDA">Column values which satisfy a 2-column UNIQUE
         constraint</a>
 </dt>
-<dt>6.1. <a href="#N13B26">User-defined Session Variables</a>
+<dt>6.1. <a href="#N13C39">User-defined Session Variables</a>
 </dt>
-<dt>6.2. <a href="#N13B3B">User-defined Temporary Session Tables</a>
+<dt>6.2. <a href="#N13C4E">User-defined Temporary Session Tables</a>
 </dt>
-<dt>6.3. <a href="#N13C4E">Setting Transaction Characteristics</a>
+<dt>6.3. <a href="#N13D61">Setting Transaction Characteristics</a>
 </dt>
-<dt>6.4. <a href="#N13C7C">Locking Tables</a>
+<dt>6.4. <a href="#N13D8F">Locking Tables</a>
 </dt>
-<dt>6.5. <a href="#N13CDF">Rollback</a>
+<dt>6.5. <a href="#N13DF2">Rollback</a>
 </dt>
-<dt>6.6. <a href="#N13D11">Setting Session Characteristics</a>
+<dt>6.6. <a href="#N13E24">Setting Session Characteristics</a>
 </dt>
-<dt>6.7. <a href="#N13D27">Setting Session Authorization</a>
+<dt>6.7. <a href="#N13E3A">Setting Session Authorization</a>
 </dt>
-<dt>6.8. <a href="#N13D54">Setting Session Time Zone</a>
+<dt>6.8. <a href="#N13E6B">Setting Session Time Zone</a>
 </dt>
-<dt>11.1. <a href="#N14D64">Using CACHED tables for the LOB schema</a>
+<dt>11.1. <a href="#N14EB8">Using CACHED tables for the LOB schema</a>
 </dt>
-<dt>11.2. <a href="#N14ED7">Creating a system-versioned table</a>
+<dt>11.2. <a href="#N1502B">Creating a system-versioned table</a>
 </dt>
-<dt>11.3. <a href="#N14F94">Displaying DbBackup Syntax</a>
+<dt>11.3. <a href="#N150ED">Displaying DbBackup Syntax</a>
 </dt>
-<dt>11.4. <a href="#N14F9F">Offline Backup Example</a>
+<dt>11.4. <a href="#N150F8">Offline Backup Example</a>
 </dt>
-<dt>11.5. <a href="#N14FC0">Listing a Backup with DbBackup</a>
+<dt>11.5. <a href="#N15119">Listing a Backup with DbBackup</a>
 </dt>
-<dt>11.6. <a href="#N14FD7">Restoring a Backup with DbBackup</a>
+<dt>11.6. <a href="#N15130">Restoring a Backup with DbBackup</a>
 </dt>
-<dt>11.7. <a href="#N152CE">SQL Log Example</a>
+<dt>11.7. <a href="#N1545D">SQL Log Example</a>
 </dt>
-<dt>11.8. <a href="#N15781">Finding foreign key rows with no parents after a bulk
+<dt>11.8. <a href="#N15937">Finding foreign key rows with no parents after a bulk
         import</a>
 </dt>
-<dt>12.1. <a href="#N15A25">Using CACHED tables for the LOB schema</a>
+<dt>12.1. <a href="#N15BDB">Using CACHED tables for the LOB schema</a>
 </dt>
-<dt>12.2. <a href="#N15B37">MainInvoker Example</a>
+<dt>12.2. <a href="#N15CED">MainInvoker Example</a>
 </dt>
-<dt>12.3. <a href="#N15C9B">Sample Range Ivy Dependency</a>
+<dt>12.3. <a href="#N15E5E">Sample Range Ivy Dependency</a>
 </dt>
-<dt>12.4. <a href="#N15CAD">Sample Range Maven Dependency</a>
+<dt>12.4. <a href="#N15E70">Sample Range Maven Dependency</a>
 </dt>
-<dt>12.5. <a href="#N15CB8">Sample Range Gradle Dependency</a>
+<dt>12.5. <a href="#N15E7B">Sample Range Gradle Dependency</a>
 </dt>
-<dt>12.6. <a href="#N15CD0">Sample Range ivy.xml loaded by Ivyxml plugin</a>
+<dt>12.6. <a href="#N15E93">Sample Range ivy.xml loaded by Ivyxml plugin</a>
 </dt>
-<dt>12.7. <a href="#N15CD5">Sample Range Groovy Dependency, using Grape</a>
+<dt>12.7. <a href="#N15E98">Sample Range Groovy Dependency, using Grape</a>
 </dt>
-<dt>15.1. <a href="#N17165">Exporting certificate from the server's keystore</a>
+<dt>15.1. <a href="#N173E7">Exporting certificate from the server's keystore</a>
 </dt>
-<dt>15.2. <a href="#N17177">Adding a certificate to the client keystore</a>
+<dt>15.2. <a href="#N173F9">Adding a certificate to the client keystore</a>
 </dt>
-<dt>15.3. <a href="#N1718B">Specifying your own trust store to a JDBC client</a>
+<dt>15.3. <a href="#N1740D">Specifying your own trust store to a JDBC client</a>
 </dt>
-<dt>15.4. <a href="#N17206">Getting a pem-style private key into a JKS keystore</a>
+<dt>15.4. <a href="#N17488">Getting a pem-style private key into a JKS keystore</a>
 </dt>
-<dt>15.5. <a href="#N1728F">Validating and Testing an ACL file</a>
+<dt>15.5. <a href="#N17511">Validating and Testing an ACL file</a>
 </dt>
-<dt>16.1. <a href="#N17557">example sqltool.rc stanza</a>
+<dt>16.1. <a href="#N177D9">example sqltool.rc stanza</a>
 </dt>
-<dt>C.1. <a href="#N17C62">Buiding the standard HSQLDB jar file with Ant</a>
+<dt>C.1. <a href="#N17EE4">Buiding the standard HSQLDB jar file with Ant</a>
 </dt>
-<dt>C.2. <a href="#N17C7B">Example source code before CodeSwitcher is run</a>
+<dt>C.2. <a href="#N17EFD">Example source code before CodeSwitcher is run</a>
 </dt>
-<dt>C.3. <a href="#N17C82">CodeSwitcher command line invocation</a>
+<dt>C.3. <a href="#N17F04">CodeSwitcher command line invocation</a>
 </dt>
-<dt>C.4. <a href="#N17C8C">Source code after CodeSwitcher processing</a>
+<dt>C.4. <a href="#N17F0E">Source code after CodeSwitcher processing</a>
 </dt>
 </dl>
 </div>
@@ -1814,7 +1828,7 @@
 <p>The first versions of HSQLDB were released in 2001. Version 2, first
     released in 2010, was a complete rewrite of most parts of the database
     engine.</p>
-<p>This documentation covers HyperSQL version 2.6.1 and has been
+<p>This documentation covers HyperSQL version 2.7.0 and has been
     regularly improved and updated. The latest, updated version can be found
     at http://hsqldb.org/doc/2.0/</p>
 <p>If you notice any mistakes in this document, or if you have problems
@@ -1930,12 +1944,12 @@
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6369 $</p>
+<p class="releaseinfo">$Revision: 6474 $</p>
 </div>
 <div>
 <div class="legalnotice">
 <a name="N100D0"></a>
-<p>Copyright 2002-2021 Fred Toussi. Permission is granted to
+<p>Copyright 2002-2022 Fred Toussi. Permission is granted to
       distribute this document without any alteration under the terms of the
       HSQLDB license. Additional permission is granted to the HSQL Development
       Group to distribute this document with or without alterations under the
@@ -1943,7 +1957,7 @@
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -2013,11 +2027,11 @@
 </div>
 </div>
 <p>HyperSQL Database (HSQLDB) is a modern relational database system.
-    Version 2.6.1 is the latest release of the all-new version 2 code. Written
+    Version 2.7.0 is the latest release of the all-new version 2 code. Written
     from ground up to follow the international ISO SQL:2016 standard, it
     supports the complete set of the classic features, together with optional
     features such as stored procedures and triggers.</p>
-<p>HyperSQL version 2.6.1 is compatible with Java 11 or later and
+<p>HyperSQL version 2.7.0 is compatible with Java 11 or later and
     supports the Java module system. A version of the HSQLDB jar compiled with
     JDK 8 is also included in the download zip package. A version of the jar
     compiled with JDK 6 is also available at hsqldb.org, numbered 2.3.9 to
@@ -2260,11 +2274,12 @@
 <p>The database file path format can be specified using forward slashes
     in Windows hosts as well as Linux hosts. So relative paths or paths that
     refer to the same directory on the same drive can be identical. For
-    example if your database directory in Linux is <code class="filename">/opt/db/
-    containing a database testdb (with files named testdb.*), then the
-    database file path is /opt/db/testdb.</code> If you create an
-    identical directory structure on the <code class="literal">C:</code> drive of a
-    Windows host, you can use the same URL in both Windows and Linux:</p>
+    example if your database directory in Linux is
+    <code class="filename">/opt/db/</code> containing a database testdb (with files
+    named <code class="filename">testdb.*</code>), then the database file path is
+    <code class="filename">/opt/db/testdb</code>. If you create an identical directory
+    structure on the <code class="literal">C:</code> drive of a Windows host, you can
+    use the same URL in both Windows and Linux:</p>
 <pre class="programlisting"> Connection c = DriverManager.getConnection("jdbc:hsqldb:file:/opt/db/testdb", "SA", "");</pre>
 <p>When using relative paths, these paths will be taken relative to the
     directory in which the shell command to start the Java Virtual Machine was
@@ -2386,7 +2401,7 @@
 <pre class="screen"> java -cp ../lib/hsqldb.jar org.hsqldb.server.WebServer --database.0 file:mydb --dbname.0 xdb</pre>
 </div>
 <p>The command line argument <code class="literal">--help</code> can be used to
-      get a list of available arguments. Connections are made using an httpl:
+      get a list of available arguments. Connections are made using an http:
       URL.</p>
 <pre class="programlisting"> Connection c = DriverManager.getConnection("jdbc:hsqldb:http://localhost/xdb", "SA", "");</pre>
 </div>
@@ -2434,7 +2449,7 @@
       used for the <em class="glossterm">hsql:</em> protocol on the same
       machine:</p>
 <div class="example">
-<a name="N10236"></a>
+<a name="N1023C"></a>
 <p class="title">
 <b>Example&nbsp;1.1.&nbsp;Java code to connect to the local hsql Server</b>
 </p>
@@ -2454,7 +2469,7 @@
 <p>If the HyperSQL HTTP server is used, the protocol is
       <em class="glossterm">http:</em> and the URL will be different:</p>
 <div class="example">
-<a name="N10240"></a>
+<a name="N10246"></a>
 <p class="title">
 <b>Example&nbsp;1.2.&nbsp;Java code to connect to the local http Server</b>
 </p>
@@ -2479,7 +2494,7 @@
 </div>
 </div>
 </div>
-<a name="N1024F" class="indexterm"></a>
+<a name="N10255" class="indexterm"></a>
 <p>When a HyperSQL server is run, network access should be adequately
       protected. Source IP addresses may be restricted by use of our <a class="link" href="#lsc_acl" title="Network Access Control">Access Control List feature</a>, network
       filtering software, firewall software, or standalone firewalls. Only
@@ -2494,7 +2509,7 @@
       be specified when running the Server or WebServer. On the client, the
       URL to connect to an SSL server is slightly different:</p>
 <div class="example">
-<a name="N10264"></a>
+<a name="N1026A"></a>
 <p class="title">
 <b>Example&nbsp;1.3.&nbsp;Java code to connect to the local secure SSL hsqls: and
           https: Servers</b>
@@ -2625,7 +2640,7 @@
     to the database (the connection that opens the database) to force a
     shutdown when the last connection closes.</p>
 <div class="example">
-<a name="N1030A"></a>
+<a name="N10310"></a>
 <p class="title">
 <b>Example&nbsp;1.4.&nbsp;specifying a connection property to shutdown the database when
         the last connection is closed</b>
@@ -2667,7 +2682,7 @@
     <code class="methodname">getConnection()</code> method will throw an
     exception.</p>
 <div class="example">
-<a name="N10327"></a>
+<a name="N1032D"></a>
 <p class="title">
 <b>Example&nbsp;1.5.&nbsp;specifying a connection property to disallow creating a new
         database</b>
@@ -2706,12 +2721,12 @@
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6339 $</p>
+<p class="releaseinfo">$Revision: 6576 $</p>
 </div>
 <div>
 <div class="legalnotice">
-<a name="N1035E"></a>
-<p>Copyright 2002-2021 Fred Toussi. Permission is granted to
+<a name="N10364"></a>
+<p>Copyright 2002-2022 Fred Toussi. Permission is granted to
       distribute this document without any alteration under the terms of the
       HSQLDB license. Additional permission is granted to the HSQL Development
       Group to distribute this document with or without alterations under the
@@ -2719,7 +2734,7 @@
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -2768,7 +2783,7 @@
 <dd>
 <dl>
 <dt>
-<span class="section"><a href="#N10485">Case Sensitivity</a></span>
+<span class="section"><a href="#N1048B">Case Sensitivity</a></span>
 </dt>
 <dt>
 <span class="section"><a href="#sgc_persist_tables">Persistent Tables</a></span>
@@ -2862,16 +2877,16 @@
 <p>Over 300 words are reserved by the Standard and should not be used
     as table or column names. For example, the word POSITION is reserved as it
     is a function defined by the Standards with a similar role as
-    <code class="methodname">String.indexOf()</code> in Java. By default, HyperSQL
-    does not prevent you from using a reserved word if it does not support its
-    use or can distinguish it. For example, CUBE is a reserved word for a
-    feature that is supported by HyperSQL from version 2.5.1. Before this
-    version, CUBE was allowed as a table or column name, but it is no longer
-    allowed. You should avoid using such names as future versions of HyperSQL
-    are likely to support the reserved words and may reject your table
-    definitions or queries. The full list of SQL reserved words is in the
-    appendix <a class="link" href="#lists-app" title="Appendix&nbsp;A.&nbsp;Lists of Keywords">Lists of Keywords</a> . You can
-    set a property to disallow the use of reserved keywords for names of
+    <code class="methodname">String::indexOf(String)</code> in Java. By default,
+    HyperSQL does not prevent you from using a reserved word if it does not
+    support its use or can distinguish it. For example, CUBE is a reserved
+    word for a feature that is supported by HyperSQL from version 2.5.1.
+    Before this version, CUBE was allowed as a table or column name, but it is
+    no longer allowed. You should avoid using such names as future versions of
+    HyperSQL are likely to support the reserved words and may reject your
+    table definitions or queries. The full list of SQL reserved words is in
+    the appendix <a class="link" href="#lists-app" title="Appendix&nbsp;A.&nbsp;Lists of Keywords">Lists of Keywords</a> . You
+    can set a property to disallow the use of reserved keywords for names of
     tables and other database objects. There are several other user-defined
     properties to control the strict application of the SQL Standard in
     different areas.</p>
@@ -3133,7 +3148,7 @@
 <div>
 <div>
 <h3 class="title">
-<a name="N10485"></a>Case Sensitivity</h3>
+<a name="N1048B"></a>Case Sensitivity</h3>
 </div>
 </div>
 </div>
@@ -3154,7 +3169,7 @@
       double-quoted name is all-uppercase, it can be referenced in any case;
       <code class="literal">"MYTABLE"</code> is the same as <code class="literal">myTable</code>
       and <code class="literal">MyTable</code> because they are all converted to
-      <code class="literal">MYTABLE</code>. </p>
+      <code class="literal">MYTABLE</code>.</p>
 </div>
 <div class="section">
 <div class="titlepage">
@@ -3349,12 +3364,12 @@
 </li>
 </ul>
 </div>
-<p>HyperSQL 2.6 has several compatibility modes which allow the type
+<p>HyperSQL 2.7 has several compatibility modes which allow the type
     names that are used by other RDBMS to be accepted and translated into the
     closest SQL Standard type. For example, the type TEXT, supported by MySQL
     and PostgreSQL is translated in these compatibility modes.</p>
 <div class="table">
-<a name="N10531"></a>
+<a name="N10537"></a>
 <p class="title">
 <b>Table&nbsp;2.1.&nbsp;List of SQL types</b>
 </p>
@@ -3398,7 +3413,7 @@
 </tr>
 <tr>
 <td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">BINARY(L)</td><td style="border-bottom: 0.5pt solid ; ">fixed-length binary string type - padded with zero to
-            length L (**) </td>
+            length L (**)</td>
 </tr>
 <tr>
 <td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">VARBINARY(L) or BINARY VARYING(L)</td><td style="border-bottom: 0.5pt solid ; ">variable-length binary string type (***)</td>
@@ -3508,7 +3523,7 @@
 </div>
 </div>
 </div>
-<a name="N105D1" class="indexterm"></a>
+<a name="N105D7" class="indexterm"></a>
 <p>TINYINT, SMALLINT, INTEGER, BIGINT, NUMERIC and DECIMAL (without a
       decimal point) are the supported integral types. They correspond
       respectively to <code class="classname">byte</code>,
@@ -3674,7 +3689,7 @@
 </div>
 </div>
 </div>
-<a name="N1069D" class="indexterm"></a>
+<a name="N106A3" class="indexterm"></a>
 <p>The BOOLEAN type conforms to the SQL Standard and represents the
       values <code class="literal">TRUE</code>, <code class="literal">FALSE</code> and
       <code class="literal">UNKNOWN</code>. This type of column can be initialised with
@@ -3708,7 +3723,7 @@
 </div>
 </div>
 </div>
-<a name="N106C4" class="indexterm"></a>
+<a name="N106CA" class="indexterm"></a>
 <p>The CHARACTER, CHARACTER VARYING and CLOB types are the SQL
       Standard character string types. CHAR, VARCHAR and CHARACTER LARGE
       OBJECT are synonyms for these types. HyperSQL also supports LONGVARCHAR
@@ -3801,7 +3816,7 @@
 </div>
 </div>
 </div>
-<a name="N106FF" class="indexterm"></a>
+<a name="N10705" class="indexterm"></a>
 <p>The BINARY, BINARY VARYING and BLOB types are the SQL Standard
       binary string types. VARBINARY and BINARY LARGE OBJECT are synonyms for
       BINARY VARYING and BLOB types. HyperSQL also supports LONGVARBINARY as a
@@ -3874,7 +3889,7 @@
 </div>
 </div>
 </div>
-<a name="N1072C" class="indexterm"></a>
+<a name="N10732" class="indexterm"></a>
 <p>The BIT and BIT VARYING types are the supported bit string types.
       These types were defined by SQL:1999 but were later removed from the
       Standard. Bit types represent bit maps of given lengths. Each bit is 0
@@ -3979,7 +3994,7 @@
 </div>
 </div>
 </div>
-<a name="N107A6" class="indexterm"></a>
+<a name="N107AC" class="indexterm"></a>
 <p>From version 2.3.4 there are two options for storing Java
       Objects.</p>
 <p>The default option allows storing Serializable object. The objects
@@ -4109,7 +4124,7 @@ SELECT obj FROM movies WHERE director LI
 <p>HSQLDB fully supports datetime and interval types and operations,
     including all relevant optional features, as specified by the SQL Standard
     since SQL-92. The two groups of types are complementary.</p>
-<a name="N10803" class="indexterm"></a>
+<a name="N10809" class="indexterm"></a>
 <p>The DATE type represents a calendar date with YEAR, MONTH and DAY
     fields.</p>
 <p>The TIME type represents time of day with HOUR, MINUTE and SECOND
@@ -4160,7 +4175,7 @@ SELECT obj FROM movies WHERE director LI
  TIME '20:08:08.034900'
  TIME '20:08:08.034900-8:00' /* US Pacific */</pre>
 </div>
-<a name="N10829" class="indexterm"></a>
+<a name="N1082F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>Time Zone</strong></span>
 </p>
@@ -4181,28 +4196,39 @@ SELECT obj FROM movies WHERE director LI
 <p>The time zone displacement is of the type INTERVAL HOUR TO MINUTE.
     This data type is described in the next section. The legal values are
     between '&ndash;18:00' and &nbsp; '+18:00'.</p>
-<a name="N10838" class="indexterm"></a>
+<a name="N1083E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>Operations on Datetime
     Types</strong></span>
 </p>
-<p>The expression <code class="literal">&lt;datetime expression&gt; AT TIME ZONE
-    &lt;time displacement&gt;</code> evaluates to a datetime value
-    representing exactly the same point of time in the specified
-    <code class="literal">&lt;time displacement&gt;</code>. The expression, <code class="literal">AT
+<p>The expression <code class="literal">&lt;datetime expression&gt; AT TIME ZONE {
+    &lt;interval primary&gt; | &lt;time zone name&gt; }</code> evaluates to
+    a datetime value representing exactly the same point of time in the
+    specified <code class="literal">&lt;time displacement&gt;</code> or the geographical
+    <code class="literal">&lt;time zone name&gt;</code>. The expression, <code class="literal">AT
     LOCAL</code> is equivalent to <code class="literal">AT TIME ZONE &lt;local time
     displacement&gt;</code>. If <code class="literal">AT TIME ZONE</code> is used
     with a datetime operand of type WITHOUT TIME ZONE, the operand is first
-    converted to a value of type WITH TIME ZONE at the session&rsquo;s time
-    displacement, then the specified time zone displacement is set for the
-    value. Therefore, in these cases, the final value depends on the time zone
-    of the session in which the statement was used.</p>
+    converted to a value of type WITH TIME ZONE using the session's calendar,
+    then the specified time zone displacement is set for the value. Therefore,
+    in these cases, the final value depends on the time zone of the session in
+    which the statement was used, calculated at the exact point of time (of
+    the input) and accounting for daylight saving time at that point of
+    time.</p>
+<p>From version 2.7.0 it is possible to use regional time zones with AT
+    TIME ZONE. Any zone name used must match exactly a TimeZone id supported
+    by the JVM. These include names such as 'America/New_York'. Some zones
+    include daylight saving time periods which are used when converting the
+    time zone.</p>
+<p>See also the FROM_TZ function which allows you to convert to a time
+    zone without changing the date-time values such as hour and minute.</p>
 <p>AT TIME ZONE, modifies the field values of the datetime operand.
     This is done by the following procedure:</p>
 <div class="orderedlist">
 <ol class="orderedlist" type="1">
 <li class="listitem">
-<p>determine the corresponding datetime at UTC.</p>
+<p>determine the corresponding datetime at UTC using the session's
+        calendar.</p>
 </li>
 <li class="listitem">
 <p>find the datetime value at the given time zone that corresponds
@@ -4212,12 +4238,25 @@ SELECT obj FROM movies WHERE director LI
 </div>
 <p>Example a:</p>
 <div class="informalexample">
-<pre class="programlisting"> TIME '12:00:00' AT TIME ZONE INTERVAL '1:00' HOUR TO MINUTE
-</pre>
-</div>
-<p>If the session&rsquo;s time zone displacement is -'8:00', then in step 1,
-    TIME '12:00:00' is converted to UTC, which is TIME '20:00:00+0:00'. In
-    step 2, this value is expressed as TIME '21:00:00+1:00'.</p>
+<pre class="programlisting"> VALUES TIMESTAMP'2022-03-28 11:00:00' AT TIME ZONE INTERVAL '-5:00' HOUR TO MINUTE
+ C1                       
+ ------------------------ 
+ 2022-03-28 14:00:00-5:00 
+
+ VALUES TIMESTAMP'2022-03-28 11:00:00+4:00' AT TIME ZONE 'America/Chicago'
+ C1                       
+ ------------------------ 
+ 2022-03-28 02:00:00-5:00 
+</pre>
+</div>
+<p>In the first example above, the session's time zone displacement is
+    '-8:00'. In step 1, time '11:00:00' is converted to UTC, which is time
+    '19:00:00+0:00'. In step 2, this value is expressed as time
+    '14:00:00-5:00' in the target zone.</p>
+<p>In the second example, the session's time zone displacement is not
+    considered. In step 1, time is converted to UTC, which is time
+    '07:00:00+0:00', In step 2, this value is expressed as time
+    '02:00:00-5:00' in the target zone.</p>
 <p>Example b:</p>
 <div class="informalexample">
 <pre class="programlisting"> TIME '12:00:00-5:00' AT TIME ZONE INTERVAL '1:00' HOUR TO MINUTE
@@ -4333,10 +4372,15 @@ SELECT obj FROM movies WHERE director LI
 </p>
 <p>When an SQL session is started (with a JDBC connection) the local
     time zone of the client JVM (including any seasonal time adjustments such
-    as daylight-saving time) is used as the session time zone displacement.
-    Note that the SQL session time displacement is not changed when a seasonal
-    time adjustment takes place while the session is open. To change the SQL
-    session time zone displacement, use the following commands:</p>
+    as daylight-saving time) is used as the session time zone displacement. In
+    version 2.7.0 a Java Calendar object with the local time zone of the
+    client JVM is created and used. Therefore when a seasonal time adjustment
+    for daylight saving time is made while the session is open, the SQL
+    session zone displacement is changed. In some older versions of HyperSQL,
+    the SQL session time displacement was not changed when a seasonal time
+    adjustment took place.</p>
+<p>To change the SQL session time zone displacement, use the following
+    commands:</p>
 <p>
 <code class="literal">SET TIME ZONE &lt;time
     displacement&gt;</code>
@@ -4385,16 +4429,14 @@ SELECT obj FROM movies WHERE director LI
     <code class="methodname">getTimestamp(...)</code> methods of the ResultSet
     interface which have a Calendar parameter can be used with a Calendar
     argument to retrieve the values.</p>
-<p>JDBC 4 and JAVA6 has an unfortunate limitation and does not include
-    type codes for SQL datetime types that have a TIME ZONE property.
-    Therefore, for compatibility with database tools that are limited to the
-    JDBC type codes, HyperSQL reports these types by default as datetime types
-    without TIME ZONE.</p>
 <p>
 <span class="bold"><strong>Java 8 Extensions</strong></span>
 </p>
+<p>JDBC 4 and JAVA6 did not include type codes for SQL datetime types
+    that have a TIME ZONE property. Therefore, HyperSQL reported these types
+    by default as datetime types without TIME ZONE.</p>
 <p>JAVA 8 introduced new type codes for TIMESTAMP WITH TIME ZONE and
-    TIME WITH TIME ZONE. HSQLDB 2.4.0 and later when compiled with JDK8
+    TIME WITH TIME ZONE. HyperSQL (except the jars compiled with JDK 1.6)
     supports this in <code class="classname">ResultSet</code>,
     <code class="classname">PreparedStatement</code> and
     <code class="classname">CallableStatement</code>.</p>
@@ -4416,8 +4458,9 @@ SELECT obj FROM movies WHERE director LI
         <code class="classname">java.time</code> package types:
         <code class="classname">LocalDate</code>, <code class="classname">LocalTime</code>,
         <code class="classname">LocalDateTime</code>,
-        <code class="classname">OffsetTime</code> and
-        <code class="classname">OffsetDateTime</code> as well as
+        <code class="classname">OffsetTime</code>,
+        <code class="classname">OffsetDateTime</code>, and
+        <code class="classname">Instance</code> as well as
         <code class="classname">java.sql</code> package types,
         <code class="classname">Date</code>, <code class="classname">Time</code> and
         <code class="classname">Timestamp</code>.</p>
@@ -4438,7 +4481,7 @@ SELECT obj FROM movies WHERE director LI
 <span class="bold"><strong>Non-Standard
     Extensions</strong></span>
 </p>
-<p>HyperSQL version 2.5 supports some extensions to the SQL standard
+<p>HyperSQL version 2.7 supports some extensions to the SQL standard
     treatment of datetime and interval types. For example, the Standard
     expression to add a number of days to a date has an explicit INTERVAL
     value but HSQLDB also allows an integer to be used without specifying DAY.
@@ -4466,7 +4509,7 @@ SELECT obj FROM movies WHERE director LI
 </div>
 </div>
 </div>
-<a name="N10970" class="indexterm"></a>
+<a name="N10984" class="indexterm"></a>
 <p>Interval types are used to represent differences between date time
     values. The difference between two date time values can be measured in
     seconds or in months. For measurements in months, the units YEAR and MONTH
@@ -4687,8 +4730,8 @@ SELECT obj FROM movies WHERE director LI
 <p>
 <span class="bold"><strong>Java 8 Extensions</strong></span>
 </p>
-<p>JAVA 8 does not have SQL type codes for INTERVAL types. HSQLDB 2.4.0
-    and later, when compiled with JDK8 or later, supports
+<p>JAVA 8 does not have SQL type codes for INTERVAL types. HyperSQL
+    (except the jars compiled with JDK 1.6) supports
     <code class="classname">java.time</code> types for INTERVAL types in
     <code class="classname">ResultSet</code>, <code class="classname">PreparedStatement</code>
     and <code class="classname">CallableStatement</code>.</p>
@@ -4696,10 +4739,10 @@ SELECT obj FROM movies WHERE director LI
 <ul class="itemizedlist" style="list-style-type: disc; ">
 <li class="listitem">
 <p>The <code class="methodname">getObject(int columnIndex, Class
-        type)</code> method on an INTERVAL supports
+        type)</code> method on an INTERVAL supports the
         <code class="classname">java.time.Period</code> type for YEAR and MONTH
-        interval and <code class="classname">java.time.Duration</code> type for other
-        interval types that cover DAY to SECOND.</p>
+        interval and the <code class="classname">java.time.Duration</code> type for
+        other interval types that cover DAY to SECOND.</p>
 </li>
 <li class="listitem">
 <p>The <code class="methodname">setObject(int columnIndex)</code> method
@@ -5087,12 +5130,12 @@ ps.executeUpdate();
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6319 $</p>
+<p class="releaseinfo">$Revision: 6425 $</p>
 </div>
 <div>
 <div class="legalnotice">
-<a name="N10B34"></a>
-<p>Copyright 2009-2021 Fred Toussi. Permission is granted to
+<a name="N10B48"></a>
+<p>Copyright 2009-2022 Fred Toussi. Permission is granted to
       distribute this document without any alteration under the terms of the
       HSQLDB license. Additional permission is granted to the HSQL Development
       Group to distribute this document with or without alterations under the
@@ -5100,7 +5143,7 @@ ps.executeUpdate();
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -5326,9 +5369,9 @@ ps.executeUpdate();
 </div>
 <p>A new HyperSQL catalog contains an empty schema called PUBLIC. By
     default, this schema is the initial schema when a new session is started.
-    New schemas and schema objects can be defined and used in the PUBLIC
-    schema, as well as any new schema that is created by the user. You can
-    rename the PUBLIC schema.</p>
+    Additional schemas can be defined. Schema objects can be defined and used
+    in the PUBLIC schema, as well as any new schema that is created by the
+    user. You can rename the PUBLIC schema.</p>
 <p>HyperSQL allows all schemas to be dropped, except the schema that is
     the default initial schema for new sessions (by default, the PUBLIC
     schema). For this schema, a DROP SCHEMA ... CASCADE statement will succeed
@@ -5574,7 +5617,7 @@ ps.executeUpdate();
       &lt;name&gt;</code> expression. This expression can be used for
       inserting and updating table rows.</p>
 <div class="example">
-<a name="N10C0E"></a>
+<a name="N10C22"></a>
 <p class="title">
 <b>Example&nbsp;3.1.&nbsp;inserting the next sequence value into a table row</b>
 </p>
@@ -5587,7 +5630,7 @@ ps.executeUpdate();
       to number the returned rows of a SELECT in sequential order, you can
       use:</p>
 <div class="example">
-<a name="N10C15"></a>
+<a name="N10C29"></a>
 <p class="title">
 <b>Example&nbsp;3.2.&nbsp;numbering returned rows of a SELECT in sequential order</b>
 </p>
@@ -5613,7 +5656,7 @@ ps.executeUpdate();
       returned by the sequence, the same value 15 is inserted in the three
       rows.</p>
 <div class="example">
-<a name="N10C21"></a>
+<a name="N10C35"></a>
 <p class="title">
 <b>Example&nbsp;3.3.&nbsp;using the last value of a sequence</b>
 </p>
@@ -5867,7 +5910,7 @@ ps.executeUpdate();
       values in different rows. The following example satisfies a UNIQUE
       constraint on the two columns</p>
 <div class="example">
-<a name="N10CC6"></a>
+<a name="N10CDA"></a>
 <p class="title">
 <b>Example&nbsp;3.4.&nbsp;Column values which satisfy a 2-column UNIQUE
         constraint</b>
@@ -6049,7 +6092,7 @@ ps.executeUpdate();
 <p>These elements and statements are used for different types of
       object. They are described here, before the statements that can use
       them.</p>
-<a name="N10D4F" class="indexterm"></a>
+<a name="N10D63" class="indexterm"></a>
 <p>
 <span class="bold"><strong>identifier</strong></span>
 </p>
@@ -6127,7 +6170,7 @@ ps.executeUpdate();
 </li>
 </ul>
 </div>
-<a name="N10D98" class="indexterm"></a>
+<a name="N10DAC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CASCADE or RESTRICT</strong></span>
 </p>
@@ -6148,7 +6191,7 @@ ps.executeUpdate();
       referencing objects are modified or dropped with cascading effect.
       Whether a referencing object is modified or dropped, depends on the kind
       of schema object that is dropped.</p>
-<a name="N10DB2" class="indexterm"></a>
+<a name="N10DC6" class="indexterm"></a>
 <p>
 <span class="bold"><strong>IF EXISTS</strong></span>
 </p>
@@ -6164,7 +6207,7 @@ ps.executeUpdate();
       sequences, and indexes). If it is specified, then the statement does not
       return an error if the drop statement is issued on a non-existent
       object.</p>
-<a name="N10DC3" class="indexterm"></a>
+<a name="N10DD7" class="indexterm"></a>
 <p>
 <span class="bold"><strong>IF NOT EXISTS</strong></span>
 </p>
@@ -6181,7 +6224,7 @@ ps.executeUpdate();
       COLUMN statements. If it is specified, then the statement does not
       return an error if the CREATE or ALTER statement is for an object name
       that already exists.</p>
-<a name="N10DD4" class="indexterm"></a>
+<a name="N10DE8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SPECIFIC</strong></span>
 </p>
@@ -6212,7 +6255,7 @@ ps.executeUpdate();
 </div>
 </div>
 </div>
-<a name="N10DFB" class="indexterm"></a>
+<a name="N10E0F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>RENAME</strong></span>
 </p>
@@ -6248,7 +6291,7 @@ ps.executeUpdate();
 </div>
 </div>
 </div>
-<a name="N10E1C" class="indexterm"></a>
+<a name="N10E30" class="indexterm"></a>
 <p>
 <span class="bold"><strong>COMMENT</strong></span>
 </p>
@@ -6287,7 +6330,7 @@ ps.executeUpdate();
 </div>
 </div>
 </div>
-<a name="N10E42" class="indexterm"></a>
+<a name="N10E56" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE SCHEMA</strong></span>
 </p>
@@ -6349,7 +6392,7 @@ ps.executeUpdate();
 <p>It is not really necessary to create a schema and all its objects
       as one command. The schema can be created first, and its objects can be
       created one by one.</p>
-<a name="N10E7D" class="indexterm"></a>
+<a name="N10E91" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP SCHEMA</strong></span>
 </p>
@@ -6377,7 +6420,7 @@ ps.executeUpdate();
 </div>
 </div>
 </div>
-<a name="N10E9E" class="indexterm"></a>
+<a name="N10EB2" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE TABLE</strong></span>
 </p>
@@ -6412,7 +6455,7 @@ ps.executeUpdate();
       &lt;table period definition&gt; | &lt;table constraint definition&gt; |
       &lt;like clause&gt; </code>
 </p>
-<a name="N10EBC" class="indexterm"></a>
+<a name="N10ED0" class="indexterm"></a>
 <p>
 <span class="emphasis"><em>like clause</em></span>
 </p>
@@ -6458,7 +6501,7 @@ ps.executeUpdate();
 <code class="literal">&lt;generation option&gt; ::= INCLUDING GENERATED |
       EXCLUDING GENERATED</code>
 </p>
-<a name="N10EF0" class="indexterm"></a>
+<a name="N10F04" class="indexterm"></a>
 <p>
 <span class="emphasis"><em>as subquery clause</em></span>
 </p>
@@ -6478,7 +6521,7 @@ ps.executeUpdate();
 <pre class="programlisting"> CREATE TABLE t (a, b, c) AS (SELECT * FROM atable) WITH DATA
 </pre>
 </div>
-<a name="N10F0C" class="indexterm"></a>
+<a name="N10F20" class="indexterm"></a>
 <p>
 <span class="emphasis"><em>column definition</em></span>
 </p>
@@ -6519,7 +6562,7 @@ ps.executeUpdate();
       then a UNIQUE or PRIMARY KEY constraint or an INDEX on the column will
       use the specified collation. Otherwise the default collation for the
       database is used.</p>
-<a name="N10F3E" class="indexterm"></a>
+<a name="N10F52" class="indexterm"></a>
 <p>
 <span class="bold"><strong>GENERATED</strong></span>
 </p>
@@ -6627,7 +6670,7 @@ ps.executeUpdate();
  INSERT INTO t (id, firstname, lastname, fullname) VALUES (2, 'Pink', 'Panther', DEFAULT)
 </pre>
 </div>
-<a name="N10F95" class="indexterm"></a>
+<a name="N10FA9" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DEFAULT</strong></span>
 </p>
@@ -6653,7 +6696,7 @@ ps.executeUpdate();
 <p>In PGS (PostgreSQL) compatibility mode, a NEXTVAL function can be
       used. Also, in MSS compatibility mode, the default value can be enclosed
       in parentheses.</p>
-<a name="N10FB3" class="indexterm"></a>
+<a name="N10FC7" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ON UPDATE</strong></span>
 </p>
@@ -6674,7 +6717,7 @@ ps.executeUpdate();
       ZONE.</p>
 <p>This feature is not part of the SQL Standard and is similar to
       MySQL's ON UPDATE clause.</p>
-<a name="N10FCB" class="indexterm"></a>
+<a name="N10FDF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CONSTRAINT</strong></span>
 </p>
@@ -6706,7 +6749,7 @@ ps.executeUpdate();
       This feature of the SQL Standard has been criticised because it allows a
       session to read uncommitted data that violates database integrity
       constraints but has not yet been checked.</p>
-<a name="N10FEB" class="indexterm"></a>
+<a name="N10FFF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CONSTRAINT</strong></span>
 </p>
@@ -6727,7 +6770,7 @@ ps.executeUpdate();
       (including PRIMARY KEY), FOREIGN KEY and CHECK. Each kind has its own
       rules to limit the values that can be specified for different columns in
       each row of the table.</p>
-<a name="N10FFF" class="indexterm"></a><a name="N11004" class="indexterm"></a>
+<a name="N11013" class="indexterm"></a><a name="N11018" class="indexterm"></a>
 <p>
 <span class="bold"><strong>UNIQUE</strong></span>
 </p>
@@ -6753,7 +6796,7 @@ ps.executeUpdate();
       an implicit NOT NULL constraint.</p>
 <p>If <code class="literal">UNIQUE( VALUE )</code> is specified, the
       constraint created on all columns of the table.</p>
-<a name="N11020" class="indexterm"></a>
+<a name="N11034" class="indexterm"></a>
 <p>
 <span class="bold"><strong>FOREIGN KEY</strong></span>
 </p>
@@ -6841,7 +6884,7 @@ ps.executeUpdate();
       referencing rows to be set to NULL. Similarly, the SET DEFAULT option
       results in the columns of the referencing rows to be set to their
       default values.</p>
-<a name="N1106B" class="indexterm"></a>
+<a name="N1107F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CHECK</strong></span>
 </p>
@@ -6884,7 +6927,7 @@ ps.executeUpdate();
       inserted into the database belongs to the future (at the time of
       insertion), or any similar constraint, then use a TRIGGER with the
       desired condition.</p>
-<a name="N11094" class="indexterm"></a>
+<a name="N110A8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP TABLE</strong></span>
 </p>
@@ -6914,7 +6957,7 @@ ps.executeUpdate();
 </div>
 </div>
 </div>
-<a name="N110AF" class="indexterm"></a>
+<a name="N110C3" class="indexterm"></a>
 <p>System-versioned tables are tables that contain a SYSTEM_TIME
       period consisting of pair of columns defined as auto-generated TIMESTAMP
       WITH TIME ZONE, together with the SYSTEM VERSIONING clause.</p>
@@ -6984,7 +7027,7 @@ ps.executeUpdate();
 <p>Table settings statements change the attributes of tables. These
       attributes are specific to HyperSQL and are not part of the SQL
       Standard.</p>
-<a name="N110E5" class="indexterm"></a>
+<a name="N110F9" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET TABLE CLUSTERED</strong></span>
 </p>
@@ -7015,7 +7058,7 @@ ps.executeUpdate();
       all future reordering of rows. Note that if extensive inserts or updates
       are performed on the tables, the rows will get out of order until the
       next reordering.</p>
-<a name="N110FA" class="indexterm"></a>
+<a name="N1110E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET TABLE TYPE</strong></span>
 </p>
@@ -7030,7 +7073,7 @@ ps.executeUpdate();
       and MEMORY types.</p>
 <p>Only a user with the DBA role can execute this
       statement.</p>
-<a name="N1110D" class="indexterm"></a>
+<a name="N11121" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET TABLE
       writability</strong></span>
@@ -7046,7 +7089,7 @@ ps.executeUpdate();
       default. This statement can be used to change the property between
       <code class="literal">READ ONLY</code> and <code class="literal">READ WRITE</code>. This is
       a feature of HyperSQL.</p>
-<a name="N11124" class="indexterm"></a>
+<a name="N11138" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET TABLE SOURCE</strong></span>
 </p>
@@ -7280,7 +7323,7 @@ ps.executeUpdate();
 </div>
 <p>Only a user with the DBA role can execute this
       statement.</p>
-<a name="N111B7" class="indexterm"></a>
+<a name="N111CB" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET TABLE SOURCE
       HEADER</strong></span>
@@ -7299,7 +7342,7 @@ ps.executeUpdate();
       the first line of the source file of the text table. This line is not
       part of the table data. Only a user with the DBA role can execute this
       statement.</p>
-<a name="N111CB" class="indexterm"></a>
+<a name="N111DF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET TABLE SOURCE
       on-off</strong></span>
@@ -7333,7 +7376,7 @@ ps.executeUpdate();
 <p>Table manipulation statements modify the objects such as columns
       and constraints. Some of these statements are defined by the SQL
       Standard. Others are HyperSQL extensions.</p>
-<a name="N111E2" class="indexterm"></a>
+<a name="N111F6" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ALTER TABLE</strong></span>
 </p>
@@ -7354,7 +7397,7 @@ ps.executeUpdate();
 </p>
 <p>Change the definition of a table. Specific types of this
       statement are covered below.</p>
-<a name="N111F6" class="indexterm"></a>
+<a name="N1120A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ADD COLUMN</strong></span>
 </p>
@@ -7376,7 +7419,7 @@ ps.executeUpdate();
       GENERATED. The column values for each row is then filled with the result
       of the <code class="literal">&lt;default clause&gt;</code> or the generated
       value.</p>
-<a name="N11218" class="indexterm"></a>
+<a name="N1122C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP COLUMN</strong></span>
 </p>
@@ -7396,7 +7439,7 @@ ps.executeUpdate();
       specified. If <code class="literal">CASCADE</code> is specified, then any
       CONSTRAINT, VIEW or TRIGGER object that references the column is dropped
       with a cascading effect.</p>
-<a name="N11238" class="indexterm"></a>
+<a name="N1124C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ADD CONSTRAINT</strong></span>
 </p>
@@ -7410,7 +7453,7 @@ ps.executeUpdate();
 <p>Add a constraint to a table. The existing rows of the table
       must conform to the added constraint, otherwise the statement will not
       succeed.</p>
-<a name="N11249" class="indexterm"></a>
+<a name="N1125D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP CONSTRAINT</strong></span>
 </p>
@@ -7432,7 +7475,7 @@ ps.executeUpdate();
       relationship exists between these columns and the other columns in that
       query expression, then the VIEW or other schema object will be dropped
       when <code class="literal">CASCADE</code> is specified.</p>
-<a name="N11263" class="indexterm"></a>
+<a name="N11277" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ADD SYSTEM PERIOD</strong></span>
 </p>
@@ -7456,7 +7499,7 @@ ps.executeUpdate();
 <pre class="programlisting"> ALTER TABLE t ADD PERIOD FOR SYSTEM_TIME(rs, re) ADD COLUMN rs TIMESTAMP GENERATED ALWAYS AS ROW START ADD COLUMN re TIMESTAMP GENERATED ALWAYS AS ROW END
 </pre>
 </div>
-<a name="N11277" class="indexterm"></a>
+<a name="N1128B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP SYSTEM PERIOD</strong></span>
 </p>
@@ -7476,7 +7519,7 @@ ps.executeUpdate();
       is specified, then any such VIEW or other database object that
       references the period or its columns is dropped with a cascading
       effect</p>
-<a name="N11297" class="indexterm"></a>
+<a name="N112AB" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ADD SYSTEM
       VERSIONING</strong></span>
@@ -7494,7 +7537,7 @@ ps.executeUpdate();
 <pre class="programlisting"> ALTER TABLE t ADD SYSTEM VERSIONING
 </pre>
 </div>
-<a name="N112AB" class="indexterm"></a>
+<a name="N112BF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP SYSTEM
       VERSIONING</strong></span>
@@ -7518,7 +7561,7 @@ ps.executeUpdate();
       of this statement, all the history rows in the table are deleted and
       only the current versions of rows survive. The period for SYSTEM_TIME,
       and its columns, survive after dropping versioning.</p>
-<a name="N112CB" class="indexterm"></a>
+<a name="N112DF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ALTER COLUMN</strong></span>
 </p>
@@ -7540,7 +7583,7 @@ ps.executeUpdate();
 <p>Change a column and its definition. Specific types of this
       statement are covered below. See also the RENAME statement
       above.</p>
-<a name="N112DF" class="indexterm"></a>
+<a name="N112F3" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DEFAULT</strong></span>
 </p>
@@ -7553,7 +7596,7 @@ ps.executeUpdate();
 </p>
 <p>Set the default clause for a column. This can be used if the
       column is not defined as GENERATED.</p>
-<a name="N112F0" class="indexterm"></a>
+<a name="N11304" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP DEFAULT</strong></span>
 </p>
@@ -7565,7 +7608,7 @@ ps.executeUpdate();
       DEFAULT</code>
 </p>
 <p>Drop the default clause from a column.</p>
-<a name="N11301" class="indexterm"></a>
+<a name="N11315" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATA TYPE</strong></span>
 </p>
@@ -7582,7 +7625,7 @@ ps.executeUpdate();
       enlarge. HyperSQL allows changing the type if all the existing values
       can be cast into the new type without string truncation or loss of
       significant digits.</p>
-<a name="N11312" class="indexterm"></a>
+<a name="N11326" class="indexterm"></a>
 <p>
 <span class="bold"><strong>alter column add identity generator or
       sequence</strong></span>
@@ -7606,7 +7649,7 @@ ps.executeUpdate();
 <pre class="programlisting"> ALTER TABLE mytable ALTER COLUMN id GENERATED ALWAYS AS IDENTITY (START WITH 20000)</pre>
 <pre class="programlisting"> ALTER TABLE mytable ALTER COLUMN id GENERATED BY DEFAULT AS SEQUENCE seq</pre>
 </div>
-<a name="N1132B" class="indexterm"></a>
+<a name="N1133F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>alter column identity
       generator</strong></span>
@@ -7632,7 +7675,7 @@ ps.executeUpdate();
  ALTER TABLE mytable ALTER COLUMN id SET INCREMENT BY 5
 </pre>
 </div>
-<a name="N11342" class="indexterm"></a>
+<a name="N11356" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP GENERATED</strong></span>
 </p>
@@ -7650,7 +7693,7 @@ ps.executeUpdate();
 <pre class="programlisting">  ALTER TABLE mytable ALTER COLUMN id DROP GENERATED
 </pre>
 </div>
-<a name="N11356" class="indexterm"></a>
+<a name="N1136A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET [ NOT ] NULL</strong></span>
 </p>
@@ -7673,7 +7716,7 @@ ps.executeUpdate();
 </div>
 </div>
 </div>
-<a name="N1136B" class="indexterm"></a>
+<a name="N1137F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE VIEW</strong></span>
 </p>
@@ -7713,7 +7756,7 @@ ps.executeUpdate();
       <code class="literal">&lt;query expression&gt;</code> of the view references
       another view, then the search condition of the underlying view should
       also be satisfied by the update or insert operation.</p>
-<a name="N1139F" class="indexterm"></a>
+<a name="N113B3" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP VIEW</strong></span>
 </p>
@@ -7727,7 +7770,7 @@ ps.executeUpdate();
 </p>
 <p>Destroy a view. The <code class="literal">&lt;drop behavior&gt;</code> is
       similar to dropping a table.</p>
-<a name="N113B3" class="indexterm"></a>
+<a name="N113C7" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ALTER VIEW</strong></span>
 </p>
@@ -7754,7 +7797,7 @@ ps.executeUpdate();
 </div>
 </div>
 </div>
-<a name="N113C8" class="indexterm"></a>
+<a name="N113DC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE DOMAIN</strong></span>
 </p>
@@ -7790,7 +7833,7 @@ ps.executeUpdate();
 <pre class="programlisting"> CREATE DOMAIN valid_string AS VARCHAR(20) DEFAULT 'NO VALUE' CHECK (VALUE IS NOT NULL AND CHARACTER_LENGTH(VALUE) &gt; 2) 
 </pre>
 </div>
-<a name="N113EA" class="indexterm"></a>
+<a name="N113FE" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ALTER DOMAIN</strong></span>
 </p>
@@ -7808,7 +7851,7 @@ ps.executeUpdate();
       definition&gt;</code>
 </p>
 <p>Change a domain and its definition.</p>
-<a name="N113FE" class="indexterm"></a>
+<a name="N11412" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DEFAULT</strong></span>
 </p>
@@ -7821,7 +7864,7 @@ ps.executeUpdate();
 </p>
 <p>Set the default value in a domain. This is allowed if the
       domain is already used in a table definition.</p>
-<a name="N1140F" class="indexterm"></a>
+<a name="N11423" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP DEFAULT</strong></span>
 </p>
@@ -7837,7 +7880,7 @@ ps.executeUpdate();
       domain as its type, the domain default is removed. If there is no
       existing column default clause, the default clause of the domain becomes
       the column default clause.</p>
-<a name="N11420" class="indexterm"></a>
+<a name="N11434" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ADD CONSTRAINT</strong></span>
 </p>
@@ -7851,7 +7894,7 @@ ps.executeUpdate();
 <p>Add a constraint to a domain. This is allowed if the domain is
       already used in a table definition and the table data satisfies the
       constraint.</p>
-<a name="N11431" class="indexterm"></a>
+<a name="N11445" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP CONSTRAINT</strong></span>
 </p>
@@ -7866,7 +7909,7 @@ ps.executeUpdate();
 <p>Remove a constraint on a domain. This is allowed if the domain is
       already used in a table definition. The constraint no longer applies to
       a column that uses the domain as its type.</p>
-<a name="N11442" class="indexterm"></a>
+<a name="N11456" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP DOMAIN</strong></span>
 </p>
@@ -7895,7 +7938,7 @@ ps.executeUpdate();
 </div>
 </div>
 </div>
-<a name="N11460" class="indexterm"></a>
+<a name="N11474" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE TRIGGER</strong></span>
 </p>
@@ -8003,7 +8046,7 @@ ps.executeUpdate();
       interface.</p>
 <p>HyperSQL does not yet allow the use of OLD TABLE or NEW TABLE in
       statement level trigger definitions.</p>
-<a name="N114C8" class="indexterm"></a>
+<a name="N114DC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP TRIGGER</strong></span>
 </p>
@@ -8025,7 +8068,7 @@ ps.executeUpdate();
 </div>
 </div>
 </div>
-<a name="N114DD" class="indexterm"></a>
+<a name="N114F1" class="indexterm"></a>
 <p>
 <span class="bold"><strong>schema routine</strong></span>
 </p>
@@ -8197,7 +8240,7 @@ ps.executeUpdate();
 <p>Define an SQL-invoked routine. A few of the options are not used
       by HyperSQL and have default behaviours. See the <a class="link" href="#sqlroutines-chapt" title="Chapter&nbsp;9.&nbsp;SQL-Invoked Routines">SQL-Invoked Routines</a>
       chapter for more details of various options and examples.</p>
-<a name="N1155C" class="indexterm"></a>
+<a name="N11570" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ALTER routine</strong></span>
 </p>
@@ -8250,7 +8293,7 @@ ps.executeUpdate();
   END
 </pre>
 </div>
-<a name="N11580" class="indexterm"></a>
+<a name="N11594" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP</strong></span>
 </p>
@@ -8272,7 +8315,7 @@ ps.executeUpdate();
 </div>
 </div>
 </div>
-<a name="N11595" class="indexterm"></a>
+<a name="N115A9" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE SEQUENCE</strong></span>
 </p>
@@ -8367,7 +8410,7 @@ ps.executeUpdate();
 <p>The integer types: SMALLINT, INTEGER, BIGINT, DECIMAL and NUMERIC
       can be used as the type of the sequence. DECIMAL and NUMERIC types must
       have a scale of 0 and a precision not exceeding 18.</p>
-<a name="N115E4" class="indexterm"></a>
+<a name="N115F8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ALTER SEQUENCE</strong></span>
 </p>
@@ -8405,7 +8448,7 @@ ps.executeUpdate();
 <p>If RESTART is used by itself (without a value), then the current
       value of the sequence is reset to the start value. Otherwise, the
       current value is reset to the given restart value.</p>
-<a name="N11606" class="indexterm"></a>
+<a name="N1161A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP SEQUENCE</strong></span>
 </p>
@@ -8432,7 +8475,7 @@ ps.executeUpdate();
 </div>
 </div>
 </div>
-<a name="N11622" class="indexterm"></a>
+<a name="N11636" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SQL procedure
       statement</strong></span>
@@ -8496,7 +8539,7 @@ ps.executeUpdate();
 </div>
 </div>
 </div>
-<a name="N11646" class="indexterm"></a>
+<a name="N1165A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE SYNONYM</strong></span>
 </p>
@@ -8512,7 +8555,7 @@ ps.executeUpdate();
       the name is qualified with a different schema name. The target object
       name can be a schema object in the current schema or in another schema.
       The synonym can be used only without the schema name.</p>
-<a name="N1165A" class="indexterm"></a>
+<a name="N1166E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP SYNONYM</strong></span>
 </p>
@@ -8526,7 +8569,7 @@ ps.executeUpdate();
 <p>Drops the synonym. The <code class="literal">&lt;synonym name&gt;</code> can
       be the simple name of the synonym or qualified with the schema
       name.</p>
-<a name="N1166E" class="indexterm"></a>
+<a name="N11682" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE INDEX</strong></span>
 </p>
@@ -8547,7 +8590,7 @@ ps.executeUpdate();
       not duplicate the columns of PRIMARY KEY, UNIQUE or FOREIGN key
       constraints as each of these constraints creates an index
       automatically.</p>
-<a name="N1167F" class="indexterm"></a>
+<a name="N11693" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP INDEX</strong></span>
 </p>
@@ -8559,7 +8602,7 @@ ps.executeUpdate();
       EXISTS ] &lt;index name&gt; [ IF EXISTS ]</code>
 </p>
 <p>Destroy an index.</p>
-<a name="N11690" class="indexterm"></a>
+<a name="N116A4" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ALTER INDEX</strong></span>
 </p>
@@ -8574,7 +8617,7 @@ ps.executeUpdate();
 <p>Redefine an index with a new column list. This statement is
       more efficient than dropping an existing index and creating a new
       one.</p>
-<a name="N116A1" class="indexterm"></a>
+<a name="N116B5" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ALTER CONSTRAINT</strong></span>
 </p>
@@ -8592,7 +8635,7 @@ ps.executeUpdate();
       does not change. If the statement is used again, the previous extra
       columns of the index are replaced with the new extra columns. The
       FOREIGN KEY must have a user-defined name.</p>
-<a name="N116B2" class="indexterm"></a>
+<a name="N116C6" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE TYPE</strong></span>
 </p>
@@ -8614,7 +8657,7 @@ ps.executeUpdate();
 </p>
 <p>Define a user-defined type. Currently only simple distinct
       types can be defined without further attributes.</p>
-<a name="N116C9" class="indexterm"></a>
+<a name="N116DD" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE CAST</strong></span>
 </p>
@@ -8641,7 +8684,7 @@ ps.executeUpdate();
 </p>
 <p>Define a user-defined cast. This feature may be supported in a
       future version of HyperSQL.</p>
-<a name="N116E3" class="indexterm"></a>
+<a name="N116F7" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP CAST</strong></span>
 </p>
@@ -8655,7 +8698,7 @@ ps.executeUpdate();
 </p>
 <p>Destroy a user-defined cast. This feature may be supported in a
       future version of HyperSQL.</p>
-<a name="N116F4" class="indexterm"></a>
+<a name="N11708" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE CHARACTER SET</strong></span>
 </p>
@@ -8678,7 +8721,7 @@ ps.executeUpdate();
       CHARACTER SET. Currently this statement has no effect, as the character
       set used by HyperSQL is Unicode and there is no need for subset
       character sets.</p>
-<a name="N1170B" class="indexterm"></a>
+<a name="N1171F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP CHARACTER SET</strong></span>
 </p>
@@ -8693,7 +8736,7 @@ ps.executeUpdate();
       referenced in any database object, the command fails. Note that
       <code class="literal">CASCADE</code> or <code class="literal">RESTRICT</code> cannot be
       specified for this command.</p>
-<a name="N11722" class="indexterm"></a>
+<a name="N11736" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE COLLATION</strong></span>
 </p>
@@ -8727,7 +8770,7 @@ ps.executeUpdate();
       FROM "French" NO PAD</code>, results in a French collation without
       padding. This collation can be used for sorting or for individual
       columns of tables.</p>
-<a name="N11747" class="indexterm"></a>
+<a name="N1175B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP COLLATION</strong></span>
 </p>
@@ -8742,7 +8785,7 @@ ps.executeUpdate();
       behavior&gt;</code> is <code class="literal">CASCADE</code>, then all
       references to the collation revert to the default collation that would
       be in force if the dropped collation was not specified.</p>
-<a name="N1175E" class="indexterm"></a>
+<a name="N11772" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE TRANSLATION</strong></span>
 </p>
@@ -8778,7 +8821,7 @@ ps.executeUpdate();
 </p>
 <p>Define a character transliteration. This feature may be supported
       in a future version of HyperSQL.</p>
-<a name="N1177E" class="indexterm"></a>
+<a name="N11792" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP TRANSLATION</strong></span>
 </p>
@@ -8791,7 +8834,7 @@ ps.executeUpdate();
 </p>
 <p>Destroy a character transliteration. This feature may be
       supported in a future version of HyperSQL.</p>
-<a name="N1178F" class="indexterm"></a>
+<a name="N117A3" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE ASSERTION</strong></span>
 </p>
@@ -8806,7 +8849,7 @@ ps.executeUpdate();
 </p>
 <p>Specify an integrity constraint. This feature may be supported
       in a future version of HyperSQL.</p>
-<a name="N117A0" class="indexterm"></a>
+<a name="N117B4" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP ASSERTION</strong></span>
 </p>
@@ -8864,7 +8907,7 @@ ps.executeUpdate();
       objects that use (reference) a particular database object.
       Alternatively, the statement lists all the database object that are used
       (referenced) by a particular database object.</p>
-<a name="N117C5" class="indexterm"></a>
+<a name="N117D9" class="indexterm"></a>
 <p>
 <span class="bold"><strong>EXPLAIN REFERENCES</strong></span>
 </p>
@@ -9032,252 +9075,252 @@ ps.executeUpdate();
 <p>The following views are defined by the SQL Standard and supported
       by HyperSQL. The columns and contents exactly match the Standard
       requirements.</p>
-<a name="N11823" class="indexterm"></a>
+<a name="N11837" class="indexterm"></a>
 <p>ADMINISTRABLE_ROLE_AUTHORIZATIONS</p>
 <p>Information on ROLE authorizations, all granted by the admin
       role.</p>
-<a name="N1182C" class="indexterm"></a>
+<a name="N11840" class="indexterm"></a>
 <p>APPLICABLE_ROLES</p>
 <p>Information on ROLE authorizations for the current user</p>
-<a name="N11835" class="indexterm"></a>
+<a name="N11849" class="indexterm"></a>
 <p>ASSERTIONS</p>
 <p>Empty view as ASSERTION objects are not yet supported.</p>
-<a name="N1183E" class="indexterm"></a>
+<a name="N11852" class="indexterm"></a>
 <p>AUTHORIZATIONS</p>
 <p>Top level information on USER and ROLE objects in the
       database</p>
-<a name="N11847" class="indexterm"></a>
+<a name="N1185B" class="indexterm"></a>
 <p>CHARACTER_SETS</p>
 <p>List of supported CHARACTER SET objects</p>
-<a name="N11850" class="indexterm"></a>
+<a name="N11864" class="indexterm"></a>
 <p>CHECK_CONSTRAINTS</p>
 <p>Additional information specific to each CHECK constraint,
       including the search condition</p>
-<a name="N11859" class="indexterm"></a>
+<a name="N1186D" class="indexterm"></a>
 <p>CHECK_CONSTRAINT_ROUTINE_USAGE</p>
 <p>Information on FUNCTION objects referenced in CHECK constraints
       search conditions</p>
-<a name="N11862" class="indexterm"></a>
+<a name="N11876" class="indexterm"></a>
 <p>COLLATIONS</p>
 <p>Information on collations supported by the database.</p>
-<a name="N1186B" class="indexterm"></a>
+<a name="N1187F" class="indexterm"></a>
 <p>COLUMNS</p>
 <p>Information on COLUMN objects in TABLE and VIEW definitions</p>
-<a name="N11874" class="indexterm"></a>
+<a name="N11888" class="indexterm"></a>
 <p>COLUMN_COLUMN_USAGE</p>
 <p>Information on references to COLUMN objects from other, GENERATED,
       COLUMN objects</p>
-<a name="N1187D" class="indexterm"></a>
+<a name="N11891" class="indexterm"></a>
 <p>COLUMN_DOMAIN_USAGE</p>
 <p>Information on DOMAIN objects used in type definition of COLUMN
       objects</p>
-<a name="N11886" class="indexterm"></a>
+<a name="N1189A" class="indexterm"></a>
 <p>COLUMN_PRIVILEGES</p>
 <p>Information on privileges on each COLUMN object, granted to
       different ROLE and USER authorizations</p>
-<a name="N1188F" class="indexterm"></a>
+<a name="N118A3" class="indexterm"></a>
 <p>COLUMN_UDT_USAGE</p>
 <p>Information on distinct TYPE objects used in type definition of
       COLUMN objects</p>
-<a name="N11898" class="indexterm"></a>
+<a name="N118AC" class="indexterm"></a>
 <p>CONSTRAINT_COLUMN_USAGE</p>
 <p>Information on COLUMN objects referenced by CONSTRAINT objects in
       the database</p>
-<a name="N118A1" class="indexterm"></a>
+<a name="N118B5" class="indexterm"></a>
 <p>CONSTRAINT_PERIOD_USAGE</p>
 <p>Information on application PERIOD objects referenced by CONSTRAINT
       objects in the database</p>
-<a name="N118AA" class="indexterm"></a>
+<a name="N118BE" class="indexterm"></a>
 <p>CONSTRAINT_TABLE_USAGE</p>
 <p>Information on TABLE and VIEW objects referenced by CONSTRAINT
       objects in the database</p>
-<a name="N118B3" class="indexterm"></a>
+<a name="N118C7" class="indexterm"></a>
 <p>DATA_TYPE_PRIVILEGES</p>
 <p>Information on top level schema objects of various kinds that
       reference TYPE objects</p>
-<a name="N118BC" class="indexterm"></a>
+<a name="N118D0" class="indexterm"></a>
 <p>DOMAINS</p>
 <p>Top level information on DOMAIN objects in the database.</p>
-<a name="N118C5" class="indexterm"></a>
+<a name="N118D9" class="indexterm"></a>
 <p>DOMAIN_CONSTRAINTS</p>
 <p>Information on CONSTRAINT definitions used for DOMAIN
       objects</p>
-<a name="N118CE" class="indexterm"></a>
+<a name="N118E2" class="indexterm"></a>
 <p>ELEMENT_TYPES</p>
 <p>Information on the type of elements of ARRAY used in database
       columns or routine parameters and return values</p>
-<a name="N118D7" class="indexterm"></a>
+<a name="N118EB" class="indexterm"></a>
 <p>ENABLED_ROLES</p>
 <p>Information on ROLE privileges enabled for the current
       session</p>
-<a name="N118E0" class="indexterm"></a>
+<a name="N118F4" class="indexterm"></a>
 <p>INFORMATION_SCHEMA_CATALOG_NAME</p>
 <p>Information on the single CATALOG object of the database</p>
-<a name="N118E9" class="indexterm"></a>
+<a name="N118FD" class="indexterm"></a>
 <p>KEY_COLUMN_USAGE</p>
 <p>Information on COLUMN objects of tables that are used by PRIMARY
       KEY, UNIQUE and FOREIGN KEY constraints</p>
-<a name="N118F2" class="indexterm"></a>
+<a name="N11906" class="indexterm"></a>
 <p>KEY_PERIOD_USAGE</p>
 <p>Information on application PERIOD objects that are used by PRIMARY
       KEY, UNIQUE and FOREIGN KEY constraints</p>
-<a name="N118FB" class="indexterm"></a>
+<a name="N1190F" class="indexterm"></a>
 <p>PARAMETERS</p>
 <p>Information on parameters of each FUNCTION or PROCEDURE</p>
-<a name="N11904" class="indexterm"></a>
+<a name="N11918" class="indexterm"></a>
 <p>PERIODS</p>
 <p>Information on PERIOD objects defined in tables</p>
-<a name="N1190D" class="indexterm"></a>
+<a name="N11921" class="indexterm"></a>
 <p>REFERENTIAL_CONSTRAINTS</p>
 <p>Additional information on FOREIGN KEY constraints, including
       triggered action and name of UNIQUE constraint they refer to</p>
-<a name="N11916" class="indexterm"></a>
+<a name="N1192A" class="indexterm"></a>
 <p>ROLE_AUTHORIZATION_DESCRIPTORS</p>
-<a name="N1191D" class="indexterm"></a>
+<a name="N11931" class="indexterm"></a>
 <p>ROLE_COLUMN_GRANTS</p>
 <p>Information on privileges on COLUMN objects granted to or by the
       current session roles</p>
-<a name="N11926" class="indexterm"></a>
+<a name="N1193A" class="indexterm"></a>
 <p>ROLE_ROUTINE_GRANTS</p>
 <p>Information on privileges on FUNCTION and PROCEDURE objects
       granted to or by the current session roles</p>
-<a name="N1192F" class="indexterm"></a>
+<a name="N11943" class="indexterm"></a>
 <p>ROLE_TABLE_GRANTS</p>
 <p>Information on privileges on TABLE and VIEW objects granted to or
       by the current session roles</p>
-<a name="N11938" class="indexterm"></a>
+<a name="N1194C" class="indexterm"></a>
 <p>ROLE_UDT_GRANTS</p>
 <p>Information on privileges on TYPE objects granted to or by the
       current session roles</p>
-<a name="N11941" class="indexterm"></a>
+<a name="N11955" class="indexterm"></a>
 <p>ROLE_USAGE_GRANTS</p>
 <p>Information on privileges on USAGE privileges granted to or by the
       current session roles</p>
-<a name="N1194A" class="indexterm"></a>
+<a name="N1195E" class="indexterm"></a>
 <p>ROUTINE_COLUMN_USAGE</p>
 <p>Information on COLUMN objects of different tables that are
       referenced in FUNCTION and PROCEDURE definitions</p>
-<a name="N11953" class="indexterm"></a>
+<a name="N11967" class="indexterm"></a>
 <p>ROUTINE_JAR_USAGE</p>
 <p>Information on JAR usage by Java language FUNCTION and PROCEDURE
       objects.</p>
-<a name="N1195C" class="indexterm"></a>
+<a name="N11970" class="indexterm"></a>
 <p>ROUTINE_PERIOD_USAGE</p>
 <p>Information on table PERIOD objects referenced in FUNCTION and
       PROCEDURE objects.</p>
-<a name="N11965" class="indexterm"></a>
+<a name="N11979" class="indexterm"></a>
 <p>ROUTINE_PRIVILEGES</p>
 <p>Information on EXECUTE privileges granted on PROCEDURE and
       FUNCTION objects</p>
-<a name="N1196E" class="indexterm"></a>
+<a name="N11982" class="indexterm"></a>
 <p>ROUTINE_ROUTINE_USAGE</p>
 <p>Information on PROCEDURE and FUNCTION objects that are referenced
       in FUNCTION and PROCEDURE definitions</p>
-<a name="N11977" class="indexterm"></a>
+<a name="N1198B" class="indexterm"></a>
 <p>ROUTINE_SEQUENCE_USAGE</p>
 <p>Information on SEQUENCE objects that are referenced in FUNCTION
       and PROCEDURE definitions</p>
-<a name="N11980" class="indexterm"></a>
+<a name="N11994" class="indexterm"></a>
 <p>ROUTINE_TABLE_USAGE</p>
 <p>Information on TABLE and VIEW objects that are referenced in
       FUNCTION and PROCEDURE definitions</p>
-<a name="N11989" class="indexterm"></a>
+<a name="N1199D" class="indexterm"></a>
 <p>ROUTINES</p>
 <p>Top level information on all PROCEDURE and FUNCTION objects in the
       database</p>
-<a name="N11992" class="indexterm"></a>
+<a name="N119A6" class="indexterm"></a>
 <p>SCHEMATA</p>
 <p>Information on all the SCHEMA objects in the database</p>
-<a name="N1199B" class="indexterm"></a>
+<a name="N119AF" class="indexterm"></a>
 <p>SEQUENCES</p>
 <p>Information on SEQUENCE objects</p>
-<a name="N119A4" class="indexterm"></a>
+<a name="N119B8" class="indexterm"></a>
 <p>SQL_FEATURES</p>
 <p>List of all SQL:2011 standard features, including information on
       whether they are supported or not supported by HyperSQL</p>
-<a name="N119AD" class="indexterm"></a>
+<a name="N119C1" class="indexterm"></a>
 <p>SQL_IMPLEMENTATION_INFO</p>
 <p>Information on name, capabilities and defaults of the database
       engine software.</p>
-<a name="N119B6" class="indexterm"></a>
+<a name="N119CA" class="indexterm"></a>
 <p>SQL_PACKAGES</p>
 <p>List of SQL:2011 Standard packages, including information on
       whether they are supported or not supported by HyperSQL</p>
-<a name="N119BF" class="indexterm"></a>
+<a name="N119D3" class="indexterm"></a>
 <p>SQL_PARTS</p>
 <p>List of the SQL:2011 Standard parts, including information on
       whether they are supported or not supported by HyperSQL</p>
-<a name="N119C8" class="indexterm"></a>
+<a name="N119DC" class="indexterm"></a>
 <p>SQL_SIZING</p>
 <p>List of the SQL:2011 Standard maximum supported sizes for
       different features as supported by HyperSQL</p>
-<a name="N119D1" class="indexterm"></a>
+<a name="N119E5" class="indexterm"></a>
 <p>SQL_SIZING_PROFILES</p>
-<a name="N119D8" class="indexterm"></a>
+<a name="N119EC" class="indexterm"></a>
 <p>TABLES</p>
 <p>Information on all TABLE and VIEW object, including the
       INFORMATION_SCHEMA views themselves</p>
-<a name="N119E1" class="indexterm"></a>
+<a name="N119F5" class="indexterm"></a>
 <p>TABLE_CONSTRAINTS</p>
 <p>Information on all table level constraints, including PRIMARY KEY,
       UNIQUE, FOREIGN KEY and CHECK constraints</p>
-<a name="N119EA" class="indexterm"></a>
+<a name="N119FE" class="indexterm"></a>
 <p>TABLE_PRIVILEGES</p>
 <p>Information on privileges on TABLE and VIEW objects owned or given
       to the current user</p>
-<a name="N119F3" class="indexterm"></a>
+<a name="N11A07" class="indexterm"></a>
 <p>TRANSLATIONS</p>
-<a name="N119FA" class="indexterm"></a>
+<a name="N11A0E" class="indexterm"></a>
 <p>TRIGGERED_UPDATE_COLUMNS</p>
 <p>Information on columns that have been used in TRIGGER definitions
       in the ON UPDATE clause</p>
-<a name="N11A03" class="indexterm"></a>
+<a name="N11A17" class="indexterm"></a>
 <p>TRIGGERS</p>
 <p>Top level information on the TRIGGER definitions in the
       databases</p>
-<a name="N11A0C" class="indexterm"></a>
+<a name="N11A20" class="indexterm"></a>
 <p>TRIGGER_COLUMN_USAGE</p>
 <p>Information on COLUMN objects that have been referenced in the
       body of TRIGGER definitions</p>
-<a name="N11A15" class="indexterm"></a>
+<a name="N11A29" class="indexterm"></a>
 <p>TRIGGER_PERIOD_USAGE</p>
 <p>Information on PERIOD objects that have been referenced in the
       body of TRIGGER definitions</p>
-<a name="N11A1E" class="indexterm"></a>
+<a name="N11A32" class="indexterm"></a>
 <p>TRIGGER_ROUTINE_USAGE</p>
 <p>Information on FUNCTION and PROCEDURE objects that have been used
       in TRIGGER definitions</p>
-<a name="N11A27" class="indexterm"></a>
+<a name="N11A3B" class="indexterm"></a>
 <p>TRIGGER_SEQUENCE_USAGE</p>
 <p>Information on SEQUENCE objects that been referenced in TRIGGER
       definitions</p>
-<a name="N11A30" class="indexterm"></a>
+<a name="N11A44" class="indexterm"></a>
 <p>TRIGGER_TABLE_USAGE</p>
 <p>Information on TABLE and VIEW objects that have been referenced in
       TRIGGER definitions</p>
-<a name="N11A39" class="indexterm"></a>
+<a name="N11A4D" class="indexterm"></a>
 <p>USAGE_PRIVILEGES</p>
 <p>Information on USAGE privileges granted to or owned by the current
       user</p>
-<a name="N11A42" class="indexterm"></a>
+<a name="N11A56" class="indexterm"></a>
 <p>USER_DEFINED_TYPES</p>
 <p>Top level information on TYPE objects in the database</p>
-<a name="N11A4B" class="indexterm"></a>
+<a name="N11A5F" class="indexterm"></a>
 <p>VIEWS</p>
 <p>Top Level information on VIEW objects in the database</p>
-<a name="N11A54" class="indexterm"></a>
+<a name="N11A68" class="indexterm"></a>
 <p>VIEW_COLUMN_USAGE</p>
 <p>Information on COLUMN objects referenced in the query expressions
       of the VIEW objects</p>
-<a name="N11A5D" class="indexterm"></a>
+<a name="N11A71" class="indexterm"></a>
 <p>VIEW_PERIOD_USAGE</p>
 <p>Information on PERIOD objects referenced in the query expressions
       of the VIEW objects</p>
-<a name="N11A66" class="indexterm"></a>
+<a name="N11A7A" class="indexterm"></a>
 <p>VIEW_ROUTINE_USAGE</p>
 <p>Information on FUNCTION and PROCEDURE objects that have been used
       in the query expressions of the VIEW objects</p>
-<a name="N11A6F" class="indexterm"></a>
+<a name="N11A83" class="indexterm"></a>
 <p>VIEW_TABLE_USAGE</p>
 <p>Information on TABLE and VIEW objects that have been referenced in
       the query expressions of the VIEW objects</p>
@@ -9294,53 +9337,53 @@ ps.executeUpdate();
         views are used directly by JDBC DatabaseMetaData method calls and are
         indicated as such. Some views contain information that is specific to
         HyperSQL and is not covered by the SQL Standard views.</p>
-<a name="N11A7E" class="indexterm"></a>
+<a name="N11A92" class="indexterm"></a>
 <p>SYSTEM_BESTROWIDENTIFIER</p>
 <p>For DatabaseMetaData.getBestRowIdentifier</p>
-<a name="N11A87" class="indexterm"></a>
+<a name="N11A9B" class="indexterm"></a>
 <p>SYSTEM_CACHEINFO</p>
 <p>Contains the current settings and variables of the data cache
         used for all CACHED tables, and the data cache of each TEXT
         table.</p>
-<a name="N11A90" class="indexterm"></a>
+<a name="N11AA4" class="indexterm"></a>
 <p>SYSTEM_COLUMN_SEQUENCE_USAGE</p>
 <p>Contains a row for each column that is defined as GENERATED BY
         DEFAULT AS SEQUENCE with the column name and sequence name</p>
-<a name="N11A99" class="indexterm"></a>
+<a name="N11AAD" class="indexterm"></a>
 <p>SYSTEM_COLUMNS</p>
 <p>For DatabaseMetaData.getColumns, contains a row for each
         column</p>
-<a name="N11AA2" class="indexterm"></a>
+<a name="N11AB6" class="indexterm"></a>
 <p>SYSTEM_COMMENTS</p>
 <p>Contains the user-defined comments added to tables and their
         columns. Also informational comments on INFORMATION_SCHEMA
         views</p>
-<a name="N11AAB" class="indexterm"></a>
+<a name="N11ABF" class="indexterm"></a>
 <p>SYSTEM_CONNECTION_PROPERTIES</p>
 <p>For DatabaseMetaData.getClientInfoProperties</p>
-<a name="N11AB4" class="indexterm"></a>
+<a name="N11AC8" class="indexterm"></a>
 <p>SYSTEM_CROSSREFERENCE</p>
 <p>Full list of all columns referenced by FOREIGN KEY constraints.
         For DatabaseMetaData.getCrossReference, getExportedKeys and
         getImportedKeys.</p>
-<a name="N11ABD" class="indexterm"></a>
+<a name="N11AD1" class="indexterm"></a>
 <p>SYSTEM_INDEXINFO</p>
 <p>For DatabaseMetaData.getIndexInfo</p>
-<a name="N11AC6" class="indexterm"></a>
+<a name="N11ADA" class="indexterm"></a>
 <p>SYSTEM_KEY_INDEX_USAGE</p>
 <p>List of system-generated index names for each PRIMARY KEY,
         UNIQUE and FOREIGN KEY constraint.</p>
-<a name="N11ACF" class="indexterm"></a>
+<a name="N11AE3" class="indexterm"></a>
 <p>SYSTEM_PRIMARYKEYS</p>
 <p>For DatabaseMetaData.getPrimaryKeys</p>
-<a name="N11AD8" class="indexterm"></a>
+<a name="N11AEC" class="indexterm"></a>
 <p>SYSTEM_PROCEDURECOLUMNS</p>
 <p>For DatabaseMetaData.getProcedureColumns</p>
-<a name="N11AE1" class="indexterm"></a>
+<a name="N11AF5" class="indexterm"></a>
 <p>SYSTEM_PROCEDURES</p>
 <p>For DatabaseMetaData.getFunctionColumns, getFunctions and
         getProcedures</p>
-<a name="N11AEA" class="indexterm"></a>
+<a name="N11AFE" class="indexterm"></a>
 <p>SYSTEM_PROPERTIES</p>
 <p>Contains the current values of all the database level
         properties. Settings such as SQL rule enforcement, database
@@ -9348,45 +9391,45 @@ ps.executeUpdate();
         this view. The names of the properties are listed in the <a class="link" href="#dbproperties-chapt" title="Chapter&nbsp;14.&nbsp;Properties">Properties</a>
         chapter together with the corresponding SQL statements used to change
         the properties.</p>
-<a name="N11AF8" class="indexterm"></a>
+<a name="N11B0C" class="indexterm"></a>
 <p>SYSTEM_SCHEMAS</p>
 <p>For DatabaseMetaData.getSchemas</p>
-<a name="N11B01" class="indexterm"></a>
+<a name="N11B15" class="indexterm"></a>
 <p>SYSTEM_SEQUENCES</p>
-<a name="N11B08" class="indexterm"></a>
+<a name="N11B1C" class="indexterm"></a>
 <p>SYSTEM_SESSIONINFO</p>
 <p>Information on the settings and properties of the current
         session.</p>
-<a name="N11B11" class="indexterm"></a>
+<a name="N11B25" class="indexterm"></a>
 <p>SYSTEM_SESSIONS</p>
 <p>Information on all open sessions in the database (when used by a
         DBA user), or just the current session. Includes the current
         transaction state of each session.</p>
-<a name="N11B1A" class="indexterm"></a>
+<a name="N11B2E" class="indexterm"></a>
 <p>SYSTEM_TABLES</p>
 <p>Information on tables and views for
         DatabaseMetaData.getTables</p>
-<a name="N11B23" class="indexterm"></a>
+<a name="N11B37" class="indexterm"></a>
 <p>SYSTEM_TABLESTATS</p>
 <p>Information on table spaces and cardinality for each
         table</p>
-<a name="N11B2C" class="indexterm"></a>
+<a name="N11B40" class="indexterm"></a>
 <p>SYSTEM_TABLETYPES</p>
 <p>For DatabaseMetaData.getTableTypes</p>
-<a name="N11B35" class="indexterm"></a>
+<a name="N11B49" class="indexterm"></a>
 <p>SYSTEM_TEXTTABLES</p>
 <p>Information on the settings of each text table.</p>
-<a name="N11B3E" class="indexterm"></a>
+<a name="N11B52" class="indexterm"></a>
 <p>SYSTEM_TYPEINFO</p>
 <p>For DatabaseMetaData.getTypeInfo</p>
-<a name="N11B47" class="indexterm"></a>
+<a name="N11B5B" class="indexterm"></a>
 <p>SYSTEM_UDTS</p>
 <p>For DatabaseMetaData.getUDTs</p>
-<a name="N11B50" class="indexterm"></a>
+<a name="N11B64" class="indexterm"></a>
 <p>SYSTEM_USERS</p>
 <p>Contains the list of all users in the database (when used by a
         DBA user), or just the current user.</p>
-<a name="N11B59" class="indexterm"></a>
+<a name="N11B6D" class="indexterm"></a>
 <p>SYSTEM_VERSIONCOLUMNS</p>
 <p>For DatabaseMetaData.getVersionColumns. Contains list of columns
         of system PERIOD and those with ON UPDATE CURRENT TIMESTAMP.</p>
@@ -9415,12 +9458,12 @@ ps.executeUpdate();
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6358 $</p>
+<p class="releaseinfo">$Revision: 6583 $</p>
 </div>
 <div>
 <div class="legalnotice">
-<a name="N11B86"></a>
-<p>Copyright 2010-2021 Fred Toussi. Permission is granted to
+<a name="N11B9A"></a>
+<p>Copyright 2010-2022 Fred Toussi. Permission is granted to
       distribute this document without any alteration under the terms of the
       HSQLDB license. Additional permission is granted to the HSQL Development
       Group to distribute this document with or without alterations under the
@@ -9428,7 +9471,7 @@ ps.executeUpdate();
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -9444,6 +9487,9 @@ ps.executeUpdate();
 <span class="section"><a href="#bfc_string_binary_functions">String and Binary String Functions</a></span>
 </dt>
 <dt>
+<span class="section"><a href="#bfc_JSON_functions">JSON Functions</a></span>
+</dt>
+<dt>
 <span class="section"><a href="#bfc_numeric_functions">Numeric Functions</a></span>
 </dt>
 <dt>
@@ -9554,7 +9600,7 @@ ps.executeUpdate();
     tokens are separated with the vertical bar ( <code class="literal">&lt;vertical
     bar&gt;</code> ). At the end of each function definition, the standard
     which specifies the function is noted in parentheses as JDBC or HyperSQL,
-    or the SQL/Foundation part of the SQL Standard.</p>
+    or the SQL:2016 Standard.</p>
 </div>
 <div class="section">
 <div class="titlepage">
@@ -9577,7 +9623,7 @@ ps.executeUpdate();
     <code class="literal">&lt;binary value expr&gt; </code>indicates a binary type
     and<code class="literal"> &lt;num value expr&gt; </code>indicates a numeric
     type.</p>
-<a name="N11BF7" class="indexterm"></a>
+<a name="N11C0B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ASCII</strong></span>
 </p>
@@ -9586,7 +9632,7 @@ ps.executeUpdate();
 </p>
 <p>Returns an INTEGER equal to the ASCII code value of the first
     character of <code class="literal">&lt;char value expr&gt;</code>. (JDBC)</p>
-<a name="N11C08" class="indexterm"></a>
+<a name="N11C1C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ASCIISTR</strong></span>
 </p>
@@ -9596,7 +9642,7 @@ ps.executeUpdate();
 <p>Returns the ASCII representation of the string argument with all
     characters outside the range 32-126 replaced with Unicode escape codes.
     (HyperSQL)</p>
-<a name="N11C16" class="indexterm"></a>
+<a name="N11C2A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>BIT_LENGTH</strong></span>
 </p>
@@ -9606,9 +9652,9 @@ ps.executeUpdate();
 </p>
 <p>BIT_LENGTH can be used with character, binary and bit strings. It
     return a BIGINT value that measures the bit length of the string.
-    (Foundation)</p>
+    (SQL:2016)</p>
 <p>See also CHARACTER_LENGTH and OCTET_LENGTH.</p>
-<a name="N11C26" class="indexterm"></a>
+<a name="N11C3A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CHAR</strong></span>
 </p>
@@ -9619,7 +9665,7 @@ ps.executeUpdate();
     single character that has the specified<code class="literal"> &lt;UNICODE
     code&gt;</code>, which is an integer. ASCII codes are a subset of the
     allowed values for <code class="literal">&lt;UNICODE code&gt;</code>. (JDBC)</p>
-<a name="N11C3A" class="indexterm"></a><a name="N11C3F" class="indexterm"></a>
+<a name="N11C4E" class="indexterm"></a><a name="N11C53" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CHARACTER_LENGTH</strong></span>
 </p>
@@ -9635,8 +9681,8 @@ ps.executeUpdate();
     string in the given unit. CHAR_LENGTH counts characters, OCTET_LENGTH
     counts octets and BIT_LENGTH counts bits in the string. For CHAR_LENGTH,
     if <code class="literal">[ USING OCTETS ] </code>is specified, the octet count is
-    returned, which is twice the normal length. (Foundation)</p>
-<a name="N11C52" class="indexterm"></a>
+    returned, which is twice the normal length. (SQL:2016)</p>
+<a name="N11C66" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CONCAT</strong></span>
 </p>
@@ -9660,7 +9706,7 @@ ps.executeUpdate();
     property is set false, then NULL values are replaced with empty
     strings.</p>
 <p>(JDBC)</p>
-<a name="N11C70" class="indexterm"></a>
+<a name="N11C84" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CONCAT_WS</strong></span>
 </p>
@@ -9678,7 +9724,7 @@ ps.executeUpdate();
 <p>This function is similar to a MySQL function of the same
     name.</p>
 <p>(HyperSQL)</p>
-<a name="N11C85" class="indexterm"></a>
+<a name="N11C99" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DIFFERENCE</strong></span>
 </p>
@@ -9691,7 +9737,7 @@ ps.executeUpdate();
     similar the two SOUNDEX value are. If the values are the same, it returns
     4, if the values have no similarity, it returns 0. In-between values are
     returned for partial similarity. (JDBC)</p>
-<a name="N11C93" class="indexterm"></a>
+<a name="N11CA7" class="indexterm"></a>
 <p>
 <span class="bold"><strong>FROM_BASE64</strong></span>
 </p>
@@ -9701,7 +9747,7 @@ ps.executeUpdate();
 </p>
 <p>Returns a binary string by converting from the base64
     <code class="literal">&lt;character value expr&gt;</code>. (HyperSQL)</p>
-<a name="N11CA4" class="indexterm"></a>
+<a name="N11CB8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>INSERT</strong></span>
 </p>
@@ -9716,7 +9762,7 @@ ps.executeUpdate();
     copied. Equivalent to SQL/Foundation <code class="literal">OVERLAY( &lt;char value
     expr1&gt; PLACING &lt; char value expr2&gt; FROM &lt;offset&gt; FOR
     &lt;length&gt; )</code> . (JDBC)</p>
-<a name="N11CC1" class="indexterm"></a>
+<a name="N11CD5" class="indexterm"></a>
 <p>
 <span class="bold"><strong>INSTR</strong></span>
 </p>
@@ -9731,7 +9777,7 @@ ps.executeUpdate();
     position indicated by <code class="literal">&lt;offset&gt;</code>. If the search is
     not successful, 0 is returned. Similar to the <code class="literal">LOCATE</code>
     function but the order of the arguments is reversed. (HyperSQL)</p>
-<a name="N11CDE" class="indexterm"></a>
+<a name="N11CF2" class="indexterm"></a>
 <p>
 <span class="bold"><strong>HEX</strong></span>
 </p>
@@ -9746,7 +9792,7 @@ ps.executeUpdate();
     same as the <code class="literal">RAWTOHEX</code> function. With
     <code class="literal">&lt;numeric value expr&gt;</code> the hexadecimal digits
     represent the number in base 16 (HyperSQL)</p>
-<a name="N11CF8" class="indexterm"></a>
+<a name="N11D0C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>HEXTORAW</strong></span>
 </p>
@@ -9759,7 +9805,7 @@ ps.executeUpdate();
     digit or a letter in the A | B | C | D | E | F set. Each byte of the
     retired binary string is formed by translating two hex digits into one
     byte. (HyperSQL)</p>
-<a name="N11D0C" class="indexterm"></a>
+<a name="N11D20" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LCASE</strong></span>
 </p>
@@ -9769,7 +9815,7 @@ ps.executeUpdate();
 <p>Returns a character string that is the lower-case version of the
     <code class="literal">&lt;char value expr&gt;</code>. Equivalent to SQL/Foundation
     <code class="literal">LOWER (&lt;char value expr&gt;)</code>. (JDBC)</p>
-<a name="N11D20" class="indexterm"></a>
+<a name="N11D34" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LEFT</strong></span>
 </p>
@@ -9782,7 +9828,7 @@ ps.executeUpdate();
     expr&gt;</code>. Equivalent to SQL/Foundation<code class="literal">
     SUBSTRING(&lt;char value expr&gt; FROM 0 FOR &lt;count&gt;)</code>.
     (JDBC)</p>
-<a name="N11D37" class="indexterm"></a>
+<a name="N11D4B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LENGTH</strong></span>
 </p>
@@ -9792,7 +9838,7 @@ ps.executeUpdate();
 <p>Returns as a BIGINT value the number of characters in
     <code class="literal">&lt;char value expr&gt;</code>. Equivalent to SQL/Foundation
     <code class="literal">CHAR_LENGTH(&lt;char value expr&gt;)</code>. (JDBC)</p>
-<a name="N11D4B" class="indexterm"></a>
+<a name="N11D5F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LOCATE</strong></span>
 </p>
@@ -9809,7 +9855,7 @@ ps.executeUpdate();
     LOCATE</code> is equivalent to the SQL Standard function
     <code class="literal">POSITION(&lt;char value expr 1&gt; IN &lt;char value expr
     2&gt;)</code>. (JDBC)</p>
-<a name="N11D6B" class="indexterm"></a>
+<a name="N11D7F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LOWER</strong></span>
 </p>
@@ -9817,8 +9863,8 @@ ps.executeUpdate();
 <code class="literal">LOWER ( &lt;char value expr&gt; ) </code>
 </p>
 <p>Returns a character string that is the lower-case version of the
-    <code class="literal">&lt;char value expr&gt;</code>. (Foundation)</p>
-<a name="N11D7C" class="indexterm"></a>
+    <code class="literal">&lt;char value expr&gt;</code>. (SQL:2016)</p>
+<a name="N11D90" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LPAD</strong></span>
 </p>
@@ -9833,7 +9879,7 @@ ps.executeUpdate();
     length of the string argument, the argument is truncated. If the optional
     <code class="literal">&lt;char value expr 2&gt;</code> is specified, this string is
     used for padding, instead of spaces. (HyperSQL)</p>
-<a name="N11D96" class="indexterm"></a>
+<a name="N11DAA" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LTRIM</strong></span>
 </p>
@@ -9847,7 +9893,7 @@ ps.executeUpdate();
     ' FROM &lt;char value expr1&gt; )</code>. When called with two
     arguments, <code class="literal">&lt;char value expr 2&gt;</code> represents the
     leading character to be removed. (JDBC)</p>
-<a name="N11DAD" class="indexterm"></a>
+<a name="N11DC1" class="indexterm"></a>
 <p>
 <span class="bold"><strong>OCTET_LENGTH</strong></span>
 </p>
@@ -9859,8 +9905,8 @@ ps.executeUpdate();
     strings.</p>
 <p>Return a BIGINT value that measures the length of the string in
     octets<code class="literal">. When used with character strings</code>, the octet
-    count is returned, which is twice the normal length. (Foundation)</p>
-<a name="N11DC0" class="indexterm"></a>
+    count is returned, which is twice the normal length. (SQL:2016)</p>
+<a name="N11DD4" class="indexterm"></a>
 <p>
 <span class="bold"><strong>OVERLAY</strong></span>
 </p>
@@ -9886,8 +9932,8 @@ ps.executeUpdate();
     <code class="literal">&lt;start position&gt;</code> and in their place, the whole
     <code class="literal">&lt;char value expr 2&gt;</code> is copied.</p>
 <p>The binary version of OVERLAY returns a binary string formed in the
-    same manner as the character version. (Foundation)</p>
-<a name="N11DE5" class="indexterm"></a>
+    same manner as the character version. (SQL:2016)</p>
+<a name="N11DF9" class="indexterm"></a>
 <p>
 <span class="bold"><strong>POSITION</strong></span>
 </p>
@@ -9902,8 +9948,8 @@ ps.executeUpdate();
 <p>The character and binary versions of POSITION search the string
     value of the second argument for the first occurrence of the first
     argument string. If the search is successful, the position in the string
-    is returned as a BIGINT. Otherwise zero is returned. (Foundation)</p>
-<a name="N11DF6" class="indexterm"></a>
+    is returned as a BIGINT. Otherwise zero is returned. (SQL:2016)</p>
+<a name="N11E0A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>RAWTOHEX</strong></span>
 </p>
@@ -9914,7 +9960,7 @@ ps.executeUpdate();
     representing the bytes in the <code class="literal">&lt;binary value
     expr&gt;</code>. Each byte of the <code class="literal">&lt;binary value
     expr&gt;</code> is translated into two hex digits. (HyperSQL)</p>
-<a name="N11E0A" class="indexterm"></a>
+<a name="N11E1E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>REGEXP_COUNT</strong></span>
 </p>
@@ -9927,7 +9973,7 @@ ps.executeUpdate();
     <code class="literal">&lt;regular expression&gt;</code>. The <code class="literal">&lt;regular
     expression&gt;</code> is defined according to Java language regular
     expression rules. Returns 0 if no match is found. (HyperSQL)</p>
-<a name="N11E21" class="indexterm"></a>
+<a name="N11E35" class="indexterm"></a>
 <p>
 <span class="bold"><strong>REGEXP_INSTR</strong></span>
 </p>
@@ -9940,7 +9986,7 @@ ps.executeUpdate();
     <code class="literal">&lt;regular expression&gt;</code>. The <code class="literal">&lt;regular
     expression&gt;</code> is defined according to Java language regular
     expression rules. Returns 0 if no match is found. (HyperSQL)</p>
-<a name="N11E38" class="indexterm"></a>
+<a name="N11E4C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>REGEXP_LIKE</strong></span>
 </p>
@@ -9948,7 +9994,7 @@ ps.executeUpdate();
 <code class="literal">REGEXP_LIKE ( &lt;char value expr&gt;, &lt;regular
     expression&gt; ) </code>
 </p>
-<a name="N11E44" class="indexterm"></a>
+<a name="N11E58" class="indexterm"></a>
 <p>
 <span class="bold"><strong>REGEXP_MATCHES</strong></span>
 </p>
@@ -9961,7 +10007,7 @@ ps.executeUpdate();
     expression&gt;</code> as a whole. The <code class="literal">&lt;regular
     expression&gt;</code> is defined according to Java language regular
     expression rules. (HyperSQL)</p>
-<a name="N11E5B" class="indexterm"></a>
+<a name="N11E6F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>REGEXP_REPLACE</strong></span>
 </p>
@@ -9984,7 +10030,7 @@ ps.executeUpdate();
     'n' for the '.' also to match any line terminator, and 'm' for multi-line
     matches. The <code class="literal">&lt;regular expression&gt;</code> is defined
     according to Java language regular expression rules. (HyperSQL)</p>
-<a name="N11E7E" class="indexterm"></a>
+<a name="N11E92" class="indexterm"></a>
 <p>
 <span class="bold"><strong>REGEXP_SUBSTR</strong></span>
 </p>
@@ -9992,7 +10038,7 @@ ps.executeUpdate();
 <code class="literal">REGEXP_SUBSTR ( &lt;char value expr&gt;, &lt;regular
     expression&gt; ) </code>
 </p>
-<a name="N11E8A" class="indexterm"></a>
+<a name="N11E9E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>REGEXP_SUBSTRING</strong></span>
 </p>
@@ -10005,7 +10051,7 @@ ps.executeUpdate();
     expression&gt;</code>. The <code class="literal">&lt;regular
     expression&gt;</code> is defined according to Java language regular
     expression rules. (HyperSQL)</p>
-<a name="N11EA1" class="indexterm"></a>
+<a name="N11EB5" class="indexterm"></a>
 <p>
 <span class="bold"><strong>REGEXP_SUBSTRING_ARRAY</strong></span>
 </p>
@@ -10019,7 +10065,7 @@ ps.executeUpdate();
     expression&gt;</code> is defined according to Java language regular
     expression rules. Returns an array containing the matching regions
     (HyperSQL)</p>
-<a name="N11EB8" class="indexterm"></a>
+<a name="N11ECC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>REPEAT</strong></span>
 </p>
@@ -10030,7 +10076,7 @@ ps.executeUpdate();
 <p>Returns a character string based on<code class="literal"> &lt;char value
     expr&gt;</code>, repeated <code class="literal">&lt;count&gt;</code> times.
     (JDBC)</p>
-<a name="N11ECC" class="indexterm"></a>
+<a name="N11EE0" class="indexterm"></a>
 <p>
 <span class="bold"><strong>REPLACE</strong></span>
 </p>
@@ -10045,7 +10091,7 @@ ps.executeUpdate();
     the &lt;char value expr 3&gt; defaults to the empty string and calling the
     function simply removes the occurrences of <code class="literal">&lt;char value expr
     2&gt;</code> from the first string.(JDBC)</p>
-<a name="N11EE6" class="indexterm"></a>
+<a name="N11EFA" class="indexterm"></a>
 <p>
 <span class="bold"><strong>REVERSE</strong></span>
 </p>
@@ -10054,7 +10100,7 @@ ps.executeUpdate();
 </p>
 <p>Returns a character string based on <code class="literal">&lt;char value
     expr&gt;</code> with characters in the reverse order. (HyperSQL)</p>
-<a name="N11EF7" class="indexterm"></a>
+<a name="N11F0B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>RIGHT</strong></span>
 </p>
@@ -10065,7 +10111,7 @@ ps.executeUpdate();
 <p>Returns a character string consisting of the last
     <code class="literal">&lt;count&gt;</code> characters of <code class="literal">&lt;char value
     expr&gt;</code>. (JDBC)</p>
-<a name="N11F0B" class="indexterm"></a>
+<a name="N11F1F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>RPAD</strong></span>
 </p>
@@ -10080,7 +10126,7 @@ ps.executeUpdate();
     the length of the string argument, the argument is truncated. If the
     optional <code class="literal">&lt;char value expr 2&gt;</code> is specified, this
     string is used for padding, instead of spaces. (HyperSQL)</p>
-<a name="N11F25" class="indexterm"></a>
+<a name="N11F39" class="indexterm"></a>
 <p>
 <span class="bold"><strong>RTRIM</strong></span>
 </p>
@@ -10094,7 +10140,7 @@ ps.executeUpdate();
     ' FROM &lt;character string&gt;)</code>. When called with two
     arguments, <code class="literal">&lt;char value expr 2&gt;</code> represents the
     trailing character to be removed. (JDBC)</p>
-<a name="N11F3C" class="indexterm"></a>
+<a name="N11F50" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SOUNDEX</strong></span>
 </p>
@@ -10103,9 +10149,12 @@ ps.executeUpdate();
 </p>
 <p>Returns a four-character code representing the sound of
     <code class="literal">&lt;char value expr&gt;</code>. The US census algorithm is
-    used. For example, the soundex value for "Washington" is W252.
-    (JDBC)</p>
-<a name="N11F4D" class="indexterm"></a>
+    used. For example, the soundex value for "Washington" is W252. This
+    function is used for storing the soundex of names in a column of a table,
+    then searching this column for strings matching the soundex of the search
+    string, then comparing the actual names stored in the database with the
+    search string. (JDBC)</p>
+<a name="N11F61" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SPACE</strong></span>
 </p>
@@ -10114,7 +10163,7 @@ ps.executeUpdate();
 </p>
 <p>Returns a character string consisting of <code class="literal">&lt;count&gt;
     </code>spaces. (JDBC)</p>
-<a name="N11F5E" class="indexterm"></a>
+<a name="N11F72" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SUBSTR</strong></span>
 </p>
@@ -10127,7 +10176,7 @@ ps.executeUpdate();
     <code class="literal">&lt;length&gt;</code> characters from <code class="literal">&lt;char value
     expr&gt; </code>starting at the <code class="literal">&lt;offset&gt;</code>
     position. (JDBC)</p>
-<a name="N11F78" class="indexterm"></a>
+<a name="N11F8C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SUBSTRING</strong></span>
 </p>
@@ -10146,8 +10195,8 @@ ps.executeUpdate();
     optional<code class="literal"> &lt;string length&gt;</code> is specified, only
     <code class="literal">&lt;string length&gt; </code>characters are returned.</p>
 <p>The binary version of SUBSTRING returns a binary string in the same
-    manner. (Foundation)</p>
-<a name="N11F97" class="indexterm"></a>
+    manner. (SQL:2016)</p>
+<a name="N11FAB" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TO_BASE64</strong></span>
 </p>
@@ -10156,7 +10205,7 @@ ps.executeUpdate();
 </p>
 <p>Returns a character string as a base 64 representation of the bytes
     in the <code class="literal">&lt;binary value expr&gt;</code>. (HyperSQL)</p>
-<a name="N11FA8" class="indexterm"></a>
+<a name="N11FBC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TRIM</strong></span>
 </p>
@@ -10181,8 +10230,8 @@ ps.executeUpdate();
     <code class="literal">&lt;binary value expr&gt;</code>. Consecutive instances of
     <code class="literal">&lt;trim octet&gt; </code>are removed in the same manner as in
     the character version. If<code class="literal"> [ &lt;trim octet&gt; ]</code> is not
-    specified, the 0 octet is used as default. (Foundation)</p>
-<a name="N11FD6" class="indexterm"></a>
+    specified, the 0 octet is used as default. (SQL:2016)</p>
+<a name="N11FEA" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TRANSLATE</strong></span>
 </p>
@@ -10205,7 +10254,7 @@ ps.executeUpdate();
  TRANSLATE( acolumn, '&Aacute;&Ccedil;&Eacute;&Iacute;&Oacute;&Uacute;&Agrave;&Egrave;&Igrave;&Ograve;&Ugrave;&Acirc;&Ecirc;&Icirc;&Ocirc;&Ucirc;&Atilde;&Otilde;&Euml;&Uuml;&aacute;&ccedil;&eacute;&iacute;&oacute;&uacute;&agrave;&egrave;&igrave;&ograve;&ugrave;&acirc;&ecirc;&icirc;&ocirc;&ucirc;&atilde;&otilde;&euml;&uuml;', 'ACEIOUAEIOUAEIOUAOEUaceiouaeiouaeiouaoeu');
 </pre>
 </div>
-<a name="N11FF9" class="indexterm"></a>
+<a name="N1200D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>UCASE</strong></span>
 </p>
@@ -10215,7 +10264,7 @@ ps.executeUpdate();
 <p>Returns a character string that is the upper case version of the
     <code class="literal">&lt;char value expr&gt;</code>. Equivalent to SQL/Foundation
     <code class="literal">UPPER( &lt;char value expr&gt; )</code>. (JDBC)</p>
-<a name="N1200D" class="indexterm"></a>
+<a name="N12021" class="indexterm"></a>
 <p>
 <span class="bold"><strong>UPPER</strong></span>
 </p>
@@ -10223,8 +10272,8 @@ ps.executeUpdate();
 <code class="literal">UPPER ( &lt;char value expr&gt; ) </code>
 </p>
 <p>Returns a character string that is the upper case version of the
-    <code class="literal">&lt;char value expr&gt;</code> . (Foundation)</p>
-<a name="N1201E" class="indexterm"></a>
+    <code class="literal">&lt;char value expr&gt;</code> . (SQL:2016)</p>
+<a name="N12032" class="indexterm"></a>
 <p>
 <span class="bold"><strong>UNHEX</strong></span>
 </p>
@@ -10234,7 +10283,7 @@ ps.executeUpdate();
 <p>Returns a binary string formed by translation of hexadecimal digits
     and letters in the &lt;<code class="literal">char value expr&gt;</code>. Exactly the
     same as the <code class="literal">HEXTORAW</code> function. (HyperSQL)</p>
-<a name="N12032" class="indexterm"></a>
+<a name="N12046" class="indexterm"></a>
 <p>
 <span class="bold"><strong>UNISTR</strong></span>
 </p>
@@ -10251,11 +10300,177 @@ ps.executeUpdate();
 <div>
 <div>
 <h2 class="title" style="clear: both">
+<a name="bfc_JSON_functions"></a>JSON Functions</h2>
+</div>
+</div>
+</div>
+<p>JSON constructor functions convert SQL data into JSON values, These
+    functions are supported by HyperSQL according to the SQL:2016 Standard.
+    Each function returns a JSON object or JSON array as a string. The format
+    conforms to the IETF rfc:7159 document, The JavaScript Object Notation
+    (JSON) Data Interchange Format.</p>
+<p>In the BNF, <code class="literal">&lt;JSON value expr&gt;</code> indicates any
+    valid SQL expression that evaluates to a single value. This includes
+    strings, numbers and booleans. Binary values are represented as
+    hexadecimal strings. All other types, including dates and timestamps, are
+    represented as strings. An optional <code class="literal">FORMAT JSON</code> is used
+    when the result of the value expression is already a string in the JSON
+    format.</p>
+<p>
+<code class="literal">&lt;JSON value expr&gt; ::= &lt;value expression&gt; [
+    FORMAT JSON ]</code>
+</p>
+<p>The optional <code class="literal">&lt;JSON constructor null clause&gt;</code>
+    indicates whether NULL values are represented as JSON nulls or are omitted
+    from the result. The default behaviour is <code class="literal">ABSENT ON
+    NULL</code> for <code class="literal">JSON_ARRAY</code>, and <code class="literal">NULL ON
+    NULL</code> for <code class="literal">JSON_OBJECT</code>.</p>
+<p>
+<code class="literal">&lt;JSON null clause&gt; ::= NULL ON NULL | ABSENT ON
+    NULL</code>
+</p>
+<p>The optional <code class="literal">&lt;JSON output clause&gt;</code> allows
+    you to change the maximum length of the returned string from the default
+    32K bytes.</p>
+<p>
+<code class="literal">&lt;JSON output clause&gt; ::= RETURNING
+    VARCHAR(N)</code>
+</p>
+<p>JSON function calls can be nested to construct more complex objects
+    containing arrays, objects, and arrays of objects.</p>
+<a name="N12089" class="indexterm"></a>
+<p>
+<span class="bold"><strong>JSON_ARRAY</strong></span>
+</p>
+<p>
+<code class="literal">JSON_ARRAY ( &lt;JSON value expr&gt;, ... [&lt;JSON null
+    caluse&gt;] [&lt;JSON output caluse&gt;])</code>
+</p>
+<p>The first form of <code class="literal">JSON_ARRAY</code> is a variable
+    argument function, It converts the values from a series of value
+    expression into a single JSON array.</p>
+<p>
+<code class="literal">JSON_ARRAY ( &lt;query expression&gt; [ FORMAT JSON ]
+    [&lt;JSON null caluse&gt;] [&lt;JSON output caluse&gt;])</code>
+</p>
+<p>The second form of <code class="literal">JSON_ARRAY</code> converts the values
+    from a single &lt;query expression&gt; into a JSON array.
+    (SQL:2016)</p>
+<div class="informalexample">
+<pre class="programlisting">-- a JSON array is constructed from a single row of the table
+
+SELECT JSON_ARRAY( country_id , name, local_name ) FROM places.countries WHERE country_id = 'ESP'
+ 
+C1                       
+------------------------ 
+["ESP","Spain","Espa&ntilde;a"]
+
+-- a JSON array is constructed from all rows of the table
+
+VALUES JSON_ARRAY(SELECT name FROM countries)
+  
+C1                                                                    
+--------------------------------------------------------------------- 
+["Austria","Switzerland","Germany","Spain","France","Italy","Sweden"]
+</pre>
+</div>
+<a name="N120A5" class="indexterm"></a>
+<p>
+<span class="bold"><strong>JSON_ARRAYAGG</strong></span>
+</p>
+<p>
+<code class="literal">JSON_ARRAYAGG ( &lt;JSON value expr&gt; [&lt;order by
+    clause&gt;] [&lt;JSON null caluse&gt;] )</code>
+</p>
+<p>
+<code class="literal">JSON_ARRAYAGG</code> is an aggregate function similar to
+    the <code class="literal">ARRAY_AGG</code> SQL function, It evaluates a value
+    expression over a series of rows and combines the values, separated by
+    commas, into a single JSON array. Returns a JSON string. (SQL:2016)</p>
+<div class="informalexample">
+<pre class="programlisting">-- a JSON array is constructed from all rows of the table
+
+SELECT JSON_ARRAYAGG( country_id ) FROM places.countries
+ 
+C1                                          
+------------------------------------------- 
+["AUT","CHE","DEU","ESP","FRA","ITA","SWE"]
+</pre>
+</div>
+<a name="N120BB" class="indexterm"></a>
+<p>
+<span class="bold"><strong>JSON_OBJECT</strong></span>
+</p>
+<p>
+<code class="literal">JSON_OBJECT ( &lt;JSON name and value&gt;, ... [&lt;JSON
+    null caluse&gt;] [ { WITH | WITHOUT } UNIQUE [ KEYS] ] )</code>
+</p>
+<p>
+<code class="literal">JSON_OBJECT</code> is a variable argument function, It
+    combines a series of keys and values into a single JSON object. Returns a
+    JSON string.</p>
+<p>There are two supported syntax forms for key:value pairs.</p>
+<p>
+<code class="literal">&lt;JSON name and value&gt; ::= &lt;JSON name&gt;
+    &lt;colon&gt; &lt;JSON value expression&gt; | [ KEY ] &lt;JSON name&gt;
+    VALUE &lt;JSON value expression&gt; </code>
+</p>
+<p>The optional <code class="literal">WITH UNIQUE KEYS</code> clause forces an
+    error if the keys within the JSON object are not unique. The default is
+    <code class="literal">WITHOUT UNIQUE KEYS</code>. (SQL:2016)</p>
+<div class="informalexample">
+<pre class="programlisting">-- a JSON object is constructed from each row of the table; both syntax options are shown
+
+SELECT country_id, JSON_OBJECT( country_id : name ) FROM places.countries
+
+SELECT country_id, JSON_OBJECT( KEY country_id  VALUE name ) FROM places.countries
+ 
+ 
+COUNTRY_ID C2                    
+---------- --------------------- 
+AUT        {"AUT":"Austria"}     
+CHE        {"CHE":"Switzerland"} 
+DEU        {"DEU":"Germany"}     
+ESP        {"ESP":"Spain"}       
+FRA        {"FRA":"France"}      
+ITA        {"ITA":"Italy"}       
+SWE        {"SWE":"Sweden"}
+</pre>
+</div>
+<a name="N120DB" class="indexterm"></a>
+<p>
+<span class="bold"><strong>JSON_OBJECTAGG</strong></span>
+</p>
+<p>
+<code class="literal">JSON_OBJECTAGG ( &lt;JSON name and value&gt; [&lt;JSON null
+    caluse&gt;] [ { WITH | WITHOUT } UNIQUE [ KEYS] ] )</code>
+</p>
+<p>
+<code class="literal">JSON_OBJECTAGG</code> is an aggregate function similar
+    to the <code class="literal">ARRAY_AGG</code> SQL function, It constructs a JSON
+    object by using keys and values from the aggregated rows.
+    (SQL:2016)</p>
+<div class="informalexample">
+<pre class="programlisting">-- a JSON object is constructed from multiple rows of the table
+
+SELECT JSON_OBJECTAGG( country_id : name ) FROM places.countries
+ 
+C1                                                                                                                                                 
+--------------------------------------------------------------------------------------------------------------- 
+{"AUT":"Austria","CHE":"Switzerland","DEU":"Germany","ESP":"Spain","FRA":"France","ITA":"Italy","SWE":"Sweden"}
+</pre>
+</div>
+</div>
+<div class="section">
+<div class="titlepage">
+<div>
+<div>
+<h2 class="title" style="clear: both">
 <a name="bfc_numeric_functions"></a>Numeric Functions</h2>
 </div>
 </div>
 </div>
-<a name="N1204A" class="indexterm"></a>
+<a name="N120F5" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ABS</strong></span>
 </p>
@@ -10264,8 +10479,8 @@ ps.executeUpdate();
     ) </code>
 </p>
 <p>Returns the absolute value of the argument as a value of the same
-    type. (JDBC and Foundation)</p>
-<a name="N12058" class="indexterm"></a>
+    type. (JDBC and SQL:2016)</p>
+<a name="N12103" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ACOS</strong></span>
 </p>
@@ -10274,7 +10489,7 @@ ps.executeUpdate();
 </p>
 <p>Returns the arc-cosine of the argument in radians as a value of
     DOUBLE type. (JDBC)</p>
-<a name="N12066" class="indexterm"></a>
+<a name="N12111" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ASIN</strong></span>
 </p>
@@ -10283,7 +10498,7 @@ ps.executeUpdate();
 </p>
 <p>Returns the arc-sine of the argument in radians as a value of DOUBLE
     type. (JDBC)</p>
-<a name="N12074" class="indexterm"></a>
+<a name="N1211F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ATAN</strong></span>
 </p>
@@ -10292,7 +10507,7 @@ ps.executeUpdate();
 </p>
 <p>Returns the arc-tangent of the argument in radians as a value of
     DOUBLE type. (JDBC)</p>
-<a name="N12082" class="indexterm"></a>
+<a name="N1212D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ATAN2</strong></span>
 </p>
@@ -10305,7 +10520,7 @@ ps.executeUpdate();
     <code class="varname">y</code> coordinates of a point. Returns the angle, in
     radians, representing the angle coordinate of the point in polar
     coordinates, as a value of DOUBLE type. (JDBC)</p>
-<a name="N1209C" class="indexterm"></a>
+<a name="N12147" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CEILING</strong></span>
 </p>
@@ -10316,8 +10531,8 @@ ps.executeUpdate();
 <p>Returns the smallest integer greater than or equal to the argument.
     If the argument is exact numeric then the result is exact numeric with a
     scale of 0. If the argument is approximate numeric, then the result is of
-    DOUBLE type. (JDBC and Foundation)</p>
-<a name="N120AA" class="indexterm"></a>
+    DOUBLE type. (JDBC and SQL:2016)</p>
+<a name="N12155" class="indexterm"></a>
 <p>
 <span class="bold"><strong>BITAND</strong></span>
 </p>
@@ -10329,7 +10544,7 @@ ps.executeUpdate();
 <code class="literal">BITAND ( &lt;bit value expr 1&gt;, &lt;bit value expr 2&gt;
     )</code>
 </p>
-<a name="N120B9" class="indexterm"></a>
+<a name="N12164" class="indexterm"></a>
 <p>
 <span class="bold"><strong>BITANDNOT</strong></span>
 </p>
@@ -10341,7 +10556,7 @@ ps.executeUpdate();
 <code class="literal">BITANDNOT ( &lt;bit value expr 1&gt;, &lt;bit value expr
     2&gt; )</code>
 </p>
-<a name="N120C8" class="indexterm"></a>
+<a name="N12173" class="indexterm"></a>
 <p>
 <span class="bold"><strong>BITNOT</strong></span>
 </p>
@@ -10351,7 +10566,7 @@ ps.executeUpdate();
 <p>
 <code class="literal">BITNOT ( &lt;bit value expr 1&gt; )</code>
 </p>
-<a name="N120D7" class="indexterm"></a>
+<a name="N12182" class="indexterm"></a>
 <p>
 <span class="bold"><strong>BITOR</strong></span>
 </p>
@@ -10363,7 +10578,7 @@ ps.executeUpdate();
 <code class="literal">BITOR ( &lt;bit value expr 1&gt;, &lt;bit value expr 2&gt;
     )</code>
 </p>
-<a name="N120E6" class="indexterm"></a>
+<a name="N12191" class="indexterm"></a>
 <p>
 <span class="bold"><strong>BITXOR</strong></span>
 </p>
@@ -10383,7 +10598,7 @@ ps.executeUpdate();
     arguments. The names of the function indicate NOT, OR, AND, XOR
     operations. The BITANDNOT performs NOT on the second argument, then
     performs AND on result and the first argument. (HyperSQL)</p>
-<a name="N120F7" class="indexterm"></a>
+<a name="N121A2" class="indexterm"></a>
 <p>
 <span class="bold"><strong>COS</strong></span>
 </p>
@@ -10392,7 +10607,7 @@ ps.executeUpdate();
 </p>
 <p>Returns the cosine of the argument (an angle expressed in radians)
     as a value of DOUBLE type. (JDBC)</p>
-<a name="N12105" class="indexterm"></a>
+<a name="N121B0" class="indexterm"></a>
 <p>
 <span class="bold"><strong>COSH</strong></span>
 </p>
@@ -10401,7 +10616,7 @@ ps.executeUpdate();
 </p>
 <p>Returns the hyperbolic cosine of the argument as a value of DOUBLE
     type. (HyperSQL)</p>
-<a name="N12113" class="indexterm"></a>
+<a name="N121BE" class="indexterm"></a>
 <p>
 <span class="bold"><strong>COT</strong></span>
 </p>
@@ -10411,7 +10626,7 @@ ps.executeUpdate();
 <p>Returns the cotangent of the argument as a value of DOUBLE type. The
     <code class="literal">&lt;num value expr&gt;</code> represents an angle expressed in
     radians. (JDBC)</p>
-<a name="N12124" class="indexterm"></a>
+<a name="N121CF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DEGREES</strong></span>
 </p>
@@ -10421,7 +10636,7 @@ ps.executeUpdate();
 <p>Converts the argument (an angle expressed in<code class="literal">
     radians</code>) into degrees and returns the value in the DOUBLE type.
     (JDBC)</p>
-<a name="N12135" class="indexterm"></a>
+<a name="N121E0" class="indexterm"></a>
 <p>
 <span class="bold"><strong>EXP</strong></span>
 </p>
@@ -10429,8 +10644,8 @@ ps.executeUpdate();
 <code class="literal">EXP ( &lt;num value expr&gt; ) </code>
 </p>
 <p>Returns the exponential value of the argument as a value of DOUBLE
-    type. (JDBC and Foundation)</p>
-<a name="N12143" class="indexterm"></a>
+    type. (JDBC and SQL:2016)</p>
+<a name="N121EE" class="indexterm"></a>
 <p>
 <span class="bold"><strong>FLOOR</strong></span>
 </p>
@@ -10440,8 +10655,8 @@ ps.executeUpdate();
 <p>Returns the largest integer that is less than or equal to the
     argument. If the argument is exact numeric then the result is exact
     numeric with a scale of 0. If the argument is approximate numeric, then
-    the result is of DOUBLE type. (JDBC and Foundation)</p>
-<a name="N12151" class="indexterm"></a>
+    the result is of DOUBLE type. (JDBC and SQL:2016)</p>
+<a name="N121FC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LN</strong></span>
 </p>
@@ -10449,8 +10664,8 @@ ps.executeUpdate();
 <code class="literal">LN ( &lt;num value expr&gt; ) </code>
 </p>
 <p>Returns the natural logarithm of the argument, as a value of DOUBLE
-    type. (Foundation)</p>
-<a name="N1215F" class="indexterm"></a>
+    type. (SQL:2016)</p>
+<a name="N1220A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LOG</strong></span>
 </p>
@@ -10459,7 +10674,7 @@ ps.executeUpdate();
 </p>
 <p>Returns the natural logarithm of the argument, as a value of DOUBLE
     type. (JDBC)</p>
-<a name="N1216D" class="indexterm"></a>
+<a name="N12218" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LOG10</strong></span>
 </p>
@@ -10468,7 +10683,7 @@ ps.executeUpdate();
 </p>
 <p>Returns the base 10 logarithm of the argument as a value of DOUBLE
     type. (JDBC)</p>
-<a name="N1217B" class="indexterm"></a>
+<a name="N12226" class="indexterm"></a>
 <p>
 <span class="bold"><strong>MOD</strong></span>
 </p>
@@ -10479,8 +10694,8 @@ ps.executeUpdate();
 <p>Returns the remainder (modulus) of <code class="literal">&lt;num value expr
     1&gt;</code> divided by <code class="literal">&lt;num value expr 2&gt;.</code>
     The data type of the returned value is the same as the second argument.
-    (JDBC and Foundation)</p>
-<a name="N1218F" class="indexterm"></a>
+    (JDBC and SQL:2016)</p>
+<a name="N1223A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>NANVL</strong></span>
 </p>
@@ -10492,7 +10707,7 @@ ps.executeUpdate();
     <code class="literal">&lt;num value expr 1&gt;</code> as <code class="literal">&lt;num value expr
     2&gt;.</code>, otherwise returns the first argument. The data type of
     the returned value is DOUBLE. (HyperSQL)</p>
-<a name="N121A3" class="indexterm"></a>
+<a name="N1224E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>PI</strong></span>
 </p>
@@ -10500,7 +10715,7 @@ ps.executeUpdate();
 <code class="literal">PI () </code>
 </p>
 <p>Returns the constant pi as a value of DOUBLE type. (JDBC)</p>
-<a name="N121B1" class="indexterm"></a>
+<a name="N1225C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>POWER</strong></span>
 </p>
@@ -10510,8 +10725,8 @@ ps.executeUpdate();
 </p>
 <p>Returns the value of <code class="literal">&lt;num value expr 1&gt;</code>
     raised to the power of <code class="literal">&lt;int value expr 2&gt;</code> as a
-    value of DOUBLE type. (JDBC and Foundation)</p>
-<a name="N121C5" class="indexterm"></a>
+    value of DOUBLE type. (JDBC and SQL:2016)</p>
+<a name="N12270" class="indexterm"></a>
 <p>
 <span class="bold"><strong>RADIANS</strong></span>
 </p>
@@ -10521,7 +10736,7 @@ ps.executeUpdate();
 <p>Converts the argument (an angle expressed in<code class="literal">
     degrees</code>) into radians and returns the value in the DOUBLE type.
     (JDBC)</p>
-<a name="N121D6" class="indexterm"></a>
+<a name="N12281" class="indexterm"></a>
 <p>
 <span class="bold"><strong>RAND</strong></span>
 </p>
@@ -10533,7 +10748,7 @@ ps.executeUpdate();
     session has a separate random number generator. The first call that uses a
     seed parameter sets the seed for subsequent calls that do not include a
     parameter. (JDBC)</p>
-<a name="N121E7" class="indexterm"></a>
+<a name="N12292" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ROUND</strong></span>
 </p>
@@ -10553,7 +10768,7 @@ ps.executeUpdate();
     and the argument and result are DOUBLE, It rounds the value towards the
     closest even value.</p>
 <p>The datetime version is discussed in the next section. (JDBC)</p>
-<a name="N12205" class="indexterm"></a>
+<a name="N122B0" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SIGN</strong></span>
 </p>
@@ -10563,7 +10778,7 @@ ps.executeUpdate();
 <p>Returns an INTEGER, indicating the sign of the argument. If the
     argument is negative then -1 is returned. If it is equal to zero then 0 is
     returned. If the argument is positive then 1 is returned. (JDBC)</p>
-<a name="N12213" class="indexterm"></a>
+<a name="N122BE" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SIN</strong></span>
 </p>
@@ -10572,7 +10787,7 @@ ps.executeUpdate();
 </p>
 <p>Returns the sine of the argument (an angle expressed in radians) as
     a value of DOUBLE type. (JDBC)</p>
-<a name="N12221" class="indexterm"></a>
+<a name="N122CC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SINH</strong></span>
 </p>
@@ -10581,7 +10796,7 @@ ps.executeUpdate();
 </p>
 <p>Returns the hyperbolic sine of the argument as a value of DOUBLE
     type. (HyperSQL)</p>
-<a name="N1222F" class="indexterm"></a>
+<a name="N122DA" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SQRT</strong></span>
 </p>
@@ -10589,8 +10804,8 @@ ps.executeUpdate();
 <code class="literal">SQRT ( &lt;num value expr&gt; ) </code>
 </p>
 <p>Returns the square root of the argument as a value of DOUBLE type.
-    (JDBC and Foundation)</p>
-<a name="N1223D" class="indexterm"></a>
+    (JDBC and SQL:2016)</p>
+<a name="N122E8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TAN</strong></span>
 </p>
@@ -10599,7 +10814,7 @@ ps.executeUpdate();
 </p>
 <p>Returns the tangent of the argument (an angle expressed in radians)
     as a value of DOUBLE type. (JDBC)</p>
-<a name="N1224B" class="indexterm"></a>
+<a name="N122F6" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TANH</strong></span>
 </p>
@@ -10608,7 +10823,7 @@ ps.executeUpdate();
 </p>
 <p>Returns the hyperbolic tangent of the argument as a value of DOUBLE
     type. (HyperSQL)</p>
-<a name="N12259" class="indexterm"></a>
+<a name="N12304" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TO_NUMBER</strong></span>
 </p>
@@ -10619,7 +10834,7 @@ ps.executeUpdate();
     string must consist of digits and can have a decimal point. Use the SQL
     Standard CAST expression instead of this non-standard function.
     (HyperSQL)</p>
-<a name="N12267" class="indexterm"></a>
+<a name="N12312" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TRUNC</strong></span>
 </p>
@@ -10632,7 +10847,7 @@ ps.executeUpdate();
     used in its place.</p>
 <p>The datetime version is discussed in the next section.
     (HyperSQL)</p>
-<a name="N1227A" class="indexterm"></a>
+<a name="N12325" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TRUNCATE</strong></span>
 </p>
@@ -10655,7 +10870,7 @@ ps.executeUpdate();
     column reference) then the type of the return value is always the same as
     the type of the first argument. In this case, the discarded digits are
     replaced with zeros. (JDBC)</p>
-<a name="N12296" class="indexterm"></a>
+<a name="N12341" class="indexterm"></a>
 <p>
 <span class="bold"><strong>WIDTH_BUCKET</strong></span>
 </p>
@@ -10676,7 +10891,7 @@ ps.executeUpdate();
     arguments, including <code class="literal">&lt;int value expr&gt;</code> smaller
     than 1, or equal values for <code class="literal">&lt;value expr 2&gt;</code> and
     <code class="literal">&lt;value expr 3&gt;</code> will cause an exception.
-    (Foundation)</p>
+    (SQL:2016)</p>
 <p>An example is given below:</p>
 <div class="informalexample">
 <pre class="programlisting"> WIDTH_BUCKET( 5, 10, 110, 10)
@@ -10712,33 +10927,36 @@ ps.executeUpdate();
 </div>
 </div>
 </div>
-<a name="N122D0" class="indexterm"></a>
+<a name="N1237B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TIMEZONE</strong></span>
 </p>
 <p>
 <code class="literal">TIMEZONE()</code>
 </p>
-<p>Returns the current time zone for the session. Returns an INTERVAL
-      HOUR TO MINUTE value. (HyperSQL)</p>
-<a name="N122DE" class="indexterm"></a>
+<p>Returns the current time zone for the session. This value is the
+      same as SESSION_TIMEZONE if the user has not changed the TIME ZONE of
+      the session. Returns an INTERVAL HOUR TO MINUTE value. (HyperSQL)</p>
+<a name="N12389" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SESSION_TIMEZONE</strong></span>
 </p>
 <p>
 <code class="literal">SESSION_TIMEZONE()</code>
 </p>
-<p>Returns the default time zone for the current session. Returns an
-      INTERVAL HOUR TO MINUTE value. (HyperSQL)</p>
-<a name="N122EC" class="indexterm"></a>
+<p>Returns the default time zone for the current session. This value
+      is based on the default Java Calendar for the current session. Returns
+      an INTERVAL HOUR TO MINUTE value. (HyperSQL)</p>
+<a name="N12397" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SESSIONTIMEZONE</strong></span>
 </p>
 <p>
 <code class="literal">SESSIONTIMEZONE()</code>
 </p>
-<p>Same as SESSION_TIMEZONE. (HyperSQL)</p>
-<a name="N122FA" class="indexterm"></a>
+<p>Similar to SESSION_TIMEZONE but converts the INTERVAL to a
+      VARCHAR. (HyperSQL)</p>
+<a name="N123A5" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DATABASE_TIMEZONE</strong></span>
 </p>
@@ -10766,14 +10984,14 @@ ps.executeUpdate();
 </div>
 </div>
 </div>
-<a name="N12315" class="indexterm"></a>
+<a name="N123C0" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CURRENT_DATE</strong></span>
 </p>
 <p>
 <code class="literal">CURRENT_DATE</code>
 </p>
-<a name="N12321" class="indexterm"></a>
+<a name="N123CC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CURRENT_TIME</strong></span>
 </p>
@@ -10781,14 +10999,14 @@ ps.executeUpdate();
 <code class="literal">CURRENT_TIME [ ( &lt;time precision&gt; )
       ]</code>
 </p>
-<a name="N1232D" class="indexterm"></a>
+<a name="N123D8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LOCALTIME</strong></span>
 </p>
 <p>
 <code class="literal">LOCALTIME [ ( &lt;time precision&gt; ) ]</code>
 </p>
-<a name="N12339" class="indexterm"></a>
+<a name="N123E4" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CURRENT_TIMESTAMP</strong></span>
 </p>
@@ -10796,7 +11014,7 @@ ps.executeUpdate();
 <code class="literal">CURRENT_TIMESTAMP [ ( &lt;timestamp precision&gt; )
       ]</code>
 </p>
-<a name="N12345" class="indexterm"></a>
+<a name="N123F0" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LOCALTIMESTAMP</strong></span>
 </p>
@@ -10805,17 +11023,22 @@ ps.executeUpdate();
       ]</code>
 </p>
 <p>These datetime functions return the datetime value representing
-      the moment the function is called. CURRENT_DATE returns a value of DATE
-      type. CURRENT_TIME returns a value of TIME WITH TIME ZONE type.
-      LOCALTIME returns a value of TIME type. CURRENT_TIMESTAMP returns a
-      value of TIMESTAMP WITH TIME ZONE type. LOCALTIMESTAMP returns a value
-      of TIMESTAMP type. If the optional <code class="literal">[ ( &lt;time precision&gt; )
-      ]</code> or<code class="literal"> [ ( &lt;timestamp precision&gt; ) ]</code> is
-      used, then the returned value has the specified fraction of the second
-      precision. When the functions are used multiple times in a single SQL
-      statement, the returned values represent the same point of time.
-      (Foundation)</p>
-<a name="N12359" class="indexterm"></a>
+      the moment the function is called. <code class="literal">CURRENT_DATE</code>
+      returns a value of DATE type. <code class="literal">CURRENT_TIME</code> returns a
+      value of TIME WITH TIME ZONE type. <code class="literal">LOCALTIME</code> returns
+      a value of TIME type. <code class="literal">CURRENT_TIMESTAMP</code> returns a
+      value of TIMESTAMP WITH TIME ZONE type.
+      <code class="literal">LOCALTIMESTAMP</code> returns a value of TIMESTAMP type. The
+      time zone of the SQL session is used. If the optional <code class="literal">[ (
+      &lt;time precision&gt; ) ]</code> or<code class="literal"> [ ( &lt;timestamp
+      precision&gt; ) ]</code> is used, then the returned value has the
+      specified fraction of the second precision. When the functions are used
+      multiple times in a single SQL statement, the returned values represent
+      the same point of time.</p>
+<p>From version 2.7.0 the functions return values with microsecond
+      precision. Previous versions returned values with millisecond precision.
+      (SQL:2016)</p>
+<a name="N12415" class="indexterm"></a>
 <p>
 <span class="bold"><strong>NOW</strong></span>
 </p>
@@ -10825,7 +11048,7 @@ ps.executeUpdate();
 <p>This function is equivalent to <code class="literal">LOCALTIMESTAMP</code>.
       It can be used as a no-arg function as the parens are optional.
       (HyperSQL)</p>
-<a name="N1236A" class="indexterm"></a>
+<a name="N12426" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CURDATE</strong></span>
 </p>
@@ -10834,7 +11057,7 @@ ps.executeUpdate();
 </p>
 <p>This function is equivalent to<code class="literal"> CURRENT_DATE</code>.
       (JDBC)</p>
-<a name="N1237B" class="indexterm"></a>
+<a name="N12437" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CURTIME</strong></span>
 </p>
@@ -10843,7 +11066,7 @@ ps.executeUpdate();
 </p>
 <p>This function is equivalent to<code class="literal"> LOCALTIME</code>.
       (JDBC)</p>
-<a name="N1238C" class="indexterm"></a>
+<a name="N12448" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SYSDATE</strong></span>
 </p>
@@ -10853,7 +11076,7 @@ ps.executeUpdate();
 <p>This no-arg function is similar to <code class="literal">LOCALTIMESTAMP
       </code>but it returns the timestamp without fraction of second.
       (HyperSQL)</p>
-<a name="N1239D" class="indexterm"></a>
+<a name="N12459" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SYSTIMESTAMP</strong></span>
 </p>
@@ -10863,7 +11086,7 @@ ps.executeUpdate();
 <p>This no-arg function is similar to
       <code class="literal">CURRENT_TIMESTAMP</code> and is enabled in ORA syntax mode
       only. It returns the timestamp when it is called. (HyperSQL)</p>
-<a name="N123AE" class="indexterm"></a>
+<a name="N1246A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TODAY</strong></span>
 </p>
@@ -10882,15 +11105,15 @@ ps.executeUpdate();
 </div>
 </div>
 </div>
-<a name="N123C3" class="indexterm"></a>
+<a name="N1247F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DATENAME, DATEPART and
       EOMONTH</strong></span>
 </p>
 <p>These functions are available in the MSS compatibility mode and
-      perform the equivalent of EXTRACT function or the LAST_DAY function.
-      (HyperSQL)</p>
-<a name="N123CE" class="indexterm"></a>
+      perform the equivalent of <code class="literal">EXTRACT</code> function or the
+      <code class="literal">LAST_DAY</code> function. (HyperSQL)</p>
+<a name="N12490" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DAYNAME</strong></span>
 </p>
@@ -10900,7 +11123,7 @@ ps.executeUpdate();
 <p>This function is equivalent to<code class="literal"> EXTRACT ( DAY_NAME FROM
       ... ) </code>Returns a string in the range of Sunday - Saturday.
       (JDBC)</p>
-<a name="N123DF" class="indexterm"></a>
+<a name="N124A1" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DAYOFMONTH</strong></span>
 </p>
@@ -10911,7 +11134,7 @@ ps.executeUpdate();
 <p>This function is equivalent to<code class="literal"> EXTRACT ( DAY_OF_MONTH
       FROM ... ) </code>Returns an integer value in the range of 1-31.
       (JDBC)</p>
-<a name="N123F0" class="indexterm"></a>
+<a name="N124B2" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DAYOFWEEK</strong></span>
 </p>
@@ -10922,7 +11145,7 @@ ps.executeUpdate();
 <p>This function is equivalent to <code class="literal">EXTRACT ( DAY_OF_WEEK FROM
       ... ) </code>Returns an integer value in the range of 1-7. The first
       day of the week is Sunday. (JDBC)</p>
-<a name="N12401" class="indexterm"></a>
+<a name="N124C3" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DAYOFYEAR</strong></span>
 </p>
@@ -10933,7 +11156,7 @@ ps.executeUpdate();
 <p>This function is equivalent to <code class="literal">EXTRACT ( DAY_OF_YEAR FROM
       ... ) </code>Returns an integer value in the range of 1-366.
       (JDBC)</p>
-<a name="N12412" class="indexterm"></a>
+<a name="N124D4" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DAYS</strong></span>
 </p>
@@ -10943,7 +11166,7 @@ ps.executeUpdate();
 <p>The <code class="literal">&lt;datetime value expr&gt; </code>is of DATE or
       TIMESTAMP type. This function returns the DAY number since the first day
       of the calendar. The first day is numbered 1. (HyperSQL)</p>
-<a name="N12423" class="indexterm"></a>
+<a name="N124E5" class="indexterm"></a>
 <p>
 <span class="bold"><strong>HOUR</strong></span>
 </p>
@@ -10952,7 +11175,7 @@ ps.executeUpdate();
 </p>
 <p>This function is equivalent to <code class="literal">EXTRACT ( HOUR FROM ... )
       </code>Returns an integer value in the range of 0-23. (JDBC)</p>
-<a name="N12434" class="indexterm"></a>
+<a name="N124F6" class="indexterm"></a>
 <p>
 <span class="bold"><strong>MINUTE</strong></span>
 </p>
@@ -10962,7 +11185,7 @@ ps.executeUpdate();
 <p>This function is equivalent to<code class="literal"> EXTRACT ( MINUTE FROM ...
       ) </code>Returns an integer value in the range of 0 - 59.
       (JDBC)</p>
-<a name="N12445" class="indexterm"></a>
+<a name="N12507" class="indexterm"></a>
 <p>
 <span class="bold"><strong>MONTH</strong></span>
 </p>
@@ -10971,7 +11194,7 @@ ps.executeUpdate();
 </p>
 <p>This function is equivalent to <code class="literal">EXTRACT ( MONTH FROM ... )
       </code>Returns an integer value in the range of 1-12. (JDBC)</p>
-<a name="N12456" class="indexterm"></a>
+<a name="N12518" class="indexterm"></a>
 <p>
 <span class="bold"><strong>MONTHNAME</strong></span>
 </p>
@@ -10982,7 +11205,7 @@ ps.executeUpdate();
 <p>This function is equivalent to <code class="literal">EXTRACT ( NAME_OF_MONTH
       FROM ... ) </code>Returns a string in the range of January -
       December. (JDBC)</p>
-<a name="N12467" class="indexterm"></a>
+<a name="N12529" class="indexterm"></a>
 <p>
 <span class="bold"><strong>QUARTER</strong></span>
 </p>
@@ -10991,7 +11214,7 @@ ps.executeUpdate();
 </p>
 <p>This function is equivalent to <code class="literal">EXTRACT ( QUARTER FROM ...
       ) </code>Returns an integer in the range of 1 - 4. (JDBC)</p>
-<a name="N12478" class="indexterm"></a>
+<a name="N1253A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SECOND</strong></span>
 </p>
@@ -10999,9 +11222,9 @@ ps.executeUpdate();
 <code class="literal">SECOND ( &lt;datetime value expr&gt; )</code>
 </p>
 <p>This function is equivalent to <code class="literal">EXTRACT ( SECOND FROM ...
-      ) </code>Returns an integer or decimal in the range of 0 - 59, with
-      the same precision as the &lt;datetime value expr&gt;. (JDBC)</p>
-<a name="N12489" class="indexterm"></a>
+      ) </code>Returns a decimal in the range of 0 - 60, with the same
+      precision as the &lt;datetime value expr&gt;. (JDBC)</p>
+<a name="N1254B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SECONDS_SINCE_MIDNIGHT</strong></span>
 </p>
@@ -11012,7 +11235,7 @@ ps.executeUpdate();
 <p>This function is equivalent to<code class="literal"> EXTRACT (
       SECONDS_SINCE_MIDNIGHT FROM ... ) </code>Returns an integer in the
       range of 0 - 86399. (HyperSQL)</p>
-<a name="N1249A" class="indexterm"></a>
+<a name="N1255C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>UNIX_MILLIS</strong></span>
 </p>
@@ -11024,7 +11247,7 @@ ps.executeUpdate();
       returns the number of milliseconds since 1970-01-01. With a DATE or
       TIMESTAMP parameter, it converts the argument into number of
       milliseconds since 1970-01-01. (HyperSQL)</p>
-<a name="N124A8" class="indexterm"></a>
+<a name="N1256A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>UNIX_TIMESTAMP</strong></span>
 </p>
@@ -11035,9 +11258,10 @@ ps.executeUpdate();
 <p>This function returns a BIGINT value. With no parameter, it
       returns the number of seconds since 1970-01-01. With a DATE or TIMESTAMP
       parameter, it converts the argument into number of seconds since
-      1970-01-01. See also the TIMESTAMP ( &lt;num value expression&gt;)
-      function to return a TIMESTAMP from a Unix timestamp. (HyperSQL)</p>
-<a name="N124B6" class="indexterm"></a>
+      1970-01-01. See also the <code class="literal">TIMESTAMP ( &lt;num value
+      expression&gt; )</code> function to return a TIMESTAMP from a Unix
+      timestamp. (HyperSQL)</p>
+<a name="N1257B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>WEEK</strong></span>
 </p>
@@ -11047,7 +11271,7 @@ ps.executeUpdate();
 <p>This function is equivalent to<code class="literal"> EXTRACT ( WEEK_OF_YEAR
       FROM ... ) </code>Returns an integer in the range of 1 - 54.
       (JDBC)</p>
-<a name="N124C7" class="indexterm"></a>
+<a name="N1258C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>YEAR</strong></span>
 </p>
@@ -11056,7 +11280,7 @@ ps.executeUpdate();
 </p>
 <p>This function is equivalent to<code class="literal"> EXTRACT ( YEAR FROM ... )
       </code>Returns an integer in the range of 1 - 9999. (JDBC)</p>
-<a name="N124D8" class="indexterm"></a>
+<a name="N1259D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>EXTRACT</strong></span>
 </p>
@@ -11108,7 +11332,7 @@ ps.executeUpdate();
       MINUTE | SECOND | SECONDS_MIDNIGHT</code> options may be valid for
       INTERVAL types based on seconds. For example,<code class="literal"> DAY | HOUR |
       MINUTE</code> are the only valid fields for the INTERVAL DAY TO
-      MINUTE data type. (Foundation with HyperSQL extensions)</p>
+      MINUTE data type. (SQL:2016 with HyperSQL extensions)</p>
 </div>
 <div class="section">
 <div class="titlepage">
@@ -11119,7 +11343,7 @@ ps.executeUpdate();
 </div>
 </div>
 </div>
-<a name="N12533" class="indexterm"></a>
+<a name="N125F8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>NEXT_DAY</strong></span>
 </p>
@@ -11132,7 +11356,7 @@ ps.executeUpdate();
       occurs after the first date. For example, next Wednesday is expressed as
       <code class="literal">NEXT_DAY(CURRENT_DATE, 'WEDNESDAY')</code>.
       (HyperSQL)</p>
-<a name="N12544" class="indexterm"></a>
+<a name="N12609" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ADD_MONTHS</strong></span>
 </p>
@@ -11140,8 +11364,8 @@ ps.executeUpdate();
 <code class="literal">ADD_MONTHS ( &lt;datetime value expr&gt;, &lt;numeric
       value expr&gt;)</code>
 </p>
-<p>This function is similar but different to simple addition a MONTH
-      interval to a datetime value. The SQL Standard expression,
+<p>This function is similar but different to simple addition of a
+      MONTH interval to a datetime value. The SQL Standard expression,
       <code class="literal">&lt;datetime value expr&gt; + n MONTH</code>, when used with
       the last day of a short month such as February, returns a date that has
       the same day of the month in the target month. The
@@ -11159,7 +11383,7 @@ ps.executeUpdate();
  2012-03-31 00:00:00 2012-03-29 
 </pre>
 </div>
-<a name="N1255E" class="indexterm"></a>
+<a name="N12623" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LAST_DAY</strong></span>
 </p>
@@ -11179,7 +11403,7 @@ ps.executeUpdate();
  2012-02-29 12:30:44 
 </pre>
 </div>
-<a name="N12573" class="indexterm"></a>
+<a name="N12638" class="indexterm"></a>
 <p>
 <span class="bold"><strong>MONTHS_BETWEEN</strong></span>
 </p>
@@ -11190,7 +11414,7 @@ ps.executeUpdate();
 <p>Returns a number (not an INTERVAL) possibly with a fraction,
       representing the number of months between two days. If both dates have
       the same day of month, or are on the last day of the month, the result
-      is an exact numeric. Otherwise, the fraction is calculated base on 31
+      is an exact numeric. Otherwise, the fraction is calculated based on 31
       days per month. You can cast the resulting value into INTERVAL MONTH and
       use it for datetime arithmetic. (HyperSQL)</p>
 <div class="informalexample">
@@ -11201,7 +11425,7 @@ ps.executeUpdate();
  13.32258064516129000000000000000000 
 </pre>
 </div>
-<a name="N12585" class="indexterm"></a>
+<a name="N1264A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TIMESTAMPADD</strong></span>
 </p>
@@ -11209,7 +11433,7 @@ ps.executeUpdate();
 <code class="literal">TIMESTAMPADD ( &lt;tsi datetime field&gt;, &lt;numeric
       value expression&gt;, &lt;datetime value expr&gt;)</code>
 </p>
-<a name="N12591" class="indexterm"></a>
+<a name="N12656" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TIMESTAMPDIFF</strong></span>
 </p>
@@ -11237,18 +11461,20 @@ ps.executeUpdate();
 <p>The two JDBC functions, <code class="literal">TIMESTAMPADD </code>and
       <code class="literal">TIMESTAMPDIFF</code> perform a similar function to the above
       SQL expressions. The &lt;tsi datetime field&gt; names are keywords and
-      are different from those used in the EXTRACT functions. These names are
-      valid for use only when calling these two functions. With TIMESTAMPDIFF,
-      the names indicate the unit of time used to compute the difference
-      between two datetime fields. With TIMESTAMPADD they represent the unit
-      of time used for the &lt;numeric value expression&gt;. The unit of time
-      for each name is self-explanatory. In the case of SQL_TSI_FRAC_SECOND,
-      the unit is nanosecond.</p>
+      are different from those used in the <code class="literal">EXTRACT</code>
+      functions. These names are valid for use only when calling these two
+      functions. With <code class="literal">TIMESTAMPDIFF</code>, the names indicate the
+      unit of time used to compute the difference between two datetime fields.
+      With TIMESTAMPADD they represent the unit of time used for the
+      &lt;numeric value expression&gt;. The unit of time for each name is
+      self-explanatory. In the case of SQL_TSI_FRAC_SECOND, the unit is
+      nanosecond.</p>
 <p>The return value for TIMESTAMPADD is of the same type as the
-      datetime argument used. The return type for TIMESTAMPDIFF is always
-      BIGINT, regardless of the type of arguments. The two datetime arguments
-      of TIMESTAMPDIFF should be of the same type. The TIME type is not
-      supported for the arguments to these functions.</p>
+      datetime argument used. The return type for
+      <code class="literal">TIMESTAMPDIFF</code> is always BIGINT, regardless of the
+      type of arguments. The two datetime arguments of
+      <code class="literal">TIMESTAMPDIFF</code> should be of the same type. The TIME
+      type is not supported for the arguments to these functions.</p>
 <p>
 <code class="literal">TIMESTAMPDIFF</code> is evaluated as &lt;datetime
       value expr 2&gt; - &lt;datetime value expr 1&gt;. (JDBC)</p>
@@ -11258,7 +11484,7 @@ ps.executeUpdate();
  TIMESTAMPDIFF ( SQL_TSI_HOUR, TIMESTAMP '2008-11-20 20:30:40', TIMESTAMP '2008-11-21 21:30:40' )
 </pre>
 </div>
-<a name="N125C2" class="indexterm"></a>
+<a name="N12693" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DATE_ADD</strong></span>
 </p>
@@ -11266,7 +11492,7 @@ ps.executeUpdate();
 <code class="literal">DATE_ADD ( &lt;datetime value expr&gt; , &lt;interval
       value expr&gt; )</code>
 </p>
-<a name="N125CE" class="indexterm"></a>
+<a name="N1269F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DATE_SUB</strong></span>
 </p>
@@ -11287,7 +11513,7 @@ ps.executeUpdate();
  DATE_SUB ( TIMESTAMP '2008-11-22 20:30:40', INTERVAL 20 HOUR )
 </pre>
 </div>
-<a name="N125DF" class="indexterm"></a>
+<a name="N126B0" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DATEADD</strong></span>
 </p>
@@ -11295,7 +11521,7 @@ ps.executeUpdate();
 <code class="literal">DATEADD ( &lt;field&gt;, &lt;numeric value expr&gt;,
       &lt;datetime value expr&gt; )</code>
 </p>
-<a name="N125EB" class="indexterm"></a>
+<a name="N126BC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DATEDIFF</strong></span>
 </p>
@@ -11312,9 +11538,10 @@ ps.executeUpdate();
 <code class="literal">&lt;field&gt; ::= YY | YEAR | MM | MONTH | DD | DAY | HH
       | HOUR | MI | MINUTE | SS | SECOND | MS | MILLISECOND</code>
 </p>
-<p>The DATEADD and DATEDIFF functions are alternatives to
-      TIMESTAMPADD and TIMESTAMPDIFF, with fewer available field options. The
-      field names are specified as strings or as keywords. The short field
+<p>The <code class="literal">DATEADD</code> and <code class="literal">DATEDIFF</code>
+      functions are alternatives to <code class="literal">TIMESTAMPADD</code> and
+      <code class="literal">TIMESTAMPDIFF</code>, with fewer available field options.
+      The field names are specified as strings or as keywords. The short field
       names translate to YEAR, MONTH, DAY, HOUR, MINUTE, SECOND and
       MILLISECOND. <code class="literal">DATEDIFF</code> is evaluated as &lt;datetime
       value expr 2&gt; - &lt;datetime value expr 1&gt;. (HyperSQL}</p>
@@ -11335,7 +11562,7 @@ ps.executeUpdate();
  DATEDIFF ( 'hour', TIMESTAMP '2008-11-22 20:30:40', TIMESTAMP '2008-11-22 00:30:40' )
 </pre>
 </div>
-<a name="N12610" class="indexterm"></a>
+<a name="N126ED" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ROUND</strong></span>
 </p>
@@ -11354,7 +11581,7 @@ ps.executeUpdate();
       date or midnight the next day if the time is at or after 12 noon. If the
       second argument is omitted, the datetime value is rounded to the nearest
       day. (HyperSQL)</p>
-<a name="N12624" class="indexterm"></a>
+<a name="N12701" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TRUNC</strong></span>
 </p>
@@ -11369,8 +11596,9 @@ ps.executeUpdate();
       table for TO_CHAR and TO_DATE format elements (see below). The datetime
       value is truncated after the specified field and the rest of the fields
       to the right are set to one for MONTH and DAY, or zero, for the rest of
-      the fields. For example, applying TRUNC to a timestamp value on the DAY
-      field results in midnight the same date. Examples of ROUND and TRUNC
+      the fields. For example, applying <code class="literal">TRUNC</code> to a
+      timestamp value on the DAY field results in midnight the same date.
+      Examples of <code class="literal">ROUND</code> and <code class="literal">TRUNC</code>
       functions are given below. If the second argument is omitted, the
       datetime value is truncated to midnight the same date. (HyperSQL)</p>
 <div class="informalexample">
@@ -11393,7 +11621,32 @@ ps.executeUpdate();
 </div>
 </div>
 </div>
-<a name="N1263F" class="indexterm"></a>
+<a name="N12725" class="indexterm"></a>
+<p>
+<span class="bold"><strong>FROM_TZ</strong></span>
+</p>
+<p>
+<code class="literal">FROM_TZ ( &lt;timestamp value expr&gt;, &lt;zone or
+      interval spec string&gt; )</code>
+</p>
+<p>This function takes the date-time (year, month, day, hour, minute,
+      second, fraction) from the first argument and the time zone from the
+      second argument to construct a TIMESTAMP WITH TIME ZONE value. The
+      output can represent a different point of universal time (UTC) than the
+      input. This is different from the AT TIME ZONE expression which keeps
+      the UTC value and changes the zone. (HyperSQL)</p>
+<div class="informalexample">
+<pre class="programlisting">-- the output shows the same timestamp as the input, but with the time zone of the specified region
+VALUES FROM_TZ(TIMESTAMP'2022-03-28 11:00:00+4:00','America/Chicago')
+ C1                              
+ ------------------------------- 
+ 2022-03-28 11:00:00.000000-5:00 
+
+-- this example has the same output as the previous one
+VALUES FROM_TZ(TIMESTAMP'2022-03-28 11:00:00','-5:00')
+</pre>
+</div>
+<a name="N12736" class="indexterm"></a>
 <p>
 <span class="bold"><strong>NUMTODSINTERVAL</strong></span>
 </p>
@@ -11404,7 +11657,7 @@ ps.executeUpdate();
 <p>This function converts the numeric value to an interval, exactly
       like CAST. The interval spec string is one of 'DAY', 'HOUR', 'MINUTE',
       'SECOND'. (HyperSQL)</p>
-<a name="N1264D" class="indexterm"></a>
+<a name="N12744" class="indexterm"></a>
 <p>
 <span class="bold"><strong>NUMTOYMINTERVAL</strong></span>
 </p>
@@ -11415,7 +11668,7 @@ ps.executeUpdate();
 <p>This function converts the numeric value to an interval, exactly
       like CAST. The interval spec string is 'YEAR' or 'MONTH'.
       (HyperSQL)</p>
-<a name="N1265B" class="indexterm"></a>
+<a name="N12752" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TIMESTAMP</strong></span>
 </p>
@@ -11433,7 +11686,7 @@ ps.executeUpdate();
 <code class="literal">TIMESTAMP ( &lt;date value expr&gt;, &lt;time value
       expr&gt; )</code>
 </p>
-<p>This function translates the arguments into a TIMESTAMP WIHOUT
+<p>This function translates the arguments into a TIMESTAMP WITHOUT
       TIME ZONE value.</p>
 <p>When the single argument is a numeric value, it is interpreted as
       a Unix timestamp in seconds.</p>
@@ -11450,7 +11703,7 @@ ps.executeUpdate();
  TIMESTAMP '2008-11-22 20:30:40.000000'
 </pre>
 </div>
-<a name="N1267B" class="indexterm"></a>
+<a name="N12772" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TIMESTAMP_WITH_ZONE</strong></span>
 </p>
@@ -11467,7 +11720,7 @@ ps.executeUpdate();
       For example, if the local time zone was +4:00 at the time of the given
       Unix timestamp, the returned value is local timestamp at the time with
       time zone +4:00.</p>
-<a name="N12690" class="indexterm"></a>
+<a name="N12787" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TO_CHAR</strong></span>
 </p>
@@ -11496,7 +11749,7 @@ ps.executeUpdate();
       format strings should not be used. You can include a string literal
       inside the format string by enclosing it in double quotes (see the
       second example above). (HyperSQL)</p>
-<a name="N126A6" class="indexterm"></a>
+<a name="N1279D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TO_DATE</strong></span>
 </p>
@@ -11507,7 +11760,7 @@ ps.executeUpdate();
 <p>This function translates a formatted datetime sting to a
       TIMESTAMP(0) according to the format given in the second argument. See
       TO_TIMESTAMP below for further details.</p>
-<a name="N126B4" class="indexterm"></a>
+<a name="N127AB" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TO_TIMESTAMP</strong></span>
 </p>
@@ -11542,7 +11795,7 @@ ps.executeUpdate();
 <p>The supported format components are all uppercase as
       follows:</p>
 <div class="table">
-<a name="N126CE"></a>
+<a name="N127C5"></a>
 <p class="title">
 <b>Table&nbsp;4.1.&nbsp;TO_CHAR, TO_DATE and TO_TIMESTAMP format elements</b>
 </p>
@@ -11691,7 +11944,7 @@ ps.executeUpdate();
 <p>Array functions are specialised functions with ARRAY parameters or
     return values. For the ARRAY_AGG aggregate function, see the <a class="link" href="#dataaccess-chapt" title="Chapter&nbsp;5.&nbsp;Data Access and Change">Data Access and Change</a>
     chapter.</p>
-<a name="N12783" class="indexterm"></a>
+<a name="N1287A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CARDINALITY</strong></span>
 </p>
@@ -11699,8 +11952,8 @@ ps.executeUpdate();
 <code class="literal">CARDINALITY( &lt;array value expr&gt; )</code>
 </p>
 <p>Returns the element count for the given array argument.
-    (Foundation)</p>
-<a name="N12791" class="indexterm"></a>
+    (SQL:2016)</p>
+<a name="N12888" class="indexterm"></a>
 <p>
 <span class="bold"><strong>MAX_CARDINALITY</strong></span>
 </p>
@@ -11709,8 +11962,8 @@ ps.executeUpdate();
     )</code>
 </p>
 <p>Returns the maximum allowed element count for the given array
-    argument. (Foundation)</p>
-<a name="N1279F" class="indexterm"></a>
+    argument. (SQL:2016)</p>
+<a name="N12896" class="indexterm"></a>
 <p>
 <span class="bold"><strong>POSITION_ARRAY</strong></span>
 </p>
@@ -11723,7 +11976,7 @@ ps.executeUpdate();
     the beginning of the array. The optional <code class="literal">&lt;int value
     expr&gt;</code> specifies the start position. Positions are counted
     from 1. Returns zero if no match is found. (HyperSQL)</p>
-<a name="N127B3" class="indexterm"></a>
+<a name="N128AA" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SORT_ARRAY</strong></span>
 </p>
@@ -11733,7 +11986,7 @@ ps.executeUpdate();
 </p>
 <p>Returns a sorted copy of the array. By default, sort is performed in
     ascending order and NULL elements are sorted first. (HyperSQL)</p>
-<a name="N127C1" class="indexterm"></a>
+<a name="N128B8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TRIM_ARRAY</strong></span>
 </p>
@@ -11744,8 +11997,8 @@ ps.executeUpdate();
 <p>Returns a new array that contains the elements of the
     <code class="literal">&lt;array value expr&gt;</code> minus the number of elements
     specified by the <code class="literal">&lt;num value expr&gt;. </code>Elements are
-    discarded from the end of the array. (Foundation)</p>
-<a name="N127D5" class="indexterm"></a>
+    discarded from the end of the array. (SQL:2016)</p>
+<a name="N128CC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SEQUENCE_ARRAY</strong></span>
 </p>
@@ -11807,8 +12060,9 @@ ps.executeUpdate();
 <p>General functions can take different types of arguments. Some
     General Functions accept a variable number of arguments.</p>
 <p>Also see the <a class="link" href="#dataaccess-chapt" title="Chapter&nbsp;5.&nbsp;Data Access and Change">Data Access and Change</a> chapter for SQL expressions that are
-    similar to functions, for example CAST and NULLIF.</p>
-<a name="N12801" class="indexterm"></a>
+    similar to functions, for example <code class="literal">CAST</code> and
+    <code class="literal">NULLIF</code>.</p>
+<a name="N128FE" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CASEWHEN</strong></span>
 </p>
@@ -11819,9 +12073,9 @@ ps.executeUpdate();
 <p>If the <code class="literal">&lt;boolean value expr&gt;</code> is true,
     returns <code class="literal">&lt;value expr 2&gt;</code> otherwise returns
     <code class="literal">&lt;value expr 3&gt;. Use a CASE WHEN expression instead for more
-    extensive capabilities and options.</code> CASE WHEN is documented in
-    the <a class="link" href="#dataaccess-chapt" title="Chapter&nbsp;5.&nbsp;Data Access and Change">Data Access and Change</a> chapter. (HyperSQL)</p>
-<a name="N1281D" class="indexterm"></a>
+    extensive capabilities and options.</code> <code class="literal">CASE WHEN</code>
+    is documented in the <a class="link" href="#dataaccess-chapt" title="Chapter&nbsp;5.&nbsp;Data Access and Change">Data Access and Change</a> chapter. (HyperSQL)</p>
+<a name="N1291D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>COALESCE</strong></span>
 </p>
@@ -11831,8 +12085,8 @@ ps.executeUpdate();
 </p>
 <p>Returns <code class="literal">&lt;value expr 1&gt;</code> if it is not null,
     otherwise returns <code class="literal">&lt;value expr 2&gt;</code> if not null and
-    so on. The type of both arguments must be comparable. (Foundation)</p>
-<a name="N12831" class="indexterm"></a>
+    so on. The type of both arguments must be comparable. (SQL:2016)</p>
+<a name="N12931" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CONVERT</strong></span>
 </p>
@@ -11871,7 +12125,7 @@ ps.executeUpdate();
 <p>When MS SQL Server compatibility mode is on, the parameters of
     CONVERT are switched and only the real type names with required precision,
     scale or length are allowed. (JDBC)</p>
-<a name="N1285D" class="indexterm"></a>
+<a name="N1295D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DECODE</strong></span>
 </p>
@@ -11891,7 +12145,7 @@ ps.executeUpdate();
     returned. The type of the return value is a combination of the types of
     the <code class="literal">&lt;value expr result ... &gt;</code> arguments.
     (HyperSQL)</p>
-<a name="N12880" class="indexterm"></a>
+<a name="N12980" class="indexterm"></a>
 <p>
 <span class="bold"><strong>GREATEST</strong></span>
 </p>
@@ -11903,11 +12157,11 @@ ps.executeUpdate();
     arguments with each other and returns the greatest argument. The return
     type is the combined type of the arguments. Arguments can be of any type,
     so long as they are comparable. (HyperSQL)</p>
-<a name="N1288E" class="indexterm"></a>
+<a name="N1298E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>IFNULL</strong></span>
 </p>
-<a name="N12897" class="indexterm"></a>
+<a name="N12997" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ISNULL</strong></span>
 </p>
@@ -11921,7 +12175,7 @@ ps.executeUpdate();
     Almost equivalent to SQL Standard <code class="literal">COALESCE(&lt;value expr 1&gt;,
     &lt;value expr 2&gt;)</code> function, but without type modification.
     (JDBC)</p>
-<a name="N128B1" class="indexterm"></a>
+<a name="N129B1" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LEAST</strong></span>
 </p>
@@ -11933,7 +12187,7 @@ ps.executeUpdate();
     arguments with each other and returns the smallest argument. The return
     type is the combined type of the arguments. Arguments can be of any type,
     so long as they are comparable. (HyperSQL)</p>
-<a name="N128BF" class="indexterm"></a>
+<a name="N129BF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LOAD_FILE</strong></span>
 </p>
@@ -11950,7 +12204,7 @@ ps.executeUpdate();
     property must be set <code class="literal">true</code> in order to access files
     outside the directory structure of the database files.</p>
 <p>(HyperSQL)</p>
-<a name="N128D7" class="indexterm"></a>
+<a name="N129D7" class="indexterm"></a>
 <p>
 <span class="bold"><strong>NULLIF</strong></span>
 </p>
@@ -11961,8 +12215,8 @@ ps.executeUpdate();
 <p>Returns <code class="literal">&lt;value expr 1&gt;</code> if it is not equal
     to <code class="literal">&lt;value expr 2&gt;</code>, otherwise returns null. The
     type of both arguments must be the same. This function is a shorthand for
-    a specific CASE expression. (Foundation)</p>
-<a name="N128EB" class="indexterm"></a>
+    a specific CASE expression. (SQL:2016)</p>
+<a name="N129EB" class="indexterm"></a>
 <p>
 <span class="bold"><strong>NVL</strong></span>
 </p>
@@ -11977,7 +12231,7 @@ ps.executeUpdate();
     and <code class="literal">&lt;value expr 2&gt;</code> is a DOUBLE constant, the
     return type is cast into INTEGER. This function is similar to IFNULL.
     (HyperSQL)</p>
-<a name="N12908" class="indexterm"></a>
+<a name="N12A08" class="indexterm"></a>
 <p>
 <span class="bold"><strong>NVL2</strong></span>
 </p>
@@ -11990,7 +12244,7 @@ ps.executeUpdate();
     <code class="literal">&lt;value expr 3&gt;</code>. The type of the return value is
     the type of <code class="literal">&lt;value expr 2&gt;</code> unless it is null.
     (HyperSQL)</p>
-<a name="N12922" class="indexterm"></a>
+<a name="N12A22" class="indexterm"></a>
 <p>
 <span class="bold"><strong>UUID</strong></span>
 </p>
@@ -12031,7 +12285,7 @@ ps.executeUpdate();
 </div>
 </div>
 </div>
-<a name="N12946" class="indexterm"></a>
+<a name="N12A46" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CRYPT_KEY</strong></span>
 </p>
@@ -12045,7 +12299,7 @@ ps.executeUpdate();
     <code class="literal">&lt;value expr 2&gt;</code>. To use the default provider,
     specify null for <code class="literal">&lt;value expr 2&gt;</code>.
     (HyperSQL)</p>
-<a name="N1295D" class="indexterm"></a>
+<a name="N12A5D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DIAGNOSTICS</strong></span>
 </p>
@@ -12060,7 +12314,7 @@ ps.executeUpdate();
     statements. Calling this function immediately after executing an INSERT,
     UPDATE, DELETE or MERGE statement returns the row count for the last
     statement, as it is returned by the JDBC statement. (HyperSQL)</p>
-<a name="N12971" class="indexterm"></a>
+<a name="N12A71" class="indexterm"></a>
 <p>
 <span class="bold"><strong>IDENTITY</strong></span>
 </p>
@@ -12075,7 +12329,7 @@ ps.executeUpdate();
     function call separately and is not affected by inserts in other sessions.
     The statement can be executed as a direct statement or a prepared
     statement. (HyperSQL)</p>
-<a name="N1297F" class="indexterm"></a>
+<a name="N12A7F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DATABASE</strong></span>
 </p>
@@ -12084,7 +12338,7 @@ ps.executeUpdate();
 </p>
 <p>Returns the file name (without directory information) of the
     database. (JDBC)</p>
-<a name="N1298D" class="indexterm"></a>
+<a name="N12A8D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DATABASE_NAME</strong></span>
 </p>
@@ -12097,7 +12351,7 @@ ps.executeUpdate();
     by an admin user but the new name must be all uppercase and 16 characters
     long. This name is used in log messages with external logging frameworks.
     (HyperSQL)</p>
-<a name="N1299B" class="indexterm"></a>
+<a name="N12A9B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DATABASE_VERSION</strong></span>
 </p>
@@ -12105,8 +12359,8 @@ ps.executeUpdate();
 <code class="literal">DATABASE_VERSION ()</code>
 </p>
 <p>Returns the full version string for the database engine. For
-    example, 2.5.0. (JDBC)</p>
-<a name="N129A9" class="indexterm"></a>
+    example, 2.7.0. (JDBC)</p>
+<a name="N12AA9" class="indexterm"></a>
 <p>
 <span class="bold"><strong>USER</strong></span>
 </p>
@@ -12115,42 +12369,42 @@ ps.executeUpdate();
 </p>
 <p>Equivalent to the SQL function <code class="literal">CURRENT_USER</code>.
     (JDBC)</p>
-<a name="N129BA" class="indexterm"></a>
+<a name="N12ABA" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CURRENT_USER</strong></span>
 </p>
 <p>
 <code class="literal">CURRENT_USER</code>
 </p>
-<a name="N129C6" class="indexterm"></a>
+<a name="N12AC6" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CURRENT_ROLE</strong></span>
 </p>
 <p>
 <code class="literal">CURRENT_ROLE</code>
 </p>
-<a name="N129D2" class="indexterm"></a>
+<a name="N12AD2" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SESSION_USER</strong></span>
 </p>
 <p>
 <code class="literal">SESSION_USER</code>
 </p>
-<a name="N129DE" class="indexterm"></a>
+<a name="N12ADE" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SYSTEM_USER</strong></span>
 </p>
 <p>
 <code class="literal">SYSTEM_USER</code>
 </p>
-<a name="N129EA" class="indexterm"></a>
+<a name="N12AEA" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CURRENT_SCHEMA</strong></span>
 </p>
 <p>
 <code class="literal">CURRENT_SCHEMA</code>
 </p>
-<a name="N129F6" class="indexterm"></a>
+<a name="N12AF6" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CURRENT_CATALOG</strong></span>
 </p>
@@ -12159,16 +12413,23 @@ ps.executeUpdate();
 </p>
 <p>These functions return the named current session attribute. They are
     all SQL Standard functions.</p>
-<p>The CURRENT_USER is the user that connected to the database, or a
-    user subsequently set by the SET AUTHORIZATION statement.</p>
-<p>SESSION_USER is the same as CURRENT_USER</p>
-<p>SYSTEM_USER is the user that connected to the database. It is not
-    changed with any command until the session is closed.</p>
-<p>CURRENT_SCHEMA is default schema of the user, or a schema
-    subsequently set by the SET SCHEMA command.</p>
-<p>CURRENT_CATALOG is always the same within a given HyperSQL database
-    and indicates the name of the catalog.</p>
-<a name="N12A0E" class="indexterm"></a>
+<p>The <code class="literal">CURRENT_USER</code> is the user that connected to
+    the database, or a user subsequently set by the <code class="literal">SET
+    AUTHORIZATION</code> statement.</p>
+<p>
+<code class="literal">SESSION_USER</code> is the same as CURRENT_USER</p>
+<p>
+<code class="literal">SYSTEM_USER</code> is the user that connected to the
+    database. It is not changed with any command until the session is
+    closed.</p>
+<p>
+<code class="literal">CURRENT_SCHEMA</code> is default schema of the user, or
+    a schema subsequently set by the <code class="literal">SET SCHEMA</code>
+    command.</p>
+<p>
+<code class="literal">CURRENT_CATALOG</code> is always the same within a given
+    HyperSQL database and indicates the name of the catalog.</p>
+<a name="N12B1F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>IS_AUTOCOMMIT</strong></span>
 </p>
@@ -12177,7 +12438,7 @@ ps.executeUpdate();
 </p>
 <p>Returns TRUE if the session is in auto-commit mode.
     (HyperSQL)</p>
-<a name="N12A1C" class="indexterm"></a>
+<a name="N12B2D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>IS_READONLY_SESSION</strong></span>
 </p>
@@ -12185,7 +12446,7 @@ ps.executeUpdate();
 <code class="literal">IS_READONLY_SESSION()</code>
 </p>
 <p>Returns TRUE if the session is in read only mode. (HyperSQL)</p>
-<a name="N12A2A" class="indexterm"></a>
+<a name="N12B3B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>IS_READONLY_DATABASE</strong></span>
 </p>
@@ -12194,7 +12455,7 @@ ps.executeUpdate();
 </p>
 <p>Returns TRUE if the database is a read only database.
     (HyperSQL)</p>
-<a name="N12A38" class="indexterm"></a>
+<a name="N12B49" class="indexterm"></a>
 <p>
 <span class="bold"><strong>IS_READONLY_DATABASE_FILES</strong></span>
 </p>
@@ -12204,7 +12465,7 @@ ps.executeUpdate();
 <p>Returns TRUE if the database is a read-only files database. In this
     kind of database, it is possible to modify the data, but the changes are
     not persisted to the database files. (HyperSQL)</p>
-<a name="N12A46" class="indexterm"></a>
+<a name="N12B57" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ISOLATION_LEVEL</strong></span>
 </p>
@@ -12214,7 +12475,7 @@ ps.executeUpdate();
 <p>Returns the current transaction isolation level for the session.
     Returns either READ COMMITTED or SERIALIZABLE as a string.
     (HyperSQL)</p>
-<a name="N12A54" class="indexterm"></a>
+<a name="N12B65" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SESSION_ID</strong></span>
 </p>
@@ -12224,7 +12485,7 @@ ps.executeUpdate();
 <p>Returns the id of the session as a BIGINT value. Each session id is
     unique during the operational lifetime of the database. Id's are restarted
     after a shutdown and restart. (HyperSQL)</p>
-<a name="N12A62" class="indexterm"></a>
+<a name="N12B73" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SESSION_ISOLATION_LEVEL</strong></span>
 </p>
@@ -12234,7 +12495,7 @@ ps.executeUpdate();
 <p>Returns the default transaction isolation level for the current
     session. Returns either READ COMMITTED or SERIALIZABLE as a string.
     (HyperSQL)</p>
-<a name="N12A70" class="indexterm"></a>
+<a name="N12B81" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DATABASE_ISOLATION_LEVEL</strong></span>
 </p>
@@ -12244,7 +12505,7 @@ ps.executeUpdate();
 <p>Returns the default transaction isolation level for the database.
     Returns either READ COMMITTED or SERIALIZABLE as a string.
     (HyperSQL)</p>
-<a name="N12A7E" class="indexterm"></a>
+<a name="N12B8F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TRANSACTION_SIZE</strong></span>
 </p>
@@ -12254,7 +12515,7 @@ ps.executeUpdate();
 <p>Returns the row change count for the current transaction. Each row
     change represents a row INSERT or a row DELETE operation. There will be a
     pair of row change operations for each row that is updated.</p>
-<a name="N12A8C" class="indexterm"></a>
+<a name="N12B9D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TRANSACTION_ID</strong></span>
 </p>
@@ -12266,7 +12527,7 @@ ps.executeUpdate();
     to new transactions and new actions (statement executions) in different
     sessions. This value is unique to the current transaction.
     (HyperSQL)</p>
-<a name="N12A9A" class="indexterm"></a>
+<a name="N12BAB" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TRANSACTION_UTC</strong></span>
 </p>
@@ -12276,7 +12537,7 @@ ps.executeUpdate();
 <p>Returns the transaction timestamp in UTC time zone for the session.
     This timestamp is used in updates made to system-versioned tables during
     the transaction. (HyperSQL)</p>
-<a name="N12AA8" class="indexterm"></a>
+<a name="N12BB9" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ACTION_ID</strong></span>
 </p>
@@ -12287,7 +12548,7 @@ ps.executeUpdate();
     database maintains a global incremental id which is allocated to new
     transactions and new actions (statement executions) in different sessions.
     This value is unique to the current action. (HyperSQL)</p>
-<a name="N12AB6" class="indexterm"></a>
+<a name="N12BC7" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TRANSACTION_CONTROL</strong></span>
 </p>
@@ -12296,7 +12557,7 @@ ps.executeUpdate();
 </p>
 <p>Returns the current transaction model for the database. Returns
     LOCKS, MVLOCKS or MVCC as a string. (HyperSQL)</p>
-<a name="N12AC4" class="indexterm"></a>
+<a name="N12BD5" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LOB_ID</strong></span>
 </p>
@@ -12307,14 +12568,14 @@ ps.executeUpdate();
     and never reused. The &lt;column reference&gt; is the name of the column
     (or variable, or argument) which is a CLOB or BLOB. Returns null if the
     value is null. (HyperSQL)</p>
-<a name="N12AD2" class="indexterm"></a>
+<a name="N12BE3" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ROWNUM</strong></span>
 </p>
 <p>
 <code class="literal">ROWNUM()</code>
 </p>
-<a name="N12ADE" class="indexterm"></a>
+<a name="N12BEF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ROW_NUMBER</strong></span>
 </p>
@@ -12353,12 +12614,12 @@ ps.executeUpdate();
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6369 $</p>
+<p class="releaseinfo">$Revision: 6535 $</p>
 </div>
 <div>
 <div class="legalnotice">
-<a name="N12B13"></a>
-<p>Copyright 2010-2021 Fred Toussi. Permission is granted to
+<a name="N12C24"></a>
+<p>Copyright 2010-2022 Fred Toussi. Permission is granted to
       distribute this document without any alteration under the terms of the
       HSQLDB license. Additional permission is granted to the HSQL Development
       Group to distribute this document with or without alterations under the
@@ -12366,7 +12627,7 @@ ps.executeUpdate();
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -13007,7 +13268,7 @@ ps.executeUpdate();
       In the current version of HyperSQL, the cursor is used only to return a
       result set from the procedure. Therefore, the cursor must be declared
       WITH RETURN and can only be READ ONLY.</p>
-<a name="N12CA3" class="indexterm"></a>
+<a name="N12DB4" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DECLARE CURSOR</strong></span>
 </p>
@@ -13073,7 +13334,7 @@ ps.executeUpdate();
 <p>Literals are used to express constant values. The general type of
       a literal is known by its format. The specific type is based on
       conventions.</p>
-<a name="N12CD2" class="indexterm"></a>
+<a name="N12DE3" class="indexterm"></a>
 <p>
 <span class="bold"><strong>unicode escape
       elements</strong></span>
@@ -13111,7 +13372,7 @@ ps.executeUpdate();
       &lt;quote&gt;, &lt;double quote&gt;, or &lt;white
       space&gt;</code>
 </p>
-<a name="N12CF0" class="indexterm"></a>
+<a name="N12E01" class="indexterm"></a>
 <p>
 <span class="bold"><strong>character literal</strong></span>
 </p>
@@ -13178,7 +13439,7 @@ ps.executeUpdate();
  U&amp;'Unicode string with forward slash // as custom escape character'UESCAPE'/'
 </pre>
 </div>
-<a name="N12D1D" class="indexterm"></a>
+<a name="N12E2E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>binary literal</strong></span>
 </p>
@@ -13206,7 +13467,7 @@ ps.executeUpdate();
 <div class="informalexample">
 <pre class="programlisting"> X'1abACD34' 'Af'</pre>
 </div>
-<a name="N12D34" class="indexterm"></a>
+<a name="N12E45" class="indexterm"></a>
 <p>
 <span class="bold"><strong>bit literal</strong></span>
 </p>
@@ -13228,7 +13489,7 @@ ps.executeUpdate();
 <div class="informalexample">
 <pre class="programlisting"> B'10001001' '00010'</pre>
 </div>
-<a name="N12D4B" class="indexterm"></a>
+<a name="N12E5C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>numeric literal</strong></span>
 </p>
@@ -13288,7 +13549,7 @@ ps.executeUpdate();
  +12E-2
 </pre>
 </div>
-<a name="N12D7B" class="indexterm"></a>
+<a name="N12E8C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>boolean literal</strong></span>
 </p>
@@ -13300,7 +13561,7 @@ ps.executeUpdate();
       UNKNOWN</code>
 </p>
 <p>The boolean literal is one of the specified keywords.</p>
-<a name="N12D8C" class="indexterm"></a>
+<a name="N12E9D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>datetime and interval
       literal</strong></span>
@@ -13459,7 +13720,7 @@ ps.executeUpdate();
 <p>References are identifier chains, which can be a single
       identifiers or identifiers chains composed of single identifiers chained
       together with the period symbol.</p>
-<a name="N12DFE" class="indexterm"></a>
+<a name="N12F0F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>identifier chain</strong></span>
 </p>
@@ -13489,7 +13750,7 @@ ps.executeUpdate();
  ALTER SEQUENCE MYCATALOG.MYSCHEMA.MYSEQUENCE RESTART WITH 100
 </pre>
 </div>
-<a name="N12E1D" class="indexterm"></a>
+<a name="N12F2E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>column reference</strong></span>
 </p>
@@ -13502,7 +13763,7 @@ ps.executeUpdate();
       &lt;period&gt; &lt;column name&gt;</code>
 </p>
 <p>Reference a column or a routine variable.</p>
-<a name="N12E2E" class="indexterm"></a>
+<a name="N12F3F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SQL parameter
       reference</strong></span>
@@ -13515,7 +13776,7 @@ ps.executeUpdate();
       identifier chain&gt;</code>
 </p>
 <p>Reference an SQL routine parameter.</p>
-<a name="N12E3F" class="indexterm"></a>
+<a name="N12F50" class="indexterm"></a>
 <p>
 <span class="bold"><strong>contextually typed value
       specification</strong></span>
@@ -13560,7 +13821,7 @@ ps.executeUpdate();
 <p>Value expression is a general name for all expressions that return
       a value. Different types of expressions are allowed in different
       contexts.</p>
-<a name="N12E60" class="indexterm"></a>
+<a name="N12F71" class="indexterm"></a>
 <p>
 <span class="bold"><strong>value expression
       primary</strong></span>
@@ -13587,7 +13848,7 @@ ps.executeUpdate();
       invocation&gt;</code>
 </p>
 <p>Specify a value that is syntactically self-delimited.</p>
-<a name="N12E77" class="indexterm"></a>
+<a name="N12F88" class="indexterm"></a>
 <p>
 <span class="bold"><strong>value specification</strong></span>
 </p>
@@ -13624,7 +13885,7 @@ ps.executeUpdate();
 </p>
 <p>Specify one or more values, host parameters, SQL parameters,
       dynamic parameters, or host variables.</p>
-<a name="N12E97" class="indexterm"></a>
+<a name="N12FA8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>row value expression</strong></span>
 </p>
@@ -13658,7 +13919,7 @@ ps.executeUpdate();
       separated list of expressions, enclosed in brackets, with the optional
       keyword ROW. In SQL, a row containing a single element can often be used
       where a single value is expected.</p>
-<a name="N12EB4" class="indexterm"></a>
+<a name="N12FC5" class="indexterm"></a>
 <p>
 <span class="bold"><strong>set function
       specification</strong></span>
@@ -13679,7 +13940,7 @@ ps.executeUpdate();
       of the column in the current row of the result of GROUPING SETS.
       HyperSQL supports <code class="literal">&lt;grouping operation&gt;</code> from
       version 2.5.1.</p>
-<a name="N12ECB" class="indexterm"></a>
+<a name="N12FDC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>COALESCE</strong></span>
 </p>
@@ -13702,7 +13963,7 @@ ps.executeUpdate();
       expression&gt;</code> instances. Therefore, any value returned is
       implicitly cast to this type. HyperSQL also features built-in functions
       with similar functionality.</p>
-<a name="N12EE4" class="indexterm"></a>
+<a name="N12FF5" class="indexterm"></a>
 <p>
 <span class="bold"><strong>NULLIF</strong></span>
 </p>
@@ -13722,7 +13983,7 @@ ps.executeUpdate();
 <div class="informalexample">
 <pre class="programlisting"> SELECT i, NULLIF(n, 'not defined') FROM t</pre>
 </div>
-<a name="N12EFE" class="indexterm"></a>
+<a name="N1300F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CASE</strong></span>
 </p>
@@ -13800,7 +14061,7 @@ ps.executeUpdate();
 </div>
 <p>The case statement can be far more complex and involve several
       conditions.</p>
-<a name="N12F34" class="indexterm"></a>
+<a name="N13045" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CAST</strong></span>
 </p>
@@ -13843,7 +14104,7 @@ ps.executeUpdate();
  CAST ('1992-04-21' AS DATE) = DATE '1992-04-21'
 </pre>
 </div>
-<a name="N12F52" class="indexterm"></a>
+<a name="N13063" class="indexterm"></a>
 <p>
 <span class="bold"><strong>NEXT VALUE FOR</strong></span>
 </p>
@@ -13869,7 +14130,7 @@ ps.executeUpdate();
 <pre class="programlisting">INSERT INTO MYTABLE(COL1, COL2) VALUES 2, NEXT VALUE FOR MYSEQUENCE
 </pre>
 </div>
-<a name="N12F66" class="indexterm"></a>
+<a name="N13077" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CURRENT VALUE FOR</strong></span>
 </p>
@@ -13889,7 +14150,7 @@ ps.executeUpdate();
  INSERT INTO CHILDTABLE(COL1, COL2) VALUES 10, CURRENT VALUE FOR MYSEQUENCE;
 </pre>
 </div>
-<a name="N12F7A" class="indexterm"></a>
+<a name="N1308B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>value expression</strong></span>
 </p>
@@ -13904,7 +14165,7 @@ ps.executeUpdate();
 </p>
 <p>An expression that returns a value. The value can be a single
       value, or a row consisting more than one value.</p>
-<a name="N12F8B" class="indexterm"></a>
+<a name="N1309C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>numeric value
       expression</strong></span>
@@ -13936,7 +14197,7 @@ ps.executeUpdate();
       <code class="literal">&lt;solidus&gt;</code> (the operators for multiplication and
       division) have precedence over <code class="literal">&lt;minus sign&gt;</code> and
       <code class="literal">&lt;plus sign&gt;</code>.</p>
-<a name="N12FB1" class="indexterm"></a>
+<a name="N130C2" class="indexterm"></a>
 <p>
 <span class="bold"><strong>numeric value
       function</strong></span>
@@ -13952,7 +14213,7 @@ ps.executeUpdate();
 <p>Specify a function yielding a value of type numeric. The
       supported numeric value functions are listed and described in the <a class="link" href="#builtinfunctions-chapt" title="Chapter&nbsp;4.&nbsp;Built In Functions">Built In Functions</a>
       chapter.</p>
-<a name="N12FC6" class="indexterm"></a>
+<a name="N130D7" class="indexterm"></a>
 <p>
 <span class="bold"><strong>string value
       expression</strong></span>
@@ -13983,7 +14244,7 @@ ps.executeUpdate();
       primary&gt;</code>. The types of the <code class="literal">&lt;value expression
       primary&gt;</code> elements must be compatible, that is, all must be
       string, or binary or bit string values.</p>
-<a name="N12FE6" class="indexterm"></a>
+<a name="N130F7" class="indexterm"></a>
 <p>
 <span class="bold"><strong>character value
       function</strong></span>
@@ -13998,7 +14259,7 @@ ps.executeUpdate();
 <p>Specify a function that returns a character string or binary
       string. The supported character value functions are listed and described
       in the <a class="link" href="#builtinfunctions-chapt" title="Chapter&nbsp;4.&nbsp;Built In Functions">Built In Functions</a> chapter.</p>
-<a name="N12FFB" class="indexterm"></a>
+<a name="N1310C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>datetime value
       expression</strong></span>
@@ -14030,12 +14291,12 @@ ps.executeUpdate();
       specifier&gt;</code>
 </p>
 <p>
-<code class="literal">&lt;time zone specifier&gt; ::= LOCAL | TIME ZONE
-      &lt;interval primary&gt;</code>
+<code class="literal">&lt;time zone specifier&gt; ::= LOCAL | TIME ZONE {
+      &lt;interval primary&gt; | &lt;time zone name&gt; }</code>
 </p>
 <p>Specify a datetime value. Details are described in the <a class="link" href="#sqlgeneral-chapt" title="Chapter&nbsp;2.&nbsp;SQL Language">SQL Language</a>
       chapter.</p>
-<a name="N1301F" class="indexterm"></a>
+<a name="N13130" class="indexterm"></a>
 <p>
 <span class="bold"><strong>datetime value
       function</strong></span>
@@ -14049,7 +14310,7 @@ ps.executeUpdate();
 </p>
 <p>Specify a function that returns a datetime value. The supported
       datetime value functions are listed and described in the <a class="link" href="#builtinfunctions-chapt" title="Chapter&nbsp;4.&nbsp;Built In Functions">Built In Functions</a> chapter.</p>
-<a name="N13035" class="indexterm"></a>
+<a name="N13146" class="indexterm"></a>
 <p>
 <span class="bold"><strong>interval term</strong></span>
 </p>
@@ -14093,7 +14354,7 @@ ps.executeUpdate();
 </p>
 <p>Specify an interval value. Details are described in the <a class="link" href="#sqlgeneral-chapt" title="Chapter&nbsp;2.&nbsp;SQL Language">SQL Language</a>
       chapter.</p>
-<a name="N1305C" class="indexterm"></a>
+<a name="N1316D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>interval absolute value
       function</strong></span>
@@ -14113,7 +14374,7 @@ ps.executeUpdate();
 <p>Specify a function that returns the absolute value of an
       interval. If the interval is negative, it is negated, otherwise the
       original value is returned.</p>
-<a name="N13070" class="indexterm"></a>
+<a name="N13181" class="indexterm"></a>
 <p>
 <span class="bold"><strong>boolean value
       expression</strong></span>
@@ -14194,7 +14455,7 @@ ps.executeUpdate();
       predicand&gt;</code> has more than one element, and one or more of
       the fields evaluate to NULL, the result depends on the particular
       predicate.</p>
-<a name="N130BD" class="indexterm"></a>
+<a name="N131CE" class="indexterm"></a>
 <p>
 <span class="bold"><strong>comparison predicand</strong></span>
 </p>
@@ -14263,7 +14524,7 @@ ps.executeUpdate();
  ((2, NULL, ...) &lt; (1, NULL, ...)) IS FALSE
 </pre>
 </div>
-<a name="N1310B" class="indexterm"></a>
+<a name="N1321C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>BETWEEN</strong></span>
 </p>
@@ -14289,7 +14550,7 @@ ps.executeUpdate();
       BETWEEN ...)</code>. If any of the three <code class="literal">&lt;row value
       predicand&gt;</code> evaluates to NULL, the result is
       UNKNOWN.</p>
-<a name="N13134" class="indexterm"></a>
+<a name="N13245" class="indexterm"></a>
 <p>
 <span class="bold"><strong>IN</strong></span>
 </p>
@@ -14346,7 +14607,7 @@ ps.executeUpdate();
  ResultSet rs = ps.executeQuery();
 </pre>
 </div>
-<a name="N13175" class="indexterm"></a>
+<a name="N13286" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LIKE</strong></span>
 </p>
@@ -14406,7 +14667,7 @@ ps.executeUpdate();
       (A LIKE B)</code>. If the length of the escape is not 1 or it is used
       in the pattern not immediately before an underscore or a percent
       character, an exception is raised.</p>
-<a name="N131C2" class="indexterm"></a>
+<a name="N132D3" class="indexterm"></a>
 <p>
 <span class="bold"><strong>IS NULL</strong></span>
 </p>
@@ -14426,7 +14687,7 @@ ps.executeUpdate();
       IS NULL</code> and <code class="literal">X IS NOT NULL</code> are FALSE. If all
       fields are not null, <code class="literal">X IS NULL</code> is FALSE and
       <code class="literal">X IS NOT NULL</code> is TRUE.</p>
-<a name="N131EE" class="indexterm"></a>
+<a name="N132FF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ALL and ANY</strong></span>
 </p>
@@ -14480,7 +14741,7 @@ ps.executeUpdate();
  invoice_date &lt; ALL (SELECT holiday_date FROM holidays)
 </pre>
 </div>
-<a name="N13231" class="indexterm"></a>
+<a name="N13342" class="indexterm"></a>
 <p>
 <span class="bold"><strong>EXISTS</strong></span>
 </p>
@@ -14494,7 +14755,7 @@ ps.executeUpdate();
 <p>Specify a test for a non-empty set. If the evaluation of
       <code class="literal">&lt;table subquery&gt;</code> results in one or more rows,
       then the expression is TRUE, otherwise FALSE.</p>
-<a name="N13245" class="indexterm"></a>
+<a name="N13356" class="indexterm"></a>
 <p>
 <span class="bold"><strong>UNIQUE</strong></span>
 </p>
@@ -14512,7 +14773,7 @@ ps.executeUpdate();
       distinct from each other, the result of the test is TRUE, otherwise it
       is FALSE. The distinctness of rows X and Y is tested with the predicate
       <code class="literal">X IS DISTINCT FROM Y</code>.</p>
-<a name="N1325C" class="indexterm"></a>
+<a name="N1336D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>MATCH</strong></span>
 </p>
@@ -14554,7 +14815,7 @@ ps.executeUpdate();
 <p>Note that MATCH can also be used in FOREIGN KEY constraint
       definitions. The exact meaning is described in the <a class="link" href="#databaseobjects-chapt" title="Chapter&nbsp;3.&nbsp;Schemas and Database Objects">Schemas and Database Objects</a>
       chapter.</p>
-<a name="N1329E" class="indexterm"></a>
+<a name="N133AF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CONTAINS</strong></span>
 </p>
@@ -14579,7 +14840,7 @@ ps.executeUpdate();
       result is TRUE. Otherwise it is false.</p>
 <p>If any of the values is NULL, the result is
       UNDEFINED.</p>
-<a name="N132BB" class="indexterm"></a>
+<a name="N133CC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>EQUALS</strong></span>
 </p>
@@ -14597,7 +14858,7 @@ ps.executeUpdate();
       TRUE. Otherwise it is false.</p>
 <p>If any of the values is NULL, the result is
       UNDEFINED.</p>
-<a name="N132CE" class="indexterm"></a>
+<a name="N133DF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>IS DISTINCT</strong></span>
 </p>
@@ -14626,7 +14887,7 @@ ps.executeUpdate();
 <div class="informalexample">
 <pre class="programlisting"> startdate IS DISTINCT FROM enddate</pre>
 </div>
-<a name="N132F4" class="indexterm"></a>
+<a name="N13405" class="indexterm"></a>
 <p>
 <span class="bold"><strong>OVERLAPS</strong></span>
 </p>
@@ -14654,7 +14915,7 @@ ps.executeUpdate();
 <div class="informalexample">
 <pre class="programlisting"> (startdate, enddate) OVERLAPS (CURRENT_DATE - 7 DAY, CURRENT_DATE - 1 DAY)</pre>
 </div>
-<a name="N13311" class="indexterm"></a>
+<a name="N13422" class="indexterm"></a>
 <p>
 <span class="bold"><strong>PRECEDES</strong></span>
 </p>
@@ -14676,7 +14937,7 @@ ps.executeUpdate();
       period.</p>
 <p>If any of the values is NULL, the result is
       UNDEFINED.</p>
-<a name="N13326" class="indexterm"></a>
+<a name="N13437" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SUCCEEDS</strong></span>
 </p>
@@ -14709,7 +14970,7 @@ ps.executeUpdate();
 </div>
 </div>
 </div>
-<a name="N13344" class="indexterm"></a>
+<a name="N13455" class="indexterm"></a>
 <p>
 <span class="bold"><strong>aggregate function</strong></span>
 </p>
@@ -14876,7 +15137,7 @@ ps.executeUpdate();
 </div>
 </div>
 </div>
-<a name="N133E2" class="indexterm"></a>
+<a name="N134F3" class="indexterm"></a>
 <p>
 <span class="bold"><strong>search condition</strong></span>
 </p>
@@ -14889,7 +15150,7 @@ ps.executeUpdate();
 </p>
 <p>Specify a condition that is TRUE, FALSE, or UNKNOWN. A search
       condition is often a predicate.</p>
-<a name="N133F3" class="indexterm"></a>
+<a name="N13504" class="indexterm"></a>
 <p>
 <span class="bold"><strong>PATH</strong></span>
 </p>
@@ -14906,7 +15167,7 @@ ps.executeUpdate();
 </p>
 <p>Specify an order for searching for a user-defined SQL-invoked
       routine. This is not currently supported by HyperSQL.</p>
-<a name="N13407" class="indexterm"></a>
+<a name="N13518" class="indexterm"></a>
 <p>
 <span class="bold"><strong>routine invocation</strong></span>
 </p>
@@ -14932,7 +15193,7 @@ ps.executeUpdate();
 </p>
 <p>Invoke an SQL-invoked routine. Examples are given in the <a class="link" href="#sqlroutines-chapt" title="Chapter&nbsp;9.&nbsp;SQL-Invoked Routines">SQL-Invoked Routines</a>
       chapter.</p>
-<a name="N13425" class="indexterm"></a>
+<a name="N13536" class="indexterm"></a>
 <p>
 <span class="bold"><strong>COLLATE</strong></span>
 </p>
@@ -14949,7 +15210,7 @@ ps.executeUpdate();
       UPDATE or DELETE statements, when a UNIQUE constraint or index is
       defined on the column, or when the rows are sorted by an ORDER BY
       clause.</p>
-<a name="N13436" class="indexterm"></a>
+<a name="N13547" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CONSTRAINT</strong></span>
 </p>
@@ -15077,7 +15338,7 @@ ps.executeUpdate();
       access statements, which may combine multiple SELECT statements. The
       <code class="literal">&lt;query specification&gt;</code> is the most common data
       access statement and begins with the SELECT keyword.</p>
-<a name="N13490" class="indexterm"></a>
+<a name="N135A1" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SELECT STATEMENT</strong></span>
 </p>
@@ -15386,7 +15647,7 @@ SELECT DISTINCT firstname, lastname, ema
 </div>
 </div>
 </div>
-<a name="N13587" class="indexterm"></a>
+<a name="N13698" class="indexterm"></a>
 <p>
 <span class="bold"><strong>derived table</strong></span>
 </p>
@@ -15410,7 +15671,7 @@ SELECT DISTINCT firstname, lastname, ema
 </div>
 </div>
 </div>
-<a name="N135A2" class="indexterm"></a>
+<a name="N136B3" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LATERAL</strong></span>
 </p>
@@ -15446,7 +15707,7 @@ SELECT firstname, lastname, a.c FROM cus
 </div>
 </div>
 </div>
-<a name="N135BF" class="indexterm"></a>
+<a name="N136D0" class="indexterm"></a>
 <p>
 <span class="bold"><strong>UNNEST</strong></span>
 </p>
@@ -15524,7 +15785,7 @@ SELECT firstname, lastname, a.c FROM cus
 </div>
 </div>
 </div>
-<a name="N135DB" class="indexterm"></a>
+<a name="N136EC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>Table Function Derived
         Table</strong></span>
@@ -15569,7 +15830,7 @@ SELECT firstname, lastname, a.c FROM cus
 </div>
 </div>
 </div>
-<a name="N135F9" class="indexterm"></a>
+<a name="N1370A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>column name list</strong></span>
 </p>
@@ -15644,7 +15905,7 @@ SELECT firstname, lastname, a.c FROM cus
 <code class="literal">&lt;join column list&gt; ::= &lt;column name
       list&gt;</code>
 </p>
-<a name="N1362E" class="indexterm"></a>
+<a name="N1373F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CROSS JOIN</strong></span>
 </p>
@@ -15666,7 +15927,7 @@ SELECT firstname, lastname, a.c FROM cus
       before they are joined.</p>
 <p>CROSS JOIN is not is not generally very useful, as it returns
       large result tables unless WHERE conditions are used.</p>
-<a name="N13645" class="indexterm"></a>
+<a name="N13756" class="indexterm"></a>
 <p>
 <span class="bold"><strong>UNION JOIN</strong></span>
 </p>
@@ -15678,7 +15939,7 @@ SELECT firstname, lastname, a.c FROM cus
       This should not be confused with <code class="literal">A UNION B</code>, which is
       a set operation. Union join is for special applications and is not
       commonly used.</p>
-<a name="N13656" class="indexterm"></a>
+<a name="N13767" class="indexterm"></a>
 <p>
 <span class="bold"><strong>JOIN ... ON</strong></span>
 </p>
@@ -15693,11 +15954,11 @@ SELECT firstname, lastname, a.c FROM cus
 <pre class="programlisting">SELECT a.*, b.* FROM a INNER JOIN b ON a.col_one = b.col_two
 </pre>
 </div>
-<a name="N13669" class="indexterm"></a>
+<a name="N1377A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>JOIN ... USING</strong></span>
 </p>
-<a name="N13672" class="indexterm"></a>
+<a name="N13783" class="indexterm"></a>
 <p>
 <span class="bold"><strong>NATURAL JOIN</strong></span>
 </p>
@@ -15736,7 +15997,7 @@ SELECT firstname, lastname, a.c FROM cus
  SELECT * FROM a INNER JOIN b USING (col_two)
 </pre>
 </div>
-<a name="N1368C" class="indexterm"></a>
+<a name="N1379D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>OUTER JOIN</strong></span>
 </p>
@@ -15833,7 +16094,7 @@ SELECT firstname, lastname, a.c FROM cus
       as C1, C2, etc. As generated naming is implementation defined according
       to the SQL Standard, it is better to explicitly name the computed and
       derived columns in your applications.</p>
-<a name="N136C1" class="indexterm"></a>
+<a name="N137D2" class="indexterm"></a>
 <p>
 <span class="bold"><strong>Naming in Joined
       Table</strong></span>
@@ -15866,7 +16127,7 @@ SELECT firstname, lastname, a.c FROM cus
  SELECT d, e, f FROM atable WHERE a + b = c
  SELECT x, y, z FROM atable AS t (u, v, w, x, y, z)  WHERE u + v = w</pre>
 </div>
-<a name="N136DD" class="indexterm"></a>
+<a name="N137EE" class="indexterm"></a>
 <p>
 <span class="bold"><strong>Naming in Select
       List</strong></span>
@@ -15886,7 +16147,7 @@ SELECT firstname, lastname, a.c FROM cus
 <p>If the names <code class="literal">xysum</code> or <code class="literal">yzsum</code>
       are not used, the computed columns cannot be referenced in the ORDER BY
       list.</p>
-<a name="N136F5" class="indexterm"></a>
+<a name="N13806" class="indexterm"></a>
 <p>
 <span class="bold"><strong>Name Resolution</strong></span>
 </p>
@@ -15903,7 +16164,7 @@ SELECT firstname, lastname, a.c FROM cus
 </div>
 </div>
 </div>
-<a name="N13704" class="indexterm"></a>
+<a name="N13815" class="indexterm"></a>
 <p>
 <span class="bold"><strong>Grouping Operations</strong></span>
 </p>
@@ -15914,7 +16175,7 @@ SELECT firstname, lastname, a.c FROM cus
       of their columns when compared to another row). The other form of
       grouping is performed with the GROUP BY clause. This form is usually
       used together with aggregation.</p>
-<a name="N1370F" class="indexterm"></a>
+<a name="N13820" class="indexterm"></a>
 <p>
 <span class="bold"><strong>GROUP BY</strong></span>
 </p>
@@ -16058,7 +16319,7 @@ DIRECT SALES (null) (null)  3778500
       DISTINCT eliminates the duplicate groups.</p>
 <p>Note any ordering of the rows returned by GROUP BY in incidental.
       You need to use ORDER BY for the ordering you require.</p>
-<a name="N1378D" class="indexterm"></a>
+<a name="N1389E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>HAVING</strong></span>
 </p>
@@ -16067,7 +16328,7 @@ DIRECT SALES (null) (null)  3778500
       clause&gt;</code> using its search condition. The search condition
       must be an expression based on the expressions in the GROUP BY list or
       the aggregate functions used.</p>
-<a name="N1379E" class="indexterm"></a>
+<a name="N138AF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DISTINCT</strong></span>
 </p>
@@ -16111,7 +16372,7 @@ DIRECT SALES (null) (null)  3778500
 </div>
 </div>
 </div>
-<a name="N137BE" class="indexterm"></a>
+<a name="N138CF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>Set and Multiset
       Operations</strong></span>
@@ -16212,7 +16473,7 @@ DIRECT SALES (null) (null)  3778500
       body&gt;</code> that follows the WITH clause.</p>
 <p>HyperSQL limits recursion to 256 rounds. If this is exceeded, an
       error is raised.</p>
-<p>From version 2.6.0, HyperSQL extends recursive query processing by
+<p>From version 2.6, HyperSQL extends recursive query processing by
       allowing the use of <code class="literal">RECURSIVE_TABLE</code> to reference the
       current general result of the <code class="literal">&lt;query
       expression&gt;</code>. This table name can be used in subqueries with
@@ -16405,7 +16666,7 @@ DIRECT SALES (null) (null)  3778500
       when it can use the same index for accessing the table data and
       ordering. Optimisation can happen both with DESC + NULLS LAST and ASC +
       NULLS FIRST.</p>
-<a name="N13897" class="indexterm"></a>
+<a name="N139A8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>sort specification
       list</strong></span>
@@ -16494,7 +16755,7 @@ DIRECT SALES (null) (null)  3778500
       indexes used, together with other useful information about the query.
       EXPLAIN PLAN can also be used for data manipulation statements such as
       UPDATE.</p>
-<a name="N138D8" class="indexterm"></a>
+<a name="N139E9" class="indexterm"></a>
 <p>
 <span class="bold"><strong>EXPLAIN PLAN</strong></span>
 </p>
@@ -16527,7 +16788,7 @@ DIRECT SALES (null) (null)  3778500
 </div>
 </div>
 </div>
-<a name="N138F4" class="indexterm"></a>
+<a name="N13A05" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DELETE FROM</strong></span>
 </p>
@@ -16577,7 +16838,7 @@ DIRECT SALES (null) (null)  3778500
 </div>
 </div>
 </div>
-<a name="N13918" class="indexterm"></a>
+<a name="N13A29" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TRUNCATE TABLE</strong></span>
 </p>
@@ -16627,7 +16888,7 @@ DIRECT SALES (null) (null)  3778500
       statement&gt;</code> is for removing old history rows from a
       system-versioned table. All history rows that expired before the given
       timestamp are removed. No current row is removed.</p>
-<a name="N13944" class="indexterm"></a>
+<a name="N13A55" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TRUNCATE SCHEMA</strong></span>
 </p>
@@ -16659,7 +16920,7 @@ DIRECT SALES (null) (null)  3778500
 </div>
 </div>
 </div>
-<a name="N1395D" class="indexterm"></a>
+<a name="N13A6E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>INSERT INTO</strong></span>
 </p>
@@ -16810,7 +17071,7 @@ DIRECT SALES (null) (null)  3778500
 </div>
 </div>
 </div>
-<a name="N139C3" class="indexterm"></a>
+<a name="N13AD4" class="indexterm"></a>
 <p>
 <span class="bold"><strong>UPDATE</strong></span>
 </p>
@@ -16850,7 +17111,7 @@ DIRECT SALES (null) (null)  3778500
       this situation, you can perform the operation is chunks and commit after
       each chunk to reduce memory usage and the total time of the
       operation.</p>
-<a name="N139E7" class="indexterm"></a>
+<a name="N13AF8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>set clause list</strong></span>
 </p>
@@ -16918,7 +17179,7 @@ DIRECT SALES (null) (null)  3778500
 </div>
 </div>
 </div>
-<a name="N13A15" class="indexterm"></a>
+<a name="N13B26" class="indexterm"></a>
 <p>
 <span class="bold"><strong>MERGE INTO</strong></span>
 </p>
@@ -17069,7 +17330,7 @@ DIRECT SALES (null) (null)  3778500
     limited extent. The built-in function <code class="literal">DIAGNOSTICS()</code> is
     an alternative. These are normally used in SQL/PSM routines to check the
     result of the last data update operation.</p>
-<a name="N13A9B" class="indexterm"></a>
+<a name="N13BAC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>GET DIAGNOSTICS</strong></span>
 </p>
@@ -17116,12 +17377,12 @@ DIRECT SALES (null) (null)  3778500
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6306 $</p>
+<p class="releaseinfo">$Revision: 6535 $</p>
 </div>
 <div>
 <div class="legalnotice">
-<a name="N13AE4"></a>
-<p>Copyright 2010-2021 Fred Toussi. Permission is granted to
+<a name="N13BF5"></a>
+<p>Copyright 2010-2022 Fred Toussi. Permission is granted to
       distribute this document without any alteration under the terms of the
       HSQLDB license. Additional permission is granted to the HSQL Development
       Group to distribute this document with or without alterations under the
@@ -17129,7 +17390,7 @@ DIRECT SALES (null) (null)  3778500
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -17280,6 +17541,12 @@ DIRECT SALES (null) (null)  3778500
       auto-commit or read-only modes can be read using other built-in
       functions. All these functions are listed in the <a class="link" href="#builtinfunctions-chapt" title="Chapter&nbsp;4.&nbsp;Built In Functions">Built In Functions</a>
       chapter.</p>
+<p>Each session has a time zone, which is the time zone of the JVM in
+      which the connection is made and can be different from the time zone of
+      a server database. Different client / server sessions can therefore have
+      different time zones and display time-zone-sensitive information
+      differently. See the description of the SET TIME ZONE statement below
+      for more detail.</p>
 </div>
 <div class="section">
 <div class="titlepage">
@@ -17298,7 +17565,7 @@ DIRECT SALES (null) (null)  3778500
       useful for development and debugging. See the example in the <a class="link" href="#sqlroutines-chapt" title="Chapter&nbsp;9.&nbsp;SQL-Invoked Routines">SQL-Invoked Routines</a> chapter,
       under Formal Parameters.</p>
 <div class="example">
-<a name="N13B26"></a>
+<a name="N13C39"></a>
 <p class="title">
 <b>Example&nbsp;6.1.&nbsp;User-defined Session Variables</b>
 </p>
@@ -17344,10 +17611,10 @@ DIRECT SALES (null) (null)  3778500
       takes precedence over a schema table of the same name. To distinguish a
       session table from schema tables, the pseudo schema name, SESSION can be
       used. The alternative name, MODULE is deprecated and does not work in
-      version 2.5.1 but can be used in version 2.6.0. An example is given
-      below:</p>
+      version 2.5.1 but can be used in version 2.6 and later for backward
+      compatibility. An example is given below:</p>
 <div class="example">
-<a name="N13B3B"></a>
+<a name="N13C4E"></a>
 <p class="title">
 <b>Example&nbsp;6.2.&nbsp;User-defined Temporary Session Tables</b>
 </p>
@@ -17356,7 +17623,7 @@ DIRECT SALES (null) (null)  3778500
  INSERT INTO session.buffer SELECT id, firstname || ' ' || lastname FROM customers
  -- do some more work
  DROP TABLE session.buffer
- -- alternative schema name, MODULE can be used in version 2.6.0 but it is deprecated
+ -- alternative schema name, MODULE can be used in version 2.7.0 but it is deprecated
  DROP TABLE module.buffer
 </pre>
 </div>
@@ -17739,7 +18006,7 @@ DIRECT SALES (null) (null)  3778500
 </div>
 </div>
 </div>
-<a name="N13BCE" class="indexterm"></a>
+<a name="N13CE1" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ALTER SESSION</strong></span>
 </p>
@@ -17776,7 +18043,7 @@ DIRECT SALES (null) (null)  3778500
     currently open result sets are closed and the resources are released. When
     TABLE DATA is specified, the data in all temporary tables is
     cleared.</p>
-<a name="N13BF2" class="indexterm"></a>
+<a name="N13D05" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET AUTOCOMMIT</strong></span>
 </p>
@@ -17792,7 +18059,7 @@ DIRECT SALES (null) (null)  3778500
     performed automatically. This statement changes the mode. It is equivalent
     to using the <code class="methodname">setAutoCommit( boolean autoCommit)</code>
     method of the JDBC <code class="classname">Connection</code> object.</p>
-<a name="N13C09" class="indexterm"></a>
+<a name="N13D1C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>START TRANSACTION</strong></span>
 </p>
@@ -17807,7 +18074,7 @@ DIRECT SALES (null) (null)  3778500
     transactional SQL statements start a transaction automatically, therefore
     using this statement is not necessary. If the statement is called in the
     middle of a transaction, an exception is thrown.</p>
-<a name="N13C1A" class="indexterm"></a>
+<a name="N13D2D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET TRANSACTION</strong></span>
 </p>
@@ -17822,7 +18089,7 @@ DIRECT SALES (null) (null)  3778500
 <p>Set the characteristics of the next transaction in the current
     session. This statement has an effect only on the next transactions and
     has no effect on the future transactions after the next.</p>
-<a name="N13C2B" class="indexterm"></a>
+<a name="N13D3E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>transaction
     characteristics</strong></span>
@@ -17862,7 +18129,7 @@ DIRECT SALES (null) (null)  3778500
 </p>
 <p>Specify transaction characteristics.</p>
 <div class="example">
-<a name="N13C4E"></a>
+<a name="N13D61"></a>
 <p class="title">
 <b>Example&nbsp;6.3.&nbsp;Setting Transaction Characteristics</b>
 </p>
@@ -17874,7 +18141,7 @@ DIRECT SALES (null) (null)  3778500
 </div>
 </div>
 <br class="example-break">
-<a name="N13C53" class="indexterm"></a>
+<a name="N13D66" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET CONSTRAINTS</strong></span>
 </p>
@@ -17895,7 +18162,7 @@ DIRECT SALES (null) (null)  3778500
     the rest of the current transaction. If the statement is issued when a
     transaction is not active then it applies only to the next transaction in
     the current session. HyperSQL does not yet support this feature.</p>
-<a name="N13C67" class="indexterm"></a>
+<a name="N13D7A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LOCK TABLE</strong></span>
 </p>
@@ -17927,7 +18194,7 @@ DIRECT SALES (null) (null)  3778500
 <p>Currently, this command does not have any effect when the
     database transaction control model is MVCC.</p>
 <div class="example">
-<a name="N13C7C"></a>
+<a name="N13D8F"></a>
 <p class="title">
 <b>Example&nbsp;6.4.&nbsp;Locking Tables</b>
 </p>
@@ -17936,7 +18203,7 @@ DIRECT SALES (null) (null)  3778500
 </div>
 </div>
 <br class="example-break">
-<a name="N13C81" class="indexterm"></a>
+<a name="N13D94" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SAVEPOINT</strong></span>
 </p>
@@ -17955,7 +18222,7 @@ DIRECT SALES (null) (null)  3778500
     transaction. It establishes a milestone for the current transaction. The
     SAVEPOINT can be used at a later point in the transaction to rollback the
     transaction to the milestone.</p>
-<a name="N13C95" class="indexterm"></a>
+<a name="N13DA8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>RELEASE SAVEPOINT</strong></span>
 </p>
@@ -17969,7 +18236,7 @@ DIRECT SALES (null) (null)  3778500
 <p>Destroy a savepoint. This command is rarely used as it is not
     very useful. It removes a SAVEPOINT that has already been
     defined.</p>
-<a name="N13CA6" class="indexterm"></a>
+<a name="N13DB9" class="indexterm"></a>
 <p>
 <span class="bold"><strong>COMMIT</strong></span>
 </p>
@@ -17982,7 +18249,7 @@ DIRECT SALES (null) (null)  3778500
 </p>
 <p>Terminate the current SQL-transaction with commit. This make all
     the changes to the database permanent.</p>
-<a name="N13CB7" class="indexterm"></a>
+<a name="N13DCA" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ROLLBACK</strong></span>
 </p>
@@ -17998,7 +18265,7 @@ DIRECT SALES (null) (null)  3778500
     NO CHAIN is specified, a new SQL transaction is started just after the
     rollback. The new transaction inherits the properties of the old
     transaction.</p>
-<a name="N13CC8" class="indexterm"></a>
+<a name="N13DDB" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ROLLBACK TO SAVEPOINT</strong></span>
 </p>
@@ -18015,7 +18282,7 @@ DIRECT SALES (null) (null)  3778500
     <code class="literal">rollback( Savepoint savepoint)</code> method of the JDBC
     <code class="classname">Connection</code> object.</p>
 <div class="example">
-<a name="N13CDF"></a>
+<a name="N13DF2"></a>
 <p class="title">
 <b>Example&nbsp;6.5.&nbsp;Rollback</b>
 </p>
@@ -18029,7 +18296,7 @@ DIRECT SALES (null) (null)  3778500
 </div>
 </div>
 <br class="example-break">
-<a name="N13CE5" class="indexterm"></a>
+<a name="N13DF8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DISCONNECT</strong></span>
 </p>
@@ -18042,7 +18309,7 @@ DIRECT SALES (null) (null)  3778500
 </p>
 <p>Terminate the current SQL session. Closing a JDBC connection has
     the same effect as this command.</p>
-<a name="N13CF7" class="indexterm"></a>
+<a name="N13E0A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET SESSION
     CHARACTERISTICS</strong></span>
@@ -18076,7 +18343,7 @@ DIRECT SALES (null) (null)  3778500
     command. The current read-only mode can be accessed with the ISREADONLY()
     function.</p>
 <div class="example">
-<a name="N13D11"></a>
+<a name="N13E24"></a>
 <p class="title">
 <b>Example&nbsp;6.6.&nbsp;Setting Session Characteristics</b>
 </p>
@@ -18088,7 +18355,7 @@ DIRECT SALES (null) (null)  3778500
 </div>
 </div>
 <br class="example-break">
-<a name="N13D16" class="indexterm"></a>
+<a name="N13E29" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET SESSION
     AUTHORIZATION</strong></span>
@@ -18108,7 +18375,7 @@ DIRECT SALES (null) (null)  3778500
     user. The current authorisation can be accessed with the CURRENT_USER and
     SESSION_USER functions.</p>
 <div class="example">
-<a name="N13D27"></a>
+<a name="N13E3A"></a>
 <p class="title">
 <b>Example&nbsp;6.7.&nbsp;Setting Session Authorization</b>
 </p>
@@ -18119,7 +18386,7 @@ DIRECT SALES (null) (null)  3778500
 </div>
 </div>
 <br class="example-break">
-<a name="N13D2C" class="indexterm"></a>
+<a name="N13E3F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET ROLE</strong></span>
 </p>
@@ -18139,7 +18406,7 @@ DIRECT SALES (null) (null)  3778500
     the specified role. If NONE is specified, then the previous CURRENT_ROLE
     is eliminated. The effect of this lasts for the lifetime of the session.
     The current role can be accessed with the CURRENT_ROLE function.</p>
-<a name="N13D40" class="indexterm"></a>
+<a name="N13E53" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET TIME ZONE</strong></span>
 </p>
@@ -18152,27 +18419,39 @@ DIRECT SALES (null) (null)  3778500
 </p>
 <p>
 <code class="literal">&lt;set time zone value&gt; ::= &lt;interval value
-    expression&gt; | LOCAL</code>
+    expression&gt; | &lt;string value expression&gt; |
+    LOCAL</code>
 </p>
 <p>Set the current default time zone displacement for the current
     SQL-session. When the session starts, the time zone displacement is set to
     the time zone of the client. This command changes the time zone
     displacement. The effect of this lasts for the lifetime of the session. If
     LOCAL is specified, the time zone displacement reverts to the local time
-    zone of the session.</p>
+    zone of the session that was in force prior to the use of the
+    command.</p>
+<p>From version 2.7.0, zone strings indicating geographical regions
+    can be used. These zone often support daylight saving time.</p>
+<p>This command works fine with in-process databases. When the
+    sessions is for a connection to a server, this command should not
+    generally be used as it only affects the server part of the session. With
+    client / server connections, the only way to specify a session time zone
+    that is different from the local time zone is by setting the JVM time zone
+    prior to connecting to the database.</p>
 <div class="example">
-<a name="N13D54"></a>
+<a name="N13E6B"></a>
 <p class="title">
 <b>Example&nbsp;6.8.&nbsp;Setting Session Time Zone</b>
 </p>
 <div class="example-contents">
 <pre class="screen"> SET TIME ZONE LOCAL
  SET TIME ZONE INTERVAL '+6:00' HOUR TO MINUTE
+ SET TIME ZONE '-6:00'
+ SET TIME ZONE 'America/Chicago'
 </pre>
 </div>
 </div>
 <br class="example-break">
-<a name="N13D59" class="indexterm"></a>
+<a name="N13E70" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET CATALOG</strong></span>
 </p>
@@ -18192,7 +18471,7 @@ DIRECT SALES (null) (null)  3778500
     As there is only one catalog in the database, only the name of this
     catalog can be used. The current catalog can be accessed with the
     CURRENT_CATALOG function.</p>
-<a name="N13D6D" class="indexterm"></a>
+<a name="N13E84" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET SCHEMA</strong></span>
 </p>
@@ -18213,7 +18492,7 @@ DIRECT SALES (null) (null)  3778500
     form requires the schema name as a single-quoted string. HyperSQL also
     allows the use of the identifier for the schema. The current schema can be
     accessed with the CURRENT_SCHEMA function.</p>
-<a name="N13D81" class="indexterm"></a>
+<a name="N13E98" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET PATH</strong></span>
 </p>
@@ -18232,7 +18511,7 @@ DIRECT SALES (null) (null)  3778500
     invocations with unqualified routine names used in SQL statements that are
     prepared or executed directly in the current sessions. The effect of this
     lasts for the lifetime of the session.</p>
-<a name="N13D95" class="indexterm"></a>
+<a name="N13EAC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET MAXROWS</strong></span>
 </p>
@@ -18260,7 +18539,7 @@ DIRECT SALES (null) (null)  3778500
     &lt;n&gt;. Therefore, this command is not recommended for general use. The
     only legitimate use of this command is for checking and testing queries
     that may return very large numbers of rows.</p>
-<a name="N13DB8" class="indexterm"></a>
+<a name="N13ECF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET SESSION RESULT MEMORY
     ROWS</strong></span>
@@ -18286,7 +18565,7 @@ DIRECT SALES (null) (null)  3778500
 <code class="literal">SET DATABASE DEFAULT RESULT MEMORY ROWS &lt;unsigned
     integer literal&gt;</code>
 </p>
-<a name="N13DCE" class="indexterm"></a>
+<a name="N13EE5" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET IGNORECASE</strong></span>
 </p>
@@ -18346,12 +18625,12 @@ DIRECT SALES (null) (null)  3778500
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6271 $</p>
+<p class="releaseinfo">$Revision: 6425 $</p>
 </div>
 <div>
 <div class="legalnotice">
-<a name="N13E20"></a>
-<p>Copyright 2002-2021 Bob Preston and Fred Toussi. Permission is
+<a name="N13F37"></a>
+<p>Copyright 2002-2022 Bob Preston and Fred Toussi. Permission is
       granted to distribute this document without any alteration under the
       terms of the HSQLDB license. Additional permission is granted to the
       HSQL Development Group to distribute this document with or without
@@ -18359,7 +18638,7 @@ DIRECT SALES (null) (null)  3778500
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -19134,8 +19413,8 @@ DIRECT SALES (null) (null)  3778500
 </div>
 <div>
 <div class="legalnotice">
-<a name="N14029"></a>
-<p>Copyright 2010-2021 Fred Toussi. Permission is granted to
+<a name="N14140"></a>
+<p>Copyright 2010-2022 Fred Toussi. Permission is granted to
       distribute this document without any alteration under the terms of the
       HSQLDB license. Additional permission is granted to the HSQL Development
       Group to distribute this document with or without alterations under the
@@ -19143,7 +19422,7 @@ DIRECT SALES (null) (null)  3778500
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -19170,6 +19449,9 @@ DIRECT SALES (null) (null)  3778500
 <span class="section"><a href="#acc_access_rights">Access Rights</a></span>
 </dt>
 <dt>
+<span class="section"><a href="#N1425C">Simple Access Control</a></span>
+</dt>
+<dt>
 <span class="section"><a href="#acc_fine_grained_access">Fine-Grained Data Access Control</a></span>
 </dt>
 </dl>
@@ -19189,24 +19471,27 @@ DIRECT SALES (null) (null)  3778500
 </div>
 </div>
 </div>
-<p>This chapter is about access control to database objects such as
-    tables, inside the database engine. Other issues related to security
-    include user authentication, password complexity and secure connections
+<p>This chapter is about controlling access to database objects such as
+    tables and routines. Other topics related to security include user
+    authentication, password complexity and secure connections. These topics
     are covered in the <a class="link" href="#management-chapt" title="Chapter&nbsp;11.&nbsp;System Management">System Management</a> chapter and the <a class="link" href="#listeners-chapt" title="Chapter&nbsp;15.&nbsp;HyperSQL Network Listeners (Servers)">HyperSQL Network Listeners
     (Servers)</a> chapter.</p>
 <p>Apart from schemas and their object, each HyperSQL catalog has USER
     and ROLE objects. These objects are collectively called
     <span class="emphasis"><em>authorizations</em></span>. Each AUTHORIZATION has some access
-    rights on some of the schemas or the objects they contain. The persistent
-    elements of an SQL environment are database objects</p>
-<p>Authorization names are stored in the database in the case-normal
-    form. When connecting to a database via JDBC, the user name and password
-    must match the case of this case-normal form.</p>
-<p>When a user is created with the CREATE USER statement, if the user
-    name is enclosed in double quotes, the exact name is used as the
-    case-normal form. But if it is not enclosed in double quotes, the name is
-    converted to uppercase and this uppercase version is stored in the
-    database as the case-normal form.</p>
+    rights on some of the schemas and the database objects such as tables and
+    routines contained in those schemas.</p>
+<p>Authorization names are stored in the database in case-normal form.
+    When a user is created with the CREATE USER statement, if the user name is
+    enclosed in double quotes, the exact name is used as the case-normal form.
+    But if it is not enclosed in double quotes, the name is converted to
+    uppercase and this uppercase version is stored in the database as the
+    case-normal form. When connecting to a database via JDBC, the user name
+    and password must match the case of the stored form.</p>
+<p>Each database has at least one admin user. When the first connection
+    to a non-existent database is made, the admin user is created with the the
+    user name for the connection. The user name <code class="literal">SA</code> is
+    suggested in the documentation but you can use any name.</p>
 </div>
 <div class="section">
 <div class="titlepage">
@@ -19217,41 +19502,45 @@ DIRECT SALES (null) (null)  3778500
 </div>
 </div>
 </div>
+<a name="N14162" class="indexterm"></a>
 <p>In general, ROLE and USER objects simply control access to schema
-    objects. This is the scope of the SQL Standard. However, there are special
-    roles that allow the creation of USER and ROLE objects and also allow some
-    special operations on the database as a whole. These roles are not defined
-    by the Standard, which has left it to implementers to define such roles as
-    they are needed for the particular SQL implementation.</p>
+    objects. There is the built-in DBA role that allows full access to all
+    possible operations on the database, including the creation of USER and
+    ROLE objects and schemas. There are other built-in roles that allow some
+    special operations on the database as a whole. Admin users have the DBA
+    role.</p>
 <p>A ROLE has a name, a collection of zero or more other roles, plus
     some privileges (access rights). A USER has a name and a password. It
     similarly has a collection of zero or more roles plus some
     privileges.</p>
-<p>USER objects existed in the SQL-92, but ROLE objects were introduced
-    in SQL:1999. Originally it was intended that USER objects would normally
-    be the same as the operating system USER objects and their authentication
-    would be handled outside the SQL environment. The co-existence of ROLE and
-    USER objects results in complexity. With the addition of ROLE objects,
-    there is no rationale, other than legacy support, for granting privileges
-    to USER objects directly. It is better to create roles and grant
-    privileges to them, then grant the roles to USER objects.</p>
+<p>USER objects existed in SQL-92, but ROLE objects were introduced in
+    SQL:1999. The co-existence of ROLE and USER objects results in complexity.
+    With the addition of ROLE objects, there is no rationale, other than
+    legacy support, for granting privileges to USER objects directly. It is
+    better to create roles and grant privileges to them, then grant the roles
+    to USER objects.</p>
 <p>The Standard effectively defines a special ROLE, named PUBLIC. All
     authorizations have the PUBLIC role, which cannot be removed from them.
     Therefore, any access right assigned to the PUBLIC role applies to all
     authorizations in the database. For many simple databases, it is adequate
-    to create a single, non-admin user, then assign access rights to the
-    pre-existing PUBLIC role. Access to INFORMATION_SCHEMA views is granted to
+    to create one or more non-admin user, then assign access rights to the
+    tables and sequences to the PUBLIC role.</p>
+<p>The PUBLIC role is separate from the default PUBLIC schema. The
+    contents of this schema is not visible to non-admin users unless access is
+    granted by the DBA role.</p>
+<p>Access to INFORMATION_SCHEMA views is automatically granted to
     PUBLIC; therefore these views are accessible to all. However, the contents
     of each view depend on the ROLE or USER (AUTHORIZATION) that is in force
-    while accessing the view.</p>
+    while accessing the view. This means a user cannot even see the existence
+    of tables and other objects when it has no access rights on those
+    objects.</p>
 <p>Each schema has a single AUTHORIZATION. This is commonly known as
     the <span class="emphasis"><em>owner</em></span> of the schema. All the objects in the
     schema inherit the schema owner. The schema owner can add objects to the
-    schema, drop them or alter them.</p>
-<p>By default, the objects in a schema can only be accessed by the
-    schema owner. The schema owner can grant access rights on the objects to
-    other users or roles.</p>
-<a name="N14057" class="indexterm"></a>
+    schema, drop them or alter them. By default, the objects in a schema can
+    only be accessed by the schema owner. The schema owner can grant access
+    rights on the objects to other users or roles.</p>
+<a name="N14178" class="indexterm"></a>
 <p>
 <span class="bold"><strong>authorization
     identifier</strong></span>
@@ -19274,29 +19563,31 @@ DIRECT SALES (null) (null)  3778500
 </div>
 </div>
 </div>
+<a name="N1418D" class="indexterm"></a>
 <p>There are some pre-defined roles in each database; some defined by
       the SQL Standard, some by HyperSQL. These roles can be assigned to users
       (directly or via other, user-defined roles). In addition, there is the
-      initial SYS user created with each new database. The initial user name
+      initial admin user created with each new database. The initial user name
       and password is defined in the connection properties when the first
       connection to the database is made. In older versions of HSQLDB, this
       name was always SA. But in the latest version, the name can be defined
       as a different string.</p>
-<a name="N1406E" class="indexterm"></a>
+<a name="N14194" class="indexterm"></a>
 <p>
-<span class="bold"><strong>SYS User</strong></span>
+<span class="bold"><strong>Admin User</strong></span>
 </p>
 <p>
-<span class="emphasis"><em>the SYS user (HyperSQL-specific)</em></span>
+<span class="emphasis"><em>the Admin user
+      (HyperSQL-specific)</em></span>
 </p>
 <p>This user is automatically created with a new database and has
       the DBA role. This user name and its password are defined in the
       connection properties when connecting to the new database to create the
-      database. As this user, it is possible to change the password, create
-      other users and created new schema objects. The initial SYS user can be
+      database. This user can change the password, create other users and
+      create new schemas and other objects. The initial admin user can be
       dropped by another user that has the DBA role. As a result, there is
-      always at least one SYS user in the database.</p>
-<a name="N1407C" class="indexterm"></a>
+      always at least one admin user in the database.</p>
+<a name="N141A2" class="indexterm"></a>
 <p>
 <span class="bold"><strong>PUBLIC</strong></span>
 </p>
@@ -19308,7 +19599,7 @@ DIRECT SALES (null) (null)  3778500
       the INFORMATION_SCHEMA with limited visibility. Any roles or rights
       granted to this role, are in effect granted to all users of the
       database.</p>
-<a name="N1408A" class="indexterm"></a>
+<a name="N141B0" class="indexterm"></a>
 <p>
 <span class="bold"><strong>_SYSTEM</strong></span>
 </p>
@@ -19318,7 +19609,7 @@ DIRECT SALES (null) (null)  3778500
 <p>This role is the authorization for the pre-defined (system)
       objects in the database, including the INFORMATION_SCHEMA. This role
       cannot be assigned to any authorization (user or role).</p>
-<a name="N14098" class="indexterm"></a>
+<a name="N141BE" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DBA</strong></span>
 </p>
@@ -19330,8 +19621,9 @@ DIRECT SALES (null) (null)  3778500
       role can also act as a proxy for all the roles and users in the
       database. This means it can do everything the authorization for a schema
       can do, including dropping the schema or its objects, or granting rights
-      on the schema objects to a grantee.</p>
-<a name="N140A6" class="indexterm"></a>
+      on the schema objects to a grantee. All admin users have this
+      role.</p>
+<a name="N141CC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE_SCHEMA</strong></span>
 </p>
@@ -19342,7 +19634,7 @@ DIRECT SALES (null) (null)  3778500
 <p>An authorization that has this role, can create schemas. The
       DBA authorization has this role and can grant it to other
       authorizations.</p>
-<a name="N140B4" class="indexterm"></a>
+<a name="N141DA" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CHANGE_AUTHORIZATION</strong></span>
 </p>
@@ -19355,7 +19647,7 @@ DIRECT SALES (null) (null)  3778500
       (otherwise, the original user would gain DBA privileges). The DBA
       authorization has this role and can grant it to other
       authorizations.</p>
-<a name="N140C2" class="indexterm"></a>
+<a name="N141E8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SCRIPT_OPS</strong></span>
 </p>
@@ -19376,8 +19668,10 @@ DIRECT SALES (null) (null)  3778500
 </div>
 </div>
 </div>
+<a name="N141FA" class="indexterm"></a>
 <p>Tables in the INFORMATION_SCHEMA contain the list of users and
-      roles for the database.</p>
+      roles for the database. Only admin users can see the full contents of
+      these tables.</p>
 <p>The SYSTEM_USERS tables contains the list of users, with some
       extra settings for each user. The AUTHORIZATIONS table contains a list
       of both users and roles.</p>
@@ -19400,10 +19694,19 @@ DIRECT SALES (null) (null)  3778500
 </div>
 </div>
 </div>
-<p>By default, the objects in a schema can only be accessed by the
-      schema owner. But the schema owner can grant privileges (access rights)
-      on the objects to other users or roles.</p>
-<p>Things can get far more complex, because the grant of privileges
+<a name="N14211" class="indexterm"></a>
+<p>The create schema statements has an optional AUTHORIZATION clause:
+      For example:</p>
+<div class="informalexample">
+<pre class="programlisting"> CREATE SCHEMA mySchema AUTHORIZATION aUserOrRole
+</pre>
+</div>
+<p>If the authorization is not specified, the DBA role becomes the
+      authorization. This authorization is the owner of the schema. By
+      default, the objects in a schema can only be accessed by the schema
+      owner. But the schema owner can grant privileges (access rights) on the
+      objects to other users or roles.</p>
+<p>Things can get far more complex because the grant of privileges
       can be made WITH GRANT OPTION. In this case, the role or user that has
       been granted the privilege can grant the privilege to other roles and
       users.</p>
@@ -19411,9 +19714,9 @@ DIRECT SALES (null) (null)  3778500
 <p>The statements for granting and revoking privileges normally
       specify which privileges are granted or revoked. However, there is a
       shortcut, ALL PRIVILEGES, which means all the privileges that the
-      <code class="literal">&lt;grantor&gt;</code> has on the schema object. The
-      <code class="literal">&lt;grantor&gt;</code> is normally the CURRENT_USER of the
-      session that issues the statement.</p>
+      <code class="literal">&lt;grantor&gt;</code> has on the specified schema object.
+      The <code class="literal">&lt;grantor&gt;</code> is normally the CURRENT_USER of
+      the session that issues the statement.</p>
 <p>The user or role that is granted privileges is referred to as
       <code class="literal">&lt;grantee&gt;</code> for the granted privileges.</p>
 <p>
@@ -19471,16 +19774,75 @@ DIRECT SALES (null) (null)  3778500
 <div>
 <div>
 <h3 class="title">
+<a name="N1425C"></a>Simple Access Control</h3>
+</div>
+</div>
+</div>
+<a name="N1425F" class="indexterm"></a>
+<p>The simplest form of access control is when the DBA user creates a
+      single non-admin user, then creates the tables and other objects in the
+      PUBLIC schema, and grants access to the objects to PUBLIC. A grant to
+      PUBLIC applies to all non-admin users, including any users that are
+      created later.</p>
+<div class="informalexample">
+<pre class="programlisting">CREATE USER generalUser PASSWORD 'aPassword'
+
+-- the objects are created one by one in the PUBLIC schema 
+SET SCHEMA PUBLIC
+CREATE TABLE aTable ...
+CREATE TABLE anotherTable ...
+...
+CREATE SEQUENCE aSequence ...
+CREATE PROCECURE aProc ...
+'''
+
+-- access rights are granted to PUBLIC, which includes the generalUser
+GRANT ALL ON ALL TABLES IN SCHEMA public TO PUBLIC
+GRANT ALL ON ALL SEQUENCES IN SCHEMA public TO PUBLIC
+GRANT ALL ON ALL ROUTINES IN SCHEMA public TO PUBLIC
+</pre>
+</div>
+<p>When different users need to have different levels of access, the
+      privileges are granted to individual users as opposed to PUBLIC. In the
+      example below there are 2 users with different access rights to the
+      objects in the schema.</p>
+<div class="informalexample">
+<pre class="programlisting">-- two users are created first
+CREATE USER generalUser PASSWORD 'aPassword'
+CREATE USER auditUser PASSWORD 'anotherPassword'
+
+-- the schema and its objects are created with a single compound statement 
+CREATE SCHEMA mySchema AUTHORIZATION DBA
+    CREATE TABLE aTable ...
+    CREATE TABLE anotherTable ...
+    ...
+    CREATE SEQUENCE aSequence ...
+    CREATE PROCECURE aProc ...
+    ''';
+
+-- different access rights are granted to the users
+GRANT ALL ON ALL TABLES IN SCHEMA mySchema TO generalUser
+GRANT USAGE ON ALL SEQUENCES IN SCHEMA mySchema TO generalUser
+GRANT EXECUTE ON ALL ROUTINES IN SCHEMA mySchema TO generalUser
+GRANT SELECT ON ALL TABLES IN SCHEMA mySchema TO auditUser;
+</pre>
+</div>
+</div>
+<div class="section">
+<div class="titlepage">
+<div>
+<div>
+<h3 class="title">
 <a name="acc_fine_grained_access"></a>Fine-Grained Data Access Control</h3>
 </div>
 </div>
 </div>
-<a name="N1412B" class="indexterm"></a>
-<p>As mentioned above, a USER or ROLE that does not own a schema can
-      be granted access to individual columns of a table in the schema.
-      HyperSQL adds a feature that is not part of the SQL Standard to allow
-      this access to be granted to a ROLE only for certain rows of a table,
-      based on a FILTER condition.</p>
+<a name="N14272" class="indexterm"></a>
+<p>A USER or ROLE that does not own a schema can be granted access to
+      individual columns of a table in the schema. HyperSQL adds a feature
+      that is not part of the SQL Standard to allow access to be granted to a
+      ROLE only for certain rows of a table, based on a FILTER
+      condition.</p>
 <p>When the GRANT statement contains a FILTER condition, the
       condition is applied to each row of the table that a SELECT, INSERT,
       UPDATE, DELETE or MERGE statement tries to access. Only the rows that
@@ -19493,7 +19855,7 @@ DIRECT SALES (null) (null)  3778500
       A group of ordinary users with the <code class="literal">eu_admin</code> role is
       only allowed to access the data for a certain region. Another group with
       the <code class="literal">eu_user</code> role is only allowed to access the rows
-      before the expiration date. </p>
+      before the expiration date.</p>
 <div class="informalexample">
 <pre class="programlisting">CREATE TABLE info(id INT PRIMARY KEY, info VARCHAR(100), region VARCHAR(32) NOT NULL, expires DATE NOT NULL)
 -- there is also a foreign key constraint on the REGION column to reference a list of valid region names.
@@ -19516,11 +19878,11 @@ GRANT eu_user TO emma, john
       rows they cannot access.</p>
 <p>The <code class="literal">&lt;filter clause&gt;</code> can be used for other
       forms of fine-grained access control. In the example below, the
-      COMMON_USER role is defined and granted access during office hours
+      COMMON_ROLE role is defined and granted access during office hours
       only.</p>
 <div class="informalexample">
-<pre class="programlisting">CREATE ROLE common_user
-GRANT SELECT FILTER (WHERE EXTRACT(HOUR FROM CURRENT_TIMESTAMP) BETWEEN 9 AND 17) ON TABLE info TO common_user
+<pre class="programlisting">CREATE ROLE common_role
+GRANT SELECT FILTER (WHERE EXTRACT(HOUR FROM CURRENT_TIMESTAMP) BETWEEN 9 AND 17) ON TABLE info TO common_role
 </pre>
 </div>
 <p>Fine-grained data access control can also be used to implement
@@ -19553,7 +19915,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     assigned to other roles or to users. The same statements are also used in
     a different form to assign privileges on schema objects to users and
     roles.</p>
-<a name="N1415A" class="indexterm"></a>
+<a name="N142A1" class="indexterm"></a>
 <p>
 <a name="create_user-sql"></a><span class="bold"><strong>CREATE
     USER</strong></span>
@@ -19572,7 +19934,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     characters and is case-sensitive. If <code class="literal">ADMIN</code> is
     specified, the DBA role is granted to the new user. Only a user with the
     DBA role can execute this statement.</p>
-<a name="N14175" class="indexterm"></a>
+<a name="N142BC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP USER</strong></span>
 </p>
@@ -19587,7 +19949,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     authorization for a schema, the schema is destroyed.</p>
 <p>Only a user with the DBA role can execute this
     statement.</p>
-<a name="N14188" class="indexterm"></a>
+<a name="N142CF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ALTER USER ... SET
     PASSWORD</strong></span>
@@ -19606,7 +19968,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     <code class="literal">&lt;password&gt;</code> is a string enclosed with single quote
     characters and is case-sensitive.</p>
 <p>Only a user with the DBA role can execute this command.</p>
-<a name="N141A1" class="indexterm"></a>
+<a name="N142E8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ALTER USER ... SET INITIAL
     SCHEMA</strong></span>
@@ -19628,7 +19990,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     session.</p>
 <p>Only a user with the DBA role can execute this
     statement.</p>
-<a name="N141B7" class="indexterm"></a>
+<a name="N142FE" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ALTER USER ... SET
     LOCAL</strong></span>
@@ -19649,7 +20011,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     authentication for a specific user.</p>
 <p>Only a user with the DBA role can execute this
     statement.</p>
-<a name="N141CA" class="indexterm"></a>
+<a name="N14311" class="indexterm"></a>
 <p>
 <a name="set_password-sql"></a><span class="bold"><strong>SET
     PASSWORD</strong></span>
@@ -19664,7 +20026,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <p>Set the password for the current user.
     <code class="literal">&lt;password&gt;</code> is a string enclosed with single quote
     characters and is case-sensitive.</p>
-<a name="N141DF" class="indexterm"></a>
+<a name="N14326" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET INITIAL SCHEMA</strong></span>
 </p>
@@ -19682,7 +20044,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     for all users is used as the initial schema for the current user. The
     separate SET SCHEMA command allows the user to change the schema for the
     duration of the session. See also the <a class="link" href="#sessions-chapt" title="Chapter&nbsp;6.&nbsp;Sessions and Transactions">Sessions and Transactions</a> chapter.</p>
-<a name="N141F8" class="indexterm"></a>
+<a name="N1433F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE DEFAULT INITIAL
     SCHEMA</strong></span>
@@ -19699,7 +20061,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <p>Sets the initial schema for new users. This schema can later be
     changed with the <code class="literal">&lt;set initial schema statement&gt;</code>
     command.</p>
-<a name="N1420C" class="indexterm"></a>
+<a name="N14353" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE ROLE</strong></span>
 </p>
@@ -19713,7 +20075,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <p>Defines a new role. Initially the role has no rights, except
     those of the PUBLIC role. Only a user with the DBA role can execute this
     command.</p>
-<a name="N1421D" class="indexterm"></a>
+<a name="N14364" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP ROLE</strong></span>
 </p>
@@ -19727,7 +20089,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <p>Drop (destroy) a role. If the specified role is the authorization
     for a schema, the schema is destroyed. Only a user with the DBA role can
     execute this statement.</p>
-<a name="N1422E" class="indexterm"></a>
+<a name="N14375" class="indexterm"></a>
 <p>
 <span class="bold"><strong>GRANTED BY</strong></span>
 </p>
@@ -19746,7 +20108,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     clause can be used in various statements that perform GRANT or REVOKE
     actions. If the clause is not used, the authorization is CURRENT_USER.
     Otherwise, it is the specified authorization.</p>
-<a name="N14245" class="indexterm"></a>
+<a name="N1438C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>GRANT</strong></span>
 </p>
@@ -19783,13 +20145,21 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     EXECUTE</code>
 </p>
 <p>
-<code class="literal">&lt;object name&gt; ::= [ TABLE ] &lt;table name&gt; |
-    DOMAIN &lt;domain name&gt; | COLLATION &lt;collation name&gt; | CHARACTER
-    SET &lt;character set name&gt; | TRANSLATION &lt;transliteration name&gt;
-    | TYPE &lt;user-defined type name&gt; | SEQUENCE &lt;sequence generator
-    name&gt; | &lt;specific routine designator&gt; | ROUTINE &lt;routine
-    name&gt; | FUNCTION &lt;function name&gt; | PROCEDURE &lt;procedure
-    name&gt;</code>
+<code class="literal">&lt;object name&gt; ::= { &lt;single object name&gt; |
+    &lt;schema object set name&gt; }</code>
+</p>
+<p>
+<code class="literal">&lt;simple object name&gt; ::= [ TABLE ] &lt;table
+    name&gt; | DOMAIN &lt;domain name&gt; | COLLATION &lt;collation name&gt; |
+    CHARACTER SET &lt;character set name&gt; | TRANSLATION &lt;transliteration
+    name&gt; | TYPE &lt;user-defined type name&gt; | SEQUENCE &lt;sequence
+    generator name&gt; | &lt;specific routine designator&gt; | ROUTINE
+    &lt;routine name&gt; | FUNCTION &lt;function name&gt; | PROCEDURE
+    &lt;procedure name&gt;</code>
+</p>
+<p>
+<code class="literal">&lt;schema object set name&gt; ::= ALL { TABLES |
+    SEQUENCES | ROUTINES } IN SCHEMA &lt;schema name&gt;</code>
 </p>
 <p>
 <code class="literal">&lt;privilege column list&gt; ::= &lt;column name
@@ -19808,27 +20178,33 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     are discussed in the previous section. For a table or view, if
     <code class="literal">&lt;privilege column list&gt;</code> is not specified, then
     the privilege is granted on the table, which includes all of its columns
-    and any column that may be added to it in the future. For routines, the
-    name of the routine can be specified in two ways, either as the generic
-    name, or as the specific name for a signature. HyperSQL allows referencing
-    the generic name which covers all overloaded versions of a routine at the
-    same time. This is an extension to the SQL Standard which requires the use
-    of <code class="literal">&lt;specific routine designator&gt;</code> to grant
-    privileges separately on each different signature of the
-    routine.</p>
+    and any column that may be added to it in the future.</p>
+<p>For routines, the name of the routine can be specified in two
+    ways, either as the generic name, or as the specific name for a signature.
+    HyperSQL allows referencing the generic name which covers all overloaded
+    versions of a routine at the same time. This is an extension to the SQL
+    Standard, which requires the use of <code class="literal">&lt;specific routine
+    designator&gt;</code> to grant privileges separately on each different
+    signature of the routine.</p>
+<p>HyperSQL also adds the <code class="literal">&lt;schema object set
+    name&gt;</code> option as an extension to the SQL Standard. This form
+    grants the privileges to all the tables of the schema with a single GRANT
+    statement.</p>
 <p>The <code class="literal">&lt;filter clause&gt;</code> can be specified
     after the <code class="literal">&lt;object name&gt;</code> to limit access for all
-    the granted privileges, or it can be used after individual privileges.
-    </p>
+    the granted privileges, or it can be used after individual
+    privileges.</p>
 <p>Each <code class="literal">&lt;grantee&gt;</code> is the name of a role or
     a user. Examples of GRANT statement are given below:</p>
 <div class="informalexample">
 <pre class="programlisting"> GRANT ALL ON SEQUENCE aSequence TO roleOrUser 
- GRANT SELECT ON aTable TO roleOrUser  
+ GRANT SELECT ON aTable TO roleOrUser
+ GRANT SELECT(col3, col5) ON aTable TO aRole  
  GRANT SELECT, UPDATE FILTER(WHERE aColumn &gt; 2) ON aTABLE TO role1 -- filter only for update
  GRANT SELECT, UPDATE ON aTable FILTER(WHERE aColumn &gt; 2) TO role2 -- filter for both select and update
  GRANT SELECT(columnA, columnB), UPDATE(columnA, columnB) ON TABLE aTable TO user1, role1, role2
  GRANT EXECUTE ON SPECIFIC ROUTINE aroutine_1234 TO roleOrUser
+ GRANT SELECT ON ALL TABLES IN SCHEMA mySchema TO PUBLIC
 </pre>
 </div>
 <p>As mentioned in the general discussion, it is better to define a
@@ -19837,7 +20213,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     privileges of this role, they are automatically reflected in all the users
     that have the role. Fine-grained privileges (those with a FILTER clause)
     can be granted to roles only.</p>
-<a name="N14297" class="indexterm"></a>
+<a name="N143EB" class="indexterm"></a>
 <p>
 <span class="bold"><strong>GRANT</strong></span>
 </p>
@@ -19866,7 +20242,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
  GRANT EXECUTE ON ROUTINE aroutine TO approle
 </pre>
 </div>
-<a name="N142B7" class="indexterm"></a>
+<a name="N1440B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>REVOKE privilege</strong></span>
 </p>
@@ -19879,8 +20255,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     &lt;grantee&gt; }... ] [ GRANTED BY &lt;grantor&gt; ] RESTRICT |
     CASCADE</code>
 </p>
-<p>Revoke privileges from a user or role.</p>
-<a name="N142C8" class="indexterm"></a>
+<p>Revoke privileges from a user or role. The syntax elements are
+    similar to the GRANT statements.</p>
+<a name="N1441C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>REVOKE role</strong></span>
 </p>
@@ -19921,12 +20298,12 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6327 $</p>
+<p class="releaseinfo">$Revision: 6474 $</p>
 </div>
 <div>
 <div class="legalnotice">
-<a name="N14300"></a>
-<p>Copyright 2010-2021 Fred Toussi. Permission is granted to
+<a name="N14454"></a>
+<p>Copyright 2010-2022 Fred Toussi. Permission is granted to
       distribute this document without any alteration under the terms of the
       HSQLDB license. Additional permission is granted to the HSQL Development
       Group to distribute this document with or without alterations under the
@@ -19934,7 +20311,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -20073,7 +20450,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 <p>SQL-invoked routines are functions and procedures called from SQL.
-    HyperSQL 2.6 supports routines conforming to two parts of the SQL
+    HyperSQL 2.7 supports routines conforming to two parts of the SQL
     Standard. Routines written in the SQL language are supported in
     conformance to SQL/PSM (Persistent Stored Modules) specification. Routines
     written in Java are supported in broad conformance to SQL/JRT
@@ -20162,11 +20539,11 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <p>Routine definition has several mandatory or optional clauses. The
     complete BNF supported by HyperSQL and the remaining clauses are
     documented in this section.</p>
-<a name="N1434D" class="indexterm"></a>
+<a name="N144A1" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE FUNCTION</strong></span>
 </p>
-<a name="N14356" class="indexterm"></a>
+<a name="N144AA" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE PROCEDURE</strong></span>
 </p>
@@ -20213,7 +20590,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     type&gt;</code>
 </p>
 <p>Return Value and Table Functions</p>
-<a name="N14383" class="indexterm"></a>
+<a name="N144D7" class="indexterm"></a>
 <p>
 <span class="bold"><strong>RETURNS</strong></span>
 </p>
@@ -20270,7 +20647,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <code class="literal">&lt;returns data type&gt; ::= &lt;data
     type&gt;</code>
 </p>
-<a name="N143C3" class="indexterm"></a>
+<a name="N14517" class="indexterm"></a>
 <p>
 <span class="bold"><strong>routine body</strong></span>
 </p>
@@ -20302,7 +20679,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <code class="literal">&lt;rights clause&gt; ::= SQL SECURITY INVOKER | SQL
     SECURITY DEFINER</code>
 </p>
-<a name="N143E3" class="indexterm"></a>
+<a name="N14537" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SQL routine body</strong></span>
 </p>
@@ -20314,7 +20691,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <code class="literal">&lt;SQL routine body&gt; ::= &lt;SQL procedure
     statement&gt;</code>
 </p>
-<a name="N143F4" class="indexterm"></a>
+<a name="N14548" class="indexterm"></a>
 <p>
 <span class="bold"><strong>EXTERNAL NAME</strong></span>
 </p>
@@ -20360,7 +20737,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       characteristic&gt; | &lt;savepoint level
       indication&gt;</code>
 </p>
-<a name="N1441D" class="indexterm"></a>
+<a name="N14571" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LANGUAGE</strong></span>
 </p>
@@ -20385,7 +20762,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <p>
 <code class="literal">&lt;parameter style&gt; ::= JAVA</code>
 </p>
-<a name="N14439" class="indexterm"></a>
+<a name="N1458D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SPECIFIC NAME</strong></span>
 </p>
@@ -20415,7 +20792,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 
 </pre>
 </div>
-<a name="N14453" class="indexterm"></a>
+<a name="N145A7" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DETERMINISTIC</strong></span>
 </p>
@@ -20434,7 +20811,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <code class="literal">&lt;deterministic characteristic&gt; ::= DETERMINISTIC
       | NOT DETERMINISTIC</code>
 </p>
-<a name="N1446A" class="indexterm"></a>
+<a name="N145BE" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SQL DATA access</strong></span>
 </p>
@@ -20463,7 +20840,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <code class="literal">&lt;SQL-data access indication&gt; ::= NO SQL |
       CONTAINS SQL | READS SQL DATA | MODIFIES SQL DATA</code>
 </p>
-<a name="N14498" class="indexterm"></a>
+<a name="N145EC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>NULL INPUT</strong></span>
 </p>
@@ -20482,7 +20859,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <code class="literal">&lt;null-call clause&gt; ::= RETURNS NULL ON NULL
       INPUT | CALLED ON NULL INPUT</code>
 </p>
-<a name="N144B1" class="indexterm"></a>
+<a name="N14605" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SAVEPOINT LEVEL</strong></span>
 </p>
@@ -20500,7 +20877,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <code class="literal">&lt;savepoint level indication&gt; ::= NEW SAVEPOINT
       LEVEL | OLD SAVEPOINT LEVEL</code>
 </p>
-<a name="N144CB" class="indexterm"></a>
+<a name="N1461F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DYNAMIC RESULT SETS</strong></span>
 </p>
@@ -20836,7 +21213,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </pre>
 </div>
 <p>The BNF for variable declaration is given below:</p>
-<a name="N145C4" class="indexterm"></a>
+<a name="N14718" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DECLARE variable</strong></span>
 </p>
@@ -20999,7 +21376,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <p>The BNF for <code class="literal">&lt;handler declaration&gt;</code> is
       given below:</p>
-<a name="N14671" class="indexterm"></a>
+<a name="N147C5" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DECLARE HANDLER</strong></span>
 </p>
@@ -21138,7 +21515,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <p>A special form of SELECT can also be used for assigning values
       from a query to one or more arguments or variables. This works similar
       to a SET statement that has a SELECT statement as the source.</p>
-<a name="N146F6" class="indexterm"></a>
+<a name="N1484A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SELECT : SINGLE ROW</strong></span>
 </p>
@@ -21233,7 +21610,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       of one or more SQL statements. The <code class="literal">&lt;search
       condition&gt;</code> can be any valid SQL expression of BOOLEAN
       type.</p>
-<a name="N1473D" class="indexterm"></a>
+<a name="N14891" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LOOP</strong></span>
 </p>
@@ -21248,7 +21625,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <p>The LOOP statement is a simple loop without its own condition. A
       conditional LEAVE statement inside the loop is used to break out of the
       loop.</p>
-<a name="N1474E" class="indexterm"></a>
+<a name="N148A2" class="indexterm"></a>
 <p>
 <span class="bold"><strong>WHILE</strong></span>
 </p>
@@ -21276,7 +21653,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 
 </pre>
 </div>
-<a name="N14767" class="indexterm"></a>
+<a name="N148BB" class="indexterm"></a>
 <p>
 <span class="bold"><strong>REPEAT</strong></span>
 </p>
@@ -21307,7 +21684,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       iterated statement, but it is always used with a cursor declaration to
       iterate over the rows of the result set of the cursor and perform
       operations using the values of each row.</p>
-<a name="N14787" class="indexterm"></a>
+<a name="N148DB" class="indexterm"></a>
 <p>
 <span class="bold"><strong>FOR</strong></span>
 </p>
@@ -21371,7 +21748,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <p>There are two types of CASE ... WHEN statement and the IF ... THEN
       statement.</p>
-<a name="N147AD" class="indexterm"></a>
+<a name="N14901" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CASE WHEN</strong></span>
 </p>
@@ -21439,7 +21816,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 
 </pre>
 </div>
-<a name="N147D9" class="indexterm"></a>
+<a name="N1492D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>IF</strong></span>
 </p>
@@ -21494,7 +21871,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       ResultSet returned from a function that returns a result set. If the
       function returns a scalar value, the returned result has a single column
       and a single row which contains the scalar returned value.</p>
-<a name="N1480A" class="indexterm"></a>
+<a name="N1495E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>RETURN</strong></span>
 </p>
@@ -21588,7 +21965,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <p>Signal and Resignal Statements allow the routine to throw an
       exception. If used with the IF or CASE conditions, the exception is
       thrown conditionally.</p>
-<a name="N14845" class="indexterm"></a>
+<a name="N14999" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SIGNAL</strong></span>
 </p>
@@ -21610,7 +21987,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       value&gt; [ SET MESSAGE_TEXT = &lt;character string literal&gt; ]
       </code>
 </p>
-<a name="N14858" class="indexterm"></a>
+<a name="N149AC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>RESIGNAL</strong></span>
 </p>
@@ -22465,7 +22842,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       fourth parameters have user-defined types and must be defined as INOUT
       parameters. The defined return type of the function determines the type
       of the value returned when the function is invoked.</p>
-<a name="N14A66" class="indexterm"></a>
+<a name="N14BBA" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE AGGREGATE
       FUNCTION</strong></span>
@@ -22730,8 +23107,8 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <div>
 <div class="legalnotice">
-<a name="N14AFF"></a>
-<p>Copyright 2010-2021 Fred Toussi. Permission is granted to
+<a name="N14C53"></a>
+<p>Copyright 2010-2022 Fred Toussi. Permission is granted to
       distribute this document without any alteration under the terms of the
       HSQLDB license. Additional permission is granted to the HSQL Development
       Group to distribute this document with or without alterations under the
@@ -22739,7 +23116,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -23164,7 +23541,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 </div>
-<a name="N14BC0" class="indexterm"></a>
+<a name="N14D14" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE TRIGGER</strong></span>
 </p>
@@ -23272,7 +23649,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     interface.</p>
 <p>Early releases of HyperSQL version 2.x did not allow the use of
     OLD TABLE or NEW TABLE in statement level triggers.</p>
-<a name="N14C2B" class="indexterm"></a>
+<a name="N14D7F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TRIGGERED SQL
     STATEMENT</strong></span>
@@ -23325,7 +23702,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </pre>
 </div>
 <p></p>
-<a name="N14C4F" class="indexterm"></a>
+<a name="N14DA3" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TRIGGER EXECUTION
     ORDER</strong></span>
@@ -23343,7 +23720,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     specified other trigger. If this clause is not used, the new trigger is
     executed after all the previously defined triggers of the same scope
     (BEFORE / AFTER, EACH ROW / EACH STATEMENT).</p>
-<a name="N14C60" class="indexterm"></a>
+<a name="N14DB4" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP TRIGGER</strong></span>
 </p>
@@ -23378,12 +23755,12 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6366 $</p>
+<p class="releaseinfo">$Revision: 6577 $</p>
 </div>
 <div>
 <div class="legalnotice">
-<a name="N14C95"></a>
-<p>Copyright 2002-2021 Fred Toussi. Permission is granted to
+<a name="N14DE9"></a>
+<p>Copyright 2002-2022 Fred Toussi. Permission is granted to
       distribute this document without any alteration under the terms of the
       HSQLDB license. Additional permission is granted to the HSQL Development
       Group to distribute this document with or without alterations under the
@@ -23391,7 +23768,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -23814,7 +24191,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       becomes an issue, you can change one or all LOB schema tables to CACHED
       tables. See statements below:</p>
 <div class="example">
-<a name="N14D64"></a>
+<a name="N14EB8"></a>
 <p class="title">
 <b>Example&nbsp;11.1.&nbsp;Using CACHED tables for the LOB schema</b>
 </p>
@@ -23884,14 +24261,14 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     and FOREIGN KEY constraints: a unique index is created for each PRIMARY
     KEY or UNIQUE constraint; a non-unique index is created for each FOREIGN
     KEY constraint.</p>
-<p>From version 2.6.0, you can extend the non-unique index for a
-    FORIEGN KEY constraint to cover extra columns. For example, if you have a
-    FOREIGN KEY constraint defined on
-    <code class="literal">INVOICES(CUSTOMER_ID)</code>, you can add an extra column such
-    as <code class="literal">INVOICE_DATE</code> to the FOREIGN KEY index. This speeds
-    up queries with conditions such as: <code class="literal">WHERE customer_id = 456 and
-    invoice_date = '2020-02-02</code>. See the ALTER CONSTRAINT statement
-    for syntax.</p>
+<p>From version 2.6, you can extend the non-unique index for a FORIEGN
+    KEY constraint to cover extra columns. For example, if you have a FOREIGN
+    KEY constraint defined on <code class="literal">INVOICES(CUSTOMER_ID)</code>, you
+    can add an extra column such as <code class="literal">INVOICE_DATE</code> to the
+    FOREIGN KEY index. This speeds up queries with conditions such as:
+    <code class="literal">WHERE customer_id = 456 and invoice_date =
+    '2020-02-02'</code>. See the ALTER CONSTRAINT statement for
+    syntax.</p>
 <p>HyperSQL allows you to define indexes on single or multiple columns
     with the CREATE INDEX statement. You should not create duplicate indexes
     on the same column sets covered by constraints. This will result in
@@ -24266,7 +24643,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 </div>
-<a name="N14EAF" class="indexterm"></a>
+<a name="N15003" class="indexterm"></a>
 <p>HyperSQL 2.5 and later allows you to store data in temporal
     system-versioned tables. The additional syntax elements for CREATE TABLE
     and ALTER TABLE allow creating system-versioned tables and adding system
@@ -24307,7 +24684,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     chapter.</p>
 <p>An example of a system-versioned table follows:</p>
 <div class="example">
-<a name="N14ED7"></a>
+<a name="N1502B"></a>
 <p class="title">
 <b>Example&nbsp;11.2.&nbsp;Creating a system-versioned table</b>
 </p>
@@ -24334,7 +24711,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 </div>
-<a name="N14EE0" class="indexterm"></a>
+<a name="N15034" class="indexterm"></a>
 <p>Replicated databases are databases with multiple copies in different
     locations that contain the same table structure and data. With
     system-versioned tables, a set of replicas can be synchronized.</p>
@@ -24350,7 +24727,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     longer to import.</p>
 <div class="informalexample">
 <pre class="programlisting"> -- on one replica, the changes from the given UTC timestamp are exported to a file 
- PERFORM EXPORT SCRIPT FOR DATABASE VERSIONING DATA FROM '2021-03-21 08:00:00' TO '/data/diff_file'
+ PERFORM EXPORT SCRIPT FOR DATABASE VERSIONING DATA FROM '2022-03-21 08:00:00' TO '/data/diff_file'
   
  -- on another replica, the diff file is imported and the changes are merged into the database
  PERFORM IMPORT SCRIPT VERSIONING DATA FROM '/data/diff_file'
@@ -24375,7 +24752,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 </div>
-<a name="N14EF4" class="indexterm"></a>
+<a name="N15048" class="indexterm"></a>
 <p>Data for all CACHED tables is stored in the <code class="literal">.data</code>
     file. With a new recommended setting, HyperSQL 2.5 and later allocates
     separate blocks of the data file to different CACHED tables. This is
@@ -24403,6 +24780,12 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <p>
 <code class="literal">SET FILES SPACE TRUE </code>
 </p>
+<p>The alternative is to include the corresponding connection property
+    on the JDBC connection URL that creates the database. For example:</p>
+<p>
+<code class="literal">jdbc:hsqldb:file:&lt;database
+    path&gt;;hsqldb.files_space=true</code>
+</p>
 <p>Then the statement below should be executed for each CACHED table
     that will have its own space:</p>
 <p>
@@ -24436,12 +24819,12 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     the <code class="code">SET FILES SPACE TRUE</code> command is executed when there are
     already some rows in any CACHED table, the change does not happen
     immediately. In this case, the table spaces are created only when
-    CHCKPOINT DEFRAG, SHUTDOWN COMPACT or SHUTDOWN SCRIPT is executed. Among
+    CHECKPOINT DEFRAG, SHUTDOWN COMPACT, or SHUTDOWN SCRIPT is executed. Among
     these commands, CHECKPOINT DEFRAG will also automatically allocate a
     separate space to each table that is larger than a certain size.</p>
-<p>In a database with table spaces, the <code class="code">SET TABLE &lt;table
-    name&gt; NEW SPACE</code> command immediately applies a separate space to
-    the table.</p>
+<p>In a database with table spaces enabled, the <code class="code">SET TABLE
+    &lt;table name&gt; NEW SPACE</code> command immediately applies a separate
+    space to the table, whether it is empty or has data..</p>
 </div>
 <div class="section">
 <div class="titlepage">
@@ -24453,11 +24836,11 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 <p>
-<a name="N14F39" class="indexterm"></a>
+<a name="N15092" class="indexterm"></a>
 </p>
-<p>From version 2.5.1, the integrity of the indexes and table data can
-    be checked with a command. This applies to CACHED tables only. Individual
-    tables or all tables can be checked.</p>
+<p>The integrity of the indexes and table data can be checked with a
+    statement. This applies to CACHED tables only. Individual tables or all
+    tables can be checked.</p>
 <div class="informalexample">
 <pre class="programlisting"> PERFORM CHECK TABLE PUBLIC.CUSTOMER INDEX [ AND FIX ]</pre>
 </div>
@@ -24483,7 +24866,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 </div>
-<a name="N14F50" class="indexterm"></a>
+<a name="N150A9" class="indexterm"></a>
 <p>The database engine saves the files containing all the data in a
     file catalog when a shutdown takes place. It automatically recovers from
     an abnormal termination and preserves the data when the catalog is opened
@@ -24553,7 +24936,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       command-line to make offline backups and to restore backups. Here is how
       to see all options for <code class="classname">DbBackup</code>. </p>
 <div class="example">
-<a name="N14F94"></a>
+<a name="N150ED"></a>
 <p class="title">
 <b>Example&nbsp;11.3.&nbsp;Displaying DbBackup Syntax</b>
 </p>
@@ -24579,7 +24962,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       database is named dbname and is in the dbdir directory. The backup is
       saved to a file named backup.tar in the tardir directory.</p>
 <div class="example">
-<a name="N14F9F"></a>
+<a name="N150F8"></a>
 <p class="title">
 <b>Example&nbsp;11.4.&nbsp;Offline Backup Example</b>
 </p>
@@ -24609,7 +24992,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       or with any Pax-compliant tar or pax client (this includes GNU tar),
       </p>
 <div class="example">
-<a name="N14FC0"></a>
+<a name="N15119"></a>
 <p class="title">
 <b>Example&nbsp;11.5.&nbsp;Listing a Backup with DbBackup</b>
 </p>
@@ -24639,7 +25022,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <p>You use <code class="classname">DbBackup</code> on your operating system
       command line to restore a catalog from a backup. </p>
 <div class="example">
-<a name="N14FD7"></a>
+<a name="N15130"></a>
 <p class="title">
 <b>Example&nbsp;11.6.&nbsp;Restoring a Backup with DbBackup</b>
 </p>
@@ -24735,8 +25118,8 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       production. Create your own random values.</p>
 <p>The files that are encrypted include the
       <code class="literal">.script</code>, <code class="literal">.data</code>,
-      <code class="literal">.backup</code> and <code class="literal">.log</code> files. In version
-      2.5 and later, the <code class="literal">.lobs</code> file is also encrypted by
+      <code class="literal">.backup</code> and <code class="literal">.log</code> files. From
+      version 2.5, the <code class="literal">.lobs</code> file is also encrypted by
       default and the blobs and clobs are both compressed and encrypted. You
       can override this with the property <code class="literal">crypt_lobs=false</code>
       on the URL. Earlier versions of HSQLDB did not support encrypted lobs,
@@ -24849,7 +25232,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       be enabled with the <code class="literal">SET DATABASE EVENT LOG SQL LEVEL</code>
       statement, described in this chapter. As all the executed statements are
       logged, there is a small impact on speed. So you should only use this
-      for debugging. Two levels of SQL logging are supported.</p>
+      for debugging. Four levels of SQL logging are supported.</p>
 </div>
 <div class="section">
 <div class="titlepage">
@@ -24891,11 +25274,14 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       the unique id (a 16 character string) of the database that generated the
       message, so they can be identified in a multi-database server
       context.</p>
+<p>The extent of logged messages is controlled with the <code class="literal">SET
+      DATABASE EXTERNAL EVENT LOG LEVEL</code> statement, described in this
+      chapter.</p>
 <p>As the default JDK logging framework has several shortcomings,
-      HyperSQL configures this logging framework for better operation. If you
-      do not want HyperSQL to configure the JDK logging framework, you should
+      HyperSQL can configures this logging framework for better operation. If
+      you want HyperSQL to configure the JDK logging framework, you should
       include the system level property
-      <code class="literal">hsqldb.reconfig_logging=false</code> in your
+      <code class="literal">hsqldb.reconfig_logging=true</code> in your
       environment.</p>
 </div>
 <div class="section">
@@ -25073,7 +25459,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       password authentication. Each user is created with a password, which is
       stored as a hash in the database and checked each time a new database
       connection is created.</p>
-<a name="N150DD" class="indexterm"></a>
+<a name="N1523B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>Password Complexity
       Check</strong></span>
@@ -25083,7 +25469,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       the database. Each time a user connects, the user's name and password
       are checked against the stored list of users and passwords. The
       connection attempt is rejected if there is no match.</p>
-<a name="N150E8" class="indexterm"></a>
+<a name="N15246" class="indexterm"></a>
 <p>
 <span class="bold"><strong>External
       Authentication</strong></span>
@@ -25122,7 +25508,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 <p>These statements perform a system level action.</p>
-<a name="N15105" class="indexterm"></a>
+<a name="N15263" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SHUTDOWN</strong></span>
 </p>
@@ -25206,7 +25592,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <p>Only a user with the DBA role can execute this
       statement.</p>
-<a name="N15145" class="indexterm"></a>
+<a name="N152A3" class="indexterm"></a>
 <p>
 <span class="bold"><strong>BACKUP DATABASE</strong></span>
 </p>
@@ -25264,7 +25650,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       chapter under Backing up Database Catalogs.</p>
 <p>Only a user with the DBA role can execute this
       statement.</p>
-<a name="N15185" class="indexterm"></a>
+<a name="N152E3" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CHECKPOINT</strong></span>
 </p>
@@ -25287,7 +25673,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       sessions.</p>
 <p>Only a user with the DBA role can execute this
       statement.</p>
-<a name="N151A5" class="indexterm"></a>
+<a name="N15303" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SCRIPT</strong></span>
 </p>
@@ -25322,7 +25708,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <p>These statements allow data to be transferred in bulk from one
       database to another using files formatted in the same manner as the
       <code class="literal">.script</code> files.</p>
-<a name="N151C7" class="indexterm"></a>
+<a name="N15325" class="indexterm"></a>
 <p>
 <span class="bold"><strong>EXPORT SCRIPT</strong></span>
 </p>
@@ -25366,7 +25752,26 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       to allow synchronization across time zones.</p>
 <p>Only a user with the SCRIPT_OPS role can execute this
       statement.</p>
-<a name="N151EC" class="indexterm"></a>
+<a name="N1534A" class="indexterm"></a>
+<p>
+<span class="bold"><strong>EXPORT DSV</strong></span>
+</p>
+<p>
+<span class="emphasis"><em>export DSV statement</em></span>
+</p>
+<p>
+<code class="literal">&lt;export DSV statement&gt; ::= PERFORM EXPORT DATA
+      FROM TABLE &lt;table name&gt; TO &lt;single-quouted text file source
+      string&gt;</code>
+</p>
+<p>Writes the contents of a table as a DSV file, for example as a
+      Comma-Seperated Values (CSV).</p>
+<p>The destination is defined as a file path together with
+      optional setting as defined for a TEXT table. See the Text Tables
+      chapter for the properties.</p>
+<p>Only a user with the SCRIPT_OPS role can execute this
+      statement.</p>
+<a name="N1535F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>IMPORT SCRIPT</strong></span>
 </p>
@@ -25407,7 +25812,37 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       the <code class="literal">.reject</code> file.</p>
 <p>Only a user with the SCRIPT_OPS role can execute this
       statement.</p>
-<a name="N1520C" class="indexterm"></a>
+<a name="N1537F" class="indexterm"></a>
+<p>
+<span class="bold"><strong>IMPORT DSV</strong></span>
+</p>
+<p>
+<span class="emphasis"><em>import DSV statement</em></span>
+</p>
+<p>
+<code class="literal">&lt;import DSV statement&gt; ::= PERFORM IMPORT DATA
+      INTO &lt;table name&gt; FROM &lt;single-quoted file path&gt; { CONTINUE
+      | STOP | CHECK } ON ERROR</code>
+</p>
+<p>Imports data from a DSV file into a table. The file to be
+      imported may be a file exported with the EXPORT DSV statement listed
+      above, or a file from another source. The source is defined as a file
+      path together with optional setting as defined for a TEXT table. See the
+      Text Tables chapter for the properties.</p>
+<p>The { CONTINUE | STOP | CHECK } ON ERROR clause determines the
+      action when an error occurs due to constraint violation. The CHECK
+      option does not insert the data, but checks each line of data in the DSV
+      file for type constraints such as string size limit or row constraints
+      such as NOT NULL. It cannot check for UNIQUE constraints. The STOP
+      option stops the import at the first error. The CONTINUE option writes
+      the rows that cannot be imported, to a file in the same location as the
+      imported script, with the file suffix <code class="literal">.reject</code> and the
+      timestamp of the import, then continues the import. If there is a
+      malformed line in the DSV file, the import is aborted with an error
+      message, regardless of the ON ERROR option.</p>
+<p>Only a user with the SCRIPT_OPS role can execute this
+      statement.</p>
+<a name="N15397" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CHECK INDEX</strong></span>
 </p>
@@ -25449,7 +25884,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 <p>These statements change the database settings.</p>
-<a name="N1522D" class="indexterm"></a>
+<a name="N153B8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE
       COLLATION</strong></span>
@@ -25488,7 +25923,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
  -- this collation is case-sensitive French
  SET DATABASE COLLATION "French 2"  </pre>
 </div>
-<a name="N1525A" class="indexterm"></a>
+<a name="N153E5" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE DEFAULT RESULT MEMORY
       ROWS</strong></span>
@@ -25514,7 +25949,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.result_max_memory_rows</code>.</p>
-<a name="N1527C" class="indexterm"></a>
+<a name="N15407" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE DEFAULT TABLE
       TYPE</strong></span>
@@ -25533,7 +25968,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.default_table_type</code>.</p>
-<a name="N15296" class="indexterm"></a>
+<a name="N15421" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE EVENT LOG
       LEVEL</strong></span>
@@ -25544,30 +25979,41 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </p>
 <p>
 <code class="literal">&lt;set database event log level&gt; ::= SET DATABASE
-      EVENT LOG [ SQL ] LEVEL { 0 | 1 | 2 | 3 }</code>
+      [EXTERNAL] EVENT LOG [ SQL ] LEVEL { 0 | 1 | 2 | 3 |
+      4}</code>
 </p>
-<p>When the SQL option is not used, this statement sets the amount
-      of information logged in the internal, database-specific event log.
-      Level 0 means no log. Level 1 means only important (error) events. Level
-      2 means more events, including both important and less important
-      (normal) events. Level 3 includes even more details. For readonly and
-      <em class="glossterm">mem:</em> databases, if the level is set above 0, the
-      log messages are directed to stderr.</p>
+<p>This statement has 3 different purposes and can be used up to
+      three times with different options to configure various event logging
+      operations.</p>
+<p>When the EXTERNAL and SQL options are not used, this statement
+      sets the amount of information logged in the internal, database-specific
+      event log. Level 0 means no log. Level 1 means only important (error)
+      events. Level 2 means warning events as well. Level 3 means more events,
+      including both important and less important (normal) events. Level 4
+      includes even more details.</p>
 <p>The events are logged in a file with the extension
-      <code class="literal">.app.log</code> alongside the main database files.</p>
-<p>This is equivalent to the connection property
+      <code class="literal">.app.log</code> alongside the main database files. For
+      readonly and <em class="glossterm">mem:</em> databases, if the level is set
+      above 0, the log messages are directed to stderr, but these databases do
+      not generate many log messages.</p>
+<p>This command is equivalent to the connection property
       <code class="literal">hsqldb.applog</code>.</p>
+<p>When the EXTERNAL option is used (the SQL option is not allowed
+      in this case), the statement configures the level of events that are
+      logged to the JDK or Log4J logger. For example, LEVEL 2 indicates error
+      and warning events (levels 1 and 2) are logged.</p>
 <p>When the SQL option is used, this statement logs the SQL
       statements as they are executed. Each log line contains the timestamp
       and the session number, followed by the SQL statement and JDBC arguments
       if any.</p>
-<p>Levels 1, 2 and 3 are supported. Level 1 only logs commits and
-      rollbacks, while Level 2 and 3 log all statements. Level 2 truncates
+<p>Levels 1, 2, 3 and 4 are supported. Level 1 only logs commits
+      and rollbacks. Level 2 and above log all statements. Level 2 truncates
       long statements, while level 3 reports the full statement and parameter
-      values.</p>
+      values. Level 4 add the update count or the size of the returned result
+      set.</p>
 <p>The logged lines are stored in a file with the extension
       <code class="literal">.sql.log</code> alongside the main database files.</p>
-<p>This is equivalent to the connection property
+<p>This command is equivalent to the connection property
       <code class="literal">hsqldb.sqllog</code>.</p>
 <p>Only a user with the DBA role can execute this
       statement.</p>
@@ -25580,12 +26026,12 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       number. The values for prepared statement parameters are shown in
       parentheses at the end of the statement.</p>
 <div class="example">
-<a name="N152CE"></a>
+<a name="N1545D"></a>
 <p class="title">
 <b>Example&nbsp;11.7.&nbsp;SQL Log Example</b>
 </p>
 <div class="example-contents">
-<pre class="screen"> 2012-11-29 10:40:40.250 10 INSERT INTO TEST_CLOB VALUES (1,'Ut wisi enim ad minim veniam, quis nostrud exerci') 
+<pre class="screen"> 2012-11-29 10:40:40.250 10 INSERT INTO TEST_CLOB VALUES (1,'Ut enim ad minima veniam, quis nostrum exercitationem ...') 
  2012-11-29 10:40:40.250 1 INSERT INTO SYSTEM_LOBS.LOB_IDS VALUES(?, ?, ?, ?) (1,49,0,40)
  2012-11-29 10:40:40.250 1 COMMIT 
  2012-11-29 10:40:40.265 1 CALL SYSTEM_LOBS.ALLOC_BLOCKS(?, ?, ?) (1,0,1)
@@ -25594,7 +26040,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 <br class="example-break">
-<a name="N152D3" class="indexterm"></a>
+<a name="N15462" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE GC</strong></span>
 </p>
@@ -25605,12 +26051,12 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <code class="literal">&lt;set database gc statement&gt; ::= SET DATABASE GC
       &lt;unsigned integer literal&gt;</code>
 </p>
-<p>In previous versions an optional property which forced calls to
-      <code class="literal">System.gc() </code>after the specified number of row
-      operations. This has no effect from version 2.5.0.</p>
+<p>In previous versions, an optional property which forced calls
+      to <code class="literal">System.gc() </code>after the specified number of row
+      operations. This has no effect from version 2.5.</p>
 <p>Only a user with the DBA role can execute this
       statement.</p>
-<a name="N152E9" class="indexterm"></a>
+<a name="N15478" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE TEXT TABLE
       DEFAULTS</strong></span>
@@ -25631,7 +26077,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       chapter.</p>
 <p>Only a user with the DBA role can execute this
       statement.</p>
-<a name="N15300" class="indexterm"></a>
+<a name="N1548F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE TRANSACTION
       CONTROL</strong></span>
@@ -25652,7 +26098,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.tx</code>.</p>
-<a name="N1531C" class="indexterm"></a>
+<a name="N154AB" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE TRANSACTION ROLLBACK ON
       CONFLICT</strong></span>
@@ -25679,7 +26125,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.tx_conflict_rollback</code>.</p>
-<a name="N15338" class="indexterm"></a>
+<a name="N154C7" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE TRANSACTION ROLLBACK ON
       INTERRUPT</strong></span>
@@ -25702,7 +26148,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.tx_conflict_rollback</code>.</p>
-<a name="N15354" class="indexterm"></a>
+<a name="N154E3" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE DEFAULT ISOLATION
       LEVEL</strong></span>
@@ -25723,7 +26169,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.tx_level</code>.</p>
-<a name="N1536E" class="indexterm"></a>
+<a name="N154FD" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE UNIQUE
       NAME</strong></span>
@@ -25744,7 +26190,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       spaces.</p>
 <p>Only a user with the DBA role can execute this
       statement.</p>
-<a name="N15383" class="indexterm"></a>
+<a name="N15512" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET TABLE TYPE</strong></span>
 </p>
@@ -25780,7 +26226,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       as it is practical, it is best to set the non-conforming defaults to
       TRUE in order to improve the quality of the database
       application.</p>
-<a name="N1539C" class="indexterm"></a>
+<a name="N1552B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL RESTRICT
       EXEC</strong></span>
@@ -25805,7 +26251,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.restrict_exec</code>.</p>
-<a name="N153BC" class="indexterm"></a>
+<a name="N1554B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL
       SIZE</strong></span>
@@ -25826,7 +26272,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.enforce_size</code>.</p>
-<a name="N153DC" class="indexterm"></a>
+<a name="N1556B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL
       NAMES</strong></span>
@@ -25850,7 +26296,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.enforce_names</code>.</p>
-<a name="N153FB" class="indexterm"></a>
+<a name="N1558A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL REGULAR
       NAMES</strong></span>
@@ -25876,7 +26322,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.regular_names</code>.</p>
-<a name="N15418" class="indexterm"></a>
+<a name="N155A7" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL
       REFERENCES</strong></span>
@@ -25903,7 +26349,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.enforce_refs</code>.</p>
-<a name="N1543A" class="indexterm"></a>
+<a name="N155C9" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL
       TYPES</strong></span>
@@ -25930,7 +26376,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.enforce_type</code>.</p>
-<a name="N1545E" class="indexterm"></a>
+<a name="N155ED" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL TDC
       DELETE</strong></span>
@@ -25958,7 +26404,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.enforce_tdc_delete</code>.</p>
-<a name="N1547F" class="indexterm"></a>
+<a name="N1560E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL TDC
       UPDATE</strong></span>
@@ -25986,7 +26432,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.enforce_tdc_update</code>.</p>
-<a name="N154A1" class="indexterm"></a>
+<a name="N15630" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL TRANSLATE TTI
       TYPES</strong></span>
@@ -26017,7 +26463,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">jdbc.translate_tti_types</code>.</p>
-<a name="N154C9" class="indexterm"></a>
+<a name="N15658" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL CHARACTER
       LITERAL</strong></span>
@@ -26045,7 +26491,34 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.char_literal</code>.</p>
-<a name="N154FF" class="indexterm"></a>
+<a name="N1568E" class="indexterm"></a>
+<p>
+<span class="bold"><strong>SET DATABASE SQL TRUNCATE
+      TRAILING</strong></span>
+</p>
+<p>
+<span class="emphasis"><em>set database sql truncate
+      trailing</em></span>
+</p>
+<p>
+<code class="literal">&lt;set database sql truncate trailing&gt; ::= SET
+      DATABASE SQL TRUNCATE TRAILING { TRUE | FALSE }</code>
+</p>
+<p>By default, this property is <code class="literal">TRUE</code>, Whan a
+      string that is longer than the maximum size of a column is inserted,
+      spaces at the end are removed to reduce the length of the string to the
+      maximum size of the column. If this is not possible, an exception is
+      raised.</p>
+<p>When the property is set to <code class="literal">FALSE</code>, no
+      truncation take place and an exception is always raised. This behaviour
+      is common to some other database engines.</p>
+<p>SQL Standard requires the default behaviour.</p>
+<p>The property is <code class="literal">TRUE</code> by default.</p>
+<p>Only a user with the DBA role can execute this
+      statement.</p>
+<p>This is equivalent to the connection property
+      <code class="literal">sql.truncate_trailing</code>.</p>
+<a name="N156B5" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL CONCAT
       NULLS</strong></span>
@@ -26070,7 +26543,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.concat_nulls</code>.</p>
-<a name="N15529" class="indexterm"></a>
+<a name="N156DF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL UNIQUE
       NULLS</strong></span>
@@ -26100,7 +26573,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.unique_nulls</code>.</p>
-<a name="N15559" class="indexterm"></a>
+<a name="N1570F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL CONVERT
       TRUNCATE</strong></span>
@@ -26128,7 +26601,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.convert_trunc</code>.</p>
-<a name="N15581" class="indexterm"></a>
+<a name="N15737" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL AVG
       SCALE</strong></span>
@@ -26154,7 +26627,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.avg_scale</code>.</p>
-<a name="N155A0" class="indexterm"></a>
+<a name="N15756" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL DOUBLE
       NAN</strong></span>
@@ -26177,7 +26650,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.double_nan</code>.</p>
-<a name="N155CE" class="indexterm"></a>
+<a name="N15784" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL NULLS
       FIRST</strong></span>
@@ -26198,7 +26671,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.nulls_first</code>.</p>
-<a name="N155EE" class="indexterm"></a>
+<a name="N157A4" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL NULLS
       ORDER</strong></span>
@@ -26225,7 +26698,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.nulls_order</code>.</p>
-<a name="N15615" class="indexterm"></a>
+<a name="N157CB" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL
       IGNORECASE</strong></span>
@@ -26251,7 +26724,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.ignore_case</code>.</p>
-<a name="N15643" class="indexterm"></a>
+<a name="N157F9" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL LOWER CASE
       IDENTIFIER</strong></span>
@@ -26266,10 +26739,10 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </p>
 <p>This property is <code class="literal">FALSE</code> by default and should
       only be used in special circumstances where additional compatibility
-      MySQL or PostgreSQL is required.</p>
+      with MySQL or PostgreSQL is required.</p>
 <p>When the property is <code class="literal">TRUE</code>, the names of
       column, tables and schemas are returned from JDBC ResultSetMetaData
-      methods in lowercase instead of uppercase if the database objects where
+      methods in lowercase instead of uppercase if the database objects were
       created as unquoted identifiers. Quoted identifier names are still
       returned in the original case.</p>
 <p>The property is <code class="literal">FALSE</code> by default.</p>
@@ -26277,7 +26750,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.lowercase_ident</code>.</p>
-<a name="N15668" class="indexterm"></a>
+<a name="N1581E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL LIVE
       OBJECT</strong></span>
@@ -26297,7 +26770,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       all.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.live_object</code>.</p>
-<a name="N1568F" class="indexterm"></a>
+<a name="N15845" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL SYS INDEX
       NAMES</strong></span>
@@ -26323,7 +26796,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.sys_index_names</code>.</p>
-<a name="N156AE" class="indexterm"></a>
+<a name="N15864" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL SYNTAX
       DB2</strong></span>
@@ -26348,7 +26821,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.syntax_db2</code>.</p>
-<a name="N156D1" class="indexterm"></a>
+<a name="N15887" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL SYNTAX
       MSS</strong></span>
@@ -26371,7 +26844,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.syntax_mss</code>.</p>
-<a name="N156F4" class="indexterm"></a>
+<a name="N158AA" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL SYNTAX
       MYS</strong></span>
@@ -26399,7 +26872,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.syntax_mys</code>.</p>
-<a name="N1571B" class="indexterm"></a>
+<a name="N158D1" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL SYNTAX
       ORA</strong></span>
@@ -26425,7 +26898,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.syntax_ora</code>.</p>
-<a name="N1573A" class="indexterm"></a>
+<a name="N158F0" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL SYNTAX
       PGS</strong></span>
@@ -26454,7 +26927,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.syntax_pgs</code>.</p>
-<a name="N1576A" class="indexterm"></a>
+<a name="N15920" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE REFERENTIAL
       INTEGRITY</strong></span>
@@ -26482,7 +26955,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <p>A query example to return the rows in a foreign key table that
       have no parent is given below:</p>
 <div class="example">
-<a name="N15781"></a>
+<a name="N15937"></a>
 <p class="title">
 <b>Example&nbsp;11.8.&nbsp;Finding foreign key rows with no parents after a bulk
         import</b>
@@ -26507,7 +26980,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <p>These statements control the memory and other settings for
       database persistence.</p>
-<a name="N1578E" class="indexterm"></a>
+<a name="N15944" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET FILES BACKUP INCREMENT
       </strong></span>
@@ -26532,7 +27005,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.inc_backup</code>.</p>
-<a name="N157B1" class="indexterm"></a>
+<a name="N15967" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET FILES CACHE ROWS</strong></span>
 </p>
@@ -26550,7 +27023,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.cache_rows</code>.</p>
-<a name="N157CB" class="indexterm"></a>
+<a name="N15981" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET FILES CACHE SIZE</strong></span>
 </p>
@@ -26570,7 +27043,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.cache_size</code>.</p>
-<a name="N157E5" class="indexterm"></a>
+<a name="N1599B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET FILES DEFRAG</strong></span>
 </p>
@@ -26599,7 +27072,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.defrag_limit</code>.</p>
-<a name="N1580B" class="indexterm"></a>
+<a name="N159C1" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET FILES LOG</strong></span>
 </p>
@@ -26617,7 +27090,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.log_data</code>.</p>
-<a name="N15823" class="indexterm"></a>
+<a name="N159D9" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET FILES LOG SIZE</strong></span>
 </p>
@@ -26637,7 +27110,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.log_size</code>.</p>
-<a name="N15841" class="indexterm"></a>
+<a name="N159F7" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET FILES NIO</strong></span>
 </p>
@@ -26655,7 +27128,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.nio_data_file</code>.</p>
-<a name="N1585C" class="indexterm"></a>
+<a name="N15A12" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET FILES NIO SIZE</strong></span>
 </p>
@@ -26674,7 +27147,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.nio_max_size</code>.</p>
-<a name="N15874" class="indexterm"></a>
+<a name="N15A2A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET FILES WRITE
       DELAY</strong></span>
@@ -26707,7 +27180,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <p>This is equivalent to the connection properties
       <code class="literal">hsqldb.write_delay</code> and
       <code class="literal">hsqldb.write_delay_millis</code>.</p>
-<a name="N15897" class="indexterm"></a>
+<a name="N15A4D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET FILES SCALE</strong></span>
 </p>
@@ -26739,7 +27212,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.cache_file_scale</code>.</p>
-<a name="N158BB" class="indexterm"></a>
+<a name="N15A71" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET FILES LOB SCALE</strong></span>
 </p>
@@ -26765,7 +27238,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.lob_file_scale</code>.</p>
-<a name="N158D8" class="indexterm"></a>
+<a name="N15A8E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET FILES LOB
       COMPRESSED</strong></span>
@@ -26787,7 +27260,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.lob_compressed</code>.</p>
-<a name="N158F5" class="indexterm"></a>
+<a name="N15AAB" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET FILES SCRIPT
       FORMAT</strong></span>
@@ -26805,7 +27278,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       command causes a CHECKPOINT.</p>
 <p>Only a user with the DBA role can execute this
       statement.</p>
-<a name="N1590B" class="indexterm"></a>
+<a name="N15AC1" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET FILES SPACE</strong></span>
 </p>
@@ -26823,7 +27296,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       statement below.</p>
 <p>Only a user with the DBA role can execute this
       statement.</p>
-<a name="N1591E" class="indexterm"></a>
+<a name="N15AD4" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET TABLE NEW SPACE</strong></span>
 </p>
@@ -26853,7 +27326,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <p>Two settings are available for authentication control.</p>
 <p>When the default password authentication is used, the passwords
       can be checked for complexity according to administrative rules</p>
-<a name="N1593C" class="indexterm"></a>
+<a name="N15AF2" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE PASSWORD CHECK
       FUNCTION</strong></span>
@@ -26903,7 +27376,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       completely with a function that uses external authentication servers,
       such as LDAP. This function is called each time a user connects to the
       database.</p>
-<a name="N1596A" class="indexterm"></a>
+<a name="N15B20" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE AUTHENTICATION
       FUNCTION</strong></span>
@@ -26974,12 +27447,12 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6279 $</p>
+<p class="releaseinfo">$Revision: 6556 $</p>
 </div>
 <div>
 <div class="legalnotice">
-<a name="N159AE"></a>
-<p>Copyright 2002-2021 Fred Toussi. Permission is granted to
+<a name="N15B64"></a>
+<p>Copyright 2002-2022 Fred Toussi. Permission is granted to
       distribute this document without any alteration under the terms of the
       HSQLDB license. Additional permission is granted to the HSQL Development
       Group to distribute this document with or without alterations under the
@@ -26987,7 +27460,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -27095,7 +27568,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 </div>
-<a name="N159B5" class="indexterm"></a>
+<a name="N15B6B" class="indexterm"></a>
 <p>Memory used by the program can be thought of as two distinct pools:
     memory used for table data which is not released unless the data is
     deleted and memory that can be released or is released automatically,
@@ -27272,7 +27745,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       change the lob schema storage to CACHED tables with the following
       statements:</p>
 <div class="example">
-<a name="N15A25"></a>
+<a name="N15BDB"></a>
 <p class="title">
 <b>Example&nbsp;12.1.&nbsp;Using CACHED tables for the LOB schema</b>
 </p>
@@ -27647,7 +28120,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       arguments (if any), then an empty string to separate it from the next
       main class.</p>
 <div class="example">
-<a name="N15B37"></a>
+<a name="N15CED"></a>
 <p class="title">
 <b>Example&nbsp;12.2.&nbsp;MainInvoker Example</b>
 </p>
@@ -27699,17 +28172,15 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 </div>
-<a name="N15B5F" class="indexterm"></a>
-<p>HSQLDB version 2.6.0 and later can open databases created with
-    version 2.0 and above. It will not open databases created with older
-    versions. It is a good idea to perform SHUTDOWN COMPACT after the
-    upgrade.</p>
-<p>Downgrading is also possible. Once a database is upgraded to 2.6.0,
-    you need to perform SHUTDOWN SCRIPT before you open it with previous 2.x.x
-    versions of HyperSQL.</p>
+<a name="N15D15" class="indexterm"></a>
+<p>HSQLDB can open databases created with version 2.0 and above. It is
+    a good idea to perform SHUTDOWN COMPACT to complete the upgrade.</p>
+<p>Downgrading is also possible. A database created with the current
+    version can be closed with SHUTDOWN SCRIPT before you open it with
+    previous 2.x.x versions of HyperSQL.</p>
 <p>To upgrade an old database created with version 1.8.x, you can use
-    HSQLDB version 2.3.x to 2.5.0 to open the database and perform SHUTDOWN
-    SCRIPT. You can then open the database with version 2.6.0 or later.</p>
+    HSQLDB version 2.3.x to 2.5 to open the database and perform SHUTDOWN
+    SCRIPT. You can then open the database with version 2.6 or later.</p>
 <p>If the 1.8.x database script format is set to BINARY or COMPRESSED
     (ZIPPED), you must open the database with version 1.8.x and issue the SET
     SCRIPTFORMAT TEXT and SHUTDOWN SCRIPT commands with the old version, prior
@@ -27860,7 +28331,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 </div>
-<p>HyperSQL 2 conforms to the SQL Standard better than previous
+<p>HyperSQL 2.7.0 conforms to the SQL Standard better than previous
     versions and has many more features. For these reasons, there may be some
     compatibility issues when converting old database, or using applications
     that were written for version 1.8.x or earlier. Some of the potential
@@ -27869,16 +28340,17 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <div class="itemizedlist">
 <ul class="itemizedlist" style="list-style-type: disc; ">
 <li class="listitem">
-<p>By default, when comparison strings, the shorter string is
-        padded with spaces. This has an effect on comparing
-        <code class="literal">'test'</code> and <code class="literal">'test '</code> which are now
-        considered equal, despite the length difference. This behaviour is
-        controlled by the default PAD SPACE property of collations, which can
-        be changed to NO PAD. See the statement <code class="literal">SET DATABASE
-        COLLATION &lt;name&gt; [ PAD SPACE | NO PAD ]</code>.</p>
+<p>By default, when comparing strings, the shorter string is padded
+        with spaces. This has an effect on comparing <code class="literal">'test'</code>
+        and <code class="literal">'test '</code> which are now considered equal, despite
+        the length difference. This behaviour is controlled by the default PAD
+        SPACE property of collations, which can be changed to NO PAD. See the
+        statement <code class="literal">SET DATABASE COLLATION &lt;name&gt; [ PAD SPACE |
+        NO PAD ]</code>.</p>
 </li>
 <li class="listitem">
-<p>User names and passwords are case-sensitive. Check the
+<p>User names and passwords are case-sensitive. The only exception
+        is the username 'SA' which is always converted to uppercase. Check the
         <code class="literal">.script</code> file of a database for the correct case of
         user name and password and use this form in the connection properties
         or on connection URL.</p>
@@ -27942,8 +28414,8 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
         T (ID IDENTITY, DAT VARCHAR(20))</code> is translated into
         <code class="literal">CREATE TABLE T(ID INTEGER GENERATED BY DEFAULT AS IDENTITY
         PRIMARY KEY, DAT VARCHAR(20))</code>. This last form is the correct
-        way of defining both autoincrement and primary key in versions 1.8 and
-        2.x.</p>
+        way of defining both auto-increment and primary key in versions 1.8
+        and 2.x.</p>
 </li>
 <li class="listitem">
 <p>CREATE ALIAS is now obsolete. Use the new function definition
@@ -27987,11 +28459,21 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <a name="dec_dependency_applications"></a>HyperSQL Dependency Settings for Applications</h2>
 </div>
 <div>
-<h3 class="subtitle">Dependency settings using Gradle, Ivy, Maven, Groovy</h3>
+<h3 class="subtitle">Java Module Dependency and Dependency settings using Gradle,
+    Ivy, Maven, Groovy</h3>
 </div>
 </div>
 </div>
-<p>This section is about building applications that have build-time
+<p>HyperSQL and SqlTool version 2.7.0 jars are Java Module jars
+    compiled with JDK 11. The module name for HyperSQL is
+    <code class="literal">org.hsqldb</code> and for SqlTool,
+    <code class="literal">org.hsqldb.sqltool</code>. In a modular application, these
+    names are referenced in the <code class="literal">module-info.java</code> file for
+    the user application that accesses these jars.</p>
+<p>For non-modular applications, the jars are simply included the
+    the classpath. Jars compiled with JDK8 are also provided and can be used
+    for applications that must run on a JVM older than 11,</p>
+<p>This section is about building applications that have
     dependencies upon HyperSQL, and for executions that use a dependency
     library system. Examples of the second type are unit test runs, job runs
     triggered by a build system, or systems like Grape that pull libraries
@@ -28033,7 +28515,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
       the suggestions in the appropriate sections below. If you need to
       specify a specific version, follow the instructions in the
       range-versioning section but change the version range specifications to
-      literal versions like <code class="literal">2.6.0</code>.</p>
+      literal versions like <code class="literal">2.7.0</code>.</p>
 </div>
 <div class="section">
 <div class="titlepage">
@@ -28091,7 +28573,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </table>
 </div>
 <div class="example">
-<a name="N15C9B"></a>
+<a name="N15E5E"></a>
 <p class="title">
 <b>Example&nbsp;12.3.&nbsp;Sample Range Ivy Dependency</b>
 </p>
@@ -28103,15 +28585,15 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
           because I have so far failed to get that to succeed. Classifiers in
           in <code class="filename">ivy.xml</code> are supported if using Gradle, as
           covered below.</p>
-<p>At the time that I'm writing this, our builds are only
-          providing one classifier (besides the default no-classifier, of
-          course) and its name is "debug". Therefore in all examples for using
-          a classifier I am using classifier name "debug".</p>
+<p>At the time that I'm writing this, our builds are providing
+          two classifiers (besides the default no-classifier, of course) named
+          "debug" and "jdk8". In all examples for using a classifier I am
+          using classifier name "debug".</p>
 </div>
 </div>
 <br class="example-break">
 <div class="example">
-<a name="N15CAD"></a>
+<a name="N15E70"></a>
 <p class="title">
 <b>Example&nbsp;12.4.&nbsp;Sample Range Maven Dependency</b>
 </p>
@@ -28133,7 +28615,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="example-break">
 <div class="example">
-<a name="N15CB8"></a>
+<a name="N15E7B"></a>
 <p class="title">
 <b>Example&nbsp;12.5.&nbsp;Sample Range Gradle Dependency</b>
 </p>
@@ -28154,7 +28636,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
         <code class="literal">ivyxml</code>. See the <a class="link" href="https://github.com/unsaved/gradle-ivyxml-plugin/raw/master/README.txt" target="_top">
         Ivyxml documentation</a> to see exactly how. </p>
 <div class="example">
-<a name="N15CD0"></a>
+<a name="N15E93"></a>
 <p class="title">
 <b>Example&nbsp;12.6.&nbsp;Sample Range ivy.xml loaded by Ivyxml plugin</b>
 </p>
@@ -28169,7 +28651,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <br class="example-break">
 </p>
 <div class="example">
-<a name="N15CD5"></a>
+<a name="N15E98"></a>
 <p class="title">
 <b>Example&nbsp;12.7.&nbsp;Sample Range Groovy Dependency, using Grape</b>
 </p>
@@ -28208,8 +28690,8 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <div>
 <div class="legalnotice">
-<a name="N15CFE"></a>
-<p>Copyright 2010-2021 Fred Toussi. Permission is granted to
+<a name="N15EC1"></a>
+<p>Copyright 2010-2022 Fred Toussi. Permission is granted to
       distribute this document without any alteration under the terms of the
       HSQLDB license. Additional permission is granted to the HSQL Development
       Group to distribute this document with or without alterations under the
@@ -28217,7 +28699,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -28417,7 +28899,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 </div>
-<p>HyperSQL version 2.6 is highly compatible with MySQL and supports
+<p>HyperSQL version 2.7 is highly compatible with MySQL and supports
       most of its non-standard syntax. The latest versions of MySQL have
       introduced better Standard compatibility but some of these features have
       to be turned on via properties. You should therefore check the current
@@ -28829,7 +29311,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
           their SQL Standard equivalents.</p>
 </li>
 <li class="listitem">
-<p>HyperSQL 2.6 supports several datetime functions in MSS
+<p>HyperSQL 2.7 supports several datetime functions in MSS
           compatibility mode. These include DATEPART, DATENAME, EOMONTH and
           compatible DATEADD and DATEDIFF behaviour.</p>
 </li>
@@ -28869,12 +29351,12 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6366 $</p>
+<p class="releaseinfo">$Revision: 6491 $</p>
 </div>
 <div>
 <div class="legalnotice">
-<a name="N15EE4"></a>
-<p>Copyright 2002-2021 Fred Toussi. Permission is granted to
+<a name="N160A7"></a>
+<p>Copyright 2002-2022 Fred Toussi. Permission is granted to
       distribute this document without any alteration under the terms of the
       HSQLDB license. Additional permission is granted to the HSQL Development
       Group to distribute this document with or without alterations under the
@@ -28882,7 +29364,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -28898,7 +29380,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <span class="section"><a href="#dpc_variables_url">Variables in Connection URL</a></span>
 </dt>
 <dt>
-<span class="section"><a href="#N16054">Connection Properties</a></span>
+<span class="section"><a href="#N16217">Connection Properties</a></span>
 </dt>
 <dt>
 <span class="section"><a href="#dpc_connection_props">Properties for Individual Connections</a></span>
@@ -28938,9 +29420,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <p>The normal method of accessing a HyperSQL catalog is via the JDBC
     Connection interface. An introduction to different methods of providing
-    database services and accessing them can be found in the <a class="link" href="#sqlgeneral-chapt" title="Chapter&nbsp;2.&nbsp;SQL Language">SQL Language</a> chapter.
-    Details and examples of how to connect via JDBC are provided in our
-    JavaDoc for <code class="classname"><a class="classname" href="#JDBCConnection.html-link">JDBCConnection</a></code>.</p>
+    database services and accessing them can be found in the <a class="link" href="#running-chapt" title="Chapter&nbsp;1.&nbsp;Running and Using HyperSQL">Running and Using HyperSQL</a> chapter. Details and
+    examples of how to connect via JDBC are provided in our JavaDoc for
+    <code class="classname"><a class="classname" href="#JDBCConnection.html-link">JDBCConnection</a></code>.</p>
 <p>A uniform method is used to distinguish between different types of
     connection. The common driver identifier is
     <code class="literal">jdbc:hsqldb:</code> followed by a protocol identifier
@@ -28952,7 +29434,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     property / value pairs can be appended to the end of the URL, separated
     with semicolons.</p>
 <div class="table">
-<a name="N15F0F"></a>
+<a name="N160D2"></a>
 <p class="title">
 <b>Table&nbsp;14.1.&nbsp;Memory Database URL</b>
 </p>
@@ -29012,7 +29494,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N15F50"></a>
+<a name="N16113"></a>
 <p class="title">
 <b>Table&nbsp;14.2.&nbsp;File Database URL</b>
 </p>
@@ -29073,7 +29555,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N15F96"></a>
+<a name="N16159"></a>
 <p class="title">
 <b>Table&nbsp;14.3.&nbsp;Resource Database URL</b>
 </p>
@@ -29120,7 +29602,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N15FCA"></a>
+<a name="N1618D"></a>
 <p class="title">
 <b>Table&nbsp;14.4.&nbsp;Server Database URL</b>
 </p>
@@ -29250,12 +29732,12 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <div>
 <div>
 <h2 class="title" style="clear: both">
-<a name="N16054"></a>Connection Properties</h2>
+<a name="N16217"></a>Connection Properties</h2>
 </div>
 </div>
 </div>
 <p>There are two types of connection properties: properties for
-    individual connections, and Properties for the whole database.</p>
+    individual connections, and properties for the whole database.</p>
 <p>The properties for individual connections apply only to the
     connection that uses them and can be different for different connections.
     These properties can be used when connecting to in-process and server
@@ -29266,9 +29748,14 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     <em class="glossterm">mem:</em> database. For the connection that creates a
     new database all the user-defined database properties can be specified as
     URL properties.</p>
+<p>A few of the properties for the database can be applied to an
+    existing database when the database is reopened after a shutdown.</p>
 <p>When running a server, these properties are not used on the
     connection URL but can be appended to the database path URL in
     <code class="literal">server.properties</code> or the server command line.</p>
+<p>Almost all properties for the database listed in this chapter have
+    corresponding SQL statements which can be used after connecting to the
+    database. The SQL statement for each property is listed here.</p>
 </div>
 <div class="section">
 <div class="titlepage">
@@ -29289,7 +29776,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     Connection URL.</p>
 <pre class="programlisting"> DriverManager.getConnection (String url, Properties info);</pre>
 <div class="table">
-<a name="N1607B"></a>
+<a name="N16242"></a>
 <p class="title">
 <b>Table&nbsp;14.5.&nbsp;User and Password</b>
 </p>
@@ -29339,73 +29826,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N160BC"></a>
+<a name="N16283"></a>
 <p class="title">
-<b>Table&nbsp;14.6.&nbsp;Creating New Database</b>
-</p>
-<div class="table-contents">
-<table summary="Creating New Database" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
-<colgroup>
-<col width="6.5cm" align="left" class="c1">
-<col width="1.5cm" align="left" class="c2">
-<col align="left" class="c3">
-</colgroup>
-<thead>
-<tr>
-<th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Name</th><th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Default</th><th style="border-bottom: 0.5pt solid ; " align="left">Description</th>
-</tr>
-</thead>
-<tbody valign="top">
-<tr>
-<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">ifexists</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">false</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">connect only if database already exists</td>
-</tr>
-<tr>
-<td style="border-bottom: 0.5pt solid ; " colspan="3" align="left" valign="top">
-<p>Has an effect only with
-            <em class="glossterm">mem:</em> and <em class="glossterm">file:</em>
-            database. When true, will not create a new database if one does
-            not already exist for the URL.</p>
-<p>When the property is
-            false (the default), a new <em class="glossterm">mem:</em> or
-            <em class="glossterm">file:</em> database will be created if it does
-            not exist.</p>
-<p>Setting the property to true is useful when
-            troubleshooting as no database is created if the URL is malformed.
-            Example below:</p>
-<pre class="programlisting"> jdbc:hsqldb:file:accounts;ifexists=true</pre>
-</td>
-</tr>
-<tr>
-<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">create</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">true</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">create the database if it does not exist</td>
-</tr>
-<tr>
-<td style="" colspan="3" align="left" valign="top">
-<p>Similar to the ifexists
-            property, but with opposite meaning.</p>
-<p>Has an effect
-            only with <em class="glossterm">mem:</em> and
-            <em class="glossterm">file:</em> databases. When false, will not
-            create a new database if one does not already exist for the
-            URL.</p>
-<p>When the property is true (the default), a new
-            <em class="glossterm">mem:</em> or <em class="glossterm">file:</em>
-            database will be created if it does not exist.</p>
-<p>Setting
-            the property to true is useful when troubleshooting as no database
-            is created if the URL is malformed. Example
-            below:</p>
-<pre class="programlisting"> jdbc:hsqldb:file:enrolments;create=false</pre>
-</td>
-</tr>
-</tbody>
-</table>
-</div>
-</div>
-<br class="table-break">
-<div class="table">
-<a name="N1611B"></a>
-<p class="title">
-<b>Table&nbsp;14.7.&nbsp;Closing old ResultSet when Statement is reused</b>
+<b>Table&nbsp;14.6.&nbsp;Closing old ResultSet when Statement is reused</b>
 </p>
 <div class="table-contents">
 <table summary="Closing old ResultSet when Statement is reused" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -29456,9 +29879,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16162"></a>
+<a name="N162CA"></a>
 <p class="title">
-<b>Table&nbsp;14.8.&nbsp;Column Names in JDBC ResultSet</b>
+<b>Table&nbsp;14.7.&nbsp;Column Names in JDBC ResultSet</b>
 </p>
 <div class="table-contents">
 <table summary="Column Names in JDBC ResultSet" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -29501,9 +29924,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N1619B"></a>
+<a name="N16303"></a>
 <p class="title">
-<b>Table&nbsp;14.9.&nbsp;In-memory LOBs from JDBC ResultSet</b>
+<b>Table&nbsp;14.8.&nbsp;In-memory LOBs from JDBC ResultSet</b>
 </p>
 <div class="table-contents">
 <table summary="In-memory LOBs from JDBC ResultSet" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -29541,9 +29964,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N161CC"></a>
+<a name="N16334"></a>
 <p class="title">
-<b>Table&nbsp;14.10.&nbsp;Empty batch in JDBC PreparedStatement</b>
+<b>Table&nbsp;14.9.&nbsp;Empty batch in JDBC PreparedStatement</b>
 </p>
 <div class="table-contents">
 <table summary="Empty batch in JDBC PreparedStatement" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -29586,9 +30009,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16202"></a>
+<a name="N1636A"></a>
 <p class="title">
-<b>Table&nbsp;14.11.&nbsp;Automatic Shutdown</b>
+<b>Table&nbsp;14.10.&nbsp;Automatic Shutdown</b>
 </p>
 <div class="table-contents">
 <table summary="Automatic Shutdown" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -29639,6 +30062,44 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 <br class="table-break">
+<div class="table">
+<a name="N163A1"></a>
+<p class="title">
+<b>Table&nbsp;14.11.&nbsp;OpenOffice and Libre Office usage</b>
+</p>
+<div class="table-contents">
+<table summary="OpenOffice and Libre Office usage" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
+<colgroup>
+<col width="7cm" align="left" class="c1">
+<col width="1.5cm" align="left" class="c2">
+<col align="left" class="c3">
+</colgroup>
+<thead>
+<tr>
+<th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Name</th><th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Default</th><th style="border-bottom: 0.5pt solid ; " align="left">Description</th>
+</tr>
+</thead>
+<tbody valign="top">
+<tr>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">default_schema</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">false</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">OpenOffice and LibreOffice connections</td>
+</tr>
+<tr>
+<td style="" colspan="3" align="left" valign="top">
+<p>When HyperSQL is used with
+            OpenOffice.org as an external database, the property
+            "default_schema=true" must be set on the URL, otherwise the
+            program will not operate correctly as it does with its built-in
+            hsqldb instance.</p>
+<p>The default is
+            false.</p>
+<pre class="programlisting"> jdbc:hsqldb:hsql://localhost/enrolments;default_schema=true</pre>
+</td>
+</tr>
+</tbody>
+</table>
+</div>
+</div>
+<br class="table-break">
 </div>
 <div class="section">
 <div class="titlepage">
@@ -29659,11 +30120,16 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     corresponding SQL command is given for each property. For a server, these
     properties can be appended to the database path URL in server.properties
     or the server command line.</p>
+<p>When connecting to an <em class="glossterm">in-process</em> database
+    creates a new database, or opens an existing database (i.e. it is the
+    first connection made to the database by the application), all the
+    user-defined database properties listed in this section can be specified
+    as URL properties.</p>
 <p>Note the preferred method of setting database properties is by using
     a set of SQL statements. These statements can be used both for a new
     database or an existing database, unlike URL properties that are generally
     effective for new databases only.</p>
-<p>If the properties are used for connection to an existing database,
+<p>If these properties are used for connection to an existing database,
     they are ignored.</p>
 <p>The exceptions are the following property settings that are allowed
     for the first connection to an existing database (the connection which
@@ -29689,7 +30155,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     statements are described more extensively in the <a class="link" href="#management-chapt" title="Chapter&nbsp;11.&nbsp;System Management">System Management</a>
     chapter.</p>
 <div class="table">
-<a name="N1626C"></a>
+<a name="N16407"></a>
 <p class="title">
 <b>Table&nbsp;14.12.&nbsp;Validity Check Property</b>
 </p>
@@ -29723,6 +30189,70 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 <br class="table-break">
+<div class="table">
+<a name="N16434"></a>
+<p class="title">
+<b>Table&nbsp;14.13.&nbsp;Creating New Database Check Property</b>
+</p>
+<div class="table-contents">
+<table summary="Creating New Database Check Property" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
+<colgroup>
+<col width="6.5cm" align="left" class="c1">
+<col width="1.5cm" align="left" class="c2">
+<col align="left" class="c3">
+</colgroup>
+<thead>
+<tr>
+<th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Name</th><th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Default</th><th style="border-bottom: 0.5pt solid ; " align="left">Description</th>
+</tr>
+</thead>
+<tbody valign="top">
+<tr>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">ifexists</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">false</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">connect only if database already exists</td>
+</tr>
+<tr>
+<td style="border-bottom: 0.5pt solid ; " colspan="3" align="left" valign="top">
+<p>Has an effect only with
+            <em class="glossterm">mem:</em> and <em class="glossterm">file:</em>
+            database. When true, will not create a new database if one does
+            not already exist for the URL.</p>
+<p>When the property is
+            false (the default), a new <em class="glossterm">mem:</em> or
+            <em class="glossterm">file:</em> database will be created if it does
+            not exist.</p>
+<p>Setting the property to true is useful when
+            troubleshooting as no database is created if the URL is malformed.
+            Example below:</p>
+<pre class="programlisting"> jdbc:hsqldb:file:accounts;ifexists=true</pre>
+</td>
+</tr>
+<tr>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">create</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">true</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">create the database if it does not exist</td>
+</tr>
+<tr>
+<td style="" colspan="3" align="left" valign="top">
+<p>Similar to the ifexists
+            property, but with opposite meaning.</p>
+<p>Has an effect
+            only with <em class="glossterm">mem:</em> and
+            <em class="glossterm">file:</em> databases. When false, will not
+            create a new database if one does not already exist for the
+            URL.</p>
+<p>When the property is true (the default), a new
+            <em class="glossterm">mem:</em> or <em class="glossterm">file:</em>
+            database will be created if it does not exist.</p>
+<p>Setting
+            the property to true is useful when troubleshooting as no database
+            is created if the URL is malformed. Example
+            below:</p>
+<pre class="programlisting"> jdbc:hsqldb:file:enrolments;create=false</pre>
+</td>
+</tr>
+</tbody>
+</table>
+</div>
+</div>
+<br class="table-break">
 <div class="section">
 <div class="titlepage">
 <div>
@@ -29733,9 +30263,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 <div class="table">
-<a name="N1629D"></a>
+<a name="N16497"></a>
 <p class="title">
-<b>Table&nbsp;14.13.&nbsp;Execution of Multiple SQL Statements etc.</b>
+<b>Table&nbsp;14.14.&nbsp;Execution of Multiple SQL Statements etc.</b>
 </p>
 <div class="table-contents">
 <table summary="Execution of Multiple SQL Statements etc." cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -29781,9 +30311,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N162DD"></a>
+<a name="N164D7"></a>
 <p class="title">
-<b>Table&nbsp;14.14.&nbsp;SQL Keyword Use as Identifier</b>
+<b>Table&nbsp;14.15.&nbsp;SQL Keyword Use as Identifier</b>
 </p>
 <div class="table-contents">
 <table summary="SQL Keyword Use as Identifier" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -29815,9 +30345,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N1630A"></a>
+<a name="N16504"></a>
 <p class="title">
-<b>Table&nbsp;14.15.&nbsp;SQL Keyword Starting with the Underscore or Containing Dollar
+<b>Table&nbsp;14.16.&nbsp;SQL Keyword Starting with the Underscore or Containing Dollar
         Characters</b>
 </p>
 <div class="table-contents">
@@ -29852,9 +30382,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16337"></a>
+<a name="N16531"></a>
 <p class="title">
-<b>Table&nbsp;14.16.&nbsp;Reference to Columns Names</b>
+<b>Table&nbsp;14.17.&nbsp;Reference to Columns Names</b>
 </p>
 <div class="table-contents">
 <table summary="Reference to Columns Names" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -29889,9 +30419,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16364"></a>
+<a name="N1655E"></a>
 <p class="title">
-<b>Table&nbsp;14.17.&nbsp;String Size Declaration</b>
+<b>Table&nbsp;14.18.&nbsp;String Size Declaration</b>
 </p>
 <div class="table-contents">
 <table summary="String Size Declaration" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -29927,9 +30457,46 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16391"></a>
+<a name="N1658B"></a>
+<p class="title">
+<b>Table&nbsp;14.19.&nbsp;Truncation of trailing spaces from string</b>
+</p>
+<div class="table-contents">
+<table summary="Truncation of trailing spaces from string" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
+<colgroup>
+<col width="6.5cm" align="left" class="c1">
+<col width="1.5cm" align="left" class="c2">
+<col align="left" class="c3">
+</colgroup>
+<thead>
+<tr>
+<th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Name</th><th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Default</th><th style="border-bottom: 0.5pt solid ; " align="left">Description</th>
+</tr>
+</thead>
+<tbody valign="top">
+<tr>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">sql.truncate_trailing</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">true</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">truncation of long strings with trailing spaces</td>
+</tr>
+<tr>
+<td style="" colspan="3" align="left" valign="top">
+<p>When a string that is
+              longer than the maximum size of a column is inserted, the
+              default behaviour is to remove any trailing spaces until the
+              length of the string equals the maximum size of the column. When
+              this property is set to false, long strings are always rejected
+              and an exception is raised.</p>
+<pre class="programlisting">SET DATABASE SQL TRUNCATE TRAILING { TRUE | FALSE }</pre>
+</td>
+</tr>
+</tbody>
+</table>
+</div>
+</div>
+<br class="table-break">
+<div class="table">
+<a name="N165B8"></a>
 <p class="title">
-<b>Table&nbsp;14.18.&nbsp;Type Enforcement in Comparison and Assignment</b>
+<b>Table&nbsp;14.20.&nbsp;Type Enforcement in Comparison and Assignment</b>
 </p>
 <div class="table-contents">
 <table summary="Type Enforcement in Comparison and Assignment" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -29966,9 +30533,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N163BE"></a>
+<a name="N165E5"></a>
 <p class="title">
-<b>Table&nbsp;14.19.&nbsp;Foreign Key Triggered Data Change</b>
+<b>Table&nbsp;14.21.&nbsp;Foreign Key Triggered Data Change</b>
 </p>
 <div class="table-contents">
 <table summary="Foreign Key Triggered Data Change" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -30028,9 +30595,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16401"></a>
+<a name="N16628"></a>
 <p class="title">
-<b>Table&nbsp;14.20.&nbsp;Use of LOB for LONGVAR Types</b>
+<b>Table&nbsp;14.22.&nbsp;Use of LOB for LONGVAR Types</b>
 </p>
 <div class="table-contents">
 <table summary="Use of LOB for LONGVAR Types" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -30064,9 +30631,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N1642E"></a>
+<a name="N16655"></a>
 <p class="title">
-<b>Table&nbsp;14.21.&nbsp;Type of string literals in CASE WHEN</b>
+<b>Table&nbsp;14.23.&nbsp;Type of string literals in CASE WHEN</b>
 </p>
 <div class="table-contents">
 <table summary="Type of string literals in CASE WHEN" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -30101,9 +30668,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N1645B"></a>
+<a name="N16682"></a>
 <p class="title">
-<b>Table&nbsp;14.22.&nbsp;Concatenation with NULL</b>
+<b>Table&nbsp;14.24.&nbsp;Concatenation with NULL</b>
 </p>
 <div class="table-contents">
 <table summary="Concatenation with NULL" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -30136,9 +30703,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16488"></a>
+<a name="N166AF"></a>
 <p class="title">
-<b>Table&nbsp;14.23.&nbsp;NULL in Multi-Column UNIQUE Constraints</b>
+<b>Table&nbsp;14.25.&nbsp;NULL in Multi-Column UNIQUE Constraints</b>
 </p>
 <div class="table-contents">
 <table summary="NULL in Multi-Column UNIQUE Constraints" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -30172,9 +30739,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N164B5"></a>
+<a name="N166DC"></a>
 <p class="title">
-<b>Table&nbsp;14.24.&nbsp;Truncation or Rounding in Type Conversion</b>
+<b>Table&nbsp;14.26.&nbsp;Truncation or Rounding in Type Conversion</b>
 </p>
 <div class="table-contents">
 <table summary="Truncation or Rounding in Type Conversion" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -30208,9 +30775,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N164E2"></a>
+<a name="N16709"></a>
 <p class="title">
-<b>Table&nbsp;14.25.&nbsp;Decimal Scale of Division and AVG Values</b>
+<b>Table&nbsp;14.27.&nbsp;Decimal Scale of Division and AVG Values</b>
 </p>
 <div class="table-contents">
 <table summary="Decimal Scale of Division and AVG Values" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -30248,9 +30815,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N1650F"></a>
+<a name="N16736"></a>
 <p class="title">
-<b>Table&nbsp;14.26.&nbsp;Support for NaN values</b>
+<b>Table&nbsp;14.28.&nbsp;Support for NaN values</b>
 </p>
 <div class="table-contents">
 <table summary="Support for NaN values" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -30283,9 +30850,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N1653C"></a>
+<a name="N16763"></a>
 <p class="title">
-<b>Table&nbsp;14.27.&nbsp;Sort order of NULL values</b>
+<b>Table&nbsp;14.29.&nbsp;Sort order of NULL values</b>
 </p>
 <div class="table-contents">
 <table summary="Sort order of NULL values" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -30319,9 +30886,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16569"></a>
+<a name="N16790"></a>
 <p class="title">
-<b>Table&nbsp;14.28.&nbsp;Sort order of NULL values with DESC</b>
+<b>Table&nbsp;14.30.&nbsp;Sort order of NULL values with DESC</b>
 </p>
 <div class="table-contents">
 <table summary="Sort order of NULL values with DESC" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -30357,9 +30924,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16599"></a>
+<a name="N167C0"></a>
 <p class="title">
-<b>Table&nbsp;14.29.&nbsp;String Comparison with Padding</b>
+<b>Table&nbsp;14.31.&nbsp;String Comparison with Padding</b>
 </p>
 <div class="table-contents">
 <table summary="String Comparison with Padding" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -30397,9 +30964,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N165C8"></a>
+<a name="N167EF"></a>
 <p class="title">
-<b>Table&nbsp;14.30.&nbsp;Default Locale Language Collation</b>
+<b>Table&nbsp;14.32.&nbsp;Default Locale Language Collation</b>
 </p>
 <div class="table-contents">
 <table summary="Default Locale Language Collation" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -30432,9 +30999,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N165F5"></a>
+<a name="N1681C"></a>
 <p class="title">
-<b>Table&nbsp;14.31.&nbsp;Case-Insensitive Varchar columns</b>
+<b>Table&nbsp;14.33.&nbsp;Case-Insensitive Varchar columns</b>
 </p>
 <div class="table-contents">
 <table summary="Case-Insensitive Varchar columns" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -30470,9 +31037,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16622"></a>
+<a name="N16849"></a>
 <p class="title">
-<b>Table&nbsp;14.32.&nbsp;Lowercase column identifiers in ResultSet</b>
+<b>Table&nbsp;14.34.&nbsp;Lowercase column identifiers in ResultSet</b>
 </p>
 <div class="table-contents">
 <table summary="Lowercase column identifiers in ResultSet" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -30509,9 +31076,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N1664F"></a>
+<a name="N16876"></a>
 <p class="title">
-<b>Table&nbsp;14.33.&nbsp;Storage of Live Java Objects</b>
+<b>Table&nbsp;14.35.&nbsp;Storage of Live Java Objects</b>
 </p>
 <div class="table-contents">
 <table summary="Storage of Live Java Objects" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -30546,9 +31113,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N1667C"></a>
+<a name="N168A3"></a>
 <p class="title">
-<b>Table&nbsp;14.34.&nbsp;Names of System Indexes Used for Constraints</b>
+<b>Table&nbsp;14.36.&nbsp;Names of System Indexes Used for Constraints</b>
 </p>
 <div class="table-contents">
 <table summary="Names of System Indexes Used for Constraints" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -30564,16 +31131,21 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </thead>
 <tbody valign="top">
 <tr>
-<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">sql.sys_index_names</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">false</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">name of system generated indexes for constraints</td>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">sql.sys_index_names</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">true</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">name of system generated indexes for constraints</td>
 </tr>
 <tr>
 <td style="" colspan="3" align="left" valign="top">
 <p>HSQLDB automatically
               creates a system index for each PRIMARY KEY, UNIQUE and FOREIGN
-              KEY constraint. By default the names of those indexes are
-              generated the system as a string beginning with SYS_. When the
-              setting is changed to true, the names will be the same as the
-              constraint names.</p>
+              KEY constraint. If a constraint is not defined with a name, the
+              system generates a name. By default, the names of these indexes
+              will be the same as the constraint names. This helps associating
+              the index name with the user-defined constraint name. When this
+              property is false, the names of those indexes are generated the
+              system as a string beginning with SYS_. </p>
+<p>The default
+              value for this property was false before version
+              2.7.0.</p>
 <pre class="programlisting">SET DATABASE SQL SYS INDEX NAMES { TRUE | FALSE }</pre>
 </td>
 </tr>
@@ -30583,9 +31155,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N166A9"></a>
+<a name="N168D2"></a>
 <p class="title">
-<b>Table&nbsp;14.35.&nbsp;DB2 Style Syntax</b>
+<b>Table&nbsp;14.37.&nbsp;DB2 Style Syntax</b>
 </p>
 <div class="table-contents">
 <table summary="DB2 Style Syntax" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -30617,9 +31189,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N166D5"></a>
+<a name="N168FE"></a>
 <p class="title">
-<b>Table&nbsp;14.36.&nbsp;MSSQL Style Syntax</b>
+<b>Table&nbsp;14.38.&nbsp;MSSQL Style Syntax</b>
 </p>
 <div class="table-contents">
 <table summary="MSSQL Style Syntax" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -30652,9 +31224,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16701"></a>
+<a name="N1692A"></a>
 <p class="title">
-<b>Table&nbsp;14.37.&nbsp;MySQL Style Syntax</b>
+<b>Table&nbsp;14.39.&nbsp;MySQL Style Syntax</b>
 </p>
 <div class="table-contents">
 <table summary="MySQL Style Syntax" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -30687,9 +31259,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N1672E"></a>
+<a name="N16957"></a>
 <p class="title">
-<b>Table&nbsp;14.38.&nbsp;Oracle Style Syntax</b>
+<b>Table&nbsp;14.40.&nbsp;Oracle Style Syntax</b>
 </p>
 <div class="table-contents">
 <table summary="Oracle Style Syntax" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -30723,9 +31295,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N1675B"></a>
+<a name="N16984"></a>
 <p class="title">
-<b>Table&nbsp;14.39.&nbsp;PostgreSQL Style Syntax</b>
+<b>Table&nbsp;14.41.&nbsp;PostgreSQL Style Syntax</b>
 </p>
 <div class="table-contents">
 <table summary="PostgreSQL Style Syntax" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -30757,6 +31329,44 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 <br class="table-break">
+<div class="table">
+<a name="N169B0"></a>
+<p class="title">
+<b>Table&nbsp;14.42.&nbsp;Maximum Iterations of Recursive Queries</b>
+</p>
+<div class="table-contents">
+<table summary="Maximum Iterations of Recursive Queries" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
+<colgroup>
+<col width="6.5cm" align="left" class="c1">
+<col width="1.5cm" align="left" class="c2">
+<col align="left" class="c3">
+</colgroup>
+<thead>
+<tr>
+<th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Name</th><th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Default</th><th style="border-bottom: 0.5pt solid ; " align="left">Description</th>
+</tr>
+</thead>
+<tbody valign="top">
+<tr>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">sql.max_recursive</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">256</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">maximum number of iterations of a recursive query</td>
+</tr>
+<tr>
+<td style="" colspan="3" align="left" valign="top">
+<p>Recursive queries
+              terminate if they are not completed when the maximum number of
+              iterations is reached. This is to avoid long-running queries
+              that may never actually finish.</p>
+<p>The default value is
+              fine for most use-cases. You can change the default if you need
+              to.</p>
+<pre class="programlisting">SET DATABASE SQL MAX RECURSIVE &lt;count&gt;</pre>
+</td>
+</tr>
+</tbody>
+</table>
+</div>
+</div>
+<br class="table-break">
 </div>
 <div class="section">
 <div class="titlepage">
@@ -30768,9 +31378,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 <div class="table">
-<a name="N1678B"></a>
+<a name="N169E3"></a>
 <p class="title">
-<b>Table&nbsp;14.40.&nbsp;Default Table Type</b>
+<b>Table&nbsp;14.43.&nbsp;Default Table Type</b>
 </p>
 <div class="table-contents">
 <table summary="Default Table Type" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -30806,9 +31416,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N167BB"></a>
+<a name="N16A13"></a>
 <p class="title">
-<b>Table&nbsp;14.41.&nbsp;Transaction Control Mode</b>
+<b>Table&nbsp;14.44.&nbsp;Transaction Control Mode</b>
 </p>
 <div class="table-contents">
 <table summary="Transaction Control Mode" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -30842,9 +31452,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N167F1"></a>
+<a name="N16A49"></a>
 <p class="title">
-<b>Table&nbsp;14.42.&nbsp;Default Isolation Level for Sessions</b>
+<b>Table&nbsp;14.45.&nbsp;Default Isolation Level for Sessions</b>
 </p>
 <div class="table-contents">
 <table summary="Default Isolation Level for Sessions" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -30878,9 +31488,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16824"></a>
+<a name="N16A7C"></a>
 <p class="title">
-<b>Table&nbsp;14.43.&nbsp;Transaction Rollback in Deadlock</b>
+<b>Table&nbsp;14.46.&nbsp;Transaction Rollback in Deadlock</b>
 </p>
 <div class="table-contents">
 <table summary="Transaction Rollback in Deadlock" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -30921,9 +31531,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16851"></a>
+<a name="N16AA9"></a>
 <p class="title">
-<b>Table&nbsp;14.44.&nbsp;Transaction Rollback on Interrupt</b>
+<b>Table&nbsp;14.47.&nbsp;Transaction Rollback on Interrupt</b>
 </p>
 <div class="table-contents">
 <table summary="Transaction Rollback on Interrupt" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -30959,9 +31569,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N1687E"></a>
+<a name="N16AD6"></a>
 <p class="title">
-<b>Table&nbsp;14.45.&nbsp;Time Zone and Interval Types</b>
+<b>Table&nbsp;14.48.&nbsp;Time Zone and Interval Types</b>
 </p>
 <div class="table-contents">
 <table summary="Time Zone and Interval Types" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -30977,18 +31587,20 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </thead>
 <tbody valign="top">
 <tr>
-<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.translate_tti_types</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">true</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">usage of type codes for advanced datetime and interval
-              types</td>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.translate_tti_types</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">true</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">usage of type codes for advanced interval types</td>
 </tr>
 <tr>
 <td style="" colspan="3" align="left" valign="top">
 <p>If the property is true,
-              the TIME / TIMESTAMP WITH TIME ZONE types and INTERVAL types are
-              represented in JDBC methods of
+              the INTERVAL types are represented in JDBC methods of
               <code class="classname">ResultSetMetaData</code> and
-              <code class="classname">DatabaseMetaData</code> as JDBC datetime types
-              without time zone and the VARCHAR type respectively. The
+              <code class="classname">DatabaseMetaData</code> as the VARCHAR type. The
               original type names are preserved.</p>
+<p>JDBC does not
+              have direct support for names and codes of INTERVAL types. From
+              Java 8, getting and setting INTERVAL values is possible via
+              getObject() and setObject() methods of ResultSet and
+              PreparedStatement.</p>
 <pre class="programlisting">SET DATABASE SQL TRANSLATE TTI TYPES { TRUE | FALSE }</pre>
 </td>
 </tr>
@@ -30997,6 +31609,44 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 <br class="table-break">
+<div class="table">
+<a name="N16B0B"></a>
+<p class="title">
+<b>Table&nbsp;14.49.&nbsp;Temporary Result Rows in Memory</b>
+</p>
+<div class="table-contents">
+<table summary="Temporary Result Rows in Memory" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
+<colgroup>
+<col width="6.5cm" align="left" class="c1">
+<col width="1.5cm" align="left" class="c2">
+<col align="left" class="c3">
+</colgroup>
+<thead>
+<tr>
+<th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Name</th><th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Default</th><th style="border-bottom: 0.5pt solid ; " align="left">Description</th>
+</tr>
+</thead>
+<tbody valign="top">
+<tr>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.result_max_memory_rows</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">0</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">storage of temporary results and tables in memory or on
+              disk</td>
+</tr>
+<tr>
+<td style="" colspan="3" align="left" valign="top">
+<p>This property can be set
+              to specify how many rows of each results or temporary table are
+              stored in memory before the table is written to disk. The
+              default is zero and means data is always stored in memory. If
+              this setting is used, it should be set above
+              1000.</p>
+<pre class="programlisting">SET DATABASE DEFAULT RESULT MEMORY ROWS &lt;numeric value&gt;</pre>
+</td>
+</tr>
+</tbody>
+</table>
+</div>
+</div>
+<br class="table-break">
 </div>
 <div class="section">
 <div class="titlepage">
@@ -31008,9 +31658,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 <div class="table">
-<a name="N168B5"></a>
+<a name="N16B3C"></a>
 <p class="title">
-<b>Table&nbsp;14.46.&nbsp;Opening Database as Read Only</b>
+<b>Table&nbsp;14.50.&nbsp;Opening Database as Read Only</b>
 </p>
 <div class="table-contents">
 <table summary="Opening Database as Read Only" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -31046,9 +31696,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N168E5"></a>
+<a name="N16B6C"></a>
 <p class="title">
-<b>Table&nbsp;14.47.&nbsp;Opening Database Without Modifying the Files</b>
+<b>Table&nbsp;14.51.&nbsp;Opening Database Without Modifying the Files</b>
 </p>
 <div class="table-contents">
 <table summary="Opening Database Without Modifying the Files" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -31083,9 +31733,124 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16915"></a>
+<a name="N16B9C"></a>
 <p class="title">
-<b>Table&nbsp;14.48.&nbsp;Huge database files and tables</b>
+<b>Table&nbsp;14.52.&nbsp;Event Logging</b>
+</p>
+<div class="table-contents">
+<table summary="Event Logging" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
+<colgroup>
+<col width="6.5cm" align="left" class="c1">
+<col width="1.5cm" align="left" class="c2">
+<col align="left" class="c3">
+</colgroup>
+<thead>
+<tr>
+<th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Name</th><th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Default</th><th style="border-bottom: 0.5pt solid ; " align="left">Description</th>
+</tr>
+</thead>
+<tbody valign="top">
+<tr>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.applog</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">0</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">application logging level - can also be used when opening
+              an existing <em class="glossterm">file:</em> database</td>
+</tr>
+<tr>
+<td style="" colspan="3" align="left" valign="top">
+<p>The default level 0
+              indicates no logging. Level 1 results in minimal logging,
+              including any failures. Level 2 indicates all events, including
+              ordinary events. LEVEL 3 adds details of some of the normal
+              operations. The events are logged in a file ending with
+              ".app.log".</p>
+<pre class="programlisting">SET DATABASE EVENT LOG LEVEL { 0 | 1 | 2 | 3}</pre>
+</td>
+</tr>
+</tbody>
+</table>
+</div>
+</div>
+<br class="table-break">
+<div class="table">
+<a name="N16BCC"></a>
+<p class="title">
+<b>Table&nbsp;14.53.&nbsp;SQL Logging</b>
+</p>
+<div class="table-contents">
+<table summary="SQL Logging" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
+<colgroup>
+<col width="6.5cm" align="left" class="c1">
+<col width="1.5cm" align="left" class="c2">
+<col align="left" class="c3">
+</colgroup>
+<thead>
+<tr>
+<th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Name</th><th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Default</th><th style="border-bottom: 0.5pt solid ; " align="left">Description</th>
+</tr>
+</thead>
+<tbody valign="top">
+<tr>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.sqllog</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">0</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">sql logging level - can also be used when opening an
+              existing <em class="glossterm">file:</em> database</td>
+</tr>
+<tr>
+<td style="" colspan="3" align="left" valign="top">
+<p>The default level 0
+              indicates no logging. Level 1 logs only commits and rollbacks.
+              Level 2 logs all the SQL statements executed, together with
+              their parameter values. Long statements and parameter values are
+              truncated. Level 3 is similar to Level 2 but does not truncate
+              long statements and values. The events are logged in a file
+              ending with ".sql.log". This property applies to existing file:
+              databases as well as new databases.</p>
+<pre class="programlisting">SET DATABASE EVENT LOG SQL LEVEL { 0 | 1 | 2 | 3}</pre>
+</td>
+</tr>
+</tbody>
+</table>
+</div>
+</div>
+<br class="table-break">
+<div class="table">
+<a name="N16BFC"></a>
+<p class="title">
+<b>Table&nbsp;14.54.&nbsp;Table Spaces for Cached Tables</b>
+</p>
+<div class="table-contents">
+<table summary="Table Spaces for Cached Tables" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
+<colgroup>
+<col width="6.5cm" align="left" class="c1">
+<col width="1.5cm" align="left" class="c2">
+<col align="left" class="c3">
+</colgroup>
+<thead>
+<tr>
+<th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Name</th><th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Default</th><th style="border-bottom: 0.5pt solid ; " align="left">Description</th>
+</tr>
+</thead>
+<tbody valign="top">
+<tr>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.files_space</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">false</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">use of separate table spaces for each CACHED
+              table</td>
+</tr>
+<tr>
+<td style="" colspan="3" align="left" valign="top">
+<p>The default value is
+              false, indicating table space management is not used. When the
+              value is true at the time of creation of a new database, the
+              directory structures are created inside the .data file and table
+              space support is enabled</p>
+<pre class="programlisting">SET FILES SPACE { TRUE | FALSE }</pre>
+</td>
+</tr>
+</tbody>
+</table>
+</div>
+</div>
+<br class="table-break">
+<div class="table">
+<a name="N16C29"></a>
+<p class="title">
+<b>Table&nbsp;14.55.&nbsp;Huge database files and tables</b>
 </p>
 <div class="table-contents">
 <table summary="Huge database files and tables" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -31120,12 +31885,12 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16945"></a>
+<a name="N16C59"></a>
 <p class="title">
-<b>Table&nbsp;14.49.&nbsp;Event Logging</b>
+<b>Table&nbsp;14.56.&nbsp;Use of NIO for Disk Table Storage</b>
 </p>
 <div class="table-contents">
-<table summary="Event Logging" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
+<table summary="Use of NIO for Disk Table Storage" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
 <colgroup>
 <col width="6.5cm" align="left" class="c1">
 <col width="1.5cm" align="left" class="c2">
@@ -31138,18 +31903,20 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </thead>
 <tbody valign="top">
 <tr>
-<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.applog</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">0</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">application logging level - can also be used when opening
-              an existing <em class="glossterm">file:</em> database</td>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.nio_data_file</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">true</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">use of nio access methods for the .data file</td>
 </tr>
 <tr>
 <td style="" colspan="3" align="left" valign="top">
-<p>The default level 0
-              indicates no logging. Level 1 results in minimal logging,
-              including any failures. Level 2 indicates all events, including
-              ordinary events. LEVEL 3 adds details of some of the normal
-              operations. The events are logged in a file ending with
-              ".app.log".</p>
-<pre class="programlisting">SET DATABASE EVENT LOG LEVEL { 0 | 1 | 2 | 3}</pre>
+<p>Setting this property to
+              <code class="literal">false</code> will avoid the use of nio access
+              methods, resulting in somewhat reduced speed. If the data file
+              is larger than <code class="literal">hsqldb.nio_max_size</code> (default
+              256MB) when it is first opened (or when its size is increased),
+              nio access methods are not used. Also, if the file gets larger
+              than the amount of available computer memory that needs to be
+              allocated for nio access, non-nio access methods are
+              used.</p>
+<pre class="programlisting">SET FILES NIO { TRUE | FALSE }</pre>
 </td>
 </tr>
 </tbody>
@@ -31158,12 +31925,12 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16975"></a>
+<a name="N16C8C"></a>
 <p class="title">
-<b>Table&nbsp;14.50.&nbsp;SQL Logging</b>
+<b>Table&nbsp;14.57.&nbsp;Use of NIO for Disk Table Storage</b>
 </p>
 <div class="table-contents">
-<table summary="SQL Logging" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
+<table summary="Use of NIO for Disk Table Storage" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
 <colgroup>
 <col width="6.5cm" align="left" class="c1">
 <col width="1.5cm" align="left" class="c2">
@@ -31176,20 +31943,17 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </thead>
 <tbody valign="top">
 <tr>
-<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.sqllog</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">0</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">sql logging level - can also be used when opening an
-              existing <em class="glossterm">file:</em> database</td>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.nio_max_size</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">256</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">nio buffer size limit</td>
 </tr>
 <tr>
 <td style="" colspan="3" align="left" valign="top">
-<p>The default level 0
-              indicates no logging. Level 1 logs only commits and rollbacks.
-              Level 2 logs all the SQL statements executed, together with
-              their parameter values. Long statements and parameter values are
-              truncated. Level 3 is similar to Level 2 but does not truncate
-              long statements and values. The events are logged in a file
-              ending with ".sql.log". This property applies to existing file:
-              databases as well as new databases.</p>
-<pre class="programlisting">SET DATABASE EVENT LOG SQL LEVEL { 0 | 1 | 2 | 3}</pre>
+<p>The maximum size of .data
+              file in mega bytes that can use the nio access method. When the
+              file gets larger than this limit, non-nio access methods are
+              used. Values 64, 128, 256, 512, 1024, and larger multiples of
+              512 can be used. The default is
+              256MB.</p>
+<pre class="programlisting">SET FILES NIO SIZE &lt;numeric value&gt;</pre>
 </td>
 </tr>
 </tbody>
@@ -31198,12 +31962,12 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N169A5"></a>
+<a name="N16CB9"></a>
 <p class="title">
-<b>Table&nbsp;14.51.&nbsp;Temporary Result Rows in Memory</b>
+<b>Table&nbsp;14.58.&nbsp;Internal Backup of the .data File</b>
 </p>
 <div class="table-contents">
-<table summary="Temporary Result Rows in Memory" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
+<table summary="Internal Backup of the .data File" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
 <colgroup>
 <col width="6.5cm" align="left" class="c1">
 <col width="1.5cm" align="left" class="c2">
@@ -31216,18 +31980,22 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </thead>
 <tbody valign="top">
 <tr>
-<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.result_max_memory_rows</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">0</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">storage of temporary results and tables in memory or on
-              disk</td>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.inc_backup</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">true</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">incremental backup of data file - NOW OBSOLETE</td>
 </tr>
 <tr>
 <td style="" colspan="3" align="left" valign="top">
-<p>This property can be set
-              to specify how many rows of each results or temporary table are
-              stored in memory before the table is written to disk. The
-              default is zero and means data is always stored in memory. If
-              this setting is used, it should be set above
-              1000.</p>
-<pre class="programlisting">SET DATABASE DEFAULT RESULT MEMORY ROWS &lt;numeric value&gt;</pre>
+<p>As the contents of the
+              .data file are modified during database operation, the original
+              contents are backed up gradually. This allows fast checkpoint
+              and shutdown.</p>
+<p>With HSQLDB up to version 2.5 it was
+              possible to set the property false in order to have the .data
+              file backed up entirely at the time of checkpoint and
+              shutdown.</p>
+<p>From version 2.5.1, this property has no
+              effect and backup is always
+              incremental.</p>
+<pre class="programlisting">SET FILES BACKUP INCREMENT { TRUE | FALSE }</pre>
 </td>
 </tr>
 </tbody>
@@ -31236,9 +32004,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N169D2"></a>
+<a name="N16CEA"></a>
 <p class="title">
-<b>Table&nbsp;14.52.&nbsp;Unused Space Recovery</b>
+<b>Table&nbsp;14.59.&nbsp;Unused Space Recovery</b>
 </p>
 <div class="table-contents">
 <table summary="Unused Space Recovery" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -31268,6 +32036,10 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
               are deleted, the smaller recovered spaces are lost and the
               largest ones are retained for later use. Normally there is no
               need to set this property.</p>
+<p>When table space
+              management is turned on (see hsqldb.files_space property) this
+              property has little effect as unused spaces are always
+              recovered.</p>
 <pre class="programlisting">this property cannot be set with an SQL statement</pre>
 </td>
 </tr>
@@ -31277,9 +32049,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16A04"></a>
+<a name="N16D1E"></a>
 <p class="title">
-<b>Table&nbsp;14.53.&nbsp;Rows Cached In Memory</b>
+<b>Table&nbsp;14.60.&nbsp;Rows Cached In Memory</b>
 </p>
 <div class="table-contents">
 <table summary="Rows Cached In Memory" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -31315,9 +32087,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16A33"></a>
+<a name="N16D4D"></a>
 <p class="title">
-<b>Table&nbsp;14.54.&nbsp;Size of Rows Cached in Memory</b>
+<b>Table&nbsp;14.61.&nbsp;Size of Rows Cached in Memory</b>
 </p>
 <div class="table-contents">
 <table summary="Size of Rows Cached in Memory" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -31360,9 +32132,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16A62"></a>
+<a name="N16D7C"></a>
 <p class="title">
-<b>Table&nbsp;14.55.&nbsp;Size Scale of Disk Table Storage</b>
+<b>Table&nbsp;14.62.&nbsp;Size Scale of Disk Table Storage</b>
 </p>
 <div class="table-contents">
 <table summary="Size Scale of Disk Table Storage" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -31396,9 +32168,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16A8F"></a>
+<a name="N16DA9"></a>
 <p class="title">
-<b>Table&nbsp;14.56.&nbsp;Size Scale of LOB Storage</b>
+<b>Table&nbsp;14.63.&nbsp;Size Scale of LOB Storage</b>
 </p>
 <div class="table-contents">
 <table summary="Size Scale of LOB Storage" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -31432,9 +32204,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16ABC"></a>
+<a name="N16DD6"></a>
 <p class="title">
-<b>Table&nbsp;14.57.&nbsp;Compression of BLOB and CLOB data</b>
+<b>Table&nbsp;14.64.&nbsp;Compression of BLOB and CLOB data</b>
 </p>
 <div class="table-contents">
 <table summary="Compression of BLOB and CLOB data" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -31467,51 +32239,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16AE9"></a>
+<a name="N16E03"></a>
 <p class="title">
-<b>Table&nbsp;14.58.&nbsp;Internal Backup of Database Files</b>
-</p>
-<div class="table-contents">
-<table summary="Internal Backup of Database Files" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
-<colgroup>
-<col width="6.5cm" align="left" class="c1">
-<col width="1.5cm" align="left" class="c2">
-<col align="left" class="c3">
-</colgroup>
-<thead>
-<tr>
-<th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Name</th><th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Default</th><th style="border-bottom: 0.5pt solid ; " align="left">Description</th>
-</tr>
-</thead>
-<tbody valign="top">
-<tr>
-<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.inc_backup</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">true</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">incremental backup of data file</td>
-</tr>
-<tr>
-<td style="" colspan="3" align="left" valign="top">
-<p>As the contents of the
-              .data file are modified during database operation, the original
-              contents are backed up gradually. This allows fast checkpoint
-              and shutdown.</p>
-<p>With HSQLDB up to version 2.5.0 it was
-              possible to set the property false in order to have the .data
-              file backed up entirely at the time of checkpoint and
-              shutdown.</p>
-<p>From version 2.5.1, this property has no
-              effect and backup is always
-              incremental.</p>
-<pre class="programlisting">SET FILES BACKUP INCREMENT { TRUE | FALSE }</pre>
-</td>
-</tr>
-</tbody>
-</table>
-</div>
-</div>
-<br class="table-break">
-<div class="table">
-<a name="N16B1A"></a>
-<p class="title">
-<b>Table&nbsp;14.59.&nbsp;Use of Lock File</b>
+<b>Table&nbsp;14.65.&nbsp;Use of Lock File</b>
 </p>
 <div class="table-contents">
 <table summary="Use of Lock File" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -31548,9 +32278,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16B4A"></a>
+<a name="N16E33"></a>
 <p class="title">
-<b>Table&nbsp;14.60.&nbsp;Logging Data Change Statements</b>
+<b>Table&nbsp;14.66.&nbsp;Logging Data Change Statements</b>
 </p>
 <div class="table-contents">
 <table summary="Logging Data Change Statements" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -31574,11 +32304,10 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
               to <code class="literal">false</code> when database recovery in the event
               of an unexpected crash is not necessary. A database that is used
               as a temporary cache is an example. Regardless of the value of
-              this property, if there is a proper shutdown of the database,
-              all the changed data is stored. A checkpoint or shutdown still
-              rewrites the <code class="literal">.script</code> file and saves the
-              <code class="literal">.backup</code> file according to the other
-              settings.</p>
+              this property, a checkpoint or shutdown still writes the
+              <code class="literal">.script</code> file and saves the
+              <code class="literal">.data</code> file in full, therefore persisting all
+              the changes.</p>
 <pre class="programlisting">SET FILES LOG  { TRUE | FALSE }</pre>
 </td>
 </tr>
@@ -31588,9 +32317,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16B80"></a>
+<a name="N16E69"></a>
 <p class="title">
-<b>Table&nbsp;14.61.&nbsp;Automatic Checkpoint Frequency</b>
+<b>Table&nbsp;14.67.&nbsp;Automatic Checkpoint Frequency</b>
 </p>
 <div class="table-contents">
 <table summary="Automatic Checkpoint Frequency" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -31624,9 +32353,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16BB6"></a>
+<a name="N16E9F"></a>
 <p class="title">
-<b>Table&nbsp;14.62.&nbsp;Automatic Defrag at Checkpoint</b>
+<b>Table&nbsp;14.68.&nbsp;Automatic Defrag at Checkpoint</b>
 </p>
 <div class="table-contents">
 <table summary="Automatic Defrag at Checkpoint" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -31664,9 +32393,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16BE3"></a>
+<a name="N16ECC"></a>
 <p class="title">
-<b>Table&nbsp;14.63.&nbsp;Compression of the .script file</b>
+<b>Table&nbsp;14.69.&nbsp;Compression of the .script file</b>
 </p>
 <div class="table-contents">
 <table summary="Compression of the .script file" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -31701,9 +32430,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16C13"></a>
+<a name="N16EFC"></a>
 <p class="title">
-<b>Table&nbsp;14.64.&nbsp;Logging Data Change Statements Frequency</b>
+<b>Table&nbsp;14.70.&nbsp;Logging Data Change Statements Frequency</b>
 </p>
 <div class="table-contents">
 <table summary="Logging Data Change Statements Frequency" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -31740,9 +32469,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16C40"></a>
+<a name="N16F29"></a>
 <p class="title">
-<b>Table&nbsp;14.65.&nbsp;Logging Data Change Statements Frequency</b>
+<b>Table&nbsp;14.71.&nbsp;Logging Data Change Statements Frequency</b>
 </p>
 <div class="table-contents">
 <table summary="Logging Data Change Statements Frequency" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -31778,86 +32507,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16C6D"></a>
-<p class="title">
-<b>Table&nbsp;14.66.&nbsp;Use of NIO for Disk Table Storage</b>
-</p>
-<div class="table-contents">
-<table summary="Use of NIO for Disk Table Storage" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
-<colgroup>
-<col width="6.5cm" align="left" class="c1">
-<col width="1.5cm" align="left" class="c2">
-<col align="left" class="c3">
-</colgroup>
-<thead>
-<tr>
-<th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Name</th><th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Default</th><th style="border-bottom: 0.5pt solid ; " align="left">Description</th>
-</tr>
-</thead>
-<tbody valign="top">
-<tr>
-<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.nio_data_file</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">true</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">use of nio access methods for the .data file</td>
-</tr>
-<tr>
-<td style="" colspan="3" align="left" valign="top">
-<p>Setting this property to
-              <code class="literal">false</code> will avoid the use of nio access
-              methods, resulting in somewhat reduced speed. If the data file
-              is larger than <code class="literal">hsqldb.nio_max_size</code> (default
-              256MB) when it is first opened (or when its size is increased),
-              nio access methods are not used. Also, if the file gets larger
-              than the amount of available computer memory that needs to be
-              allocated for nio access, non-nio access methods are
-              used.</p>
-<pre class="programlisting">SET FILES NIO { TRUE | FALSE }</pre>
-</td>
-</tr>
-</tbody>
-</table>
-</div>
-</div>
-<br class="table-break">
-<div class="table">
-<a name="N16CA0"></a>
+<a name="N16F56"></a>
 <p class="title">
-<b>Table&nbsp;14.67.&nbsp;Use of NIO for Disk Table Storage</b>
-</p>
-<div class="table-contents">
-<table summary="Use of NIO for Disk Table Storage" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
-<colgroup>
-<col width="6.5cm" align="left" class="c1">
-<col width="1.5cm" align="left" class="c2">
-<col align="left" class="c3">
-</colgroup>
-<thead>
-<tr>
-<th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Name</th><th style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">Default</th><th style="border-bottom: 0.5pt solid ; " align="left">Description</th>
-</tr>
-</thead>
-<tbody valign="top">
-<tr>
-<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">hsqldb.nio_max_size</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">256</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">nio buffer size limit</td>
-</tr>
-<tr>
-<td style="" colspan="3" align="left" valign="top">
-<p>The maximum size of .data
-              file in mega bytes that can use the nio access method. When the
-              file gets larger than this limit, non-nio access methods are
-              used. Values 64, 128, 256, 512, 1024, and larger multiples of
-              512 can be used. The default is
-              256MB.</p>
-<pre class="programlisting">SET FILES NIO SIZE &lt;numeric value&gt;</pre>
-</td>
-</tr>
-</tbody>
-</table>
-</div>
-</div>
-<br class="table-break">
-<div class="table">
-<a name="N16CCD"></a>
-<p class="title">
-<b>Table&nbsp;14.68.&nbsp;Recovery Log Processing</b>
+<b>Table&nbsp;14.72.&nbsp;Recovery Log Processing</b>
 </p>
 <div class="table-contents">
 <table summary="Recovery Log Processing" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -31895,9 +32547,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16CFA"></a>
+<a name="N16F83"></a>
 <p class="title">
-<b>Table&nbsp;14.69.&nbsp;Default Properties for TEXT Tables</b>
+<b>Table&nbsp;14.73.&nbsp;Default Properties for TEXT Tables</b>
 </p>
 <div class="table-contents">
 <table summary="Default Properties for TEXT Tables" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -31932,9 +32584,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16D2E"></a>
+<a name="N16FB7"></a>
 <p class="title">
-<b>Table&nbsp;14.70.&nbsp;Forcing Garbage Collection</b>
+<b>Table&nbsp;14.74.&nbsp;Forcing Garbage Collection</b>
 </p>
 <div class="table-contents">
 <table summary="Forcing Garbage Collection" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -31950,14 +32602,14 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </thead>
 <tbody valign="top">
 <tr>
-<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">runtime.gc_interval</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">0</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">forced garbage collection</td>
+<td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><span class="property">runtime.gc_interval</span></td><td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left" valign="top"><code class="literal">0</code></td><td style="border-bottom: 0.5pt solid ; " align="left" valign="top">forced garbage collection - NOW OBSOLETE</td>
 </tr>
 <tr>
 <td style="" colspan="3" align="left" valign="top">
 <p>No-op setting previously
               used to forces garbage collection each time a set number of
               result set row or cache row objects are created. This setting
-              has no effect in version 2.5.0 or
+              has no effect in version 2.5 or
               later,</p>
 <pre class="programlisting">SET DATABASE GC &lt;numeric value&gt;</pre>
 </td>
@@ -31978,9 +32630,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 <div class="table">
-<a name="N16D5F"></a>
+<a name="N16FE8"></a>
 <p class="title">
-<b>Table&nbsp;14.71.&nbsp;Crypt Property For LOBs</b>
+<b>Table&nbsp;14.75.&nbsp;Crypt Property For LOBs</b>
 </p>
 <div class="table-contents">
 <table summary="Crypt Property For LOBs" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -32015,9 +32667,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16D8C"></a>
+<a name="N17015"></a>
 <p class="title">
-<b>Table&nbsp;14.72.&nbsp;Cipher Key for Encrypted Database</b>
+<b>Table&nbsp;14.76.&nbsp;Cipher Key for Encrypted Database</b>
 </p>
 <div class="table-contents">
 <table summary="Cipher Key for Encrypted Database" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -32048,9 +32700,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16DB9"></a>
+<a name="N17042"></a>
 <p class="title">
-<b>Table&nbsp;14.73.&nbsp;Cipher Initialization Vector for Encrypted Database</b>
+<b>Table&nbsp;14.77.&nbsp;Cipher Initialization Vector for Encrypted Database</b>
 </p>
 <div class="table-contents">
 <table summary="Cipher Initialization Vector for Encrypted Database" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -32082,9 +32734,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16DE6"></a>
+<a name="N1706F"></a>
 <p class="title">
-<b>Table&nbsp;14.74.&nbsp;Crypt Provider Encrypted Database</b>
+<b>Table&nbsp;14.78.&nbsp;Crypt Provider Encrypted Database</b>
 </p>
 <div class="table-contents">
 <table summary="Crypt Provider Encrypted Database" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -32116,9 +32768,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16E13"></a>
+<a name="N1709C"></a>
 <p class="title">
-<b>Table&nbsp;14.75.&nbsp;Cipher Specification for Encrypted Database</b>
+<b>Table&nbsp;14.79.&nbsp;Cipher Specification for Encrypted Database</b>
 </p>
 <div class="table-contents">
 <table summary="Cipher Specification for Encrypted Database" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -32148,15 +32800,6 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 <br class="table-break">
-<p>When connecting to an <em class="glossterm">in-process</em> database
-      creates a new database, or opens an existing database (i.e. it is the
-      first connection made to the database by the application), all the
-      user-defined database properties listed in this section can be specified
-      as URL properties.</p>
-<p>When HyperSQL is used with OpenOffice.org as an external
-      database, the property "default_schema=true" must be set on the URL,
-      otherwise the program will not operate correctly as it does with its
-      built-in hsqldb instance.</p>
 </div>
 </div>
 <div class="section">
@@ -32172,9 +32815,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     Java command line or by calling System.setProperty() from the user's
     program. They are not valid as URL or connection properties.</p>
 <div class="table">
-<a name="N16E4D"></a>
+<a name="N170CF"></a>
 <p class="title">
-<b>Table&nbsp;14.76.&nbsp;Logging Framework</b>
+<b>Table&nbsp;14.80.&nbsp;Logging Framework</b>
 </p>
 <div class="table-contents">
 <table summary="Logging Framework" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -32206,9 +32849,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16E77"></a>
+<a name="N170F9"></a>
 <p class="title">
-<b>Table&nbsp;14.77.&nbsp;Text Tables</b>
+<b>Table&nbsp;14.81.&nbsp;Text Tables</b>
 </p>
 <div class="table-contents">
 <table summary="Text Tables" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -32242,9 +32885,9 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 <br class="table-break">
 <div class="table">
-<a name="N16EA4"></a>
+<a name="N17126"></a>
 <p class="title">
-<b>Table&nbsp;14.78.&nbsp;Java Functions</b>
+<b>Table&nbsp;14.82.&nbsp;Java Functions</b>
 </p>
 <div class="table-contents">
 <table summary="Java Functions" cellspacing="0" width="100%" style="border-collapse: collapse;border-top: 0.5pt solid ; border-bottom: 0.5pt solid ; border-left: 0.5pt solid ; border-right: 0.5pt solid ; ">
@@ -32304,12 +32947,12 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6271 $</p>
+<p class="releaseinfo">$Revision: 6428 $</p>
 </div>
 <div>
 <div class="legalnotice">
-<a name="N16EF9"></a>
-<p>Copyright 2002-2021 Fred Toussi. Permission is granted to
+<a name="N1717B"></a>
+<p>Copyright 2002-2022 Fred Toussi. Permission is granted to
       distribute this document without any alteration under the terms of the
       HSQLDB license. Additional permission is granted to the HSQL Development
       Group to distribute this document with or without alterations under the
@@ -32317,7 +32960,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -32502,7 +33145,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
     will work). Supported properties and their default values (if any) are as
     follows:</p>
 <div class="table">
-<a name="N16F70"></a>
+<a name="N171F2"></a>
 <p class="title">
 <b>Table&nbsp;15.1.&nbsp;common server and webserver properties</b>
 </p>
@@ -32580,7 +33223,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <p>Properties or default values specific to
     <code class="filename">server.properties</code> are:</p>
 <div class="table">
-<a name="N1700D"></a>
+<a name="N1728F"></a>
 <p class="title">
 <b>Table&nbsp;15.2.&nbsp;server properties</b>
 </p>
@@ -32614,7 +33257,7 @@ GRANT SELECT FILTER (WHERE EXTRACT(HOUR
 <p>Properties or default values specific to
     <code class="filename">webserver.properties</code> are:</p>
 <div class="table">
-<a name="N1703F"></a>
+<a name="N172C1"></a>
 <p class="title">
 <b>Table&nbsp;15.3.&nbsp;webserver properties</b>
 </p>
@@ -32831,14 +33474,14 @@ Connection c = DriverManager.getConnecti
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6271 $</p>
+<p class="releaseinfo">$Revision: 6428 $</p>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
-<a name="N17124" class="indexterm"></a>
+<a name="N173A6" class="indexterm"></a>
 <p>This section explains how to encrypt the stream between JDBC network
     clients and HyperSQL Listeners. If you are running an
     <em class="glossterm">in-process</em> (non-Listener) setup, this chapter does
@@ -32937,7 +33580,7 @@ Connection c = DriverManager.getConnecti
 <p>You may already have an X509 cert for your server. If you have a
         server keystore, then you can generate a X509 cert like this. </p>
 <div class="example">
-<a name="N17165"></a>
+<a name="N173E7"></a>
 <p class="title">
 <b>Example&nbsp;15.1.&nbsp;Exporting certificate from the server's keystore</b>
 </p>
@@ -32956,7 +33599,7 @@ Connection c = DriverManager.getConnecti
         existing keystore, or create a new keystore if
         <code class="filename">client.store</code> doesn't exist.</p>
 <div class="example">
-<a name="N17177"></a>
+<a name="N173F9"></a>
 <p class="title">
 <b>Example&nbsp;15.2.&nbsp;Adding a certificate to the client keystore</b>
 </p>
@@ -32980,7 +33623,7 @@ Connection c = DriverManager.getConnecti
         <code class="classname">javax.net.ssl.trustStore</code> every time that you
         run your client program. For example </p>
 <div class="example">
-<a name="N1718B"></a>
+<a name="N1740D"></a>
 <p class="title">
 <b>Example&nbsp;15.3.&nbsp;Specifying your own trust store to a JDBC client</b>
 </p>
@@ -33098,7 +33741,7 @@ Connection c = DriverManager.getConnecti
 <p>Because I have spent a lot of time on this document already, I
         am just giving you an example.</p>
 <div class="example">
-<a name="N17206"></a>
+<a name="N17488"></a>
 <p class="title">
 <b>Example&nbsp;15.4.&nbsp;Getting a pem-style private key into a JKS keystore</b>
 </p>
@@ -33162,7 +33805,7 @@ Connection c = DriverManager.getConnecti
       file.</p>
 <p>If you are using a private server certificate, make sure to also
       set the trust store filepath for relevant urlids in your RC file, as
-      explained in the sample <a class="link" href="#hsqldb.cfg-link">config
+      explained in the sample <a class="link" href="#hsqldb.conf-link">config
       file</a>.</p>
 </div>
 </div>
@@ -33178,7 +33821,7 @@ Connection c = DriverManager.getConnecti
 </div>
 </div>
 </div>
-<a name="N17245" class="indexterm"></a><a name="N17248" class="indexterm"></a>
+<a name="N174C7" class="indexterm"></a><a name="N174CA" class="indexterm"></a>
 <p>JDBC connections will always be denied if the supplied user and
     password are not found in the target catalog. But an HyperSQL listener can
     also restrict access at the listener level, even protecting private
@@ -33274,7 +33917,7 @@ allow 192.168.101.0/24
     copy it to a temporary file and edit the temporary file). Then use the
     <code class="classname">ServerAcl</code> class to test it. </p>
 <div class="example">
-<a name="N1728F"></a>
+<a name="N17511"></a>
 <p class="title">
 <b>Example&nbsp;15.5.&nbsp;Validating and Testing an ACL file</b>
 </p>
@@ -33328,10 +33971,10 @@ allow 192.168.101.0/24
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6155 $</p>
+<p class="releaseinfo">$Revision: 6474 $</p>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -33535,7 +34178,7 @@ allow 192.168.101.0/24
 </div>
 <p class="simpara">All the files in the zip archive will be extracted to
           underneath a new subdirectory named like
-          <code class="filename">hsqldb-2.4.1/hsqldb</code>.</p>
+          <code class="filename">hsqldb-2.7.0/hsqldb</code>.</p>
 </td>
 </tr>
 </tbody>
@@ -33547,7 +34190,7 @@ allow 192.168.101.0/24
     HyperSQL system is <code class="filename">hsqldb.jar</code>, which resides in the
     subdirectory <code class="filename">lib</code>. Depending on who built your
     distribution, your file name may have a version label in it, like
-    <code class="filename">hsqldb-1.2.3.4.jar</code>.</p>
+    <code class="filename">hsqldb-2.7.0.jar</code>.</p>
 <div class="important" style="margin-left: 0.5in; margin-right: 0.5in;">
 <table border="0" summary="Important">
 <tr>
@@ -33586,7 +34229,7 @@ allow 192.168.101.0/24
     document</a>. Otherwise build a new
     <code class="filename">hsqldb.jar</code>.</p>
 <div class="procedure">
-<a name="N1738C"></a>
+<a name="N1760E"></a>
 <p class="title">
 <b>Procedure&nbsp;16.1.&nbsp;Building hsqldb.jar</b>
 </p>
@@ -33765,11 +34408,13 @@ server.database.0=file:db0/db0
     <code class="varname">HSQLDB_OWNER</code>'s home directory. Use
     <code class="literal">chmod</code> to make the file readable and writable only to
     <code class="varname">HSQLDB_OWNER</code>.</p>
-<pre class="programlisting"># $Id: sqltool.rc 5871 2018-12-22 16:56:06Z unsaved $
+<pre class="programlisting"># $Id: sqltool.rc 6381 2021-11-18 21:45:56Z unsaved $
 
 # This is a sample RC configuration file used by SqlTool, DatabaseManager,
 # and any other program that uses the org.hsqldb.lib.RCData class.
 # See the documentation for SqlTool for various ways to use this file.
+# This is not a Java Properties file. It uses a custom format with stanzas,
+# similar to .netrc files.
 
 # If you have the least concerns about security, then secure access to
 # your RC file.
@@ -33807,6 +34452,41 @@ server.database.0=file:db0/db0
 #    liberal patterns, and override settings later in the file with more
 #    specific (or exact) patterns.
 
+# Since service discovery works great in all JREs for many years now, I
+# have removed all 'driver' specifications here.  JRE discover will
+# automatically resolve the driver class based on the JDBC URL format.
+# Most people use default ports, so I have removed port specification from
+# examples except for Microsoft's Sql Server driver where you can't depend
+# on a default port.
+# In all cases, to specify a non-default port, insert colon and port number
+# after the hostname or ip address in the JDBC URL, like
+# jdbc:hsqldb:hsql://localhost:9977 or
+# jdbc:sqlserver://hostname.admc.com:1433;databaseName=dbname
+
+# Amazon Aurora instances are access from JDBC exactly the same as the
+# non-Aurora RDS counterpart.
+
+# For using any database engine other than HyperSQL, you must add the
+# JDBC jar file and the SqlTool jar to your CLASSPATH then run a command like:
+#     java org.hsqldb.util.SqlTool...
+# I.e., the "-jar" switch doesn't support modified classpath.
+# (See SqlTool manual for how to do same thing using Java modules.)
+# To oversimplify for non-developers, the two most common methods to set
+# CLASSPATH for an executable tool like SqlTool are to either use the java
+# "-cp" switch or set environmental variable CLASSPATH.
+# Windows users can use graphical UI or CLI "set".  Unix shell users must
+# "export" in addition to assigning.
+#
+# All JDBC jar files used in these examples are available from Maven
+# repositories.  You can also get them from vendor web sites or with product
+# bundles (especially database distributions).
+# Most databases provide multiple variants.  Most people will want a type 4
+# driver supporting your connection mechanism (most commonly TCP/IP service,
+# but also database file access and others) and your client JRE version.
+# By convention the variants are distinguished in segments of the jar file
+# name before the final ".jar" .
+
+
 # Global default.  .+ matches all lookups:
 urlid .+ 
 username SA
@@ -33820,7 +34500,7 @@ url jdbc:hsqldb:mem:memdbid
 # A personal, local, persistent database.
 # Inherits username and password from default setting above.
 urlid personal
-url jdbc:hsqldb:file:${user.home}/db/personal;shutdown=true
+url jdbc:hsqldb:file:${user.home}/db/personal;shutdown=true;ifexist=true
 transiso TRANSACTION_READ_COMMITTED
 # When connecting directly to a file database like this, you should 
 # use the shutdown connection property like this to shut down the DB
@@ -33829,36 +34509,25 @@ transiso TRANSACTION_READ_COMMITTED
 # This is for a hsqldb Server running with default settings on your local
 # computer (and for which you have not changed the password for "SA").
 # Inherits username and password from default setting above.
+# Default port 9001
 urlid localhost-sa
 url jdbc:hsqldb:hsql://localhost
 
 
 
 # Template for a urlid for an Oracle database.
-# You will need to put the oracle.jdbc.OracleDriver class into your 
-# classpath.
-# In the great majority of cases, you want to use jhe desired version of a
-# file odbc*.jar (previously JDBC distributed as classes12.zip),
-# which you can get from the directory $ORACLE_HOME/jdbc/lib of any
-# Oracle installation compatible with your server.
-# Since you need to add to the classpath, you can't invoke SqlTool with
-# the jar switch, like "java -jar .../sqltool.jar...".
-# Put both the SqlTool jar and odbc*.jar in your classpath (and export!)
-# and run something like "java org.hsqldb.util.SqlTool...".
+# Driver jar files from this century have format like "ojbc*.jar".
+# Default port 1521
+urlid localhost-sa
+# Avoid older drivers because they have quirks.
 # You could use the thick driver instead of the thin, but I know of no reason
 # why any Java app should.
 
 #urlid cardiff2
-#url jdbc:oracle:thin:@aegir.admc.com:1521:TRAFFIC_SID
-# Thin SID URLs must specify both port and SID, there are no defaults.
-# Oracle listens to 1521 by default, so that's what you will usually specify.
-# But can alternatively use global service name (not tnsnames.ora service
-# alias, in which case the port does default to 1521):
-#url jdbc:oracle:thin:@centos.admc.com/tstsid.admc
+# Can identify target database with either SID or global service name.
+#url jdbc:oracle:thin:@//centos.admc.com/tstsid.admc
 #username blaine
-#password secretpassword
-#driver oracle.jdbc.OracleDriver
-
+#password asecret
 
 
 # Template for a TLS-encrypted HSQLDB Server.
@@ -33868,6 +34537,7 @@ url jdbc:hsqldb:hsql://localhost
 # You only need to set "truststore" if the server cert is not approved by
 # your system default truststore (which a commercial certificate probably
 # would be).
+# Port defaults to 554.
 
 #urlid tls
 #url jdbc:hsqldb:hsqls://db.admc.com:9001/lm2
@@ -33877,77 +34547,84 @@ url jdbc:hsqldb:hsql://localhost
 
 
 # Template for a Postgresql database
+# Driver jar files are of format like "postgresql-*.jar"
+# Port defaults to 5432.
 #urlid blainedb
 #url jdbc:postgresql://idun.africawork.org/blainedb
 #username blaine
-#password losung1
-#driver org.postgresql.Driver
+#password asecret
+
+# Amazon RedShift (a fork of Postgresql)
+# Driver jar files are of format like "redshift-jdbc*.jar"
+# Port defaults to 5439.
+#urlid redhshift
+#url jdbc:redshift://clustername.hex.us-east-1.redshift.amazonaws.com/dev
+#username awsuser
+#password asecret
 
 # Template for a MySQL database.  MySQL has poor JDBC support.
+# The latest driver jar files are of format like "mysql-jdbc*.jar", but not
+# long ago they were like "mysql-connector-java*.jar".
+# Port defaults to 3306
 #urlid mysql-testdb
-#url jdbc:mysql://hostname:3306/dbname
+#url jdbc:mysql://hostname/dbname
 #username root
-#password hiddenpwd
-#driver com.mysql.jdbc.Driver
+#password asecret
+# Alternatively, you can access MySQL using jdbc:mariadb URLs and driver.
 
 # Note that "databases" in SQL Server and Sybase are traditionally used for
 # the same purpose as "schemas" with more SQL-compliant databases.
 
 # Template for a Microsoft SQL Server database using Microsoft's Driver
-# (I find that the JTDS driver is much more responsive than Microsoft's).
-# Port defaults to 1433.
+# Seems that some versions default to port 1433 and others to 1434.
 # MSDN implies instances are port-specific, so can specify port or instname.
 #urlid msprojsvr
-# url/driver for Current 2011 JDBC Driver for Microsoft SQL Server:
-# Requires just the new sqljdbc4.jar.  (Microsoft just loves back-slashes)
-#url jdbc:sqlserver://hostname\instname;databaseName=dbname
-# OR
+# Driver jar files are of format like "mssql-jdbc-*.jar".
+# Don't use older MS JDBC drivers (like SQL Server 2000 vintage) because they
+# are pitifully incompetent, handling transactions incorrectly.
+# I recommend that you do not use Microsoft's nonstandard format that
+# includes backslashes.
 #url jdbc:sqlserver://hostname;instanceName=instname;databaseName=dbname
-#driver com.microsoft.jdbc.sqlserver.SQLServerDriver
-# See, for example,
-# https://docs.microsoft.com/en-us/sql/connect/jdbc/building-the-connection-url?view=sql-server-2017
-# url/deriver for OLDER JDBC Driver:
-#url jdbc:microsoft:sqlserver://hostname;DatabaseName=DbName;SelectMethod=Cursor
-# The SelectMethod setting is required to do more than one thing on a JDBC
-# session (I guess Microsoft thought nobody would really use Java for 
-# anything other than a "hello world" program).
-# This is for Microsoft's SQL Server 2000 driver (requires mssqlserver.jar
-# and msutil.jar).
-#driver com.microsoft.jdbc.sqlserver.SQLServerDriver
+# with port:
+#url jdbc:sqlserver://hostname:1433;instanceName=instname;databaseName=dbname
 #username myuser
-#password hiddenpwd
+#password asecret
 
 # Template for Microsoft SQL Server database using the JTDS Driver
-# http://jtds.sourceforge.net  Jar file has name like "jtds-1.2.5.jar".
+# Looks like this project is no longer maintained, so you may be better off
+# using the Microsoft driver above.
+# http://jtds.sourceforge.net  Jar file has name like "jtds-1.3.1.jar".
 # Port defaults to 1433.
 # MSDN implies instances are port-specific, so can specify port or instname.
 #urlid nlyte
 #username myuser
-#password hiddenpwd
+#password asecret
 #url jdbc:jtds:sqlserver://myhost/nlyte;instance=MSSQLSERVER
 # Where database is 'nlyte' and instance is 'MSSQLSERVER'.
 # N.b. this is diff. from MS tools and JDBC driver where (depending on which
 # document you read), instance or database X are specified like  HOSTNAME\X.
-#driver net.sourceforge.jtds.jdbc.Driver
 
 # Template for a Sybase database
 #urlid sybase
 #url jdbc:sybase:Tds:hostname:4100/dbname
 #username blaine
-#password hiddenpwd
+#password asecret
 # This is for the jConnect driver (requires jconn3.jar).
-#driver com.sybase.jdbc3.jdbc.SybDriver
 
-# Template for Embedded Derby / Java DB.
-#urlid derby1
-#url jdbc:derby:path/to/derby/directory;create=true
+# Derby / Java DB.
+# Please see the Derby JDBC docs, because they have changed the organization
+# of their driver jar files in recent years.  Combining that with the different
+# database types supported and jar file classpath chaining, and it's not
+# feasible to document it adequately here.
+# I'll just give one example using network service, which works with 10.15.2.0.
+# Put files derbytools*.jar, derbyclient*.jar, derbyshared*.jar into a
+# directory and include the path to the derbytools.jar in your classpath.
+# Port defaults to 1527.
+#url jdbc:derby://server:&lt;port&gt;/databaseName
 #username ${user.name}
 #password any_noauthbydefault
-#driver org.apache.derby.jdbc.EmbeddedDriver
-# The embedded Derby driver requires derby.jar.
-# There'a also the org.apache.derby.jdbc.ClientDriver driver with URL
-# like jdbc:derby://&lt;server&gt;[:&lt;port&gt;]/databaseName, which requires
-# derbyclient.jar.
+# If you get the right classes into classpath, local file URLs are like:
+#url jdbc:derby:path/to/derby/directory
 # You can use \= to commit, since the Derby team decided (why???)
 # not to implement the SQL standard statement "commit"!!
 # Note that SqlTool can not shut down an embedded Derby database properly,
@@ -33955,6 +34632,16 @@ url jdbc:hsqldb:hsql://localhost
 # However, I've never lost data by shutting it down improperly.
 # Other than not supporting this quirk of Derby, SqlTool is miles ahead of
 # Derby's ij.
+
+# Maria DB
+# With current versions, the MySQL driver does not work to access a Maria
+# database (though the inverse works).
+# Driver jar files are of format like "mariadb-java-client*.jar"
+# Port defaults to 3306
+#urlid maria
+#url jdbc:mariadb://hostname/db2
+#username blaine
+#password asecret
 </pre>
 <p>We will be using the "localhost-sa" sample urlid definition from
     the config file. The JDBC URL for this urlid is
@@ -34083,7 +34770,7 @@ url jdbc:hsqldb:hsql://localhost
 </div>
 </div>
 </div>
-<a name="N174DB" class="indexterm"></a>
+<a name="N1775D" class="indexterm"></a>
 <p>You can, of course, run HSQLDB through inittab on System V
     UNIXes, but usually an init script is more convenient and manageable. This
     section explains how to set up and use our UNIX init script. Our init
@@ -34206,7 +34893,7 @@ url jdbc:hsqldb:hsql://localhost
           catalog. You must supply for this catalog, a hsql: JDBC URL, an
           administrative user name, and the password.</p>
 <div class="example">
-<a name="N17557"></a>
+<a name="N177D9"></a>
 <p class="title">
 <b>Example&nbsp;16.1.&nbsp;example sqltool.rc stanza</b>
 </p>
@@ -34222,13 +34909,13 @@ url jdbc:hsqldb:hsql://localhost
 <li class="step">
 <p>Look at the comment towards the top of the init script
           which lists recommended locations for the configuration file for
-          various UNIX platforms. Copy the sample config file <code class="filename"><a class="filename" href="#hsqldb.cfg-link">sample/hsqldb.cfg</a></code> to one of
+          various UNIX platforms. Copy the sample config file <code class="filename"><a class="filename" href="#hsqldb.conf-link">sample/hsqldb.conf</a></code> to one of
           the listed locations (your choice). Edit the config file according
           to the instructions in it. For our example, you will set the value
           of <code class="varname">URLIDS</code> to <code class="literal">localhostdb1</code>,
           since that is the urlid name that we used in the
           <code class="filename">sqltool.rc</code> file.</p>
-<pre class="programlisting"># $Id: hsqldb.cfg 3583 2010-05-16 01:49:52Z unsaved $
+<pre class="programlisting"># $Id: hsqldb.conf 6310 2021-02-28 15:25:00Z unsaved $
 
 # Sample configuration file for HyperSQL Server Listener.
 # See the "HyperSQL on UNIX" chapter of the HyperSQL User Guide.
@@ -34530,7 +35217,7 @@ URLIDS='localhostdb1'
     <code class="filename">/sample/hsqldb.init</code> over top of of your init script
     (wherever it runs from). Then update your old config file according to the
     instructions in the new config file template at
-    <code class="filename">sample/hsqldb.cfg</code>. You will have to change very few
+    <code class="filename">sample/hsqldb.conf</code>. You will have to change very few
     settings. If you are upgrading from a pre-2.0 installation to a post-2.0
     installation, you will need to (1) add the setting
     <code class="varname">URLIDS</code>, as described above and in the inline comments,
@@ -34569,7 +35256,7 @@ URLIDS='localhostdb1'
 <p class="releaseinfo">$Revision: 5999 $</p>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -35038,7 +35725,7 @@ URLIDS='localhostdb1'
 <p>See the above section for descriptions and usage details. This
     section just contains a list of the available settings.</p>
 <div class="table">
-<a name="N17791"></a>
+<a name="N17A13"></a>
 <p class="title">
 <b>Table&nbsp;17.1.&nbsp;Settings List</b>
 </p>
@@ -35175,7 +35862,7 @@ URLIDS='localhostdb1'
 <p class="releaseinfo">$Revision: 847 $</p>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -35216,7 +35903,7 @@ URLIDS='localhostdb1'
 <p>All keywords can be used with double quotes as identifiers. For
     example</p>
 <pre class="programlisting">  CREATE TABLE "ALL" ("AND" INT, "WHEN" INT)
-  SELECT "AND" FROM "ALL" WHERE "WHEN" = 2021
+  SELECT "AND" FROM "ALL" WHERE "WHEN" = 2022
 </pre>
 <p>ABS &bull; ALL &bull; ALLOCATE &bull; ALTER &bull; AND &bull; ANY &bull; ARE &bull; ARRAY &bull; AS &bull;
     ASENSITIVE &bull; ASYMMETRIC &bull; AT &bull; ATOMIC &bull; AUTHORIZATION &bull; AVG</p>
@@ -35350,7 +36037,7 @@ URLIDS='localhostdb1'
 <p class="releaseinfo">$Revision: 5925 $</p>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -35610,7 +36297,7 @@ URLIDS='localhostdb1'
 </div>
 </div>
 <div class="procedure">
-<a name="N17A2A"></a>
+<a name="N17CAC"></a>
 <p class="title">
 <b>Procedure&nbsp;B.1.&nbsp;Clean HyperSQL database shutdown</b>
 </p>
@@ -35672,7 +36359,7 @@ URLIDS='localhostdb1'
 </div>
 </div>
 <div class="procedure">
-<a name="N17A74"></a>
+<a name="N17CF6"></a>
 <p class="title">
 <b>Procedure&nbsp;B.2.&nbsp;Opening the Database</b>
 </p>
@@ -35726,7 +36413,7 @@ URLIDS='localhostdb1'
 <p>The current <code class="filename">test.data</code> file is not necessarily
       consistent. The database engine takes these steps:</p>
 <div class="procedure">
-<a name="N17AB6"></a>
+<a name="N17D38"></a>
 <p class="title">
 <b>Procedure&nbsp;B.3.&nbsp;Restore a Database</b>
 </p>
@@ -35798,7 +36485,7 @@ URLIDS='localhostdb1'
 <p class="releaseinfo">$Revision: 6366 $</p>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -35873,7 +36560,7 @@ URLIDS='localhostdb1'
 </div>
 </div>
 </div>
-<a name="N17B38" class="indexterm"></a>
+<a name="N17DBA" class="indexterm"></a>
 <p>Unlike most software build systems, you do not need to have the
     Gradle system installed on your computer to use it. You don't need to
     understand the details to use it, but this is the purpose of the
@@ -35983,7 +36670,7 @@ URLIDS='localhostdb1'
 </div>
 </div>
 </div>
-<a name="N17BAE" class="indexterm"></a>
+<a name="N17E30" class="indexterm"></a>
 <p>You should use version 1.9 or 1.10 of Ant (Another Neat Tool) to
     do Ant builds with HyperSQL.</p>
 <div class="section">
@@ -36155,7 +36842,7 @@ URLIDS='localhostdb1'
 <p>The command displays a list of different options for building
       different sizes of the HSQLDB Jar. The default is built using:</p>
 <div class="example">
-<a name="N17C62"></a>
+<a name="N17EE4"></a>
 <p class="title">
 <b>Example&nbsp;C.1.&nbsp;Buiding the standard HSQLDB jar file with Ant</b>
 </p>
@@ -36208,7 +36895,7 @@ URLIDS='localhostdb1'
     particular version of the file. This operation is done for all files of a
     defined directory, and all subdirectories.</p>
 <div class="example">
-<a name="N17C7B"></a>
+<a name="N17EFD"></a>
 <p class="title">
 <b>Example&nbsp;C.2.&nbsp;Example source code before CodeSwitcher is run</b>
 </p>
@@ -36236,7 +36923,7 @@ URLIDS='localhostdb1'
 <br class="example-break">
 <p>The next step is to run CodeSwitcher.</p>
 <div class="example">
-<a name="N17C82"></a>
+<a name="N17F04"></a>
 <p class="title">
 <b>Example&nbsp;C.3.&nbsp;CodeSwitcher command line invocation</b>
 </p>
@@ -36250,7 +36937,7 @@ URLIDS='localhostdb1'
     subdirectories are processed recursively). <code class="literal">-JAVA8</code> means
     the code labelled with JAVA8 must be switched off.</p>
 <div class="example">
-<a name="N17C8C"></a>
+<a name="N17F0E"></a>
 <p class="title">
 <b>Example&nbsp;C.4.&nbsp;Source code after CodeSwitcher processing</b>
 </p>
@@ -36410,10 +37097,10 @@ URLIDS='localhostdb1'
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6281 $</p>
+<p class="releaseinfo">$Revision: 6491 $</p>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -36462,7 +37149,7 @@ URLIDS='localhostdb1'
     database schema and application, even if the database is intended for your
     own application, rather than OpenOffice.</p>
 <p>HyperSQ version 1.8.0 is included in OOo, ApacheOpenOffice and
-    LibreOffice. You can simply replace the jar with a HyperSQL version 2.6
+    LibreOffice. You can simply replace the jar with a HyperSQL version 2.7
     jar to use the latest capabilities with external databases. It is not yet
     possible to create and use embedded databases with this version.</p>
 <p>HyperSQL version 2.x jar will hopefully be included in the future
@@ -36491,8 +37178,8 @@ URLIDS='localhostdb1'
 <p>The only current limitation is that OpenOffice only works with
     the PUBLIC schema. This limitation will hopefully disappear in the future
     versions of OOo.</p>
-<p>There will hopefully be a HyperSQLDB 2.x jar in the future
-    versions of OpenOffice.</p>
+<p>There will hopefully be a HyperSQL 2.x jar in future versions of
+    OpenOffice.</p>
 </div>
 <div class="section">
 <div class="titlepage">
@@ -36520,22 +37207,20 @@ URLIDS='localhostdb1'
 </div>
 </div>
 </div>
-<p>In 2021, two new OOo and LO extensions are developed and
+<p>Since 2021, two new OOo and LO extensions are developed and
     maintained on GitHub by the developer prrvchr. These extensions make it
     easy to use the latest version of HSQLDB 2.x with the latest versions of
     the Base program. One extension simply adds and loads the HSQLDB 2.x jar,
     ready for use. It also allows updating the jar to the latest version. The
     second extension extracts the database from the .odb file in the same
     directory and connects to the extracted database files.</p>
-<p>The simple driver: <a class="link" href="https://prrvchr.github.io/HsqlDBDriverOOo/" target="_top">https://prrvchr.github.io/HsqlDBDriverOOo/</a>
-    
+<p>The simple driver: <a class="link" href="https://prrvchr.github.io/jdbcDriverOOo/" target="_top">https://prrvchr.github.io/jdbcDriverOOo/</a>
 </p>
 <p>The driver that extracts the files: <a class="link" href="https://prrvchr.github.io/HsqlDBembeddedOOo/" target="_top">https://prrvchr.github.io/HsqlDBembeddedOOo/</a>
-    
 </p>
 <p>The extensions are easy to use, with clear visual instructions on
     how to add the extensions to the Office suite and how to create and open
-    databases. </p>
+    databases.</p>
 </div>
 </div>
 <div class="appendix">
@@ -36583,12 +37268,12 @@ URLIDS='localhostdb1'
 <a name="JDBCConnection.html-link"></a>
 <p class="simpara">
         Local:
-        <a class="link" href="../apidocs/org/hsqldb/jdbc/JDBCConnection.html" target="_top">../apidocs/org/hsqldb/jdbc/JDBCConnection.html</a>
+        <a class="link" href="../apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCConnection.html" target="_top">../apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCConnection.html</a>
       
 </p>
 <p class="simpara">
         
-<a class="link" href="http://hsqldb.org/doc/2.0/apidocs/org/hsqldb/jdbc/JDBCConnection.html" target="_top">http://hsqldb.org/doc/2.0/apidocs/org/hsqldb/jdbc/JDBCConnection.html</a>
+<a class="link" href="http://hsqldb.org/doc/2.0/apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCConnection.html" target="_top">http://hsqldb.org/doc/2.0/apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCConnection.html</a>
       
 </p>
 </li>
@@ -36596,12 +37281,12 @@ URLIDS='localhostdb1'
 <a name="JDBCDriver.html-link"></a>
 <p class="simpara">
         Local:
-        <a class="link" href="../apidocs/org/hsqldb/jdbc/JDBCDriver.html" target="_top">../apidocs/org/hsqldb/jdbc/JDBCDriver.html</a>
+        <a class="link" href="../apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCDriver.html" target="_top">../apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCDriver.html</a>
       
 </p>
 <p class="simpara">
         
-<a class="link" href="http://hsqldb.org/doc/2.0/apidocs/org/hsqldb/jdbc/JDBCDriver.html" target="_top">http://hsqldb.org/doc/2.0/apidocs/org/hsqldb/jdbc/JDBCDriver.html</a>
+<a class="link" href="http://hsqldb.org/doc/2.0/apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCDriver.html" target="_top">http://hsqldb.org/doc/2.0/apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCDriver.html</a>
       
 </p>
 </li>
@@ -36609,12 +37294,12 @@ URLIDS='localhostdb1'
 <a name="JDBCDatabaseMetaData.html-link"></a>
 <p class="simpara">
         Local:
-        <a class="link" href="../apidocs/org/hsqldb/jdbc/JDBCDatabaseMetaData.html" target="_top">../apidocs/org/hsqldb/jdbc/JDBCDatabaseMetaData.html</a>
+        <a class="link" href="../apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCDatabaseMetaData.html" target="_top">../apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCDatabaseMetaData.html</a>
       
 </p>
 <p class="simpara">
         
-<a class="link" href="http://hsqldb.org/doc/2.0/apidocs/org/hsqldb/jdbc/JDBCDatabaseMetaData.html" target="_top">http://hsqldb.org/doc/2.0/apidocs/org/hsqldb/jdbc/JDBCDatabaseMetaData.html</a>
+<a class="link" href="http://hsqldb.org/doc/2.0/apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCDatabaseMetaData.html" target="_top">http://hsqldb.org/doc/2.0/apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCDatabaseMetaData.html</a>
       
 </p>
 </li>
@@ -36622,12 +37307,12 @@ URLIDS='localhostdb1'
 <a name="JDBCResultSet.html-link"></a>
 <p class="simpara">
         Local:
-        <a class="link" href="../apidocs/org/hsqldb/jdbc/JDBCResultSet.html" target="_top">../apidocs/org/hsqldb/jdbc/JDBCResultSet.html</a>
+        <a class="link" href="../apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCResultSet.html" target="_top">../apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCResultSet.html</a>
       
 </p>
 <p class="simpara">
         
-<a class="link" href="http://hsqldb.org/doc/2.0/apidocs/org/hsqldb/jdbc/JDBCResultSet.html" target="_top">http://hsqldb.org/doc/2.0/apidocs/org/hsqldb/jdbc/JDBCResultSet.html</a>
+<a class="link" href="http://hsqldb.org/doc/2.0/apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCResultSet.html" target="_top">http://hsqldb.org/doc/2.0/apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCResultSet.html</a>
       
 </p>
 </li>
@@ -36635,12 +37320,12 @@ URLIDS='localhostdb1'
 <a name="JDBCStatement.html-link"></a>
 <p class="simpara">
         Local:
-        <a class="link" href="../apidocs/org/hsqldb/jdbc/JDBCStatement.html" target="_top">../apidocs/org/hsqldb/jdbc/JDBCStatement.html</a>
+        <a class="link" href="../apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCStatement.html" target="_top">../apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCStatement.html</a>
       
 </p>
 <p class="simpara">
         
-<a class="link" href="http://hsqldb.org/doc/2.0/apidocs/org/hsqldb/jdbc/JDBCStatement.html" target="_top">http://hsqldb.org/doc/2.0/apidocs/org/hsqldb/jdbc/JDBCStatement.html</a>
+<a class="link" href="http://hsqldb.org/doc/2.0/apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCStatement.html" target="_top">http://hsqldb.org/doc/2.0/apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCStatement.html</a>
       
 </p>
 </li>
@@ -36648,12 +37333,12 @@ URLIDS='localhostdb1'
 <a name="JDBCPreparedStatement.html-link"></a>
 <p class="simpara">
         Local:
-        <a class="link" href="../apidocs/org/hsqldb/jdbc/JDBCPreparedStatement.html" target="_top">../apidocs/org/hsqldb/jdbc/JDBCPreparedStatement.html</a>
+        <a class="link" href="../apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCPreparedStatement.html" target="_top">../apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCPreparedStatement.html</a>
       
 </p>
 <p class="simpara">
         
-<a class="link" href="http://hsqldb.org/doc/2.0/apidocs/org/hsqldb/jdbc/JDBCPreparedStatement.html" target="_top">http://hsqldb.org/doc/2.0/apidocs/org/hsqldb/jdbc/JDBCPreparedStatement.html</a>
+<a class="link" href="http://hsqldb.org/doc/2.0/apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCPreparedStatement.html" target="_top">http://hsqldb.org/doc/2.0/apidocs/org.hsqldb/org/hsqldb/jdbc/JDBCPreparedStatement.html</a>
       
 </p>
 </li>
@@ -36661,12 +37346,12 @@ URLIDS='localhostdb1'
 <a name="MainInvoker.html-link"></a>
 <p class="simpara">
         Local:
-        <a class="link" href="../apidocs/org/hsqldb/util/MainInvoker.html" target="_top">../apidocs/org/hsqldb/util/MainInvoker.html</a>
+        <a class="link" href="../apidocs/org.hsqldb/org/hsqldb/util/MainInvoker.html" target="_top">../apidocs/org.hsqldb/org/hsqldb/util/MainInvoker.html</a>
       
 </p>
 <p class="simpara">
       
-<a class="link" href="http://hsqldb.org/doc/2.0/apidocs/org/hsqldb/util/MainInvoker.html" target="_top">http://hsqldb.org/doc/2.0/apidocs/org/hsqldb/util/MainInvoker.html</a>
+<a class="link" href="http://hsqldb.org/doc/2.0/apidocs/org.hsqldb/org/hsqldb/util/MainInvoker.html" target="_top">http://hsqldb.org/doc/2.0/apidocs/org.hsqldb/org/hsqldb/util/MainInvoker.html</a>
       
 </p>
 </li>
@@ -36775,15 +37460,15 @@ URLIDS='localhostdb1'
 </p>
 </li>
 <li class="listitem">
-<a name="hsqldb.cfg-link"></a>
+<a name="hsqldb.conf-link"></a>
 <p class="simpara">
         Local:
-        <a class="link" href="../verbatim/sample/hsqldb.cfg" target="_top">../verbatim/sample/hsqldb.cfg</a>
+        <a class="link" href="../verbatim/sample/hsqldb.conf" target="_top">../verbatim/sample/hsqldb.conf</a>
       
 </p>
 <p class="simpara">
         
-<a class="link" href="http://hsqldb.org/doc/2.0/verbatim/sample/hsqldb.cfg" target="_top">http://hsqldb.org/doc/2.0/verbatim/sample/hsqldb.cfg</a>
+<a class="link" href="http://hsqldb.org/doc/2.0/verbatim/sample/hsqldb.conf" target="_top">http://hsqldb.org/doc/2.0/verbatim/sample/hsqldb.conf</a>
       
 </p>
 </li>
@@ -36855,7 +37540,7 @@ URLIDS='localhostdb1'
 <div class="indexdiv">
 <h3>Symbols</h3>
 <dl>
-<dt>_SYSTEM ROLE, <a class="indexterm" href="#acc_built_in_roles_users">Built-In Roles and Users</a>
+<dt>_SYSTEM Role, <a class="indexterm" href="#acc_built_in_roles_users">Built-In Roles and Users</a>
 </dt>
 </dl>
 </div>
@@ -36864,6 +37549,8 @@ URLIDS='localhostdb1'
 <dl>
 <dt>ABS function, <a class="indexterm" href="#bfc_numeric_functions">Numeric Functions</a>
 </dt>
+<dt>Access Rights, <a class="indexterm" href="#acc_access_rights">Access Rights</a>
+</dt>
 <dt>ACOS function, <a class="indexterm" href="#bfc_numeric_functions">Numeric Functions</a>
 </dt>
 <dt>ACTION_ID function, <a class="indexterm" href="#bfc_system_functions">System Functions</a>
@@ -36884,6 +37571,8 @@ URLIDS='localhostdb1'
 </dt>
 <dt>ADMINISTRABLE_ROLE_AUTHORIZATIONS, <a class="indexterm" href="#dbc_standard_views_info_schema">SQL Standard Views</a>
 </dt>
+<dt>Admin USER, <a class="indexterm" href="#acc_built_in_roles_users">Built-In Roles and Users</a>
+</dt>
 <dt>aggregate function, <a class="indexterm" href="#dac_aggregate_funcs">Aggregate Functions</a>
 </dt>
 <dt>ALL and ANY predicates, <a class="indexterm" href="#dac_sql_predicates">Predicates</a>
@@ -36935,6 +37624,8 @@ URLIDS='localhostdb1'
 </dt>
 <dt>ATAN function, <a class="indexterm" href="#bfc_numeric_functions">Numeric Functions</a>
 </dt>
+<dt>Authorisation and Access Control, <a class="indexterm" href="#acc_auth_and_access_ctrl">Authorizations and Access Control</a>
+</dt>
 <dt>AUTHORIZATION IDENTIFIER, <a class="indexterm" href="#acc_auth_and_access_ctrl">Authorizations and Access Control</a>
 </dt>
 <dt>AUTHORIZATIONS, <a class="indexterm" href="#dbc_standard_views_info_schema">SQL Standard Views</a>
@@ -36974,6 +37665,8 @@ URLIDS='localhostdb1'
 </dt>
 <dt>boolean value expression, <a class="indexterm" href="#dac_value_expression">Value Expression</a>
 </dt>
+<dt>Built-in Roles and Users, <a class="indexterm" href="#acc_built_in_roles_users">Built-In Roles and Users</a>
+</dt>
 </dl>
 </div>
 <div class="indexdiv">
@@ -37077,7 +37770,7 @@ URLIDS='localhostdb1'
 </dt>
 <dt>COT function, <a class="indexterm" href="#bfc_numeric_functions">Numeric Functions</a>
 </dt>
-<dt>CREATE_SCHEMA ROLE, <a class="indexterm" href="#acc_built_in_roles_users">Built-In Roles and Users</a>
+<dt>CREATE_SCHEMA Role, <a class="indexterm" href="#acc_built_in_roles_users">Built-In Roles and Users</a>
 </dt>
 <dt>CREATE AGGREGATE FUNCTION, <a class="indexterm" href="#src_aggregate_function_definition">Definition of Aggregate Functions</a>
 </dt>
@@ -37190,7 +37883,7 @@ URLIDS='localhostdb1'
 </dt>
 <dt>DAYS function datetime, <a class="indexterm" href="#bfc_extract_datetime">Functions to Extract an Element of a Datetime</a>
 </dt>
-<dt>DBA ROLE, <a class="indexterm" href="#acc_built_in_roles_users">Built-In Roles and Users</a>
+<dt>DBA Role, <a class="indexterm" href="#acc_built_in_roles_users">Built-In Roles and Users</a>
 </dt>
 <dt>DECLARE CURSOR, <a class="indexterm" href="#dac_declare_cursor">Cursor Declaration</a>
 </dt>
@@ -37314,6 +38007,8 @@ URLIDS='localhostdb1'
 </dt>
 <dt>FROM_BASE64 function, <a class="indexterm" href="#bfc_string_binary_functions">String and Binary String Functions</a>
 </dt>
+<dt>FROM_TZ function, <a class="indexterm" href="#bfc_datetime_format">Functions to Convert or Format a Datetime</a>
+</dt>
 </dl>
 </div>
 <div class="indexdiv">
@@ -37326,7 +38021,7 @@ URLIDS='localhostdb1'
 <dt>GRANTED BY, <a class="indexterm" href="#acc_statements">Statements for
     Authorization and Access Control</a>
 </dt>
-<dt>GRANT privilege, <a class="indexterm" href="#acc_statements">Statements for
+<dt>GRANT privileges, <a class="indexterm" href="#acc_statements">Statements for
     Authorization and Access Control</a>
 </dt>
 <dt>GRANT role, <a class="indexterm" href="#acc_statements">Statements for
@@ -37411,6 +38106,12 @@ URLIDS='localhostdb1'
 </dt>
 <dt>JOIN with condition, <a class="indexterm" href="#dac_joined_table">Joined Table</a>
 </dt>
+<dt>JSON_ARRAY_AGG function, <a class="indexterm" href="#bfc_JSON_functions">JSON Functions</a>
+</dt>
+<dt>JSON_ARRAY function, <a class="indexterm" href="#bfc_JSON_functions">JSON Functions</a>
+</dt>
+<dt>JSON_OBJECT function, <a class="indexterm" href="#bfc_JSON_functions">JSON Functions</a>
+</dt>
 </dl>
 </div>
 <div class="indexdiv">
@@ -37443,6 +38144,8 @@ URLIDS='localhostdb1'
 </dt>
 <dt>LIKE predicate, <a class="indexterm" href="#dac_sql_predicates">Predicates</a>
 </dt>
+<dt>Listing Users and Roles, <a class="indexterm" href="#acc_listing">Listing Users and Roles</a>
+</dt>
 <dt>LN function, <a class="indexterm" href="#bfc_numeric_functions">Numeric Functions</a>
 </dt>
 <dt>LOAD_FILE function, <a class="indexterm" href="#bfc_general_functions">General Functions</a>
@@ -37561,8 +38264,12 @@ URLIDS='localhostdb1'
 </dt>
 <dt>PERFORM CHECK INDEX, <a class="indexterm" href="#mtc_data_management_statements">Data Management Statements</a>
 </dt>
+<dt>PERFORM EXPORT DSV, <a class="indexterm" href="#mtc_data_management_statements">Data Management Statements</a>
+</dt>
 <dt>PERFORM EXPORT SCRIPT, <a class="indexterm" href="#mtc_data_management_statements">Data Management Statements</a>
 </dt>
+<dt>PERFORM IMPORT DSV file, <a class="indexterm" href="#mtc_data_management_statements">Data Management Statements</a>
+</dt>
 <dt>PERFORM IMPORT SCRIPT, <a class="indexterm" href="#mtc_data_management_statements">Data Management Statements</a>
 </dt>
 <dt>PERIODS, <a class="indexterm" href="#dbc_standard_views_info_schema">SQL Standard Views</a>
@@ -37579,7 +38286,7 @@ URLIDS='localhostdb1'
 </dt>
 <dt>PRIMARY KEY constraint, <a class="indexterm" href="#dbc_table_creation">Table Creation</a>
 </dt>
-<dt>PUBLIC ROLE, <a class="indexterm" href="#acc_built_in_roles_users">Built-In Roles and Users</a>
+<dt>PUBLIC Role, <a class="indexterm" href="#acc_built_in_roles_users">Built-In Roles and Users</a>
 </dt>
 </dl>
 </div>
@@ -37637,7 +38344,7 @@ URLIDS='localhostdb1'
 </dt>
 <dt>REVERSE function, <a class="indexterm" href="#bfc_string_binary_functions">String and Binary String Functions</a>
 </dt>
-<dt>REVOKE, <a class="indexterm" href="#acc_statements">Statements for
+<dt>REVOKE privileges, <a class="indexterm" href="#acc_statements">Statements for
     Authorization and Access Control</a>
 </dt>
 <dt>REVOKE ROLE, <a class="indexterm" href="#acc_statements">Statements for
@@ -37710,7 +38417,7 @@ URLIDS='localhostdb1'
 </dt>
 <dt>SCRIPT, <a class="indexterm" href="#mtc_system_operation_statements">System Operations</a>
 </dt>
-<dt>SCRIPT_OPS, <a class="indexterm" href="#acc_built_in_roles_users">Built-In Roles and Users</a>
+<dt>SCRIPT_OPS Role, <a class="indexterm" href="#acc_built_in_roles_users">Built-In Roles and Users</a>
 </dt>
 <dt>search condition, <a class="indexterm" href="#dac_other_syntax_elements">Other Syntax Elements</a>
 </dt>
@@ -37809,6 +38516,8 @@ URLIDS='localhostdb1'
 </dt>
 <dt>SET DATABASE SQL TRANSLATE TTI TYPES, <a class="indexterm" href="#mtc_sql_settings">SQL Conformance Settings</a>
 </dt>
+<dt>SET DATABASE SQL TRUNCATE TRAILING, <a class="indexterm" href="#mtc_sql_settings">SQL Conformance Settings</a>
+</dt>
 <dt>SET DATABASE SQL TYPES, <a class="indexterm" href="#mtc_sql_settings">SQL Conformance Settings</a>
 </dt>
 <dt>SET DATABASE SQL UNIQUE NULLS, <a class="indexterm" href="#mtc_sql_settings">SQL Conformance Settings</a>
@@ -37907,6 +38616,8 @@ URLIDS='localhostdb1'
 </dt>
 <dt>SIGN function, <a class="indexterm" href="#bfc_numeric_functions">Numeric Functions</a>
 </dt>
+<dt>Simple Data Access Control, <a class="indexterm" href="#N1425C">Simple Access Control</a>
+</dt>
 <dt>SIN function, <a class="indexterm" href="#bfc_numeric_functions">Numeric Functions</a>
 </dt>
 <dt>SINH function, <a class="indexterm" href="#bfc_numeric_functions">Numeric Functions</a>
@@ -38015,8 +38726,6 @@ URLIDS='localhostdb1'
 </dt>
 <dt>SYSTIMESTAMP function, <a class="indexterm" href="#bfc_current_datetime">Functions to Report the Current Datetime</a>
 </dt>
-<dt>SYS USER, <a class="indexterm" href="#acc_built_in_roles_users">Built-In Roles and Users</a>
-</dt>
 </dl>
 </div>
 <div class="indexdiv">
@@ -38199,7 +38908,7 @@ URLIDS='localhostdb1'
 <div class="indexdiv">
 <h3>Symbols</h3>
 <dl>
-<dt>_SYSTEM ROLE, <a class="indexterm" href="#acc_built_in_roles_users">Built-In Roles and Users</a>
+<dt>_SYSTEM Role, <a class="indexterm" href="#acc_built_in_roles_users">Built-In Roles and Users</a>
 </dt>
 </dl>
 </div>
@@ -38208,6 +38917,8 @@ URLIDS='localhostdb1'
 <dl>
 <dt>ABS function, <a class="indexterm" href="#bfc_numeric_functions">Numeric Functions</a>
 </dt>
+<dt>Access Rights, <a class="indexterm" href="#acc_access_rights">Access Rights</a>
+</dt>
 <dt>ACL, <a class="indexterm" href="#lsc_acl">Network Access Control</a>
 </dt>
 <dt>ACOS function, <a class="indexterm" href="#bfc_numeric_functions">Numeric Functions</a>
@@ -38230,6 +38941,8 @@ URLIDS='localhostdb1'
 </dt>
 <dt>ADMINISTRABLE_ROLE_AUTHORIZATIONS, <a class="indexterm" href="#dbc_standard_views_info_schema">SQL Standard Views</a>
 </dt>
+<dt>Admin USER, <a class="indexterm" href="#acc_built_in_roles_users">Built-In Roles and Users</a>
+</dt>
 <dt>aggregate function, <a class="indexterm" href="#dac_aggregate_funcs">Aggregate Functions</a>
 </dt>
 <dt>ALL and ANY predicates, <a class="indexterm" href="#dac_sql_predicates">Predicates</a>
@@ -38283,6 +38996,8 @@ URLIDS='localhostdb1'
 </dt>
 <dt>ATAN function, <a class="indexterm" href="#bfc_numeric_functions">Numeric Functions</a>
 </dt>
+<dt>Authorisation and Access Control, <a class="indexterm" href="#acc_auth_and_access_ctrl">Authorizations and Access Control</a>
+</dt>
 <dt>AUTHORIZATION IDENTIFIER, <a class="indexterm" href="#acc_auth_and_access_ctrl">Authorizations and Access Control</a>
 </dt>
 <dt>AUTHORIZATIONS, <a class="indexterm" href="#dbc_standard_views_info_schema">SQL Standard Views</a>
@@ -38324,6 +39039,8 @@ URLIDS='localhostdb1'
 </dt>
 <dt>boolean value expression, <a class="indexterm" href="#dac_value_expression">Value Expression</a>
 </dt>
+<dt>Built-in Roles and Users, <a class="indexterm" href="#acc_built_in_roles_users">Built-In Roles and Users</a>
+</dt>
 </dl>
 </div>
 <div class="indexdiv">
@@ -38429,7 +39146,7 @@ URLIDS='localhostdb1'
 </dt>
 <dt>COT function, <a class="indexterm" href="#bfc_numeric_functions">Numeric Functions</a>
 </dt>
-<dt>CREATE_SCHEMA ROLE, <a class="indexterm" href="#acc_built_in_roles_users">Built-In Roles and Users</a>
+<dt>CREATE_SCHEMA Role, <a class="indexterm" href="#acc_built_in_roles_users">Built-In Roles and Users</a>
 </dt>
 <dt>CREATE AGGREGATE FUNCTION, <a class="indexterm" href="#src_aggregate_function_definition">Definition of Aggregate Functions</a>
 </dt>
@@ -38542,7 +39259,7 @@ URLIDS='localhostdb1'
 </dt>
 <dt>DAYS function datetime, <a class="indexterm" href="#bfc_extract_datetime">Functions to Extract an Element of a Datetime</a>
 </dt>
-<dt>DBA ROLE, <a class="indexterm" href="#acc_built_in_roles_users">Built-In Roles and Users</a>
+<dt>DBA Role, <a class="indexterm" href="#acc_built_in_roles_users">Built-In Roles and Users</a>
 </dt>
 <dt>DECLARE CURSOR, <a class="indexterm" href="#dac_declare_cursor">Cursor Declaration</a>
 </dt>
@@ -38666,6 +39383,8 @@ URLIDS='localhostdb1'
 </dt>
 <dt>FROM_BASE64 function, <a class="indexterm" href="#bfc_string_binary_functions">String and Binary String Functions</a>
 </dt>
+<dt>FROM_TZ function, <a class="indexterm" href="#bfc_datetime_format">Functions to Convert or Format a Datetime</a>
+</dt>
 </dl>
 </div>
 <div class="indexdiv">
@@ -38680,7 +39399,7 @@ URLIDS='localhostdb1'
 <dt>GRANTED BY, <a class="indexterm" href="#acc_statements">Statements for
     Authorization and Access Control</a>
 </dt>
-<dt>GRANT privilege, <a class="indexterm" href="#acc_statements">Statements for
+<dt>GRANT privileges, <a class="indexterm" href="#acc_statements">Statements for
     Authorization and Access Control</a>
 </dt>
 <dt>GRANT role, <a class="indexterm" href="#acc_statements">Statements for
@@ -38767,6 +39486,12 @@ URLIDS='localhostdb1'
 </dt>
 <dt>JOIN with condition, <a class="indexterm" href="#dac_joined_table">Joined Table</a>
 </dt>
+<dt>JSON_ARRAY_AGG function, <a class="indexterm" href="#bfc_JSON_functions">JSON Functions</a>
+</dt>
+<dt>JSON_ARRAY function, <a class="indexterm" href="#bfc_JSON_functions">JSON Functions</a>
+</dt>
+<dt>JSON_OBJECT function, <a class="indexterm" href="#bfc_JSON_functions">JSON Functions</a>
+</dt>
 </dl>
 </div>
 <div class="indexdiv">
@@ -38799,6 +39524,8 @@ URLIDS='localhostdb1'
 </dt>
 <dt>LIKE predicate, <a class="indexterm" href="#dac_sql_predicates">Predicates</a>
 </dt>
+<dt>Listing Users and Roles, <a class="indexterm" href="#acc_listing">Listing Users and Roles</a>
+</dt>
 <dt>LN function, <a class="indexterm" href="#bfc_numeric_functions">Numeric Functions</a>
 </dt>
 <dt>LOAD_FILE function, <a class="indexterm" href="#bfc_general_functions">General Functions</a>
@@ -38919,8 +39646,12 @@ URLIDS='localhostdb1'
 </dt>
 <dt>PERFORM CHECK INDEX, <a class="indexterm" href="#mtc_data_management_statements">Data Management Statements</a>
 </dt>
+<dt>PERFORM EXPORT DSV, <a class="indexterm" href="#mtc_data_management_statements">Data Management Statements</a>
+</dt>
 <dt>PERFORM EXPORT SCRIPT, <a class="indexterm" href="#mtc_data_management_statements">Data Management Statements</a>
 </dt>
+<dt>PERFORM IMPORT DSV file, <a class="indexterm" href="#mtc_data_management_statements">Data Management Statements</a>
+</dt>
 <dt>PERFORM IMPORT SCRIPT, <a class="indexterm" href="#mtc_data_management_statements">Data Management Statements</a>
 </dt>
 <dt>PERIODS, <a class="indexterm" href="#dbc_standard_views_info_schema">SQL Standard Views</a>
@@ -38937,7 +39668,7 @@ URLIDS='localhostdb1'
 </dt>
 <dt>PRIMARY KEY constraint, <a class="indexterm" href="#dbc_table_creation">Table Creation</a>
 </dt>
-<dt>PUBLIC ROLE, <a class="indexterm" href="#acc_built_in_roles_users">Built-In Roles and Users</a>
+<dt>PUBLIC Role, <a class="indexterm" href="#acc_built_in_roles_users">Built-In Roles and Users</a>
 </dt>
 </dl>
 </div>
@@ -38995,7 +39726,7 @@ URLIDS='localhostdb1'
 </dt>
 <dt>REVERSE function, <a class="indexterm" href="#bfc_string_binary_functions">String and Binary String Functions</a>
 </dt>
-<dt>REVOKE, <a class="indexterm" href="#acc_statements">Statements for
+<dt>REVOKE privileges, <a class="indexterm" href="#acc_statements">Statements for
     Authorization and Access Control</a>
 </dt>
 <dt>REVOKE ROLE, <a class="indexterm" href="#acc_statements">Statements for
@@ -39068,7 +39799,7 @@ URLIDS='localhostdb1'
 </dt>
 <dt>SCRIPT, <a class="indexterm" href="#mtc_system_operation_statements">System Operations</a>
 </dt>
-<dt>SCRIPT_OPS, <a class="indexterm" href="#acc_built_in_roles_users">Built-In Roles and Users</a>
+<dt>SCRIPT_OPS Role, <a class="indexterm" href="#acc_built_in_roles_users">Built-In Roles and Users</a>
 </dt>
 <dt>search condition, <a class="indexterm" href="#dac_other_syntax_elements">Other Syntax Elements</a>
 </dt>
@@ -39169,6 +39900,8 @@ URLIDS='localhostdb1'
 </dt>
 <dt>SET DATABASE SQL TRANSLATE TTI TYPES, <a class="indexterm" href="#mtc_sql_settings">SQL Conformance Settings</a>
 </dt>
+<dt>SET DATABASE SQL TRUNCATE TRAILING, <a class="indexterm" href="#mtc_sql_settings">SQL Conformance Settings</a>
+</dt>
 <dt>SET DATABASE SQL TYPES, <a class="indexterm" href="#mtc_sql_settings">SQL Conformance Settings</a>
 </dt>
 <dt>SET DATABASE SQL UNIQUE NULLS, <a class="indexterm" href="#mtc_sql_settings">SQL Conformance Settings</a>
@@ -39267,6 +40000,8 @@ URLIDS='localhostdb1'
 </dt>
 <dt>SIGN function, <a class="indexterm" href="#bfc_numeric_functions">Numeric Functions</a>
 </dt>
+<dt>Simple Data Access Control, <a class="indexterm" href="#N1425C">Simple Access Control</a>
+</dt>
 <dt>SIN function, <a class="indexterm" href="#bfc_numeric_functions">Numeric Functions</a>
 </dt>
 <dt>SINH function, <a class="indexterm" href="#bfc_numeric_functions">Numeric Functions</a>
@@ -39375,8 +40110,6 @@ URLIDS='localhostdb1'
 </dt>
 <dt>SYSTIMESTAMP function, <a class="indexterm" href="#bfc_current_datetime">Functions to Report the Current Datetime</a>
 </dt>
-<dt>SYS USER, <a class="indexterm" href="#acc_built_in_roles_users">Built-In Roles and Users</a>
-</dt>
 </dl>
 </div>
 <div class="indexdiv">
@@ -39550,6 +40283,6 @@ URLIDS='localhostdb1'
 </div>
 </div>
 <HR>
-<P class="svnrev">$Revision: 6369 $</P>
+<P class="svnrev">$Revision: 6474 $</P>
 </body>
 </html>
Binary files 2.6.1-1/hsqldb/doc/guide/guide.pdf and 2.7.0-1/hsqldb/doc/guide/guide.pdf differ
diff -pruN 2.6.1-1/hsqldb/doc/guide/index.html 2.7.0-1/hsqldb/doc/guide/index.html
--- 2.6.1-1/hsqldb/doc/guide/index.html	2021-10-20 09:33:34.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/guide/index.html	2022-07-26 20:21:48.000000000 +0000
@@ -28,7 +28,7 @@
 <a name="guide"></a>HyperSQL User Guide</h1>
 </div>
 <div>
-<h2 class="subtitle">HyperSQL Database Engine 2.6.1</h2>
+<h2 class="subtitle">HyperSQL Database Engine 2.7.0</h2>
 </div>
 <table xmlns:xi="http://www.w3.org/2001/XInclude" class="titlead" cellspacing="0">
 <tr>
@@ -66,7 +66,7 @@
 <div>
 <div class="legalnotice">
 <a name="N1003E"></a>
-<p>Copyright 2002-2021 Blaine Simpson, Fred Toussi and The HSQL
+<p>Copyright 2002-2022 Blaine Simpson, Fred Toussi and The HSQL
       Development Group. Permission is granted to distribute this document
       without any alteration under the terms of the HSQLDB license. You are
       not allowed to distribute or display this document on the web in an
@@ -74,7 +74,7 @@
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </td><td class="sponsorad">
 <div xml:base="../doc-src/branding-frag.xhtml" class="branding">
@@ -201,7 +201,7 @@
 <dd>
 <dl>
 <dt>
-<span class="section"><a href="sqlgeneral-chapt.html#N10485">Case Sensitivity</a></span>
+<span class="section"><a href="sqlgeneral-chapt.html#N1048B">Case Sensitivity</a></span>
 </dt>
 <dt>
 <span class="section"><a href="sqlgeneral-chapt.html#sgc_persist_tables">Persistent Tables</a></span>
@@ -426,6 +426,9 @@
 <span class="section"><a href="builtinfunctions-chapt.html#bfc_string_binary_functions">String and Binary String Functions</a></span>
 </dt>
 <dt>
+<span class="section"><a href="builtinfunctions-chapt.html#bfc_JSON_functions">JSON Functions</a></span>
+</dt>
+<dt>
 <span class="section"><a href="builtinfunctions-chapt.html#bfc_numeric_functions">Numeric Functions</a></span>
 </dt>
 <dt>
@@ -752,6 +755,9 @@
 <span class="section"><a href="accesscontrol-chapt.html#acc_access_rights">Access Rights</a></span>
 </dt>
 <dt>
+<span class="section"><a href="accesscontrol-chapt.html#N1425C">Simple Access Control</a></span>
+</dt>
+<dt>
 <span class="section"><a href="accesscontrol-chapt.html#acc_fine_grained_access">Fine-Grained Data Access Control</a></span>
 </dt>
 </dl>
@@ -1257,7 +1263,7 @@
 <span class="section"><a href="dbproperties-chapt.html#dpc_variables_url">Variables in Connection URL</a></span>
 </dt>
 <dt>
-<span class="section"><a href="dbproperties-chapt.html#N16054">Connection Properties</a></span>
+<span class="section"><a href="dbproperties-chapt.html#N16217">Connection Properties</a></span>
 </dt>
 <dt>
 <span class="section"><a href="dbproperties-chapt.html#dpc_connection_props">Properties for Individual Connections</a></span>
@@ -1534,174 +1540,182 @@
 <dl>
 <dt>1. <a href="book-pref.html#altformats-tbl">Available formats of this document</a>
 </dt>
-<dt>2.1. <a href="sqlgeneral-chapt.html#N10531">List of SQL types</a>
+<dt>2.1. <a href="sqlgeneral-chapt.html#N10537">List of SQL types</a>
 </dt>
-<dt>4.1. <a href="builtinfunctions-chapt.html#N126CE">TO_CHAR, TO_DATE and TO_TIMESTAMP format elements</a>
+<dt>4.1. <a href="builtinfunctions-chapt.html#N127C5">TO_CHAR, TO_DATE and TO_TIMESTAMP format elements</a>
 </dt>
-<dt>14.1. <a href="dbproperties-chapt.html#N15F0F">Memory Database URL</a>
+<dt>14.1. <a href="dbproperties-chapt.html#N160D2">Memory Database URL</a>
 </dt>
-<dt>14.2. <a href="dbproperties-chapt.html#N15F50">File Database URL</a>
+<dt>14.2. <a href="dbproperties-chapt.html#N16113">File Database URL</a>
 </dt>
-<dt>14.3. <a href="dbproperties-chapt.html#N15F96">Resource Database URL</a>
+<dt>14.3. <a href="dbproperties-chapt.html#N16159">Resource Database URL</a>
 </dt>
-<dt>14.4. <a href="dbproperties-chapt.html#N15FCA">Server Database URL</a>
+<dt>14.4. <a href="dbproperties-chapt.html#N1618D">Server Database URL</a>
 </dt>
-<dt>14.5. <a href="dbproperties-chapt.html#N1607B">User and Password</a>
+<dt>14.5. <a href="dbproperties-chapt.html#N16242">User and Password</a>
 </dt>
-<dt>14.6. <a href="dbproperties-chapt.html#N160BC">Creating New Database</a>
+<dt>14.6. <a href="dbproperties-chapt.html#N16283">Closing old ResultSet when Statement is reused</a>
 </dt>
-<dt>14.7. <a href="dbproperties-chapt.html#N1611B">Closing old ResultSet when Statement is reused</a>
+<dt>14.7. <a href="dbproperties-chapt.html#N162CA">Column Names in JDBC ResultSet</a>
 </dt>
-<dt>14.8. <a href="dbproperties-chapt.html#N16162">Column Names in JDBC ResultSet</a>
+<dt>14.8. <a href="dbproperties-chapt.html#N16303">In-memory LOBs from JDBC ResultSet</a>
 </dt>
-<dt>14.9. <a href="dbproperties-chapt.html#N1619B">In-memory LOBs from JDBC ResultSet</a>
+<dt>14.9. <a href="dbproperties-chapt.html#N16334">Empty batch in JDBC PreparedStatement</a>
 </dt>
-<dt>14.10. <a href="dbproperties-chapt.html#N161CC">Empty batch in JDBC PreparedStatement</a>
+<dt>14.10. <a href="dbproperties-chapt.html#N1636A">Automatic Shutdown</a>
 </dt>
-<dt>14.11. <a href="dbproperties-chapt.html#N16202">Automatic Shutdown</a>
+<dt>14.11. <a href="dbproperties-chapt.html#N163A1">OpenOffice and Libre Office usage</a>
 </dt>
-<dt>14.12. <a href="dbproperties-chapt.html#N1626C">Validity Check Property</a>
+<dt>14.12. <a href="dbproperties-chapt.html#N16407">Validity Check Property</a>
 </dt>
-<dt>14.13. <a href="dbproperties-chapt.html#N1629D">Execution of Multiple SQL Statements etc.</a>
+<dt>14.13. <a href="dbproperties-chapt.html#N16434">Creating New Database Check Property</a>
 </dt>
-<dt>14.14. <a href="dbproperties-chapt.html#N162DD">SQL Keyword Use as Identifier</a>
+<dt>14.14. <a href="dbproperties-chapt.html#N16497">Execution of Multiple SQL Statements etc.</a>
 </dt>
-<dt>14.15. <a href="dbproperties-chapt.html#N1630A">SQL Keyword Starting with the Underscore or Containing Dollar
+<dt>14.15. <a href="dbproperties-chapt.html#N164D7">SQL Keyword Use as Identifier</a>
+</dt>
+<dt>14.16. <a href="dbproperties-chapt.html#N16504">SQL Keyword Starting with the Underscore or Containing Dollar
         Characters</a>
 </dt>
-<dt>14.16. <a href="dbproperties-chapt.html#N16337">Reference to Columns Names</a>
+<dt>14.17. <a href="dbproperties-chapt.html#N16531">Reference to Columns Names</a>
+</dt>
+<dt>14.18. <a href="dbproperties-chapt.html#N1655E">String Size Declaration</a>
+</dt>
+<dt>14.19. <a href="dbproperties-chapt.html#N1658B">Truncation of trailing spaces from string</a>
+</dt>
+<dt>14.20. <a href="dbproperties-chapt.html#N165B8">Type Enforcement in Comparison and Assignment</a>
 </dt>
-<dt>14.17. <a href="dbproperties-chapt.html#N16364">String Size Declaration</a>
+<dt>14.21. <a href="dbproperties-chapt.html#N165E5">Foreign Key Triggered Data Change</a>
 </dt>
-<dt>14.18. <a href="dbproperties-chapt.html#N16391">Type Enforcement in Comparison and Assignment</a>
+<dt>14.22. <a href="dbproperties-chapt.html#N16628">Use of LOB for LONGVAR Types</a>
 </dt>
-<dt>14.19. <a href="dbproperties-chapt.html#N163BE">Foreign Key Triggered Data Change</a>
+<dt>14.23. <a href="dbproperties-chapt.html#N16655">Type of string literals in CASE WHEN</a>
 </dt>
-<dt>14.20. <a href="dbproperties-chapt.html#N16401">Use of LOB for LONGVAR Types</a>
+<dt>14.24. <a href="dbproperties-chapt.html#N16682">Concatenation with NULL</a>
 </dt>
-<dt>14.21. <a href="dbproperties-chapt.html#N1642E">Type of string literals in CASE WHEN</a>
+<dt>14.25. <a href="dbproperties-chapt.html#N166AF">NULL in Multi-Column UNIQUE Constraints</a>
 </dt>
-<dt>14.22. <a href="dbproperties-chapt.html#N1645B">Concatenation with NULL</a>
+<dt>14.26. <a href="dbproperties-chapt.html#N166DC">Truncation or Rounding in Type Conversion</a>
 </dt>
-<dt>14.23. <a href="dbproperties-chapt.html#N16488">NULL in Multi-Column UNIQUE Constraints</a>
+<dt>14.27. <a href="dbproperties-chapt.html#N16709">Decimal Scale of Division and AVG Values</a>
 </dt>
-<dt>14.24. <a href="dbproperties-chapt.html#N164B5">Truncation or Rounding in Type Conversion</a>
+<dt>14.28. <a href="dbproperties-chapt.html#N16736">Support for NaN values</a>
 </dt>
-<dt>14.25. <a href="dbproperties-chapt.html#N164E2">Decimal Scale of Division and AVG Values</a>
+<dt>14.29. <a href="dbproperties-chapt.html#N16763">Sort order of NULL values</a>
 </dt>
-<dt>14.26. <a href="dbproperties-chapt.html#N1650F">Support for NaN values</a>
+<dt>14.30. <a href="dbproperties-chapt.html#N16790">Sort order of NULL values with DESC</a>
 </dt>
-<dt>14.27. <a href="dbproperties-chapt.html#N1653C">Sort order of NULL values</a>
+<dt>14.31. <a href="dbproperties-chapt.html#N167C0">String Comparison with Padding</a>
 </dt>
-<dt>14.28. <a href="dbproperties-chapt.html#N16569">Sort order of NULL values with DESC</a>
+<dt>14.32. <a href="dbproperties-chapt.html#N167EF">Default Locale Language Collation</a>
 </dt>
-<dt>14.29. <a href="dbproperties-chapt.html#N16599">String Comparison with Padding</a>
+<dt>14.33. <a href="dbproperties-chapt.html#N1681C">Case-Insensitive Varchar columns</a>
 </dt>
-<dt>14.30. <a href="dbproperties-chapt.html#N165C8">Default Locale Language Collation</a>
+<dt>14.34. <a href="dbproperties-chapt.html#N16849">Lowercase column identifiers in ResultSet</a>
 </dt>
-<dt>14.31. <a href="dbproperties-chapt.html#N165F5">Case-Insensitive Varchar columns</a>
+<dt>14.35. <a href="dbproperties-chapt.html#N16876">Storage of Live Java Objects</a>
 </dt>
-<dt>14.32. <a href="dbproperties-chapt.html#N16622">Lowercase column identifiers in ResultSet</a>
+<dt>14.36. <a href="dbproperties-chapt.html#N168A3">Names of System Indexes Used for Constraints</a>
 </dt>
-<dt>14.33. <a href="dbproperties-chapt.html#N1664F">Storage of Live Java Objects</a>
+<dt>14.37. <a href="dbproperties-chapt.html#N168D2">DB2 Style Syntax</a>
 </dt>
-<dt>14.34. <a href="dbproperties-chapt.html#N1667C">Names of System Indexes Used for Constraints</a>
+<dt>14.38. <a href="dbproperties-chapt.html#N168FE">MSSQL Style Syntax</a>
 </dt>
-<dt>14.35. <a href="dbproperties-chapt.html#N166A9">DB2 Style Syntax</a>
+<dt>14.39. <a href="dbproperties-chapt.html#N1692A">MySQL Style Syntax</a>
 </dt>
-<dt>14.36. <a href="dbproperties-chapt.html#N166D5">MSSQL Style Syntax</a>
+<dt>14.40. <a href="dbproperties-chapt.html#N16957">Oracle Style Syntax</a>
 </dt>
-<dt>14.37. <a href="dbproperties-chapt.html#N16701">MySQL Style Syntax</a>
+<dt>14.41. <a href="dbproperties-chapt.html#N16984">PostgreSQL Style Syntax</a>
 </dt>
-<dt>14.38. <a href="dbproperties-chapt.html#N1672E">Oracle Style Syntax</a>
+<dt>14.42. <a href="dbproperties-chapt.html#N169B0">Maximum Iterations of Recursive Queries</a>
 </dt>
-<dt>14.39. <a href="dbproperties-chapt.html#N1675B">PostgreSQL Style Syntax</a>
+<dt>14.43. <a href="dbproperties-chapt.html#N169E3">Default Table Type</a>
 </dt>
-<dt>14.40. <a href="dbproperties-chapt.html#N1678B">Default Table Type</a>
+<dt>14.44. <a href="dbproperties-chapt.html#N16A13">Transaction Control Mode</a>
 </dt>
-<dt>14.41. <a href="dbproperties-chapt.html#N167BB">Transaction Control Mode</a>
+<dt>14.45. <a href="dbproperties-chapt.html#N16A49">Default Isolation Level for Sessions</a>
 </dt>
-<dt>14.42. <a href="dbproperties-chapt.html#N167F1">Default Isolation Level for Sessions</a>
+<dt>14.46. <a href="dbproperties-chapt.html#N16A7C">Transaction Rollback in Deadlock</a>
 </dt>
-<dt>14.43. <a href="dbproperties-chapt.html#N16824">Transaction Rollback in Deadlock</a>
+<dt>14.47. <a href="dbproperties-chapt.html#N16AA9">Transaction Rollback on Interrupt</a>
 </dt>
-<dt>14.44. <a href="dbproperties-chapt.html#N16851">Transaction Rollback on Interrupt</a>
+<dt>14.48. <a href="dbproperties-chapt.html#N16AD6">Time Zone and Interval Types</a>
 </dt>
-<dt>14.45. <a href="dbproperties-chapt.html#N1687E">Time Zone and Interval Types</a>
+<dt>14.49. <a href="dbproperties-chapt.html#N16B0B">Temporary Result Rows in Memory</a>
 </dt>
-<dt>14.46. <a href="dbproperties-chapt.html#N168B5">Opening Database as Read Only</a>
+<dt>14.50. <a href="dbproperties-chapt.html#N16B3C">Opening Database as Read Only</a>
 </dt>
-<dt>14.47. <a href="dbproperties-chapt.html#N168E5">Opening Database Without Modifying the Files</a>
+<dt>14.51. <a href="dbproperties-chapt.html#N16B6C">Opening Database Without Modifying the Files</a>
 </dt>
-<dt>14.48. <a href="dbproperties-chapt.html#N16915">Huge database files and tables</a>
+<dt>14.52. <a href="dbproperties-chapt.html#N16B9C">Event Logging</a>
 </dt>
-<dt>14.49. <a href="dbproperties-chapt.html#N16945">Event Logging</a>
+<dt>14.53. <a href="dbproperties-chapt.html#N16BCC">SQL Logging</a>
 </dt>
-<dt>14.50. <a href="dbproperties-chapt.html#N16975">SQL Logging</a>
+<dt>14.54. <a href="dbproperties-chapt.html#N16BFC">Table Spaces for Cached Tables</a>
 </dt>
-<dt>14.51. <a href="dbproperties-chapt.html#N169A5">Temporary Result Rows in Memory</a>
+<dt>14.55. <a href="dbproperties-chapt.html#N16C29">Huge database files and tables</a>
 </dt>
-<dt>14.52. <a href="dbproperties-chapt.html#N169D2">Unused Space Recovery</a>
+<dt>14.56. <a href="dbproperties-chapt.html#N16C59">Use of NIO for Disk Table Storage</a>
 </dt>
-<dt>14.53. <a href="dbproperties-chapt.html#N16A04">Rows Cached In Memory</a>
+<dt>14.57. <a href="dbproperties-chapt.html#N16C8C">Use of NIO for Disk Table Storage</a>
 </dt>
-<dt>14.54. <a href="dbproperties-chapt.html#N16A33">Size of Rows Cached in Memory</a>
+<dt>14.58. <a href="dbproperties-chapt.html#N16CB9">Internal Backup of the .data File</a>
 </dt>
-<dt>14.55. <a href="dbproperties-chapt.html#N16A62">Size Scale of Disk Table Storage</a>
+<dt>14.59. <a href="dbproperties-chapt.html#N16CEA">Unused Space Recovery</a>
 </dt>
-<dt>14.56. <a href="dbproperties-chapt.html#N16A8F">Size Scale of LOB Storage</a>
+<dt>14.60. <a href="dbproperties-chapt.html#N16D1E">Rows Cached In Memory</a>
 </dt>
-<dt>14.57. <a href="dbproperties-chapt.html#N16ABC">Compression of BLOB and CLOB data</a>
+<dt>14.61. <a href="dbproperties-chapt.html#N16D4D">Size of Rows Cached in Memory</a>
 </dt>
-<dt>14.58. <a href="dbproperties-chapt.html#N16AE9">Internal Backup of Database Files</a>
+<dt>14.62. <a href="dbproperties-chapt.html#N16D7C">Size Scale of Disk Table Storage</a>
 </dt>
-<dt>14.59. <a href="dbproperties-chapt.html#N16B1A">Use of Lock File</a>
+<dt>14.63. <a href="dbproperties-chapt.html#N16DA9">Size Scale of LOB Storage</a>
 </dt>
-<dt>14.60. <a href="dbproperties-chapt.html#N16B4A">Logging Data Change Statements</a>
+<dt>14.64. <a href="dbproperties-chapt.html#N16DD6">Compression of BLOB and CLOB data</a>
 </dt>
-<dt>14.61. <a href="dbproperties-chapt.html#N16B80">Automatic Checkpoint Frequency</a>
+<dt>14.65. <a href="dbproperties-chapt.html#N16E03">Use of Lock File</a>
 </dt>
-<dt>14.62. <a href="dbproperties-chapt.html#N16BB6">Automatic Defrag at Checkpoint</a>
+<dt>14.66. <a href="dbproperties-chapt.html#N16E33">Logging Data Change Statements</a>
 </dt>
-<dt>14.63. <a href="dbproperties-chapt.html#N16BE3">Compression of the .script file</a>
+<dt>14.67. <a href="dbproperties-chapt.html#N16E69">Automatic Checkpoint Frequency</a>
 </dt>
-<dt>14.64. <a href="dbproperties-chapt.html#N16C13">Logging Data Change Statements Frequency</a>
+<dt>14.68. <a href="dbproperties-chapt.html#N16E9F">Automatic Defrag at Checkpoint</a>
 </dt>
-<dt>14.65. <a href="dbproperties-chapt.html#N16C40">Logging Data Change Statements Frequency</a>
+<dt>14.69. <a href="dbproperties-chapt.html#N16ECC">Compression of the .script file</a>
 </dt>
-<dt>14.66. <a href="dbproperties-chapt.html#N16C6D">Use of NIO for Disk Table Storage</a>
+<dt>14.70. <a href="dbproperties-chapt.html#N16EFC">Logging Data Change Statements Frequency</a>
 </dt>
-<dt>14.67. <a href="dbproperties-chapt.html#N16CA0">Use of NIO for Disk Table Storage</a>
+<dt>14.71. <a href="dbproperties-chapt.html#N16F29">Logging Data Change Statements Frequency</a>
 </dt>
-<dt>14.68. <a href="dbproperties-chapt.html#N16CCD">Recovery Log Processing</a>
+<dt>14.72. <a href="dbproperties-chapt.html#N16F56">Recovery Log Processing</a>
 </dt>
-<dt>14.69. <a href="dbproperties-chapt.html#N16CFA">Default Properties for TEXT Tables</a>
+<dt>14.73. <a href="dbproperties-chapt.html#N16F83">Default Properties for TEXT Tables</a>
 </dt>
-<dt>14.70. <a href="dbproperties-chapt.html#N16D2E">Forcing Garbage Collection</a>
+<dt>14.74. <a href="dbproperties-chapt.html#N16FB7">Forcing Garbage Collection</a>
 </dt>
-<dt>14.71. <a href="dbproperties-chapt.html#N16D5F">Crypt Property For LOBs</a>
+<dt>14.75. <a href="dbproperties-chapt.html#N16FE8">Crypt Property For LOBs</a>
 </dt>
-<dt>14.72. <a href="dbproperties-chapt.html#N16D8C">Cipher Key for Encrypted Database</a>
+<dt>14.76. <a href="dbproperties-chapt.html#N17015">Cipher Key for Encrypted Database</a>
 </dt>
-<dt>14.73. <a href="dbproperties-chapt.html#N16DB9">Cipher Initialization Vector for Encrypted Database</a>
+<dt>14.77. <a href="dbproperties-chapt.html#N17042">Cipher Initialization Vector for Encrypted Database</a>
 </dt>
-<dt>14.74. <a href="dbproperties-chapt.html#N16DE6">Crypt Provider Encrypted Database</a>
+<dt>14.78. <a href="dbproperties-chapt.html#N1706F">Crypt Provider Encrypted Database</a>
 </dt>
-<dt>14.75. <a href="dbproperties-chapt.html#N16E13">Cipher Specification for Encrypted Database</a>
+<dt>14.79. <a href="dbproperties-chapt.html#N1709C">Cipher Specification for Encrypted Database</a>
 </dt>
-<dt>14.76. <a href="dbproperties-chapt.html#N16E4D">Logging Framework</a>
+<dt>14.80. <a href="dbproperties-chapt.html#N170CF">Logging Framework</a>
 </dt>
-<dt>14.77. <a href="dbproperties-chapt.html#N16E77">Text Tables</a>
+<dt>14.81. <a href="dbproperties-chapt.html#N170F9">Text Tables</a>
 </dt>
-<dt>14.78. <a href="dbproperties-chapt.html#N16EA4">Java Functions</a>
+<dt>14.82. <a href="dbproperties-chapt.html#N17126">Java Functions</a>
 </dt>
-<dt>15.1. <a href="listeners-chapt.html#N16F70">common server and webserver properties</a>
+<dt>15.1. <a href="listeners-chapt.html#N171F2">common server and webserver properties</a>
 </dt>
-<dt>15.2. <a href="listeners-chapt.html#N1700D">server properties</a>
+<dt>15.2. <a href="listeners-chapt.html#N1728F">server properties</a>
 </dt>
-<dt>15.3. <a href="listeners-chapt.html#N1703F">webserver properties</a>
+<dt>15.3. <a href="listeners-chapt.html#N172C1">webserver properties</a>
 </dt>
-<dt>17.1. <a href="odbc-chapt.html#N17791">Settings List</a>
+<dt>17.1. <a href="odbc-chapt.html#N17A13">Settings List</a>
 </dt>
 </dl>
 </div>
@@ -1710,100 +1724,100 @@
 <b>List of Examples</b>
 </p>
 <dl>
-<dt>1.1. <a href="running-chapt.html#N10236">Java code to connect to the local hsql Server</a>
+<dt>1.1. <a href="running-chapt.html#N1023C">Java code to connect to the local hsql Server</a>
 </dt>
-<dt>1.2. <a href="running-chapt.html#N10240">Java code to connect to the local http Server</a>
+<dt>1.2. <a href="running-chapt.html#N10246">Java code to connect to the local http Server</a>
 </dt>
-<dt>1.3. <a href="running-chapt.html#N10264">Java code to connect to the local secure SSL hsqls: and
+<dt>1.3. <a href="running-chapt.html#N1026A">Java code to connect to the local secure SSL hsqls: and
           https: Servers</a>
 </dt>
-<dt>1.4. <a href="running-chapt.html#N1030A">specifying a connection property to shutdown the database when
+<dt>1.4. <a href="running-chapt.html#N10310">specifying a connection property to shutdown the database when
         the last connection is closed</a>
 </dt>
-<dt>1.5. <a href="running-chapt.html#N10327">specifying a connection property to disallow creating a new
+<dt>1.5. <a href="running-chapt.html#N1032D">specifying a connection property to disallow creating a new
         database</a>
 </dt>
-<dt>3.1. <a href="databaseobjects-chapt.html#N10C0E">inserting the next sequence value into a table row</a>
+<dt>3.1. <a href="databaseobjects-chapt.html#N10C22">inserting the next sequence value into a table row</a>
 </dt>
-<dt>3.2. <a href="databaseobjects-chapt.html#N10C15">numbering returned rows of a SELECT in sequential order</a>
+<dt>3.2. <a href="databaseobjects-chapt.html#N10C29">numbering returned rows of a SELECT in sequential order</a>
 </dt>
-<dt>3.3. <a href="databaseobjects-chapt.html#N10C21">using the last value of a sequence</a>
+<dt>3.3. <a href="databaseobjects-chapt.html#N10C35">using the last value of a sequence</a>
 </dt>
-<dt>3.4. <a href="databaseobjects-chapt.html#N10CC6">Column values which satisfy a 2-column UNIQUE
+<dt>3.4. <a href="databaseobjects-chapt.html#N10CDA">Column values which satisfy a 2-column UNIQUE
         constraint</a>
 </dt>
-<dt>6.1. <a href="sessions-chapt.html#N13B26">User-defined Session Variables</a>
+<dt>6.1. <a href="sessions-chapt.html#N13C39">User-defined Session Variables</a>
 </dt>
-<dt>6.2. <a href="sessions-chapt.html#N13B3B">User-defined Temporary Session Tables</a>
+<dt>6.2. <a href="sessions-chapt.html#N13C4E">User-defined Temporary Session Tables</a>
 </dt>
-<dt>6.3. <a href="sessions-chapt.html#N13C4E">Setting Transaction Characteristics</a>
+<dt>6.3. <a href="sessions-chapt.html#N13D61">Setting Transaction Characteristics</a>
 </dt>
-<dt>6.4. <a href="sessions-chapt.html#N13C7C">Locking Tables</a>
+<dt>6.4. <a href="sessions-chapt.html#N13D8F">Locking Tables</a>
 </dt>
-<dt>6.5. <a href="sessions-chapt.html#N13CDF">Rollback</a>
+<dt>6.5. <a href="sessions-chapt.html#N13DF2">Rollback</a>
 </dt>
-<dt>6.6. <a href="sessions-chapt.html#N13D11">Setting Session Characteristics</a>
+<dt>6.6. <a href="sessions-chapt.html#N13E24">Setting Session Characteristics</a>
 </dt>
-<dt>6.7. <a href="sessions-chapt.html#N13D27">Setting Session Authorization</a>
+<dt>6.7. <a href="sessions-chapt.html#N13E3A">Setting Session Authorization</a>
 </dt>
-<dt>6.8. <a href="sessions-chapt.html#N13D54">Setting Session Time Zone</a>
+<dt>6.8. <a href="sessions-chapt.html#N13E6B">Setting Session Time Zone</a>
 </dt>
-<dt>11.1. <a href="management-chapt.html#N14D64">Using CACHED tables for the LOB schema</a>
+<dt>11.1. <a href="management-chapt.html#N14EB8">Using CACHED tables for the LOB schema</a>
 </dt>
-<dt>11.2. <a href="management-chapt.html#N14ED7">Creating a system-versioned table</a>
+<dt>11.2. <a href="management-chapt.html#N1502B">Creating a system-versioned table</a>
 </dt>
-<dt>11.3. <a href="management-chapt.html#N14F94">Displaying DbBackup Syntax</a>
+<dt>11.3. <a href="management-chapt.html#N150ED">Displaying DbBackup Syntax</a>
 </dt>
-<dt>11.4. <a href="management-chapt.html#N14F9F">Offline Backup Example</a>
+<dt>11.4. <a href="management-chapt.html#N150F8">Offline Backup Example</a>
 </dt>
-<dt>11.5. <a href="management-chapt.html#N14FC0">Listing a Backup with DbBackup</a>
+<dt>11.5. <a href="management-chapt.html#N15119">Listing a Backup with DbBackup</a>
 </dt>
-<dt>11.6. <a href="management-chapt.html#N14FD7">Restoring a Backup with DbBackup</a>
+<dt>11.6. <a href="management-chapt.html#N15130">Restoring a Backup with DbBackup</a>
 </dt>
-<dt>11.7. <a href="management-chapt.html#N152CE">SQL Log Example</a>
+<dt>11.7. <a href="management-chapt.html#N1545D">SQL Log Example</a>
 </dt>
-<dt>11.8. <a href="management-chapt.html#N15781">Finding foreign key rows with no parents after a bulk
+<dt>11.8. <a href="management-chapt.html#N15937">Finding foreign key rows with no parents after a bulk
         import</a>
 </dt>
-<dt>12.1. <a href="deployment-chapt.html#N15A25">Using CACHED tables for the LOB schema</a>
+<dt>12.1. <a href="deployment-chapt.html#N15BDB">Using CACHED tables for the LOB schema</a>
 </dt>
-<dt>12.2. <a href="deployment-chapt.html#N15B37">MainInvoker Example</a>
+<dt>12.2. <a href="deployment-chapt.html#N15CED">MainInvoker Example</a>
 </dt>
-<dt>12.3. <a href="deployment-chapt.html#N15C9B">Sample Range Ivy Dependency</a>
+<dt>12.3. <a href="deployment-chapt.html#N15E5E">Sample Range Ivy Dependency</a>
 </dt>
-<dt>12.4. <a href="deployment-chapt.html#N15CAD">Sample Range Maven Dependency</a>
+<dt>12.4. <a href="deployment-chapt.html#N15E70">Sample Range Maven Dependency</a>
 </dt>
-<dt>12.5. <a href="deployment-chapt.html#N15CB8">Sample Range Gradle Dependency</a>
+<dt>12.5. <a href="deployment-chapt.html#N15E7B">Sample Range Gradle Dependency</a>
 </dt>
-<dt>12.6. <a href="deployment-chapt.html#N15CD0">Sample Range ivy.xml loaded by Ivyxml plugin</a>
+<dt>12.6. <a href="deployment-chapt.html#N15E93">Sample Range ivy.xml loaded by Ivyxml plugin</a>
 </dt>
-<dt>12.7. <a href="deployment-chapt.html#N15CD5">Sample Range Groovy Dependency, using Grape</a>
+<dt>12.7. <a href="deployment-chapt.html#N15E98">Sample Range Groovy Dependency, using Grape</a>
 </dt>
-<dt>15.1. <a href="listeners-chapt.html#N17165">Exporting certificate from the server's keystore</a>
+<dt>15.1. <a href="listeners-chapt.html#N173E7">Exporting certificate from the server's keystore</a>
 </dt>
-<dt>15.2. <a href="listeners-chapt.html#N17177">Adding a certificate to the client keystore</a>
+<dt>15.2. <a href="listeners-chapt.html#N173F9">Adding a certificate to the client keystore</a>
 </dt>
-<dt>15.3. <a href="listeners-chapt.html#N1718B">Specifying your own trust store to a JDBC client</a>
+<dt>15.3. <a href="listeners-chapt.html#N1740D">Specifying your own trust store to a JDBC client</a>
 </dt>
-<dt>15.4. <a href="listeners-chapt.html#N17206">Getting a pem-style private key into a JKS keystore</a>
+<dt>15.4. <a href="listeners-chapt.html#N17488">Getting a pem-style private key into a JKS keystore</a>
 </dt>
-<dt>15.5. <a href="listeners-chapt.html#N1728F">Validating and Testing an ACL file</a>
+<dt>15.5. <a href="listeners-chapt.html#N17511">Validating and Testing an ACL file</a>
 </dt>
-<dt>16.1. <a href="unix-chapt.html#N17557">example sqltool.rc stanza</a>
+<dt>16.1. <a href="unix-chapt.html#N177D9">example sqltool.rc stanza</a>
 </dt>
-<dt>C.1. <a href="building-app.html#N17C62">Buiding the standard HSQLDB jar file with Ant</a>
+<dt>C.1. <a href="building-app.html#N17EE4">Buiding the standard HSQLDB jar file with Ant</a>
 </dt>
-<dt>C.2. <a href="building-app.html#N17C7B">Example source code before CodeSwitcher is run</a>
+<dt>C.2. <a href="building-app.html#N17EFD">Example source code before CodeSwitcher is run</a>
 </dt>
-<dt>C.3. <a href="building-app.html#N17C82">CodeSwitcher command line invocation</a>
+<dt>C.3. <a href="building-app.html#N17F04">CodeSwitcher command line invocation</a>
 </dt>
-<dt>C.4. <a href="building-app.html#N17C8C">Source code after CodeSwitcher processing</a>
+<dt>C.4. <a href="building-app.html#N17F0E">Source code after CodeSwitcher processing</a>
 </dt>
 </dl>
 </div>
 </div>
 <HR xmlns:xi="http://www.w3.org/2001/XInclude">
-<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6369 $</P>
+<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6474 $</P>
 <div class="navfooter">
 <hr>
 <table summary="Navigation footer" width="100%">
diff -pruN 2.6.1-1/hsqldb/doc/guide/listeners-chapt.html 2.7.0-1/hsqldb/doc/guide/listeners-chapt.html
--- 2.6.1-1/hsqldb/doc/guide/listeners-chapt.html	2021-10-20 09:35:06.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/guide/listeners-chapt.html	2022-07-26 20:23:04.000000000 +0000
@@ -51,12 +51,12 @@
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6271 $</p>
+<p class="releaseinfo">$Revision: 6428 $</p>
 </div>
 <div>
 <div class="legalnotice">
-<a name="N16EF9"></a>
-<p>Copyright 2002-2021 Fred Toussi. Permission is granted to
+<a name="N1717B"></a>
+<p>Copyright 2002-2022 Fred Toussi. Permission is granted to
       distribute this document without any alteration under the terms of the
       HSQLDB license. Additional permission is granted to the HSQL Development
       Group to distribute this document with or without alterations under the
@@ -64,7 +64,7 @@
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -249,7 +249,7 @@
     will work). Supported properties and their default values (if any) are as
     follows:</p>
 <div class="table">
-<a name="N16F70"></a>
+<a name="N171F2"></a>
 <p class="title">
 <b>Table&nbsp;15.1.&nbsp;common server and webserver properties</b>
 </p>
@@ -327,7 +327,7 @@
 <p>Properties or default values specific to
     <code class="filename">server.properties</code> are:</p>
 <div class="table">
-<a name="N1700D"></a>
+<a name="N1728F"></a>
 <p class="title">
 <b>Table&nbsp;15.2.&nbsp;server properties</b>
 </p>
@@ -361,7 +361,7 @@
 <p>Properties or default values specific to
     <code class="filename">webserver.properties</code> are:</p>
 <div class="table">
-<a name="N1703F"></a>
+<a name="N172C1"></a>
 <p class="title">
 <b>Table&nbsp;15.3.&nbsp;webserver properties</b>
 </p>
@@ -578,14 +578,14 @@ Connection c = DriverManager.getConnecti
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6271 $</p>
+<p class="releaseinfo">$Revision: 6428 $</p>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
-<a name="N17124" class="indexterm"></a>
+<a name="N173A6" class="indexterm"></a>
 <p>This section explains how to encrypt the stream between JDBC network
     clients and HyperSQL Listeners. If you are running an
     <em class="glossterm">in-process</em> (non-Listener) setup, this chapter does
@@ -684,7 +684,7 @@ Connection c = DriverManager.getConnecti
 <p>You may already have an X509 cert for your server. If you have a
         server keystore, then you can generate a X509 cert like this. </p>
 <div class="example">
-<a name="N17165"></a>
+<a name="N173E7"></a>
 <p class="title">
 <b>Example&nbsp;15.1.&nbsp;Exporting certificate from the server's keystore</b>
 </p>
@@ -703,7 +703,7 @@ Connection c = DriverManager.getConnecti
         existing keystore, or create a new keystore if
         <code class="filename">client.store</code> doesn't exist.</p>
 <div class="example">
-<a name="N17177"></a>
+<a name="N173F9"></a>
 <p class="title">
 <b>Example&nbsp;15.2.&nbsp;Adding a certificate to the client keystore</b>
 </p>
@@ -727,7 +727,7 @@ Connection c = DriverManager.getConnecti
         <code class="classname">javax.net.ssl.trustStore</code> every time that you
         run your client program. For example </p>
 <div class="example">
-<a name="N1718B"></a>
+<a name="N1740D"></a>
 <p class="title">
 <b>Example&nbsp;15.3.&nbsp;Specifying your own trust store to a JDBC client</b>
 </p>
@@ -845,7 +845,7 @@ Connection c = DriverManager.getConnecti
 <p>Because I have spent a lot of time on this document already, I
         am just giving you an example.</p>
 <div class="example">
-<a name="N17206"></a>
+<a name="N17488"></a>
 <p class="title">
 <b>Example&nbsp;15.4.&nbsp;Getting a pem-style private key into a JKS keystore</b>
 </p>
@@ -909,7 +909,7 @@ Connection c = DriverManager.getConnecti
       file.</p>
 <p>If you are using a private server certificate, make sure to also
       set the trust store filepath for relevant urlids in your RC file, as
-      explained in the sample <a class="link" href="filelinks-app.html#hsqldb.cfg-link">config
+      explained in the sample <a class="link" href="filelinks-app.html#hsqldb.conf-link">config
       file</a>.</p>
 </div>
 </div>
@@ -925,7 +925,7 @@ Connection c = DriverManager.getConnecti
 </div>
 </div>
 </div>
-<a name="N17245" class="indexterm"></a><a name="N17248" class="indexterm"></a>
+<a name="N174C7" class="indexterm"></a><a name="N174CA" class="indexterm"></a>
 <p>JDBC connections will always be denied if the supplied user and
     password are not found in the target catalog. But an HyperSQL listener can
     also restrict access at the listener level, even protecting private
@@ -1021,7 +1021,7 @@ allow 192.168.101.0/24
     copy it to a temporary file and edit the temporary file). Then use the
     <code class="classname">ServerAcl</code> class to test it. </p>
 <div class="example">
-<a name="N1728F"></a>
+<a name="N17511"></a>
 <p class="title">
 <b>Example&nbsp;15.5.&nbsp;Validating and Testing an ACL file</b>
 </p>
@@ -1051,7 +1051,7 @@ allow 192.168.101.0/24
 </div>
 </div>
 <HR xmlns:xi="http://www.w3.org/2001/XInclude">
-<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6369 $</P>
+<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6474 $</P>
 <div class="navfooter">
 <hr>
 <table summary="Navigation footer" width="100%">
diff -pruN 2.6.1-1/hsqldb/doc/guide/lists-app.html 2.7.0-1/hsqldb/doc/guide/lists-app.html
--- 2.6.1-1/hsqldb/doc/guide/lists-app.html	2021-10-20 09:33:34.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/guide/lists-app.html	2022-07-26 20:21:48.000000000 +0000
@@ -50,7 +50,7 @@
 <p class="releaseinfo">$Revision: 847 $</p>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -91,7 +91,7 @@
 <p>All keywords can be used with double quotes as identifiers. For
     example</p>
 <pre class="programlisting">  CREATE TABLE "ALL" ("AND" INT, "WHEN" INT)
-  SELECT "AND" FROM "ALL" WHERE "WHEN" = 2021
+  SELECT "AND" FROM "ALL" WHERE "WHEN" = 2022
 </pre>
 <p>ABS &bull; ALL &bull; ALLOCATE &bull; ALTER &bull; AND &bull; ANY &bull; ARE &bull; ARRAY &bull; AS &bull;
     ASENSITIVE &bull; ASYMMETRIC &bull; AT &bull; ATOMIC &bull; AUTHORIZATION &bull; AVG</p>
@@ -215,7 +215,7 @@
 </div>
 </div>
 <HR xmlns:xi="http://www.w3.org/2001/XInclude">
-<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6369 $</P>
+<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6474 $</P>
 <div class="navfooter">
 <hr>
 <table summary="Navigation footer" width="100%">
diff -pruN 2.6.1-1/hsqldb/doc/guide/management-chapt.html 2.7.0-1/hsqldb/doc/guide/management-chapt.html
--- 2.6.1-1/hsqldb/doc/guide/management-chapt.html	2021-10-20 09:33:34.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/guide/management-chapt.html	2022-07-26 20:21:48.000000000 +0000
@@ -44,12 +44,12 @@
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6366 $</p>
+<p class="releaseinfo">$Revision: 6577 $</p>
 </div>
 <div>
 <div class="legalnotice">
-<a name="N14C95"></a>
-<p>Copyright 2002-2021 Fred Toussi. Permission is granted to
+<a name="N14DE9"></a>
+<p>Copyright 2002-2022 Fred Toussi. Permission is granted to
       distribute this document without any alteration under the terms of the
       HSQLDB license. Additional permission is granted to the HSQL Development
       Group to distribute this document with or without alterations under the
@@ -57,7 +57,7 @@
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -480,7 +480,7 @@
       becomes an issue, you can change one or all LOB schema tables to CACHED
       tables. See statements below:</p>
 <div class="example">
-<a name="N14D64"></a>
+<a name="N14EB8"></a>
 <p class="title">
 <b>Example&nbsp;11.1.&nbsp;Using CACHED tables for the LOB schema</b>
 </p>
@@ -550,14 +550,14 @@
     and FOREIGN KEY constraints: a unique index is created for each PRIMARY
     KEY or UNIQUE constraint; a non-unique index is created for each FOREIGN
     KEY constraint.</p>
-<p>From version 2.6.0, you can extend the non-unique index for a
-    FORIEGN KEY constraint to cover extra columns. For example, if you have a
-    FOREIGN KEY constraint defined on
-    <code class="literal">INVOICES(CUSTOMER_ID)</code>, you can add an extra column such
-    as <code class="literal">INVOICE_DATE</code> to the FOREIGN KEY index. This speeds
-    up queries with conditions such as: <code class="literal">WHERE customer_id = 456 and
-    invoice_date = '2020-02-02</code>. See the ALTER CONSTRAINT statement
-    for syntax.</p>
+<p>From version 2.6, you can extend the non-unique index for a FORIEGN
+    KEY constraint to cover extra columns. For example, if you have a FOREIGN
+    KEY constraint defined on <code class="literal">INVOICES(CUSTOMER_ID)</code>, you
+    can add an extra column such as <code class="literal">INVOICE_DATE</code> to the
+    FOREIGN KEY index. This speeds up queries with conditions such as:
+    <code class="literal">WHERE customer_id = 456 and invoice_date =
+    '2020-02-02'</code>. See the ALTER CONSTRAINT statement for
+    syntax.</p>
 <p>HyperSQL allows you to define indexes on single or multiple columns
     with the CREATE INDEX statement. You should not create duplicate indexes
     on the same column sets covered by constraints. This will result in
@@ -932,7 +932,7 @@
 </div>
 </div>
 </div>
-<a name="N14EAF" class="indexterm"></a>
+<a name="N15003" class="indexterm"></a>
 <p>HyperSQL 2.5 and later allows you to store data in temporal
     system-versioned tables. The additional syntax elements for CREATE TABLE
     and ALTER TABLE allow creating system-versioned tables and adding system
@@ -973,7 +973,7 @@
     chapter.</p>
 <p>An example of a system-versioned table follows:</p>
 <div class="example">
-<a name="N14ED7"></a>
+<a name="N1502B"></a>
 <p class="title">
 <b>Example&nbsp;11.2.&nbsp;Creating a system-versioned table</b>
 </p>
@@ -1000,7 +1000,7 @@
 </div>
 </div>
 </div>
-<a name="N14EE0" class="indexterm"></a>
+<a name="N15034" class="indexterm"></a>
 <p>Replicated databases are databases with multiple copies in different
     locations that contain the same table structure and data. With
     system-versioned tables, a set of replicas can be synchronized.</p>
@@ -1016,7 +1016,7 @@
     longer to import.</p>
 <div class="informalexample">
 <pre class="programlisting"> -- on one replica, the changes from the given UTC timestamp are exported to a file 
- PERFORM EXPORT SCRIPT FOR DATABASE VERSIONING DATA FROM '2021-03-21 08:00:00' TO '/data/diff_file'
+ PERFORM EXPORT SCRIPT FOR DATABASE VERSIONING DATA FROM '2022-03-21 08:00:00' TO '/data/diff_file'
   
  -- on another replica, the diff file is imported and the changes are merged into the database
  PERFORM IMPORT SCRIPT VERSIONING DATA FROM '/data/diff_file'
@@ -1041,7 +1041,7 @@
 </div>
 </div>
 </div>
-<a name="N14EF4" class="indexterm"></a>
+<a name="N15048" class="indexterm"></a>
 <p>Data for all CACHED tables is stored in the <code class="literal">.data</code>
     file. With a new recommended setting, HyperSQL 2.5 and later allocates
     separate blocks of the data file to different CACHED tables. This is
@@ -1069,6 +1069,12 @@
 <p>
 <code class="literal">SET FILES SPACE TRUE </code>
 </p>
+<p>The alternative is to include the corresponding connection property
+    on the JDBC connection URL that creates the database. For example:</p>
+<p>
+<code class="literal">jdbc:hsqldb:file:&lt;database
+    path&gt;;hsqldb.files_space=true</code>
+</p>
 <p>Then the statement below should be executed for each CACHED table
     that will have its own space:</p>
 <p>
@@ -1102,12 +1108,12 @@
     the <code class="code">SET FILES SPACE TRUE</code> command is executed when there are
     already some rows in any CACHED table, the change does not happen
     immediately. In this case, the table spaces are created only when
-    CHCKPOINT DEFRAG, SHUTDOWN COMPACT or SHUTDOWN SCRIPT is executed. Among
+    CHECKPOINT DEFRAG, SHUTDOWN COMPACT, or SHUTDOWN SCRIPT is executed. Among
     these commands, CHECKPOINT DEFRAG will also automatically allocate a
     separate space to each table that is larger than a certain size.</p>
-<p>In a database with table spaces, the <code class="code">SET TABLE &lt;table
-    name&gt; NEW SPACE</code> command immediately applies a separate space to
-    the table.</p>
+<p>In a database with table spaces enabled, the <code class="code">SET TABLE
+    &lt;table name&gt; NEW SPACE</code> command immediately applies a separate
+    space to the table, whether it is empty or has data..</p>
 </div>
 <div class="section">
 <div class="titlepage">
@@ -1119,11 +1125,11 @@
 </div>
 </div>
 <p>
-<a name="N14F39" class="indexterm"></a>
+<a name="N15092" class="indexterm"></a>
 </p>
-<p>From version 2.5.1, the integrity of the indexes and table data can
-    be checked with a command. This applies to CACHED tables only. Individual
-    tables or all tables can be checked.</p>
+<p>The integrity of the indexes and table data can be checked with a
+    statement. This applies to CACHED tables only. Individual tables or all
+    tables can be checked.</p>
 <div class="informalexample">
 <pre class="programlisting"> PERFORM CHECK TABLE PUBLIC.CUSTOMER INDEX [ AND FIX ]</pre>
 </div>
@@ -1149,7 +1155,7 @@
 </div>
 </div>
 </div>
-<a name="N14F50" class="indexterm"></a>
+<a name="N150A9" class="indexterm"></a>
 <p>The database engine saves the files containing all the data in a
     file catalog when a shutdown takes place. It automatically recovers from
     an abnormal termination and preserves the data when the catalog is opened
@@ -1219,7 +1225,7 @@
       command-line to make offline backups and to restore backups. Here is how
       to see all options for <code class="classname">DbBackup</code>. </p>
 <div class="example">
-<a name="N14F94"></a>
+<a name="N150ED"></a>
 <p class="title">
 <b>Example&nbsp;11.3.&nbsp;Displaying DbBackup Syntax</b>
 </p>
@@ -1245,7 +1251,7 @@
       database is named dbname and is in the dbdir directory. The backup is
       saved to a file named backup.tar in the tardir directory.</p>
 <div class="example">
-<a name="N14F9F"></a>
+<a name="N150F8"></a>
 <p class="title">
 <b>Example&nbsp;11.4.&nbsp;Offline Backup Example</b>
 </p>
@@ -1275,7 +1281,7 @@
       or with any Pax-compliant tar or pax client (this includes GNU tar),
       </p>
 <div class="example">
-<a name="N14FC0"></a>
+<a name="N15119"></a>
 <p class="title">
 <b>Example&nbsp;11.5.&nbsp;Listing a Backup with DbBackup</b>
 </p>
@@ -1305,7 +1311,7 @@
 <p>You use <code class="classname">DbBackup</code> on your operating system
       command line to restore a catalog from a backup. </p>
 <div class="example">
-<a name="N14FD7"></a>
+<a name="N15130"></a>
 <p class="title">
 <b>Example&nbsp;11.6.&nbsp;Restoring a Backup with DbBackup</b>
 </p>
@@ -1401,8 +1407,8 @@
       production. Create your own random values.</p>
 <p>The files that are encrypted include the
       <code class="literal">.script</code>, <code class="literal">.data</code>,
-      <code class="literal">.backup</code> and <code class="literal">.log</code> files. In version
-      2.5 and later, the <code class="literal">.lobs</code> file is also encrypted by
+      <code class="literal">.backup</code> and <code class="literal">.log</code> files. From
+      version 2.5, the <code class="literal">.lobs</code> file is also encrypted by
       default and the blobs and clobs are both compressed and encrypted. You
       can override this with the property <code class="literal">crypt_lobs=false</code>
       on the URL. Earlier versions of HSQLDB did not support encrypted lobs,
@@ -1515,7 +1521,7 @@
       be enabled with the <code class="literal">SET DATABASE EVENT LOG SQL LEVEL</code>
       statement, described in this chapter. As all the executed statements are
       logged, there is a small impact on speed. So you should only use this
-      for debugging. Two levels of SQL logging are supported.</p>
+      for debugging. Four levels of SQL logging are supported.</p>
 </div>
 <div class="section">
 <div class="titlepage">
@@ -1557,11 +1563,14 @@
       the unique id (a 16 character string) of the database that generated the
       message, so they can be identified in a multi-database server
       context.</p>
+<p>The extent of logged messages is controlled with the <code class="literal">SET
+      DATABASE EXTERNAL EVENT LOG LEVEL</code> statement, described in this
+      chapter.</p>
 <p>As the default JDK logging framework has several shortcomings,
-      HyperSQL configures this logging framework for better operation. If you
-      do not want HyperSQL to configure the JDK logging framework, you should
+      HyperSQL can configures this logging framework for better operation. If
+      you want HyperSQL to configure the JDK logging framework, you should
       include the system level property
-      <code class="literal">hsqldb.reconfig_logging=false</code> in your
+      <code class="literal">hsqldb.reconfig_logging=true</code> in your
       environment.</p>
 </div>
 <div class="section">
@@ -1739,7 +1748,7 @@
       password authentication. Each user is created with a password, which is
       stored as a hash in the database and checked each time a new database
       connection is created.</p>
-<a name="N150DD" class="indexterm"></a>
+<a name="N1523B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>Password Complexity
       Check</strong></span>
@@ -1749,7 +1758,7 @@
       the database. Each time a user connects, the user's name and password
       are checked against the stored list of users and passwords. The
       connection attempt is rejected if there is no match.</p>
-<a name="N150E8" class="indexterm"></a>
+<a name="N15246" class="indexterm"></a>
 <p>
 <span class="bold"><strong>External
       Authentication</strong></span>
@@ -1788,7 +1797,7 @@
 </div>
 </div>
 <p>These statements perform a system level action.</p>
-<a name="N15105" class="indexterm"></a>
+<a name="N15263" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SHUTDOWN</strong></span>
 </p>
@@ -1872,7 +1881,7 @@
 </div>
 <p>Only a user with the DBA role can execute this
       statement.</p>
-<a name="N15145" class="indexterm"></a>
+<a name="N152A3" class="indexterm"></a>
 <p>
 <span class="bold"><strong>BACKUP DATABASE</strong></span>
 </p>
@@ -1930,7 +1939,7 @@
       chapter under Backing up Database Catalogs.</p>
 <p>Only a user with the DBA role can execute this
       statement.</p>
-<a name="N15185" class="indexterm"></a>
+<a name="N152E3" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CHECKPOINT</strong></span>
 </p>
@@ -1953,7 +1962,7 @@
       sessions.</p>
 <p>Only a user with the DBA role can execute this
       statement.</p>
-<a name="N151A5" class="indexterm"></a>
+<a name="N15303" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SCRIPT</strong></span>
 </p>
@@ -1988,7 +1997,7 @@
 <p>These statements allow data to be transferred in bulk from one
       database to another using files formatted in the same manner as the
       <code class="literal">.script</code> files.</p>
-<a name="N151C7" class="indexterm"></a>
+<a name="N15325" class="indexterm"></a>
 <p>
 <span class="bold"><strong>EXPORT SCRIPT</strong></span>
 </p>
@@ -2032,7 +2041,26 @@
       to allow synchronization across time zones.</p>
 <p>Only a user with the SCRIPT_OPS role can execute this
       statement.</p>
-<a name="N151EC" class="indexterm"></a>
+<a name="N1534A" class="indexterm"></a>
+<p>
+<span class="bold"><strong>EXPORT DSV</strong></span>
+</p>
+<p>
+<span class="emphasis"><em>export DSV statement</em></span>
+</p>
+<p>
+<code class="literal">&lt;export DSV statement&gt; ::= PERFORM EXPORT DATA
+      FROM TABLE &lt;table name&gt; TO &lt;single-quouted text file source
+      string&gt;</code>
+</p>
+<p>Writes the contents of a table as a DSV file, for example as a
+      Comma-Seperated Values (CSV).</p>
+<p>The destination is defined as a file path together with
+      optional setting as defined for a TEXT table. See the Text Tables
+      chapter for the properties.</p>
+<p>Only a user with the SCRIPT_OPS role can execute this
+      statement.</p>
+<a name="N1535F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>IMPORT SCRIPT</strong></span>
 </p>
@@ -2073,7 +2101,37 @@
       the <code class="literal">.reject</code> file.</p>
 <p>Only a user with the SCRIPT_OPS role can execute this
       statement.</p>
-<a name="N1520C" class="indexterm"></a>
+<a name="N1537F" class="indexterm"></a>
+<p>
+<span class="bold"><strong>IMPORT DSV</strong></span>
+</p>
+<p>
+<span class="emphasis"><em>import DSV statement</em></span>
+</p>
+<p>
+<code class="literal">&lt;import DSV statement&gt; ::= PERFORM IMPORT DATA
+      INTO &lt;table name&gt; FROM &lt;single-quoted file path&gt; { CONTINUE
+      | STOP | CHECK } ON ERROR</code>
+</p>
+<p>Imports data from a DSV file into a table. The file to be
+      imported may be a file exported with the EXPORT DSV statement listed
+      above, or a file from another source. The source is defined as a file
+      path together with optional setting as defined for a TEXT table. See the
+      Text Tables chapter for the properties.</p>
+<p>The { CONTINUE | STOP | CHECK } ON ERROR clause determines the
+      action when an error occurs due to constraint violation. The CHECK
+      option does not insert the data, but checks each line of data in the DSV
+      file for type constraints such as string size limit or row constraints
+      such as NOT NULL. It cannot check for UNIQUE constraints. The STOP
+      option stops the import at the first error. The CONTINUE option writes
+      the rows that cannot be imported, to a file in the same location as the
+      imported script, with the file suffix <code class="literal">.reject</code> and the
+      timestamp of the import, then continues the import. If there is a
+      malformed line in the DSV file, the import is aborted with an error
+      message, regardless of the ON ERROR option.</p>
+<p>Only a user with the SCRIPT_OPS role can execute this
+      statement.</p>
+<a name="N15397" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CHECK INDEX</strong></span>
 </p>
@@ -2115,7 +2173,7 @@
 </div>
 </div>
 <p>These statements change the database settings.</p>
-<a name="N1522D" class="indexterm"></a>
+<a name="N153B8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE
       COLLATION</strong></span>
@@ -2154,7 +2212,7 @@
  -- this collation is case-sensitive French
  SET DATABASE COLLATION "French 2"  </pre>
 </div>
-<a name="N1525A" class="indexterm"></a>
+<a name="N153E5" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE DEFAULT RESULT MEMORY
       ROWS</strong></span>
@@ -2180,7 +2238,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.result_max_memory_rows</code>.</p>
-<a name="N1527C" class="indexterm"></a>
+<a name="N15407" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE DEFAULT TABLE
       TYPE</strong></span>
@@ -2199,7 +2257,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.default_table_type</code>.</p>
-<a name="N15296" class="indexterm"></a>
+<a name="N15421" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE EVENT LOG
       LEVEL</strong></span>
@@ -2210,30 +2268,41 @@
 </p>
 <p>
 <code class="literal">&lt;set database event log level&gt; ::= SET DATABASE
-      EVENT LOG [ SQL ] LEVEL { 0 | 1 | 2 | 3 }</code>
+      [EXTERNAL] EVENT LOG [ SQL ] LEVEL { 0 | 1 | 2 | 3 |
+      4}</code>
 </p>
-<p>When the SQL option is not used, this statement sets the amount
-      of information logged in the internal, database-specific event log.
-      Level 0 means no log. Level 1 means only important (error) events. Level
-      2 means more events, including both important and less important
-      (normal) events. Level 3 includes even more details. For readonly and
-      <em class="glossterm">mem:</em> databases, if the level is set above 0, the
-      log messages are directed to stderr.</p>
+<p>This statement has 3 different purposes and can be used up to
+      three times with different options to configure various event logging
+      operations.</p>
+<p>When the EXTERNAL and SQL options are not used, this statement
+      sets the amount of information logged in the internal, database-specific
+      event log. Level 0 means no log. Level 1 means only important (error)
+      events. Level 2 means warning events as well. Level 3 means more events,
+      including both important and less important (normal) events. Level 4
+      includes even more details.</p>
 <p>The events are logged in a file with the extension
-      <code class="literal">.app.log</code> alongside the main database files.</p>
-<p>This is equivalent to the connection property
+      <code class="literal">.app.log</code> alongside the main database files. For
+      readonly and <em class="glossterm">mem:</em> databases, if the level is set
+      above 0, the log messages are directed to stderr, but these databases do
+      not generate many log messages.</p>
+<p>This command is equivalent to the connection property
       <code class="literal">hsqldb.applog</code>.</p>
+<p>When the EXTERNAL option is used (the SQL option is not allowed
+      in this case), the statement configures the level of events that are
+      logged to the JDK or Log4J logger. For example, LEVEL 2 indicates error
+      and warning events (levels 1 and 2) are logged.</p>
 <p>When the SQL option is used, this statement logs the SQL
       statements as they are executed. Each log line contains the timestamp
       and the session number, followed by the SQL statement and JDBC arguments
       if any.</p>
-<p>Levels 1, 2 and 3 are supported. Level 1 only logs commits and
-      rollbacks, while Level 2 and 3 log all statements. Level 2 truncates
+<p>Levels 1, 2, 3 and 4 are supported. Level 1 only logs commits
+      and rollbacks. Level 2 and above log all statements. Level 2 truncates
       long statements, while level 3 reports the full statement and parameter
-      values.</p>
+      values. Level 4 add the update count or the size of the returned result
+      set.</p>
 <p>The logged lines are stored in a file with the extension
       <code class="literal">.sql.log</code> alongside the main database files.</p>
-<p>This is equivalent to the connection property
+<p>This command is equivalent to the connection property
       <code class="literal">hsqldb.sqllog</code>.</p>
 <p>Only a user with the DBA role can execute this
       statement.</p>
@@ -2246,12 +2315,12 @@
       number. The values for prepared statement parameters are shown in
       parentheses at the end of the statement.</p>
 <div class="example">
-<a name="N152CE"></a>
+<a name="N1545D"></a>
 <p class="title">
 <b>Example&nbsp;11.7.&nbsp;SQL Log Example</b>
 </p>
 <div class="example-contents">
-<pre class="screen"> 2012-11-29 10:40:40.250 10 INSERT INTO TEST_CLOB VALUES (1,'Ut wisi enim ad minim veniam, quis nostrud exerci') 
+<pre class="screen"> 2012-11-29 10:40:40.250 10 INSERT INTO TEST_CLOB VALUES (1,'Ut enim ad minima veniam, quis nostrum exercitationem ...') 
  2012-11-29 10:40:40.250 1 INSERT INTO SYSTEM_LOBS.LOB_IDS VALUES(?, ?, ?, ?) (1,49,0,40)
  2012-11-29 10:40:40.250 1 COMMIT 
  2012-11-29 10:40:40.265 1 CALL SYSTEM_LOBS.ALLOC_BLOCKS(?, ?, ?) (1,0,1)
@@ -2260,7 +2329,7 @@
 </div>
 </div>
 <br class="example-break">
-<a name="N152D3" class="indexterm"></a>
+<a name="N15462" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE GC</strong></span>
 </p>
@@ -2271,12 +2340,12 @@
 <code class="literal">&lt;set database gc statement&gt; ::= SET DATABASE GC
       &lt;unsigned integer literal&gt;</code>
 </p>
-<p>In previous versions an optional property which forced calls to
-      <code class="literal">System.gc() </code>after the specified number of row
-      operations. This has no effect from version 2.5.0.</p>
+<p>In previous versions, an optional property which forced calls
+      to <code class="literal">System.gc() </code>after the specified number of row
+      operations. This has no effect from version 2.5.</p>
 <p>Only a user with the DBA role can execute this
       statement.</p>
-<a name="N152E9" class="indexterm"></a>
+<a name="N15478" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE TEXT TABLE
       DEFAULTS</strong></span>
@@ -2297,7 +2366,7 @@
       chapter.</p>
 <p>Only a user with the DBA role can execute this
       statement.</p>
-<a name="N15300" class="indexterm"></a>
+<a name="N1548F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE TRANSACTION
       CONTROL</strong></span>
@@ -2318,7 +2387,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.tx</code>.</p>
-<a name="N1531C" class="indexterm"></a>
+<a name="N154AB" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE TRANSACTION ROLLBACK ON
       CONFLICT</strong></span>
@@ -2345,7 +2414,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.tx_conflict_rollback</code>.</p>
-<a name="N15338" class="indexterm"></a>
+<a name="N154C7" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE TRANSACTION ROLLBACK ON
       INTERRUPT</strong></span>
@@ -2368,7 +2437,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.tx_conflict_rollback</code>.</p>
-<a name="N15354" class="indexterm"></a>
+<a name="N154E3" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE DEFAULT ISOLATION
       LEVEL</strong></span>
@@ -2389,7 +2458,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.tx_level</code>.</p>
-<a name="N1536E" class="indexterm"></a>
+<a name="N154FD" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE UNIQUE
       NAME</strong></span>
@@ -2410,7 +2479,7 @@
       spaces.</p>
 <p>Only a user with the DBA role can execute this
       statement.</p>
-<a name="N15383" class="indexterm"></a>
+<a name="N15512" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET TABLE TYPE</strong></span>
 </p>
@@ -2446,7 +2515,7 @@
       as it is practical, it is best to set the non-conforming defaults to
       TRUE in order to improve the quality of the database
       application.</p>
-<a name="N1539C" class="indexterm"></a>
+<a name="N1552B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL RESTRICT
       EXEC</strong></span>
@@ -2471,7 +2540,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.restrict_exec</code>.</p>
-<a name="N153BC" class="indexterm"></a>
+<a name="N1554B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL
       SIZE</strong></span>
@@ -2492,7 +2561,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.enforce_size</code>.</p>
-<a name="N153DC" class="indexterm"></a>
+<a name="N1556B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL
       NAMES</strong></span>
@@ -2516,7 +2585,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.enforce_names</code>.</p>
-<a name="N153FB" class="indexterm"></a>
+<a name="N1558A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL REGULAR
       NAMES</strong></span>
@@ -2542,7 +2611,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.regular_names</code>.</p>
-<a name="N15418" class="indexterm"></a>
+<a name="N155A7" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL
       REFERENCES</strong></span>
@@ -2569,7 +2638,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.enforce_refs</code>.</p>
-<a name="N1543A" class="indexterm"></a>
+<a name="N155C9" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL
       TYPES</strong></span>
@@ -2596,7 +2665,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.enforce_type</code>.</p>
-<a name="N1545E" class="indexterm"></a>
+<a name="N155ED" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL TDC
       DELETE</strong></span>
@@ -2624,7 +2693,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.enforce_tdc_delete</code>.</p>
-<a name="N1547F" class="indexterm"></a>
+<a name="N1560E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL TDC
       UPDATE</strong></span>
@@ -2652,7 +2721,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.enforce_tdc_update</code>.</p>
-<a name="N154A1" class="indexterm"></a>
+<a name="N15630" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL TRANSLATE TTI
       TYPES</strong></span>
@@ -2683,7 +2752,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">jdbc.translate_tti_types</code>.</p>
-<a name="N154C9" class="indexterm"></a>
+<a name="N15658" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL CHARACTER
       LITERAL</strong></span>
@@ -2711,7 +2780,34 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.char_literal</code>.</p>
-<a name="N154FF" class="indexterm"></a>
+<a name="N1568E" class="indexterm"></a>
+<p>
+<span class="bold"><strong>SET DATABASE SQL TRUNCATE
+      TRAILING</strong></span>
+</p>
+<p>
+<span class="emphasis"><em>set database sql truncate
+      trailing</em></span>
+</p>
+<p>
+<code class="literal">&lt;set database sql truncate trailing&gt; ::= SET
+      DATABASE SQL TRUNCATE TRAILING { TRUE | FALSE }</code>
+</p>
+<p>By default, this property is <code class="literal">TRUE</code>, Whan a
+      string that is longer than the maximum size of a column is inserted,
+      spaces at the end are removed to reduce the length of the string to the
+      maximum size of the column. If this is not possible, an exception is
+      raised.</p>
+<p>When the property is set to <code class="literal">FALSE</code>, no
+      truncation take place and an exception is always raised. This behaviour
+      is common to some other database engines.</p>
+<p>SQL Standard requires the default behaviour.</p>
+<p>The property is <code class="literal">TRUE</code> by default.</p>
+<p>Only a user with the DBA role can execute this
+      statement.</p>
+<p>This is equivalent to the connection property
+      <code class="literal">sql.truncate_trailing</code>.</p>
+<a name="N156B5" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL CONCAT
       NULLS</strong></span>
@@ -2736,7 +2832,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.concat_nulls</code>.</p>
-<a name="N15529" class="indexterm"></a>
+<a name="N156DF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL UNIQUE
       NULLS</strong></span>
@@ -2766,7 +2862,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.unique_nulls</code>.</p>
-<a name="N15559" class="indexterm"></a>
+<a name="N1570F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL CONVERT
       TRUNCATE</strong></span>
@@ -2794,7 +2890,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.convert_trunc</code>.</p>
-<a name="N15581" class="indexterm"></a>
+<a name="N15737" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL AVG
       SCALE</strong></span>
@@ -2820,7 +2916,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.avg_scale</code>.</p>
-<a name="N155A0" class="indexterm"></a>
+<a name="N15756" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL DOUBLE
       NAN</strong></span>
@@ -2843,7 +2939,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.double_nan</code>.</p>
-<a name="N155CE" class="indexterm"></a>
+<a name="N15784" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL NULLS
       FIRST</strong></span>
@@ -2864,7 +2960,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.nulls_first</code>.</p>
-<a name="N155EE" class="indexterm"></a>
+<a name="N157A4" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL NULLS
       ORDER</strong></span>
@@ -2891,7 +2987,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.nulls_order</code>.</p>
-<a name="N15615" class="indexterm"></a>
+<a name="N157CB" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL
       IGNORECASE</strong></span>
@@ -2917,7 +3013,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.ignore_case</code>.</p>
-<a name="N15643" class="indexterm"></a>
+<a name="N157F9" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL LOWER CASE
       IDENTIFIER</strong></span>
@@ -2932,10 +3028,10 @@
 </p>
 <p>This property is <code class="literal">FALSE</code> by default and should
       only be used in special circumstances where additional compatibility
-      MySQL or PostgreSQL is required.</p>
+      with MySQL or PostgreSQL is required.</p>
 <p>When the property is <code class="literal">TRUE</code>, the names of
       column, tables and schemas are returned from JDBC ResultSetMetaData
-      methods in lowercase instead of uppercase if the database objects where
+      methods in lowercase instead of uppercase if the database objects were
       created as unquoted identifiers. Quoted identifier names are still
       returned in the original case.</p>
 <p>The property is <code class="literal">FALSE</code> by default.</p>
@@ -2943,7 +3039,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.lowercase_ident</code>.</p>
-<a name="N15668" class="indexterm"></a>
+<a name="N1581E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL LIVE
       OBJECT</strong></span>
@@ -2963,7 +3059,7 @@
       all.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.live_object</code>.</p>
-<a name="N1568F" class="indexterm"></a>
+<a name="N15845" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL SYS INDEX
       NAMES</strong></span>
@@ -2989,7 +3085,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.sys_index_names</code>.</p>
-<a name="N156AE" class="indexterm"></a>
+<a name="N15864" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL SYNTAX
       DB2</strong></span>
@@ -3014,7 +3110,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.syntax_db2</code>.</p>
-<a name="N156D1" class="indexterm"></a>
+<a name="N15887" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL SYNTAX
       MSS</strong></span>
@@ -3037,7 +3133,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.syntax_mss</code>.</p>
-<a name="N156F4" class="indexterm"></a>
+<a name="N158AA" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL SYNTAX
       MYS</strong></span>
@@ -3065,7 +3161,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.syntax_mys</code>.</p>
-<a name="N1571B" class="indexterm"></a>
+<a name="N158D1" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL SYNTAX
       ORA</strong></span>
@@ -3091,7 +3187,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.syntax_ora</code>.</p>
-<a name="N1573A" class="indexterm"></a>
+<a name="N158F0" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE SQL SYNTAX
       PGS</strong></span>
@@ -3120,7 +3216,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">sql.syntax_pgs</code>.</p>
-<a name="N1576A" class="indexterm"></a>
+<a name="N15920" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE REFERENTIAL
       INTEGRITY</strong></span>
@@ -3148,7 +3244,7 @@
 <p>A query example to return the rows in a foreign key table that
       have no parent is given below:</p>
 <div class="example">
-<a name="N15781"></a>
+<a name="N15937"></a>
 <p class="title">
 <b>Example&nbsp;11.8.&nbsp;Finding foreign key rows with no parents after a bulk
         import</b>
@@ -3173,7 +3269,7 @@
 </div>
 <p>These statements control the memory and other settings for
       database persistence.</p>
-<a name="N1578E" class="indexterm"></a>
+<a name="N15944" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET FILES BACKUP INCREMENT
       </strong></span>
@@ -3198,7 +3294,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.inc_backup</code>.</p>
-<a name="N157B1" class="indexterm"></a>
+<a name="N15967" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET FILES CACHE ROWS</strong></span>
 </p>
@@ -3216,7 +3312,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.cache_rows</code>.</p>
-<a name="N157CB" class="indexterm"></a>
+<a name="N15981" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET FILES CACHE SIZE</strong></span>
 </p>
@@ -3236,7 +3332,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.cache_size</code>.</p>
-<a name="N157E5" class="indexterm"></a>
+<a name="N1599B" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET FILES DEFRAG</strong></span>
 </p>
@@ -3265,7 +3361,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.defrag_limit</code>.</p>
-<a name="N1580B" class="indexterm"></a>
+<a name="N159C1" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET FILES LOG</strong></span>
 </p>
@@ -3283,7 +3379,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.log_data</code>.</p>
-<a name="N15823" class="indexterm"></a>
+<a name="N159D9" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET FILES LOG SIZE</strong></span>
 </p>
@@ -3303,7 +3399,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.log_size</code>.</p>
-<a name="N15841" class="indexterm"></a>
+<a name="N159F7" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET FILES NIO</strong></span>
 </p>
@@ -3321,7 +3417,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.nio_data_file</code>.</p>
-<a name="N1585C" class="indexterm"></a>
+<a name="N15A12" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET FILES NIO SIZE</strong></span>
 </p>
@@ -3340,7 +3436,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.nio_max_size</code>.</p>
-<a name="N15874" class="indexterm"></a>
+<a name="N15A2A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET FILES WRITE
       DELAY</strong></span>
@@ -3373,7 +3469,7 @@
 <p>This is equivalent to the connection properties
       <code class="literal">hsqldb.write_delay</code> and
       <code class="literal">hsqldb.write_delay_millis</code>.</p>
-<a name="N15897" class="indexterm"></a>
+<a name="N15A4D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET FILES SCALE</strong></span>
 </p>
@@ -3405,7 +3501,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.cache_file_scale</code>.</p>
-<a name="N158BB" class="indexterm"></a>
+<a name="N15A71" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET FILES LOB SCALE</strong></span>
 </p>
@@ -3431,7 +3527,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.lob_file_scale</code>.</p>
-<a name="N158D8" class="indexterm"></a>
+<a name="N15A8E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET FILES LOB
       COMPRESSED</strong></span>
@@ -3453,7 +3549,7 @@
       statement.</p>
 <p>This is equivalent to the connection property
       <code class="literal">hsqldb.lob_compressed</code>.</p>
-<a name="N158F5" class="indexterm"></a>
+<a name="N15AAB" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET FILES SCRIPT
       FORMAT</strong></span>
@@ -3471,7 +3567,7 @@
       command causes a CHECKPOINT.</p>
 <p>Only a user with the DBA role can execute this
       statement.</p>
-<a name="N1590B" class="indexterm"></a>
+<a name="N15AC1" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET FILES SPACE</strong></span>
 </p>
@@ -3489,7 +3585,7 @@
       statement below.</p>
 <p>Only a user with the DBA role can execute this
       statement.</p>
-<a name="N1591E" class="indexterm"></a>
+<a name="N15AD4" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET TABLE NEW SPACE</strong></span>
 </p>
@@ -3519,7 +3615,7 @@
 <p>Two settings are available for authentication control.</p>
 <p>When the default password authentication is used, the passwords
       can be checked for complexity according to administrative rules</p>
-<a name="N1593C" class="indexterm"></a>
+<a name="N15AF2" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE PASSWORD CHECK
       FUNCTION</strong></span>
@@ -3569,7 +3665,7 @@
       completely with a function that uses external authentication servers,
       such as LDAP. This function is called each time a user connects to the
       database.</p>
-<a name="N1596A" class="indexterm"></a>
+<a name="N15B20" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET DATABASE AUTHENTICATION
       FUNCTION</strong></span>
@@ -3620,7 +3716,7 @@
 </div>
 </div>
 <HR xmlns:xi="http://www.w3.org/2001/XInclude">
-<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6369 $</P>
+<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6474 $</P>
 <div class="navfooter">
 <hr>
 <table summary="Navigation footer" width="100%">
diff -pruN 2.6.1-1/hsqldb/doc/guide/odbc-chapt.html 2.7.0-1/hsqldb/doc/guide/odbc-chapt.html
--- 2.6.1-1/hsqldb/doc/guide/odbc-chapt.html	2021-10-20 09:33:34.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/guide/odbc-chapt.html	2022-07-26 20:21:48.000000000 +0000
@@ -50,7 +50,7 @@
 <p class="releaseinfo">$Revision: 5999 $</p>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -519,7 +519,7 @@
 <p>See the above section for descriptions and usage details. This
     section just contains a list of the available settings.</p>
 <div class="table">
-<a name="N17791"></a>
+<a name="N17A13"></a>
 <p class="title">
 <b>Table&nbsp;17.1.&nbsp;Settings List</b>
 </p>
@@ -630,7 +630,7 @@
 </div>
 </div>
 <HR xmlns:xi="http://www.w3.org/2001/XInclude">
-<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6369 $</P>
+<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6474 $</P>
 <div class="navfooter">
 <hr>
 <table summary="Navigation footer" width="100%">
diff -pruN 2.6.1-1/hsqldb/doc/guide/openoffice-app.html 2.7.0-1/hsqldb/doc/guide/openoffice-app.html
--- 2.6.1-1/hsqldb/doc/guide/openoffice-app.html	2021-10-20 09:33:34.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/guide/openoffice-app.html	2022-07-26 20:21:48.000000000 +0000
@@ -47,10 +47,10 @@
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6281 $</p>
+<p class="releaseinfo">$Revision: 6491 $</p>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -99,7 +99,7 @@
     database schema and application, even if the database is intended for your
     own application, rather than OpenOffice.</p>
 <p>HyperSQ version 1.8.0 is included in OOo, ApacheOpenOffice and
-    LibreOffice. You can simply replace the jar with a HyperSQL version 2.6
+    LibreOffice. You can simply replace the jar with a HyperSQL version 2.7
     jar to use the latest capabilities with external databases. It is not yet
     possible to create and use embedded databases with this version.</p>
 <p>HyperSQL version 2.x jar will hopefully be included in the future
@@ -128,8 +128,8 @@
 <p>The only current limitation is that OpenOffice only works with
     the PUBLIC schema. This limitation will hopefully disappear in the future
     versions of OOo.</p>
-<p>There will hopefully be a HyperSQLDB 2.x jar in the future
-    versions of OpenOffice.</p>
+<p>There will hopefully be a HyperSQL 2.x jar in future versions of
+    OpenOffice.</p>
 </div>
 <div class="section">
 <div class="titlepage">
@@ -157,26 +157,24 @@
 </div>
 </div>
 </div>
-<p>In 2021, two new OOo and LO extensions are developed and
+<p>Since 2021, two new OOo and LO extensions are developed and
     maintained on GitHub by the developer prrvchr. These extensions make it
     easy to use the latest version of HSQLDB 2.x with the latest versions of
     the Base program. One extension simply adds and loads the HSQLDB 2.x jar,
     ready for use. It also allows updating the jar to the latest version. The
     second extension extracts the database from the .odb file in the same
     directory and connects to the extracted database files.</p>
-<p>The simple driver: <a class="link" href="https://prrvchr.github.io/HsqlDBDriverOOo/" target="_top">https://prrvchr.github.io/HsqlDBDriverOOo/</a>
-    
+<p>The simple driver: <a class="link" href="https://prrvchr.github.io/jdbcDriverOOo/" target="_top">https://prrvchr.github.io/jdbcDriverOOo/</a>
 </p>
 <p>The driver that extracts the files: <a class="link" href="https://prrvchr.github.io/HsqlDBembeddedOOo/" target="_top">https://prrvchr.github.io/HsqlDBembeddedOOo/</a>
-    
 </p>
 <p>The extensions are easy to use, with clear visual instructions on
     how to add the extensions to the Office suite and how to create and open
-    databases. </p>
+    databases.</p>
 </div>
 </div>
 <HR xmlns:xi="http://www.w3.org/2001/XInclude">
-<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6369 $</P>
+<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6474 $</P>
 <div class="navfooter">
 <hr>
 <table summary="Navigation footer" width="100%">
diff -pruN 2.6.1-1/hsqldb/doc/guide/running-chapt.html 2.7.0-1/hsqldb/doc/guide/running-chapt.html
--- 2.6.1-1/hsqldb/doc/guide/running-chapt.html	2021-10-20 09:33:34.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/guide/running-chapt.html	2022-07-26 20:21:48.000000000 +0000
@@ -44,12 +44,12 @@
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6369 $</p>
+<p class="releaseinfo">$Revision: 6474 $</p>
 </div>
 <div>
 <div class="legalnotice">
 <a name="N100D0"></a>
-<p>Copyright 2002-2021 Fred Toussi. Permission is granted to
+<p>Copyright 2002-2022 Fred Toussi. Permission is granted to
       distribute this document without any alteration under the terms of the
       HSQLDB license. Additional permission is granted to the HSQL Development
       Group to distribute this document with or without alterations under the
@@ -57,7 +57,7 @@
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -127,11 +127,11 @@
 </div>
 </div>
 <p>HyperSQL Database (HSQLDB) is a modern relational database system.
-    Version 2.6.1 is the latest release of the all-new version 2 code. Written
+    Version 2.7.0 is the latest release of the all-new version 2 code. Written
     from ground up to follow the international ISO SQL:2016 standard, it
     supports the complete set of the classic features, together with optional
     features such as stored procedures and triggers.</p>
-<p>HyperSQL version 2.6.1 is compatible with Java 11 or later and
+<p>HyperSQL version 2.7.0 is compatible with Java 11 or later and
     supports the Java module system. A version of the HSQLDB jar compiled with
     JDK 8 is also included in the download zip package. A version of the jar
     compiled with JDK 6 is also available at hsqldb.org, numbered 2.3.9 to
@@ -374,11 +374,12 @@
 <p>The database file path format can be specified using forward slashes
     in Windows hosts as well as Linux hosts. So relative paths or paths that
     refer to the same directory on the same drive can be identical. For
-    example if your database directory in Linux is <code class="filename">/opt/db/
-    containing a database testdb (with files named testdb.*), then the
-    database file path is /opt/db/testdb.</code> If you create an
-    identical directory structure on the <code class="literal">C:</code> drive of a
-    Windows host, you can use the same URL in both Windows and Linux:</p>
+    example if your database directory in Linux is
+    <code class="filename">/opt/db/</code> containing a database testdb (with files
+    named <code class="filename">testdb.*</code>), then the database file path is
+    <code class="filename">/opt/db/testdb</code>. If you create an identical directory
+    structure on the <code class="literal">C:</code> drive of a Windows host, you can
+    use the same URL in both Windows and Linux:</p>
 <pre class="programlisting"> Connection c = DriverManager.getConnection("jdbc:hsqldb:file:/opt/db/testdb", "SA", "");</pre>
 <p>When using relative paths, these paths will be taken relative to the
     directory in which the shell command to start the Java Virtual Machine was
@@ -500,7 +501,7 @@
 <pre class="screen"> java -cp ../lib/hsqldb.jar org.hsqldb.server.WebServer --database.0 file:mydb --dbname.0 xdb</pre>
 </div>
 <p>The command line argument <code class="literal">--help</code> can be used to
-      get a list of available arguments. Connections are made using an httpl:
+      get a list of available arguments. Connections are made using an http:
       URL.</p>
 <pre class="programlisting"> Connection c = DriverManager.getConnection("jdbc:hsqldb:http://localhost/xdb", "SA", "");</pre>
 </div>
@@ -548,7 +549,7 @@
       used for the <em class="glossterm">hsql:</em> protocol on the same
       machine:</p>
 <div class="example">
-<a name="N10236"></a>
+<a name="N1023C"></a>
 <p class="title">
 <b>Example&nbsp;1.1.&nbsp;Java code to connect to the local hsql Server</b>
 </p>
@@ -568,7 +569,7 @@
 <p>If the HyperSQL HTTP server is used, the protocol is
       <em class="glossterm">http:</em> and the URL will be different:</p>
 <div class="example">
-<a name="N10240"></a>
+<a name="N10246"></a>
 <p class="title">
 <b>Example&nbsp;1.2.&nbsp;Java code to connect to the local http Server</b>
 </p>
@@ -593,7 +594,7 @@
 </div>
 </div>
 </div>
-<a name="N1024F" class="indexterm"></a>
+<a name="N10255" class="indexterm"></a>
 <p>When a HyperSQL server is run, network access should be adequately
       protected. Source IP addresses may be restricted by use of our <a class="link" href="listeners-chapt.html#lsc_acl" title="Network Access Control">Access Control List feature</a>, network
       filtering software, firewall software, or standalone firewalls. Only
@@ -608,7 +609,7 @@
       be specified when running the Server or WebServer. On the client, the
       URL to connect to an SSL server is slightly different:</p>
 <div class="example">
-<a name="N10264"></a>
+<a name="N1026A"></a>
 <p class="title">
 <b>Example&nbsp;1.3.&nbsp;Java code to connect to the local secure SSL hsqls: and
           https: Servers</b>
@@ -739,7 +740,7 @@
     to the database (the connection that opens the database) to force a
     shutdown when the last connection closes.</p>
 <div class="example">
-<a name="N1030A"></a>
+<a name="N10310"></a>
 <p class="title">
 <b>Example&nbsp;1.4.&nbsp;specifying a connection property to shutdown the database when
         the last connection is closed</b>
@@ -781,7 +782,7 @@
     <code class="methodname">getConnection()</code> method will throw an
     exception.</p>
 <div class="example">
-<a name="N10327"></a>
+<a name="N1032D"></a>
 <p class="title">
 <b>Example&nbsp;1.5.&nbsp;specifying a connection property to disallow creating a new
         database</b>
@@ -800,7 +801,7 @@
 </div>
 </div>
 <HR xmlns:xi="http://www.w3.org/2001/XInclude">
-<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6369 $</P>
+<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6474 $</P>
 <div class="navfooter">
 <hr>
 <table summary="Navigation footer" width="100%">
diff -pruN 2.6.1-1/hsqldb/doc/guide/sessions-chapt.html 2.7.0-1/hsqldb/doc/guide/sessions-chapt.html
--- 2.6.1-1/hsqldb/doc/guide/sessions-chapt.html	2021-10-20 09:33:34.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/guide/sessions-chapt.html	2022-07-26 20:21:48.000000000 +0000
@@ -44,12 +44,12 @@
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6306 $</p>
+<p class="releaseinfo">$Revision: 6535 $</p>
 </div>
 <div>
 <div class="legalnotice">
-<a name="N13AE4"></a>
-<p>Copyright 2010-2021 Fred Toussi. Permission is granted to
+<a name="N13BF5"></a>
+<p>Copyright 2010-2022 Fred Toussi. Permission is granted to
       distribute this document without any alteration under the terms of the
       HSQLDB license. Additional permission is granted to the HSQL Development
       Group to distribute this document with or without alterations under the
@@ -57,7 +57,7 @@
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -208,6 +208,12 @@
       auto-commit or read-only modes can be read using other built-in
       functions. All these functions are listed in the <a class="link" href="builtinfunctions-chapt.html" title="Chapter&nbsp;4.&nbsp;Built In Functions">Built In Functions</a>
       chapter.</p>
+<p>Each session has a time zone, which is the time zone of the JVM in
+      which the connection is made and can be different from the time zone of
+      a server database. Different client / server sessions can therefore have
+      different time zones and display time-zone-sensitive information
+      differently. See the description of the SET TIME ZONE statement below
+      for more detail.</p>
 </div>
 <div class="section">
 <div class="titlepage">
@@ -226,7 +232,7 @@
       useful for development and debugging. See the example in the <a class="link" href="sqlroutines-chapt.html" title="Chapter&nbsp;9.&nbsp;SQL-Invoked Routines">SQL-Invoked Routines</a> chapter,
       under Formal Parameters.</p>
 <div class="example">
-<a name="N13B26"></a>
+<a name="N13C39"></a>
 <p class="title">
 <b>Example&nbsp;6.1.&nbsp;User-defined Session Variables</b>
 </p>
@@ -272,10 +278,10 @@
       takes precedence over a schema table of the same name. To distinguish a
       session table from schema tables, the pseudo schema name, SESSION can be
       used. The alternative name, MODULE is deprecated and does not work in
-      version 2.5.1 but can be used in version 2.6.0. An example is given
-      below:</p>
+      version 2.5.1 but can be used in version 2.6 and later for backward
+      compatibility. An example is given below:</p>
 <div class="example">
-<a name="N13B3B"></a>
+<a name="N13C4E"></a>
 <p class="title">
 <b>Example&nbsp;6.2.&nbsp;User-defined Temporary Session Tables</b>
 </p>
@@ -284,7 +290,7 @@
  INSERT INTO session.buffer SELECT id, firstname || ' ' || lastname FROM customers
  -- do some more work
  DROP TABLE session.buffer
- -- alternative schema name, MODULE can be used in version 2.6.0 but it is deprecated
+ -- alternative schema name, MODULE can be used in version 2.7.0 but it is deprecated
  DROP TABLE module.buffer
 </pre>
 </div>
@@ -667,7 +673,7 @@
 </div>
 </div>
 </div>
-<a name="N13BCE" class="indexterm"></a>
+<a name="N13CE1" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ALTER SESSION</strong></span>
 </p>
@@ -704,7 +710,7 @@
     currently open result sets are closed and the resources are released. When
     TABLE DATA is specified, the data in all temporary tables is
     cleared.</p>
-<a name="N13BF2" class="indexterm"></a>
+<a name="N13D05" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET AUTOCOMMIT</strong></span>
 </p>
@@ -720,7 +726,7 @@
     performed automatically. This statement changes the mode. It is equivalent
     to using the <code class="methodname">setAutoCommit( boolean autoCommit)</code>
     method of the JDBC <code class="classname">Connection</code> object.</p>
-<a name="N13C09" class="indexterm"></a>
+<a name="N13D1C" class="indexterm"></a>
 <p>
 <span class="bold"><strong>START TRANSACTION</strong></span>
 </p>
@@ -735,7 +741,7 @@
     transactional SQL statements start a transaction automatically, therefore
     using this statement is not necessary. If the statement is called in the
     middle of a transaction, an exception is thrown.</p>
-<a name="N13C1A" class="indexterm"></a>
+<a name="N13D2D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET TRANSACTION</strong></span>
 </p>
@@ -750,7 +756,7 @@
 <p>Set the characteristics of the next transaction in the current
     session. This statement has an effect only on the next transactions and
     has no effect on the future transactions after the next.</p>
-<a name="N13C2B" class="indexterm"></a>
+<a name="N13D3E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>transaction
     characteristics</strong></span>
@@ -790,7 +796,7 @@
 </p>
 <p>Specify transaction characteristics.</p>
 <div class="example">
-<a name="N13C4E"></a>
+<a name="N13D61"></a>
 <p class="title">
 <b>Example&nbsp;6.3.&nbsp;Setting Transaction Characteristics</b>
 </p>
@@ -802,7 +808,7 @@
 </div>
 </div>
 <br class="example-break">
-<a name="N13C53" class="indexterm"></a>
+<a name="N13D66" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET CONSTRAINTS</strong></span>
 </p>
@@ -823,7 +829,7 @@
     the rest of the current transaction. If the statement is issued when a
     transaction is not active then it applies only to the next transaction in
     the current session. HyperSQL does not yet support this feature.</p>
-<a name="N13C67" class="indexterm"></a>
+<a name="N13D7A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LOCK TABLE</strong></span>
 </p>
@@ -855,7 +861,7 @@
 <p>Currently, this command does not have any effect when the
     database transaction control model is MVCC.</p>
 <div class="example">
-<a name="N13C7C"></a>
+<a name="N13D8F"></a>
 <p class="title">
 <b>Example&nbsp;6.4.&nbsp;Locking Tables</b>
 </p>
@@ -864,7 +870,7 @@
 </div>
 </div>
 <br class="example-break">
-<a name="N13C81" class="indexterm"></a>
+<a name="N13D94" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SAVEPOINT</strong></span>
 </p>
@@ -883,7 +889,7 @@
     transaction. It establishes a milestone for the current transaction. The
     SAVEPOINT can be used at a later point in the transaction to rollback the
     transaction to the milestone.</p>
-<a name="N13C95" class="indexterm"></a>
+<a name="N13DA8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>RELEASE SAVEPOINT</strong></span>
 </p>
@@ -897,7 +903,7 @@
 <p>Destroy a savepoint. This command is rarely used as it is not
     very useful. It removes a SAVEPOINT that has already been
     defined.</p>
-<a name="N13CA6" class="indexterm"></a>
+<a name="N13DB9" class="indexterm"></a>
 <p>
 <span class="bold"><strong>COMMIT</strong></span>
 </p>
@@ -910,7 +916,7 @@
 </p>
 <p>Terminate the current SQL-transaction with commit. This make all
     the changes to the database permanent.</p>
-<a name="N13CB7" class="indexterm"></a>
+<a name="N13DCA" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ROLLBACK</strong></span>
 </p>
@@ -926,7 +932,7 @@
     NO CHAIN is specified, a new SQL transaction is started just after the
     rollback. The new transaction inherits the properties of the old
     transaction.</p>
-<a name="N13CC8" class="indexterm"></a>
+<a name="N13DDB" class="indexterm"></a>
 <p>
 <span class="bold"><strong>ROLLBACK TO SAVEPOINT</strong></span>
 </p>
@@ -943,7 +949,7 @@
     <code class="literal">rollback( Savepoint savepoint)</code> method of the JDBC
     <code class="classname">Connection</code> object.</p>
 <div class="example">
-<a name="N13CDF"></a>
+<a name="N13DF2"></a>
 <p class="title">
 <b>Example&nbsp;6.5.&nbsp;Rollback</b>
 </p>
@@ -957,7 +963,7 @@
 </div>
 </div>
 <br class="example-break">
-<a name="N13CE5" class="indexterm"></a>
+<a name="N13DF8" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DISCONNECT</strong></span>
 </p>
@@ -970,7 +976,7 @@
 </p>
 <p>Terminate the current SQL session. Closing a JDBC connection has
     the same effect as this command.</p>
-<a name="N13CF7" class="indexterm"></a>
+<a name="N13E0A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET SESSION
     CHARACTERISTICS</strong></span>
@@ -1004,7 +1010,7 @@
     command. The current read-only mode can be accessed with the ISREADONLY()
     function.</p>
 <div class="example">
-<a name="N13D11"></a>
+<a name="N13E24"></a>
 <p class="title">
 <b>Example&nbsp;6.6.&nbsp;Setting Session Characteristics</b>
 </p>
@@ -1016,7 +1022,7 @@
 </div>
 </div>
 <br class="example-break">
-<a name="N13D16" class="indexterm"></a>
+<a name="N13E29" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET SESSION
     AUTHORIZATION</strong></span>
@@ -1036,7 +1042,7 @@
     user. The current authorisation can be accessed with the CURRENT_USER and
     SESSION_USER functions.</p>
 <div class="example">
-<a name="N13D27"></a>
+<a name="N13E3A"></a>
 <p class="title">
 <b>Example&nbsp;6.7.&nbsp;Setting Session Authorization</b>
 </p>
@@ -1047,7 +1053,7 @@
 </div>
 </div>
 <br class="example-break">
-<a name="N13D2C" class="indexterm"></a>
+<a name="N13E3F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET ROLE</strong></span>
 </p>
@@ -1067,7 +1073,7 @@
     the specified role. If NONE is specified, then the previous CURRENT_ROLE
     is eliminated. The effect of this lasts for the lifetime of the session.
     The current role can be accessed with the CURRENT_ROLE function.</p>
-<a name="N13D40" class="indexterm"></a>
+<a name="N13E53" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET TIME ZONE</strong></span>
 </p>
@@ -1080,27 +1086,39 @@
 </p>
 <p>
 <code class="literal">&lt;set time zone value&gt; ::= &lt;interval value
-    expression&gt; | LOCAL</code>
+    expression&gt; | &lt;string value expression&gt; |
+    LOCAL</code>
 </p>
 <p>Set the current default time zone displacement for the current
     SQL-session. When the session starts, the time zone displacement is set to
     the time zone of the client. This command changes the time zone
     displacement. The effect of this lasts for the lifetime of the session. If
     LOCAL is specified, the time zone displacement reverts to the local time
-    zone of the session.</p>
+    zone of the session that was in force prior to the use of the
+    command.</p>
+<p>From version 2.7.0, zone strings indicating geographical regions
+    can be used. These zone often support daylight saving time.</p>
+<p>This command works fine with in-process databases. When the
+    sessions is for a connection to a server, this command should not
+    generally be used as it only affects the server part of the session. With
+    client / server connections, the only way to specify a session time zone
+    that is different from the local time zone is by setting the JVM time zone
+    prior to connecting to the database.</p>
 <div class="example">
-<a name="N13D54"></a>
+<a name="N13E6B"></a>
 <p class="title">
 <b>Example&nbsp;6.8.&nbsp;Setting Session Time Zone</b>
 </p>
 <div class="example-contents">
 <pre class="screen"> SET TIME ZONE LOCAL
  SET TIME ZONE INTERVAL '+6:00' HOUR TO MINUTE
+ SET TIME ZONE '-6:00'
+ SET TIME ZONE 'America/Chicago'
 </pre>
 </div>
 </div>
 <br class="example-break">
-<a name="N13D59" class="indexterm"></a>
+<a name="N13E70" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET CATALOG</strong></span>
 </p>
@@ -1120,7 +1138,7 @@
     As there is only one catalog in the database, only the name of this
     catalog can be used. The current catalog can be accessed with the
     CURRENT_CATALOG function.</p>
-<a name="N13D6D" class="indexterm"></a>
+<a name="N13E84" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET SCHEMA</strong></span>
 </p>
@@ -1141,7 +1159,7 @@
     form requires the schema name as a single-quoted string. HyperSQL also
     allows the use of the identifier for the schema. The current schema can be
     accessed with the CURRENT_SCHEMA function.</p>
-<a name="N13D81" class="indexterm"></a>
+<a name="N13E98" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET PATH</strong></span>
 </p>
@@ -1160,7 +1178,7 @@
     invocations with unqualified routine names used in SQL statements that are
     prepared or executed directly in the current sessions. The effect of this
     lasts for the lifetime of the session.</p>
-<a name="N13D95" class="indexterm"></a>
+<a name="N13EAC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET MAXROWS</strong></span>
 </p>
@@ -1188,7 +1206,7 @@
     &lt;n&gt;. Therefore, this command is not recommended for general use. The
     only legitimate use of this command is for checking and testing queries
     that may return very large numbers of rows.</p>
-<a name="N13DB8" class="indexterm"></a>
+<a name="N13ECF" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET SESSION RESULT MEMORY
     ROWS</strong></span>
@@ -1214,7 +1232,7 @@
 <code class="literal">SET DATABASE DEFAULT RESULT MEMORY ROWS &lt;unsigned
     integer literal&gt;</code>
 </p>
-<a name="N13DCE" class="indexterm"></a>
+<a name="N13EE5" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SET IGNORECASE</strong></span>
 </p>
@@ -1240,7 +1258,7 @@
 </div>
 </div>
 <HR xmlns:xi="http://www.w3.org/2001/XInclude">
-<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6369 $</P>
+<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6474 $</P>
 <div class="navfooter">
 <hr>
 <table summary="Navigation footer" width="100%">
diff -pruN 2.6.1-1/hsqldb/doc/guide/sqlgeneral-chapt.html 2.7.0-1/hsqldb/doc/guide/sqlgeneral-chapt.html
--- 2.6.1-1/hsqldb/doc/guide/sqlgeneral-chapt.html	2021-10-20 09:33:34.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/guide/sqlgeneral-chapt.html	2022-07-26 20:21:48.000000000 +0000
@@ -44,12 +44,12 @@
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6339 $</p>
+<p class="releaseinfo">$Revision: 6576 $</p>
 </div>
 <div>
 <div class="legalnotice">
-<a name="N1035E"></a>
-<p>Copyright 2002-2021 Fred Toussi. Permission is granted to
+<a name="N10364"></a>
+<p>Copyright 2002-2022 Fred Toussi. Permission is granted to
       distribute this document without any alteration under the terms of the
       HSQLDB license. Additional permission is granted to the HSQL Development
       Group to distribute this document with or without alterations under the
@@ -57,7 +57,7 @@
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -106,7 +106,7 @@
 <dd>
 <dl>
 <dt>
-<span class="section"><a href="sqlgeneral-chapt.html#N10485">Case Sensitivity</a></span>
+<span class="section"><a href="sqlgeneral-chapt.html#N1048B">Case Sensitivity</a></span>
 </dt>
 <dt>
 <span class="section"><a href="sqlgeneral-chapt.html#sgc_persist_tables">Persistent Tables</a></span>
@@ -200,16 +200,16 @@
 <p>Over 300 words are reserved by the Standard and should not be used
     as table or column names. For example, the word POSITION is reserved as it
     is a function defined by the Standards with a similar role as
-    <code class="methodname">String.indexOf()</code> in Java. By default, HyperSQL
-    does not prevent you from using a reserved word if it does not support its
-    use or can distinguish it. For example, CUBE is a reserved word for a
-    feature that is supported by HyperSQL from version 2.5.1. Before this
-    version, CUBE was allowed as a table or column name, but it is no longer
-    allowed. You should avoid using such names as future versions of HyperSQL
-    are likely to support the reserved words and may reject your table
-    definitions or queries. The full list of SQL reserved words is in the
-    appendix <a class="link" href="lists-app.html" title="Appendix&nbsp;A.&nbsp;Lists of Keywords">Lists of Keywords</a> . You can
-    set a property to disallow the use of reserved keywords for names of
+    <code class="methodname">String::indexOf(String)</code> in Java. By default,
+    HyperSQL does not prevent you from using a reserved word if it does not
+    support its use or can distinguish it. For example, CUBE is a reserved
+    word for a feature that is supported by HyperSQL from version 2.5.1.
+    Before this version, CUBE was allowed as a table or column name, but it is
+    no longer allowed. You should avoid using such names as future versions of
+    HyperSQL are likely to support the reserved words and may reject your
+    table definitions or queries. The full list of SQL reserved words is in
+    the appendix <a class="link" href="lists-app.html" title="Appendix&nbsp;A.&nbsp;Lists of Keywords">Lists of Keywords</a> . You
+    can set a property to disallow the use of reserved keywords for names of
     tables and other database objects. There are several other user-defined
     properties to control the strict application of the SQL Standard in
     different areas.</p>
@@ -471,7 +471,7 @@
 <div>
 <div>
 <h3 class="title">
-<a name="N10485"></a>Case Sensitivity</h3>
+<a name="N1048B"></a>Case Sensitivity</h3>
 </div>
 </div>
 </div>
@@ -492,7 +492,7 @@
       double-quoted name is all-uppercase, it can be referenced in any case;
       <code class="literal">"MYTABLE"</code> is the same as <code class="literal">myTable</code>
       and <code class="literal">MyTable</code> because they are all converted to
-      <code class="literal">MYTABLE</code>. </p>
+      <code class="literal">MYTABLE</code>.</p>
 </div>
 <div class="section">
 <div class="titlepage">
@@ -687,12 +687,12 @@
 </li>
 </ul>
 </div>
-<p>HyperSQL 2.6 has several compatibility modes which allow the type
+<p>HyperSQL 2.7 has several compatibility modes which allow the type
     names that are used by other RDBMS to be accepted and translated into the
     closest SQL Standard type. For example, the type TEXT, supported by MySQL
     and PostgreSQL is translated in these compatibility modes.</p>
 <div class="table">
-<a name="N10531"></a>
+<a name="N10537"></a>
 <p class="title">
 <b>Table&nbsp;2.1.&nbsp;List of SQL types</b>
 </p>
@@ -736,7 +736,7 @@
 </tr>
 <tr>
 <td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">BINARY(L)</td><td style="border-bottom: 0.5pt solid ; ">fixed-length binary string type - padded with zero to
-            length L (**) </td>
+            length L (**)</td>
 </tr>
 <tr>
 <td style="border-right: 0.5pt solid ; border-bottom: 0.5pt solid ; " align="left">VARBINARY(L) or BINARY VARYING(L)</td><td style="border-bottom: 0.5pt solid ; ">variable-length binary string type (***)</td>
@@ -846,7 +846,7 @@
 </div>
 </div>
 </div>
-<a name="N105D1" class="indexterm"></a>
+<a name="N105D7" class="indexterm"></a>
 <p>TINYINT, SMALLINT, INTEGER, BIGINT, NUMERIC and DECIMAL (without a
       decimal point) are the supported integral types. They correspond
       respectively to <code class="classname">byte</code>,
@@ -1012,7 +1012,7 @@
 </div>
 </div>
 </div>
-<a name="N1069D" class="indexterm"></a>
+<a name="N106A3" class="indexterm"></a>
 <p>The BOOLEAN type conforms to the SQL Standard and represents the
       values <code class="literal">TRUE</code>, <code class="literal">FALSE</code> and
       <code class="literal">UNKNOWN</code>. This type of column can be initialised with
@@ -1046,7 +1046,7 @@
 </div>
 </div>
 </div>
-<a name="N106C4" class="indexterm"></a>
+<a name="N106CA" class="indexterm"></a>
 <p>The CHARACTER, CHARACTER VARYING and CLOB types are the SQL
       Standard character string types. CHAR, VARCHAR and CHARACTER LARGE
       OBJECT are synonyms for these types. HyperSQL also supports LONGVARCHAR
@@ -1139,7 +1139,7 @@
 </div>
 </div>
 </div>
-<a name="N106FF" class="indexterm"></a>
+<a name="N10705" class="indexterm"></a>
 <p>The BINARY, BINARY VARYING and BLOB types are the SQL Standard
       binary string types. VARBINARY and BINARY LARGE OBJECT are synonyms for
       BINARY VARYING and BLOB types. HyperSQL also supports LONGVARBINARY as a
@@ -1212,7 +1212,7 @@
 </div>
 </div>
 </div>
-<a name="N1072C" class="indexterm"></a>
+<a name="N10732" class="indexterm"></a>
 <p>The BIT and BIT VARYING types are the supported bit string types.
       These types were defined by SQL:1999 but were later removed from the
       Standard. Bit types represent bit maps of given lengths. Each bit is 0
@@ -1317,7 +1317,7 @@
 </div>
 </div>
 </div>
-<a name="N107A6" class="indexterm"></a>
+<a name="N107AC" class="indexterm"></a>
 <p>From version 2.3.4 there are two options for storing Java
       Objects.</p>
 <p>The default option allows storing Serializable object. The objects
@@ -1447,7 +1447,7 @@ SELECT obj FROM movies WHERE director LI
 <p>HSQLDB fully supports datetime and interval types and operations,
     including all relevant optional features, as specified by the SQL Standard
     since SQL-92. The two groups of types are complementary.</p>
-<a name="N10803" class="indexterm"></a>
+<a name="N10809" class="indexterm"></a>
 <p>The DATE type represents a calendar date with YEAR, MONTH and DAY
     fields.</p>
 <p>The TIME type represents time of day with HOUR, MINUTE and SECOND
@@ -1498,7 +1498,7 @@ SELECT obj FROM movies WHERE director LI
  TIME '20:08:08.034900'
  TIME '20:08:08.034900-8:00' /* US Pacific */</pre>
 </div>
-<a name="N10829" class="indexterm"></a>
+<a name="N1082F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>Time Zone</strong></span>
 </p>
@@ -1519,28 +1519,39 @@ SELECT obj FROM movies WHERE director LI
 <p>The time zone displacement is of the type INTERVAL HOUR TO MINUTE.
     This data type is described in the next section. The legal values are
     between '&ndash;18:00' and &nbsp; '+18:00'.</p>
-<a name="N10838" class="indexterm"></a>
+<a name="N1083E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>Operations on Datetime
     Types</strong></span>
 </p>
-<p>The expression <code class="literal">&lt;datetime expression&gt; AT TIME ZONE
-    &lt;time displacement&gt;</code> evaluates to a datetime value
-    representing exactly the same point of time in the specified
-    <code class="literal">&lt;time displacement&gt;</code>. The expression, <code class="literal">AT
+<p>The expression <code class="literal">&lt;datetime expression&gt; AT TIME ZONE {
+    &lt;interval primary&gt; | &lt;time zone name&gt; }</code> evaluates to
+    a datetime value representing exactly the same point of time in the
+    specified <code class="literal">&lt;time displacement&gt;</code> or the geographical
+    <code class="literal">&lt;time zone name&gt;</code>. The expression, <code class="literal">AT
     LOCAL</code> is equivalent to <code class="literal">AT TIME ZONE &lt;local time
     displacement&gt;</code>. If <code class="literal">AT TIME ZONE</code> is used
     with a datetime operand of type WITHOUT TIME ZONE, the operand is first
-    converted to a value of type WITH TIME ZONE at the session&rsquo;s time
-    displacement, then the specified time zone displacement is set for the
-    value. Therefore, in these cases, the final value depends on the time zone
-    of the session in which the statement was used.</p>
+    converted to a value of type WITH TIME ZONE using the session's calendar,
+    then the specified time zone displacement is set for the value. Therefore,
+    in these cases, the final value depends on the time zone of the session in
+    which the statement was used, calculated at the exact point of time (of
+    the input) and accounting for daylight saving time at that point of
+    time.</p>
+<p>From version 2.7.0 it is possible to use regional time zones with AT
+    TIME ZONE. Any zone name used must match exactly a TimeZone id supported
+    by the JVM. These include names such as 'America/New_York'. Some zones
+    include daylight saving time periods which are used when converting the
+    time zone.</p>
+<p>See also the FROM_TZ function which allows you to convert to a time
+    zone without changing the date-time values such as hour and minute.</p>
 <p>AT TIME ZONE, modifies the field values of the datetime operand.
     This is done by the following procedure:</p>
 <div class="orderedlist">
 <ol class="orderedlist" type="1">
 <li class="listitem">
-<p>determine the corresponding datetime at UTC.</p>
+<p>determine the corresponding datetime at UTC using the session's
+        calendar.</p>
 </li>
 <li class="listitem">
 <p>find the datetime value at the given time zone that corresponds
@@ -1550,12 +1561,25 @@ SELECT obj FROM movies WHERE director LI
 </div>
 <p>Example a:</p>
 <div class="informalexample">
-<pre class="programlisting"> TIME '12:00:00' AT TIME ZONE INTERVAL '1:00' HOUR TO MINUTE
+<pre class="programlisting"> VALUES TIMESTAMP'2022-03-28 11:00:00' AT TIME ZONE INTERVAL '-5:00' HOUR TO MINUTE
+ C1                       
+ ------------------------ 
+ 2022-03-28 14:00:00-5:00 
+
+ VALUES TIMESTAMP'2022-03-28 11:00:00+4:00' AT TIME ZONE 'America/Chicago'
+ C1                       
+ ------------------------ 
+ 2022-03-28 02:00:00-5:00 
 </pre>
 </div>
-<p>If the session&rsquo;s time zone displacement is -'8:00', then in step 1,
-    TIME '12:00:00' is converted to UTC, which is TIME '20:00:00+0:00'. In
-    step 2, this value is expressed as TIME '21:00:00+1:00'.</p>
+<p>In the first example above, the session's time zone displacement is
+    '-8:00'. In step 1, time '11:00:00' is converted to UTC, which is time
+    '19:00:00+0:00'. In step 2, this value is expressed as time
+    '14:00:00-5:00' in the target zone.</p>
+<p>In the second example, the session's time zone displacement is not
+    considered. In step 1, time is converted to UTC, which is time
+    '07:00:00+0:00', In step 2, this value is expressed as time
+    '02:00:00-5:00' in the target zone.</p>
 <p>Example b:</p>
 <div class="informalexample">
 <pre class="programlisting"> TIME '12:00:00-5:00' AT TIME ZONE INTERVAL '1:00' HOUR TO MINUTE
@@ -1671,10 +1695,15 @@ SELECT obj FROM movies WHERE director LI
 </p>
 <p>When an SQL session is started (with a JDBC connection) the local
     time zone of the client JVM (including any seasonal time adjustments such
-    as daylight-saving time) is used as the session time zone displacement.
-    Note that the SQL session time displacement is not changed when a seasonal
-    time adjustment takes place while the session is open. To change the SQL
-    session time zone displacement, use the following commands:</p>
+    as daylight-saving time) is used as the session time zone displacement. In
+    version 2.7.0 a Java Calendar object with the local time zone of the
+    client JVM is created and used. Therefore when a seasonal time adjustment
+    for daylight saving time is made while the session is open, the SQL
+    session zone displacement is changed. In some older versions of HyperSQL,
+    the SQL session time displacement was not changed when a seasonal time
+    adjustment took place.</p>
+<p>To change the SQL session time zone displacement, use the following
+    commands:</p>
 <p>
 <code class="literal">SET TIME ZONE &lt;time
     displacement&gt;</code>
@@ -1723,16 +1752,14 @@ SELECT obj FROM movies WHERE director LI
     <code class="methodname">getTimestamp(...)</code> methods of the ResultSet
     interface which have a Calendar parameter can be used with a Calendar
     argument to retrieve the values.</p>
-<p>JDBC 4 and JAVA6 has an unfortunate limitation and does not include
-    type codes for SQL datetime types that have a TIME ZONE property.
-    Therefore, for compatibility with database tools that are limited to the
-    JDBC type codes, HyperSQL reports these types by default as datetime types
-    without TIME ZONE.</p>
 <p>
 <span class="bold"><strong>Java 8 Extensions</strong></span>
 </p>
+<p>JDBC 4 and JAVA6 did not include type codes for SQL datetime types
+    that have a TIME ZONE property. Therefore, HyperSQL reported these types
+    by default as datetime types without TIME ZONE.</p>
 <p>JAVA 8 introduced new type codes for TIMESTAMP WITH TIME ZONE and
-    TIME WITH TIME ZONE. HSQLDB 2.4.0 and later when compiled with JDK8
+    TIME WITH TIME ZONE. HyperSQL (except the jars compiled with JDK 1.6)
     supports this in <code class="classname">ResultSet</code>,
     <code class="classname">PreparedStatement</code> and
     <code class="classname">CallableStatement</code>.</p>
@@ -1754,8 +1781,9 @@ SELECT obj FROM movies WHERE director LI
         <code class="classname">java.time</code> package types:
         <code class="classname">LocalDate</code>, <code class="classname">LocalTime</code>,
         <code class="classname">LocalDateTime</code>,
-        <code class="classname">OffsetTime</code> and
-        <code class="classname">OffsetDateTime</code> as well as
+        <code class="classname">OffsetTime</code>,
+        <code class="classname">OffsetDateTime</code>, and
+        <code class="classname">Instance</code> as well as
         <code class="classname">java.sql</code> package types,
         <code class="classname">Date</code>, <code class="classname">Time</code> and
         <code class="classname">Timestamp</code>.</p>
@@ -1776,7 +1804,7 @@ SELECT obj FROM movies WHERE director LI
 <span class="bold"><strong>Non-Standard
     Extensions</strong></span>
 </p>
-<p>HyperSQL version 2.5 supports some extensions to the SQL standard
+<p>HyperSQL version 2.7 supports some extensions to the SQL standard
     treatment of datetime and interval types. For example, the Standard
     expression to add a number of days to a date has an explicit INTERVAL
     value but HSQLDB also allows an integer to be used without specifying DAY.
@@ -1804,7 +1832,7 @@ SELECT obj FROM movies WHERE director LI
 </div>
 </div>
 </div>
-<a name="N10970" class="indexterm"></a>
+<a name="N10984" class="indexterm"></a>
 <p>Interval types are used to represent differences between date time
     values. The difference between two date time values can be measured in
     seconds or in months. For measurements in months, the units YEAR and MONTH
@@ -2025,8 +2053,8 @@ SELECT obj FROM movies WHERE director LI
 <p>
 <span class="bold"><strong>Java 8 Extensions</strong></span>
 </p>
-<p>JAVA 8 does not have SQL type codes for INTERVAL types. HSQLDB 2.4.0
-    and later, when compiled with JDK8 or later, supports
+<p>JAVA 8 does not have SQL type codes for INTERVAL types. HyperSQL
+    (except the jars compiled with JDK 1.6) supports
     <code class="classname">java.time</code> types for INTERVAL types in
     <code class="classname">ResultSet</code>, <code class="classname">PreparedStatement</code>
     and <code class="classname">CallableStatement</code>.</p>
@@ -2034,10 +2062,10 @@ SELECT obj FROM movies WHERE director LI
 <ul class="itemizedlist" style="list-style-type: disc; ">
 <li class="listitem">
 <p>The <code class="methodname">getObject(int columnIndex, Class
-        type)</code> method on an INTERVAL supports
+        type)</code> method on an INTERVAL supports the
         <code class="classname">java.time.Period</code> type for YEAR and MONTH
-        interval and <code class="classname">java.time.Duration</code> type for other
-        interval types that cover DAY to SECOND.</p>
+        interval and the <code class="classname">java.time.Duration</code> type for
+        other interval types that cover DAY to SECOND.</p>
 </li>
 <li class="listitem">
 <p>The <code class="methodname">setObject(int columnIndex)</code> method
@@ -2405,7 +2433,7 @@ ps.executeUpdate();
 </div>
 </div>
 <HR xmlns:xi="http://www.w3.org/2001/XInclude">
-<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6369 $</P>
+<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6474 $</P>
 <div class="navfooter">
 <hr>
 <table summary="Navigation footer" width="100%">
diff -pruN 2.6.1-1/hsqldb/doc/guide/sql-ind.html 2.7.0-1/hsqldb/doc/guide/sql-ind.html
--- 2.6.1-1/hsqldb/doc/guide/sql-ind.html	2021-10-20 09:33:34.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/guide/sql-ind.html	2022-07-26 20:21:48.000000000 +0000
@@ -35,7 +35,7 @@
 <div class="indexdiv">
 <h3>Symbols</h3>
 <dl>
-<dt>_SYSTEM ROLE, <a class="indexterm" href="accesscontrol-chapt.html#acc_built_in_roles_users">Built-In Roles and Users</a>
+<dt>_SYSTEM Role, <a class="indexterm" href="accesscontrol-chapt.html#acc_built_in_roles_users">Built-In Roles and Users</a>
 </dt>
 </dl>
 </div>
@@ -44,6 +44,8 @@
 <dl>
 <dt>ABS function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_numeric_functions">Numeric Functions</a>
 </dt>
+<dt>Access Rights, <a class="indexterm" href="accesscontrol-chapt.html#acc_access_rights">Access Rights</a>
+</dt>
 <dt>ACOS function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_numeric_functions">Numeric Functions</a>
 </dt>
 <dt>ACTION_ID function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_system_functions">System Functions</a>
@@ -64,6 +66,8 @@
 </dt>
 <dt>ADMINISTRABLE_ROLE_AUTHORIZATIONS, <a class="indexterm" href="databaseobjects-chapt.html#dbc_standard_views_info_schema">SQL Standard Views</a>
 </dt>
+<dt>Admin USER, <a class="indexterm" href="accesscontrol-chapt.html#acc_built_in_roles_users">Built-In Roles and Users</a>
+</dt>
 <dt>aggregate function, <a class="indexterm" href="dataaccess-chapt.html#dac_aggregate_funcs">Aggregate Functions</a>
 </dt>
 <dt>ALL and ANY predicates, <a class="indexterm" href="dataaccess-chapt.html#dac_sql_predicates">Predicates</a>
@@ -115,6 +119,8 @@
 </dt>
 <dt>ATAN function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_numeric_functions">Numeric Functions</a>
 </dt>
+<dt>Authorisation and Access Control, <a class="indexterm" href="accesscontrol-chapt.html#acc_auth_and_access_ctrl">Authorizations and Access Control</a>
+</dt>
 <dt>AUTHORIZATION IDENTIFIER, <a class="indexterm" href="accesscontrol-chapt.html#acc_auth_and_access_ctrl">Authorizations and Access Control</a>
 </dt>
 <dt>AUTHORIZATIONS, <a class="indexterm" href="databaseobjects-chapt.html#dbc_standard_views_info_schema">SQL Standard Views</a>
@@ -154,6 +160,8 @@
 </dt>
 <dt>boolean value expression, <a class="indexterm" href="dataaccess-chapt.html#dac_value_expression">Value Expression</a>
 </dt>
+<dt>Built-in Roles and Users, <a class="indexterm" href="accesscontrol-chapt.html#acc_built_in_roles_users">Built-In Roles and Users</a>
+</dt>
 </dl>
 </div>
 <div class="indexdiv">
@@ -257,7 +265,7 @@
 </dt>
 <dt>COT function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_numeric_functions">Numeric Functions</a>
 </dt>
-<dt>CREATE_SCHEMA ROLE, <a class="indexterm" href="accesscontrol-chapt.html#acc_built_in_roles_users">Built-In Roles and Users</a>
+<dt>CREATE_SCHEMA Role, <a class="indexterm" href="accesscontrol-chapt.html#acc_built_in_roles_users">Built-In Roles and Users</a>
 </dt>
 <dt>CREATE AGGREGATE FUNCTION, <a class="indexterm" href="sqlroutines-chapt.html#src_aggregate_function_definition">Definition of Aggregate Functions</a>
 </dt>
@@ -370,7 +378,7 @@
 </dt>
 <dt>DAYS function datetime, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_extract_datetime">Functions to Extract an Element of a Datetime</a>
 </dt>
-<dt>DBA ROLE, <a class="indexterm" href="accesscontrol-chapt.html#acc_built_in_roles_users">Built-In Roles and Users</a>
+<dt>DBA Role, <a class="indexterm" href="accesscontrol-chapt.html#acc_built_in_roles_users">Built-In Roles and Users</a>
 </dt>
 <dt>DECLARE CURSOR, <a class="indexterm" href="dataaccess-chapt.html#dac_declare_cursor">Cursor Declaration</a>
 </dt>
@@ -494,6 +502,8 @@
 </dt>
 <dt>FROM_BASE64 function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_string_binary_functions">String and Binary String Functions</a>
 </dt>
+<dt>FROM_TZ function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_datetime_format">Functions to Convert or Format a Datetime</a>
+</dt>
 </dl>
 </div>
 <div class="indexdiv">
@@ -506,7 +516,7 @@
 <dt>GRANTED BY, <a class="indexterm" href="accesscontrol-chapt.html#acc_statements">Statements for
     Authorization and Access Control</a>
 </dt>
-<dt>GRANT privilege, <a class="indexterm" href="accesscontrol-chapt.html#acc_statements">Statements for
+<dt>GRANT privileges, <a class="indexterm" href="accesscontrol-chapt.html#acc_statements">Statements for
     Authorization and Access Control</a>
 </dt>
 <dt>GRANT role, <a class="indexterm" href="accesscontrol-chapt.html#acc_statements">Statements for
@@ -591,6 +601,12 @@
 </dt>
 <dt>JOIN with condition, <a class="indexterm" href="dataaccess-chapt.html#dac_joined_table">Joined Table</a>
 </dt>
+<dt>JSON_ARRAY_AGG function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_JSON_functions">JSON Functions</a>
+</dt>
+<dt>JSON_ARRAY function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_JSON_functions">JSON Functions</a>
+</dt>
+<dt>JSON_OBJECT function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_JSON_functions">JSON Functions</a>
+</dt>
 </dl>
 </div>
 <div class="indexdiv">
@@ -623,6 +639,8 @@
 </dt>
 <dt>LIKE predicate, <a class="indexterm" href="dataaccess-chapt.html#dac_sql_predicates">Predicates</a>
 </dt>
+<dt>Listing Users and Roles, <a class="indexterm" href="accesscontrol-chapt.html#acc_listing">Listing Users and Roles</a>
+</dt>
 <dt>LN function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_numeric_functions">Numeric Functions</a>
 </dt>
 <dt>LOAD_FILE function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_general_functions">General Functions</a>
@@ -741,8 +759,12 @@
 </dt>
 <dt>PERFORM CHECK INDEX, <a class="indexterm" href="management-chapt.html#mtc_data_management_statements">Data Management Statements</a>
 </dt>
+<dt>PERFORM EXPORT DSV, <a class="indexterm" href="management-chapt.html#mtc_data_management_statements">Data Management Statements</a>
+</dt>
 <dt>PERFORM EXPORT SCRIPT, <a class="indexterm" href="management-chapt.html#mtc_data_management_statements">Data Management Statements</a>
 </dt>
+<dt>PERFORM IMPORT DSV file, <a class="indexterm" href="management-chapt.html#mtc_data_management_statements">Data Management Statements</a>
+</dt>
 <dt>PERFORM IMPORT SCRIPT, <a class="indexterm" href="management-chapt.html#mtc_data_management_statements">Data Management Statements</a>
 </dt>
 <dt>PERIODS, <a class="indexterm" href="databaseobjects-chapt.html#dbc_standard_views_info_schema">SQL Standard Views</a>
@@ -759,7 +781,7 @@
 </dt>
 <dt>PRIMARY KEY constraint, <a class="indexterm" href="databaseobjects-chapt.html#dbc_table_creation">Table Creation</a>
 </dt>
-<dt>PUBLIC ROLE, <a class="indexterm" href="accesscontrol-chapt.html#acc_built_in_roles_users">Built-In Roles and Users</a>
+<dt>PUBLIC Role, <a class="indexterm" href="accesscontrol-chapt.html#acc_built_in_roles_users">Built-In Roles and Users</a>
 </dt>
 </dl>
 </div>
@@ -817,7 +839,7 @@
 </dt>
 <dt>REVERSE function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_string_binary_functions">String and Binary String Functions</a>
 </dt>
-<dt>REVOKE, <a class="indexterm" href="accesscontrol-chapt.html#acc_statements">Statements for
+<dt>REVOKE privileges, <a class="indexterm" href="accesscontrol-chapt.html#acc_statements">Statements for
     Authorization and Access Control</a>
 </dt>
 <dt>REVOKE ROLE, <a class="indexterm" href="accesscontrol-chapt.html#acc_statements">Statements for
@@ -890,7 +912,7 @@
 </dt>
 <dt>SCRIPT, <a class="indexterm" href="management-chapt.html#mtc_system_operation_statements">System Operations</a>
 </dt>
-<dt>SCRIPT_OPS, <a class="indexterm" href="accesscontrol-chapt.html#acc_built_in_roles_users">Built-In Roles and Users</a>
+<dt>SCRIPT_OPS Role, <a class="indexterm" href="accesscontrol-chapt.html#acc_built_in_roles_users">Built-In Roles and Users</a>
 </dt>
 <dt>search condition, <a class="indexterm" href="dataaccess-chapt.html#dac_other_syntax_elements">Other Syntax Elements</a>
 </dt>
@@ -989,6 +1011,8 @@
 </dt>
 <dt>SET DATABASE SQL TRANSLATE TTI TYPES, <a class="indexterm" href="management-chapt.html#mtc_sql_settings">SQL Conformance Settings</a>
 </dt>
+<dt>SET DATABASE SQL TRUNCATE TRAILING, <a class="indexterm" href="management-chapt.html#mtc_sql_settings">SQL Conformance Settings</a>
+</dt>
 <dt>SET DATABASE SQL TYPES, <a class="indexterm" href="management-chapt.html#mtc_sql_settings">SQL Conformance Settings</a>
 </dt>
 <dt>SET DATABASE SQL UNIQUE NULLS, <a class="indexterm" href="management-chapt.html#mtc_sql_settings">SQL Conformance Settings</a>
@@ -1087,6 +1111,8 @@
 </dt>
 <dt>SIGN function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_numeric_functions">Numeric Functions</a>
 </dt>
+<dt>Simple Data Access Control, <a class="indexterm" href="accesscontrol-chapt.html#N1425C">Simple Access Control</a>
+</dt>
 <dt>SIN function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_numeric_functions">Numeric Functions</a>
 </dt>
 <dt>SINH function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_numeric_functions">Numeric Functions</a>
@@ -1195,8 +1221,6 @@
 </dt>
 <dt>SYSTIMESTAMP function, <a class="indexterm" href="builtinfunctions-chapt.html#bfc_current_datetime">Functions to Report the Current Datetime</a>
 </dt>
-<dt>SYS USER, <a class="indexterm" href="accesscontrol-chapt.html#acc_built_in_roles_users">Built-In Roles and Users</a>
-</dt>
 </dl>
 </div>
 <div class="indexdiv">
@@ -1367,7 +1391,7 @@
 </div>
 </div>
 <HR xmlns:xi="http://www.w3.org/2001/XInclude">
-<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6369 $</P>
+<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6474 $</P>
 <div class="navfooter">
 <hr>
 <table summary="Navigation footer" width="100%">
diff -pruN 2.6.1-1/hsqldb/doc/guide/sqlroutines-chapt.html 2.7.0-1/hsqldb/doc/guide/sqlroutines-chapt.html
--- 2.6.1-1/hsqldb/doc/guide/sqlroutines-chapt.html	2021-10-20 09:33:34.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/guide/sqlroutines-chapt.html	2022-07-26 20:21:48.000000000 +0000
@@ -44,12 +44,12 @@
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6327 $</p>
+<p class="releaseinfo">$Revision: 6474 $</p>
 </div>
 <div>
 <div class="legalnotice">
-<a name="N14300"></a>
-<p>Copyright 2010-2021 Fred Toussi. Permission is granted to
+<a name="N14454"></a>
+<p>Copyright 2010-2022 Fred Toussi. Permission is granted to
       distribute this document without any alteration under the terms of the
       HSQLDB license. Additional permission is granted to the HSQL Development
       Group to distribute this document with or without alterations under the
@@ -57,7 +57,7 @@
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -196,7 +196,7 @@
 </div>
 </div>
 <p>SQL-invoked routines are functions and procedures called from SQL.
-    HyperSQL 2.6 supports routines conforming to two parts of the SQL
+    HyperSQL 2.7 supports routines conforming to two parts of the SQL
     Standard. Routines written in the SQL language are supported in
     conformance to SQL/PSM (Persistent Stored Modules) specification. Routines
     written in Java are supported in broad conformance to SQL/JRT
@@ -285,11 +285,11 @@
 <p>Routine definition has several mandatory or optional clauses. The
     complete BNF supported by HyperSQL and the remaining clauses are
     documented in this section.</p>
-<a name="N1434D" class="indexterm"></a>
+<a name="N144A1" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE FUNCTION</strong></span>
 </p>
-<a name="N14356" class="indexterm"></a>
+<a name="N144AA" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE PROCEDURE</strong></span>
 </p>
@@ -336,7 +336,7 @@
     type&gt;</code>
 </p>
 <p>Return Value and Table Functions</p>
-<a name="N14383" class="indexterm"></a>
+<a name="N144D7" class="indexterm"></a>
 <p>
 <span class="bold"><strong>RETURNS</strong></span>
 </p>
@@ -393,7 +393,7 @@
 <code class="literal">&lt;returns data type&gt; ::= &lt;data
     type&gt;</code>
 </p>
-<a name="N143C3" class="indexterm"></a>
+<a name="N14517" class="indexterm"></a>
 <p>
 <span class="bold"><strong>routine body</strong></span>
 </p>
@@ -425,7 +425,7 @@
 <code class="literal">&lt;rights clause&gt; ::= SQL SECURITY INVOKER | SQL
     SECURITY DEFINER</code>
 </p>
-<a name="N143E3" class="indexterm"></a>
+<a name="N14537" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SQL routine body</strong></span>
 </p>
@@ -437,7 +437,7 @@
 <code class="literal">&lt;SQL routine body&gt; ::= &lt;SQL procedure
     statement&gt;</code>
 </p>
-<a name="N143F4" class="indexterm"></a>
+<a name="N14548" class="indexterm"></a>
 <p>
 <span class="bold"><strong>EXTERNAL NAME</strong></span>
 </p>
@@ -483,7 +483,7 @@
       characteristic&gt; | &lt;savepoint level
       indication&gt;</code>
 </p>
-<a name="N1441D" class="indexterm"></a>
+<a name="N14571" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LANGUAGE</strong></span>
 </p>
@@ -508,7 +508,7 @@
 <p>
 <code class="literal">&lt;parameter style&gt; ::= JAVA</code>
 </p>
-<a name="N14439" class="indexterm"></a>
+<a name="N1458D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SPECIFIC NAME</strong></span>
 </p>
@@ -538,7 +538,7 @@
 
 </pre>
 </div>
-<a name="N14453" class="indexterm"></a>
+<a name="N145A7" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DETERMINISTIC</strong></span>
 </p>
@@ -557,7 +557,7 @@
 <code class="literal">&lt;deterministic characteristic&gt; ::= DETERMINISTIC
       | NOT DETERMINISTIC</code>
 </p>
-<a name="N1446A" class="indexterm"></a>
+<a name="N145BE" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SQL DATA access</strong></span>
 </p>
@@ -586,7 +586,7 @@
 <code class="literal">&lt;SQL-data access indication&gt; ::= NO SQL |
       CONTAINS SQL | READS SQL DATA | MODIFIES SQL DATA</code>
 </p>
-<a name="N14498" class="indexterm"></a>
+<a name="N145EC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>NULL INPUT</strong></span>
 </p>
@@ -605,7 +605,7 @@
 <code class="literal">&lt;null-call clause&gt; ::= RETURNS NULL ON NULL
       INPUT | CALLED ON NULL INPUT</code>
 </p>
-<a name="N144B1" class="indexterm"></a>
+<a name="N14605" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SAVEPOINT LEVEL</strong></span>
 </p>
@@ -623,7 +623,7 @@
 <code class="literal">&lt;savepoint level indication&gt; ::= NEW SAVEPOINT
       LEVEL | OLD SAVEPOINT LEVEL</code>
 </p>
-<a name="N144CB" class="indexterm"></a>
+<a name="N1461F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DYNAMIC RESULT SETS</strong></span>
 </p>
@@ -959,7 +959,7 @@
 </pre>
 </div>
 <p>The BNF for variable declaration is given below:</p>
-<a name="N145C4" class="indexterm"></a>
+<a name="N14718" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DECLARE variable</strong></span>
 </p>
@@ -1122,7 +1122,7 @@
 </div>
 <p>The BNF for <code class="literal">&lt;handler declaration&gt;</code> is
       given below:</p>
-<a name="N14671" class="indexterm"></a>
+<a name="N147C5" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DECLARE HANDLER</strong></span>
 </p>
@@ -1261,7 +1261,7 @@
 <p>A special form of SELECT can also be used for assigning values
       from a query to one or more arguments or variables. This works similar
       to a SET statement that has a SELECT statement as the source.</p>
-<a name="N146F6" class="indexterm"></a>
+<a name="N1484A" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SELECT : SINGLE ROW</strong></span>
 </p>
@@ -1356,7 +1356,7 @@
       of one or more SQL statements. The <code class="literal">&lt;search
       condition&gt;</code> can be any valid SQL expression of BOOLEAN
       type.</p>
-<a name="N1473D" class="indexterm"></a>
+<a name="N14891" class="indexterm"></a>
 <p>
 <span class="bold"><strong>LOOP</strong></span>
 </p>
@@ -1371,7 +1371,7 @@
 <p>The LOOP statement is a simple loop without its own condition. A
       conditional LEAVE statement inside the loop is used to break out of the
       loop.</p>
-<a name="N1474E" class="indexterm"></a>
+<a name="N148A2" class="indexterm"></a>
 <p>
 <span class="bold"><strong>WHILE</strong></span>
 </p>
@@ -1399,7 +1399,7 @@
 
 </pre>
 </div>
-<a name="N14767" class="indexterm"></a>
+<a name="N148BB" class="indexterm"></a>
 <p>
 <span class="bold"><strong>REPEAT</strong></span>
 </p>
@@ -1430,7 +1430,7 @@
       iterated statement, but it is always used with a cursor declaration to
       iterate over the rows of the result set of the cursor and perform
       operations using the values of each row.</p>
-<a name="N14787" class="indexterm"></a>
+<a name="N148DB" class="indexterm"></a>
 <p>
 <span class="bold"><strong>FOR</strong></span>
 </p>
@@ -1494,7 +1494,7 @@
 </div>
 <p>There are two types of CASE ... WHEN statement and the IF ... THEN
       statement.</p>
-<a name="N147AD" class="indexterm"></a>
+<a name="N14901" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CASE WHEN</strong></span>
 </p>
@@ -1562,7 +1562,7 @@
 
 </pre>
 </div>
-<a name="N147D9" class="indexterm"></a>
+<a name="N1492D" class="indexterm"></a>
 <p>
 <span class="bold"><strong>IF</strong></span>
 </p>
@@ -1617,7 +1617,7 @@
       ResultSet returned from a function that returns a result set. If the
       function returns a scalar value, the returned result has a single column
       and a single row which contains the scalar returned value.</p>
-<a name="N1480A" class="indexterm"></a>
+<a name="N1495E" class="indexterm"></a>
 <p>
 <span class="bold"><strong>RETURN</strong></span>
 </p>
@@ -1711,7 +1711,7 @@
 <p>Signal and Resignal Statements allow the routine to throw an
       exception. If used with the IF or CASE conditions, the exception is
       thrown conditionally.</p>
-<a name="N14845" class="indexterm"></a>
+<a name="N14999" class="indexterm"></a>
 <p>
 <span class="bold"><strong>SIGNAL</strong></span>
 </p>
@@ -1733,7 +1733,7 @@
       value&gt; [ SET MESSAGE_TEXT = &lt;character string literal&gt; ]
       </code>
 </p>
-<a name="N14858" class="indexterm"></a>
+<a name="N149AC" class="indexterm"></a>
 <p>
 <span class="bold"><strong>RESIGNAL</strong></span>
 </p>
@@ -2588,7 +2588,7 @@
       fourth parameters have user-defined types and must be defined as INOUT
       parameters. The defined return type of the function determines the type
       of the value returned when the function is invoked.</p>
-<a name="N14A66" class="indexterm"></a>
+<a name="N14BBA" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE AGGREGATE
       FUNCTION</strong></span>
@@ -2829,7 +2829,7 @@
 </div>
 </div>
 <HR xmlns:xi="http://www.w3.org/2001/XInclude">
-<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6369 $</P>
+<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6474 $</P>
 <div class="navfooter">
 <hr>
 <table summary="Navigation footer" width="100%">
diff -pruN 2.6.1-1/hsqldb/doc/guide/texttables-chapt.html 2.7.0-1/hsqldb/doc/guide/texttables-chapt.html
--- 2.6.1-1/hsqldb/doc/guide/texttables-chapt.html	2021-10-20 09:33:34.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/guide/texttables-chapt.html	2022-07-26 20:21:48.000000000 +0000
@@ -58,12 +58,12 @@
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6271 $</p>
+<p class="releaseinfo">$Revision: 6425 $</p>
 </div>
 <div>
 <div class="legalnotice">
-<a name="N13E20"></a>
-<p>Copyright 2002-2021 Bob Preston and Fred Toussi. Permission is
+<a name="N13F37"></a>
+<p>Copyright 2002-2022 Bob Preston and Fred Toussi. Permission is
       granted to distribute this document without any alteration under the
       terms of the HSQLDB license. Additional permission is granted to the
       HSQL Development Group to distribute this document with or without
@@ -71,7 +71,7 @@
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -822,7 +822,7 @@
 </div>
 </div>
 <HR xmlns:xi="http://www.w3.org/2001/XInclude">
-<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6369 $</P>
+<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6474 $</P>
 <div class="navfooter">
 <hr>
 <table summary="Navigation footer" width="100%">
diff -pruN 2.6.1-1/hsqldb/doc/guide/triggers-chapt.html 2.7.0-1/hsqldb/doc/guide/triggers-chapt.html
--- 2.6.1-1/hsqldb/doc/guide/triggers-chapt.html	2021-10-20 09:33:34.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/guide/triggers-chapt.html	2022-07-26 20:21:48.000000000 +0000
@@ -48,8 +48,8 @@
 </div>
 <div>
 <div class="legalnotice">
-<a name="N14AFF"></a>
-<p>Copyright 2010-2021 Fred Toussi. Permission is granted to
+<a name="N14C53"></a>
+<p>Copyright 2010-2022 Fred Toussi. Permission is granted to
       distribute this document without any alteration under the terms of the
       HSQLDB license. Additional permission is granted to the HSQL Development
       Group to distribute this document with or without alterations under the
@@ -57,7 +57,7 @@
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -482,7 +482,7 @@
 </div>
 </div>
 </div>
-<a name="N14BC0" class="indexterm"></a>
+<a name="N14D14" class="indexterm"></a>
 <p>
 <span class="bold"><strong>CREATE TRIGGER</strong></span>
 </p>
@@ -590,7 +590,7 @@
     interface.</p>
 <p>Early releases of HyperSQL version 2.x did not allow the use of
     OLD TABLE or NEW TABLE in statement level triggers.</p>
-<a name="N14C2B" class="indexterm"></a>
+<a name="N14D7F" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TRIGGERED SQL
     STATEMENT</strong></span>
@@ -643,7 +643,7 @@
 </pre>
 </div>
 <p></p>
-<a name="N14C4F" class="indexterm"></a>
+<a name="N14DA3" class="indexterm"></a>
 <p>
 <span class="bold"><strong>TRIGGER EXECUTION
     ORDER</strong></span>
@@ -661,7 +661,7 @@
     specified other trigger. If this clause is not used, the new trigger is
     executed after all the previously defined triggers of the same scope
     (BEFORE / AFTER, EACH ROW / EACH STATEMENT).</p>
-<a name="N14C60" class="indexterm"></a>
+<a name="N14DB4" class="indexterm"></a>
 <p>
 <span class="bold"><strong>DROP TRIGGER</strong></span>
 </p>
@@ -676,7 +676,7 @@
 </div>
 </div>
 <HR xmlns:xi="http://www.w3.org/2001/XInclude">
-<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6369 $</P>
+<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6474 $</P>
 <div class="navfooter">
 <hr>
 <table summary="Navigation footer" width="100%">
diff -pruN 2.6.1-1/hsqldb/doc/guide/unix-chapt.html 2.7.0-1/hsqldb/doc/guide/unix-chapt.html
--- 2.6.1-1/hsqldb/doc/guide/unix-chapt.html	2021-10-20 09:35:06.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/guide/unix-chapt.html	2022-07-26 20:23:04.000000000 +0000
@@ -49,10 +49,10 @@
 </div>
 </div>
 <div>
-<p class="releaseinfo">$Revision: 6155 $</p>
+<p class="releaseinfo">$Revision: 6474 $</p>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -256,7 +256,7 @@
 </div>
 <p class="simpara">All the files in the zip archive will be extracted to
           underneath a new subdirectory named like
-          <code class="filename">hsqldb-2.4.1/hsqldb</code>.</p>
+          <code class="filename">hsqldb-2.7.0/hsqldb</code>.</p>
 </td>
 </tr>
 </tbody>
@@ -268,7 +268,7 @@
     HyperSQL system is <code class="filename">hsqldb.jar</code>, which resides in the
     subdirectory <code class="filename">lib</code>. Depending on who built your
     distribution, your file name may have a version label in it, like
-    <code class="filename">hsqldb-1.2.3.4.jar</code>.</p>
+    <code class="filename">hsqldb-2.7.0.jar</code>.</p>
 <div class="important" style="margin-left: 0.5in; margin-right: 0.5in;">
 <table border="0" summary="Important">
 <tr>
@@ -307,7 +307,7 @@
     document</a>. Otherwise build a new
     <code class="filename">hsqldb.jar</code>.</p>
 <div class="procedure">
-<a name="N1738C"></a>
+<a name="N1760E"></a>
 <p class="title">
 <b>Procedure&nbsp;16.1.&nbsp;Building hsqldb.jar</b>
 </p>
@@ -486,11 +486,13 @@ server.database.0=file:db0/db0
     <code class="varname">HSQLDB_OWNER</code>'s home directory. Use
     <code class="literal">chmod</code> to make the file readable and writable only to
     <code class="varname">HSQLDB_OWNER</code>.</p>
-<pre class="programlisting"># $Id: sqltool.rc 5871 2018-12-22 16:56:06Z unsaved $
+<pre class="programlisting"># $Id: sqltool.rc 6381 2021-11-18 21:45:56Z unsaved $
 
 # This is a sample RC configuration file used by SqlTool, DatabaseManager,
 # and any other program that uses the org.hsqldb.lib.RCData class.
 # See the documentation for SqlTool for various ways to use this file.
+# This is not a Java Properties file. It uses a custom format with stanzas,
+# similar to .netrc files.
 
 # If you have the least concerns about security, then secure access to
 # your RC file.
@@ -528,6 +530,41 @@ server.database.0=file:db0/db0
 #    liberal patterns, and override settings later in the file with more
 #    specific (or exact) patterns.
 
+# Since service discovery works great in all JREs for many years now, I
+# have removed all 'driver' specifications here.  JRE discover will
+# automatically resolve the driver class based on the JDBC URL format.
+# Most people use default ports, so I have removed port specification from
+# examples except for Microsoft's Sql Server driver where you can't depend
+# on a default port.
+# In all cases, to specify a non-default port, insert colon and port number
+# after the hostname or ip address in the JDBC URL, like
+# jdbc:hsqldb:hsql://localhost:9977 or
+# jdbc:sqlserver://hostname.admc.com:1433;databaseName=dbname
+
+# Amazon Aurora instances are access from JDBC exactly the same as the
+# non-Aurora RDS counterpart.
+
+# For using any database engine other than HyperSQL, you must add the
+# JDBC jar file and the SqlTool jar to your CLASSPATH then run a command like:
+#     java org.hsqldb.util.SqlTool...
+# I.e., the "-jar" switch doesn't support modified classpath.
+# (See SqlTool manual for how to do same thing using Java modules.)
+# To oversimplify for non-developers, the two most common methods to set
+# CLASSPATH for an executable tool like SqlTool are to either use the java
+# "-cp" switch or set environmental variable CLASSPATH.
+# Windows users can use graphical UI or CLI "set".  Unix shell users must
+# "export" in addition to assigning.
+#
+# All JDBC jar files used in these examples are available from Maven
+# repositories.  You can also get them from vendor web sites or with product
+# bundles (especially database distributions).
+# Most databases provide multiple variants.  Most people will want a type 4
+# driver supporting your connection mechanism (most commonly TCP/IP service,
+# but also database file access and others) and your client JRE version.
+# By convention the variants are distinguished in segments of the jar file
+# name before the final ".jar" .
+
+
 # Global default.  .+ matches all lookups:
 urlid .+ 
 username SA
@@ -541,7 +578,7 @@ url jdbc:hsqldb:mem:memdbid
 # A personal, local, persistent database.
 # Inherits username and password from default setting above.
 urlid personal
-url jdbc:hsqldb:file:${user.home}/db/personal;shutdown=true
+url jdbc:hsqldb:file:${user.home}/db/personal;shutdown=true;ifexist=true
 transiso TRANSACTION_READ_COMMITTED
 # When connecting directly to a file database like this, you should 
 # use the shutdown connection property like this to shut down the DB
@@ -550,36 +587,25 @@ transiso TRANSACTION_READ_COMMITTED
 # This is for a hsqldb Server running with default settings on your local
 # computer (and for which you have not changed the password for "SA").
 # Inherits username and password from default setting above.
+# Default port 9001
 urlid localhost-sa
 url jdbc:hsqldb:hsql://localhost
 
 
 
 # Template for a urlid for an Oracle database.
-# You will need to put the oracle.jdbc.OracleDriver class into your 
-# classpath.
-# In the great majority of cases, you want to use jhe desired version of a
-# file odbc*.jar (previously JDBC distributed as classes12.zip),
-# which you can get from the directory $ORACLE_HOME/jdbc/lib of any
-# Oracle installation compatible with your server.
-# Since you need to add to the classpath, you can't invoke SqlTool with
-# the jar switch, like "java -jar .../sqltool.jar...".
-# Put both the SqlTool jar and odbc*.jar in your classpath (and export!)
-# and run something like "java org.hsqldb.util.SqlTool...".
+# Driver jar files from this century have format like "ojbc*.jar".
+# Default port 1521
+urlid localhost-sa
+# Avoid older drivers because they have quirks.
 # You could use the thick driver instead of the thin, but I know of no reason
 # why any Java app should.
 
 #urlid cardiff2
-#url jdbc:oracle:thin:@aegir.admc.com:1521:TRAFFIC_SID
-# Thin SID URLs must specify both port and SID, there are no defaults.
-# Oracle listens to 1521 by default, so that's what you will usually specify.
-# But can alternatively use global service name (not tnsnames.ora service
-# alias, in which case the port does default to 1521):
-#url jdbc:oracle:thin:@centos.admc.com/tstsid.admc
+# Can identify target database with either SID or global service name.
+#url jdbc:oracle:thin:@//centos.admc.com/tstsid.admc
 #username blaine
-#password secretpassword
-#driver oracle.jdbc.OracleDriver
-
+#password asecret
 
 
 # Template for a TLS-encrypted HSQLDB Server.
@@ -589,6 +615,7 @@ url jdbc:hsqldb:hsql://localhost
 # You only need to set "truststore" if the server cert is not approved by
 # your system default truststore (which a commercial certificate probably
 # would be).
+# Port defaults to 554.
 
 #urlid tls
 #url jdbc:hsqldb:hsqls://db.admc.com:9001/lm2
@@ -598,77 +625,84 @@ url jdbc:hsqldb:hsql://localhost
 
 
 # Template for a Postgresql database
+# Driver jar files are of format like "postgresql-*.jar"
+# Port defaults to 5432.
 #urlid blainedb
 #url jdbc:postgresql://idun.africawork.org/blainedb
 #username blaine
-#password losung1
-#driver org.postgresql.Driver
+#password asecret
+
+# Amazon RedShift (a fork of Postgresql)
+# Driver jar files are of format like "redshift-jdbc*.jar"
+# Port defaults to 5439.
+#urlid redhshift
+#url jdbc:redshift://clustername.hex.us-east-1.redshift.amazonaws.com/dev
+#username awsuser
+#password asecret
 
 # Template for a MySQL database.  MySQL has poor JDBC support.
+# The latest driver jar files are of format like "mysql-jdbc*.jar", but not
+# long ago they were like "mysql-connector-java*.jar".
+# Port defaults to 3306
 #urlid mysql-testdb
-#url jdbc:mysql://hostname:3306/dbname
+#url jdbc:mysql://hostname/dbname
 #username root
-#password hiddenpwd
-#driver com.mysql.jdbc.Driver
+#password asecret
+# Alternatively, you can access MySQL using jdbc:mariadb URLs and driver.
 
 # Note that "databases" in SQL Server and Sybase are traditionally used for
 # the same purpose as "schemas" with more SQL-compliant databases.
 
 # Template for a Microsoft SQL Server database using Microsoft's Driver
-# (I find that the JTDS driver is much more responsive than Microsoft's).
-# Port defaults to 1433.
+# Seems that some versions default to port 1433 and others to 1434.
 # MSDN implies instances are port-specific, so can specify port or instname.
 #urlid msprojsvr
-# url/driver for Current 2011 JDBC Driver for Microsoft SQL Server:
-# Requires just the new sqljdbc4.jar.  (Microsoft just loves back-slashes)
-#url jdbc:sqlserver://hostname\instname;databaseName=dbname
-# OR
+# Driver jar files are of format like "mssql-jdbc-*.jar".
+# Don't use older MS JDBC drivers (like SQL Server 2000 vintage) because they
+# are pitifully incompetent, handling transactions incorrectly.
+# I recommend that you do not use Microsoft's nonstandard format that
+# includes backslashes.
 #url jdbc:sqlserver://hostname;instanceName=instname;databaseName=dbname
-#driver com.microsoft.jdbc.sqlserver.SQLServerDriver
-# See, for example,
-# https://docs.microsoft.com/en-us/sql/connect/jdbc/building-the-connection-url?view=sql-server-2017
-# url/deriver for OLDER JDBC Driver:
-#url jdbc:microsoft:sqlserver://hostname;DatabaseName=DbName;SelectMethod=Cursor
-# The SelectMethod setting is required to do more than one thing on a JDBC
-# session (I guess Microsoft thought nobody would really use Java for 
-# anything other than a "hello world" program).
-# This is for Microsoft's SQL Server 2000 driver (requires mssqlserver.jar
-# and msutil.jar).
-#driver com.microsoft.jdbc.sqlserver.SQLServerDriver
+# with port:
+#url jdbc:sqlserver://hostname:1433;instanceName=instname;databaseName=dbname
 #username myuser
-#password hiddenpwd
+#password asecret
 
 # Template for Microsoft SQL Server database using the JTDS Driver
-# http://jtds.sourceforge.net  Jar file has name like "jtds-1.2.5.jar".
+# Looks like this project is no longer maintained, so you may be better off
+# using the Microsoft driver above.
+# http://jtds.sourceforge.net  Jar file has name like "jtds-1.3.1.jar".
 # Port defaults to 1433.
 # MSDN implies instances are port-specific, so can specify port or instname.
 #urlid nlyte
 #username myuser
-#password hiddenpwd
+#password asecret
 #url jdbc:jtds:sqlserver://myhost/nlyte;instance=MSSQLSERVER
 # Where database is 'nlyte' and instance is 'MSSQLSERVER'.
 # N.b. this is diff. from MS tools and JDBC driver where (depending on which
 # document you read), instance or database X are specified like  HOSTNAME\X.
-#driver net.sourceforge.jtds.jdbc.Driver
 
 # Template for a Sybase database
 #urlid sybase
 #url jdbc:sybase:Tds:hostname:4100/dbname
 #username blaine
-#password hiddenpwd
+#password asecret
 # This is for the jConnect driver (requires jconn3.jar).
-#driver com.sybase.jdbc3.jdbc.SybDriver
 
-# Template for Embedded Derby / Java DB.
-#urlid derby1
-#url jdbc:derby:path/to/derby/directory;create=true
+# Derby / Java DB.
+# Please see the Derby JDBC docs, because they have changed the organization
+# of their driver jar files in recent years.  Combining that with the different
+# database types supported and jar file classpath chaining, and it's not
+# feasible to document it adequately here.
+# I'll just give one example using network service, which works with 10.15.2.0.
+# Put files derbytools*.jar, derbyclient*.jar, derbyshared*.jar into a
+# directory and include the path to the derbytools.jar in your classpath.
+# Port defaults to 1527.
+#url jdbc:derby://server:&lt;port&gt;/databaseName
 #username ${user.name}
 #password any_noauthbydefault
-#driver org.apache.derby.jdbc.EmbeddedDriver
-# The embedded Derby driver requires derby.jar.
-# There'a also the org.apache.derby.jdbc.ClientDriver driver with URL
-# like jdbc:derby://&lt;server&gt;[:&lt;port&gt;]/databaseName, which requires
-# derbyclient.jar.
+# If you get the right classes into classpath, local file URLs are like:
+#url jdbc:derby:path/to/derby/directory
 # You can use \= to commit, since the Derby team decided (why???)
 # not to implement the SQL standard statement "commit"!!
 # Note that SqlTool can not shut down an embedded Derby database properly,
@@ -676,6 +710,16 @@ url jdbc:hsqldb:hsql://localhost
 # However, I've never lost data by shutting it down improperly.
 # Other than not supporting this quirk of Derby, SqlTool is miles ahead of
 # Derby's ij.
+
+# Maria DB
+# With current versions, the MySQL driver does not work to access a Maria
+# database (though the inverse works).
+# Driver jar files are of format like "mariadb-java-client*.jar"
+# Port defaults to 3306
+#urlid maria
+#url jdbc:mariadb://hostname/db2
+#username blaine
+#password asecret
 </pre>
 <p>We will be using the "localhost-sa" sample urlid definition from
     the config file. The JDBC URL for this urlid is
@@ -804,7 +848,7 @@ url jdbc:hsqldb:hsql://localhost
 </div>
 </div>
 </div>
-<a name="N174DB" class="indexterm"></a>
+<a name="N1775D" class="indexterm"></a>
 <p>You can, of course, run HSQLDB through inittab on System V
     UNIXes, but usually an init script is more convenient and manageable. This
     section explains how to set up and use our UNIX init script. Our init
@@ -927,7 +971,7 @@ url jdbc:hsqldb:hsql://localhost
           catalog. You must supply for this catalog, a hsql: JDBC URL, an
           administrative user name, and the password.</p>
 <div class="example">
-<a name="N17557"></a>
+<a name="N177D9"></a>
 <p class="title">
 <b>Example&nbsp;16.1.&nbsp;example sqltool.rc stanza</b>
 </p>
@@ -943,13 +987,13 @@ url jdbc:hsqldb:hsql://localhost
 <li class="step">
 <p>Look at the comment towards the top of the init script
           which lists recommended locations for the configuration file for
-          various UNIX platforms. Copy the sample config file <code class="filename"><a class="filename" href="filelinks-app.html#hsqldb.cfg-link">sample/hsqldb.cfg</a></code> to one of
+          various UNIX platforms. Copy the sample config file <code class="filename"><a class="filename" href="filelinks-app.html#hsqldb.conf-link">sample/hsqldb.conf</a></code> to one of
           the listed locations (your choice). Edit the config file according
           to the instructions in it. For our example, you will set the value
           of <code class="varname">URLIDS</code> to <code class="literal">localhostdb1</code>,
           since that is the urlid name that we used in the
           <code class="filename">sqltool.rc</code> file.</p>
-<pre class="programlisting"># $Id: hsqldb.cfg 3583 2010-05-16 01:49:52Z unsaved $
+<pre class="programlisting"># $Id: hsqldb.conf 6310 2021-02-28 15:25:00Z unsaved $
 
 # Sample configuration file for HyperSQL Server Listener.
 # See the "HyperSQL on UNIX" chapter of the HyperSQL User Guide.
@@ -1251,7 +1295,7 @@ URLIDS='localhostdb1'
     <code class="filename">/sample/hsqldb.init</code> over top of of your init script
     (wherever it runs from). Then update your old config file according to the
     instructions in the new config file template at
-    <code class="filename">sample/hsqldb.cfg</code>. You will have to change very few
+    <code class="filename">sample/hsqldb.conf</code>. You will have to change very few
     settings. If you are upgrading from a pre-2.0 installation to a post-2.0
     installation, you will need to (1) add the setting
     <code class="varname">URLIDS</code>, as described above and in the inline comments,
@@ -1264,7 +1308,7 @@ URLIDS='localhostdb1'
 </div>
 </div>
 <HR xmlns:xi="http://www.w3.org/2001/XInclude">
-<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6369 $</P>
+<P xmlns:xi="http://www.w3.org/2001/XInclude" class="svnrev">$Revision: 6474 $</P>
 <div class="navfooter">
 <hr>
 <table summary="Navigation footer" width="100%">
diff -pruN 2.6.1-1/hsqldb/doc/hsqldb_lic.txt 2.7.0-1/hsqldb/doc/hsqldb_lic.txt
--- 2.6.1-1/hsqldb/doc/hsqldb_lic.txt	2021-10-20 09:34:48.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/hsqldb_lic.txt	2022-07-26 20:22:38.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
diff -pruN 2.6.1-1/hsqldb/doc/hypersonic_lic.txt 2.7.0-1/hsqldb/doc/hypersonic_lic.txt
--- 2.6.1-1/hsqldb/doc/hypersonic_lic.txt	2021-10-20 09:34:48.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/hypersonic_lic.txt	2022-07-26 20:22:38.000000000 +0000
@@ -1,7 +1,7 @@
 /*
  * For work developed by the HSQL Development Group:
  *
- * Copyright (c) 2001-2021, The HSQL Development Group
+ * Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
diff -pruN 2.6.1-1/hsqldb/doc/index.html 2.7.0-1/hsqldb/doc/index.html
--- 2.6.1-1/hsqldb/doc/index.html	2021-10-20 09:34:48.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/index.html	2022-07-26 20:22:38.000000000 +0000
@@ -5,9 +5,9 @@
 </head>
 
 <body>
-<h3>HyperSQL version 2.6.0 Documentation</h3>
+<h3>HyperSQL version 2.7.0 Documentation</h3>
 <p>HSQLDB (HyperSQL Database) is a relational database engine
-written in Java. Version 2.6.0 is the result of 10 years development
+written in Java. Version 2.7.0 is the result of 12 years development
 since version 2.0. It offers many features and adheres
 closely to the latest SQL:2016 and JDBC 4.2 standards.</p>
 <div class="section_title"> </div>
@@ -22,8 +22,12 @@ Utilities Guide</a> in HTML format.<br>
 <a href="util-guide/util-guide.pdf">HyperSQL Utilities
 Guide</a> in PDF format.
 </p>
-<p>The <a href="apidocs/index.html">JavaDoc</a>
-for public classes, including the JDBC documentation.
+<p>The JavaDoc for public classes, including the JDBC documentation.
+</p>
+<p>
+<a href="apidocs/index.html"> HyperSQL Database Javadoc</a>
+</p><p>
+<a href="apidocssqltool/index.html"> SqlTool Javadoc</a>
 </p>
 <p>Chronological list of changes and bug fixes since the
 release of version 2.0 <a href="changelist_2_0.txt">changelist_2_0.txt</a>
@@ -37,5 +41,5 @@ for sources that contain code from the c
 in various forms, including a mailing list and user forums. The web
 site features the latest bugfix versions of the software, FAQ and other
 useful resources.</p>
-<p>$Date: 2021-01-29 14:39:07 +0000 (Fri, 29 Jan 2021) $</p>
+<p>$Date: 2022-04-18 21:21:19 +0100 (Mon, 18 Apr 2022) $</p>
 </body></html>
diff -pruN 2.6.1-1/hsqldb/doc/readme-docauthors.txt 2.7.0-1/hsqldb/doc/readme-docauthors.txt
--- 2.6.1-1/hsqldb/doc/readme-docauthors.txt	2021-10-20 09:34:48.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/readme-docauthors.txt	2022-07-26 20:22:38.000000000 +0000
@@ -1,8 +1,8 @@
-$Id: readme-docauthors.txt 6285 2021-02-02 13:08:51Z fredt $
+$Id: readme-docauthors.txt 6486 2022-04-18 20:21:19Z fredt $
 
 BUILDING
 
-You need JDK 1.8 or later and Ant 9.x or later.
+You need JDK 11 and Ant 10.x or later.
 
 Run "ant gen-docs" from the build subdirectory.
 Error messages should be self-explanatory.
diff -pruN 2.6.1-1/hsqldb/doc/util-guide/dbm-chapt.html 2.7.0-1/hsqldb/doc/util-guide/dbm-chapt.html
--- 2.6.1-1/hsqldb/doc/util-guide/dbm-chapt.html	2021-10-20 09:34:38.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/util-guide/dbm-chapt.html	2022-07-26 20:22:30.000000000 +0000
@@ -56,7 +56,7 @@
 <p class="releaseinfo">$Revision: 6065 $</p>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
diff -pruN 2.6.1-1/hsqldb/doc/util-guide/index.html 2.7.0-1/hsqldb/doc/util-guide/index.html
--- 2.6.1-1/hsqldb/doc/util-guide/index.html	2021-10-20 09:34:38.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/util-guide/index.html	2022-07-26 20:22:30.000000000 +0000
@@ -71,7 +71,7 @@
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </td><td class="sponsorad">
 <div xml:base="../doc-src/branding-frag.xhtml" class="branding">
diff -pruN 2.6.1-1/hsqldb/doc/util-guide/sqltool-chapt.html 2.7.0-1/hsqldb/doc/util-guide/sqltool-chapt.html
--- 2.6.1-1/hsqldb/doc/util-guide/sqltool-chapt.html	2021-10-20 09:35:06.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/util-guide/sqltool-chapt.html	2022-07-26 20:23:04.000000000 +0000
@@ -52,7 +52,7 @@
 <p class="releaseinfo">$Revision: 6319 $</p>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -1553,11 +1553,13 @@
 <b>Example&nbsp;1.1.&nbsp;Sample RC File</b>
 </p>
 <div class="example-contents">
-<pre class="programlisting"># $Id: sqltool.rc 5871 2018-12-22 16:56:06Z unsaved $
+<pre class="programlisting"># $Id: sqltool.rc 6381 2021-11-18 21:45:56Z unsaved $
 
 # This is a sample RC configuration file used by SqlTool, DatabaseManager,
 # and any other program that uses the org.hsqldb.lib.RCData class.
 # See the documentation for SqlTool for various ways to use this file.
+# This is not a Java Properties file. It uses a custom format with stanzas,
+# similar to .netrc files.
 
 # If you have the least concerns about security, then secure access to
 # your RC file.
@@ -1595,6 +1597,41 @@
 #    liberal patterns, and override settings later in the file with more
 #    specific (or exact) patterns.
 
+# Since service discovery works great in all JREs for many years now, I
+# have removed all 'driver' specifications here.  JRE discover will
+# automatically resolve the driver class based on the JDBC URL format.
+# Most people use default ports, so I have removed port specification from
+# examples except for Microsoft's Sql Server driver where you can't depend
+# on a default port.
+# In all cases, to specify a non-default port, insert colon and port number
+# after the hostname or ip address in the JDBC URL, like
+# jdbc:hsqldb:hsql://localhost:9977 or
+# jdbc:sqlserver://hostname.admc.com:1433;databaseName=dbname
+
+# Amazon Aurora instances are access from JDBC exactly the same as the
+# non-Aurora RDS counterpart.
+
+# For using any database engine other than HyperSQL, you must add the
+# JDBC jar file and the SqlTool jar to your CLASSPATH then run a command like:
+#     java org.hsqldb.util.SqlTool...
+# I.e., the "-jar" switch doesn't support modified classpath.
+# (See SqlTool manual for how to do same thing using Java modules.)
+# To oversimplify for non-developers, the two most common methods to set
+# CLASSPATH for an executable tool like SqlTool are to either use the java
+# "-cp" switch or set environmental variable CLASSPATH.
+# Windows users can use graphical UI or CLI "set".  Unix shell users must
+# "export" in addition to assigning.
+#
+# All JDBC jar files used in these examples are available from Maven
+# repositories.  You can also get them from vendor web sites or with product
+# bundles (especially database distributions).
+# Most databases provide multiple variants.  Most people will want a type 4
+# driver supporting your connection mechanism (most commonly TCP/IP service,
+# but also database file access and others) and your client JRE version.
+# By convention the variants are distinguished in segments of the jar file
+# name before the final ".jar" .
+
+
 # Global default.  .+ matches all lookups:
 urlid .+ 
 username SA
@@ -1608,7 +1645,7 @@ url jdbc:hsqldb:mem:memdbid
 # A personal, local, persistent database.
 # Inherits username and password from default setting above.
 urlid personal
-url jdbc:hsqldb:file:${user.home}/db/personal;shutdown=true
+url jdbc:hsqldb:file:${user.home}/db/personal;shutdown=true;ifexist=true
 transiso TRANSACTION_READ_COMMITTED
 # When connecting directly to a file database like this, you should 
 # use the shutdown connection property like this to shut down the DB
@@ -1617,36 +1654,25 @@ transiso TRANSACTION_READ_COMMITTED
 # This is for a hsqldb Server running with default settings on your local
 # computer (and for which you have not changed the password for "SA").
 # Inherits username and password from default setting above.
+# Default port 9001
 urlid localhost-sa
 url jdbc:hsqldb:hsql://localhost
 
 
 
 # Template for a urlid for an Oracle database.
-# You will need to put the oracle.jdbc.OracleDriver class into your 
-# classpath.
-# In the great majority of cases, you want to use jhe desired version of a
-# file odbc*.jar (previously JDBC distributed as classes12.zip),
-# which you can get from the directory $ORACLE_HOME/jdbc/lib of any
-# Oracle installation compatible with your server.
-# Since you need to add to the classpath, you can't invoke SqlTool with
-# the jar switch, like "java -jar .../sqltool.jar...".
-# Put both the SqlTool jar and odbc*.jar in your classpath (and export!)
-# and run something like "java org.hsqldb.util.SqlTool...".
+# Driver jar files from this century have format like "ojbc*.jar".
+# Default port 1521
+urlid localhost-sa
+# Avoid older drivers because they have quirks.
 # You could use the thick driver instead of the thin, but I know of no reason
 # why any Java app should.
 
 #urlid cardiff2
-#url jdbc:oracle:thin:@aegir.admc.com:1521:TRAFFIC_SID
-# Thin SID URLs must specify both port and SID, there are no defaults.
-# Oracle listens to 1521 by default, so that's what you will usually specify.
-# But can alternatively use global service name (not tnsnames.ora service
-# alias, in which case the port does default to 1521):
-#url jdbc:oracle:thin:@centos.admc.com/tstsid.admc
+# Can identify target database with either SID or global service name.
+#url jdbc:oracle:thin:@//centos.admc.com/tstsid.admc
 #username blaine
-#password secretpassword
-#driver oracle.jdbc.OracleDriver
-
+#password asecret
 
 
 # Template for a TLS-encrypted HSQLDB Server.
@@ -1656,6 +1682,7 @@ url jdbc:hsqldb:hsql://localhost
 # You only need to set "truststore" if the server cert is not approved by
 # your system default truststore (which a commercial certificate probably
 # would be).
+# Port defaults to 554.
 
 #urlid tls
 #url jdbc:hsqldb:hsqls://db.admc.com:9001/lm2
@@ -1665,77 +1692,84 @@ url jdbc:hsqldb:hsql://localhost
 
 
 # Template for a Postgresql database
+# Driver jar files are of format like "postgresql-*.jar"
+# Port defaults to 5432.
 #urlid blainedb
 #url jdbc:postgresql://idun.africawork.org/blainedb
 #username blaine
-#password losung1
-#driver org.postgresql.Driver
+#password asecret
+
+# Amazon RedShift (a fork of Postgresql)
+# Driver jar files are of format like "redshift-jdbc*.jar"
+# Port defaults to 5439.
+#urlid redhshift
+#url jdbc:redshift://clustername.hex.us-east-1.redshift.amazonaws.com/dev
+#username awsuser
+#password asecret
 
 # Template for a MySQL database.  MySQL has poor JDBC support.
+# The latest driver jar files are of format like "mysql-jdbc*.jar", but not
+# long ago they were like "mysql-connector-java*.jar".
+# Port defaults to 3306
 #urlid mysql-testdb
-#url jdbc:mysql://hostname:3306/dbname
+#url jdbc:mysql://hostname/dbname
 #username root
-#password hiddenpwd
-#driver com.mysql.jdbc.Driver
+#password asecret
+# Alternatively, you can access MySQL using jdbc:mariadb URLs and driver.
 
 # Note that "databases" in SQL Server and Sybase are traditionally used for
 # the same purpose as "schemas" with more SQL-compliant databases.
 
 # Template for a Microsoft SQL Server database using Microsoft's Driver
-# (I find that the JTDS driver is much more responsive than Microsoft's).
-# Port defaults to 1433.
+# Seems that some versions default to port 1433 and others to 1434.
 # MSDN implies instances are port-specific, so can specify port or instname.
 #urlid msprojsvr
-# url/driver for Current 2011 JDBC Driver for Microsoft SQL Server:
-# Requires just the new sqljdbc4.jar.  (Microsoft just loves back-slashes)
-#url jdbc:sqlserver://hostname\instname;databaseName=dbname
-# OR
+# Driver jar files are of format like "mssql-jdbc-*.jar".
+# Don't use older MS JDBC drivers (like SQL Server 2000 vintage) because they
+# are pitifully incompetent, handling transactions incorrectly.
+# I recommend that you do not use Microsoft's nonstandard format that
+# includes backslashes.
 #url jdbc:sqlserver://hostname;instanceName=instname;databaseName=dbname
-#driver com.microsoft.jdbc.sqlserver.SQLServerDriver
-# See, for example,
-# https://docs.microsoft.com/en-us/sql/connect/jdbc/building-the-connection-url?view=sql-server-2017
-# url/deriver for OLDER JDBC Driver:
-#url jdbc:microsoft:sqlserver://hostname;DatabaseName=DbName;SelectMethod=Cursor
-# The SelectMethod setting is required to do more than one thing on a JDBC
-# session (I guess Microsoft thought nobody would really use Java for 
-# anything other than a "hello world" program).
-# This is for Microsoft's SQL Server 2000 driver (requires mssqlserver.jar
-# and msutil.jar).
-#driver com.microsoft.jdbc.sqlserver.SQLServerDriver
+# with port:
+#url jdbc:sqlserver://hostname:1433;instanceName=instname;databaseName=dbname
 #username myuser
-#password hiddenpwd
+#password asecret
 
 # Template for Microsoft SQL Server database using the JTDS Driver
-# http://jtds.sourceforge.net  Jar file has name like "jtds-1.2.5.jar".
+# Looks like this project is no longer maintained, so you may be better off
+# using the Microsoft driver above.
+# http://jtds.sourceforge.net  Jar file has name like "jtds-1.3.1.jar".
 # Port defaults to 1433.
 # MSDN implies instances are port-specific, so can specify port or instname.
 #urlid nlyte
 #username myuser
-#password hiddenpwd
+#password asecret
 #url jdbc:jtds:sqlserver://myhost/nlyte;instance=MSSQLSERVER
 # Where database is 'nlyte' and instance is 'MSSQLSERVER'.
 # N.b. this is diff. from MS tools and JDBC driver where (depending on which
 # document you read), instance or database X are specified like  HOSTNAME\X.
-#driver net.sourceforge.jtds.jdbc.Driver
 
 # Template for a Sybase database
 #urlid sybase
 #url jdbc:sybase:Tds:hostname:4100/dbname
 #username blaine
-#password hiddenpwd
+#password asecret
 # This is for the jConnect driver (requires jconn3.jar).
-#driver com.sybase.jdbc3.jdbc.SybDriver
 
-# Template for Embedded Derby / Java DB.
-#urlid derby1
-#url jdbc:derby:path/to/derby/directory;create=true
+# Derby / Java DB.
+# Please see the Derby JDBC docs, because they have changed the organization
+# of their driver jar files in recent years.  Combining that with the different
+# database types supported and jar file classpath chaining, and it's not
+# feasible to document it adequately here.
+# I'll just give one example using network service, which works with 10.15.2.0.
+# Put files derbytools*.jar, derbyclient*.jar, derbyshared*.jar into a
+# directory and include the path to the derbytools.jar in your classpath.
+# Port defaults to 1527.
+#url jdbc:derby://server:&lt;port&gt;/databaseName
 #username ${user.name}
 #password any_noauthbydefault
-#driver org.apache.derby.jdbc.EmbeddedDriver
-# The embedded Derby driver requires derby.jar.
-# There'a also the org.apache.derby.jdbc.ClientDriver driver with URL
-# like jdbc:derby://&lt;server&gt;[:&lt;port&gt;]/databaseName, which requires
-# derbyclient.jar.
+# If you get the right classes into classpath, local file URLs are like:
+#url jdbc:derby:path/to/derby/directory
 # You can use \= to commit, since the Derby team decided (why???)
 # not to implement the SQL standard statement "commit"!!
 # Note that SqlTool can not shut down an embedded Derby database properly,
@@ -1743,6 +1777,16 @@ url jdbc:hsqldb:hsql://localhost
 # However, I've never lost data by shutting it down improperly.
 # Other than not supporting this quirk of Derby, SqlTool is miles ahead of
 # Derby's ij.
+
+# Maria DB
+# With current versions, the MySQL driver does not work to access a Maria
+# database (though the inverse works).
+# Driver jar files are of format like "mariadb-java-client*.jar"
+# Port defaults to 3306
+#urlid maria
+#url jdbc:mariadb://hostname/db2
+#username blaine
+#password asecret
 </pre>
 </div>
 </div>
@@ -6732,7 +6776,7 @@ SELECT * FROM *{MYTABLE};
 </p>
 <div class="example-contents">
 <pre class="programlisting">/*
- * $Id: plsql.sql 610 2008-12-22 15:54:18Z unsaved $
+ * $Id: plsql.sql 6375 2021-11-07 17:44:56Z unsaved $
  *
  * This example is copied from the "Simple Programs in PL/SQL"
  * example by Yu-May Chang, Jeff Ullman, Prof. Jennifer Widom at
@@ -6760,19 +6804,12 @@ INSERT INTO T1 VALUES(2, 4);
 
 /* Above is plain SQL; below is the PL/SQL program. */
 DECLARE
-
     a NUMBER;
-
     b NUMBER;
-
 BEGIN
-
     SELECT e,f INTO a,b FROM T1 WHERE e&gt;1;
-
     INSERT INTO T1 VALUES(b,a);
-
 END;
-
 .;
 /** The statement on the previous line, ".;" is SqlTool specific.
  *  This command says to save the input up to this point to the
diff -pruN 2.6.1-1/hsqldb/doc/util-guide/transfer-tool-chapt.html 2.7.0-1/hsqldb/doc/util-guide/transfer-tool-chapt.html
--- 2.6.1-1/hsqldb/doc/util-guide/transfer-tool-chapt.html	2021-10-20 09:34:38.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/util-guide/transfer-tool-chapt.html	2022-07-26 20:22:30.000000000 +0000
@@ -47,7 +47,7 @@
 <p class="releaseinfo">$Revision: 6065 $</p>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
diff -pruN 2.6.1-1/hsqldb/doc/util-guide/util-guide.html 2.7.0-1/hsqldb/doc/util-guide/util-guide.html
--- 2.6.1-1/hsqldb/doc/util-guide/util-guide.html	2021-10-20 09:35:06.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/util-guide/util-guide.html	2022-07-26 20:23:04.000000000 +0000
@@ -58,7 +58,7 @@
 </div>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </td><td class="sponsorad">
 <div xml:base="../doc-src/branding-frag.xhtml" class="branding">
@@ -569,7 +569,7 @@
 <p class="releaseinfo">$Revision: 6319 $</p>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -2070,11 +2070,13 @@
 <b>Example&nbsp;1.1.&nbsp;Sample RC File</b>
 </p>
 <div class="example-contents">
-<pre class="programlisting"># $Id: sqltool.rc 5871 2018-12-22 16:56:06Z unsaved $
+<pre class="programlisting"># $Id: sqltool.rc 6381 2021-11-18 21:45:56Z unsaved $
 
 # This is a sample RC configuration file used by SqlTool, DatabaseManager,
 # and any other program that uses the org.hsqldb.lib.RCData class.
 # See the documentation for SqlTool for various ways to use this file.
+# This is not a Java Properties file. It uses a custom format with stanzas,
+# similar to .netrc files.
 
 # If you have the least concerns about security, then secure access to
 # your RC file.
@@ -2112,6 +2114,41 @@
 #    liberal patterns, and override settings later in the file with more
 #    specific (or exact) patterns.
 
+# Since service discovery works great in all JREs for many years now, I
+# have removed all 'driver' specifications here.  JRE discover will
+# automatically resolve the driver class based on the JDBC URL format.
+# Most people use default ports, so I have removed port specification from
+# examples except for Microsoft's Sql Server driver where you can't depend
+# on a default port.
+# In all cases, to specify a non-default port, insert colon and port number
+# after the hostname or ip address in the JDBC URL, like
+# jdbc:hsqldb:hsql://localhost:9977 or
+# jdbc:sqlserver://hostname.admc.com:1433;databaseName=dbname
+
+# Amazon Aurora instances are access from JDBC exactly the same as the
+# non-Aurora RDS counterpart.
+
+# For using any database engine other than HyperSQL, you must add the
+# JDBC jar file and the SqlTool jar to your CLASSPATH then run a command like:
+#     java org.hsqldb.util.SqlTool...
+# I.e., the "-jar" switch doesn't support modified classpath.
+# (See SqlTool manual for how to do same thing using Java modules.)
+# To oversimplify for non-developers, the two most common methods to set
+# CLASSPATH for an executable tool like SqlTool are to either use the java
+# "-cp" switch or set environmental variable CLASSPATH.
+# Windows users can use graphical UI or CLI "set".  Unix shell users must
+# "export" in addition to assigning.
+#
+# All JDBC jar files used in these examples are available from Maven
+# repositories.  You can also get them from vendor web sites or with product
+# bundles (especially database distributions).
+# Most databases provide multiple variants.  Most people will want a type 4
+# driver supporting your connection mechanism (most commonly TCP/IP service,
+# but also database file access and others) and your client JRE version.
+# By convention the variants are distinguished in segments of the jar file
+# name before the final ".jar" .
+
+
 # Global default.  .+ matches all lookups:
 urlid .+ 
 username SA
@@ -2125,7 +2162,7 @@ url jdbc:hsqldb:mem:memdbid
 # A personal, local, persistent database.
 # Inherits username and password from default setting above.
 urlid personal
-url jdbc:hsqldb:file:${user.home}/db/personal;shutdown=true
+url jdbc:hsqldb:file:${user.home}/db/personal;shutdown=true;ifexist=true
 transiso TRANSACTION_READ_COMMITTED
 # When connecting directly to a file database like this, you should 
 # use the shutdown connection property like this to shut down the DB
@@ -2134,36 +2171,25 @@ transiso TRANSACTION_READ_COMMITTED
 # This is for a hsqldb Server running with default settings on your local
 # computer (and for which you have not changed the password for "SA").
 # Inherits username and password from default setting above.
+# Default port 9001
 urlid localhost-sa
 url jdbc:hsqldb:hsql://localhost
 
 
 
 # Template for a urlid for an Oracle database.
-# You will need to put the oracle.jdbc.OracleDriver class into your 
-# classpath.
-# In the great majority of cases, you want to use jhe desired version of a
-# file odbc*.jar (previously JDBC distributed as classes12.zip),
-# which you can get from the directory $ORACLE_HOME/jdbc/lib of any
-# Oracle installation compatible with your server.
-# Since you need to add to the classpath, you can't invoke SqlTool with
-# the jar switch, like "java -jar .../sqltool.jar...".
-# Put both the SqlTool jar and odbc*.jar in your classpath (and export!)
-# and run something like "java org.hsqldb.util.SqlTool...".
+# Driver jar files from this century have format like "ojbc*.jar".
+# Default port 1521
+urlid localhost-sa
+# Avoid older drivers because they have quirks.
 # You could use the thick driver instead of the thin, but I know of no reason
 # why any Java app should.
 
 #urlid cardiff2
-#url jdbc:oracle:thin:@aegir.admc.com:1521:TRAFFIC_SID
-# Thin SID URLs must specify both port and SID, there are no defaults.
-# Oracle listens to 1521 by default, so that's what you will usually specify.
-# But can alternatively use global service name (not tnsnames.ora service
-# alias, in which case the port does default to 1521):
-#url jdbc:oracle:thin:@centos.admc.com/tstsid.admc
+# Can identify target database with either SID or global service name.
+#url jdbc:oracle:thin:@//centos.admc.com/tstsid.admc
 #username blaine
-#password secretpassword
-#driver oracle.jdbc.OracleDriver
-
+#password asecret
 
 
 # Template for a TLS-encrypted HSQLDB Server.
@@ -2173,6 +2199,7 @@ url jdbc:hsqldb:hsql://localhost
 # You only need to set "truststore" if the server cert is not approved by
 # your system default truststore (which a commercial certificate probably
 # would be).
+# Port defaults to 554.
 
 #urlid tls
 #url jdbc:hsqldb:hsqls://db.admc.com:9001/lm2
@@ -2182,77 +2209,84 @@ url jdbc:hsqldb:hsql://localhost
 
 
 # Template for a Postgresql database
+# Driver jar files are of format like "postgresql-*.jar"
+# Port defaults to 5432.
 #urlid blainedb
 #url jdbc:postgresql://idun.africawork.org/blainedb
 #username blaine
-#password losung1
-#driver org.postgresql.Driver
+#password asecret
+
+# Amazon RedShift (a fork of Postgresql)
+# Driver jar files are of format like "redshift-jdbc*.jar"
+# Port defaults to 5439.
+#urlid redhshift
+#url jdbc:redshift://clustername.hex.us-east-1.redshift.amazonaws.com/dev
+#username awsuser
+#password asecret
 
 # Template for a MySQL database.  MySQL has poor JDBC support.
+# The latest driver jar files are of format like "mysql-jdbc*.jar", but not
+# long ago they were like "mysql-connector-java*.jar".
+# Port defaults to 3306
 #urlid mysql-testdb
-#url jdbc:mysql://hostname:3306/dbname
+#url jdbc:mysql://hostname/dbname
 #username root
-#password hiddenpwd
-#driver com.mysql.jdbc.Driver
+#password asecret
+# Alternatively, you can access MySQL using jdbc:mariadb URLs and driver.
 
 # Note that "databases" in SQL Server and Sybase are traditionally used for
 # the same purpose as "schemas" with more SQL-compliant databases.
 
 # Template for a Microsoft SQL Server database using Microsoft's Driver
-# (I find that the JTDS driver is much more responsive than Microsoft's).
-# Port defaults to 1433.
+# Seems that some versions default to port 1433 and others to 1434.
 # MSDN implies instances are port-specific, so can specify port or instname.
 #urlid msprojsvr
-# url/driver for Current 2011 JDBC Driver for Microsoft SQL Server:
-# Requires just the new sqljdbc4.jar.  (Microsoft just loves back-slashes)
-#url jdbc:sqlserver://hostname\instname;databaseName=dbname
-# OR
+# Driver jar files are of format like "mssql-jdbc-*.jar".
+# Don't use older MS JDBC drivers (like SQL Server 2000 vintage) because they
+# are pitifully incompetent, handling transactions incorrectly.
+# I recommend that you do not use Microsoft's nonstandard format that
+# includes backslashes.
 #url jdbc:sqlserver://hostname;instanceName=instname;databaseName=dbname
-#driver com.microsoft.jdbc.sqlserver.SQLServerDriver
-# See, for example,
-# https://docs.microsoft.com/en-us/sql/connect/jdbc/building-the-connection-url?view=sql-server-2017
-# url/deriver for OLDER JDBC Driver:
-#url jdbc:microsoft:sqlserver://hostname;DatabaseName=DbName;SelectMethod=Cursor
-# The SelectMethod setting is required to do more than one thing on a JDBC
-# session (I guess Microsoft thought nobody would really use Java for 
-# anything other than a "hello world" program).
-# This is for Microsoft's SQL Server 2000 driver (requires mssqlserver.jar
-# and msutil.jar).
-#driver com.microsoft.jdbc.sqlserver.SQLServerDriver
+# with port:
+#url jdbc:sqlserver://hostname:1433;instanceName=instname;databaseName=dbname
 #username myuser
-#password hiddenpwd
+#password asecret
 
 # Template for Microsoft SQL Server database using the JTDS Driver
-# http://jtds.sourceforge.net  Jar file has name like "jtds-1.2.5.jar".
+# Looks like this project is no longer maintained, so you may be better off
+# using the Microsoft driver above.
+# http://jtds.sourceforge.net  Jar file has name like "jtds-1.3.1.jar".
 # Port defaults to 1433.
 # MSDN implies instances are port-specific, so can specify port or instname.
 #urlid nlyte
 #username myuser
-#password hiddenpwd
+#password asecret
 #url jdbc:jtds:sqlserver://myhost/nlyte;instance=MSSQLSERVER
 # Where database is 'nlyte' and instance is 'MSSQLSERVER'.
 # N.b. this is diff. from MS tools and JDBC driver where (depending on which
 # document you read), instance or database X are specified like  HOSTNAME\X.
-#driver net.sourceforge.jtds.jdbc.Driver
 
 # Template for a Sybase database
 #urlid sybase
 #url jdbc:sybase:Tds:hostname:4100/dbname
 #username blaine
-#password hiddenpwd
+#password asecret
 # This is for the jConnect driver (requires jconn3.jar).
-#driver com.sybase.jdbc3.jdbc.SybDriver
 
-# Template for Embedded Derby / Java DB.
-#urlid derby1
-#url jdbc:derby:path/to/derby/directory;create=true
+# Derby / Java DB.
+# Please see the Derby JDBC docs, because they have changed the organization
+# of their driver jar files in recent years.  Combining that with the different
+# database types supported and jar file classpath chaining, and it's not
+# feasible to document it adequately here.
+# I'll just give one example using network service, which works with 10.15.2.0.
+# Put files derbytools*.jar, derbyclient*.jar, derbyshared*.jar into a
+# directory and include the path to the derbytools.jar in your classpath.
+# Port defaults to 1527.
+#url jdbc:derby://server:&lt;port&gt;/databaseName
 #username ${user.name}
 #password any_noauthbydefault
-#driver org.apache.derby.jdbc.EmbeddedDriver
-# The embedded Derby driver requires derby.jar.
-# There'a also the org.apache.derby.jdbc.ClientDriver driver with URL
-# like jdbc:derby://&lt;server&gt;[:&lt;port&gt;]/databaseName, which requires
-# derbyclient.jar.
+# If you get the right classes into classpath, local file URLs are like:
+#url jdbc:derby:path/to/derby/directory
 # You can use \= to commit, since the Derby team decided (why???)
 # not to implement the SQL standard statement "commit"!!
 # Note that SqlTool can not shut down an embedded Derby database properly,
@@ -2260,6 +2294,16 @@ url jdbc:hsqldb:hsql://localhost
 # However, I've never lost data by shutting it down improperly.
 # Other than not supporting this quirk of Derby, SqlTool is miles ahead of
 # Derby's ij.
+
+# Maria DB
+# With current versions, the MySQL driver does not work to access a Maria
+# database (though the inverse works).
+# Driver jar files are of format like "mariadb-java-client*.jar"
+# Port defaults to 3306
+#urlid maria
+#url jdbc:mariadb://hostname/db2
+#username blaine
+#password asecret
 </pre>
 </div>
 </div>
@@ -7249,7 +7293,7 @@ SELECT * FROM *{MYTABLE};
 </p>
 <div class="example-contents">
 <pre class="programlisting">/*
- * $Id: plsql.sql 610 2008-12-22 15:54:18Z unsaved $
+ * $Id: plsql.sql 6375 2021-11-07 17:44:56Z unsaved $
  *
  * This example is copied from the "Simple Programs in PL/SQL"
  * example by Yu-May Chang, Jeff Ullman, Prof. Jennifer Widom at
@@ -7277,19 +7321,12 @@ INSERT INTO T1 VALUES(2, 4);
 
 /* Above is plain SQL; below is the PL/SQL program. */
 DECLARE
-
     a NUMBER;
-
     b NUMBER;
-
 BEGIN
-
     SELECT e,f INTO a,b FROM T1 WHERE e&gt;1;
-
     INSERT INTO T1 VALUES(b,a);
-
 END;
-
 .;
 /** The statement on the previous line, ".;" is SqlTool specific.
  *  This command says to save the input up to this point to the
@@ -8426,7 +8463,7 @@ SELECT * FROM t;
 <p class="releaseinfo">$Revision: 6065 $</p>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
@@ -8850,7 +8887,7 @@ java org.hsqldb.util.DatabaseManagerSwin
 <p class="releaseinfo">$Revision: 6065 $</p>
 </div>
 <div>
-<p class="pubdate">2021-10-21</p>
+<p class="pubdate">2022-07-26</p>
 </div>
 </div>
 </div>
Binary files 2.6.1-1/hsqldb/doc/util-guide/util-guide.pdf and 2.7.0-1/hsqldb/doc/util-guide/util-guide.pdf differ
diff -pruN 2.6.1-1/hsqldb/doc/verbatim/sample/hsqldb.cfg 2.7.0-1/hsqldb/doc/verbatim/sample/hsqldb.cfg
--- 2.6.1-1/hsqldb/doc/verbatim/sample/hsqldb.cfg	2021-10-20 09:34:48.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/verbatim/sample/hsqldb.cfg	1970-01-01 00:00:00.000000000 +0000
@@ -1,173 +0,0 @@
-# $Id: hsqldb.cfg 3583 2010-05-16 01:49:52Z unsaved $
-
-# Sample configuration file for HyperSQL Server Listener.
-# See the "HyperSQL on UNIX" chapter of the HyperSQL User Guide.
-
-# N.b.!!!!  You must place this in the right location for your type of UNIX.
-# See the init script "hsqldb" to see where this must be placed and
-# what it should be renamed to.
-
-# This file is "sourced" by a Bourne shell, so use Bourne shell syntax.
-
-# This file WILL NOT WORK until you set (at least) the non-commented
-# variables to the appropriate values for your system.
-# Life will be easier if you avoid all filepaths with spaces or any other
-# funny characters.  Don't ask for support if you ignore this advice.
-
-# The URLIDS setting below is new and REQUIRED.  This setting replaces the
-# server.urlid.X settings which used to be needed in your Server's
-# properties file.
-
-# -- Blaine (blaine dot simpson at admc dot com)
-
-JAVA_EXECUTABLE=/usr/bin/java
-
-# Unless you copied the jar files from another system, this typically
-# resides at $HSQLDB_HOME/lib/sqltool.jar, where $HSQLDB_HOME is your HSQLDB
-# software base directory.
-# The file name may actually have a version label in it, like
-# sqltool-1.2.3.jar (in which case, you must specify the full name here).
-# A 'hsqldb.jar' file (with or without version label) must reside in the same
-# directory as the specified sqltool.jar file.
-SQLTOOL_JAR_PATH=/opt/hsqldb-2.0.0/hsqldb/lib/sqltool.jar
-# For the sample value above, there must also exist a file
-# /opt/hsqldb-2.0.0/hsqldb/lib/hsqldb*.jar.
-
-# Where the file "server.properties" or "webserver.properties" resides.
-SERVER_HOME=/opt/hsqldb-2.0.0/hsqldb/data
-
-# What UNIX user the server will run as.
-# (The shutdown client is always run as root or the invoker of the init script).
-# Runs as root by default, but you should take the time to set database file
-# ownerships to another user and set that user name here.
-HSQLDB_OWNER=hsqldb
-
-# The HSQLDB jar file specified in HSQLDB_JAR_PATH above will automatically
-# be in the class path.  This arg specifies additional classpath elements.
-# To embed your own application, add your jar file(s) or class base
-# directories here, and add your main class to the INVOC_ADDL_ARGS setting
-# below.  Another common use-case for adding to your class path is to make
-# classes available to the DB engines for SQL/JRT functions and procedures.
-#SERVER_ADDL_CLASSPATH=/usr/local/dist/currencybank.jar
-
-# For startup or shutdown failures, you can save a lot of debugging time by
-# temporarily adjusting down MAX_START_SECS and MAX_TERMINATE_SECS to a
-# little over what it should take for successful startup and shutdown on
-# your system.
-
-# We require all Server/WebServer instances to be accessible within 
-# $MAX_START_SECS from when the Server/WebServer is started.
-# Defaults to 60.
-# Raise this is you are running lots of DB instances or have a slow server.
-#MAX_START_SECS=200
-
-# Max time to allow for JVM to die after all HSQLDB instances stopped.
-# Defaults to 60.  Set high because the script will always continue as soon as
-# the process has stopped.  The importance of this setting is, how long until
-# a non-stopping-JVM-problem will be detected.
-#MAX_TERMINATE_SECS=0
-
-# NEW AND IMPORTANT!!!
-# As noted at the top of this file, this setting replaces the old property
-# settings server.urlid.X.
-# Simply list the URLIDs for all DB instances which your *Server starts.
-# Usually, these will exactly mirror the server.database.X settings in your
-# server.properties or webserver.properties file.
-# Each urlid listed here must be defined to a NETWORK url with Admin privileges
-# in the AUTH_FILE specified below.  (Network type because we use this for
-# inter-process communication)
-# Separate multiple values with white space.  NO OTHER SPECIAL CHARACTERS!
-# Make sure to quote the entire value if it contains white space separator(s).
-URLIDS='localhostdb1'
-
-# These are urlids # ** IN ADDITION TO URLIDS **, for instances which the init
-# script should stop but not start.
-# Most users will not need this setting.  If you need it, you'll know it.
-# Defaults to none (i.e., only URLIDS will be stopped).
-#SHUTDOWN_URLIDS='ondemand'
-
-# SqlTool authentication file used only for shutdown.
-# The default value will be sqltool.rc in root's home directory, since it is 
-# root who runs the init script.
-# (See the SqlTool chapter of the HyperSQL Utilities Guide if you don't
-# understand this).
-#AUTH_FILE=/home/blaine/sqltool.rc
-
-# Typical users will leave this unset and it will default to
-# org.hsqldb.server.Server.  If you need to run the HSQLDB WebServer class
-# instead, due to a firewall or routing impediment, set this to
-# org.hsqldb.server.WebServer, see the docs about running WebServr, and
-# set up a "webserver.properties" file instead of a "server.properties".
-# The JVM that is started can invoke many classes (see the following item
-# about that), but this is the server that is used (1) to check status,
-# (2) to shut down the JVM.
-#TARGET_CLASS=org.hsqldb.server.WebServer
-
-# This is where you may specify both command-line parameters to TARGET_CLASS,
-# plus any number of additional progams to run (along with their command-line
-# parameters).  The MainInvoker program is used to embed these multiple
-# static main invocations into a single JVM, so see the API spec for
-# org.hsqldb.util.MainInvoker if you want to learn more.
-# N.b. You should only use this setting to set HSQLDB Server or WebServer
-# parameters if you run multiple instances of this class, since you can use the
-# server/webserver.properties file for a single instance.
-# Every additional class (in addition to the TARGET_CLASS)
-# must be preceded with an empty string, so that MainInvoker will know
-# you are giving a class name.  MainInvoker will invoke the normal 
-# static main(String[]) method of each such class.  
-# By default, MainInvoker will just run TARGET_CLASS with no args.
-# Example that runs just the TARGET_CLASS with the specified arguments:
-#INVOC_ADDL_ARGS='-silent false'   #but use server.properties property instead!
-# Example that runs the TARGET_CLASS plus a WebServer:
-#INVOC_ADDL_ARGS='"" org.hsqldb.server.WebServer'
-# Note the empty string preceding the class name.
-# Example that starts TARGET_CLASS with an argument + a WebServer +
-# your own application with its args (i.e., the HSQLDB Servers are
-# "embedded" in your application).  (Set SERVER_ADDL_CLASSPATH too).:
-#INVOC_ADDL_ARGS='-silent false "" org.hsqldb.server.WebServer "" com.acme.Stone --env prod localhost'
-#   but use server.properties for -silent option instead!
-# Example to run a non-TLS server in same JVM with a TLS server.  In this
-# case, TARGET_CLASS is Server which will run both in TLS mode by virtue of 
-# setting the tls, keyStore, and keyStorePassword settings in
-# server*.properties, as described below; plus an "additional" Server with
-# overridden 'tls' and 'port' settings:
-#INVOC_ADDL_ARGS="'' org.hsqldb.server.Server --port 9002 --tls false"
-# This is an important use case.  If you run more than one Server instance,
-# you can specify different parameters for each here, even though only one
-# server.properties file is supported.
-# Note that you use nested quotes to group arguments and to specify the
-# empty-string delimiter.
-
-# The TLS_* settings have been obsoleted.
-# To get your server running with TLS, set
-# system.javax.net.ssl.keyStore=/path/to/your/private.keystore
-# system.javax.net.ssl.keyStorePassword=secretPassword
-# server.ssl=true
-# IN server.properties or webserver.properties, and
-# MAKE THE FILE OWNER-READ-ONLY!
-# See the TLS Encryption section of the HyperSQL User Guide, paying attention
-# to the security warning(s).
-# If you are running with a private server cert, then you will also need to 
-# set "truststore" in the your SqlTool config file (location is set by the
-# AUTH_FILE variable in this file, or it must be at the default location for 
-# HSQLDB_OWNER).
-
-# Any JVM args for the invocation of the JDBC client used to verify DB
-# instances and to shut them down (SqlToolSprayer).
-# Server-side System Properties should normally be set with system.*
-# settings in the server/webserver.properties file.
-# This example specifies the location of a private trust store for TLS 
-# encryption.
-# For multiple args, put quotes around entire value.
-# If you are starting just a TLS_encrypted Listener, you need to uncomment
-# this so the init scripts uses TLS to connect.
-# If using a private keystore, you also need to set "truststore" settings in
-# the sqltool.rc file.
-#CLIENT_JVMARGS=-Djavax.net.debug=ssl
-# This sample value displays useful debugging information about TLS/SSL.
-
-# Any JVM args for the server.
-# For multiple args, put quotes around entire value.
-#SERVER_JVMARGS=-Xmx512m
-# You can set the "javax.net.debug" property on the server side here, in the
-# same exact way as shown for the client side above.
diff -pruN 2.6.1-1/hsqldb/doc/verbatim/sample/plsql.sql 2.7.0-1/hsqldb/doc/verbatim/sample/plsql.sql
--- 2.6.1-1/hsqldb/doc/verbatim/sample/plsql.sql	2021-10-20 09:34:48.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/verbatim/sample/plsql.sql	2022-07-26 20:22:38.000000000 +0000
@@ -1,5 +1,5 @@
 /*
- * $Id: plsql.sql 610 2008-12-22 15:54:18Z unsaved $
+ * $Id: plsql.sql 6375 2021-11-07 17:44:56Z unsaved $
  *
  * This example is copied from the "Simple Programs in PL/SQL"
  * example by Yu-May Chang, Jeff Ullman, Prof. Jennifer Widom at
@@ -27,19 +27,12 @@ INSERT INTO T1 VALUES(2, 4);
 
 /* Above is plain SQL; below is the PL/SQL program. */
 DECLARE
-
     a NUMBER;
-
     b NUMBER;
-
 BEGIN
-
     SELECT e,f INTO a,b FROM T1 WHERE e>1;
-
     INSERT INTO T1 VALUES(b,a);
-
 END;
-
 .;
 /** The statement on the previous line, ".;" is SqlTool specific.
  *  This command says to save the input up to this point to the
diff -pruN 2.6.1-1/hsqldb/doc/verbatim/sample/sqltool.rc 2.7.0-1/hsqldb/doc/verbatim/sample/sqltool.rc
--- 2.6.1-1/hsqldb/doc/verbatim/sample/sqltool.rc	2021-10-20 09:34:48.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/verbatim/sample/sqltool.rc	2022-07-26 20:22:38.000000000 +0000
@@ -1,8 +1,10 @@
-# $Id: sqltool.rc 5871 2018-12-22 16:56:06Z unsaved $
+# $Id: sqltool.rc 6381 2021-11-18 21:45:56Z unsaved $
 
 # This is a sample RC configuration file used by SqlTool, DatabaseManager,
 # and any other program that uses the org.hsqldb.lib.RCData class.
 # See the documentation for SqlTool for various ways to use this file.
+# This is not a Java Properties file. It uses a custom format with stanzas,
+# similar to .netrc files.
 
 # If you have the least concerns about security, then secure access to
 # your RC file.
@@ -40,6 +42,41 @@
 #    liberal patterns, and override settings later in the file with more
 #    specific (or exact) patterns.
 
+# Since service discovery works great in all JREs for many years now, I
+# have removed all 'driver' specifications here.  JRE discover will
+# automatically resolve the driver class based on the JDBC URL format.
+# Most people use default ports, so I have removed port specification from
+# examples except for Microsoft's Sql Server driver where you can't depend
+# on a default port.
+# In all cases, to specify a non-default port, insert colon and port number
+# after the hostname or ip address in the JDBC URL, like
+# jdbc:hsqldb:hsql://localhost:9977 or
+# jdbc:sqlserver://hostname.admc.com:1433;databaseName=dbname
+
+# Amazon Aurora instances are access from JDBC exactly the same as the
+# non-Aurora RDS counterpart.
+
+# For using any database engine other than HyperSQL, you must add the
+# JDBC jar file and the SqlTool jar to your CLASSPATH then run a command like:
+#     java org.hsqldb.util.SqlTool...
+# I.e., the "-jar" switch doesn't support modified classpath.
+# (See SqlTool manual for how to do same thing using Java modules.)
+# To oversimplify for non-developers, the two most common methods to set
+# CLASSPATH for an executable tool like SqlTool are to either use the java
+# "-cp" switch or set environmental variable CLASSPATH.
+# Windows users can use graphical UI or CLI "set".  Unix shell users must
+# "export" in addition to assigning.
+#
+# All JDBC jar files used in these examples are available from Maven
+# repositories.  You can also get them from vendor web sites or with product
+# bundles (especially database distributions).
+# Most databases provide multiple variants.  Most people will want a type 4
+# driver supporting your connection mechanism (most commonly TCP/IP service,
+# but also database file access and others) and your client JRE version.
+# By convention the variants are distinguished in segments of the jar file
+# name before the final ".jar" .
+
+
 # Global default.  .+ matches all lookups:
 urlid .+ 
 username SA
@@ -53,7 +90,7 @@ url jdbc:hsqldb:mem:memdbid
 # A personal, local, persistent database.
 # Inherits username and password from default setting above.
 urlid personal
-url jdbc:hsqldb:file:${user.home}/db/personal;shutdown=true
+url jdbc:hsqldb:file:${user.home}/db/personal;shutdown=true;ifexist=true
 transiso TRANSACTION_READ_COMMITTED
 # When connecting directly to a file database like this, you should 
 # use the shutdown connection property like this to shut down the DB
@@ -62,36 +99,25 @@ transiso TRANSACTION_READ_COMMITTED
 # This is for a hsqldb Server running with default settings on your local
 # computer (and for which you have not changed the password for "SA").
 # Inherits username and password from default setting above.
+# Default port 9001
 urlid localhost-sa
 url jdbc:hsqldb:hsql://localhost
 
 
 
 # Template for a urlid for an Oracle database.
-# You will need to put the oracle.jdbc.OracleDriver class into your 
-# classpath.
-# In the great majority of cases, you want to use jhe desired version of a
-# file odbc*.jar (previously JDBC distributed as classes12.zip),
-# which you can get from the directory $ORACLE_HOME/jdbc/lib of any
-# Oracle installation compatible with your server.
-# Since you need to add to the classpath, you can't invoke SqlTool with
-# the jar switch, like "java -jar .../sqltool.jar...".
-# Put both the SqlTool jar and odbc*.jar in your classpath (and export!)
-# and run something like "java org.hsqldb.util.SqlTool...".
+# Driver jar files from this century have format like "ojbc*.jar".
+# Default port 1521
+urlid localhost-sa
+# Avoid older drivers because they have quirks.
 # You could use the thick driver instead of the thin, but I know of no reason
 # why any Java app should.
 
 #urlid cardiff2
-#url jdbc:oracle:thin:@aegir.admc.com:1521:TRAFFIC_SID
-# Thin SID URLs must specify both port and SID, there are no defaults.
-# Oracle listens to 1521 by default, so that's what you will usually specify.
-# But can alternatively use global service name (not tnsnames.ora service
-# alias, in which case the port does default to 1521):
-#url jdbc:oracle:thin:@centos.admc.com/tstsid.admc
+# Can identify target database with either SID or global service name.
+#url jdbc:oracle:thin:@//centos.admc.com/tstsid.admc
 #username blaine
-#password secretpassword
-#driver oracle.jdbc.OracleDriver
-
+#password asecret
 
 
 # Template for a TLS-encrypted HSQLDB Server.
@@ -101,6 +127,7 @@ url jdbc:hsqldb:hsql://localhost
 # You only need to set "truststore" if the server cert is not approved by
 # your system default truststore (which a commercial certificate probably
 # would be).
+# Port defaults to 554.
 
 #urlid tls
 #url jdbc:hsqldb:hsqls://db.admc.com:9001/lm2
@@ -110,77 +137,84 @@ url jdbc:hsqldb:hsql://localhost
 
 
 # Template for a Postgresql database
+# Driver jar files are of format like "postgresql-*.jar"
+# Port defaults to 5432.
 #urlid blainedb
 #url jdbc:postgresql://idun.africawork.org/blainedb
 #username blaine
-#password losung1
-#driver org.postgresql.Driver
+#password asecret
+
+# Amazon RedShift (a fork of Postgresql)
+# Driver jar files are of format like "redshift-jdbc*.jar"
+# Port defaults to 5439.
+#urlid redhshift
+#url jdbc:redshift://clustername.hex.us-east-1.redshift.amazonaws.com/dev
+#username awsuser
+#password asecret
 
 # Template for a MySQL database.  MySQL has poor JDBC support.
+# The latest driver jar files are of format like "mysql-jdbc*.jar", but not
+# long ago they were like "mysql-connector-java*.jar".
+# Port defaults to 3306
 #urlid mysql-testdb
-#url jdbc:mysql://hostname:3306/dbname
+#url jdbc:mysql://hostname/dbname
 #username root
-#password hiddenpwd
-#driver com.mysql.jdbc.Driver
+#password asecret
+# Alternatively, you can access MySQL using jdbc:mariadb URLs and driver.
 
 # Note that "databases" in SQL Server and Sybase are traditionally used for
 # the same purpose as "schemas" with more SQL-compliant databases.
 
 # Template for a Microsoft SQL Server database using Microsoft's Driver
-# (I find that the JTDS driver is much more responsive than Microsoft's).
-# Port defaults to 1433.
+# Seems that some versions default to port 1433 and others to 1434.
 # MSDN implies instances are port-specific, so can specify port or instname.
 #urlid msprojsvr
-# url/driver for Current 2011 JDBC Driver for Microsoft SQL Server:
-# Requires just the new sqljdbc4.jar.  (Microsoft just loves back-slashes)
-#url jdbc:sqlserver://hostname\instname;databaseName=dbname
-# OR
+# Driver jar files are of format like "mssql-jdbc-*.jar".
+# Don't use older MS JDBC drivers (like SQL Server 2000 vintage) because they
+# are pitifully incompetent, handling transactions incorrectly.
+# I recommend that you do not use Microsoft's nonstandard format that
+# includes backslashes.
 #url jdbc:sqlserver://hostname;instanceName=instname;databaseName=dbname
-#driver com.microsoft.jdbc.sqlserver.SQLServerDriver
-# See, for example,
-# https://docs.microsoft.com/en-us/sql/connect/jdbc/building-the-connection-url?view=sql-server-2017
-# url/deriver for OLDER JDBC Driver:
-#url jdbc:microsoft:sqlserver://hostname;DatabaseName=DbName;SelectMethod=Cursor
-# The SelectMethod setting is required to do more than one thing on a JDBC
-# session (I guess Microsoft thought nobody would really use Java for 
-# anything other than a "hello world" program).
-# This is for Microsoft's SQL Server 2000 driver (requires mssqlserver.jar
-# and msutil.jar).
-#driver com.microsoft.jdbc.sqlserver.SQLServerDriver
+# with port:
+#url jdbc:sqlserver://hostname:1433;instanceName=instname;databaseName=dbname
 #username myuser
-#password hiddenpwd
+#password asecret
 
 # Template for Microsoft SQL Server database using the JTDS Driver
-# http://jtds.sourceforge.net  Jar file has name like "jtds-1.2.5.jar".
+# Looks like this project is no longer maintained, so you may be better off
+# using the Microsoft driver above.
+# http://jtds.sourceforge.net  Jar file has name like "jtds-1.3.1.jar".
 # Port defaults to 1433.
 # MSDN implies instances are port-specific, so can specify port or instname.
 #urlid nlyte
 #username myuser
-#password hiddenpwd
+#password asecret
 #url jdbc:jtds:sqlserver://myhost/nlyte;instance=MSSQLSERVER
 # Where database is 'nlyte' and instance is 'MSSQLSERVER'.
 # N.b. this is diff. from MS tools and JDBC driver where (depending on which
 # document you read), instance or database X are specified like  HOSTNAME\X.
-#driver net.sourceforge.jtds.jdbc.Driver
 
 # Template for a Sybase database
 #urlid sybase
 #url jdbc:sybase:Tds:hostname:4100/dbname
 #username blaine
-#password hiddenpwd
+#password asecret
 # This is for the jConnect driver (requires jconn3.jar).
-#driver com.sybase.jdbc3.jdbc.SybDriver
 
-# Template for Embedded Derby / Java DB.
-#urlid derby1
-#url jdbc:derby:path/to/derby/directory;create=true
+# Derby / Java DB.
+# Please see the Derby JDBC docs, because they have changed the organization
+# of their driver jar files in recent years.  Combining that with the different
+# database types supported and jar file classpath chaining, and it's not
+# feasible to document it adequately here.
+# I'll just give one example using network service, which works with 10.15.2.0.
+# Put files derbytools*.jar, derbyclient*.jar, derbyshared*.jar into a
+# directory and include the path to the derbytools.jar in your classpath.
+# Port defaults to 1527.
+#url jdbc:derby://server:<port>/databaseName
 #username ${user.name}
 #password any_noauthbydefault
-#driver org.apache.derby.jdbc.EmbeddedDriver
-# The embedded Derby driver requires derby.jar.
-# There'a also the org.apache.derby.jdbc.ClientDriver driver with URL
-# like jdbc:derby://<server>[:<port>]/databaseName, which requires
-# derbyclient.jar.
+# If you get the right classes into classpath, local file URLs are like:
+#url jdbc:derby:path/to/derby/directory
 # You can use \= to commit, since the Derby team decided (why???)
 # not to implement the SQL standard statement "commit"!!
 # Note that SqlTool can not shut down an embedded Derby database properly,
@@ -188,3 +222,13 @@ url jdbc:hsqldb:hsql://localhost
 # However, I've never lost data by shutting it down improperly.
 # Other than not supporting this quirk of Derby, SqlTool is miles ahead of
 # Derby's ij.
+
+# Maria DB
+# With current versions, the MySQL driver does not work to access a Maria
+# database (though the inverse works).
+# Driver jar files are of format like "mariadb-java-client*.jar"
+# Port defaults to 3306
+#urlid maria
+#url jdbc:mariadb://hostname/db2
+#username blaine
+#password asecret
diff -pruN 2.6.1-1/hsqldb/doc/verbatim/src/org/hsqldb/server/Servlet.java 2.7.0-1/hsqldb/doc/verbatim/src/org/hsqldb/server/Servlet.java
--- 2.6.1-1/hsqldb/doc/verbatim/src/org/hsqldb/server/Servlet.java	2021-10-20 09:34:48.000000000 +0000
+++ 2.7.0-1/hsqldb/doc/verbatim/src/org/hsqldb/server/Servlet.java	2022-07-26 20:22:38.000000000 +0000
@@ -1,8 +1,79 @@
+/*
+ * For work developed by the HSQL Development Group:
+ *
+ * Copyright (c) 2001-2022, The HSQL Development Group
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ * Redistributions of source code must retain the above copyright notice, this
+ * list of conditions and the following disclaimer.
+ *
+ * Redistributions in binary form must reproduce the above copyright notice,
+ * this list of conditions and the following disclaimer in the documentation
+ * and/or other materials provided with the distribution.
+ *
+ * Neither the name of the HSQL Development Group nor the names of its
+ * contributors may be used to endorse or promote products derived from this
+ * software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL HSQL DEVELOPMENT GROUP, HSQLDB.ORG,
+ * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+ * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+ * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+ * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+ * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+ * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ *
+ *
+ *
+ * For work originally developed by the Hypersonic SQL Group:
+ *
+ * Copyright (c) 1995-2000, The Hypersonic SQL Group.
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ * Redistributions of source code must retain the above copyright notice, this
+ * list of conditions and the following disclaimer.
+ *
+ * Redistributions in binary form must reproduce the above copyright notice,
+ * this list of conditions and the following disclaimer in the documentation
+ * and/or other materials provided with the distribution.
+ *
+ * Neither the name of the Hypersonic SQL Group nor the names of its
+ * contributors may be used to endorse or promote products derived from this
+ * software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE HYPERSONIC SQL GROUP,
+ * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+ * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+ * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+ * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+ * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+ * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ *
+ * This software consists of voluntary contributions made by many individuals
+ * on behalf of the Hypersonic SQL Group.
+ */
+
+
 package org.hsqldb.server;
 
 import java.io.DataInputStream;
 import java.io.IOException;
 import java.io.PrintWriter;
+import java.util.TimeZone;
 
 import javax.servlet.ServletConfig;
 import javax.servlet.ServletException;
@@ -60,7 +131,7 @@ import org.hsqldb.rowio.RowOutputBinary;
  * calls are supported.<p>
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 1.6.2
  */
 public class Servlet extends HttpServlet {
@@ -198,8 +269,7 @@ public class Servlet extends HttpServlet
                                                    resultIn.getMainString(),
                                                    resultIn.getSubString(),
                                                    new HsqlProperties(),
-                                                   resultIn.getZoneString(),
-                                                   resultIn.getUpdateCount());
+                                                   TimeZone.getDefault());
                     resultOut =
                         Result.newConnectionAcknowledgeResponse(session);
                 } catch (HsqlException e) {
diff -pruN 2.6.1-1/hsqldb/doc-src/changelist_2_0.txt 2.7.0-1/hsqldb/doc-src/changelist_2_0.txt
--- 2.6.1-1/hsqldb/doc-src/changelist_2_0.txt	2021-10-19 20:56:48.000000000 +0000
+++ 2.7.0-1/hsqldb/doc-src/changelist_2_0.txt	2022-05-30 12:29:06.000000000 +0000
@@ -1,3 +1,20 @@
+30 May 2022 - version 2.7.0
+-- version 2.7.0 jar requires JRE 11 or later - tested up to Java 17
+-- version 2.7.0 alternative jar requires JRE 8 or later
+-- added support for JSON constructor functions
+-- added support for microsecond precision CURRENT_TIMESTAMP and similar functions
+-- added support for GRANT and REVOKE on all objects in a schema
+-- added support for CSV file data import and export
+-- added support for regional time zones such as 'America/New_York' in conversions
+-- added SET DATABASE SQL MAX RECURSIVE (sql.max_recursive) setting
+-- changed the default for SET DATABASE SQL SYS INDEX NAMES (sql.sys_index_names) to true
+-- changed the properties reported by JDBC DatabaseMetaDat::getClientInfoProperties() method
+-- improved  JDBC DatabaseMetaDat::getTablePrivileges() method to cover fine-grained privileges
+-- improved error messages for SQL settings statements
+-- improved documentation
+-- added some minor enhancements
+-- fixed a number of reported regressions and bugs (see tracker)
+
 21 October 2021 - version 2.6.1
 -- version 2.6.1 is a bug fix release
 -- added sql.lowercase_ident property for extra compatibility with PostgreSQL and MySQL unquoted identifier names
diff -pruN 2.6.1-1/hsqldb/doc-src/hsqldb_lic.txt 2.7.0-1/hsqldb/doc-src/hsqldb_lic.txt
--- 2.6.1-1/hsqldb/doc-src/hsqldb_lic.txt	2021-01-25 11:09:36.000000000 +0000
+++ 2.7.0-1/hsqldb/doc-src/hsqldb_lic.txt	2022-02-21 14:42:16.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
diff -pruN 2.6.1-1/hsqldb/doc-src/hypersonic_lic.txt 2.7.0-1/hsqldb/doc-src/hypersonic_lic.txt
--- 2.6.1-1/hsqldb/doc-src/hypersonic_lic.txt	2021-01-25 11:09:44.000000000 +0000
+++ 2.7.0-1/hsqldb/doc-src/hypersonic_lic.txt	2022-02-21 14:42:14.000000000 +0000
@@ -1,7 +1,7 @@
 /*
  * For work developed by the HSQL Development Group:
  *
- * Copyright (c) 2001-2021, The HSQL Development Group
+ * Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
diff -pruN 2.6.1-1/hsqldb/index.html 2.7.0-1/hsqldb/index.html
--- 2.6.1-1/hsqldb/index.html	2021-07-19 09:51:12.000000000 +0000
+++ 2.7.0-1/hsqldb/index.html	2022-04-24 11:22:18.000000000 +0000
@@ -9,23 +9,21 @@
       src="doc-src/images/hypersql_logo.png">
     <h3><br>
     </h3>
-    <h3>HyperSQL version 2.6.1 Distribution<br>
+    <h3>HyperSQL version 2.7.0 Distribution<br>
     </h3>
     <p>HSQLDB (HyperSQL Database) is a relational
-      database management system written in Java. Now in its 20th year,
-      HSQLDB version 2.6.1 is the result of 16 years development since
-      version 1.8.0, and 11 years
-      improvements over version 2.0. It offers many features and
+      database management system written in Java. Now in its 22nd year,
+      HSQLDB version 2.7.0 is the result of 12 years
+      improvements since version 2.0. It offers many features and
       adheres closely to the latest SQL and JDBC 4.2 standards.</p>
     <p>This release should be used in preference to earlier 2.x
       releases, as it fixes a number of bugs and regressions, as well as
       improving functionality and adding new features.</p>
     <p>The main jars in this package are Java module jars and compatible
       with Java 11 and later. The alternative jars are compatible with
-      Java 8 and later. The jars have been tested with JRE 8 to 15.
-      Version 2.3.9 jar (separate download from the web site) has the
-      same features as version 2.6.1 minus the java.time features and
-      can be used with Java 6 and 7.
+      Java 8 and later. The jars have been tested with JRE 8, 11 and 17.
+      A eparate jar from the web site has the same functionality as 
+      version 2.7.0 minus the java.time features and  can be used with Java 6 and 7.
     </p>
     <h4>SUPPORTWARE</h4>
     <p>The development and maintenance of&nbsp; HyperSQL has been
@@ -116,11 +114,9 @@
         version is the most stable and bug-free version in the 2.x
         series.</li>
       <li>Compared to earlier versions, there are many new features and
-        changes. Most
-        of these do not affect compatibility.</li>
+        changes. Most of these do not affect compatibility.</li>
       <li>Differences are detailed in the Guide. The main differences in
-        version 2.6.1
-        are as follows:</li>
+        version 2.7.0 are as follows:</li>
       <li>Transaction management has been improved to allow creation and
         alteration of database objects such as tables
         while other transactions are active. This applies to the default
diff -pruN 2.6.1-1/hsqldb/integration/ant/preprocessor/build.cmd 2.7.0-1/hsqldb/integration/ant/preprocessor/build.cmd
--- 2.6.1-1/hsqldb/integration/ant/preprocessor/build.cmd	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/integration/ant/preprocessor/build.cmd	2022-03-09 18:43:38.000000000 +0000
@@ -0,0 +1,5 @@
+@echo off
+@setlocal
+..\..\..\build\setenv.cmd
+ant
+@endlocal
diff -pruN 2.6.1-1/hsqldb/integration/ant/preprocessor/build.xml 2.7.0-1/hsqldb/integration/ant/preprocessor/build.xml
--- 2.6.1-1/hsqldb/integration/ant/preprocessor/build.xml	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/integration/ant/preprocessor/build.xml	2022-03-09 18:43:38.000000000 +0000
@@ -0,0 +1,215 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<project basedir="." default="help" name="hsqldb-base-trunk/integration/ant/preprocessor">
+    <description>Builds the Ant preprocessor integration jar </description>
+    <target name="help" description="Top-level help message">
+        <echo>Ant version: ${ant.version} </echo>
+        <echo><![CDATA[usage:
+ant -help            Display ant help screen
+ant -projecthelp     Display all invocable targets
+ant check            Check the project dependencies
+and clean            Delete the jar and javadoc artifacts.
+ant jar              Build the Ant preprocessor integration jar
+ant javadoc          Build the prjoect javadoc artifacts
+ant sample           Preprocess the sample files]]></echo>
+    </target>
+    <!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
+    <!-- B U I L D  T I M E S T A M P                                         -->
+    <!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
+    <tstamp>
+        <format property="_tmpstamp"
+                pattern="yyyy/MM/dd-hh:mm:ss"
+                locale="en"/>
+    </tstamp>
+
+    <!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
+    <!-- U S E R  B U I L D  P R O P E R T I E S  O V E R R I D E S           -->
+    <!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
+    <property file="${basedir}/build.properties"/>
+
+    <!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
+    <!-- D E F A U L T  B U I L D  P R O P E R T I E S                        -->
+    <!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
+    <property name="hsqldb-ant-preprocessor.version"
+              value="2.6.2"/>
+
+    <property name="hsqldb-ant-preprocessor.title"
+              value="HSQLDB Ant preprocessor integration"/>
+
+    <property name="hsqldb-ant-preprocessor.vendor"
+              value="The HSQL Development Group"/>
+
+    <property name="hsqldb-ant-preprocessor.implementation.title"
+              value="Ant preprocessor task and resolver"/>
+
+    <property name="hsqldb-ant-preprocessor.implementation.label"
+              value="private-${_tmpstamp}"/>
+
+    <property name="hsqldb-ant-preprocessor.implementation.vendor"
+              value="${user.name}"/>
+
+    <property name="hsqldb-lib.dir"
+              value="${basedir}/../../../lib" />
+        
+    <property name="hsqldb-ant-preprocessor.src.dir"
+              value="${basedir}/src" />
+   
+    <property name="hsqldb-ant-preprocessor.lib.dir"
+              value="${basedir}/lib" />
+
+    <property name="hsqldb-ant-preprocessor.classes.dir"
+              value="${basedir}/classes" />
+
+    <property name="hsqldb-preprocessor.jar"
+              value="${hsqldb-lib.dir}/preprocessor.jar" />
+
+    <property name="hsqldb-ant-preprocessor.jar"
+              value="${hsqldb-ant-preprocessor.lib.dir}/hsqldb-ant-preprocessor.jar" />
+
+    <property name="build.debug"
+              value="true" />
+
+    <property name="build.optimize"
+              value="false" />
+
+    <!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
+    <!-- B U I L D  C L A S S P A T H                                         -->
+    <!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
+    <path id="hsqldb-ant-preprocessor.javac.classpath">
+        <pathelement location="${hsqldb-preprocessor.jar}"/>
+    </path>
+    
+    <!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
+    <!-- P R E P R O C E S S O R  C L A S S P A T H                           -->
+    <!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
+    <path id="hsqldb-ant-preprocessor.runtime.classpath">
+        <pathelement location="${hsqldb-preprocessor.jar}"/>
+        <pathelement location="${hsqldb-ant-preprocessor.jar}"/>
+    </path>
+
+    <!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
+    <!-- S H A R E D  I N I T I A L I Z A T I O N                             -->
+    <!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
+    <target name="-init">
+        <available file=""
+                   type="file"
+                   property="hsqldb-preprocessor.jar.available"/>
+
+        <fail unless='hsqldb-preprocessor.jar.available'
+              message="'The HSQLDB preprocessor.jar' must reside at ${hsqldb-preprocessor.jar}"/>
+
+    </target>
+	
+    <target name="check"
+            description="checks the project dependencies">
+        <pathconvert pathsep="${line.separator}" 
+                     property="check.class.path" 
+                     refid="hsqldb-ant-preprocessor.runtime.classpath"/>
+        <echo><![CDATA[
+Check Status     : SUCCESS - project dependences satisifed.
+Project Name     : ${ant.project.name}
+Project Base     : ${basedir}
+Project Classpath:
+${check.class.path}
+Ant Version      :${ant.version}
+Ant Home         :${ant.home}]]></echo>
+    </target>
+
+    <!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
+    <!-- M A K E  A N T  P R E P R O C E S S O R  J A R                       -->
+    <!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
+    <target name="jar"
+            description="Builds classes and creates the hsqldb-ant-preprocessor jar"
+            depends="-init">
+        <mkdir dir="${hsqldb-ant-preprocessor.classes.dir}"/>
+        <mkdir dir="${hsqldb-ant-preprocessor.lib.dir}"/>
+
+        <!-- Compile Classes -->
+        <javac srcdir="${hsqldb-ant-preprocessor.src.dir}"
+               destdir="${hsqldb-ant-preprocessor.classes.dir}"
+               debug="${build.debug}"
+               optimize="${build.optimize}"
+               includeantruntime="true">
+            <classpath refid="hsqldb-ant-preprocessor.javac.classpath"/>
+        </javac>
+
+        <!-- Build Jar -->
+        <jar jarfile="${hsqldb-ant-preprocessor.jar}"
+             basedir="${hsqldb-ant-preprocessor.classes.dir}">
+            <manifest>
+                <attribute name='Specification-Title'
+                           value='${hsqldb-ant-preprocessor.title}'/>
+
+                <attribute name='Specification-Version'
+                           value='${hsqldb-ant-preprocessor.version}'/>
+
+                <attribute name='Specification-Vendor'
+                           value='${hsqldb-ant-preprocessor.vendor}'/>
+
+                <attribute name='Implementation-Title'
+                           value='${hsqldb-ant-preprocessor.implementation.title}'/>
+
+                <attribute name='Implementation-Version'
+                           value='${hsqldb-ant-preprocessor.implementation.label}'/>
+
+                <attribute name='Implementation-Vendor'
+                           value='${hsqldb-ant-preprocessor.implementation.vendor}'/>
+            </manifest>
+        </jar>
+    </target>
+        
+    <target name="javadoc" depends="jar">
+        <javadoc
+            destdir="dist/javadoc"
+            docencoding="UTF-8"
+            charset="UTF-8"
+            author="true"
+            version="true"
+            use="true"
+            public="true"
+            failonerror="false"
+            verbose="false"
+            windowtitle="${hsqldb-ant-preprocessor.title} ${hsqldb-ant-preprocessor.version} API"
+            doctitle="${hsqldb-ant-preprocessor.title} ${hsqldb-ant-preprocessor.version}"
+            bottom="&lt;i&gt;Copyright &#169; 2001 - 2022 HSQL Development Group.&lt;/i&gt;">
+            <classpath>
+                <pathelement location="${hsqldb-preprocessor.jar}"/>
+                <pathelement location="${hsqldb-ant-preprocessor.jar}"/>
+                <pathelement location="${ant.core.lib}"/>
+            </classpath>
+            <packageset dir="${hsqldb-ant-preprocessor.src.dir}">
+                <include name='org/hsqldb/util/preprocessor/ant'/>
+            </packageset>
+        </javadoc>
+    </target>
+    
+    <target name="sample" depends="jar">
+        <taskdef
+            name="preprocess"
+            classname="org.hsqldb.util.preprocessor.ant.PreprocessorAntTask">
+            <classpath refid="hsqldb-ant-preprocessor.runtime.classpath"/>
+        </taskdef>
+ 
+        <preprocess
+            srcdir="${basedir}/sample"
+            targetdir="${basedir}/output"
+            altext=".pre"
+            backup="false"
+            encoding="UTF8"
+            filter="true"
+            indent="false"
+            testonly="true"
+            verbose="true">
+        </preprocess>
+
+    </target>
+
+
+    <!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
+    <!-- C L E A N  T E S T  S U I T E                                        -->
+    <!-- ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ -->
+    <target name="clean"
+            description="Deletes all output artifacts">
+        <delete dir="${hsqldb-ant-preprocessor.classes.dir}" />
+        <delete dir="${hsqldb-ant-preprocessor.lib.dir}" />
+    </target>
+</project>
diff -pruN 2.6.1-1/hsqldb/integration/ant/preprocessor/sample/ATest.exp 2.7.0-1/hsqldb/integration/ant/preprocessor/sample/ATest.exp
--- 2.6.1-1/hsqldb/integration/ant/preprocessor/sample/ATest.exp	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/integration/ant/preprocessor/sample/ATest.exp	2022-03-09 18:43:38.000000000 +0000
@@ -0,0 +1,13 @@
+class ATest {
+// JDBC Version is GTE 4:
+String msg4 = "I was included because jdbc_version was GTE 4";
+// JDBC Version is GTE 3 and LT 4:
+String msg3 = "I was included because jdbc_version was GTE 3 and LT 4";
+// JDBC Version is GTE 2 and LT 3:
+String msg2 = "I was included because jdbc_version was GTE 2 and LT 3";
+String s1 = "v1 was defined";
+String s2 = "v2 was defined";
+String s3 = "v1 was \"happy\"";
+String s4 = "v2 was \"sad\"";
+String s5 = "v1 was less than or equal to v2";
+}
diff -pruN 2.6.1-1/hsqldb/integration/ant/preprocessor/sample/ATest.src 2.7.0-1/hsqldb/integration/ant/preprocessor/sample/ATest.src
--- 2.6.1-1/hsqldb/integration/ant/preprocessor/sample/ATest.src	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/integration/ant/preprocessor/sample/ATest.src	2022-03-09 18:43:38.000000000 +0000
@@ -0,0 +1,41 @@
+class ATest {
+//#ifndef jdbc_version
+// jdbc_version was not defined:
+//#else
+//#include Main.inc
+//#endinclude
+//#endif
+//#define jdbc_version 3
+//#include Main.inc
+//#endinclude
+//#define jdbc_version 2
+//#include Main.inc
+//#endinclude
+//#define v1 "happy"
+//#define v2 "sad"
+//#ifdef v1
+String s1 = "v1 was defined";
+    //#ifdef v2
+String s2 = "v2 was defined";
+        //#if (v1 == "happy")
+String s3 = "v1 was \"happy\"";
+            //#if (v2 == "sad")
+String s4 = "v2 was \"sad\"";
+                //#if (v1 <= v2)
+String s5 = "v1 was less than or equal to v2";
+                //#else
+String s5 = "v1 was greater than v2";
+                //#endif (v1 <= v2)
+            //#else
+String s4 = "v2 was not \"sad\"";
+            //#endif (v2 == "sad")
+        //#else
+String s3 = "v2 was not defined or v1 was not \"happy\"";
+        //#endif (v1 == "happy")
+    //#else
+String s2 = "v2 was not defined";
+    //#endif v1
+//#else
+String s1 = "v1 was not defined";
+//#endif v1
+}
\ No newline at end of file
diff -pruN 2.6.1-1/hsqldb/integration/ant/preprocessor/sample/Jdbc2.inc 2.7.0-1/hsqldb/integration/ant/preprocessor/sample/Jdbc2.inc
--- 2.6.1-1/hsqldb/integration/ant/preprocessor/sample/Jdbc2.inc	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/integration/ant/preprocessor/sample/Jdbc2.inc	2022-03-09 18:43:38.000000000 +0000
@@ -0,0 +1 @@
+String msg2 = "I was included because jdbc_version was GTE 2 and LT 3";
\ No newline at end of file
diff -pruN 2.6.1-1/hsqldb/integration/ant/preprocessor/sample/Jdbc3.inc 2.7.0-1/hsqldb/integration/ant/preprocessor/sample/Jdbc3.inc
--- 2.6.1-1/hsqldb/integration/ant/preprocessor/sample/Jdbc3.inc	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/integration/ant/preprocessor/sample/Jdbc3.inc	2022-03-09 18:43:38.000000000 +0000
@@ -0,0 +1 @@
+String msg3 = "I was included because jdbc_version was GTE 3 and LT 4";
\ No newline at end of file
diff -pruN 2.6.1-1/hsqldb/integration/ant/preprocessor/sample/Jdbc4.inc 2.7.0-1/hsqldb/integration/ant/preprocessor/sample/Jdbc4.inc
--- 2.6.1-1/hsqldb/integration/ant/preprocessor/sample/Jdbc4.inc	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/integration/ant/preprocessor/sample/Jdbc4.inc	2022-03-09 18:43:38.000000000 +0000
@@ -0,0 +1 @@
+String msg4 = "I was included because jdbc_version was GTE 4";
\ No newline at end of file
diff -pruN 2.6.1-1/hsqldb/integration/ant/preprocessor/sample/Main.inc 2.7.0-1/hsqldb/integration/ant/preprocessor/sample/Main.inc
--- 2.6.1-1/hsqldb/integration/ant/preprocessor/sample/Main.inc	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/integration/ant/preprocessor/sample/Main.inc	2022-03-09 18:43:38.000000000 +0000
@@ -0,0 +1,20 @@
+//#if (jdbc_version >= 4)
+// JDBC Version is GTE 4:
+    //#include Jdbc4.inc
+         // This is where the JDBC 4 stuff will go...
+    //#endinclude
+//#elif (jdbc_version >= 3)
+// JDBC Version is GTE 3 and LT 4:
+    //#include Jdbc3.inc
+         // This is where the JDBC 3 stuff will go...
+    //#endinclude
+//#elif (jdbc_version >= 2)
+// JDBC Version is GTE 2 and LT 3:
+    //#include Jdbc2.inc
+        // This is where the JDBC 2 stuff will go...
+    //#endinclude
+//#elif (jdbc_version >= 1)
+// JDBC Version is GTE 1 and LT 2:
+//#else
+// JDBC Version is LT 1:
+//#endif
\ No newline at end of file
diff -pruN 2.6.1-1/hsqldb/integration/ant/preprocessor/src/org/hsqldb/util/preprocessor/ant/AntResolver.java 2.7.0-1/hsqldb/integration/ant/preprocessor/src/org/hsqldb/util/preprocessor/ant/AntResolver.java
--- 2.6.1-1/hsqldb/integration/ant/preprocessor/src/org/hsqldb/util/preprocessor/ant/AntResolver.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/integration/ant/preprocessor/src/org/hsqldb/util/preprocessor/ant/AntResolver.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1,63 @@
+/* Copyright (c) 2001-2007, The HSQL Development Group
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ * Redistributions of source code must retain the above copyright notice, this
+ * list of conditions and the following disclaimer.
+ *
+ * Redistributions in binary form must reproduce the above copyright notice,
+ * this list of conditions and the following disclaimer in the documentation
+ * and/or other materials provided with the distribution.
+ *
+ * Neither the name of the HSQL Development Group nor the names of its
+ * contributors may be used to endorse or promote products derived from this
+ * software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL HSQL DEVELOPMENT GROUP, HSQLDB.ORG,
+ * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+ * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+ * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+ * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+ * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+ * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+
+package org.hsqldb.util.preprocessor.ant;
+
+import java.io.File;
+import org.apache.tools.ant.Project;
+import org.hsqldb.util.preprocessor.IResolver;
+
+
+/**
+ * Resolves properties and paths using an ANT Project.
+ *
+ * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
+ * @version 2.6.2
+ * @since 1.8.1
+ */
+public class AntResolver implements IResolver {
+
+    private final Project project;
+
+    public AntResolver(final Project project) {
+        this.project = project;
+    }
+
+    @Override
+    public String resolveProperties(String expression) {
+        return this.project.replaceProperties(expression);
+    }
+
+    @Override
+    public File resolveFile(String path) {
+        return this.project.resolveFile(path);
+    }
+}
diff -pruN 2.6.1-1/hsqldb/integration/ant/preprocessor/src/org/hsqldb/util/preprocessor/ant/PreprocessorAntTask.java 2.7.0-1/hsqldb/integration/ant/preprocessor/src/org/hsqldb/util/preprocessor/ant/PreprocessorAntTask.java
--- 2.6.1-1/hsqldb/integration/ant/preprocessor/src/org/hsqldb/util/preprocessor/ant/PreprocessorAntTask.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/integration/ant/preprocessor/src/org/hsqldb/util/preprocessor/ant/PreprocessorAntTask.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1,242 @@
+/* Copyright (c) 2001-2022, The HSQL Development Group
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ * Redistributions of source code must retain the above copyright notice, this
+ * list of conditions and the following disclaimer.
+ *
+ * Redistributions in binary form must reproduce the above copyright notice,
+ * this list of conditions and the following disclaimer in the documentation
+ * and/or other materials provided with the distribution.
+ *
+ * Neither the name of the HSQL Development Group nor the names of its
+ * contributors may be used to endorse or promote products derived from this
+ * software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL HSQL DEVELOPMENT GROUP, HSQLDB.ORG,
+ * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+ * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+ * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+ * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+ * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+ * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+
+package org.hsqldb.util.preprocessor.ant;
+
+import java.io.File;
+
+import org.apache.tools.ant.BuildException;
+import org.apache.tools.ant.taskdefs.MatchingTask;
+import org.hsqldb.util.preprocessor.IResolver;
+import org.hsqldb.util.preprocessor.Option;
+import org.hsqldb.util.preprocessor.Preprocessor;
+
+/**
+ * <p>Provides a facility for invoking the Preprocessor from ANT.</p>
+ * <p><b>Example ANT target:</b></p><pre>{@code <target
+ *     name="preprocess"
+ *     depends="build-preprocessor">
+ *
+ *     <taskdef
+ *         name="preprocess"
+ *         classname="org.hsqldb.util.preprocessor.PreprocessorAntTask"
+ *         classpath="${preprocessor.class.path}"/>
+ *
+ *     <preprocess
+ *         srcdir="${src.dir}"
+ *         targetdir="${target.dir}"
+ *         altext=".pre"
+ *         backup="true"
+ *         encoding="UTF8"
+ *         filter="true"
+ *         indent="false"
+ *         symbols="java_version=${java.version}, jdbc_version=${jdbc.version}"
+ *         testonly="false"
+ *         verbose="true"
+ *         if="${preprocess.if}"
+ *         unless="${preprocess.unless}">
+ *     </preprocess>
+ *
+ * </target>}</pre><p><b>Task Attributes</b></p>
+ * <table summary="Task Attributes" border="1" cellspacing="1">
+ *     <thead>
+ *         <tr><th>Name</th><th>Description</th></tr>
+ *     </thead>
+ *     <tbody>
+ *     <tr>
+ *         <td><b>srcdir</b> (required)</td>
+ *         <td><b>file</b> - directory under which input files are located</td>
+ *     </tr>
+ *     <tr>
+ *         <td><b>targetdir</b> (required)</td>
+ *         <td><b>file</b> - directory under which output files are to be written</td>
+ *     </tr>
+ *     <tr>
+ *         <td><b>altext</b> (optional)</td>
+ *         <td><b>string</b> - alternate extension to use for output file names. <br>
+ *         If needed, leading dot should be provided</td>
+ *     </tr>
+ *     <tr>
+ *         <td><b>backup</b> (optional - default: <b>false</b>)</td>
+ *         <td><b>boolean</b> - whether to back up pre-existing target files. <br>
+ *         When true, pre-existing target files are preserved by renaming with
+ *         postfix "~"</td>
+ *     </tr>
+ *     <tr>
+ *         <td><b>encoding</b> (optional)</td>
+ *         <td><b>string</b> - the encoding with which to read and write file content.<br>
+ *         If specified, must be a valid Java encoding identifier, such as "UTF8". <br>
+ *         When unspecified, the default Java platformn encoding is used.</td>
+ *     </tr>
+ *     <tr>
+ *         <td><b>filter</b> (optional - default: <b>false</b>)</td>
+ *         <td><b>boolean</b> - whether to exclude directive lines from output.</td>
+ *     </tr>
+ *     <tr>
+ *         <td><b>indent</b> (optional - default: <b>false</b>)</td>
+ *         <td><b>boolean</b> - whether to indent directive lines in output.</td>
+ *     </tr>
+ *     <tr>
+ *         <td><b>symbols</b> (optional)</td>
+ *         <td><b>string</b> - CSV list of preprocessor symbols to predefine. <br>
+ *         When specified, each list element <i>must</i> be of the form: <br>
+ *         {@code IDENT (ASSIGN? (STRING | NUMBER | IDENT) )?}<br>
+ *         Note that forward assignments are illegal. <br>
+ *         See {@link Preprocessor Preprocessor} for details</td>
+ *     </tr>
+ *     <tr>
+ *         <td><b>testonly</b> (optional - default: <b>false</b>)</td>
+ *         <td><b>boolean</b> - whether to omit writing output files.</td>
+ *     </tr>
+ *     <tr>
+ *         <td><b>verbose</b> (optional - default: <b>false</b>)</td>
+ *         <td><b>boolean</b> - whether to log detailed information.</td>
+ *     </tr>
+ *     </tbody>
+ * </table>
+ *
+ * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
+ * @version 2.6.2
+ * @since 1.8.1
+ */
+public class PreprocessorAntTask extends MatchingTask {
+
+    private String ifExpr;
+    private String unlessExpr;
+    private File   sourceDir;
+    private File   targetDir;
+    private String defines;
+    private String altExt;
+    private String encoding;
+    private int    options = Option.INDENT;
+
+    public void init() {
+        super.init();
+    }
+
+    public void setSrcdir(final File value) {
+        sourceDir = value;
+    }
+
+    public void setTargetdir(final File value) {
+        targetDir = value;
+    }
+
+    public void setSymbols(final String value) {
+        defines = value;
+    }
+
+    public void setVerbose(final boolean verbose) {
+        options = Option.setVerbose(options, verbose);
+    }
+
+    public void setBackup(final boolean backup) {
+        options = Option.setBackup(options, backup);
+    }
+
+    public void setIndent(final boolean indent) {
+        options = Option.setIndent(options, indent);
+    }
+
+    public void setTestonly(final boolean testOnly) {
+        options = Option.setTestOnly(options, testOnly);
+    }
+
+    public void setFilter(final boolean filter) {
+        options = Option.setFilter(options, filter);
+    }
+
+    public void setAltext(final String ext) {
+        this.altExt = ext;
+    }
+
+    public void setEncoding(final String encoding) {
+          this.encoding = encoding;
+    }
+
+    public void setIf(final String expr) {
+        this.ifExpr = expr;
+    }
+
+    public void setUnless(final String expr) {
+        this.unlessExpr = expr;
+    }
+
+    public boolean isActive() {
+        return (this.ifExpr == null
+                || getProject().getProperty(this.ifExpr) != null
+                || this.unlessExpr == null
+                || getProject().getProperty(this.unlessExpr) == null);
+    }
+
+    public void execute() throws BuildException {
+
+        if (!isActive()) {
+            return;
+        }
+
+        checkTargetDir();
+
+        this.sourceDir = getProject().resolveFile("" + this.sourceDir);
+
+        IResolver resolver = new AntResolver(getProject());
+        String[]  files    = getFiles();
+
+        log("Preprocessing " + files.length + " file(s)");
+
+        try {
+            Preprocessor.preprocessBatch(this.sourceDir, this.targetDir, files,
+                    this.altExt, this.encoding, this.options, this.defines,
+                    resolver);
+        } catch (Exception ex) {
+            ex.printStackTrace();
+
+            throw new BuildException("Preprocessing failed: " + ex,
+                    ex);
+        }
+    }
+
+    private String[] getFiles() {
+        return getDirectoryScanner(sourceDir).getIncludedFiles();
+    }
+	
+	private void checkSourceDir() throws BuildException {
+        if (this.sourceDir == null) {
+            throw new BuildException("Source directory is required.");
+        }
+    }
+
+    private void checkTargetDir() throws BuildException {
+        if (targetDir == null) {
+            throw new BuildException("Target directory is required.");
+        }
+    }
+}
diff -pruN 2.6.1-1/hsqldb/modinfo-src/org.hsqldb/module-info.java 2.7.0-1/hsqldb/modinfo-src/org.hsqldb/module-info.java
--- 2.6.1-1/hsqldb/modinfo-src/org.hsqldb/module-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/modinfo-src/org.hsqldb/module-info.java	2022-06-07 22:07:20.000000000 +0000
@@ -0,0 +1,50 @@
+/* Copyright (c) 2001-2022, The HSQL Development Group
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ * Redistributions of source code must retain the above copyright notice, this
+ * list of conditions and the following disclaimer.
+ *
+ * Redistributions in binary form must reproduce the above copyright notice,
+ * this list of conditions and the following disclaimer in the documentation
+ * and/or other materials provided with the distribution.
+ *
+ * Neither the name of the HSQL Development Group nor the names of its
+ * contributors may be used to endorse or promote products derived from this
+ * software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL HSQL DEVELOPMENT GROUP, HSQLDB.ORG,
+ * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+ * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+ * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+ * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+ * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+ * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+
+module org.hsqldb {
+   exports org.hsqldb.auth;
+   exports org.hsqldb.jdbc;
+   exports org.hsqldb.jdbc.pool;
+   exports org.hsqldb.lib;
+   exports org.hsqldb.lib.tar;
+   exports org.hsqldb.server;
+   exports org.hsqldb.trigger;
+   exports org.hsqldb.util;
+
+   requires java.desktop;
+   requires java.logging;
+   requires java.naming;
+   requires java.sql;
+   requires java.xml;
+   requires jdk.unsupported;
+   
+   provides java.sql.Driver with org.hsqldb.jdbc.JDBCDriver;
+}
diff -pruN 2.6.1-1/hsqldb/modinfo-src/org.hsqldb.min/module-info.java 2.7.0-1/hsqldb/modinfo-src/org.hsqldb.min/module-info.java
--- 2.6.1-1/hsqldb/modinfo-src/org.hsqldb.min/module-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/modinfo-src/org.hsqldb.min/module-info.java	2022-06-07 22:06:20.000000000 +0000
@@ -0,0 +1,47 @@
+/* Copyright (c) 2001-2022, The HSQL Development Group
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ * Redistributions of source code must retain the above copyright notice, this
+ * list of conditions and the following disclaimer.
+ *
+ * Redistributions in binary form must reproduce the above copyright notice,
+ * this list of conditions and the following disclaimer in the documentation
+ * and/or other materials provided with the distribution.
+ *
+ * Neither the name of the HSQL Development Group nor the names of its
+ * contributors may be used to endorse or promote products derived from this
+ * software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL HSQL DEVELOPMENT GROUP, HSQLDB.ORG,
+ * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+ * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+ * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+ * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+ * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+ * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+
+module org.hsqldb {
+   exports org.hsqldb.auth;
+   exports org.hsqldb.jdbc;
+   exports org.hsqldb.jdbc.pool;
+   exports org.hsqldb.lib;
+   exports org.hsqldb.lib.tar;
+   exports org.hsqldb.trigger;
+
+   requires java.logging;
+   requires java.naming;
+   requires java.sql;
+   requires java.xml;
+   requires jdk.unsupported;
+
+   provides java.sql.Driver with org.hsqldb.jdbc.JDBCDriver;
+}
diff -pruN 2.6.1-1/hsqldb/modinfo-src/org.hsqldb.sqltool/module-info.java 2.7.0-1/hsqldb/modinfo-src/org.hsqldb.sqltool/module-info.java
--- 2.6.1-1/hsqldb/modinfo-src/org.hsqldb.sqltool/module-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/modinfo-src/org.hsqldb.sqltool/module-info.java	2022-06-07 22:07:42.000000000 +0000
@@ -0,0 +1,40 @@
+/* Copyright (c) 2001-2022, The HSQL Development Group
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ * Redistributions of source code must retain the above copyright notice, this
+ * list of conditions and the following disclaimer.
+ *
+ * Redistributions in binary form must reproduce the above copyright notice,
+ * this list of conditions and the following disclaimer in the documentation
+ * and/or other materials provided with the distribution.
+ *
+ * Neither the name of the HSQL Development Group nor the names of its
+ * contributors may be used to endorse or promote products derived from this
+ * software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL HSQL DEVELOPMENT GROUP, HSQLDB.ORG,
+ * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+ * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+ * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+ * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+ * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+ * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+
+module org.hsqldb.sqltool {
+    requires transitive java.logging;
+    requires transitive java.sql;
+
+    exports org.hsqldb.cmdline;
+    exports org.hsqldb.cmdline.libclone;
+    exports org.hsqldb.cmdline.sqltool;
+    exports org.hsqldb.cmdline.utilclone;
+}
diff -pruN 2.6.1-1/hsqldb/readme.txt 2.7.0-1/hsqldb/readme.txt
--- 2.6.1-1/hsqldb/readme.txt	2021-07-19 09:47:44.000000000 +0000
+++ 2.7.0-1/hsqldb/readme.txt	2022-04-24 11:24:32.000000000 +0000
@@ -1,6 +1,6 @@
 Readme File
-2021/06/28-16:31:16
-This package contains HyperSQL v. 2.6.1
+
+This package contains HyperSQL version 2.7.0
 
 HyperSQL Database is a relational database management system and a set of tools
 written in Java.
diff -pruN 2.6.1-1/hsqldb/sample/plsql.sql 2.7.0-1/hsqldb/sample/plsql.sql
--- 2.6.1-1/hsqldb/sample/plsql.sql	2018-10-23 07:24:58.000000000 +0000
+++ 2.7.0-1/hsqldb/sample/plsql.sql	2022-02-21 14:42:16.000000000 +0000
@@ -1,5 +1,5 @@
 /*
- * $Id: plsql.sql 610 2008-12-22 15:54:18Z unsaved $
+ * $Id: plsql.sql 6375 2021-11-07 17:44:56Z unsaved $
  *
  * This example is copied from the "Simple Programs in PL/SQL"
  * example by Yu-May Chang, Jeff Ullman, Prof. Jennifer Widom at
@@ -27,19 +27,12 @@ INSERT INTO T1 VALUES(2, 4);
 
 /* Above is plain SQL; below is the PL/SQL program. */
 DECLARE
-
     a NUMBER;
-
     b NUMBER;
-
 BEGIN
-
     SELECT e,f INTO a,b FROM T1 WHERE e>1;
-
     INSERT INTO T1 VALUES(b,a);
-
 END;
-
 .;
 /** The statement on the previous line, ".;" is SqlTool specific.
  *  This command says to save the input up to this point to the
diff -pruN 2.6.1-1/hsqldb/sample/sqltool.rc 2.7.0-1/hsqldb/sample/sqltool.rc
--- 2.6.1-1/hsqldb/sample/sqltool.rc	2019-01-23 14:53:46.000000000 +0000
+++ 2.7.0-1/hsqldb/sample/sqltool.rc	2022-02-21 14:42:16.000000000 +0000
@@ -1,8 +1,10 @@
-# $Id: sqltool.rc 5871 2018-12-22 16:56:06Z unsaved $
+# $Id: sqltool.rc 6381 2021-11-18 21:45:56Z unsaved $
 
 # This is a sample RC configuration file used by SqlTool, DatabaseManager,
 # and any other program that uses the org.hsqldb.lib.RCData class.
 # See the documentation for SqlTool for various ways to use this file.
+# This is not a Java Properties file. It uses a custom format with stanzas,
+# similar to .netrc files.
 
 # If you have the least concerns about security, then secure access to
 # your RC file.
@@ -40,6 +42,41 @@
 #    liberal patterns, and override settings later in the file with more
 #    specific (or exact) patterns.
 
+# Since service discovery works great in all JREs for many years now, I
+# have removed all 'driver' specifications here.  JRE discover will
+# automatically resolve the driver class based on the JDBC URL format.
+# Most people use default ports, so I have removed port specification from
+# examples except for Microsoft's Sql Server driver where you can't depend
+# on a default port.
+# In all cases, to specify a non-default port, insert colon and port number
+# after the hostname or ip address in the JDBC URL, like
+# jdbc:hsqldb:hsql://localhost:9977 or
+# jdbc:sqlserver://hostname.admc.com:1433;databaseName=dbname
+
+# Amazon Aurora instances are access from JDBC exactly the same as the
+# non-Aurora RDS counterpart.
+
+# For using any database engine other than HyperSQL, you must add the
+# JDBC jar file and the SqlTool jar to your CLASSPATH then run a command like:
+#     java org.hsqldb.util.SqlTool...
+# I.e., the "-jar" switch doesn't support modified classpath.
+# (See SqlTool manual for how to do same thing using Java modules.)
+# To oversimplify for non-developers, the two most common methods to set
+# CLASSPATH for an executable tool like SqlTool are to either use the java
+# "-cp" switch or set environmental variable CLASSPATH.
+# Windows users can use graphical UI or CLI "set".  Unix shell users must
+# "export" in addition to assigning.
+#
+# All JDBC jar files used in these examples are available from Maven
+# repositories.  You can also get them from vendor web sites or with product
+# bundles (especially database distributions).
+# Most databases provide multiple variants.  Most people will want a type 4
+# driver supporting your connection mechanism (most commonly TCP/IP service,
+# but also database file access and others) and your client JRE version.
+# By convention the variants are distinguished in segments of the jar file
+# name before the final ".jar" .
+
+
 # Global default.  .+ matches all lookups:
 urlid .+ 
 username SA
@@ -53,7 +90,7 @@ url jdbc:hsqldb:mem:memdbid
 # A personal, local, persistent database.
 # Inherits username and password from default setting above.
 urlid personal
-url jdbc:hsqldb:file:${user.home}/db/personal;shutdown=true
+url jdbc:hsqldb:file:${user.home}/db/personal;shutdown=true;ifexist=true
 transiso TRANSACTION_READ_COMMITTED
 # When connecting directly to a file database like this, you should 
 # use the shutdown connection property like this to shut down the DB
@@ -62,36 +99,25 @@ transiso TRANSACTION_READ_COMMITTED
 # This is for a hsqldb Server running with default settings on your local
 # computer (and for which you have not changed the password for "SA").
 # Inherits username and password from default setting above.
+# Default port 9001
 urlid localhost-sa
 url jdbc:hsqldb:hsql://localhost
 
 
 
 # Template for a urlid for an Oracle database.
-# You will need to put the oracle.jdbc.OracleDriver class into your 
-# classpath.
-# In the great majority of cases, you want to use jhe desired version of a
-# file odbc*.jar (previously JDBC distributed as classes12.zip),
-# which you can get from the directory $ORACLE_HOME/jdbc/lib of any
-# Oracle installation compatible with your server.
-# Since you need to add to the classpath, you can't invoke SqlTool with
-# the jar switch, like "java -jar .../sqltool.jar...".
-# Put both the SqlTool jar and odbc*.jar in your classpath (and export!)
-# and run something like "java org.hsqldb.util.SqlTool...".
+# Driver jar files from this century have format like "ojbc*.jar".
+# Default port 1521
+urlid localhost-sa
+# Avoid older drivers because they have quirks.
 # You could use the thick driver instead of the thin, but I know of no reason
 # why any Java app should.
 
 #urlid cardiff2
-#url jdbc:oracle:thin:@aegir.admc.com:1521:TRAFFIC_SID
-# Thin SID URLs must specify both port and SID, there are no defaults.
-# Oracle listens to 1521 by default, so that's what you will usually specify.
-# But can alternatively use global service name (not tnsnames.ora service
-# alias, in which case the port does default to 1521):
-#url jdbc:oracle:thin:@centos.admc.com/tstsid.admc
+# Can identify target database with either SID or global service name.
+#url jdbc:oracle:thin:@//centos.admc.com/tstsid.admc
 #username blaine
-#password secretpassword
-#driver oracle.jdbc.OracleDriver
-
+#password asecret
 
 
 # Template for a TLS-encrypted HSQLDB Server.
@@ -101,6 +127,7 @@ url jdbc:hsqldb:hsql://localhost
 # You only need to set "truststore" if the server cert is not approved by
 # your system default truststore (which a commercial certificate probably
 # would be).
+# Port defaults to 554.
 
 #urlid tls
 #url jdbc:hsqldb:hsqls://db.admc.com:9001/lm2
@@ -110,77 +137,84 @@ url jdbc:hsqldb:hsql://localhost
 
 
 # Template for a Postgresql database
+# Driver jar files are of format like "postgresql-*.jar"
+# Port defaults to 5432.
 #urlid blainedb
 #url jdbc:postgresql://idun.africawork.org/blainedb
 #username blaine
-#password losung1
-#driver org.postgresql.Driver
+#password asecret
+
+# Amazon RedShift (a fork of Postgresql)
+# Driver jar files are of format like "redshift-jdbc*.jar"
+# Port defaults to 5439.
+#urlid redhshift
+#url jdbc:redshift://clustername.hex.us-east-1.redshift.amazonaws.com/dev
+#username awsuser
+#password asecret
 
 # Template for a MySQL database.  MySQL has poor JDBC support.
+# The latest driver jar files are of format like "mysql-jdbc*.jar", but not
+# long ago they were like "mysql-connector-java*.jar".
+# Port defaults to 3306
 #urlid mysql-testdb
-#url jdbc:mysql://hostname:3306/dbname
+#url jdbc:mysql://hostname/dbname
 #username root
-#password hiddenpwd
-#driver com.mysql.jdbc.Driver
+#password asecret
+# Alternatively, you can access MySQL using jdbc:mariadb URLs and driver.
 
 # Note that "databases" in SQL Server and Sybase are traditionally used for
 # the same purpose as "schemas" with more SQL-compliant databases.
 
 # Template for a Microsoft SQL Server database using Microsoft's Driver
-# (I find that the JTDS driver is much more responsive than Microsoft's).
-# Port defaults to 1433.
+# Seems that some versions default to port 1433 and others to 1434.
 # MSDN implies instances are port-specific, so can specify port or instname.
 #urlid msprojsvr
-# url/driver for Current 2011 JDBC Driver for Microsoft SQL Server:
-# Requires just the new sqljdbc4.jar.  (Microsoft just loves back-slashes)
-#url jdbc:sqlserver://hostname\instname;databaseName=dbname
-# OR
+# Driver jar files are of format like "mssql-jdbc-*.jar".
+# Don't use older MS JDBC drivers (like SQL Server 2000 vintage) because they
+# are pitifully incompetent, handling transactions incorrectly.
+# I recommend that you do not use Microsoft's nonstandard format that
+# includes backslashes.
 #url jdbc:sqlserver://hostname;instanceName=instname;databaseName=dbname
-#driver com.microsoft.jdbc.sqlserver.SQLServerDriver
-# See, for example,
-# https://docs.microsoft.com/en-us/sql/connect/jdbc/building-the-connection-url?view=sql-server-2017
-# url/deriver for OLDER JDBC Driver:
-#url jdbc:microsoft:sqlserver://hostname;DatabaseName=DbName;SelectMethod=Cursor
-# The SelectMethod setting is required to do more than one thing on a JDBC
-# session (I guess Microsoft thought nobody would really use Java for 
-# anything other than a "hello world" program).
-# This is for Microsoft's SQL Server 2000 driver (requires mssqlserver.jar
-# and msutil.jar).
-#driver com.microsoft.jdbc.sqlserver.SQLServerDriver
+# with port:
+#url jdbc:sqlserver://hostname:1433;instanceName=instname;databaseName=dbname
 #username myuser
-#password hiddenpwd
+#password asecret
 
 # Template for Microsoft SQL Server database using the JTDS Driver
-# http://jtds.sourceforge.net  Jar file has name like "jtds-1.2.5.jar".
+# Looks like this project is no longer maintained, so you may be better off
+# using the Microsoft driver above.
+# http://jtds.sourceforge.net  Jar file has name like "jtds-1.3.1.jar".
 # Port defaults to 1433.
 # MSDN implies instances are port-specific, so can specify port or instname.
 #urlid nlyte
 #username myuser
-#password hiddenpwd
+#password asecret
 #url jdbc:jtds:sqlserver://myhost/nlyte;instance=MSSQLSERVER
 # Where database is 'nlyte' and instance is 'MSSQLSERVER'.
 # N.b. this is diff. from MS tools and JDBC driver where (depending on which
 # document you read), instance or database X are specified like  HOSTNAME\X.
-#driver net.sourceforge.jtds.jdbc.Driver
 
 # Template for a Sybase database
 #urlid sybase
 #url jdbc:sybase:Tds:hostname:4100/dbname
 #username blaine
-#password hiddenpwd
+#password asecret
 # This is for the jConnect driver (requires jconn3.jar).
-#driver com.sybase.jdbc3.jdbc.SybDriver
 
-# Template for Embedded Derby / Java DB.
-#urlid derby1
-#url jdbc:derby:path/to/derby/directory;create=true
+# Derby / Java DB.
+# Please see the Derby JDBC docs, because they have changed the organization
+# of their driver jar files in recent years.  Combining that with the different
+# database types supported and jar file classpath chaining, and it's not
+# feasible to document it adequately here.
+# I'll just give one example using network service, which works with 10.15.2.0.
+# Put files derbytools*.jar, derbyclient*.jar, derbyshared*.jar into a
+# directory and include the path to the derbytools.jar in your classpath.
+# Port defaults to 1527.
+#url jdbc:derby://server:<port>/databaseName
 #username ${user.name}
 #password any_noauthbydefault
-#driver org.apache.derby.jdbc.EmbeddedDriver
-# The embedded Derby driver requires derby.jar.
-# There'a also the org.apache.derby.jdbc.ClientDriver driver with URL
-# like jdbc:derby://<server>[:<port>]/databaseName, which requires
-# derbyclient.jar.
+# If you get the right classes into classpath, local file URLs are like:
+#url jdbc:derby:path/to/derby/directory
 # You can use \= to commit, since the Derby team decided (why???)
 # not to implement the SQL standard statement "commit"!!
 # Note that SqlTool can not shut down an embedded Derby database properly,
@@ -188,3 +222,13 @@ url jdbc:hsqldb:hsql://localhost
 # However, I've never lost data by shutting it down improperly.
 # Other than not supporting this quirk of Derby, SqlTool is miles ahead of
 # Derby's ij.
+
+# Maria DB
+# With current versions, the MySQL driver does not work to access a Maria
+# database (though the inverse works).
+# Driver jar files are of format like "mariadb-java-client*.jar"
+# Port defaults to 3306
+#urlid maria
+#url jdbc:mariadb://hostname/db2
+#username blaine
+#password asecret
diff -pruN 2.6.1-1/hsqldb/src/modules/org.hsqldb/module-info.java 2.7.0-1/hsqldb/src/modules/org.hsqldb/module-info.java
--- 2.6.1-1/hsqldb/src/modules/org.hsqldb/module-info.java	2020-12-15 18:31:46.000000000 +0000
+++ 2.7.0-1/hsqldb/src/modules/org.hsqldb/module-info.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,49 +0,0 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions are met:
- *
- * Redistributions of source code must retain the above copyright notice, this
- * list of conditions and the following disclaimer.
- *
- * Redistributions in binary form must reproduce the above copyright notice,
- * this list of conditions and the following disclaimer in the documentation
- * and/or other materials provided with the distribution.
- *
- * Neither the name of the HSQL Development Group nor the names of its
- * contributors may be used to endorse or promote products derived from this
- * software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
- * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED. IN NO EVENT SHALL HSQL DEVELOPMENT GROUP, HSQLDB.ORG,
- * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
- * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
- * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
- * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
- * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
- * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
- * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- */
-
-
-module org.hsqldb {
-   exports org.hsqldb.auth;
-   exports org.hsqldb.jdbc;
-   exports org.hsqldb.jdbc.pool;
-   exports org.hsqldb.lib;
-   exports org.hsqldb.lib.tar;
-   exports org.hsqldb.server;
-   exports org.hsqldb.trigger;
-   exports org.hsqldb.util;
-
-   requires java.desktop;
-   requires java.logging;
-   requires java.naming;
-   requires java.sql;
-   requires java.xml;
-
-   provides java.sql.Driver with org.hsqldb.jdbc.JDBCDriver;
-}
diff -pruN 2.6.1-1/hsqldb/src/modules/org.hsqldb.min/module-info.java 2.7.0-1/hsqldb/src/modules/org.hsqldb.min/module-info.java
--- 2.6.1-1/hsqldb/src/modules/org.hsqldb.min/module-info.java	2020-12-17 16:11:46.000000000 +0000
+++ 2.7.0-1/hsqldb/src/modules/org.hsqldb.min/module-info.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,46 +0,0 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions are met:
- *
- * Redistributions of source code must retain the above copyright notice, this
- * list of conditions and the following disclaimer.
- *
- * Redistributions in binary form must reproduce the above copyright notice,
- * this list of conditions and the following disclaimer in the documentation
- * and/or other materials provided with the distribution.
- *
- * Neither the name of the HSQL Development Group nor the names of its
- * contributors may be used to endorse or promote products derived from this
- * software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
- * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED. IN NO EVENT SHALL HSQL DEVELOPMENT GROUP, HSQLDB.ORG,
- * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
- * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
- * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
- * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
- * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
- * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
- * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- */
-
-
-module org.hsqldb {
-   exports org.hsqldb.auth;
-   exports org.hsqldb.jdbc;
-   exports org.hsqldb.jdbc.pool;
-   exports org.hsqldb.lib;
-   exports org.hsqldb.lib.tar;
-   exports org.hsqldb.trigger;
-
-   requires java.logging;
-   requires java.naming;
-   requires java.sql;
-   requires java.xml;
-
-   provides java.sql.Driver with org.hsqldb.jdbc.JDBCDriver;
-}
diff -pruN 2.6.1-1/hsqldb/src/modules/org.hsqldb.sqltool/module-info.java 2.7.0-1/hsqldb/src/modules/org.hsqldb.sqltool/module-info.java
--- 2.6.1-1/hsqldb/src/modules/org.hsqldb.sqltool/module-info.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/modules/org.hsqldb.sqltool/module-info.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,40 +0,0 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions are met:
- *
- * Redistributions of source code must retain the above copyright notice, this
- * list of conditions and the following disclaimer.
- *
- * Redistributions in binary form must reproduce the above copyright notice,
- * this list of conditions and the following disclaimer in the documentation
- * and/or other materials provided with the distribution.
- *
- * Neither the name of the HSQL Development Group nor the names of its
- * contributors may be used to endorse or promote products derived from this
- * software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
- * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED. IN NO EVENT SHALL HSQL DEVELOPMENT GROUP, HSQLDB.ORG,
- * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
- * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
- * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
- * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
- * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
- * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
- * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- */
-
-
-module org.hsqldb.sqltool {
-    requires transitive java.logging;
-    requires transitive java.sql;
-
-    exports org.hsqldb.cmdline;
-    exports org.hsqldb.cmdline.libclone;
-    exports org.hsqldb.cmdline.sqltool;
-    exports org.hsqldb.cmdline.utilclone;
-}
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/auth/AuthBeanMultiplexer.java 2.7.0-1/hsqldb/src/org/hsqldb/auth/AuthBeanMultiplexer.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/auth/AuthBeanMultiplexer.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/auth/AuthBeanMultiplexer.java	2022-05-17 12:18:14.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -91,6 +91,8 @@ public class AuthBeanMultiplexer {
      * The given entries are copied, to limit side-effects and concurrency
      * issues.
      * </P>
+     *
+     * @param authFunctionBeanMap Map
      */
     public void setAuthFunctionBeans(
             Map<String, List<AuthFunctionBean>> authFunctionBeanMap) {
@@ -131,7 +133,8 @@ public class AuthBeanMultiplexer {
     /**
      * Wrapper for {@code setAuthFunctionBeans(String, List<AuthFunctionBean>)}
      *
-     * @param c  An open Connection to the desired database.
+     * @param c An open Connection to the desired database.
+     * @param authFunctionBeans List
      * @throws SQLException if failed to obtain unique name from given
      *                      Connection.
      */
@@ -155,6 +158,8 @@ public class AuthBeanMultiplexer {
      *
      * @see #setAuthFunctionBeans(Map)
      * @see #setAuthFunctionBean(String, AuthFunctionBean)
+     * @param dbName String
+     * @param authFunctionBeans List
      */
     public void setAuthFunctionBeans(String dbName,
             List<AuthFunctionBean> authFunctionBeans) {
@@ -179,6 +184,11 @@ public class AuthBeanMultiplexer {
     /**
      * Exactly the same as setAuthFunctionBeans(String, List) other than taking
      * an open Connection to identify the database.
+     *
+     * @param c Connection
+     * @param authFunctionBean AuthFunctionBean
+     * @throws SQLException if failed to obtain unique name from given
+     *   Connection.
      */
     public void setAuthFunctionBean(Connection c,
             AuthFunctionBean authFunctionBean) throws SQLException {
@@ -197,6 +207,8 @@ public class AuthBeanMultiplexer {
      * </P>
      *
      * @see #setAuthFunctionBeans(String, List)
+     * @param dbName String
+     * @param authFunctionBean AuthFunctionBean
      */
     public void setAuthFunctionBean(String dbName,
             AuthFunctionBean authFunctionBean) {
@@ -239,6 +251,9 @@ public class AuthBeanMultiplexer {
      *         Exception.
      * @return Null or java.sql.Array to indicate successful authentication
      *         according to the contract for HyperSQL authentication functions.
+     * @param database String
+     * @param user String
+     * @param password String
      */
     public static java.sql.Array authenticate(
             String database, String user, String password)
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/auth/HsqldbSlaveAuthBean.java 2.7.0-1/hsqldb/src/org/hsqldb/auth/HsqldbSlaveAuthBean.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/auth/HsqldbSlaveAuthBean.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/auth/HsqldbSlaveAuthBean.java	2022-05-17 12:18:14.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -61,14 +61,18 @@ public class HsqldbSlaveAuthBean impleme
     /**
      * Use this method and setValidationPassword if you want access to the
      * master database to be verified upon instance initialization.
+     *
+     * @param validationUser String
      */
     public void setValidationUser(String validationUser) {
         this.validationUser = validationUser;
     }
 
     /**
-     * Use this method and setValidationUser if you want access to the
-     * master database to be verified upon instance initialization.
+     * Use this method and setValidationUser if you want access to the master
+     * database to be verified upon instance initialization.
+     *
+     * @param validationPassword String
      */
     public void setValidationPassword(String validationPassword) {
         this.validationPassword = validationPassword;
@@ -79,10 +83,10 @@ public class HsqldbSlaveAuthBean impleme
     }
 
     /**
-     * Defaults to true.
+     * Defaults to true. Whether roles and initial schema for the new session
+     * will be determined by what they are for this user in the master database.
      *
-     * Whether roles and initial schema for the new session will be determined
-     * by what they are for this user in the master database.
+     * @param doDelegateRolesSchema boolean
      */
     public void setDelegateRolesSchema(boolean doDelegateRolesSchema) {
         delegateRolesSchema = doDelegateRolesSchema;
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/ClientConnectionHTTP.java 2.7.0-1/hsqldb/src/org/hsqldb/ClientConnectionHTTP.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/ClientConnectionHTTP.java	2021-02-09 04:52:12.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/ClientConnectionHTTP.java	2022-04-11 19:00:20.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -36,6 +36,7 @@ import java.io.DataInputStream;
 import java.io.IOException;
 import java.net.HttpURLConnection;
 import java.net.URL;
+import java.util.TimeZone;
 
 import org.hsqldb.lib.DataOutputStream;
 import org.hsqldb.lib.HsqlByteArrayOutputStream;
@@ -46,7 +47,7 @@ import org.hsqldb.result.Result;
  * protocol.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.4.1
+ * @version 2.7.0
  * @since 1.7.2
  */
 public class ClientConnectionHTTP extends ClientConnection {
@@ -60,9 +61,9 @@ public class ClientConnectionHTTP extend
     public ClientConnectionHTTP(String host, int port, String path,
                                 String database, boolean isTLS,
                                 boolean isTLSWrapper, String user,
-                                String password, int timeZoneSeconds) {
+                                String password, TimeZone timeZone) {
         super(host, port, path, database, isTLS, isTLSWrapper, user, password,
-              timeZoneSeconds);
+              timeZone);
     }
 
     public ClientConnectionHTTP(ClientConnectionHTTP other) {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/ClientConnection.java 2.7.0-1/hsqldb/src/org/hsqldb/ClientConnection.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/ClientConnection.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/ClientConnection.java	2022-06-28 18:49:38.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -57,7 +57,6 @@ import org.hsqldb.rowio.RowOutputInterfa
 import org.hsqldb.server.HsqlSocketFactory;
 import org.hsqldb.types.BlobDataID;
 import org.hsqldb.types.ClobDataID;
-import org.hsqldb.types.TimestampData;
 
 /**
  * Base remote session proxy implementation. Uses instances of Result to
@@ -65,7 +64,7 @@ import org.hsqldb.types.TimestampData;
  * protocol.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.5.1
+ * @version 2.7.0
  * @since 1.7.2
  */
 public class ClientConnection implements SessionInterface, Cloneable {
@@ -130,7 +129,7 @@ public class ClientConnection implements
     public ClientConnection(String host, int port, String path,
                             String database, boolean isTLS,
                             boolean isTLSWrapper, String user,
-                            String password, int timeZoneSeconds) {
+                            String password, TimeZone timeZone) {
 
         this.host         = host;
         this.port         = port;
@@ -138,14 +137,14 @@ public class ClientConnection implements
         this.database     = database;
         this.isTLS        = isTLS;
         this.isTLSWrapper = isTLSWrapper;
-        this.zoneSeconds  = timeZoneSeconds;
-        this.zoneString   = TimeZone.getDefault().getID();
+        this.zoneSeconds  = timeZone.getOffset(System.currentTimeMillis()) / 1000;
+        this.zoneString   = timeZone.getID();
 
         initStructures();
         initConnection(host, port, isTLS);
 
         Result login = Result.newConnectionAttemptRequest(user, password,
-            database, zoneString, timeZoneSeconds);
+            database, zoneString, zoneSeconds);
         Result resultIn = execute(login);
 
         if (resultIn.isError()) {
@@ -250,7 +249,7 @@ public class ClientConnection implements
 
             return read();
         } catch (Throwable e) {
-            throw Error.error(ErrorCode.X_08006, e.toString());
+            throw Error.error(e, ErrorCode.X_08006, e.toString());
         }
     }
 
@@ -267,7 +266,7 @@ public class ClientConnection implements
 
             return (RowSetNavigatorClient) result.getNavigator();
         } catch (Throwable e) {
-            throw Error.error(ErrorCode.X_08006, e.toString());
+            throw Error.error(e, ErrorCode.X_08006, e.toString());
         }
     }
 
@@ -633,15 +632,6 @@ public class ClientConnection implements
         return simpleDateFormatGMT;
     }
 
-    public TimestampData getCurrentDate() {
-
-        long currentMillis = System.currentTimeMillis();
-
-        currentMillis = HsqlDateTime.getNormalisedDate(currentMillis);
-
-        return new TimestampData(currentMillis / 1000);
-    }
-
     public int getZoneSeconds() {
         return zoneSeconds;
     }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/cmdline/package-info.java 2.7.0-1/hsqldb/src/org/hsqldb/cmdline/package-info.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/cmdline/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/cmdline/package-info.java	2022-05-16 22:32:22.000000000 +0000
@@ -0,0 +1,35 @@
+/* Copyright (c) 2001-2022, The HSQL Development Group
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ * Redistributions of source code must retain the above copyright notice, this
+ * list of conditions and the following disclaimer.
+ *
+ * Redistributions in binary form must reproduce the above copyright notice,
+ * this list of conditions and the following disclaimer in the documentation
+ * and/or other materials provided with the distribution.
+ *
+ * Neither the name of the HSQL Development Group nor the names of its
+ * contributors may be used to endorse or promote products derived from this
+ * software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL HSQL DEVELOPMENT GROUP, HSQLDB.ORG,
+ * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+ * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+ * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+ * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+ * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+ * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+
+/**
+ * Contains the SqlTool command-line tool
+ */
+package org.hsqldb.cmdline;
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/cmdline/SqlFile.java 2.7.0-1/hsqldb/src/org/hsqldb/cmdline/SqlFile.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/cmdline/SqlFile.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/cmdline/SqlFile.java	2022-06-12 14:53:32.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -86,11 +86,11 @@ import org.hsqldb.cmdline.libclone.Appen
 import org.hsqldb.cmdline.libclone.FrameworkLogger;
 import org.hsqldb.cmdline.utilclone.RCData;
 
-/* $Id: SqlFile.java 6266 2021-01-25 16:08:06Z fredt $ */
+/* $Id: SqlFile.java 6559 2022-06-12 15:53:31Z fredt $ */
 
 /**
- * Encapsulation of SQL text and the environment under which it will executed
- * with a JDBC Connection.
+ * Encapsulation of SQL text and the environment under which it will be
+ * executed with a JDBC Connection.
  * 'SqlInputStream' would be a more precise name, but the content we are
  * talking about here is what is colloqially known as the contents of
  * "SQL file"s.
@@ -149,8 +149,7 @@ import org.hsqldb.cmdline.utilclone.RCDa
  * @see <a href="../../../../util-guide/sqltool-chapt.html" target="guide">
  *     The SqlTool chapter of the
  *     HyperSQL Utilities Guide</a>
- * @see org.hsqldb.sample.SqlFileEmbedder
- * @version $Revision: 6266 $, $Date: 2021-01-25 16:08:06 +0000 (Mon, 25 Jan 2021) $
+ * @version $Revision: 6559 $, $Date: 2022-06-12 16:53:31 +0100 (Sun, 12 Jun 2022) $
  * @author Blaine Simpson (blaine dot simpson at admc dot com)
  */
 
@@ -160,16 +159,16 @@ public class SqlFile {
     private static final int TIMESTAMP_WITH_TIMEZONE = 2014;
 
     private enum Recursion { FILE, IF, WHILE, FOREACH, FOR, FORROWS }
-    private static FrameworkLogger logger =
+    private static final FrameworkLogger logger =
             FrameworkLogger.getLog(SqlFile.class);
     private static final int DEFAULT_HISTORY_SIZE = 40;
     private boolean          executing;
     private boolean          permitEmptySqlStatements;
     private boolean          interactive;
-    private String           primaryPrompt    = "sql> ";
-    private static String    rawPrompt;
+    private final String           primaryPrompt    = "sql> ";
+    private static final String    rawPrompt;
     private static Method    createArrayOfMethod;
-    private String           contPrompt       = "  +> ";
+    private static final String           contPrompt       = "  +> ";
     private boolean          htmlMode;
     private TokenList        history;
     /** Platform-specific line separator */
@@ -181,19 +180,19 @@ public class SqlFile {
     private Reader           reader;
     // Reader serves the auxiliary purpose of null meaning execute()
     // has finished.
-    private String           inputStreamLabel;
-    private URL              atBase;
+    private final String           inputStreamLabel;
+    private final URL        atBase;
     private boolean          dsvTrimAll;
     private boolean          ignoreBangStatus;
     private boolean          allQuoted;
     private boolean          doPrepare;
-    private static String    DSV_X_SYNTAX_MSG;
-    private static String    DSV_M_SYNTAX_MSG;
-    private static String    nobufferYetString;
+    private static final String    DSV_X_SYNTAX_MSG;
+    private static final String    DSV_M_SYNTAX_MSG;
+    private static final String    nobufferYetString;
     private String           prepareVar;
     private int              dsvRecordsPerCommit = 0;
 
-    static String            DEFAULT_FILE_ENCODING =
+    static final String            DEFAULT_FILE_ENCODING =
                              System.getProperty("file.encoding");
 
     // These settings are never null
@@ -221,66 +220,66 @@ public class SqlFile {
      * unpredictable wrt whether you get a null capture group vs. no capture.
      * Must always check count!
      */
-    private static Pattern   varPattern = Pattern.compile("\\*?[a-zA-Z]\\w*");
-    private static Pattern   wordAndDotPattern = Pattern.compile("[\\w.]+");
-    private static Pattern   specialPattern =
+    private static final Pattern   varPattern = Pattern.compile("\\*?[a-zA-Z]\\w*");
+    private static final Pattern   wordAndDotPattern = Pattern.compile("[\\w.]+");
+    private static final Pattern   specialPattern =
             Pattern.compile("(\\S+)(?:\\s(.*))?");
-    private static Pattern  plPattern = Pattern.compile("(.*\\S)?\\s*");
-    private static Pattern  mathAsgnPattern = Pattern.compile(
+    private static final Pattern  plPattern = Pattern.compile("(.*\\S)?\\s*");
+    private static final Pattern  mathAsgnPattern = Pattern.compile(
         "\\(\\(\\s*([a-zA-Z]\\w*)\\s*([-+*/%][-+=])\\s*(.+?)?\\s*\\)\\)\\s*");
-    private static Pattern  mathPattern = Pattern.compile(
+    private static final Pattern  mathPattern = Pattern.compile(
             "\\(\\(\\s*([a-zA-Z]\\w*)\\s*=\\s*(.+?)?\\s*\\)\\)\\s*");
-    private static Pattern   foreachPattern =
+    private static final Pattern   foreachPattern =
             Pattern.compile("foreach\\s+(\\S+)\\s*\\(([^)]+)\\)\\s*");
-    private static Pattern   forrowsPattern =
+    private static final Pattern   forrowsPattern =
             Pattern.compile("forrows((?:\\s+[a-zA-Z]\\w*)*)\\s*");
-    private static Pattern   forPattern = Pattern.compile(
+    private static final Pattern   forPattern = Pattern.compile(
         "for\\s+(\\(\\(.+\\)\\))?\\s*(\\([^)]+\\))\\s*(\\(\\(.+\\)\\))\\s*");
-    private static Pattern   ifwhilePattern =
+    private static final Pattern   ifwhilePattern =
             Pattern.compile("\\S+\\s*\\(([^)]*)\\)\\s*");
-    private static Pattern   inlineifPattern =
+    private static final Pattern   inlineifPattern =
             Pattern.compile("(if\\s*\\([^)]*\\))(.*\\S.*)");
-    private static Pattern   varsetPattern =
+    private static final Pattern   varsetPattern =
             Pattern.compile("(\\S+)\\s*([=_~:])(.*)?");
-    private static Pattern   substitutionPattern =
+    private static final Pattern   substitutionPattern =
             Pattern.compile("(\\S)(.+?)\\1(.*?)\\1(.+?)?\\s*");
             // Note that this pattern does not include the leading ":s".
-    private static Pattern   slashHistoryPattern =
+    private static final Pattern   slashHistoryPattern =
             Pattern.compile("\\s*/([^/]+)/\\s*(\\S.*)?");
-    private static Pattern   historyPattern =
+    private static final Pattern   historyPattern =
             Pattern.compile("\\s*(-?\\d+)?\\s*(\\S.*)?");
             // Note that this pattern does not include the leading ":".
     private static Pattern wincmdPattern;
-    private static Pattern useMacroPattern =
+    private static final Pattern useMacroPattern =
             Pattern.compile("(\\w+)(\\s.*[^;])?(;?)");
-    private static Pattern useFnPattern =
+    private static final Pattern useFnPattern =
             Pattern.compile("(\\w+\\()\\s*([^;)]*?)\\s*\\)(.*)");
-    private static Pattern legacyEditMacroPattern =
+    private static final Pattern legacyEditMacroPattern =
             Pattern.compile("(\\w+(?:\\(\\))?)\\s*:(.*)");
-    private static Pattern editMacroPattern =
+    private static final Pattern editMacroPattern =
             Pattern.compile(":\\s(\\w+(?:\\(\\))?)(?:\\s(.*))?");
-    private static Pattern spMacroPattern =
+    private static final Pattern spMacroPattern =
             Pattern.compile("(\\w+(?:\\(\\))?)\\s+([*\\\\])(.*\\S)");
-    private static Pattern sqlMacroPattern =
+    private static final Pattern sqlMacroPattern =
             Pattern.compile("(\\w+(?:\\(\\))?)\\s+(.*\\S)");
-    private static Pattern integerPattern = Pattern.compile("\\d+");
-    private static Pattern nameValPairPattern =
+    private static final Pattern integerPattern = Pattern.compile("\\d+");
+    private static final Pattern nameValPairPattern =
             Pattern.compile("\\s*(\\w+)\\s*=(.*)");
             // Specifically permits 0-length values, but not names.
-    private static Pattern dotPattern = Pattern.compile("(\\w*)\\.(\\w*)");
-    private static Pattern commitOccursPattern =
-            Pattern.compile("(?is)(?:set\\s+autocommit.*)|(commit\\s*)");
-    private static Pattern logPattern =
+    private static final Pattern dotPattern = Pattern.compile("(\\w*)\\.(\\w*)");
+    private static final Pattern commitOccursPattern =
+            Pattern.compile("(?is)set\\s+autocommit.*|commit\\s*");
+    private static final Pattern logPattern =
         Pattern.compile("(?i)(FINER|WARNING|SEVERE|INFO|FINEST)\\s+(.*\\S)");
-    private static Pattern   arrayPattern =
-            Pattern.compile("ARRAY\\s*\\[\\s*(.*\\S)?\\s*\\]");
-    private static Pattern fnParamPat = Pattern.compile("\\*\\{(:)?(\\d+)\\}");
+    private static final Pattern   arrayPattern =
+            Pattern.compile("ARRAY\\s*\\[\\s*(.*\\S)?\\s*]");
+    private static final Pattern fnParamPat = Pattern.compile("\\*\\{(:)?(\\d+)}");
     static final Pattern URL_WITH_PROTO_RE = Pattern.compile("[a-z]{2,}:.+");
 
-    private static Map<String, Pattern> nestingPLCommands =
-            new HashMap<String, Pattern>();
-    private static Map<String, Pattern> inlineNestPLCommands =
-            new HashMap<String, Pattern>();
+    private static final Map<String, Pattern> nestingPLCommands =
+            new HashMap<>();
+    private static final Map<String, Pattern> inlineNestPLCommands =
+            new HashMap<>();
     static {
         nestingPLCommands.put("if", ifwhilePattern);
         nestingPLCommands.put("while", ifwhilePattern);
@@ -311,7 +310,7 @@ public class SqlFile {
 
     private boolean removeEmptyVars() {
         String sysP = System.getProperty("sqltool.REMOVE_EMPTY_VARS");
-        return sysP != null && Boolean.parseBoolean(sysP);
+        return Boolean.parseBoolean(sysP);
     }
 
     /**
@@ -433,12 +432,12 @@ public class SqlFile {
         Connection jdbcConn;
 
         // Since we enforce non-null mapping values, userVars.get(key) of null
-        // always means that that the map does not contain the specified key.
-        Map<String, String> userVars = new HashMap<String, String>();
+        // always means that the map does not contain the specified key.
+        final Map<String, String> userVars = new HashMap<>();
 
-        Map<String, Token> macros = new HashMap<String, Token>();
+        final Map<String, Token> macros = new HashMap<>();
 
-        PrintStream psStd;
+        final PrintStream psStd;
 
         SharedFields(PrintStream psStd) {
             this.psStd = psStd;
@@ -453,16 +452,17 @@ public class SqlFile {
         "-----------------------------------------------------------------"
         + "-----------------------------------------------------------------";
     // Needs to be at least as wide as the widest field or header displayed.
-    private static final String revString = "$Revision: 6266 $";
+    private static final String revString = "$Revision: 6559 $";
     private static final int revStringLength = revString.length();
+    @SuppressWarnings("ConstantConditions")
     private static final String  revnum =
             (revStringLength - " $".length() > "$Revision: ".length())
             ?  revString.substring("$Revision: ".length(),
                     revStringLength - " $".length())
             : "<UNTRACKED>";
 
-    private static String DSV_OPTIONS_TEXT;
-    private static String D_OPTIONS_TEXT;
+    private static final String DSV_OPTIONS_TEXT;
+    private static final String D_OPTIONS_TEXT;
 
     /**
      * Convenience wrapper for the SqlFile(File, String) constructor
@@ -550,7 +550,7 @@ public class SqlFile {
     final boolean interactive, final File atBaseFile)
     throws IOException {
         this(reader, inputStreamLabel, psStd, encoding, interactive,
-          atBaseFile == null ? ((URL) null) :
+          atBaseFile == null ? null :
           new URL("file", null, atBaseFile.getPath()));
     }
 
@@ -616,12 +616,9 @@ public class SqlFile {
             }
             // Updates local vars basd on * shared.userVars
             // even when (like now) these are all defaults.
-        } catch (IOException ioe) {
-            closeReader();
-            throw ioe;
-        } catch (RuntimeException re) {
+        } catch (IOException | RuntimeException iore) {
             closeReader();
-            throw re;
+            throw iore;
         }
     }
 
@@ -720,7 +717,7 @@ public class SqlFile {
                         "Null mapping values not allowed");
         }
         shared.userVars.putAll(newUserVars);
-        List<String> strangeVars = new ArrayList<String>();
+        List<String> strangeVars = new ArrayList<>();
         for (String name : newUserVars.keySet())
             if (!name.equals("?") && !name.equals("#")
                     && !varPattern.matcher(name).matches())
@@ -810,7 +807,7 @@ public class SqlFile {
      * @throws SQLException thrown by JDBC driver.
      *                       Only possible if in "\c false" mode.
      * @throws SqlToolError  all other errors.
-     *               This includes including QuitNow, BreakException,
+     *               This includes QuitNow, BreakException,
      *               ContinueException for recursive calls only.
      */
     synchronized public void execute() throws SqlToolError, SQLException {
@@ -839,7 +836,7 @@ public class SqlFile {
                 closeQueryOutputStream();
                 if (autoClose) closeReader();
             } finally {
-                reader = null; // Encourage GC of buffers
+                reader = null; // encourage GC of buffers
             }
         }
     }
@@ -873,7 +870,7 @@ public class SqlFile {
      *
      * @return Matcher which has already successfully .matched() or null
      */
-    private Matcher inlineNestMatcher(Token token) throws BadSpecial {
+    private Matcher inlineNestMatcher(Token token) {
         if (token.type != Token.PL_TYPE) return null;
         // The scanner assures that val is non-null for PL_TYPEs.
         String commandWord = token.val.replaceFirst("\\s.*", "");
@@ -1006,7 +1003,7 @@ public class SqlFile {
                         }
                         if (receivedType == Token.RAWEXEC_TYPE) {
                             historize();
-                            ResultSet rs = null;
+                            ResultSet rs;
                             Statement statement = processSQL();
                             if (statement != null) {
                                 try {
@@ -1014,13 +1011,12 @@ public class SqlFile {
                                     displaySqlResults(
                                             statement, rs, null, null, true);
                                 } finally {
-                                    assert statement != null;
                                     try {
                                         statement.close();
                                     } catch (SQLException nse) {
                                         // Purposefully doing nothing
                                     } finally {
-                                        statement = null;
+                                        statement = null; // encourage GC
                                     }
                                 }
                             }
@@ -1057,7 +1053,7 @@ public class SqlFile {
                         if (token.val == null) token.val = "";
                         setBuf(token);
                         historize();
-                        ResultSet rs = null;
+                        ResultSet rs;
                         Statement statement = processSQL();
                         if (statement != null) {
                             try {
@@ -1065,13 +1061,12 @@ public class SqlFile {
                                 displaySqlResults(
                                         statement, rs, null, null, true);
                             } finally {
-                                assert statement != null;
                                 try {
                                     statement.close();
                                 } catch (SQLException nse) {
                                     // Purposefully doing nothing
                                 } finally {
-                                    statement = null;
+                                    statement = null;  // encourage dealloc.
                                 }
                             }
                         }
@@ -1083,7 +1078,6 @@ public class SqlFile {
                 }
             } catch (BadSpecial bs) {
                 // BadSpecials ALWAYS have non-null getMessage().
-                assert token != null;
                 errprintln(SqltoolRB.errorat.getString(
                         inputStreamLabel,
                         Integer.toString(token.line),
@@ -1096,7 +1090,6 @@ public class SqlFile {
                 if (!continueOnError) throw new SqlToolError(bs);
             } catch (SQLException se) {
                 //se.printStackTrace();
-                assert token != null;
                 errprintln("SQL " + SqltoolRB.errorat.getString(
                         inputStreamLabel, Integer.toString(token.line),
                         lastSqlStatement,
@@ -1135,8 +1128,7 @@ public class SqlFile {
             } catch (QuitNow qn) {
                 throw qn;
             } catch (SqlToolError ste) {
-                assert token != null;
-                StringBuffer sb = new StringBuffer(SqltoolRB.errorat.getString(
+                String str0 = SqltoolRB.errorat.getString(
                     /* WARNING:  I have removed an extra LS appended to
                      * non-null ste.getMessages() below because I believe that
                      * it is unnecessary (and causes inconsistent blank lines
@@ -1144,15 +1136,13 @@ public class SqlFile {
                      * If I am wrong and this is needed for Scanner display or
                      * something, restore it.
                      */
-                    (new String[] {
-                        inputStreamLabel, Integer.toString(token.line),
-                        ((token.val == null) ? "" : token.reconstitute()),
-                        ((ste.getMessage() == null)
-                                ? "" : ste.getMessage())
-                     })
-                ));
+                    inputStreamLabel, Integer.toString(token.line),
+                    ((token.val == null) ? "" : token.reconstitute()),
+                    ((ste.getMessage() == null)
+                            ? "" : ste.getMessage())
+                );
                 Throwable cause = ste.getCause();
-                errprintln((cause == null) ? sb.toString()
+                errprintln((cause == null) ? str0
                         : SqltoolRB.causereport.getString(cause));
                 if (!continueOnError) throw ste;
             }
@@ -1173,8 +1163,6 @@ public class SqlFile {
                 errprintln(SqltoolRB.aborting.getString(qn.getMessage()));
                 throw new SqlToolError(qn.getMessage());
             }
-
-            return;
         } finally {
             if (fetchingVar != null) {
                 errprintln(SqltoolRB.plvar_set_incomplete.getString(
@@ -1199,7 +1187,7 @@ public class SqlFile {
      *
      * Do not instantiate with null message.
      */
-    private static class BadSpecial extends AppendableException {
+    public static class BadSpecial extends AppendableException {
         static final long serialVersionUID = 7162440064026570590L;
 
         BadSpecial(final String s) {
@@ -1310,12 +1298,11 @@ public class SqlFile {
      * we do for other kinds of commands.
      *
      * @param token Complete command, less the leading ':' character.
-     * @throws SQLException  thrown by JDBC driver.
      * @throws BadSpecial    special-command-specific errors.
      * @throws SqlToolError  all other errors.
      */
     private void processBuffHist(final Token token)
-    throws BadSpecial, SQLException, SqlToolError {
+    throws BadSpecial, SqlToolError {
         if (token.val.length() < 1)
             throw new BadSpecial(SqltoolRB.bufhist_unspecified.getString());
 
@@ -1353,7 +1340,7 @@ public class SqlFile {
                 return;
         }
 
-        Integer histNum = null;
+        Integer histNum;
         Matcher hm = slashHistoryPattern.matcher(token.val);
         if (hm.matches()) {
             histNum = historySearch(hm.group(1));
@@ -1379,7 +1366,7 @@ public class SqlFile {
         other = ((commandChar == '\0') ? null : hm.group(2).substring(1));
         if (other != null && other.trim().length() < 1) other = null;
         Token targetCommand = ((histNum == null)
-                ? null : commandFromHistory(histNum.intValue()));
+                ? null : commandFromHistory(histNum));
         // Every command below depends upon buffer content.
 
         switch (commandChar) {
@@ -1575,8 +1562,9 @@ public class SqlFile {
      * @throws SqlToolError all other errors, plus QuitNow,
      *                      BreakException, ContinueException.
      */
+    @SuppressWarnings("SameParameterValue")
     private void processSpecial(final String inString)
-    throws BadSpecial, QuitNow, SQLException, SqlToolError {
+    throws BadSpecial, SQLException, SqlToolError {
         String string = (inString == null) ? buffer.val : inString;
         if (string.length() < 1)
             throw new BadSpecial(SqltoolRB.special_unspecified.getString());
@@ -1680,7 +1668,7 @@ public class SqlFile {
                                 SqltoolRB.dsv_targetfile_demand.getString());
                     ResultSet rs = null;
                     Statement st = null;
-                    File dsvFile = null;
+                    File dsvFile;
                     csvStyleQuoting = arg1.equals("xq");
                     try {
                         dsvFile = dsvTargetFile == null
@@ -1695,10 +1683,10 @@ public class SqlFile {
 
                         st = shared.jdbcConn.createStatement();
                         rs = st.executeQuery(query.toString());
-                        List<Integer> colList = new ArrayList<Integer>();
+                        List<Integer> colList = new ArrayList<>();
                         int[] incCols = null;
                         if (dsvSkipCols != null) {
-                            Set<String> skipCols = new HashSet<String>();
+                            Set<String> skipCols = new HashSet<>();
                             for (String s : dsvSkipCols.split(
                                     "\\Q" + dsvColDelim, -1)) {
                             // Don't know if better to use dsvColDelim or
@@ -1711,7 +1699,7 @@ public class SqlFile {
                             for (int i = 1; i <= rsmd.getColumnCount(); i++) {
                                 if (!skipCols.remove(rsmd.getColumnName(i)
                                         .toLowerCase()))
-                                    colList.add(Integer.valueOf(i));
+                                    colList.add(i);
                             }
                             if (colList.size() < 1)
                                 throw new BadSpecial(
@@ -1723,7 +1711,7 @@ public class SqlFile {
                                         skipCols.toString()));
                             incCols = new int[colList.size()];
                             for (int i = 0; i < incCols.length; i++)
-                                incCols[i] = colList.get(i).intValue();
+                                incCols[i] = colList.get(i);
                         }
                         displaySqlResults(st, rs, incCols, null, true);
                     } finally {
@@ -1733,24 +1721,21 @@ public class SqlFile {
                         } catch (SQLException se) {
                             // Purposefully empty
                         } finally {
-                            rs = null;
+                            rs = null;  // encourage deallocation
                         }
                         if (st != null) try {
                             st.close();
                         } catch (SQLException se) {
                             // Purposefully empty
                         } finally {
-                            st = null;
+                            st = null;  // encourage deallocation
                         }
                     }
                     pwDsv.flush();
                     stdprintln(SqltoolRB.file_wrotechars.getString(
                             Long.toString(dsvFile.length()),
                             dsvFile.toString()));
-                } catch (FileNotFoundException e) {
-                    throw new BadSpecial(SqltoolRB.file_writefail.getString(
-                            other), e);
-                } catch (UnsupportedEncodingException e) {
+                } catch (FileNotFoundException | UnsupportedEncodingException e) {
                     throw new BadSpecial(SqltoolRB.file_writefail.getString(
                             other), e);
                 } finally {
@@ -1851,15 +1836,13 @@ public class SqlFile {
                 sqlExpandMode = null;
                 try {
                     new SqlFile(this, dereferenceAtToUrl(other)).execute();
-                } catch (ContinueException ce) {
-                    throw ce;
+                } catch (ContinueException | QuitNow ceqn) {
+                    throw ceqn;
                 } catch (BreakException be) {
                     String beMessage = be.getMessage();
 
                     // Handle "file" and plain breaks (by doing nothing)
                     if (beMessage != null && !beMessage.equals("file")) throw be;
-                } catch (QuitNow qn) {
-                    throw qn;
                 } catch (Exception e) {
                     throw new BadSpecial(
                             SqltoolRB.sqlfile_execute_fail.getString(other), e);
@@ -1991,7 +1974,7 @@ public class SqlFile {
                     if (urlid != null) {
                         shared.jdbcConn = new RCData(new File(
                             SqlTool.DEFAULT_RCFILE), urlid).getConnection();
-                    } else if (acct != null) {
+                    } else if (acct != null) { // keep condition for clarity
                         shared.jdbcConn =
                                 DriverManager.getConnection(url, acct, pwd);
                     }
@@ -2013,6 +1996,7 @@ public class SqlFile {
                 if (other != null) {
                     other = other.trim();
                     if (integerPattern.matcher(other).matches()) {
+                        //noinspection MagicConstant
                         shared.jdbcConn.setTransactionIsolation(
                                 Integer.parseInt(other));
                     } else {
@@ -2069,8 +2053,6 @@ public class SqlFile {
                         stdprintln(SqltoolRB.binary_loadedbytesinto.getString(
                                 binBuffer.length));
                     }
-                } catch (BadSpecial bs) {
-                    throw bs;
                 } catch (IOException ioe) {
                     throw new BadSpecial(SqltoolRB.binary_filefail.getString(
                             other), ioe);
@@ -2133,7 +2115,7 @@ public class SqlFile {
                 try {
                     Runtime runtime = Runtime.getRuntime();
                     proc = ((wincmdPattern == null)
-                            ? runtime.exec(extCommand)
+                            ? runtime.exec(extCommand.split("\\s+"))
                             : runtime.exec(genWinArgs(extCommand))
                     );
 
@@ -2196,6 +2178,7 @@ public class SqlFile {
      * @param startIndex Index within inString where the variable name begins
      * @return Index within inString, 1 past end of the variable name
      */
+    @SuppressWarnings("SameParameterValue")
     static int pastName(final String inString, final int startIndex) {
         String workString = inString.substring(startIndex);
         int    e          = inString.length();  // Index 1 past end of var name.
@@ -2221,7 +2204,7 @@ public class SqlFile {
 
         /* TODO:  Rewrite using java.util.regex. */
         String       varName, varValue;
-        StringBuffer expandBuffer = new StringBuffer(inString);
+        StringBuilder expandBuffer = new StringBuilder(inString);
         int          b, e;    // begin and end of name.  end really 1 PAST name
         int iterations;
 
@@ -2313,23 +2296,28 @@ public class SqlFile {
 
             varValue = shared.userVars.get(varName);
             if (varValue == null) {  // Key not in map, since never null vals.
-                if (varName.equals("*TIMESTAMP")) {
-                    if (timestampFormat == null)
-                        throw new SqlToolError(
-                                SqltoolRB.no_timestamp_format.getString());
-                    varValue = timestampFormat.format(new java.util.Date());
-                } else if (varName.equals("*SCRIPT")) {
-                    varValue = inputStreamLabel;
-                } else if (varName.equals("*SCRIPT_FILE")) {
-                    varValue = inputStreamLabel.replaceFirst("^.*[/\\\\]", "");
-                } else if (varName.equals("*SCRIPT_BASE")) {
-                    varValue = inputStreamLabel.replaceFirst("^.*[/\\\\]", "")
-                      .replaceFirst("[.][^.]*$", "");
-                } else {
-                    if (!permitUnset)
-                        throw new SqlToolError(
-                                SqltoolRB.plvar_undefined.getString(varName));
-                    varValue = "";
+                switch (varName) {
+                    case "*TIMESTAMP":
+                        if (timestampFormat == null)
+                            throw new SqlToolError(
+                                    SqltoolRB.no_timestamp_format.getString());
+                        varValue = timestampFormat.format(new java.util.Date());
+                        break;
+                    case "*SCRIPT":
+                        varValue = inputStreamLabel;
+                        break;
+                    case "*SCRIPT_FILE":
+                        varValue = inputStreamLabel.replaceFirst("^.*[/\\\\]", "");
+                        break;
+                    case "*SCRIPT_BASE":
+                        varValue = inputStreamLabel.replaceFirst("^.*[/\\\\]", "")
+                          .replaceFirst("[.][^.]*$", "");
+                        break;
+                    default:
+                        if (!permitUnset)
+                            throw new SqlToolError(
+                                    SqltoolRB.plvar_undefined.getString(varName));
+                        varValue = "";
                 }
             }
 
@@ -2499,19 +2487,19 @@ public class SqlFile {
                 throw new BadSpecial("*forrows command not followed "
                         + "immediately by an SQL statement");
             setBuf(queryToken);
-            List<String[]> rowData = new ArrayList<String[]>();
+            List<String[]> rowData = new ArrayList<>();
             ResultSet rs = null;
-            int colCount = 0;
+            int colCount;
             Statement statement = processSQL();
             if (statement == null)
                 // TODO: Define message
                 throw new BadSpecial("Failed to prepare SQL for loop");
             shared.userVars.put("#", "0");
             shared.userVars.remove("*ROWS");
-            List<String> dsvRows = new ArrayList<String>();
+            List<String> dsvRows = new ArrayList<>();
             try {
                 rs = statement.getResultSet();
-                shared.userVars.put("#", Integer.toString(rowData.size()));
+                shared.userVars.put("#", "0");
                 ResultSetMetaData rsmd = rs.getMetaData();
                 colCount = rsmd.getColumnCount();
                 if (vars != null && vars.length > colCount)
@@ -2534,14 +2522,14 @@ public class SqlFile {
                 } catch (SQLException nse) {
                     // Purposefully doing nothing
                 } finally {
-                    rs = null;
+                    rs = null;  // encourage deallocation
                 }
                 try {
                     statement.close();
                 } catch (SQLException nse) {
                     // Purposefully doing nothing
                 } finally {
-                    statement = null;
+                    statement = null;  // encourage deallocation
                 }
             }
             lastSqlStatement = null;
@@ -2617,12 +2605,15 @@ public class SqlFile {
             } finally {
                 shared.userVars.remove("*ROW");
                 if (origVals != null) for (int i = 1; i < origVals.length; i++)
-                    if (origVals[i] == null)
-                        shared.userVars.remove(vars[i]);
-                    else
-                        shared.userVars.put(vars[i], origVals[i]);
+                    if (vars != null) {
+                        if (origVals[i] == null)
+                            shared.userVars.remove(vars[i]);
+                        else
+                            shared.userVars.put(vars[i], origVals[i]);
+                    }
                 // Simply want to do String.join(delim, strings), but that's
                 // not in Java until v8.
+                // TODO:  We're requiring v8 now, so update this.
                 StringBuilder sb = new StringBuilder();
                 for (String dsvRow : dsvRows) {
                     if (sb.length() > 0) sb.append(dsvRowDelim);
@@ -2642,7 +2633,6 @@ public class SqlFile {
             if (!foreachM.matches())
                 throw new BadSpecial(
                         SqltoolRB.pl_malformat_specific.getString("foreach"));
-            if (foreachM.groupCount() != 2)
             assert foreachM.groupCount() == 2:
                 "Internal assertion failed.  "
                 + "foreach pattern matched, but captured "
@@ -2740,10 +2730,8 @@ public class SqlFile {
 
                     // Handle "if" and plain breaks (by doing nothing)
                     if (beMessage == null || !beMessage.equals("if")) throw be;
-                } catch (ContinueException ce) {
-                    throw ce;
-                } catch (QuitNow qn) {
-                    throw qn;
+                } catch (ContinueException | QuitNow ceqn) {
+                    throw ceqn;
                 } catch (BadSpecial bs) {
                     bs.appendMessage(
                             SqltoolRB.pl_malformat_specific.getString("if"));
@@ -2850,7 +2838,7 @@ public class SqlFile {
 
         if (tokens[0].charAt(0) == '?') {
             String remainder = tokens[0].substring(1);
-            String msg = null;
+            String msg;
             if (remainder.startsWith("assign") ||
                     (tokens.length > 1 && tokens[1].startsWith("assign")))
                 msg = SqltoolRB.pl_assign.getString();
@@ -3087,6 +3075,8 @@ public class SqlFile {
                     // Special case so we can proactively prohibit encodings
                     // which will not work, so we'll always be confident
                     // that 'encoding' value is always good.
+                    if (varVal == null)
+                        throw new UnsupportedEncodingException("null");
                     setEncoding(varVal.trim());
                     return;
                 } catch (UnsupportedEncodingException use) {
@@ -3137,6 +3127,7 @@ public class SqlFile {
      *
      * Conditionally HTML-ifies output.
      */
+    @SuppressWarnings("SameParameterValue")
     private void stdprintln(final boolean queryOutput) {
         if (shared.psStd != null) {
             if (htmlMode) {
@@ -3272,7 +3263,8 @@ public class SqlFile {
         "SYS", "SYSTEM", "OUTLN", "DBSNMP", "OUTLN", "MDSYS", "ORDSYS",
         "ORDPLUGINS", "CTXSYS", "DSSYS", "PERFSTAT", "WKPROXY", "WKSYS",
         "WMSYS", "XDB", "ANONYMOUS", "ODM", "ODM_MTR", "OLAPSYS", "TRACESVR",
-        "REPADMIN"
+        "REPADMIN", "APPQOSSYS", "AUDSYS", "DBSFWUSER", "GSMADMIN_INTERNAL",
+        "RDSADMIN"
     };
 
     public String getCurrentSchema() throws BadSpecial, SqlToolError {
@@ -3297,14 +3289,14 @@ public class SqlFile {
             } catch (SQLException se) {
                 // Purposefully doing nothing
             } finally {
-                rs = null;
+                rs = null;  // encourage deallocation
             }
             if (st != null) try {
-                st.close();
+                st.close();  // encourage deallocation
             } catch (SQLException se) {
                 // Purposefully doing nothing
             } finally {
-                st = null;
+                st = null;  // encourage deallocation
             }
         }
     }
@@ -3332,11 +3324,11 @@ public class SqlFile {
     private void listTables(final char c, final String inFilter)
     throws BadSpecial, SqlToolError {
         requireConnection();
-        String   schema  = null;
+        String   schema = null;
         int[]    listSet = null;
-        String[] types   = null;
+        String[] types;
 
-        /* For workaround for \T for Oracle */
+        /* For workaround for \dt for Oracle */
         String[] additionalSchemas = null;
 
         /* This is for specific non-getTable() queries */
@@ -3358,13 +3350,13 @@ public class SqlFile {
 
             // We only use majorVersion and minorVersion for HyperSQL so far
             // The calls avoided here avoid problems with non-confirmant drivers
-            if (dbProductName.indexOf("HSQL") > -1) try {
+            if (dbProductName.contains("HSQL")) try {
                 majorVersion  = md.getDatabaseMajorVersion();
                 minorVersion  = md.getDatabaseMinorVersion();
             } catch (UnsupportedOperationException uoe) {
                 // It seems that Sun's JDBC/ODBC bridge throws here
                 majorVersion = 2;
-                minorVersion = 0;
+                //minorVersion = 0;  this is default value
             }
 
             //System.err.println("DB NAME = (" + dbProductName + ')');
@@ -3381,23 +3373,44 @@ public class SqlFile {
             switch (c) {
                 case '*' :
                     types = null;
+                    // Filtering not working on this for MySQL
                     break;
 
                 case 'S' :
-                    if (dbProductName.indexOf("Oracle") > -1) {
+                    if (dbProductName.contains("Oracle")) {
                         if (interactive)
                             errprintln(SqltoolRB.vendor_oracle_dS.getString());
 
                         types[0]          = "TABLE";
                         schema            = "SYS";
                         additionalSchemas = oracleSysSchemas;
+                    } else if (dbProductName.contains("MySQL")
+                    || dbProductName.contains("MariaDB")) {
+                        statement = shared.jdbcConn.createStatement();
+                        statement.execute(
+                          "SELECT table_schema, table_name\n"
+                          + "FROM information_schema.tables\n"
+                          + "WHERE table_schema IN ('information_schema', "
+                          + "'mysql', 'performance_schema', 'sys')\n"
+                          + "ORDER BY table_schema, table_name");
+                    } else if (dbProductName.contains("SQL Server")) {
+                        // for \dS we SHOULD query x.sys.tables for x in
+                        // master, msdb, rdsadmin, tempdb, but I'm not up
+                        // for assembling 4 queries now.
+                        // Until fixed, this is precisely same as \dt.
+                        statement = shared.jdbcConn.createStatement();
+                        statement.execute("SELECT schemas.name AS 'SCHEMA', "
+                          + "tables.name AS 'TABLE'\n"
+                          + "FROM sys.tables, sys.schemas\n"
+                          + "WHERE tables.schema_id = schemas.schema_id\n"
+                          + "ORDER BY schemas.name, tables.name");
                     } else {
                         types[0] = "SYSTEM TABLE";
                     }
                     break;
 
                 case 's' :
-                    if (dbProductName.indexOf("HSQL") > -1) {
+                    if (dbProductName.contains("HSQL")) {
                         //  HSQLDB does not consider Sequences as "tables",
                         //  hence we do not list them in
                         //  DatabaseMetaData.getTables().
@@ -3420,13 +3433,33 @@ public class SqlFile {
                             + "information_schema."
                             + ((minorVersion> 8 || majorVersion > 1)
                             ? "sequences" : "system_sequences") + narrower);
+                    } else if (dbProductName.contains("Oracle")) {
+                        statement = shared.jdbcConn.createStatement();
+                        statement.execute(
+                          "SELECT sequence_name, sequence_owner FROM\n"
+                          + "sys.all_sequences ORDER BY sequence_name");
+                    } else if (dbProductName.contains("MySQL")
+                    || dbProductName.contains("MariaDB")) {
+                        statement = shared.jdbcConn.createStatement();
+                        statement.execute(
+                          "SELECT table_schema, table_name, column_name FROM\n"
+                          + "information_schema.columns\n"
+                          + "WHERE extra like '%auto_increment%'\n"
+                          + "ORDER BY table_schema, table_name, column_name");
+                    } else if (dbProductName.contains("SQL Server")) {
+                        statement = shared.jdbcConn.createStatement();
+                        statement.execute("SELECT schemas.name AS 'SCHEMA', "
+                          + "sequences.name AS SEQUENCE\n"
+                          + "FROM sys.sequences, sys.schemas\n"
+                          + "WHERE sequences.schema_id = schemas.schema_id\n"
+                          + "ORDER BY schemas.name, sequences.name");
                     } else {
                         types[0] = "SEQUENCE";
                     }
                     break;
 
                 case 'r' :
-                    if (dbProductName.indexOf("HSQL") > -1) {
+                    if (dbProductName.contains("HSQL")) {
                         statement = shared.jdbcConn.createStatement();
 
                         statement.execute(
@@ -3435,8 +3468,22 @@ public class SqlFile {
                             ? "authorizations" : "system_authorizations")
                             + "\nWHERE authorization_type = 'ROLE'\n"
                             + "ORDER BY authorization_name");
-                    } else if (dbProductName.indexOf(
-                            "Adaptive Server Enterprise") > -1) {
+                    } else if (dbProductName.contains("PostgreSQL")) {
+                        statement = shared.jdbcConn.createStatement();
+
+                        statement.execute(
+                            "SELECT rolname FROM pg_catalog.pg_roles\n"
+                            + "ORDER BY rolname");
+                    } else if (dbProductName.contains("Redshift")) {
+                        // Difficult call here.
+                        // Redshift pg_role table is not readable admins, so
+                        // useless.  Report groups instead, because it's useful.
+                        statement = shared.jdbcConn.createStatement();
+                        statement.execute(
+                            "SELECT groname FROM pg_catalog.pg_group\n"
+                            + "ORDER BY groname");
+                    } else if (dbProductName.contains(
+                            "Adaptive Server Enterprise")) {
                         // This is the basic Sybase server.  Sybase also has
                         // their "Anywhere", ASA (for embedded), and replication
                         // databases, but I don't know the Metadata strings for
@@ -3445,8 +3492,17 @@ public class SqlFile {
 
                         statement.execute(
                             "SELECT name FROM syssrvroles ORDER BY name");
-                    } else if (dbProductName.indexOf(
-                            "Apache Derby") > -1) {
+                    } else if (dbProductName.contains("Oracle")) {
+                        statement = shared.jdbcConn.createStatement();
+
+                        try {
+                            statement.execute(
+                                "SELECT role FROM sys.dba_roles ORDER BY role");
+                        } catch (SQLException se) {
+                            throw new BadSpecial(
+                              "You do not database privileges to list roles");
+                        }
+                    } else if (dbProductName.contains("Apache Derby")) {
                         throw new BadSpecial(
                             SqltoolRB.vendor_derby_dr.getString());
                     } else {
@@ -3456,7 +3512,7 @@ public class SqlFile {
                     break;
 
                 case 'u' :
-                    if (dbProductName.indexOf("HSQL") > -1) {
+                    if (dbProductName.contains("HSQL")) {
                         statement = shared.jdbcConn.createStatement();
 
                         statement.execute("SELECT "
@@ -3464,20 +3520,26 @@ public class SqlFile {
                             ? "user_name" : "user") + ", admin FROM "
                             + "information_schema.system_users\n"
                             + "ORDER BY user_name");
-                    } else if (dbProductName.indexOf("Oracle") > -1) {
+                    } else if (dbProductName.contains("Oracle")) {
                         statement = shared.jdbcConn.createStatement();
-
                         statement.execute(
                             "SELECT username, created FROM all_users "
                             + "ORDER BY username");
-                    } else if (dbProductName.indexOf("PostgreSQL") > -1) {
+                    } else if (dbProductName.contains("MySQL")
+                    || dbProductName.contains("MariaDB")) {
+                        statement = shared.jdbcConn.createStatement();
+                        statement.execute(
+                            "SELECT host, user FROM mysql.user\n"
+                            + "ORDER BY user,host");
+                    } else if (dbProductName.contains("PostgreSQL")
+                    || dbProductName.contains("Redshift")) {
                         statement = shared.jdbcConn.createStatement();
 
                         statement.execute(
                             "SELECT usename, usesuper FROM pg_catalog.pg_user "
                             + "ORDER BY usename");
-                    } else if (dbProductName.indexOf(
-                            "Adaptive Server Enterprise") > -1) {
+                    } else if (dbProductName.contains(
+                            "Adaptive Server Enterprise")) {
                         // This is the basic Sybase server.  Sybase also has
                         // their "Anywhere", ASA (for embedded), and replication
                         // databases, but I don't know the Metadata strings for
@@ -3487,8 +3549,7 @@ public class SqlFile {
                         statement.execute(
                             "SELECT name, accdate, fullname FROM syslogins "
                             + "ORDER BY name");
-                    } else if (dbProductName.indexOf(
-                            "Apache Derby") > -1) {
+                    } else if (dbProductName.contains("Apache Derby")) {
                         throw new BadSpecial(
                             SqltoolRB.vendor_derby_du.getString());
                     } else {
@@ -3498,7 +3559,7 @@ public class SqlFile {
                     break;
 
                 case 'a' :
-                    if (dbProductName.indexOf("HSQL") > -1
+                    if (dbProductName.contains("HSQL")
                         && (minorVersion < 9 && majorVersion < 2)) {
                         // HSQLDB after 1.8 doesn't support any type of aliases
                         //  Earlier HSQLDB Aliases are not the same things as
@@ -3526,13 +3587,56 @@ public class SqlFile {
                     break;
 
                 case 't' :
-                    excludeSysSchemas = (dbProductName.indexOf("Oracle")
-                                         > -1);
-                    types[0] = "TABLE";
+                    if (dbProductName.contains("MySQL")
+                    || dbProductName.contains("MariaDB")) {
+                        /*
+                        statement = shared.jdbcConn.createStatement();
+                        statement.execute("show tables");
+                        */
+                        statement = shared.jdbcConn.createStatement();
+                        statement.execute(
+                          "SELECT table_schema AS DATABASE_NAME, table_name\n"
+                          + "FROM information_schema.tables\n"
+                          + "WHERE table_schema NOT IN ('information_schema', "
+                          + "'mysql', 'performance_schema', 'sys')\n"
+                          + "ORDER BY table_schema, table_name");
+                    } else if (dbProductName.contains("SQL Server")) {
+                        // Best we can do is list all tables in current db
+                        statement = shared.jdbcConn.createStatement();
+                        statement.execute("SELECT schemas.name AS 'SCHEMA', "
+                          + "tables.name AS 'TABLE'\n"
+                          + "FROM sys.tables, sys.schemas\n"
+                          + "WHERE tables.schema_id = schemas.schema_id\n"
+                          + "ORDER BY schemas.name, tables.name");
+                    } else {
+                        excludeSysSchemas = dbProductName.contains("Oracle");
+                        types[0] = "TABLE";
+                    }
                     break;
 
                 case 'v' :
-                    types[0] = "VIEW";
+                    if (dbProductName.contains("MySQL")
+                    || dbProductName.contains("MariaDB")) {
+                        statement = shared.jdbcConn.createStatement();
+                        statement.execute(
+                          "SELECT table_schema AS DATABASE_NAME, "
+                          + "table_name AS VIEW_NAME\n"
+                          + "FROM information_schema.views\n"
+                          + "WHERE table_schema NOT IN ('information_schema', "
+                          + "'mysql', 'performance_schema', 'sys')\n"
+                          + "ORDER BY table_schema, table_name");
+                    } else if (dbProductName.contains("SQL Server")) {
+                        // Best we can do is list all views in current db
+                        statement = shared.jdbcConn.createStatement();
+                        statement.execute("SELECT schemas.name AS 'SCHEMA', "
+                          + "views.name AS 'VIEW'\n"
+                          + "FROM sys.views, sys.schemas\n"
+                          + "WHERE views.schema_id = schemas.schema_id\n"
+                          + "ORDER BY schemas.name, views.name");
+                    } else {
+                        excludeSysSchemas = dbProductName.contains("Oracle");
+                        types[0] = "VIEW";
+                    }
                     break;
 
                 case 'c' :
@@ -3559,26 +3663,21 @@ public class SqlFile {
 
                 case 'i' :
 
-                    // Some databases require to specify table, some don't.
-                    /*
+                    // Most databases require to specify table, some don't.
                     if (filter == null) {
                         throw new BadSpecial("You must specify the index's "
                                 + "table as argument to \\di");
                     }
-                     */
-                    String table = null;
+                    String table;
 
-                    if (filter != null) {
-                        Matcher matcher = dotPattern.matcher(filter);
-                        if (matcher.matches()) {
-                            table = (matcher.group(2).length() > 0)
-                                    ? matcher.group(2) : null;
-                            schema = (matcher.group(1).length() > 0)
-                                    ? matcher.group(1) : getCurrentSchema();
-                        } else {
-                            table = filter;
-                        }
-                        filter = null;
+                    Matcher matcher = dotPattern.matcher(filter);
+                    if (matcher.matches()) {
+                        table = (matcher.group(2).length() > 0)
+                                ? matcher.group(2) : null;
+                        schema = (matcher.group(1).length() > 0)
+                                ? matcher.group(1) : getCurrentSchema();
+                    } else {
+                        table = filter;
                     }
 
                     // N.b. Oracle incorrectly reports the INDEX SCHEMA as
@@ -3601,9 +3700,9 @@ public class SqlFile {
             }
 
             if (statement == null) {
-                if (dbProductName.indexOf("HSQL") > -1) {
+                if (dbProductName.contains("HSQL")) {
                     listSet = listMDTableCols[HSQLDB_ELEMENT];
-                } else if (dbProductName.indexOf("Oracle") > -1) {
+                } else if (dbProductName.contains("Oracle")) {
                     listSet = listMDTableCols[ORACLE_ELEMENT];
                 } else {
                     listSet = listMDTableCols[DEFAULT_ELEMENT];
@@ -3651,11 +3750,9 @@ public class SqlFile {
                         listSet, filter, false);
                 }
             }
-        } catch (SQLException se) {
-            throw new BadSpecial(SqltoolRB.metadata_fetch_fail.getString(), se);
-        } catch (NullPointerException npe) {
+        } catch (SQLException | NullPointerException senpe) {
             throw new BadSpecial(SqltoolRB.metadata_fetch_fail.getString(),
-                    npe);
+              senpe);
         } finally {
             excludeSysSchemas = false;
 
@@ -3666,7 +3763,7 @@ public class SqlFile {
                     // We already got what we want from it, or have/are
                     // processing a more specific error.
                 } finally {
-                    rs = null;
+                    rs = null;  // encourage deallocation
                 }
             }
 
@@ -3675,7 +3772,7 @@ public class SqlFile {
             } catch (SQLException se) {
                 // Purposefully doing nothing
             } finally {
-                statement = null;
+                statement = null;  // encourage deallocation
             }
         }
     }
@@ -3701,7 +3798,7 @@ public class SqlFile {
         // No reason to check autoCommit constantly.  If we need to roll
         // back, we will check the autocommit state at that time.
         if (sqlExpandMode == null) setSqlExpandMode();
-        lastSqlStatement = sqlExpandMode.booleanValue()
+        lastSqlStatement = sqlExpandMode
                            ? dereference(buffer.val, true) : buffer.val;
         // Above is the only case where we deference conditionally.
         // For :, \, * commands we either always do or always don't.
@@ -3764,24 +3861,15 @@ public class SqlFile {
         // If we return resources, we obviously do not close them.
         // User already being notified about the problem so don't clutter
         // with details about close failures.
-        } catch (SQLException se) {
-            if (statement != null) try {
-                statement.close();
-            } catch (SQLException sen) {
-                // Intentionally empty.  See preceding comment
-            } finally {
-                statement = null;
-            }
-            throw se; // rethrow
-        } catch (SqlToolError ste) {
+        } catch (SQLException | SqlToolError seste) {
             if (statement != null) try {
                 statement.close();
             } catch (SQLException sen) {
                 // Intentionally empty.  See preceding comment
             } finally {
-                statement = null;
+                statement = null;  // encourage deallocation
             }
-            throw ste; // rethrow
+            throw seste; // rethrow
         } finally {
             if (reportTimes) {
                 long elapsed = (new java.util.Date().getTime()) - startTime;
@@ -3866,6 +3954,7 @@ public class SqlFile {
         if (excludeSysSchemas && interactive)
             stdprintln(SqltoolRB.vendor_nosup_sysschemas.getString());
 
+        //noinspection SwitchStatementWithTooFewBranches
         switch (updateCount) {
             case -1 :
                 if (r == null) {
@@ -3882,8 +3971,8 @@ public class SqlFile {
                                                                : incCols
                                                                    .length;
                 String            val;
-                List<String[]>    rows        = new ArrayList<String[]>();
-                String[]          headerArray = null;
+                List<String[]>    rows        = new ArrayList<>();
+                String[]          headerArray;
                 String[]          fieldArray;
                 int[]             maxWidth = new int[incCount];
                 int               insi;
@@ -3891,9 +3980,6 @@ public class SqlFile {
                 boolean           isValNull;
 
                 // STEP 1: GATHER DATA
-                if (!htmlMode) for (int i = 0; i < maxWidth.length; i++)
-                    maxWidth[i] = 0;
-
                 boolean[] rightJust = new boolean[incCount];
                 int[]     dataType  = new int[incCount];
                 boolean[] autonulls = new boolean[incCount];
@@ -3905,8 +3991,11 @@ public class SqlFile {
                     if (incCols != null) {
                         skip = true;
 
-                        for (int j = 0; j < incCols.length; j++)
-                            if (i == incCols[j]) skip = false;
+                        for (int incolEntry : incCols)
+                            if (i == incolEntry) {
+                                skip = false;
+                                break;
+                            }
 
                         if (skip) continue;
                     }
@@ -3966,7 +4055,10 @@ public class SqlFile {
                             skip = true;
 
                             for (int incCol : incCols)
-                                if (i == incCol) skip = false;
+                                if (i == incCol) {
+                                    skip = false;
+                                    break;
+                                }
 
                             if (skip) continue;
                         }
@@ -4054,7 +4146,7 @@ public class SqlFile {
                             try {
                                 binBuffer =
                                     SqlFile.streamToBytes(r.getBinaryStream(i));
-                                isValNull = r.wasNull();
+                                //isValNull = r.wasNull();  unused
                             } catch (IOException ioe) {
                                 throw new SqlToolError(
                                     SqltoolRB.streamread_failure.getString(),
@@ -4084,7 +4176,6 @@ public class SqlFile {
                             for (String oracleSysSchema : oracleSysSchemas)
                                 if (val.equals(oracleSysSchema)) {
                                     filteredOut = true;
-
                                     break;
                                 }
 
@@ -4160,13 +4251,14 @@ public class SqlFile {
 
                         for (int i = 0; i < headerArray.length; i++) {
                             condlPrint("<TH>"
-                                    + SqlFile.escapeHtml(headerArray[i])
+                                    + (headerArray[i]==null ? "&nbsp;" : SqlFile.escapeHtml(headerArray[i]))
                                     + "</TH>", true);
                             condlPrint(((i > 0) ? "  " : "")
                                     + ((i < headerArray.length - 1
                                         || rightJust[i])
                                        ? toPaddedString(
-                                         headerArray[i], maxWidth[i],
+                           (headerArray[i] == null ? "" : headerArray[i]),
+                                          maxWidth[i],
                                          ' ', !rightJust[i])
                                        : headerArray[i])
                                     , false);
@@ -4238,12 +4330,11 @@ public class SqlFile {
                 }
 
                 if (csvStyleQuoting) {
-                    Pattern delimPat = Pattern.compile(dsvColDelim);
                     for (String[] fArray : rows)
                         for (int j = 0; j < fArray.length; j++)
                             if (fArray[j] != null && (allQuoted
                                     || fArray[j].indexOf('"') > -1
-                                    || fArray[j].indexOf(dsvColDelim) > -1))
+                                    || fArray[j].contains(dsvColDelim)))
                                 fArray[j] = '"'
                                         + fArray[j].replace("\"", "\"\"") + '"';
                 }
@@ -4289,14 +4380,14 @@ public class SqlFile {
             } catch (SQLException se) {
                 logger.warning("Failed to close SQL result set: " + se);
             } finally {
-                r = null;
+                r = null;  // encourage deallocation
             }
             if (statement != null) try {
                 statement.close();
             } catch (SQLException se) {
                 logger.warning("Failed to close SQL statement: " + se);
             } finally {
-                statement = null;
+                statement = null;  // encourage deallocation
             }
         }
     }
@@ -4402,7 +4493,7 @@ public class SqlFile {
     private Integer historySearch(final String findRegex) throws BadSpecial {
         if (history == null)
             throw new BadSpecial(SqltoolRB.history_unavailable.getString());
-        Pattern pattern = null;
+        Pattern pattern;
         try {
             pattern = Pattern.compile("(?ims)" + findRegex);
         } catch (PatternSyntaxException pse) {
@@ -4412,7 +4503,7 @@ public class SqlFile {
         // by using "(?-OPTIONS)" or (?OPTIONS) in their regexes.
         for (int index = history.size() - 1; index >= 0; index--)
             if (pattern.matcher((history.get(index)).val).find())
-                return Integer.valueOf(index + oldestHist);
+                return index + oldestHist;
         return null;
     }
 
@@ -4443,6 +4534,7 @@ public class SqlFile {
     /**
      * Add a command onto the history list.
      */
+    @SuppressWarnings("UnusedReturnValue")
     private boolean historize() {
         if (history == null || buffer == null) return false;
         if (history.size() > 0 &&
@@ -4474,7 +4566,7 @@ public class SqlFile {
          */
         Pattern   filter = null;
         boolean   filterMatchesAll = false;  // match filter against all cols.
-        List<String[]> rows = new ArrayList<String[]>();
+        List<String[]> rows = new ArrayList<>();
         String[]  headerArray = {
             SqltoolRB.describe_table_name.getString(),
             SqltoolRB.describe_table_datatype.getString(),
@@ -4605,14 +4697,14 @@ public class SqlFile {
             } catch (SQLException nse) {
                 // intentionally empty;
             } finally {
-                r = null;
+                r = null;  // encourage deallocation
             }
             if (statement != null) try {
                 statement.close();
             } catch (SQLException nse) {
                 // intentionally empty;
             } finally {
-                statement = null;
+                statement = null;  // encourage deallocation
             }
         }
     }
@@ -4767,7 +4859,7 @@ public class SqlFile {
                 : new TreeMap<Object, Object>(map).entrySet()) {
             s = (String) entry.getValue();
 
-            SqlFile.appendLine(sb, "    " + (String) entry.getKey()
+            SqlFile.appendLine(sb, "    " + entry.getKey()
                     + ": " + (withValues ? ("(" + s + ')')
                     : Integer.toString( s.length())));
         }
@@ -4828,7 +4920,7 @@ public class SqlFile {
         if (binBuffer == null)
             throw new BadSpecial(SqltoolRB.binbuffer_empty.getString());
 
-        int len = 0;
+        int len;
         FileOutputStream fos = new FileOutputStream(dumpFile);
 
         try {
@@ -4864,7 +4956,7 @@ public class SqlFile {
      */
     public String streamToString(InputStream is, final String cs)
     throws IOException {
-        byte[] ba = null;
+        byte[] ba;
         int bytesread = 0;
         int retval;
         try {
@@ -4927,7 +5019,7 @@ public class SqlFile {
     public static byte[] streamToBytes(final InputStream is)
     throws IOException {
         byte[]                xferBuffer = new byte[10240];
-        byte[]                outBytes = null;
+        byte[]                outBytes;
         int                   i;
         ByteArrayOutputStream baos       = new ByteArrayOutputStream();
 
@@ -4941,8 +5033,8 @@ public class SqlFile {
     }
 
     /**
-     * Legacy function..
-     * See following function for documentatin.
+     * Legacy function.
+     * See following function for documentation.
      */
     public static byte[] loadBinary(final File binFile) throws IOException {
         return loadBinary(new URL("file", null, binFile.getPath()));
@@ -4957,7 +5049,7 @@ public class SqlFile {
      */
     public static byte[] loadBinary(final URL binUrl) throws IOException {
         byte[]                xferBuffer = new byte[10240];
-        byte[]                outBytes = null;
+        byte[]                outBytes;
         ByteArrayOutputStream baos;
         int                   i;
         InputStream           fis        = binUrl.openStream();
@@ -4995,13 +5087,13 @@ public class SqlFile {
      *
      * @param i JDBC type number
      * @return boolean
-     * @see <A href="http://java.sun.com/docs/books/tutorial/jdbc/basics/retrieving.html">http://java.sun.com/docs/books/tutorial/jdbc/basics/retrieving.html
+     * @see <a href="http://java.sun.com/docs/books/tutorial/jdbc/basics/retrieving.html">http://java.sun.com/docs/books/tutorial/jdbc/basics/retrieving.html</a>
      *      The table on this page lists the most common SqlTypes, all of which
-     *      must implement toString()</A>
+     *      must implement toString()
      * @see java.sql.Types
      */
     public static boolean canDisplayType(final int i) {
-        /* I don't now about some of the more obscure types, like REF and
+        /* I don't know about some of the more obscure types, like REF and
          * DATALINK */
         switch (i) {
             //case java.sql.Types.BINARY :
@@ -5162,7 +5254,7 @@ public class SqlFile {
     }
 
     /**
-     * Translates user-supplied escapes into the traditionaly corresponding
+     * Translates user-supplied escapes into the traditionaly
      * corresponding binary characters.
      *
      * Allowed sequences:
@@ -5218,9 +5310,9 @@ public class SqlFile {
      */
     private static String convertNumericEscape(
     final String string, final int offset) {
-        int post = -1;
-        int firstDigit = -1;
-        int radix = -1;
+        int post;
+        int firstDigit;
+        int radix;
         if (Character.toUpperCase(string.charAt(offset + 1)) == 'X') {
             firstDigit = offset + 2;
             radix = 16;
@@ -5351,7 +5443,7 @@ public class SqlFile {
             // specify values as spaces, empty string, null.
             // We do not support CVS-quoted style constColMap String.
             // Must be specified in DSV style.
-            constColMap = new TreeMap<String, String>();
+            constColMap = new TreeMap<>();
             for (String constPair : dsvConstCols.split(dsvColSplitter, -1)) {
                 matcher = nameValPairPattern.matcher(constPair);
                 if (!matcher.matches())
@@ -5366,12 +5458,12 @@ public class SqlFile {
         if (dsvSkipCols != null) {
             // We do not support CVS-quoted style skipCols String.
             // Must be specified in DSV style.
-            skipCols = new HashSet<String>();
+            skipCols = new HashSet<>();
             for (String skipCol : dsvSkipCols.split(dsvColSplitter, -1))
                 skipCols.add(skipCol.trim().toLowerCase());
         }
 
-        FileRecordReader dsvReader = null;
+        FileRecordReader dsvReader;
         try {
             dsvReader = new FileRecordReader(fileUrl, dsvRowSplitter,
                     (shared.encoding == null)
@@ -5391,15 +5483,15 @@ public class SqlFile {
 
         String dateString;
 
-        List<String> headerList = new ArrayList<String>();
+        List<String> headerList = new ArrayList<>();
         String    tableName = dsvTargetTable;
 
         // First read one until we get one header line
         int lineCount = 0;
-        String trimmedLine = null;
+        String trimmedLine;
         boolean switching = false;
         int headerOffset = 0;  //  Used to offset read-start of header record
-        String curLine = null; // Val will be replaced 4 lines down
+        String curLine; // Val will be replaced 4 lines down
                                   // This is just to quiet compiler warning
 
         try {
@@ -5455,7 +5547,7 @@ public class SqlFile {
         String colName;
         String[] cols = headerLine.split(
                 (csvStyleQuoting ? "\u0002" : dsvColSplitter), -1);
-        Set<String> usedCols = new HashSet<String>();  // Checks for dup cols
+        Set<String> usedCols = new HashSet<>();  // Checks for dup cols
 
         for (String col : cols) {
             if (col.length() < 1)
@@ -5485,7 +5577,7 @@ public class SqlFile {
             oneCol = true;
             break;
         }
-        if (oneCol == false)
+        if (!oneCol)
             // Difficult call, but I think in any real-world situation, the
             // user will want to know if they are inserting records with no
             // data from their input file.
@@ -5508,8 +5600,8 @@ public class SqlFile {
             if (i > 0) tableName = tableName.substring(0, i);
         }
 
-        StringBuffer tmpSb = new StringBuffer();
-        List<String> tmpList = new ArrayList<String>();
+        StringBuilder tmpSb = new StringBuilder();
+        List<String> tmpList = new ArrayList<>();
 
         int skippers = 0;
         for (String header : headers) {
@@ -5531,9 +5623,9 @@ public class SqlFile {
         // even skipped columns.
         // The autonulls array only has columns that we will insert into.
 
-        StringBuffer sb = new StringBuffer("INSERT INTO " + tableName + " ("
+        StringBuilder sb = new StringBuilder("INSERT INTO " + tableName + " ("
                                            + tmpSb + ") VALUES (");
-        StringBuffer typeQuerySb = new StringBuffer("SELECT " + tmpSb
+        StringBuilder typeQuerySb = new StringBuilder("SELECT " + tmpSb
             + " FROM " + tableName + " WHERE 1 = 2");
 
         try {
@@ -5551,7 +5643,7 @@ public class SqlFile {
                 // If so, it's probably a SqlTool problem, not a user or
                 // data problem.
                 // Should be researched and either return a user-friendly
-                // message or a RuntimeExceptin.
+                // message or a RuntimeException.
 
             for (int i = 0; i < autonulls.length; i++) {
                 autonulls[i] = true;
@@ -5621,12 +5713,9 @@ public class SqlFile {
                     (shared.encoding == null)
                     ? DEFAULT_FILE_ENCODING : shared.encoding));
             rejectWriter.print(headerLine + dsvRowDelim);
-        } catch (BadSpecial bs) {
+        } catch (BadSpecial | IOException bsioe) {
             throw new SqlToolError(SqltoolRB.dsv_rejectfile_setupfail.getString(
-                    dsvRejectFile), bs);
-        } catch (IOException ioe) {
-            throw new SqlToolError(SqltoolRB.dsv_rejectfile_setupfail.getString(
-                    dsvRejectFile), ioe);
+                    dsvRejectFile), bsioe);
         }
         if (dsvRejectReport != null) try {
             rejectReportFile = dereferenceAtToFile(dsvRejectReport);
@@ -5649,21 +5738,17 @@ public class SqlFile {
                     ((rejectFile == null) ? SqltoolRB.none.getString()
                                     : rejectFile.getPath()),
                     ((rejectFile == null) ? null : rejectFile.getPath())));
-        } catch (BadSpecial bs) {
-            throw new SqlToolError(
-                    SqltoolRB.dsv_rejectreport_setupfail.getString(
-                    dsvRejectReport), bs);
-        } catch (IOException ioe) {
+        } catch (BadSpecial | IOException bsioe) {
             throw new SqlToolError(
                     SqltoolRB.dsv_rejectreport_setupfail.getString(
-                    dsvRejectReport), ioe);
+                    dsvRejectReport), bsioe);
         }
 
         int recCount = 0;
         int skipCount = 0;
         PreparedStatement ps = null;
         boolean importAborted = false;
-        boolean doResetAutocommit = false;
+        boolean doResetAutocommit;
         try {
             doResetAutocommit = dsvRecordsPerCommit > 0
                 && shared.jdbcConn.getAutoCommit();
@@ -5887,10 +5972,8 @@ public class SqlFile {
                 } else {
                     shared.possiblyUncommitteds = true;
                 }
-            } catch (NumberFormatException nfe) {
-                throw new RowError(null, nfe);
-            } catch (SQLException se) {
-                throw new RowError(null, se);
+            } catch (NumberFormatException | SQLException nfese) {
+                throw new RowError(null, nfese);
             } } catch (RowError re) {
                 rejectCount++;
                 if (rejectWriter != null || rejectReportWriter != null) {
@@ -5932,8 +6015,9 @@ public class SqlFile {
                 }
                 if (doResetAutocommit) shared.jdbcConn.setAutoCommit(true);
             } catch (SQLException se) {
+                //noinspection ThrowFromFinallyBlock
                 throw new SqlToolError(
-                        SqltoolRB.rpc_commit_failure.getString(), se);
+                  SqltoolRB.rpc_commit_failure.getString(), se);
             }
             String summaryString = null;
             if (recCount > 0) {
@@ -5999,7 +6083,7 @@ public class SqlFile {
     }
 
     protected static void appendLine(final StringBuffer sb, final String s) {
-        sb.append(s + LS);
+        sb.append(s).append(LS);
     }
 
     /**
@@ -6010,7 +6094,7 @@ public class SqlFile {
      * @return String[]
      */
     private static String[] genWinArgs(final String monolithic) {
-        List<String> list = new ArrayList<String>();
+        List<String> list = new ArrayList<>();
         list.add("cmd.exe");
         list.add("/y");
         list.add("/c");
@@ -6130,7 +6214,7 @@ public class SqlFile {
 
         if (defToken.val.length() < 1)
             throw new BadSpecial(SqltoolRB.macro_tip.getString());
-        int newType = -1;
+        int newType;
         StringBuffer newVal = new StringBuffer();
         switch (defToken.val.charAt(0)) {
             case '?':
@@ -6148,7 +6232,6 @@ public class SqlFile {
                 if (matcher.groupCount() > 1 && matcher.group(2) != null
                         && matcher.group(2).length() > 0)
                     newVal.append(matcher.group(2));
-                newType = buffer.type;
                 if (newVal.length() < 1)
                     throw new BadSpecial(SqltoolRB.macrodef_empty.getString());
                 if (newVal.charAt(newVal.length() - 1) == ';')
@@ -6208,7 +6291,7 @@ public class SqlFile {
                         throw new BadSpecial(
                                 SqltoolRB.macro_undefined.getString(
                                 matcher.group(1) + "...)"));
-                    String[] splitVars = null;
+                    String[] splitVars;
                     if (matcher.groupCount() > 1 && matcher.group(2) != null
                             && matcher.group(2).length() > 0) {
                         //buffer.val += matcher.group(2);
@@ -6394,7 +6477,7 @@ public class SqlFile {
         if (s.indexOf('@') != 0) return new File(s);
         if (atBase == null)
             throw new BadSpecial(SqltoolRB.illegal_at.getString());
-        if (atBase.getProtocol() != "file")
+        if (!atBase.getProtocol().equals("file"))
             throw new BadSpecial(SqltoolRB.desturl_nowrite.getString(
               atBase.toString()));
         try {
@@ -6410,7 +6493,7 @@ public class SqlFile {
 
     /**
      * Escaping rules taken from 'Reserved Characters in HTML table at
-     * http://www.w3schools.com/tags/ref_entities.asp
+     * <a href="http://www.w3schools.com/tags/ref_entities.asp">http://www.w3schools.com/tags/ref_entities.asp</a>
      *
      * @param s String
      * @return String
@@ -6463,12 +6546,12 @@ public class SqlFile {
             if (is == null)
                 throw new IOException("Missing resource: "
                     + ((topHtmlFile == null)
-                    ? topHtmlFile
-                    : "sqltool/top-boilerplate"));
+                    ? "sqltool/top-boilerplate"
+                    : topHtmlFile));
             isr = new InputStreamReader(is);
             while ((i = isr.read(readBfr)) > -1)
                 sWriter.write(readBfr, 0, i);
-            readBfr = null;
+            readBfr = null;  // encourage GC
             str = sWriter.toString();
             sWriter.close();
         } catch (Exception e) {
@@ -6504,11 +6587,11 @@ public class SqlFile {
             if (is == null)
                 throw new IOException("Missing resource: "
                     + ((bottomHtmlFile == null)
-                    ? bottomHtmlFile
-                    : "sqltool/bottom-boilerplate"));
+                    ? "sqltool/bottom-boilerplate"
+                    : bottomHtmlFile));
             isr = new InputStreamReader(is);
             while ((i = isr.read(readBfr)) > -1) sWriter.write(readBfr, 0, i);
-            readBfr = null;
+            readBfr = null;  // encourage GC
             str = sWriter.toString();
             sWriter.close();
         } catch (Exception e) {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/cmdline/SqlTool.java 2.7.0-1/hsqldb/src/org/hsqldb/cmdline/SqlTool.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/cmdline/SqlTool.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/cmdline/SqlTool.java	2022-06-12 14:53:32.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -48,7 +48,7 @@ import org.hsqldb.cmdline.sqltool.Token;
 import org.hsqldb.cmdline.libclone.FrameworkLogger;
 import org.hsqldb.cmdline.utilclone.RCData;
 
-/* $Id: SqlTool.java 6266 2021-01-25 16:08:06Z fredt $ */
+/* $Id: SqlTool.java 6559 2022-06-12 15:53:31Z fredt $ */
 
 /**
  * A command-line JDBC SQL tool supporting both interactive and
@@ -70,18 +70,18 @@ import org.hsqldb.cmdline.utilclone.RCDa
  * @see #main(String[])
  * @see #objectMain(String[])
  * @see SqlFile
- * @see org.hsqldb.sample.SqlFileEmbedder
- * @version $Revision: 6266 $, $Date: 2021-01-25 16:08:06 +0000 (Mon, 25 Jan 2021) $
+ * @version $Revision: 6559 $, $Date: 2022-06-12 16:53:31 +0100 (Sun, 12 Jun 2022) $
  * @author Blaine Simpson (blaine dot simpson at admc dot com)
  */
 public class SqlTool {
-    private static FrameworkLogger logger =
+    private static final FrameworkLogger logger =
             FrameworkLogger.getLog(SqlTool.class);
     public static final String DEFAULT_RCFILE =
         System.getProperty("user.home") + "/sqltool.rc";
     // N.b. the following are static!
-    private static final String revString = "$Revision: 6266 $";
+    private static final String revString = "$Revision: 6559 $";
     private static final int revStringLength = revString.length();
+    @SuppressWarnings("ConstantConditions")
     private static final String  revnum =
             (revStringLength - " $".length() > "$Revision: ".length())
             ?  revString.substring("$Revision: ".length(),
@@ -101,7 +101,7 @@ public class SqlTool {
      * The configuration identifier to use when connection parameters are
      * specified on the command line
      */
-    private static String CMDLINE_ID = "cmdline";
+    private static final String CMDLINE_ID = "cmdline";
 
     /** Platform-specific line separator */
     public static final String LS = System.getProperty("line.separator");
@@ -115,7 +115,7 @@ public class SqlTool {
     }
 
     /** Utility object for internal use. */
-    private static BadCmdline bcl = new BadCmdline();
+    private static final BadCmdline bcl = new BadCmdline();
 
     /** For trapping of exceptions inside this class.
      * These are always handled inside this class.
@@ -136,8 +136,8 @@ public class SqlTool {
 
     public static class SqlToolException extends Exception {
         static final long serialVersionUID = 1424909871915188519L;
+        int exitValue;
 
-        int exitValue = 1;
         SqlToolException(String message, int exitValue) {
             super(message);
             this.exitValue = exitValue;
@@ -163,8 +163,6 @@ public class SqlTool {
         BufferedReader console;
         String         password;
 
-        password = null;
-
         try {
             console = new BufferedReader(new InputStreamReader(System.in));
 
@@ -215,7 +213,7 @@ public class SqlTool {
             throw new IllegalArgumentException(
                     "inVarString is null in SqlTool.varParser call");
         }
-        boolean escapesPresent = inVarString.indexOf("\\,") > -1;
+        boolean escapesPresent = inVarString.contains("\\,");
         String  varString = escapesPresent ?
                 inVarString.replace("\\,", "\u0002")
                 : inVarString;
@@ -301,7 +299,7 @@ public class SqlTool {
         URL[]   scriptFiles      = null;
         int     i                = -1;
         boolean listMode         = false;
-        boolean interactive      = false;
+        boolean interactive;
         boolean noinput          = false;
         boolean noautoFile       = false;
         boolean autoCommit       = false;
@@ -309,24 +307,23 @@ public class SqlTool {
         Boolean coeOverride      = null;
         Boolean stdinputOverride = null;
         String  rcParams         = null;
-        String  rcUrl            = null;
-        String  rcUsername       = null;
-        String  rcUser           = null;
-        String  rcPassword       = null;
-        String  rcCharset        = null;
-        String  rcTruststore     = null;
-        String  rcTransIso       = null;
-        String  rcDriver         = null;
-        Map<String, String> rcFields = null;
+        String  rcUrl;
+        String  rcUsername;
+        String  rcUser;
+        String  rcPassword;
+        String  rcCharset;
+        String  rcTruststore;
+        String  rcTransIso;
+        String  rcDriver;
+        Map<String, String> rcFields;
         String  parameter;
-        SqlFile[] sqlFiles       = null;
+        SqlFile[] sqlFiles;
         Connection conn          = null;
-        Map<String, String> userVars = new HashMap<String, String>();
+        Map<String, String> userVars = new HashMap<>();
 
         try { // Try block to GC tmpReader
         try { // Try block for BadCmdline
-            while ((i + 1 < arg.length))
-            if (arg[i + 1].startsWith("--")) {
+            while ((i + 1 < arg.length)) if (arg[i + 1].startsWith("--")) {
                 i++;
 
                 if (arg[i].length() == 2) {
@@ -563,7 +560,7 @@ public class SqlTool {
             }
 
             if (stdinputOverride != null) {
-                noinput = !stdinputOverride.booleanValue();
+                noinput = !stdinputOverride;
             }
 
             interactive = (!noinput) && (arg.length <= i + 1);
@@ -577,7 +574,7 @@ public class SqlTool {
                 // I.e., if there are any SQL files specified.
                 scriptFiles = new URL[arg.length - i - 1
                         + ((stdinputOverride == null
-                                || !stdinputOverride.booleanValue()) ? 0 : 1)];
+                                || !stdinputOverride) ? 0 : 1)];
 
                 if (debug) {
                     System.err.println("scriptFiles has "
@@ -595,9 +592,7 @@ public class SqlTool {
                       "Invalid SQL file URL " + arg[i]);
                 }
 
-                if (stdinputOverride != null
-                        && stdinputOverride.booleanValue()) {
-                    scriptFiles[scriptIndex++] = null;
+                if (stdinputOverride != null && stdinputOverride) {
                     noinput                    = true;
                 }
             }
@@ -630,7 +625,7 @@ public class SqlTool {
             if (!rcParamsOverride && conData != null)
                 throw new RuntimeException(
                   "inlineRc override but urlid was specified");
-            rcFields = new HashMap<String, String>();
+            rcFields = new HashMap<>();
 
             try {
                 varParser(rcParams, rcFields, true);
@@ -656,7 +651,6 @@ public class SqlTool {
                     throw new RuntimeException("RC params 'user' and "
                      + "'username' both set.  Set only 'username'");
                 rcUsername = rcUser;
-                rcUser = null;
             }
 
             if (rcDriver != null && driver != null)
@@ -708,7 +702,7 @@ public class SqlTool {
         if (listMode) {
             // listMode has been handled above.
             // Just returning here to prevent unexpected consequences if the
-            // user specifies both an inline RC (will will be ignored) and
+            // user specifies both an inline RC (will be ignored) and
             // --list.
             return;
         }
@@ -819,7 +813,7 @@ public class SqlTool {
                 if (userVars.size() > 0) sqlFile.addUserVars(userVars);
                 if (macros != null) sqlFile.addMacros(macros);
                 if (coeOverride != null)
-                    sqlFile.setContinueOnError(coeOverride.booleanValue());
+                    sqlFile.setContinueOnError(coeOverride);
 
                 sqlFile.execute();
                 userVars = sqlFile.getUserVars();
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/cmdline/SqltoolRB.java 2.7.0-1/hsqldb/src/org/hsqldb/cmdline/SqltoolRB.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/cmdline/SqltoolRB.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/cmdline/SqltoolRB.java	2022-05-21 10:33:44.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -34,7 +34,7 @@ package org.hsqldb.cmdline;
 import org.hsqldb.cmdline.libclone.RefCapableRBInterface;
 import org.hsqldb.cmdline.libclone.ValidatingResourceBundle;
 
-/* $Id: SqltoolRB.java 6266 2021-01-25 16:08:06Z fredt $ */
+/* $Id: SqltoolRB.java 6520 2022-05-21 11:33:38Z fredt $ */
 
 /**
  * Resource Bundle for SqlTool and associated classes.
@@ -270,7 +270,7 @@ public enum SqltoolRB implements RefCapa
     desturl_nowrite
     ;
 
-    private static ValidatingResourceBundle vrb =
+    private static final ValidatingResourceBundle vrb =
             new ValidatingResourceBundle(
                     SqltoolRB.class.getPackage().getName() + ".sqltool",
                     SqltoolRB.class);
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/cmdline/SqlToolSprayer.java 2.7.0-1/hsqldb/src/org/hsqldb/cmdline/SqlToolSprayer.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/cmdline/SqlToolSprayer.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/cmdline/SqlToolSprayer.java	2022-05-23 06:46:22.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -35,7 +35,7 @@ import java.io.File;
 import java.util.ArrayList;
 import java.util.Date;
 
-/* $Id: SqlToolSprayer.java 6266 2021-01-25 16:08:06Z fredt $ */
+/* $Id: SqlToolSprayer.java 6525 2022-05-23 00:50:39Z unsaved $ */
 
 /**
  * Sql Tool Sprayer.
@@ -52,7 +52,7 @@ import java.util.Date;
  * </UL>
  *
  * @see #main(String[])
- * @version $Revision: 6266 $, $Date: 2021-01-25 16:08:06 +0000 (Mon, 25 Jan 2021) $
+ * @version $Revision: 6525 $, $Date: 2022-05-23 01:50:39 +0100 (Mon, 23 May 2022) $
  * @author Blaine Simpson (blaine dot simpson at admc dot com)
  */
 public class SqlToolSprayer {
@@ -92,8 +92,10 @@ public class SqlToolSprayer {
                                                                    : new File(
                                                                        System.getProperty(
                                                                            "sqltoolsprayer.monfile"));
-        ArrayList<String> urlids = new ArrayList<String>();
+        ArrayList<String> urlids = new ArrayList<>();
 
+        // I think false hit from IntelliJ.  Not copying the entire array
+        //noinspection ManualArrayToCollectionCopy
         for (int i = 1; i < sa.length; i++) {
             urlids.add(sa[i]);
         }
@@ -122,8 +124,6 @@ public class SqlToolSprayer {
                 System.exit(2);
             }
 
-            onefailed = false;
-
             for (int i = 0; i < status.length; i++) {
                 if (status[i]) {
                     continue;
@@ -160,11 +160,11 @@ public class SqlToolSprayer {
             }
         }
 
-        ArrayList<String> failedUrlids = new ArrayList<String>();
+        ArrayList<String> failedUrlids = new ArrayList<>();
 
         // If all statuses true, then System.exit(0);
         for (int i = 0; i < status.length; i++) {
-            if (status[i] != true) {
+            if (!status[i]) {
                 failedUrlids.add(urlids.get(i));
             }
         }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/Constraint.java 2.7.0-1/hsqldb/src/org/hsqldb/Constraint.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/Constraint.java	2021-05-30 14:47:30.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/Constraint.java	2022-04-21 06:32:20.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -51,7 +51,7 @@ import org.hsqldb.types.Type;
  * by the constraint.<p>
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.1
+ * @version 2.7.0
  * @since 1.6.0
  */
 public final class Constraint implements SchemaObject {
@@ -818,7 +818,7 @@ public final class Constraint implements
                 } else {
                     if (oldData != null) {
                         int c = core.refIndex.compareRow(session, data,
-                                                          oldData);
+                                                         oldData);
 
                         if (c == 0) {
                             return;
@@ -1029,10 +1029,10 @@ public final class Constraint implements
         parser.compileContext.setNextRangeVarIndex(0);
         parser.read();
 
-        parser.isCheckOrTriggerCondition = true;
-
         Expression condition = parser.XreadBooleanValueExpression();
 
+        condition.setNoOptimisation();
+
         return condition;
     }
 
@@ -1040,6 +1040,7 @@ public final class Constraint implements
 
         // to ensure no subselects etc. are in condition
         check.checkValidCheckConstraint();
+        check.setNoOptimisation();
 
         QuerySpecification checkSelect = Expression.getCheckSelect(session,
             table, check);
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/Database.java 2.7.0-1/hsqldb/src/org/hsqldb/Database.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/Database.java	2021-07-15 13:57:30.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/Database.java	2022-07-14 19:30:44.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -31,6 +31,8 @@
 
 package org.hsqldb;
 
+import java.util.TimeZone;
+
 import org.hsqldb.HsqlNameManager.HsqlName;
 import org.hsqldb.Session.TimeoutManager;
 import org.hsqldb.dbinfo.DatabaseInformation;
@@ -61,7 +63,7 @@ import org.hsqldb.types.Collation;
  * It holds the data structures that form an HSQLDB database instance.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.1
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class Database {
@@ -110,18 +112,20 @@ public class Database {
     public boolean                sqlIgnoreCase          = false;
     public boolean                sqlLiveObject          = false;
     public boolean                sqlLongvarIsLob        = false;
+    public boolean                sqlLowerCaseIdentifier = false;
     public boolean                sqlNullsFirst          = true;
     public boolean                sqlNullsOrder          = true;
-    public boolean                sqlSysIndexNames       = false;
+    public int                    sqlMaxRecursive        = 256;
     public boolean                sqlRegularNames        = true;
-    public boolean                sqlTranslateTTI        = true;
-    public boolean                sqlUniqueNulls         = true;
-    public boolean                sqlLowerCaseIdentifier = false;
     public boolean                sqlSyntaxDb2           = false;
     public boolean                sqlSyntaxMss           = false;
     public boolean                sqlSyntaxMys           = false;
     public boolean                sqlSyntaxOra           = false;
     public boolean                sqlSyntaxPgs           = false;
+    public boolean                sqlSysIndexNames       = false;
+    public boolean                sqlTranslateTTI        = true;
+    public boolean                sqlTruncateTrailing    = true;
+    public boolean                sqlUniqueNulls         = true;
     public int                    recoveryMode           = 0;
     private boolean               isReferentialIntegrity = true;
     public HsqlDatabaseProperties databaseProperties;
@@ -389,7 +393,7 @@ public class Database {
      * Throws if username or password is invalid.
      */
     synchronized Session connect(String username, String password,
-                                 String zoneString, int timeZoneSeconds) {
+                                 TimeZone zone) {
 
         if (getState() != DATABASE_ONLINE) {
             throw Error.error(ErrorCode.X_08001);
@@ -401,7 +405,7 @@ public class Database {
 
         User user = userManager.getUser(username, password);
         Session session = sessionManager.newSession(this, user,
-            databaseReadOnly, true, zoneString, timeZoneSeconds);
+            databaseReadOnly, true, zone);
 
         return session;
     }
@@ -544,6 +548,10 @@ public class Database {
         sqlConvertTruncate = mode;
     }
 
+    public void setTruncateTrailing(boolean mode) {
+        sqlTruncateTrailing = mode;
+    }
+
     public void setDoubleNaN(boolean mode) {
         sqlDoubleNaN = mode;
     }
@@ -552,6 +560,10 @@ public class Database {
         sqlAvgScale = scale;
     }
 
+    public void setMaxRecursive(int value) {
+        sqlMaxRecursive = value;
+    }
+
     public void setLongVarIsLob(boolean mode) {
         sqlLongvarIsLob = mode;
     }
@@ -602,7 +614,7 @@ public class Database {
     }
 
     /**
-     *  Closes this Database using the specified mode. <p>
+     *  Closes this Database using the specified mode.
      *
      * <ol>
      *  <LI> closemode -1 performs SHUTDOWN IMMEDIATELY, equivalent
@@ -650,8 +662,8 @@ public class Database {
             if (result && closemode == CLOSEMODE_COMPACT) {
                 clearStructures();
                 reopen();
-                txManager.setGlobalChangeTimestamp(
-                    txManager.getGlobalChangeTimestamp() + 1);
+                txManager.setSystemChangeNumber(
+                    txManager.getSystemChangeNumber() + 1);
                 setState(DATABASE_CLOSING);
                 sessionManager.closeAllSessions();
                 logger.close(CLOSEMODE_NORMAL);
@@ -887,7 +899,7 @@ public class Database {
      *
      * The runner is called at second intervals. It handles the countdown for
      * each session currently running a statement with timeout. If timeout
-     * is reached, the runner aborts the statement.<p>
+     * is reached, the runner aborts the statement.
      */
     static class TimeoutRunner implements Runnable {
 
@@ -899,6 +911,8 @@ public class Database {
 
             try {
                 synchronized (this) {
+                    long systemMillis = System.currentTimeMillis();
+
                     for (int i = 0; i < timeoutList.size(); i++) {
                         TimeoutManager timeOut =
                             (TimeoutManager) timeoutList.get(i);
@@ -911,7 +925,7 @@ public class Database {
                             continue;
                         }
 
-                        boolean result = timeOut.checkTimeout();
+                        boolean result = timeOut.checkTimeout(systemMillis);
 
                         if (result) {
                             abortCount++;
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/DatabaseManager.java 2.7.0-1/hsqldb/src/org/hsqldb/DatabaseManager.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/DatabaseManager.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/DatabaseManager.java	2022-04-11 19:00:20.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -31,6 +31,7 @@
 
 package org.hsqldb;
 
+import java.util.TimeZone;
 import java.util.Vector;
 import java.util.concurrent.atomic.AtomicInteger;
 
@@ -58,7 +59,7 @@ import org.hsqldb.persist.HsqlProperties
  * Maintains a reference to the timer used for file locks and logging.<p>
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.5.0
+ * @version 2.7.0
  * @since 1.7.2
  */
 public class DatabaseManager {
@@ -127,7 +128,7 @@ public class DatabaseManager {
      * Used by server to open a new session
      */
     public static Session newSession(int dbID, String user, String password,
-                                     String zoneString, int timeZoneSeconds) {
+                                     String zoneString) {
 
         Database db = null;
 
@@ -139,8 +140,8 @@ public class DatabaseManager {
             return null;
         }
 
-        Session session = db.connect(user, password, zoneString,
-                                     timeZoneSeconds);
+        Session session = db.connect(user, password,
+                                     TimeZone.getTimeZone(zoneString));
 
         session.isNetwork = true;
 
@@ -152,11 +153,11 @@ public class DatabaseManager {
      */
     public static Session newSession(String type, String path, String user,
                                      String password, HsqlProperties props,
-                                     String zoneString, int timeZoneSeconds) {
+                                     TimeZone zone) {
 
         Database db = getDatabase(type, path, props);
 
-        return db.connect(user, password, zoneString, timeZoneSeconds);
+        return db.connect(user, password, zone);
     }
 
     /**
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/DatabaseType.java 2.7.0-1/hsqldb/src/org/hsqldb/DatabaseType.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/DatabaseType.java	2019-06-05 12:33:04.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/DatabaseType.java	2022-04-21 13:25:00.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -46,7 +46,7 @@ public enum DatabaseType {
     DB_FILE("file:"),
     DB_RES("res:");
 
-    private String value;
+    private final String value;
 
     DatabaseType(String value) {
         this.value = value;
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/dbinfo/DatabaseInformationFull.java 2.7.0-1/hsqldb/src/org/hsqldb/dbinfo/DatabaseInformationFull.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/dbinfo/DatabaseInformationFull.java	2021-06-25 14:01:46.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/dbinfo/DatabaseInformationFull.java	2022-07-13 17:41:50.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -59,6 +59,7 @@ import org.hsqldb.View;
 import org.hsqldb.index.Index;
 import org.hsqldb.lib.ArrayUtil;
 import org.hsqldb.lib.FileUtil;
+import org.hsqldb.lib.HashMap;
 import org.hsqldb.lib.HashSet;
 import org.hsqldb.lib.Iterator;
 import org.hsqldb.lib.LineGroupReader;
@@ -71,7 +72,7 @@ import org.hsqldb.persist.DataFileCache;
 import org.hsqldb.persist.DataSpaceManager;
 import org.hsqldb.persist.DirectoryBlockCachedObject;
 import org.hsqldb.persist.HsqlDatabaseProperties;
-import org.hsqldb.persist.HsqlProperties;
+import org.hsqldb.persist.HsqlProperties.PropertyMeta;
 import org.hsqldb.persist.PersistentStore;
 import org.hsqldb.persist.TableSpaceManager;
 import org.hsqldb.persist.TextCache;
@@ -112,7 +113,7 @@ import org.hsqldb.types.Type;
  *
  * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.1
+ * @version 2.7.0
  * @since 1.7.2
  */
 final class DatabaseInformationFull
@@ -810,55 +811,18 @@ extends org.hsqldb.dbinfo.DatabaseInform
     }
 
     /**
-     * Retrieves a <code>Table</code> object describing the capabilities
-     * and operating parameter properties for the engine hosting this
-     * database, as well as their applicability in terms of scope and
-     * name space. <p>
-     *
-     * Reported properties include certain predefined <code>Database</code>
-     * properties file values as well as certain database scope
-     * attributes. <p>
-     *
-     * It is intended that all <code>Database</code> attributes and
-     * properties that can be set via the database properties file,
-     * JDBC connection properties or SQL SET/ALTER statements will
-     * eventually be reported here or, where more applicable, in an
-     * ANSI/ISO conforming feature info base table in the definition
-     * schema. <p>
+     * Retrieves a <code>Table</code> object describing the operating properties
+     * for this database, as well as their scope.<p>
      *
-     * Currently, the database properties reported are:
+     * The properties cover those that were set via the JDBC connection
+     * properties or SQL SET statements.<p>
      *
-     * <OL>
-     *     <LI>hsqldb.cache_file_scale - the scaling factor used to translate data and index structure file pointers
-     *     <LI>hsqldb.cache_scale - base-2 exponent scaling allowable cache row count
-     *     <LI>hsqldb.cache_size_scale - base-2 exponent scaling allowable cache byte count
-     *     <LI>hsqldb.cache_version -
-     *     <LI>hsqldb.catalogs - whether to report the database catalog (database uri)
-     *     <LI>hsqldb.compatible_version -
-     *     <LI>hsqldb.files_readonly - whether the database is in files_readonly mode
-     *     <LI>hsqldb.gc_interval - # new records forcing gc ({0|NULL}=>never)
-     *     <LI>hsqldb.max_nio_scale - scale factor for cache nio mapped buffers
-     *     <LI>hsqldb.nio_data_file - whether cache uses nio mapped buffers
-     *     <LI>hsqldb.original_version -
-     *     <LI>sql.enforce_strict_size - column length specifications enforced strictly (raise exception on overflow)?
-     *     <LI>textdb.all_quoted - default policy regarding whether to quote all character field values
-     *     <LI>textdb.cache_scale - base-2 exponent scaling allowable cache row count
-     *     <LI>textdb.cache_size_scale - base-2 exponent scaling allowable cache byte count
-     *     <LI>textdb.encoding - default TEXT table file encoding
-     *     <LI>textdb.fs - default field separator
-     *     <LI>textdb.vs - default varchar field separator
-     *     <LI>textdb.lvs - default long varchar field separator
-     *     <LI>textdb.ignore_first - default policy regarding whether to ignore the first line
-     *     <LI>textdb.quoted - default policy regarding treatment character field values that _may_ require quoting
-     *     <LI>IGNORECASE - create table VARCHAR_IGNORECASE?
-     *     <LI>LOGSIZSE - # bytes to which REDO log grows before auto-checkpoint
-     *     <LI>REFERENTIAL_INTEGITY - currently enforcing referential integrity?
-     *     <LI>SCRIPTFORMAT - 0 : TEXT, 1 : BINARY, ...
-     *     <LI>WRITEDELAY - does REDO log currently use buffered write strategy?
-     * </OL> <p>
+     * Restricted to SQL properties for non-admin users.<p>
+     *
+     * System property values (Java VM properties) are shown as NULL when not
+     * defined.
      *
-     * @return table describing database and session operating parameters
-     *      and capabilities
+     * @return table describing database operating parameters
      */
     Table SYSTEM_PROPERTIES(Session session, PersistentStore store) {
 
@@ -899,33 +863,55 @@ extends org.hsqldb.dbinfo.DatabaseInform
         String nameSpace;
 
         // intermediate holders
-        Object[]               row;
-        HsqlDatabaseProperties props;
+        Object[] row;
+        boolean  restrict   = !session.isAdmin();
+        Iterator it = HsqlDatabaseProperties.getUserDefinedProperties();
+        HashMap  nameToProp = database.logger.getPropertyValueMap(session);
+
+        while (it.hasNext()) {
+            PropertyMeta metaData = (PropertyMeta) it.next();
 
-        // First, we want the names and values for
-        // all JDBC capabilities constants
-        scope     = "SESSION";
-        props     = database.getProperties();
-        nameSpace = "database.properties";
+            if (restrict
+                    && metaData.propType != HsqlDatabaseProperties.SQL_PROP) {
+                continue;
+            }
 
-        // boolean properties
-        Iterator it = props.getUserDefinedPropertyData().iterator();
+            switch (metaData.propType) {
 
-        while (it.hasNext()) {
-            Object[] metaData = (Object[]) it.next();
+                case HsqlDatabaseProperties.SYSTEM_PROP :
+                    scope = "SYSTEM";
+                    break;
+
+                case HsqlDatabaseProperties.FILES_PROP :
+                    scope = "FILES";
+                    break;
 
+                case HsqlDatabaseProperties.DB_PROP :
+                    scope = "DATABASE";
+                    break;
+
+                case HsqlDatabaseProperties.SQL_PROP :
+                    scope = "SQL";
+                    break;
+
+                default :
+                    scope = "";
+            }
+
+            nameSpace   = "database.properties";
             row         = t.getEmptyRowData();
             row[iscope] = scope;
             row[ins]    = nameSpace;
-            row[iname]  = metaData[HsqlProperties.indexName];
-            row[ivalue] =
-                database.logger.getValueStringForProperty((String) row[iname]);
+            row[iname]  = metaData.propName;
+            row[ivalue] = nameToProp.get(metaData.propName);
 
-            if (row[ivalue] == null) {
-                row[ivalue] = props.getPropertyString((String) row[iname]);
+            if (row[ivalue] == null
+                    && metaData.propType
+                       != HsqlDatabaseProperties.SYSTEM_PROP) {
+                row[ivalue] = String.valueOf(metaData.propDefaultValue);
             }
 
-            row[iclass] = metaData[HsqlProperties.indexClass];
+            row[iclass] = metaData.propClass;
 
             t.insertSys(session, store, row);
         }
@@ -937,7 +923,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * Retrieves a <code>Table</code> object describing attributes
      * for the calling session context.<p>
      *
-     * The rows report the following {key,value} pairs:<p>
+     * The rows report the following {key,value} pairs:
      *
      * <pre class="SqlCodeExample">
      * KEY (VARCHAR)       VALUE (VARCHAR)
@@ -995,8 +981,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
         row    = t.getEmptyRowData();
         row[0] = "CONNECTED";
 
-        TimestampData ts =
-            TimestampData.fromMillisecondsGMT(session.getConnectTime());
+        TimestampData ts = session.getConnectTimestamp();
 
         row[1] = Type.SQL_TIMESTAMP_WITH_TIME_ZONE.convertToString(ts);
 
@@ -1100,7 +1085,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * sessions. ADMIN users see *all* sessions
      * while non-admin users see only their own session.<p>
      *
-     * Each row is a session state description with the following columns: <p>
+     * Each row is a session state description with the following columns:
      *
      * <pre class="SqlCodeExample">
      * SESSION_ID         BIGINT    session identifier
@@ -1191,12 +1176,12 @@ extends org.hsqldb.dbinfo.DatabaseInform
             s              = sessions[i];
             row            = t.getEmptyRowData();
             row[isid]      = ValuePool.getLong(s.getId());
-            row[ict] = TimestampData.fromMillisecondsGMT(s.getConnectTime());
+            row[ict]       = s.getConnectTimestamp();
             row[iuname]    = s.getUsername();
             row[iis_admin] = s.isAdmin() ? Boolean.TRUE
                                          : Boolean.FALSE;
             row[iautocmt]  = s.sessionContext.isAutoCommit;
-            row[ireadonly] = Boolean.valueOf(s.isReadOnlyDefault);
+            row[ireadonly] = s.isReadOnlyDefault;
 
             Number lastId = s.getLastIdentity();
 
@@ -1702,7 +1687,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * within this database.<p>
      *
      * Each row is an index column description with the following
-     * columns: <p>
+     * columns:
      *
      * <pre class="SqlCodeExample">
      * TABLE_CATALOG    VARCHAR   table's catalog
@@ -1719,7 +1704,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *        <code>Index</code> objects for each accessible
      *        table defined within this database.
      */
-    final Table SYSTEM_INDEXSTATS(Session session, PersistentStore store) {
+    Table SYSTEM_INDEXSTATS(Session session, PersistentStore store) {
 
         Table t = sysTables[SYSTEM_INDEXSTATS];
 
@@ -1830,8 +1815,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *     INDEX_NAME         INFORMATION_SCHEMA.SQL_IDENTIFIER
      * )</pre>
      */
-    final Table SYSTEM_KEY_INDEX_USAGE(Session session,
-                                       PersistentStore store) {
+    Table SYSTEM_KEY_INDEX_USAGE(Session session, PersistentStore store) {
 
         Table t = sysTables[SYSTEM_KEY_INDEX_USAGE];
 
@@ -1988,7 +1972,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * Identifies the applicable roles for the current user.<p>
      *
-     * <b>Definition</b><p>
+     * <b>Definition</b>
      *
      * <pre class="SqlCodeExample">
      * CREATE RECURSIVE VIEW APPLICABLE_ROLES ( GRANTEE, ROLE_NAME, IS_GRANTABLE ) AS
@@ -2127,7 +2111,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *  those that may create a schema, or currently own a schema created
      *  through a &lt;schema definition&gt;. <p>
      *
-     *  <b>Definition</b><p>
+     *  <b>Definition</b>
      *
      *  <pre class="SqlCodeExample">
      *  CREATE TABLE AUTHORIZATIONS (
@@ -2142,23 +2126,16 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *       )
      *  </pre>
      *
-     *  <b>Description</b><p>
+     *  <b>Description</b>
      *
      *  <ol>
-     *  <li> The values of AUTHORIZATION_TYPE have the following meanings:<p>
-     *
-     *  <table border cellpadding="3">
-     *       <tr>
-     *           <td nowrap>USER</td>
-     *           <td nowrap>The value of AUTHORIZATION_NAME is a known
-     *                      &lt;user identifier&gt;.</td>
-     *       <tr>
-     *       <tr>
-     *           <td nowrap>NO</td>
-     *           <td nowrap>The value of AUTHORIZATION_NAME is a &lt;role
-     *                      name&gt; defined by a &lt;role definition&gt;.</td>
-     *       <tr>
-     *  </table> <p>
+     *  <li> The values of AUTHORIZATION_TYPE have the following meanings:<br>
+     *           USER :
+     *           The value of AUTHORIZATION_NAME is a known
+     *                      &lt;user identifier&gt;.<br>
+     *           NO :
+     *           The value of AUTHORIZATION_NAME is a &lt;role
+     *                      name&gt; defined by a &lt;role definition&gt;.
      *  </ol>
      *
      * @return Table
@@ -2285,7 +2262,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * contained in an &lt;assertion definition&gt;, a &lt;domain
      * constraint&gt;, or a &lt;table constraint definition&gt;. <p>
      *
-     * <b>Definition:</b> <p>
+     * <b>Definition:</b>
      *
      * <pre class="SqlCodeExample">
      * CREATE TABLE SYSTEM_CHECK_ROUTINE_USAGE (
@@ -2300,27 +2277,27 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * )
      * </pre>
      *
-     * <b>Description:</b> <p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The CHECK_ROUTINE_USAGE table has one row for each
-     *      SQL-invoked routine R identified as the subject routine of either a
+     *      SQL-invoked routine identified as the subject routine of either a
      *      &lt;routine invocation&gt;, a &lt;method reference&gt;, a &lt;method
      *      invocation&gt;, or a &lt;static method invocation&gt; contained in
      *      an &lt;assertion definition&gt; or in the &lt;check constraint
      *      definition&gt; contained in either a &lt;domain constraint&gt; or a
-     *      &lt;table constraint definition&gt;. <p>
+     *      &lt;table constraint definition&gt;.
      *
      * <li> The values of CONSTRAINT_CATALOG, CONSTRAINT_SCHEMA, and
      *      CONSTRAINT_NAME are the catalog name, schema name, and
      *      identifier, respectively, of the assertion or check
-     *      constraint being described. <p>
+     *      constraint being described.
      *
      * <li> The values of SPECIFIC_CATALOG, SPECIFIC_SCHEMA, and SPECIFIC_NAME
      *      are the catalog name, schema name, and qualified
-     *      identifier, respectively, of the specific name of R. <p>
+     *      identifier, respectively, of the specific name of the routine.
      *
-     * <1i> Routines are reported only if the user or one of its roles is
+     * <li> Routines are reported only if the user or one of its roles is
      *      the authorization (owner) of the routine.
      *
      * </ol>
@@ -2455,7 +2432,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * The CHECK_CONSTRAINTS view has one row for each domain
      * constraint, table check constraint, and assertion. <p>
      *
-     * <b>Definition:</b><p>
+     * <b>Definition:</b>
      *
      * <pre class="SqlCodeExample">
      *      CONSTRAINT_CATALOG  VARCHAR NULL,
@@ -2464,22 +2441,22 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *      CHECK_CLAUSE        VARCHAR NOT NULL,
      * </pre>
      *
-     * <b>Description:</b><p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> A constraint is shown in this view if the authorization for the
      *      schema that contains the constraint is the current user or is a role
-     *      assigned to the current user. <p>
+     *      assigned to the current user.
      *
      * <li> The values of CONSTRAINT_CATALOG, CONSTRAINT_SCHEMA and
      *      CONSTRAINT_NAME are the catalog name, schema name,
      *      and identifier, respectively, of the constraint being
-     *      described. <p>
+     *      described.
      *
      * <li> the value of CHECK_CLAUSE is that character representation of
      *      the search condition contained in the check constraint.
      *
-     * <1i> Constraints are reported only if the user or one of its roles is
+     * <li> Constraints are reported only if the user or one of its roles is
      *      the authorization (owner) of the table.
      * </ol>
      *
@@ -2619,28 +2596,20 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * )
      * </pre>
      *
-     * <b>Description</b><p>
+     * <b>Description</b>
      *
      * <ol>
      *      <li>The values of COLLATION_CATALOG, COLLATION_SCHEMA, and
      *          COLLATION_NAME are the catalog name, schema name,
      *          and identifier, respectively, of the collation being
-     *          described.<p>
+     *          described.
      *
-     *      <li>The values of PAD_ATTRIBUTE have the following meanings:<p>
+     *      <li>The values of PAD_ATTRIBUTE have the following meanings:<br>
      *
-     *      <table border cellpadding="3">
-     *          <tr>
-     *              <td nowrap>NO PAD</td>
-     *              <td nowrap>The collation being described has the NO PAD
-     *                  characteristic.</td>
-     *          <tr>
-     *          <tr>
-     *              <td nowrap>PAD</td>
-     *              <td nowrap>The collation being described has the PAD SPACE
-     *                         characteristic.</td>
-     *          <tr>
-     *      </table> <p>
+     *              NO PAD :
+     *              The collation does not pad strings with spaces for comparison.<br>
+     *              PAD :
+     *              The collation pads strings with spaces for comparison.
      * </ol>
      *
      * @return Table
@@ -2725,7 +2694,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * a GENERATED column.<p>
      *
      * <b>Definition:</b><p>
-     *
+     * <pre>
      *      TABLE_CATALOG       VARCHAR
      *      TABLE_SCHEMA        VARCHAR
      *      TABLE_NAME          VARCHAR
@@ -2734,7 +2703,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * </pre>
      *
-     * <b>Description:</b> <p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of TABLE_CATALOG, TABLE_SCHEMA, TABLE_NAME, and
@@ -2746,7 +2715,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *      of COLUMN_NAME is the name of a column referenced by the generated
      *      column. There may be multiple rows for each generated column.
      *
-     * <1i> Columns are reported only if the user or one of its roles is
+     * <li> Columns are reported only if the user or one of its roles is
      *      the authorization (owner) of the table.
      * </ol>
      * <p>
@@ -2839,7 +2808,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * a DOMAIN data type.<p>
      *
      * <b>Definition:</b><p>
-     *
+     * <pre>
      *      DOMAIN_CATALOG      VARCHAR
      *      DOMAIN_SCHEMA       VARCHAR
      *      DOMAIN_NAME         VARCHAR
@@ -2850,7 +2819,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * </pre>
      *
-     * <b>Description:</b> <p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of DOMAIN_CATALOG, DOMAIN_SCHEMA and DOMAIN_NAME
@@ -2862,7 +2831,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *      identifier, and column name, respectively, of a column
      *      defined with a DOMAIN data type.
      *
-     * <1i> Columns are reported only if the user or one of its roles is
+     * <li> Columns are reported only if the user or one of its roles is
      *      the authorization (owner) of the DOMAIN.
      * </ol>
      * <p>
@@ -2958,6 +2927,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * <b>Definition:</b><p>
      *
+     * <pre>
      *      UDT_CATALOG      VARCHAR
      *      UDT_SCHEMA       VARCHAR
      *      UDT_NAME         VARCHAR
@@ -2968,7 +2938,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * </pre>
      *
-     * <b>Description:</b> <p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of UDT_CATALOG, UDT_SCHEMA and UDT_NAME
@@ -2980,7 +2950,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *      identifier, and column name, respectively, of a column
      *      defined with a DICTINCT TYPE data type.
      *
-     * <1i> Columns are reported only if the user or one of its roles is
+     * <li> Columns are reported only if the user or one of its roles is
      *      the authorization (owner) of the DISTINCT TYPE.
      * </ol>
      * <p>
@@ -3073,9 +3043,9 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * SQL:2008 VIEW<p>
      * The COLUMNS view has one row for each column of each table or view.
      * The column, its data type characteristics, together with its
-     * IDENTITY or GENERATED characteristics are reported in this view.<p>
+     * IDENTITY or GENERATED characteristics are reported in this view.
      * <ol>
-     * <1i> Columns are reported only if the user or one of its roles is
+     * <li> Columns are reported only if the user or one of its roles is
      *      the authorization (owner) of the table, or is granted any privilege
      *      on the table or the column.
      *
@@ -3393,6 +3363,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * <b>Definition:</b><p>
      *
+     * <pre>
      *      TABLE_CATALOG       VARCHAR
      *      TABLE_SCHEMA        VARCHAR
      *      TABLE_NAME          VARCHAR
@@ -3403,7 +3374,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * </pre>
      *
-     * <b>Description:</b> <p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of TABLE_CATALOG, TABLE_SCHEMA, TABLE_NAME, and
@@ -3416,12 +3387,12 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * <li> The values of CONSTRAINT_CATALOG, CONSTRAINT_SCHEMA, and
      *      CONSTRAINT_NAME are the catalog name, schema name,
      *      and identifier, respectively, of the constraint being
-     *      described. <p>
+     *      described.
      *
      * <li> For FOREIGN KEY constraints, the columns of the UNIQUE constraint
      *      in the referenced table are also included in this view.
      *
-     * <1i> Columns are reported only if the user or one of its roles is
+     * <li> Columns are reported only if the user or one of its roles is
      *      the authorization (owner) of the table.
      *
      * </ol>
@@ -3584,6 +3555,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * <b>Definition:</b><p>
      *
+     * <pre>
      *      TABLE_CATALOG       VARCHAR
      *      TABLE_SCHEMA        VARCHAR
      *      TABLE_NAME          VARCHAR
@@ -3594,7 +3566,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * </pre>
      *
-     * <b>Description:</b> <p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of TABLE_CATALOG, TABLE_SCHEMA, TABLE_NAME, and
@@ -3605,9 +3577,9 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * <li> The values of CONSTRAINT_CATALOG, CONSTRAINT_SCHEMA, and
      *      CONSTRAINT_NAME are the catalog name, schema name,
      *      and identifier, respectively, of the constraint being
-     *      described. <p>
+     *      described.
      *
-     * <1i> Periods are reported only if the user or one of its roles is
+     * <li> Periods are reported only if the user or one of its roles is
      *      the authorization (owner) of the table.
      *
      * </ol>
@@ -3720,7 +3692,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * containing / referenced by each PRIMARY KEY, UNIQUE and FOREIGN KEY
      * constraint<p>
      *
-     * <b>Definition:</b> <p>
+     * <b>Definition:</b>
      *
      * <pre class="SqlCodeExample">
      *      TABLE_CATALOG           VARCHAR
@@ -3731,13 +3703,13 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *      CONSTRAINT_NAME         VARCHAR
      * </pre>
      *
-     * <b>Description:</b> <p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of CONSTRAINT_CATALOG, CONSTRAINT_SCHEMA, and
      *      CONSTRAINT_NAME are the catalog name, schema name,
      *       and identifier, respectively, of the constraint being
-     *      described. <p>
+     *      described.
      *
      * <li> The values of TABLE_CATALOG, TABLE_SCHEMA, and TABLE_NAME are the
      *      catalog name, schema name, and identifier,
@@ -3746,7 +3718,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *      *lt;search condition&gt; of the constraint being described, or
      *      its columns.
      *
-     * <1i> Tables are reported only if the user or one of its roles is
+     * <li> Tables are reported only if the user or one of its roles is
      *      the authorization (owner) of the table.
      * </ol>
      *
@@ -3796,7 +3768,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * The DATA_TYPE_PRIVILEGES view has one row for each use of a data type.
      * Currently this view does not report the DTD_IDENTIFIER column.
-     * <b>Definition:</b> <p>
+     * <b>Definition:</b>
      *
      * <pre class="SqlCodeExample">
      *      OBJECT_CATALOG      VARCHAR
@@ -3806,17 +3778,17 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *      DTD_IDENTIFIER      VARCHAR
      * </pre>
      *
-     * <b>Description:</b> <p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of OBJECT_CATALOG, OBJECT_SCHEMA, and
      *      OBJECT_NAME are the catalog name, schema name,
-     *       and identifier, respectively, of the object. <p>
+     *       and identifier, respectively, of the object.
      *
      * <li> The value of OBJECT_TYPE is the type of the object, for example
      *      'TABLE'.
      *
-     * <1i> Tables are reported only if the user or one of its roles is
+     * <li> Tables are reported only if the user or one of its roles is
      *      the authorization (owner) of the table.
      * </ol>
      *
@@ -3947,7 +3919,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * The DOMAIN_CONSTRAINTS view has one row for each domain
      * constraint. <p>
      *
-     * <b>Definition:</b><p>
+     * <b>Definition:</b>
      *
      * <pre class="SqlCodeExample">
      *      CONSTRAINT_CATALOG  VARCHAR NULL,
@@ -3960,19 +3932,19 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *      INITIALLY_DEFERRED  VARCHAR NOT NULL,
      * </pre>
      *
-     * <b>Description:</b><p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> A constraint is shown in this view if the authorization for the
      *      DOMAIN that contains the constraint is the current user or is a role
-     *      assigned to the current user. <p>
+     *      assigned to the current user.
      *
      * <li> The values of CONSTRAINT_CATALOG, CONSTRAINT_SCHEMA and
      *      CONSTRAINT_NAME are the catalog name, schema name,
      *      and identifier, respectively, of the constraint being
      *      described. <p>
      *
-     * <1i> Constraints are reported only if the user or one of its roles is
+     * <li> Constraints are reported only if the user or one of its roles is
      *      the authorization (owner) of the DOMAIN.
      * </ol>
      *
@@ -4548,7 +4520,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * Identify the enabled roles for the current SQL-session.<p>
      *
-     * Definition<p>
+     * Definition
      *
      * <pre class="SqlCodeExample">
      * CREATE RECURSIVE VIEW ENABLED_ROLES ( ROLE_NAME ) AS
@@ -4604,7 +4576,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
     /**
      * SQL:2008 VIEW<p>
      *
-     * The JAR_JAR_USAGE view is empty.<p>
+     * The JAR_JAR_USAGE view is empty.
      *
      */
     Table JAR_JAR_USAGE(Session session, PersistentStore store) {
@@ -4650,7 +4622,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
     /**
      * SQL:2008 VIEW<p>
      *
-     * The JARS view is empty.<p>
+     * The JARS view is empty.
      *
      */
     Table JARS(Session session, PersistentStore store) {
@@ -4696,7 +4668,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * defined within this database. <p>
      *
      * Each row is a PRIMARY KEY or UNIQUE column description with the following
-     * columns: <p>
+     * columns:
      *
      * <pre class="SqlCodeExample">
      * CONSTRAINT_CATALOG              VARCHAR NULL,
@@ -4855,7 +4827,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * defined within this database. <p>
      *
      * Each row is a PRIMARY KEY, UNIQUE OR FOREIGN KEY description with the
-     * following columns: <p>
+     * following columns:
      *
      * <pre class="SqlCodeExample">
      * CONSTRAINT_CATALOG              VARCHAR NULL,
@@ -4952,7 +4924,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
     /**
      * SQL:2008 VIEW<p>
      *
-     * The METHOD_SPECIFICATION_PARAMETERS view is not implemented.<p>
+     * The METHOD_SPECIFICATION_PARAMETERS view is not implemented.
      *
      */
     Table METHOD_SPECIFICATION_PARAMETERS(Session session,
@@ -4963,7 +4935,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
     /**
      * SQL:2008 VIEW<p>
      *
-     * The METHOD_SPECIFICATIONS view is not implemented.<p>
+     * The METHOD_SPECIFICATIONS view is not implemented.
      *
      */
     Table METHOD_SPECIFICATIONS(Session session, PersistentStore store) {
@@ -4973,7 +4945,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
     /**
      * SQL:2008 VIEW<p>
      *
-     * The MODULE_COLUMN_USAGE view is not implemented.<p>
+     * The MODULE_COLUMN_USAGE view is not implemented.
      *
      */
     Table MODULE_COLUMN_USAGE(Session session, PersistentStore store) {
@@ -4983,7 +4955,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
     /**
      * SQL:2008 VIEW<p>
      *
-     * The MODULE_PRIVILEGES view is not implemented.<p>
+     * The MODULE_PRIVILEGES view is not implemented.
      *
      */
     Table MODULE_PRIVILEGES(Session session, PersistentStore store) {
@@ -4993,7 +4965,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
     /**
      * SQL:2008 VIEW<p>
      *
-     * The MODULE_TABLE_USAGE view is not implemented.<p>
+     * The MODULE_TABLE_USAGE view is not implemented.
      *
      */
     Table MODULE_TABLE_USAGE(Session session, PersistentStore store) {
@@ -5003,7 +4975,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
     /**
      * SQL:2008 VIEW<p>
      *
-     * The MODULES view is not implemented.<p>
+     * The MODULES view is not implemented.
      *
      */
     Table MODULES(Session session, PersistentStore store) {
@@ -5014,7 +4986,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * SQL:2008 VIEW<p>
      *
      * The PARAMETERS view has one row for each parameter of a user defined
-     * routine.<p>
+     * routine.
      *
      * <pre class="SqlCodeExample">
      *      OBJECT_CATALOG      VARCHAR
@@ -5024,17 +4996,17 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *      DTD_IDENTIFIER      VARCHAR
      * </pre>
      *
-     * <b>Description:</b> <p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of OBJECT_CATALOG, OBJECT_SCHEMA, and
      *      OBJECT_NAME are the catalog name, schema name,
-     *       and identifier, respectively, of the object. <p>
+     *       and identifier, respectively, of the object.
      *
      * <li> The value of OBJECT_TYPE is the type of the object, for example
      *      'TABLE'.
      *
-     * <1i> Tables are reported only if the user or one of its roles is
+     * <li> Tables are reported only if the user or one of its roles is
      *      the authorization (owner) of the table.
      * </ol>
      *
@@ -5271,7 +5243,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
     /**
      * SQL:2011 VIEW<p>
      *
-     * The PERIODS view has one row for each period defined in a table.<p>
+     * The PERIODS view has one row for each period defined in a table.
      *
      * <pre class="SqlCodeExample">
      *      TABLE_CATALOG      VARCHAR
@@ -5282,12 +5254,12 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *      END_COLUMN_NAME    VARCHAR
      * </pre>
      *
-     * <b>Description:</b> <p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of TABLE_CATALOG, TABLE_SCHEMA, and
      *      TABLE_NAME are the catalog name, schema name,
-     *       and identifier, respectively, of the table. <p>
+     *       and identifier, respectively, of the table.
      *
      * <li> The value of PERIOD_NAME is the name of the period, either
      *      SYSTE_TIME or an application period.
@@ -5295,10 +5267,10 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * <li> The values of START_COLUMN_NAME and END_COLUMN_NAME are the names
      *      of the period columns.
      *
-     * <1i> Periods are reported only if the user or one of its roles
+     * <li> Periods are reported only if the user or one of its roles
      *      can access the table and some of its columns.
      *
-     * <1i> Column names are reported only if the user or one of its roles is
+     * <li> Column names are reported only if the user or one of its roles is
      *      the authorization (owner) of the table.
      * </ol>
      *
@@ -5393,7 +5365,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * The REFERENTIAL_CONSTRAINTS view has one row for each FOREIGN KEY
      * constraint. <p>
      *
-     * <b>Definition:</b><p>
+     * <b>Definition:</b>
      *
      * <pre class="SqlCodeExample">
      *      CONSTRAINT_CATALOG             VARCHAR ,
@@ -5407,17 +5379,17 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *      DELETE_RULE                    VARCHAR ,
      * </pre>
      *
-     * <b>Description:</b><p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of CONSTRAINT_CATALOG, CONSTRAINT_SCHEMA and
      *      CONSTRAINT_NAME are the catalog name, schema name,
      *      and identifier, respectively, of the constraint being
-     *      described. <p>
+     *      described.
      *
      * <li> The values of UNIQUE_CONSTRAINT_CATALOG, UNIQUE_CONSTRAINT_SCHEMA and
      *      UNIQUE_CONSTRAINT_NAME are the catalog name, schema name,
-     *      and identifier, respectively, of the referenced UNIQUE constraint. <p>
+     *      and identifier, respectively, of the referenced UNIQUE constraint.
      *
      * <li> A constraint is shown in this view if the user has table level
      *      privilege of at lease one of the types, INSERT, UPDATE, DELETE,
@@ -5524,7 +5496,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * The ROLE_COLUMN_GRANTS view has one row for each privilege granted to each
      * ROLE on each column. <p>
      *
-     * <b>Definition:</b><p>
+     * <b>Definition:</b>
      *
      * <pre class="SqlCodeExample">
      *      GRANTOR                        VARCHAR ,
@@ -5537,7 +5509,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *      IS_GRANTABLE                   VARCHAR ,
      * </pre>
      *
-     * <b>Description:</b><p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of GRANTOR is the grantor of the privilege. The value of
@@ -5546,11 +5518,11 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * <li> The values of TABLE_CATALOG, TABLE_SCHEMA,
      *      TABLE_NAME and COLUMN_NAME are the catalog name, schema name,
      *      table name and column identifier, respectively, of the column grant being
-     *      described. <p>
+     *      described.
      *
      * <li> The value of PRIVILEGE_TYPE is the type of the privilege, including,
      *      'SELECT', 'UPDATE', 'INSERT', 'REFERENCES' and 'TRIGGER'.
-     *      The value IS_GRANTABLE is 'YES' if the privilege is grantable. <p>
+     *      The value IS_GRANTABLE is 'YES' if the privilege is grantable.
      * </ol>
      *
      * @return Table
@@ -5604,7 +5576,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * The ROLE_ROUTINE_GRANTS view has one row for each privilege granted to each
      * ROLE on each specific routine. <p>
      *
-     * <b>Definition:</b><p>
+     * <b>Definition:</b>
      *
      * <pre class="SqlCodeExample">
      *      GRANTOR                        VARCHAR ,
@@ -5619,7 +5591,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *      IS_GRANTABLE                   VARCHAR ,
      * </pre>
      *
-     * <b>Description:</b><p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of GRANTOR is the grantor of the privilege. The value of
@@ -5628,7 +5600,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * <li> The values of SPECIFIC_CATALOG, SPECIFIC_SCHEMA and
      *      SPECIFIC_NAME are the catalog name, schema name,
      *      routine identifier, respectively, of the grant being
-     *      described. <p>
+     *      described.
      *
      * <li> The value of PRIVILEGE_TYPE is the type of the privilege, including
      *      'EXECUTE'.
@@ -5701,7 +5673,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * The ROLE_ROUTINE_GRANTS view has one row for each privilege granted to each
      * ROLE on each table. <p>
      *
-     * <b>Definition:</b><p>
+     * <b>Definition:</b>
      *
      * <pre class="SqlCodeExample">
      *      GRANTOR                        VARCHAR ,
@@ -5714,7 +5686,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *      WITH_HIERARCHY                 VARCHAR ,
      * </pre>
      *
-     * <b>Description:</b><p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of GRANTOR is the grantor of the privilege. The value of
@@ -5723,7 +5695,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * <li> The values of TABLE_CATALOG, TABLE_SCHEMA and
      *      TABLE_NAME are the catalog name, schema name and
      *      table name, respectively, of the table level grant being
-     *      described. <p>
+     *      described.
      *
      * <li> The value of PRIVILEGE_TYPE is the type of the privilege, including,
      *      'DELETE', 'SELECT', 'UPDATE', 'INSERT', 'REFERENCES' and 'TRIGGER'.
@@ -5782,7 +5754,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * The ROLE_UDT_GRANT view has one row for each privilege granted to each
      * user defined type. <p>
      *
-     * <b>Definition:</b><p>
+     * <b>Definition:</b>
      *
      * <pre class="SqlCodeExample">
      *      GRANTOR                        VARCHAR ,
@@ -5794,7 +5766,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *      IS_GRANTABLE                   VARCHAR ,
      * </pre>
      *
-     * <b>Description:</b><p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of GRANTOR is the grantor of the privilege. The value of
@@ -5803,7 +5775,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * <li> The values of UDT_CATALOG, UDT_SCHEMA and
      *      UDT_NAME are the catalog name, schema name and
      *      table name, respectively, of the table level grant being
-     *      described. <p>
+     *      described.
      *
      * <li> The value of PRIVILEGE_TYPE is the type of the privilege, including,
      *      'USAGE'.
@@ -5856,7 +5828,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * The ROLE_USAGE_GRANTS view has one row for each privilege granted to each
      * ROLE on each table. <p>
      *
-     * <b>Definition:</b><p>
+     * <b>Definition:</b>
      *
      * <pre class="SqlCodeExample">
      *      GRANTOR                        VARCHAR ,
@@ -5869,7 +5841,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *      IS_GRANTABLE                   VARCHAR ,
      * </pre>
      *
-     * <b>Description:</b><p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of GRANTOR is the grantor of the privilege. The value of
@@ -5878,12 +5850,12 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * <li> The values of OBJECT_CATALOG, OBJECT_SCHEMA and
      *      OBJECT_NAME are the catalog name, schema name and
      *      table name, respectively, of the object being
-     *      described. <p>
+     *      described.
      * <li> The value of OBJECT_TYPE is they type of object, including 'DOMAIN', 'CHARACTER SET',
      *      'COLLATION', 'TRANSLATION' and 'SEQUENCE'.
      * <li> The value of PRIVILEGE_TYPE is the type of the privilege, including,
      *      'USAGE'.
-     *      The value IS_GRANTABLE is 'YES' if the privilege is grantable. <p>
+     *      The value IS_GRANTABLE is 'YES' if the privilege is grantable.
      * </ol>
      *
      * @return Table
@@ -5937,6 +5909,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * <b>Definition:</b><p>
      *
+     * <pre>
      *      SPECIFIC_CATALOG    VARCHAR ,
      *      SPECIFIC_SCHEMA     VARCHAR ,
      *      SPECIFIC_NAME       VARCHAR ,
@@ -5950,19 +5923,19 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * </pre>
      *
-     * <b>Description:</b> <p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of SPECIFIC_CATALOG, SPECIFIC_SCHEMA and
      *      SPECIFIC_NAME are the catalog name, schema name,
      *      specific routine identifier, respectively, of the grant being
-     *      described. <p>
+     *      described.
      * <li> The values of TABLE_CATALOG, TABLE_SCHEMA, TABLE_NAME, and
      *      COLUMN_NAME are the catalog name, schema name,
      *      identifier, and column name, respectively, of a column
-     *      reference in the routine body.<>
+     *      reference in the routine body.
      *
-     * <1i> Columns are reported only if the user or one of its roles is
+     * <li> Columns are reported only if the user or one of its roles is
      *      the authorization (owner) of the table.
      *
      * </ol>
@@ -6063,6 +6036,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * <b>Definition:</b><p>
      *
+     * <pre>
      *      SPECIFIC_CATALOG    VARCHAR ,
      *      SPECIFIC_SCHEMA     VARCHAR ,
      *      SPECIFIC_NAME       VARCHAR ,
@@ -6072,19 +6046,19 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * </pre>
      *
-     * <b>Description:</b> <p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of SPECIFIC_CATALOG, SPECIFIC_SCHEMA and
      *      SPECIFIC_NAME are the catalog name, schema name,
-     *      specific routine identifier, respectively. <p>
+     *      specific routine identifier, respectively.
      *
      * <li> The values of JAR_CATALOG, JAR_SCHEMA and JAR_NAME are
      *      the catalog name, schema name,
      *      identifier, and column name, respectively, of a jar
-     *      reference in the routine body.<>
+     *      reference in the routine body.
      *
-     * <1i> Currently 'CLASSPATH' is reported for all entries.
+     * <li> Currently 'CLASSPATH' is reported for all entries.
      *
      * </ol>
      *
@@ -6164,6 +6138,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * <b>Definition:</b><p>
      *
+     * <pre>
      *      SPECIFIC_CATALOG    VARCHAR ,
      *      SPECIFIC_SCHEMA     VARCHAR ,
      *      SPECIFIC_NAME       VARCHAR ,
@@ -6177,21 +6152,21 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * </pre>
      *
-     * <b>Description:</b> <p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of SPECIFIC_CATALOG, SPECIFIC_SCHEMA and
      *      SPECIFIC_NAME are the catalog name, schema name,
-     *      specific routine identifier, respectively, of the routine. <p>
+     *      specific routine identifier, respectively, of the routine.
      * <li> The values of TABLE_CATALOG, TABLE_SCHEMA and TABLE_NAME
      *      are the catalog name, schema name and
      *      identifier, respectively, of a TABLE
-     *      reference in the routine body.<>
+     *      reference in the routine body.
      *
      * <li> The value of PERIOD_NAME is the name of the PERIOD of a TABLE
-     *      reference in the routine body.<>
+     *      reference in the routine body.
      *
-     * <1i> Periods are reported only if the user or one of its roles is
+     * <li> Periods are reported only if the user or one of its roles is
      *      the authorization (owner) of the TABLE.
      *
      * </ol>
@@ -6304,7 +6279,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *      IS_GRANTABLE          VARCHAR ,
      * </pre>
      *
-     * <b>Description:</b> <p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of GRANTOR is the grantor of the privilege. The value of
@@ -6312,15 +6287,15 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * <li> The values of SPECIFIC_CATALOG, SPECIFIC_SCHEMA and
      *      SPECIFIC_NAME are the catalog name, schema name
-     *      and identifier, respectively, of the specific ROUTINE. <p>
+     *      and identifier, respectively, of the specific ROUTINE.
      *
      * <li> The values of ROUTINE_CATALOG, ROUTINE_SCHEMA and
      *      ROUTINE_NAME are the catalog name, schema name
-     *      and identifier, respectively, of the ROUTINE. <p>
+     *      and identifier, respectively, of the ROUTINE.
      *
      * <li> The value of PRIVILEGE_TYPE is the type of the privilege, including,
      *      'EXECUTE'
-     *      The value IS_GRANTABLE is 'YES' if the privilege is grantable. <p>
+     *      The value IS_GRANTABLE is 'YES' if the privilege is grantable.
      * </ol>
      *
      * @return Table
@@ -6402,7 +6377,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
                     Right right          = (Right) rights.get(j);
                     Right grantableRight = right.getGrantableRights();
 
-                    if (!right.canAccessFully(GrantConstants.EXECUTE)) {
+                    if (!right.canAccess(GrantConstants.EXECUTE)) {
                         continue;
                     }
 
@@ -6420,10 +6395,10 @@ extends org.hsqldb.dbinfo.DatabaseInform
                     row[routine_name]     = routine.getName().name;
                     row[privilege_type]   = privilege;
                     row[is_grantable] =
-                        right.getGrantee() == routine.getOwner()
-                        || grantableRight.canAccessFully(
-                            GrantConstants.EXECUTE) ? "YES"
-                                                    : "NO";
+                        right.getGrantee() == routine
+                            .getOwner() || grantableRight
+                            .canAccess(GrantConstants.EXECUTE) ? "YES"
+                                                               : "NO";
 
                     try {
                         t.insertSys(session, store, row);
@@ -6443,6 +6418,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * <b>Definition:</b><p>
      *
+     * <pre>
      *      SPECIFIC_CATALOG    VARCHAR ,
      *      SPECIFIC_SCHEMA     VARCHAR ,
      *      SPECIFIC_NAME       VARCHAR ,
@@ -6452,18 +6428,18 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * </pre>
      *
-     * <b>Description:</b> <p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of SPECIFIC_CATALOG, SPECIFIC_SCHEMA and
      *      SPECIFIC_NAME are the catalog name, schema name,
      *      specific routine identifier, respectively, of the routine
-     *      which contains the reference. <p>
+     *      which contains the reference.
      * <li> The values of ROUTINE_CATALOG, ROUTINE_SCHEMA and ROUTINE_NAME
      *      are the catalog name, schema name and
      *      identifier, respectively, of the routine that is referenced.<p>
      *
-     * <1i> Referenced routines are reported only if the user or one of its roles is
+     * <li> Referenced routines are reported only if the user or one of its roles is
      *      the authorization (owner) of the referenced routine.
      *
      * </ol>
@@ -6550,6 +6526,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * <b>Definition:</b><p>
      *
+     * <pre>
      *      SPECIFIC_CATALOG    VARCHAR ,
      *      SPECIFIC_SCHEMA     VARCHAR ,
      *      SPECIFIC_NAME       VARCHAR ,
@@ -6559,18 +6536,18 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * </pre>
      *
-     * <b>Description:</b> <p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of SPECIFIC_CATALOG, SPECIFIC_SCHEMA and
      *      SPECIFIC_NAME are the catalog name, schema name,
-     *      specific routine identifier, respectively, of the routine. <p>
+     *      specific routine identifier, respectively, of the routine.
      * <li> The values of SEQUENCE_CATALOG, SEQUENCE_SCHEMA and SEQUENCE_NAME
      *      are the catalog name, schema name and
      *      identifier, respectively, of a SEQUENCE
-     *      reference in the routine body.<>
+     *      reference in the routine body.
      *
-     * <1i> Referenced sequences are reported only if the user or one of its roles is
+     * <li> Referenced sequences are reported only if the user or one of its roles is
      *      the authorization (owner) of the SEQUENCE.
      *
      * </ol>
@@ -6657,6 +6634,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * <b>Definition:</b><p>
      *
+     * <pre>
      *      SPECIFIC_CATALOG    VARCHAR ,
      *      SPECIFIC_SCHEMA     VARCHAR ,
      *      SPECIFIC_NAME       VARCHAR ,
@@ -6669,18 +6647,18 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * </pre>
      *
-     * <b>Description:</b> <p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of SPECIFIC_CATALOG, SPECIFIC_SCHEMA and
      *      SPECIFIC_NAME are the catalog name, schema name,
-     *      specific routine identifier, respectively, of the routine. <p>
+     *      specific routine identifier, respectively, of the routine.
      * <li> The values of TABLE_CATALOG, TABLE_SCHEMA and TABLE_NAME
      *      are the catalog name, schema name and
      *      identifier, respectively, of a TABLE
-     *      reference in the routine body.<>
+     *      reference in the routine body.
      *
-     * <1i> Tables are reported only if the user or one of its roles is
+     * <li> Tables are reported only if the user or one of its roles is
      *      the authorization (owner) of the TABLE.
      *
      * </ol>
@@ -6772,7 +6750,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
     /**
      * SQL:2008 VIEW<p>
      *
-     * The ROUTINES view has one row for each PROCEDURE and FUNCTION.<p>
+     * The ROUTINES view has one row for each PROCEDURE and FUNCTION.
      *
      */
     Table ROUTINES(Session session, PersistentStore store) {
@@ -7163,7 +7141,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * The SCHEMATA view has one row for each accessible schema. <p>
      *
      * <b>Definition:</b><p>
-     *
+     * <pre>
      *      CATALOG_NAME                       VARCHAR ,
      *      SCHEMA_NAME                        VARCHAR ,
      *      SCHEMA_OWNER                       VARCHAR ,
@@ -7174,32 +7152,32 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * </pre>
      *
-     * <b>Description</b><p>
+     * <b>Description</b>
      *
      * <ol>
      *      <li>The value of CATALOG_NAME is the name of the catalog of the
-     *          schema described by this row.<p>
+     *          schema described by this row.
      *
      *      <li>The value of SCHEMA_NAME is the schema name of
-     *          the schema described by this row.<p>
+     *          the schema described by this row.
      *
      *      <li>The values of SCHEMA_OWNER are the authorization identifiers
-     *          that own the schemata.<p>
+     *          that own the schemata.
      *
      *      <li>The values of DEFAULT_CHARACTER_SET_CATALOG,
      *          DEFAULT_CHARACTER_SET_SCHEMA, and DEFAULT_CHARACTER_SET_NAME
      *          are the catalog name, schema name, and qualified
      *          identifier, respectively, of the default character set for
-     *          columns and domains in the schemata.<p>
+     *          columns and domains in the schemata.
      *
-     *      <li>Case:<p>
+     *      <li>Case:
      *          <ul>
      *              <li>If &lt;schema path specification&gt; was specified in
      *                  the &lt;schema definition&gt; that defined the schema
      *                  described by this row and the character representation
      *                  of the &lt;schema path specification&gt; can be
      *                  represented without truncation, then the value of
-     *                  SQL_PATH is that character representation.<p>
+     *                  SQL_PATH is that character representation.
      *
      *              <li>Otherwise, the value of SQL_PATH is the null value.
      *         </ul>
@@ -7283,8 +7261,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * SQL:2008 VIEW<p>
      *
      * The SQL_FEATURES view lists the individual features of the SQL Standard
-     * supported by HyperSQL.<p>
-     *
+     * supported by HyperSQL.
      */
     Table SQL_FEATURES(Session session, PersistentStore store) {
 
@@ -7326,8 +7303,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * SQL:2008 VIEW<p>
      *
      * The SQL_IMPLEMENTATION_INFO shows some properties and capabilities
-     * of the database engine .<p>
-     *
+     * of the database engine .
      */
     Table SQL_IMPLEMENTATION_INFO(Session session, PersistentStore store) {
 
@@ -7365,8 +7341,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * SQL:2008 VIEW<p>
      *
      * The SQL_PACHAGES view lists the packages of the SQL Standard supported by
-     * HyperSQL.<p>
-     *
+     * HyperSQL.
      */
     Table SQL_PACKAGES(Session session, PersistentStore store) {
 
@@ -7404,8 +7379,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * SQL:2008 VIEW<p>
      *
      * The SQL_PARTS view lists the parts of the SQL Standard supported by
-     * HyperSQL.<p>
-     *
+     * HyperSQL.
      */
     Table SQL_PARTS(Session session, PersistentStore store) {
 
@@ -7442,8 +7416,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * SQL:2008 VIEW<p>
      *
      * The SQL_SIZING view has one row for the maximum size of each built in
-     * type supported by HyperSQL.<p>
-     *
+     * type supported by HyperSQL.
      */
     Table SQL_SIZING(Session session, PersistentStore store) {
 
@@ -7478,8 +7451,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
     /**
      * SQL:2008 VIEW<p>
      *
-     * The SQL_SIZING_PROFILES is empty.<p>
-     *
+     * The SQL_SIZING_PROFILES is empty.
      */
     Table SQL_SIZING_PROFILES(Session session, PersistentStore store) {
 
@@ -7514,7 +7486,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * It effectively contains a representation of the table constraint
      * descriptors. <p>
      *
-     * <b>Definition:</b> <p>
+     * <b>Definition:</b>
      *
      * <pre class="SqlCodeExample">
      * CREATE TABLE SYSTEM_TABLE_CONSTRAINTS (
@@ -7539,7 +7511,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * )
      * </pre>
      *
-     * <b>Description:</b> <p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of CONSTRAINT_CATALOG, CONSTRAINT_SCHEMA, and
@@ -7550,62 +7522,26 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *      that defined the constraint did not specify a
      *      &lt;constraint name&gt;, then the values of CONSTRAINT_CATALOG,
      *      CONSTRAINT_SCHEMA, and CONSTRAINT_NAME are
-     *      implementation-defined. <p>
+     *      implementation-defined.
      *
-     * <li> The values of CONSTRAINT_TYPE have the following meanings: <p>
-     *  <table border cellpadding="3">
-     *  <tr>
-     *      <td nowrap>FOREIGN KEY</td>
-     *      <td nowrap>The constraint being described is a
-     *                 foreign key constraint.</td>
-     *  </tr>
-     *  <tr>
-     *      <td nowrap>UNIQUE</td>
-     *      <td nowrap>The constraint being described is a
-     *                 unique constraint.</td>
-     *  </tr>
-     *  <tr>
-     *      <td nowrap>PRIMARY KEY</td>
-     *      <td nowrap>The constraint being described is a
-     *                 primary key constraint.</td>
-     *  </tr>
-     *  <tr>
-     *      <td nowrap>CHECK</td>
-     *      <td nowrap>The constraint being described is a
-     *                 check constraint.</td>
-     *  </tr>
-     * </table> <p>
+     * <li> The values of CONSTRAINT_TYPE can be FOREIGN_KEY, UNIQUE,
+     *      PRIMARY_KEY or CHECK. They are self-explanatory.
      *
      * <li> The values of TABLE_CATALOG, TABLE_SCHEMA, and TABLE_NAME are
      *      the catalog name, the schema name, and the
      *      name of the table to which the
-     *      table constraint being described applies. <p>
+     *      table constraint being described applies.
      *
-     * <li> The values of IS_DEFERRABLE have the following meanings: <p>
+     * <li> The values of IS_DEFERRABLE apply only to FOREIGN KEY constraints
+     * and have the following meanings:<br>
      *
-     *  <table>
-     *      <tr>
-     *          <td nowrap>YES</td>
-     *          <td nowrap>The table constraint is deferrable.</td>
-     *      </tr>
-     *      <tr>
-     *          <td nowrap>NO</td>
-     *          <td nowrap>The table constraint is not deferrable.</td>
-     *      </tr>
-     *  </table> <p>
-     *
-     * <li> The values of INITIALLY_DEFERRED have the following meanings: <p>
-     *
-     *  <table>
-     *      <tr>
-     *          <td nowrap>YES</td>
-     *          <td nowrap>The table constraint is initially deferred.</td>
-     *      </tr>
-     *      <tr>
-     *          <td nowrap>NO</td>
-     *          <td nowrap>The table constraint is initially immediate.</td>
-     *      </tr>
-     *  </table> <p>
+     *          YES : The constraint is deferrable.<br>
+     *          NO : The constraint is not deferrable.
+     *
+     * <li> The values of INITIALLY_DEFERRED have the following meanings: <br>
+     *
+     *          YES : The constraint is initially deferred.<br>
+     *          NO : The constraint is initially immediate.
      * </ol>
      *
      * @return Table
@@ -7731,10 +7667,10 @@ extends org.hsqldb.dbinfo.DatabaseInform
     }
 
     /**
-     * SQL:2008 VIEW<p>
+     * SQL:2008 VIEW
      *
      * The TRANSLATIONS view has one row for each translation between two
-     * character sets.<p>
+     * character sets.
      *
      */
     Table TRANSLATIONS(Session session, PersistentStore store) {
@@ -7779,6 +7715,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * <b>Definition:</b><p>
      *
+     * <pre>
      *      TRIGGER_CATALOG     VARCHAR ,
      *      TRIGGER_SCHEMA      VARCHAR ,
      *      TRIGGER_NAME        VARCHAR ,
@@ -7789,18 +7726,18 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * </pre>
      *
-     * <b>Description:</b> <p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of TRIGGER_CATALOG, TRIGGER_SCHEMA and
      *      TRIGGER_NAME are the catalog name, schema name and
-     *      identifier, respectively, of the trigger. <p>
+     *      identifier, respectively, of the trigger.
      * <li> The values of TABLE_CATALOG, TABLE_SCHEMA, TABLE_NAME, and
      *      COLUMN_NAME are the catalog name, schema name,
      *      identifier, and column name, respectively, of a column
-     *      reference in the trigger body.<>
+     *      reference in the trigger body.
      *
-     * <1i> Columns are reported only if the user or one of its roles is
+     * <li> Columns are reported only if the user or one of its roles is
      *      the authorization (owner) of the TRIGGER.
      *
      * </ol>
@@ -7899,6 +7836,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * <b>Definition:</b><p>
      *
+     * <pre>
      *      TRIGGER_CATALOG     VARCHAR ,
      *      TRIGGER_SCHEMA      VARCHAR ,
      *      TRIGGER_NAME        VARCHAR ,
@@ -7908,18 +7846,18 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * </pre>
      *
-     * <b>Description:</b> <p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of TRIGGER_CATALOG, TRIGGER_SCHEMA and TRIGGER_NAME
      *      are the catalog name, schema name and
-     *      identifier, respectively, of the TRIGGER.<p>
+     *      identifier, respectively, of the TRIGGER.
      * <li> The values of TABLE_CATALOG, TABLE_SCHEMA and
      *      TABLE_NAME are the catalog name, schema name and
      *      identifier, respectively, of the TABLE
      *      that is referenced. <p>
      *
-     * <1i> Referenced tables are reported only if the user or one of its roles is
+     * <li> Referenced tables are reported only if the user or one of its roles is
      *      the authorization (owner) of the TRIGGER.
      *
      * </ol>
@@ -8030,6 +7968,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * <b>Definition:</b><p>
      *
+     * <pre>
      *      TRIGGER_CATALOG     VARCHAR ,
      *      TRIGGER_SCHEMA      VARCHAR ,
      *      TRIGGER_NAME        VARCHAR ,
@@ -8039,18 +7978,18 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * </pre>
      *
-     * <b>Description:</b> <p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of TRIGGER_CATALOG, TRIGGER_SCHEMA and TRIGGER_NAME
      *      are the catalog name, schema name and
-     *      identifier, respectively, of the TRIGGER.<p>
+     *      identifier, respectively, of the TRIGGER.
      * <li> The values of SPECIFIC_CATALOG, SPECIFIC_SCHEMA and
      *      SPECIFIC_NAME are the catalog name, schema name,
      *      specific routine identifier, respectively, of the routine
      *      that is referenced. <p>
      *
-     * <1i> Referenced routines are reported only if the user or one of its roles is
+     * <li> Referenced routines are reported only if the user or one of its roles is
      *      the authorization (owner) of the TRIGGER.
      *
      * </ol>
@@ -8139,6 +8078,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * <b>Definition:</b><p>
      *
+     * <pre>
      *      TRIGGER_CATALOG     VARCHAR ,
      *      TRIGGER_SCHEMA      VARCHAR ,
      *      TRIGGER_NAME        VARCHAR ,
@@ -8148,18 +8088,18 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * </pre>
      *
-     * <b>Description:</b> <p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of TRIGGER_CATALOG, TRIGGER_SCHEMA and TRIGGER_NAME
      *      are the catalog name, schema name and
-     *      identifier, respectively, of the TRIGGER.<p>
+     *      identifier, respectively, of the TRIGGER.
      * <li> The values of SEQUENCE_CATALOG, SEQUENCE_SCHEMA and
      *      SEQUENCE_NAME are the catalog name, schema name and
      *      identifier, respectively, of the SEQUENCE
-     *      that is referenced. <p>
+     *      that is referenced.
      *
-     * <1i> Referenced sequences are reported only if the user or one of its roles is
+     * <li> Referenced sequences are reported only if the user or one of its roles is
      *      the authorization (owner) of the TRIGGER.
      *
      * </ol>
@@ -8249,6 +8189,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * <b>Definition:</b><p>
      *
+     * <pre>
      *      TRIGGER_CATALOG     VARCHAR ,
      *      TRIGGER_SCHEMA      VARCHAR ,
      *      TRIGGER_NAME        VARCHAR ,
@@ -8258,18 +8199,18 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * </pre>
      *
-     * <b>Description:</b> <p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of TRIGGER_CATALOG, TRIGGER_SCHEMA and TRIGGER_NAME
      *      are the catalog name, schema name and
-     *      identifier, respectively, of the TRIGGER.<p>
+     *      identifier, respectively, of the TRIGGER.
      * <li> The values of TABLE_CATALOG, TABLE_SCHEMA and
      *      TABLE_NAME are the catalog name, schema name and
      *      identifier, respectively, of the TABLE
-     *      that is referenced. <p>
+     *      that is referenced.
      *
-     * <1i> Referenced tables are reported only if the user or one of its roles is
+     * <li> Referenced tables are reported only if the user or one of its roles is
      *      the authorization (owner) of the TRIGGER.
      *
      * </ol>
@@ -8359,6 +8300,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * <b>Definition:</b><p>
      *
+     * <pre>
      *      TRIGGER_CATALOG               VARCHAR ,
      *      TRIGGER_SCHEMA                VARCHAR ,
      *      TRIGGER_NAME                  VARCHAR ,
@@ -8379,17 +8321,17 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * </pre>
      *
-     * <b>Description:</b> <p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of TRIGGER_CATALOG, TRIGGER_SCHEMA and TRIGGER_NAME
      *      are the catalog name, schema name and
-     *      identifier, respectively, of the TRIGGER.<p>
+     *      identifier, respectively, of the TRIGGER.
      * <li> The value of EVENT_MANUPULATION indicates for which action the
      *      trigger is fired: 'INSERT', 'UPDATE' or 'DELETE'.
      * <li> The values of EVENT_OBJECT_CATALOG, EVENT_OBJECT_SCHEMA and
      *      EVENT_OBJECT_NAME are the catalog name, schema name and
-     *      identifier, respectively, of the trigger TABLE. <p>
+     *      identifier, respectively, of the trigger TABLE.
      * <li> The value of ACTION_ORDER indicates the ordinal position of the
      *      trigger is firing event, among all the triggers of the same
      *      ACTION_ORIENTATION and ACTION_TIMING.
@@ -8411,7 +8353,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *      NEW ROW.
      * <li> The value of CREATED contains the timestamp of the creation of the
      *      trigger. Currently NULL.
-     * <1i> Triggers are reported only if the user or one of its roles has
+     * <li> Triggers are reported only if the user or one of its roles has
      *      some privilege on at least one column of the trigger table.
      * <li> The ACTION_CONDITION and ACTION_STATEMENT columns show the SQL only
      *      if the user or one of its roles is the authorization (owner) of the
@@ -8534,6 +8476,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * <b>Definition:</b><p>
      *
+     * <pre>
      *      TRIGGER_CATALOG            VARCHAR ,
      *      TRIGGER_SCHEMA             VARCHAR ,
      *      TRIGGER_NAME               VARCHAR ,
@@ -8543,12 +8486,12 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *
      * </pre>
      *
-     * <b>Description:</b> <p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of TRIGGER_CATALOG, TRIGGER_SCHEMA and TRIGGER_NAME
      *      are the catalog name, schema name and
-     *      identifier, respectively, of the TRIGGER.<p>
+     *      identifier, respectively, of the TRIGGER.
      * <li> The values of EVENT_OBJECT_CATALOG, EVENT_OBJECT_SCHEMA and
      *      EVENT_OBJECT_NAME are the catalog name, schema name and
      *      identifier, respectively, of the COLUMN
@@ -8650,7 +8593,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *      IS_GRANTABLE          VARCHAR
      * </pre>
      *
-     * <b>Description:</b> <p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of GRANTOR is the grantor of the privilege. The value of
@@ -8659,11 +8602,11 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * <li> The values of UDT_CATALOG, UDT_SCHEMA and
      *      UDT_NAME are the catalog name, schema name
      *      and identifier, respectively, of the user defined type
-     *      described. <p>
+     *      described.
      *
      * <li> The value of PRIVILEGE_TYPE is the type of the privilege, including,
      *      'USAGE'
-     *      The value IS_GRANTABLE is 'YES' if the privilege is grantable. <p>
+     *      The value IS_GRANTABLE is 'YES' if the privilege is grantable.
      * </ol>
      *
      * @return Table
@@ -8764,7 +8707,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * It effectively contains a representation of the usage privilege
      * descriptors. <p>
      *
-     * <b>Definition:</b> <p>
+     * <b>Definition:</b>
      *
      * <pre class="SqlCodeExample">
      * CREATE TABLE SYSTEM_USAGE_PRIVILEGES (
@@ -8786,61 +8729,53 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *      user or role who granted usage privileges on the object of the type
      *      identified by OBJECT_TYPE that is identified by OBJECT_CATALOG,
      *      OBJECT_SCHEMA, and OBJECT_NAME, to the user or role identified by the
-     *      value of GRANTEE for the usage privilege being described. <p>
+     *      value of GRANTEE for the usage privilege being described.
      *
      * <li> The value of GRANTEE is the &lt;authorization identifier&gt; of some
      *      user or role, or PUBLIC to indicate all users, to whom the usage
-     *      privilege being described is granted. <p>
+     *      privilege being described is granted.
      *
      * <li> The values of OBJECT_CATALOG, OBJECT_SCHEMA, and OBJECT_NAME are the
      *      catalog name, schema name, and identifier,
-     *      respectively, of the object to which the privilege applies. <p>
+     *      respectively, of the object to which the privilege applies.
      *
-     * <li> The values of OBJECT_TYPE have the following meanings: <p>
+     * <li> The values of OBJECT_TYPE have the following meanings:
      *
-     *      <table border cellpadding="3">
+     *      <table border="1"> <caption>Object Types </caption>
      *          <tr>
-     *              <td nowrap>DOMAIN</td>
-     *              <td nowrap>The object to which the privilege applies is
+     *              <td>DOMAIN</td>
+     *              <td>The object to which the privilege applies is
      *                         a domain.</td>
      *          <tr>
      *          <tr>
-     *              <td nowrap>CHARACTER SET</td>
-     *              <td nowrap>The object to which the privilege applies is a
+     *              <td>CHARACTER SET</td>
+     *              <td>The object to which the privilege applies is a
      *                         character set.</td>
      *          <tr>
      *          <tr>
-     *              <td nowrap>COLLATION</td>
-     *              <td nowrap>The object to which the privilege applies is a
+     *              <td>COLLATION</td>
+     *              <td>The object to which the privilege applies is a
      *                         collation.</td>
      *          <tr>
      *          <tr>
-     *              <td nowrap>TRANSLATION</td>
-     *              <td nowrap>The object to which the privilege applies is a
+     *              <td>TRANSLATION</td>
+     *              <td>The object to which the privilege applies is a
      *                         transliteration.</td>
      *          <tr>
      *          <tr>
-     *              <td nowrap>SEQUENCE</td>
-     *              <td nowrap>The object to which the privilege applies is a
+     *              <td>SEQUENCE</td>
+     *              <td>The object to which the privilege applies is a
      *                         sequence generator.</td>
      *          <tr>
-     *      </table> <p>
+     *      </table>
      *
-     * <li> The values of IS_GRANTABLE have the following meanings: <p>
+     * <li> The values of IS_GRANTABLE have the following meanings:<br>
      *
-     *      <table border cellpadding="3">
-     *          <tr>
-     *              <td nowrap>YES</td>
-     *              <td nowrap>The privilege being described was granted
-     *                         WITH GRANT OPTION and is thus grantable.</td>
-     *          <tr>
-     *          <tr>
-     *              <td nowrap>NO</td>
-     *              <td nowrap>The privilege being described was not granted
-     *                  WITH GRANT OPTION and is thus not grantable.</td>
-     *          <tr>
-     *      </table> <p>
-     * <ol>
+     *      YES : The privilege being described was granted
+     *                         WITH GRANT OPTION and is thus grantable.<br>
+     *      NO : The privilege being described was not granted
+     *                  WITH GRANT OPTION and is thus not grantable.
+     * </ol>
      *
      * @return Table
      */
@@ -8956,7 +8891,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * The USER_DEFINED_TYPES view has one row for each user defined type.
      * Only DICTINCT TYPE user defined types are currently supported. <p>
      *
-     * <b>Definition:</b> <p>
+     * <b>Definition:</b>
      *
      * <pre class="SqlCodeExample">
      *      VIEW_CATALOG    VARCHAR NULL,
@@ -8968,19 +8903,19 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *      COLUMN_NAME     VARCHAR NOT NULL,
      * </pre>
      *
-     * <b>Description:</b> <p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of VIEW_CATALOG, VIEW_SCHEMA, and VIEW_NAME are the
      *      catalog name, schema name, and identifier,
-     *      respectively, of the view being described. <p>
+     *      respectively, of the view being described.
      *
      * <li> The values of TABLE_CATALOG, TABLE_SCHEMA, TABLE_NAME, and
      *      COLUMN_NAME are the catalog name, schema name,
      *      table name, and column name, respectively, of a column
      *      of a table that is explicitly or implicitly referenced in the
      *      &lt;query expression&gt; of the view being described.
-     * <1i> Referenced routines are reported only if the user or one of its roles is
+     * <li> Referenced routines are reported only if the user or one of its roles is
      *      the authorization (owner) of the referenced ROUTINE
      * </ol>
      *
@@ -9166,7 +9101,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * table that is explicitly or implicitly referenced in the
      * &lt;query expression&gt; of the view being described. <p>
      *
-     * <b>Definition:</b> <p>
+     * <b>Definition:</b>
      *
      * <pre class="SqlCodeExample">
      *      VIEW_CATALOG    VARCHAR NULL,
@@ -9178,19 +9113,19 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *      COLUMN_NAME     VARCHAR NOT NULL,
      * </pre>
      *
-     * <b>Description:</b> <p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of VIEW_CATALOG, VIEW_SCHEMA, and VIEW_NAME are the
      *      catalog name, schema name, and identifier,
-     *      respectively, of the view being described. <p>
+     *      respectively, of the view being described.
      *
      * <li> The values of TABLE_CATALOG, TABLE_SCHEMA, TABLE_NAME, and
      *      COLUMN_NAME are the catalog name, schema name,
      *      table name, and column name, respectively, of a column
      *      of a table that is explicitly or implicitly referenced in the
      *      &lt;query expression&gt; of the view being described.
-     * <1i> Referenced routines are reported only if the user or one of its roles is
+     * <li> Referenced routines are reported only if the user or one of its roles is
      *      the authorization (owner) of the referenced ROUTINE
      * </ol>
      *
@@ -9300,7 +9235,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * The VIEW_PERIOD_USAGE view has one row for each period contained in the
      * &lt;query expression&gt; of a view. <p>
      *
-     * <b>Definition</b><p>
+     * <b>Definition</b>
      *
      * <pre class="SqlCodeExample">
      *      VIEW_CATALOG    VARCHAR NOT NULL,
@@ -9312,18 +9247,18 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *      PERIOD_NAME     VARCHAR NOT NULL,
      * </pre>
      *
-     * <b>Description:</b><p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of VIEW_CATALOG, VIEW_SCHEMA, and VIEW_NAME are the
      *      catalog name, schema name, and identifier,
-     *      respectively, of the view being described. <p>
+     *      respectively, of the view being described.
      *
      * <li> The values of TABLE_CATALOG, TABLE_SCHEMA, and TABLE_NAME are the
      *      catalog name, schema name, and identifier,
      *      respectively, of a table containing the period that is referenced in
      *      the &lt;query expression&gt; of the view being described.
-     * <1i> Referenced periods are reported only if the user or one of its roles is
+     * <li> Referenced periods are reported only if the user or one of its roles is
      *      the authorization (owner) of the containing TABLE
      * </ol>
      *
@@ -9423,7 +9358,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * or a &lt;static method invocation&gt; contained in a &lt;view
      * definition&gt;. <p>
      *
-     * <b>Definition</b><p>
+     * <b>Definition</b>
      *
      * <pre class="SqlCodeExample">
      *      TABLE_CATALOG       VARCHAR NULL,
@@ -9434,7 +9369,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *      SPECIFIC_NAME       VARCHAR NOT NULL,
      * </pre>
      *
-     * <b>Description</b><p>
+     * <b>Description</b>
      *
      * <ol>
      * <li> The values of TABLE_CATALOG, TABLE_SCHEMA, and TABLE_NAME are the
@@ -9444,7 +9379,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * <li> The values of SPECIFIC_CATALOG, SPECIFIC_SCHEMA, and SPECIFIC_NAME are
      *      the catalog name, schema name, and identifier,
      *      respectively, of the specific name of R.
-     * <1i> Referenced routines are reported only if the user or one of its roles is
+     * <li> Referenced routines are reported only if the user or one of its roles is
      *      the authorization (owner) of the referenced ROUTINE.
      * </ol>
      *
@@ -9537,7 +9472,7 @@ extends org.hsqldb.dbinfo.DatabaseInform
      * by a &lt;table name&gt; simply contained in a &lt;table reference&gt;
      * that is contained in the &lt;query expression&gt; of a view. <p>
      *
-     * <b>Definition</b><p>
+     * <b>Definition</b>
      *
      * <pre class="SqlCodeExample">
      *      VIEW_CATALOG    VARCHAR NULL,
@@ -9548,19 +9483,19 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *      TABLE_NAME      VARCHAR NULL,
      * </pre>
      *
-     * <b>Description:</b><p>
+     * <b>Description:</b>
      *
      * <ol>
      * <li> The values of VIEW_CATALOG, VIEW_SCHEMA, and VIEW_NAME are the
      *      catalog name, schema name, and identifier,
-     *      respectively, of the view being described. <p>
+     *      respectively, of the view being described.
      *
      * <li> The values of TABLE_CATALOG, TABLE_SCHEMA, and TABLE_NAME are the
      *      catalog name, schema name, and identifier,
      *      respectively, of a table identified by a &lt;table name&gt;
      *      simply contained in a &lt;table reference&gt; that is contained in
      *      the &lt;query expression&gt; of the view being described.
-     * <1i> Referenced tables are reported only if the user or one of its roles is
+     * <li> Referenced tables are reported only if the user or one of its roles is
      *      the authorization (owner) of the referenced TABLE
      * </ol>
      *
@@ -9803,36 +9738,28 @@ extends org.hsqldb.dbinfo.DatabaseInform
      *      IS_GRANTABLE  VARCHAR     the character representation of the
      * </pre>
      *
-     * <b>Description</b><p>
+     * <b>Description</b>
      *
      * <ol>
      *      <li>The value of ROLE_NAME is the &lt;role name&gt; of some
      *          &lt;role granted&gt; by the &lt;grant role statement&gt; or
-     *          the &lt;role name&gt; of a &lt;role definition&gt;. <p>
+     *          the &lt;role name&gt; of a &lt;role definition&gt;.
      *
      *      <li>The value of GRANTEE is an &lt;authorization identifier&gt;,
      *          possibly PUBLIC, or &lt;role name&gt; specified as a
      *          &lt;grantee&gt; contained in a &lt;grant role statement&gt;,
      *          or the &lt;authorization identifier&gt; of the current
-     *          SQLsession when the &lt;role definition&gt; is executed. <p>
+     *          SQLsession when the &lt;role definition&gt; is executed.
      *
      *      <li>The value of GRANTOR is the &lt;authorization identifier&gt;
      *          of the user or role who granted the role identified by
      *          ROLE_NAME to the user or role identified by the value of
-     *          GRANTEE. <p>
+     *          GRANTEE.
      *
-     *      <li>The values of IS_GRANTABLE have the following meanings:<p>
+     *      <li>The values of IS_GRANTABLE have the following meanings:<br>
      *
-     *      <table border cellpadding="3">
-     *          <tr>
-     *              <td nowrap>YES</td>
-     *              <td nowrap>The described role is grantable.</td>
-     *          <tr>
-     *          <tr>
-     *              <td nowrap>NO</td>
-     *              <td nowrap>The described role is not grantable.</td>
-     *          <tr>
-     *      </table> <p>
+     *          YES : The described role is grantable.<br>
+     *          NO : The described role is not grantable.
      * </ol>
      *
      * @return Table
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/dbinfo/DatabaseInformation.java 2.7.0-1/hsqldb/src/org/hsqldb/dbinfo/DatabaseInformation.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/dbinfo/DatabaseInformation.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/dbinfo/DatabaseInformation.java	2022-06-08 08:04:08.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -54,7 +54,7 @@ import org.hsqldb.persist.PersistentStor
  * DatabaseInformation implementations. <p>
  *
  * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
- * @version 2.5.1
+ * @version 2.7.0
  * @since 1.7.2
  */
 public class DatabaseInformation {
@@ -71,103 +71,104 @@ public class DatabaseInformation {
     static final int SYSTEM_TABLES            = 8;
     static final int SYSTEM_TABLETYPES        = 9;
     static final int SYSTEM_TYPEINFO          = 10;
-    static final int SYSTEM_UDTS              = 11;
-    static final int SYSTEM_USERS             = 12;    //-- ref in SqlFile only
-    static final int SYSTEM_VERSIONCOLUMNS    = 13;    //-- returns autogenerated columns
-    static final int SYSTEM_SEQUENCES = 14;            //-- same as SEQUENCES
+    static final int SYSTEM_UDTATTRIBUTES     = 11;
+    static final int SYSTEM_UDTS              = 12;
+    static final int SYSTEM_USERS             = 13;    //-- ref in SqlFile only
+    static final int SYSTEM_VERSIONCOLUMNS    = 14;    //-- returns autogenerated columns
+    static final int SYSTEM_SEQUENCES = 15;            //-- same as SEQUENCES
 
     // HSQLDB-specific
-    static final int SYSTEM_CACHEINFO             = 15;
-    static final int SYSTEM_COLUMN_SEQUENCE_USAGE = 16;
-    static final int SYSTEM_COMMENTS              = 17;
-    static final int SYSTEM_CONNECTION_PROPERTIES = 18;
-    static final int SYSTEM_INDEXSTATS            = 19;
-    static final int SYSTEM_KEY_INDEX_USAGE       = 20;
-    static final int SYSTEM_PROPERTIES            = 21;
-    static final int SYSTEM_SESSIONINFO           = 22;
-    static final int SYSTEM_SESSIONS              = 23;
-    static final int SYSTEM_TABLESTATS            = 24;
-    static final int SYSTEM_TEXTTABLES            = 25;
-    static final int SYSTEM_SYNONYMS              = 26;
+    static final int SYSTEM_CACHEINFO             = 16;
+    static final int SYSTEM_COLUMN_SEQUENCE_USAGE = 17;
+    static final int SYSTEM_COMMENTS              = 18;
+    static final int SYSTEM_CONNECTION_PROPERTIES = 19;
+    static final int SYSTEM_INDEXSTATS            = 20;
+    static final int SYSTEM_KEY_INDEX_USAGE       = 21;
+    static final int SYSTEM_PROPERTIES            = 22;
+    static final int SYSTEM_SESSIONINFO           = 23;
+    static final int SYSTEM_SESSIONS              = 24;
+    static final int SYSTEM_TABLESTATS            = 25;
+    static final int SYSTEM_TEXTTABLES            = 26;
+    static final int SYSTEM_SYNONYMS              = 27;
 
     // SQL 200n tables
-    static final int ADMINISTRABLE_ROLE_AUTHORIZATIONS = 27;
-    static final int APPLICABLE_ROLES                  = 28;
-    static final int ASSERTIONS                        = 29;
-    static final int AUTHORIZATIONS                    = 30;
-    static final int CHARACTER_SETS                    = 31;
-    static final int CHECK_CONSTRAINT_ROUTINE_USAGE    = 32;
-    static final int CHECK_CONSTRAINTS                 = 33;
-    static final int COLLATIONS                        = 34;
-    static final int COLUMN_COLUMN_USAGE               = 35;
-    static final int COLUMN_DOMAIN_USAGE               = 36;
-    static final int COLUMN_PRIVILEGES                 = 37;
-    static final int COLUMN_UDT_USAGE                  = 38;
-    static final int COLUMNS                           = 39;
-    static final int CONSTRAINT_COLUMN_USAGE           = 40;
-    static final int CONSTRAINT_PERIOD_USAGE           = 41;
-    static final int CONSTRAINT_TABLE_USAGE            = 42;
-    static final int DATA_TYPE_PRIVILEGES              = 43;
-    static final int DOMAIN_CONSTRAINTS                = 44;
-    static final int DOMAINS                           = 45;
-    static final int ELEMENT_TYPES                     = 46;
-    static final int ENABLED_ROLES                     = 47;
-    static final int INFORMATION_SCHEMA_CATALOG_NAME   = 48;
-    static final int JAR_JAR_USAGE                     = 49;
-    static final int JARS                              = 50;
-    static final int KEY_COLUMN_USAGE                  = 51;
-    static final int KEY_PERIOD_USAGE                  = 52;
-    static final int METHOD_SPECIFICATIONS             = 53;
-    static final int MODULE_COLUMN_USAGE               = 54;
-    static final int MODULE_PRIVILEGES                 = 55;
-    static final int MODULE_TABLE_USAGE                = 56;
-    static final int MODULES                           = 57;
-    static final int PARAMETERS                        = 58;
-    static final int PERIODS                           = 59;
-    static final int REFERENTIAL_CONSTRAINTS           = 60;
-    static final int ROLE_AUTHORIZATION_DESCRIPTORS    = 61;
-    static final int ROLE_COLUMN_GRANTS                = 62;
-    static final int ROLE_MODULE_GRANTS                = 63;
-    static final int ROLE_ROUTINE_GRANTS               = 64;
-    static final int ROLE_TABLE_GRANTS                 = 65;
-    static final int ROLE_UDT_GRANTS                   = 66;
-    static final int ROLE_USAGE_GRANTS                 = 67;
-    static final int ROUTINE_COLUMN_USAGE              = 68;
-    static final int ROUTINE_JAR_USAGE                 = 69;
-    static final int ROUTINE_PERIOD_USAGE              = 70;
-    static final int ROUTINE_PRIVILEGES                = 71;
-    static final int ROUTINE_ROUTINE_USAGE             = 72;
-    static final int ROUTINE_SEQUENCE_USAGE            = 73;
-    static final int ROUTINE_TABLE_USAGE               = 74;
-    static final int ROUTINES                          = 75;
-    static final int SCHEMATA                          = 76;
-    static final int SEQUENCES                         = 77;
-    static final int SQL_FEATURES                      = 78;
-    static final int SQL_IMPLEMENTATION_INFO           = 79;
-    static final int SQL_PACKAGES                      = 80;
-    static final int SQL_PARTS                         = 81;
-    static final int SQL_SIZING                        = 82;
-    static final int SQL_SIZING_PROFILES               = 83;
-    static final int TABLE_CONSTRAINTS                 = 84;
-    static final int TABLE_PRIVILEGES                  = 85;
-    static final int TABLES                            = 86;
-    static final int TRANSLATIONS                      = 87;
-    static final int TRIGGER_COLUMN_USAGE              = 88;
-    static final int TRIGGER_PERIOD_USAGE              = 89;
-    static final int TRIGGER_ROUTINE_USAGE             = 90;
-    static final int TRIGGER_SEQUENCE_USAGE            = 91;
-    static final int TRIGGER_TABLE_USAGE               = 92;
-    static final int TRIGGERED_UPDATE_COLUMNS          = 93;
-    static final int TRIGGERS                          = 94;
-    static final int TYPE_JAR_USAGE                    = 95;
-    static final int UDT_PRIVILEGES                    = 96;
-    static final int USAGE_PRIVILEGES                  = 97;
-    static final int USER_DEFINED_TYPES                = 98;
-    static final int VIEW_COLUMN_USAGE                 = 99;
-    static final int VIEW_PERIOD_USAGE                 = 100;
-    static final int VIEW_ROUTINE_USAGE                = 101;
-    static final int VIEW_TABLE_USAGE                  = 102;
-    static final int VIEWS                             = 103;
+    static final int ADMINISTRABLE_ROLE_AUTHORIZATIONS = 28;
+    static final int APPLICABLE_ROLES                  = 29;
+    static final int ASSERTIONS                        = 30;
+    static final int AUTHORIZATIONS                    = 31;
+    static final int CHARACTER_SETS                    = 32;
+    static final int CHECK_CONSTRAINT_ROUTINE_USAGE    = 33;
+    static final int CHECK_CONSTRAINTS                 = 34;
+    static final int COLLATIONS                        = 35;
+    static final int COLUMN_COLUMN_USAGE               = 36;
+    static final int COLUMN_DOMAIN_USAGE               = 37;
+    static final int COLUMN_PRIVILEGES                 = 38;
+    static final int COLUMN_UDT_USAGE                  = 39;
+    static final int COLUMNS                           = 40;
+    static final int CONSTRAINT_COLUMN_USAGE           = 41;
+    static final int CONSTRAINT_PERIOD_USAGE           = 42;
+    static final int CONSTRAINT_TABLE_USAGE            = 43;
+    static final int DATA_TYPE_PRIVILEGES              = 44;
+    static final int DOMAIN_CONSTRAINTS                = 45;
+    static final int DOMAINS                           = 46;
+    static final int ELEMENT_TYPES                     = 47;
+    static final int ENABLED_ROLES                     = 48;
+    static final int INFORMATION_SCHEMA_CATALOG_NAME   = 49;
+    static final int JAR_JAR_USAGE                     = 50;
+    static final int JARS                              = 51;
+    static final int KEY_COLUMN_USAGE                  = 52;
+    static final int KEY_PERIOD_USAGE                  = 53;
+    static final int METHOD_SPECIFICATIONS             = 54;
+    static final int MODULE_COLUMN_USAGE               = 55;
+    static final int MODULE_PRIVILEGES                 = 56;
+    static final int MODULE_TABLE_USAGE                = 57;
+    static final int MODULES                           = 58;
+    static final int PARAMETERS                        = 59;
+    static final int PERIODS                           = 60;
+    static final int REFERENTIAL_CONSTRAINTS           = 61;
+    static final int ROLE_AUTHORIZATION_DESCRIPTORS    = 62;
+    static final int ROLE_COLUMN_GRANTS                = 63;
+    static final int ROLE_MODULE_GRANTS                = 64;
+    static final int ROLE_ROUTINE_GRANTS               = 65;
+    static final int ROLE_TABLE_GRANTS                 = 66;
+    static final int ROLE_UDT_GRANTS                   = 67;
+    static final int ROLE_USAGE_GRANTS                 = 68;
+    static final int ROUTINE_COLUMN_USAGE              = 69;
+    static final int ROUTINE_JAR_USAGE                 = 70;
+    static final int ROUTINE_PERIOD_USAGE              = 71;
+    static final int ROUTINE_PRIVILEGES                = 72;
+    static final int ROUTINE_ROUTINE_USAGE             = 73;
+    static final int ROUTINE_SEQUENCE_USAGE            = 74;
+    static final int ROUTINE_TABLE_USAGE               = 75;
+    static final int ROUTINES                          = 76;
+    static final int SCHEMATA                          = 77;
+    static final int SEQUENCES                         = 78;
+    static final int SQL_FEATURES                      = 79;
+    static final int SQL_IMPLEMENTATION_INFO           = 80;
+    static final int SQL_PACKAGES                      = 81;
+    static final int SQL_PARTS                         = 82;
+    static final int SQL_SIZING                        = 83;
+    static final int SQL_SIZING_PROFILES               = 84;
+    static final int TABLE_CONSTRAINTS                 = 85;
+    static final int TABLE_PRIVILEGES                  = 86;
+    static final int TABLES                            = 87;
+    static final int TRANSLATIONS                      = 88;
+    static final int TRIGGER_COLUMN_USAGE              = 89;
+    static final int TRIGGER_PERIOD_USAGE              = 90;
+    static final int TRIGGER_ROUTINE_USAGE             = 91;
+    static final int TRIGGER_SEQUENCE_USAGE            = 92;
+    static final int TRIGGER_TABLE_USAGE               = 93;
+    static final int TRIGGERED_UPDATE_COLUMNS          = 94;
+    static final int TRIGGERS                          = 95;
+    static final int TYPE_JAR_USAGE                    = 96;
+    static final int UDT_PRIVILEGES                    = 97;
+    static final int USAGE_PRIVILEGES                  = 98;
+    static final int USER_DEFINED_TYPES                = 99;
+    static final int VIEW_COLUMN_USAGE                 = 100;
+    static final int VIEW_PERIOD_USAGE                 = 101;
+    static final int VIEW_ROUTINE_USAGE                = 102;
+    static final int VIEW_TABLE_USAGE                  = 103;
+    static final int VIEWS                             = 104;
 
     /** system table names strictly in order of their ids */
     static final String[] sysTableNames = {
@@ -182,6 +183,7 @@ public class DatabaseInformation {
         "SYSTEM_TABLES",                                         //
         "SYSTEM_TABLETYPES",                                     //
         "SYSTEM_TYPEINFO",                                       //
+        "SYSTEM_UDTATTRIBUTES",                                           //
         "SYSTEM_UDTS",                                           //
         "SYSTEM_USERS",                                          //
         "SYSTEM_VERSIONCOLUMNS",                                 //
@@ -281,7 +283,7 @@ public class DatabaseInformation {
         "VIEWS",                                                 //
     };
 
-    /** Map: table name => table id */
+    /** Map: table name : table id */
     static final IntValueHashMap sysTableNamesMap;
 
     static {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/dbinfo/DatabaseInformationMain.java 2.7.0-1/hsqldb/src/org/hsqldb/dbinfo/DatabaseInformationMain.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/dbinfo/DatabaseInformationMain.java	2021-02-19 15:04:08.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/dbinfo/DatabaseInformationMain.java	2022-06-08 09:17:04.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -56,6 +56,7 @@ import org.hsqldb.lib.WrapperIterator;
 import org.hsqldb.map.ValuePool;
 import org.hsqldb.persist.HsqlDatabaseProperties;
 import org.hsqldb.persist.HsqlProperties;
+import org.hsqldb.persist.HsqlProperties.PropertyMeta;
 import org.hsqldb.persist.PersistentStore;
 import org.hsqldb.rights.GrantConstants;
 import org.hsqldb.rights.Grantee;
@@ -69,8 +70,6 @@ import org.hsqldb.types.NumberType;
 import org.hsqldb.types.Type;
 import org.hsqldb.types.Types;
 
-/* $Id: DatabaseInformationMain.java 6303 2021-02-19 16:04:03Z fredt $ */
-
 // fredt@users - 1.7.2 - structural modifications to allow inheritance
 // campbell-burnet@users - 1.7.2 - 20020225
 // - factored out all reusable code into DIXXX support classes
@@ -143,7 +142,7 @@ import org.hsqldb.types.Types;
  * (fredt@users) <p>
  * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 1.7.2
  */
 class DatabaseInformationMain extends DatabaseInformation {
@@ -341,6 +340,9 @@ class DatabaseInformationMain extends Da
             case SYSTEM_USERS :
                 return SYSTEM_USERS(session, store);
 
+            case SYSTEM_UDTATTRIBUTES :
+                return SYSTEM_UDTATTRIBUTES(session, store);
+
             case SYSTEM_UDTS :
                 return SYSTEM_UDTS(session, store);
 
@@ -366,7 +368,7 @@ class DatabaseInformationMain extends Da
 
     /**
      * One time initialisation of instance attributes
-     * at construction time. <p>
+     * at construction time.
      *
      */
     protected final void init(Session session) {
@@ -413,7 +415,7 @@ class DatabaseInformationMain extends Da
      * @return true if the table is accessible, else false
      * @param object the schmea object for which to check accessibility
      */
-    private final boolean isAccessible(Session session, SchemaObject object) {
+    private boolean isAccessible(Session session, SchemaObject object) {
         return session.getGrantee().isAccessible(object);
     }
 
@@ -425,9 +427,7 @@ class DatabaseInformationMain extends Da
      */
     protected final Table createBlankTable(HsqlName name) {
 
-        Table table = new Table(database, name, TableBase.INFO_SCHEMA_TABLE);
-
-        return table;
+        return new Table(database, name, TableBase.INFO_SCHEMA_TABLE);
     }
 
     /**
@@ -498,7 +498,7 @@ class DatabaseInformationMain extends Da
      *
      * Each row describes a single column of the best row identifier column
      * set for a particular table.  Each row has the following
-     * columns: <p>
+     * columns:
      *
      * <pre class="SqlCodeExample">
      * SCOPE          SMALLINT  scope of applicability
@@ -540,7 +540,7 @@ class DatabaseInformationMain extends Da
      *
      * <b>DEFINTIONS:</b>  <p>
      *
-     * <b>Alternate key</b> <p>
+     * <b>Alternate key</b>
      *
      *  <UL>
      *   <LI> An attribute of a table that, by virtue of its having a set of
@@ -550,7 +550,7 @@ class DatabaseInformationMain extends Da
      *        primary key on those same columns.
      *  </UL> <p>
      *
-     * <b>Column set performance ranking</b> <p>
+     * <b>Column set performance ranking</b>
      *
      *  <UL>
      *  <LI> The ranking of the expected average performance w.r.t a subset of
@@ -567,7 +567,7 @@ class DatabaseInformationMain extends Da
      * <b>Rules:</b> <p>
      *
      * Given the above definitions, the rules currently in effect for reporting
-     * best row identifier are as follows, in order of precedence: <p>
+     * best row identifier are as follows, in order of precedence:
      *
      * <OL>
      * <LI> if the table under consideration has a primary key constraint, then
@@ -591,14 +591,14 @@ class DatabaseInformationMain extends Da
      *      candidate column sets. If there exists a tie for lowest non-zero
      *      count of columns having a not null constraint, then the columns
      *      of the first such encountered candidate set are reported. Each
-     *      row has its IN_KEY column set to FALSE. <p>
+     *      row has its IN_KEY column set to FALSE.
      *
      * <LI> Finally, if the set of candidate column sets in 3.) is the empty,
      *      then no column set is reported for the table under consideration.
      * </OL> <p>
      *
      * The scope reported for a best row identifier column set is determined
-     * thus: <p>
+     * thus:
      *
      * <OL>
      * <LI> if the database containing the table under consideration is in
@@ -771,7 +771,7 @@ class DatabaseInformationMain extends Da
      * visible columns of all accessible tables defined
      * within this database.<p>
      *
-     * Each row is a column description with the following columns: <p>
+     * Each row is a column description with the following columns:
      *
      * <pre class="SqlCodeExample">
      * TABLE_CAT         VARCHAR   table catalog
@@ -804,7 +804,7 @@ class DatabaseInformationMain extends Da
      *
      * @return a <code>Table</code> object describing the
      *        visible columns of all accessible
-     *        tables defined within this database.<p>
+     *        tables defined within this database.
      */
     final Table SYSTEM_COLUMNS(Session session, PersistentStore store) {
 
@@ -1025,7 +1025,7 @@ class DatabaseInformationMain extends Da
      * the columns of the referenced tables.<p>
      *
      * Each row is a foreign key column description with the following
-     * columns: <p>
+     * columns:
      *
      * <pre class="SqlCodeExample">
      * PKTABLE_CAT   VARCHAR   referenced table catalog
@@ -1227,7 +1227,7 @@ class DatabaseInformationMain extends Da
      * within this database.<p>
      *
      * Each row is an index column description with the following
-     * columns: <p>
+     * columns:
      *
      * <pre class="SqlCodeExample">
      * TABLE_CAT        VARCHAR   table's catalog
@@ -1418,7 +1418,7 @@ class DatabaseInformationMain extends Da
      * this database. <p>
      *
      * Each row is a PRIMARY KEY column description with the following
-     * columns: <p>
+     * columns:
      *
      * <pre class="SqlCodeExample">
      * TABLE_CAT   VARCHAR   table catalog
@@ -1528,7 +1528,7 @@ class DatabaseInformationMain extends Da
      * routines defined within this database.<p>
      *
      * Each row is a procedure column description with the following
-     * columns: <p>
+     * columns:
      *
      * <pre class="SqlCodeExample">
      * PROCEDURE_CAT   VARCHAR   routine catalog
@@ -1777,7 +1777,7 @@ class DatabaseInformationMain extends Da
      * routines (both functions and procedures) defined within this database.<p>
      *
      * Each row is a procedure description with the following
-     * columns: <p>
+     * columns:
      *
      * <pre class="SqlCodeExample">
      * PROCEDURE_CAT     VARCHAR   catalog in which routine is defined
@@ -1888,13 +1888,14 @@ class DatabaseInformationMain extends Da
      * getClientInfoProperties
      *
      * @return Result
-     *
-     * <li><b>NAME</b> String=> The name of the client info property<br>
-     * <li><b>MAX_LEN</b> int=> The maximum length of the value for the property<br>
-     * <li><b>DEFAULT_VALUE</b> String=> The default value of the property<br>
-     * <li><b>DESCRIPTION</b> String=> A description of the property.  This will typically
+     * <ul>
+     * <li><b>NAME</b> String : The name of the client info property<br>
+     * <li><b>MAX_LEN</b> int : The maximum length of the value for the property<br>
+     * <li><b>DEFAULT_VALUE</b> String : The default value of the property<br>
+     * <li><b>DESCRIPTION</b> String : A description of the property.  This will typically
      *                                                  contain information as to where this property is
      *                                                  stored in the database.
+     * </ul>
      */
     final Table SYSTEM_CONNECTION_PROPERTIES(Session session,
             PersistentStore store) {
@@ -1926,30 +1927,17 @@ class DatabaseInformationMain extends Da
         final int imax_len       = 1;
         final int idefault_value = 2;
         final int idescription   = 3;
-        Iterator  it = HsqlDatabaseProperties.getPropertiesMetaIterator();
+        Iterator  it = HsqlDatabaseProperties.getUrlUserConnectionProperties();
 
         while (it.hasNext()) {
-            Object[] meta = (Object[]) it.next();
-            int propType =
-                ((Integer) meta[HsqlProperties.indexType]).intValue();
-
-            if (propType == HsqlDatabaseProperties.FILE_PROPERTY) {
-                if (HsqlDatabaseProperties.hsqldb_readonly.equals(
-                        meta[HsqlProperties.indexName]) || HsqlDatabaseProperties
-                            .hsqldb_files_readonly.equals(
-                                meta[HsqlProperties.indexName])) {}
-                else {
-                    continue;
-                }
-            } else if (propType != HsqlDatabaseProperties.SQL_PROPERTY) {
-                continue;
-            }
+            PropertyMeta meta     = (PropertyMeta) it.next();
+            int          propType = meta.propType;
 
             row = t.getEmptyRowData();
 
-            Object def = meta[HsqlProperties.indexDefaultValue];
+            Object def = meta.propDefaultValue;
 
-            row[iname]          = meta[HsqlProperties.indexName];
+            row[iname]          = meta.propName;
             row[imax_len]       = ValuePool.getInt(8);
             row[idefault_value] = def == null ? null
                                               : def.toString();
@@ -2180,7 +2168,7 @@ class DatabaseInformationMain extends Da
      * defined within this database. <p>
      *
      * Each row is a schema description with the following
-     * columns: <p>
+     * columns:
      *
      * <pre class="SqlCodeExample">
      * TABLE_SCHEM      VARCHAR   simple schema name
@@ -2244,7 +2232,7 @@ class DatabaseInformationMain extends Da
      * Retrieves a <code>Table</code> object describing the accessible
      * tables defined within this database. <p>
      *
-     * Each row is a table description with the following columns: <p>
+     * Each row is a table description with the following columns:
      *
      * <pre class="SqlCodeExample">
      * TABLE_CAT                 VARCHAR   table catalog
@@ -2384,29 +2372,26 @@ class DatabaseInformationMain extends Da
      * available in this database. <p>
      *
      * In general, the range of values that may be commonly encountered across
-     * most DBMS implementations is: <p>
+     * most DBMS implementations is:
      *
      * <UL>
-     *   <LI><FONT color='#FF00FF'>"TABLE"</FONT>
-     *   <LI><FONT color='#FF00FF'>"VIEW"</FONT>
-     *   <LI><FONT color='#FF00FF'>"SYSTEM TABLE"</FONT>
-     *   <LI><FONT color='#FF00FF'>"GLOBAL TEMPORARY"</FONT>
-     *   <LI><FONT color='#FF00FF'>"LOCAL TEMPORARY"</FONT>
-     *   <LI><FONT color='#FF00FF'>"ALIAS"</FONT>
-     *   <LI><FONT color='#FF00FF'>"SYNONYM"</FONT>
+     *   <li>"TABLE"
+     *   <li>"VIEW"
+     *   <li>"SYSTEM TABLE"
+     *   <li>"GLOBAL TEMPORARY"
+     *   <li>"LOCAL TEMPORARY"
+     *   <li>"ALIAS"
+     *   <li>"SYNONYM"
      * </UL> <p>
      *
-     * As of HSQLDB 1.7.2, the engine supports and thus this method reports
-     * only a subset of the range above: <p>
+     * This method reports the following from the range above:
      *
      * <UL>
-     *   <LI><FONT color='#FF00FF'>"TABLE"</FONT>
-     *    (HSQLDB MEMORY, CACHED and TEXT tables)
-     *   <LI><FONT color='#FF00FF'>"VIEW"</FONT>  (Views)
-     *   <LI><FONT color='#FF00FF'>"SYSTEM TABLE"</FONT>
-     *    (The tables generated by this object)
-     *   <LI><FONT color='#FF00FF'>"GLOBAL TEMPORARY"</FONT>
-     *    (HSQLDB TEMP and TEMP TEXT tables)
+     *   <LI>"TABLE" (HSQLDB MEMORY, CACHED and TEXT tables)
+     *   <LI>"VIEW"  (Views)
+     *   <LI>"SYSTEM TABLE" (INFORMATION_SCHEMA views)
+     *   <LI>"GLOBAL TEMPORAR" (GLOBAL TEMORARY and TEMP TEXT tables)
+     *   <LI>"LOCAL TEMPORARY" (the session-declared LOCAL TEMPORARY tables)
      * </UL> <p>
      *
      * @return a <code>Table</code> object describing the table types
@@ -2453,9 +2438,9 @@ class DatabaseInformationMain extends Da
      * TYPE_NAME          VARCHAR   the canonical name for DDL statements.
      * DATA_TYPE          SMALLINT  data type code from DITypes.
      * PRECISION          INTEGER   max column size.
-     *                              number => max precision.
-     *                              character => max characters.
-     *                              datetime => max chars incl. frac. component.
+     *                              number  : max precision.
+     *                              character  : max characters.
+     *                              datetime  : max chars incl. frac. component.
      * LITERAL_PREFIX     VARCHAR   char(s) prefixing literal of this type.
      * LITERAL_SUFFIX     VARCHAR   char(s) terminating literal of this type.
      * CREATE_PARAMS      VARCHAR   Localized syntax-order list of domain
@@ -2594,8 +2579,8 @@ class DatabaseInformationMain extends Da
 
             if (type.isBinaryType() || type.isCharacterType()
                     || type.isDateTimeType() || type.isIntervalType()) {
-                row[iliteral_prefix] = "\'";
-                row[iliteral_suffix] = "\'";
+                row[iliteral_prefix] = "'";
+                row[iliteral_suffix] = "'";
             }
 
             if (type.acceptsPrecision() && type.acceptsScale()) {
@@ -2653,23 +2638,108 @@ class DatabaseInformationMain extends Da
 
     /**
      * Retrieves a <code>Table</code> object describing the accessible
+     * attributes of the accessible user-defined type (UDT) objects
+     * defined within this database. <p>
+     *
+     * This description does not contain inherited attributes. <p>
+     *
+     * Each row is a user-defined type attributes description with the
+     * following columns:
+     *
+     * <pre class="SqlCodeExample">
+     * TYPE_CAT          VARCHAR   type catalog
+     * TYPE_SCHEM        VARCHAR   type schema
+     * TYPE_NAME         VARCHAR   type name
+     * ATTR_NAME         VARCHAR   attribute name
+     * DATA_TYPE         SMALLINT  attribute's SQL type from DITypes
+     * ATTR_TYPE_NAME    VARCHAR   UDT: fully qualified type name
+     *                            REF: fully qualified type name of target type of
+     *                            the reference type.
+     * ATTR_SIZE         INTEGER   column size.
+     *                            char or date types  : maximum number of characters;
+     *                            numeric or decimal types  : precision.
+     * DECIMAL_DIGITS    INTEGER   # of fractional digits (scale) of number type
+     * NUM_PREC_RADIX    INTEGER   Radix of number type
+     * NULLABLE          INTEGER   whether NULL is allowed
+     * REMARKS           VARCHAR   comment describing attribute
+     * ATTR_DEF          VARCHAR   default attribute value
+     * SQL_DATA_TYPE     INTEGER   expected value of SQL CLI SQL_DESC_TYPE in the SQLDA
+     * SQL_DATETIME_SUB  INTEGER   DATETIME/INTERVAL  : datetime/interval subcode
+     * CHAR_OCTET_LENGTH INTEGER   for char types:  max bytes in column
+     * ORDINAL_POSITION  INTEGER   index of column in table (starting at 1)
+     * IS_NULLABLE       VARCHAR   "NO"  : strictly no NULL values;
+     *                             "YES"  : maybe NULL values;
+     *                             ""  : unknown.
+     * SCOPE_CATALOG     VARCHAR   catalog of REF attribute scope table or NULL
+     * SCOPE_SCHEMA      VARCHAR   schema of REF attribute scope table or NULL
+     * SCOPE_TABLE       VARCHAR   name of REF attribute scope table or NULL
+     * SOURCE_DATA_TYPE  SMALLINT  For DISTINCT or user-generated REF DATA_TYPE:
+     *                            source SQL type from DITypes
+     *                            For other DATA_TYPE values:  NULL
+     * </pre>
+     *
+     * <B>Note:</B> Currently, neither the HSQLDB engine or the JDBC driver
+     * support UDTs, so an empty table is returned. <p>
+     * @return a <code>Table</code> object describing the accessible
+     *        attrubutes of the accessible user-defined type
+     *        (UDT) objects defined within this database
+     * @throws HsqlException if an error occurs while producing the table
+     */
+    Table SYSTEM_UDTATTRIBUTES(Session session, PersistentStore store) {
+
+        Table t = sysTables[SYSTEM_UDTATTRIBUTES];
+
+        if (t == null) {
+            t = createBlankTable(sysTableHsqlNames[SYSTEM_UDTATTRIBUTES]);
+
+            addColumn(t, "TYPE_CAT", SQL_IDENTIFIER);
+            addColumn(t, "TYPE_SCHEM", SQL_IDENTIFIER);
+            addColumn(t, "TYPE_NAME", SQL_IDENTIFIER);             // not null
+            addColumn(t, "ATTR_NAME", SQL_IDENTIFIER);             // not null
+            addColumn(t, "DATA_TYPE", Type.SQL_SMALLINT);          // not null
+            addColumn(t, "ATTR_TYPE_NAME", SQL_IDENTIFIER);        // not null
+            addColumn(t, "ATTR_SIZE", Type.SQL_INTEGER);
+            addColumn(t, "DECIMAL_DIGITS", Type.SQL_INTEGER);
+            addColumn(t, "NUM_PREC_RADIX", Type.SQL_INTEGER);
+            addColumn(t, "NULLABLE", Type.SQL_INTEGER);
+            addColumn(t, "REMARKS", CHARACTER_DATA);
+            addColumn(t, "ATTR_DEF", CHARACTER_DATA);
+            addColumn(t, "SQL_DATA_TYPE", Type.SQL_INTEGER);
+            addColumn(t, "SQL_DATETIME_SUB", Type.SQL_INTEGER);
+            addColumn(t, "CHAR_OCTET_LENGTH", Type.SQL_INTEGER);
+            addColumn(t, "ORDINAL_POSITION", Type.SQL_INTEGER);    // not null
+            addColumn(t, "IS_NULLABLE", YES_OR_NO);                // not null
+            addColumn(t, "SCOPE_CATALOG", SQL_IDENTIFIER);
+            addColumn(t, "SCOPE_SCHEMA", SQL_IDENTIFIER);
+            addColumn(t, "SCOPE_TABLE", SQL_IDENTIFIER);
+            addColumn(t, "SOURCE_DATA_TYPE", Type.SQL_SMALLINT);
+            t.createPrimaryKey();
+
+            return t;
+        }
+
+        return t;
+    }
+
+    /**
+     * Retrieves a <code>Table</code> object describing the accessible
      * user-defined types defined in this database. <p>
      *
      * Schema-specific UDTs may have type JAVA_OBJECT, STRUCT, or DISTINCT.
      *
      * <P>Each row is a UDT description with the following columns:
      * <OL>
-     *   <LI><B>TYPE_CAT</B> <code>VARCHAR</code> => the type's catalog
-     *   <LI><B>TYPE_SCHEM</B> <code>VARCHAR</code> => type's schema
-     *   <LI><B>TYPE_NAME</B> <code>VARCHAR</code> => type name
-     *   <LI><B>CLASS_NAME</B> <code>VARCHAR</code> => Java class name
-     *   <LI><B>DATA_TYPE</B> <code>VARCHAR</code> =>
+     *   <LI><B>TYPE_CAT</B> <code>VARCHAR</code>  : the type's catalog
+     *   <LI><B>TYPE_SCHEM</B> <code>VARCHAR</code>  : type's schema
+     *   <LI><B>TYPE_NAME</B> <code>VARCHAR</code>  : type name
+     *   <LI><B>CLASS_NAME</B> <code>VARCHAR</code>  : Java class name
+     *   <LI><B>DATA_TYPE</B> <code>VARCHAR</code>  :
      *         type value defined in <code>DITypes</code>;
      *         one of <code>JAVA_OBJECT</code>, <code>STRUCT</code>, or
      *        <code>DISTINCT</code>
-     *   <LI><B>REMARKS</B> <code>VARCHAR</code> =>
+     *   <LI><B>REMARKS</B> <code>VARCHAR</code>  :
      *          explanatory comment on the type
-     *   <LI><B>BASE_TYPE</B><code>SMALLINT</code> =>
+     *   <LI><B>BASE_TYPE</B><code>SMALLINT</code>  :
      *          type code of the source type of a DISTINCT type or the
      *          type that implements the user-generated reference type of the
      *          SELF_REFERENCING_COLUMN of a structured type as defined in
@@ -2752,22 +2822,22 @@ class DatabaseInformationMain extends Da
     /**
      * Retrieves a <code>Table</code> object describing the accessible
      * columns that are automatically updated when any value in a row
-     * is updated. <p>
+     * is updated.<P>
      *
-     * Each row is a version column description with the following columns: <p>
+     * Each row is a version column description with the following columns:
      *
      * <OL>
-     * <LI><B>SCOPE</B> <code>SMALLINT</code> => is not used
-     * <LI><B>COLUMN_NAME</B> <code>VARCHAR</code> => column name
-     * <LI><B>DATA_TYPE</B> <code>SMALLINT</code> =>
+     * <LI><B>SCOPE</B> <code>SMALLINT</code>  : is not used
+     * <LI><B>COLUMN_NAME</B> <code>VARCHAR</code>  : column name
+     * <LI><B>DATA_TYPE</B> <code>SMALLINT</code>  :
      *        SQL data type from java.sql.Types
-     * <LI><B>TYPE_NAME</B> <code>SMALLINT</code> =>
+     * <LI><B>TYPE_NAME</B> <code>SMALLINT</code>  :
      *       Data source dependent type name
-     * <LI><B>COLUMN_SIZE</B> <code>INTEGER</code> => precision
-     * <LI><B>BUFFER_LENGTH</B> <code>INTEGER</code> =>
+     * <LI><B>COLUMN_SIZE</B> <code>INTEGER</code>  : precision
+     * <LI><B>BUFFER_LENGTH</B> <code>INTEGER</code>  :
      *        length of column value in bytes
-     * <LI><B>DECIMAL_DIGITS</B> <code>SMALLINT</code> => scale
-     * <LI><B>PSEUDO_COLUMN</B> <code>SMALLINT</code> =>
+     * <LI><B>DECIMAL_DIGITS</B> <code>SMALLINT</code>  : scale
+     * <LI><B>PSEUDO_COLUMN</B> <code>SMALLINT</code>  :
      *        is this a pseudo column like an Oracle <code>ROWID</code>:<BR>
      *        (as defined in <code>java.sql.DatabaseMetadata</code>)
      * <UL>
@@ -2961,7 +3031,7 @@ class DatabaseInformationMain extends Da
      * tables defined within this database.<p>
      *
      * Each row is a column privilege description with the following
-     * columns: <p>
+     * columns:
      *
      * <pre class="SqlCodeExample">
      * TABLE_CAT    VARCHAR   table catalog
@@ -3062,13 +3132,14 @@ class DatabaseInformationMain extends Da
                     Right right          = (Right) rights.get(j);
                     Right grantableRight = right.getGrantableRights();
 
-                    for (int k = 0; k < Right.privilegeTypes.length; k++) {
+                    for (int k = 0; k < Right.tablePrivilegeTypes.length;
+                            k++) {
                         OrderedHashSet columnList =
                             right.getColumnsForPrivilege(
-                                table, Right.privilegeTypes[k]);
+                                table, Right.tablePrivilegeTypes[k]);
                         OrderedHashSet grantableList =
                             grantableRight.getColumnsForPrivilege(table,
-                                Right.privilegeTypes[k]);
+                                Right.tablePrivilegeTypes[k]);
 
                         for (int l = 0; l < columnList.size(); l++) {
                             HsqlName fullName = ((HsqlName) columnList.get(l));
@@ -3080,7 +3151,7 @@ class DatabaseInformationMain extends Da
                             row[table_schema]   = tableSchema;
                             row[table_name]     = tableName;
                             row[column_name]    = fullName.name;
-                            row[privilege_type] = Right.privilegeNames[k];
+                            row[privilege_type] = Right.tablePrivilegeNames[k];
                             row[is_grantable] =
                                 right.getGrantee() == table.getOwner()
                                 || grantableList.contains(fullName) ? "YES"
@@ -3102,7 +3173,7 @@ class DatabaseInformationMain extends Da
      * The SEQUENCES view has one row for each external sequence
      * generator. <p>
      *
-     * <b>Definition:</b> <p>
+     * <b>Definition:</b>
      *
      * <pre class="SqlCodeExample">
      *
@@ -3126,43 +3197,34 @@ class DatabaseInformationMain extends Da
      *
      * </pre>
      *
-     * <b>DESCRIPTION:</b><p>
+     * <b>DESCRIPTION:</b>
      *
      * <ol>
      * <li> The values of SEQUENCE_CATALOG, SEQUENCE_SCHEMA, and
      *      SEQUENCE_NAME are the catalog name, unqualified schema name,
      *      and qualified identifier, respectively, of the sequence generator
-     *      being described. <p>
+     *      being described.
      *
      * <li> The values of SEQUENCE_CATALOG, SEQUENCE_SCHEMA, SEQUENCE_NAME, and
      *      DTD_IDENTIFIER are the values of OBJECT_CATALOG, OBJECT_SCHEMA,
      *      OBJECT_NAME, and DTD_IDENTIFIER, respectively, of the row in
      *      DATA_TYPE_DESCRIPTOR (not yet implemented) that describes the data
-     *      type of the sequence generator. <p>
+     *      type of the sequence generator.
      *
      * <li> The values of MAXIMUM_VALUE, MINIMUM_VALUE, and INCREMENT are the
      *      character representations of maximum value, minimum value,
      *      and increment, respectively, of the sequence generator being
-     *      described. <p>
+     *      described.
      *
-     * <li> The values of CYCLE_OPTION have the following meanings: <p>
+     * <li> The values of CYCLE_OPTION have the following meanings:<br>
      *
-     *      <table border cellpadding="3">
-     *          <tr>
-     *              <td nowrap>YES</td>
-     *              <td nowrap>The cycle option of the sequence generator
-     *                         is CYCLE.</td>
-     *          <tr>
-     *              <td nowrap>NO</td>
-     *              <td nowrap>The cycle option of the sequence generator is
-     *                         NO CYCLE.</td>
-     *          </tr>
-     *      </table> <p>
+     *              YES : The cycle option of the sequence generator
+     *                         is CYCLE.<br>
+     *              NO : The cycle option of the sequence generator is
+     *                         NO CYCLE.
      *
      * <li> The value of START_WITH is HSQLDB-specific (not in the SQL 200n
-     *      spec).  <p>
-     *
-     *      It is the character representation of the START WITH value. <p>
+     *      spec). It is the character representation of the START WITH value.
      *
      * <li> The value of NEXT_VALUE is HSQLDB-specific (not in the SQL 200n)<p>
      *      This is the character representation of the value that
@@ -3394,7 +3456,7 @@ class DatabaseInformationMain extends Da
      * The TABLE_PRIVILEGES view has one row for each visible access
      * right for each accessible table defined within this database. <p>
      *
-     * Each row is a table privilege description with the following columns: <p>
+     * Each row is a table privilege description with the following columns:
      *
      * <pre class="SqlCodeExample">
      * GRANTOR      VARCHAR   grantor of access
@@ -3489,12 +3551,13 @@ class DatabaseInformationMain extends Da
                     Right right          = (Right) rights.get(j);
                     Right grantableRight = right.getGrantableRights();
 
-                    for (int k = 0; k < Right.privilegeTypes.length; k++) {
-                        if (!right.canAccessFully(Right.privilegeTypes[k])) {
+                    for (int k = 0; k < Right.tablePrivilegeTypes.length;
+                            k++) {
+                        if (!right.canAccess(Right.tablePrivilegeTypes[k])) {
                             continue;
                         }
 
-                        privilege           = Right.privilegeNames[k];
+                        privilege           = Right.tablePrivilegeNames[k];
                         row                 = t.getEmptyRowData();
                         row[grantor] = right.getGrantor().getName().name;
                         row[grantee] = right.getGrantee().getName().name;
@@ -3504,9 +3567,9 @@ class DatabaseInformationMain extends Da
                         row[privilege_type] = privilege;
                         row[is_grantable] =
                             right.getGrantee() == table.getOwner()
-                            || grantableRight.canAccessFully(
-                                Right.privilegeTypes[k]) ? "YES"
-                                                         : "NO";
+                            || grantableRight.canAccess(
+                                Right.tablePrivilegeTypes[k]) ? "YES"
+                                                              : "NO";
                         row[with_hierarchy] = "NO";
 
                         try {
@@ -3637,7 +3700,7 @@ class DatabaseInformationMain extends Da
      * Retrieves a <code>Table</code> object naming the accessible catalogs
      * defined within this database. <p>
      *
-     * Each row is a catalog name description with the following column: <p>
+     * Each row is a catalog name description with the following column:
      *
      * <pre class="SqlCodeExample">
      * TABLE_CAT   VARCHAR   catalog name
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/dbinfo/DITableInfo.java 2.7.0-1/hsqldb/src/org/hsqldb/dbinfo/DITableInfo.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/dbinfo/DITableInfo.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/dbinfo/DITableInfo.java	2022-05-22 18:09:56.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -83,7 +83,7 @@ final class DITableInfo {
     }
 
     /**
-     * Sets the Locale for table and column remarks. <p>
+     * Sets the Locale for table and column remarks.
      */
     void setupBundles() {
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/error/Error.java 2.7.0-1/hsqldb/src/org/hsqldb/error/Error.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/error/Error.java	2020-11-30 19:14:54.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/error/Error.java	2022-06-08 08:14:16.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -43,7 +43,7 @@ import org.hsqldb.result.Result;
  *
  * @author Loic Lefevre
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.2.7
+ * @version 2.7.0
  * @since 1.9.0
  */
 public final class Error {
@@ -122,7 +122,7 @@ public final class Error {
      * the add parameters.
      *
      * @param code      main error code
-     * @param subCode   sub error code (if 0 => no subMessage!)
+     * @param subCode   sub error code (if 0 then no subMessage!)
      * @param   add     optional parameters
      *
      * @return an <code>HsqlException</code>
@@ -265,7 +265,7 @@ public final class Error {
         String message = getResourceString(code);
 
         if (subCode != 0) {
-            message += getResourceString(subCode);
+            message += ' ' + getResourceString(subCode);
         }
 
         if (add != null) {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/ExpressionArithmetic.java 2.7.0-1/hsqldb/src/org/hsqldb/ExpressionArithmetic.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/ExpressionArithmetic.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/ExpressionArithmetic.java	2022-05-28 16:35:22.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -43,7 +43,7 @@ import org.hsqldb.types.Types;
  *
  * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.4.0
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class ExpressionArithmetic extends Expression {
@@ -231,8 +231,10 @@ public class ExpressionArithmetic extend
     }
 
     public List resolveColumnReferences(Session session,
-            RangeGroup rangeGroup, int rangeCount, RangeGroup[] rangeGroups,
-            List unresolvedSet, boolean acceptsSequences) {
+                                        RangeGroup rangeGroup, int rangeCount,
+                                        RangeGroup[] rangeGroups,
+                                        List unresolvedSet,
+                                        boolean acceptsSequences) {
 
         if (opType == OpTypes.VALUE) {
             return unresolvedSet;
@@ -282,6 +284,11 @@ public class ExpressionArithmetic extend
                 break;
 
             case OpTypes.ADD :
+                if (session.database.sqlSyntaxOra) {
+                    resolveTypesForArithmetic(session, parent);
+
+                    break;
+                }
 
                 // special case for concat using +
                 if ((nodes[LEFT].dataType != null && nodes[LEFT].dataType
@@ -503,6 +510,14 @@ public class ExpressionArithmetic extend
                 }
             }
         } else {
+            if (session.database.sqlSyntaxOra) {
+                if (nodes[LEFT].dataType.isNumberType()
+                        && nodes[RIGHT].dataType.isCharacterType()) {
+                    nodes[RIGHT] = new ExpressionOp(nodes[RIGHT],
+                                                    nodes[LEFT].dataType);
+                }
+            }
+
             dataType = nodes[LEFT].dataType.getCombinedType(session,
                     nodes[RIGHT].dataType, opType);
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/ExpressionArrayAggregate.java 2.7.0-1/hsqldb/src/org/hsqldb/ExpressionArrayAggregate.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/ExpressionArrayAggregate.java	2021-03-04 20:48:54.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/ExpressionArrayAggregate.java	2022-06-18 18:39:26.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -46,7 +46,7 @@ import org.hsqldb.types.Type;
  * Implementation of array aggregate operations
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 2.0.1
  */
 public class ExpressionArrayAggregate extends Expression {
@@ -55,7 +55,8 @@ public class ExpressionArrayAggregate ex
     SortAndSlice distinctSort;
     String       separator = ",";
     ArrayType    arrayDataType;
-    Type         exprType;
+    Type         exprDataType;
+    int          exprOpType;    // original opType, may change during resolution
     Expression   condition = Expression.EXPR_TRUE;
 
     ExpressionArrayAggregate(int type, boolean distinct, Expression e,
@@ -65,17 +66,12 @@ public class ExpressionArrayAggregate ex
 
         this.isDistinctAggregate = distinct;
         this.sort                = sort;
+        this.exprOpType          = e.opType;
 
         if (separator != null) {
             this.separator = separator;
         }
 
-        if (type == OpTypes.MEDIAN) {
-            nodes = new Expression[]{ e };
-
-            return;
-        }
-
         if (sort == null) {
             nodes = new Expression[]{ e };
         } else {
@@ -169,8 +165,10 @@ public class ExpressionArrayAggregate ex
     }
 
     public List resolveColumnReferences(Session session,
-            RangeGroup rangeGroup, int rangeCount, RangeGroup[] rangeGroups,
-            List unresolvedSet, boolean acceptsSequences) {
+                                        RangeGroup rangeGroup, int rangeCount,
+                                        RangeGroup[] rangeGroups,
+                                        List unresolvedSet,
+                                        boolean acceptsSequences) {
 
         List conditionSet = condition.resolveColumnReferences(session,
             rangeGroup, rangeCount, rangeGroups, null, false);
@@ -213,13 +211,13 @@ public class ExpressionArrayAggregate ex
             }
         }
 
-        exprType = nodes[nodes.length - 1].dataType;
+        exprDataType = nodes[nodes.length - 1].dataType;
 
-        if (exprType.isLobType()) {
+        if (exprDataType.isLobType()) {
             throw Error.error(ErrorCode.X_42534);
         }
 
-        if (exprType.isArrayType()) {
+        if (exprDataType.isArrayType()) {
             throw Error.error(ErrorCode.X_42534);
         }
 
@@ -231,7 +229,7 @@ public class ExpressionArrayAggregate ex
                 arrayDataType =
                     new ArrayType(rowDataType,
                                   ArrayType.defaultLargeArrayCardinality);
-                dataType = new ArrayType(exprType,
+                dataType = new ArrayType(exprDataType,
                                          ArrayType.defaultArrayCardinality);
                 break;
 
@@ -248,7 +246,7 @@ public class ExpressionArrayAggregate ex
                                   ArrayType.defaultLargeArrayCardinality);
                 dataType = ExpressionAggregate.getType(session,
                                                        OpTypes.MEDIAN,
-                                                       exprType);
+                                                       exprDataType);
                 break;
         }
 
@@ -381,7 +379,7 @@ public class ExpressionArrayAggregate ex
                     Object   value = row[row.length - 1];
                     String string =
                         (String) Type.SQL_VARCHAR.convertToType(session,
-                            value, exprType);
+                            value, exprDataType);
 
                     sb.append(string);
                 }
@@ -412,10 +410,10 @@ public class ExpressionArrayAggregate ex
                 }
 
                 if (dataType.isDateTimeTypeWithZone()) {
-                    value = DateTimeType.changeZoneToUTC(value);
+                    value = ((DateTimeType)dataType).changeZoneToUTC(value);
                 }
 
-                return dataType.convertToType(session, value, exprType);
+                return dataType.convertToType(session, value, exprDataType);
             }
         }
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/ExpressionColumn.java 2.7.0-1/hsqldb/src/org/hsqldb/ExpressionColumn.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/ExpressionColumn.java	2021-05-30 14:45:04.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/ExpressionColumn.java	2022-04-21 06:32:20.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -401,8 +401,10 @@ public class ExpressionColumn extends Ex
     }
 
     public List resolveColumnReferences(Session session,
-            RangeGroup rangeGroup, int rangeCount, RangeGroup[] rangeGroups,
-            List unresolvedSet, boolean acceptsSequences) {
+                                        RangeGroup rangeGroup, int rangeCount,
+                                        RangeGroup[] rangeGroups,
+                                        List unresolvedSet,
+                                        boolean acceptsSequences) {
 
         switch (opType) {
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/Expression.java 2.7.0-1/hsqldb/src/org/hsqldb/Expression.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/Expression.java	2021-05-22 09:08:42.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/Expression.java	2022-04-21 06:32:20.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -62,7 +62,7 @@ import org.hsqldb.types.Types;
  *
  * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.1
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class Expression implements Cloneable {
@@ -106,6 +106,9 @@ public class Expression implements Clone
     // for query and value lists, etc
     boolean isCorrelated;
 
+    // for CHECK and GENERATED expressions
+    boolean noOptimisation;
+
     // for COLUMN
     int columnIndex = -1;
 
@@ -1289,15 +1292,19 @@ public class Expression implements Clone
             }
 
             for (int i = 0; i < nodes.length; i++) {
-                if (nodes[i].nodes[j].isUnresolvedParam()) {
-                    nodes[i].nodes[j].dataType = nodeDataTypes[j];
+                Expression node = nodes[i];
+
+                if (node.nodes[j].isUnresolvedParam()) {
+                    node.nodes[j].dataType = nodeDataTypes[j];
+                    node.nodeDataTypes[j]  = node.nodes[j].dataType;
 
                     continue;
                 }
 
-                if (nodes[i].nodes[j].opType == OpTypes.VALUE) {
-                    if (nodes[i].nodes[j].valueData == null) {
-                        nodes[i].nodes[j].dataType = nodeDataTypes[j];
+                if (node.nodes[j].opType == OpTypes.VALUE) {
+                    if (node.nodes[j].valueData == null) {
+                        node.nodes[j].dataType = nodeDataTypes[j];
+                        node.nodeDataTypes[j]  = node.nodes[j].dataType;
                     }
                 }
             }
@@ -1928,6 +1935,17 @@ public class Expression implements Clone
         return set;
     }
 
+    public void setNoOptimisation() {
+
+        noOptimisation = true;
+
+        for (int i = 0; i < nodes.length; i++) {
+            if (nodes[i] != null) {
+                nodes[i].setNoOptimisation();
+            }
+        }
+    }
+
     public OrderedHashSet getSubqueries() {
         return collectAllSubqueries(null);
     }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/ExpressionJSON.java 2.7.0-1/hsqldb/src/org/hsqldb/ExpressionJSON.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/ExpressionJSON.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/ExpressionJSON.java	2022-05-23 11:22:16.000000000 +0000
@@ -0,0 +1,455 @@
+/* Copyright (c) 2001-2022, The HSQL Development Group
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ * Redistributions of source code must retain the above copyright notice, this
+ * list of conditions and the following disclaimer.
+ *
+ * Redistributions in binary form must reproduce the above copyright notice,
+ * this list of conditions and the following disclaimer in the documentation
+ * and/or other materials provided with the distribution.
+ *
+ * Neither the name of the HSQL Development Group nor the names of its
+ * contributors may be used to endorse or promote products derived from this
+ * software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL HSQL DEVELOPMENT GROUP, HSQLDB.ORG,
+ * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+ * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+ * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+ * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+ * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+ * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+
+package org.hsqldb;
+
+import org.hsqldb.error.Error;
+import org.hsqldb.error.ErrorCode;
+import org.hsqldb.lib.HsqlArrayList;
+import org.hsqldb.lib.OrderedHashMap;
+import org.hsqldb.lib.OrderedHashSet;
+import org.hsqldb.lib.StringConverter;
+import org.hsqldb.types.ArrayType;
+import org.hsqldb.types.Type;
+
+/**
+ * JSON functions
+ *
+ * @author Fred Toussi (fredt@users dot sourceforge.net)
+ * @version 2.7.0
+ * @since 2.7.0
+ */
+public interface ExpressionJSON {
+
+    class ExpressionJSONWrapper extends Expression {
+
+        public ExpressionJSONWrapper(Expression expr) {
+
+            super(OpTypes.JSON_FUNCTION);
+
+            nodes = new Expression[]{ expr };
+        }
+
+        public void resolveTypes(Session session, Expression parent) {
+
+            nodes[LEFT].resolveTypes(session, this);
+
+            dataType = nodes[LEFT].dataType;
+        }
+
+        public Object getValue(Session session) {
+            return nodes[LEFT].getValue(session);
+        }
+
+        public String getSQL() {
+            return nodes[LEFT].getSQL();
+        }
+
+        public String describe(Session session, int blanks) {
+            return nodes[LEFT].getSQL();
+        }
+    }
+
+    class ExpressionJSONArrayFromQuery extends Expression {
+
+        final Expression exprQuery;
+        final boolean    nullOnNull;
+
+        public ExpressionJSONArrayFromQuery(Expression expressionQuery,
+                                            boolean nullOnNull,
+                                            Type dataType) {
+
+            super(OpTypes.JSON_FUNCTION);
+
+            this.exprQuery  = expressionQuery;
+            this.nullOnNull = nullOnNull;
+            this.dataType   = dataType == null ? Type.SQL_VARCHAR_LONG
+                                               : dataType;
+            nodes           = new Expression[]{ expressionQuery };
+        }
+
+        public void resolveTypes(Session session, Expression parent) {
+            nodes[LEFT].resolveTypes(session, this);
+        }
+
+        public Object getValue(Session session) {
+
+            StringBuilder sb     = new StringBuilder();
+            Object        values = nodes[LEFT].getValue(session);
+
+            nodes[LEFT].dataType.convertToJSON(values, sb);
+
+            if (sb.length() > dataType.precision) {
+                throw Error.error(ErrorCode.X_22001);
+            }
+
+            return sb.toString();
+        }
+
+        public String getSQL() {
+            return Tokens.T_JSON_ARRAY + "()";
+        }
+
+        public String describe(Session session, int blanks) {
+            return Tokens.T_JSON_ARRAY + "()";
+        }
+    }
+
+    class ExpressionJSONArrayFromValues extends Expression {
+
+        final HsqlArrayList exprList;
+        final boolean       nullOnNull;
+
+        public ExpressionJSONArrayFromValues(HsqlArrayList expressionList,
+                                             boolean nullOnNull,
+                                             Type dataType) {
+
+            super(OpTypes.JSON_FUNCTION);
+
+            this.exprList   = expressionList;
+            this.nullOnNull = nullOnNull;
+            this.dataType   = dataType == null ? Type.SQL_VARCHAR_LONG
+                                               : dataType;
+            nodes           = new Expression[expressionList.size()];
+
+            expressionList.toArray(nodes);
+        }
+
+        public void resolveTypes(Session session, Expression parent) {
+
+            for (int i = 0; i < nodes.length; i++) {
+                if (nodes[i] != null) {
+                    nodes[i].resolveTypes(session, this);
+                }
+            }
+        }
+
+        public Object getValue(Session session) {
+
+            StringBuilder sb    = new StringBuilder();
+            int           count = 0;
+
+            sb.append('[');
+
+            for (int i = 0; i < nodes.length; i++) {
+                if (count > 0) {
+                    sb.append(',');
+                }
+
+                Object value = nodes[i].getValue(session);
+
+                if (nodes[i].opType == OpTypes.JSON_FUNCTION) {
+                    sb.append((String) value);
+                } else {
+                    nodes[i].dataType.convertToJSON(value, sb);
+                }
+
+                count++;
+            }
+
+            sb.append(']');
+
+            if (sb.length() > dataType.precision) {
+                throw Error.error(ErrorCode.X_22001);
+            }
+
+            return sb.toString();
+        }
+
+        public String getSQL() {
+            return Tokens.T_JSON_ARRAY + "()";
+        }
+
+        public String describe(Session session, int blanks) {
+            return Tokens.T_JSON_ARRAY + "()";
+        }
+    }
+
+    class ExpressionJSONArrayAgg extends Expression {
+
+        final boolean isValueJSON;
+        final boolean nullOnNull;
+
+        public ExpressionJSONArrayAgg(ExpressionArrayAggregate valuesAgg,
+                                      boolean nullOnNull, Type dataType) {
+
+            super(OpTypes.JSON_FUNCTION);
+
+            this.nullOnNull  = nullOnNull;
+            this.dataType    = dataType == null ? Type.SQL_VARCHAR_LONG
+                                                : dataType;
+            this.isValueJSON = valuesAgg.exprOpType == OpTypes.JSON_FUNCTION;
+            nodes            = new Expression[]{ valuesAgg };
+        }
+
+        public void resolveTypes(Session session, Expression parent) {
+            nodes[LEFT].resolveTypes(session, this);
+        }
+
+        public Object getValue(Session session) {
+
+            StringBuilder sb         = new StringBuilder();
+            Object        values     = nodes[LEFT].getValue(session);
+            ArrayType     valuesType = (ArrayType) nodes[LEFT].dataType;
+
+            if (isValueJSON) {
+                valuesType.convertToJSONsimple(values, sb);
+            } else {
+                valuesType.convertToJSON(values, sb);
+            }
+
+            if (sb.length() > dataType.precision) {
+                throw Error.error(ErrorCode.X_22001);
+            }
+
+            return sb.toString();
+        }
+
+        public String getSQL() {
+            return Tokens.T_JSON_ARRAYAGG + "()";
+        }
+
+        public String describe(Session session, int blanks) {
+            return Tokens.T_JSON_ARRAYAGG + "()";
+        }
+    }
+
+    class ExpressionJSONObject extends Expression {
+
+        final OrderedHashMap exprMap;
+        final boolean        nullOnNull;
+        final boolean        uniqueKeys;
+
+        public ExpressionJSONObject(OrderedHashMap exprMap,
+                                    boolean nullOnNull, boolean uniqueKeys,
+                                    Type dataType) {
+
+            super(OpTypes.JSON_FUNCTION);
+
+            this.exprMap    = exprMap;
+            this.nullOnNull = nullOnNull;
+            this.uniqueKeys = uniqueKeys;
+            this.dataType   = dataType == null ? Type.SQL_VARCHAR_LONG
+                                               : dataType;
+            nodes           = new Expression[exprMap.size() * 2];
+
+            for (int i = 0; i < exprMap.size(); i++) {
+                nodes[i * 2]     = (Expression) exprMap.getKeyAt(i);
+                nodes[i * 2 + 1] = (Expression) exprMap.get(i);
+            }
+        }
+
+        public void resolveTypes(Session session, Expression parent) {
+
+            for (int i = 0; i < nodes.length; i++) {
+                if (nodes[i] != null) {
+                    nodes[i].resolveTypes(session, this);
+                }
+            }
+        }
+
+        public Object getValue(Session session) {
+
+            StringBuilder  sb     = new StringBuilder();
+            int            count  = 0;
+            OrderedHashSet keySet = new OrderedHashSet();
+
+            sb.append('{');
+
+            for (int i = 0; i < exprMap.size(); i++) {
+                int j = i * 2;
+
+                if (count > 0) {
+                    sb.append(',');
+                }
+
+                Object name = nodes[j].getValue(session);
+
+                if (uniqueKeys) {
+                    String s = nodes[j].dataType.convertToString(name);
+
+                    if (!keySet.add(s)) {
+                        throw Error.error(ErrorCode.X_23505);
+                    }
+                }
+
+                if (nodes[j].dataType.isCharacterType()) {
+                    nodes[j].dataType.convertToJSON(name, sb);
+                } else {
+                    String s = nodes[j].dataType.convertToString(name);
+
+                    s = StringConverter.toQuotedString(s, '"', false);
+
+                    sb.append(s);
+                }
+
+                sb.append(':');
+
+                Object value = nodes[j + 1].getValue(session);
+
+                if (nodes[j + 1].opType == OpTypes.JSON_FUNCTION) {
+                    sb.append((String) value);
+                } else {
+                    nodes[j + 1].dataType.convertToJSON(value, sb);
+                }
+
+                count++;
+            }
+
+            sb.append('}');
+
+            if (sb.length() > dataType.precision) {
+                throw Error.error(ErrorCode.X_22001);
+            }
+
+            return sb.toString();
+        }
+
+        public String getSQL() {
+            return Tokens.T_JSON_OBJECT + "()";
+        }
+
+        public String describe(Session session, int blanks) {
+            return Tokens.T_JSON_OBJECT + "()";
+        }
+    }
+
+    class ExpressionJSONObjectAgg extends Expression {
+
+        final ExpressionArrayAggregate namesAgg;
+        final ExpressionArrayAggregate valuesAgg;
+        final boolean                  nullOnNull;
+        final boolean                  uniqueKeys;
+        boolean                        isValueJSON;
+
+        public ExpressionJSONObjectAgg(ExpressionArrayAggregate namesAgg,
+                                       ExpressionArrayAggregate valuesAgg,
+                                       boolean nullOnNull, boolean uniqueKeys,
+                                       Type dataType) {
+
+            super(OpTypes.JSON_FUNCTION);
+
+            this.namesAgg    = namesAgg;
+            this.valuesAgg   = valuesAgg;
+            this.nullOnNull  = nullOnNull;
+            this.uniqueKeys  = uniqueKeys;
+            this.dataType    = dataType == null ? Type.SQL_VARCHAR_LONG
+                                                : dataType;
+            this.isValueJSON = valuesAgg.exprOpType == OpTypes.JSON_FUNCTION;
+            nodes            = new Expression[] {
+                namesAgg, valuesAgg
+            };
+        }
+
+        public void resolveTypes(Session session, Expression parent) {
+
+            for (int i = 0; i < nodes.length; i++) {
+                if (nodes[i] != null) {
+                    nodes[i].resolveTypes(session, this);
+                }
+            }
+        }
+
+        public Object getValue(Session session) {
+
+            StringBuilder  sb     = new StringBuilder();
+            int            count  = 0;
+            Object[]       names  = (Object[]) nodes[LEFT].getValue(session);
+            Object[]       values = (Object[]) nodes[RIGHT].getValue(session);
+            Type nameType         = nodes[LEFT].dataType.collectionBaseType();
+            Type valueType        = nodes[RIGHT].dataType.collectionBaseType();
+            OrderedHashSet keySet = new OrderedHashSet();
+
+            sb.append('{');
+
+            for (int i = 0; i < names.length; i++) {
+                String name  = (String) names[i];
+                String value = (String) values[i];
+
+                if (name == null) {
+                    continue;
+                }
+
+                if (!nullOnNull && value == null) {
+                    continue;
+                }
+
+                if (count > 0) {
+                    sb.append(',');
+                }
+
+                if (uniqueKeys) {
+                    String s = nameType.convertToString(name);
+
+                    if (!keySet.add(s)) {
+                        throw Error.error(ErrorCode.X_23505);
+                    }
+                }
+
+                if (nameType.isCharacterType()) {
+                    nameType.convertToJSON(name, sb);
+                } else {
+                    String s = nameType.convertToString(name);
+
+                    s = StringConverter.toQuotedString(s, '"', false);
+
+                    sb.append(s);
+                }
+
+                sb.append(':');
+
+                if (isValueJSON) {
+                    sb.append((String) value);
+                } else {
+                    valueType.convertToJSON(value, sb);
+                }
+
+                count++;
+            }
+
+            sb.append('}');
+
+            if (sb.length() > dataType.precision) {
+                throw Error.error(ErrorCode.X_22001);
+            }
+
+            return sb.toString();
+        }
+
+        public String getSQL() {
+            return Tokens.T_JSON_OBJECTAGG + "()";
+        }
+
+        public String describe(Session session, int blanks) {
+            return Tokens.T_JSON_OBJECTAGG + "()";
+        }
+    }
+}
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/ExpressionLike.java 2.7.0-1/hsqldb/src/org/hsqldb/ExpressionLike.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/ExpressionLike.java	2021-01-29 13:34:34.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/ExpressionLike.java	2022-04-21 06:32:20.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -54,8 +54,7 @@ public final class ExpressionLike extend
     /**
      * Creates a LIKE expression
      */
-    ExpressionLike(Expression left, Expression right, Expression escape,
-                   boolean noOptimisation) {
+    ExpressionLike(Expression left, Expression right, Expression escape) {
 
         super(OpTypes.LIKE);
 
@@ -64,7 +63,6 @@ public final class ExpressionLike extend
         nodes[RIGHT]        = right;
         nodes[ESCAPE]       = escape;
         likeObject          = new Like();
-        this.noOptimisation = noOptimisation;
     }
 
     private ExpressionLike(ExpressionLike other) {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/ExpressionLogical.java 2.7.0-1/hsqldb/src/org/hsqldb/ExpressionLogical.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/ExpressionLogical.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/ExpressionLogical.java	2022-04-21 06:32:20.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -47,12 +47,11 @@ import org.hsqldb.types.Types;
 /**
  * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.5.1
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class ExpressionLogical extends Expression {
 
-    boolean noOptimisation;
     boolean isQuantified;
     boolean isTerminal;
 
@@ -710,15 +709,23 @@ public class ExpressionLogical extends E
                     } else {
                         Object value = nodes[LEFT].getValue(session);
 
-                        if (value == null || Boolean.FALSE.equals(value)) {
+                        if (Boolean.FALSE.equals(value)) {
                             setAsConstantValue(Boolean.FALSE, parent);
+                        } else if (Boolean.TRUE.equals(value)) {
+                            if (parent != null) {
+                                parent.replaceNode(this, nodes[RIGHT]);
+                            }
                         }
                     }
                 } else if (nodes[RIGHT].opType == OpTypes.VALUE) {
                     Object value = nodes[RIGHT].getValue(session);
 
-                    if (value == null || Boolean.FALSE.equals(value)) {
+                    if (Boolean.FALSE.equals(value)) {
                         setAsConstantValue(Boolean.FALSE, parent);
+                    } else if (Boolean.TRUE.equals(value)) {
+                        if (parent != null) {
+                            parent.replaceNode(this, nodes[LEFT]);
+                        }
                     }
                 }
 
@@ -735,6 +742,10 @@ public class ExpressionLogical extends E
 
                         if (Boolean.TRUE.equals(value)) {
                             setAsConstantValue(Boolean.TRUE, parent);
+                        } else if (Boolean.FALSE.equals(value)) {
+                            if (parent != null) {
+                                parent.replaceNode(this, nodes[RIGHT]);
+                            }
                         }
                     }
                 } else if (nodes[RIGHT].opType == OpTypes.VALUE) {
@@ -742,6 +753,10 @@ public class ExpressionLogical extends E
 
                     if (Boolean.TRUE.equals(value)) {
                         setAsConstantValue(Boolean.TRUE, parent);
+                    } else if (Boolean.FALSE.equals(value)) {
+                        if (parent != null) {
+                            parent.replaceNode(this, nodes[LEFT]);
+                        }
                     }
                 }
 
@@ -797,6 +812,10 @@ public class ExpressionLogical extends E
                             nodes[LEFT] = node;
                             opType      = OpTypes.NOT;
 
+                            if (noOptimisation) {
+                                nodes[LEFT].setNoOptimisation();
+                            }
+
                             resolveTypes(session, parent);
 
                             break;
@@ -843,7 +862,7 @@ public class ExpressionLogical extends E
                 break;
 
             case OpTypes.IN :
-                resolveTypesForIn(session);
+                resolveTypesForAllAny(session);
                 break;
 
             case OpTypes.MATCH_SIMPLE :
@@ -1245,10 +1264,6 @@ public class ExpressionLogical extends E
         }
     }
 
-    void resolveTypesForIn(Session session) {
-        resolveTypesForAllAny(session);
-    }
-
     public Object getValue(Session session) {
 
         switch (opType) {
@@ -2454,4 +2469,17 @@ public class ExpressionLogical extends E
 
         return cost;
     }
+
+    public void setNoOptimisation() {
+
+        super.setNoOptimisation();
+
+        if (opType == OpTypes.EQUAL) {
+            if (exprSubType == OpTypes.ANY_QUANTIFIED) {
+                exprSubType  = 0;
+                opType       = OpTypes.IN;
+                isQuantified = false;
+            }
+        }
+    }
 }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/ExpressionOp.java 2.7.0-1/hsqldb/src/org/hsqldb/ExpressionOp.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/ExpressionOp.java	2021-05-22 09:08:36.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/ExpressionOp.java	2022-05-30 12:36:44.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -49,7 +49,7 @@ import org.hsqldb.types.Types;
  *
  * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.1
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class ExpressionOp extends Expression {
@@ -140,40 +140,30 @@ public class ExpressionOp extends Expres
      */
     ExpressionOp(Expression e) {
 
-        super(e.dataType.isDateTimeTypeWithZone() ? OpTypes.CAST
-                                                  : OpTypes.ZONE_MODIFIER);
+        super(OpTypes.CAST);
+
+        nodes       = new Expression[UNARY];
+        nodes[LEFT] = e;
 
         switch (e.dataType.typeCode) {
 
             case Types.SQL_TIME_WITH_TIME_ZONE :
-                nodes                = new Expression[UNARY];
-                nodes[LEFT] = new ExpressionOp(OpTypes.ZONE_MODIFIER, e, null);
-                nodes[LEFT].dataType = e.dataType;
                 dataType = DateTimeType.getDateTimeType(Types.SQL_TIME,
                         e.dataType.scale);
                 break;
 
             case Types.SQL_TIMESTAMP_WITH_TIME_ZONE :
-                nodes                = new Expression[UNARY];
-                nodes[LEFT] = new ExpressionOp(OpTypes.ZONE_MODIFIER, e, null);
-                nodes[LEFT].dataType = e.dataType;
                 dataType = DateTimeType.getDateTimeType(Types.SQL_TIMESTAMP,
                         e.dataType.scale);
                 break;
 
             case Types.SQL_TIME :
-                nodes                = new Expression[BINARY];
-                nodes[LEFT]          = e;
-                nodes[LEFT].dataType = e.dataType;
                 dataType =
                     DateTimeType.getDateTimeType(Types.SQL_TIME_WITH_TIME_ZONE,
                                                  e.dataType.scale);
                 break;
 
             case Types.SQL_TIMESTAMP :
-                nodes                = new Expression[BINARY];
-                nodes[LEFT]          = e;
-                nodes[LEFT].dataType = e.dataType;
                 dataType = DateTimeType.getDateTimeType(
                     Types.SQL_TIMESTAMP_WITH_TIME_ZONE, e.dataType.scale);
                 break;
@@ -471,23 +461,15 @@ public class ExpressionOp extends Expres
                 }
 
                 if (nodes[RIGHT] != null) {
-                    if (nodes[RIGHT].dataType == null) {
+                    Type rightDataType = nodes[RIGHT].dataType;
+
+                    if (rightDataType == null) {
                         nodes[RIGHT].dataType =
                             Type.SQL_INTERVAL_HOUR_TO_MINUTE;
-                    }
-
-                    if (nodes[RIGHT].dataType.typeCode
-                            != Types.SQL_INTERVAL_HOUR_TO_MINUTE) {
-                        if (nodes[RIGHT].opType == OpTypes.VALUE) {
-                            nodes[RIGHT].valueData =
-                                Type.SQL_INTERVAL_HOUR_TO_MINUTE.castToType(
-                                    session, nodes[RIGHT].valueData,
-                                    nodes[RIGHT].dataType);
-                            nodes[RIGHT].dataType =
-                                Type.SQL_INTERVAL_HOUR_TO_MINUTE;
-                        } else {
-                            throw Error.error(ErrorCode.X_42563);
-                        }
+                    } else if (!rightDataType.isCharacterType()
+                               && rightDataType.typeCode
+                                  != Types.SQL_INTERVAL_HOUR_TO_MINUTE) {
+                        throw Error.error(ErrorCode.X_42563);
                     }
                 }
 
@@ -969,18 +951,36 @@ public class ExpressionOp extends Expres
                     return null;
                 }
 
-                if (nodes[RIGHT] != null && rightValue == null) {
+                boolean atLocal = nodes[RIGHT] == null;
+
+                if (atLocal) {
+                    return ((DateTimeType) dataType).changeZone(session,
+                            leftValue, nodes[LEFT].dataType, 0, atLocal);
+                }
+
+                if (rightValue == null) {
                     return null;
                 }
 
-                long zoneSeconds = nodes[RIGHT] == null
-                                   ? session.getZoneSeconds()
-                                   : ((IntervalType) nodes[RIGHT].dataType)
-                                       .getSeconds(rightValue);
+                if (nodes[RIGHT].dataType.isCharacterType()) {
+                    if (DateTimeType.zoneIDs.contains(rightValue)) {
+                        return ((DateTimeType) dataType).changeZone(session,
+                                leftValue, nodes[LEFT].dataType,
+                                (String) rightValue);
+                    } else {
+                        rightValue =
+                            Type.SQL_INTERVAL_HOUR_TO_MINUTE
+                                .convertToDefaultType(session, rightValue);
+                    }
+                }
+
+                long zoneSeconds =
+                    ((IntervalType) nodes[RIGHT].dataType).getSeconds(
+                        rightValue);
 
                 return ((DateTimeType) dataType).changeZone(session,
                         leftValue, nodes[LEFT].dataType, (int) zoneSeconds,
-                        session.getZoneSeconds());
+                        false);
             }
             case OpTypes.LIMIT :
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/FunctionCustom.java 2.7.0-1/hsqldb/src/org/hsqldb/FunctionCustom.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/FunctionCustom.java	2021-05-30 14:47:20.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/FunctionCustom.java	2022-07-13 15:38:30.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -77,7 +77,7 @@ import org.hsqldb.types.Types;
  * Some functions are translated into equivalent SQL Standard functions.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.1
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class FunctionCustom extends FunctionSQL {
@@ -322,7 +322,6 @@ public class FunctionCustom extends Func
         customRegularFuncMap.put(Tokens.MONTHS_BETWEEN, FUNC_MONTHS_BETWEEN);
         customRegularFuncMap.put(Tokens.NANVL, FUNC_NANVL);
         customRegularFuncMap.put(Tokens.NEWID, FUNC_UUID);
-        customRegularFuncMap.put(Tokens.NEW_TIME, FUNC_NEW_TIME);
         customRegularFuncMap.put(Tokens.NEXT_DAY, FUNC_NEXT_DAY);
         customRegularFuncMap.put(Tokens.NUMTODSINTERVAL, FUNC_NUMTODSINTERVAL);
         customRegularFuncMap.put(Tokens.NUMTOYMINTERVAL, FUNC_NUMTOYMINTERVAL);
@@ -448,6 +447,7 @@ public class FunctionCustom extends Func
                 FunctionSQL function = new FunctionSQL(id);
 
                 function.parseList = tripleParamList;
+                function.name      = Tokens.T_SUBSTR;
 
                 return function;
             }
@@ -695,7 +695,6 @@ public class FunctionCustom extends Func
                 parseList = doubleParamList;
                 break;
 
-            case FUNC_NEW_TIME :
             case FUNC_SEQUENCE_ARRAY :
             case FUNC_TRANSLATE :
                 parseList = tripleParamList;
@@ -955,12 +954,11 @@ public class FunctionCustom extends Func
                 return new IntervalSecondData(session.getZoneSeconds(), 0);
 
             case FUNC_SESSION_TIMEZONE :
-                return new IntervalSecondData(session.sessionTimeZoneSeconds,
-                                              0);
+                return new IntervalSecondData(session.getZoneSeconds(), 0);
 
             case FUNC_DBTIMEZONE : {
-                TimestampData timestamp = Session.getSystemTimestamp(true,
-                    false);
+                TimestampData timestamp =
+                    DateTimeType.newSystemTimestampWithZone();
                 IntervalSecondData zone =
                     new IntervalSecondData(timestamp.getZone(), 0);
 
@@ -978,10 +976,10 @@ public class FunctionCustom extends Func
                 return Long.valueOf(session.getId());
             }
             case FUNC_ACTION_ID : {
-                return Long.valueOf(session.actionTimestamp);
+                return Long.valueOf(session.actionSCN);
             }
             case FUNC_TRANSACTION_ID : {
-                return Long.valueOf(session.transactionTimestamp);
+                return Long.valueOf(session.transactionSCN);
             }
             case FUNC_TRANSACTION_SIZE : {
                 return Long.valueOf(session.getTransactionSize());
@@ -1488,8 +1486,14 @@ public class FunctionCustom extends Func
 
                 if (unary) {
                     if (nodes[0].dataType.isNumberType()) {
-                        return new TimestampData(
-                            ((Number) data[0]).longValue());
+                        Calendar calendar = session.getCalendar();
+                        long     seconds  = ((Number) data[0]).longValue();
+
+                        calendar.setTimeInMillis(seconds * 1000);
+
+                        int zone = HsqlDateTime.getZoneSeconds(calendar);
+
+                        return new TimestampData(seconds + zone);
                     }
 
                     try {
@@ -1576,7 +1580,7 @@ public class FunctionCustom extends Func
                                 ((BinaryData) data[0]).getBytes());
                         }
                     } catch (NumberFormatException e) {
-                        throw Error.error(ErrorCode.X_22026);
+                        throw Error.error(ErrorCode.X_22026, e);
                     }
                 }
             }
@@ -1584,7 +1588,7 @@ public class FunctionCustom extends Func
                 TimestampData ts;
 
                 if (nodes[0] == null) {
-                    ts = session.getCurrentTimestamp(true);
+                    ts = session.getCurrentTimestamp();
                 } else {
                     if (data[0] == null) {
                         return null;
@@ -1601,7 +1605,7 @@ public class FunctionCustom extends Func
                 TimestampData ts;
 
                 if (nodes[0] == null) {
-                    ts = session.getCurrentTimestamp(true);
+                    ts = session.getCurrentTimestamp();
                 } else {
                     if (data[0] == null) {
                         return null;
@@ -2092,10 +2096,20 @@ public class FunctionCustom extends Func
                     }
                 }
 
-                int count = ((Number) data[1]).intValue();
+                int     start     = 0;
+                int     count     = ((Number) data[1]).intValue();
+                boolean hasLength = true;
+                boolean trailing  = false;
+
+                if (funcType == FUNC_RIGHT) {
+                    start     = count;
+                    count     = 0;
+                    hasLength = false;
+                    trailing  = true;
+                }
 
                 return ((CharacterType) dataType).substring(session, data[0],
-                        0, count, true, funcType == FUNC_RIGHT);
+                        start, count, hasLength, trailing);
             }
             case FUNC_SPACE : {
                 if (data[0] == null) {
@@ -2404,13 +2418,20 @@ public class FunctionCustom extends Func
                 }
 
                 TimestampData timestamp = (TimestampData) data[0];
-                IntervalSecondData zone =
-                    (IntervalSecondData) Type.SQL_INTERVAL_HOUR_TO_MINUTE
-                        .convertToDefaultType(session, data[1]);
 
-                return new TimestampData(
-                    timestamp.getSeconds() - zone.getSeconds(),
-                    timestamp.getNanos(), (int) zone.getSeconds());
+                if (DateTimeType.zoneIDs.contains(data[1])) {
+                    return ((DateTimeType) dataType).changeZone(session,
+                            timestamp, (String) data[1]);
+                } else {
+                    IntervalSecondData zone =
+                        (IntervalSecondData) Type.SQL_INTERVAL_HOUR_TO_MINUTE
+                            .convertToDefaultType(session, data[1]);
+
+                    return new TimestampData(
+                        timestamp.getSeconds() + timestamp.getZone()
+                        - zone.getSeconds(), timestamp.getNanos(),
+                                             (int) zone.getSeconds());
+                }
             }
             case FUNC_LAST_DAY : {
                 if (data[0] == null) {
@@ -2442,25 +2463,6 @@ public class FunctionCustom extends Func
 
                 return data[0];
 
-            case FUNC_NEW_TIME : {
-                if (data[0] == null || data[1] == null || data[2] == null) {
-                    return null;
-                }
-
-                IntervalSecondData zone1 =
-                    (IntervalSecondData) Type.SQL_INTERVAL_HOUR_TO_MINUTE
-                        .convertToDefaultType(session, data[1]);
-                IntervalSecondData zone2 =
-                    (IntervalSecondData) Type.SQL_INTERVAL_HOUR_TO_MINUTE
-                        .convertToDefaultType(session, data[1]);
-                Object val =
-                    Type.SQL_TIMESTAMP_WITH_TIME_ZONE.changeZone(session,
-                        data[0], Type.SQL_TIMESTAMP, (int) zone2.getSeconds(),
-                        (int) zone1.getSeconds());
-
-                return Type.SQL_TIMESTAMP.convertToType(session, val,
-                        Type.SQL_TIMESTAMP_WITH_TIME_ZONE);
-            }
             case FUNC_NEXT_DAY : {
                 if (data[0] == null || data[1] == null) {
                     return null;
@@ -2533,7 +2535,7 @@ public class FunctionCustom extends Func
             }
             case FUNC_SESSIONTIMEZONE : {
                 IntervalSecondData zone =
-                    new IntervalSecondData(session.sessionTimeZoneSeconds, 0);
+                    new IntervalSecondData(session.getZoneSeconds(), 0);
 
                 return Type.SQL_INTERVAL_HOUR_TO_MINUTE.convertToString(zone);
             }
@@ -2543,17 +2545,16 @@ public class FunctionCustom extends Func
                 }
 
                 return Type.SQL_TIMESTAMP_WITH_TIME_ZONE.changeZone(session,
-                        data[0], Type.SQL_TIMESTAMP_WITH_TIME_ZONE, 0, 0);
+                        data[0], Type.SQL_TIMESTAMP_WITH_TIME_ZONE, 0, false);
             }
             case FUNC_SYSDATE : {
-                TimestampData timestamp = Session.getSystemTimestamp(false,
-                    false);
+                TimestampData timestamp = DateTimeType.newSysDateTimestamp();
 
                 return Type.SQL_TIMESTAMP_NO_FRACTION.convertToType(session,
                         timestamp, Type.SQL_TIMESTAMP);
             }
             case FUNC_SYSTIMESTAMP : {
-                return Session.getSystemTimestamp(true, false);
+                return DateTimeType.newSystemTimestampWithZone();
             }
             case FUNC_TO_DSINTERVAL : {
                 if (data[0] == null) {
@@ -3900,6 +3901,14 @@ public class FunctionCustom extends Func
                     nodes[1].dataType = Type.SQL_VARCHAR;
                 }
 
+                if (!nodes[0].dataType.isTimestampType()) {
+                    throw Error.error(ErrorCode.X_42563);
+                }
+
+                if (!nodes[1].dataType.isCharacterType()) {
+                    throw Error.error(ErrorCode.X_42563);
+                }
+
                 dataType = Type.SQL_TIMESTAMP_WITH_TIME_ZONE;
                 break;
 
@@ -3953,22 +3962,6 @@ public class FunctionCustom extends Func
                 dataType = nodes[0].dataType;
                 break;
 
-            case FUNC_NEW_TIME :
-                if (nodes[0].dataType == null) {
-                    nodes[0].dataType = Type.SQL_TIMESTAMP_NO_FRACTION;
-                }
-
-                if (nodes[1].dataType == null) {
-                    nodes[1].dataType = Type.SQL_VARCHAR;
-                }
-
-                if (nodes[2].dataType == null) {
-                    nodes[2].dataType = Type.SQL_VARCHAR;
-                }
-
-                dataType = Type.SQL_TIMESTAMP_NO_FRACTION;
-                break;
-
             case FUNC_NEXT_DAY :
                 if (nodes[0].dataType == null) {
                     nodes[0].dataType = Type.SQL_TIMESTAMP_NO_FRACTION;
@@ -4314,7 +4307,6 @@ public class FunctionCustom extends Func
             case FUNC_MONTHS_BETWEEN :
             case FUNC_NEXT_DAY :
             case FUNC_NANVL :
-            case FUNC_NEW_TIME :
             case FUNC_NUMTODSINTERVAL :
             case FUNC_NUMTOYMINTERVAL :
             case FUNC_SESSIONTIMEZONE :
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/FunctionSQL.java 2.7.0-1/hsqldb/src/org/hsqldb/FunctionSQL.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/FunctionSQL.java	2021-01-29 13:34:34.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/FunctionSQL.java	2022-05-22 18:09:56.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -52,7 +52,7 @@ import org.hsqldb.types.Types;
  * Implementation of SQL standard function calls
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class FunctionSQL extends Expression {
@@ -545,7 +545,7 @@ public class FunctionSQL extends Express
     }
 
     /**
-     * Evaluates and returns this Function in the context of the session.<p>
+     * Evaluates and returns this Function in the context of the session.
      */
     public Object getValue(Session session) {
 
@@ -905,23 +905,27 @@ public class FunctionSQL extends Express
                                     Type.SQL_INTEGER);
             }
             case FUNC_SUBSTRING_CHAR : {
+                long    length    = 0;
+                boolean hasLength = false;
+                boolean trailing  = false;
+
                 if (data[0] == null || data[1] == null) {
                     return null;
                 }
 
+                if (nodes[2] != null && data[2] == null) {
+                    return null;
+                }
+
                 Object value;
 
                 value = Type.SQL_BIGINT.convertToType(session, data[1],
                                                       nodes[1].dataType);
 
-                long offset = ((Number) value).longValue() - 1;
-                long length = 0;
+                long offset = ((Number) value).longValue();
 
                 if (nodes[2] != null) {
-                    if (data[2] == null) {
-                        return null;
-                    }
-
+                    hasLength = true;
                     value = Type.SQL_BIGINT.convertToType(session, data[2],
                                                           nodes[2].dataType);
                     length = ((Number) value).longValue();
@@ -934,8 +938,21 @@ public class FunctionSQL extends Express
                     // not clear what the rules on USING OCTECTS are with UTF
                 }
 
+                if (session.database.sqlSyntaxOra) {
+                    if (name == Tokens.T_SUBSTR) {
+                        if (offset == 0) {
+                            offset = 1;
+                        } else if (offset < 0) {
+                            offset   = -offset + 1;
+                            trailing = true;
+                        }
+                    }
+                }
+
+                offset--;
+
                 return ((CharacterType) dataType).substring(session, data[0],
-                        offset, length, nodes[2] != null, false);
+                        offset, length, hasLength, trailing);
             }
             /*
             case FUNCTION_SUBSTRING_REG_EXPR :
@@ -1027,7 +1044,7 @@ public class FunctionSQL extends Express
                     length = ((Number) value).longValue();
                 }
 
-                return ((CharacterType) dataType).overlay(null, data[0],
+                return ((CharacterType) dataType).overlay(session, data[0],
                         data[1], offset, length, nodes[3] != null);
             }
             /*
@@ -1166,26 +1183,26 @@ public class FunctionSQL extends Express
             case FUNC_CURRENT_DATE :
                 if (session.database.sqlSyntaxOra) {
                     return dataType.convertToTypeLimits(
-                        session, session.getCurrentTimestamp(false));
+                        session, session.getLocalTimestamp());
                 }
 
                 return session.getCurrentDate();
 
             case FUNC_CURRENT_TIME :
                 return dataType.convertToTypeLimits(
-                    session, session.getCurrentTime(true));
+                    session, session.getCurrentTime());
 
             case FUNC_CURRENT_TIMESTAMP :
                 return dataType.convertToTypeLimits(
-                    session, session.getCurrentTimestamp(true));
+                    session, session.getCurrentTimestamp());
 
             case FUNC_LOCALTIME :
                 return dataType.convertToTypeLimits(
-                    session, session.getCurrentTime(false));
+                    session, session.getLocalTime());
 
             case FUNC_LOCALTIMESTAMP :
                 return dataType.convertToTypeLimits(
-                    session, session.getCurrentTimestamp(false));
+                    session, session.getLocalTimestamp());
 
             default :
                 throw Error.runtimeError(ErrorCode.U_S0500, "FunctionSQL");
@@ -2137,7 +2154,7 @@ public class FunctionSQL extends Express
     }
 
     /**
-     * Returns a String representation of this object. <p>
+     * Returns a String representation of this object.
      */
     public String describe(Session session, int blanks) {
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/HsqlDateTime.java 2.7.0-1/hsqldb/src/org/hsqldb/HsqlDateTime.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/HsqlDateTime.java	2021-02-11 11:24:42.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/HsqlDateTime.java	2022-06-28 16:10:02.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -59,7 +59,7 @@ import org.hsqldb.types.Types;
  * timezone.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 1.7.0
  */
 public class HsqlDateTime {
@@ -105,7 +105,7 @@ public class HsqlDateTime {
                 return d.getTime() / 1000;
             }
         } catch (Exception e) {
-            throw Error.error(ErrorCode.X_22007);
+            throw Error.error(ErrorCode.X_22007, e);
         }
     }
 
@@ -127,15 +127,16 @@ public class HsqlDateTime {
                 return d.getTime() / 1000;
             }
         } catch (Exception e) {
-            throw Error.error(ErrorCode.X_22007);
+            throw Error.error(ErrorCode.X_22007, e);
         }
     }
 
-    public static String getTimestampString(long seconds,
-                                          int nanos, int scale) {
+    public static String getTimestampString(long seconds, int nanos,
+            int scale) {
 
         synchronized (sdfts) {
             sysDate.setTime(seconds * 1000);
+
             String ts = sdfts.format(sysDate);
 
             if (scale > 0) {
@@ -190,26 +191,40 @@ public class HsqlDateTime {
         }
     }
 
-    public static long convertMillisFromCalendar(Calendar calendar,
-            long millis) {
-        return convertMillisFromCalendar(tempCalGMT, calendar, millis);
-    }
+    public static long convertMillisFromCalendar(Calendar sourceCalendar,
+            Calendar targetClendar, long millis) {
 
-    public static long convertMillisFromCalendar(Calendar clendarGMT,
-            Calendar calendar, long millis) {
+        synchronized (targetClendar) {
+            synchronized (sourceCalendar) {
+                targetClendar.clear();
+                sourceCalendar.setTimeInMillis(millis);
+                targetClendar.set(sourceCalendar.get(Calendar.YEAR),
+                                  sourceCalendar.get(Calendar.MONTH),
+                                  sourceCalendar.get(Calendar.DAY_OF_MONTH),
+                                  sourceCalendar.get(Calendar.HOUR_OF_DAY),
+                                  sourceCalendar.get(Calendar.MINUTE),
+                                  sourceCalendar.get(Calendar.SECOND));
+
+                return targetClendar.getTimeInMillis();
+            }
+        }
+    }
 
-        synchronized (clendarGMT) {
-            synchronized (calendar) {
-                clendarGMT.clear();
-                calendar.setTimeInMillis(millis);
-                clendarGMT.set(calendar.get(Calendar.YEAR),
-                               calendar.get(Calendar.MONTH),
-                               calendar.get(Calendar.DAY_OF_MONTH),
-                               calendar.get(Calendar.HOUR_OF_DAY),
-                               calendar.get(Calendar.MINUTE),
-                               calendar.get(Calendar.SECOND));
+    public static long convertSecondsFromCalendar(Calendar sourceCalendar,
+            Calendar targetClendar, long seconds) {
+
+        synchronized (targetClendar) {
+            synchronized (sourceCalendar) {
+                targetClendar.clear();
+                sourceCalendar.setTimeInMillis(seconds * 1000);
+                targetClendar.set(sourceCalendar.get(Calendar.YEAR),
+                                  sourceCalendar.get(Calendar.MONTH),
+                                  sourceCalendar.get(Calendar.DAY_OF_MONTH),
+                                  sourceCalendar.get(Calendar.HOUR_OF_DAY),
+                                  sourceCalendar.get(Calendar.MINUTE),
+                                  sourceCalendar.get(Calendar.SECOND));
 
-                return clendarGMT.getTimeInMillis();
+                return targetClendar.getTimeInMillis() / 1000;
             }
         }
     }
@@ -283,21 +298,6 @@ public class HsqlDateTime {
     }
 
     /**
-     * Returns the indicated part of the given millisecond date object.
-     * @param m the millisecond time value from which to extract the indicated part
-     * @param part an integer code corresponding to the desired date part
-     * @return the indicated part of the given <code>java.util.Date</code> object
-     */
-    public static int getDateTimePart(Calendar calendar, long m, int part) {
-
-        synchronized (calendar) {
-            calendar.setTimeInMillis(m);
-
-            return calendar.get(part);
-        }
-    }
-
-    /**
      * truncates millisecond date object
      */
     public static long getTruncatedPart(Calendar calendar, long m, int part) {
@@ -313,6 +313,7 @@ public class HsqlDateTime {
                     if (dayWeek == 1) {
                         dayWeek = 8;
                     }
+
                     calendar.add(Calendar.DAY_OF_YEAR, 2 - dayWeek);
                     resetToDate(calendar);
 
@@ -420,7 +421,7 @@ public class HsqlDateTime {
         }
     }
 
-    static void zeroFromPart(Calendar cal, int part) {
+    public static void zeroFromPart(Calendar cal, int part) {
 
         switch (part) {
 
@@ -533,7 +534,7 @@ public class HsqlDateTime {
 
             millis = format.parse(string).getTime();
         } catch (Exception e) {
-            throw Error.error(ErrorCode.X_22007, e.toString());
+            throw Error.error(e, ErrorCode.X_22007, e.toString());
         }
 
         if (matchIndex >= 0 && fraction) {
@@ -555,7 +556,7 @@ public class HsqlDateTime {
 
                 nanos *= (1000000 / factor);
             } catch (Exception e) {
-                throw Error.error(ErrorCode.X_22007, e.toString());
+                throw Error.error(e, ErrorCode.X_22007, e.toString());
             }
         }
 
@@ -570,7 +571,7 @@ public class HsqlDateTime {
         try {
             format.applyPattern(javaPattern);
         } catch (Exception e) {
-            throw Error.error(ErrorCode.X_22511);
+            throw Error.error(ErrorCode.X_22511, e);
         }
 
         String result     = format.format(date);
@@ -702,7 +703,7 @@ public class HsqlDateTime {
                     String s     = javaDateTokens[index];
 
                     // consecutive quoted tokens
-                    if (s.startsWith("\'") && s.endsWith("\'")) {
+                    if (s.startsWith("'") && s.endsWith("'")) {
                         if (limitQuotedToken == sb.length()) {
                             sb.setLength(sb.length() - 1);
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/HsqlNameManager.java 2.7.0-1/hsqldb/src/org/hsqldb/HsqlNameManager.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/HsqlNameManager.java	2021-01-06 12:25:58.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/HsqlNameManager.java	2022-05-23 11:24:00.000000000 +0000
@@ -211,9 +211,7 @@ public final class HsqlNameManager {
     public HsqlName newAutoName(String prefix, HsqlName schema,
                                 HsqlName parent, int type) {
 
-        HsqlName name = newAutoName(prefix, null, schema, parent, type);
-
-        return name;
+        return newAutoName(prefix, null, schema, parent, type);
     }
 
     public HsqlName newConstraintIndexName(HsqlName tableName,
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/index/IndexAVLCheck.java 2.7.0-1/hsqldb/src/org/hsqldb/index/IndexAVLCheck.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/index/IndexAVLCheck.java	2020-11-30 18:01:36.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/index/IndexAVLCheck.java	2022-06-08 10:06:52.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -31,11 +31,6 @@
 
 package org.hsqldb.index;
 
-import org.hsqldb.Table;
-import org.hsqldb.persist.RowStoreAVL;
-import org.hsqldb.result.Result;
-import org.hsqldb.lib.HsqlArrayList;
-import org.hsqldb.Session;
 import org.hsqldb.HsqlException;
 import org.hsqldb.Row;
 import org.hsqldb.Session;
@@ -47,10 +42,12 @@ import org.hsqldb.lib.OrderedLongHashSet
 import org.hsqldb.map.BitMap;
 import org.hsqldb.persist.DataFileCache;
 import org.hsqldb.persist.PersistentStore;
+import org.hsqldb.persist.RowStoreAVL;
+import org.hsqldb.result.Result;
 import org.hsqldb.rowio.RowInputBinary;
 
 /**
- * Checks indexex for insonsistencies
+ * Checks indexes for inconsistencies
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
  * @version 2.5.1
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/index/NodeAVLDisk.java 2.7.0-1/hsqldb/src/org/hsqldb/index/NodeAVLDisk.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/index/NodeAVLDisk.java	2021-01-29 13:34:34.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/index/NodeAVLDisk.java	2022-05-22 18:09:56.000000000 +0000
@@ -1,7 +1,7 @@
 /*
  * For work developed by the HSQL Development Group:
  *
- * Copyright (c) 2001-2021, The HSQL Development Group
+ * Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -70,8 +70,6 @@
 
 package org.hsqldb.index;
 
-import java.io.IOException;
-
 import org.hsqldb.RowAVL;
 import org.hsqldb.RowAVLDisk;
 import org.hsqldb.Table;
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/index/NodeAVLDiskLarge.java 2.7.0-1/hsqldb/src/org/hsqldb/index/NodeAVLDiskLarge.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/index/NodeAVLDiskLarge.java	2020-07-10 16:58:46.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/index/NodeAVLDiskLarge.java	2022-05-22 17:54:48.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -31,8 +31,6 @@
 
 package org.hsqldb.index;
 
-import java.io.IOException;
-
 import org.hsqldb.RowAVL;
 import org.hsqldb.RowAVLDisk;
 import org.hsqldb.Table;
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCBlobFile.java 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCBlobFile.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCBlobFile.java	2021-02-07 01:45:22.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCBlobFile.java	2022-04-19 16:49:40.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -291,7 +291,7 @@ public class JDBCBlobFile implements jav
      * value will be increased to accommodate the extra bytes.
      * <p>
      * <b>Note:</b> If the value specified for <code>pos</code>
-     * is greater then the length+1 of the <code>BLOB</code> value then the
+     * is greater than the length+1 of the <code>BLOB</code> value then the
      * behavior is undefined. Some JDBC drivers may throw a
      * <code>SQLException</code> while other drivers may support this
      * operation.
@@ -341,7 +341,7 @@ public class JDBCBlobFile implements jav
      * value will be increased to accommodate the extra bytes.
      * <p>
      * <b>Note:</b> If the value specified for <code>pos</code>
-     * is greater then the length+1 of the <code>BLOB</code> value then the
+     * is greater than the length+1 of the <code>BLOB</code> value then the
      * behavior is undefined. Some JDBC drivers may throw a
      * <code>SQLException</code> while other drivers may support this
      * operation.
@@ -407,7 +407,7 @@ public class JDBCBlobFile implements jav
      * value will be increased to accommodate the extra bytes.
      * <p>
      * <b>Note:</b> If the value specified for <code>pos</code>
-     * is greater then the length+1 of the <code>BLOB</code> value then the
+     * is greater than the length+1 of the <code>BLOB</code> value then the
      * behavior is undefined. Some JDBC drivers may throw a
      * <code>SQLException</code> while other drivers may support this
      * operation.
@@ -483,7 +483,7 @@ public class JDBCBlobFile implements jav
      * object represents to be <code>len</code> bytes in length.
      * <p>
      * <b>Note:</b> If the value specified for <code>pos</code>
-     * is greater then the length+1 of the <code>BLOB</code> value then the
+     * is greater than the length+1 of the <code>BLOB</code> value then the
      * behavior is undefined. Some JDBC drivers may throw a
      * <code>SQLException</code> while other drivers may support this
      * operation.
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCBlob.java 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCBlob.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCBlob.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCBlob.java	2022-04-21 06:31:02.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -68,7 +68,7 @@ import org.hsqldb.lib.java.JavaSystem;
  * <code>Blob</code> object contains a logical pointer to the
  * SQL <code>BLOB</code> data rather than the data itself.
  * A <code>Blob</code> object is valid for the duration of the
- * transaction in which is was created.
+ * transaction in which it was created.
  *
  * <P>Methods in the interfaces {@link java.sql.ResultSet},
  * {@link java.sql.CallableStatement}, and {@link java.sql.PreparedStatement}, such as
@@ -321,7 +321,7 @@ public class JDBCBlob implements Blob {
      * value will be increased to accommodate the extra bytes.
      * <p>
      * <b>Note:</b> If the value specified for <code>pos</code>
-     * is greater then the length+1 of the <code>BLOB</code> value then the
+     * is greater than the length+1 of the <code>BLOB</code> value then the
      * behavior is undefined. Some JDBC drivers may throw a
      * <code>SQLException</code> while other drivers may support this
      * operation.
@@ -389,7 +389,7 @@ public class JDBCBlob implements Blob {
      * value will be increased to accommodate the extra bytes.
      * <p>
      * <b>Note:</b> If the value specified for <code>pos</code>
-     * is greater then the length+1 of the <code>BLOB</code> value then the
+     * is greater than the length+1 of the <code>BLOB</code> value then the
      * behavior is undefined. Some JDBC drivers may throw a
      * <code>SQLException</code> while other drivers may support this
      * operation.
@@ -500,7 +500,7 @@ public class JDBCBlob implements Blob {
      * value will be increased to accommodate the extra bytes.
      * <p>
      * <b>Note:</b> If the value specified for <code>pos</code>
-     * is greater then the length+1 of the <code>BLOB</code> value then the
+     * is greater than the length+1 of the <code>BLOB</code> value then the
      * behavior is undefined. Some JDBC drivers may throw a
      * <code>SQLException</code> while other drivers may support this
      * operation.
@@ -602,7 +602,7 @@ public class JDBCBlob implements Blob {
      * object represents to be <code>len</code> bytes in length.
      * <p>
      * <b>Note:</b> If the value specified for <code>pos</code>
-     * is greater then the length+1 of the <code>BLOB</code> value then the
+     * is greater than the length+1 of the <code>BLOB</code> value then the
      * behavior is undefined. Some JDBC drivers may throw a
      * <code>SQLException</code> while other drivers may support this
      * operation.
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCCallableStatement.java 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCCallableStatement.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCCallableStatement.java	2021-01-03 20:59:20.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCCallableStatement.java	2022-06-29 13:20:18.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -57,7 +57,6 @@ import java.util.Map;
 import org.hsqldb.HsqlDateTime;
 import org.hsqldb.HsqlException;
 import org.hsqldb.SchemaObject;
-import org.hsqldb.error.Error;
 import org.hsqldb.error.ErrorCode;
 import org.hsqldb.lib.IntValueHashMap;
 import org.hsqldb.result.ResultConstants;
@@ -80,15 +79,12 @@ import java.time.Duration;
 import java.time.LocalDate;
 import java.time.LocalDateTime;
 import java.time.LocalTime;
-import java.time.OffsetDateTime;
-import java.time.OffsetTime;
 import java.time.Period;
-import java.time.ZoneOffset;
 
 //#endif JAVA8
 
 
-/* $Id: JDBCCallableStatement.java 6261 2021-01-03 21:59:13Z fredt $ */
+/* $Id: JDBCCallableStatement.java 6565 2022-06-29 14:20:12Z fredt $ */
 
 /* @todo fredt 1.9.0 - continuous review wrt multiple result sets, named parameters etc. */
 
@@ -111,7 +107,7 @@ import java.time.ZoneOffset;
 // campbell-burnet@users 2004-04-xx - doc 1.7.2 - javadocs added/updated
 // campbell-burnet@users 2005-12-07 - patch 1.8.0.x - initial JDBC 4.0 support work
 // campbell-burnet@users 2006-05-22 - doc 1.9.0 - full synch up to Mustang Build 84
-// Revision 1.14  2006/07/12 11:58:49  boucherb
+// Revision 1.14  2006/07/12 11:58:49  campbell-burnet
 //  - full synch up to Mustang b90
 
 /**
@@ -214,7 +210,7 @@ import java.time.ZoneOffset;
  *
  * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.5.1
+ * @version 2.7.0
  * @since 1.9.0
  * @see JDBCConnection#prepareCall
  * @see JDBCResultSet
@@ -1291,13 +1287,7 @@ public class JDBCCallableStatement exten
             return null;
         }
 
-        long millis = t.getSeconds() * 1000;
-
-        if (cal != null) {
-            millis = HsqlDateTime.convertMillisToCalendar(cal, millis);
-        }
-
-        return new Date(millis);
+        return (Date) Type.SQL_DATE.convertSQLToJava(session, t, cal);
     }
 
     /**
@@ -1338,24 +1328,13 @@ public class JDBCCallableStatement exten
     public synchronized Time getTime(int parameterIndex,
                                      Calendar cal) throws SQLException {
 
-        TimeData t = (TimeData) getColumnInType(parameterIndex, Type.SQL_TIME);
+        Object t = getColumnValue(parameterIndex);
 
         if (t == null) {
             return null;
         }
 
-        long millis = DateTimeType.normaliseTime(t.getSeconds()) * 1000L;
-
-        if (!parameterMetaData.columnTypes[--parameterIndex]
-                .isDateTimeTypeWithZone()) {
-            Calendar calendar = cal == null ? session.getCalendar()
-                    : cal;
-
-            millis = HsqlDateTime.convertMillisToCalendar(calendar, millis);
-            millis = HsqlDateTime.getNormalisedTime(millis);
-        }
-
-        return new Time(millis);
+        return (Time) Type.SQL_TIME.convertSQLToJava(session, t, cal);
     }
 
     /**
@@ -1396,31 +1375,14 @@ public class JDBCCallableStatement exten
     public synchronized Timestamp getTimestamp(int parameterIndex,
             Calendar cal) throws SQLException {
 
-        TimestampData t = (TimestampData) getColumnInType(parameterIndex,
-            Type.SQL_TIMESTAMP);
+
+        Object t = getColumnValue(parameterIndex);
 
         if (t == null) {
             return null;
         }
 
-        long millis = t.getSeconds() * 1000;
-
-        if (!parameterMetaData.columnTypes[--parameterIndex]
-                .isDateTimeTypeWithZone()) {
-            Calendar calendar = cal == null ? session.getCalendar()
-                    : cal;
-
-            if (cal != null) {
-                millis = HsqlDateTime.convertMillisToCalendar(calendar,
-                        millis);
-            }
-        }
-
-        Timestamp ts = new Timestamp(millis);
-
-        ts.setNanos(t.getNanos());
-
-        return ts;
+        return (Timestamp) Type.SQL_TIMESTAMP.convertSQLToJava(session, t, cal);
     }
 
     /**
@@ -3612,7 +3574,7 @@ public class JDBCCallableStatement exten
      * because it informs the driver that the parameter value should be sent to
      * the server as a <code>CLOB</code>.  When the <code>setCharacterStream</code> method is used, the
      * driver may have to do extra work to determine whether the parameter
-     * data should be send to the server as a <code>LONGVARCHAR</code> or a <code>CLOB</code>
+     * data should be sent to the server as a <code>LONGVARCHAR</code> or a <code>CLOB</code>
      * @param parameterName the name of the parameter to be set
      * @param reader An object that contains the data to set the parameter value to.
      * @param length the number of characters in the parameter data.
@@ -3670,7 +3632,7 @@ public class JDBCCallableStatement exten
      * because it informs the driver that the parameter value should be sent to
      * the server as a <code>NCLOB</code>.  When the <code>setCharacterStream</code> method is used, the
      * driver may have to do extra work to determine whether the parameter
-     * data should be send to the server as a <code>LONGNVARCHAR</code> or a <code>NCLOB</code>
+     * data should be sent to the server as a <code>LONGNVARCHAR</code> or a <code>NCLOB</code>
      *
      * @param parameterName the name of the parameter to be set
      * @param reader An object that contains the data to set the parameter value to.
@@ -4357,7 +4319,7 @@ public class JDBCCallableStatement exten
      * because it informs the driver that the parameter value should be sent to
      * the server as a <code>CLOB</code>.  When the <code>setCharacterStream</code> method is used, the
      * driver may have to do extra work to determine whether the parameter
-     * data should be send to the server as a <code>LONGVARCHAR</code> or a <code>CLOB</code>
+     * data should be sent to the server as a <code>LONGVARCHAR</code> or a <code>CLOB</code>
      *
      * <P><B>Note:</B> Consult your JDBC driver documentation to determine if
      * it might be more efficient to use a version of
@@ -4383,7 +4345,7 @@ public class JDBCCallableStatement exten
      * method because it informs the driver that the parameter value should be
      * sent to the server as a <code>BLOB</code>.  When the <code>setBinaryStream</code> method is used,
      * the driver may have to do extra work to determine whether the parameter
-     * data should be send to the server as a <code>LONGVARBINARY</code> or a <code>BLOB</code>
+     * data should be sent to the server as a <code>LONGVARBINARY</code> or a <code>BLOB</code>
      *
      * <P><B>Note:</B> Consult your JDBC driver documentation to determine if
      * it might be more efficient to use a version of
@@ -4411,7 +4373,7 @@ public class JDBCCallableStatement exten
      * because it informs the driver that the parameter value should be sent to
      * the server as a <code>NCLOB</code>.  When the <code>setCharacterStream</code> method is used, the
      * driver may have to do extra work to determine whether the parameter
-     * data should be send to the server as a <code>LONGNVARCHAR</code> or a <code>NCLOB</code>
+     * data should be sent to the server as a <code>LONGNVARCHAR</code> or a <code>NCLOB</code>
      * <P><B>Note:</B> Consult your JDBC driver documentation to determine if
      * it might be more efficient to use a version of
      * <code>setNClob</code> which takes a length parameter.
@@ -4466,13 +4428,7 @@ public class JDBCCallableStatement exten
             throw JDBCUtil.nullArgument();
         }
 
-        Type hsqlType = Types.getParameterSQLType(type);
-
-        if(hsqlType == null) {
-            throw JDBCUtil.sqlException(ErrorCode.X_42561);
-        }
-
-        Object source;
+        final Object source = getColumnValue(parameterIndex);
 
         if (wasNullValue) {
             return null;
@@ -4538,42 +4494,70 @@ public class JDBCCallableStatement exten
                 o = getTimestamp(parameterIndex);
                 break;
             }
-            case "java.util.UUID":
-                source = getColumnInType(parameterIndex, hsqlType);
-                o = Type.SQL_GUID.convertSQLToJava(session, source);
+            case "java.util.UUID": {
+                Type columnType = parameterTypes[parameterIndex - 1];
+                if (columnType.isUUIDType()) {
+                    o = Type.SQL_GUID.convertSQLToJava(session, source);
+                } else {
+                    Object value = Type.SQL_GUID.convertToTypeJDBC(session,
+                            source, columnType);
+                    o = Type.SQL_GUID.convertSQLToJava(session, value);
+                }
+                break;
+            }
+            case "java.time.Instant": {
+                Type columnType = parameterTypes[parameterIndex - 1];
+                if (columnType.isDateOrTimestampType()) {
+                    TimestampData v = (TimestampData) source;
+                    o = ((DateTimeType) columnType).toInstant(session, v);
+                }
                 break;
+            }
             case "java.time.LocalDate": {
-                source = getColumnInType(parameterIndex, hsqlType);
-                TimestampData v = (TimestampData) source;
-                long millis = v.getMillis();
-                Calendar cal = session.getCalendarGMT();
-                cal.setTimeInMillis(millis);
-                o = LocalDate.of(cal.get(Calendar.YEAR), cal.get(Calendar.MONTH) + 1, cal.get(Calendar.DAY_OF_MONTH));
+                Type columnType = parameterTypes[parameterIndex - 1];
+                if (columnType.isDateOrTimestampType()) {
+                    TimestampData v = (TimestampData) source;
+                    o = ((DateTimeType) columnType).toLocalDate(session, v);
+                }
                 break;
             }
             case "java.time.LocalTime": {
-                source = getColumnInType(parameterIndex, hsqlType);
-                TimeData v = (TimeData) source;
-                o = LocalTime.ofNanoOfDay(v.getSeconds() * 1_000_000_000L + v.getNanos());
+                Type columnType = parameterTypes[parameterIndex - 1];
+                if (columnType.isTimeType()) {
+                    TimeData v = (TimeData) source;
+                    o = ((DateTimeType) columnType).toLocalTime(session, v);
+                } else if (columnType.isTimestampType()) {
+                    TimestampData v = (TimestampData) source;
+                    o = ((DateTimeType) columnType).toLocalTime(session, v);
+                }
                 break;
             }
             case "java.time.LocalDateTime": {
-                source = getColumnInType(parameterIndex, hsqlType);
-                TimestampData v = (TimestampData) source;
-
-                long millis = v.getMillis();
-                int nanos = v.getNanos();
-                Calendar cal = session.getCalendarGMT();
-                cal.setTimeInMillis(millis);
-                o = LocalDateTime.of(cal.get(Calendar.YEAR), cal.get(Calendar.MONTH) + 1, cal.get(Calendar.DAY_OF_MONTH), cal.get(Calendar.HOUR_OF_DAY), cal.get(Calendar.MINUTE), cal.get(Calendar.SECOND ), nanos);
+                Type columnType = parameterTypes[parameterIndex - 1];
+                if (columnType.isDateOrTimestampType()) {
+                    TimestampData v = (TimestampData) source;
+                    o = ((DateTimeType) columnType).toLocalDateTime(session, v);
+                }
                 break;
             }
             case "java.time.OffsetTime": {
-                o = getTimeWithZone(parameterIndex);
+                Type columnType = parameterTypes[parameterIndex - 1];
+                if (columnType.isTimeType()) {
+                    TimeData v = (TimeData) source;
+                    o = ((DateTimeType) columnType).toOffsetTime(session, v);
+                } else if (columnType.isTimestampType()) {
+                    TimestampData v = (TimestampData) source;
+                    o = ((DateTimeType) columnType).toOffsetTime(session, v);
+                }
+
                 break;
             }
             case "java.time.OffsetDateTime": {
-                o = getTimestampWithZone(parameterIndex);
+                Type columnType = parameterTypes[parameterIndex - 1];
+                if (columnType.isDateOrTimestampType()) {
+                    TimestampData v = (TimestampData) source;
+                    o = ((DateTimeType) columnType).toOffsetDateTime(session, v);
+                }
                 break;
             }
             case "java.time.Duration": {
@@ -4582,7 +4566,6 @@ public class JDBCCallableStatement exten
                 if (!sourceType.isIntervalDaySecondType()) {
                     break;
                 }
-                source = getColumnInType(parameterIndex, hsqlType);
                 IntervalSecondData v = (IntervalSecondData) source;
                 o = Duration.ofSeconds(v.getSeconds(), v.getNanos());
                 break;
@@ -4593,7 +4576,6 @@ public class JDBCCallableStatement exten
                 if (!sourceType.isIntervalYearMonthType()) {
                     break;
                 }
-                source = getColumnInType(parameterIndex, hsqlType);
                 IntervalMonthData v = (IntervalMonthData) source;
                 int months = v.getMonths();
 
@@ -4884,7 +4866,7 @@ public class JDBCCallableStatement exten
      * If the JDBC type expected to be returned to this output parameter
      * is specific to this particular database, {@code sqlType}
      * should be {@code JDBCType.OTHER} or a {@code SQLType} that is supported
-     * by the JDBC driver..  The method
+     * by the JDBC driver.  The method
      * {@link #getObject} retrieves the value.
      *<P>
      * The default implementation will throw {@code SQLFeatureNotSupportedException}
@@ -5005,7 +4987,7 @@ public class JDBCCallableStatement exten
 
 // --------------------------- Internal Implementation -------------------------
 
-    /** parameter name => parameter index */
+    /** parameter name maps to parameter index */
     private IntValueHashMap parameterNameMap;
     private boolean         wasNullValue;
 
@@ -5103,7 +5085,7 @@ public class JDBCCallableStatement exten
 
     /**
      * Does the specialized work required to free this object's resources and
-     * that of it's parent classes. <p>
+     * that of its parent classes. <p>
      *
      * @throws SQLException if a database access error occurs
      */
@@ -5146,6 +5128,20 @@ public class JDBCCallableStatement exten
 */
 
     /**
+     * Internal get value.
+     */
+    protected Object getColumnValue(int columnIndex) throws SQLException {
+
+        checkGetParameterIndex(columnIndex);
+
+        Object value = parameterValues[columnIndex - 1];
+
+        trackNull(value);
+
+        return value;
+    }
+
+    /**
      * Internal value converter. Similar to its counterpart in JDBCResultSet <p>
      *
      * All trivially successful getXXX methods eventually go through this
@@ -5198,53 +5194,26 @@ public class JDBCCallableStatement exten
         return value;
     }
 
-//#ifdef JAVA8
     private Object getTimestampWithZone(int columnIndex) throws SQLException {
-        TimestampData v = (TimestampData) getColumnInType(columnIndex, Type.SQL_TIMESTAMP_WITH_TIME_ZONE);
+        TimestampData v = (TimestampData) getColumnInType(columnIndex,
+                Type.SQL_TIMESTAMP_WITH_TIME_ZONE);
 
         if (v == null) {
             return null;
         }
-
-        ZoneOffset z = ZoneOffset.ofTotalSeconds(v.getZone());
-        LocalDateTime ldt = LocalDateTime.ofEpochSecond(v.getSeconds(), v.getNanos(), z);
-        return OffsetDateTime.of(ldt, z);
+        return Type.SQL_TIMESTAMP_WITH_TIME_ZONE.convertSQLToJava(session, v);
     }
 
     private Object getTimeWithZone(int columnIndex) throws SQLException {
-        TimeData v = (TimeData) getColumnInType(columnIndex, Type.SQL_TIME_WITH_TIME_ZONE);
+        TimeData v = (TimeData) getColumnInType(columnIndex,
+                Type.SQL_TIME_WITH_TIME_ZONE);
 
         if (v == null) {
             return null;
         }
-
-        ZoneOffset z = ZoneOffset.ofTotalSeconds(v.getZone());
-        LocalTime lt = LocalTime.ofNanoOfDay((v.getSeconds() + v.getZone()) * 1_000_000_000L + v.getNanos());
-        return OffsetTime.of(lt, z);
+        return Type.SQL_TIME_WITH_TIME_ZONE.convertSQLToJava(session, v);
     }
 
-//#else
-/*
-    private Object getTimestampWithZone(int columnIndex) throws SQLException {
-        TimestampData v = (TimestampData) getColumnInType(columnIndex, Type.SQL_TIMESTAMP_WITH_TIME_ZONE);
-
-        if (v == null) {
-            return null;
-        }
-        return Type.SQL_TIMESTAMP.convertSQLToJava(session, v);
-    }
-
-    private Object getTimeWithZone(int columnIndex) throws SQLException {
-        TimeData v = (TimeData) getColumnInType(columnIndex, Type.SQL_TIME_WITH_TIME_ZONE);
-
-        if (v == null) {
-            return null;
-        }
-        return Type.SQL_TIME.convertSQLToJava(session, v);
-    }
-*/
-//#endif JAVA8
-
     private boolean trackNull(Object o) {
         return (wasNullValue = (o == null));
     }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCClobClient.java 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCClobClient.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCClobClient.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCClobClient.java	2022-07-26 18:24:12.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -35,16 +35,7 @@ import java.io.IOException;
 import java.io.InputStream;
 import java.io.OutputStream;
 import java.io.Reader;
-import java.io.UnsupportedEncodingException;
 import java.io.Writer;
-import java.nio.ByteBuffer;
-import java.nio.CharBuffer;
-import java.nio.charset.Charset;
-import java.nio.charset.CharsetDecoder;
-import java.nio.charset.CharsetEncoder;
-import java.nio.charset.CoderResult;
-import java.nio.charset.CodingErrorAction;
-import java.nio.charset.IllegalCharsetNameException;
 import java.sql.Clob;
 import java.sql.SQLException;
 import java.sql.SQLFeatureNotSupportedException;
@@ -61,8 +52,8 @@ import org.hsqldb.types.ClobInputStream;
  * Instances of this class are returned by calls to ResultSet methods.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.4.0
- * @since  JDK 1.2, HSQLDB 1.9.0
+ * @version 2.7.0
+ * @since HSQLDB 1.9.0
  */
 public class JDBCClobClient implements Clob {
 
@@ -70,6 +61,10 @@ public class JDBCClobClient implements C
      * Retrieves the <code>CLOB</code> value designated by this
      * <code>Clob</code> object as an ascii stream.
      *
+     * The ascii stream consists of the low ordre bytes of UTF-16 characters
+     * in the clob. The question mark character is returnd for UTF-16 characters
+     * beyond the range of 8-bit ASCII.
+     *
      * @return a <code>java.io.InputStream</code> object containing the
      *   <code>CLOB</code> data
      * @throws SQLException if there is an error accessing the
@@ -81,154 +76,56 @@ public class JDBCClobClient implements C
 
         return new InputStream() {
 
-            private final byte[] oneChar = new byte[1];
-            private boolean      m_closed;
-
-            // better size than 8192 for network connections.
-            private CharBuffer m_charBuffer =
-                (CharBuffer) CharBuffer.allocate(64 * 1024).flip();
-            private ByteBuffer m_byteBuffer = ByteBuffer.allocate(1024);
-            private Charset    m_charset    = charsetForName("US-ASCII");
-            private CharsetEncoder m_encoder =
-                m_charset.newEncoder().onMalformedInput(
-                    CodingErrorAction.REPLACE).onUnmappableCharacter(
-                    CodingErrorAction.REPLACE);
-            private Reader m_reader = clob.getCharacterStream(session);
+            private Reader reader = clob.getCharacterStream(session);
 
             public int read() throws IOException {
 
-                if (isEOF()) {
+                int c = reader.read();
+
+                if (c < 0) {
                     return -1;
                 }
 
-                synchronized (oneChar) {
-                    int charsRead = read(oneChar, 0, 1);
-
-                    return charsRead == 1 ? oneChar[0]
-                                          : -1;
-                }
+                return c < 256 ? c & 0xff
+                               : '?';
             }
 
             public int read(byte[] b, int off, int len) throws IOException {
 
-                checkClosed();
-
-                if (isEOF()) {
-                    return -1;
-                }
-
-                final CharBuffer cb = m_charBuffer;
-
-                //
-                int charsRead;
-                int bytesRead;
-
-                if (cb.remaining() == 0) {
-                    cb.clear();
-
-                    charsRead = m_reader.read(cb);
-
-                    cb.flip();
-
-                    if (charsRead < 0) {
-                        setEOF();
-
-                        return -1;
-                    } else if (charsRead == 0) {
-                        return 0;
-                    }
+                if (b == null) {
+                    throw new NullPointerException();
                 }
 
-                final ByteBuffer bb = (m_byteBuffer.capacity() < len)
-                                      ? ByteBuffer.allocate(len)
-                                      : m_byteBuffer;
-
-                // Since ASCII is single-byte, restrict encoder character consumption
-                // to at most 'len' characters' to produce at most len ASCII
-                // characters
-                int cbLimit    = cb.limit();
-                int cbPosition = cb.position();
-
-                cb.limit(cbPosition + len);
-                bb.clear();
-
-                int         bbPosition = bb.position();
-                CoderResult result     = m_encoder.encode(cb, bb, false);
-
-                if (bbPosition == bb.position() && result.isUnderflow()) {
-
-                    // surrogate character time
-                    cb.limit(cb.limit() + 1);
-                    m_encoder.encode(cb, bb, false);
+                if (off < 0 || len < 0 || len > b.length - off) {
+                    throw new IndexOutOfBoundsException();
                 }
 
-                // Restore the old limit so the buffer gets topped up
-                // when required.
-                cb.limit(cbLimit);
-                bb.flip();
-
-                bytesRead = bb.limit();
-
-                if (bytesRead == 0) {
-                    setEOF();
-
-                    return -1;
+                if (len == 0) {
+                    return 0;
                 }
 
-                m_byteBuffer = bb;
+                int bytesRead = 0;
 
-                bb.get(b, off, bytesRead);
+                for (int i = 0; i < len; i++) {
+                    int c = reader.read();
 
-                return bytesRead;
-            }
-
-            public void close() throws IOException {
-
-                boolean isClosed = m_closed;
-
-                if (!isClosed) {
-                    m_closed     = true;
-                    m_charBuffer = null;
-                    m_charset    = null;
-                    m_encoder    = null;
-
-                    try {
-                        m_reader.close();
-                    } catch (Exception ex) {}
-                }
-            }
-
-            private boolean isEOF() {
-
-                final Reader reader = m_reader;
-
-                return (reader == null);
-            }
-
-            private void setEOF() {
+                    if (c < 0) {
+                        break;
+                    }
 
-                final Reader reader = m_reader;
+                    b[off + i] = (byte) c;
 
-                if (reader != null) {
-                    try {
-                        reader.close();
-                    } catch (IOException iOException) {}
+                    bytesRead++;
                 }
 
-                m_reader = null;
+                return bytesRead == 0 ? -1 : bytesRead;
             }
 
-            private void checkClosed() throws IOException {
-
-                if (JDBCClobClient.this.isClosed()) {
-                    try {
-                        this.close();
-                    } catch (Exception ex) {}
-                }
+            public void close() throws IOException {
 
-                if (m_closed) {
-                    throw new IOException("The stream is closed.");
-                }
+                try {
+                    reader.close();
+                } catch (Exception ex) {}
             }
         };
     }
@@ -358,6 +255,10 @@ public class JDBCClobClient implements C
             }
         }
 
+        if (!isInLimits(Integer.MAX_VALUE, 0, searchstr.length())) {
+            throw JDBCUtil.outOfRangeArgument();
+        }
+
         return position(searchstr.getSubString(1, (int) searchstr.length()),
                         start);
     }
@@ -367,6 +268,9 @@ public class JDBCClobClient implements C
      * <code>CLOB</code> value that this <code>Clob</code> object represents,
      * starting at position <code>pos</code>.
      *
+     * The bytes written to the OutputStream are stored verbatim in the clob as
+     * the low order bytes of UTF-16 characters.
+     *
      * @param pos the position at which to start writing to this
      *   <code>CLOB</code> object
      * @return the stream to which ASCII encoded characters can be written
@@ -376,117 +280,39 @@ public class JDBCClobClient implements C
     public synchronized OutputStream setAsciiStream(final long pos)
     throws SQLException {
 
-        checkClosed();
-
-        if (pos < 1) {
-            throw JDBCUtil.outOfRangeArgument("pos: " + pos);
-        }
-
-        if (!isWritable) {
-            throw JDBCUtil.notUpdatableColumn();
-        }
-
-        startUpdate();
-
         return new OutputStream() {
 
-            private long    m_position = pos - 1;
-            private Charset m_charset  = charsetForName("US-ASCII");
-            private CharsetDecoder m_decoder =
-                m_charset.newDecoder().onMalformedInput(
-                    CodingErrorAction.REPLACE).onUnmappableCharacter(
-                    CodingErrorAction.REPLACE);
-            private CharBuffer   m_charBuffer = CharBuffer.allocate(64 * 1024);
-            private ByteBuffer   m_byteBuffer = ByteBuffer.allocate(1024);
-            private final byte[] oneByte      = new byte[1];
-            private boolean      m_closed;
+            Writer writer = setCharacterStream(pos);
 
             public void write(int b) throws IOException {
-
-                synchronized (oneByte) {
-                    oneByte[0] = (byte) b;
-
-                    this.write(oneByte, 0, 1);
-                }
+                writer.write(b & 0xff);
             }
 
             public void write(byte[] b, int off, int len) throws IOException {
 
-                checkClosed();
-
-                final ByteBuffer bb = (m_byteBuffer.capacity() < len)
-                                      ? ByteBuffer.allocate(len)
-                                      : m_byteBuffer;
-
-                if (m_charBuffer.remaining() < len) {
-                    flush0();
+                if (b == null) {
+                    throw new NullPointerException();
                 }
 
-                final CharBuffer cb = m_charBuffer.capacity() < len
-                                      ? CharBuffer.allocate(len)
-                                      : m_charBuffer;
-
-                bb.clear();
-                bb.put(b, off, len);
-                bb.flip();
-                m_decoder.decode(bb, cb, false);
-
-                if (cb.remaining() == 0) {
-                    flush();
+                if (off < 0 || len < 0 || len > b.length - off) {
+                    throw new IndexOutOfBoundsException();
                 }
-            }
-
-            public void flush() throws IOException {
-                checkClosed();
-                flush0();
-            }
-
-            public void close() throws IOException {
 
-                if (!m_closed) {
-                    try {
-                        flush0();
-                    } finally {
-                        m_closed     = true;
-                        m_byteBuffer = null;
-                        m_charBuffer = null;
-                        m_charset    = null;
-                        m_decoder    = null;
-                    }
+                if (len == 0) {
+                    return;
                 }
-            }
 
-            private void checkClosed() throws IOException {
+                char[] charArray = new char[len];
 
-                if (JDBCClobClient.this.isClosed()) {
-                    try {
-                        close();
-                    } catch (Exception ex) {}
+                for (int i = 0; i < len; i++) {
+                    charArray[i] = (char) b[off + i];
                 }
 
-                if (m_closed) {
-                    throw new IOException("The stream is closed.");
-                }
+                writer.write(charArray, 0, len);
             }
 
-            private void flush0() throws IOException {
-
-                final CharBuffer cb = m_charBuffer;
-
-                cb.flip();
-
-                final char[] chars = new char[cb.length()];
-
-                cb.get(chars);
-                cb.clear();
-
-                try {
-                    clob.setChars(session, m_position, chars, 0, chars.length);
-                } catch (Exception e) {
-                    throw new IOException(e.toString());
-                }
-
-                m_position += chars.length;
+            public void close() throws IOException {
+                writer.close();
             }
         };
     }
@@ -642,7 +468,7 @@ public class JDBCClobClient implements C
     //------------------------- JDBC 4.0 -----------------------------------
 
     /**
-     * This method frees the <code>Clob</code> object and releases the resources the resources
+     * This method frees the <code>Clob</code> object and releases the resources
      * that it holds.  The object is invalid once the <code>free</code> method
      * is called.
      * <p>
@@ -765,22 +591,4 @@ public class JDBCClobClient implements C
         return fullLength >= 0 && pos >= 0 && len >= 0
                && pos <= fullLength - len;
     }
-
-    protected static Charset charsetForName(final String charsetName)
-    throws SQLException {
-
-        String csn = charsetName;
-
-        if (csn == null) {
-            csn = Charset.defaultCharset().name();
-        }
-
-        try {
-            if (Charset.isSupported(csn)) {
-                return Charset.forName(csn);
-            }
-        } catch (IllegalCharsetNameException x) {}
-
-        throw JDBCUtil.sqlException(new UnsupportedEncodingException(csn));
-    }
 }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCClobFile.java 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCClobFile.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCClobFile.java	2021-02-09 04:51:18.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCClobFile.java	2022-04-19 16:49:40.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -470,7 +470,7 @@ public class JDBCClobFile implements jav
      * value will be increased to accommodate the extra characters.
      * <p>
      * <b>Note:</b> If the value specified for <code>pos</code>
-     * is greater then the length+1 of the <code>CLOB</code> value then the
+     * is greater than the length+1 of the <code>CLOB</code> value then the
      * behavior is undefined. Some JDBC drivers may throw a
      * <code>SQLException</code> while other drivers may support this
      * operation.
@@ -504,7 +504,7 @@ public class JDBCClobFile implements jav
      * value will be increased to accommodate the extra characters.
      * <p>
      * <b>Note:</b> If the value specified for <code>pos</code>
-     * is greater then the length+1 of the <code>CLOB</code> value then the
+     * is greater than the length+1 of the <code>CLOB</code> value then the
      * behavior is undefined. Some JDBC drivers may throw a
      * <code>SQLException</code> while other drivers may support this
      * operation.
@@ -609,7 +609,7 @@ public class JDBCClobFile implements jav
      * value will be increased to accommodate the extra characters.
      * <p>
      * <b>Note:</b> If the value specified for <code>pos</code>
-     * is greater then the length+1 of the <code>CLOB</code> value then the
+     * is greater than the length+1 of the <code>CLOB</code> value then the
      * behavior is undefined. Some JDBC drivers may throw a
      * <code>SQLException</code> while other drivers may support this
      * operation.
@@ -682,7 +682,7 @@ public class JDBCClobFile implements jav
      * value will be increased to accommodate the extra characters.
      * <p>
      * <b>Note:</b> If the value specified for <code>pos</code>
-     * is greater then the length+1 of the <code>CLOB</code> value then the
+     * is greater than the length+1 of the <code>CLOB</code> value then the
      * behavior is undefined. Some JDBC drivers may throw a
      * <code>SQLException</code> while other drivers may support this
      * operation.
@@ -755,7 +755,7 @@ public class JDBCClobFile implements jav
      * characters.
      * <p>
      * <b>Note:</b> If the value specified for <code>pos</code>
-     * is greater then the length+1 of the <code>CLOB</code> value then the
+     * is greater than the length+1 of the <code>CLOB</code> value then the
      * behavior is undefined. Some JDBC drivers may throw a
      * <code>SQLException</code> while other drivers may support this
      * operation.
@@ -801,7 +801,7 @@ public class JDBCClobFile implements jav
     }
 
     /**
-     * This method frees the <code>Clob</code> object and releases the resources the resources
+     * This method frees the <code>Clob</code> object and releases the resources
      * that it holds.  The object is invalid once the <code>free</code> method
      * is called.
      * <p>
@@ -969,7 +969,7 @@ public class JDBCClobFile implements jav
     }
 
     /**
-     * Constructs a new JDBCClobFile instance backed by an File object
+     * Constructs a new JDBCClobFile instance backed by a File object
      * created by File.createTempFile(TEMP_FILE_PREFIX, TEMP_FILE_SUFFIX),
      * using the given encoding to read and write file content.
      *
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCClob.java 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCClob.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCClob.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCClob.java	2022-07-07 16:32:28.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -42,7 +42,7 @@ import org.hsqldb.error.ErrorCode;
 import org.hsqldb.lib.FrameworkLogger;
 import org.hsqldb.lib.java.JavaSystem;
 
-/* $Id: JDBCClob.java 6266 2021-01-25 16:08:06Z fredt $ */
+/* $Id: JDBCClob.java 6572 2022-07-07 17:32:55Z fredt $ */
 
 // campbell-burnet@users 2004-03/04-xx - doc 1.7.2 - javadocs updated; methods put in
 //                                            correct (historical, interface
@@ -124,9 +124,6 @@ import org.hsqldb.lib.java.JavaSystem;
  */
 public class JDBCClob implements Clob {
 
-    private static final FrameworkLogger LOG =
-        FrameworkLogger.getLog(JDBCClob.class);
-
     /**
      * Retrieves the number of characters
      * in the <code>CLOB</code> value
@@ -364,7 +361,7 @@ public class JDBCClob implements Clob {
      * value will be increased to accommodate the extra characters.
      * <p>
      * <b>Note:</b> If the value specified for <code>pos</code>
-     * is greater then the length+1 of the <code>CLOB</code> value then the
+     * is greater than the length+1 of the <code>CLOB</code> value then the
      * behavior is undefined. Some JDBC drivers may throw a
      * <code>SQLException</code> while other drivers may support this
      * operation.
@@ -435,7 +432,7 @@ public class JDBCClob implements Clob {
      * value will be increased to accommodate the extra characters.
      * <p>
      * <b>Note:</b> If the value specified for <code>pos</code>
-     * is greater then the length+1 of the <code>CLOB</code> value then the
+     * is greater than the length+1 of the <code>CLOB</code> value then the
      * behavior is undefined. Some JDBC drivers may throw a
      * <code>SQLException</code> while other drivers may support this
      * operation.
@@ -685,7 +682,7 @@ public class JDBCClob implements Clob {
      * value will be increased to accommodate the extra characters.
      * <p>
      * <b>Note:</b> If the value specified for <code>pos</code>
-     * is greater then the length+1 of the <code>CLOB</code> value then the
+     * is greater than the length+1 of the <code>CLOB</code> value then the
      * behavior is undefined. Some JDBC drivers may throw a
      * <code>SQLException</code> while other drivers may support this
      * operation.
@@ -844,7 +841,7 @@ public class JDBCClob implements Clob {
     //------------------------- JDBC 4.0 -----------------------------------
 
     /**
-     * This method frees the <code>Clob</code> object and releases the resources the resources
+     * This method frees the <code>Clob</code> object and releases the resources
      * that it holds.  The object is invalid once the <code>free</code> method
      * is called.
      * <p>
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCCommonDataSource.java 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCCommonDataSource.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCCommonDataSource.java	2019-01-25 21:04:54.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCCommonDataSource.java	2022-04-02 11:54:24.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCConnection.java 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCConnection.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCConnection.java	2021-02-07 17:08:32.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCConnection.java	2022-05-22 18:09:56.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -41,6 +41,7 @@ import java.sql.NClob;
 import java.sql.PreparedStatement;
 import java.sql.SQLClientInfoException;
 import java.sql.SQLFeatureNotSupportedException;
+
 //import java.sql.SQLData;
 //import java.sql.SQLOutput;
 //import java.sql.SQLInput;
@@ -50,17 +51,17 @@ import java.sql.SQLXML;
 import java.sql.Savepoint;
 import java.sql.Statement;
 import java.sql.Struct;
-import java.util.Calendar;
+import java.util.HashMap;
 import java.util.Map;
 import java.util.Properties;
+import java.util.TimeZone;
+
 // import java.util.logging.Level;
 // import java.util.logging.Logger;
-
 import org.hsqldb.ClientConnection;
 import org.hsqldb.ClientConnectionHTTP;
 import org.hsqldb.DatabaseManager;
 import org.hsqldb.DatabaseURL;
-import org.hsqldb.HsqlDateTime;
 import org.hsqldb.HsqlException;
 import org.hsqldb.SessionInterface;
 import org.hsqldb.error.ErrorCode;
@@ -73,8 +74,7 @@ import org.hsqldb.result.ResultPropertie
 import org.hsqldb.types.ArrayType;
 import org.hsqldb.types.Type;
 
-
-/* $Id: JDBCConnection.java 6294 2021-02-07 18:08:27Z fredt $ */
+/* $Id: JDBCConnection.java 6524 2022-05-22 19:09:49Z fredt $ */
 
 // fredt@users    20020320 - patch 1.7.0 - JDBC 2 support and error trapping
 //
@@ -121,7 +121,7 @@ import org.hsqldb.types.Type;
  *  should use the appropriate <code>Connection</code> method such as
  *  <code>setAutoCommit</code> or <code>setTransactionIsolation</code>.
  *  Applications should not invoke SQL commands directly to change the connection's
- *   configuration when there is a JDBC method available.  By default a <code>Connection</code> object is in
+ *   configuration when there is a JDBC method available. By default, a <code>Connection</code> object is in
  * auto-commit mode, which means that it automatically commits changes
  * after executing each statement. If auto-commit mode has been
  * disabled, the method <code>commit</code> must be called explicitly in
@@ -220,7 +220,7 @@ import org.hsqldb.types.Type;
  * For more information on server configuration regarding mounting multiple
  * databases and assigning them <b>&lt;alias&gt;</b> values, please read the
  * Java API documentation for {@link org.hsqldb.server.Server Server} and related
- * chapters in the general documentation, especially the <em>Advanced Users
+ * chapters in the general documentation, especially the <em>HyperSQL User
  * Guide</em>.
  *
  * <hr>
@@ -361,13 +361,10 @@ import org.hsqldb.types.Type;
  *      Please read your OS file system documentation.
  * </ol> <p>
  *
- * <b>Note:</b> Versions of HSQLDB previous to 1.7.0 did not support creating
+ * <b>Note:</b>HSQLDB creates
  * directories along the file path specified in the persistent, in-process mode
  * database connection <b>&lt;url&gt;</b> form, in the case that they did
- * not already exist.  Starting with HSQLDB 1.7.0, directories <i>will</i>
- * be created if they do not already exist., but only if HSQLDB is built under
- * a version of the compiler greater than JDK 1.1.x.
- *
+ * not already exist.
  * <hr>
  *
  * <b>res: protocol Connections:</b><p>
@@ -435,7 +432,7 @@ import org.hsqldb.types.Type;
  *
  * For more information about HSQLDB file structure, various database modes
  * and other attributes such as those controlled through the HSQLDB properties
- * files, please read the general documentation, especially the Advanced Users
+ * files, please read the general documentation, especially the HyperSQL User
  * Guide. <p>
  *
  * <b>JDBC 4.0 Notes:</b><p>
@@ -443,7 +440,7 @@ import org.hsqldb.types.Type;
  * Starting with JDBC 4.0 (JDK 1.6), the <code>DriverManager</code> methods
  * <code>getConnection</code> and <code>getDrivers</code> have been
  * enhanced to support the Java Standard Edition Service Provider mechanism.
- * When built under a Java runtime that supports JDBC 4.0, HSQLDB distribution
+ * HSQLDB distribution
  * jars containing the Driver implementation also include the file
  * <code>META-INF/services/java.sql.Driver</code>. This file contains the fully
  * qualified class name ('org.hsqldb.jdbc.JDBCDriver') of the HSQLDB implementation
@@ -462,7 +459,7 @@ import org.hsqldb.types.Type;
  * </div> <!-- end release-specific documentation -->
  * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since HSQLDB 1.9.0
  * @see JDBCDriver
  * @see JDBCStatement
@@ -524,7 +521,8 @@ public class JDBCConnection implements C
 
         int props =
             ResultProperties.getValueForJDBC(JDBCResultSet.TYPE_FORWARD_ONLY,
-                JDBCResultSet.CONCUR_READ_ONLY, rsHoldability);
+                                             JDBCResultSet.CONCUR_READ_ONLY,
+                                             rsHoldability);
         Statement stmt = new JDBCStatement(this, props);
 
         return stmt;
@@ -582,16 +580,16 @@ public class JDBCConnection implements C
      * or this method is called on a closed connection
      * @see #prepareStatement(String,int,int)
      */
-    public synchronized PreparedStatement prepareStatement(
-            String sql) throws SQLException {
+    public synchronized PreparedStatement prepareStatement(String sql)
+    throws SQLException {
 
         checkClosed();
 
         try {
-            return new JDBCPreparedStatement(this, sql,
-                    JDBCResultSet.TYPE_FORWARD_ONLY,
-                    JDBCResultSet.CONCUR_READ_ONLY, rsHoldability,
-                    ResultConstants.RETURN_NO_GENERATED_KEYS, null, null);
+            return new JDBCPreparedStatement(
+                this, sql, JDBCResultSet.TYPE_FORWARD_ONLY,
+                JDBCResultSet.CONCUR_READ_ONLY, rsHoldability,
+                ResultConstants.RETURN_NO_GENERATED_KEYS, null, null);
         } catch (HsqlException e) {
             throw JDBCUtil.sqlException(e);
         }
@@ -642,8 +640,8 @@ public class JDBCConnection implements C
      * or this method is called on a closed connection
      * @see #prepareCall(String,int,int)
      */
-    public synchronized CallableStatement prepareCall(
-            String sql) throws SQLException {
+    public synchronized CallableStatement prepareCall(String sql)
+    throws SQLException {
 
         CallableStatement stmt;
 
@@ -651,8 +649,9 @@ public class JDBCConnection implements C
 
         try {
             stmt = new JDBCCallableStatement(this, sql,
-                    JDBCResultSet.TYPE_FORWARD_ONLY,
-                    JDBCResultSet.CONCUR_READ_ONLY, rsHoldability);
+                                             JDBCResultSet.TYPE_FORWARD_ONLY,
+                                             JDBCResultSet.CONCUR_READ_ONLY,
+                                             rsHoldability);
 
             return stmt;
         } catch (HsqlException e) {
@@ -736,8 +735,8 @@ public class JDBCConnection implements C
      * (JDBC4 clarification:)
      * or this method is called on a closed connection
      */
-    public synchronized String nativeSQL(
-            final String sql) throws SQLException {
+    public synchronized String nativeSQL(final String sql)
+    throws SQLException {
 
         checkClosed();
 
@@ -785,6 +784,7 @@ public class JDBCConnection implements C
                         if (sb == null) {
                             sb = new StringBuilder(sql.length());
                         }
+
                         sb.append(sql, tail, i);
 
                         i       = onStartEscapeSequence(sql, sb, i);
@@ -795,22 +795,22 @@ public class JDBCConnection implements C
 
                         state = inside_escape;
                     }
-
                     break;
+
                 case outside_escape_inside_single_quotes :    // inside ' ' only
                 case inside_escape_inside_single_quotes :     // inside { } and ' '
                     if (c == '\'') {
                         state -= 1;
                     }
-
                     break;
+
                 case outside_escape_inside_double_quotes :    // inside " " only
                 case inside_escape_inside_double_quotes :     // inside { } and " "
                     if (c == '"') {
                         state -= 2;
                     }
-
                     break;
+
                 case inside_escape :                          // inside { }
                     if (c == '\'') {
                         state = inside_escape_inside_single_quotes;
@@ -828,7 +828,7 @@ public class JDBCConnection implements C
                         nest--;
 
                         state = (nest == 0) ? outside_all
-                                : inside_escape;
+                                            : inside_escape;
                     } else if (c == '{') {
                         sb.append(sql, tail, i);
 
@@ -841,13 +841,15 @@ public class JDBCConnection implements C
                         state = inside_escape;
                     }
                     break;
-                default:
+
+                default :
             }
         }
 
         if (!changed) {
             return sql;
         }
+
         sb.append(sql.substring(tail));
 
         return sb.toString();
@@ -917,8 +919,8 @@ public class JDBCConnection implements C
      * or this method is called on a closed connection
      * @see #getAutoCommit
      */
-    public synchronized void setAutoCommit(
-            boolean autoCommit) throws SQLException {
+    public synchronized void setAutoCommit(boolean autoCommit)
+    throws SQLException {
 
         checkClosed();
 
@@ -1053,7 +1055,7 @@ public class JDBCConnection implements C
      *
      * </div> <!-- end release-specific documentation -->
      *
-     * @exception SQLException SQLException if a database access error occurs
+     * @exception SQLException if a database access error occurs
      */
     public synchronized void close() throws SQLException {
 
@@ -1064,6 +1066,7 @@ public class JDBCConnection implements C
         if (isInternal || isClosed) {
             return;
         }
+
         isClosed       = true;
         rootWarning    = null;
         connProperties = null;
@@ -1191,8 +1194,8 @@ public class JDBCConnection implements C
      *  method is called on a closed connection or this
      *            method is called during a transaction
      */
-    public synchronized void setReadOnly(
-            boolean readOnly) throws SQLException {
+    public synchronized void setReadOnly(boolean readOnly)
+    throws SQLException {
 
         checkClosed();
 
@@ -1209,7 +1212,7 @@ public class JDBCConnection implements C
      *
      * @return <code>true</code> if this <code>Connection</code> object
      *         is read-only; <code>false</code> otherwise
-     * @exception SQLException SQLException if a database access error occurs
+     * @exception SQLException if a database access error occurs
      * (JDBC4 Clarification:)
      * or this method is called on a closed connection
      */
@@ -1344,8 +1347,8 @@ public class JDBCConnection implements C
      * @see JDBCDatabaseMetaData#supportsTransactionIsolationLevel
      * @see #getTransactionIsolation
      */
-    public synchronized void setTransactionIsolation(
-            int level) throws SQLException {
+    public synchronized void setTransactionIsolation(int level)
+    throws SQLException {
 
         checkClosed();
 
@@ -1356,6 +1359,7 @@ public class JDBCConnection implements C
             case TRANSACTION_REPEATABLE_READ :
             case TRANSACTION_SERIALIZABLE :
                 break;
+
             default :
                 throw JDBCUtil.invalidArgument();
         }
@@ -1471,7 +1475,7 @@ public class JDBCConnection implements C
      *
      * </div> <!-- end release-specific documentation -->
      *
-     * @exception SQLException SQLException if a database access error occurs
+     * @exception SQLException if a database access error occurs
      * (JDBC4 Clarification:)
      * or this method is called on a closed connection
      */
@@ -1609,9 +1613,9 @@ public class JDBCConnection implements C
         checkClosed();
 
         try {
-            return new JDBCPreparedStatement(this, sql, resultSetType,
-                    resultSetConcurrency, rsHoldability,
-                    ResultConstants.RETURN_NO_GENERATED_KEYS, null, null);
+            return new JDBCPreparedStatement(
+                this, sql, resultSetType, resultSetConcurrency, rsHoldability,
+                ResultConstants.RETURN_NO_GENERATED_KEYS, null, null);
         } catch (HsqlException e) {
             throw JDBCUtil.sqlException(e);
         }
@@ -1679,7 +1683,8 @@ public class JDBCConnection implements C
 
         try {
             return new JDBCCallableStatement(this, sql, resultSetType,
-                    resultSetConcurrency, rsHoldability);
+                                             resultSetConcurrency,
+                                             rsHoldability);
         } catch (HsqlException e) {
             throw JDBCUtil.sqlException(e);
         }
@@ -1721,13 +1726,12 @@ public class JDBCConnection implements C
      * @since JDK 1.2
      * @see #setTypeMap
      */
-    public synchronized java.util
-            .Map<java.lang.String,
-                 java.lang.Class<?>> getTypeMap() throws SQLException {
+    public synchronized Map<String, Class<?>> getTypeMap()
+    throws SQLException {
 
         checkClosed();
 
-        return new java.util.HashMap<java.lang.String, java.lang.Class<?>>();
+        return new HashMap<String, Class<?>>();
     }
 
     /**
@@ -1737,7 +1741,7 @@ public class JDBCConnection implements C
      * this <code>Connection</code> object.  The type map will be used for the
      * custom mapping of SQL structured types and distinct types.
      * JDBC4.1[<p>
-     * You must set the the values for the <code>TypeMap</code> prior to
+     * You must set the values for the <code>TypeMap</code> prior to
      * calling <code>setMap</code> as a JDBC driver may create an internal copy
      * of the <code>TypeMap</code>:
      *
@@ -1771,8 +1775,8 @@ public class JDBCConnection implements C
      * @since JDK 1.2
      * @see #getTypeMap
      */
-    public synchronized void setTypeMap(Map<String,
-            Class<?>> map) throws SQLException {
+    public synchronized void setTypeMap(Map<String, Class<?>> map)
+    throws SQLException {
 
         checkClosed();
 
@@ -1788,7 +1792,7 @@ public class JDBCConnection implements C
      * Changes the default holdability of <code>ResultSet</code> objects
      * created using this <code>Connection</code> object to the given
      * holdability.  The default holdability of <code>ResultSet</code> objects
-     * can be be determined by invoking
+     * can be determined by invoking
      * {@link DatabaseMetaData#getResultSetHoldability}.
      *
      * <!-- end generic documentation -->
@@ -1813,8 +1817,8 @@ public class JDBCConnection implements C
      * @see JDBCResultSet
      * @since JDK 1.4, HSQLDB 1.7.2
      */
-    public synchronized void setHoldability(
-            int holdability) throws SQLException {
+    public synchronized void setHoldability(int holdability)
+    throws SQLException {
 
         checkClosed();
 
@@ -1823,9 +1827,11 @@ public class JDBCConnection implements C
             case JDBCResultSet.HOLD_CURSORS_OVER_COMMIT :
             case JDBCResultSet.CLOSE_CURSORS_AT_COMMIT :
                 break;
+
             default :
                 throw JDBCUtil.invalidArgument();
         }
+
         rsHoldability = holdability;
     }
 
@@ -1953,8 +1959,8 @@ public class JDBCConnection implements C
      * @see java.sql.Savepoint
      * @since JDK 1.4, HSQLDB 1.7.2
      */
-    public synchronized Savepoint setSavepoint(
-            String name) throws SQLException {
+    public synchronized Savepoint setSavepoint(String name)
+    throws SQLException {
 
         checkClosed();
 
@@ -2019,8 +2025,8 @@ public class JDBCConnection implements C
      * @see #rollback
      * @since JDK 1.4, HSQLDB 1.7.2
      */
-    public synchronized void rollback(
-            Savepoint savepoint) throws SQLException {
+    public synchronized void rollback(Savepoint savepoint)
+    throws SQLException {
 
         JDBCSavepoint sp;
 
@@ -2033,6 +2039,7 @@ public class JDBCConnection implements C
         if (!(savepoint instanceof JDBCSavepoint)) {
             throw JDBCUtil.invalidArgument(ErrorCode.X_3B001);
         }
+
         sp = (JDBCSavepoint) savepoint;
 
         if (JDBCDatabaseMetaData.JDBC_MAJOR >= 4 && sp.name == null) {
@@ -2098,8 +2105,8 @@ public class JDBCConnection implements C
      * @see java.sql.Savepoint
      * @since JDK 1.4, HSQLDB 1.7.2
      */
-    public synchronized void releaseSavepoint(
-            Savepoint savepoint) throws SQLException {
+    public synchronized void releaseSavepoint(Savepoint savepoint)
+    throws SQLException {
 
         JDBCSavepoint sp;
         Result        req;
@@ -2113,6 +2120,7 @@ public class JDBCConnection implements C
         if (!(savepoint instanceof JDBCSavepoint)) {
             throw JDBCUtil.invalidArgument(ErrorCode.X_3B001);
         }
+
         sp = (JDBCSavepoint) savepoint;
 
         if (JDBCDatabaseMetaData.JDBC_MAJOR >= 4 && sp.name == null) {
@@ -2285,9 +2293,10 @@ public class JDBCConnection implements C
         checkClosed();
 
         try {
-            return new JDBCPreparedStatement(this, sql, resultSetType,
-                    resultSetConcurrency, resultSetHoldability,
-                    ResultConstants.RETURN_NO_GENERATED_KEYS, null, null);
+            return new JDBCPreparedStatement(
+                this, sql, resultSetType, resultSetConcurrency,
+                resultSetHoldability,
+                ResultConstants.RETURN_NO_GENERATED_KEYS, null, null);
         } catch (HsqlException e) {
             throw JDBCUtil.sqlException(e);
         }
@@ -2361,7 +2370,8 @@ public class JDBCConnection implements C
 
         try {
             return new JDBCCallableStatement(this, sql, resultSetType,
-                    resultSetConcurrency, resultSetHoldability);
+                                             resultSetConcurrency,
+                                             resultSetHoldability);
         } catch (HsqlException e) {
             throw JDBCUtil.sqlException(e);
         }
@@ -2437,15 +2447,17 @@ public class JDBCConnection implements C
 
         try {
             if (autoGeneratedKeys != Statement.RETURN_GENERATED_KEYS
-                && autoGeneratedKeys != Statement.NO_GENERATED_KEYS
-                && autoGeneratedKeys != JDBCStatement.RETURN_PRIMARY_KEYS) {
+                    && autoGeneratedKeys != Statement.NO_GENERATED_KEYS
+                    && autoGeneratedKeys
+                       != JDBCStatement.RETURN_PRIMARY_KEYS) {
                 throw JDBCUtil.invalidArgument("autoGeneratedKeys");
             }
 
             return new JDBCPreparedStatement(this, sql,
-                    JDBCResultSet.TYPE_FORWARD_ONLY,
-                    JDBCResultSet.CONCUR_READ_ONLY, rsHoldability,
-                    autoGeneratedKeys, null, null);
+                                             JDBCResultSet.TYPE_FORWARD_ONLY,
+                                             JDBCResultSet.CONCUR_READ_ONLY,
+                                             rsHoldability, autoGeneratedKeys,
+                                             null, null);
         } catch (HsqlException e) {
             throw JDBCUtil.sqlException(e);
         }
@@ -2515,11 +2527,11 @@ public class JDBCConnection implements C
         checkClosed();
 
         try {
-            return new JDBCPreparedStatement(this, sql,
-                    JDBCResultSet.TYPE_FORWARD_ONLY,
-                    JDBCResultSet.CONCUR_READ_ONLY, rsHoldability,
-                    ResultConstants.RETURN_GENERATED_KEYS_COL_INDEXES,
-                    columnIndexes, null);
+            return new JDBCPreparedStatement(
+                this, sql, JDBCResultSet.TYPE_FORWARD_ONLY,
+                JDBCResultSet.CONCUR_READ_ONLY, rsHoldability,
+                ResultConstants.RETURN_GENERATED_KEYS_COL_INDEXES,
+                columnIndexes, null);
         } catch (HsqlException e) {
             throw JDBCUtil.sqlException(e);
         }
@@ -2591,11 +2603,11 @@ public class JDBCConnection implements C
         checkClosed();
 
         try {
-            return new JDBCPreparedStatement(this, sql,
-                    JDBCResultSet.TYPE_FORWARD_ONLY,
-                    JDBCResultSet.CONCUR_READ_ONLY, rsHoldability,
-                    ResultConstants.RETURN_GENERATED_KEYS_COL_NAMES, null,
-                    columnNames);
+            return new JDBCPreparedStatement(
+                this, sql, JDBCResultSet.TYPE_FORWARD_ONLY,
+                JDBCResultSet.CONCUR_READ_ONLY, rsHoldability,
+                ResultConstants.RETURN_GENERATED_KEYS_COL_NAMES, null,
+                columnNames);
         } catch (HsqlException e) {
             throw JDBCUtil.sqlException(e);
         }
@@ -2659,7 +2671,6 @@ public class JDBCConnection implements C
      *
      * @since JDK 1.6, HSQLDB 2.0
      */
-
     public NClob createNClob() throws SQLException {
 
         checkClosed();
@@ -2719,7 +2730,7 @@ public class JDBCConnection implements C
      *
      * @return true if the connection is valid, false otherwise
      * @exception SQLException if the value supplied for <code>timeout</code>
-     * is less then 0
+     * is less than 0
      * @since JDK 1.6, HSQLDB 2.0
      *
      * @see JDBCDatabaseMetaData#getClientInfoProperties
@@ -2738,7 +2749,7 @@ public class JDBCConnection implements C
             return false;
         }
 
-        final boolean[] flag = new boolean[] { true };
+        final boolean[] flag = new boolean[]{ true };
         Thread          t    = new Thread() {
 
             public void run() {
@@ -2767,8 +2778,7 @@ public class JDBCConnection implements C
 
             try {
                 t.setContextClassLoader(null);
-            } catch (Throwable th) {
-            }
+            } catch (Throwable th) {}
 
             if (timeout == 0) {
                 return flag[0];
@@ -2796,7 +2806,7 @@ public class JDBCConnection implements C
      * value in the database until the next time a statement is executed or
      * prepared.  Other than storing the client information in the appropriate
      * place in the database, these methods shall not alter the behavior of
-     * the connection in anyway.  The values supplied to these methods are
+     * the connection in any way.  The values supplied to these methods are
      * used for accounting, diagnostics and debugging purposes only.
      * <p>
      * The driver shall generate a warning if the client info name specified
@@ -2886,8 +2896,8 @@ public class JDBCConnection implements C
      * is called on a closed connection
      *
      */
-    public void setClientInfo(
-            Properties properties) throws SQLClientInfoException {
+    public void setClientInfo(Properties properties)
+    throws SQLClientInfoException {
 
         if (!this.isClosed && (properties == null || properties.isEmpty())) {
             return;
@@ -2995,6 +3005,7 @@ public class JDBCConnection implements C
         if (typeName == null) {
             throw JDBCUtil.nullArgument();
         }
+
         typeName = typeName.toUpperCase();
 
         int typeNumber = Type.getTypeNr(typeName);
@@ -3055,7 +3066,7 @@ public class JDBCConnection implements C
      * If the receiver implements the interface then the result is the receiver
      * or a proxy for the receiver. If the receiver is a wrapper
      * and the wrapped object implements the interface then the result is the
-     * wrapped object or a proxy for the wrapped object. Otherwise return the
+     * wrapped object or a proxy for the wrapped object. Otherwise return
      * the result of calling <code>unwrap</code> recursively on the wrapped object
      * or a proxy for that result. If the receiver is not a
      * wrapper and does not implement the interface, then an <code>SQLException</code> is thrown.
@@ -3067,7 +3078,7 @@ public class JDBCConnection implements C
      * @since JDK 1.6, HSQLDB 2.0
      */
     @SuppressWarnings("unchecked")
-    public <T>T unwrap(java.lang.Class<T> iface) throws java.sql.SQLException {
+    public <T>T unwrap(Class<T> iface) throws java.sql.SQLException {
 
         checkClosed();
 
@@ -3093,8 +3104,7 @@ public class JDBCConnection implements C
      * for an object with the given interface.
      * @since JDK 1.6, HSQLDB 2.0
      */
-    public boolean isWrapperFor(
-            java.lang.Class<?> iface) throws java.sql.SQLException {
+    public boolean isWrapperFor(Class<?> iface) throws SQLException {
 
         checkClosed();
 
@@ -3188,12 +3198,13 @@ public class JDBCConnection implements C
      * @see java.util.concurrent.Executor
      * @since JDK 1.7, HSQLDB 2.0.1
      */
-    public void abort(
-            java.util.concurrent.Executor executor) throws SQLException {
+    public void abort(java.util.concurrent.Executor executor)
+    throws SQLException {
 
         if (executor == null) {
             throw JDBCUtil.nullArgument("executor");
         }
+
         close();
     }
 
@@ -3219,7 +3230,7 @@ public class JDBCConnection implements C
      * JDBC connection is accessible to the administrator thread.
      * The <code>setNetworkTimeout</code> method will cover cases where
      * there is no administrator thread, or it has no access to the
-     * connection. This method is severe in it's effects, and should be
+     * connection. This method is severe in its effects, and should be
      * given a high enough value so it is never triggered before any more
      * normal timeouts, such as transaction timeouts.
      * <p>
@@ -3270,7 +3281,7 @@ public class JDBCConnection implements C
      * JDBC driver will round the value up to the nearest second.  If the
      * timeout period expires before the operation
      * completes, a SQLException will be thrown.
-     * A value of 0 indicates that there is not timeout for database operations.
+     * A value of 0 indicates that there is no timeout for database operations.
      * @throws java.sql.SQLException if a database access error occurs, this
      * method is called on a closed connection,
      * the {@code executor} is {@code null},
@@ -3316,6 +3327,8 @@ public class JDBCConnection implements C
 
 //---------------------- internal implementation ---------------------------
 // -------------------------- Common Attributes ------------------------------
+    /** Shared, reused local TimeZone which should not be modified*/
+    TimeZone timeZone = TimeZone.getDefault();
 
     /** Initial holdability */
     int rsHoldability = JDBCResultSet.HOLD_CURSORS_OVER_COMMIT;
@@ -3355,10 +3368,10 @@ public class JDBCConnection implements C
     private int savepointIDSequence;
 
     /** reuse count in ConnectionPool */
-    int                         incarnation;
+    int incarnation;
 
     /** used by a JDBCPool or other custom ConnectionPool instance */
-    boolean                     isPooled;
+    boolean isPooled;
 
     /** used by a JDBCPool or other custom ConnectionPool instance */
     JDBCConnectionEventListener poolEventListener;
@@ -3366,6 +3379,12 @@ public class JDBCConnection implements C
     /** connection URL property close_result indicates to close old result when Statement is reused */
     boolean isCloseResultSet;
 
+    /** connection URL property defult_schema for use with OpenOffic indicates to use PUBLIC schema by default */
+    boolean isDefaultSchema;
+
+    /** connection URL property memory_lobs indicates to load lobs fully into memory in ResultSet */
+    boolean isMemoryLobs;
+
     /** connection URL property use_column_name indicates to return column name in ResultMetadata */
     boolean isUseColumnName = true;
 
@@ -3373,7 +3392,7 @@ public class JDBCConnection implements C
     boolean isTranslateTTIType = true;
 
     /** connection URL property allow_empty_batch indicates to accept executeBatch() when the batch is empty */
-    boolean isEmptyBatchAllowed = false;
+    boolean isAllowEmptyBatch = false;
 
     /** database URL property hsqldb.live_object indicates to store non-serialized object in OTHER columns */
     boolean isStoreLiveObject = false;
@@ -3414,7 +3433,9 @@ public class JDBCConnection implements C
         String database = props.getProperty("database");
         boolean isTLS = (DatabaseURL.S_HSQLS.equals(connType)
                          || DatabaseURL.S_HTTPS.equals(connType));
-        boolean isTLSWrapper = props.isPropertyTrue(HsqlDatabaseProperties.url_tls_wrapper, false);
+        boolean isTLSWrapper =
+            props.isPropertyTrue(HsqlDatabaseProperties.url_tls_wrapper,
+                                 false);
 
         isTLSWrapper &= isTLS;
 
@@ -3426,32 +3447,31 @@ public class JDBCConnection implements C
             password = "";
         }
 
-        Calendar cal         = Calendar.getInstance();
-        int      zoneSeconds = HsqlDateTime.getZoneSeconds(cal);
-
         try {
             if (DatabaseURL.isInProcessDatabaseType(connType)) {
-
                 /*
                  * @todo - fredt - this should be the only static reference to
                  * a core class (apart form references to the Type package)
                  * from the jdbc package - we might make it dynamic
                  */
                 sessionProxy = DatabaseManager.newSession(connType, database,
-                        user, password, props, null, zoneSeconds);
+                        user, password, props, timeZone);
             } else if (DatabaseURL.S_HSQL.equals(connType)
                        || DatabaseURL.S_HSQLS.equals(connType)) {
                 sessionProxy = new ClientConnection(host, port, path,
-                        database, isTLS, isTLSWrapper, user, password, zoneSeconds);
+                                                    database, isTLS,
+                                                    isTLSWrapper, user,
+                                                    password, timeZone);
                 isNetConn = true;
             } else if (DatabaseURL.S_HTTP.equals(connType)
                        || DatabaseURL.S_HTTPS.equals(connType)) {
                 sessionProxy = new ClientConnectionHTTP(host, port, path,
-                        database, isTLS, isTLSWrapper, user, password, zoneSeconds);
+                        database, isTLS, isTLSWrapper, user, password, timeZone);
                 isNetConn = true;
             } else {    // alias: type not yet implemented
                 throw JDBCUtil.invalidArgument(connType);
             }
+
             sessionProxy.setJDBCConnection(this);
 
             connProperties   = props;
@@ -3531,27 +3551,32 @@ public class JDBCConnection implements C
     }
 
     private void setLocalVariables() {
+
         if (connProperties == null) {
             return;
         }
 
+        isMemoryLobs = connProperties.isPropertyTrue(
+            HsqlDatabaseProperties.url_memory_lobs, false);
         isCloseResultSet = connProperties.isPropertyTrue(
             HsqlDatabaseProperties.url_close_result, false);
+        isDefaultSchema = connProperties.isPropertyTrue(
+            HsqlDatabaseProperties.url_default_schema, false);
+        isAllowEmptyBatch = connProperties.isPropertyTrue(
+            HsqlDatabaseProperties.url_allow_empty_batch, false);
         isUseColumnName = connProperties.isPropertyTrue(
             HsqlDatabaseProperties.url_get_column_name, true);
-        isEmptyBatchAllowed = connProperties.isPropertyTrue(
-            HsqlDatabaseProperties.url_allow_empty_batch, false);
         isTranslateTTIType = clientProperties.isPropertyTrue(
             HsqlDatabaseProperties.jdbc_translate_tti_types, true);
         isStoreLiveObject = clientProperties.isPropertyTrue(
             HsqlDatabaseProperties.sql_live_object, false);
-
-        if (isStoreLiveObject)  {
+        if (isStoreLiveObject) {
             String connType = connProperties.getProperty("connection_type");
-            if(!DatabaseURL.S_MEM.equals(connType))
-            isStoreLiveObject = false;
-        }
 
+            if (!DatabaseURL.S_MEM.equals(connType)) {
+                isStoreLiveObject = false;
+            }
+        }
     }
 
     synchronized int getSavepointID() {
@@ -3566,7 +3591,7 @@ public class JDBCConnection implements C
      *      constructed
      * @throws SQLException if this connection is closed
      */
-    synchronized String getURL() throws SQLException {
+    synchronized public String getURL() throws SQLException {
 
         checkClosed();
 
@@ -3714,4 +3739,21 @@ public class JDBCConnection implements C
 
         return i;
     }
+
+    public boolean isInternal() {
+        return isInternal;
+    }
+
+    public boolean isNetwork() {
+        return isNetConn;
+    }
+
+    public HsqlProperties getConnProperties() {
+
+        HsqlProperties props = new HsqlProperties();
+
+        props.addProperties(connProperties);
+
+        return props;
+    }
 }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCDatabaseMetaData.java 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCDatabaseMetaData.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCDatabaseMetaData.java	2021-02-28 17:46:22.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCDatabaseMetaData.java	2022-06-08 10:09:06.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -40,9 +40,10 @@ import java.sql.SQLException;
 import org.hsqldb.lib.StringConverter;
 import org.hsqldb.lib.StringUtil;
 import org.hsqldb.persist.HsqlDatabaseProperties;
+import org.hsqldb.types.BlobType;
 import org.hsqldb.types.Type;
 
-/* $Id: JDBCDatabaseMetaData.java 6311 2021-02-28 18:46:14Z fredt $ */
+/* $Id: JDBCDatabaseMetaData.java 6550 2022-06-08 11:09:08Z fredt $ */
 
 // fredt@users 20020320 - patch 1.7.0 - JDBC 2 support and error trapping
 // JDBC 2 methods can now be called from jdk 1.1.x - see javadoc comments
@@ -173,20 +174,11 @@ import org.hsqldb.types.Type;
  * standard-defined full-name INFORMATION_SCHEMA views. <p>
  *
  * However, just as CATALOG semantics and handling are still considered to be
- * implementation defined by the most recent SQL standard (SQL:2008), so is the
+ * implementation defined by the most recent SQL standard (SQL:2011), so is the
  * HSQLDB CATALOG concept still in the process of being defined and refined in
  * HSQLDB 2.x. and beyond.<p>
  *
- * Previous to HSQLDB 2.x, there were, at various points in time, experimental
- * features provided to turn on pseudo catalog (and before that, pseudo-schema)
- * reporting in the system tables, using the database properties
- * 'hsqldb.catalogs' and 'hsqldb.schemas', respectively.<p>
- *
- * However, once the engine fully supported the SQL SCHEMA concept, the
- * experimental 'hsqldb.schemas' * database property was retired. <p>
- *
- * Similarly, starting with HSQLDB 2.x, the 'hsqldb.catalogs' database property
- * has been retired and replaced with the convention that, from the perspective
+ * Similarly, starting with HSQLDB 2.x, from the perspective
  * of SQL identification, an HSQLDB JDBC URL connects to a single HSQLDB
  * database instance which consists of a single, default CATALOG
  * named PUBLIC in which each SCHEMA instance of the database resides. The name of
@@ -224,7 +216,7 @@ import org.hsqldb.types.Type;
  *
  * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since HSQLDB 1.9.0
  * @see org.hsqldb.dbinfo.DatabaseInformation
  */
@@ -897,7 +889,7 @@ public class JDBCDatabaseMetaData implem
      * <div class="ReleaseSpecificDocumentation">
      * <h1>HSQLDB-Specific Information:</h1> <p>
      *
-     * From 1.7.0, HSQLDB supports this type of
+     * HSQLDB supports this type of
      * <code>ALTER TABLE</code> statement; this method always
      * returns <code>true</code>.
      * </div>
@@ -917,7 +909,7 @@ public class JDBCDatabaseMetaData implem
      * <div class="ReleaseSpecificDocumentation">
      * <h1>HSQLDB-Specific Information:</h1> <p>
      *
-     * From 1.7.0, HSQLDB supports this type of
+     * HSQLDB supports this type of
      * <code>ALTER TABLE</code> statement; this method always
      * returns <code>true</code>.
      * </div>
@@ -2971,12 +2963,7 @@ public class JDBCDatabaseMetaData implem
      * case-sensitive comparison between name (pattern) arguments and the
      * corresponding identifier values as they are stored in the database.
      * Therefore, care must be taken to specify name arguments precisely
-     * (including case) as they are stored in the database. <p>
-     *
-     * Since 1.7.2, this feature is supported by default. If the jar is
-     * compiled without org.hsqldb.dbinfo.DatabaseInformationMain, the feature is
-     * not supported. The default implementation is the
-     * org.hsqldb.dbinfo.DatabaseInformationFull class.
+     * (including case) as they are stored in the database.
      * </div>
      * <!-- end release-specific documentation -->
      *
@@ -3507,12 +3494,7 @@ public class JDBCDatabaseMetaData implem
      * case-sensitive comparison between name (pattern) arguments and the
      * corresponding identifier values as they are stored in the database.
      * Therefore, care must be taken to specify name arguments precisely
-     * (including case) as they are stored in the database. <p>
-     *
-     * Since 1.7.2, this feature is supported by default. If the jar is
-     * compiled without org.hsqldb.dbinfo.DatabaseInformationMain, the feature is
-     * not supported. The default implementation is
-     * the org.hsqldb.dbinfo.DatabaseInformationMain class.
+     * (including case) as they are stored in the database.
      * </div>
      * <!-- end release-specific documentation -->
      *
@@ -3609,12 +3591,7 @@ public class JDBCDatabaseMetaData implem
      * If the name of a column is defined in the database without double
      * quotes, an all-uppercase name must be specified when calling this
      * method. Otherwise, the name must be specified in the exact case of
-     * the column definition in the database. <p>
-     *
-     * Since 1.7.2, this feature is supported by default. If the jar is
-     * compiled without org.hsqldb.dbinfo.DatabaseInformationMain, the feature is
-     * not supported. The default implementation is
-     * the org.hsqldb.dbinfo.DatabaseInformationMain class.
+     * the column definition in the database.
      * </div>
      * <!-- end release-specific documentation -->
      *
@@ -3785,12 +3762,7 @@ public class JDBCDatabaseMetaData implem
      * case-sensitive comparison between name (pattern) arguments and the
      * corresponding identifier values as they are stored in the database.
      * Therefore, care must be taken to specify name arguments precisely
-     * (including case) as they are stored in the database. <p>
-     *
-     * Since 1.7.2, this feature is supported by default. If the jar is
-     * compiled without org.hsqldb.dbinfo.DatabaseInformationMain, the feature is
-     * not supported. The default implementation is
-     * the org.hsqldb.dbinfo.DatabaseInformationMain class.
+     * (including case) as they are stored in the database.
      * </div>
      * <!-- end release-specific documentation -->
      *
@@ -3900,12 +3872,7 @@ public class JDBCDatabaseMetaData implem
      * case-sensitive comparison between name (pattern) arguments and the
      * corresponding identifier values as they are stored in the database.
      * Therefore, care must be taken to specify name arguments precisely
-     * (including case) as they are stored in the database. <p>
-     *
-     * Since 1.7.2, this feature is supported by default. If the jar is
-     * compiled without org.hsqldb.dbinfo.DatabaseInformationMain, the feature is
-     * not supported. The default implementation is
-     * the org.hsqldb.dbinfo.DatabaseInformationMain class.
+     * (including case) as they are stored in the database.
      * </div>
      * <!-- end release-specific documentation -->
      *
@@ -4015,12 +3982,7 @@ public class JDBCDatabaseMetaData implem
      * case-sensitive comparison between name (pattern) arguments and the
      * corresponding identifier values as they are stored in the database.
      * Therefore, care must be taken to specify name arguments precisely
-     * (including case) as they are stored in the database. <p>
-     *
-     * Since 1.7.2, this feature is supported by default. If the jar is
-     * compiled without org.hsqldb.dbinfo.DatabaseInformationMain, the feature is
-     * not supported. The default implementation is
-     * the org.hsqldb.dbinfo.DatabaseInformationMain class.
+     * (including case) as they are stored in the database.
      * </div>
      * <!-- end release-specific documentation -->
      *
@@ -4135,12 +4097,7 @@ public class JDBCDatabaseMetaData implem
      * case-sensitive comparison between name (pattern) arguments and the
      * corresponding identifier values as they are stored in the database.
      * Therefore, care must be taken to specify name arguments precisely
-     * (including case) as they are stored in the database. <p>
-     *
-     * Since 1.7.2, this feature is supported by default. If the jar is
-     * compiled without org.hsqldb.dbinfo.DatabaseInformationMain, the feature is
-     * not supported. The default implementation is
-     * the org.hsqldb.dbinfo.DatabaseInformationMain class.
+     * (including case) as they are stored in the database.
      * </div>
      * <!-- end release-specific documentation -->
      *
@@ -4261,10 +4218,7 @@ public class JDBCDatabaseMetaData implem
      * <div class="ReleaseSpecificDocumentation">
      * <h1>HSQLDB-Specific Information:</h1> <p>
      *
-     * Since 1.7.2, this feature is supported by default. If the jar is
-     * compiled without org.hsqldb.dbinfo.DatabaseInformationMain, the feature is
-     * not supported. The default implementation is
-     * the org.hsqldb.dbinfo.DatabaseInformationMain class.
+     * This feature is supported.
      * </div>
      * <!-- end release-specific documentation -->
      *
@@ -4329,12 +4283,7 @@ public class JDBCDatabaseMetaData implem
      * case-sensitive comparison between name (pattern) arguments and the
      * corresponding identifier values as they are stored in the database.
      * Therefore, care must be taken to specify name arguments precisely
-     * (including case) as they are stored in the database. <p>
-     *
-     * Since 1.7.2, this feature is supported by default. If the jar is
-     * compiled without org.hsqldb.dbinfo.DatabaseInformationMain, the feature is
-     * not supported. The default implementation is
-     * the org.hsqldb.dbinfo.DatabaseInformationMain class.
+     * (including case) as they are stored in the database.
      * </div>
      * <!-- end release-specific documentation -->
      *
@@ -4780,8 +4729,7 @@ public class JDBCDatabaseMetaData implem
      * <div class="ReleaseSpecificDocumentation">
      * <h1>HSQLDB-Specific Information:</h1> <p>
      *
-     * Beginning with 1.7.2, this SQL feature is supported
-     * through JDBC as well as SQL. <p>
+     * This SQL feature is supported through JDBC as well as SQL.
      *
      * </div>
      * <!-- end release-specific documentation -->
@@ -4802,8 +4750,8 @@ public class JDBCDatabaseMetaData implem
      * <div class="ReleaseSpecificDocumentation">
      * <h1>HSQLDB-Specific Information:</h1> <p>
      *
-     * Starting with 1.7.2, HSQLDB supports JDBC named parameters to
-     * callable statements; this method returns true. <p>
+     * HSQLDB supports JDBC named parameters to
+     * callable statements; this method returns true.
      *
      * </div>
      * <!-- end release-specific documentation -->
@@ -5103,18 +5051,17 @@ public class JDBCDatabaseMetaData implem
             String catalog, String schemaPattern, String typeNamePattern,
             String attributeNamePattern) throws SQLException {
 
-        StringBuilder select = toQueryPrefixNoSelect(
-            "SELECT TABLE_NAME AS TYPE_CAT, TABLE_NAME AS TYPE_SCHME, TABLE_NAME AS TYPE_NAME, "
-            + "TABLE_NAME AS ATTR_NAME, CAST(0 AS INTEGER) AS DATA_TYPE, TABLE_NAME AS ATTR_TYPE_NAME, "
-            + "CAST(0 AS INTEGER) AS ATTR_SIZE, CAST(0 AS INTEGER) AS DECIMAL_DIGITS, "
-            + "CAST(0 AS INTEGER) AS NUM_PREC_RADIX, CAST(0 AS INTEGER) AS NULLABLE, "
-            + "'' AS REMARK, '' AS ATTR_DEF, CAST(0 AS INTEGER) AS SQL_DATA_TYPE, "
-            + "CAST(0 AS INTEGER) AS SQL_DATETIME_SUB, CAST(0 AS INTEGER) AS CHAR_OCTECT_LENGTH, "
-            + "CAST(0 AS INTEGER) AS ORDINAL_POSITION, '' AS NULLABLE, "
-            + "'' AS SCOPE_CATALOG, '' AS SCOPE_SCHEMA, '' AS SCOPE_TABLE, "
-            + "CAST(0 AS SMALLINT) AS SCOPE_DATA_TYPE "
-            + "FROM INFORMATION_SCHEMA.TABLES ").append(
-                and("TABLE_NAME", "=", ""));
+        if (wantsIsNull(typeNamePattern)
+                || wantsIsNull(attributeNamePattern)) {
+            return executeSelect("SYSTEM_UDTATTRIBUTES", "0=1");
+        }
+        schemaPattern = translateSchema(schemaPattern);
+
+        StringBuilder select = toQueryPrefix("SYSTEM_UDTATTRIBUTES").append(
+            and("TYPE_CAT", "=", catalog)).append(
+            and("TYPE_SCHEM", "LIKE", schemaPattern)).append(
+            and("TYPE_NAME", "LIKE", typeNamePattern)).append(
+            and("ATTR_NAME", "LIKE", attributeNamePattern));
 
         return execute(select.toString());
     }
@@ -5462,7 +5409,7 @@ public class JDBCDatabaseMetaData implem
      * <code>FUNCTION_NAME</code> and
      * <code>SPECIFIC_ NAME</code>.
      *
-     * <P>Each function description has the the following columns:
+     * <P>Each function description has the following columns:
      *  <OL>
      *  <LI><B>FUNCTION_CAT</B> String {@code =>} function catalog (may be <code>null</code>)
      *  <LI><B>FUNCTION_SCHEM</B> String {@code =>} function schema (may be <code>null</code>)
@@ -5815,7 +5762,7 @@ public class JDBCDatabaseMetaData implem
      */
 //#ifdef JAVA8
     public long getMaxLogicalLobSize() throws SQLException {
-        return Type.SQL_BLOB.maxBlobPrecision;
+        return BlobType.maxBlobPrecision;
     }
 
 //#endif JAVA8
@@ -5866,7 +5813,6 @@ public class JDBCDatabaseMetaData implem
      * A CSV list representing the SQL IN list to use when generating
      * queries for <code>getBestRowIdentifier</code> when the
      * <code>scope</code> argument is <code>bestRowSession</code>.
-     * @since HSQLDB 1.7.2
      */
     private static final String BRI_SESSION_SCOPE_IN_LIST = "("
         + bestRowSession + ")";
@@ -5875,7 +5821,6 @@ public class JDBCDatabaseMetaData implem
      * A CSV list representing the SQL IN list to use when generating
      * queries for <code>getBestRowIdentifier</code> when the
      * <code>scope</code> argument is <code>bestRowTemporary</code>.
-     * @since HSQLDB 1.7.2
      */
     private static final String BRI_TEMPORARY_SCOPE_IN_LIST = "("
         + bestRowTemporary + "," + bestRowTransaction + "," + bestRowSession
@@ -5885,7 +5830,6 @@ public class JDBCDatabaseMetaData implem
      * A CSV list representing the SQL IN list to use when generating
      * queries for <code>getBestRowIdentifier</code> when the
      * <code>scope</code> argument is <code>bestRowTransaction</code>.
-     * @since HSQLDB 1.7.2
      */
     private static final String BRI_TRANSACTION_SCOPE_IN_LIST = "("
         + bestRowTransaction + "," + bestRowSession + ")";
@@ -5894,9 +5838,7 @@ public class JDBCDatabaseMetaData implem
      * "SELECT * FROM ". <p>
      *
      * This attribute is in support of methods that use SQL SELECT statements to
-     * generate returned <code>ResultSet</code> objects. <p>
-     *
-     * @since HSQLDB 1.7.2
+     * generate returned <code>ResultSet</code> objects.
      */
     private static final String selstar = "SELECT * FROM INFORMATION_SCHEMA.";
 
@@ -5906,12 +5848,11 @@ public class JDBCDatabaseMetaData implem
      * This attribute is in support of methods that use SQL SELECT statements to
      * generate returned <code>ResultSet</code> objects. <p>
      *
-     * A good optimizer will simply drop this when parsing a condition
+     * The optimizer will simply drop this when parsing a condition
      * expression. And it makes our code much easier to write, since we don't
      * have to check our "WHERE" clause productions as strictly for proper
      * conjunction:  we just stick additional conjunctive predicates on the
-     * end of this and Presto! Everything works :-) <p>
-     * @since HSQLDB 1.7.2
+     * end of this and Presto! Everything works :-)
      */
     private static final String whereTrue = " WHERE TRUE";
 
@@ -5943,9 +5884,7 @@ public class JDBCDatabaseMetaData implem
         // PRE: is non-null and not closed
         connection       = c;
         useSchemaDefault = c.isInternal ? false
-                                        : c.connProperties
-                                        .isPropertyTrue(HsqlDatabaseProperties
-                                            .url_default_schema);
+                                        : c.isDefaultSchema;
     }
 
     /**
@@ -5966,14 +5905,14 @@ public class JDBCDatabaseMetaData implem
      *
      * @param val an object representing the value to use in some conditional
      *      operation, op, between the column identified by the id argument
-     *      and this argument. <p>
+     *      and this argument.
      *
      *      <UL>
-     *          <LI>null causes the empty string to be returned. <p>
+     *          <LI>null causes the empty string to be returned.
      *
      *          <LI>toString().length() == 0 causes the returned expression
      *              to be built so that the IS NULL operation will occur
-     *              against the specified column. <p>
+     *              against the specified column.
      *
      *          <LI>instanceof String causes the returned expression to be
      *              built so that the specified operation will occur between
@@ -5982,7 +5921,7 @@ public class JDBCDatabaseMetaData implem
      *              escaped by doubling). If <code>op</code> is "LIKE" and
      *              <code>val</code> does not contain any "%" or "_" wild
      *              card characters, then <code>op</code> is silently
-     *              converted to "=". <p>
+     *              converted to "=".
      *
      *          <LI>!instanceof String causes an expression to built so that
      *              the specified operation will occur between the specified
@@ -6148,7 +6087,7 @@ public class JDBCDatabaseMetaData implem
 
     /**
      * Retrieves whether the JDBC <code>DatabaseMetaData</code> contract
-     * specifies that the argument <code>s</code>code> is filter parameter
+     * specifies that the argument <code>s</code> is filter parameter
      * value that requires a corresponding IS NULL predicate. <p>
      *
      * @param s the filter parameter to test
@@ -6183,6 +6122,29 @@ public class JDBCDatabaseMetaData implem
 
         rs.close();
     }
+
+    /**
+     * Returns the name of the default collation for database.
+     * @return name of collation
+     */
+    public String getDatabaseDefaultCollation() {
+
+        String value = null;
+        try {
+            ResultSet rs = executeSelect("SYSTEM_PROPERTIES",
+                "PROPERTY_NAME = 'sql.default_collation'");
+
+            if (rs.next()) {
+                value = rs.getString(4);
+            }
+
+            rs.close();
+        } catch (Exception e) {
+        }
+
+        return value;
+    }
+
     /**
      * Returns the name of the default schema for database.
      */
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCDataSource.java 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCDataSource.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCDataSource.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCDataSource.java	2022-04-21 06:31:02.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -182,7 +182,7 @@ public class JDBCDataSource extends JDBC
      * If the receiver implements the interface then the result is the receiver
      * or a proxy for the receiver. If the receiver is a wrapper
      * and the wrapped object implements the interface then the result is the
-     * wrapped object or a proxy for the wrapped object. Otherwise return the
+     * wrapped object or a proxy for the wrapped object. Otherwise return
      * the result of calling <code>unwrap</code> recursively on the wrapped object
      * or a proxy for that result. If the receiver is not a
      * wrapper and does not implement the interface, then an <code>SQLException</code> is thrown.
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCDriver.java 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCDriver.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCDriver.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCDriver.java	2022-04-21 16:08:00.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -107,7 +107,7 @@ import org.hsqldb.persist.HsqlProperties
  * <hr>
  * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.4.0
+ * @version 2.7.0
  * @since HSQLDB 1.9.0
  * </div> <!-- end release-specific documentation -->
  *
@@ -115,6 +115,11 @@ import org.hsqldb.persist.HsqlProperties
  */
 public class JDBCDriver implements Driver {
 
+
+    /**
+     * name of loginTimeout property, can not change
+     */
+    static final String conn_loginTimeout = "loginTimeout";
     /**
      * Default constructor
      */
@@ -218,10 +223,6 @@ public class JDBCDriver implements Drive
                               DatabaseURL.S_URL_INTERNAL.length())) {
             JDBCConnection conn = threadConnection.get();
 
-            if (conn == null) {
-                return null;
-            }
-
             return conn;
         }
 
@@ -259,7 +260,7 @@ public class JDBCDriver implements Drive
         long timeout = 0;
 
         if (info != null) {
-            timeout = HsqlProperties.getIntegerProperty(info, "loginTimeout", 0);
+            timeout = HsqlProperties.getIntegerProperty(info, conn_loginTimeout, 0);
         }
 
         props.addProperties(info);
@@ -508,8 +509,7 @@ public class JDBCDriver implements Drive
     /**
      * As a separate instance of this class is registered with DriverManager
      * for each class loader, the threadConnection is not declared as static.
-     * The registered instance is kept to allow access to the its
-     * threadConnection.
+     * The registered instance is kept to allow access to its threadConnection.
      *
      */
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCNClob.java 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCNClob.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCNClob.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCNClob.java	2022-04-21 06:31:02.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -40,7 +40,7 @@ import java.sql.NClob;
  * that stores a Character Large Object using the National Character Set
  *  as a column value in a row of  a database table.
  * <P>The <code>NClob</code> interface extends the <code>Clob</code> interface
- * which provides provides methods for getting the
+ * which provides methods for getting the
  * length of an SQL <code>NCLOB</code> value,
  * for materializing a <code>NCLOB</code> value on the client, and for
  * searching for a substring or <code>NCLOB</code> object within a
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCParameterMetaData.java 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCParameterMetaData.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCParameterMetaData.java	2021-01-29 13:39:14.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCParameterMetaData.java	2022-05-17 12:18:14.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -40,7 +40,7 @@ import org.hsqldb.result.ResultMetaData;
 import org.hsqldb.types.IntervalType;
 import org.hsqldb.types.Type;
 
-/* $Id: JDBCParameterMetaData.java 6271 2021-01-29 14:39:07Z fredt $ */
+/* $Id: JDBCParameterMetaData.java 6509 2022-05-17 13:18:08Z fredt $ */
 
 /* @todo 1.9.0 - implement internal support for INOUT, OUT return parameter */
 
@@ -65,7 +65,7 @@ import org.hsqldb.types.Type;
  * object.
  *
  * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since JDK 1.4, HSQLDB 1.7.2
  */
 public class JDBCParameterMetaData implements ParameterMetaData,
@@ -258,7 +258,7 @@ public class JDBCParameterMetaData imple
      * If the receiver implements the interface then the result is the receiver
      * or a proxy for the receiver. If the receiver is a wrapper
      * and the wrapped object implements the interface then the result is the
-     * wrapped object or a proxy for the wrapped object. Otherwise return the
+     * wrapped object or a proxy for the wrapped object. Otherwise return
      * the result of calling <code>unwrap</code> recursively on the wrapped object
      * or a proxy for that result. If the receiver is not a
      * wrapper and does not implement the interface, then an <code>SQLException</code> is thrown.
@@ -311,10 +311,9 @@ public class JDBCParameterMetaData imple
      * Creates a new instance of JDBCParameterMetaData. <p>
      *
      * @param metaData A ResultMetaData object describing the statement parameters
-     * @throws SQLException never - reserved for future use
      */
     JDBCParameterMetaData(JDBCConnection conn,
-                          ResultMetaData metaData) throws SQLException {
+                          ResultMetaData metaData) {
 
         rmd              = metaData;
         parameterCount   = rmd.getColumnCount();
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCPool.java 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCPool.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCPool.java	2021-02-07 01:10:32.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCPool.java	2022-04-19 16:49:40.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -177,7 +177,7 @@ public class JDBCPool implements DataSou
      * or a proxy for the receiver. If the receiver is a wrapper
      * and the wrapped object implements the interface then the result is the
      * wrapped object or a proxy for the wrapped object. Otherwise return the
-     * the result of calling <code>unwrap</code> recursively on the wrapped object
+     * result of calling <code>unwrap</code> recursively on the wrapped object
      * or a proxy for that result. If the receiver is not a
      * wrapper and does not implement the interface, then an <code>SQLException</code> is thrown.
      *
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCPreparedStatement.java 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCPreparedStatement.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCPreparedStatement.java	2021-01-29 13:39:14.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCPreparedStatement.java	2022-06-29 13:20:18.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -101,8 +101,7 @@ import java.sql.SQLType;
 
 //#endif JAVA8
 
-
-/* $Id: JDBCPreparedStatement.java 6271 2021-01-29 14:39:07Z fredt $ */
+/* $Id: JDBCPreparedStatement.java 6565 2022-06-29 14:20:12Z fredt $ */
 
 // changes by fredt
 // SimpleDateFormat objects moved out of methods to improve performance
@@ -229,13 +228,13 @@ import java.sql.SQLType;
  *
  * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 1.9.0
  * @see JDBCConnection#prepareStatement
  * @see JDBCResultSet
  */
-public class JDBCPreparedStatement extends JDBCStatementBase implements
-    PreparedStatement {
+public class JDBCPreparedStatement extends JDBCStatementBase
+implements PreparedStatement {
 
     /**
      * <!-- start generic documentation -->
@@ -254,6 +253,7 @@ public class JDBCPreparedStatement exten
         if (statementRetType != StatementTypes.RETURN_RESULT) {
             checkStatementType(StatementTypes.RETURN_RESULT);
         }
+
         fetchResult();
 
         return getResultSet();
@@ -280,6 +280,7 @@ public class JDBCPreparedStatement exten
         if (statementRetType != StatementTypes.RETURN_COUNT) {
             checkStatementType(StatementTypes.RETURN_COUNT);
         }
+
         fetchResult();
 
         return resultIn.getUpdateCount();
@@ -505,7 +506,7 @@ public class JDBCPreparedStatement exten
      * this method is called on a closed <code>PreparedStatement</code>
      */
     public synchronized void setBigDecimal(int parameterIndex,
-            BigDecimal x) throws SQLException {
+                                           BigDecimal x) throws SQLException {
         setParameter(parameterIndex, x);
     }
 
@@ -617,7 +618,7 @@ public class JDBCPreparedStatement exten
      */
     public synchronized void setTime(int parameterIndex,
                                      Time x) throws SQLException {
-        setTime(parameterIndex, x, null);
+        setParameter(parameterIndex, x);
     }
 
     /**
@@ -646,8 +647,8 @@ public class JDBCPreparedStatement exten
      * this method is called on a closed <code>PreparedStatement</code>
      */
     public synchronized void setTimestamp(int parameterIndex,
-            Timestamp x) throws SQLException {
-        setTimestamp(parameterIndex, x, null);
+                                          Timestamp x) throws SQLException {
+        setParameter(parameterIndex, x);
     }
 
     /* @todo 1.9.0 - implement streaming */
@@ -719,16 +720,9 @@ public class JDBCPreparedStatement exten
      * <div class="ReleaseSpecificDocumentation">
      * <h1>HSQLDB-Specific Information:</h1> <p>
      *
-     * From 1.7.0 to 1.8.0.x, this method complies with behavior as defined by
-     * the JDBC3 specification (the stream is treated as though it has UTF16
-     * encoding). <p>
-     *
      * Starting with 2.0, this method behaves according to the JDBC4
-     * specification (the stream is treated as though it has UTF-8
-     * encoding, as defined in the Java Virtual Machine Specification) when
-     * built under JDK 1.6+; otherwise, it behaves as defined by the JDBC3
-     * specification.  Regardless, this method is deprecated: please use
-     * setCharacterStream(...) instead.
+     * specification (the stream is treated as though it has UTF-8 encoding.
+     * This method is deprecated: please use setCharacterStream(...) instead.
      * </div>
      * <!-- end release-specific documentation -->
      *
@@ -776,8 +770,9 @@ public class JDBCPreparedStatement exten
             }
         } catch (IOException ex) {
             throw JDBCUtil.sqlException(ErrorCode.SERVER_TRANSFER_CORRUPTED,
-                                    ex.toString(), ex);
+                                        ex.toString(), ex);
         }
+
         setParameter(parameterIndex, writer.toString());
     }
 
@@ -834,6 +829,7 @@ public class JDBCPreparedStatement exten
         if (isClosed || connection.isClosed) {
             checkClosed();
         }
+
         Arrays.fill(parameterValues, null);
         Arrays.fill(parameterSet, false);
         Arrays.fill(streamLengths, 0, streamLengths.length, 0);
@@ -1066,6 +1062,7 @@ public class JDBCPreparedStatement exten
         if (isClosed || connection.isClosed) {
             checkClosed();
         }
+
         checkParametersSet();
 
         if (!isBatch) {
@@ -1203,10 +1200,11 @@ public class JDBCPreparedStatement exten
                 setBlobForBinaryParameter(parameterIndex, x);
 
                 return;
+
             case Types.SQL_BLOB :
                 setBlobParameter(parameterIndex, x);
-
                 break;
+
             default :
                 throw JDBCUtil.invalidArgument();
         }
@@ -1216,7 +1214,7 @@ public class JDBCPreparedStatement exten
      * Converts a blob to binary data for non-blob binary parameters.
      */
     private void setBlobForBinaryParameter(int parameterIndex,
-            Blob x) throws SQLException {
+                                           Blob x) throws SQLException {
 
         if (x instanceof JDBCBlob) {
             setParameter(parameterIndex, ((JDBCBlob) x).data());
@@ -1245,7 +1243,7 @@ public class JDBCPreparedStatement exten
             out.close();
         } catch (Throwable e) {
             throw JDBCUtil.sqlException(ErrorCode.JDBC_INPUTSTREAM_ERROR,
-                                    e.toString(), e);
+                                        e.toString(), e);
         }
     }
 
@@ -1297,17 +1295,19 @@ public class JDBCPreparedStatement exten
                 setClobForStringParameter(parameterIndex, x);
 
                 return;
+
             case Types.SQL_CLOB :
                 setClobParameter(parameterIndex, x);
 
                 return;
+
             default :
                 throw JDBCUtil.invalidArgument();
         }
     }
 
     private void setClobForStringParameter(int parameterIndex,
-            Clob x) throws SQLException {
+                                           Clob x) throws SQLException {
 
         if (x instanceof JDBCClob) {
             setParameter(parameterIndex, ((JDBCClob) x).getData());
@@ -1334,7 +1334,7 @@ public class JDBCPreparedStatement exten
             setParameter(parameterIndex, writer.toString());
         } catch (Throwable e) {
             throw JDBCUtil.sqlException(ErrorCode.SERVER_TRANSFER_CORRUPTED,
-                                    e.toString(), e);
+                                        e.toString(), e);
         }
     }
 
@@ -1383,10 +1383,9 @@ public class JDBCPreparedStatement exten
         Object[] data = null;
 
         if (x instanceof JDBCArray) {
-            Type     baseType = type.collectionBaseType();
-            Object[] array    = ((JDBCArray) x).getArrayInternal();
-
-            Type otherType = ((JDBCArray) x).arrayType;
+            Type     baseType  = type.collectionBaseType();
+            Object[] array     = ((JDBCArray) x).getArrayInternal();
+            Type     otherType = ((JDBCArray) x).arrayType;
 
             data = (Object[]) type.convertToType(session, array, otherType);
         } else {
@@ -1407,6 +1406,7 @@ public class JDBCPreparedStatement exten
                 throw JDBCUtil.notSupported();
             }
         }
+
         parameterValues[index] = data;
         parameterSet[index]    = true;
     }
@@ -1471,6 +1471,7 @@ public class JDBCPreparedStatement exten
                     }
                 }
             }
+
             resultSetMetaData = new JDBCResultSetMetaData(resultMetaData,
                     isUpdatable, isInsertable, connection);
         }
@@ -1503,43 +1504,31 @@ public class JDBCPreparedStatement exten
 
         checkSetParameterIndex(parameterIndex);
 
-        int i = parameterIndex - 1;
+        int index = parameterIndex - 1;
 
         if (x == null) {
-            parameterValues[i] = null;
-            parameterSet[i]    = true;
+            parameterValues[index] = null;
+            parameterSet[index]    = true;
 
             return;
         }
 
-        Type outType = parameterTypes[i];
-        Calendar calendar = cal == null ? session.getCalendar()
-                : cal;
-
-        long millis = HsqlDateTime.convertMillisFromCalendar(
-                session.getCalendarGMT(), calendar, x.getTime());
-
-        millis = HsqlDateTime.getNormalisedDate(session.getCalendarGMT(),
-                millis);
+        Type outType = parameterTypes[index];
 
         switch (outType.typeCode) {
 
             case Types.SQL_DATE :
             case Types.SQL_TIMESTAMP :
-                parameterValues[i] = new TimestampData(millis / 1000);
-
-                break;
             case Types.SQL_TIMESTAMP_WITH_TIME_ZONE :
-                int zoneOffset = HsqlDateTime.getZoneMillis(calendar, millis);
-
-                parameterValues[i] = new TimestampData(millis / 1000, 0,
-                        zoneOffset / 1000);
-
                 break;
             default :
                 throw JDBCUtil.sqlException(ErrorCode.X_42561);
         }
-        parameterSet[i] = true;
+
+        Object value = ((DateTimeType)outType).convertJavaToSQL(session, x, cal);
+
+        parameterValues[index] = value;
+        parameterSet[index] = true;
     }
 
     /**
@@ -1586,30 +1575,20 @@ public class JDBCPreparedStatement exten
             return;
         }
 
-        Type     outType    = parameterTypes[index];
-        long     millis     = x.getTime();
-        int      zoneOffset = 0;
-        Calendar calendar   = cal == null ? session.getCalendar()
-                : cal;
-
-        millis = HsqlDateTime.convertMillisFromCalendar(
-                session.getCalendarGMT(), calendar, millis);
-        millis = HsqlDateTime.convertToNormalisedTime(session.getCalendarGMT(),
-                millis);
+        Type outType = parameterTypes[index];
 
         switch (outType.typeCode) {
 
             case Types.SQL_TIME :
-                break;
             case Types.SQL_TIME_WITH_TIME_ZONE :
-                zoneOffset = HsqlDateTime.getZoneMillis(calendar, millis);
-
                 break;
             default :
                 throw JDBCUtil.sqlException(ErrorCode.X_42561);
         }
-        parameterValues[index] = new TimeData((int) (millis / 1000), 0,
-                zoneOffset / 1000);
+
+        Object value = ((DateTimeType)outType).convertJavaToSQL(session, x, cal);
+
+        parameterValues[index] = value;
         parameterSet[index] = true;
     }
 
@@ -1649,7 +1628,7 @@ public class JDBCPreparedStatement exten
      * @since JDK 1.2
      */
     public synchronized void setTimestamp(int parameterIndex, Timestamp x,
-            Calendar cal) throws SQLException {
+                                          Calendar cal) throws SQLException {
 
         checkSetParameterIndex(parameterIndex);
 
@@ -1662,62 +1641,22 @@ public class JDBCPreparedStatement exten
             return;
         }
 
-        Type     outType    = parameterTypes[index];
-        long     millis     = x.getTime();
-        long     seconds;
-        int      zoneOffset = 0;
-        Calendar calendar   = cal == null ? session.getCalendar()
-                : cal;
+        Type outType = parameterTypes[index];
 
-        millis = HsqlDateTime.convertMillisFromCalendar(
-                session.getCalendarGMT(),calendar, millis);
         switch (outType.typeCode) {
-
             case Types.SQL_TIMESTAMP_WITH_TIME_ZONE :
-                zoneOffset = HsqlDateTime.getZoneMillis(calendar, millis);
-
-            // fall through
             case Types.SQL_TIMESTAMP :
-                seconds    = millis / 1000;
-                if (seconds < DateTimeType.epochSeconds
-                    || seconds > DateTimeType.epochLimitSeconds) {
-                    throw JDBCUtil.sqlException(ErrorCode.X_22008);
-                }
-                parameterValues[index] = new TimestampData(seconds,
-                        x.getNanos(), zoneOffset / 1000);
-
-                break;
             case Types.SQL_TIME :
-                millis = HsqlDateTime.getNormalisedTime(
-                        session.getCalendarGMT(), millis);
-                parameterValues[index] = new TimeData((int) (millis / 1000),
-                        x.getNanos(), 0);
-
-                break;
             case Types.SQL_TIME_WITH_TIME_ZONE :
-                millis = HsqlDateTime.getNormalisedTime(
-                        session.getCalendarGMT(), millis);
-                zoneOffset = HsqlDateTime.getZoneMillis(calendar, millis);
-                parameterValues[index] = new TimeData((int) (millis / 1000),
-                        x.getNanos(), zoneOffset / 1000);
-
-                break;
             case Types.SQL_DATE :
-                millis  = HsqlDateTime.getNormalisedDate(
-                        session.getCalendarGMT(), millis);
-                seconds = millis / 1000;
-
-                if (seconds < DateTimeType.epochSeconds
-                    || seconds > DateTimeType.epochLimitSeconds) {
-                    throw JDBCUtil.sqlException(ErrorCode.X_22008);
-                }
-
-                parameterValues[index] = new TimestampData(seconds);
-
                 break;
             default :
                 throw JDBCUtil.sqlException(ErrorCode.X_42561);
         }
+
+        Object value = ((DateTimeType)outType).convertJavaToSQL(session, x, cal);
+
+        parameterValues[index] = value;
         parameterSet[index] = true;
     }
 
@@ -1846,15 +1785,17 @@ public class JDBCPreparedStatement exten
         if (isClosed || connection.isClosed) {
             checkClosed();
         }
+
         checkStatementType(StatementTypes.RETURN_COUNT);
 
         if (!isBatch) {
-            if (connection.isEmptyBatchAllowed) {
+            if (connection.isAllowEmptyBatch) {
                 return new int[]{};
             }
 
             throw JDBCUtil.sqlExceptionSQL(ErrorCode.X_07506);
         }
+
         generatedResult = null;
 
         int batchCount = resultOut.getNavigator().getSize();
@@ -1890,8 +1831,9 @@ public class JDBCPreparedStatement exten
                 throw new BatchUpdateException(updateCounts);
             } else {
                 throw new BatchUpdateException(errorResult.getMainString(),
-                        errorResult.getSubString(),
-                        errorResult.getErrorCode(), updateCounts);
+                                               errorResult.getSubString(),
+                                               errorResult.getErrorCode(),
+                                               updateCounts);
             }
         }
 
@@ -1938,8 +1880,8 @@ public class JDBCPreparedStatement exten
      * @throws SQLException always
      * @return nothing
      */
-    public synchronized ResultSet executeQuery(
-            String sql) throws SQLException {
+    public synchronized ResultSet executeQuery(String sql)
+    throws SQLException {
         throw JDBCUtil.notSupported();
     }
 
@@ -1969,7 +1911,7 @@ public class JDBCPreparedStatement exten
 
     /**
      * Does the specialized work required to free this object's resources and
-     * that of it's parent class. <p>
+     * that of its parent class. <p>
      *
      * @throws SQLException if a database access error occurs
      */
@@ -1978,6 +1920,7 @@ public class JDBCPreparedStatement exten
         if (isClosed()) {
             return;
         }
+
         closeResultData();
 
         HsqlException he = null;
@@ -1993,6 +1936,7 @@ public class JDBCPreparedStatement exten
         } catch (HsqlException e) {
             he = e;
         }
+
         parameterValues   = null;
         parameterSet      = null;
         parameterTypes    = null;
@@ -2041,6 +1985,7 @@ public class JDBCPreparedStatement exten
 
             return sb.toString();
         }
+
         sb.append("[sql=[").append(sql).append("]");
 
         if (pv.length > 0) {
@@ -2051,9 +1996,11 @@ public class JDBCPreparedStatement exten
                 sb.append(pv[i]);
                 sb.append("], ");
             }
+
             sb.setLength(sb.length() - 2);
             sb.append(']');
         }
+
         sb.append(']');
 
         return sb.toString();
@@ -2111,8 +2058,8 @@ public class JDBCPreparedStatement exten
      * @see java.sql.ParameterMetaData
      * @since JDK 1.4, HSQL 1.7.0
      */
-    public synchronized ParameterMetaData getParameterMetaData() throws
-        SQLException {
+    public synchronized ParameterMetaData getParameterMetaData()
+    throws SQLException {
 
         checkClosed();
 
@@ -2201,8 +2148,8 @@ public class JDBCPreparedStatement exten
      * @since JDK 1.4, HSQLDB 1.7
      * @see #execute
      */
-    public synchronized boolean getMoreResults(
-            int current) throws SQLException {
+    public synchronized boolean getMoreResults(int current)
+    throws SQLException {
         return super.getMoreResults(current);
     }
 
@@ -2301,7 +2248,6 @@ public class JDBCPreparedStatement exten
      *
      * @since JDK 1.6, HSQLDB 2.0
      */
-
     public void setRowId(int parameterIndex, RowId x) throws SQLException {
         throw JDBCUtil.notSupported();
     }
@@ -2360,7 +2306,6 @@ public class JDBCPreparedStatement exten
      * @throws SQLFeatureNotSupportedException  if the JDBC driver does not support this method
      * @since JDK 1.6, HSQLDB 2.0
      */
-
     public synchronized void setNClob(int parameterIndex,
                                       NClob value) throws SQLException {
         setClob(parameterIndex, value);
@@ -2376,7 +2321,7 @@ public class JDBCPreparedStatement exten
      * because it informs the driver that the parameter value should be sent to
      * the server as a <code>CLOB</code>.  When the <code>setCharacterStream</code> method is used, the
      * driver may have to do extra work to determine whether the parameter
-     * data should be send to the server as a <code>LONGVARCHAR</code> or a <code>CLOB</code>
+     * data should be sent to the server as a <code>LONGVARCHAR</code> or a <code>CLOB</code>
      * @param parameterIndex index of the first parameter is 1, the second is 2, ...
      * @param reader An object that contains the data to set the parameter value to.
      * @param length the number of characters in the parameter data.
@@ -2402,7 +2347,7 @@ public class JDBCPreparedStatement exten
      * method because it informs the driver that the parameter value should be
      * sent to the server as a <code>BLOB</code>.  When the <code>setBinaryStream</code> method is used,
      * the driver may have to do extra work to determine whether the parameter
-     * data should be send to the server as a <code>LONGVARBINARY</code> or a <code>BLOB</code>
+     * data should be sent to the server as a <code>LONGVARBINARY</code> or a <code>BLOB</code>
      * <!-- start release-specific documentation -->
      * <div class="ReleaseSpecificDocumentation">
      * <h1>HSQLDB-Specific Information:</h1> <p>
@@ -2442,7 +2387,7 @@ public class JDBCPreparedStatement exten
      * because it informs the driver that the parameter value should be sent to
      * the server as a <code>NCLOB</code>.  When the <code>setCharacterStream</code> method is used, the
      * driver may have to do extra work to determine whether the parameter
-     * data should be send to the server as a <code>LONGNVARCHAR</code> or a <code>NCLOB</code>
+     * data should be sent to the server as a <code>LONGNVARCHAR</code> or a <code>NCLOB</code>
      * @param parameterIndex index of the first parameter is 1, the second is 2, ...
      * @param reader An object that contains the data to set the parameter value to.
      * @param length the number of characters in the parameter data.
@@ -2478,11 +2423,11 @@ public class JDBCPreparedStatement exten
      *
      * @since JDK 1.6, HSQLDB 2.0
      */
-
     public void setSQLXML(int parameterIndex,
                           SQLXML xmlObject) throws SQLException {
         throw JDBCUtil.notSupported();
     }
+
 // --------------------------- Added: Mustang Build 86 -------------------------
 
     /* @todo 1.9.0 - implement streaming and remove length limits */
@@ -2526,8 +2471,9 @@ public class JDBCPreparedStatement exten
 
         if (length < 0) {
             throw JDBCUtil.sqlException(ErrorCode.JDBC_INVALID_ARGUMENT,
-                                    "length: " + length);
+                                        "length: " + length);
         }
+
         setAscStream(parameterIndex, x, length);
     }
 
@@ -2548,9 +2494,11 @@ public class JDBCPreparedStatement exten
             if (length >= 0 && s.length() > length) {
                 s = s.substring(0, (int) length);
             }
+
             setParameter(parameterIndex, s);
         } catch (IOException e) {
-            throw JDBCUtil.sqlException(ErrorCode.JDBC_INPUTSTREAM_ERROR, null, e);
+            throw JDBCUtil.sqlException(ErrorCode.JDBC_INPUTSTREAM_ERROR,
+                                        null, e);
         }
     }
 
@@ -2592,12 +2540,12 @@ public class JDBCPreparedStatement exten
 
         if (length < 0) {
             throw JDBCUtil.sqlException(ErrorCode.JDBC_INVALID_ARGUMENT,
-                                    "length: " + length);
+                                        "length: " + length);
         }
 
         if (length > parameterTypes[parameterIndex - 1].precision) {
             throw JDBCUtil.sqlException(ErrorCode.X_22001,
-                                    "length: " + length);
+                                        "length: " + length);
         }
 
         // ignore length as client/server cannot handle incorrect data length entered by user
@@ -2631,10 +2579,11 @@ public class JDBCPreparedStatement exten
             } else {
                 output = new HsqlByteArrayOutputStream(x, (int) length);
             }
+
             setParameter(parameterIndex, output.toByteArray());
         } catch (Throwable e) {
             throw JDBCUtil.sqlException(ErrorCode.JDBC_INPUTSTREAM_ERROR,
-                                    e.toString(), e);
+                                        e.toString(), e);
         }
     }
 
@@ -2676,12 +2625,12 @@ public class JDBCPreparedStatement exten
 
         if (length < 0) {
             throw JDBCUtil.sqlException(ErrorCode.JDBC_INVALID_ARGUMENT,
-                                    "length: " + length);
+                                        "length: " + length);
         }
 
-        if (length > parameterTypes[parameterIndex -1].precision) {
+        if (length > parameterTypes[parameterIndex - 1].precision) {
             throw JDBCUtil.sqlException(ErrorCode.X_22001,
-                                    "length: " + length);
+                                        "length: " + length);
         }
 
         // ignore length as client/server cannot handle incorrect data length entered by user
@@ -2713,10 +2662,11 @@ public class JDBCPreparedStatement exten
             } else {
                 writer = new CharArrayWriter(reader, (int) length);
             }
+
             setParameter(parameterIndex, writer.toString());
         } catch (Throwable e) {
             throw JDBCUtil.sqlException(ErrorCode.JDBC_INPUTSTREAM_ERROR,
-                                    e.toString(), e);
+                                        e.toString(), e);
         }
     }
 
@@ -2756,7 +2706,7 @@ public class JDBCPreparedStatement exten
      *   @since 1.6
      */
     public synchronized void setAsciiStream(int parameterIndex,
-                               java.io.InputStream x) throws SQLException {
+            java.io.InputStream x) throws SQLException {
         setAscStream(parameterIndex, x, -1);
     }
 
@@ -2842,7 +2792,7 @@ public class JDBCPreparedStatement exten
      * @since 1.6
      */
     public synchronized void setCharacterStream(int parameterIndex,
-                                   java.io.Reader reader) throws SQLException {
+            java.io.Reader reader) throws SQLException {
         setCharStream(parameterIndex, reader, -1);
     }
 
@@ -2872,7 +2822,7 @@ public class JDBCPreparedStatement exten
      *   @since 1.6
      */
     public synchronized void setNCharacterStream(int parameterIndex,
-                                    Reader value) throws SQLException {
+            Reader value) throws SQLException {
         setCharStream(parameterIndex, value, -1);
     }
 
@@ -2901,7 +2851,7 @@ public class JDBCPreparedStatement exten
      * @since 1.6
      */
     public synchronized void setClob(int parameterIndex,
-                        Reader reader) throws SQLException {
+                                     Reader reader) throws SQLException {
         setCharStream(parameterIndex, reader, -1);
     }
 
@@ -2933,7 +2883,8 @@ public class JDBCPreparedStatement exten
      * @since 1.6
      */
     public synchronized void setBlob(int parameterIndex,
-                        InputStream inputStream) throws SQLException {
+                                     InputStream inputStream)
+                                     throws SQLException {
         setBinStream(parameterIndex, inputStream, -1);
     }
 
@@ -2963,7 +2914,7 @@ public class JDBCPreparedStatement exten
      * @since 1.6
      */
     public synchronized void setNClob(int parameterIndex,
-                         Reader reader) throws SQLException {
+                                      Reader reader) throws SQLException {
         setCharStream(parameterIndex, reader, -1);
     }
 
@@ -3102,6 +3053,7 @@ public class JDBCPreparedStatement exten
         if (max < 0) {
             throw JDBCUtil.outOfRangeArgument();
         }
+
         maxRows = max;
     }
 
@@ -3177,6 +3129,7 @@ public class JDBCPreparedStatement exten
         if (seconds > Short.MAX_VALUE) {
             seconds = Short.MAX_VALUE;
         }
+
         queryTimeout = seconds;
     }
 
@@ -3203,10 +3156,12 @@ public class JDBCPreparedStatement exten
      * this method
      */
     public synchronized void cancel() throws SQLException {
+
         checkClosed();
-        String sql = resultOut.getMainString();
-        int randomId = connection.sessionProxy.getRandomId();
-        Result request = Result.newCancelRequest(randomId, -1, sql);
+
+        String sql      = resultOut.getMainString();
+        int    randomId = connection.sessionProxy.getRandomId();
+        Result request  = Result.newCancelRequest(randomId, -1, sql);
 
         try {
             Result response = connection.sessionProxy.cancel(request);
@@ -3279,6 +3234,7 @@ public class JDBCPreparedStatement exten
         if (isClosed || connection.isClosed) {
             checkClosed();
         }
+
         rootWarning = null;
     }
 
@@ -3292,7 +3248,7 @@ public class JDBCPreparedStatement exten
      * used in SQL positioned update or delete statements to identify the
      * current row in the <code>ResultSet</code> object generated by this
      * statement.  If the database does not support positioned update/delete,
-     * this method is a noop.  To insure that a cursor has the proper isolation
+     * this method is a noop.  To ensure that a cursor has the proper isolation
      * level to support updates, the cursor's <code>SELECT</code> statement
      * should have the form <code>SELECT FOR UPDATE</code>.  If
      * <code>FOR UPDATE</code> is not present, positioned updates may fail.
@@ -3428,8 +3384,8 @@ public class JDBCPreparedStatement exten
      * @since JDK 1.2
      * @see #getFetchDirection
      */
-    public synchronized void setFetchDirection(
-            int direction) throws SQLException {
+    public synchronized void setFetchDirection(int direction)
+    throws SQLException {
 
         if (isClosed || connection.isClosed) {
             checkClosed();
@@ -3440,6 +3396,7 @@ public class JDBCPreparedStatement exten
                 && direction != ResultSet.FETCH_UNKNOWN) {
             throw JDBCUtil.notSupported();
         }
+
         fetchDirection = direction;
     }
 
@@ -3518,6 +3475,7 @@ public class JDBCPreparedStatement exten
         if (rows < 0) {
             throw JDBCUtil.outOfRangeArgument();
         }
+
         fetchSize = rows;
     }
 
@@ -3673,7 +3631,6 @@ public class JDBCPreparedStatement exten
     }
 
     //----------------------------- JDBC 4.0 -----------------------------------
-
     boolean poolable = true;
 
     /**
@@ -3698,12 +3655,13 @@ public class JDBCPreparedStatement exten
      * <p>
      * @since JDK 1.6, HSQLDB 2.0
      */
-    public synchronized void setPoolable(
-            boolean poolable) throws SQLException {
+    public synchronized void setPoolable(boolean poolable)
+    throws SQLException {
 
         if (isClosed || connection.isClosed) {
             checkClosed();
         }
+
         this.poolable = poolable;
     }
 
@@ -3739,7 +3697,7 @@ public class JDBCPreparedStatement exten
      * or a proxy for the receiver. If the receiver is a wrapper
      * and the wrapped object implements the interface then the result is the
      * wrapped object or a proxy for the wrapped object. Otherwise return the
-     * the result of calling <code>unwrap</code> recursively on the wrapped object
+     * result of calling <code>unwrap</code> recursively on the wrapped object
      * or a proxy for that result. If the receiver is not a
      * wrapper and does not implement the interface, then an <code>SQLException</code> is thrown.
      *
@@ -3787,7 +3745,7 @@ public class JDBCPreparedStatement exten
      * <p>
      * This method should be used when the returned row count may exceed
      * {@link Integer#MAX_VALUE}.
-     *<p>
+     * <p>
      * The public implementation will throw {@code UnsupportedOperationException}
      *
      * @return the current result as an update count; -1 if the current result
@@ -3813,7 +3771,7 @@ public class JDBCPreparedStatement exten
      * <p>
      * This method should be used when the row limit may exceed
      * {@link Integer#MAX_VALUE}.
-     *<p>
+     * <p>
      * The default implementation will throw {@code UnsupportedOperationException}
      *
      * @param max the new max rows limit; zero means there is no limit
@@ -3841,7 +3799,7 @@ public class JDBCPreparedStatement exten
      * <p>
      * This method should be used when the returned row limit may exceed
      * {@link Integer#MAX_VALUE}.
-     *<p>
+     * <p>
      * The default implementation will return {@code 0}
      *
      * @return the current maximum number of rows for a <code>ResultSet</code>
@@ -3894,7 +3852,7 @@ public class JDBCPreparedStatement exten
      * <p>
      * This method should be used when the returned row count may exceed
      * {@link Integer#MAX_VALUE}.
-     *<p>
+     * <p>
      * The default implementation will throw {@code UnsupportedOperationException}
      *
      * @return an array of update counts containing one element for each
@@ -3954,7 +3912,7 @@ public class JDBCPreparedStatement exten
      *
      * <p>Note that this method may be used to pass database-specific
      * abstract data types.
-     *<P>
+     * <P>
      * The default implementation will throw {@code SQLFeatureNotSupportedException}
      *
      * @param parameterIndex the first parameter is 1, the second is 2, ...
@@ -3995,7 +3953,7 @@ public class JDBCPreparedStatement exten
      * This method is similar to {@link #setObject(int parameterIndex,
      * Object x, SQLType targetSqlType, int scaleOrLength)},
      * except that it assumes a scale of zero.
-     *<P>
+     * <P>
      * The default implementation will throw {@code SQLFeatureNotSupportedException}
      *
      * @param parameterIndex the first parameter is 1, the second is 2, ...
@@ -4016,6 +3974,7 @@ public class JDBCPreparedStatement exten
         int typeNo = targetSqlType.getVendorTypeNumber().intValue();
         setObject(parameterIndex, x, typeNo);
     }
+
 //#endif JAVA8
 
     /**
@@ -4067,16 +4026,15 @@ public class JDBCPreparedStatement exten
     JDBCPreparedStatement(JDBCConnection c, String sql, int resultSetType,
                           int resultSetConcurrency, int resultSetHoldability,
                           int generatedKeys, int[] generatedIndexes,
-                          String[] generatedNames) throws HsqlException,
-                              SQLException {
+                          String[] generatedNames)
+                          throws HsqlException, SQLException {
 
         isResult              = false;
         connection            = c;
         connectionIncarnation = connection.incarnation;
         session               = c.sessionProxy;
         sql                   = c.nativeSQL(sql);
-
-        resultOut = Result.newPrepareStatementRequest();
+        resultOut             = Result.newPrepareStatementRequest();
 
         int props = ResultProperties.getValueForJDBC(resultSetType,
             resultSetConcurrency, resultSetHoldability);
@@ -4089,6 +4047,7 @@ public class JDBCPreparedStatement exten
         if (in.mode == ResultConstants.ERROR) {
             throw JDBCUtil.sqlException(in);
         }
+
         rootWarning = null;
 
         Result current = in;
@@ -4106,6 +4065,7 @@ public class JDBCPreparedStatement exten
                 }
             }
         }
+
         connection.setWarnings(rootWarning);
 
         statementID       = in.getStatementID();
@@ -4213,8 +4173,8 @@ public class JDBCPreparedStatement exten
      * @param parameterIndex The parameter index to check
      * @throws SQLException if the specified parameter index is invalid
      */
-    protected void checkSetParameterIndex(int parameterIndex) throws
-        SQLException {
+    protected void checkSetParameterIndex(int parameterIndex)
+    throws SQLException {
 
         if (isClosed || connection.isClosed) {
             checkClosed();
@@ -4226,10 +4186,10 @@ public class JDBCPreparedStatement exten
             throw JDBCUtil.outOfRangeArgument(msg);
         }
 
-        if (parameterModes[parameterIndex - 1] ==
-            SchemaObject.ParameterModes.PARAM_OUT) {
-            String msg = "Not IN or INOUT mode for parameter: " +
-                         parameterIndex;
+        if (parameterModes[parameterIndex - 1]
+                == SchemaObject.ParameterModes.PARAM_OUT) {
+            String msg = "Not IN or INOUT mode for parameter: "
+                         + parameterIndex;
 
             throw JDBCUtil.invalidArgument(msg);
         }
@@ -4242,8 +4202,8 @@ public class JDBCPreparedStatement exten
      * @param parameterIndex The parameter index to check
      * @throws SQLException if the specified parameter index is invalid
      */
-    protected void checkGetParameterIndex(int parameterIndex) throws
-        SQLException {
+    protected void checkGetParameterIndex(int parameterIndex)
+    throws SQLException {
 
         if (isClosed || connection.isClosed) {
             checkClosed();
@@ -4263,10 +4223,11 @@ public class JDBCPreparedStatement exten
             case SchemaObject.ParameterModes.PARAM_OUT :
             case SchemaObject.ParameterModes.PARAM_INOUT :
                 break;
+
             case SchemaObject.ParameterModes.PARAM_IN :
-            default:
-                String msg = "Not OUT or INOUT mode for parameter: " +
-                             parameterIndex;
+            default :
+                String msg = "Not OUT or INOUT mode for parameter: "
+                             + parameterIndex;
 
                 throw JDBCUtil.invalidArgument(msg);
         }
@@ -4290,8 +4251,8 @@ public class JDBCPreparedStatement exten
         for (int i = 0; i < parameterSet.length; i++) {
             if (parameterModes[i] != SchemaObject.ParameterModes.PARAM_OUT) {
                 if (!parameterSet[i]) {
-                    throw JDBCUtil.sqlException(ErrorCode.
-                        JDBC_PARAMETER_NOT_SET);
+                    throw JDBCUtil.sqlException(
+                        ErrorCode.JDBC_PARAMETER_NOT_SET);
                 }
             }
         }
@@ -4340,7 +4301,6 @@ public class JDBCPreparedStatement exten
                 }
 
                 throw JDBCUtil.sqlException(ErrorCode.X_42563);
-
             case Types.SQL_BIT :
             case Types.SQL_BIT_VARYING :
                 try {
@@ -4378,7 +4338,6 @@ public class JDBCPreparedStatement exten
                 }
 
                 throw JDBCUtil.sqlException(ErrorCode.X_42563);
-
             case Types.SQL_BINARY :
             case Types.SQL_VARBINARY :
             case Types.SQL_GUID :
@@ -4390,6 +4349,7 @@ public class JDBCPreparedStatement exten
 
                 if (o instanceof UUID) {
                     o = BinaryUUIDType.getBinary((UUID) o);
+
                     break;
                 }
 
@@ -4404,7 +4364,6 @@ public class JDBCPreparedStatement exten
                 }
 
                 throw JDBCUtil.sqlException(ErrorCode.X_42563);
-
             case Types.SQL_ARRAY :
                 if (o instanceof Array) {
                     setArray(parameterIndex, (Array) o);
@@ -4424,21 +4383,23 @@ public class JDBCPreparedStatement exten
                     for (int j = 0; j < data.length; j++) {
                         data[j] = baseType.convertJavaToSQL(session, array[j]);
                     }
+
                     o = data;
 
                     break;
                 }
 
                 throw JDBCUtil.sqlException(ErrorCode.X_42563);
-
             case Types.SQL_BLOB :
                 setBlobParameter(parameterIndex, o);
 
                 return;
+
             case Types.SQL_CLOB :
                 setClobParameter(parameterIndex, o);
 
                 return;
+
             case Types.SQL_DATE :
             case Types.SQL_TIME_WITH_TIME_ZONE :
             case Types.SQL_TIMESTAMP_WITH_TIME_ZONE :
@@ -4447,10 +4408,11 @@ public class JDBCPreparedStatement exten
                 try {
                     if (o instanceof String) {
                         o = outType.convertToType(session, o,
-                                Type.SQL_VARCHAR);
+                                                  Type.SQL_VARCHAR);
 
                         break;
                     }
+
                     o = outType.convertJavaToSQL(session, o);
 
                     break;
@@ -4470,7 +4432,7 @@ public class JDBCPreparedStatement exten
                 try {
                     if (o instanceof String) {
                         o = outType.convertToType(session, o,
-                                Type.SQL_VARCHAR);
+                                                  Type.SQL_VARCHAR);
 
                         break;
                     } else if (o instanceof Boolean) {
@@ -4479,6 +4441,7 @@ public class JDBCPreparedStatement exten
                         o = value ? Integer.valueOf(1)
                                   : Integer.valueOf(0);
                     }
+
                     o = outType.convertToDefaultType(session, o);
 
                     break;
@@ -4488,21 +4451,24 @@ public class JDBCPreparedStatement exten
             case Types.SQL_VARCHAR : {
                 if (o instanceof String) {
                     break;
-                } else {
-                    try {
-                        o = outType.convertToDefaultType(session, o);
+                }
 
-                        break;
-                    } catch (HsqlException e) {
-                        throw JDBCUtil.sqlException(e);
-                    }
+                try {
+                    o = outType.convertToDefaultType(session, o);
+
+                    break;
+                } catch (HsqlException e) {
+                    throw JDBCUtil.sqlException(e);
                 }
             }
             case Types.SQL_CHAR : {
+                if (o instanceof String) {
+                    break;
+                }
+
                 if (outType.precision == 1) {
                     if (o instanceof Character) {
-                        o = new String(new char[] {
-                            ((Character) o).charValue() });
+                        o = String.valueOf(((Character) o).charValue());
 
                         break;
                     } else if (o instanceof Boolean) {
@@ -4523,6 +4489,11 @@ public class JDBCPreparedStatement exten
             }
             default :
                 try {
+                    if (outType.isIntervalType()) {
+                        o = outType.convertJavaToSQL(session, o);
+                        break;
+                    }
+
                     o = outType.convertToDefaultType(session, o);
 
                     break;
@@ -4530,6 +4501,7 @@ public class JDBCPreparedStatement exten
                     throw JDBCUtil.sqlException(e);
                 }
         }
+
         parameterValues[index] = o;
         parameterSet[index]    = true;
     }
@@ -4556,6 +4528,7 @@ public class JDBCPreparedStatement exten
 
                 return;
             }
+
             parameterValues[i - 1] = o;
             parameterSet[i - 1]    = Boolean.TRUE;
 
@@ -4571,8 +4544,9 @@ public class JDBCPreparedStatement exten
             if (is.session.getDatabaseUniqueName().equals(
                     session.getDatabaseUniqueName())) {
                 throw JDBCUtil.sqlException(ErrorCode.JDBC_INVALID_ARGUMENT,
-                                        "invalid Reader");
+                                            "invalid Reader");
             }
+
             parameterValues[i - 1] = o;
             streamLengths[i - 1]   = streamLength;
             parameterSet[i - 1]    = true;
@@ -4641,7 +4615,7 @@ public class JDBCPreparedStatement exten
             if (is.session.getDatabaseUniqueName().equals(
                     session.getDatabaseUniqueName())) {
                 throw JDBCUtil.sqlException(ErrorCode.JDBC_INVALID_ARGUMENT,
-                                        "invalid Reader");
+                                            "invalid Reader");
             }
 
             // in the same database ? see if it blocks in
@@ -4721,8 +4695,8 @@ public class JDBCPreparedStatement exten
     void setLongParameter(int parameterIndex, long value) throws SQLException {
 
         checkSetParameterIndex(parameterIndex);
-        int index   = parameterIndex - 1;
 
+        int index   = parameterIndex - 1;
         int outType = parameterTypes[index].typeCode;
 
         switch (outType) {
@@ -4732,8 +4706,8 @@ public class JDBCPreparedStatement exten
 
                 parameterValues[index] = o;
                 parameterSet[index]    = true;
-
                 break;
+
             case Types.SQL_BINARY :
             case Types.SQL_VARBINARY :
             case Types.OTHER :
@@ -4774,14 +4748,14 @@ public class JDBCPreparedStatement exten
                     InputStream stream = ((Blob) value).getBinaryStream();
                     ResultLob resultLob =
                         ResultLob.newLobCreateBlobRequest(session.getId(), id,
-                            stream, length);
+                                                          stream, length);
 
                     session.allocateResultLob(resultLob);
                     resultOut.addLobResult(resultLob);
                 } else if (value instanceof InputStream) {
-                    long length = streamLengths[i];
-
-                    long createLength = length > 0 ? length : 0;
+                    long length       = streamLengths[i];
+                    long createLength = length > 0 ? length
+                                                   : 0;
 
                     blob = session.createBlob(createLength);
                     id   = blob.getId();
@@ -4789,13 +4763,14 @@ public class JDBCPreparedStatement exten
                     InputStream stream = (InputStream) value;
                     ResultLob resultLob =
                         ResultLob.newLobCreateBlobRequest(session.getId(), id,
-                            stream, length);
+                                                          stream, length);
 
                     session.allocateResultLob(resultLob);
                     resultOut.addLobResult(resultLob);
                 } else if (value instanceof BlobDataID) {
                     blob = (BlobDataID) value;
                 }
+
                 parameterValues[i] = blob;
             } else if (parameterTypes[i].typeCode == Types.SQL_CLOB) {
                 long       id;
@@ -4815,14 +4790,14 @@ public class JDBCPreparedStatement exten
 
                     ResultLob resultLob =
                         ResultLob.newLobCreateClobRequest(session.getId(), id,
-                            reader, length);
+                                                          reader, length);
 
                     session.allocateResultLob(resultLob);
                     resultOut.addLobResult(resultLob);
                 } else if (value instanceof Reader) {
-                    long length = streamLengths[i];
-
-                    long createLength = length > 0 ? length : 0;
+                    long length       = streamLengths[i];
+                    long createLength = length > 0 ? length
+                                                   : 0;
 
                     clob = session.createClob(createLength);
                     id   = clob.getId();
@@ -4830,13 +4805,14 @@ public class JDBCPreparedStatement exten
                     Reader reader = (Reader) value;
                     ResultLob resultLob =
                         ResultLob.newLobCreateClobRequest(session.getId(), id,
-                            reader, length);
+                                                          reader, length);
 
                     session.allocateResultLob(resultLob);
                     resultOut.addLobResult(resultLob);
                 } else if (value instanceof ClobDataID) {
                     clob = (ClobDataID) value;
                 }
+
                 parameterValues[i] = clob;
             }
         }
@@ -4853,6 +4829,7 @@ public class JDBCPreparedStatement exten
         if (isClosed || connection.isClosed) {
             checkClosed();
         }
+
         closeResultData();
         checkParametersSet();
 
@@ -4865,7 +4842,8 @@ public class JDBCPreparedStatement exten
             resultOut.setPreparedResultUpdateProperties(parameterValues);
         } else {
             resultOut.setPreparedExecuteProperties(parameterValues, maxRows,
-                    fetchSize, rsProperties, queryTimeout);
+                                                   fetchSize, rsProperties,
+                                                   queryTimeout);
         }
 
         try {
@@ -4884,7 +4862,7 @@ public class JDBCPreparedStatement exten
 
         if (resultIn.isData()) {
             currentResultSet = new JDBCResultSet(connection, this, resultIn,
-                    resultIn.metaData);
+                                                 resultIn.metaData);
         } else if (statementRetType == StatementTypes.RETURN_RESULT) {
             getMoreResults();
         }
@@ -4944,4 +4922,24 @@ public class JDBCPreparedStatement exten
 
     /** The session attribute of the connection */
     protected SessionInterface session;
+
+    public String getSQL() {
+        return sql;
+    }
+
+    public long getStatementID() {
+        return statementID;
+    }
+
+    public boolean isRowCount() {
+        return statementRetType == StatementTypes.RETURN_COUNT;
+    }
+
+    public JDBCResultSetMetaData getResultSetMetaData() {
+        return resultSetMetaData;
+    }
+
+    public ResultMetaData getParameterMetaDataDirect() {
+        return parameterMetaData;
+    }
 }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCResultSet.java 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCResultSet.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCResultSet.java	2021-06-10 09:54:40.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCResultSet.java	2022-07-05 15:52:02.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -65,7 +65,6 @@ import org.hsqldb.lib.IntValueHashMap;
 import org.hsqldb.lib.StringInputStream;
 import org.hsqldb.lib.java.JavaSystem;
 import org.hsqldb.navigator.RowSetNavigator;
-import org.hsqldb.persist.HsqlDatabaseProperties;
 import org.hsqldb.result.Result;
 import org.hsqldb.result.ResultConstants;
 import org.hsqldb.result.ResultMetaData;
@@ -92,14 +91,11 @@ import java.time.Duration;
 import java.time.LocalDate;
 import java.time.LocalDateTime;
 import java.time.LocalTime;
-import java.time.OffsetDateTime;
-import java.time.OffsetTime;
 import java.time.Period;
-import java.time.ZoneOffset;
 //#endif JAVA8
 
 
-/* $Id: JDBCResultSet.java 6349 2021-06-10 10:54:35Z fredt $ */
+/* $Id: JDBCResultSet.java 6571 2022-07-05 16:50:27Z fredt $ */
 
 //campbell-burnet@users 20051207 - patch 1.9.0 - initial JDBC 4.0 support work
 //fredt@users    20060431 - patch 1.9.0 rewrite with RowSetNavigator
@@ -246,11 +242,14 @@ import java.time.ZoneOffset;
  * String ninthRowValue = rs.<b>getString</b>(<span class="JavaNumericLiteral">1</span>);
  * </pre>
  *
- * Note: An HSQLDB <code>ResultSet</code> object persists, even after its
+ * Note: An HSQLDB <code>ResultSet</code> object stays open if it is not
+ * explicitly closed, even after its
  * connection is closed.  This is regardless of the operational mode of
  * the {@link org.hsqldb.Database Database} from which it came.  That is, they
  * persist whether originating from a <code>Server</code>,
- * <code>WebServer</code> or in-process mode <code>Database.</code>
+ * <code>WebServer</code> or in-process mode <code>Database</code>. A connection
+ * opened with the property setting <code>close_result=true </code> closes
+ * any remaining open results when the connection is closed.
  * <p>
  *
  * From HSQLDB 2.0, there is full support for updatable result sets.
@@ -294,7 +293,7 @@ import java.time.ZoneOffset;
  *
  * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class JDBCResultSet implements ResultSet {
@@ -909,12 +908,22 @@ public class JDBCResultSet implements Re
     public java.io.InputStream getAsciiStream(
             int columnIndex) throws SQLException {
 
-        String s = getString(columnIndex);
+        Object o = getColumnValue(columnIndex);
 
-        if (s == null) {
+        if (o == null) {
             return null;
         }
 
+        if (o instanceof ClobDataID) {
+            JDBCClobClient clob = new JDBCClobClient(session, (ClobDataID) o);
+
+            return clob.getAsciiStream();
+        } else if (o instanceof Clob) {
+            return ((Clob) o).getAsciiStream();
+        }
+
+        String s = getString(columnIndex);
+
         try {
             return new ByteArrayInputStream(s.getBytes(JavaSystem.CS_US_ASCII));
         } catch (Throwable e) {
@@ -925,7 +934,7 @@ public class JDBCResultSet implements Re
     /**
      * <!-- start generic documentation -->
      * Retrieves the value of the designated column in the current row
-     * of this <code>ResultSet</code> object as
+     * of this <code>ResultSet</code> object
      * as a stream of two-byte Unicode characters. The first byte is
      * the high byte; the second byte is the low byte.
      *
@@ -1016,10 +1025,7 @@ public class JDBCResultSet implements Re
     public java.io.InputStream getBinaryStream(
             int columnIndex) throws SQLException {
 
-        checkColumn(columnIndex);
-
-        Type   sourceType = resultMetaData.columnTypes[columnIndex - 1];
-        Object o          = getColumnInType(columnIndex, sourceType);
+        Object o = getColumnValue(columnIndex);
 
         if (o == null) {
             return null;
@@ -1477,7 +1483,7 @@ public class JDBCResultSet implements Re
      * <P>In SQL, a result table is retrieved through a cursor that is
      * named. The current row of a result set can be updated or deleted
      * using a positioned update/delete statement that references the
-     * cursor name. To insure that the cursor has the proper isolation
+     * cursor name. To ensure that the cursor has the proper isolation
      * level to support update, the cursor's <code>SELECT</code> statement
      * should be of the form <code>SELECT FOR UPDATE</code>. If
      * <code>FOR UPDATE</code> is omitted, the positioned updates may fail.
@@ -2354,7 +2360,7 @@ public class JDBCResultSet implements Re
      * <!-- start generic documentation -->
      * Moves the cursor a relative number of rows, either positive or negative.
      * Attempting to move beyond the first/last row in the
-     * result set positions the cursor before/after the
+     * result set positions the cursor before/after
      * the first/last row. Calling <code>relative(0)</code> is valid, but does
      * not change the cursor position.
      *
@@ -4166,7 +4172,7 @@ public class JDBCResultSet implements Re
      *
      * Only the updater, getter,
      * and <code>insertRow</code> methods may be
-     * called when the cursor is on the insert row.  All of the columns in
+     * called when the cursor is on the insert row. All of the columns in
      * a result set must be given a value each time this method is
      * called before calling <code>insertRow</code>.
      * An updater method must be called before a
@@ -4353,9 +4359,8 @@ public class JDBCResultSet implements Re
 
                 byte[] bytes = ((BlobDataID) o).getBytes(session, 0,
                                    (int) length);
-                JDBCBlob b = new JDBCBlob(bytes);
 
-                return b;
+                return new JDBCBlob(bytes);
             }
 
             JDBCBlobClient blob = new JDBCBlobClient(session, (BlobDataID) o);
@@ -4429,9 +4434,8 @@ public class JDBCResultSet implements Re
 
                 String s = ((ClobDataID) o).getSubString(session, 0,
                                (int) length);
-                JDBCClob c = new JDBCClob(s);
 
-                return c;
+                return new JDBCClob(s);
             }
 
             JDBCClobClient clob = new JDBCClobClient(session, (ClobDataID) o);
@@ -4683,13 +4687,7 @@ public class JDBCResultSet implements Re
             return null;
         }
 
-        long millis = t.getSeconds() * 1000;
-
-        if (cal != null) {
-            millis = HsqlDateTime.convertMillisToCalendar(cal, millis);
-        }
-
-        return new Date(millis);
+        return (Date) Type.SQL_DATE.convertSQLToJava(session, t, cal);
     }
 
     /**
@@ -4739,8 +4737,8 @@ public class JDBCResultSet implements Re
      * of the returned java.sql.Time object is the UTC of the SQL value without
      * modification. In other words, the Calendar object is not used.</li>
      * <li>If the SQL type of the column is WITHOUT TIME ZONE, then the UTC
-     * value of the returned java.sql.Time is correct for the given Calendar
-     * object.</li>
+     * value of the returned java.sql.Time is correct for the given Calendar's
+     * time zone.</li>
      * <li>If the cal argument is null, it it ignored and the method returns
      * the same Object as the method without the Calendar parameter.</li>
      * </ol>
@@ -4764,18 +4762,7 @@ public class JDBCResultSet implements Re
             return null;
         }
 
-        long millis = DateTimeType.normaliseTime(t.getSeconds()) * 1000L;
-
-        if (!resultMetaData.columnTypes[--columnIndex]
-                .isDateTimeTypeWithZone()) {
-            Calendar calendar = cal == null ? session.getCalendar()
-                    : cal;
-
-            millis = HsqlDateTime.convertMillisToCalendar(calendar, millis);
-            millis = HsqlDateTime.getNormalisedTime(millis);
-        }
-
-        return new Time(millis);
+        return (Time) Type.SQL_TIME.convertSQLToJava(session, t, cal);
     }
 
     /**
@@ -4798,9 +4785,10 @@ public class JDBCResultSet implements Re
      * <li>If the SQL type of the column is WITH TIME ZONE, then the UTC value
      * of the returned java.sql.Time object is the UTC of the SQL value without
      * modification. In other words, the Calendar object is not used.</li>
-     * <li>If the SQL type of the column is WITHOUT TIME ZONE, then the UTC
-     * value of the returned java.sql.Time is correct for the given Calendar
-     * object.</li>
+     * <li>If the SQL type of the column is WITHOUT TIME ZONE, then the
+     * UTC value of the returned java.sql.Time will represent the correct
+     * time for the time zone (including daylight saving time) of the given
+     * Calendar. </li>
      * <li>If the cal argument is null, it it ignored and the method returns
      * the same Object as the method without the Calendar parameter.</li>
      * </ol>
@@ -4865,11 +4853,6 @@ public class JDBCResultSet implements Re
      */
     public Timestamp getTimestamp(int columnIndex,
                                   Calendar cal) throws SQLException {
-
-        if (cal == null) {
-            return getTimestamp(columnIndex);
-        }
-
         TimestampData t = (TimestampData) getColumnInType(columnIndex,
             Type.SQL_TIMESTAMP);
 
@@ -4877,19 +4860,7 @@ public class JDBCResultSet implements Re
             return null;
         }
 
-        long millis = t.getSeconds() * 1000;
-
-        if (!resultMetaData.columnTypes[columnIndex - 1]
-                .isDateTimeTypeWithZone()) {
-                millis = HsqlDateTime.convertMillisToCalendar(cal,
-                        millis);
-        }
-
-        Timestamp ts = new Timestamp(millis);
-
-        ts.setNanos(t.getNanos());
-
-        return ts;
+        return (Timestamp) Type.SQL_TIMESTAMP.convertSQLToJava(session, t, cal);
     }
 
     /**
@@ -6002,7 +5973,7 @@ public class JDBCResultSet implements Re
 
     /**
      * Updates the designated column with an ascii stream value, which will have
-     * the specified number of bytes..
+     * the specified number of bytes.
      * The updater methods are used to update column values in the
      * current row or the insert row.  The updater methods do not
      * update the underlying database; instead the <code>updateRow</code> or
@@ -6860,13 +6831,7 @@ public class JDBCResultSet implements Re
             throw JDBCUtil.nullArgument();
         }
 
-        Type hsqlType = Types.getParameterSQLType(type);
-
-        if(hsqlType == null) {
-            throw JDBCUtil.sqlException(ErrorCode.X_42561);
-        }
-
-        Object source = getColumnValue(columnIndex);
+        final Object source = getColumnValue(columnIndex);
 
         if (wasNullValue) {
             return null;
@@ -6933,42 +6898,69 @@ public class JDBCResultSet implements Re
                 break;
             }
             case "java.util.UUID": {
-                source = getColumnInType(columnIndex, hsqlType);
-                o = Type.SQL_GUID.convertSQLToJava(session, source);
+                Type columnType = resultMetaData.columnTypes[columnIndex - 1];
+                if (columnType.isUUIDType()) {
+                    o = Type.SQL_GUID.convertSQLToJava(session, source);
+                } else {
+                    Object value = Type.SQL_GUID.convertToTypeJDBC(session,
+                            source, columnType);
+                    o = Type.SQL_GUID.convertSQLToJava(session, value);
+                }
+                break;
+            }
+            case "java.time.Instant": {
+                Type columnType = resultMetaData.columnTypes[columnIndex - 1];
+                if (columnType.isDateOrTimestampType()) {
+                    TimestampData v = (TimestampData) source;
+                    o = ((DateTimeType) columnType).toInstant(session, v);
+                }
                 break;
             }
             case "java.time.LocalDate": {
-                source = getColumnInType(columnIndex, hsqlType);
-                TimestampData v = (TimestampData) source;
-                long millis = v.getMillis();
-                Calendar cal = session.getCalendarGMT();
-                cal.setTimeInMillis(millis);
-                o = LocalDate.of(cal.get(Calendar.YEAR), cal.get(Calendar.MONTH) + 1, cal.get(Calendar.DAY_OF_MONTH));
+                Type columnType = resultMetaData.columnTypes[columnIndex - 1];
+                if (columnType.isDateOrTimestampType()) {
+                    TimestampData v = (TimestampData) source;
+                    o = ((DateTimeType) columnType).toLocalDate(session, v);
+                }
                 break;
             }
             case "java.time.LocalTime": {
-                source = getColumnInType(columnIndex, hsqlType);
-                TimeData v = (TimeData) source;
-                o = LocalTime.ofNanoOfDay(v.getSeconds() * 1000000000L + v.getNanos());
+                Type columnType = resultMetaData.columnTypes[columnIndex - 1];
+                if (columnType.isTimeType()) {
+                    TimeData v = (TimeData) source;
+                    o = ((DateTimeType) columnType).toLocalTime(session, v);
+                } else if (columnType.isTimestampType()) {
+                    TimestampData v = (TimestampData) source;
+                    o = ((DateTimeType) columnType).toLocalTime(session, v);
+                }
                 break;
             }
             case "java.time.LocalDateTime": {
-                source = getColumnInType(columnIndex, hsqlType);
-                TimestampData v = (TimestampData) source;
-
-                long millis = v.getMillis();
-                int nanos = v.getNanos();
-                Calendar cal = session.getCalendarGMT();
-                cal.setTimeInMillis(millis);
-                o = LocalDateTime.of(cal.get(Calendar.YEAR), cal.get(Calendar.MONTH) + 1, cal.get(Calendar.DAY_OF_MONTH), cal.get(Calendar.HOUR_OF_DAY), cal.get(Calendar.MINUTE), cal.get(Calendar.SECOND ), nanos);
+                Type columnType = resultMetaData.columnTypes[columnIndex - 1];
+                if (columnType.isDateOrTimestampType()) {
+                    TimestampData v = (TimestampData) source;
+                    o = ((DateTimeType) columnType).toLocalDateTime(session, v);
+                }
                 break;
             }
             case "java.time.OffsetTime": {
-                o = getTimeWithZone(columnIndex);
+                Type columnType = resultMetaData.columnTypes[columnIndex - 1];
+                if (columnType.isTimeType()) {
+                    TimeData v = (TimeData) source;
+                    o = ((DateTimeType) columnType).toOffsetTime(session, v);
+                } else if (columnType.isTimestampType()) {
+                    TimestampData v = (TimestampData) source;
+                    o = ((DateTimeType) columnType).toOffsetTime(session, v);
+                }
+
                 break;
             }
             case "java.time.OffsetDateTime": {
-                o = getTimestampWithZone(columnIndex);
+                Type columnType = resultMetaData.columnTypes[columnIndex - 1];
+                if (columnType.isDateOrTimestampType()) {
+                    TimestampData v = (TimestampData) source;
+                    o = ((DateTimeType) columnType).toOffsetDateTime(session, v);
+                }
                 break;
             }
             case "java.time.Duration": {
@@ -7206,61 +7198,26 @@ public class JDBCResultSet implements Re
 
 //#endif JAVA8
 
-
-//#ifdef JAVA8
     private Object getTimestampWithZone(int columnIndex) throws SQLException {
-        TimestampData v = (TimestampData) getColumnInType(columnIndex, Type.SQL_TIMESTAMP_WITH_TIME_ZONE);
+        TimestampData v = (TimestampData) getColumnInType(columnIndex,
+            Type.SQL_TIMESTAMP_WITH_TIME_ZONE);
 
         if (v == null) {
             return null;
         }
-
-        ZoneOffset    z   = ZoneOffset.ofTotalSeconds(v.getZone());
-        LocalDateTime ldt = LocalDateTime.ofEpochSecond(v.getSeconds(), v.getNanos(), z);
-
-        return OffsetDateTime.of(ldt, z);
+        return Type.SQL_TIMESTAMP_WITH_TIME_ZONE.convertSQLToJava(session, v);
     }
 
     private Object getTimeWithZone(int columnIndex) throws SQLException {
-        TimeData v = (TimeData) getColumnInType(columnIndex, Type.SQL_TIME_WITH_TIME_ZONE);
+        DateTimeType columnType = (DateTimeType) resultMetaData.columnTypes[columnIndex - 1];
+        TimeData v = (TimeData) getColumnValue(columnIndex);
 
         if (v == null) {
             return null;
         }
-
-        int s = v.getSeconds() + v.getZone();
-
-        s = DateTimeType.normaliseTime(s);
-
-        ZoneOffset z  = ZoneOffset.ofTotalSeconds(v.getZone());
-        LocalTime  lt = LocalTime.ofNanoOfDay(s * 1000000000L + v.getNanos());
-
-        return OffsetTime.of(lt, z);
+        return columnType.convertSQLToJava(session, v);
     }
 
-//#else
-/*
-    private Object getTimestampWithZone(int columnIndex) throws SQLException {
-        TimestampData v = (TimestampData) getColumnInType(columnIndex, Type.SQL_TIMESTAMP_WITH_TIME_ZONE);
-
-        if (v == null) {
-            return null;
-        }
-        return Type.SQL_TIMESTAMP.convertSQLToJava(session, v);
-    }
-
-    private Object getTimeWithZone(int columnIndex) throws SQLException {
-        TimeData v = (TimeData) getColumnInType(columnIndex, Type.SQL_TIME_WITH_TIME_ZONE);
-
-        if (v == null) {
-            return null;
-        }
-        return Type.SQL_TIME.convertSQLToJava(session, v);
-    }
-*/
-//#endif JAVA8
-
-
 //------------------------ Internal Implementation -----------------------------
 
     /** The internal representation. */
@@ -7283,7 +7240,7 @@ public class JDBCResultSet implements Re
     /** The ResultSetMetaData object for this ResultSet */
     private ResultSetMetaData resultSetMetaData;
 
-    /** Accelerates findColumn; Map<columnName, columnIndex> */
+    /** Accelerates fineColumn {@code Map<columnName, columnIndex>} */
     private IntValueHashMap columnMap;
 
     /** The first warning in the chain. Null if there are no warnings. */
@@ -7296,7 +7253,7 @@ public class JDBCResultSet implements Re
 
     /**
      * The Statement that generated this result. Null if the result is
-     * from DatabaseMetaData<p>
+     * from DatabaseMetaData
      */
     JDBCStatementBase statement;
 
@@ -7441,19 +7398,16 @@ public class JDBCResultSet implements Re
                                      Type targetType) throws SQLException {
 
         Object value = getColumnValue(columnIndex);
-        Type sourceType;
+        Type sourceType = resultMetaData.columnTypes[columnIndex - 1];
 
         if (value == null) {
             return null;
         }
 
-        sourceType = resultMetaData.columnTypes[columnIndex - 1];
-
         if (translateTTIType && targetType.isIntervalType()) {
             targetType = ((IntervalType) targetType).getCharacterType();
         }
 
-
         if (sourceType.typeCode != targetType.typeCode) {
             try {
                 value = targetType.convertToTypeJDBC(session, value,
@@ -7492,7 +7446,7 @@ public class JDBCResultSet implements Re
      * row number after any updateXXX()
      * -1 after updateRow(), clearUpdate() or moveToCurrentRow();
      */
-    int currentUpdateRowNumber;
+    int currentUpdateRowNumber = -1;
 
     private void checkUpdatable() throws SQLException {
 
@@ -7525,10 +7479,12 @@ public class JDBCResultSet implements Re
 
         checkUpdatable(columnIndex);
 
-        if (currentUpdateRowNumber != navigator.getRowNumber()) {
-            preparedStatement.clearParameters();
+        if (!isOnInsertRow) {
+            if (currentUpdateRowNumber != navigator.getRowNumber()) {
+                preparedStatement.clearParameters();
+            }
+            currentUpdateRowNumber = navigator.getRowNumber();
         }
-        currentUpdateRowNumber = navigator.getRowNumber();
         isRowUpdated           = true;
     }
 
@@ -7536,7 +7492,7 @@ public class JDBCResultSet implements Re
 
         checkUpdatable();
         preparedStatement.clearParameters();
-
+        currentUpdateRowNumber = -1;
         isRowUpdated = false;
     }
 
@@ -7545,6 +7501,7 @@ public class JDBCResultSet implements Re
         checkUpdatable();
 
         // check insertable
+        currentUpdateRowNumber = -2;
         isOnInsertRow = true;
     }
 
@@ -7553,6 +7510,7 @@ public class JDBCResultSet implements Re
         checkUpdatable();
         preparedStatement.clearParameters();
 
+        currentUpdateRowNumber = -1;
         isOnInsertRow = false;
     }
 
@@ -7588,7 +7546,9 @@ public class JDBCResultSet implements Re
             boolean set = preparedStatement.parameterSet[i];
 
             if (!set) {
-                throw JDBCUtil.sqlException(ErrorCode.X_24515);
+                if(!resultMetaData.columns[i].isIdentity()) {
+                    throw JDBCUtil.sqlException(ErrorCode.X_24515);
+                }
             }
             preparedStatement.resultOut.metaData.columnTypes[i] =
                 preparedStatement.parameterTypes[i];
@@ -7601,12 +7561,18 @@ public class JDBCResultSet implements Re
         rootWarning = preparedStatement.getWarnings();
 
         preparedStatement.clearWarnings();
+
+        isRowUpdated = false;
     }
 
     private void performDelete() throws SQLException {
 
         checkUpdatable();
 
+        if (isOnInsertRow) {
+            throw JDBCUtil.sqlExceptionSQL(ErrorCode.X_24504);
+        }
+
         preparedStatement.parameterValues[columnCount] =
             getCurrent()[columnCount];
         preparedStatement.resultOut.metaData.columnTypes[columnCount] =
@@ -7682,11 +7648,7 @@ public class JDBCResultSet implements Re
 
         if (conn != null) {
             translateTTIType = conn.isTranslateTTIType;
-
-            if (conn.connProperties != null) {
-                memoryLobs = conn.connProperties.isPropertyTrue(
-                    HsqlDatabaseProperties.url_memory_lobs, false);
-            }
+            memoryLobs       = conn.isMemoryLobs;
         }
     }
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCResultSetMetaData.java 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCResultSetMetaData.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCResultSetMetaData.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCResultSetMetaData.java	2022-04-21 06:31:02.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -40,7 +40,7 @@ import org.hsqldb.types.IntervalType;
 import org.hsqldb.types.Type;
 import org.hsqldb.types.Types;
 
-/* $Id: JDBCResultSetMetaData.java 6266 2021-01-25 16:08:06Z fredt $ */
+/* $Id: JDBCResultSetMetaData.java 6492 2022-04-21 07:30:40Z fredt $ */
 
 // fredt@users    - 20040412 - removed DITypeInfo dependencies
 // campbell-burnet@users - 200404xx - removed unused imports;refinement for better
@@ -823,7 +823,7 @@ public class JDBCResultSetMetaData imple
      * or a proxy for the receiver. If the receiver is a wrapper
      * and the wrapped object implements the interface then the result is the
      * wrapped object or a proxy for the wrapped object. Otherwise return the
-     * the result of calling <code>unwrap</code> recursively on the wrapped object
+     * result of calling <code>unwrap</code> recursively on the wrapped object
      * or a proxy for that result. If the receiver is not a
      * wrapper and does not implement the interface, then an <code>SQLException</code> is thrown.
      *
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCRowId.java 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCRowId.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCRowId.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCRowId.java	2022-04-21 06:31:02.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -39,7 +39,7 @@ import java.sql.RowId;
 import java.sql.SQLException;
 import java.util.Arrays;
 
-/* $Id: JDBCRowId.java 6266 2021-01-25 16:08:06Z fredt $ */
+/* $Id: JDBCRowId.java 6492 2022-04-21 07:30:40Z fredt $ */
 
 //campbell-burnet@users 20060522 - doc 1.8.1 full synch up to Mustang Build 84
 
@@ -108,7 +108,7 @@ public final class JDBCRowId implements
     }
 
     /**
-     * Constructs a new JDBCRowId instance whose internal octet sequence is
+     * Constructs a new JDBCRowId instance whose internal octet sequence
      * is a copy of the octet sequence of the given RowId object. <p>
      *
      * @param id the octet sequence representing the Rowid value
@@ -119,7 +119,7 @@ public final class JDBCRowId implements
     }
 
     /**
-     * Constructs a new JDBCRowId instance whose internal octet sequence is
+     * Constructs a new JDBCRowId instance whose internal octet sequence
      * is that represented by the given hexadecimal character sequence. <p>
      * @param hex the hexadecimal character sequence from which to derive
      *        the internal octet sequence
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCSQLXML.java 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCSQLXML.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCSQLXML.java	2021-02-09 16:10:54.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCSQLXML.java	2022-04-21 06:31:02.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -102,7 +102,7 @@ import org.xml.sax.InputSource;
 import org.xml.sax.Locator;
 import org.xml.sax.SAXException;
 
-/* $Id: JDBCSQLXML.java 6299 2021-02-09 17:10:48Z fredt $ */
+/* $Id: JDBCSQLXML.java 6492 2022-04-21 07:30:40Z fredt $ */
 
 /**
  * <!-- start generic documentation -->
@@ -641,7 +641,7 @@ public class JDBCSQLXML implements SQLXM
 
     /**
      * This method closes this object and releases the resources that it held.
-     * The SQL XML object becomes invalid and neither readable or writable
+     * The SQL XML object becomes invalid and neither readable nor writable
      * when this method is called.<p>
      *
      * After <code>free</code> has been called, any attempt to invoke a
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCStatementBase.java 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCStatementBase.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCStatementBase.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCStatementBase.java	2022-04-21 06:31:02.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -61,7 +61,7 @@ import org.hsqldb.result.ResultConstants
  *
  * ResultSets may be held over commits and span several transactions.
  *
- * There is no real relation between the current state fo an Statement instance
+ * There is no real relation between the current state of a Statement instance
  * and the various ResultSets that it may have returned for different queries.
  */
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCStatement.java 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCStatement.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/JDBCStatement.java	2021-02-07 17:08:32.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/JDBCStatement.java	2022-04-19 17:00:36.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -48,7 +48,7 @@ import org.hsqldb.result.Result;
 import org.hsqldb.result.ResultConstants;
 import org.hsqldb.result.ResultProperties;
 
-/* $Id: JDBCStatement.java 6294 2021-02-07 18:08:27Z fredt $ */
+/* $Id: JDBCStatement.java 6489 2022-04-19 18:00:13Z fredt $ */
 
 // fredt@users   20020320 - patch 1.7.0 - JDBC 2 support and error trapping
 //
@@ -103,7 +103,7 @@ import org.hsqldb.result.ResultPropertie
  *
  * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since HSQLDB 1.9.0
  * @see JDBCConnection#createStatement
  * @see JDBCResultSet
@@ -547,7 +547,7 @@ public class JDBCStatement extends JDBCS
      * used in SQL positioned update or delete statements to identify the
      * current row in the <code>ResultSet</code> object generated by this
      * statement.  If the database does not support positioned update/delete,
-     * this method is a noop.  To insure that a cursor has the proper isolation
+     * this method is a noop.  To ensure that a cursor has the proper isolation
      * level to support updates, the cursor's <code>SELECT</code> statement
      * should have the form <code>SELECT FOR UPDATE</code>.  If
      * <code>FOR UPDATE</code> is not present, positioned updates may fail.
@@ -1586,10 +1586,9 @@ public class JDBCStatement extends JDBCS
      * Retrieves whether this <code>Statement</code> object has been closed. A <code>Statement</code> is closed if the
      * method close has been called on it, or if it is automatically closed.
      * @return true if this <code>Statement</code> object is closed; false if it is still open
-     * @throws SQLException if a database access error occurs
      * @since JDK 1.6, HSQLDB 2.0
      */
-    public synchronized boolean isClosed() throws SQLException {
+    public synchronized boolean isClosed() {
         return isClosed;
     }
 
@@ -1657,7 +1656,7 @@ public class JDBCStatement extends JDBCS
      * or a proxy for the receiver. If the receiver is a wrapper
      * and the wrapped object implements the interface then the result is the
      * wrapped object or a proxy for the wrapped object. Otherwise return the
-     * the result of calling <code>unwrap</code> recursively on the wrapped object
+     * result of calling <code>unwrap</code> recursively on the wrapped object
      * or a proxy for that result. If the receiver is not a
      * wrapper and does not implement the interface, then an <code>SQLException</code> is thrown.
      *
@@ -2083,4 +2082,9 @@ public class JDBCStatement extends JDBCS
             getMoreResults();
         }
     }
+
+    public int getResultSetScrollability() {
+        return ResultProperties.getJDBCScrollability(rsProperties);
+    }
+
 }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/pool/JDBCXID.java 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/pool/JDBCXID.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/jdbc/pool/JDBCXID.java	2020-11-22 09:56:16.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/jdbc/pool/JDBCXID.java	2022-02-21 14:41:50.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2020, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/CharArrayWriter.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/CharArrayWriter.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/CharArrayWriter.java	2021-02-06 23:35:04.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/CharArrayWriter.java	2022-05-23 11:24:38.000000000 +0000
@@ -63,13 +63,8 @@ public class CharArrayWriter {
             int read = reader.read(buffer, count, left);
 
             if (read == -1) {
-                if (left > 0) {
-                    reader.close();
-
-                    throw new EOFException();
-                }
-
-                break;
+                reader.close();
+                throw new EOFException();
             }
 
             left  -= read;
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/ClosableCharArrayWriter.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/ClosableCharArrayWriter.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/ClosableCharArrayWriter.java	2021-02-09 04:48:08.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/ClosableCharArrayWriter.java	2022-05-17 12:18:14.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -280,6 +280,8 @@ public class ClosableCharArrayWriter ext
      * characters, then it may be resized to become more space efficient.
      * Calling this method may, but is not required to, affect the value
      * returned by a subsequent call to the {@link #capacity()} method.
+     *
+     * @throws IOException if buffer is freed
      */
     public synchronized void trimToSize() throws IOException {
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/CountUpDownLatch.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/CountUpDownLatch.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/CountUpDownLatch.java	2021-02-09 04:54:52.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/CountUpDownLatch.java	2022-06-08 08:17:16.000000000 +0000
@@ -463,7 +463,7 @@ public class CountUpDownLatch {
          *                                  cause a silent numeric overflow,
          *                                  resulting in a negative
          *                                  {@code count}.
-         * @throws IllegalArgumentException if {@code amount is less than one)
+         * @throws IllegalArgumentException if {@code amount is less than one}
          *
          */
         boolean countUp(int amount) {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/DoubleIntIndex.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/DoubleIntIndex.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/DoubleIntIndex.java	2021-02-07 17:08:32.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/DoubleIntIndex.java	2022-06-08 08:17:32.000000000 +0000
@@ -752,7 +752,7 @@ public class DoubleIntIndex implements L
     }
 
     /**
-     * Returns the index of the lowest element >= the given search target, or
+     * Returns the index of the lowest element {@code >=} the given search target, or
      * count.
      *
      * @return the index or count.
@@ -780,7 +780,7 @@ public class DoubleIntIndex implements L
     }
 
     /**
-     * Returns the index of the lowest element > the given search target
+     * Returns the index of the lowest element {@code >} the given search target
      * or count or -1 if target is found
      * @return the index
      */
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/DoubleLongIndex.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/DoubleLongIndex.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/DoubleLongIndex.java	2021-02-07 01:45:22.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/DoubleLongIndex.java	2022-06-08 08:17:40.000000000 +0000
@@ -321,7 +321,7 @@ public final class DoubleLongIndex imple
     }
 
     /**
-     * Returns the index of the lowest element >= the given search target, or
+     * Returns the index of the lowest element {@code >=} the given search target, or
      * count
      *
      * @return the index or count
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/EventLogInterface.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/EventLogInterface.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/EventLogInterface.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/EventLogInterface.java	2022-07-07 15:28:30.000000000 +0000
@@ -0,0 +1,48 @@
+/* Copyright (c) 2001-2022, The HSQL Development Group
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ * Redistributions of source code must retain the above copyright notice, this
+ * list of conditions and the following disclaimer.
+ *
+ * Redistributions in binary form must reproduce the above copyright notice,
+ * this list of conditions and the following disclaimer in the documentation
+ * and/or other materials provided with the distribution.
+ *
+ * Neither the name of the HSQL Development Group nor the names of its
+ * contributors may be used to endorse or promote products derived from this
+ * software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL HSQL DEVELOPMENT GROUP, HSQLDB.ORG,
+ * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+ * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+ * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+ * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+ * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+ * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+
+package org.hsqldb.lib;
+
+/**
+ * @author Fred Toussi (fredt@users dot sourceforge.net)
+ * @version 2.7.0
+ * @since 1.9.0
+ */
+public interface EventLogInterface {
+
+    void logSevereEvent(String message, Throwable t);
+
+    void logWarningEvent(String message, Throwable t);
+
+    void logInfoEvent(String message);
+
+    void logDetailEvent(String message);
+}
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/FileAccess.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/FileAccess.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/FileAccess.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/FileAccess.java	2022-07-08 18:59:22.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -39,7 +39,7 @@ import java.io.OutputStream;
  * Interface for abstraction of file access.
  *
  * @author  Ocke Janssen oj@openoffice.org
- * @version 2.5.1
+ * @version 2.7.0
  * @since 1.8.0
  */
 public interface FileAccess {
@@ -65,7 +65,8 @@ public interface FileAccess {
 
     boolean renameElement(String oldName, String newName);
 
-    boolean renameElementOrCopy(String oldName, String newName);
+    boolean renameElementOrCopy(String oldName, String newName,
+                                EventLogInterface logger);
 
     interface FileSync {
         void sync() throws IOException;
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/FileAccessRes.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/FileAccessRes.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/FileAccessRes.java	2020-03-19 19:07:58.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/FileAccessRes.java	2022-07-08 18:39:36.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -37,8 +37,11 @@ import java.io.InputStream;
 import java.io.OutputStream;
 import java.net.URL;
 
-import org.hsqldb.lib.FileAccess.FileSync;
-
+/**
+* @author Fred Toussi (fredt@users dot sourceforge.net)
+* @version 2.7.0
+* @since 1.8.0
+*/
 public class FileAccessRes implements FileAccess {
 
     public boolean isStreamElement(String fileName) {
@@ -102,15 +105,18 @@ public class FileAccessRes implements Fi
         return false;
     }
 
-    public boolean renameElementOrCopy(String oldName, String newName) {
+    public boolean renameElementOrCopy(String oldName, String newName,
+                                       EventLogInterface logger) {
         return false;
     }
 
-    public OutputStream openOutputStreamElement(String streamName) throws IOException {
+    public OutputStream openOutputStreamElement(String streamName)
+    throws IOException {
         throw new IOException();
     }
 
-    public OutputStream openOutputStreamElementAppend(String streamName) throws IOException {
+    public OutputStream openOutputStreamElementAppend(String streamName)
+    throws IOException {
         throw new IOException();
     }
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/FileUtil.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/FileUtil.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/FileUtil.java	2021-02-09 04:54:46.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/FileUtil.java	2022-07-08 18:59:22.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -50,13 +50,11 @@ import org.hsqldb.lib.java.JavaSystem;
  * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
  * @author Fred Toussi (fredt@users dot sourceforge.net)
  * @author Ocke Janssen oj@openoffice.org
- * @version 2.5.1
+ * @version 2.7.0
  * @since 1.7.2
  */
 public class FileUtil implements FileAccess {
 
-    private static final FrameworkLogger LOG =
-        FrameworkLogger.getLog(FileUtil.class);
     private static FileUtil      fileUtil      = new FileUtil();
     private static FileAccessRes fileAccessRes = new FileAccessRes();
 
@@ -103,7 +101,8 @@ public class FileUtil implements FileAcc
         return renameWithOverwrite(oldName, newName);
     }
 
-    public boolean renameElementOrCopy(String oldName, String newName) {
+    public boolean renameElementOrCopy(String oldName, String newName,
+                                       EventLogInterface logger) {
 
         if (renameWithOverwrite(oldName, newName)) {
             return true;
@@ -123,7 +122,7 @@ public class FileUtil implements FileAcc
                 "Platform does not allow renaming files and failed to copy file contents from %s to %s",
                 oldName, newName);
 
-            LOG.error(message, e);
+            logger.logSevereEvent(message, e);
 
             return false;
         } finally {
@@ -132,7 +131,7 @@ public class FileUtil implements FileAcc
                     inputStream.close();
                 }
             } catch (IOException e) {
-                LOG.finest("Failed to dispose streams", e);
+                logger.logWarningEvent("Failed to dispose streams", e);
             }
 
             try {
@@ -140,19 +139,20 @@ public class FileUtil implements FileAcc
                     outputStream.close();
                 }
             } catch (IOException e) {
-                LOG.finest("Failed to dispose streams", e);
+                logger.logDetailEvent("Failed to dispose streams");
             }
         }
 
         if (!delete(oldName)) {
-            LOG.warning("Failed to delete renamed file " + oldName);
+            logger.logWarningEvent("Failed to delete renamed file " + oldName,
+                                   null);
         }
 
         String message = String.format(
             "Platform does not allow renaming files. Copied file from %s to %s instead",
             oldName, newName);
 
-        LOG.finer(message);
+        logger.logDetailEvent(message);
 
         return true;
     }
@@ -494,10 +494,10 @@ public class FileUtil implements FileAcc
 
     static class DatabaseFilenameFilter implements FilenameFilter {
 
-        String[] suffixes      = new String[] {
+        String[]        suffixes      = new String[] {
             ".backup", ".properties", ".script", ".data", ".log", ".lobs"
         };
-        String[] extraSuffixes = new String[] {
+        String[]        extraSuffixes = new String[] {
             ".lck", ".sql.log", ".app.log"
         };
         private String  dbName;
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/FrameworkLogger.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/FrameworkLogger.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/FrameworkLogger.java	2021-02-08 20:12:02.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/FrameworkLogger.java	2022-07-07 13:56:28.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -84,7 +84,7 @@ import java.util.logging.Logger;
  * configuration takes place.
  *
  * @author Blaine Simpson (blaine dot simpson at admc dot com)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class FrameworkLogger {
@@ -334,7 +334,10 @@ public class FrameworkLogger {
 
         String propVal = System.getProperty("hsqldb.reconfig_logging");
 
-        if (propVal != null && propVal.equalsIgnoreCase("false")) {
+        // from 2.7.0 the system property must be set to true for any reconfig
+        // the new hsqldb.extlog=level property specifies the level above which
+        // messages are logged to JUL OR Log4J
+        if (propVal == null || !propVal.equalsIgnoreCase("true")) {
             return;
         }
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/HashSet.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/HashSet.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/HashSet.java	2021-02-07 17:08:32.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/HashSet.java	2022-05-30 12:51:16.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -37,7 +37,7 @@ import org.hsqldb.map.BaseHashMap;
  * This class does not store null keys.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 1.7.2
  */
 public class HashSet<E> extends BaseHashMap implements Set<E> {
@@ -60,6 +60,14 @@ public class HashSet<E> extends BaseHash
         this.comparator = comparator;
     }
 
+    public HashSet(Object[] valueList) {
+        this(valueList.length);
+
+        for (int i = 0; i < valueList.length; i++) {
+            add((E) valueList[i]);
+        }
+    }
+
     public boolean contains(Object key) {
         return super.containsKey(key);
     }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/HsqlByteArrayOutputStream.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/HsqlByteArrayOutputStream.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/HsqlByteArrayOutputStream.java	2021-02-09 04:48:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/HsqlByteArrayOutputStream.java	2022-05-17 12:18:14.000000000 +0000
@@ -73,8 +73,12 @@ implements DataOutput {
 
     /**
      * Constructor from an InputStream limits size to the length argument.
-     * Throws if the actual length of the InputStream is smaller than
-     * length value.
+     * Throws if the actual length of the InputStream is smaller than length
+     * value.
+     *
+     * @param input InputStream
+     * @param length int
+     * @throws IOException if an error occurs
      */
     public HsqlByteArrayOutputStream(InputStream input,
                                      int length) throws IOException {
@@ -411,6 +415,8 @@ implements DataOutput {
 
     /**
      * size must fit in buffer
+     *
+     * @param size int
      */
     public void setSize(int size) {
         count = size;
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/HsqlConsoleHandler.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/HsqlConsoleHandler.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/HsqlConsoleHandler.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/HsqlConsoleHandler.java	2022-04-02 16:02:58.000000000 +0000
@@ -0,0 +1,36 @@
+/* Copyright (c) 2001-2022, The HSQL Development Group
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ * Redistributions of source code must retain the above copyright notice, this
+ * list of conditions and the following disclaimer.
+ *
+ * Redistributions in binary form must reproduce the above copyright notice,
+ * this list of conditions and the following disclaimer in the documentation
+ * and/or other materials provided with the distribution.
+ *
+ * Neither the name of the HSQL Development Group nor the names of its
+ * contributors may be used to endorse or promote products derived from this
+ * software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL HSQL DEVELOPMENT GROUP, HSQLDB.ORG,
+ * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+ * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+ * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+ * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+ * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+ * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+
+package org.hsqldb.lib;
+
+import java.util.logging.ConsoleHandler;
+
+public class HsqlConsoleHandler extends ConsoleHandler {}
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/HsqlTimer.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/HsqlTimer.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/HsqlTimer.java	2021-02-06 23:35:04.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/HsqlTimer.java	2022-06-08 08:18:14.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -56,23 +56,23 @@ import java.util.Date;
 public final class HsqlTimer implements Comparator, ThreadFactory {
 
     /** The priority queue for the scheduled tasks. */
-    protected final TaskQueue taskQueue = new TaskQueue(16, this);
+    final TaskQueue taskQueue = new TaskQueue(16, this);
 
     /** The inner runnable that executes tasks in the background thread. */
-    protected final TaskRunner taskRunner = new TaskRunner();
+    final TaskRunner taskRunner = new TaskRunner();
 
     /** The background thread. */
-    protected Thread taskRunnerThread;
+    Thread taskRunnerThread;
 
     /** The factory that produces the background threads. */
-    protected final ThreadFactory threadFactory;
+    final ThreadFactory threadFactory;
 
     /**
      * Whether this timer should disallow all further processing.
      *
      * Once set true, stays true forever.
      */
-    protected volatile boolean isShutdown;
+    volatile boolean isShutdown;
 
     /**
      * Constructs a new HsqlTimer using the default thread factory
@@ -459,7 +459,7 @@ public final class HsqlTimer implements
      * @param relative if true, use fixed rate else use fixed delay scheduling
      * @return an opaque reference to the internal task
      */
-    protected Task addTask(final long first, final Runnable runnable,
+    Task addTask(final long first, final Runnable runnable,
                            final long period, boolean relative) {
 
         if (this.isShutdown) {
@@ -478,7 +478,7 @@ public final class HsqlTimer implements
     }
 
     /** Sets the background thread to null. */
-    protected synchronized void clearThread() {
+    synchronized void clearThread() {
 
         try {
             taskRunnerThread.setContextClassLoader(null);
@@ -493,7 +493,7 @@ public final class HsqlTimer implements
      *
      * @return the next task to execute, or null
      */
-    protected Task nextTask() {
+    Task nextTask() {
 
         try {
             while (!this.isShutdown || Thread.interrupted()) {
@@ -868,7 +868,7 @@ public final class HsqlTimer implements
          * {@link #unpark() unpark} or the specified amount of time has
          * elapsed.
          *
-         * Implements the sync & wait(n) half of this queue's availability
+         * Implements the sync and wait(n) half of this queue's availability
          * condition. <p>
          *
          * @param timeout the maximum time to wait in milliseconds.
@@ -947,7 +947,7 @@ public final class HsqlTimer implements
          * Wakes up a single thread (if any) that is waiting on this queue's
          * {@link #park(long) park} method.
          *
-         * Implements the sync & notify half of this queue's availability
+         * Implements the sync and notify half of this queue's availability
          * condition.
          */
         synchronized void unpark() {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/InOutUtil.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/InOutUtil.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/InOutUtil.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/InOutUtil.java	2022-05-17 12:18:14.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -54,8 +54,13 @@ public final class InOutUtil {
 
     /**
      * Implementation only supports unix line-end format and is suitable for
-     * processing HTTP and other network protocol communications. Reads and writes
-     * a line of data. Returns the number of bytes read/written.
+     * processing HTTP and other network protocol communications. Reads and
+     * writes a line of data. Returns the number of bytes read/written.
+     *
+     * @param in InputStream
+     * @param out OutputStream
+     * @throws IOException on failure
+     * @return int
      */
     public static int readLine(InputStream in,
                                OutputStream out) throws IOException {
@@ -82,11 +87,12 @@ public final class InOutUtil {
     }
 
     /**
-     * Retrieves the serialized form of the specified <code>Object</code>
-     * as an array of bytes.
+     * Retrieves the serialized form of the specified <code>Object</code> as an
+     * array of bytes.
      *
      * @param s the Object to serialize
-     * @return  a static byte array representing the passed Object
+     * @return a static byte array representing the passed Object
+     * @throws IOException on failure
      */
     public static byte[] serialize(Serializable s) throws IOException {
 
@@ -104,6 +110,8 @@ public final class InOutUtil {
      *
      * @return the Object resulting from deserializing the specified array of bytes
      * @param ba the byte array to deserialize to an Object
+     * @throws IOException on failure
+     * @throws ClassNotFoundException if not found
      */
     public static Serializable deserialize(byte[] ba)
     throws IOException, ClassNotFoundException {
@@ -118,7 +126,12 @@ public final class InOutUtil {
     public static final long DEFAULT_COPY_AMOUNT      = Long.MAX_VALUE;
 
     /**
+     *
      * @see #copy(java.io.InputStream, java.io.OutputStream, long, int)
+     * @param inputStream InputStream
+     * @param outputStream OutputStream
+     * @throws IOException on failure
+     * @return long
      */
     public static long copy(final InputStream inputStream,
                             final OutputStream outputStream)
@@ -128,7 +141,13 @@ public final class InOutUtil {
     }
 
     /**
+     *
      * @see #copy(java.io.InputStream, java.io.OutputStream, long, int)
+     * @param inputStream InputStream
+     * @param outputStream OutputStream
+     * @param amount long
+     * @throws IOException on failure
+     * @return long
      */
     public static long copy(final InputStream inputStream,
                             final OutputStream outputStream,
@@ -190,7 +209,12 @@ public final class InOutUtil {
     }
 
     /**
+     *
      * @see #copy(java.io.Reader, java.io.Writer, long, int)
+     * @param reader Reader
+     * @param writer Writer
+     * @throws IOException on failure
+     * @return long
      */
     public static long copy(final Reader reader,
                             final Writer writer) throws IOException {
@@ -199,7 +223,13 @@ public final class InOutUtil {
     }
 
     /**
+     *
      * @see #copy(java.io.Reader, java.io.Writer, long, int)
+     * @param reader Reader
+     * @param writer Writer
+     * @param amount long
+     * @throws IOException on failure
+     * @return long
      */
     public static long copy(final Reader reader, final Writer writer,
                             final long amount) throws IOException {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/IntIndex.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/IntIndex.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/IntIndex.java	2021-02-06 12:50:52.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/IntIndex.java	2022-06-08 08:18:54.000000000 +0000
@@ -393,7 +393,7 @@ public class IntIndex {
     }
 
     /**
-     * Returns the index of the lowest element >= the given search target,
+     * Returns the index of the lowest element {@code >=} the given search target,
      * or count
      *     @return the index
      */
@@ -419,7 +419,7 @@ public class IntIndex {
     }
 
     /**
-     * Returns the index of the lowest element > the given search target
+     * Returns the index of the lowest element {@code >} the given search target
      * or count or -1 if target is found
      * @return the index
      */
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/java/JavaSystem.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/java/JavaSystem.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/java/JavaSystem.java	2021-07-15 17:15:28.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/java/JavaSystem.java	2022-05-22 18:09:56.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -35,7 +35,6 @@ import java.io.IOException;
 import java.lang.reflect.Field;
 import java.lang.reflect.InvocationTargetException;
 import java.lang.reflect.Method;
-import java.math.BigDecimal;
 import java.nio.MappedByteBuffer;
 import java.nio.charset.Charset;
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/java/package-info.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/java/package-info.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/java/package-info.java	2021-03-23 08:35:34.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/java/package-info.java	2022-06-08 10:06:58.000000000 +0000
@@ -30,7 +30,7 @@
 
 
 /**
- *  * Contains a single static class which handles invariants, runtime and
+ *  Contains a single static class which handles invariants, runtime and
  *  methods in different JDK versions
  */
 package org.hsqldb.lib.java;
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/LineGroupReader.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/LineGroupReader.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/LineGroupReader.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/LineGroupReader.java	2022-05-17 12:18:14.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -72,6 +72,8 @@ public class LineGroupReader {
      * Default constructor for TestUtil usage.
      * Sections start at lines beginning with any non-space character.
      * SQL comment lines are ignored.
+     *
+     * @param reader LineNumberReader
      */
     public LineGroupReader(LineNumberReader reader) {
 
@@ -87,6 +89,9 @@ public class LineGroupReader {
 
     /**
      * Constructor for sections starting with specified strings.
+     *
+     * @param reader LineNumberReader
+     * @param sectionStarts String[]
      */
     public LineGroupReader(LineNumberReader reader, String[] sectionStarts) {
 
@@ -152,9 +157,12 @@ public class LineGroupReader {
         HsqlArrayList list = getNextSection();
         return convertToString(list, 0);
     }
+
     /**
-     * Returns a map/list which contains the first line of each line group
-     * as key and the rest of the lines as a String value.
+     * Returns a map/list which contains the first line of each line group as
+     * key and the rest of the lines as a String value.
+     *
+     * @return OrderedHashMap
      */
     public OrderedHashMap getAsMap() {
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/OrderedHashSet.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/OrderedHashSet.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/OrderedHashSet.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/OrderedHashSet.java	2022-05-30 12:38:54.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -31,9 +31,6 @@
 
 package org.hsqldb.lib;
 
-import java.util.ListIterator;
-
-
 /**
  * A list which is also a Set which maintains the inserted order of elements and
  * allows access by index. Iterators return the elements in the index order.<p>
@@ -41,7 +38,7 @@ import java.util.ListIterator;
  * This class does not store null elements.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class OrderedHashSet<E> extends HashSet<E> implements List<E>, Set<E> {
@@ -64,6 +61,14 @@ public class OrderedHashSet<E> extends H
         this.isList = true;
     }
 
+    public OrderedHashSet(Object[] valueList) {
+        this(valueList.length);
+
+        for (int i = 0; i < valueList.length; i++) {
+            add((E) valueList[i]);
+        }
+    }
+
     public boolean remove(Object key) {
 
         if (key == null) {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/RefCapablePropertyResourceBundle.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/RefCapablePropertyResourceBundle.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/RefCapablePropertyResourceBundle.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/RefCapablePropertyResourceBundle.java	2022-05-18 07:29:06.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -34,8 +34,6 @@ package org.hsqldb.lib;
 import java.io.IOException;
 import java.io.InputStream;
 import java.nio.charset.Charset;
-import java.security.AccessController;
-import java.security.PrivilegedAction;
 import java.util.Enumeration;
 import java.util.HashMap;
 import java.util.Locale;
@@ -46,7 +44,7 @@ import java.util.ResourceBundle;
 import java.util.regex.Matcher;
 import java.util.regex.Pattern;
 
-/* $Id: RefCapablePropertyResourceBundle.java 6266 2021-01-25 16:08:06Z fredt $ */
+/* $Id: RefCapablePropertyResourceBundle.java 6513 2022-05-18 03:25:20Z unsaved $ */
 
 /**
  * Just like PropertyResourceBundle, except keys mapped to nothing in the
@@ -192,8 +190,12 @@ public class RefCapablePropertyResourceB
     }
 
     /**
-     * Same as getString(), but expands System Variables specified in
-     * property values like ${sysvarname}.
+     * Same as getString(), but expands System Variables specified in property
+     * values like ${sysvarname}.
+     *
+     * @param key String
+     * @param behavior int
+     * @return String
      */
     public String getExpandedString(String key, int behavior) {
         String s = getString(key);
@@ -239,8 +241,13 @@ public class RefCapablePropertyResourceB
 
     /**
      * Replaces positional substitution patterns of the form %{\d} with
-     * corresponding element of the given subs array.
-     * Note that %{\d} numbers are 1-based, so we lok for subs[x-1].
+     * corresponding element of the given subs array. Note that %{\d} numbers
+     * are 1-based, so we lok for subs[x-1].
+     *
+     * @param s String
+     * @param subs String[]
+     * @param behavior int
+     * @return String
      */
     public String posSubst(String s, String[] subs, int behavior) {
         Matcher matcher  = posPattern.matcher(s);
@@ -296,6 +303,8 @@ public class RefCapablePropertyResourceB
 
     /**
      * Just identifies this RefCapablePropertyResourceBundle instance.
+     *
+     * @return String
      */
     public String toString() {
         return baseName + " for " + language + " / " + country + " / "
@@ -304,11 +313,13 @@ public class RefCapablePropertyResourceB
 
     /**
      * Returns value defined in this RefCapablePropertyResourceBundle's
-     * .properties file, unless that value is empty.
-     * If the value in the .properties file is empty, then this returns
-     * the entire contents of the referenced text file.
+     * .properties file, unless that value is empty. If the value in the
+     * .properties file is empty, then this returns the entire contents of the
+     * referenced text file.
      *
      * @see ResourceBundle#getString(String)
+     * @param key String
+     * @return String
      */
     public String getString(String key) {
         String value = wrappedBundle.getString(key);
@@ -344,16 +355,27 @@ public class RefCapablePropertyResourceB
      * Java).
      *
      * @see ResourceBundle#getBundle(String)
+     * @param baseName String
+     * @param loader ClassLoader
+     * @param loaderClass Class
+     * @return RefCapablePropertyResourceBundle
      */
     public static RefCapablePropertyResourceBundle getBundle(String baseName,
             ClassLoader loader, Class<? extends Enum<?>> loaderClass) {
         return getRef(baseName, ResourceBundle.getBundle(baseName,
                 Locale.getDefault(), loader), loaderClass);
     }
+
     /**
-     * Use exactly like java.util.ResourceBundle.get(String, Locale, ClassLoader).
+     * Use exactly like java.util.ResourceBundle.get(String, Locale,
+     * ClassLoader).
      *
      * @see ResourceBundle#getBundle(String, Locale, ClassLoader)
+     * @param baseName String
+     * @param locale Locale
+     * @param loader ClassLoader
+     * @param loaderClass Class
+     * @return RefCapablePropertyResourceBundle
      */
     public static RefCapablePropertyResourceBundle
             getBundle(String baseName, Locale locale, ClassLoader loader,
@@ -363,8 +385,13 @@ public class RefCapablePropertyResourceB
     }
 
     /**
-     * Return a ref to a new or existing RefCapablePropertyResourceBundle,
-     * or throw a MissingResourceException.
+     * Return a ref to a new or existing RefCapablePropertyResourceBundle, or
+     * throw a MissingResourceException.
+     *
+     * @param baseName String
+     * @param rb ResourceBundle
+     * @param loaderClass Class
+     * @return RefCapablePropertyResourceBundle
      */
     static private RefCapablePropertyResourceBundle getRef(String baseName,
             ResourceBundle rb, Class<? extends Enum<?>> loaderClass) {
@@ -399,13 +426,7 @@ public class RefCapablePropertyResourceB
                 + ((v == null) ? "" : ("_" + v))
                 + ".text";
         //System.err.println("Seeking " + filePath + " FOR " + baseName);
-        InputStream is = (InputStream) AccessController.doPrivileged(
-            new PrivilegedAction<InputStream>() {
-
-            public InputStream run() {
-                return loaderClass.getResourceAsStream(filePath);
-            }
-        });
+        InputStream is = loaderClass.getResourceAsStream(filePath);
         // N.b.  If were using Class.getRes... instead of ClassLoader.getRes...
         // we would need to prefix the path with "/".
         return (is == null && l != null)
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/SimpleLog.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/SimpleLog.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/SimpleLog.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/SimpleLog.java	2022-07-07 16:32:28.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -53,14 +53,15 @@ public class SimpleLog {
 
     public static final int LOG_NONE   = 0;
     public static final int LOG_ERROR  = 1;
-    public static final int LOG_NORMAL = 2;
-    public static final int LOG_DETAIL = 3;
+    public static final int LOG_WARNING = 2;
+    public static final int LOG_NORMAL = 3;
+    public static final int LOG_DETAIL = 4;
     public static final int LOG_RESULT = 4;
 
     //
     public static final String logTypeNameEngine = "ENGINE";
     static final String[]      appLogTypeNames   = {
-        "", "ERROR ", "NORMAL", "DETAIL"
+        "", "ERROR ", "WARNING", "NORMAL", "DETAIL"
     };
     static final String[]      sqlLogTypeNames   = {
         "", "BASIC ", "NORMAL", "DETAIL", "RESULT"
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/StringConverter.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/StringConverter.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/StringConverter.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/StringConverter.java	2022-03-04 20:50:54.000000000 +0000
@@ -1,7 +1,7 @@
 /*
  * For work developed by the HSQL Development Group:
  *
- * Copyright (c) 2001-2021, The HSQL Development Group
+ * Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -84,7 +84,7 @@ import org.hsqldb.map.BitMap;
  *
  * @author Thomas Mueller (Hypersonic SQL Group)
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.5.0
+ * @version 2.7.0
  * @since 1.7.2
  */
 public class StringConverter {
@@ -954,4 +954,42 @@ public class StringConverter {
 
         return b.toString();
     }
+
+    public static void toJSONString(String s, StringBuilder sb) {
+
+        int firstQuote;
+        int length = s.length();
+
+        sb.append('"');
+
+        firstQuote = s.indexOf('"');
+
+        if (firstQuote == -1) {
+            if (s.indexOf('\\') == -1) {
+                sb.append(s);
+                sb.append('"');
+
+                return;
+            }
+        }
+
+        sb.append(s.substring(0, firstQuote));
+
+        for (int i = firstQuote; i < length; i++) {
+            char c = s.charAt(i);
+
+            if (c < 32) {
+                sb.append('\\');
+                appendHex(sb, c);
+            } else {
+                if (c == '"' || c == '\\') {
+                    sb.append('\\');
+                }
+
+                sb.append(c);
+            }
+        }
+
+        sb.append('"');
+    }
 }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/tar/RB.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/tar/RB.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/tar/RB.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/tar/RB.java	2022-05-23 11:29:54.000000000 +0000
@@ -34,7 +34,7 @@ package org.hsqldb.lib.tar;
 import org.hsqldb.lib.ValidatingResourceBundle;
 import org.hsqldb.lib.RefCapableRBInterface;
 
-/* $Id: RB.java 6266 2021-01-25 16:08:06Z fredt $ */
+/* $Id: RB.java 6527 2022-05-23 12:29:48Z fredt $ */
 
 /**
  * Resource Bundle for Tar classes
@@ -117,7 +117,7 @@ public enum RB implements RefCapableRBIn
     listing_format,
     ;
 
-    private static ValidatingResourceBundle vrb =
+    private static final ValidatingResourceBundle vrb =
             new ValidatingResourceBundle(
                     RB.class.getPackage().getName() + ".rb", RB.class);
     static {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/tar/TarFileInputStream.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/tar/TarFileInputStream.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/tar/TarFileInputStream.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/tar/TarFileInputStream.java	2022-05-17 12:42:22.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -90,6 +90,8 @@ public class TarFileInputStream {
      * Convenience wrapper to use default readBufferBlocks and compressionType.
      *
      * @see #TarFileInputStream(File, int, int)
+     * @param sourceFile File
+     * @throws IOException on failure
      */
     public TarFileInputStream(File sourceFile) throws IOException {
         this(sourceFile, TarFileOutputStream.Compression.DEFAULT_COMPRESSION);
@@ -99,6 +101,9 @@ public class TarFileInputStream {
      * Convenience wrapper to use default readBufferBlocks.
      *
      * @see #TarFileInputStream(File, int, int)
+     * @param sourceFile File
+     * @param compressionType int
+     * @throws IOException on failure
      */
     public TarFileInputStream(File sourceFile,
                               int compressionType) throws IOException {
@@ -123,6 +128,10 @@ public class TarFileInputStream {
      *
      * @see #close()
      * @see #readNextHeaderBlock()
+     * @param sourceFile File
+     * @param compressionType int
+     * @param readBufferBlocks int
+     * @throws IOException on failure
      */
     public TarFileInputStream(File sourceFile, int compressionType,
                               int readBufferBlocks) throws IOException {
@@ -242,6 +251,8 @@ public class TarFileInputStream {
      * </P>
      *
      * @see #readNextHeaderBlock
+     * @throws IOException on access failure
+     * @throws TarMalformatException if malformed
      */
     public void readBlock() throws IOException, TarMalformatException {
         readBlocks(1);
@@ -250,16 +261,17 @@ public class TarFileInputStream {
     /**
      * readBlock() and readNextHeaderBlock are the methods that USERS of this
      * class should use to read header blocks from the tar file.
-     * <P>
-     * readNextHeaderBlock continues working through the Tar File from the
-     * current point until it finds a block with a non-0 first byte.
-     * </P>
+     *
+     * <P> readNextHeaderBlock continues working through the Tar File from the
+     * current point until it finds a block with a non-0 first byte. </P>
      *
      * @return  True if a header block was read and place at beginning of the
      *          readBuffer array.  False if EOF was encountered without finding
      *          any blocks with first byte != 0.  If false is returned, we have
      *          automatically closed the this TarFileInputStream too.
      * @see #readBlock
+     * @throws IOException on access failure
+     * @throws TarMalformatException if malformed
      */
     public boolean readNextHeaderBlock()
     throws IOException, TarMalformatException {
@@ -293,6 +305,7 @@ public class TarFileInputStream {
      * Implements java.io.Closeable.
      *
      * @see java.io.Closeable
+     * @throws IOException on failure
      */
     public void close() throws IOException {
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/tar/TarFileOutputStream.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/tar/TarFileOutputStream.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/tar/TarFileOutputStream.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/tar/TarFileOutputStream.java	2022-05-17 12:18:14.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -103,6 +103,8 @@ public class TarFileOutputStream {
      * Convenience wrapper to use default blocksPerRecord and compressionType.
      *
      * @see #TarFileOutputStream(File, int, int)
+     * @param targetFile File
+     * @throws IOException on failure
      */
     public TarFileOutputStream(File targetFile) throws IOException {
         this(targetFile, Compression.DEFAULT_COMPRESSION);
@@ -112,6 +114,9 @@ public class TarFileOutputStream {
      * Convenience wrapper to use default blocksPerRecord.
      *
      * @see #TarFileOutputStream(File, int, int)
+     * @param targetFile File
+     * @param compressionType int
+     * @throws IOException on failure
      */
     public TarFileOutputStream(File targetFile,
                                int compressionType) throws IOException {
@@ -125,6 +130,11 @@ public class TarFileOutputStream {
      * "tar.gz" (and that they match the specified compression type).
      *
      * It also overwrites files without warning (just like FileOutputStream).
+     *
+     * @param targetFile File
+     * @param compressionType int
+     * @param blocksPerRecord int
+     * @throws IOException on failure
      */
     public TarFileOutputStream(File targetFile, int compressionType,
                                int blocksPerRecord) throws IOException {
@@ -189,8 +199,12 @@ public class TarFileOutputStream {
 
     /**
      * This class and subclasses should write to the underlying writeStream
-     * <b>ONLY WITH THIS METHOD</b>.
-     * That way we can be confident that bytesWritten will always be accurate.
+     * <b>ONLY WITH THIS METHOD</b>. That way we can be confident that
+     * bytesWritten will always be accurate.
+     *
+     * @param byteArray byte[]
+     * @param byteCount int
+     * @throws IOException on failure
      */
     public void write(byte[] byteArray, int byteCount) throws IOException {
 
@@ -202,16 +216,21 @@ public class TarFileOutputStream {
     /**
      * The normal way to write file data (as opposed to header data or padding)
      * using this class.
+     *
+     * @param byteCount int
+     * @throws IOException on failure
      */
     public void write(int byteCount) throws IOException {
         write(writeBuffer, byteCount);
     }
 
     /**
-     * Write a user-specified 512-byte block.
-     * For efficiency, write(int) should be used when writing file body content.
+     * Write a user-specified 512-byte block. For efficiency, write(int) should
+     * be used when writing file body content.
      *
      * @see #write(int)
+     * @param block byte[]
+     * @throws IOException on failure
      */
     public void writeBlock(byte[] block) throws IOException {
 
@@ -225,6 +244,9 @@ public class TarFileOutputStream {
 
     /**
      * Writes the specified quantity of zero'd blocks.
+     *
+     * @param blockCount int
+     * @throws IOException on failure
      */
     public void writePadBlocks(int blockCount) throws IOException {
 
@@ -235,6 +257,8 @@ public class TarFileOutputStream {
 
     /**
      * Writes a single zero'd block.
+     *
+     * @throws IOException on failure
      */
     public void writePadBlock() throws IOException {
         writePadBlocks(1);
@@ -264,8 +288,10 @@ public class TarFileOutputStream {
     }
 
     /**
-     * Rounds out the current block to the next block boundary.
-     * If we are currently at a block boundary, nothing is done.
+     * Rounds out the current block to the next block boundary. If we are
+     * currently at a block boundary, nothing is done.
+     *
+     * @throws IOException on failure
      */
     public void padCurrentBlock() throws IOException {
 
@@ -285,6 +311,7 @@ public class TarFileOutputStream {
      * Implements java.io.Flushable.
      *
      * @see java.io.Flushable
+     * @throws IOException on failure
      */
     public void flush() throws IOException {
         writeStream.flush();
@@ -297,6 +324,7 @@ public class TarFileOutputStream {
      * closing it!
      *
      * @see java.io.Closeable
+     * @throws IOException on failure
      */
     public void close() throws IOException {
 
@@ -331,6 +359,7 @@ public class TarFileOutputStream {
      * finish()).
      *
      * @see #close
+     * @throws IOException on failure
      */
     public void finish() throws IOException {
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/tar/TarGenerator.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/tar/TarGenerator.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/tar/TarGenerator.java	2021-02-09 04:47:58.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/tar/TarGenerator.java	2022-05-17 11:19:34.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -73,13 +73,17 @@ public class TarGenerator {
      * At this time, PAX is only implemented for entries added as Files,
      * not entries added as Stream.
      * </P>
+     *
+     * @param paxThreshold long
      */
     public void setPaxThreshold(long paxThreshold) {
         this.paxThreshold = paxThreshold;
     }
 
     /**
+     *
      * @see #setPaxThreshold(long)
+     * @return long
      */
     public long getPaxThreshold() {
         return paxThreshold;
@@ -95,6 +99,7 @@ public class TarGenerator {
      *                     method.
      * @param overWrite    True to replace an existing file of same path.
      * @param blocksPerRecord  Null will use default tar value.
+     * @throws IOException on access failure
      */
     public TarGenerator(File inFile, boolean overWrite, Integer blocksPerRecord)
             throws IOException {
@@ -178,6 +183,12 @@ public class TarGenerator {
      * <P>
      * This limitation may or may not be eliminated in the future.
      * </P>
+
+     * @param entryPath String
+     * @param inStream InputStream
+     * @param maxBytes int
+     * @throws IOException on access failure
+     * @throws TarMalformatException if malformed
      */
     public void queueEntry(String entryPath, InputStream inStream, int maxBytes)
             throws IOException, TarMalformatException {
@@ -187,6 +198,9 @@ public class TarGenerator {
 
     /**
      * This method does release all of the streams, even if there is a failure.
+     *
+     * @throws IOException on access failure
+     * @throws TarMalformatException if malformed
      */
     public void write() throws IOException, TarMalformatException {
         if (TarFileOutputStream.debug) {
@@ -386,6 +400,10 @@ public class TarGenerator {
 
         /**
          * This creates a 'x' entry for a 0/\0 entry.
+         *
+         * @throws IOException on access failure
+         * @throws TarMalformatException if malformed
+         * @return TarEntrySupplicant
          */
         public TarEntrySupplicant makeXentry()
                 throws IOException, TarMalformatException {
@@ -408,6 +426,13 @@ public class TarGenerator {
          * After instantiating a TarEntrySupplicant, the user must either invoke
          * write() or close(), to release system resources on the input
          * File/Stream.
+         *
+         * @param path String
+         * @param file File
+         * @param tarStream TarFileOutputStream
+         * @param paxThreshold long
+         * @throws FileNotFoundException if not found
+         * @throws TarMalformatException if malformed
          */
         public TarEntrySupplicant(String path, File file,
                                   TarFileOutputStream tarStream,
@@ -472,10 +497,16 @@ public class TarGenerator {
          * RAM before anything is written to disk.
          * </P>
          *
+         * @param path String
+         * @param origStream InputStream
          * @param maxBytes This method will fail if more than maxBytes bytes
          *                 are supplied on the specified InputStream.
          *                 As the type of this parameter enforces, the max
          *                 size you can request is 2GB.
+         * @param typeFlag char
+         * @param tarStream TarFileOutputStream
+         * @throws IOException on access failure
+         * @throws TarMalformatException if malformed
          */
         public TarEntrySupplicant(String path, InputStream origStream,
                                   int maxBytes, char typeFlag,
@@ -590,6 +621,9 @@ public class TarGenerator {
          * Writes entire entry to this object's tarStream.
          *
          * This method is guaranteed to close the supplicant's input stream.
+         *
+         * @throws IOException on access failure
+         * @throws TarMalformatException if malformed
          */
         public void write() throws IOException, TarMalformatException {
             int i;
@@ -665,6 +699,9 @@ public class TarGenerator {
          * privileges for "other" (last nibble in file Mode), but no ability
          * to detect the same.
          * </P>
+         *
+         * @param file File
+         * @return String
          */
         static protected String getLameMode(File file) {
             int umod = 0;
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/tar/TarGeneratorMain.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/tar/TarGeneratorMain.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/tar/TarGeneratorMain.java	2014-01-24 17:19:38.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/tar/TarGeneratorMain.java	2022-05-17 11:10:14.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -37,9 +37,12 @@ import java.io.IOException;
 public class TarGeneratorMain {
 
     /**
-     * Creates specified tar file to contain specified files, or stdin,
-     * using default blocks-per-record and replacing tar file if it already
-     * exists.
+     * Creates specified tar file to contain specified files, or stdin, using
+     * default blocks-per-record and replacing tar file if it already exists.
+     *
+     * @param sa arguments
+     * @throws IOException on access failure
+     * @throws TarMalformatException if malformed
      */
     public static void main(String[] sa)
     throws IOException, TarMalformatException {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/tar/TarHeaderField.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/tar/TarHeaderField.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/tar/TarHeaderField.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/tar/TarHeaderField.java	2022-05-23 11:22:00.000000000 +0000
@@ -108,7 +108,8 @@ public enum TarHeaderField {
         this.start = start;
         this.stop = stop;
     }
-    private int start, stop;
+    private final int start;
+    private final int stop;
 
     // The getters below throw RuntimExceptions instead of
     // TarMalformatExceptions because these errors indicate a dev problem,
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/tar/TarReader.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/tar/TarReader.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/tar/TarReader.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/tar/TarReader.java	2022-06-08 08:19:08.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -98,6 +98,7 @@ public class TarReader {
      * @param inDir   Directory that RELATIVE entries will be extracted
      *                relative to.  Defaults to current directory (user.dir).
      *                Only used for extract modes and relative file entries.
+     * @throws IOException on access failure
      * @throws IllegalArgumentException if any given pattern is an invalid
      *                  regular expression.  Don't have to worry about this if
      *                  you call with null 'patterns' param.
@@ -486,6 +487,8 @@ public class TarReader {
         /**
          * @param rawHeader  May be longer than 512 bytes, but the first 512
          *                   bytes MUST COMPRISE a raw tar entry header.
+         *
+         * @throws TarMalformatException if malformed
          */
         public TarEntryHeader(byte[] rawHeader) throws TarMalformatException {
 
@@ -591,6 +594,8 @@ public class TarReader {
 
         /**
          * Setter is needed in order to override header size setting for Pax.
+         *
+         * @param dataSize long
          */
         public void setDataSize(long dataSize) {
             this.dataSize = dataSize;
@@ -612,7 +617,10 @@ public class TarReader {
          * Choosing not to report fields that we don't write (e.g. "gname"),
          * but which would certainly be useful for a general Java tar client
          * implementation.
-         * This design decision is subject to change.
+         *
+         * <P> This design decision is subject to change.
+         *
+         * @return String
          */
         public String toString() {
 
@@ -640,6 +648,9 @@ public class TarReader {
 
         /**
          * Is this any UStar variant
+         *
+         * @throws TarMalformatException
+         * @return boolean
          */
         public boolean isUstar() throws TarMalformatException {
 
@@ -649,7 +660,12 @@ public class TarReader {
         }
 
         /**
+         *
          * @return index based at 0 == from
+         * @param ba byte[]
+         * @param val byte
+         * @param from int
+         * @param to int
          */
         public static int indexOf(byte[] ba, byte val, int from, int to) {
 
@@ -673,7 +689,10 @@ public class TarReader {
         }
 
         /**
-         * @return null or String with length() > 0.
+         *
+         * @return null or String with {@code length() > 0}.
+         * @param field TarHeaderField
+         * @throws TarMalformatException
          */
         protected String readString(TarHeaderField field) throws TarMalformatException {
 
@@ -706,8 +725,12 @@ public class TarReader {
         }
 
         /**
-         * Integer as in positive whole number, which does not imply Java
-         * types of <CODE>int</CODE> or <CODE>Integer</CODE>.
+         * Integer as in positive whole number, which does not imply Java types
+         * of <CODE>int</CODE> or <CODE>Integer</CODE>.
+         *
+         * @param field TarHeaderField
+         * @throws TarMalformatException if malformed
+         * @return Long
          */
         protected Long readInteger(TarHeaderField field)
                 throws TarMalformatException {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/tar/TarReaderMain.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/tar/TarReaderMain.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/tar/TarReaderMain.java	2014-01-24 17:19:38.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/tar/TarReaderMain.java	2022-05-17 11:11:04.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -40,6 +40,10 @@ public class TarReaderMain {
      * Reads a specified tar file or stdin in order to either list or extract
      * the file tar entries, depending on the first argument being "t" or "x",
      * using default read buffer blocks.
+     *
+     * @param sa arguments
+     * @throws IOException on access failure
+     * @throws TarMalformatException if malformed
      */
     public static void main(String[] sa)
     throws IOException, TarMalformatException {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/lib/ValidatingResourceBundle.java 2.7.0-1/hsqldb/src/org/hsqldb/lib/ValidatingResourceBundle.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/lib/ValidatingResourceBundle.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/lib/ValidatingResourceBundle.java	2022-05-17 13:15:00.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -35,7 +35,7 @@ import java.util.Enumeration;
 import java.util.HashSet;
 import java.util.Set;
 
-/* $Id: ValidatingResourceBundle.java 6266 2021-01-25 16:08:06Z fredt $ */
+/* $Id: ValidatingResourceBundle.java 6511 2022-05-17 14:14:54Z fredt $ */
 
 /**
  * Purpose of this class is to wrap a RefCapablePropertyResourceBundle to
@@ -83,7 +83,12 @@ public class ValidatingResourceBundle {
 
     // The following methods are a passthru wrappers for the wrapped RCPRB.
 
-    /** @see RefCapablePropertyResourceBundle#getString(String) */
+    /**
+     *
+     * @see RefCapablePropertyResourceBundle#getString(String)
+     * @param key Enum
+     * @return String
+     */
     public String getString(Enum<?> key) {
         if (!enumType.isInstance(key))
             throw new IllegalArgumentException(
@@ -92,7 +97,13 @@ public class ValidatingResourceBundle {
         return wrappedRCPRB.getString(key.toString());
     }
 
-    /** @see RefCapablePropertyResourceBundle#getString(String, String[], int) */
+    /**
+     *
+     * @see RefCapablePropertyResourceBundle#getString(String, String[], int)
+     * @param key Enum
+     * @param strings String[]
+     * @return String
+     */
     public String getString(Enum<?> key, String... strings) {
         if (!enumType.isInstance(key))
             throw new IllegalArgumentException(
@@ -102,7 +113,12 @@ public class ValidatingResourceBundle {
                 key.toString(), strings, missingPosValueBehavior);
     }
 
-    /** @see RefCapablePropertyResourceBundle#getExpandedString(String, int) */
+    /**
+     *
+     * @see RefCapablePropertyResourceBundle#getExpandedString(String, int)
+     * @param key Enum
+     * @return String
+     */
     public String getExpandedString(Enum<?> key) {
         if (!enumType.isInstance(key))
             throw new IllegalArgumentException(
@@ -111,7 +127,14 @@ public class ValidatingResourceBundle {
         return wrappedRCPRB.getExpandedString(key.toString(), missingPropertyBehavior);
     }
 
-    /** @see RefCapablePropertyResourceBundle#getExpandedString(String, String[], int, int) */
+    /**
+     *
+     * @see RefCapablePropertyResourceBundle#getExpandedString(String,
+     *   String[], int, int)
+     * @param key Enum
+     * @param strings String[]
+     * @return String
+     */
     public String getExpandedString(Enum<?> key, String... strings) {
         if (!enumType.isInstance(key))
             throw new IllegalArgumentException(
@@ -125,28 +148,33 @@ public class ValidatingResourceBundle {
     private int missingPosValueBehavior = THROW_BEHAVIOR;
 
     /**
-     * Set behavior for get*String*() method when a referred-to
-     * System Property is not set.  Set to one of
+     * Set behavior for get*String*() method when a referred-to System Property
+     * is not set. Set to one of
      * <UL>
      *  <LI>RefCapablePropertyResourceBundle.THROW_BEHAVIOR
      *  <LI>RefCapablePropertyResourceBundle.EMPTYSTRING_BEHAVIOR
      *  <LI>RefCapablePropertyResourceBundle.NOOP_BEHAVIOR
      * </UL>
      * The first value is the default.
+     *
+     * @param missingPropertyBehavior int
      */
     public void setMissingPropertyBehavior(int missingPropertyBehavior) {
         this.missingPropertyBehavior = missingPropertyBehavior;
     }
+
     /**
-     * Set behavior for get*String(String, String[]) method when a
-     * positional index (like %{4}) is used but no subs value was given for
-     * that index.  Set to one of
+     * Set behavior for get*String(String, String[]) method when a positional
+     * index (like %{4}) is used but no subs value was given for that index. Set
+     * to one of
      * <UL>
      *  <LI>RefCapablePropertyResourceBundle.THROW_BEHAVIOR
      *  <LI>RefCapablePropertyResourceBundle.EMPTYSTRING_BEHAVIOR
      *  <LI>RefCapablePropertyResourceBundle.NOOP_BEHAVIOR
      * </UL>
      * The first value is the default.
+     *
+     * @param missingPosValueBehavior int
      */
     public void setMissingPosValueBehavior(int missingPosValueBehavior) {
         this.missingPosValueBehavior = missingPosValueBehavior;
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/map/BaseHashMap.java 2.7.0-1/hsqldb/src/org/hsqldb/map/BaseHashMap.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/map/BaseHashMap.java	2021-07-09 17:00:38.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/map/BaseHashMap.java	2022-06-08 08:19:24.000000000 +0000
@@ -851,7 +851,7 @@ public class BaseHashMap {
     }
 
     /**
-     * type specific method for Object sets or Object->Object maps
+     * type specific method for Object sets or Object to Object maps
      */
     protected Object removeObject(Object objectKey, boolean removeRow) {
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/map/HashIndex.java 2.7.0-1/hsqldb/src/org/hsqldb/map/HashIndex.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/map/HashIndex.java	2021-01-31 14:29:58.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/map/HashIndex.java	2022-06-08 08:19:56.000000000 +0000
@@ -153,7 +153,7 @@ public class HashIndex {
     }
 
     /**
-     * This looks from a given node, so the parameter is always > -1.
+     * This looks from a given node, so the parameter is always {@code > -1}.
      *
      * @param lookup A valid node to look from
      * @return either -1 or the next node from this node
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/navigator/RowSetNavigatorDataChange.java 2.7.0-1/hsqldb/src/org/hsqldb/navigator/RowSetNavigatorDataChange.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/navigator/RowSetNavigatorDataChange.java	2020-06-24 09:02:18.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/navigator/RowSetNavigatorDataChange.java	2022-02-21 14:41:56.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2020, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/navigator/RowSetNavigatorDataChangeMemory.java 2.7.0-1/hsqldb/src/org/hsqldb/navigator/RowSetNavigatorDataChangeMemory.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/navigator/RowSetNavigatorDataChangeMemory.java	2021-02-09 04:48:50.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/navigator/RowSetNavigatorDataChangeMemory.java	2022-05-22 17:54:48.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -31,8 +31,6 @@
 
 package org.hsqldb.navigator;
 
-import java.io.IOException;
-
 import org.hsqldb.Row;
 import org.hsqldb.Session;
 import org.hsqldb.error.Error;
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/navigator/RowSetNavigatorDataTable.java 2.7.0-1/hsqldb/src/org/hsqldb/navigator/RowSetNavigatorDataTable.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/navigator/RowSetNavigatorDataTable.java	2021-05-22 08:58:08.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/navigator/RowSetNavigatorDataTable.java	2022-03-26 22:14:26.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -49,7 +49,7 @@ import org.hsqldb.rowio.RowOutputInterfa
  * Implementation of RowSetNavigator using a table as the data store.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.1
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class RowSetNavigatorDataTable extends RowSetNavigatorData {
@@ -162,6 +162,14 @@ public class RowSetNavigatorDataTable ex
     public void add(Object[] data) {
 
         try {
+            if (table.getDataColumnCount() > data.length) {
+                Object[] d = table.getEmptyRowData();
+
+                ArrayUtil.copyArray(data, d, data.length);
+
+                data = d;
+            }
+
             Row row = (Row) store.getNewCachedObject((Session) session, data,
                 false);
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/OpTypes.java 2.7.0-1/hsqldb/src/org/hsqldb/OpTypes.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/OpTypes.java	2021-05-30 14:48:46.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/OpTypes.java	2022-03-17 17:35:22.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -37,7 +37,7 @@ import org.hsqldb.lib.OrderedIntHashSet;
  * Enumerate expression operation types<p>
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.1
+ * @version 2.7.0
  * @since 1.9.0
  */
 public interface OpTypes {
@@ -140,7 +140,9 @@ public interface OpTypes {
         USER_AGGREGATE             = 100,
         ARRAY_ACCESS               = 101,
         ARRAY_SUBQUERY             = 102,
-        GROUPING                   = 103;    // grouping function
+        JSON_FUNCTION              = 103,
+        JSON_SQL_FUNCTION          = 104,
+        GROUPING                   = 105;    // grouping function
     //J-
     int[] aggOpTypes = new int[] {
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/ParserBase.java 2.7.0-1/hsqldb/src/org/hsqldb/ParserBase.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/ParserBase.java	2021-10-19 21:06:54.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/ParserBase.java	2022-06-01 17:39:08.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -49,7 +49,7 @@ import org.hsqldb.types.Types;
 
 /**
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.1
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class ParserBase {
@@ -61,7 +61,6 @@ public class ParserBase {
     protected int           partPosition;
     protected HsqlException lastError;
     protected HsqlName      lastSynonym;
-    protected boolean       isCheckOrTriggerCondition;
     protected boolean       isSchemaDefinition;
     protected boolean       isViewDefinition;
     protected boolean       isRecording;
@@ -106,13 +105,12 @@ public class ParserBase {
         scanner.reset(session, sql);
 
         //
-        partPosition              = 0;
-        lastError                 = null;
-        lastSynonym               = null;
-        isCheckOrTriggerCondition = false;
-        isSchemaDefinition        = false;
-        isViewDefinition          = false;
-        isRecording               = false;
+        partPosition       = 0;
+        lastError          = null;
+        lastSynonym        = null;
+        isSchemaDefinition = false;
+        isViewDefinition   = false;
+        isRecording        = false;
 
         recordedStatement.clear();
     }
@@ -401,19 +399,39 @@ public class ParserBase {
         }
     }
 
+    void checkIsIntegral() {
+
+        if (!isIntegral()) {
+            throw unexpectedTokenRequire("an integer");
+        }
+    }
+
     void checkIsQuotedString() {
 
-        if (token.tokenType != Tokens.X_VALUE
-                || !token.dataType.isCharacterType()) {
-            throw unexpectedToken();
+        if (!isQuotedString()) {
+            throw unexpectedTokenRequire("a quoted string");
         }
     }
 
+    boolean isIntegral() {
+        return token.tokenType == Tokens.X_VALUE
+               && token.dataType.isIntegralType();
+    }
+
+    boolean isQuotedString() {
+        return token.tokenType == Tokens.X_VALUE
+               && token.dataType.isCharacterType();
+    }
+
     void checkIsThis(int type) {
 
         if (token.tokenType != type) {
             String required = Tokens.getKeyword(type);
 
+            if (required == null) {
+                required = "";
+            }
+
             throw unexpectedTokenRequire(required);
         }
     }
@@ -450,11 +468,7 @@ public class ParserBase {
 
     String readQuotedString() {
 
-        checkIsValue();
-
-        if (!token.dataType.isCharacterType()) {
-            throw Error.error(ErrorCode.X_42563);
-        }
+        checkIsQuotedString();
 
         String value = token.tokenString;
 
@@ -505,6 +519,39 @@ public class ParserBase {
         return false;
     }
 
+    void readAny(int id1, int id2, int id3, int id4) {
+        read();
+        checkIsAny(id1, id2, id3, id4);
+    }
+
+    void checkIsAny(int id1, int id2, int id3, int id4) {
+
+        if (token.tokenType == id1 || token.tokenType == id2
+                || token.tokenType == id3 || token.tokenType == id4) {
+            return;
+        }
+
+        String required = "";
+
+        if (id1 != 0) {
+            required += Tokens.getKeyword(id1);
+
+            if (id2 != 0) {
+                required += " or " + Tokens.getKeyword(id2);
+            }
+
+            if (id3 != 0) {
+                required += " or " + Tokens.getKeyword(id3);
+            }
+
+            if (id4 != 0) {
+                required += " or " + Tokens.getKeyword(id4);
+            }
+        }
+
+        throw unexpectedTokenRequire(required);
+    }
+
     Integer readIntegerObject() {
 
         int value = readInteger();
@@ -522,7 +569,7 @@ public class ParserBase {
             read();
         }
 
-        checkIsValue();
+        checkIsIntegral();
 
         if (minus && token.dataType.typeCode == Types.SQL_BIGINT
                 && ((Number) token.tokenValue).longValue()
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/ParserCommand.java 2.7.0-1/hsqldb/src/org/hsqldb/ParserCommand.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/ParserCommand.java	2021-07-15 13:57:30.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/ParserCommand.java	2022-07-13 15:38:30.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -54,7 +54,7 @@ import org.hsqldb.types.Types;
  * Parser for session and management statements
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.1
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class ParserCommand extends ParserDDL {
@@ -107,7 +107,7 @@ public class ParserCommand extends Parse
             }
 
             cs.setCompileTimestamp(
-                database.txManager.getGlobalChangeTimestamp());
+                database.txManager.getSystemChangeNumber());
             list.add(cs);
         }
 
@@ -297,17 +297,7 @@ public class ParserCommand extends Parse
                 break;
 
             case Tokens.EXPLAIN : {
-                int position = getPosition();
-
-                read();
-
-                if (token.tokenType == Tokens.PLAN) {
-                    cs = compileExplainPlan();
-                } else {
-                    cs = compileExplainReferences();
-                }
-
-                cs.setSQL(getLastPart(position));
+                cs = compileExplain();
 
                 break;
             }
@@ -388,6 +378,7 @@ public class ParserCommand extends Parse
 
         if (extended) {
             readThis(Tokens.FOR);
+            checkIsAny(Tokens.DATABASE, Tokens.TABLE, 0, 0);
 
             if (readIfThis(Tokens.DATABASE)) {
                 switch (token.tokenType) {
@@ -823,13 +814,7 @@ public class ParserCommand extends Parse
                                             args);
             }
             case Tokens.AUTOCOMMIT : {
-                read();
-
-                Boolean  mode = processTrueOrFalseObject();
-                Object[] args = new Object[]{ mode };
-
-                return new StatementSession(
-                    StatementTypes.SET_SESSION_AUTOCOMMIT, args);
+                return compileSetAutoCommit();
             }
 
             // deprecated
@@ -990,6 +975,44 @@ public class ParserCommand extends Parse
         }
     }
 
+    StatementSession compileSetAutoCommit() {
+
+        read();
+
+        boolean mode = false;
+        int     rows = -1;
+
+        switch (token.tokenType) {
+
+            case Tokens.TRUE :
+            case Tokens.FALSE :
+                mode = processTrueOrFalse();
+                break;
+
+            case Tokens.AT :
+                read();
+
+                rows = readInteger();
+
+                if (rows < 0) {
+                    throw Error.error(ErrorCode.X_22003);
+                }
+
+                readThis(Tokens.ROWS);
+                break;
+
+            default :
+                throw unexpectedToken();
+        }
+
+        Object[] args = new Object[] {
+            mode, rows
+        };
+
+        return new StatementSession(StatementTypes.SET_SESSION_AUTOCOMMIT,
+                                    args);
+    }
+
     StatementCommand compileSetTable() {
 
         read();
@@ -1214,7 +1237,23 @@ public class ParserCommand extends Parse
 
                 Integer  value = readIntegerObject();
                 Object[] args  = new Object[] {
-                    value, Boolean.valueOf(sqlLog)
+                    value, Boolean.valueOf(sqlLog), Boolean.TRUE
+                };
+
+                return new StatementCommand(
+                    StatementTypes.SET_DATABASE_FILES_EVENT_LOG, args, null,
+                    null);
+            }
+            case Tokens.EXTERNAL : {
+                read();
+                readThis(Tokens.EVENT);
+                readThis(Tokens.LOG);
+
+                readThis(Tokens.LEVEL);
+
+                Integer  value = readIntegerObject();
+                Object[] args  = new Object[] {
+                    value, Boolean.FALSE, Boolean.FALSE
                 };
 
                 return new StatementCommand(
@@ -1282,96 +1321,92 @@ public class ParserCommand extends Parse
 
                 switch (token.tokenType) {
 
-                    case Tokens.RESTRICT :
+                    case Tokens.AVG :
                         read();
-                        readThis(Tokens.EXEC);
+                        readThis(Tokens.SCALE);
 
-                        property = HsqlDatabaseProperties.sql_restrict_exec;
-                        flag     = processTrueOrFalseObject();
+                        value    = readIntegerObject();
+                        property = HsqlDatabaseProperties.sql_avg_scale;
                         break;
 
-                    case Tokens.LIVE :
+                    case Tokens.CHARACTER :
                         read();
-                        readThis(Tokens.OBJECT);
+                        readThis(Tokens.LITERAL);
 
-                        property = HsqlDatabaseProperties.sql_live_object;
                         flag     = processTrueOrFalseObject();
+                        property = HsqlDatabaseProperties.sql_char_literal;
                         break;
 
-                    case Tokens.NAMES :
+                    case Tokens.CONCAT_WORD :
                         read();
+                        readThis(Tokens.NULLS);
 
-                        property = HsqlDatabaseProperties.sql_enforce_names;
                         flag     = processTrueOrFalseObject();
+                        property = HsqlDatabaseProperties.sql_concat_nulls;
                         break;
 
-                    case Tokens.REGULAR :
+                    case Tokens.CONVERT :
                         read();
-                        readThis(Tokens.NAMES);
+                        readThis(Tokens.TRUNCATE);
 
-                        property = HsqlDatabaseProperties.sql_regular_names;
                         flag     = processTrueOrFalseObject();
+                        property = HsqlDatabaseProperties.sql_convert_trunc;
                         break;
 
-                    case Tokens.REFERENCES :
+                    case Tokens.DOUBLE :
                         read();
+                        readThis(Tokens.NAN);
 
                         flag     = processTrueOrFalseObject();
-                        property = HsqlDatabaseProperties.sql_enforce_refs;
+                        property = HsqlDatabaseProperties.sql_double_nan;
                         break;
 
-                    case Tokens.SIZE :
+                    case Tokens.IGNORECASE :
                         read();
 
                         flag     = processTrueOrFalseObject();
-                        property = HsqlDatabaseProperties.sql_enforce_size;
+                        property = HsqlDatabaseProperties.sql_ignore_case;
                         break;
 
-                    case Tokens.TYPES :
+                    case Tokens.LIVE :
                         read();
+                        readThis(Tokens.OBJECT);
 
+                        property = HsqlDatabaseProperties.sql_live_object;
                         flag     = processTrueOrFalseObject();
-                        property = HsqlDatabaseProperties.sql_enforce_types;
                         break;
 
-                    case Tokens.TDC :
+                    case Tokens.LONGVAR :
                         read();
+                        readThis(Tokens.IS);
+                        readThis(Tokens.LOB);
 
-                        if (readIfThis(Tokens.DELETE)) {
-                            property = HsqlDatabaseProperties.sql_enforce_tdcd;
-                        } else {
-                            readThis(Tokens.UPDATE);
-
-                            property = HsqlDatabaseProperties.sql_enforce_tdcu;
-                        }
-
-                        flag = processTrueOrFalseObject();
+                        flag     = processTrueOrFalseObject();
+                        property = HsqlDatabaseProperties.sql_longvar_is_lob;
                         break;
 
-                    case Tokens.TRANSLATE :
+                    case Tokens.LOWER :
                         read();
-                        readThis(Tokens.TTI);
-                        readThis(Tokens.TYPES);
+                        readThis(Tokens.CASE);
+                        readThis(Tokens.IDENTIFIER);
 
-                        flag = processTrueOrFalseObject();
-                        property =
-                            HsqlDatabaseProperties.jdbc_translate_tti_types;
+                        flag     = processTrueOrFalseObject();
+                        property = HsqlDatabaseProperties.sql_lowercase_ident;
                         break;
 
-                    case Tokens.CHARACTER :
+                    case Tokens.MAX :
                         read();
-                        readThis(Tokens.LITERAL);
+                        readThis(Tokens.RECURSIVE);
 
-                        flag     = processTrueOrFalseObject();
-                        property = HsqlDatabaseProperties.sql_char_literal;
+                        value    = readIntegerObject();
+                        property = HsqlDatabaseProperties.sql_max_recursive;
                         break;
 
-                    case Tokens.CONCAT_WORD :
+                    case Tokens.NAMES :
                         read();
-                        readThis(Tokens.NULLS);
 
+                        property = HsqlDatabaseProperties.sql_enforce_names;
                         flag     = processTrueOrFalseObject();
-                        property = HsqlDatabaseProperties.sql_concat_nulls;
                         break;
 
                     case Tokens.NULLS :
@@ -1388,61 +1423,34 @@ public class ParserCommand extends Parse
                         flag = processTrueOrFalseObject();
                         break;
 
-                    case Tokens.UNIQUE :
-                        read();
-                        readThis(Tokens.NULLS);
-
-                        flag     = processTrueOrFalseObject();
-                        property = HsqlDatabaseProperties.sql_unique_nulls;
-                        break;
-
-                    case Tokens.CONVERT :
-                        read();
-                        readThis(Tokens.TRUNCATE);
-
-                        flag     = processTrueOrFalseObject();
-                        property = HsqlDatabaseProperties.sql_convert_trunc;
-                        break;
-
-                    case Tokens.AVG :
-                        read();
-                        readThis(Tokens.SCALE);
-
-                        value    = readIntegerObject();
-                        property = HsqlDatabaseProperties.sql_avg_scale;
-                        break;
-
-                    case Tokens.DOUBLE :
+                    case Tokens.REGULAR :
                         read();
-                        readThis(Tokens.NAN);
+                        readThis(Tokens.NAMES);
 
+                        property = HsqlDatabaseProperties.sql_regular_names;
                         flag     = processTrueOrFalseObject();
-                        property = HsqlDatabaseProperties.sql_double_nan;
                         break;
 
-                    case Tokens.LONGVAR :
+                    case Tokens.REFERENCES :
                         read();
-                        readThis(Tokens.IS);
-                        readThis(Tokens.LOB);
 
                         flag     = processTrueOrFalseObject();
-                        property = HsqlDatabaseProperties.sql_longvar_is_lob;
+                        property = HsqlDatabaseProperties.sql_enforce_refs;
                         break;
 
-                    case Tokens.LOWER :
+                    case Tokens.RESTRICT :
                         read();
-                        readThis(Tokens.CASE);
-                        readThis(Tokens.IDENTIFIER);
+                        readThis(Tokens.EXEC);
 
+                        property = HsqlDatabaseProperties.sql_restrict_exec;
                         flag     = processTrueOrFalseObject();
-                        property = HsqlDatabaseProperties.sql_lowercase_ident;
                         break;
 
-                    case Tokens.IGNORECASE :
+                    case Tokens.SIZE :
                         read();
 
                         flag     = processTrueOrFalseObject();
-                        property = HsqlDatabaseProperties.sql_ignore_case;
+                        property = HsqlDatabaseProperties.sql_enforce_size;
                         break;
 
                     case Tokens.SYNTAX :
@@ -1475,16 +1483,62 @@ public class ParserCommand extends Parse
                         flag = processTrueOrFalseObject();
                         break;
 
-                    case Tokens.SYS : {
+                    case Tokens.SYS :
                         read();
                         readThis(Tokens.INDEX);
                         readThis(Tokens.NAMES);
 
                         flag     = processTrueOrFalseObject();
                         property = HsqlDatabaseProperties.sql_sys_index_names;
+                        break;
+
+                    case Tokens.TDC :
+                        read();
+
+                        if (readIfThis(Tokens.DELETE)) {
+                            property = HsqlDatabaseProperties.sql_enforce_tdcd;
+                        } else {
+                            readThis(Tokens.UPDATE);
 
+                            property = HsqlDatabaseProperties.sql_enforce_tdcu;
+                        }
+
+                        flag = processTrueOrFalseObject();
                         break;
-                    }
+
+                    case Tokens.TRANSLATE :
+                        read();
+                        readThis(Tokens.TTI);
+                        readThis(Tokens.TYPES);
+
+                        flag = processTrueOrFalseObject();
+                        property =
+                            HsqlDatabaseProperties.jdbc_translate_tti_types;
+                        break;
+
+                    case Tokens.TRUNCATE :
+                        read();
+                        readThis(Tokens.TRAILING);
+
+                        flag     = processTrueOrFalseObject();
+                        property = HsqlDatabaseProperties.sql_trunc_trailing;
+                        break;
+
+                    case Tokens.TYPES :
+                        read();
+
+                        flag     = processTrueOrFalseObject();
+                        property = HsqlDatabaseProperties.sql_enforce_types;
+                        break;
+
+                    case Tokens.UNIQUE :
+                        read();
+                        readThis(Tokens.NULLS);
+
+                        flag     = processTrueOrFalseObject();
+                        property = HsqlDatabaseProperties.sql_unique_nulls;
+                        break;
+
                     default :
                         throw unexpectedToken();
                 }
@@ -1606,7 +1660,7 @@ public class ParserCommand extends Parse
 
         int        type  = 0;
         Boolean    flag  = null;
-        Integer    value = null;
+        Object     value = null;
         Boolean    mode  = null;
         HsqlName[] names = database.schemaManager.getCatalogNameArray();
 
@@ -1751,7 +1805,7 @@ public class ParserCommand extends Parse
                 readThis(Tokens.PATH);
 
                 type  = StatementTypes.SET_DATABASE_FILES_TEMP_PATH;
-                value = readIntegerObject();
+                value = readQuotedString();
 
                 break;
             }
@@ -1826,6 +1880,8 @@ public class ParserCommand extends Parse
         boolean  readonly = false;
         Object[] args     = new Object[2];
 
+        checkIsAny(Tokens.READ, Tokens.ISOLATION, 0, 0);
+
         outerloop:
         while (true) {
             switch (token.tokenType) {
@@ -1858,6 +1914,8 @@ public class ParserCommand extends Parse
 
                     read();
                     readThis(Tokens.LEVEL);
+                    checkIsAny(Tokens.SERIALIZABLE, Tokens.READ,
+                               Tokens.REPEATABLE, 0);
 
                     switch (token.tokenType) {
 
@@ -1868,7 +1926,8 @@ public class ParserCommand extends Parse
                             break;
 
                         case Tokens.READ :
-                            read();
+                            readAny(Tokens.COMMITTED, Tokens.UNCOMMITTED, 0,
+                                    0);
 
                             if (token.tokenType == Tokens.COMMITTED) {
                                 read();
@@ -2123,6 +2182,9 @@ public class ParserCommand extends Parse
 
     private Statement compileSessionSettings() {
 
+        checkIsAny(Tokens.CHARACTERISTICS, Tokens.AUTHORIZATION,
+                   Tokens.RESULT, Tokens.FEATURE);
+
         switch (token.tokenType) {
 
             case Tokens.CHARACTERISTICS : {
@@ -2227,26 +2289,37 @@ public class ParserCommand extends Parse
 
         readThis(Tokens.ZONE);
 
-        if (token.tokenType == Tokens.LOCAL) {
-            read();
-
-            e = new ExpressionValue(null, Type.SQL_INTERVAL_HOUR_TO_MINUTE);
-        } else {
-            e = XreadIntervalValueExpression();
+        switch (token.tokenType) {
 
-            List unresolved = e.resolveColumnReferences(session,
-                RangeGroup.emptyGroup, RangeGroup.emptyArray, null);
+            case Tokens.LOCAL : {
+                read();
 
-            ExpressionColumn.checkColumnsResolved(unresolved);
-            e.resolveTypes(session, null);
+                e = new ExpressionValue(null,
+                                        Type.SQL_INTERVAL_HOUR_TO_MINUTE);
 
-            if (e.dataType == null) {
-                throw Error.error(ErrorCode.X_42563);
+                break;
             }
+            case Tokens.INTERVAL : {
+                e = XreadIntervalValueExpression();
+
+                List unresolved = e.resolveColumnReferences(session,
+                    RangeGroup.emptyGroup, RangeGroup.emptyArray, null);
+
+                ExpressionColumn.checkColumnsResolved(unresolved);
+                e.resolveTypes(session, null);
+
+                if (e.dataType == null) {
+                    throw Error.error(ErrorCode.X_42563);
+                }
+
+                if (e.dataType.typeCode != Types.SQL_INTERVAL_HOUR_TO_MINUTE) {
+                    throw Error.error(ErrorCode.X_42563);
+                }
 
-            if (e.dataType.typeCode != Types.SQL_INTERVAL_HOUR_TO_MINUTE) {
-                throw Error.error(ErrorCode.X_42563);
+                break;
             }
+            default :
+                e = XreadValueExpression();
         }
 
         return new StatementSession(session, compileContext,
@@ -2432,80 +2505,106 @@ public class ParserCommand extends Parse
 
     private Statement compilePerform() {
 
-        read();
+        readAny(Tokens.CHECK, Tokens.EXPORT, Tokens.IMPORT, 0);
 
         switch (token.tokenType) {
 
-            /*
-             * PERFORM CHECK TABLE <name> INDEX [AND FIX]
-             * PERFORM CHECK ALL TABLE INDEX [AND FIX]
-             */
-            case Tokens.CHECK : {
-                read();
+            case Tokens.CHECK :
+                return compileCheck();
 
-                boolean  isAll     = false;
-                HsqlName tableName = null;
-                Integer  type      = Integer.valueOf(IndexStats.checkRows);
-                Integer  number    = Integer.valueOf(-1);
+            case Tokens.IMPORT :
+                readAny(Tokens.SCRIPT, Tokens.DATA, 0, 0);
 
-                switch (token.tokenType) {
+                if (token.tokenType == Tokens.SCRIPT) {
+                    return compileImportScript();
+                } else {
+                    return compileImportData();
+                }
+            case Tokens.EXPORT :
+                readAny(Tokens.SCRIPT, Tokens.DATA, 0, 0);
 
-                    case Tokens.ALL : {
-                        read();
+                if (token.tokenType == Tokens.SCRIPT) {
+                    return compileScript(true);
+                } else {
+                    return compileExportData();
+                }
+            default :
+                throw unexpectedToken();
+        }
+    }
 
-                        isAll = true;
-                    }
+    /*
+     * PERFORM CHECK TABLE <name> INDEX [AND FIX]
+     * PERFORM CHECK ALL TABLE INDEX [AND FIX]
+     */
+    private Statement compileCheck() {
 
-                    // fall through
-                    case Tokens.TABLE : {
-                        readThis(Tokens.TABLE);
+        readAny(Tokens.ALL, Tokens.TABLE, 0, 0);
 
-                        if (isAll) {
-                            readThis(Tokens.INDEX);
-                        } else {
-                            tableName = readTableName().getName();
+        boolean  isAll     = false;
+        HsqlName tableName = null;
+        Integer  type      = Integer.valueOf(IndexStats.checkRows);
+        Integer  number    = Integer.valueOf(-1);
 
-                            readThis(Tokens.INDEX);
-                        }
-                    }
-                }
+        switch (token.tokenType) {
 
-                if (readIfThis(Tokens.AND)) {
-                    readThis("FIX");
+            case Tokens.ALL : {
+                read();
 
-                    type = Integer.valueOf(IndexStats.fixAll);
-                }
+                isAll = true;
+            }
 
-                Object[] args = new Object[] {
-                    tableName, type, number
-                };
-                HsqlName[] names =
-                    isAll
-                    ? database.schemaManager.getCatalogAndBaseTableNames()
-                    : database.schemaManager.getCatalogAndBaseTableNames(
-                        tableName);
+            // fall through
+            case Tokens.TABLE : {
+                readThis(Tokens.TABLE);
 
-                return new StatementCommand(StatementTypes.CHECK_INDEX, args,
-                                            null, names);
-            }
-            case Tokens.IMPORT : {
-                read();
+                if (isAll) {
+                    readThis(Tokens.INDEX);
+                } else {
+                    tableName = readTableName().getName();
 
-                return compileImportScript();
-            }
-            case Tokens.EXPORT : {
-                return compileExport();
+                    readThis(Tokens.INDEX);
+                }
             }
-            default :
-                throw unexpectedToken();
         }
+
+        if (readIfThis(Tokens.AND)) {
+            readThis("FIX");
+
+            type = Integer.valueOf(IndexStats.fixAll);
+        }
+
+        Object[] args = new Object[] {
+            tableName, type, number
+        };
+        HsqlName[] names =
+            isAll ? database.schemaManager.getCatalogAndBaseTableNames()
+                  : database.schemaManager.getCatalogAndBaseTableNames(
+                      tableName);
+
+        return new StatementCommand(StatementTypes.CHECK_INDEX, args, null,
+                                    names);
     }
 
-    private Statement compileExport() {
+    private Statement compileExportData() {
 
-        read();
+        readThis(Tokens.DATA);
+        readThis(Tokens.FROM);
+        readThis(Tokens.TABLE);
+
+        HsqlName tableName = readTableName().getName();
+
+        readThis(Tokens.TO);
+
+        String fileName = readQuotedString();
+        HsqlName[] names =
+            database.schemaManager.getCatalogAndBaseTableNames();
+        Object[] args = new Object[] {
+            tableName, fileName
+        };
 
-        return compileScript(true);
+        return new StatementCommand(StatementTypes.UNLOAD_DATA, args, null,
+                                    names);
     }
 
     private Statement compileImportScript() {
@@ -2515,6 +2614,7 @@ public class ParserCommand extends Parse
         Boolean isVersioning = Boolean.FALSE;
 
         readThis(Tokens.SCRIPT);
+        checkIsAny(Tokens.VERSIONING, Tokens.DATA, 0, 0);
 
         if (token.tokenType == Tokens.VERSIONING) {
             readThis(Tokens.VERSIONING);
@@ -2541,10 +2641,34 @@ public class ParserCommand extends Parse
                                     names);
     }
 
+    private Statement compileImportData() {
+
+        readThis(Tokens.DATA);
+        readThis(Tokens.INTO);
+        readThis(Tokens.TABLE);
+
+        HsqlName tableName = readTableName().getName();
+
+        readThis(Tokens.FROM);
+
+        String fileName = readQuotedString();
+        int    mode     = readLoadMode();
+        HsqlName[] names =
+            database.schemaManager.getCatalogAndBaseTableNames();
+        Object[] args = new Object[] {
+            tableName, fileName, Integer.valueOf(mode)
+        };
+
+        return new StatementCommand(StatementTypes.LOAD_DATA, args, null,
+                                    names);
+    }
+
     private int readLoadMode() {
 
         int mode = -1;
 
+        checkIsAny(Tokens.CONTINUE, Tokens.STOP, Tokens.CHECK, 0);
+
         switch (token.tokenType) {
 
             case Tokens.CONTINUE :
@@ -2612,7 +2736,7 @@ public class ParserCommand extends Parse
         Statement cs = new StatementCommand(StatementTypes.DATABASE_CHECKPOINT,
                                             args, null, names);
 
-        cs.setCompileTimestamp(database.txManager.getGlobalChangeTimestamp());
+        cs.setCompileTimestamp(database.txManager.getSystemChangeNumber());
         cs.setSQL(Tokens.T_CHECKPOINT);
 
         return cs;
@@ -2628,6 +2752,24 @@ public class ParserCommand extends Parse
         return cs;
     }
 
+    private Statement compileExplain() {
+
+        Statement cs;
+        int       position = getPosition();
+
+        readAny(Tokens.PLAN, Tokens.REFERENCES, 0, 0);
+
+        if (token.tokenType == Tokens.PLAN) {
+            cs = compileExplainPlan();
+        } else {
+            cs = compileExplainReferences();
+        }
+
+        cs.setSQL(getLastPart(position));
+
+        return cs;
+    }
+
     private Statement compileExplainPlan() {
 
         Statement cs;
@@ -2648,7 +2790,7 @@ public class ParserCommand extends Parse
         SchemaObject object;
         boolean      referencesFrom = false;
 
-        readThis(Tokens.REFERENCES);
+        readAny(Tokens.TO, Tokens.FROM, 0, 0);
 
         if (!readIfThis(Tokens.TO)) {
             readThis(Tokens.FROM);
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/ParserDDL.java 2.7.0-1/hsqldb/src/org/hsqldb/ParserDDL.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/ParserDDL.java	2021-03-04 20:57:56.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/ParserDDL.java	2022-04-13 18:18:52.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -43,6 +43,7 @@ import org.hsqldb.lib.List;
 import org.hsqldb.lib.OrderedHashSet;
 import org.hsqldb.lib.OrderedIntHashSet;
 import org.hsqldb.map.ValuePool;
+import org.hsqldb.rights.GrantConstants;
 import org.hsqldb.rights.Grantee;
 import org.hsqldb.rights.GranteeManager;
 import org.hsqldb.rights.Right;
@@ -56,7 +57,7 @@ import org.hsqldb.types.UserTypeModifier
  * Parser for DDL statements
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class ParserDDL extends ParserRoutine {
@@ -1063,7 +1064,7 @@ public class ParserDDL extends ParserRou
         boolean  ifNot = readIfNotExists();
         HsqlName name  = readNewSchemaObjectName(SchemaObject.TABLE, false);
 
-        name.schema = SqlInvariants.SYSTEM_SCHEMA_HSQLNAME;
+        name.schema = SqlInvariants.SESSION_SCHEMA_HSQLNAME;
 
         Table           table = new Table(database, name, tableType);
         StatementSchema cs;
@@ -2337,12 +2338,20 @@ public class ParserDDL extends ParserRou
             ColumnSchema column, int columnIndex) {
 
         //ALTER TABLE .. ALTER COLUMN .. SET DEFAULT
-        Type       type = column.getDataType();
-        Expression expr = readDefaultClause(type);
-        String     sql  = getLastPart();
-        Object[]   args = new Object[] {
-            StatementTypes.ALTER_COLUMN_DEFAULT, table, column,
-            Integer.valueOf(columnIndex), expr
+        Type       type          = column.getDataType();
+        Expression expr          = readDefaultClause(type);
+        String     sql           = getLastPart();
+        int        statementType = StatementTypes.ALTER_COLUMN_DEFAULT;
+        Object     argObject     = expr;
+
+        if (expr.opType == OpTypes.SEQUENCE) {
+            statementType = StatementTypes.ALTER_COLUMN_SEQUENCE;
+            argObject     = ((ExpressionColumn) expr).sequence;
+        }
+
+        Object[] args = new Object[] {
+            statementType, table, column, Integer.valueOf(columnIndex),
+            argObject
         };
         HsqlName[] writeLockNames =
             database.schemaManager.getCatalogAndBaseTableNames(
@@ -2983,10 +2992,6 @@ public class ParserDDL extends ParserRou
 
                     // fall through
                     case Tokens.DELETE :
-                        if (right == null) {
-                            right = new Right();
-                        }
-
                         right.set(rightType, columnSet);
 
                         isTable = true;
@@ -3007,10 +3012,6 @@ public class ParserDDL extends ParserRou
                         break;
 
                     case Tokens.TRIGGER :
-                        if (right == null) {
-                            right = new Right();
-                        }
-
                         right.set(rightType, null);
 
                         isTable = true;
@@ -3162,6 +3163,39 @@ public class ParserDDL extends ParserRou
                 objectType = SchemaObject.CHARSET;
                 break;
 
+            case Tokens.ALL :
+                read();
+
+                if (readIfThis("SEQUENCES")) {
+                    if (!isUsage && !isAll) {
+                        throw unexpectedToken("SEQUENCES");
+                    }
+
+                    right = new Right();
+
+                    right.set(GrantConstants.USAGE, null);
+                } else if (readIfThis("ROUTINES")) {
+                    if (!isExec && !isAll) {
+                        throw unexpectedToken("ROUTINES");
+                    }
+
+                    right = new Right();
+
+                    right.set(GrantConstants.EXECUTE, null);
+                } else {
+                    if (!isTable && !isAll) {
+                        throw unexpectedToken();
+                    }
+
+                    readThis("TABLES");
+                }
+
+                readThis(Tokens.IN);
+                readThis(Tokens.SCHEMA);
+
+                objectType = SchemaObject.SCHEMA;
+                break;
+
             case Tokens.TABLE :
             default :
                 if (!isTable && !isAll) {
@@ -3543,7 +3577,7 @@ public class ParserDDL extends ParserRou
      * Retrieves boolean value corresponding to the next token.
      *
      * @return   true if next token is "TRUE"; false if next token is "FALSE"
-     * @throws  HsqlException if the next token is neither "TRUE" or "FALSE"
+     * @throws  HsqlException if the next token is neither "TRUE" nor "FALSE"
      */
     boolean processTrueOrFalse() {
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/ParserDQL.java 2.7.0-1/hsqldb/src/org/hsqldb/ParserDQL.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/ParserDQL.java	2021-07-15 13:57:30.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/ParserDQL.java	2022-06-08 07:23:52.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -66,7 +66,7 @@ import org.hsqldb.types.UserTypeModifier
  * Parser for DQL statements
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.1
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class ParserDQL extends ParserBase {
@@ -1912,14 +1912,22 @@ public class ParserDQL extends ParserBas
         } else if (token.tokenType == Tokens.FETCH) {
             read();
 
+            boolean first = false;
+
             if (token.tokenType == Tokens.FIRST
                     || token.tokenType == Tokens.NEXT) {
+                first = true;
+
                 read();
             }
 
             e2 = XreadSimpleValueSpecificationOrNull();
 
             if (e2 == null) {
+                if (!first) {
+                    throw super.unexpectedTokenRequire(Tokens.T_FIRST);
+                }
+
                 e2 = new ExpressionValue(ValuePool.INTEGER_1,
                                          Type.SQL_INTEGER);
             }
@@ -2160,7 +2168,7 @@ public class ParserDQL extends ParserBas
     }
 
     /**
-     * Creates a RangeVariable from the parse context. <p>
+     * Creates a RangeVariable from the parse context.
      */
     protected RangeVariable readTableOrSubquery() {
 
@@ -2622,7 +2630,7 @@ public class ParserDQL extends ParserBas
             case Tokens.COLON :
                 read();
 
-                if (token.tokenType == Tokens.X_VALUE) {
+                if (isIntegral()) {
                     int pos = readInteger();
                     ExpressionColumn p =
                         new ExpressionColumn(OpTypes.DYNAMIC_PARAM, pos);
@@ -2630,29 +2638,23 @@ public class ParserDQL extends ParserBas
                     compileContext.addParameter(p, getPosition());
 
                     return p;
-                } else if (token.tokenType == Tokens.X_DELIMITED_IDENTIFIER
-                           || token.tokenType == Tokens.X_IDENTIFIER) {
-                    if (token.namePrefix == null) {
-                        int pos = compileContext.parameters.size();
-                        ExpressionColumn p =
-                            new ExpressionColumn(OpTypes.DYNAMIC_PARAM, pos);
-
-                        compileContext.addParameter(p, getPosition());
-
-                        Token newToken = new Token();
-
-                        newToken.tokenType = Tokens.X_VALUE;
-                        newToken.dataType  = Type.SQL_INTEGER;
-                        newToken.tokenString =
-                            String.valueOf(p.parameterIndex);
+                } else if (isUndelimitedSimpleName()) {
+                    int pos = compileContext.parameters.size();
+                    ExpressionColumn p =
+                        new ExpressionColumn(OpTypes.DYNAMIC_PARAM, pos);
 
-                        replaceToken(newToken, null);
-                        read();
+                    compileContext.addParameter(p, getPosition());
 
-                        return p;
-                    } else {
-                        throw unexpectedToken(Tokens.T_COLON);
-                    }
+                    Token newToken = new Token();
+
+                    newToken.tokenType   = Tokens.X_VALUE;
+                    newToken.dataType    = Type.SQL_INTEGER;
+                    newToken.tokenString = String.valueOf(p.parameterIndex);
+
+                    replaceToken(newToken, null);
+                    read();
+
+                    return p;
                 } else {
                     throw unexpectedToken(Tokens.T_COLON);
                 }
@@ -3236,6 +3238,26 @@ public class ParserDQL extends ParserBas
 
                 return new ExpressionColumn(groupingElements);
             }
+            case Tokens.JSON_ARRAY : {
+                read();
+
+                return readJSONArray();
+            }
+            case Tokens.JSON_ARRAYAGG : {
+                read();
+
+                return readJSONArrayAgg();
+            }
+            case Tokens.JSON_OBJECT : {
+                read();
+
+                return readJSONObject();
+            }
+            case Tokens.JSON_OBJECTAGG : {
+                read();
+
+                return readJSONObjectAgg();
+            }
             default :
                 if (isCoreReservedKey()) {
                     throw unexpectedToken();
@@ -3251,6 +3273,313 @@ public class ParserDQL extends ParserBas
         return e;
     }
 
+    Expression readJSONArray() {
+
+        HsqlArrayList list       = new HsqlArrayList();
+        Expression    qe         = null;
+        boolean       nullOnNull = true;
+        Type          dataType   = Type.SQL_VARCHAR_LONG;
+
+        readThis(Tokens.OPENBRACKET);
+
+        int position = getPosition();
+
+        loop:
+        while (true) {
+            Expression value;
+
+            switch (token.tokenType) {
+
+                case Tokens.ABSENT :
+                case Tokens.NULL :
+                case Tokens.CLOSEBRACKET :
+                    break loop;
+
+                case Tokens.COMMA :
+                    if (list.size() == 0) {
+                        throw unexpectedToken();
+                    }
+
+                    read();
+            }
+
+            try {
+                value = XreadValueExpression();
+
+                list.add(value);
+            } catch (HsqlException e) {
+                if (list.size() > 0) {
+                    throw e;
+                }
+
+                rewind(position);
+
+                break loop;
+            }
+        }
+
+        if (list.size() == 0) {
+            if (token.tokenType != Tokens.CLOSEBRACKET) {
+                TableDerived td =
+                    XreadSubqueryTableBody(OpTypes.TABLE_SUBQUERY);
+
+                qe = new Expression(OpTypes.ARRAY_SUBQUERY, td);
+            }
+        }
+
+        nullOnNull = readJSONNullClause(nullOnNull);
+
+        if (readIfThis(Tokens.RETURNING)) {
+            dataType = readJSONReturningClause();
+        }
+
+        readThis(Tokens.CLOSEBRACKET);
+
+        if (qe == null) {
+            return new ExpressionJSON.ExpressionJSONArrayFromValues(list,
+                    nullOnNull, dataType);
+        } else {
+            return new ExpressionJSON.ExpressionJSONArrayFromQuery(qe,
+                    nullOnNull, dataType);
+        }
+    }
+
+    Expression readJSONArrayAgg() {
+
+        boolean                  nullOnNull = false;
+        Type                     dataType   = Type.SQL_VARCHAR_LONG;
+        Expression               valueExpr;
+        ExpressionArrayAggregate arrayAgg;
+        SortAndSlice             sort = null;
+
+        readThis(Tokens.OPENBRACKET);
+
+        valueExpr = XreadValueExpression();
+
+        if (token.tokenType == Tokens.ORDER) {
+            read();
+            readThis(Tokens.BY);
+
+            sort = XreadOrderBy();
+        }
+
+        arrayAgg = new ExpressionArrayAggregate(OpTypes.ARRAY_AGG, false,
+                valueExpr, sort, null);
+        nullOnNull = readJSONNullClause(nullOnNull);
+
+        if (readIfThis(Tokens.RETURNING)) {
+            dataType = readJSONReturningClause();
+        }
+
+        readThis(Tokens.CLOSEBRACKET);
+
+        return new ExpressionJSON.ExpressionJSONArrayAgg(arrayAgg, nullOnNull,
+                dataType);
+    }
+
+    Expression readJSONObject() {
+
+        OrderedHashMap map          = new OrderedHashMap();
+        boolean        nullOnNull   = true;
+        boolean        uniqueKeys   = false;
+        Type           dataType     = Type.SQL_VARCHAR_LONG;
+        boolean        hasDuplicate = false;
+
+        readThis(Tokens.OPENBRACKET);
+
+        loop:
+        while (true) {
+            Expression nameExpr;
+            Expression valueExpr;
+            boolean    isKey = false;
+
+            switch (token.tokenType) {
+
+                case Tokens.ABSENT :
+                case Tokens.NULL :
+                case Tokens.WITH :
+                case Tokens.WITHOUT :
+                case Tokens.CLOSEBRACKET :
+                    break loop;
+
+                case Tokens.COMMA :
+                    if (map.size() == 0) {
+                        throw unexpectedToken();
+                    }
+
+                    read();
+            }
+
+            if (readIfThis(Tokens.KEY)) {
+                isKey = true;
+            }
+
+            int position = getPosition();
+
+            nameExpr = XreadCharacterValueExpression();
+
+            if (nameExpr.opType == OpTypes.JSON_FUNCTION) {
+                rewind(position);
+
+                throw unexpectedToken();
+            }
+
+            if (!readIfThis(Tokens.VALUE)) {
+                if (isKey) {
+                    throw unexpectedToken();
+                }
+
+                readThis(Tokens.COLON);
+            }
+
+            valueExpr = XreadValueExpression();
+
+            if (readIfThis(Tokens.FORMAT)) {
+                readThis(Tokens.JSON);
+
+                valueExpr =
+                    new ExpressionJSON.ExpressionJSONWrapper(valueExpr);
+            }
+
+            Object e = map.put(nameExpr, valueExpr);
+
+            if (e != null) {
+                hasDuplicate = true;
+            }
+        }
+
+        nullOnNull = readJSONNullClause(nullOnNull);
+        uniqueKeys = readJSONUniqueClause(uniqueKeys);
+
+        if (uniqueKeys && hasDuplicate) {
+            throw Error.error(ErrorCode.X_23505);
+        }
+
+        if (readIfThis(Tokens.RETURNING)) {
+            dataType = readJSONReturningClause();
+        }
+
+        readThis(Tokens.CLOSEBRACKET);
+
+        return new ExpressionJSON.ExpressionJSONObject(map, nullOnNull,
+                uniqueKeys, dataType);
+    }
+
+    Expression readJSONObjectAgg() {
+
+        boolean                  nullOnNull = true;
+        boolean                  uniqueKeys = false;
+        Type                     dataType   = Type.SQL_VARCHAR_LONG;
+        Expression               nameExpr;
+        Expression               valueExpr;
+        ExpressionArrayAggregate arrayAggName;
+        ExpressionArrayAggregate arrayAggValue;
+
+        readThis(Tokens.OPENBRACKET);
+
+        int position = getPosition();
+
+        nameExpr = XreadCharacterValueExpression();
+
+        if (nameExpr.opType == OpTypes.JSON_FUNCTION) {
+            rewind(position);
+
+            throw unexpectedToken();
+        }
+
+        readThis(Tokens.COLON);
+
+        valueExpr = XreadValueExpression();
+        arrayAggName = new ExpressionArrayAggregate(OpTypes.ARRAY_AGG, false,
+                nameExpr, null, null);
+        arrayAggValue = new ExpressionArrayAggregate(OpTypes.ARRAY_AGG, false,
+                valueExpr, null, null);
+        nullOnNull = readJSONNullClause(nullOnNull);
+        uniqueKeys = readJSONUniqueClause(uniqueKeys);
+
+        if (readIfThis(Tokens.RETURNING)) {
+            dataType = readJSONReturningClause();
+        }
+
+        readThis(Tokens.CLOSEBRACKET);
+
+        return new ExpressionJSON.ExpressionJSONObjectAgg(arrayAggName,
+                arrayAggValue, nullOnNull, uniqueKeys, dataType);
+    }
+
+    boolean readJSONNullClause(boolean defaultValue) {
+
+        boolean nullOnNull = defaultValue;
+
+        switch (token.tokenType) {
+
+            case Tokens.ABSENT : {
+                read();
+                readThis(Tokens.ON);
+                readThis(Tokens.NULL);
+
+                nullOnNull = false;
+
+                break;
+            }
+            case Tokens.NULL : {
+                read();
+                readThis(Tokens.ON);
+                readThis(Tokens.NULL);
+
+                nullOnNull = true;
+
+                break;
+            }
+        }
+
+        return nullOnNull;
+    }
+
+    boolean readJSONUniqueClause(boolean defaultValue) {
+
+        boolean uniqueKeys = defaultValue;
+
+        switch (token.tokenType) {
+
+            case Tokens.WITH : {
+                read();
+                readThis(Tokens.UNIQUE);
+                readIfThis(Tokens.KEYS);
+
+                uniqueKeys = true;
+
+                break;
+            }
+            case Tokens.WITHOUT : {
+                read();
+                readThis(Tokens.UNIQUE);
+                readIfThis(Tokens.KEYS);
+
+                uniqueKeys = false;
+
+                break;
+            }
+        }
+
+        return uniqueKeys;
+    }
+
+    Type readJSONReturningClause() {
+
+        int  position = getPosition();
+        Type dataType = readTypeDefinition(false, true);
+
+        if (dataType.typeCode == Types.SQL_VARCHAR
+                || dataType.typeCode == Types.SQL_CLOB) {
+            return dataType;
+        }
+
+        rewind(position);
+
+        throw super.unexpectedTokenRequire("VARCHAR or CLOB");
+    }
+
     Expression readNextvalFunction() {
 
         read();
@@ -3349,7 +3678,7 @@ public class ParserDQL extends ParserBas
                 if (token.tokenType == Tokens.LOCAL) {
                     read();
                 } else if (token.tokenType == Tokens.TIME) {
-                    readThis(Tokens.TIME);
+                    read();
                     readThis(Tokens.ZONE);
 
                     e1 = XreadValueExpressionPrimary();
@@ -3560,10 +3889,10 @@ public class ParserDQL extends ParserBas
     }
 
     /**
-     *     <value expression> ::=
-     *   <common value expression>
-     *   | <boolean value expression>
-     *   | <row value expression>
+     *   value expression ::=
+     *     common value expression
+     *   | boolean value expression
+     *   | row value expression
      *
      */
     Expression XreadValueExpression() {
@@ -4406,8 +4735,7 @@ public class ParserDQL extends ParserBas
                 return l;
             }
             case Tokens.LIKE : {
-                e                = XreadLikePredicateRightPart(l);
-                e.noOptimisation = isCheckOrTriggerCondition;
+                e = XreadLikePredicateRightPart(l);
 
                 break;
             }
@@ -4417,8 +4745,7 @@ public class ParserDQL extends ParserBas
                 break;
             }
             case Tokens.IN : {
-                e                = XreadInPredicateRightPart(l);
-                e.noOptimisation = isCheckOrTriggerCondition;
+                e = XreadInPredicateRightPart(l);
 
                 break;
             }
@@ -4683,13 +5010,9 @@ public class ParserDQL extends ParserBas
 
         ExpressionLogical r;
 
-        if (isCheckOrTriggerCondition) {
-            r = new ExpressionLogical(OpTypes.IN, l, e);
-        } else {
-            r = new ExpressionLogical(OpTypes.EQUAL, l, e);
+        r = new ExpressionLogical(OpTypes.EQUAL, l, e);
 
-            r.setSubType(OpTypes.ANY_QUANTIFIED);
-        }
+        r.setSubType(OpTypes.ANY_QUANTIFIED);
 
         return r;
     }
@@ -4761,7 +5084,7 @@ public class ParserDQL extends ParserBas
             escape = XreadStringValueExpression();
         }
 
-        return new ExpressionLike(a, b, escape, isCheckOrTriggerCondition);
+        return new ExpressionLike(a, b, escape);
     }
 
     private ExpressionLogical XreadMatchPredicateRightPart(Expression a) {
@@ -7310,9 +7633,10 @@ public class ParserDQL extends ParserBas
 
         queryExpression.setReturningResult();
 
-        if (database.sqlLowerCaseIdentifier && !isRoutine ) {
+        if (database.sqlLowerCaseIdentifier && !isRoutine) {
             queryExpression.setLowerCaseResultIdentifer();
         }
+
         queryExpression.resolve(session, rangeGroups, null);
 
         StatementQuery cs = isRoutine
@@ -7866,17 +8190,23 @@ public class ParserDQL extends ParserBas
 
                 HsqlName name = range.rangeTable.getName();
 
-                if (name.schema != SqlInvariants.SYSTEM_SCHEMA_HSQLNAME) {
-                    set.add(name);
+                if (name.type == SchemaObject.TRANSITION) {
                     set.addAll(range.getColumnNames());
 
-                    if (range.periodCondition != null) {
-                        if (range.periodCondition.isSystemVersionCondition()) {
-                            set.add(range.rangeTable.systemPeriod.getName());
-                        }
+                    continue;
+                }
+
+                if (name.schema == SqlInvariants.SYSTEM_SCHEMA_HSQLNAME) {
+                    continue;
+                }
+
+                set.add(name);
+                set.addAll(range.getColumnNames());
+
+                if (range.periodCondition != null) {
+                    if (range.periodCondition.isSystemVersionCondition()) {
+                        set.add(range.rangeTable.systemPeriod.getName());
                     }
-                } else if (name.type == SchemaObject.TRANSITION) {
-                    set.addAll(range.getColumnNames());
                 }
             }
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/ParserRoutine.java 2.7.0-1/hsqldb/src/org/hsqldb/ParserRoutine.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/ParserRoutine.java	2021-02-19 14:56:46.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/ParserRoutine.java	2022-04-21 06:32:20.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -50,7 +50,7 @@ import org.hsqldb.types.Type;
  * Parser for SQL stored procedures and functions - PSM
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class ParserRoutine extends ParserTable {
@@ -2430,10 +2430,8 @@ public class ParserRoutine extends Parse
 
             int position = getPosition();
 
-            isCheckOrTriggerCondition = true;
-            condition                 = XreadBooleanValueExpression();
-            conditionSQL              = getLastPart(position);
-            isCheckOrTriggerCondition = false;
+            condition    = XreadBooleanValueExpression();
+            conditionSQL = getLastPart(position);
 
             readThis(Tokens.CLOSEBRACKET);
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/ParserTable.java 2.7.0-1/hsqldb/src/org/hsqldb/ParserTable.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/ParserTable.java	2021-02-10 00:08:36.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/ParserTable.java	2022-04-20 11:48:10.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -47,7 +47,7 @@ import org.hsqldb.types.Types;
  * Parser for SQL table definition
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class ParserTable extends ParserDML {
@@ -1130,8 +1130,10 @@ public class ParserTable extends ParserD
 
                     colConstraint = new ExpressionLogical(OpTypes.IN, left,
                                                           right);
-                    colConstraint.noOptimisation = true;
-                    c.check                      = colConstraint;
+
+                    colConstraint.setNoOptimisation();
+
+                    c.check = colConstraint;
                 }
             }
         }
@@ -1830,12 +1832,9 @@ public class ParserTable extends ParserD
 
         readThis(Tokens.OPENBRACKET);
 
-        isCheckOrTriggerCondition = true;
-
         Expression condition = XreadBooleanValueExpression();
 
-        isCheckOrTriggerCondition = false;
-
+        condition.setNoOptimisation();
         readThis(Tokens.CLOSEBRACKET);
 
         c.check = condition;
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/persist/BlockObjectStore.java 2.7.0-1/hsqldb/src/org/hsqldb/persist/BlockObjectStore.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/persist/BlockObjectStore.java	2020-05-18 10:21:52.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/persist/BlockObjectStore.java	2022-02-21 14:41:52.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2020, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/persist/Cache.java 2.7.0-1/hsqldb/src/org/hsqldb/persist/Cache.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/persist/Cache.java	2021-01-29 13:34:34.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/persist/Cache.java	2022-07-13 15:38:30.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -52,7 +52,7 @@ import org.hsqldb.map.BaseHashMap;
  * to DataFileCache.<p>
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 1.8.0
  */
 public class Cache extends BaseHashMap {
@@ -445,7 +445,7 @@ public class Cache extends BaseHashMap {
 
 //
         sb.append("tx-ts ");
-        sb.append(dataFileCache.database.txManager.getGlobalChangeTimestamp());
+        sb.append(dataFileCache.database.txManager.getSystemChangeNumber());
 
 //
         dataFileCache.logDetailEvent(sb.toString());
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/persist/DataFileCache.java 2.7.0-1/hsqldb/src/org/hsqldb/persist/DataFileCache.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/persist/DataFileCache.java	2021-03-19 12:02:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/persist/DataFileCache.java	2022-03-26 16:18:48.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -893,7 +893,8 @@ public class DataFileCache {
 
                         if (j > 0) {
                             logInfoEvent(dataFileName
-                                         + " getFromFile out of mem, pos: " + pos);
+                                         + " getFromFile out of mem, pos: "
+                                         + pos);
 
                             HsqlException ex =
                                 Error.error(ErrorCode.OUT_OF_MEMORY, t);
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/persist/DataFileCacheSession.java 2.7.0-1/hsqldb/src/org/hsqldb/persist/DataFileCacheSession.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/persist/DataFileCacheSession.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/persist/DataFileCacheSession.java	2022-07-07 16:32:28.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -40,7 +40,7 @@ import org.hsqldb.lib.FileUtil;
  * A file-based row store for temporary CACHED table persistence.<p>
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.3.4
+ * @version  2.7.0
  * @since 1.9.0
  */
 public class DataFileCacheSession extends DataFileCache {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/persist/DataFileDefrag.java 2.7.0-1/hsqldb/src/org/hsqldb/persist/DataFileDefrag.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/persist/DataFileDefrag.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/persist/DataFileDefrag.java	2022-05-22 18:09:56.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -31,8 +31,6 @@
 
 package org.hsqldb.persist;
 
-import java.util.Arrays;
-
 import org.hsqldb.Database;
 import org.hsqldb.Session;
 import org.hsqldb.Table;
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/persist/DoubleIntArrayCachedObject.java 2.7.0-1/hsqldb/src/org/hsqldb/persist/DoubleIntArrayCachedObject.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/persist/DoubleIntArrayCachedObject.java	2020-05-20 08:42:42.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/persist/DoubleIntArrayCachedObject.java	2022-02-21 14:41:50.000000000 +0000
@@ -31,10 +31,10 @@
 
 package org.hsqldb.persist;
 
+import org.hsqldb.lib.DoubleIntIndex;
 import org.hsqldb.lib.LongLookup;
 import org.hsqldb.rowio.RowInputInterface;
 import org.hsqldb.rowio.RowOutputInterface;
-import org.hsqldb.lib.DoubleIntIndex;
 
 /**
  * @author Fred Toussi (fredt@users dot sourceforge.net)
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/persist/EventLogInterface.java 2.7.0-1/hsqldb/src/org/hsqldb/persist/EventLogInterface.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/persist/EventLogInterface.java	2019-04-27 17:24:56.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/persist/EventLogInterface.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,48 +0,0 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions are met:
- *
- * Redistributions of source code must retain the above copyright notice, this
- * list of conditions and the following disclaimer.
- *
- * Redistributions in binary form must reproduce the above copyright notice,
- * this list of conditions and the following disclaimer in the documentation
- * and/or other materials provided with the distribution.
- *
- * Neither the name of the HSQL Development Group nor the names of its
- * contributors may be used to endorse or promote products derived from this
- * software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
- * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED. IN NO EVENT SHALL HSQL DEVELOPMENT GROUP, HSQLDB.ORG,
- * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
- * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
- * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
- * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
- * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
- * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
- * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- */
-
-
-package org.hsqldb.persist;
-
-/**
- * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.3.0
- * @since 1.9.0
- */
-public interface EventLogInterface {
-
-    void logSevereEvent(String message, Throwable t);
-
-    void logWarningEvent(String message, Throwable t);
-
-    void logInfoEvent(String message);
-
-    void logDetailEvent(String message);
-}
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/persist/HsqlDatabaseProperties.java 2.7.0-1/hsqldb/src/org/hsqldb/persist/HsqlDatabaseProperties.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/persist/HsqlDatabaseProperties.java	2021-07-15 13:57:30.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/persist/HsqlDatabaseProperties.java	2022-07-08 18:55:34.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -36,43 +36,47 @@ import java.util.Enumeration;
 import org.hsqldb.Database;
 import org.hsqldb.error.Error;
 import org.hsqldb.error.ErrorCode;
+import org.hsqldb.lib.ArrayUtil;
 import org.hsqldb.lib.HashMap;
 import org.hsqldb.lib.HashSet;
 import org.hsqldb.lib.Iterator;
-import org.hsqldb.lib.Set;
 import org.hsqldb.lib.StringUtil;
+import org.hsqldb.types.Collation;
 
 /**
  * Manages a .properties file for a database.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.1
+ * @version 2.7.0
  * @since 1.7.0
  */
 public class HsqlDatabaseProperties extends HsqlProperties {
 
-    private static final String hsqldb_method_class_names =
+    public static final String hsqldb_method_class_names =
         "hsqldb.method_class_names";
     public static final String textdb_allow_full_path =
         "textdb.allow_full_path";
+    public static final String hsqldb_reconfig_logging =
+        "hsqldb.reconfig_logging";
+    public static String   methodClassNames;
     private static HashSet accessibleJavaMethodNames;
     private static boolean allowFullPath;
 
     static {
         try {
-            String prop = System.getProperty(hsqldb_method_class_names);
+            methodClassNames = System.getProperty(hsqldb_method_class_names);
 
-            if (prop != null) {
+            if (methodClassNames != null) {
                 accessibleJavaMethodNames = new HashSet();
 
-                String[] names = StringUtil.split(prop, ";");
+                String[] names = StringUtil.split(methodClassNames, ";");
 
                 for (int i = 0; i < names.length; i++) {
                     accessibleJavaMethodNames.add(names[i]);
                 }
             }
 
-            prop = System.getProperty(textdb_allow_full_path);
+            String prop = System.getProperty(textdb_allow_full_path);
 
             if (prop != null) {
                 if (Boolean.valueOf(prop)) {
@@ -128,37 +132,42 @@ public class HsqlDatabaseProperties exte
     }
 
     // accessibility
-    public static final int SYSTEM_PROPERTY = 0;
-    public static final int FILE_PROPERTY   = 1;
-    public static final int SQL_PROPERTY    = 2;
+    public static final int SYSTEM_PROP = 0;
+    public static final int FILES_PROP  = 1;
+    public static final int DB_PROP     = 2;
+    public static final int SQL_PROP    = 3;
+    public static final int URL_PROP    = 4;
 
     // db files modified
-    public static final int     FILES_NOT_MODIFIED      = 0;
-    public static final int     FILES_MODIFIED          = 1;
-    public static final int     FILES_MODIFIED_NEW      = 2;
-    public static final int     FILES_MODIFIED_NEW_DATA = 3;
-    public static final int     FILES_NEW               = 4;
-    private static final String MODIFIED_NO             = "no";
-    private static final String MODIFIED_YES            = "yes";
-    private static final String MODIFIED_YES_NEW        = "yes-new-files";
-    private static final String MODIFIED_YES_NEW_DATA   = "yes-new-files-data";
-    private static final String MODIFIED_NO_NEW         = "no-new-files";
+    public static final int FILES_NOT_MODIFIED      = 0;
+    public static final int FILES_MODIFIED          = 1;
+    public static final int FILES_MODIFIED_NEW      = 2;
+    public static final int FILES_MODIFIED_NEW_DATA = 3;
+    public static final int FILES_NEW               = 4;
+
+    //
+    private static final String MODIFIED_NO           = "no";
+    private static final String MODIFIED_YES          = "yes";
+    private static final String MODIFIED_YES_NEW      = "yes-new-files";
+    private static final String MODIFIED_YES_NEW_DATA = "yes-new-files-data";
+    private static final String MODIFIED_NO_NEW       = "no-new-files";
 
     // allowed property metadata
-    private static final HashMap dbMeta   = new HashMap(67);
-    private static final HashMap textMeta = new HashMap(17);
+    private static final HashMap<String, PropertyMeta> dbMeta = new HashMap(128);
+    private static final HashMap<String, PropertyMeta> textMeta = new HashMap(16);
+    private static final HashSet<String>               excludedMeta = new HashSet();
+    private static final HashMap<String, PropertyMeta> urlUserConnMeta = new HashMap();
 
     // versions
     public static final String VERSION_STRING_1_8_0 = "1.8.0";
     public static final String PRODUCT_NAME         = "HSQL Database Engine";
 
 //#ifdef JAVA8
-
-    public static final String THIS_VERSION         = "2.6.1";
-    public static final String THIS_FULL_VERSION    = "2.6.1";
-    public static final int    MAJOR                = 2,
-                               MINOR                = 6,
-                               REVISION             = 1;
+    public static final String THIS_VERSION      = "2.7.0";
+    public static final String THIS_FULL_VERSION = "2.7.0";
+    public static final int    MAJOR             = 2,
+                               MINOR             = 7,
+                               REVISION          = 0;
 
 //#else
 /*
@@ -191,9 +200,6 @@ public class HsqlDatabaseProperties exte
     public static final String tx_timestamp = "tx_timestamp";
 
     //
-    public static final String hsqldb_cache_version = "hsqldb.cache_version";
-
-    //
     public static final String runtime_gc_interval = "runtime.gc_interval";
 
     //
@@ -226,6 +232,7 @@ public class HsqlDatabaseProperties exte
     public static final String hsqldb_tx_interrupt_rollback =
         "hsqldb.tx_interrupt_rollback";
     public static final String hsqldb_applog         = "hsqldb.applog";
+    public static final String hsqldb_extlog         = "hsqldb.extlog";
     public static final String hsqldb_sqllog         = "hsqldb.sqllog";
     public static final String hsqldb_lob_file_scale = "hsqldb.lob_file_scale";
     public static final String hsqldb_lob_file_compressed =
@@ -269,31 +276,34 @@ public class HsqlDatabaseProperties exte
     public static final String sql_enforce_size        = "sql.enforce_size";
     public static final String sql_enforce_strict_size =
         "sql.enforce_strict_size";    // synonym for sql_enforce_size
-    public static final String sql_enforce_refs    = "sql.enforce_refs";
-    public static final String sql_enforce_names   = "sql.enforce_names";
-    public static final String sql_regular_names   = "sql.regular_names";
-    public static final String sql_enforce_types   = "sql.enforce_types";
-    public static final String sql_enforce_tdcd    = "sql.enforce_tdc_delete";
-    public static final String sql_enforce_tdcu    = "sql.enforce_tdc_update";
-    public static final String sql_char_literal    = "sql.char_literal";
-    public static final String sql_concat_nulls    = "sql.concat_nulls";
-    public static final String sql_nulls_first     = "sql.nulls_first";
-    public static final String sql_nulls_order     = "sql.nulls_order";
-    public static final String sql_unique_nulls    = "sql.unique_nulls";
-    public static final String sql_convert_trunc   = "sql.convert_trunc";
-    public static final String sql_avg_scale       = "sql.avg_scale";
-    public static final String sql_double_nan      = "sql.double_nan";
-    public static final String sql_syntax_db2      = "sql.syntax_db2";
-    public static final String sql_syntax_mss      = "sql.syntax_mss";
-    public static final String sql_syntax_mys      = "sql.syntax_mys";
-    public static final String sql_syntax_ora      = "sql.syntax_ora";
-    public static final String sql_syntax_pgs      = "sql.syntax_pgs";
-    public static final String sql_longvar_is_lob  = "sql.longvar_is_lob";
-    public static final String sql_pad_space       = "sql.pad_space";
-    public static final String sql_ignore_case     = "sql.ignore_case";
-    public static final String sql_live_object     = "sql.live_object";
-    public static final String sql_sys_index_names = "sql.sys_index_names";
-    public static final String sql_lowercase_ident = "sql.lowercase_ident";
+    public static final String sql_enforce_refs      = "sql.enforce_refs";
+    public static final String sql_enforce_names     = "sql.enforce_names";
+    public static final String sql_regular_names     = "sql.regular_names";
+    public static final String sql_enforce_types     = "sql.enforce_types";
+    public static final String sql_enforce_tdcd = "sql.enforce_tdc_delete";
+    public static final String sql_enforce_tdcu = "sql.enforce_tdc_update";
+    public static final String sql_char_literal      = "sql.char_literal";
+    public static final String sql_concat_nulls      = "sql.concat_nulls";
+    public static final String sql_nulls_first       = "sql.nulls_first";
+    public static final String sql_nulls_order       = "sql.nulls_order";
+    public static final String sql_unique_nulls      = "sql.unique_nulls";
+    public static final String sql_convert_trunc     = "sql.convert_trunc";
+    public static final String sql_trunc_trailing    = "sql.truncate_trailing";
+    public static final String sql_avg_scale         = "sql.avg_scale";
+    public static final String sql_max_recursive     = "sql.max_recursive";
+    public static final String sql_double_nan        = "sql.double_nan";
+    public static final String sql_syntax_db2        = "sql.syntax_db2";
+    public static final String sql_syntax_mss        = "sql.syntax_mss";
+    public static final String sql_syntax_mys        = "sql.syntax_mys";
+    public static final String sql_syntax_ora        = "sql.syntax_ora";
+    public static final String sql_syntax_pgs        = "sql.syntax_pgs";
+    public static final String sql_longvar_is_lob    = "sql.longvar_is_lob";
+    public static final String sql_default_collation = "sql.default_collation";
+    public static final String sql_pad_space         = "sql.pad_space";
+    public static final String sql_ignore_case       = "sql.ignore_case";
+    public static final String sql_live_object       = "sql.live_object";
+    public static final String sql_sys_index_names   = "sql.sys_index_names";
+    public static final String sql_lowercase_ident   = "sql.lowercase_ident";
 
     //
     public static final String textdb_cache_scale = "textdb.cache_scale";
@@ -311,282 +321,225 @@ public class HsqlDatabaseProperties exte
     public static final String textdb_qc           = "textdb.qc";
     public static final String textdb_null_def     = "textdb.null_def";
 
-    // obsolete property from version 2.5.1
-    public static final String hsqldb_min_reuse = "hsqldb.min_reuse";
+    // obsolete properties from version 2.5.1
+    public static final String hsqldb_min_reuse     = "hsqldb.min_reuse";
+    public static final String hsqldb_cache_version = "hsqldb.cache_version";
 
     static {
 
+        // properties that are not displayed to user, including obsolete props
+        excludedMeta.add(hsqldb_min_reuse);
+        excludedMeta.add(hsqldb_cache_version);
+        excludedMeta.add(runtime_gc_interval);
+        excludedMeta.add(hsqldb_inc_backup);
+        excludedMeta.add(tx_timestamp);
+        excludedMeta.add(hsqldb_version);
+        excludedMeta.add(hsqldb_modified);
+        excludedMeta.add(hsqldb_full_log_replay);
+        excludedMeta.add(sql_compare_in_locale);
+
+        // url properties which apply to a new connection to an open database
+        urlUserConnMeta.put(url_default_schema,
+                            newMeta(url_default_schema, URL_PROP, false));
+        urlUserConnMeta.put(url_check_props,
+                            newMeta(url_check_props, URL_PROP, false));
+        urlUserConnMeta.put(url_get_column_name,
+                            newMeta(url_get_column_name, URL_PROP, true));
+        urlUserConnMeta.put(url_close_result,
+                            newMeta(url_close_result, URL_PROP, false));
+        urlUserConnMeta.put(url_allow_empty_batch,
+                            newMeta(url_allow_empty_batch, URL_PROP, false));
+        urlUserConnMeta.put(url_memory_lobs,
+                            newMeta(url_memory_lobs, URL_PROP, false));
+
         // text table defaults
         textMeta.put(textdb_allow_full_path,
-                     HsqlProperties.getMeta(textdb_allow_full_path,
-                                            SYSTEM_PROPERTY, allowFullPath));
-        textMeta.put(textdb_quoted,
-                     HsqlProperties.getMeta(textdb_quoted, SQL_PROPERTY,
-                                            true));
+                     newMeta(textdb_allow_full_path, SYSTEM_PROP, true));
+        textMeta.put(textdb_quoted, newMeta(textdb_quoted, SQL_PROP, true));
         textMeta.put(textdb_all_quoted,
-                     HsqlProperties.getMeta(textdb_all_quoted, SQL_PROPERTY,
-                                            false));
+                     newMeta(textdb_all_quoted, SQL_PROP, false));
         textMeta.put(textdb_ignore_first,
-                     HsqlProperties.getMeta(textdb_ignore_first, SQL_PROPERTY,
-                                            false));
+                     newMeta(textdb_ignore_first, SQL_PROP, false));
         textMeta.put(textdb_null_def,
-                     HsqlProperties.getMeta(textdb_null_def, SQL_PROPERTY,
-                                            false));
-        textMeta.put(textdb_fs,
-                     HsqlProperties.getMeta(textdb_fs, SQL_PROPERTY, ","));
-        textMeta.put(textdb_vs,
-                     HsqlProperties.getMeta(textdb_vs, SQL_PROPERTY, null));
-        textMeta.put(textdb_lvs,
-                     HsqlProperties.getMeta(textdb_lvs, SQL_PROPERTY, null));
-        textMeta.put(textdb_qc,
-                     HsqlProperties.getMeta(textdb_qc, SQL_PROPERTY, "\""));
+                     newMeta(textdb_null_def, SQL_PROP, false));
+        textMeta.put(textdb_fs, newMeta(textdb_fs, SQL_PROP, ","));
+        textMeta.put(textdb_vs, newMeta(textdb_vs, SQL_PROP, null));
+        textMeta.put(textdb_lvs, newMeta(textdb_lvs, SQL_PROP, null));
+        textMeta.put(textdb_qc, newMeta(textdb_qc, SQL_PROP, "\""));
         textMeta.put(textdb_encoding,
-                     HsqlProperties.getMeta(textdb_encoding, SQL_PROPERTY,
-                                            "ISO-8859-1"));
+                     newMeta(textdb_encoding, SQL_PROP, "ISO-8859-1"));
         textMeta.put(textdb_cache_scale,
-                     HsqlProperties.getMeta(textdb_cache_scale, SQL_PROPERTY,
-                                            10, 8, 16));
+                     newMeta(textdb_cache_scale, DB_PROP, 10, 8, 16));
         textMeta.put(textdb_cache_size_scale,
-                     HsqlProperties.getMeta(textdb_cache_size_scale,
-                                            SQL_PROPERTY, 10, 6, 20));
+                     newMeta(textdb_cache_size_scale, DB_PROP, 10, 6, 20));
         textMeta.put(textdb_cache_rows,
-                     HsqlProperties.getMeta(textdb_cache_rows, SQL_PROPERTY,
-                                            1000, 100, 1000000));
+                     newMeta(textdb_cache_rows, DB_PROP, 1000, 100, 1000000));
         textMeta.put(textdb_cache_size,
-                     HsqlProperties.getMeta(textdb_cache_size, SQL_PROPERTY,
-                                            100, 10, 1000000));
+                     newMeta(textdb_cache_size, DB_PROP, 100, 10, 1000000));
         dbMeta.putAll(textMeta);
 
+        // system props
+        dbMeta.put(hsqldb_method_class_names,
+                   newMeta(hsqldb_method_class_names, SYSTEM_PROP, ""));
+        dbMeta.put(hsqldb_reconfig_logging,
+                   newMeta(hsqldb_reconfig_logging, SYSTEM_PROP, false));
+
         // string defaults for protected props
-        dbMeta.put(hsqldb_version,
-                   HsqlProperties.getMeta(hsqldb_version, FILE_PROPERTY,
-                                          null));
+        dbMeta.put(hsqldb_version, newMeta(hsqldb_version, FILES_PROP, null));
         dbMeta.put(hsqldb_modified,
-                   HsqlProperties.getMeta(hsqldb_modified, FILE_PROPERTY,
-                                          null));
+                   newMeta(hsqldb_modified, FILES_PROP, null));
         dbMeta.put(hsqldb_cache_version,
-                   HsqlProperties.getMeta(hsqldb_cache_version, FILE_PROPERTY,
-                                          null));
+                   newMeta(hsqldb_cache_version, FILES_PROP, null));
 
         // boolean defaults for protected props
         dbMeta.put(hsqldb_readonly,
-                   HsqlProperties.getMeta(hsqldb_readonly, FILE_PROPERTY,
-                                          false));
+                   newMeta(hsqldb_readonly, FILES_PROP, false));
         dbMeta.put(hsqldb_files_readonly,
-                   HsqlProperties.getMeta(hsqldb_files_readonly,
-                                          FILE_PROPERTY, false));
+                   newMeta(hsqldb_files_readonly, FILES_PROP, false));
 
         // string defaults for user defined props
-        dbMeta.put(hsqldb_tx,
-                   HsqlProperties.getMeta(hsqldb_tx, SQL_PROPERTY, "LOCKS"));
+        dbMeta.put(hsqldb_tx, newMeta(hsqldb_tx, SQL_PROP, "LOCKS"));
         dbMeta.put(hsqldb_tx_level,
-                   HsqlProperties.getMeta(hsqldb_tx_level, SQL_PROPERTY,
-                                          "READ_COMMITTED"));
+                   newMeta(hsqldb_tx_level, SQL_PROP, "READ_COMMITTED"));
         dbMeta.put(hsqldb_temp_directory,
-                   HsqlProperties.getMeta(hsqldb_temp_directory, SQL_PROPERTY,
-                                          null));
+                   newMeta(hsqldb_temp_directory, DB_PROP, null));
         dbMeta.put(hsqldb_default_table_type,
-                   HsqlProperties.getMeta(hsqldb_default_table_type,
-                                          SQL_PROPERTY, "MEMORY"));
-        dbMeta.put(hsqldb_digest,
-                   HsqlProperties.getMeta(hsqldb_digest, SQL_PROPERTY, "MD5"));
-        dbMeta.put(sql_live_object,
-                   HsqlProperties.getMeta(sql_live_object, SQL_PROPERTY,
-                                          false));
-        dbMeta.put(tx_timestamp,
-                   HsqlProperties.getMeta(tx_timestamp, SYSTEM_PROPERTY));
+                   newMeta(hsqldb_default_table_type, SQL_PROP, "MEMORY"));
+        dbMeta.put(hsqldb_digest, newMeta(hsqldb_digest, DB_PROP, "MD5"));
+        dbMeta.put(sql_live_object, newMeta(sql_live_object, DB_PROP, false));
+        dbMeta.put(tx_timestamp, newMeta(tx_timestamp, DB_PROP, 0));
 
         // boolean defaults for user defined props
         dbMeta.put(hsqldb_tx_conflict_rollback,
-                   HsqlProperties.getMeta(hsqldb_tx_conflict_rollback,
-                                          SQL_PROPERTY, true));
+                   newMeta(hsqldb_tx_conflict_rollback, SQL_PROP, true));
         dbMeta.put(hsqldb_tx_interrupt_rollback,
-                   HsqlProperties.getMeta(hsqldb_tx_interrupt_rollback,
-                                          SQL_PROPERTY, false));
+                   newMeta(hsqldb_tx_interrupt_rollback, SQL_PROP, false));
         dbMeta.put(jdbc_translate_tti_types,
-                   HsqlProperties.getMeta(jdbc_translate_tti_types,
-                                          SQL_PROPERTY, true));
+                   newMeta(jdbc_translate_tti_types, SQL_PROP, true));
         dbMeta.put(hsqldb_inc_backup,
-                   HsqlProperties.getMeta(hsqldb_inc_backup, SQL_PROPERTY,
-                                          true));
-        dbMeta.put(hsqldb_lock_file,
-                   HsqlProperties.getMeta(hsqldb_lock_file, SQL_PROPERTY,
-                                          true));
-        dbMeta.put(hsqldb_log_data,
-                   HsqlProperties.getMeta(hsqldb_log_data, SQL_PROPERTY,
-                                          true));
+                   newMeta(hsqldb_inc_backup, DB_PROP, true));
+        dbMeta.put(hsqldb_lock_file, newMeta(hsqldb_lock_file, DB_PROP, true));
+        dbMeta.put(hsqldb_log_data, newMeta(hsqldb_log_data, DB_PROP, true));
         dbMeta.put(hsqldb_nio_data_file,
-                   HsqlProperties.getMeta(hsqldb_nio_data_file, SQL_PROPERTY,
-                                          true));
+                   newMeta(hsqldb_nio_data_file, DB_PROP, true));
         dbMeta.put(hsqldb_full_log_replay,
-                   HsqlProperties.getMeta(hsqldb_full_log_replay,
-                                          SQL_PROPERTY, false));
+                   newMeta(hsqldb_full_log_replay, DB_PROP, false));
         dbMeta.put(hsqldb_write_delay,
-                   HsqlProperties.getMeta(hsqldb_write_delay, SQL_PROPERTY,
-                                          true));
+                   newMeta(hsqldb_write_delay, DB_PROP, true));
         dbMeta.put(hsqldb_large_data,
-                   HsqlProperties.getMeta(hsqldb_large_data, SQL_PROPERTY,
-                                          false));
+                   newMeta(hsqldb_large_data, DB_PROP, false));
         dbMeta.put(sql_ref_integrity,
-                   HsqlProperties.getMeta(sql_ref_integrity, SQL_PROPERTY,
-                                          true));
+                   newMeta(sql_ref_integrity, SQL_PROP, true));
         dbMeta.put(sql_restrict_exec,
-                   HsqlProperties.getMeta(sql_restrict_exec, SQL_PROPERTY,
-                                          false));
+                   newMeta(sql_restrict_exec, SQL_PROP, false));
 
         // SQL reserved words not allowed as some identifiers
         dbMeta.put(sql_enforce_names,
-                   HsqlProperties.getMeta(sql_enforce_names, SQL_PROPERTY,
-                                          false));
+                   newMeta(sql_enforce_names, SQL_PROP, false));
         dbMeta.put(sql_regular_names,
-                   HsqlProperties.getMeta(sql_regular_names, SQL_PROPERTY,
-                                          true));
+                   newMeta(sql_regular_names, SQL_PROP, true));
         dbMeta.put(sql_enforce_refs,
-                   HsqlProperties.getMeta(sql_enforce_refs, SQL_PROPERTY,
-                                          false));
+                   newMeta(sql_enforce_refs, SQL_PROP, false));
 
         // char padding to size and exception if data is too long
         dbMeta.put(sql_enforce_size,
-                   HsqlProperties.getMeta(sql_enforce_size, SQL_PROPERTY,
-                                          true));
+                   newMeta(sql_enforce_size, SQL_PROP, true));
         dbMeta.put(sql_enforce_types,
-                   HsqlProperties.getMeta(sql_enforce_types, SQL_PROPERTY,
-                                          false));
+                   newMeta(sql_enforce_types, SQL_PROP, false));
         dbMeta.put(sql_enforce_tdcd,
-                   HsqlProperties.getMeta(sql_enforce_tdcd, SQL_PROPERTY,
-                                          true));
+                   newMeta(sql_enforce_tdcd, SQL_PROP, true));
         dbMeta.put(sql_enforce_tdcu,
-                   HsqlProperties.getMeta(sql_enforce_tdcu, SQL_PROPERTY,
-                                          true));
+                   newMeta(sql_enforce_tdcu, SQL_PROP, true));
         dbMeta.put(sql_char_literal,
-                   HsqlProperties.getMeta(sql_char_literal, SQL_PROPERTY,
-                                          true));
+                   newMeta(sql_char_literal, SQL_PROP, true));
         dbMeta.put(sql_concat_nulls,
-                   HsqlProperties.getMeta(sql_concat_nulls, SQL_PROPERTY,
-                                          true));
-        dbMeta.put(sql_nulls_first,
-                   HsqlProperties.getMeta(sql_nulls_first, SQL_PROPERTY,
-                                          true));
-        dbMeta.put(sql_nulls_order,
-                   HsqlProperties.getMeta(sql_nulls_order, SQL_PROPERTY,
-                                          true));
+                   newMeta(sql_concat_nulls, SQL_PROP, true));
+        dbMeta.put(sql_nulls_first, newMeta(sql_nulls_first, SQL_PROP, true));
+        dbMeta.put(sql_nulls_order, newMeta(sql_nulls_order, SQL_PROP, true));
         dbMeta.put(sql_unique_nulls,
-                   HsqlProperties.getMeta(sql_unique_nulls, SQL_PROPERTY,
-                                          true));
+                   newMeta(sql_unique_nulls, SQL_PROP, true));
         dbMeta.put(sql_convert_trunc,
-                   HsqlProperties.getMeta(sql_convert_trunc, SQL_PROPERTY,
-                                          true));
-        dbMeta.put(sql_avg_scale,
-                   HsqlProperties.getMeta(sql_avg_scale, SQL_PROPERTY, 0, 0,
-                                          10));
-        dbMeta.put(sql_double_nan,
-                   HsqlProperties.getMeta(sql_double_nan, SQL_PROPERTY, true));
-        dbMeta.put(sql_syntax_db2,
-                   HsqlProperties.getMeta(sql_syntax_db2, SQL_PROPERTY,
-                                          false));
-        dbMeta.put(sql_syntax_mss,
-                   HsqlProperties.getMeta(sql_syntax_mss, SQL_PROPERTY,
-                                          false));
-        dbMeta.put(sql_syntax_mys,
-                   HsqlProperties.getMeta(sql_syntax_mys, SQL_PROPERTY,
-                                          false));
-        dbMeta.put(sql_syntax_ora,
-                   HsqlProperties.getMeta(sql_syntax_ora, SQL_PROPERTY,
-                                          false));
-        dbMeta.put(sql_syntax_pgs,
-                   HsqlProperties.getMeta(sql_syntax_pgs, SQL_PROPERTY,
-                                          false));
+                   newMeta(sql_convert_trunc, SQL_PROP, true));
+        dbMeta.put(sql_trunc_trailing,
+                   newMeta(sql_trunc_trailing, SQL_PROP, true));
+        dbMeta.put(sql_avg_scale, newMeta(sql_avg_scale, SQL_PROP, 0, 0, 10));
+        dbMeta.put(sql_max_recursive,
+                   newMeta(sql_max_recursive, SQL_PROP, 256, 16,
+                           1024 * 1024 * 1024));
+        dbMeta.put(sql_double_nan, newMeta(sql_double_nan, SQL_PROP, true));
+        dbMeta.put(sql_syntax_db2, newMeta(sql_syntax_db2, SQL_PROP, false));
+        dbMeta.put(sql_syntax_mss, newMeta(sql_syntax_mss, SQL_PROP, false));
+        dbMeta.put(sql_syntax_mys, newMeta(sql_syntax_mys, SQL_PROP, false));
+        dbMeta.put(sql_syntax_ora, newMeta(sql_syntax_ora, SQL_PROP, false));
+        dbMeta.put(sql_syntax_pgs, newMeta(sql_syntax_pgs, SQL_PROP, false));
         dbMeta.put(sql_compare_in_locale,
-                   HsqlProperties.getMeta(sql_compare_in_locale, SQL_PROPERTY,
-                                          false));
+                   newMeta(sql_compare_in_locale, SQL_PROP, false));
         dbMeta.put(sql_longvar_is_lob,
-                   HsqlProperties.getMeta(sql_longvar_is_lob, SQL_PROPERTY,
-                                          false));
-        dbMeta.put(sql_pad_space,
-                   HsqlProperties.getMeta(sql_pad_space, SQL_PROPERTY, true));
-        dbMeta.put(sql_ignore_case,
-                   HsqlProperties.getMeta(sql_ignore_case, SQL_PROPERTY,
-                                          false));
+                   newMeta(sql_longvar_is_lob, SQL_PROP, false));
+        dbMeta.put(sql_default_collation,
+                   newMeta(sql_default_collation, SQL_PROP,
+                           Collation.defaultCollationName));
+        dbMeta.put(sql_pad_space, newMeta(sql_pad_space, SQL_PROP, true));
+        dbMeta.put(sql_ignore_case, newMeta(sql_ignore_case, SQL_PROP, false));
         dbMeta.put(sql_sys_index_names,
-                   HsqlProperties.getMeta(sql_sys_index_names, SQL_PROPERTY,
-                                          false));
+                   newMeta(sql_sys_index_names, SQL_PROP, true));
         dbMeta.put(sql_lowercase_ident,
-                   HsqlProperties.getMeta(sql_lowercase_ident, SQL_PROPERTY,
-                                          false));
+                   newMeta(sql_lowercase_ident, SQL_PROP, false));
         dbMeta.put(hsqldb_files_space,
-                   HsqlProperties.getMeta(hsqldb_files_space, SQL_PROPERTY, 0,
-                                          new int[] {
-            0, 1, 2, 4, 8, 16, 32, 64
-        }));
+                   newMeta(hsqldb_files_space, DB_PROP, false));
 
         // integral defaults for user-defined props - sets
         dbMeta.put(hsqldb_write_delay_millis,
-                   HsqlProperties.getMeta(hsqldb_write_delay_millis,
-                                          SQL_PROPERTY, 500, 0, 10000));
-        dbMeta.put(hsqldb_applog,
-                   HsqlProperties.getMeta(hsqldb_applog, SQL_PROPERTY, 0, 0,
-                                          3));
-        dbMeta.put(hsqldb_sqllog,
-                   HsqlProperties.getMeta(hsqldb_sqllog, SQL_PROPERTY, 0, 0,
-                                          4));
+                   newMeta(hsqldb_write_delay_millis, DB_PROP, 500, 0, 10000));
+        dbMeta.put(hsqldb_applog, newMeta(hsqldb_applog, DB_PROP, 0, 0, 4));
+        dbMeta.put(hsqldb_extlog, newMeta(hsqldb_extlog, DB_PROP, 0, 0, 4));
+        dbMeta.put(hsqldb_sqllog, newMeta(hsqldb_sqllog, DB_PROP, 0, 0, 4));
         dbMeta.put(hsqldb_script_format,
-                   HsqlProperties.getMeta(hsqldb_script_format, SQL_PROPERTY,
-                                          0, new int[] {
+                   newMeta(hsqldb_script_format, DB_PROP, 0, new int[] {
             0, 1, 3
         }));
         dbMeta.put(hsqldb_lob_file_scale,
-                   HsqlProperties.getMeta(hsqldb_lob_file_scale, SQL_PROPERTY,
-                                          32, new int[] {
+                   newMeta(hsqldb_lob_file_scale, DB_PROP, 32, new int[] {
             1, 2, 4, 8, 16, 32
         }));
         dbMeta.put(hsqldb_lob_file_compressed,
-                   HsqlProperties.getMeta(hsqldb_lob_file_compressed,
-                                          SQL_PROPERTY, false));
+                   newMeta(hsqldb_lob_file_compressed, DB_PROP, false));
 
         // this property is normally 8 - or 1 for old databases from early versions
         dbMeta.put(hsqldb_cache_file_scale,
-                   HsqlProperties.getMeta(hsqldb_cache_file_scale,
-                                          SQL_PROPERTY, 32, new int[] {
+                   newMeta(hsqldb_cache_file_scale, DB_PROP, 32, new int[] {
             1, 8, 16, 32, 64, 128, 256, 512, 1024
         }));
 
         // integral defaults for user defined props - ranges
         dbMeta.put(hsqldb_log_size,
-                   HsqlProperties.getMeta(hsqldb_log_size, SQL_PROPERTY, 50,
-                                          0, 4 * 1024));
+                   newMeta(hsqldb_log_size, DB_PROP, 50, 0, 4 * 1024));
         dbMeta.put(hsqldb_defrag_limit,
-                   HsqlProperties.getMeta(hsqldb_defrag_limit, SQL_PROPERTY,
-                                          0, 0, 100));
+                   newMeta(hsqldb_defrag_limit, DB_PROP, 0, 0, 100));
         dbMeta.put(runtime_gc_interval,
-                   HsqlProperties.getMeta(runtime_gc_interval, SQL_PROPERTY,
-                                          0, 0, 1000000));
+                   newMeta(runtime_gc_interval, DB_PROP, 0, 0, 1000000));
         dbMeta.put(hsqldb_cache_size,
-                   HsqlProperties.getMeta(hsqldb_cache_size, SQL_PROPERTY,
-                                          10000, 100, 4 * 1024 * 1024));
+                   newMeta(hsqldb_cache_size, DB_PROP, 10000, 100,
+                           4 * 1024 * 1024));
         dbMeta.put(hsqldb_cache_rows,
-                   HsqlProperties.getMeta(hsqldb_cache_rows, SQL_PROPERTY,
-                                          50000, 100, 4 * 1024 * 1024));
+                   newMeta(hsqldb_cache_rows, DB_PROP, 50000, 100,
+                           4 * 1024 * 1024));
         dbMeta.put(hsqldb_cache_free_count,
-                   HsqlProperties.getMeta(hsqldb_cache_free_count,
-                                          SQL_PROPERTY, 512, 0, 4096));
+                   newMeta(hsqldb_cache_free_count, DB_PROP, 512, 0, 4096));
         dbMeta.put(hsqldb_result_max_memory_rows,
-                   HsqlProperties.getMeta(hsqldb_result_max_memory_rows,
-                                          SQL_PROPERTY, 0, 0,
-                                          4 * 1024 * 1024));
+                   newMeta(hsqldb_result_max_memory_rows, DB_PROP, 0, 0,
+                           4 * 1024 * 1024));
         dbMeta.put(hsqldb_nio_max_size,
-                   HsqlProperties.getMeta(hsqldb_nio_max_size, SQL_PROPERTY,
-                                          256, 64, 262144));
+                   newMeta(hsqldb_nio_max_size, DB_PROP, 256, 64, 262144));
         dbMeta.put(hsqldb_min_reuse,
-                   HsqlProperties.getMeta(hsqldb_min_reuse, SQL_PROPERTY, 0,
-                                          0, 1024 * 1024));
+                   newMeta(hsqldb_min_reuse, DB_PROP, 0, 0, 1024 * 1024));
     }
 
     private Database database;
 
     public HsqlDatabaseProperties(Database db) {
 
-        super(dbMeta, db.getPath(), db.logger.getFileAccess(),
-              db.isFilesInJar());
+        super(db.getPath(), db.logger.getFileAccess(), db.isFilesInJar());
 
         database = db;
 
@@ -660,8 +613,8 @@ public class HsqlDatabaseProperties exte
         }
 
         try {
-            HsqlProperties props = new HsqlProperties(dbMeta,
-                database.getPath(), database.logger.getFileAccess(), false);
+            HsqlProperties props = new HsqlProperties(database.getPath(),
+                database.logger.getFileAccess(), false);
 
             if (getIntegerProperty(hsqldb_script_format) == 3) {
                 props.setProperty(hsqldb_script_format, 3);
@@ -674,7 +627,7 @@ public class HsqlDatabaseProperties exte
             props.setProperty(hsqldb_modified, getProperty(hsqldb_modified));
             props.save(fileName + ".properties" + ".new");
             fa.renameElementOrCopy(fileName + ".properties" + ".new",
-                                   fileName + ".properties");
+                                   fileName + ".properties", database.logger);
         } catch (Throwable t) {
             database.logger.logSevereEvent("save failed", t);
 
@@ -727,20 +680,19 @@ public class HsqlDatabaseProperties exte
         strict = p.isPropertyTrue(url_check_props, false);
 
         for (Enumeration e = p.propertyNames(); e.hasMoreElements(); ) {
-            String   propertyName  = (String) e.nextElement();
-            String   propertyValue = p.getProperty(propertyName);
-            boolean  valid         = false;
-            boolean  validVal      = false;
-            String   error         = null;
-            Object[] meta          = (Object[]) dbMeta.get(propertyName);
-
-            if (meta != null
-                    && ((Integer) meta[HsqlProperties.indexType]).intValue()
-                       == SQL_PROPERTY) {
-                valid = true;
-                error = HsqlProperties.validateProperty(propertyName,
-                        propertyValue, meta);
-                validVal = error == null;
+            String       propertyName  = (String) e.nextElement();
+            String       propertyValue = p.getProperty(propertyName);
+            boolean      valid         = false;
+            boolean      validVal      = false;
+            String       error         = null;
+            PropertyMeta meta          = dbMeta.get(propertyName);
+
+            if (meta != null) {
+                if (meta.propType == DB_PROP || meta.propType == SQL_PROP) {
+                    valid = true;
+                    error = validateProperty(propertyName, propertyValue, meta);
+                    validVal = error == null;
+                }
             }
 
             if (propertyName.startsWith("sql.")
@@ -757,74 +709,69 @@ public class HsqlDatabaseProperties exte
         }
 
         for (Enumeration e = p.propertyNames(); e.hasMoreElements(); ) {
-            String   propertyName = (String) e.nextElement();
-            Object[] meta         = (Object[]) dbMeta.get(propertyName);
+            String       propertyName = (String) e.nextElement();
+            PropertyMeta meta         = dbMeta.get(propertyName);
 
-            if (meta != null
-                    && ((Integer) meta[HsqlProperties.indexType]).intValue()
-                       == SQL_PROPERTY) {
-                setDatabaseProperty(propertyName, p.getProperty(propertyName));
+            if (meta != null) {
+                if (meta.propType == DB_PROP || meta.propType == SQL_PROP) {
+                    setDatabaseProperty(propertyName, p.getProperty(propertyName));
+                }
             }
         }
     }
 
-    public Set getUserDefinedPropertyData() {
+    public static Iterator<PropertyMeta> getUserDefinedProperties() {
 
-        Set      set = new HashSet();
-        Iterator it  = dbMeta.values().iterator();
+        return new Iterator() {
 
-        while (it.hasNext()) {
-            Object[] row = (Object[]) it.next();
+            Iterator<PropertyMeta> it = dbMeta.values().iterator();
+            PropertyMeta current;
+            boolean      b = filterToNext();
 
-            if (((Integer) row[HsqlProperties.indexType]).intValue()
-                    == SQL_PROPERTY) {
-                set.add(row);
+            public boolean hasNext() {
+                return current != null;
             }
-        }
 
-        return set;
-    }
+            public Object next() {
 
-    public boolean isUserDefinedProperty(String key) {
+                PropertyMeta value = current;
 
-        Object[] row = (Object[]) dbMeta.get(key);
+                filterToNext();
 
-        return row != null
-               && ((Integer) row[HsqlProperties.indexType]).intValue()
-                  == SQL_PROPERTY;
-    }
+                return value;
+            }
 
-    public boolean isBoolean(String key) {
+            public int nextInt() {
+                return 0;
+            }
 
-        Object[] row = (Object[]) dbMeta.get(key);
+            public long nextLong() {
+                return 0L;
+            }
 
-        return row != null && row[HsqlProperties.indexClass].equals("Boolean")
-               && ((Integer) row[HsqlProperties.indexType]).intValue()
-                  == SQL_PROPERTY;
-    }
+            public void remove() {}
 
-    public boolean isIntegral(String key) {
+            private boolean filterToNext() {
 
-        Object[] row = (Object[]) dbMeta.get(key);
+                while (it.hasNext()) {
+                    current = it.next();
 
-        return row != null && row[HsqlProperties.indexClass].equals("Integer")
-               && ((Integer) row[HsqlProperties.indexType]).intValue()
-                  == SQL_PROPERTY;
-    }
-
-    public boolean isString(String key) {
+                    if (!excludedMeta.contains(current.propName)) {
+                        return true;
+                    }
+                }
 
-        Object[] row = (Object[]) dbMeta.get(key);
+                current = null;
 
-        return row != null && row[HsqlProperties.indexClass].equals("String")
-               && ((Integer) row[HsqlProperties.indexType]).intValue()
-                  == SQL_PROPERTY;
+                return false;
+            }
+        };
     }
 
     public boolean setDatabaseProperty(String key, String value) {
 
-        Object[] meta  = (Object[]) dbMeta.get(key);
-        String   error = HsqlProperties.validateProperty(key, value, meta);
+        PropertyMeta meta  = dbMeta.get(key);
+        String       error = validateProperty(key, value, meta);
 
         if (error != null) {
             return false;
@@ -890,63 +837,28 @@ public class HsqlDatabaseProperties exte
 //-----------------------
     public String getProperty(String key) {
 
-        Object[] metaData = (Object[]) dbMeta.get(key);
+        PropertyMeta meta = dbMeta.get(key);
 
-        if (metaData == null) {
+        if (meta == null) {
             throw Error.error(ErrorCode.X_42555, key);
         }
 
         return stringProps.getProperty(key);
     }
 
-    /** for all types of property apart from system props */
-    public String getPropertyString(String key) {
-
-        Object[] metaData = (Object[]) dbMeta.get(key);
-
-        if (metaData == null) {
-            throw Error.error(ErrorCode.X_42555, key);
-        }
-
-        String prop = stringProps.getProperty(key);
-        boolean isSystem =
-            ((Integer) metaData[HsqlProperties.indexType]).intValue()
-            == SYSTEM_PROPERTY;
-
-        if (prop == null && isSystem) {
-            try {
-                prop = System.getProperty(key);
-            } catch (SecurityException e) {}
-        }
-
-        if (prop == null) {
-            Object value = metaData[HsqlProperties.indexDefaultValue];
-
-            if (value == null) {
-                return null;
-            }
-
-            return String.valueOf(value);
-        }
-
-        return prop;
-    }
-
     public boolean isPropertyTrue(String key) {
 
-        Boolean  value;
-        Object[] metaData = (Object[]) dbMeta.get(key);
+        Boolean      value;
+        PropertyMeta meta = dbMeta.get(key);
 
-        if (metaData == null) {
+        if (meta == null) {
             throw Error.error(ErrorCode.X_42555, key);
         }
 
-        value = (Boolean) metaData[HsqlProperties.indexDefaultValue];
+        value = (Boolean) meta.propDefaultValue;
 
-        String prop = null;
-        boolean isSystem =
-            ((Integer) metaData[HsqlProperties.indexType]).intValue()
-            == SYSTEM_PROPERTY;
+        String  prop     = null;
+        boolean isSystem = meta.propType == SYSTEM_PROP;
 
         if (isSystem) {
             try {
@@ -963,27 +875,27 @@ public class HsqlDatabaseProperties exte
         return value.booleanValue();
     }
 
-    public String getStringPropertyDefault(String key) {
+    public static String getStringPropertyDefault(String key) {
 
-        Object[] metaData = (Object[]) dbMeta.get(key);
+        PropertyMeta meta = dbMeta.get(key);
 
-        if (metaData == null) {
+        if (meta == null) {
             throw Error.error(ErrorCode.X_42555, key);
         }
 
-        return (String) metaData[HsqlProperties.indexDefaultValue];
+        return (String) meta.propDefaultValue;
     }
 
     public String getStringProperty(String key) {
 
-        String   value;
-        Object[] metaData = (Object[]) dbMeta.get(key);
+        String       value;
+        PropertyMeta meta = dbMeta.get(key);
 
-        if (metaData == null) {
+        if (meta == null) {
             throw Error.error(ErrorCode.X_42555, key);
         }
 
-        value = (String) metaData[HsqlProperties.indexDefaultValue];
+        value = (String) meta.propDefaultValue;
 
         String prop = stringProps.getProperty(key);
 
@@ -996,15 +908,14 @@ public class HsqlDatabaseProperties exte
 
     public int getIntegerProperty(String key) {
 
-        int      value;
-        Object[] metaData = (Object[]) dbMeta.get(key);
+        int          value;
+        PropertyMeta meta = dbMeta.get(key);
 
-        if (metaData == null) {
+        if (meta == null) {
             throw Error.error(ErrorCode.X_42555, key);
         }
 
-        value =
-            ((Integer) metaData[HsqlProperties.indexDefaultValue]).intValue();
+        value = ((Integer) meta.propDefaultValue).intValue();
 
         String prop = stringProps.getProperty(key);
 
@@ -1017,8 +928,90 @@ public class HsqlDatabaseProperties exte
         return value;
     }
 
-    public static Iterator getPropertiesMetaIterator() {
-        return dbMeta.values().iterator();
+    public static PropertyMeta getMeta(String key) {
+        return dbMeta.get(key);
+    }
+
+    public static int getIntegerPropertyDefault(String key) {
+
+        int          value;
+        PropertyMeta meta = dbMeta.get(key);
+
+        if (meta == null) {
+            throw Error.error(ErrorCode.X_42555, key);
+        }
+
+        value = ((Integer) meta.propDefaultValue).intValue();
+
+        return value;
+    }
+
+    public static int getPropertyWithinRange(String name, int number) {
+
+        PropertyMeta meta = dbMeta.get(name);
+
+        if (meta == null) {
+            return number;
+        }
+
+        if (meta.propClass.equals("Integer")) {
+            if (meta.propIsRange) {
+                int low  = meta.propRangeLow;
+                int high = meta.propRangeHigh;
+
+                if (number < low) {
+                    return low;
+                } else if (high < number) {
+                    return high;
+                }
+            }
+
+            if (meta.propValues != null) {
+                int[] values = meta.propValues;
+
+                if (ArrayUtil.find(values, number) == -1) {
+                    return values[0];
+                }
+            }
+        }
+
+        return number;
+    }
+
+    public static boolean validateProperty(String name, int number) {
+
+        PropertyMeta meta = dbMeta.get(name);
+
+        if (meta == null) {
+            return false;
+        }
+
+        if (meta.propClass.equals("Integer")) {
+            if (meta.propIsRange) {
+                int low  = meta.propRangeLow;
+                int high = meta.propRangeHigh;
+
+                if (number < low || high < number) {
+                    return false;
+                }
+            }
+
+            if (meta.propValues != null) {
+                int[] values = meta.propValues;
+
+                if (ArrayUtil.find(values, number) == -1) {
+                    return false;
+                }
+            }
+
+            return true;
+        }
+
+        return false;
+    }
+
+    public static Iterator<PropertyMeta> getUrlUserConnectionProperties() {
+        return urlUserConnMeta.values().iterator();
     }
 
     public String getClientPropertiesAsString() {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/persist/HsqlProperties.java 2.7.0-1/hsqldb/src/org/hsqldb/persist/HsqlProperties.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/persist/HsqlProperties.java	2021-01-03 20:54:56.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/persist/HsqlProperties.java	2022-03-31 20:44:58.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -44,7 +44,6 @@ import org.hsqldb.error.ErrorCode;
 import org.hsqldb.lib.ArrayUtil;
 import org.hsqldb.lib.FileAccess;
 import org.hsqldb.lib.FileUtil;
-import org.hsqldb.lib.HashMap;
 import org.hsqldb.map.ValuePool;
 
 /**
@@ -52,7 +51,7 @@ import org.hsqldb.map.ValuePool;
  * allow saving and loading.<p>
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.5.1
+ * @version 2.7.0
  * @since 1.7.0
  */
 public class HsqlProperties {
@@ -66,7 +65,6 @@ public class HsqlProperties {
     protected int[]         errorCodes = ValuePool.emptyIntArray;
     protected String[]      errorKeys  = ValuePool.emptyStringArray;
     protected FileAccess    fa;
-    protected HashMap       metaData;
 
     public HsqlProperties() {
         stringProps = new Properties();
@@ -85,14 +83,12 @@ public class HsqlProperties {
         fa                 = FileUtil.getFileUtil();
     }
 
-    public HsqlProperties(HashMap meta, String fileName, FileAccess accessor,
-                          boolean b) {
+    public HsqlProperties(String fileName, FileAccess accessor, boolean b) {
 
         stringProps        = new Properties();
         this.fileName      = fileName;
         this.fileExtension = ".properties";
         fa                 = accessor;
-        metaData           = meta;
     }
 
     public HsqlProperties(Properties props) {
@@ -263,7 +259,7 @@ public class HsqlProperties {
         fa.createParentDirs(fileString);
         fa.removeElement(fileString);
 
-        OutputStream fos = fa.openOutputStreamElement(fileString);
+        OutputStream        fos = fa.openOutputStreamElement(fileString);
         FileAccess.FileSync outDescriptor = fa.getFileSync(fos);
         String name = HsqlDatabaseProperties.PRODUCT_NAME + " "
                       + HsqlDatabaseProperties.THIS_FULL_VERSION;
@@ -405,93 +401,84 @@ public class HsqlProperties {
 
     public void validate() {}
 
-    // column number mappings
-    public static final int indexName         = 0;
-    public static final int indexType         = 1;
-    public static final int indexClass        = 2;
-    public static final int indexIsRange      = 3;
-    public static final int indexDefaultValue = 4;
-    public static final int indexRangeLow     = 5;
-    public static final int indexRangeHigh    = 6;
-    public static final int indexValues       = 7;
-    public static final int indexLimit        = 9;
+    public static PropertyMeta newMeta(String name, int type,
+                                       long defaultVal) {
 
-    public static Object[] getMeta(String name, int type) {
+        PropertyMeta meta = new PropertyMeta();
 
-        Object[] row = new Object[indexLimit];
+        meta.propName         = name;
+        meta.propType         = type;
+        meta.propClass        = "Long";
+        meta.propDefaultValue = Long.valueOf(defaultVal);
 
-        row[indexName]         = name;
-        row[indexType]         = ValuePool.getInt(type);
-        row[indexClass]        = "Long";
-        row[indexDefaultValue] = Long.valueOf(0);
-
-        return row;
+        return meta;
     }
 
-    public static Object[] getMeta(String name, int type,
-                                   String defaultValue) {
+    public static PropertyMeta newMeta(String name, int type,
+                                       String defaultValue) {
 
-        Object[] row = new Object[indexLimit];
+        PropertyMeta meta = new PropertyMeta();
 
-        row[indexName]         = name;
-        row[indexType]         = ValuePool.getInt(type);
-        row[indexClass]        = "String";
-        row[indexDefaultValue] = defaultValue;
+        meta.propName         = name;
+        meta.propType         = type;
+        meta.propClass        = "String";
+        meta.propDefaultValue = defaultValue;
 
-        return row;
+        return meta;
     }
 
-    public static Object[] getMeta(String name, int type,
-                                   boolean defaultValue) {
+    public static PropertyMeta newMeta(String name, int type,
+                                       boolean defaultValue) {
 
-        Object[] row = new Object[indexLimit];
+        PropertyMeta meta = new PropertyMeta();
 
-        row[indexName]         = name;
-        row[indexType]         = ValuePool.getInt(type);
-        row[indexClass]        = "Boolean";
-        row[indexDefaultValue] = defaultValue ? Boolean.TRUE
-                                              : Boolean.FALSE;
+        meta.propName         = name;
+        meta.propType         = type;
+        meta.propClass        = "Boolean";
+        meta.propDefaultValue = defaultValue ? Boolean.TRUE
+                                             : Boolean.FALSE;
 
-        return row;
+        return meta;
     }
 
-    public static Object[] getMeta(String name, int type, int defaultValue,
-                                   int[] values) {
+    public static PropertyMeta newMeta(String name, int type,
+                                       int defaultValue, int[] values) {
 
-        Object[] row = new Object[indexLimit];
+        PropertyMeta meta = new PropertyMeta();
 
-        row[indexName]         = name;
-        row[indexType]         = ValuePool.getInt(type);
-        row[indexClass]        = "Integer";
-        row[indexDefaultValue] = ValuePool.getInt(defaultValue);
-        row[indexValues]       = values;
+        meta.propName         = name;
+        meta.propType         = type;
+        meta.propClass        = "Integer";
+        meta.propDefaultValue = ValuePool.getInt(defaultValue);
+        meta.propValues       = values;
 
-        return row;
+        return meta;
     }
 
-    public static Object[] getMeta(String name, int type, int defaultValue,
-                                   int rangeLow, int rangeHigh) {
+    public static PropertyMeta newMeta(String name, int type,
+                                       int defaultValue, int rangeLow,
+                                       int rangeHigh) {
 
-        Object[] row = new Object[indexLimit];
+        PropertyMeta meta = new PropertyMeta();
 
-        row[indexName]         = name;
-        row[indexType]         = ValuePool.getInt(type);
-        row[indexClass]        = "Integer";
-        row[indexDefaultValue] = ValuePool.getInt(defaultValue);
-        row[indexIsRange]      = Boolean.TRUE;
-        row[indexRangeLow]     = ValuePool.getInt(rangeLow);
-        row[indexRangeHigh]    = ValuePool.getInt(rangeHigh);
+        meta.propName         = name;
+        meta.propType         = type;
+        meta.propClass        = "Integer";
+        meta.propDefaultValue = ValuePool.getInt(defaultValue);
+        meta.propIsRange      = true;
+        meta.propRangeLow     = rangeLow;
+        meta.propRangeHigh    = rangeHigh;
 
-        return row;
+        return meta;
     }
 
     /**
      * Performs any range checking for property and return an error message
      */
     public static String validateProperty(String key, String value,
-                                          Object[] meta) {
+                                          PropertyMeta meta) {
 
-        if (meta[indexClass].equals("Boolean")) {
+        if (meta.propClass.equals("Boolean")) {
             value = value.toLowerCase();
 
             if (value.equals("true") || value.equals("false")) {
@@ -501,29 +488,29 @@ public class HsqlProperties {
             return "invalid boolean value for property: " + key;
         }
 
-        if (meta[indexClass].equals("String")) {
+        if (meta.propClass.equals("String")) {
             return null;
         }
 
-        if (meta[indexClass].equals("Long")) {
+        if (meta.propClass.equals("Long")) {
             return null;
         }
 
-        if (meta[indexClass].equals("Integer")) {
+        if (meta.propClass.equals("Integer")) {
             try {
                 int number = Integer.parseInt(value);
 
-                if (Boolean.TRUE.equals(meta[indexIsRange])) {
-                    int low  = ((Integer) meta[indexRangeLow]).intValue();
-                    int high = ((Integer) meta[indexRangeHigh]).intValue();
+                if (meta.propIsRange) {
+                    int low  = meta.propRangeLow;
+                    int high = meta.propRangeHigh;
 
                     if (number < low || high < number) {
                         return "value outside range for property: " + key;
                     }
                 }
 
-                if (meta[indexValues] != null) {
-                    int[] values = (int[]) meta[indexValues];
+                if (meta.propValues != null) {
+                    int[] values = meta.propValues;
 
                     if (ArrayUtil.find(values, number) == -1) {
                         return "value not supported for property: " + key;
@@ -539,70 +526,6 @@ public class HsqlProperties {
         return null;
     }
 
-    public int getPropertyWithinRange(String name, int number) {
-
-        Object[] meta = (Object[]) metaData.get(name);
-
-        if (meta == null) {
-            return number;
-        }
-
-        if (meta[indexClass].equals("Integer")) {
-            if (Boolean.TRUE.equals(meta[indexIsRange])) {
-                int low  = ((Integer) meta[indexRangeLow]).intValue();
-                int high = ((Integer) meta[indexRangeHigh]).intValue();
-
-                if (number < low) {
-                    return low;
-                } else if (high < number) {
-                    return high;
-                }
-            }
-
-            if (meta[indexValues] != null) {
-                int[] values = (int[]) meta[indexValues];
-
-                if (ArrayUtil.find(values, number) == -1) {
-                    return values[0];
-                }
-            }
-        }
-
-        return number;
-    }
-
-    public boolean validateProperty(String name, int number) {
-
-        Object[] meta = (Object[]) metaData.get(name);
-
-        if (meta == null) {
-            return false;
-        }
-
-        if (meta[indexClass].equals("Integer")) {
-            if (Boolean.TRUE.equals(meta[indexIsRange])) {
-                int low  = ((Integer) meta[indexRangeLow]).intValue();
-                int high = ((Integer) meta[indexRangeHigh]).intValue();
-
-                if (number < low || high < number) {
-                    return false;
-                }
-            }
-
-            if (meta[indexValues] != null) {
-                int[] values = (int[]) meta[indexValues];
-
-                if (ArrayUtil.find(values, number) == -1) {
-                    return false;
-                }
-            }
-
-            return true;
-        }
-
-        return false;
-    }
-
     public String toString() {
 
         StringBuilder sb = new StringBuilder();
@@ -634,4 +557,16 @@ public class HsqlProperties {
 
         return sb.toString();
     }
+
+    public static class PropertyMeta {
+
+        public String  propName;
+        public int     propType;
+        public String  propClass;
+        public boolean propIsRange;
+        public Object  propDefaultValue;
+        public int     propRangeLow;
+        public int     propRangeHigh;
+        public int[]   propValues;
+    }
 }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/persist/LobManager.java 2.7.0-1/hsqldb/src/org/hsqldb/persist/LobManager.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/persist/LobManager.java	2021-03-19 12:06:52.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/persist/LobManager.java	2022-07-13 15:38:30.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -42,7 +42,6 @@ import java.util.zip.Deflater;
 import java.util.zip.Inflater;
 
 import org.hsqldb.Database;
-import org.hsqldb.DatabaseType;
 import org.hsqldb.HsqlException;
 import org.hsqldb.Session;
 import org.hsqldb.SessionInterface;
@@ -68,7 +67,7 @@ import org.hsqldb.types.Types;
 
 /**
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class LobManager {
@@ -451,9 +450,7 @@ public class LobManager {
                 return null;
             }
 
-            BlobData blob = new BlobDataID(lobID);
-
-            return blob;
+            return new BlobDataID(lobID);
         } finally {
             writeLock.unlock();
         }
@@ -470,9 +467,7 @@ public class LobManager {
                 return null;
             }
 
-            ClobData clob = new ClobDataID(lobID);
-
-            return clob;
+            return new ClobDataID(lobID);
         } finally {
             writeLock.unlock();
         }
@@ -564,9 +559,9 @@ public class LobManager {
                 return Result.updateZeroResult;
             }
 
-            long           limitLobID = Long.MAX_VALUE;
+            long           limitLobID  = Long.MAX_VALUE;
             ResultMetaData meta = deleteUnusedLobs.getParametersMetaData();
-            Object[]       params     = new Object[meta.getColumnCount()];
+            Object[]       params      = new Object[meta.getColumnCount()];
             int            deleteCount = 0;
 
             params[0] = Long.valueOf(limitLobID);
@@ -1200,8 +1195,7 @@ public class LobManager {
 
         try {
             if (compressLobs || cryptLobs) {
-                result = getBytesCompressed(lobID, offset * 2, length * 2,
-                                            true);
+                result = getBytesCompressed(lobID, offset * 2, length * 2);
             } else {
                 result = getBytesNormal(lobID, offset * 2, length * 2);
             }
@@ -1225,7 +1219,7 @@ public class LobManager {
 
         try {
             if (compressLobs || cryptLobs) {
-                return getBytesCompressed(lobID, offset, length, false);
+                return getBytesCompressed(lobID, offset, length);
             } else {
                 return getBytesNormal(lobID, offset, length);
             }
@@ -1330,7 +1324,7 @@ public class LobManager {
     }
 
     private Result setBytesBA(long lobID, long offset, byte[] dataBytes,
-                              int dataLength, boolean isClob) {
+                              int dataLength) {
 
         if (dataLength == 0) {
             return ResultLob.newLobSetResponse(lobID, 0);
@@ -1341,7 +1335,7 @@ public class LobManager {
         try {
             if (compressLobs || cryptLobs) {
                 return setBytesBACompressed(lobID, offset, dataBytes,
-                                            dataLength, isClob);
+                                            dataLength);
             } else {
                 return setBytesBANormal(lobID, offset, dataBytes, dataLength);
             }
@@ -1438,14 +1432,14 @@ public class LobManager {
     }
 
     private Result setBytesIS(long lobID, InputStream inputStream,
-                              long length, boolean isClob) {
+                              long offset, long length) {
 
         if (length == 0) {
             return ResultLob.newLobSetResponse(lobID, 0);
         }
 
         if (compressLobs || cryptLobs) {
-            return setBytesISCompressed(lobID, inputStream, length, isClob);
+            return setBytesISCompressed(lobID, inputStream, offset, length);
         } else {
             return setBytesISNormal(lobID, inputStream, length);
         }
@@ -1543,8 +1537,7 @@ public class LobManager {
                 return ResultLob.newLobSetResponse(lobID, length);
             }
 
-            Result result = setBytesBA(lobID, offset, dataBytes, dataLength,
-                                       false);
+            Result result = setBytesBA(lobID, offset, dataBytes, dataLength);
 
             if (result.isError()) {
                 return result;
@@ -1568,7 +1561,7 @@ public class LobManager {
     /**
      * for new blob only
      *
-     * blob length is set to inputStream size (not given length)
+     * blob length is set to inputStream size (not given length which could be incorrect)
      */
     public Result setBytesForNewBlob(long lobID, InputStream inputStream,
                                      long length) {
@@ -1581,7 +1574,7 @@ public class LobManager {
         writeLock.lock();
 
         try {
-            Result result = setBytesIS(lobID, inputStream, length, false);
+            Result result       = setBytesIS(lobID, inputStream, 0L, length);
             Result actionResult = Result.updateZeroResult;
 
             if (result.isError()) {
@@ -1631,7 +1624,7 @@ public class LobManager {
 
             byte[] bytes = ArrayUtil.charArrayToBytes(chars, dataLength);
             Result result = setBytesBA(lobID, offset * 2, bytes,
-                                       dataLength * 2, true);
+                                       dataLength * 2);
 
             if (result.isError()) {
                 return result;
@@ -1662,7 +1655,7 @@ public class LobManager {
         writeLock.lock();
 
         try {
-            Result result = setBytesIS(lobID, inputStream, length * 2, false);
+            Result result = setBytesIS(lobID, inputStream, 0L, length * 2);
 
             if (result.isError()) {
                 return result;
@@ -1712,7 +1705,7 @@ public class LobManager {
             params[DELETE_BLOCKS.BLOCK_OFFSET] = Integer.valueOf(blockOffset);
             params[DELETE_BLOCKS.BLOCK_LIMIT]  = ValuePool.INTEGER_MAX;
             params[DELETE_BLOCKS.TX_ID] =
-                ValuePool.getLong(sysLobSession.getTransactionTimestamp());
+                ValuePool.getLong(sysLobSession.getTransactionSCN());
 
             Result result =
                 sysLobSession.executeCompiledStatement(deleteLobPartCall,
@@ -1811,7 +1804,7 @@ public class LobManager {
         params[DELETE_BLOCKS.BLOCK_OFFSET] = ValuePool.getInt(offset);
         params[DELETE_BLOCKS.BLOCK_LIMIT]  = ValuePool.getInt(limit);
         params[DELETE_BLOCKS.TX_ID] =
-            ValuePool.getLong(sysLobSession.getTransactionTimestamp());
+            ValuePool.getLong(sysLobSession.getTransactionSCN());
 
         Result result =
             sysLobSession.executeCompiledStatement(deleteLobPartCall, params,
@@ -1978,7 +1971,7 @@ public class LobManager {
         return blocks;
     }
 
-    private void inflate(byte[] data, int length, boolean isClob) {
+    private void inflate(byte[] data, int length) {
 
         if (cryptLobs) {
             length = database.logger.getCrypto().decode(data, 0, length, data,
@@ -2004,7 +1997,7 @@ public class LobManager {
         }
     }
 
-    private int deflate(byte[] data, int offset, int length, boolean isClob) {
+    private int deflate(byte[] data, int offset, int length) {
 
         deflater.setInput(data, offset, length);
         deflater.finish();
@@ -2036,7 +2029,7 @@ public class LobManager {
         for (int i = 0; i < aParts.length && i < bParts.length; i++) {
             int aPartLength = (int) aParts[i][ALLOC_PART.PART_LENGTH];
 
-            getPartBytesCompressedInBuffer(aID, aParts[i], false);
+            getPartBytesCompressedInBuffer(aID, aParts[i]);
 
             byte[] aPartBytes = new byte[aPartLength];
 
@@ -2044,7 +2037,7 @@ public class LobManager {
 
             int bPartLength = (int) bParts[i][ALLOC_PART.PART_LENGTH];
 
-            getPartBytesCompressedInBuffer(aID, bParts[i], false);
+            getPartBytesCompressedInBuffer(aID, bParts[i]);
 
             int result = ArrayUtil.compare(aPartBytes, 0, aPartLength,
                                            byteBuffer, 0, bPartLength);
@@ -2071,13 +2064,13 @@ public class LobManager {
         for (int i = 0; i < aParts.length && i < bParts.length; i++) {
             int aPartLength = (int) aParts[i][ALLOC_PART.PART_LENGTH];
 
-            getPartBytesCompressedInBuffer(aID, aParts[i], true);
+            getPartBytesCompressedInBuffer(aID, aParts[i]);
 
             String aString = new String(ArrayUtil.byteArrayToChars(dataBuffer,
                 aPartLength));
             int bPartLength = (int) bParts[i][ALLOC_PART.PART_LENGTH];
 
-            getPartBytesCompressedInBuffer(bID, bParts[i], true);
+            getPartBytesCompressedInBuffer(bID, bParts[i]);
 
             String bString = new String(ArrayUtil.byteArrayToChars(dataBuffer,
                 bPartLength));
@@ -2097,7 +2090,7 @@ public class LobManager {
     }
 
     private Result setBytesISCompressed(long lobID, InputStream inputStream,
-                                        long length, boolean isClob) {
+                                        long baseOffset, long length) {
 
         long   offset     = 0;
         byte[] tempBuffer = new byte[largeLobBlockSize];
@@ -2131,14 +2124,15 @@ public class LobManager {
                 return Result.newErrorResult(e);
             }
 
-            Result result = setBytesBACompressedPart(lobID, offset,
-                tempBuffer, count, isClob);
+            Result result = setBytesBACompressedPart(lobID, baseOffset,
+                tempBuffer, count);
 
             if (result.isError()) {
                 return result;
             }
 
-            offset += count;
+            offset     += count;
+            baseOffset += count;
 
             if (offset == length) {
                 break;
@@ -2151,8 +2145,7 @@ public class LobManager {
     }
 
     private Result setBytesBACompressed(long lobID, long offset,
-                                        byte[] dataBytes, int dataLength,
-                                        boolean isClob) {
+                                        byte[] dataBytes, int dataLength) {
 
         if (dataLength == 0) {
             return ResultLob.newLobSetResponse(lobID, 0);
@@ -2160,20 +2153,20 @@ public class LobManager {
 
         if (dataLength <= largeLobBlockSize) {
             return setBytesBACompressedPart(lobID, offset, dataBytes,
-                                            dataLength, isClob);
+                                            dataLength);
         }
 
         HsqlByteArrayInputStream is = new HsqlByteArrayInputStream(dataBytes,
             0, dataLength);
 
-        return setBytesISCompressed(lobID, is, dataLength, isClob);
+        return setBytesISCompressed(lobID, is, offset, dataLength);
     }
 
     /**
      * Only for loading parts of the same lob, not for overwriting parts of existing lob
      */
     private Result setBytesBACompressedPart(long lobID, long offset,
-            byte[] dataBytes, int dataLength, boolean isClob) {
+            byte[] dataBytes, int dataLength) {
 
         // get block offset after existing blocks and compressed block
         long[] lastPart = getLastPart(lobID);
@@ -2189,7 +2182,7 @@ public class LobManager {
                     "compressed lobs"));
         }
 
-        int byteLength = deflate(dataBytes, 0, dataLength, isClob);
+        int byteLength = deflate(dataBytes, 0, dataLength);
         int blockCount = (byteLength + lobBlockSize - 1) / lobBlockSize;
         Result result = createFullBlockAddresses(lobID, blockOffset,
             blockCount);
@@ -2216,8 +2209,7 @@ public class LobManager {
         return ResultLob.newLobSetResponse(lobID, dataLength);
     }
 
-    private Result getBytesCompressed(long lobID, long offset, int length,
-                                      boolean isClob) {
+    private Result getBytesCompressed(long lobID, long offset, int length) {
 
         byte[]   dataBytes = new byte[length];
         long[][] parts     = getParts(lobID, offset, offset + length);
@@ -2226,8 +2218,7 @@ public class LobManager {
             long[] part       = parts[i];
             long   partOffset = part[ALLOC_PART.PART_OFFSET];
             int    partLength = (int) part[ALLOC_PART.PART_LENGTH];
-            Result result = getPartBytesCompressedInBuffer(lobID, part,
-                isClob);
+            Result result     = getPartBytesCompressedInBuffer(lobID, part);
 
             if (result.isError()) {
                 return result;
@@ -2240,8 +2231,7 @@ public class LobManager {
         return ResultLob.newLobGetBytesResponse(lobID, offset, dataBytes);
     }
 
-    private Result getPartBytesCompressedInBuffer(long lobID, long[] part,
-            boolean isClob) {
+    private Result getPartBytesCompressedInBuffer(long lobID, long[] part) {
 
         long blockOffset     = part[ALLOC_PART.BLOCK_OFFSET];
         long partOffset      = part[ALLOC_PART.PART_OFFSET];
@@ -2257,7 +2247,7 @@ public class LobManager {
 
         byte[] byteBlock = ((ResultLob) result).getByteArray();
 
-        inflate(byteBlock, partBytesLength, isClob);
+        inflate(byteBlock, partBytesLength);
 
         return ResultLob.newLobSetResponse(lobID, partLength);
     }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/persist/LobStoreRAFile.java 2.7.0-1/hsqldb/src/org/hsqldb/persist/LobStoreRAFile.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/persist/LobStoreRAFile.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/persist/LobStoreRAFile.java	2022-07-07 16:32:28.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/persist/LockFile.java 2.7.0-1/hsqldb/src/org/hsqldb/persist/LockFile.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/persist/LockFile.java	2021-02-09 04:51:58.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/persist/LockFile.java	2022-06-07 13:22:52.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -50,7 +50,7 @@ import org.hsqldb.lib.StringConverter;
 
 /**
  * Base cooperative file locking implementation and {@code LockFile}
- * factory. <p>
+ * factory.
  *
  * <hr>
  *
@@ -65,43 +65,43 @@ import org.hsqldb.lib.StringConverter;
  * the contexts do not share a common parent class loader or do not implement
  * normal parent class loader delegation semantics. <p>
  *
- * <a name="note1"><sup>*</sup></a>
+ * <a><sup>*</sup></a>
  * The only purely in-process global discovery alternative known to the author
  * is to reflect upon objects found while traversing up the Java runtime thread
  * hierarchy.  However, this method is often subject to Java security
  * restrictions whose collective purpose is essentially dissimilar to that of
  * restrictions in effect relative to cooperative file locking requirements,
- * making it a generally unacceptable option in this context. <p>
+ * making it a generally unacceptable option in this context.
  *
  * <hr>
  *
- * Here is the way this class presently operates: <p>
+ * Here is the way this class presently operates:
  *
  * <ol style="list-style-type: upper-latin">
  *    <li>A file with a commonly agreed-upon path is used to implement
  *        cooperative locking semantics regarding another set of files with
- *        commonly agreed-upon paths.<p>
+ *        commonly agreed-upon paths.
  *
  *    <li>In particular, a background thread periodically writes a timestamp
  *        value, which acts as a heartbeat that indicates to others whether a
- *        cooperative lock condition is currently held.<p>
+ *        cooperative lock condition is currently held.
  *
  *    <li>In addition, a magic value is written so that it is possible to
  *        distinguish with a reasonably high degree of accuracy between the
- *        existence of a lock file and some other type of file.<p>
+ *        existence of a lock file and some other type of file.
  *
  *    <li>The generic rules used to acquire a cooperative lock condition are
- *        as follows:<p>
+ *        as follows:
  *
  *    <ol>
  *        <li>If a lock condition is already held by this object, do nothing and
- *            signify that the lock attempt was successful, else...<p>
+ *            signify that the lock attempt was successful, else...
  *
  *        <li>Poll the underlying file, using a configured maximum number of
  *            retries and a configured interval between the end of a failed
- *            poll and the beginning of the next.<p>
+ *            poll and the beginning of the next.
  *
- *        <li>For each poll:<p>
+ *        <li>For each poll:
  *
  *        <ol style="list-style-type: lower-roman">
  *
@@ -109,11 +109,11 @@ import org.hsqldb.lib.StringConverter;
  *                if it does not yet exist, exit the polling loop immediately
  *                indicating success if the attempt succeeds, else fast fail
  *                the current poll if a security exception is thrown in response
- *                to the attempt, else...<p>
+ *                to the attempt, else...
  *
  *            <li>Test if the underlying file exists, fast failing the current
  *                poll if it is impossible to determine (i.e. if a security
- *                exception is thrown).<p>
+ *                exception is thrown).
  *
  *            <li>If the file does not exist, exit the polling loop immediately
  *                indicating success.<p>
@@ -136,28 +136,28 @@ import org.hsqldb.lib.StringConverter;
  *                non-{@code LockFile} entity deleted the file, then there are
  *                much worse things to worry about, in particular that the files
  *                this object is supposed to protect are in reality subject to
- *                arbitrary external modification and deletion.<p>
+ *                arbitrary external modification and deletion.
  *
  *            <li>Test the file's length, fast failing the current poll if the
  *                length cannot be determined or it is not the expected
- *                value.<p>
+ *                value.
  *
  *            <li>Open a stream to read the file's {@code MAGIC} and heartbeat
  *                timestamp values, fast failing the current poll if the stream
- *                cannot be opened.<p>
+ *                cannot be opened.
  *
  *            <li>Test the file's {@code MAGIC} value, failing the current poll
  *                if the value cannot be read or it is not the expected
- *                value.<p>
+ *                value.
  *
  *            <li>Test the file's heartbeat timestamp value, fast failing the
  *                current poll if it cannot be read or it is less than a
  *                commonly agreed-upon value into the past (or future, to
- *                overcome a caveat observed by a patch contributor).<p>
+ *                overcome a caveat observed by a patch contributor).
  *        </ol>
  *        <li>If the polling phase exits with a failure indication, then one or
  *            more of the following cases must have been true at every poll
- *            iteration: <p>
+ *            iteration:
  *
  *            <ul>
  *               <li>The file had the wrong length or {@code MAGIC} value (was
@@ -182,16 +182,16 @@ import org.hsqldb.lib.StringConverter;
  *            </ul> <p>
  *
  *            In this case, signify failure indicating the last encountered
- *            reason, else...<p>
+ *            reason, else...
  *
  *        <li>Open the file for reading and writing, write the magic value and
  *            an initial heartbeat timestamp, schedule a periodic heartbeat
- *            timestamp writer task and signify success.<p>
+ *            timestamp writer task and signify success.
  *    </ol>
- *    <li>The generic rules used to release a cooperative lock condition are:<p>
+ *    <li>The generic rules used to release a cooperative lock condition are:
  *    <ol>
  *        <li>If a lock condition is not currently held, do nothing and signify
- *            success, else...<p>
+ *            success, else...
  *
  *        <li>A lock condition is currently held by this object, so try to
  *            release it. <p>
@@ -201,9 +201,9 @@ import org.hsqldb.lib.StringConverter;
  *            lock file, cancelling the periodic heartbeat timestamp writer
  *            task and deleting the lock file. If the release occurs without
  *            raising an exception, signify success, else signify that the
- *            release attempt <em>might</em> have failed. <p>
+ *            release attempt <em>might</em> have failed.
  *    </ol>
- * </ol> <p>
+ * </ol>
  *
  * <hr>
  *
@@ -314,7 +314,7 @@ import org.hsqldb.lib.StringConverter;
  * external security or operating constraints that may need to be imposed.<p>
  *
  * Alternate approaches that have been considered and rejected for now
- * include: <p>
+ * include:
  *
  * <ul>
  *    <li>Socket-based locks (with/without broadcast protocol)
@@ -638,7 +638,7 @@ public class LockFile {
         try {
             lockFile = LockFile.newLockFile(path + ".lck");
         } catch (LockFile.BaseException e) {
-            throw Error.error(ErrorCode.LOCK_FILE_ACQUISITION_FAILURE,
+            throw Error.error(e, ErrorCode.LOCK_FILE_ACQUISITION_FAILURE,
                               e.getMessage());
         }
 
@@ -647,7 +647,7 @@ public class LockFile {
         try {
             locked = lockFile.tryLock();
         } catch (LockFile.BaseException e) {
-            throw Error.error(ErrorCode.LOCK_FILE_ACQUISITION_FAILURE,
+            throw Error.error(e, ErrorCode.LOCK_FILE_ACQUISITION_FAILURE,
                               e.getMessage());
         }
 
@@ -668,7 +668,7 @@ public class LockFile {
      * whether its heartbeat timestamp is live (is, as far as can be known,
      * presumably in use by another {@code LockFile} instance) or stale. <p>
      *
-     * The check conforms to the following rules: <p>
+     * The check conforms to the following rules:
      *
      * <ol>
      * <li>If the parameter {@code withCreateNewFile} is true, {@link
@@ -676,7 +676,7 @@ public class LockFile {
      *     upon this object's {@code file} object indicates the underlying
      *     file was atomically created if and only if it did not yet exist,
      *     then return immediately (we have won the <em>race</em> to establish
-     *     a lock file). <p>
+     *     a lock file).
      *
      * <li>Test again if the file exists, returning immediately if it does not
      *     (there's no file and hence no heartbeat to check). <p>
@@ -699,7 +699,7 @@ public class LockFile {
      *     there are much worse things to worry about, in particular that the
      *     files this object is supposed to protect are in reality subject to
      *     arbitrary external modification and deletion by some uncooperative
-     *     process.<p>
+     *     process.
      *
      * <li>If a Java security exception is thrown while testing for existence,
      *     it is rethrown as a {@code FileSecurityException}.
@@ -907,7 +907,7 @@ public class LockFile {
      * and only if {@code tryLock()} successfully invokes
      * {@code pollHeartbeat()} and {@code openRAF()} first. <p>
      *
-     * From this, it can be inferred that upon entry: <p>
+     * From this, it can be inferred that upon entry:
      *
      * <ol>
      * <li>{@code locked == false}.
@@ -989,7 +989,7 @@ public class LockFile {
      * Initializes this object with a {@code File} object whose path has the
      * canonical form of the given {@code path} argument. <p>
      *
-     *  <b>PRE</b>:<p>
+     *  <b>PRE</b>:
      *
      * <ol>
      *    <li>This method is called once and <em>only</em> once per
@@ -1294,7 +1294,7 @@ public class LockFile {
      * only if it is not null, it is an instance of {@code LockFile} and
      * either it is the identical instance or it has the same lock file.  More
      * formally, is is considered equal if and only if it is not null, it is an
-     * instance of {@code LockFile}, and the expression: <p>
+     * instance of {@code LockFile}, and the expression:
      *
      * <pre>
      * this == other ||
@@ -1414,10 +1414,10 @@ public class LockFile {
      * Retrieves whether this object holds a valid lock condition on its
      * lock file. <p>
      *
-     * More formally, this method retrieves true if and only if: <p>
+     * More formally, this method retrieves true if and only if:
      *
      * <pre>
-     * isLocked() && file != null && file.exists() && raf != null
+     * {@code isLocked() && file != null && file.exists() && raf != null}
      * </pre>
      *
      * @return {@code true} if this object holds a valid lock condition on its
@@ -1433,7 +1433,7 @@ public class LockFile {
     /**
      * Retrieves a String representation of this object. <p>
      *
-     * The String is of the form: <p>
+     * The String is of the form:
      *
      * <pre>
      * super.toString() +
@@ -1480,7 +1480,7 @@ public class LockFile {
      * Retrieves the number of times {@code checkHeartbeat} may fail before
      * {@code pollHeartbeat} fails as a consequence. <p>
      *
-     * The value is obtained in the following manner: <p>
+     * The value is obtained in the following manner:
      *
      * <ol>
      * <li>retries is assigned {@code POLL_RETRIES_DEFAULT}.
@@ -1516,7 +1516,7 @@ public class LockFile {
      * Retrieves the interval, in milliseconds, that {@code pollHeartbeat}
      * waits between failed invocations of {@code checkHeartbeat}.
      *
-     * The value is obtained in the following manner: <p>
+     * The value is obtained in the following manner:
      *
      * <ol>
      * <li>interval is assigned {@code 10 + (HEARTBEAT_INTERVAL_PADDED
@@ -1895,7 +1895,7 @@ public class LockFile {
      * For internal use only. <p>
      *
      * This Runnable class provides the implementation for the timed task
-     * that periodically writes out a heartbeat timestamp to the lock file.<p>
+     * that periodically writes out a heartbeat timestamp to the lock file.
      */
     private final class HeartbeatRunner implements Runnable {
 
@@ -1910,7 +1910,7 @@ public class LockFile {
     }
 
     /**
-     * Base exception class for lock condition specific exceptions. <p>
+     * Base exception class for lock condition specific exceptions.
      *
      */
     public abstract static class BaseException extends Exception {
@@ -2033,7 +2033,7 @@ public class LockFile {
      * parent directories; or if its <code>{@link
      * java.lang.SecurityManager#checkWrite(java.lang.String)}</code>
      * method does not permit all necessary parent directories to be
-     * created. <p>
+     * created.
      *
      */
     public static final class FileSecurityException extends BaseException {
@@ -2083,7 +2083,7 @@ public class LockFile {
      *
      * Specifically, this exception is thrown when polling fails because the
      * lock file's heartbeat timestamp value indicates that another LockFile
-     * object still holds the lock condition. <p>
+     * object still holds the lock condition.
      *
      */
     public static final class LockHeldExternallyException
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/persist/Logger.java 2.7.0-1/hsqldb/src/org/hsqldb/persist/Logger.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/persist/Logger.java	2021-07-15 13:57:30.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/persist/Logger.java	2022-07-13 15:38:30.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -58,9 +58,11 @@ import org.hsqldb.index.Index;
 import org.hsqldb.index.IndexAVL;
 import org.hsqldb.index.IndexAVLMemory;
 import org.hsqldb.lib.ArrayUtil;
+import org.hsqldb.lib.EventLogInterface;
 import org.hsqldb.lib.FileAccess;
 import org.hsqldb.lib.FileUtil;
 import org.hsqldb.lib.FrameworkLogger;
+import org.hsqldb.lib.HashMap;
 import org.hsqldb.lib.HsqlArrayList;
 import org.hsqldb.lib.InputStreamInterface;
 import org.hsqldb.lib.InputStreamWrapper;
@@ -85,7 +87,7 @@ import org.hsqldb.types.Type;
  *  storage.<p>
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.1
+ * @version 2.7.0
  * @since 1.7.0
  */
 public class Logger implements EventLogInterface {
@@ -117,6 +119,7 @@ public class Logger implements EventLogI
     private int     propWriteDelay;
     private int     propLogSize;
     private boolean propLogData = true;
+    private int     propExternalEventLogLevel;
     private int     propEventLogLevel;
     int             propSqlLogLevel;
     int             propGC;
@@ -348,6 +351,13 @@ public class Logger implements EventLogI
         }
 
         level = database.urlProperties.getIntegerProperty(
+            HsqlDatabaseProperties.hsqldb_extlog, -1);
+
+        if (level >= 0) {
+            setExternalEventLogLevel(level);
+        }
+
+        level = database.urlProperties.getIntegerProperty(
             HsqlDatabaseProperties.hsqldb_sqllog, -1);
 
         if (level >= 0) {
@@ -511,8 +521,14 @@ public class Logger implements EventLogI
         database.sqlConvertTruncate =
             database.databaseProperties.isPropertyTrue(
                 HsqlDatabaseProperties.sql_convert_trunc);
+        database.sqlTruncateTrailing =
+            database.databaseProperties.isPropertyTrue(
+                HsqlDatabaseProperties.sql_trunc_trailing);
         database.sqlAvgScale = database.databaseProperties.getIntegerProperty(
             HsqlDatabaseProperties.sql_avg_scale);
+        database.sqlMaxRecursive =
+            database.databaseProperties.getIntegerProperty(
+                HsqlDatabaseProperties.sql_max_recursive);
         database.sqlDoubleNaN = database.databaseProperties.isPropertyTrue(
             HsqlDatabaseProperties.sql_double_nan);
         database.sqlLongvarIsLob = database.databaseProperties.isPropertyTrue(
@@ -542,6 +558,9 @@ public class Logger implements EventLogI
 
         propEventLogLevel = database.databaseProperties.getIntegerProperty(
             HsqlDatabaseProperties.hsqldb_applog);
+        propExternalEventLogLevel =
+            database.databaseProperties.getIntegerProperty(
+                HsqlDatabaseProperties.hsqldb_extlog);
         propSqlLogLevel = database.databaseProperties.getIntegerProperty(
             HsqlDatabaseProperties.hsqldb_sqllog);
 
@@ -576,13 +595,11 @@ public class Logger implements EventLogI
             database.databaseProperties.getIntegerProperty(
                 HsqlDatabaseProperties.hsqldb_cache_file_scale));
 
-        // linked with FILES SCALE
-        int fileSpace = database.databaseProperties.getIntegerProperty(
-            HsqlDatabaseProperties.hsqldb_files_space, 0);
+        // linked with above FILES SCALE
+        boolean fileSpace = database.databaseProperties.isPropertyTrue(
+            HsqlDatabaseProperties.hsqldb_files_space);
 
-        if (fileSpace != 0) {
-            setDataFileSpace(fileSpace);
-        }
+        setDataFileSpace(fileSpace);
 
         propDataFileDefragLimit =
             database.databaseProperties.getIntegerProperty(
@@ -762,22 +779,29 @@ public class Logger implements EventLogI
 
             sqlLog.setLevel(level);
         } else {
-            if (level > SimpleLog.LOG_DETAIL) {
-                level = SimpleLog.LOG_DETAIL;
-            }
-
             propEventLogLevel = level;
 
             appLog.setLevel(level);
         }
     }
 
+    public void setExternalEventLogLevel(int level) {
+
+        if (level < SimpleLog.LOG_NONE || level > SimpleLog.LOG_DETAIL) {
+            throw Error.error(ErrorCode.X_42556);
+        }
+
+        propExternalEventLogLevel = level;
+    }
+
     public void logSevereEvent(String message, Throwable t) {
 
         getEventLogger();
 
         if (fwLogger != null) {
-            fwLogger.severe(message, t);
+            if (propExternalEventLogLevel >= SimpleLog.LOG_ERROR) {
+                fwLogger.severe(message, t);
+            }
         }
 
         if (appLog != null) {
@@ -794,10 +818,12 @@ public class Logger implements EventLogI
         getEventLogger();
 
         if (fwLogger != null) {
-            fwLogger.warning(message, t);
+            if (propExternalEventLogLevel >= SimpleLog.LOG_WARNING) {
+                fwLogger.warning(message, t);
+            }
         }
 
-        appLog.logContext(t, message, SimpleLog.LOG_ERROR);
+        appLog.logContext(t, message, SimpleLog.LOG_WARNING);
     }
 
     public void logInfoEvent(String message) {
@@ -805,7 +831,9 @@ public class Logger implements EventLogI
         getEventLogger();
 
         if (fwLogger != null) {
-            fwLogger.info(message);
+            if (propExternalEventLogLevel >= SimpleLog.LOG_NORMAL) {
+                fwLogger.info(message);
+            }
         }
 
         appLog.logContext(SimpleLog.LOG_NORMAL, message);
@@ -816,7 +844,9 @@ public class Logger implements EventLogI
         getEventLogger();
 
         if (fwLogger != null) {
-            fwLogger.finest(message);
+            if (propExternalEventLogLevel >= SimpleLog.LOG_DETAIL) {
+                fwLogger.finest(message);
+            }
         }
 
         if (appLog != null) {
@@ -1015,7 +1045,7 @@ public class Logger implements EventLogI
             logInfoEvent("Checkpoint start");
             log.checkpoint(session, defrag);
             logInfoEvent("Checkpoint end - txts: "
-                         + database.txManager.getGlobalChangeTimestamp());
+                         + database.txManager.getSystemChangeNumber());
         }
     }
 
@@ -1137,7 +1167,7 @@ public class Logger implements EventLogI
         propDataFileScale = value;
 
         if (propDataFileSpace > 0) {
-            propDataFileSpace = propDataFileScale / 16;    // reduce if too large
+            propDataFileSpace = propDataFileScale / 16;    // change to default
         }
     }
 
@@ -1261,14 +1291,10 @@ public class Logger implements EventLogI
 
     public void setNioMaxSize(int value) {
 
-        if (value < 8) {
-            throw Error.error(ErrorCode.X_42556);
-        }
+        value = ArrayUtil.getTwoPowerFloor(value);
 
-        if (!ArrayUtil.isTwoPower(value, 10)) {
-            if (value < 1024 || value % 512 != 0) {
-                throw Error.error(ErrorCode.X_42556);
-            }
+        if (value < 64) {
+            value = 64;
         }
 
         propNioMaxSize = value * 1024L * 1024L;
@@ -1405,298 +1431,203 @@ public class Logger implements EventLogI
         throw Error.runtimeError(ErrorCode.U_S0500, "Logger");
     }
 
-    public String getValueStringForProperty(String name) {
-
-        String value = "";
-
-        if (HsqlDatabaseProperties.hsqldb_tx.equals(name)) {
-            switch (database.txManager.getTransactionControl()) {
-
-                case TransactionManager.MVCC :
-                    value = Tokens.T_MVCC.toLowerCase();
-                    break;
-
-                case TransactionManager.MVLOCKS :
-                    value = Tokens.T_MVLOCKS.toLowerCase();
-                    break;
-
-                case TransactionManager.LOCKS :
-                    value = Tokens.T_LOCKS.toLowerCase();
-                    break;
-            }
-
-            return value;
-        }
-
-        if (HsqlDatabaseProperties.hsqldb_tx_level.equals(name)) {
-            switch (database.defaultIsolationLevel) {
-
-                case SessionInterface.TX_READ_COMMITTED :
-                    value = new StringBuilder(Tokens.T_READ).append(
-                        ' ').append(
-                        Tokens.T_COMMITTED).toString().toLowerCase();
-                    break;
-
-                case SessionInterface.TX_SERIALIZABLE :
-                    value = Tokens.T_SERIALIZABLE.toLowerCase();
-                    break;
-            }
-
-            return value;
-        }
-
-        if (HsqlDatabaseProperties.hsqldb_applog.equals(name)) {
-            return String.valueOf(appLog.getLevel());
-        }
-
-        if (HsqlDatabaseProperties.hsqldb_sqllog.equals(name)) {
-            return String.valueOf(sqlLog.getLevel());
-        }
-
-        if (HsqlDatabaseProperties.hsqldb_lob_file_scale.equals(name)) {
-            return String.valueOf(propLobBlockSize / 1024);
-        }
-
-        if (HsqlDatabaseProperties.hsqldb_lob_file_compressed.equals(name)) {
-            return String.valueOf(propCompressLobs);
-        }
-
-        if (HsqlDatabaseProperties.hsqldb_cache_file_scale.equals(name)) {
-            return String.valueOf(propDataFileScale);
-        }
-
-        if (HsqlDatabaseProperties.hsqldb_cache_free_count.equals(name)) {
-            return String.valueOf(propMaxFreeBlocks);
-        }
-
-        if (HsqlDatabaseProperties.hsqldb_cache_rows.equals(name)) {
-            return String.valueOf(propCacheMaxRows);
-        }
-
-        if (HsqlDatabaseProperties.hsqldb_cache_size.equals(name)) {
-            return String.valueOf(propCacheMaxSize / 1024);
-        }
-
-        if (HsqlDatabaseProperties.hsqldb_default_table_type.equals(name)) {
-            return database.schemaManager.getDefaultTableType()
-                   == TableBase.CACHED_TABLE ? Tokens.T_CACHED
-                                             : Tokens.T_MEMORY;
-        }
-
-        if (HsqlDatabaseProperties.hsqldb_defrag_limit.equals(name)) {
-            return String.valueOf(propDataFileDefragLimit);
-        }
-
-        if (HsqlDatabaseProperties.hsqldb_files_space.equals(name)) {
-            return String.valueOf(propDataFileSpace);
-        }
-
-        if (HsqlDatabaseProperties.hsqldb_files_readonly.equals(name)) {
-            return database.databaseProperties.getPropertyString(
-                HsqlDatabaseProperties.hsqldb_files_readonly);
-        }
-
-        if (HsqlDatabaseProperties.hsqldb_large_data.equals(name)) {
-            return String.valueOf(propLargeData);
-        }
-
-        if (HsqlDatabaseProperties.hsqldb_lock_file.equals(name)) {
-            return database.databaseProperties.getPropertyString(
-                HsqlDatabaseProperties.hsqldb_lock_file);
-        }
-
-        if (HsqlDatabaseProperties.hsqldb_log_data.equals(name)) {
-            return String.valueOf(propLogData);
-        }
-
-        if (HsqlDatabaseProperties.hsqldb_log_size.equals(name)) {
-            return String.valueOf(propLogSize);
-        }
-
-        if (HsqlDatabaseProperties.hsqldb_nio_data_file.equals(name)) {
-            return String.valueOf(propNioDataFile);
-        }
-
-        if (HsqlDatabaseProperties.hsqldb_nio_max_size.equals(name)) {
-            return String.valueOf(propNioMaxSize / (1024 * 1024));
-        }
-
-        if (HsqlDatabaseProperties.hsqldb_script_format.equals(name)) {
-            return ScriptWriterBase.LIST_SCRIPT_FORMATS[propScriptFormat]
-                .toLowerCase();
-        }
-
-        if (HsqlDatabaseProperties.hsqldb_temp_directory.equals(name)) {
-            return tempDirectoryPath;
-        }
-
-        if (HsqlDatabaseProperties.hsqldb_tx_conflict_rollback.equals(name)) {
-            return String.valueOf(database.txConflictRollback);
-        }
-
-        if (HsqlDatabaseProperties.hsqldb_tx_interrupt_rollback.equals(name)) {
-            return String.valueOf(database.txInterruptRollback);
-        }
-
-        if (HsqlDatabaseProperties.hsqldb_result_max_memory_rows.equals(
-                name)) {
-            return String.valueOf(database.getResultMaxMemoryRows());
-        }
-
-        if (HsqlDatabaseProperties.hsqldb_write_delay.equals(name)) {
-            return String.valueOf(propWriteDelay != 0);
-        }
-
-        if (HsqlDatabaseProperties.hsqldb_write_delay_millis.equals(name)) {
-            return String.valueOf(propWriteDelay);
-        }
-
-        if (HsqlDatabaseProperties.hsqldb_digest.equals(name)) {
-            return database.granteeManager.getDigestAlgo();
-        }
-
-        if (HsqlDatabaseProperties.sql_restrict_exec.equals(name)) {
-            return String.valueOf(database.sqlRestrictExec);
-        }
-
-        if (HsqlDatabaseProperties.sql_avg_scale.equals(name)) {
-            return String.valueOf(database.sqlAvgScale);
-        }
-
-        if (HsqlDatabaseProperties.sql_char_literal.equals(name)) {
-            return String.valueOf(database.sqlCharLiteral);
-        }
-
-        if (HsqlDatabaseProperties.sql_concat_nulls.equals(name)) {
-            return String.valueOf(database.sqlConcatNulls);
-        }
-
-        if (HsqlDatabaseProperties.sql_convert_trunc.equals(name)) {
-            return String.valueOf(database.sqlConvertTruncate);
-        }
+    public HashMap getPropertyValueMap(Session session) {
 
-        if (HsqlDatabaseProperties.sql_double_nan.equals(name)) {
-            return String.valueOf(database.sqlDoubleNaN);
-        }
-
-        if (HsqlDatabaseProperties.sql_enforce_names.equals(name)) {
-            return String.valueOf(database.sqlEnforceNames);
-        }
+        HashMap map   = new HashMap();
+        String  value = null;
 
-        if (HsqlDatabaseProperties.sql_enforce_refs.equals(name)) {
-            return String.valueOf(database.sqlEnforceRefs);
-        }
+        map.put(HsqlDatabaseProperties.sql_avg_scale,
+                String.valueOf(database.sqlAvgScale));
+        map.put(HsqlDatabaseProperties.sql_char_literal,
+                String.valueOf(database.sqlCharLiteral));
+        map.put(HsqlDatabaseProperties.sql_concat_nulls,
+                String.valueOf(database.sqlConcatNulls));
+        map.put(HsqlDatabaseProperties.sql_convert_trunc,
+                String.valueOf(database.sqlConvertTruncate));
+        map.put(HsqlDatabaseProperties.sql_default_collation,
+                String.valueOf(database.collation.getName().name));
+        map.put(HsqlDatabaseProperties.sql_trunc_trailing,
+                String.valueOf(database.sqlTruncateTrailing));
+        map.put(HsqlDatabaseProperties.sql_double_nan,
+                String.valueOf(database.sqlDoubleNaN));
+        map.put(HsqlDatabaseProperties.sql_enforce_names,
+                String.valueOf(database.sqlEnforceNames));
+        map.put(HsqlDatabaseProperties.sql_enforce_refs,
+                String.valueOf(database.sqlEnforceRefs));
+        map.put(HsqlDatabaseProperties.sql_enforce_size,
+                String.valueOf(database.sqlEnforceSize));
+        map.put(HsqlDatabaseProperties.sql_enforce_tdcd,
+                String.valueOf(database.sqlEnforceTDCD));
+        map.put(HsqlDatabaseProperties.sql_enforce_tdcu,
+                String.valueOf(database.sqlEnforceTDCU));
+        map.put(HsqlDatabaseProperties.sql_enforce_types,
+                String.valueOf(database.sqlEnforceTypes));
+        map.put(HsqlDatabaseProperties.sql_ignore_case,
+                String.valueOf(database.sqlIgnoreCase));
+        map.put(HsqlDatabaseProperties.sql_live_object,
+                String.valueOf(database.sqlLiveObject));
+        map.put(HsqlDatabaseProperties.sql_longvar_is_lob,
+                String.valueOf(database.sqlLongvarIsLob));
+        map.put(HsqlDatabaseProperties.sql_lowercase_ident,
+                String.valueOf(database.sqlLowerCaseIdentifier));
+        map.put(HsqlDatabaseProperties.sql_max_recursive,
+                String.valueOf(database.sqlMaxRecursive));
+        map.put(HsqlDatabaseProperties.sql_nulls_first,
+                String.valueOf(database.sqlNullsFirst));
+        map.put(HsqlDatabaseProperties.sql_nulls_order,
+                String.valueOf(database.sqlNullsOrder));
+        map.put(HsqlDatabaseProperties.sql_pad_space,
+                String.valueOf(database.collation.isPadSpace()));
+        map.put(HsqlDatabaseProperties.sql_ref_integrity,
+                String.valueOf(database.isReferentialIntegrity()));
+        map.put(HsqlDatabaseProperties.sql_regular_names,
+                String.valueOf(database.sqlRegularNames));
+        map.put(HsqlDatabaseProperties.sql_restrict_exec,
+                String.valueOf(database.sqlRestrictExec));
+        map.put(HsqlDatabaseProperties.sql_syntax_db2,
+                String.valueOf(database.sqlSyntaxDb2));
+        map.put(HsqlDatabaseProperties.sql_syntax_mss,
+                String.valueOf(database.sqlSyntaxMss));
+        map.put(HsqlDatabaseProperties.sql_syntax_mys,
+                String.valueOf(database.sqlSyntaxMys));
+        map.put(HsqlDatabaseProperties.sql_syntax_ora,
+                String.valueOf(database.sqlSyntaxOra));
+        map.put(HsqlDatabaseProperties.sql_syntax_pgs,
+                String.valueOf(database.sqlSyntaxPgs));
+        map.put(HsqlDatabaseProperties.sql_sys_index_names,
+                String.valueOf(database.sqlSysIndexNames));
+        map.put(HsqlDatabaseProperties.sql_unique_nulls,
+                String.valueOf(database.sqlUniqueNulls));
 
-        if (HsqlDatabaseProperties.sql_enforce_size.equals(name)) {
-            return String.valueOf(database.sqlEnforceSize);
-        }
-
-        if (HsqlDatabaseProperties.sql_enforce_tdcd.equals(name)) {
-            return String.valueOf(database.sqlEnforceTDCD);
-        }
-
-        if (HsqlDatabaseProperties.sql_enforce_tdcu.equals(name)) {
-            return String.valueOf(database.sqlEnforceTDCU);
-        }
-
-        if (HsqlDatabaseProperties.sql_enforce_types.equals(name)) {
-            return String.valueOf(database.sqlEnforceTypes);
-        }
-
-        if (HsqlDatabaseProperties.sql_ignore_case.equals(name)) {
-            return String.valueOf(database.sqlIgnoreCase);
-        }
-
-        if (HsqlDatabaseProperties.sql_longvar_is_lob.equals(name)) {
-            return String.valueOf(database.sqlLongvarIsLob);
-        }
-
-        if (HsqlDatabaseProperties.sql_nulls_first.equals(name)) {
-            return String.valueOf(database.sqlNullsFirst);
-        }
-
-        if (HsqlDatabaseProperties.sql_nulls_order.equals(name)) {
-            return String.valueOf(database.sqlNullsOrder);
-        }
-
-        if (HsqlDatabaseProperties.sql_pad_space.equals(name)) {
-            return String.valueOf(database.collation.isPadSpace());
-        }
-
-        if (HsqlDatabaseProperties.sql_syntax_db2.equals(name)) {
-            return String.valueOf(database.sqlSyntaxDb2);
-        }
-
-        if (HsqlDatabaseProperties.sql_syntax_mss.equals(name)) {
-            return String.valueOf(database.sqlSyntaxMss);
-        }
+        //
+        map.put(HsqlDatabaseProperties.jdbc_translate_tti_types,
+                String.valueOf(database.sqlTranslateTTI));
 
-        if (HsqlDatabaseProperties.sql_syntax_mys.equals(name)) {
-            return String.valueOf(database.sqlSyntaxMys);
-        }
+        switch (database.txManager.getTransactionControl()) {
 
-        if (HsqlDatabaseProperties.sql_syntax_ora.equals(name)) {
-            return String.valueOf(database.sqlSyntaxOra);
-        }
+            case TransactionManager.MVCC :
+                value = Tokens.T_MVCC;
+                break;
 
-        if (HsqlDatabaseProperties.sql_syntax_pgs.equals(name)) {
-            return String.valueOf(database.sqlSyntaxPgs);
-        }
+            case TransactionManager.MVLOCKS :
+                value = Tokens.T_MVLOCKS;
+                break;
 
-        if (HsqlDatabaseProperties.sql_ref_integrity.equals(name)) {
-            return String.valueOf(database.isReferentialIntegrity());
+            case TransactionManager.LOCKS :
+                value = Tokens.T_LOCKS;
+                break;
         }
 
-        if (HsqlDatabaseProperties.sql_regular_names.equals(name)) {
-            return String.valueOf(database.sqlRegularNames);
-        }
+        map.put(HsqlDatabaseProperties.hsqldb_tx, value);
 
-        if (HsqlDatabaseProperties.sql_unique_nulls.equals(name)) {
-            return String.valueOf(database.sqlUniqueNulls);
-        }
+        switch (database.defaultIsolationLevel) {
 
-        if (HsqlDatabaseProperties.sql_live_object.equals(name)) {
-            return String.valueOf(database.sqlLiveObject);
-        }
+            case SessionInterface.TX_READ_COMMITTED :
+                value = new StringBuilder(Tokens.T_READ).append('_').append(
+                    Tokens.T_COMMITTED).toString();
+                break;
 
-        if (HsqlDatabaseProperties.jdbc_translate_tti_types.equals(name)) {
-            return String.valueOf(database.sqlTranslateTTI);
+            case SessionInterface.TX_SERIALIZABLE :
+                value = Tokens.T_SERIALIZABLE;
+                break;
         }
 
-/*
-        if (HsqlDatabaseProperties.textdb_all_quoted.equals(name)) {
-            return null;
-        }
+        map.put(HsqlDatabaseProperties.hsqldb_tx_level, value);
+        map.put(
+            HsqlDatabaseProperties.hsqldb_reconfig_logging,
+            System.getProperty(
+                HsqlDatabaseProperties.hsqldb_reconfig_logging));
+
+        if (HsqlDatabaseProperties.methodClassNames != null) {
+            map.put(HsqlDatabaseProperties.hsqldb_method_class_names,
+                    HsqlDatabaseProperties.methodClassNames);
+        }
+
+        map.put(HsqlDatabaseProperties.hsqldb_applog,
+                String.valueOf(appLog.getLevel()));
+        map.put(HsqlDatabaseProperties.hsqldb_extlog,
+                String.valueOf(propExternalEventLogLevel));
+        map.put(HsqlDatabaseProperties.hsqldb_sqllog,
+                String.valueOf(sqlLog.getLevel()));
+        map.put(HsqlDatabaseProperties.hsqldb_lob_file_scale,
+                String.valueOf(propLobBlockSize / 1024));
+        map.put(HsqlDatabaseProperties.hsqldb_lob_file_compressed,
+                String.valueOf(propCompressLobs));
+        map.put(HsqlDatabaseProperties.hsqldb_cache_file_scale,
+                String.valueOf(propDataFileScale));
+        map.put(HsqlDatabaseProperties.hsqldb_cache_free_count,
+                String.valueOf(propMaxFreeBlocks));
+        map.put(HsqlDatabaseProperties.hsqldb_cache_rows,
+                String.valueOf(propCacheMaxRows));
+        map.put(HsqlDatabaseProperties.hsqldb_cache_size,
+                String.valueOf(propCacheMaxSize / 1024));
 
-        if (HsqlDatabaseProperties.textdb_allow_full_path.equals(name)) {
-            return null;
-        }
+        {
+            String prop;
 
-        if (HsqlDatabaseProperties.textdb_encoding.equals(name)) {
-            return null;
-        }
+            switch (database.schemaManager.getDefaultTableType()) {
 
-        if (HsqlDatabaseProperties.textdb_ignore_first.equals(name)) {
-            return null;
-        }
+                case TableBase.CACHED_TABLE :
+                    prop = Tokens.T_CACHED;
+                    break;
 
-        if (HsqlDatabaseProperties.textdb_quoted.equals(name)) {
-            return null;
-        }
+                case TableBase.MEMORY_TABLE :
+                default :
+                    prop = Tokens.T_MEMORY;
+            }
 
-        if (HsqlDatabaseProperties.textdb_fs.equals(name)) {
-            return null;
+            map.put(HsqlDatabaseProperties.hsqldb_default_table_type, prop);
         }
 
-        if (HsqlDatabaseProperties.textdb_vs.equals(name)) {
-            return null;
-        }
+        map.put(HsqlDatabaseProperties.hsqldb_defrag_limit,
+                String.valueOf(propDataFileDefragLimit));
+        map.put(HsqlDatabaseProperties.hsqldb_files_space,
+                String.valueOf(propDataFileSpace));
+        map.put(
+            HsqlDatabaseProperties.hsqldb_files_readonly,
+            database.databaseProperties.isPropertyTrue(
+                HsqlDatabaseProperties.hsqldb_files_readonly) ? "true"
+                                                              : "false");
+        map.put(HsqlDatabaseProperties.hsqldb_large_data,
+                String.valueOf(propLargeData));
+        map.put(
+            HsqlDatabaseProperties.hsqldb_lock_file,
+            database.databaseProperties.isPropertyTrue(
+                HsqlDatabaseProperties.hsqldb_lock_file) ? "true"
+                                                         : "false");
+        map.put(HsqlDatabaseProperties.hsqldb_log_data,
+                String.valueOf(propLogData));
+        map.put(HsqlDatabaseProperties.hsqldb_log_size,
+                String.valueOf(propLogSize));
+        map.put(HsqlDatabaseProperties.hsqldb_nio_data_file,
+                String.valueOf(propNioDataFile));
+        map.put(HsqlDatabaseProperties.hsqldb_nio_max_size,
+                String.valueOf(propNioMaxSize / (1024 * 1024)));
+        map.put(HsqlDatabaseProperties.hsqldb_script_format,
+                ScriptWriterBase.LIST_SCRIPT_FORMATS[propScriptFormat]
+                    .toLowerCase());
+        map.put(HsqlDatabaseProperties.hsqldb_temp_directory,
+                tempDirectoryPath);
+        map.put(HsqlDatabaseProperties.hsqldb_tx_conflict_rollback,
+                String.valueOf(database.txConflictRollback));
+        map.put(HsqlDatabaseProperties.hsqldb_tx_interrupt_rollback,
+                String.valueOf(database.txInterruptRollback));
+        map.put(HsqlDatabaseProperties.hsqldb_result_max_memory_rows,
+                String.valueOf(database.getResultMaxMemoryRows()));
+        map.put(HsqlDatabaseProperties.hsqldb_readonly,
+                database.isReadOnly() ? "true"
+                                      : "false");
+        map.put(HsqlDatabaseProperties.hsqldb_files_readonly,
+                database.isFilesReadOnly() ? "true"
+                                           : "false");
+        map.put(HsqlDatabaseProperties.hsqldb_write_delay,
+                String.valueOf(propWriteDelay != 0));
+        map.put(HsqlDatabaseProperties.hsqldb_write_delay_millis,
+                String.valueOf(propWriteDelay));
+        map.put(HsqlDatabaseProperties.hsqldb_digest,
+                database.granteeManager.getDigestAlgo());
 
-        if (HsqlDatabaseProperties.textdb_lvs.equals(name)) {
-            return null;
-        }
-*/
-        return null;
+        return map;
     }
 
     public String[] getPropertiesSQL(boolean indexRoots) {
@@ -1708,10 +1639,6 @@ public class Logger implements EventLogI
         sb.append(Tokens.T_NAME).append(' ').append(database.getNameString());
         list.add(sb.toString());
         sb.setLength(0);
-        sb.append("SET DATABASE ").append(Tokens.T_GC).append(' ');
-        sb.append(propGC);
-        list.add(sb.toString());
-        sb.setLength(0);
         sb.append("SET DATABASE ").append(Tokens.T_DEFAULT).append(' ');
         sb.append(Tokens.T_RESULT).append(' ').append(Tokens.T_MEMORY);
         sb.append(' ').append(Tokens.T_ROWS).append(' ');
@@ -1724,6 +1651,15 @@ public class Logger implements EventLogI
         list.add(sb.toString());
         sb.setLength(0);
 
+        if (propExternalEventLogLevel != SimpleLog.LOG_NONE) {
+            sb.append("SET DATABASE ").append(Tokens.T_EXTERNAL).append(' ');
+            sb.append(Tokens.T_EVENT).append(' ');
+            sb.append(Tokens.T_LOG).append(' ').append(Tokens.T_LEVEL);
+            sb.append(' ').append(propExternalEventLogLevel);
+            list.add(sb.toString());
+            sb.setLength(0);
+        }
+
         if (propSqlLogLevel != SimpleLog.LOG_NONE) {
             sb.append("SET DATABASE ").append(Tokens.T_EVENT).append(' ');
             sb.append(Tokens.T_LOG).append(' ').append(Tokens.T_SQL);
@@ -1798,7 +1734,7 @@ public class Logger implements EventLogI
         list.add(sb.toString());
         sb.setLength(0);
 
-        String temp = database.getProperties().getStringPropertyDefault(
+        String temp = HsqlDatabaseProperties.getStringPropertyDefault(
             HsqlDatabaseProperties.hsqldb_digest);
 
         if (!temp.equals(database.granteeManager.getDigestAlgo())) {
@@ -1826,16 +1762,13 @@ public class Logger implements EventLogI
                                            : Tokens.T_FALSE);
         list.add(sb.toString());
         sb.setLength(0);
-
-        if (database.sqlRestrictExec) {
-            sb.append("SET DATABASE ").append(Tokens.T_SQL).append(' ');
-            sb.append(Tokens.T_RESTRICT).append(' ');
-            sb.append(Tokens.T_EXEC).append(' ');
-            sb.append(database.sqlRestrictExec ? Tokens.T_TRUE
-                                               : Tokens.T_FALSE);
-            list.add(sb.toString());
-            sb.setLength(0);
-        }
+        sb.append("SET DATABASE ").append(Tokens.T_SQL).append(' ');
+        sb.append(Tokens.T_RESTRICT).append(' ');
+        sb.append(Tokens.T_EXEC).append(' ');
+        sb.append(database.sqlRestrictExec ? Tokens.T_TRUE
+                                           : Tokens.T_FALSE);
+        list.add(sb.toString());
+        sb.setLength(0);
 
         if (!database.sqlRegularNames) {
             sb.append("SET DATABASE ").append(Tokens.T_SQL).append(' ');
@@ -1889,15 +1822,13 @@ public class Logger implements EventLogI
             list.add(sb.toString());
         }
 
-        if (database.sqlSysIndexNames) {
-            sb.setLength(0);
-            sb.append("SET DATABASE ").append(Tokens.T_SQL).append(' ');
-            sb.append(Tokens.T_SYS).append(' ').append(Tokens.T_INDEX);
-            sb.append(' ').append(Tokens.T_NAMES).append(' ');
-            sb.append(database.sqlSysIndexNames ? Tokens.T_TRUE
-                                                : Tokens.T_FALSE);
-            list.add(sb.toString());
-        }
+        sb.setLength(0);
+        sb.append("SET DATABASE ").append(Tokens.T_SQL).append(' ');
+        sb.append(Tokens.T_SYS).append(' ').append(Tokens.T_INDEX);
+        sb.append(' ').append(Tokens.T_NAMES).append(' ');
+        sb.append(database.sqlSysIndexNames ? Tokens.T_TRUE
+                                            : Tokens.T_FALSE);
+        list.add(sb.toString());
 
         if (!database.sqlCharLiteral) {
             sb.setLength(0);
@@ -1958,6 +1889,18 @@ public class Logger implements EventLogI
         sb.append(database.sqlAvgScale);
         list.add(sb.toString());
         sb.setLength(0);
+
+        if (database.sqlMaxRecursive
+                != HsqlDatabaseProperties.getIntegerPropertyDefault(
+                    HsqlDatabaseProperties.sql_max_recursive)) {
+            sb.append("SET DATABASE ").append(Tokens.T_SQL).append(' ');
+            sb.append(Tokens.T_MAX).append(' ');
+            sb.append(Tokens.T_RECURSIVE).append(' ');
+            sb.append(database.sqlMaxRecursive);
+            list.add(sb.toString());
+            sb.setLength(0);
+        }
+
         sb.append("SET DATABASE ").append(Tokens.T_SQL).append(' ');
         sb.append(Tokens.T_DOUBLE).append(' ');
         sb.append(Tokens.T_NAN).append(' ');
@@ -1966,6 +1909,15 @@ public class Logger implements EventLogI
         list.add(sb.toString());
         sb.setLength(0);
 
+        if (database.sqlIgnoreCase) {
+            sb.append("SET DATABASE ").append(Tokens.T_SQL).append(' ');
+            sb.append(Tokens.T_IGNORECASE).append(' ');
+            sb.append(database.sqlIgnoreCase ? Tokens.T_TRUE
+                                             : Tokens.T_FALSE);
+            list.add(sb.toString());
+            sb.setLength(0);
+        }
+
         if (database.sqlLongvarIsLob) {
             sb.append("SET DATABASE ").append(Tokens.T_SQL).append(' ');
             sb.append(Tokens.T_LONGVAR).append(' ');
@@ -1977,15 +1929,6 @@ public class Logger implements EventLogI
             sb.setLength(0);
         }
 
-        if (database.sqlIgnoreCase) {
-            sb.append("SET DATABASE ").append(Tokens.T_SQL).append(' ');
-            sb.append(Tokens.T_IGNORECASE).append(' ');
-            sb.append(database.sqlIgnoreCase ? Tokens.T_TRUE
-                                             : Tokens.T_FALSE);
-            list.add(sb.toString());
-            sb.setLength(0);
-        }
-
         if (database.sqlLowerCaseIdentifier) {
             sb.append("SET DATABASE ").append(Tokens.T_SQL).append(' ');
             sb.append(Tokens.T_LOWER).append(' ');
@@ -1997,6 +1940,16 @@ public class Logger implements EventLogI
             sb.setLength(0);
         }
 
+        if (!database.sqlTruncateTrailing) {
+            sb.append("SET DATABASE ").append(Tokens.T_SQL).append(' ');
+            sb.append(Tokens.T_TRUNCATE).append(' ');
+            sb.append(Tokens.T_TRAILING).append(' ');
+            sb.append(database.sqlTruncateTrailing ? Tokens.T_TRUE
+                                                   : Tokens.T_FALSE);
+            list.add(sb.toString());
+            sb.setLength(0);
+        }
+
         if (database.sqlSyntaxDb2) {
             sb.append("SET DATABASE ").append(Tokens.T_SQL).append(' ');
             sb.append(Tokens.T_SYNTAX).append(' ');
@@ -2349,9 +2302,9 @@ public class Logger implements EventLogI
             logInfoEvent("Successfully backed up instance '" + instanceName
                          + "' to '" + destPath + "'");
         } catch (IOException ioe) {
-            throw Error.error(ErrorCode.FILE_IO_ERROR, ioe.toString());
+            throw Error.error(ioe, ErrorCode.FILE_IO_ERROR, ioe.toString());
         } catch (TarMalformatException tme) {
-            throw Error.error(ErrorCode.FILE_IO_ERROR, tme.toString());
+            throw Error.error(tme, ErrorCode.FILE_IO_ERROR, tme.toString());
         } finally {
             if (scriptName != null) {
                 FileUtil.getFileUtil().delete(scriptName);
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/persist/Log.java 2.7.0-1/hsqldb/src/org/hsqldb/persist/Log.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/persist/Log.java	2021-02-04 10:03:14.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/persist/Log.java	2022-07-13 15:38:30.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -69,7 +69,7 @@ import org.hsqldb.scriptio.ScriptWriterT
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
  * @author Bob Preston (sqlbob@users dot sourceforge.net) - text table support
- * @version 2.5.1
+ * @version 2.7.0
  * @since 1.8.0
  */
 public class Log {
@@ -112,7 +112,7 @@ public class Log {
      * When opening a database, the hsqldb.compatible_version property is
      * used to determine if this version of the engine is equal to or greater
      * than the earliest version of the engine capable of opening that
-     * database.<p>
+     * database.
      */
     void open() {
 
@@ -186,7 +186,7 @@ public class Log {
     void close(boolean script) {
 
         database.logger.setFilesTimestamp(
-            database.txManager.getGlobalChangeTimestamp());
+            database.txManager.getSystemChangeNumber());
         closeLog();
         deleteOldFiles();
         deleteOldTempFiles();
@@ -244,7 +244,7 @@ public class Log {
 
         database.logger.textTableManager.closeAllTextCaches(false);
         database.logger.setFilesTimestamp(
-            database.txManager.getGlobalChangeTimestamp());
+            database.txManager.getSystemChangeNumber());
         closeLog();
     }
 
@@ -315,7 +315,7 @@ public class Log {
         }
 
         database.logger.setFilesTimestamp(
-            database.txManager.getGlobalChangeTimestamp());
+            database.txManager.getSystemChangeNumber());
         database.logger.logInfoEvent("checkpointClose start");
         synchLog();
         database.lobManager.synch();
@@ -338,7 +338,6 @@ public class Log {
             if (cache != null) {
                 deleteBackupFile();
             }
-
         } catch (Throwable t) {
 
             // backup failed perhaps due to lack of disk space
@@ -401,7 +400,7 @@ public class Log {
             }
 
             database.logger.setFilesTimestamp(
-                database.txManager.getGlobalChangeTimestamp());
+                database.txManager.getSystemChangeNumber());
             database.logger.logInfoEvent("checkpointClose start");
             synchLog();
             database.lobManager.synch();
@@ -617,7 +616,7 @@ public class Log {
             dbLogWriter.setWriteDelay(writeDelay);
             dbLogWriter.start();
         } catch (Throwable e) {
-            throw Error.error(ErrorCode.FILE_IO_ERROR, getLogFileName());
+            throw Error.error(e, ErrorCode.FILE_IO_ERROR, getLogFileName());
         }
     }
 
@@ -694,7 +693,7 @@ public class Log {
             } else if (e instanceof IOException) {
                 throw Error.error(ErrorCode.FILE_IO_ERROR, e);
             } else if (e instanceof OutOfMemoryError) {
-                throw Error.error(ErrorCode.OUT_OF_MEMORY);
+                throw Error.error(ErrorCode.OUT_OF_MEMORY, e);
             } else {
                 throw Error.error(ErrorCode.GENERAL_ERROR, e);
             }
@@ -734,14 +733,15 @@ public class Log {
         }
     }
 
-    static boolean renameNewFile(FileAccess fileAccess, String baseFileName) {
+    boolean renameNewFile(FileAccess fileAccess, String baseFileName) {
 
         if (fileAccess.isStreamElement(baseFileName
                                        + Logger.newFileExtension)) {
             deleteFile(fileAccess, baseFileName);
 
             return fileAccess.renameElementOrCopy(
-                baseFileName + Logger.newFileExtension, baseFileName);
+                baseFileName + Logger.newFileExtension, baseFileName,
+                database.logger);
         }
 
         return true;
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/persist/RAFileHybrid.java 2.7.0-1/hsqldb/src/org/hsqldb/persist/RAFileHybrid.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/persist/RAFileHybrid.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/persist/RAFileHybrid.java	2022-07-07 16:32:28.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/persist/RAFile.java 2.7.0-1/hsqldb/src/org/hsqldb/persist/RAFile.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/persist/RAFile.java	2021-02-09 04:51:54.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/persist/RAFile.java	2022-07-07 16:32:28.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -41,6 +41,7 @@ import org.hsqldb.Database;
 import org.hsqldb.error.Error;
 import org.hsqldb.error.ErrorCode;
 import org.hsqldb.lib.ArrayUtil;
+import org.hsqldb.lib.EventLogInterface;
 import org.hsqldb.lib.HsqlByteArrayInputStream;
 import org.hsqldb.lib.HsqlByteArrayOutputStream;
 
@@ -49,7 +50,7 @@ import org.hsqldb.lib.HsqlByteArrayOutpu
  * CACHED table storage.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version  2.7.0
  * @since  1.7.2
  */
 final class RAFile implements RandomAccessInterface {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/persist/RAFileNIO.java 2.7.0-1/hsqldb/src/org/hsqldb/persist/RAFileNIO.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/persist/RAFileNIO.java	2021-01-29 13:34:34.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/persist/RAFileNIO.java	2022-07-07 16:32:28.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -42,6 +42,7 @@ import org.hsqldb.Database;
 import org.hsqldb.error.Error;
 import org.hsqldb.error.ErrorCode;
 import org.hsqldb.lib.ArrayUtil;
+import org.hsqldb.lib.EventLogInterface;
 import org.hsqldb.lib.java.JavaSystem;
 
 /**
@@ -52,7 +53,7 @@ import org.hsqldb.lib.java.JavaSystem;
  * ScaledRAFile is used for data access.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version  2.6.0
+ * @version  2.7.0
  * @since 1.8.0.5
  */
 final class RAFileNIO implements RandomAccessInterface {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/persist/RAFileSimple.java 2.7.0-1/hsqldb/src/org/hsqldb/persist/RAFileSimple.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/persist/RAFileSimple.java	2015-03-29 13:12:58.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/persist/RAFileSimple.java	2022-07-07 15:44:42.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -38,13 +38,14 @@ import java.io.RandomAccessFile;
 import org.hsqldb.Database;
 import org.hsqldb.error.Error;
 import org.hsqldb.error.ErrorCode;
+import org.hsqldb.lib.EventLogInterface;
 
 /**
  * This class is a simple wrapper for a random access file such as used
  * for backup and lobs.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version  2.3.3
+ * @version  2.7.0
  * @since  1.9.0
  */
 final class RAFileSimple implements RandomAccessInterface {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/persist/RAShadowFile.java 2.7.0-1/hsqldb/src/org/hsqldb/persist/RAShadowFile.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/persist/RAShadowFile.java	2021-02-09 04:51:26.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/persist/RAShadowFile.java	2022-07-07 16:32:28.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -36,6 +36,7 @@ import java.io.FileNotFoundException;
 import java.io.IOException;
 
 import org.hsqldb.Database;
+import org.hsqldb.lib.EventLogInterface;
 import org.hsqldb.lib.HsqlByteArrayOutputStream;
 import org.hsqldb.lib.InputStreamInterface;
 import org.hsqldb.lib.java.JavaSystem;
@@ -45,7 +46,7 @@ import org.hsqldb.map.BitMap;
  * Wrapper for random access file for incremental backup of the .data file.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.5.0
+ * @version  2.7.0
  * @since 1.9.0
  */
 public class RAShadowFile {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/persist/RowStoreAVLDiskData.java 2.7.0-1/hsqldb/src/org/hsqldb/persist/RowStoreAVLDiskData.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/persist/RowStoreAVLDiskData.java	2021-02-11 11:26:20.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/persist/RowStoreAVLDiskData.java	2022-05-22 18:09:56.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -31,7 +31,6 @@
 
 package org.hsqldb.persist;
 
-import java.io.IOException;
 import java.util.concurrent.atomic.AtomicInteger;
 import java.util.concurrent.locks.ReentrantReadWriteLock;
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/persist/RowStoreAVLDisk.java 2.7.0-1/hsqldb/src/org/hsqldb/persist/RowStoreAVLDisk.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/persist/RowStoreAVLDisk.java	2021-03-18 00:32:42.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/persist/RowStoreAVLDisk.java	2022-05-22 18:09:56.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -31,7 +31,6 @@
 
 package org.hsqldb.persist;
 
-import java.io.IOException;
 import java.util.concurrent.locks.Lock;
 import java.util.concurrent.locks.ReentrantReadWriteLock;
 
@@ -50,7 +49,6 @@ import org.hsqldb.index.Index;
 import org.hsqldb.index.NodeAVL;
 import org.hsqldb.index.NodeAVLDisk;
 import org.hsqldb.lib.ArrayUtil;
-import org.hsqldb.lib.DoubleIntIndex;
 import org.hsqldb.lib.DoubleLongIndex;
 import org.hsqldb.lib.LongKeyHashMap;
 import org.hsqldb.lib.LongLookup;
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/persist/RowStoreAVLHybrid.java 2.7.0-1/hsqldb/src/org/hsqldb/persist/RowStoreAVLHybrid.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/persist/RowStoreAVLHybrid.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/persist/RowStoreAVLHybrid.java	2022-07-13 15:38:30.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -31,7 +31,7 @@
 
 package org.hsqldb.persist;
 
-import java.io.IOException;
+import java.util.Arrays;
 
 import org.hsqldb.HsqlException;
 import org.hsqldb.Row;
@@ -77,7 +77,7 @@ public class RowStoreAVLHybrid extends R
         }
 
         if (table.getTableType() == TableBase.RESULT_TABLE) {
-            setTimestamp(session.getActionTimestamp());
+            setTimestamp(session.getActionSCN());
         }
 
 // test code to force use of cache
@@ -215,9 +215,7 @@ public class RowStoreAVLHybrid extends R
         elementCount.set(0);
         ArrayUtil.fillArray(accessorList, null);
 
-        for (int i = 0; i < nullsList.length; i++) {
-            nullsList[i] = false;
-        }
+        Arrays.fill(nullsList, false);
     }
 
     public void remove(CachedObject object) {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/persist/RowStoreAVL.java 2.7.0-1/hsqldb/src/org/hsqldb/persist/RowStoreAVL.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/persist/RowStoreAVL.java	2021-01-29 13:34:34.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/persist/RowStoreAVL.java	2022-06-08 09:12:38.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -63,7 +63,7 @@ import org.hsqldb.types.Type;
  * Base implementation of PersistentStore for different table types.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 1.9.0
  */
 public abstract class RowStoreAVL implements PersistentStore {
@@ -634,7 +634,7 @@ public abstract class RowStoreAVL implem
                 }
             }
         } catch (OutOfMemoryError e) {
-            throw Error.error(ErrorCode.OUT_OF_MEMORY);
+            throw Error.error(ErrorCode.OUT_OF_MEMORY, e);
         }
     }
 
@@ -741,7 +741,7 @@ public abstract class RowStoreAVL implem
 
                 return true;
             } catch (OutOfMemoryError e) {
-                error = Error.error(ErrorCode.OUT_OF_MEMORY);
+                error = Error.error(ErrorCode.OUT_OF_MEMORY, e);
             } catch (HsqlException e) {
                 error = e;
             }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/persist/RowStoreDataChange.java 2.7.0-1/hsqldb/src/org/hsqldb/persist/RowStoreDataChange.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/persist/RowStoreDataChange.java	2020-07-10 14:10:30.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/persist/RowStoreDataChange.java	2022-05-22 17:54:48.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -31,8 +31,6 @@
 
 package org.hsqldb.persist;
 
-import java.io.IOException;
-
 import org.hsqldb.HsqlException;
 import org.hsqldb.Row;
 import org.hsqldb.RowDiskDataChange;
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/persist/ScriptRunner.java 2.7.0-1/hsqldb/src/org/hsqldb/persist/ScriptRunner.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/persist/ScriptRunner.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/persist/ScriptRunner.java	2022-06-03 13:24:24.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -59,7 +59,7 @@ import org.hsqldb.scriptio.StatementLine
  * logged to the application log. If memory runs out, an exception is thrown.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.5.1
+ * @version 2.7.0
  * @since 1.7.2
  */
 public class ScriptRunner {
@@ -246,7 +246,7 @@ public class ScriptRunner {
             // catch out-of-memory errors and terminate
             database.logger.logSevereEvent(error, e);
 
-            throw Error.error(ErrorCode.OUT_OF_MEMORY);
+            throw Error.error(ErrorCode.OUT_OF_MEMORY, e);
         } catch (Throwable t) {
             HsqlException e =
                 Error.error(t, ErrorCode.ERROR_IN_LOG_FILE,
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/persist/TableSpaceManager.java 2.7.0-1/hsqldb/src/org/hsqldb/persist/TableSpaceManager.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/persist/TableSpaceManager.java	2020-05-20 08:55:38.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/persist/TableSpaceManager.java	2022-02-21 14:41:52.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2020, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/persist/TextFileOps.java 2.7.0-1/hsqldb/src/org/hsqldb/persist/TextFileOps.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/persist/TextFileOps.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/persist/TextFileOps.java	2022-03-08 11:25:34.000000000 +0000
@@ -0,0 +1,254 @@
+/* Copyright (c) 2001-2022, The HSQL Development Group
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ * Redistributions of source code must retain the above copyright notice, this
+ * list of conditions and the following disclaimer.
+ *
+ * Redistributions in binary form must reproduce the above copyright notice,
+ * this list of conditions and the following disclaimer in the documentation
+ * and/or other materials provided with the distribution.
+ *
+ * Neither the name of the HSQL Development Group nor the names of its
+ * contributors may be used to endorse or promote products derived from this
+ * software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL HSQL DEVELOPMENT GROUP, HSQLDB.ORG,
+ * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+ * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+ * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+ * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+ * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+ * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+
+package org.hsqldb.persist;
+
+import org.hsqldb.Database;
+import org.hsqldb.Row;
+import org.hsqldb.Session;
+import org.hsqldb.Table;
+import org.hsqldb.error.Error;
+import org.hsqldb.error.ErrorCode;
+import org.hsqldb.lib.FileUtil;
+import org.hsqldb.navigator.RowIterator;
+import org.hsqldb.result.Result;
+import org.hsqldb.rowio.RowInputInterface;
+import org.hsqldb.rowio.RowInputText;
+import org.hsqldb.rowio.RowInputTextQuoted;
+import org.hsqldb.rowio.RowOutputInterface;
+import org.hsqldb.rowio.RowOutputText;
+import org.hsqldb.rowio.RowOutputTextQuoted;
+import org.hsqldb.types.Type;
+
+/**
+ * Read and write delimited text files.
+ *
+ * @author Fred Toussi (fredt@users dot sourceforge.net)
+ * @version 2.7.0
+ * @since 2.7.0
+*/
+public class TextFileOps {
+
+    public static Result loadTextData(Session session, String fileSettings,
+                                      Table table, int mode) {
+
+        TextFileReader reader;
+        Database       database = session.database;
+        FileUtil       fa       = FileUtil.getFileUtil();
+        TextFileSettings textFileSettings =
+            new TextFileSettings(database.getProperties(), fileSettings);
+        String                dataFileName = textFileSettings.getFileName();
+        RandomAccessInterface dataFile;
+        RowInputInterface     rowIn;
+        RowInsertSimple       rowInsert;
+
+        if (dataFileName == null || dataFileName.length() == 0) {
+            throw Error.error(ErrorCode.X_S0501);
+        }
+
+        dataFileName = fa.canonicalOrAbsolutePath(dataFileName);
+
+        boolean exists = FileUtil.getFileUtil().exists(dataFileName);
+
+        if (!exists) {
+            throw Error.error(null, ErrorCode.FILE_IO_ERROR,
+                              ErrorCode.M_TextCache_opening_file_error,
+                              new String[] {
+                dataFileName, "file does not exist"
+            });
+        }
+
+        try {
+            dataFile = RAFile.newScaledRAFile(database, dataFileName, true,
+                                              RAFile.DATA_FILE_TEXT);
+        } catch (Throwable t) {
+            throw Error.error(t, ErrorCode.FILE_IO_ERROR,
+                              ErrorCode.M_TextCache_opening_file_error,
+                              new String[] {
+                dataFileName, t.toString()
+            });
+        }
+
+        if (textFileSettings.isQuoted || textFileSettings.isAllQuoted) {
+            rowIn = new RowInputTextQuoted(textFileSettings);
+        } else {
+            rowIn = new RowInputText(textFileSettings);
+        }
+
+        reader = TextFileReader8.newTextFileReader(dataFile, textFileSettings,
+                rowIn, true);
+
+        RowInsertInterface.ErrorLogger callback;
+
+        if (mode == RowInsertInterface.modes.continueOnError) {
+            callback = new RowInsertSimple.InsertErrorHandler(database,
+                    dataFileName);
+        } else {
+            callback = new RowInsertSimple.DefaultErrorHandler();
+        }
+
+        rowInsert = new RowInsertSimple(session, callback, mode);
+
+        PersistentStore store       = table.getRowStore(session);
+        Type[]          types       = table.getColumnTypes();
+        boolean         ignoreFirst = textFileSettings.isIgnoreFirst;
+
+        try {
+            while (true) {
+                rowIn = reader.readObject();
+
+                if (rowIn == null) {
+                    break;
+                }
+
+                if (ignoreFirst) {
+                    ignoreFirst = false;
+
+                    continue;
+                }
+
+                Object[] data = rowIn.readData(types);
+
+                if (textFileSettings.isNullDef) {
+                    table.generateDefaultForNull(data);
+                }
+
+                table.generateAndCheckData(session, data);
+
+                if (mode == RowInsertInterface.modes.checkUntillError) {
+                    continue;
+                }
+
+                rowInsert.insert(table, store, data);
+            }
+
+            rowInsert.finishTable();
+        } catch (Throwable t) {
+            long linenumber = reader.getLineNumber();
+
+            throw Error.error(t, ErrorCode.TEXT_FILE, 0, new String[] {
+                String.valueOf(linenumber), t.toString()
+            });
+        } finally {
+            rowInsert.close();
+
+            try {
+                if (callback != null) {
+                    callback.close();
+                }
+            } catch (Exception e) {}
+
+            try {
+                dataFile.close();
+            } catch (Exception e) {}
+        }
+
+        return Result.newUpdateCountResult((int) reader.getLineNumber());
+    }
+
+    public static Result unloadTextData(Session session, String fileSettings,
+                                        Table table) {
+
+        Database database = session.database;
+        FileUtil fa       = FileUtil.getFileUtil();
+        TextFileSettings textFileSettings =
+            new TextFileSettings(database.getProperties(), fileSettings);
+        String                dataFileName = textFileSettings.getFileName();
+        RandomAccessInterface dataFile;
+        RowOutputInterface    rowOut;
+        int                   lineCount = 0;
+
+        if (dataFileName == null || dataFileName.length() == 0) {
+            throw Error.error(ErrorCode.X_S0501);
+        }
+
+        dataFileName = fa.canonicalOrAbsolutePath(dataFileName);
+
+        boolean exists = FileUtil.getFileUtil().exists(dataFileName);
+
+        if (exists) {
+            throw Error.error(null, ErrorCode.TEXT_SOURCE_EXISTS,
+                              ErrorCode.M_TextCache_opening_file_error,
+                              new String[] {
+                dataFileName, "file exists"
+            });
+        }
+
+        try {
+            dataFile = new RAFileSimple(database.logger, dataFileName, "rw");
+        } catch (Throwable t) {
+            throw Error.error(t, ErrorCode.FILE_IO_ERROR,
+                              ErrorCode.M_TextCache_opening_file_error,
+                              new String[]{ dataFileName });
+        }
+
+        if (textFileSettings.isQuoted || textFileSettings.isAllQuoted) {
+            rowOut = new RowOutputTextQuoted(textFileSettings);
+        } else {
+            rowOut = new RowOutputText(textFileSettings);
+        }
+
+        PersistentStore store        = table.getRowStore(session);
+        Type[]          types        = table.getColumnTypes();
+        RowIterator     it           = table.rowIteratorForScript(store);
+        long            filePosition = 0;
+
+        try {
+            while (it.next()) {
+                rowOut.reset();
+
+                Row row = it.getCurrentRow();
+
+                rowOut.writeData(row, types);
+                rowOut.writeEnd();
+                dataFile.seek(filePosition);
+                dataFile.write(rowOut.getOutputStream().getBuffer(), 0,
+                               rowOut.getOutputStream().size());
+
+                filePosition += rowOut.getOutputStream().size();
+
+                lineCount++;
+            }
+
+            dataFile.synch();
+        } catch (Throwable t) {
+            throw Error.error(t, ErrorCode.FILE_IO_ERROR,
+                              ErrorCode.M_TextCache_opening_file_error,
+                              new String[]{ dataFileName });
+        } finally {
+            try {
+                dataFile.close();
+            } catch (Exception e) {}
+        }
+
+        return Result.newUpdateCountResult((int) lineCount);
+    }
+}
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/persist/TextFileReader8.java 2.7.0-1/hsqldb/src/org/hsqldb/persist/TextFileReader8.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/persist/TextFileReader8.java	2017-12-09 11:59:04.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/persist/TextFileReader8.java	2022-06-03 12:48:34.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -48,7 +48,7 @@ import org.hsqldb.rowio.RowInputText;
  *
  * @author Bob Preston (sqlbob@users dot sourceforge.net)
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.4.1
+ * @version 2.7.0
  * @since 2.2.7
 */
 public class TextFileReader8 implements TextFileReader {
@@ -219,7 +219,7 @@ public class TextFileReader8 implements
                 try {
                     rowString = buffer.getString();
                 } catch (UnsupportedEncodingException e) {
-                    throw Error.error(ErrorCode.X_S0531);
+                    throw Error.error(ErrorCode.X_S0531, e);
                 }
 
                 ((RowInputText) rowIn).setSource(rowString, position,
@@ -280,7 +280,7 @@ public class TextFileReader8 implements
                     break;
                 }
             } catch (IOException e) {
-                throw Error.error(ErrorCode.TEXT_FILE);
+                throw Error.error(ErrorCode.TEXT_FILE, e);
             }
 
             switch (c) {
@@ -313,7 +313,7 @@ public class TextFileReader8 implements
         try {
             header = buffer.getString();
         } catch (UnsupportedEncodingException e) {
-            throw Error.error(ErrorCode.X_S0531);
+            throw Error.error(ErrorCode.X_S0531, e);
         }
 
         position += buffer.getByteSize();
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/persist/TextFileSettings.java 2.7.0-1/hsqldb/src/org/hsqldb/persist/TextFileSettings.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/persist/TextFileSettings.java	2020-02-21 20:15:10.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/persist/TextFileSettings.java	2022-06-03 12:48:22.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -41,7 +41,7 @@ import org.hsqldb.error.ErrorCode;
  *
  * @author Bob Preston (sqlbob@users dot sourceforge.net)
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.5.1
+ * @version 2.7.0
  * @since 2.2.6
  */
 public class TextFileSettings {
@@ -277,7 +277,7 @@ public class TextFileSettings {
                 bytesForSpace   = " ".getBytes(charEncoding);
             }
         } catch (UnsupportedEncodingException e) {
-            throw Error.error(ErrorCode.X_S0531);
+            throw Error.error(ErrorCode.X_S0531, e);
         }
     }
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/QueryExpression.java 2.7.0-1/hsqldb/src/org/hsqldb/QueryExpression.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/QueryExpression.java	2021-07-15 13:57:30.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/QueryExpression.java	2022-03-24 13:06:04.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -56,7 +56,7 @@ import org.hsqldb.types.Types;
  * Implementation of an SQL query expression
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.1
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class QueryExpression implements RangeGroup {
@@ -755,7 +755,7 @@ public class QueryExpression implements
                 break;
             }
 
-            if (round > 256) {
+            if (round > session.database.sqlMaxRecursive) {
                 throw Error.error(ErrorCode.X_22522);
             }
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/QuerySpecification.java 2.7.0-1/hsqldb/src/org/hsqldb/QuerySpecification.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/QuerySpecification.java	2021-10-10 20:33:04.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/QuerySpecification.java	2022-04-21 06:32:20.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -87,7 +87,6 @@ public class QuerySpecification extends
     int                   endInnerRange   = -1;
     Expression            queryCondition;
     Expression            checkQueryCondition;
-    Expression            rowExpression;
     Expression[]          exprColumns;
     HsqlArrayList         exprColumnList;
     GroupSet              groupSet;
@@ -956,8 +955,6 @@ public class QuerySpecification extends
                     (Expression) sortAndSlice.exprList.get(i);
             }
         }
-
-        rowExpression = new Expression(OpTypes.ROW, exprColumns);
     }
 
     private int replaceColumnIndexInOrderBy(Expression orderBy) {
@@ -1019,6 +1016,8 @@ public class QuerySpecification extends
      */
     public void resolveExpressionTypes(Session session) {
 
+        Expression rowExpression = new Expression(OpTypes.ROW, exprColumns);
+
         for (int i = 0; i < indexStartAggregates; i++) {
             Expression e = exprColumns[i];
 
@@ -1038,11 +1037,18 @@ public class QuerySpecification extends
             }
         }
 
+        rowExpression.nodes = new Expression[1];
+
         for (int i = 0; i < rangeVariables.length; i++) {
             Expression e = rangeVariables[i].getJoinCondition();
 
             if (e != null) {
-                e.resolveTypes(session, null);
+                rowExpression.setLeftNode(e);
+                e.resolveTypes(session, rowExpression);
+
+                e = rowExpression.getLeftNode();
+
+                rangeVariables[i].setJoinCondition(e);
 
                 if (e.getDataType() != Type.SQL_BOOLEAN) {
                     throw Error.error(ErrorCode.X_42568);
@@ -1051,7 +1057,10 @@ public class QuerySpecification extends
         }
 
         if (queryCondition != null) {
-            queryCondition.resolveTypes(session, null);
+            rowExpression.setLeftNode(queryCondition);
+            queryCondition.resolveTypes(session, rowExpression);
+
+            queryCondition = rowExpression.getLeftNode();
 
             if (queryCondition.getDataType() != Type.SQL_BOOLEAN) {
                 throw Error.error(ErrorCode.X_42568);
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/RangeVariable.java 2.7.0-1/hsqldb/src/org/hsqldb/RangeVariable.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/RangeVariable.java	2021-10-10 20:33:04.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/RangeVariable.java	2022-04-21 06:32:20.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -695,6 +695,10 @@ public class RangeVariable {
         return joinCondition;
     }
 
+    public void setJoinCondition(Expression e) {
+        joinCondition = e;
+    }
+
     public void addJoinCondition(Expression e) {
         joinCondition = ExpressionLogical.andExpressions(joinCondition, e);
     }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/RangeVariableResolver.java 2.7.0-1/hsqldb/src/org/hsqldb/RangeVariableResolver.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/RangeVariableResolver.java	2021-10-10 20:33:04.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/RangeVariableResolver.java	2022-03-26 22:13:58.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -53,7 +53,7 @@ import org.hsqldb.persist.PersistentStor
  * processing and which indexes are used for table access.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.1
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class RangeVariableResolver {
@@ -741,7 +741,7 @@ public class RangeVariableResolver {
                 continue;
             }
 
-            for (int i = 0; i < starts.size(); i++) {
+            for (int i = 0; i < newRanges.length; i++) {
                 Table table = newRanges[i].rangeTable;
 
                 collectIndexableColumns(newRanges[i], starts);
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/ReferenceObject.java 2.7.0-1/hsqldb/src/org/hsqldb/ReferenceObject.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/ReferenceObject.java	2020-03-25 23:25:14.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/ReferenceObject.java	2022-02-21 14:42:04.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2020, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/resources/information-schema.sql 2.7.0-1/hsqldb/src/org/hsqldb/resources/information-schema.sql
--- 2.6.1-1/hsqldb/src/org/hsqldb/resources/information-schema.sql	2021-07-10 19:21:02.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/resources/information-schema.sql	2022-03-05 22:19:40.000000000 +0000
@@ -1,4 +1,4 @@
--- author Fred Toussi (fredt@users dot sourceforge.net) version 2.6.1
+-- author Fred Toussi (fredt@users dot sourceforge.net) version 2.7.0
 /*system_procedures*/
 SELECT ROUTINE_CATALOG AS PROCEDURE_CAT, ROUTINE_SCHEMA AS PROCEDURE_SCHEM,
 ROUTINE_NAME AS PROCEDURE_NAME, 0, 0, 0,
@@ -531,7 +531,13 @@ VALUES
 ('T652', 'SQL-dynamic statements in SQL routines', '', '', 'NO', NULL, ''),
 ('T653', 'SQL-schema statements in external routines', '', '', 'NO', NULL, ''),
 ('T654', 'SQL-dynamic statements in external routines', '', '', 'YES', NULL, ''),
-('T655', 'Cyclically dependent routines', '', '', 'YES', NULL, '');
+('T655', 'Cyclically dependent routines', '', '', 'YES', NULL, ''),
+('T811', 'Basic SQL/JSON constructor functions', '', '', 'YES', NULL, ''),
+('T812', 'SQL/JSON: JSON_OBJECTAGG with no <JSON key uniqueness constraint', '', '', 'YES', NULL, ''),
+('T813', 'SQL/JSON: JSON_ARRAYAGG with ORDER BY', '', '', 'YES', NULL, ''),
+('T814', 'Colon in JSON_OBJECT or JSON_OBJECTAGG', '', '', 'YES', NULL, ''),
+('T830', 'Enforcing unique keys in SQL/JSON constructor functions', '', '', 'YES', NULL, '');
+
 /*sql_packages*/
 VALUES
 ( 'PKG001', 'Enhanced datetime facilities','YES', CAST(NULL AS CHARACTER), '' ),
@@ -585,7 +591,7 @@ VALUES
 ( 23, 'CURSOR COMMIT BEHAVIOR', 2, NULL, 'INT: 0: close cursors & delete prepared stmts 1: close cursors & retain prepared stmts 2: leave cursors open & retain stmts' ),
 ( 2, 'DATA SOURCE NAME', NULL, '', 'CHAR: <connection name> on CONNECT statement' ),
 ( 17, 'DBMS NAME', NULL, 'HSQLDB', 'CHAR: Name of the implementation software' ),
-( 18, 'DBMS VERSION', NULL, '2.6.1', 'CHAR: Version of the implementation software The format is: <part1>.<part2>.<part3>[<part4>] where: <part1> ::= <digit><digit> <part2> ::= <digit><digit> <part3> ::= <digit><digit><digit><digit> <part4> ::= <character representation>' ),
+( 18, 'DBMS VERSION', NULL, '2.7.0', 'CHAR: Version of the implementation software The format is: <part1>.<part2>.<part3>[<part4>] where: <part1> ::= <digit><digit> <part2> ::= <digit><digit> <part3> ::= <digit><digit><digit><digit> <part4> ::= <character representation>' ),
 ( 26, 'DEFAULT TRANSACTION ISOLATION', 2, NULL, 'INT: 1: READ UNCOMMITTED 2: READ COMMITTED 3: REPEATABLE READ 4: SERIALIZABLE' ),
 ( 28, 'IDENTIFIER CASE', 3, NULL, 'The case in which identifiers are stored in the Definition Schema INT: 1: stored in upper case 2: stored in lower case 3: stored in mixed case - case sensitive 4: stored in mixed case - case insensitive' ),
 ( 85, 'NULL COLLATION', 1, NULL, 'INT: 0: nulls higher than non-nulls 1: nulls lower than non-nulls' ),
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/resources/info-table-remarks.properties 2.7.0-1/hsqldb/src/org/hsqldb/resources/info-table-remarks.properties
--- 2.6.1-1/hsqldb/src/org/hsqldb/resources/info-table-remarks.properties	2020-03-28 13:09:50.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/resources/info-table-remarks.properties	2022-03-31 20:44:58.000000000 +0000
@@ -13,7 +13,7 @@ SYSTEM_KEY_INDEX_USAGE=names of indexes
 SYSTEM_PRIMARYKEYS=the visible columns of the primary key of each accessible table defined within this database
 SYSTEM_PROCEDURECOLUMNS=a description of the return type, parameters and result columns of each accessible callable procedure, SQL function, trigger body and UDT method defined within this database
 SYSTEM_PROCEDURES=the procedures, SQL functions, trigger body routines and UDT methods defined within the database
-SYSTEM_PROPERTIES=the static and dynamic system properties and operating parameters of this database
+SYSTEM_PROPERTIES=the system properties and operating parameters of this database
 SYSTEM_SCHEMAS=the accessible schemas defined within this database
 SYSTEM_SEQUENCES=the visible sequences in this database
 SYSTEM_SESSIONINFO=information about the current database session
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/resources/jdklogging-default.properties 2.7.0-1/hsqldb/src/org/hsqldb/resources/jdklogging-default.properties
--- 2.6.1-1/hsqldb/src/org/hsqldb/resources/jdklogging-default.properties	2018-10-23 07:24:28.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/resources/jdklogging-default.properties	2022-07-07 16:32:28.000000000 +0000
@@ -1,4 +1,4 @@
-# $Id: jdklogging-default.properties 5440 2015-03-21 15:08:28Z unsaved $
+# $Id: jdklogging-default.properties 6572 2022-07-07 17:32:55Z fredt $
 
 # As this is a Java .properties file, use ISO-8859-1 encoding for any
 # extended characters.
@@ -22,6 +22,19 @@ handlers=java.util.logging.ConsoleHandle
 java.util.logging.ConsoleHandler.level=WARNING
 java.util.logging.ConsoleHandler.formatter=org.hsqldb.lib.BasicTextJdkLogFormatter
 
+# for use of custom ConsoleHandler uncomment below and comment out above two lines
+#org.hsqldb.lib.HsqlConsoleHandler.level=WARNING
+#for testing, comment out line above and uncomment line below
+#org.hsqldb.lib.HsqlConsoleHandler.level=INFO
+#org.hsqldb.lib.HsqlConsoleHandler.formatter=org.hsqldb.lib.BasicTextJdkLogFormatter
+
+#hsqldb.db.handlers=org.hsqldb.lib.HsqlConsoleHandler
+#hsqldb.db.useParentHandlers=false
+#org.hsqldb.auth.handlers=org.hsqldb.lib.HsqlConsoleHandler
+#org.hsqldb.auth.useParentHandlers=false
+#org.hsqldb.lib.FileUtil.handlers=org.hsqldb.lib.HsqlConsoleHandler
+#org.hsqldb.lib.FileUtil.useParentHandlers=false
+
 #java.util.logging.FileHandler.pattern=hsqldb.applog
 #java.util.logging.FileHandler.limit=50000
 #java.util.logging.FileHandler.count=1
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/resources/ResourceBundleHandler.java 2.7.0-1/hsqldb/src/org/hsqldb/resources/ResourceBundleHandler.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/resources/ResourceBundleHandler.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/resources/ResourceBundleHandler.java	2022-06-08 08:20:20.000000000 +0000
@@ -63,7 +63,7 @@ public final class ResourceBundleHandler
     /** The Locale used internally to fetch resource bundles. */
     private static Locale locale = Locale.getDefault();
 
-    /** Map:  Integer object handle => <code>ResourceBundle</code> object. */
+    /** Map:  Integer object handle maps to: <code>ResourceBundle</code> object. */
     private static HashMap bundleHandleMap = new HashMap();
 
     /** List whose elements are <code>ResourceBundle</code> objects */
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/result/Result.java 2.7.0-1/hsqldb/src/org/hsqldb/result/Result.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/result/Result.java	2021-07-09 16:59:12.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/result/Result.java	2022-06-03 13:24:24.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -69,7 +69,7 @@ import org.hsqldb.types.Type;
  *
  * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.1
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class Result {
@@ -266,7 +266,7 @@ public class Result {
 
             return result;
         } catch (IOException e) {
-            throw Error.error(ErrorCode.X_08000);
+            throw Error.error(ErrorCode.X_08000, e);
         }
     }
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/result/ResultLob.java 2.7.0-1/hsqldb/src/org/hsqldb/result/ResultLob.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/result/ResultLob.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/result/ResultLob.java	2022-03-26 22:13:30.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -47,7 +47,7 @@ import org.hsqldb.rowio.RowOutputInterfa
  * Sub-class of Result for communicating Blob and Clob operations.<p>
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.5.1
+ * @version 2.7.0
  * @since 1.9.0
  */
 public final class ResultLob extends Result {
@@ -105,7 +105,7 @@ public final class ResultLob extends Res
     }
 
     public static ResultLob newLobGetBytesRequest(long id, long offset,
-            int length) {
+            long length) {
 
         ResultLob result = new ResultLob();
 
@@ -118,7 +118,7 @@ public final class ResultLob extends Res
     }
 
     public static ResultLob newLobGetCharsRequest(long id, long offset,
-            int length) {
+            long length) {
 
         ResultLob result = new ResultLob();
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/rights/Grantee.java 2.7.0-1/hsqldb/src/org/hsqldb/rights/Grantee.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/rights/Grantee.java	2021-03-20 11:39:08.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/rights/Grantee.java	2022-06-08 08:20:48.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -72,7 +72,7 @@ import org.hsqldb.types.Type;
  * @author Fred Toussi (fredt@users dot sourceforge.net)
  * @author Blaine Simpson (blaine dot simpson at admc dot com)
  *
- * @version 2.6.0
+ * @version 2.7.0
  * @since 1.8.0
  */
 public class Grantee implements SchemaObject {
@@ -294,15 +294,45 @@ public class Grantee implements SchemaOb
         return getAllRoles().contains(role);
     }
 
+    private void grantToAll(HsqlName name, Right right, Grantee grantor,
+                            boolean withGrant) {
+
+        int objectType = SchemaObject.TABLE;
+
+        if (right.isFullUsage) {
+            right      = Right.fullRights;
+            objectType = SchemaObject.SEQUENCE;
+        } else if (right.isFullExecute) {
+            right      = Right.fullRights;
+            objectType = SchemaObject.SPECIFIC_ROUTINE;
+        }
+
+        Iterator it =
+            granteeManager.database.schemaManager.databaseObjectIterator(
+                name.name, objectType);
+
+        while (it.hasNext()) {
+            SchemaObject object = (SchemaObject) it.next();
+
+            grant(object.getName(), right, grantor, withGrant);
+        }
+    }
+
     /**
      * Grants the specified rights on the specified database object. <p>
      *
      * Keys stored in rightsMap for database tables are their HsqlName
-     * attribute. This allows rights to persist when a table is renamed. <p>
+     * attribute. This allows rights to persist when a table is renamed.
      */
     void grant(HsqlName name, Right right, Grantee grantor,
                boolean withGrant) {
 
+        if (name.type == SchemaObject.SCHEMA) {
+            grantToAll(name, right, grantor, withGrant);
+
+            return;
+        }
+
         final Right grantableRights = grantor.getAllGrantableRights(name);
         Right       existingRight   = null;
 
@@ -357,6 +387,30 @@ public class Grantee implements SchemaOb
         updateAllRights();
     }
 
+    private void revokeFromAll(HsqlName name, Right right, Grantee grantor,
+                               boolean grantOption) {
+
+        int objectType = SchemaObject.TABLE;
+
+        if (right.isFullUsage) {
+            right      = Right.fullRights;
+            objectType = SchemaObject.SEQUENCE;
+        } else if (right.isFullExecute) {
+            right      = Right.fullRights;
+            objectType = SchemaObject.SPECIFIC_ROUTINE;
+        }
+
+        Iterator it =
+            granteeManager.database.schemaManager.databaseObjectIterator(
+                name.name, objectType);
+
+        while (it.hasNext()) {
+            SchemaObject object = (SchemaObject) it.next();
+
+            revoke(object, right, grantor, grantOption);
+        }
+    }
+
     /**
      * Revokes the specified rights on the specified database object. <p>
      *
@@ -369,6 +423,12 @@ public class Grantee implements SchemaOb
 
         HsqlName name = object.getName();
 
+        if (name.type == SchemaObject.SCHEMA) {
+            grantToAll(name, right, grantor, grantOption);
+
+            return;
+        }
+
         if (object instanceof Routine) {
             name = ((Routine) object).getSpecificName();
         }
@@ -427,7 +487,7 @@ public class Grantee implements SchemaOb
     }
 
     /**
-     * Update own table column set rights to include a newly created column.<p?
+     * Update own table column set rights to include a newly created column.
      */
     void updateRightsForNewColumn(HsqlName tableName, HsqlName columnName) {
 
@@ -447,7 +507,7 @@ public class Grantee implements SchemaOb
     }
 
     /**
-     * Update granted rights to include a newly created column.<p?
+     * Update granted rights to include a newly created column.
      */
     void updateRightsForNewColumn(HsqlName tableName) {
 
@@ -860,7 +920,7 @@ public class Grantee implements SchemaOb
             return false;
         }
 
-        return right.canAccesssNonSelect();
+        return right.canAccessNonSelect();
     }
 
     public boolean hasColumnRights(SchemaObject table, int[] columnMap) {
@@ -936,10 +996,7 @@ public class Grantee implements SchemaOb
     /**
      * Method used with all Grantee objects to set the full set of rights
      * according to those inherited form ROLE Grantee objects and those
-     * granted to the object itself.<p>
-     *
-     * @todo -- see if this is correct and the currentRole.fullRightsMap
-     * is always updated prior to being added to this.fullRightsMap
+     * granted to the object itself.
      */
     void updateAllRights() {
 
@@ -1065,7 +1122,7 @@ public class Grantee implements SchemaOb
      * Retrieves the map object that represents the rights that have been
      * granted on database objects.  <p>
      *
-     * The map has keys and values with the following interpretation: <P>
+     * The map has keys and values with the following interpretation:
      *
      * <UL>
      * <LI> The keys are generally (but not limited to) objects having
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/rights/GranteeManager.java 2.7.0-1/hsqldb/src/org/hsqldb/rights/GranteeManager.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/rights/GranteeManager.java	2021-03-20 11:38:30.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/rights/GranteeManager.java	2022-05-22 18:09:56.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -65,7 +65,7 @@ import org.hsqldb.lib.java.JavaSystem;
  * @author Fred Toussi (fredt@users dot sourceforge.net)
  * @author Blaine Simpson (blaine dot simpson at admc dot com)
  *
- * @version 2.6.0
+ * @version 2.7.0
  * @since 1.8.0
  * @see Grantee
  */
@@ -88,6 +88,7 @@ public class GranteeManager {
             SqlInvariants.SYSTEM_SCHEMA_HSQLNAME);
 
         SqlInvariants.INFORMATION_SCHEMA_HSQLNAME.owner = systemAuthorisation;
+        SqlInvariants.SESSION_SCHEMA_HSQLNAME.owner     = systemAuthorisation;
         SqlInvariants.SYSTEM_SCHEMA_HSQLNAME.owner      = systemAuthorisation;
         SqlInvariants.LOBS_SCHEMA_HSQLNAME.owner        = systemAuthorisation;
         SqlInvariants.SQLJ_SCHEMA_HSQLNAME.owner        = systemAuthorisation;
@@ -232,7 +233,7 @@ public class GranteeManager {
      *  rights checks and tests will fail, since the HsqlName
      *  class implements its {@link HsqlName#hashCode() hashCode} and
      *  {@link HsqlName#equals equals} methods based on pure object
-     *  identity, rather than on attribute values. <p>
+     *  identity, rather than on attribute values.
      */
     public void grant(Session session, OrderedHashSet granteeList,
                       SchemaObject dbObject, Right right, Grantee grantor,
@@ -450,7 +451,7 @@ public class GranteeManager {
      * Revokes the rights represented by the rights argument on
      * the database object identified by the dbobject argument
      * from the User object identified by the name
-     * argument.<p>
+     * argument.
      * @see #grant
      */
     public void revoke(OrderedHashSet granteeList, SchemaObject dbObject,
@@ -519,7 +520,7 @@ public class GranteeManager {
 
     /**
      * Updates all the talbe level rights on a table after the addition of a
-     * column.<p>
+     * column.
      */
     public void updateAddColumn(HsqlName table, HsqlName column) {
 
@@ -659,7 +660,7 @@ public class GranteeManager {
     /**
      * Creates a new Role object under management of this object. <p>
      *
-     *  A set of constraints regarding user creation is imposed: <p>
+     *  A set of constraints regarding user creation is imposed:
      *
      *  <OL>
      *    <LI>Can't create a role with name same as any right.
@@ -787,13 +788,13 @@ public class GranteeManager {
      * Attempts to drop a Role with the specified name
      *  from this object's set. <p>
      *
-     *  A successful drop action consists of: <p>
+     *  A successful drop action consists of:
      *
      *  <UL>
      *
      *    <LI>removing the Grantee object with the specified name
      *        from the set.
-     *  </UL> <p>
+     *  </UL>
      *
      */
     public void dropRole(String name) {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/rights/Right.java 2.7.0-1/hsqldb/src/org/hsqldb/rights/Right.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/rights/Right.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/rights/Right.java	2022-05-14 09:52:40.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -46,7 +46,7 @@ import org.hsqldb.lib.OrderedHashSet;
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
  *
- * @version 2.5.1
+ * @version 2.7.0
  * @since 1.9.0
  */
 public final class Right {
@@ -55,9 +55,11 @@ public final class Right {
     boolean        isFullSelect;
     boolean        isFullInsert;
     boolean        isFullUpdate;
+    boolean        isFullDelete;
     boolean        isFullReferences;
     boolean        isFullTrigger;
-    boolean        isFullDelete;
+    boolean        isFullExecute;    // used only in temporary Right object
+    boolean        isFullUsage;      // ditto
     OrderedHashSet selectColumnSet;
     OrderedHashSet insertColumnSet;
     OrderedHashSet updateColumnSet;
@@ -86,11 +88,11 @@ public final class Right {
         fullRights.grantor = GranteeManager.systemAuthorisation;
     }
 
-    public static final String[] privilegeNames = {
+    public static final String[] tablePrivilegeNames = {
         Tokens.T_SELECT, Tokens.T_INSERT, Tokens.T_UPDATE, Tokens.T_DELETE,
         Tokens.T_REFERENCES, Tokens.T_TRIGGER
     };
-    public static final int[] privilegeTypes = {
+    public static final int[] tablePrivilegeTypes = {
         GrantConstants.SELECT, GrantConstants.INSERT, GrantConstants.UPDATE,
         GrantConstants.DELETE, GrantConstants.REFERENCES,
         GrantConstants.TRIGGER
@@ -121,7 +123,7 @@ public final class Right {
                                        : grantableRights;
     }
 
-    public Right duplicate() {
+    Right duplicate() {
 
         Right right = new Right();
 
@@ -194,7 +196,7 @@ public final class Right {
     /**
      * Supports column level GRANT
      */
-    public void add(Right right) {
+    void add(Right right) {
 
         if (isFull) {
             return;
@@ -275,7 +277,7 @@ public final class Right {
     /**
      * supports column level REVOKE
      */
-    public void remove(SchemaObject object, Right right) {
+    void remove(SchemaObject object, Right right) {
 
         if (right.isFull) {
             clear();
@@ -400,7 +402,7 @@ public final class Right {
     /**
      * supports column level GRANT / REVOKE
      */
-    public boolean isEmpty() {
+    boolean isEmpty() {
 
         if (isFull || isFullSelect || isFullInsert || isFullUpdate
                 || isFullReferences || isFullDelete) {
@@ -461,8 +463,7 @@ public final class Right {
         return set;
     }
 
-    // construction
-    public boolean contains(Right right) {
+    boolean contains(Right right) {
 
         if (isFull) {
             return true;
@@ -579,9 +580,10 @@ public final class Right {
         return true;
     }
 
-    static boolean containsRights(boolean isFull, OrderedHashSet columnSet,
-                                  OrderedHashSet otherColumnSet,
-                                  boolean otherIsFull) {
+    private static boolean containsRights(boolean isFull,
+                                          OrderedHashSet columnSet,
+                                          OrderedHashSet otherColumnSet,
+                                          boolean otherIsFull) {
 
         if (isFull) {
             return true;
@@ -664,41 +666,7 @@ public final class Right {
         return isFull || isFullDelete;
     }
 
-    public boolean canAccessFully(int action) {
-
-        if (isFull) {
-            return true;
-        }
-
-        switch (action) {
-
-            case GrantConstants.DELETE :
-                return isFullDelete;
-
-            case GrantConstants.SELECT :
-                return isFullSelect;
-
-            case GrantConstants.INSERT :
-                return isFullInsert;
-
-            case GrantConstants.UPDATE :
-                return isFullUpdate;
-
-            case GrantConstants.REFERENCES :
-                return isFullReferences;
-
-            case GrantConstants.TRIGGER :
-                return isFullTrigger;
-
-            case GrantConstants.EXECUTE :
-                return isFull;
-
-            default :
-                throw Error.runtimeError(ErrorCode.U_S0500, "Right");
-        }
-    }
-
-    public boolean canAccesssNonSelect() {
+    boolean canAccessNonSelect() {
 
         if (isFull) {
             return true;
@@ -778,7 +746,7 @@ public final class Right {
         }
     }
 
-    public boolean canAccess(Table table, int[] columnMap) {
+    boolean canAccess(Table table, int[] columnMap) {
 
         if (isFull) {
             return true;
@@ -847,7 +815,7 @@ public final class Right {
         };
     }
 
-    public boolean hasFilter() {
+    boolean hasFilter() {
         return selectFilter != null || deleteFilter != null
                || insertFilter != null || updateFilter != null;
     }
@@ -971,7 +939,7 @@ public final class Right {
         buf.append(')');
     }
 
-    public void addNewColumn(HsqlName name) {
+    void addNewColumn(HsqlName name) {
 
         if (selectColumnSet != null) {
             selectColumnSet.add(name);
@@ -1098,6 +1066,14 @@ public final class Right {
                 triggerColumnSet = set;
                 break;
 
+            case GrantConstants.EXECUTE :
+                isFullExecute = true;
+                break;
+
+            case GrantConstants.USAGE :
+                isFullUsage = true;
+                break;
+
             default :
         }
     }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/rights/UserManager.java 2.7.0-1/hsqldb/src/org/hsqldb/rights/UserManager.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/rights/UserManager.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/rights/UserManager.java	2022-05-22 18:09:56.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -94,7 +94,7 @@ public final class UserManager {
     /**
      * Creates a new User object under management of this object. <p>
      *
-     *  A set of constraints regarding user creation is imposed: <p>
+     *  A set of constraints regarding user creation is imposed:
      *
      *  <OL>
      *    <LI>If the specified name is null, then an
@@ -165,7 +165,7 @@ public final class UserManager {
      * Attempts to drop a User object with the specified name
      *  from this object's set. <p>
      *
-     *  A successful drop action consists of: <p>
+     *  A successful drop action consists of:
      *
      *  <UL>
      *
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/RowActionBase.java 2.7.0-1/hsqldb/src/org/hsqldb/RowActionBase.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/RowActionBase.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/RowActionBase.java	2022-07-13 15:38:30.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -43,7 +43,7 @@ package org.hsqldb;
  * timestamps are not in any order
  *
  * @author Fred Toussi (fredt@users dot sourceforge dot net)
- * @version 2.3.2
+ * @version 2.7.0
 
  * @since 2.0.0
  */
@@ -59,15 +59,15 @@ public class RowActionBase {
     public static final byte ACTION_DEBUG         = 7;
 
     //
-    RowActionBase            next;
-    Session                  session;
-    long                     actionTimestamp;
-    long                     commitTimestamp;
-    byte                     type;
-    boolean                  deleteComplete;
-    boolean                  rolledback;
-    boolean                  prepared;
-    int[]                    changeColumnMap;
+    RowActionBase next;
+    Session       session;
+    long          actionSCN;
+    long          commitSCN;
+    byte          type;
+    boolean       deleteComplete;
+    boolean       rolledback;
+    boolean       prepared;
+    int[]         changeColumnMap;
 
     RowActionBase() {}
 
@@ -76,17 +76,17 @@ public class RowActionBase {
      */
     RowActionBase(Session session, byte type) {
 
-        this.session    = session;
-        this.type       = type;
-        actionTimestamp = session.actionTimestamp;
+        this.session = session;
+        this.type    = type;
+        actionSCN    = session.actionSCN;
     }
 
     void setAsAction(RowActionBase action) {
 
         next            = action.next;
         session         = action.session;
-        actionTimestamp = action.actionTimestamp;
-        commitTimestamp = action.commitTimestamp;
+        actionSCN       = action.actionSCN;
+        commitSCN       = action.commitSCN;
         type            = action.type;
         deleteComplete  = action.deleteComplete;
         rolledback      = action.rolledback;
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/RowAction.java 2.7.0-1/hsqldb/src/org/hsqldb/RowAction.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/RowAction.java	2021-01-29 13:34:34.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/RowAction.java	2022-07-13 15:38:30.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -41,7 +41,7 @@ import org.hsqldb.persist.PersistentStor
  * Represents the chain of insert / delete / rollback / commit actions on a row.
  *
  * @author Fred Toussi (fredt@users dot sourceforge dot net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 2.0.0
  */
 public class RowAction extends RowActionBase {
@@ -101,7 +101,7 @@ public class RowAction extends RowAction
 
         this.session         = session;
         this.type            = type;
-        this.actionTimestamp = session.actionTimestamp;
+        this.actionSCN       = session.actionSCN;
         this.table           = table;
         this.store           = store;
         this.memoryRow       = row;
@@ -136,7 +136,7 @@ public class RowAction extends RowAction
                 switch (action.type) {
 
                     case ACTION_INSERT : {
-                        if (action.commitTimestamp == 0
+                        if (action.commitSCN == 0
                                 && session != action.session) {
                             throw Error.runtimeError(ErrorCode.U_S0500,
                                                      "RowAction");
@@ -147,7 +147,7 @@ public class RowAction extends RowAction
                     case ACTION_DELETE_FINAL :
                     case ACTION_DELETE : {
                         if (session != action.session) {
-                            if (action.commitTimestamp == 0) {
+                            if (action.commitSCN == 0) {
                                 if (!session.actionSet.isEmpty()) {
                                     session.actionSet.clear();
                                 }
@@ -162,7 +162,7 @@ public class RowAction extends RowAction
                     }
                     case ACTION_REF : {
                         if (session != action.session
-                                && action.commitTimestamp == 0) {
+                                && action.commitSCN == 0) {
                             if (colMap == null
                                     || ArrayUtil.haveCommonElement(
                                         colMap, action.changeColumnMap)) {
@@ -213,18 +213,17 @@ public class RowAction extends RowAction
             if (session == action.session) {
                 if (action.type == ACTION_REF
                         && action.changeColumnMap == colMap
-                        && action.commitTimestamp == 0) {
+                        && action.commitSCN == 0) {
                     return false;
                 }
 
                 if (action.type == ACTION_INSERT) {
-                    if (action.commitTimestamp == 0) {
+                    if (action.commitSCN == 0) {
                         return false;
                     }
                 }
             } else {
-                if (action.type == ACTION_DELETE
-                        && action.commitTimestamp == 0) {
+                if (action.type == ACTION_DELETE && action.commitSCN == 0) {
                     if (action.changeColumnMap == null
                             || ArrayUtil.haveCommonElement(
                                 colMap, action.changeColumnMap)) {
@@ -256,9 +255,9 @@ public class RowAction extends RowAction
 
     synchronized void setNoOpAsAction(Session session, byte type) {
 
-        this.session    = session;
-        this.type       = type;
-        actionTimestamp = session.actionTimestamp;
+        this.session = session;
+        this.type    = type;
+        actionSCN    = session.actionSCN;
     }
 
     synchronized void setAsAction(RowActionBase action) {
@@ -270,8 +269,8 @@ public class RowAction extends RowAction
 //        memoryRow       = null;
         session         = null;
         type            = ACTION_NONE;
-        actionTimestamp = 0;
-        commitTimestamp = 0;
+        actionSCN       = 0;
+        commitSCN       = 0;
         rolledback      = false;
         deleteComplete  = false;
         prepared        = false;
@@ -282,8 +281,8 @@ public class RowAction extends RowAction
     private void setAsDeleteFinal(long timestamp) {
 
         type            = ACTION_DELETE_FINAL;
-        actionTimestamp = 0;
-        commitTimestamp = timestamp;
+        actionSCN       = 0;
+        commitSCN       = timestamp;
         rolledback      = false;
         deleteComplete  = false;
         prepared        = false;
@@ -297,7 +296,7 @@ public class RowAction extends RowAction
         RowActionBase action = this;
 
         do {
-            if (action.session == session && action.commitTimestamp == 0) {
+            if (action.session == session && action.commitSCN == 0) {
                 action.prepared = true;
             }
 
@@ -311,9 +310,9 @@ public class RowAction extends RowAction
         int           actiontype = ACTION_NONE;
 
         do {
-            if (action.session == session && action.commitTimestamp == 0) {
-                action.commitTimestamp = session.actionTimestamp;
-                action.prepared        = false;
+            if (action.session == session && action.commitSCN == 0) {
+                action.commitSCN = session.actionSCN;
+                action.prepared  = false;
 
                 if (action.type == ACTION_INSERT) {
                     actiontype = action.type;
@@ -339,7 +338,7 @@ public class RowAction extends RowAction
         RowActionBase action = this;
 
         do {
-            if (action.commitTimestamp != 0) {
+            if (action.commitSCN != 0) {
                 if (action.type == ACTION_DELETE
                         || action.type == ACTION_DELETE_FINAL) {
                     return true;
@@ -370,7 +369,7 @@ public class RowAction extends RowAction
         int           actionType = ACTION_NONE;
 
         do {
-            if (action.commitTimestamp == timestamp) {
+            if (action.commitSCN == timestamp) {
                 if (action.type == ACTION_INSERT) {
                     actionType = action.type;
                 } else if (action.type == ACTION_DELETE) {
@@ -396,7 +395,7 @@ public class RowAction extends RowAction
     synchronized boolean canCommit(Session session) {
 
         RowActionBase action;
-        long          timestamp       = session.transactionTimestamp;
+        long          timestamp       = session.transactionSCN;
         long          commitTimestamp = 0;
         final boolean readCommitted = session.isolationLevel
                                       == SessionInterface.TX_READ_COMMITTED;
@@ -410,8 +409,8 @@ public class RowAction extends RowAction
                         && action.type == ACTION_DELETE) {
 
                     // for READ_COMMITTED, use action timestamp for later conflicts
-                    if (action.commitTimestamp == 0) {
-                        timestamp = action.actionTimestamp;
+                    if (action.commitSCN == 0) {
+                        timestamp = action.actionSCN;
                     }
                 }
 
@@ -437,10 +436,10 @@ public class RowAction extends RowAction
                     return false;
                 }
 
-                if (action.commitTimestamp == 0) {
+                if (action.commitSCN == 0) {
                     session.actionSet.add(action);
-                } else if (action.commitTimestamp > commitTimestamp) {
-                    commitTimestamp = action.commitTimestamp;
+                } else if (action.commitSCN > commitTimestamp) {
+                    commitTimestamp = action.commitSCN;
                 }
             }
 
@@ -486,7 +485,7 @@ public class RowAction extends RowAction
                 }
 
                 if (readCommitted) {
-                    if (action.commitTimestamp > session.actionTimestamp) {
+                    if (action.commitSCN > session.actionSCN) {
 
                         // 2.0 -- investigate
                         // can redo - if deletes
@@ -495,13 +494,12 @@ public class RowAction extends RowAction
                         set.add(session);
 
                         result = false;
-                    } else if (action.commitTimestamp == 0) {
+                    } else if (action.commitSCN == 0) {
                         set.add(action.session);
 
                         result = false;
                     }
-                } else if (action.commitTimestamp
-                           > session.transactionTimestamp) {
+                } else if (action.commitSCN > session.transactionSCN) {
                     return false;
                 }
             }
@@ -552,11 +550,11 @@ public class RowAction extends RowAction
         RowActionBase action = this;
 
         do {
-            if (action.session == session && action.commitTimestamp == 0) {
-                if (action.actionTimestamp >= timestamp) {
-                    action.commitTimestamp = session.actionTimestamp;
-                    action.rolledback      = true;
-                    action.prepared        = false;
+            if (action.session == session && action.commitSCN == 0) {
+                if (action.actionSCN >= timestamp) {
+                    action.commitSCN  = session.actionSCN;
+                    action.rolledback = true;
+                    action.prepared   = false;
                 }
             }
 
@@ -641,8 +639,8 @@ public class RowAction extends RowAction
         do {
             boolean expired = false;
 
-            if (action.commitTimestamp != 0) {
-                if (action.commitTimestamp <= timestamp) {
+            if (action.commitSCN != 0) {
+                if (action.commitSCN <= timestamp) {
                     expired = true;
                 } else if (action.type == ACTION_REF) {
                     expired = true;
@@ -711,13 +709,13 @@ public class RowAction extends RowAction
                     break;
 
                 case SessionInterface.TX_READ_COMMITTED :
-                    threshold = session.actionTimestamp;
+                    threshold = session.actionSCN;
                     break;
 
                 case SessionInterface.TX_REPEATABLE_READ :
                 case SessionInterface.TX_SERIALIZABLE :
                 default :
-                    threshold = session.transactionTimestamp;
+                    threshold = session.transactionSCN;
                     break;
             }
         }
@@ -749,7 +747,7 @@ public class RowAction extends RowAction
                 action = action.next;
 
                 continue;
-            } else if (action.commitTimestamp == 0) {
+            } else if (action.commitSCN == 0) {
                 if (action.type == ACTION_NONE) {
                     throw Error.runtimeError(ErrorCode.U_S0500, "RowAction");
                 } else if (action.type == ACTION_INSERT) {
@@ -777,7 +775,7 @@ public class RowAction extends RowAction
                 action = action.next;
 
                 continue;
-            } else if (action.commitTimestamp < threshold) {
+            } else if (action.commitSCN < threshold) {
                 if (action.type == ACTION_DELETE) {
                     actionType = ACTION_DELETE;
                 } else if (action.type == ACTION_INSERT) {
@@ -813,7 +811,7 @@ public class RowAction extends RowAction
         RowActionBase action = this;
 
         do {
-            if (action.type == ACTION_REF && action.commitTimestamp == 0) {
+            if (action.type == ACTION_REF && action.commitSCN == 0) {
                 return true;
             }
 
@@ -848,10 +846,10 @@ public class RowAction extends RowAction
             }
 
             sb.append(action.session.getId()).append(' ');
-            sb.append(action.type).append(' ').append(action.actionTimestamp);
-            sb.append(' ').append(action.commitTimestamp);
+            sb.append(action.type).append(' ').append(action.actionSCN);
+            sb.append(' ').append(action.commitSCN);
 
-            if (action.commitTimestamp != 0) {
+            if (action.commitSCN != 0) {
                 if (action.rolledback) {
                     sb.append('r');
                 } else {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/rowio/RowInputBinary180.java 2.7.0-1/hsqldb/src/org/hsqldb/rowio/RowInputBinary180.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/rowio/RowInputBinary180.java	2015-03-27 15:35:48.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/rowio/RowInputBinary180.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,96 +0,0 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions are met:
- *
- * Redistributions of source code must retain the above copyright notice, this
- * list of conditions and the following disclaimer.
- *
- * Redistributions in binary form must reproduce the above copyright notice,
- * this list of conditions and the following disclaimer in the documentation
- * and/or other materials provided with the distribution.
- *
- * Neither the name of the HSQL Development Group nor the names of its
- * contributors may be used to endorse or promote products derived from this
- * software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
- * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED. IN NO EVENT SHALL HSQL DEVELOPMENT GROUP, HSQLDB.ORG,
- * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
- * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
- * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
- * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
- * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
- * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
- * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- */
-
-
-package org.hsqldb.rowio;
-
-import java.util.Calendar;
-import java.util.GregorianCalendar;
-
-import org.hsqldb.HsqlDateTime;
-import org.hsqldb.types.TimeData;
-import org.hsqldb.types.TimestampData;
-import org.hsqldb.types.Type;
-import org.hsqldb.types.Types;
-
-/**
- * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.3.3
- * @since 1.9.0
- */
-public class RowInputBinary180 extends RowInputBinary {
-
-    Calendar tempCalDefault = new GregorianCalendar();
-
-    public RowInputBinary180(byte[] buf) {
-        super(buf);
-    }
-
-    protected TimeData readTime(Type type) {
-
-        if (type.typeCode == Types.SQL_TIME) {
-            long millis = readLong();
-
-            millis = HsqlDateTime.convertMillisFromCalendar(tempCalDefault,
-                    millis);
-            millis = HsqlDateTime.getNormalisedTime(millis);
-
-            return new TimeData((int) (millis / 1000), 0, 0);
-        } else {
-            return new TimeData(readInt(), readInt(), readInt());
-        }
-    }
-
-    protected TimestampData readDate(Type type) {
-
-        long millis = readLong();
-
-        millis = HsqlDateTime.convertMillisFromCalendar(tempCalDefault,
-                millis);
-        millis = HsqlDateTime.getNormalisedDate(millis);
-
-        return new TimestampData(millis / 1000);
-    }
-
-    protected TimestampData readTimestamp(Type type) {
-
-        if (type.typeCode == Types.SQL_TIMESTAMP) {
-            long millis = readLong();
-            int  nanos  = readInt();
-
-            millis = HsqlDateTime.convertMillisFromCalendar(tempCalDefault,
-                    millis);
-
-            return new TimestampData(millis / 1000, nanos);
-        } else {
-            return new TimestampData(readLong(), readInt(), readInt());
-        }
-    }
-}
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/rowio/RowInputText.java 2.7.0-1/hsqldb/src/org/hsqldb/rowio/RowInputText.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/rowio/RowInputText.java	2021-01-03 20:46:40.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/rowio/RowInputText.java	2022-05-22 18:09:56.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -34,7 +34,6 @@ package org.hsqldb.rowio;
 import java.math.BigDecimal;
 
 import org.hsqldb.Scanner;
-import org.hsqldb.Tokens;
 import org.hsqldb.error.Error;
 import org.hsqldb.error.ErrorCode;
 import org.hsqldb.map.ValuePool;
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/rowio/RowInputTextLog.java 2.7.0-1/hsqldb/src/org/hsqldb/rowio/RowInputTextLog.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/rowio/RowInputTextLog.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/rowio/RowInputTextLog.java	2022-05-21 10:13:50.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -32,10 +32,7 @@
 package org.hsqldb.rowio;
 
 import java.math.BigDecimal;
-import java.util.Calendar;
-import java.util.GregorianCalendar;
 
-import org.hsqldb.HsqlDateTime;
 import org.hsqldb.HsqlException;
 import org.hsqldb.Scanner;
 import org.hsqldb.Session;
@@ -50,7 +47,6 @@ import org.hsqldb.types.BlobData;
 import org.hsqldb.types.BlobDataID;
 import org.hsqldb.types.ClobData;
 import org.hsqldb.types.ClobDataID;
-import org.hsqldb.types.DateTimeType;
 import org.hsqldb.types.IntervalMonthData;
 import org.hsqldb.types.IntervalSecondData;
 import org.hsqldb.types.IntervalType;
@@ -63,7 +59,7 @@ import org.hsqldb.types.Type;
  * Class for reading the data for a database row from the script file.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.5.0
+ * @version 2.7.0
  * @since 1.7.3
  */
 public class RowInputTextLog extends RowInputBase
@@ -74,9 +70,7 @@ implements RowInputInterface {
     String   schemaName = null;
     int      statementType;
     Object   value;
-    boolean  version18;
     boolean  noSeparators;
-    Calendar tempCalDefault = new GregorianCalendar();
 
     public RowInputTextLog() {
 
@@ -85,14 +79,6 @@ implements RowInputInterface {
         scanner = new Scanner();
     }
 
-    public RowInputTextLog(boolean version18) {
-
-        super(new byte[0]);
-
-        scanner        = new Scanner();
-        this.version18 = version18;
-    }
-
     public void setSource(Session session, String text) {
 
         scanner.reset(session, text);
@@ -337,17 +323,6 @@ implements RowInputInterface {
             return null;
         }
 
-        if (version18) {
-            java.sql.Time dateTime = java.sql.Time.valueOf((String) value);
-            long millis =
-                HsqlDateTime.convertMillisFromCalendar(tempCalDefault,
-                    dateTime.getTime());
-
-            millis = HsqlDateTime.getNormalisedTime(millis);
-
-            return new TimeData((int) millis / 1000, 0, 0);
-        }
-
         return scanner.newTime((String) value);
     }
 
@@ -359,17 +334,6 @@ implements RowInputInterface {
             return null;
         }
 
-        if (version18) {
-            java.sql.Date dateTime = java.sql.Date.valueOf((String) value);
-            long millis =
-                HsqlDateTime.convertMillisFromCalendar(tempCalDefault,
-                    dateTime.getTime());
-
-            millis = HsqlDateTime.getNormalisedDate(millis);
-
-            return new TimestampData(millis / 1000);
-        }
-
         return scanner.newDate((String) value);
     }
 
@@ -381,19 +345,6 @@ implements RowInputInterface {
             return null;
         }
 
-        if (version18) {
-            java.sql.Timestamp dateTime =
-                java.sql.Timestamp.valueOf((String) value);
-            long millis =
-                HsqlDateTime.convertMillisFromCalendar(tempCalDefault,
-                    dateTime.getTime());
-            int nanos = dateTime.getNanos();
-
-            nanos = DateTimeType.normaliseFraction(nanos, type.scale);
-
-            return new TimestampData(millis / 1000, nanos, 0);
-        }
-
         return scanner.newTimestamp((String) value);
     }
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/rowio/RowOutputBinary180.java 2.7.0-1/hsqldb/src/org/hsqldb/rowio/RowOutputBinary180.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/rowio/RowOutputBinary180.java	2012-04-05 23:03:32.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/rowio/RowOutputBinary180.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,97 +0,0 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions are met:
- *
- * Redistributions of source code must retain the above copyright notice, this
- * list of conditions and the following disclaimer.
- *
- * Redistributions in binary form must reproduce the above copyright notice,
- * this list of conditions and the following disclaimer in the documentation
- * and/or other materials provided with the distribution.
- *
- * Neither the name of the HSQL Development Group nor the names of its
- * contributors may be used to endorse or promote products derived from this
- * software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
- * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED. IN NO EVENT SHALL HSQL DEVELOPMENT GROUP, HSQLDB.ORG,
- * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
- * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
- * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
- * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
- * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
- * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
- * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- */
-
-
-package org.hsqldb.rowio;
-
-import java.util.Calendar;
-import java.util.GregorianCalendar;
-
-import org.hsqldb.HsqlDateTime;
-import org.hsqldb.types.TimeData;
-import org.hsqldb.types.TimestampData;
-import org.hsqldb.types.Type;
-import org.hsqldb.types.Types;
-
-/**
- * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.2.9
- * @since 1.9.0
- */
-public class RowOutputBinary180 extends RowOutputBinary {
-
-    Calendar tempCalDefault = new GregorianCalendar();
-
-    public RowOutputBinary180(int initialSize, int scale) {
-        super(initialSize, scale);
-    }
-
-    protected void writeDate(TimestampData o, Type type) {
-
-        long millis = o.getSeconds() * 1000L;
-
-        millis = HsqlDateTime.convertMillisToCalendar(tempCalDefault, millis);
-
-        writeLong(millis);
-    }
-
-    protected void writeTime(TimeData o, Type type) {
-
-        if (type.typeCode == Types.SQL_TIME) {
-            long millis = o.getSeconds() * 1000L;
-
-            millis = HsqlDateTime.convertMillisToCalendar(tempCalDefault,
-                    millis);
-
-            writeLong(millis);
-        } else {
-            writeInt(o.getSeconds());
-            writeInt(o.getNanos());
-            writeInt(o.getZone());
-        }
-    }
-
-    protected void writeTimestamp(TimestampData o, Type type) {
-
-        if (type.typeCode == Types.SQL_TIMESTAMP) {
-            long millis = o.getSeconds() * 1000L;
-
-            millis = HsqlDateTime.convertMillisToCalendar(tempCalDefault,
-                    millis);
-
-            writeLong(millis);
-            writeInt(o.getNanos());
-        } else {
-            writeLong(o.getSeconds());
-            writeInt(o.getNanos());
-            writeInt(o.getZone());
-        }
-    }
-}
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/sample/FindFile.java 2.7.0-1/hsqldb/src/org/hsqldb/sample/FindFile.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/sample/FindFile.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/sample/FindFile.java	2022-05-22 18:09:56.000000000 +0000
@@ -1,7 +1,7 @@
 /*
  * For work developed by the HSQL Development Group:
  *
- * Copyright (c) 2001-2021, The HSQL Development Group
+ * Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -91,7 +91,7 @@ class FindFile {
 
     /**
      * Extracts a directory tree and stores it ina HSQLDB database.<br>
-     * Usage:<p>
+     * Usage:
      * <pre>
      * java org.hsqldb.sample.FindFile -init .
      * Re-create database from directory '.'
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/Scanner.java 2.7.0-1/hsqldb/src/org/hsqldb/Scanner.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/Scanner.java	2021-06-11 15:08:06.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/Scanner.java	2022-03-12 19:28:04.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -40,7 +40,6 @@ import org.hsqldb.lib.ArrayUtil;
 import org.hsqldb.lib.CharArrayWriter;
 import org.hsqldb.lib.HsqlByteArrayOutputStream;
 import org.hsqldb.lib.OrderedIntHashSet;
-import org.hsqldb.lib.java.JavaSystem;
 import org.hsqldb.map.BitMap;
 import org.hsqldb.map.ValuePool;
 import org.hsqldb.types.BinaryData;
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/SchemaManager.java 2.7.0-1/hsqldb/src/org/hsqldb/SchemaManager.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/SchemaManager.java	2021-03-18 00:31:36.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/SchemaManager.java	2022-07-13 15:38:30.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -55,7 +55,7 @@ import org.hsqldb.types.Type;
  * Manages all SCHEMA related database objects
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 1.8.0
  */
 public class SchemaManager {
@@ -108,7 +108,7 @@ public class SchemaManager {
     }
 
     public void setSchemaChangeTimestamp() {
-        schemaChangeTimestamp = database.txManager.getGlobalChangeTimestamp();
+        schemaChangeTimestamp = database.txManager.getSystemChangeNumber();
     }
 
     public long getSchemaChangeTimestamp() {
@@ -1836,6 +1836,10 @@ public class SchemaManager {
         readLock.lock();
 
         try {
+            if (type == SchemaObject.SCHEMA) {
+                return getSchemaHsqlName(name);
+            }
+
             Schema          schema = (Schema) schemaMap.get(schemaName.name);
             SchemaObjectSet set    = null;
 
@@ -1875,7 +1879,10 @@ public class SchemaManager {
         readLock.lock();
 
         try {
-            Schema schema = (Schema) schemaMap.get(name.schema.name);
+            String nameString = name.type == SchemaObject.SCHEMA ? name.name
+                                                                 : name.schema
+                                                                     .name;
+            Schema schema = (Schema) schemaMap.get(nameString);
 
             if (schema == null) {
                 return null;
@@ -1960,6 +1967,9 @@ public class SchemaManager {
 
                 case SchemaObject.REFERENCE :
                     return schema.referenceLookup.getObject(name.name);
+
+                case SchemaObject.SCHEMA :
+                    return schema;
             }
 
             return null;
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/scriptio/ScriptReaderText.java 2.7.0-1/hsqldb/src/org/hsqldb/scriptio/ScriptReaderText.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/scriptio/ScriptReaderText.java	2021-01-29 13:34:34.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/scriptio/ScriptReaderText.java	2022-05-21 10:13:50.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -60,7 +60,7 @@ import org.hsqldb.types.Type;
  * corresponds to ScriptWriterText.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- *  @version 2.6.0
+ *  @version 2.7.0
  *  @since 1.7.2
  */
 public class ScriptReaderText extends ScriptReaderBase {
@@ -96,7 +96,7 @@ public class ScriptReaderText extends Sc
         }
 
         dataStreamIn = new LineReader(tempStream, JavaSystem.CS_ISO_8859_1);
-        rowIn        = new RowInputTextLog(false);
+        rowIn        = new RowInputTextLog();
     }
 
     public void readAll(Session session) {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/scriptio/ScriptWriterBase.java 2.7.0-1/hsqldb/src/org/hsqldb/scriptio/ScriptWriterBase.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/scriptio/ScriptWriterBase.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/scriptio/ScriptWriterBase.java	2022-06-03 13:24:24.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -87,7 +87,7 @@ import org.hsqldb.types.TimestampData;
  * DatabaseScriptReader and its subclasses read back the data at startup time.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.5.1
+ * @version 2.7.0
  * @since 1.7.2
  */
 public abstract class ScriptWriterBase implements Runnable {
@@ -247,7 +247,7 @@ public abstract class ScriptWriterBase i
                 isClosed      = true;
             }
         } catch (IOException e) {
-            throw Error.error(ErrorCode.FILE_IO_ERROR);
+            throw Error.error(ErrorCode.FILE_IO_ERROR, e);
         }
 
         byteCount = 0;
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/scriptio/ScriptWriterTextColumnNames.java 2.7.0-1/hsqldb/src/org/hsqldb/scriptio/ScriptWriterTextColumnNames.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/scriptio/ScriptWriterTextColumnNames.java	2020-04-05 12:44:28.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/scriptio/ScriptWriterTextColumnNames.java	2022-02-21 14:42:02.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2020, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/server/HsqlSocketFactory.java 2.7.0-1/hsqldb/src/org/hsqldb/server/HsqlSocketFactory.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/server/HsqlSocketFactory.java	2021-02-09 04:49:04.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/server/HsqlSocketFactory.java	2022-05-17 11:10:04.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -95,12 +95,12 @@ public class HsqlSocketFactory {
     }
 
     /**
-     * Returns a server socket bound to the specified port.
-     * The socket is configured with the socket options
-     * given to this factory.
+     * Returns a server socket bound to the specified port. The socket is
+     * configured with the socket options given to this factory.
      *
      * @return the ServerSocket
      * @param port the port to which to bind the ServerSocket
+     * @param address String
      * @throws Exception if a network error occurs
      */
     public ServerSocket createServerSocket(int port,
@@ -150,7 +150,7 @@ public class HsqlSocketFactory {
     }
 
 // ------------------------ static utility methods -----------------------------
-    private static HsqlSocketFactory getPlainImpl() throws Exception {
+    private static HsqlSocketFactory getPlainImpl() {
 
         synchronized (HsqlSocketFactory.class) {
             if (plainImpl == null) {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/server/HsqlSocketFactorySecure.java 2.7.0-1/hsqldb/src/org/hsqldb/server/HsqlSocketFactorySecure.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/server/HsqlSocketFactorySecure.java	2021-02-09 17:42:38.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/server/HsqlSocketFactorySecure.java	2022-06-08 08:55:44.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -65,22 +65,22 @@ implements HandshakeCompletedListener {
 // --------------------------------- members -----------------------------------
 
     /** The underlying socket factory implementation. */
-    protected Object socketFactory;
+    Object socketFactory;
 
     /** The underlying server socket factory implementation. */
-    protected Object serverSocketFactory;
+    Object serverSocketFactory;
 
     /**
      * Monitor object to guard against concurrent modification
      * of the underlying socket factory implementation member.
      */
-    protected final Object socket_factory_mutex = new Object();
+    final Object socket_factory_mutex = new Object();
 
     /**
      * Monitor object to guard against concurrent modification of
      * the underlying server socket factory implementation member.
      */
-    protected final Object server_socket_factory_mutex = new Object();
+    final Object server_socket_factory_mutex = new Object();
 
 // ------------------------------ constructors ---------------------------------
 
@@ -88,7 +88,7 @@ implements HandshakeCompletedListener {
      * External construction disabled.  New factory instances are retrieved
      * through the newHsqlSocketFactory method instead.
      */
-    protected HsqlSocketFactorySecure() throws Exception {
+    HsqlSocketFactorySecure() {
         super();
     }
 
@@ -277,11 +277,9 @@ implements HandshakeCompletedListener {
     /**
      * Retrieves the underlying javax.net.ssl.SSLServerSocketFactory.
      *
-     * @throws Exception if there is a problem retrieving the
-     *      underlying factory
      * @return the underlying javax.net.ssl.SSLServerSocketFactory
      */
-    protected SSLServerSocketFactory getServerSocketFactoryImpl() {
+    SSLServerSocketFactory getServerSocketFactoryImpl() {
 
         Object factory;
 
@@ -300,11 +298,9 @@ implements HandshakeCompletedListener {
     /**
      * Retrieves the underlying javax.net.ssl.SSLSocketFactory.
      *
-     * @throws Exception if there is a problem retrieving the
-     *      underlying factory
      * @return the underlying javax.net.ssl.SSLSocketFactory
      */
-    protected SSLSocketFactory getSocketFactoryImpl() {
+    SSLSocketFactory getSocketFactoryImpl() {
 
         Object factory;
 
@@ -330,7 +326,7 @@ implements HandshakeCompletedListener {
      * @param session SSLSession used on the connection to host
      * @throws Exception if the certificate chain cannot be verified
      */
-    protected void verify(String host, SSLSession session) throws Exception {
+    void verify(String host, SSLSession session) throws Exception {
 
         Certificate[]   chain;
         X509Certificate certificate;
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/server/OdbcUtil.java 2.7.0-1/hsqldb/src/org/hsqldb/server/OdbcUtil.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/server/OdbcUtil.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/server/OdbcUtil.java	2022-05-17 11:13:12.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -226,6 +226,10 @@ public class OdbcUtil {
      * This ID should stick with the table
      * column.  Here, it will change based on user-specified column label.
      * The int has is also being truncated into a short.
+     *
+     * @param colIndex int
+     * @param md ResultMetaData
+     * @return short
      */
     public static short getIdForColumn(int colIndex, ResultMetaData md) {
         if (!md.isTableColumn(colIndex)) {
@@ -241,8 +245,9 @@ public class OdbcUtil {
     }
 
     /**
-     * @param hexChars A String containing an EVEN number of hex
-     *                      characters.
+     *
+     * @param hexChars A String containing an EVEN number of hex characters.
+     * @return String
      */
     public static String hexCharsToOctalOctets(String hexChars) {
         int chars = hexChars.length();
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/server/PgType.java 2.7.0-1/hsqldb/src/org/hsqldb/server/PgType.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/server/PgType.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/server/PgType.java	2022-05-17 12:18:14.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -30,7 +30,7 @@
 
 
 /*
- * $Id: PgType.java 6266 2021-01-25 16:08:06Z fredt $
+ * $Id: PgType.java 6509 2022-05-17 13:18:08Z fredt $
  */
 
 package org.hsqldb.server;
@@ -275,6 +275,10 @@ public class PgType {
      * </P>
      *
      * @throws SQLException if either argument is not acceptable.
+     * @throws RecoverableOdbcFailure for some unsupported features
+     * @param inString String
+     * @param session Session
+     * @return Object
      */
     public Object getParameter(String inString, Session session)
     throws SQLException, RecoverableOdbcFailure {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/server/ServerAcl.java 2.7.0-1/hsqldb/src/org/hsqldb/server/ServerAcl.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/server/ServerAcl.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/server/ServerAcl.java	2022-04-21 16:08:00.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -95,10 +95,10 @@ public final class ServerAcl {
         }
     }
 
-    protected static final byte[] ALL_SET_4BYTES  = new byte[] {
+    static final byte[] ALL_SET_4BYTES  = new byte[] {
         -1, -1, -1, -1
     };
-    protected static final byte[] ALL_SET_16BYTES = new byte[] {
+    static final byte[] ALL_SET_16BYTES = new byte[] {
         -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1
     };
 
@@ -351,7 +351,7 @@ public final class ServerAcl {
         aclEntries   = load();
     }
 
-    synchronized protected void ensureAclsUptodate() {
+    synchronized void ensureAclsUptodate() {
 
         if (lastLoadTime > aclFile.lastModified()) {
             return;
@@ -368,7 +368,7 @@ public final class ServerAcl {
         }
     }
 
-    protected List load() throws IOException, AclFormatException {
+    List load() throws IOException, AclFormatException {
 
         if (!aclFile.exists()) {
             throw new IOException("File '" + aclFile.getAbsolutePath()
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/server/ServerConfiguration.java 2.7.0-1/hsqldb/src/org/hsqldb/server/ServerConfiguration.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/server/ServerConfiguration.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/server/ServerConfiguration.java	2022-05-17 11:10:58.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -91,8 +91,10 @@ public final class ServerConfiguration i
      * Retrieves a new HsqlProperties object, if possible, loaded from the
      * specified file.
      *
-     * @param path the file's path, without the .properties extension
-     *      (which is added automatically)
+     * @param protocol int
+     * @param path the file's path, without the .properties extension (which is
+     *   added automatically)
+     * @param extension String
      * @return a new properties object loaded from the specified file
      */
     public static ServerProperties getPropertiesFromFile(int protocol,
@@ -188,10 +190,11 @@ public final class ServerConfiguration i
     }
 
     /**
-     * Retrieves a new default properties object for a server of the
-     * specified protocol
+     * Retrieves a new default properties object for a server of the specified
+     * protocol
      *
      * @return a new default properties object
+     * @param protocol int
      */
     public static ServerProperties newDefaultProperties(int protocol) {
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/server/ServerConnection.java 2.7.0-1/hsqldb/src/org/hsqldb/server/ServerConnection.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/server/ServerConnection.java	2021-02-09 04:49:34.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/server/ServerConnection.java	2022-05-22 18:09:56.000000000 +0000
@@ -1,7 +1,7 @@
 /*
  * For work developed by the HSQL Development Group:
  *
- * Copyright (c) 2001-2021, The HSQL Development Group
+ * Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -98,6 +98,7 @@ import org.hsqldb.result.ResultPropertie
 import org.hsqldb.rowio.RowInputBinary;
 import org.hsqldb.rowio.RowOutputBinary;
 import org.hsqldb.rowio.RowOutputInterface;
+import org.hsqldb.types.DateTimeType;
 import org.hsqldb.types.Type;
 
 // fredt@users 20020215 - patch 461556 by paul-h@users - server factory
@@ -122,7 +123,7 @@ import org.hsqldb.types.Type;
  *
  * @author Blaine Simpson (unsaved@users dot sourceforge.net
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 1.6.2
  */
 class ServerConnection implements Runnable {
@@ -1559,8 +1560,7 @@ class ServerConnection implements Runnab
 
             session = DatabaseManager.newSession(dbID, user,
                                                  resultIn.getSubString(),
-                                                 resultIn.getZoneString(),
-                                                 resultIn.getUpdateCount());
+                                                 resultIn.getZoneString());
 
             if (!server.isSilent()) {
                 server.printWithThread(mThread + ":Connected user '" + user
@@ -1852,8 +1852,8 @@ class ServerConnection implements Runnab
             }
 
             try {
-                session = DatabaseManager.newSession(dbID, user, password,
-                                                     null, 0);
+                session = DatabaseManager.newSession(
+                    dbID, user, password, DateTimeType.systemTimeZone.getID());
 
                 // TODO:  Find out what updateCount, the last para, is for:
                 //                                   resultIn.getUpdateCount());
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/server/ServerProperties.java 2.7.0-1/hsqldb/src/org/hsqldb/server/ServerProperties.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/server/ServerProperties.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/server/ServerProperties.java	2022-03-31 20:44:58.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -67,7 +67,7 @@ import org.hsqldb.persist.HsqlProperties
  * against the set.<p>
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class ServerProperties extends HsqlProperties {
@@ -106,7 +106,7 @@ public class ServerProperties extends Hs
     static final String sc_default_web_root = ".";
 
     //
-    static final HashMap        meta     = new HashMap();
+    static final HashMap<String, PropertyMeta> serverMeta = new HashMap();
     static final OrderedHashSet prefixes = new OrderedHashSet();
 
     //
@@ -154,14 +154,14 @@ public class ServerProperties extends Hs
         Enumeration en = stringProps.propertyNames();
 
         while (en.hasMoreElements()) {
-            String   key      = (String) en.nextElement();
-            Object[] metadata = (Object[]) meta.get(key);
+            String       key      = (String) en.nextElement();
+            PropertyMeta meta = serverMeta.get(key);
 
-            if (metadata == null) {
-                metadata = getPrefixedMetadata(key);
+            if (meta == null) {
+                meta = getPrefixedMetadata(key);
             }
 
-            if (metadata == null) {
+            if (meta == null) {
                 String error = "unsupported property: " + key;
 
                 super.addError(ANY_ERROR, error);
@@ -171,25 +171,23 @@ public class ServerProperties extends Hs
 
             String error = null;
 
-            if (((Integer) metadata[indexType]).intValue()
-                    == SYSTEM_PROPERTY) {
-                error = validateSystemProperty(key, metadata);
-            } else if (((Integer) metadata[indexType]).intValue()
-                       == SERVER_MULTI_PROPERTY) {
-                error = validateMultiProperty(key, metadata);
+            if (meta.propType == SYSTEM_PROPERTY) {
+                error = validateSystemProperty(key, meta);
+            } else if (meta.propType == SERVER_MULTI_PROPERTY) {
+                error = validateMultiProperty(key, meta);
             } else {
                 String value = getProperty(key);
 
                 if (value == null) {
-                    if (metadata[indexDefaultValue] == null) {
+                    if (meta.propDefaultValue == null) {
                         error = "missing value for property: " + key;
                     } else {
                         setProperty(key,
-                                    metadata[indexDefaultValue].toString());
+                                    meta.propDefaultValue.toString());
                     }
                 } else {
                     error = HsqlProperties.validateProperty(key, value,
-                            metadata);
+                            meta);
                 }
             }
 
@@ -221,13 +219,13 @@ public class ServerProperties extends Hs
         initialised = true;
     }
 
-    Object[] getPrefixedMetadata(String key) {
+    PropertyMeta getPrefixedMetadata(String key) {
 
         for (int i = 0; i < prefixes.size(); i++) {
             String prefix = (String) prefixes.get(i);
 
             if (key.startsWith(prefix)) {
-                return (Object[]) meta.get(prefix);
+                return serverMeta.get(prefix);
             }
         }
 
@@ -238,12 +236,12 @@ public class ServerProperties extends Hs
      * Checks an alias or database path. Duplicates are checked as duplicate
      * numbering may result from different strings (e.g. 02 and 2).
      */
-    String validateMultiProperty(String key, Object[] meta) {
+    String validateMultiProperty(String key, PropertyMeta meta) {
 
         int    dbNumber;
-        String prefix = (String) meta[indexName];
+        String prefix = meta.propName;
 
-        if (meta[indexName].equals(sc_key_database)) {
+        if (meta.propName.equals(sc_key_database)) {
             if (sc_key_database.equals(key)) {
                 key = key + ".0";
             }
@@ -255,14 +253,14 @@ public class ServerProperties extends Hs
             return ("malformed database enumerator: " + key);
         }
 
-        if (meta[indexName].equals(sc_key_dbname)) {
+        if (meta.propName.equals(sc_key_dbname)) {
             String alias    = stringProps.getProperty(key).toLowerCase();
             Object existing = idToAliasMap.put(dbNumber, alias);
 
             if (existing != null) {
                 return "duplicate database enumerator: " + key;
             }
-        } else if (meta[indexName].equals(sc_key_database)) {
+        } else if (meta.propName.equals(sc_key_database)) {
             String path     = stringProps.getProperty(key);
             Object existing = idToPathMap.put(dbNumber, path);
 
@@ -278,9 +276,9 @@ public class ServerProperties extends Hs
      * System properties are currently not checked, as different libraries in
      * the environment may need different names?
      */
-    String validateSystemProperty(String key, Object[] meta) {
+    String validateSystemProperty(String key, PropertyMeta meta) {
 
-        String prefix      = (String) meta[indexName];
+        String prefix      = meta.propName;
         String specificKey = key.substring(prefix.length() + 1);
         String value       = stringProps.getProperty(key);
 
@@ -296,34 +294,24 @@ public class ServerProperties extends Hs
     static {
 
         // properties with variable suffixes
-        meta.put(sc_key_database,
-                 getMeta(sc_key_database, SERVER_MULTI_PROPERTY, null));
-        meta.put(sc_key_dbname,
-                 getMeta(sc_key_dbname, SERVER_MULTI_PROPERTY, null));
-        meta.put(sc_key_system, getMeta(sc_key_system, SYSTEM_PROPERTY, null));
+        serverMeta.put(sc_key_database, newMeta(sc_key_database, SERVER_MULTI_PROPERTY, null));
+        serverMeta.put(sc_key_dbname, newMeta(sc_key_dbname, SERVER_MULTI_PROPERTY, null));
+        serverMeta.put(sc_key_system, newMeta(sc_key_system, SYSTEM_PROPERTY, null));
 
         // properties with fixed names
-        meta.put(sc_key_silent,
-                 getMeta(sc_key_silent, SERVER_PROPERTY, false));
-        meta.put(sc_key_trace, getMeta(sc_key_trace, SERVER_PROPERTY, false));
-        meta.put(sc_key_tls, getMeta(sc_key_tls, SERVER_PROPERTY, false));
-        meta.put(sc_key_acl, getMeta(sc_key_acl, SERVER_PROPERTY, null));
-        meta.put(sc_key_autorestart_server,
-                 getMeta(sc_key_autorestart_server, SERVER_PROPERTY, false));
-        meta.put(sc_key_remote_open_db,
-                 getMeta(sc_key_remote_open_db, SERVER_PROPERTY, false));
-        meta.put(sc_key_no_system_exit,
-                 getMeta(sc_key_no_system_exit, SERVER_PROPERTY, false));
-        meta.put(sc_key_daemon,
-                 getMeta(sc_key_daemon, SERVER_PROPERTY, false));
-        meta.put(sc_key_address,
-                 getMeta(sc_key_address, SERVER_PROPERTY, null));
-        meta.put(sc_key_port, getMeta(sc_key_port, 0, 9001, 0, 65535));
-        meta.put(sc_key_http_port, getMeta(sc_key_http_port, 0, 80, 0, 65535));
-        meta.put(sc_key_max_connections,
-                 getMeta(sc_key_max_connections, 0, 100, 1, 10000));
-        meta.put(sc_key_max_databases,
-                 getMeta(sc_key_max_databases, 0, 10, 1, 1000));
+        serverMeta.put(sc_key_silent, newMeta(sc_key_silent, SERVER_PROPERTY, false));
+        serverMeta.put(sc_key_trace, newMeta(sc_key_trace, SERVER_PROPERTY, false));
+        serverMeta.put(sc_key_tls, newMeta(sc_key_tls, SERVER_PROPERTY, false));
+        serverMeta.put(sc_key_acl, newMeta(sc_key_acl, SERVER_PROPERTY, null));
+        serverMeta.put(sc_key_autorestart_server, newMeta(sc_key_autorestart_server, SERVER_PROPERTY, false));
+        serverMeta.put(sc_key_remote_open_db, newMeta(sc_key_remote_open_db, SERVER_PROPERTY, false));
+        serverMeta.put(sc_key_no_system_exit, newMeta(sc_key_no_system_exit, SERVER_PROPERTY, false));
+        serverMeta.put(sc_key_daemon, newMeta(sc_key_daemon, SERVER_PROPERTY, false));
+        serverMeta.put(sc_key_address, newMeta(sc_key_address, SERVER_PROPERTY, null));
+        serverMeta.put(sc_key_port, newMeta(sc_key_port, 0, 9001, 0, 65535));
+        serverMeta.put(sc_key_http_port, newMeta(sc_key_http_port, 0, 80, 0, 65535));
+        serverMeta.put(sc_key_max_connections, newMeta(sc_key_max_connections, 0, 100, 1, 10000));
+        serverMeta.put(sc_key_max_databases, newMeta(sc_key_max_databases, 0, 10, 1, 1000));
 
         //
         prefixes.add(sc_key_database);
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/server/Servlet.java 2.7.0-1/hsqldb/src/org/hsqldb/server/Servlet.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/server/Servlet.java	2021-01-29 13:34:34.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/server/Servlet.java	2022-04-12 08:02:44.000000000 +0000
@@ -1,7 +1,7 @@
 /*
  * For work developed by the HSQL Development Group:
  *
- * Copyright (c) 2001-2021, The HSQL Development Group
+ * Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -73,6 +73,7 @@ package org.hsqldb.server;
 import java.io.DataInputStream;
 import java.io.IOException;
 import java.io.PrintWriter;
+import java.util.TimeZone;
 
 import javax.servlet.ServletConfig;
 import javax.servlet.ServletException;
@@ -130,7 +131,7 @@ import org.hsqldb.rowio.RowOutputBinary;
  * calls are supported.<p>
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 1.6.2
  */
 public class Servlet extends HttpServlet {
@@ -268,8 +269,7 @@ public class Servlet extends HttpServlet
                                                    resultIn.getMainString(),
                                                    resultIn.getSubString(),
                                                    new HsqlProperties(),
-                                                   resultIn.getZoneString(),
-                                                   resultIn.getUpdateCount());
+                                                   TimeZone.getDefault());
                     resultOut =
                         Result.newConnectionAcknowledgeResponse(session);
                 } catch (HsqlException e) {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/server/WebServerConnection.java 2.7.0-1/hsqldb/src/org/hsqldb/server/WebServerConnection.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/server/WebServerConnection.java	2021-02-09 04:51:06.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/server/WebServerConnection.java	2022-04-11 19:00:20.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -80,7 +80,7 @@ import org.hsqldb.rowio.RowOutputBinary;
  *  (fredt@users)
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.5.1
+ * @version 2.7.0
  * @since 1.6.2
  */
 class WebServerConnection implements Runnable {
@@ -339,8 +339,7 @@ class WebServerConnection implements Run
                         DatabaseManager.newSession(dbID,
                                                    resultIn.getMainString(),
                                                    resultIn.getSubString(),
-                                                   resultIn.getZoneString(),
-                                                   resultIn.getUpdateCount());
+                                                   resultIn.getZoneString());
                     resultOut =
                         Result.newConnectionAcknowledgeResponse(session);
                 } catch (HsqlException e) {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/SessionContext.java 2.7.0-1/hsqldb/src/org/hsqldb/SessionContext.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/SessionContext.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/SessionContext.java	2022-07-13 17:41:30.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -50,7 +50,7 @@ import org.hsqldb.result.Result;
  * Session execution context and temporary data structures
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.4.0
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class SessionContext {
@@ -58,9 +58,10 @@ public class SessionContext {
     Session session;
 
     //
-    public Boolean isAutoCommit;
-    Boolean        isReadOnly;
-    Boolean        noSQL;
+    public boolean isAutoCommit;
+    boolean        isReadOnly;
+    boolean        noSQL;
+    int            autoCommitRows;
     int            currentMaxRows;
 
     //
@@ -77,7 +78,7 @@ public class SessionContext {
     Object[]              dynamicArguments     = ValuePool.emptyObjectArray;
     Object[][]            triggerArguments     = null;
     public int            depth;
-    Boolean               isInRoutine;
+    boolean               isInRoutine;
 
     //
     Number         lastIdentity = ValuePool.INTEGER_0;
@@ -89,7 +90,7 @@ public class SessionContext {
 
     // grouping sets data
     GroupSet groupSet;
-    List currentGroup;
+    List     currentGroup;
 
     // session tables
     OrderedHashMap sessionTables;
@@ -129,16 +130,16 @@ public class SessionContext {
                 true, RangeVariable.VARIALBE_RANGE);
         sessionVariableRangeGroups = new RangeGroup[]{
             new RangeGroupSimple(sessionVariablesRange, true) };
-        isAutoCommit = Boolean.FALSE;
-        isReadOnly   = Boolean.FALSE;
-        noSQL        = Boolean.FALSE;
-        isInRoutine  = Boolean.FALSE;
+        isAutoCommit = false;
+        isReadOnly   = false;
+        noSQL        = false;
+        isInRoutine  = false;
     }
 
     void resetStack() {
 
         while (depth > 0) {
-            pop(isInRoutine.booleanValue());
+            pop(isInRoutine);
         }
     }
 
@@ -180,7 +181,7 @@ public class SessionContext {
         rangeIterators      = new RangeIterator[8];
         savepoints          = new OrderedHashMap(4);
         savepointTimestamps = new LongDeque();
-        isAutoCommit        = Boolean.FALSE;
+        isAutoCommit        = false;
         currentMaxRows      = 0;
         isInRoutine         = Boolean.valueOf(isRoutine);
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/SessionData.java 2.7.0-1/hsqldb/src/org/hsqldb/SessionData.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/SessionData.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/SessionData.java	2022-07-13 15:38:30.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -65,7 +65,7 @@ import org.hsqldb.types.LobData;
  * Session semi-persistent data structures.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.5.1
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class SessionData {
@@ -147,7 +147,7 @@ public class SessionData {
 
         int fetchSize = command.getFetchSize();
 
-        result.setResultId(session.actionTimestamp);
+        result.setResultId(session.actionSCN);
 
         int required = command.rsProperties;
         int returned = result.rsProperties;
@@ -600,7 +600,7 @@ public class SessionData {
 
             return clob;
         } catch (IOException e) {
-            throw Error.error(ErrorCode.FILE_IO_ERROR, e.toString());
+            throw Error.error(e, ErrorCode.FILE_IO_ERROR, e.toString());
         } finally {
             try {
                 if (is != null) {
@@ -626,7 +626,7 @@ public class SessionData {
 
             return blob;
         } catch (IOException e) {
-            throw Error.error(ErrorCode.FILE_IO_ERROR);
+            throw Error.error(ErrorCode.FILE_IO_ERROR, e);
         } finally {
             try {
                 if (is != null) {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/SessionInterface.java 2.7.0-1/hsqldb/src/org/hsqldb/SessionInterface.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/SessionInterface.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/SessionInterface.java	2022-06-28 18:49:12.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -41,7 +41,6 @@ import org.hsqldb.result.Result;
 import org.hsqldb.result.ResultLob;
 import org.hsqldb.types.BlobDataID;
 import org.hsqldb.types.ClobDataID;
-import org.hsqldb.types.TimestampData;
 
 /**
  * Interface to Session and its remote proxy objects. Used by the
@@ -49,7 +48,7 @@ import org.hsqldb.types.TimestampData;
  * the session level.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.5.1
+ * @version 2.7.0
  * @since 1.7.2
  */
 public interface SessionInterface {
@@ -141,8 +140,6 @@ public interface SessionInterface {
 
     SimpleDateFormat getSimpleDateFormatGMT();
 
-    TimestampData getCurrentDate();
-
     int getZoneSeconds();
 
     int getStreamBlockSize();
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/Session.java 2.7.0-1/hsqldb/src/org/hsqldb/Session.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/Session.java	2021-07-09 16:51:50.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/Session.java	2022-07-14 19:46:58.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -37,7 +37,6 @@ import java.util.GregorianCalendar;
 import java.util.Locale;
 import java.util.Random;
 import java.util.TimeZone;
-import java.util.concurrent.atomic.AtomicInteger;
 
 import org.hsqldb.HsqlNameManager.HsqlName;
 import org.hsqldb.error.Error;
@@ -66,6 +65,7 @@ import org.hsqldb.rights.Grantee;
 import org.hsqldb.rights.User;
 import org.hsqldb.types.BlobDataID;
 import org.hsqldb.types.ClobDataID;
+import org.hsqldb.types.DateTimeType;
 import org.hsqldb.types.TimeData;
 import org.hsqldb.types.TimestampData;
 import org.hsqldb.types.Type;
@@ -75,7 +75,7 @@ import org.hsqldb.types.TypedComparator;
  * Implementation of SQL sessions.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.1
+ * @version 2.7.0
  * @since 1.7.0
  */
 public class Session implements SessionInterface {
@@ -95,11 +95,11 @@ public class Session implements SessionI
     int isolationLevel        = SessionInterface.TX_READ_COMMITTED;
     boolean                 isReadOnlyIsolation;
     int                     actionIndex;
-    long                    actionStartTimestamp;
-    long                    actionTimestamp;
-    long                    statementStartTimestamp;
-    long                    transactionTimestamp;
-    long                    transactionEndTimestamp;
+    long                    actionStartSCN;
+    long                    actionSCN;
+    long                    statementStartSCN;
+    long                    transactionSCN;
+    long                    transactionEndSCN;
     final boolean           txConflictRollback;
     final boolean           txInterruptRollback;
     boolean                 isPreTransaction;
@@ -118,15 +118,15 @@ public class Session implements SessionI
     TimeoutManager          timeoutManager;
 
     // current settings
-    final String       zoneString;
-    final int          sessionTimeZoneSeconds;
-    int                timeZoneSeconds;
-    boolean            isNetwork;
-    private int        sessionMaxRows;
-    int                sessionOptimization = 8;
-    private final long sessionId;
-    private boolean    ignoreCase;
-    private final long connectTime = System.currentTimeMillis();
+    final TimeZone              timeZone;
+    TimeZone                    currentTimeZone;
+    final String                zoneString;
+    boolean                     isNetwork;
+    private int                 sessionMaxRows;
+    int                         sessionOptimization = 8;
+    private final long          sessionId;
+    private boolean             ignoreCase;
+    private final TimestampData connectTimestamp;
 
     // internal connection
     private JDBCConnection intConnection;
@@ -156,49 +156,48 @@ public class Session implements SessionI
 
     /**
      * Constructs a new Session object.
-     *
      * @param  db the database to which this represents a connection
      * @param  user the initial user
      * @param  autocommit the initial autocommit value
      * @param  readonly the initial readonly value
      * @param  id the session identifier, as known to the database
+     * @param  zone the TimeZone
      */
     Session(Database db, User user, boolean autocommit, boolean readonly,
-            long id, String zoneString, int timeZoneSeconds) {
+            long id, TimeZone zone) {
 
-        sessionId                   = id;
-        database                    = db;
-        this.user                   = user;
-        this.sessionUser            = user;
-        this.zoneString             = zoneString;
-        this.sessionTimeZoneSeconds = timeZoneSeconds;
-        this.timeZoneSeconds        = timeZoneSeconds;
-        rowActionList               = new HsqlArrayList(128, true);
-        waitedSessions              = new OrderedHashSet();
-        waitingSessions             = new OrderedHashSet();
-        tempSet                     = new OrderedHashSet();
-        actionSet                   = new OrderedHashSet();
-        isolationLevelDefault       = database.defaultIsolationLevel;
-        ignoreCase                  = database.sqlIgnoreCase;
-        isolationLevel              = isolationLevelDefault;
-        txConflictRollback          = database.txConflictRollback;
-        txInterruptRollback         = database.txInterruptRollback;
-        isReadOnlyDefault           = readonly;
+        this.database         = db;
+        this.sessionUser      = user;
+        this.user             = user;
+        this.sessionId        = id;
+        this.timeZone         = zone;
+        this.currentTimeZone  = zone;
+        this.zoneString       = zone.getID();
+        rowActionList         = new HsqlArrayList(128, true);
+        waitedSessions        = new OrderedHashSet();
+        waitingSessions       = new OrderedHashSet();
+        tempSet               = new OrderedHashSet();
+        actionSet             = new OrderedHashSet();
+        isolationLevelDefault = database.defaultIsolationLevel;
+        ignoreCase            = database.sqlIgnoreCase;
+        isolationLevel        = isolationLevelDefault;
+        txConflictRollback    = database.txConflictRollback;
+        txInterruptRollback   = database.txInterruptRollback;
+        isReadOnlyDefault     = readonly;
         isReadOnlyIsolation = isolationLevel
                               == SessionInterface.TX_READ_UNCOMMITTED;
         sessionContext              = new SessionContext(this);
-        sessionContext.isAutoCommit = autocommit ? Boolean.TRUE
-                                                 : Boolean.FALSE;
-        sessionContext.isReadOnly   = isReadOnlyDefault ? Boolean.TRUE
-                                                        : Boolean.FALSE;
+        sessionContext.isAutoCommit = autocommit;
+        sessionContext.isReadOnly   = isReadOnlyDefault;
         parser                      = new ParserCommand(this, new Scanner());
+        sessionData                 = new SessionData(database, this);
+        statementManager            = new StatementManager(this);
+        timeoutManager              = new TimeoutManager();
 
         setResultMemoryRowCount(database.getResultMaxMemoryRows());
         resetSchema();
 
-        sessionData      = new SessionData(database, this);
-        statementManager = new StatementManager(this);
-        timeoutManager   = new TimeoutManager();
+        connectTimestamp = getCurrentTimestamp();
     }
 
     void resetSchema() {
@@ -414,7 +413,7 @@ public class Session implements SessionI
      */
     void checkReadWrite() {
 
-        if (sessionContext.isReadOnly.booleanValue() || isReadOnlyIsolation) {
+        if (sessionContext.isReadOnly || isReadOnlyIsolation) {
             throw Error.error(ErrorCode.X_25006);
         }
     }
@@ -431,8 +430,8 @@ public class Session implements SessionI
         checkReadWrite();
     }
 
-    public long getActionTimestamp() {
-        return actionTimestamp;
+    public long getActionSCN() {
+        return actionSCN;
     }
 
     /**
@@ -453,7 +452,6 @@ public class Session implements SessionI
             throw Error.error(ErrorCode.X_40502);
         }
 
-        getTransactionUTC();
         database.txManager.addDeleteAction(this, table, store, row,
                                            changedColumns);
     }
@@ -461,8 +459,6 @@ public class Session implements SessionI
     void addInsertAction(Table table, PersistentStore store, Row row,
                          int[] changedColumns) {
 
-        getTransactionUTC();
-
 //        tempActionHistory.add("add insert to transaction " + actionTimestamp);
         database.txManager.addInsertAction(this, table, store, row,
                                            changedColumns);
@@ -496,12 +492,24 @@ public class Session implements SessionI
             return;
         }
 
-        if (sessionContext.isAutoCommit.booleanValue() != autocommit) {
+        if (sessionContext.isAutoCommit != autocommit) {
             commit(false);
 
-            sessionContext.isAutoCommit = autocommit ? Boolean.TRUE
-                                                     : Boolean.FALSE;
+            sessionContext.isAutoCommit = autocommit;
+        }
+    }
+
+    public void setAutoCommitRows(int rows) {
+
+        if (isClosed) {
+            return;
+        }
+
+        if (sessionContext.depth > 0) {
+            return;
         }
+
+        sessionContext.autoCommitRows = rows;
     }
 
     public void beginAction(Statement cs) {
@@ -521,8 +529,7 @@ public class Session implements SessionI
         sessionData.persistentStoreCollection.clearStatementTables();
 
         if (result.mode == ResultConstants.ERROR) {
-            sessionData.persistentStoreCollection.clearResultTables(
-                actionTimestamp);
+            sessionData.persistentStoreCollection.clearResultTables(actionSCN);
             database.txManager.rollbackAction(this);
         } else {
             sessionContext
@@ -639,8 +646,7 @@ public class Session implements SessionI
         sessionData.closeAllTransactionNavigators();
 
         if (!chain) {
-            sessionContext.isReadOnly = isReadOnlyDefault ? Boolean.TRUE
-                                                          : Boolean.FALSE;
+            sessionContext.isReadOnly = isReadOnlyDefault;
 
             setIsolation(isolationLevelDefault);
         }
@@ -676,14 +682,14 @@ public class Session implements SessionI
         statementManager.reset();
 
         sessionContext.lastIdentity = ValuePool.INTEGER_0;
-        sessionContext.isAutoCommit = Boolean.TRUE;
+        sessionContext.isAutoCommit = true;
 
         setResultMemoryRowCount(database.getResultMaxMemoryRows());
 
         user = sessionUser;
 
         resetSchema();
-        setZoneSeconds(sessionTimeZoneSeconds);
+        resetTimeZone();
 
         sessionMaxRows = 0;
         ignoreCase     = database.sqlIgnoreCase;
@@ -706,11 +712,11 @@ public class Session implements SessionI
             sessionContext.savepointTimestamps.remove(index);
         }
 
-        actionTimestamp = database.txManager.getNextGlobalChangeTimestamp();
+        actionSCN = database.txManager.getNextSystemChangeNumber();
 
         sessionContext.savepoints.add(name,
                                       ValuePool.getInt(rowActionList.size()));
-        sessionContext.savepointTimestamps.addLast(actionTimestamp);
+        sessionContext.savepointTimestamps.addLast(actionSCN);
     }
 
     /**
@@ -780,7 +786,7 @@ public class Session implements SessionI
     }
 
     public void setNoSQL() {
-        sessionContext.noSQL = Boolean.TRUE;
+        sessionContext.noSQL = true;
     }
 
     public void setIgnoreCase(boolean mode) {
@@ -806,8 +812,7 @@ public class Session implements SessionI
             throw Error.error(ErrorCode.X_25001);
         }
 
-        sessionContext.isReadOnly = readonly ? Boolean.TRUE
-                                             : Boolean.FALSE;
+        sessionContext.isReadOnly = readonly;
     }
 
     public synchronized void setReadOnlyDefault(boolean readonly) {
@@ -819,8 +824,7 @@ public class Session implements SessionI
         isReadOnlyDefault = readonly;
 
         if (!isInMidTransaction()) {
-            sessionContext.isReadOnly = isReadOnlyDefault ? Boolean.TRUE
-                                                          : Boolean.FALSE;
+            sessionContext.isReadOnly = isReadOnlyDefault;
         }
     }
 
@@ -830,7 +834,7 @@ public class Session implements SessionI
      * @return the current value
      */
     public boolean isReadOnly() {
-        return sessionContext.isReadOnly.booleanValue() || isReadOnlyIsolation;
+        return sessionContext.isReadOnly || isReadOnlyIsolation;
     }
 
     public synchronized boolean isReadOnlyDefault() {
@@ -843,7 +847,7 @@ public class Session implements SessionI
      * @return the current value
      */
     public synchronized boolean isAutoCommit() {
-        return sessionContext.isAutoCommit.booleanValue();
+        return sessionContext.isAutoCommit;
     }
 
     public synchronized int getStreamBlockSize() {
@@ -907,8 +911,8 @@ public class Session implements SessionI
      *
      * @return the value
      */
-    public long getConnectTime() {
-        return connectTime;
+    public TimestampData getConnectTimestamp() {
+        return connectTimestamp;
     }
 
     /**
@@ -920,8 +924,8 @@ public class Session implements SessionI
         return rowActionList.size();
     }
 
-    public long getTransactionTimestamp() {
-        return transactionTimestamp;
+    public long getTransactionSCN() {
+        return transactionSCN;
     }
 
     public Statement compileStatement(String sql, int props) {
@@ -1229,7 +1233,7 @@ public class Session implements SessionI
 
             if (i > 0) {
                 if (cs.getCompileTimestamp()
-                        > database.txManager.getGlobalChangeTimestamp()) {
+                        > database.txManager.getSystemChangeNumber()) {
                     recompile = true;
                 }
 
@@ -1280,8 +1284,7 @@ public class Session implements SessionI
         }
 
         if (sessionContext.depth > 0) {
-            if (sessionContext.noSQL.booleanValue()
-                    || cs.isAutoCommitStatement()) {
+            if (sessionContext.noSQL || cs.isAutoCommitStatement()) {
                 return Result.newErrorResult(Error.error(ErrorCode.X_46000));
             }
         }
@@ -1301,14 +1304,12 @@ public class Session implements SessionI
         }
 
         sessionContext.currentStatement = cs;
-        statementStartTimestamp =
-            database.txManager.getGlobalChangeTimestamp();
+        statementStartSCN = database.txManager.getSystemChangeNumber();
 
         boolean isTX = cs.isTransactionStatement();
 
         if (!isTX) {
-            actionTimestamp =
-                database.txManager.getNextGlobalChangeTimestamp();
+            actionSCN = database.txManager.getNextSystemChangeNumber();
 
             sessionContext.setDynamicArguments(pvals);
 
@@ -1430,20 +1431,31 @@ public class Session implements SessionI
             return handleAbortTransaction();
         }
 
-        if (sessionContext.depth == 0
-                && (sessionContext.isAutoCommit.booleanValue()
-                    || cs.isAutoCommitStatement())) {
-            try {
-                if (r.mode == ResultConstants.ERROR) {
-                    rollbackNoCheck(false);
-                } else {
-                    commit(false);
+        if (sessionContext.depth == 0) {
+            if (sessionContext.isAutoCommit || cs.isAutoCommitStatement()) {
+                try {
+                    if (r.mode == ResultConstants.ERROR) {
+                        rollbackNoCheck(false);
+                    } else {
+                        commit(false);
+                    }
+                } catch (Exception e) {
+                    sessionContext.currentStatement = null;
+
+                    return Result.newErrorResult(Error.error(ErrorCode.X_40001,
+                            e));
                 }
-            } catch (Exception e) {
-                sessionContext.currentStatement = null;
+            } else if (sessionContext.autoCommitRows > 0) {
+                if (rowActionList.size() > sessionContext.autoCommitRows) {
+                    try {
+                        commit(false);
+                    } catch (Exception e) {
+                        sessionContext.currentStatement = null;
 
-                return Result.newErrorResult(Error.error(ErrorCode.X_40001,
-                        e));
+                        return Result.newErrorResult(
+                            Error.error(ErrorCode.X_40001, e));
+                    }
+                }
             }
         }
 
@@ -1632,38 +1644,57 @@ public class Session implements SessionI
     }
 
 // session DATETIME functions
-    long                  currentTimestampSCN;
-    long                  currentMillis;
+    long                  currentTimestampSCN = -1;    // initialise to invalid val
+    private TimestampData transactionUTC;
+    boolean               transactionUTCSet;
     private TimestampData currentDate;
     private TimestampData currentTimestamp;
     private TimestampData localTimestamp;
-    private TimestampData transactionUTC;
-    boolean               transactionUTCSet;
     private TimeData      currentTime;
     private TimeData      localTime;
 
     /**
-     * Returns the current date, unchanged for the duration of the current
+     * Returns the current date/time, unchanged for the duration of the current
      * execution unit (statement).<p>
      *
-     * SQL standards require that CURRENT_DATE, CURRENT_TIME and
-     * CURRENT_TIMESTAMP are all evaluated at the same point of
-     * time in the duration of each SQL statement, no matter how long the
-     * SQL statement takes to complete.<p>
+     * SQL standards require that CURRENT_DATE, CURRENT_TIME,
+     * CURRENT_TIMESTAMP, LOCALTIME, and LOCALTIMESTAMP are all evaluated at
+     * the same point of time in the duration of each SQL statement, no matter
+     * how long the SQL statement takes to complete.<p>
      *
      * When this method or a corresponding method for CURRENT_TIME or
      * CURRENT_TIMESTAMP is first called in the scope of a system change
-     * number, currentMillis is set to the current system time. All further
-     * CURRENT_XXXX calls in this scope will use this millisecond value.
+     * number, currentTimestamp is set to the current system time. All further
+     * CURRENT_XXXX and LOCALXXXX calls in this scope will use this base point
+     * of time.
+     *
      * (fredt@users)
      */
+    synchronized TimestampData getCurrentTimestamp() {
+
+        resetCurrentTimestamp();
+
+        return currentTimestamp;
+    }
+
+    synchronized TimestampData getLocalTimestamp() {
+
+        resetCurrentTimestamp();
+
+        if (localTimestamp == null) {
+            localTimestamp =
+                DateTimeType.toLocalTimestampValue(currentTimestamp);
+        }
+
+        return localTimestamp;
+    }
+
     public synchronized TimestampData getCurrentDate() {
 
         resetCurrentTimestamp();
 
         if (currentDate == null) {
-            currentDate = (TimestampData) Type.SQL_DATE.getValue(this,
-                    currentMillis / 1000, 0, getZoneSeconds());
+            currentDate = DateTimeType.toCurrentDateValue(currentTimestamp);
         }
 
         return currentDate;
@@ -1673,108 +1704,110 @@ public class Session implements SessionI
      * Returns the current time, unchanged for the duration of the current
      * execution unit (statement)
      */
-    synchronized TimeData getCurrentTime(boolean withZone) {
+    synchronized TimeData getCurrentTime() {
 
         resetCurrentTimestamp();
 
-        if (withZone) {
-            if (currentTime == null) {
-                int seconds =
-                    (int) (HsqlDateTime.getNormalisedTime(
-                        getCalendarGMT(), currentMillis)) / 1000;
-                int nanos = (int) (currentMillis % 1000) * 1000000;
+        if (currentTime == null) {
+            currentTime =
+                DateTimeType.toCurrentTimeWithZoneValue(currentTimestamp);
+        }
 
-                currentTime = new TimeData(seconds, nanos, getZoneSeconds());
-            }
+        return currentTime;
+    }
 
-            return currentTime;
-        } else {
-            if (localTime == null) {
-                int seconds =
-                    (int) (HsqlDateTime.getNormalisedTime(
-                        getCalendarGMT(),
-                        currentMillis + getZoneSeconds() * 1000L)) / 1000;
-                int nanos = (int) (currentMillis % 1000) * 1000000;
+    synchronized TimeData getLocalTime() {
 
-                localTime = new TimeData(seconds, nanos, 0);
-            }
+        resetCurrentTimestamp();
 
-            return localTime;
+        if (localTime == null) {
+            localTime = DateTimeType.toCurrentTimeValue(currentTimestamp);
         }
+
+        return localTime;
     }
 
-    /**
-     * Returns the current timestamp, unchanged for the duration of the current
-     * execution unit (statement)
-     */
-    synchronized TimestampData getCurrentTimestamp(boolean withZone) {
+    private void resetCurrentTimestamp() {
 
-        resetCurrentTimestamp();
+        if (currentTimestampSCN != actionSCN) {
+            currentTimestampSCN = actionSCN;
+            currentTimestamp =
+                DateTimeType.newCurrentTimestamp(currentTimeZone);
+            currentDate    = null;
+            localTimestamp = null;
+            currentTime    = null;
+            localTime      = null;
+        }
+    }
 
-        if (withZone) {
-            if (currentTimestamp == null) {
-                int nanos = (int) (currentMillis % 1000) * 1000000;
+    TimestampData getTransactionUTC() {
 
-                currentTimestamp = new TimestampData((currentMillis / 1000),
-                                                     nanos, getZoneSeconds());
-            }
+        if (!transactionUTCSet) {
+            transactionUTC    = DateTimeType.newSystemTimestampUTC();
+            transactionUTCSet = true;
+        }
 
-            return currentTimestamp;
-        } else {
-            if (localTimestamp == null) {
-                int nanos = (int) (currentMillis % 1000) * 1000000;
+        return transactionUTC;
+    }
 
-                localTimestamp = new TimestampData(currentMillis / 1000
-                                                   + getZoneSeconds(), nanos,
-                                                       0);
-            }
+    // session calendars
+    private Calendar calendar;
+    private Calendar calendarGMT;
+
+    public int getZoneSeconds() {
+        return currentTimestamp.getZone();
+    }
+
+    public void resetTimeZone() {
 
-            return localTimestamp;
+        currentTimeZone = timeZone;
+
+        if (calendar != null) {
+            calendar.setTimeZone(currentTimeZone);
         }
     }
 
-    static TimestampData getSystemTimestamp(boolean withZone, boolean utc) {
+    public void setTimeZone(TimeZone zone) {
 
-        long millis  = System.currentTimeMillis();
-        long seconds = millis / 1000;
-        int  nanos   = (int) (millis % 1000) * 1000000;
-        int  offset  = 0;
+        currentTimeZone = zone;
 
-        if (!utc) {
-            TimeZone zone = TimeZone.getDefault();
+        if (calendar != null) {
+            calendar.setTimeZone(currentTimeZone);
+        }
 
-            offset = zone.getOffset(millis) / 1000;
+        resetCurrentTimestamp();
+    }
 
-            if (!withZone) {
-                seconds += offset;
-                offset  = 0;
-            }
+    public Calendar getCalendar() {
+
+        if (calendar == null) {
+            calendar = new GregorianCalendar(currentTimeZone);
         }
 
-        return new TimestampData(seconds, nanos, offset);
+        return calendar;
     }
 
-    TimestampData getTransactionUTC() {
+    public Calendar getCalendarGMT() {
 
-        if (!transactionUTCSet) {
-            transactionUTC    = getSystemTimestamp(true, true);
-            transactionUTCSet = true;
+        if (calendarGMT == null) {
+            calendarGMT = new GregorianCalendar(TimeZone.getTimeZone("GMT"));
+
+            calendarGMT.setFirstDayOfWeek(Calendar.MONDAY);
+            calendarGMT.setMinimalDaysInFirstWeek(4);
         }
 
-        return transactionUTC;
+        return calendarGMT;
     }
 
-    private void resetCurrentTimestamp() {
+    public SimpleDateFormat getSimpleDateFormatGMT() {
+
+        if (simpleDateFormatGMT == null) {
+            simpleDateFormatGMT = new SimpleDateFormat("MMMM", Locale.ENGLISH);
 
-        if (currentTimestampSCN != actionTimestamp) {
-            currentTimestampSCN = actionTimestamp;
-            currentMillis       = System.currentTimeMillis();
-            currentDate         = null;
-            currentTimestamp    = null;
-            localTimestamp      = null;
-            currentTime         = null;
-            localTime           = null;
+            simpleDateFormatGMT.setCalendar(getCalendarGMT());
         }
+
+        return simpleDateFormatGMT;
     }
 
     private Result getAttributesResult(int id) {
@@ -1870,8 +1903,7 @@ public class Session implements SessionI
                 return sessionContext.isAutoCommit;
 
             case SessionInterface.INFO_CONNECTION_READONLY :
-                return isReadOnlyDefault ? Boolean.TRUE
-                                         : Boolean.FALSE;
+                return isReadOnlyDefault;
 
             case SessionInterface.INFO_CATALOG :
                 return database.getCatalogName().name;
@@ -2005,7 +2037,7 @@ public class Session implements SessionI
         if (result.getType() == ResultConstants.SQLCANCEL) {
             if (result.getSessionRandomID() == randomId) {
                 database.txManager.resetSession(
-                    this, this, statementStartTimestamp,
+                    this, this, statementStartSCN,
                     TransactionManager.resetSessionStatement);
             }
         }
@@ -2128,56 +2160,6 @@ public class Session implements SessionI
         }
     }
 
-    // session zone
-    private Calendar calendar;
-    private Calendar calendarGMT;
-
-    public int getZoneSeconds() {
-        return timeZoneSeconds;
-    }
-
-    public void setZoneSeconds(int seconds) {
-        timeZoneSeconds = seconds;
-    }
-
-    public Calendar getCalendar() {
-
-        if (calendar == null) {
-            if (zoneString == null) {
-                calendar = new GregorianCalendar();
-            } else {
-                TimeZone zone = TimeZone.getTimeZone(zoneString);
-
-                calendar = new GregorianCalendar(zone);
-            }
-        }
-
-        return calendar;
-    }
-
-    public Calendar getCalendarGMT() {
-
-        if (calendarGMT == null) {
-            calendarGMT = new GregorianCalendar(TimeZone.getTimeZone("GMT"));
-
-            calendarGMT.setFirstDayOfWeek(Calendar.MONDAY);
-            calendarGMT.setMinimalDaysInFirstWeek(4);
-        }
-
-        return calendarGMT;
-    }
-
-    public SimpleDateFormat getSimpleDateFormatGMT() {
-
-        if (simpleDateFormatGMT == null) {
-            simpleDateFormatGMT = new SimpleDateFormat("MMMM", Locale.ENGLISH);
-
-            simpleDateFormatGMT.setCalendar(getCalendarGMT());
-        }
-
-        return simpleDateFormatGMT;
-    }
-
     // services
     TypedComparator  typedComparator = new TypedComparator(this);
     Scanner          secondaryScanner;
@@ -2326,11 +2308,11 @@ public class Session implements SessionI
 
     // timeouts
     class TimeoutManager {
-
         volatile int  currentTimeout;
         volatile long checkTimestampSCN;
+        volatile long checkTimestamp;
 
-        void startTimeout(int timeout) {
+        synchronized void startTimeout(int timeout) {
 
             if (timeout == 0) {
                 return;
@@ -2338,31 +2320,30 @@ public class Session implements SessionI
 
             boolean add = checkTimestampSCN == 0;
 
-            currentTimeout    = timeout + 1;
-            checkTimestampSCN = statementStartTimestamp;
+            currentTimeout    = timeout * 1000;
+            checkTimestampSCN = statementStartSCN;
+            checkTimestamp    = System.currentTimeMillis();
 
             if (add) {
                 database.timeoutRunner.addSession(this);
             }
         }
 
-        void endTimeout() {
+        synchronized void endTimeout() {
             currentTimeout = 0;
         }
 
-        public boolean checkTimeout() {
+        synchronized public boolean checkTimeout(long systemMillis) {
 
             if (currentTimeout == 0) {
                 return false;
             }
 
-            if (checkTimestampSCN != statementStartTimestamp) {
+            if (checkTimestampSCN != statementStartSCN) {
                 return false;
             }
 
-            currentTimeout--;
-
-            if (currentTimeout <= 0) {
+            if (checkTimestamp + currentTimeout < systemMillis) {
                 currentTimeout = 0;
 
                 database.txManager.resetSession(
@@ -2375,7 +2356,7 @@ public class Session implements SessionI
             return false;
         }
 
-        public boolean isClosed() {
+        synchronized public boolean isClosed() {
             return Session.this.isClosed;
         }
     }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/SessionManager.java 2.7.0-1/hsqldb/src/org/hsqldb/SessionManager.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/SessionManager.java	2021-01-29 13:34:34.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/SessionManager.java	2022-04-21 16:08:00.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -37,13 +37,14 @@ import org.hsqldb.lib.LongKeyHashMap;
 import org.hsqldb.rights.User;
 
 import java.util.concurrent.atomic.AtomicLong;
+import java.util.TimeZone;
 
 /**
  * Container that maintains a map of session id's to Session objects.
  * Responsible for managing opening and closing of sessions.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 1.7.2
  */
 public class SessionManager {
@@ -69,9 +70,11 @@ public class SessionManager {
         User sysUser = db.getUserManager().getSysUser();
 
         sysSession = new Session(db, sysUser, false, false,
-                                 sessionIdCount.getAndIncrement(), null, 0);
+                                 sessionIdCount.getAndIncrement(),
+                                 TimeZone.getTimeZone("GMT"));
         sysLobSession = new Session(db, sysUser, true, false,
-                                    sessionIdCount.getAndIncrement(), null, 0);
+                                    sessionIdCount.getAndIncrement(),
+                                    TimeZone.getTimeZone("GMT"));
     }
 
     /*
@@ -96,18 +99,16 @@ public class SessionManager {
      * @param db the database to which the new Session is initially connected
      * @param user the Session User
      * @param readonly the ReadOnly attribute for the new Session
-     * @param timeZoneSeconds the session time zone second interval
+     * @param zone the session time zone
      * @return Session
      */
     public synchronized Session newSession(Database db, User user,
                                            boolean readonly,
-                                           boolean autoCommit,
-                                           String zoneString,
-                                           int timeZoneSeconds) {
+                                           boolean autoCommit, TimeZone zone) {
 
         long sessionId = sessionIdCount.getAndIncrement();
         Session s = new Session(db, user, autoCommit, readonly, sessionId,
-                                zoneString, timeZoneSeconds);
+                                zone);
 
         sessionMap.put(sessionId, s);
 
@@ -118,7 +119,7 @@ public class SessionManager {
 
         long sessionId = sessionIdCount.getAndIncrement();
         Session s = new Session(db, db.getUserManager().getSysUser(), false,
-                                false, sessionId, null, 0);
+                                false, sessionId, TimeZone.getTimeZone("GMT"));
 
         s.isProcessingLog = true;
 
@@ -133,7 +134,8 @@ public class SessionManager {
     public Session getSysSessionForScript(Database db) {
 
         Session session = new Session(db, db.getUserManager().getSysUser(),
-                                      false, false, 0, null, 0);
+                                      false, false, 0,
+                                      TimeZone.getTimeZone("GMT"));
 
         // some old 1.8.0 do not have SET SCHEMA PUBLIC
         session.setCurrentSchemaHsqlName(
@@ -171,7 +173,7 @@ public class SessionManager {
         long sessionId = sessionIdCount.getAndIncrement();
         Session session = new Session(sysSession.database,
                                       sysSession.getUser(), false, false,
-                                      sessionId, null, 0);
+                                      sessionId, TimeZone.getTimeZone("GMT"));
 
         session.currentSchema =
             sysSession.database.schemaManager.getDefaultSchemaHsqlName();
@@ -185,7 +187,7 @@ public class SessionManager {
 
         long sessionId = sessionIdCount.getAndIncrement();
         Session session = new Session(sysSession.database, user, false, false,
-                                      sessionId, null, 0);
+                                      sessionId, TimeZone.getTimeZone("GMT"));
 
         session.currentSchema = schema;
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/SetFunctionValueAggregate.java 2.7.0-1/hsqldb/src/org/hsqldb/SetFunctionValueAggregate.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/SetFunctionValueAggregate.java	2021-01-29 13:34:34.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/SetFunctionValueAggregate.java	2022-05-01 17:51:20.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -59,7 +59,7 @@ import org.hsqldb.types.Types;
  *
  * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 1.7.2
  *
  */
@@ -365,6 +365,8 @@ public class SetFunctionValueAggregate i
                     case Types.SQL_INTERVAL_SECOND :
                     case Types.SQL_INTERVAL_MONTH :
                     case Types.SQL_DATE :
+                    case Types.SQL_TIME :
+                    case Types.SQL_TIME_WITH_TIME_ZONE :
                     case Types.SQL_TIMESTAMP :
                     case Types.SQL_TIMESTAMP_WITH_TIME_ZONE : {
                         addLongGroup(item);
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/SortAndSlice.java 2.7.0-1/hsqldb/src/org/hsqldb/SortAndSlice.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/SortAndSlice.java	2021-05-30 14:47:48.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/SortAndSlice.java	2022-06-30 18:26:44.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -43,7 +43,7 @@ import org.hsqldb.types.Type;
  * Implementation of ORDER BY and LIMIT properties of query expressions.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.1
+ * @version 2.7.0
  * @since 1.9.0
  */
 public final class SortAndSlice {
@@ -305,6 +305,10 @@ public final class SortAndSlice {
 
         if (rangeIndex == primaryTableIndex) {
             if (descendingSort) {
+                if (select.isDistinctSelect) {
+                    return;
+                }
+
                 boolean reversed = select.rangeVariables[0].reverseOrder();
 
                 if (!reversed) {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/SqlInvariants.java 2.7.0-1/hsqldb/src/org/hsqldb/SqlInvariants.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/SqlInvariants.java	2021-03-20 11:39:38.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/SqlInvariants.java	2022-04-13 18:18:52.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -39,7 +39,7 @@ import org.hsqldb.error.ErrorCode;
  * Invariant schema objects.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 1.9.0
  */
 public final class SqlInvariants {
@@ -68,6 +68,7 @@ public final class SqlInvariants {
     /** The role name reserved for the special PUBLIC pseudo-user. */
     public static final String   PUBLIC_ROLE_NAME     = "PUBLIC";
     public static final String   DEFAULT_CATALOG_NAME = "PUBLIC";
+    public static final String   SESSION_SCHEMA       = "SESSION";
     public static final String   SYSTEM_SCHEMA        = "SYSTEM_SCHEMA";
     public static final String   LOBS_SCHEMA          = "SYSTEM_LOBS";
     public static final String   DEFINITION_SCHEMA    = "DEFINITION_SCHEMA";
@@ -80,6 +81,7 @@ public final class SqlInvariants {
     public static final String   DUMMY                = "DUMMY";
     public static final String   IDX                  = "IDX";
     public static final HsqlName INFORMATION_SCHEMA_HSQLNAME;
+    public static final HsqlName SESSION_SCHEMA_HSQLNAME;
     public static final HsqlName SYSTEM_SCHEMA_HSQLNAME;
     public static final HsqlName LOBS_SCHEMA_HSQLNAME;
     public static final HsqlName SQLJ_SCHEMA_HSQLNAME;
@@ -93,6 +95,9 @@ public final class SqlInvariants {
         INFORMATION_SCHEMA_HSQLNAME =
             HsqlNameManager.newSystemObjectName(INFORMATION_SCHEMA,
                 SchemaObject.SCHEMA);
+        SESSION_SCHEMA_HSQLNAME =
+            HsqlNameManager.newSystemObjectName(SESSION_SCHEMA,
+                SchemaObject.SCHEMA);
         SYSTEM_SCHEMA_HSQLNAME =
             HsqlNameManager.newSystemObjectName(SYSTEM_SCHEMA,
                 SchemaObject.SCHEMA);
@@ -137,7 +142,6 @@ public final class SqlInvariants {
     }
 
     public static boolean isLobsSchemaName(String name) {
-
         return SqlInvariants.LOBS_SCHEMA.equals(name);
     }
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/StatementCommand.java 2.7.0-1/hsqldb/src/org/hsqldb/StatementCommand.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/StatementCommand.java	2021-07-15 13:57:30.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/StatementCommand.java	2022-07-13 15:38:30.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -47,6 +47,7 @@ import org.hsqldb.persist.PersistentStor
 import org.hsqldb.persist.RowStoreAVLDisk;
 import org.hsqldb.persist.ScriptLoader;
 import org.hsqldb.persist.TableSpaceManager;
+import org.hsqldb.persist.TextFileOps;
 import org.hsqldb.result.Result;
 import org.hsqldb.result.ResultMetaData;
 import org.hsqldb.rights.User;
@@ -59,7 +60,7 @@ import org.hsqldb.types.Type;
  * Implementation of Statement for SQL commands.<p>
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.1
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class StatementCommand extends Statement {
@@ -117,6 +118,8 @@ public class StatementCommand extends St
 
                 break;
             }
+            case StatementTypes.UNLOAD_DATA :
+            case StatementTypes.LOAD_DATA :
             case StatementTypes.LOAD_SCRIPT : {
                 group    = StatementTypes.X_HSQLDB_DATABASE_OPERATION;
                 isLogged = false;
@@ -379,10 +382,8 @@ public class StatementCommand extends St
                     session.checkDDLWrite();
 
                     if (check) {
-                        value =
-                            session.database.getProperties()
-                                .getPropertyWithinRange(HsqlDatabaseProperties
-                                    .hsqldb_cache_rows, value);
+                        value = HsqlDatabaseProperties.getPropertyWithinRange(
+                            HsqlDatabaseProperties.hsqldb_cache_rows, value);
                     }
 
                     session.database.logger.setCacheMaxRows(value);
@@ -401,10 +402,8 @@ public class StatementCommand extends St
                     session.checkDDLWrite();
 
                     if (check) {
-                        value =
-                            session.database.getProperties()
-                                .getPropertyWithinRange(HsqlDatabaseProperties
-                                    .hsqldb_cache_size, value);
+                        value = HsqlDatabaseProperties.getPropertyWithinRange(
+                            HsqlDatabaseProperties.hsqldb_cache_size, value);
                     }
 
                     session.database.logger.setCacheSize(value);
@@ -424,13 +423,13 @@ public class StatementCommand extends St
 
                     if (session.isProcessingScript()) {
                         session.database.logger.setFilesTimestamp(value1);
-                        session.database.txManager.setGlobalChangeTimestamp(
+                        session.database.txManager.setSystemChangeNumber(
                             value1 + 1);
                     } else if (session.isProcessingLog()) {
                         if (value2 > 0) {
                             session.database.logger.setFilesTimestamp(value1);
                             session.database.txManager
-                                .setGlobalChangeTimestamp(value1 + 1);
+                                .setSystemChangeNumber(value1 + 1);
                         }
                     }
 
@@ -530,7 +529,7 @@ public class StatementCommand extends St
                     session.checkAdmin();
                     session.checkDDLWrite();
 
-                    if (!session.database.getProperties().validateProperty(
+                    if (!HsqlDatabaseProperties.validateProperty(
                             HsqlDatabaseProperties.hsqldb_defrag_limit,
                             value)) {
                         throw Error.error(ErrorCode.X_42556);
@@ -545,12 +544,19 @@ public class StatementCommand extends St
             }
             case StatementTypes.SET_DATABASE_FILES_EVENT_LOG : {
                 try {
-                    int     value = ((Integer) arguments[0]).intValue();
-                    boolean isSql = ((Boolean) arguments[1]).booleanValue();
+                    int     value    = ((Integer) arguments[0]).intValue();
+                    boolean isSql    = ((Boolean) arguments[1]).booleanValue();
+                    boolean internal = ((Boolean) arguments[2]).booleanValue();
 
                     session.checkAdmin();
                     session.checkDDLWrite();
-                    session.database.logger.setEventLogLevel(value, isSql);
+
+                    if (internal) {
+                        session.database.logger.setEventLogLevel(value, isSql);
+                    } else {
+                        session.database.logger.setExternalEventLogLevel(
+                            value);
+                    }
 
                     return Result.updateZeroResult;
                 } catch (HsqlException e) {
@@ -572,6 +578,9 @@ public class StatementCommand extends St
                     } else {
                         int value = ((Integer) arguments[0]).intValue();
 
+                        value = HsqlDatabaseProperties.getPropertyWithinRange(
+                            HsqlDatabaseProperties.hsqldb_nio_max_size, value);
+
                         session.database.logger.setNioMaxSize(value);
                     }
 
@@ -599,6 +608,10 @@ public class StatementCommand extends St
 
                     session.checkAdmin();
                     session.checkDDLWrite();
+
+                    value = HsqlDatabaseProperties.getPropertyWithinRange(
+                        HsqlDatabaseProperties.hsqldb_log_size, value);
+
                     session.database.logger.setLogSize(value);
 
                     return Result.updateZeroResult;
@@ -636,6 +649,10 @@ public class StatementCommand extends St
                 try {
                     int value = ((Integer) arguments[0]).intValue();
 
+                    value = HsqlDatabaseProperties.getPropertyWithinRange(
+                        HsqlDatabaseProperties.hsqldb_write_delay_millis,
+                        value);
+
                     session.checkAdmin();
                     session.checkDDLWrite();
                     session.database.logger.setWriteDelay(value);
@@ -772,9 +789,21 @@ public class StatementCommand extends St
                 } else if (HsqlDatabaseProperties.sql_convert_trunc.equals(
                         property)) {
                     session.database.setConvertTrunc(mode);
+                } else if (HsqlDatabaseProperties.sql_trunc_trailing.equals(
+                        property)) {
+                    session.database.setTruncateTrailing(mode);
                 } else if (HsqlDatabaseProperties.sql_avg_scale.equals(
                         property)) {
+                    value = HsqlDatabaseProperties.getPropertyWithinRange(
+                        HsqlDatabaseProperties.sql_avg_scale, value);
+
                     session.database.setAvgScale(value);
+                } else if (HsqlDatabaseProperties.sql_max_recursive.equals(
+                        property)) {
+                    value = HsqlDatabaseProperties.getPropertyWithinRange(
+                        HsqlDatabaseProperties.sql_max_recursive, value);
+
+                    session.database.setMaxRecursive(value);
                 } else if (HsqlDatabaseProperties.sql_double_nan.equals(
                         property)) {
                     session.database.setDoubleNaN(mode);
@@ -919,6 +948,11 @@ public class StatementCommand extends St
                 int size = ((Integer) arguments[0]).intValue();
 
                 session.checkAdmin();
+
+                size = HsqlDatabaseProperties.getPropertyWithinRange(
+                    HsqlDatabaseProperties.hsqldb_result_max_memory_rows,
+                    size);
+
                 session.database.setResultMaxMemoryRows(size);
 
                 return Result.updateZeroResult;
@@ -1049,6 +1083,55 @@ public class StatementCommand extends St
                     return Result.newErrorResult(e, sql);
                 }
             }
+            case StatementTypes.LOAD_DATA : {
+                try {
+                    HsqlName tableName = (HsqlName) arguments[0];
+                    String   textprops = (String) arguments[1];
+                    int      mode      = ((Integer) arguments[2]).intValue();
+                    Table table =
+                        session.database.schemaManager.findTable(session,
+                            tableName.name, tableName.schema.name, null);
+
+                    if (table == null) {
+                        throw Error.error(
+                            ErrorCode.X_42501,
+                            tableName.getSchemaQualifiedStatementName());
+                    }
+
+                    if (!session.getGrantee().canPerformScriptOps()) {
+                        throw Error.error(ErrorCode.X_42507);
+                    }
+
+                    return TextFileOps.loadTextData(session, textprops, table,
+                                                    mode);
+                } catch (HsqlException e) {
+                    return Result.newErrorResult(e, sql);
+                }
+            }
+            case StatementTypes.UNLOAD_DATA : {
+                try {
+                    HsqlName tableName = (HsqlName) arguments[0];
+                    String   textprops = (String) arguments[1];
+                    Table table =
+                        session.database.schemaManager.findTable(session,
+                            tableName.name, tableName.schema.name, null);
+
+                    if (table == null) {
+                        throw Error.error(
+                            ErrorCode.X_42501,
+                            tableName.getSchemaQualifiedStatementName());
+                    }
+
+                    if (!session.getGrantee().canPerformScriptOps()) {
+                        throw Error.error(ErrorCode.X_42507);
+                    }
+
+                    return TextFileOps.unloadTextData(session, textprops,
+                                                      table);
+                } catch (HsqlException e) {
+                    return Result.newErrorResult(e, sql);
+                }
+            }
             case StatementTypes.CHECK_INDEX : {
                 try {
                     HsqlName tableName = (HsqlName) arguments[0];
@@ -1273,7 +1356,7 @@ public class StatementCommand extends St
                     return Result.updateZeroResult;
                 } catch (Throwable e) {
                     if (!(e instanceof HsqlException)) {
-                        e = Error.error(ErrorCode.GENERAL_IO_ERROR,
+                        e = Error.error(e, ErrorCode.GENERAL_IO_ERROR,
                                         e.toString());
                     }
 
@@ -1310,13 +1393,12 @@ public class StatementCommand extends St
                             table.getSchemaName());
 
                     TableWorks tw     = new TableWorks(session, table);
-                    boolean    result = tw.setTableType(session, type);
+                    boolean    result = tw.setTableType(type);
 
                     if (!result) {
                         throw Error.error(ErrorCode.GENERAL_IO_ERROR);
                     }
 
-                    oldStore.removeAll();
                     session.database.schemaManager.setSchemaChangeTimestamp();
 
                     if (name.schema == SqlInvariants.LOBS_SCHEMA_HSQLNAME) {
@@ -1440,7 +1522,7 @@ public class StatementCommand extends St
 
                             session.database.txManager.resetSession(session,
                                     targetSession,
-                                    targetSession.statementStartTimestamp,
+                                    targetSession.statementStartSCN,
                                     TransactionManager.resetSessionStatement);
                             break;
                     }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/StatementCompound.java 2.7.0-1/hsqldb/src/org/hsqldb/StatementCompound.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/StatementCompound.java	2021-02-03 21:23:16.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/StatementCompound.java	2022-07-13 15:38:30.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -46,7 +46,7 @@ import org.hsqldb.types.Type;
  * Implementation of Statement for PSM compound statements.
 
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.5.1
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class StatementCompound extends Statement implements RangeGroup {
@@ -375,7 +375,7 @@ public class StatementCompound extends S
 
             if (hasUndoHandler) {
                 String name = HsqlNameManager.getAutoSavepointNameString(
-                    session.actionTimestamp, session.sessionContext.depth);
+                    session.actionSCN, session.sessionContext.depth);
 
                 session.savepoint(name);
             }
@@ -695,9 +695,9 @@ public class StatementCompound extends S
 
         int actionIndex = session.rowActionList.size();
         long actionTimestamp =
-            session.database.txManager.getNextGlobalChangeTimestamp();
+            session.database.txManager.getNextSystemChangeNumber();
 
-        session.actionTimestamp = actionTimestamp;
+        session.actionSCN = actionTimestamp;
 
         Result result = statement.execute(session);
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/StatementDML.java 2.7.0-1/hsqldb/src/org/hsqldb/StatementDML.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/StatementDML.java	2021-05-30 14:47:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/StatementDML.java	2022-03-26 22:13:18.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -55,7 +55,7 @@ import org.hsqldb.types.Types;
  * Implementation of Statement for DML statements.<p>
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.1
+ * @version 2.7.0
  * @since 1.9.0
  */
 
@@ -210,6 +210,8 @@ public class StatementDML extends Statem
         Result result = null;
         int    limit  = Integer.MAX_VALUE;
 
+        session.getTransactionUTC();
+
         if (sortAndSlice != null) {
             int[] limits = sortAndSlice.getLimits(session, null,
                                                   Integer.MAX_VALUE);
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/StatementDMQL.java 2.7.0-1/hsqldb/src/org/hsqldb/StatementDMQL.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/StatementDMQL.java	2021-03-07 17:30:40.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/StatementDMQL.java	2022-04-13 18:18:52.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -416,6 +416,11 @@ public abstract class StatementDMQL exte
             }
 
             if (range.rangeTable.getSchemaName()
+                    == SqlInvariants.SESSION_SCHEMA_HSQLNAME) {
+                continue;
+            }
+
+            if (range.rangeTable.getSchemaName()
                     == SqlInvariants.SYSTEM_SCHEMA_HSQLNAME) {
                 continue;
             }
@@ -505,19 +510,6 @@ public abstract class StatementDMQL exte
         }
     }
 
-    Result getWriteAccessResult(Session session) {
-
-        try {
-            if (targetTable != null && !targetTable.isTemp()) {
-                session.checkReadWrite();
-            }
-        } catch (HsqlException e) {
-            return Result.newErrorResult(e);
-        }
-
-        return null;
-    }
-
     /**
      * Returns the metadata, which is empty if the CompiledStatement does not
      * generate a Result.
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/StatementInsert.java 2.7.0-1/hsqldb/src/org/hsqldb/StatementInsert.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/StatementInsert.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/StatementInsert.java	2022-03-26 22:12:34.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -47,7 +47,7 @@ import org.hsqldb.types.Type;
  * Implementation of Statement for INSERT statements.<p>
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.5.1
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class StatementInsert extends StatementDML {
@@ -142,6 +142,8 @@ public class StatementInsert extends Sta
         PersistentStore store     = baseTable.getRowStore(session);
         int             count     = 0;
 
+        session.getTransactionUTC();
+
         if (isSimpleInsert) {
             Type[] colTypes = baseTable.getColumnTypes();
             Object[] data = getInsertData(session, colTypes,
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/StatementManager.java 2.7.0-1/hsqldb/src/org/hsqldb/StatementManager.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/StatementManager.java	2021-07-10 17:51:08.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/StatementManager.java	2022-07-13 15:38:30.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -69,7 +69,7 @@ import org.hsqldb.result.ResultMetaData;
  * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
  * @author Fred Toussi (fredt@users dot sourceforge.net)
  *
- * @version 2.6.1
+ * @version 2.7.0
  * @since 1.7.2
  */
 public final class StatementManager {
@@ -83,7 +83,7 @@ public final class StatementManager {
     /** Set of wrappers for Statement object. */
     private HashSet<StatementWrapper> statementSet;
 
-    /** Map: Statement id (int) => wrapper for Statement object. */
+    /** Map: Statement id (int) maps to: wrapper for Statement object. */
     private LongKeyHashMap csidMap;
 
     /**
@@ -164,7 +164,7 @@ public final class StatementManager {
             }
 
             newStatement.setCompileTimestamp(
-                database.txManager.getGlobalChangeTimestamp());
+                database.txManager.getSystemChangeNumber());
 
             sw.statement = newStatement;
 
@@ -237,7 +237,7 @@ public final class StatementManager {
             }
 
             newStatement.setCompileTimestamp(
-                database.txManager.getGlobalChangeTimestamp());
+                database.txManager.getSystemChangeNumber());
 
             if (setGenerated) {
                 StatementDML si = (StatementDML) cs;
@@ -264,7 +264,7 @@ public final class StatementManager {
 
         Statement cs = wrapper.statement;
 
-        cs.setCompileTimestamp(database.txManager.getGlobalChangeTimestamp());
+        cs.setCompileTimestamp(database.txManager.getSystemChangeNumber());
 
         long csid = nextID();
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/StatementResultUpdate.java 2.7.0-1/hsqldb/src/org/hsqldb/StatementResultUpdate.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/StatementResultUpdate.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/StatementResultUpdate.java	2022-03-26 22:12:26.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -46,7 +46,7 @@ import org.hsqldb.types.Type;
  * Implementation of Statement for updating result rows.<p>
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.3.2
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class StatementResultUpdate extends StatementDML {
@@ -87,6 +87,7 @@ public class StatementResultUpdate exten
 
     Result getResult(Session session) {
 
+        session.getTransactionUTC();
         checkAccessRights(session);
 
         Object[]        args = session.sessionContext.dynamicArguments;
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/StatementSchemaDefinition.java 2.7.0-1/hsqldb/src/org/hsqldb/StatementSchemaDefinition.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/StatementSchemaDefinition.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/StatementSchemaDefinition.java	2022-03-23 16:31:06.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -41,7 +41,7 @@ import org.hsqldb.result.Result;
  * Implementation of Statement for CREATE SCHEMA statements.<p>
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.1.1
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class StatementSchemaDefinition extends StatementSchema {
@@ -126,6 +126,10 @@ public class StatementSchemaDefinition e
                         cs.isLogged = false;
                         result      = cs.execute(session);
 
+                        if (result.isError()) {
+                            break;
+                        }
+
                         HsqlName name = ((Table) cs.arguments[0]).getName();
                         Table table =
                             (Table) session.database.schemaManager
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/StatementSchema.java 2.7.0-1/hsqldb/src/org/hsqldb/StatementSchema.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/StatementSchema.java	2021-02-28 10:29:22.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/StatementSchema.java	2022-03-26 22:12:50.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -51,7 +51,7 @@ import org.hsqldb.types.Type;
  * Implementation of Statement for DDL statements.<p>
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class StatementSchema extends Statement {
@@ -1830,6 +1830,10 @@ public class StatementSchema extends Sta
 
     void setSchemaName(Session session, HsqlName parent, HsqlName name) {
 
+        if (name.type == SchemaObject.SCHEMA) {
+            return;
+        }
+
         if (name.schema == null) {
             name.schema = schemaName == null
                           ? session.getCurrentSchemaHsqlName()
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/StatementSession.java 2.7.0-1/hsqldb/src/org/hsqldb/StatementSession.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/StatementSession.java	2021-03-20 11:39:52.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/StatementSession.java	2022-05-30 12:32:08.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -31,6 +31,8 @@
 
 package org.hsqldb;
 
+import java.util.TimeZone;
+
 import org.hsqldb.HsqlNameManager.HsqlName;
 import org.hsqldb.ParserDQL.CompileContext;
 import org.hsqldb.error.Error;
@@ -40,6 +42,7 @@ import org.hsqldb.lib.List;
 import org.hsqldb.result.Result;
 import org.hsqldb.rights.Grantee;
 import org.hsqldb.rights.User;
+import org.hsqldb.types.DateTimeType;
 import org.hsqldb.types.DTIType;
 import org.hsqldb.types.IntervalSecondData;
 import org.hsqldb.types.Type;
@@ -49,7 +52,7 @@ import org.hsqldb.types.Types;
  * Implementation of Statement for SQL session statements.<p>
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.4.0
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class StatementSession extends Statement {
@@ -106,12 +109,9 @@ public class StatementSession extends St
                     e.setDataType(session, Type.SQL_INTERVAL_HOUR_TO_MINUTE);
                 }
 
-                if (e.dataType.isCharacterType()) {
-                    e = new ExpressionOp(e, Type.SQL_INTERVAL_HOUR_TO_MINUTE);
-                    expressions[0] = e;
-                }
-
-                if (e.dataType.typeCode != Types.SQL_INTERVAL_HOUR_TO_MINUTE) {
+                if (e.dataType.isCharacterType()) {}
+                else if (e.dataType.typeCode
+                         != Types.SQL_INTERVAL_HOUR_TO_MINUTE) {
                     throw Error.error(ErrorCode.X_42563);
                 }
 
@@ -443,7 +443,7 @@ public class StatementSession extends St
                 if (expressions[0].getType() == OpTypes.VALUE
                         && expressions[0].getConstantValueNoCheck(session)
                            == null) {
-                    session.setZoneSeconds(session.sessionTimeZoneSeconds);
+                    session.resetTimeZone();
 
                     return Result.updateZeroResult;
                 }
@@ -485,13 +485,40 @@ public class StatementSession extends St
                     }
                 }
 
-                long seconds = ((IntervalSecondData) value).getSeconds();
+                if (value instanceof String) {
+                    String zoneString = (String) value;
 
-                if (-DTIType.timezoneSecondsLimit <= seconds
-                        && seconds <= DTIType.timezoneSecondsLimit) {
-                    session.setZoneSeconds((int) seconds);
+                    if (DateTimeType.zoneIDs.contains(zoneString)) {
+                        TimeZone zone = TimeZone.getTimeZone(zoneString);
 
-                    return Result.updateZeroResult;
+                        session.setTimeZone(zone);
+
+                        return Result.updateZeroResult;
+                    } else {
+                        value =
+                            Type.SQL_INTERVAL_HOUR_TO_MINUTE
+                                .convertToDefaultType(session, value);
+                    }
+                }
+
+                if (value instanceof IntervalSecondData) {
+                    IntervalSecondData interval = (IntervalSecondData) value;
+                    long               seconds  = interval.getSeconds();
+
+                    if (-DTIType.timezoneSecondsLimit <= seconds
+                            && seconds <= DTIType.timezoneSecondsLimit) {
+                        String i =
+                            Type.SQL_INTERVAL_HOUR_TO_MINUTE.convertToString(
+                                interval);
+                        String   sign       = seconds < 0 ? ""
+                                                          : "+";
+                        String   zoneString = "GMT" + sign + i;
+                        TimeZone zone       = TimeZone.getTimeZone(zoneString);
+
+                        session.setTimeZone(zone);
+
+                        return Result.updateZeroResult;
+                    }
                 }
 
                 return Result.newErrorResult(Error.error(ErrorCode.X_22009),
@@ -677,9 +704,14 @@ public class StatementSession extends St
             //
             case StatementTypes.SET_SESSION_AUTOCOMMIT : {
                 boolean mode = ((Boolean) arguments[0]).booleanValue();
+                int     rows = ((Integer) arguments[1]).intValue();
 
                 try {
-                    session.setAutoCommit(mode);
+                    if (rows < 0) {
+                        session.setAutoCommit(mode);
+                    } else {
+                        session.setAutoCommitRows(rows);
+                    }
 
                     return Result.updateZeroResult;
                 } catch (HsqlException e) {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/StatementSet.java 2.7.0-1/hsqldb/src/org/hsqldb/StatementSet.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/StatementSet.java	2020-07-10 12:49:32.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/StatementSet.java	2022-05-24 08:38:06.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/StatementTypes.java 2.7.0-1/hsqldb/src/org/hsqldb/StatementTypes.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/StatementTypes.java	2021-02-28 18:48:14.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/StatementTypes.java	2022-03-08 11:56:48.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -35,7 +35,7 @@ package org.hsqldb;
  * Codes based on SQL Standards for different types of statement.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 1.9.0
  */
 public interface StatementTypes {
@@ -174,6 +174,9 @@ public interface StatementTypes {
     int SET_PASSTHROUGH             = 133;
     int CREATE_USER_MAPPING         = 134;
 
+	//
+    int LOAD_DATA          = 909;
+    int UNLOAD_DATA        = 910;
     // hsqldb database
     int DATABASE_BACKUP     = 1001;
     int DATABASE_CHECKPOINT = 1002;
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/Table.java 2.7.0-1/hsqldb/src/org/hsqldb/Table.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/Table.java	2021-01-29 13:34:34.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/Table.java	2022-03-12 19:28:32.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -63,7 +63,7 @@ import org.hsqldb.types.Type;
  * Holds the data structures and methods for creation of a named database table.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 1.6.1
  */
 public class Table extends TableBase implements SchemaObject {
@@ -2506,8 +2506,7 @@ public class Table extends TableBase imp
     }
 
     /**
-     *  Enforce max field sizes according to SQL column definition.
-     *  SQL92 13.8
+     *  Enforce not null and domain size constraints
      */
     public void enforceRowConstraints(Session session, Object[] data) {
 
@@ -2552,6 +2551,10 @@ public class Table extends TableBase imp
         }
     }
 
+    /**
+     *  Enforce max field sizes according to SQL column definition.
+     *  SQL92 13.8
+     */
     public void enforceTypeLimits(Session session, Object[] data) {
 
         int i = 0;
@@ -2567,7 +2570,8 @@ public class Table extends TableBase imp
                     || code == -ErrorCode.X_22008) {
                 ColumnSchema column = getColumn(i);
                 String[]     info   = new String[] {
-                    "", tableName.statementName, column.getName().statementName
+                    "size limit: " + colTypes[i].precision,
+                    tableName.statementName, column.getName().statementName
                 };
 
                 throw Error.error(e, code, ErrorCode.COLUMN_CONSTRAINT, info);
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/TableWorks.java 2.7.0-1/hsqldb/src/org/hsqldb/TableWorks.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/TableWorks.java	2021-03-01 22:27:36.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/TableWorks.java	2022-03-26 22:14:42.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -50,7 +50,7 @@ import org.hsqldb.types.Types;
  * existing table which may result in a new Table object
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.5.1
+ * @version 2.7.0
  * @since 1.7.0
  */
 public class TableWorks {
@@ -1160,27 +1160,27 @@ public class TableWorks {
             throw Error.error(ErrorCode.X_42525);
         }
 
-        if (checkData == 0) {
+        if (checkData == Type.ReType.keep) {
             if (newCol.isIdentity()) {
                 if (!(oldCol.isIdentity() || !oldCol.isNullable()
                         || oldCol.isPrimaryKey())) {
-                    checkData = 1;
+                    checkData = Type.ReType.check;
                 }
             }
 
             if (newType.isDomainType()
                     && newType.userTypeModifier.getConstraints().length > 0) {
-                checkData = 1;
+                checkData = Type.ReType.check;
             }
         }
 
-        if (checkData == 1) {
+        if (checkData == Type.ReType.check) {
             checkConvertColDataType(oldCol, newCol);
 
-            checkData = 0;
+            checkData = Type.ReType.keep;
         }
 
-        if (checkData == 0) {
+        if (checkData == Type.ReType.keep) {
 
             // size of some types may be increased
             // default expressions can change
@@ -1351,11 +1351,10 @@ public class TableWorks {
     /**
      * Changes the type of a table
      *
-     * @param session Session
      * @param newType int
      * @return boolean
      */
-    public boolean setTableType(Session session, int newType) {
+    public boolean setTableType(int newType) {
 
         int currentType = table.getTableType();
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/test/TestConnectionSettings.java 2.7.0-1/hsqldb/src/org/hsqldb/test/TestConnectionSettings.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/test/TestConnectionSettings.java	2020-12-16 19:41:40.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/test/TestConnectionSettings.java	2022-02-21 14:41:54.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2020, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/test/TestDatabaseMetaData.java 2.7.0-1/hsqldb/src/org/hsqldb/test/TestDatabaseMetaData.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/test/TestDatabaseMetaData.java	2021-01-27 04:03:34.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/test/TestDatabaseMetaData.java	2022-02-21 14:41:52.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -41,6 +41,8 @@ import java.util.ArrayList;
 import java.util.Iterator;
 import java.util.List;
 
+import org.hsqldb.jdbc.JDBCDatabaseMetaData;
+
 public class TestDatabaseMetaData extends TestBase {
 
     public TestDatabaseMetaData(String name) {
@@ -218,31 +220,49 @@ public class TestDatabaseMetaData extend
 
         Connection conn = newConnection();
         int        updateCount;
+        ResultSet  result = null;
+        String     s = "";
 
         try {
-            TestUtil.testScript(conn, "testrun/hsqldb/TestSelf.txt");
+            TestUtil.testScript(conn, "testrun/hsqldb/TestSelf01Function.txt");
+            TestUtil.testScript(conn, "testrun/hsqldb/TestSelf01Procedure.txt");
 
             DatabaseMetaData dbmeta = conn.getMetaData();
 
             dbmeta.allProceduresAreCallable();
-            dbmeta.getBestRowIdentifier(null, null, "T_1",
+            result = dbmeta.getBestRowIdentifier(null, null, "T_1",
                                         DatabaseMetaData.bestRowTransaction,
                                         true);
-            dbmeta.getCatalogs();
-            dbmeta.getColumnPrivileges(null, "PUBLIC", "T_1", "%");
-            dbmeta.getColumns("PUBLIC", "PUBLIC", "T_1", "%");
-            dbmeta.getCrossReference(null, null, "T_1", null, null, "T_1");
-            dbmeta.getExportedKeys(null, null, "T_1");
-            dbmeta.getFunctionColumns(null, "%", "%", "%");
-            dbmeta.getFunctions(null, "%", "%");
-            dbmeta.getImportedKeys("PUBLIC", "PUBLIC", "T_1");
-            dbmeta.getIndexInfo("PUBLIC", "PUBLIC", "T1", true, true);
-            dbmeta.getPrimaryKeys("PUBLIC", "PUBLIC", "T_1");
-            dbmeta.getProcedureColumns(null, null, "%", "%");
-            dbmeta.getProcedures("PUBLIC", "%", "%");
-            dbmeta.getSchemas(null, "#");
-            dbmeta.getTablePrivileges(null, "%", "%");
-            dbmeta.getUDTs(null, "%", "%", new int[]{ Types.DISTINCT });
+            result = dbmeta.getCatalogs();
+            result = dbmeta.getColumnPrivileges(null, "PUBLIC", "T_1", "%");
+
+            while(result.next()) {
+                s = result.getString(3);
+            }
+            result = dbmeta.getColumns("PUBLIC", "PUBLIC", "T_1", "%");
+            result = dbmeta.getCrossReference(null, null, "T_1", null, null, "T_1");
+            result = dbmeta.getExportedKeys(null, null, "T_1");
+            result = dbmeta.getFunctionColumns(null, "%", "%", "%");
+            result = dbmeta.getFunctions(null, "%", "%");
+
+            while(result.next()) {
+                s = result.getString(3);
+            }
+
+            result = dbmeta.getImportedKeys("PUBLIC", "PUBLIC", "T_1");
+            result = dbmeta.getIndexInfo("PUBLIC", "PUBLIC", "T1", true, true);
+            result = dbmeta.getPrimaryKeys("PUBLIC", "PUBLIC", "T_1");
+            result = dbmeta.getProcedureColumns(null, null, "%", "%");
+            result = dbmeta.getProcedures("PUBLIC", "%", "%");
+
+            while(result.next()) {
+                s = result.getString(3);
+                s = result.getString(9);
+            }
+
+            result = dbmeta.getSchemas(null, "#");
+            result = dbmeta.getTablePrivileges(null, "%", "%");
+            result = dbmeta.getUDTs(null, "%", "%", new int[]{ Types.DISTINCT });
         } catch (Exception e) {
             assertTrue("unable to prepare or execute DDL", false);
         } finally {
@@ -265,6 +285,8 @@ public class TestDatabaseMetaData extend
             int txIsolation = dbmeta.getDefaultTransactionIsolation();
             String           userName   = dbmeta.getUserName();
             boolean          isReadOnly = dbmeta.isReadOnly();
+            String           collation  = ((JDBCDatabaseMetaData) dbmeta).getDatabaseDefaultCollation();
+            assertEquals("SQL_TEXT", collation);
         } catch (Exception e) {
             assertTrue("unable to prepare or execute DDL", false);
         } finally {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/test/TestDataCube.java 2.7.0-1/hsqldb/src/org/hsqldb/test/TestDataCube.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/test/TestDataCube.java	2019-12-28 14:31:50.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/test/TestDataCube.java	2022-06-08 09:19:12.000000000 +0000
@@ -107,8 +107,8 @@ public class TestDataCube extends TestCa
         //Channel: Internet
         addRevenueSource("INTERNET", 2009, "GB", "CAMBRIDGE", 10000);
         addRevenueSource("INTERNET", 2009, "GB", "OXFORD", 15000);
-        addRevenueSource("INTERNET", 2009, "US", "STANFORD" ,100000);
-        addRevenueSource("INTERNET", 2009, "US", "NEW YORK" ,175000);
+        addRevenueSource("INTERNET", 2009, "US", "STANFORD", 100000);        
+        addRevenueSource("INTERNET", 2009, "US", "NEW YORK", 175000);
         addRevenueSource("INTERNET", 2010, "GB", "CAMBRIDGE", 20000);
         addRevenueSource("INTERNET", 2010, "GB", "OXFORD", 25000);
         addRevenueSource("INTERNET", 2010, "US", "STANFORD", 200000);
@@ -181,7 +181,7 @@ public class TestDataCube extends TestCa
      * Tests aggregated selection using the CUBE operator with a <b>GROUP_BY</b> clause.
      * This is a normal use of the CUBE operator acting on one column.
      * The result set will contain two groupings: (CHANNEL), ()
-     **/
+     */
     public void testAggregatedGroupByCube() throws SQLException {
         String sql = "SELECT CHANNEL, SUM(SALES) \n" +
                 "FROM REVENUE \n" +
@@ -205,7 +205,7 @@ public class TestDataCube extends TestCa
      * The result set will contain eight groupings:
      * (CHANNEL, YEAR, COUNTRY), (CHANNEL, YEAR), (CHANNEL, COUNTRY), (CHANNEL),
      * (YEAR, COUNTRY), (YEAR), (COUNTRY), ()
-     **/
+     */
     public void testAggregatedGroupByCube1() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, COUNTRY, SUM(SALES) \n" +
                 "FROM REVENUE \n" +
@@ -301,7 +301,7 @@ public class TestDataCube extends TestCa
      * Tests aggregated selection using the ROLLUP operator with a <b>GROUP_BY</b> clause.
      * This is a normal use of the ROLLUP operator acting on one column.
      * The result set will contain two groupings: (CHANNEL), ()
-     **/
+     */
     public void testAggregatedGroupByRollup() throws SQLException {
         String sql = "SELECT CHANNEL, SUM(SALES) \n" +
                 "FROM REVENUE \n" +
@@ -324,7 +324,7 @@ public class TestDataCube extends TestCa
      * The ROLLUP operator acts on several column.
      * The result set will contain four groupings:
      * (CHANNEL, YEAR, COUNTRY), (CHANNEL, YEAR), (CHANNEL), (),
-     **/
+     */
     public void testAggregatedGroupByRollup1() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, COUNTRY, SUM(SALES) \n" +
                 "FROM REVENUE \n" +
@@ -396,7 +396,7 @@ public class TestDataCube extends TestCa
      * Tests aggregated selection using the GROUPING SETS operator with a <b>GROUP_BY</b> clause.
      * This is a trivial use of the GROUPING SETS operator acting on one group.
      * Equivalent to "GROUP BY CHANNEL"
-     **/
+     */
     public void testAggregatedGroupByGS() throws SQLException {
         String sql = "SELECT CHANNEL, SUM(SALES) \n" +
                 "FROM REVENUE \n" +
@@ -416,7 +416,7 @@ public class TestDataCube extends TestCa
      * The GROUPING SETS operator acts on several groups of dimension 1.
      * The result set will contain three groupings:
      * (CHANNEL), (YEAR), (COUNTRY)
-     **/
+     */
     public void testAggregatedGroupByGS1() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, COUNTRY, SUM(SALES) \n" +
                 "FROM REVENUE \n" +
@@ -443,7 +443,7 @@ public class TestDataCube extends TestCa
      * The GROUPING SETS operator acts on several groups of various dimensions.
      * The result set will contain three groupings:
      * (CHANNEL, YEAR, COUNTRY), (YEAR), (COUNTRY, YEAR), ()
-     **/
+     */
     public void testAggregatedGroupByGS2() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, COUNTRY, SUM(SALES) \n" +
                 "FROM REVENUE \n" +
@@ -521,7 +521,7 @@ public class TestDataCube extends TestCa
      *
      * The ROLLUP operator acts on several column, producing four groupings:
      * (CHANNEL, YEAR, COUNTRY), (CHANNEL, YEAR), (CHANNEL), ()
-     **/
+     */
     public void testAggregatedGrouping() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, COUNTRY, SUM(SALES), \n" +
                 "GROUPING(CHANNEL) AS CH, GROUPING(YEAR) as YR, GROUPING(COUNTRY) AS CO\n" +
@@ -573,7 +573,7 @@ public class TestDataCube extends TestCa
      *
      * The CUBE operator acts on several column, producing four groupings:
      * (CHANNEL, YEAR), (CHANNEL), (YEAR), ()
-     **/
+     */
     public void testAggregatedGrouping1() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, SUM(SALES), GROUPING(CHANNEL, YEAR) " +
                 "FROM REVENUE\n" +
@@ -612,7 +612,7 @@ public class TestDataCube extends TestCa
      *
      * The CUBE operator acts on several column, producing four groupings:
      * (CHANNEL, COUNTRY), (CHANNEL), (COUNTRY), ()
-     **/
+     */
     public void testAggregatedDecode() throws SQLException {
         String sql = "SELECT DECODE(GROUPING(CHANNEL), 1, 'MULTI-CHANNEL', CHANNEL), DECODE(GROUPING(COUNTRY), 0, COUNTRY, 'MULTI-COUNTRY'), SUM(SALES) \n" +
                 "FROM REVENUE\n" +
@@ -650,7 +650,7 @@ public class TestDataCube extends TestCa
      *
      * () evaluates to GRAND TOTAL, (CHANNEL) evaluate to the channel used,
      * (COUNTRY) evaluates to the country and (CHANNEL, COUNTRY) evaluates to NULL
-     **/
+     */
     public void testAggregatedDecode1() throws SQLException {
         String sql = "SELECT DECODE(GROUPING(CHANNEL, COUNTRY), 3, 'GRAND TOTAL', 2, COUNTRY, " +
                 "1, CHANNEL, 0, null), SUM(SALES) \n" +
@@ -685,7 +685,7 @@ public class TestDataCube extends TestCa
      * a GROUPING operator
      *
      * A SQLException should be thrown.
-     **/
+     */
     public void testInvalidGrouping() throws SQLException {
         String sql = "SELECT CHANNEL, COUNTRY, SUM(SALES)\n" +
                 "FROM REVENUE\n" +
@@ -702,7 +702,7 @@ public class TestDataCube extends TestCa
      *
      * The CUBE operator produces four groupings:
      * (CHANNEL, YEAR, COUNTRY), (CHANNEL), (YEAR, COUNTRY), ()
-     **/
+     */
     public void testAggregatedComposite() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, COUNTRY, SUM(SALES) \n" +
                 "FROM REVENUE\n" +
@@ -749,7 +749,7 @@ public class TestDataCube extends TestCa
      *
      * The ROLLUP operator produces three groupings:
      * (CHANNEL, YEAR, COUNTRY), (CHANNEL, YEAR), ()
-     **/
+     */
     public void testAggregatedComposite1() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, COUNTRY, SUM(SALES) \n" +
                 "FROM REVENUE\n" +
@@ -792,7 +792,7 @@ public class TestDataCube extends TestCa
      *
      * The ROLLUP operator produces four groupings:
      * (CHANNEL, YEAR, COUNTRY, PROVINCE), (CHANNEL, YEAR), (COUNTRY, PROVINCE), ()
-     **/
+     */
     public void testAggregatedComposite2() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, COUNTRY, PROVINCE, SUM(SALES) \n" +
                 "FROM REVENUE\n" +
@@ -862,7 +862,7 @@ public class TestDataCube extends TestCa
      *
      * Two groupings should be produced:
      * (CHANNEL, YEAR), (CHANNEL, COUNTRY)
-     **/
+     */
     public void testAggregatedConcat() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, COUNTRY, SUM(SALES) \n" +
                 "FROM REVENUE\n" +
@@ -888,12 +888,13 @@ public class TestDataCube extends TestCa
 
         compareResults(sql, expected, "00000");
     }
+
     /**
      * Tests concatenated groupings using GROUPING SETS.
      *
      * Four groupings should be produced:
      * (CHANNEL, COUNTRY), (YEAR, COUNTRY), (CHANNEL, PROVINCE), (YEAR, PROVINCE)
-     **/
+     */
     public void testAggregatedConcat1() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, COUNTRY, PROVINCE, SUM(SALES) \n" +
                 "FROM REVENUE\n" +
@@ -957,7 +958,7 @@ public class TestDataCube extends TestCa
      *
      * Four groupings should be produced:
      * (CHANNEL, YEAR, COUNTRY), (CHANNEL, YEAR), (CHANNEL, COUNTRY), (CHANNEL)
-     **/
+     */
     public void testAggregatedConcat2() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, COUNTRY, SUM(SALES) \n" +
                 "FROM REVENUE\n" +
@@ -1003,13 +1004,14 @@ public class TestDataCube extends TestCa
 
         compareResults(sql, expected, "00000");
     }
+
     /**
      * Tests concatenated groupings using CUBE and GROUPING SETS.
      *
      * Eight groupings should be produced:
      * (CHANNEL, YEAR, COUNTRY), (CHANNEL, COUNTRY), (YEAR, COUNTRY), (COUNTRY),
      * (CHANNEL, YEAR, PROVINCE), (CHANNEL, PROVINCE), (YEAR, PROVINCE), (PROVINCE)
-     **/
+     */
     public void testAggregatedConcat3() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, COUNTRY, PROVINCE, SUM(SALES) \n" +
                 "FROM REVENUE\n" +
@@ -1135,7 +1137,7 @@ public class TestDataCube extends TestCa
      * (CHANNEL, COUNTRY, PROVINCE), (YEAR, COUNTRY, PROVINCE),
      * (CHANNEL, COUNTRY), (YEAR, COUNTRY),
      * (CHANNEL),(YEAR)
-     **/
+     */
     public void testAggregatedConcat4() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, COUNTRY, PROVINCE, SUM(SALES) \n" +
                 "FROM REVENUE\n" +
@@ -1209,7 +1211,7 @@ public class TestDataCube extends TestCa
      * (CHANNEL, YEAR, COUNTRY, PROVINCE), (CHANNEL, COUNTRY, PROVINCE), (YEAR, COUNTRY, PROVINCE), (COUNTRY, PROVINCE),
      * (CHANNEL, YEAR, COUNTRY), (CHANNEL, COUNTRY), (YEAR, COUNTRY), (COUNTRY),
      * (CHANNEL, YEAR), (CHANNEL), (YEAR), (),
-     **/
+     */
     public void testAggregatedConcat5() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, COUNTRY, PROVINCE, SUM(SALES) \n" +
                 "FROM REVENUE\n" +
@@ -1349,12 +1351,13 @@ public class TestDataCube extends TestCa
     //------------------------------------------------------------
     // NESTED GROUPING TEST
     //------------------------------------------------------------
+
     /**
      * Tests nested groupings using GROUPING SETS within GROUPING SETS.
      *
      * Three groupings should be produced:
      * (CHANNEL), (YEAR), (COUNTRY)
-     **/
+     */
     public void testAggregatedNest() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, COUNTRY, SUM(SALES) \n" +
                 "FROM REVENUE\n" +
@@ -1382,7 +1385,7 @@ public class TestDataCube extends TestCa
      *
      * Five groupings should be produced:
      * (CHANNEL, YEAR), (CHANNEL), (YEAR), (), (COUNTRY)
-     **/
+     */
     public void testAggregatedNest1() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, COUNTRY, SUM(SALES) \n" +
                 "FROM REVENUE\n" +
@@ -1420,7 +1423,7 @@ public class TestDataCube extends TestCa
      *
      * Four groupings should be produced:
      * (CHANNEL), (YEAR, COUNTRY), (YEAR), ()
-     **/
+     */
     public void testAggregatedNest2() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, COUNTRY, SUM(SALES) \n" +
                 "FROM REVENUE\n" +
@@ -1454,7 +1457,7 @@ public class TestDataCube extends TestCa
      *
      * Six groupings should be produced:
      * (CHANNEL, YEAR), (CHANNEL), (), (COUNTRY, PROVINCE), (COUNTRY), ()
-     **/
+     */
     public void testAggregatedNest3() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, COUNTRY, PROVINCE, SUM(SALES) \n" +
                 "FROM REVENUE\n" +
@@ -1500,7 +1503,7 @@ public class TestDataCube extends TestCa
      * (CHANNEL, YEAR), (CHANNEL), (), (COUNTRY, PROVINCE), (COUNTRY), ()
      *
      * The second empty grouping is eliminated
-     **/
+     */
     public void testDistinctAggregatedNest3() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, COUNTRY, PROVINCE, SUM(SALES) \n" +
                 "FROM REVENUE\n" +
@@ -1542,7 +1545,7 @@ public class TestDataCube extends TestCa
      * nested ROLLUP within CUBE
      *
      * A SQLException should be thrown.
-     **/
+     */
     public void testInvalidNesting() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, SUM(SALES)\n" +
                 "FROM REVENUE \n" +
@@ -1556,7 +1559,7 @@ public class TestDataCube extends TestCa
      * nested CUBE within CUBE
      *
      * A SQLException should be thrown.
-     **/
+     */
     public void testInvalidNesting1() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, SUM(SALES)\n" +
                 "FROM REVENUE \n" +
@@ -1570,7 +1573,7 @@ public class TestDataCube extends TestCa
      * nested GROUPING SETS within CUBE
      *
      * A SQLException should be thrown.
-     **/
+     */
     public void testInvalidNesting2() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, SUM(SALES)\n" +
                 "FROM REVENUE \n" +
@@ -1583,7 +1586,7 @@ public class TestDataCube extends TestCa
      * nested ROLLUP within ROLLUP
      *
      * A SQLException should be thrown.
-     **/
+     */
     public void testInvalidNesting3() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, SUM(SALES)\n" +
                 "FROM REVENUE \n" +
@@ -1597,7 +1600,7 @@ public class TestDataCube extends TestCa
      * nested CUBE within ROLLUP
      *
      * A SQLException should be thrown.
-     **/
+     */
     public void testInvalidNesting4() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, SUM(SALES)\n" +
                 "FROM REVENUE \n" +
@@ -1611,7 +1614,7 @@ public class TestDataCube extends TestCa
      * nested GROUPING SETS within ROLLUP
      *
      * A SQLException should be thrown.
-     **/
+     */
     public void testInvalidNesting5() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, SUM(SALES)\n" +
                 "FROM REVENUE \n" +
@@ -1625,11 +1628,11 @@ public class TestDataCube extends TestCa
     /**
      * Tests <b>WHERE</b> clause with text fields.
      *
-     * Rows with COUNTRY <> 'GB' will be removed before grouping occurs
+     * Rows with {@code COUNTRY <> 'GB'} will be removed before grouping occurs
      *
      * CUBE will produce four groupings:
      * (CHANNEL, YEAR), (CHANNEL), (YEAR), ()
-     **/
+     */
     public void testAggregatedWhere() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, SUM(SALES) as SALES \n" +
                 "FROM REVENUE\n" +
@@ -1662,11 +1665,11 @@ public class TestDataCube extends TestCa
     /**
      * Tests <b>WHERE</b> clause with numerical fields.
      *
-     * Rows with SALES <= 20000 will be removed before grouping occurs
+     * Rows with {@code SALES <= 20000} will be removed before grouping occurs
      *
      * ROLLUP will produce three groupings:
      * (CHANNEL, YEAR), (CHANNEL), ()
-     **/
+     */
     public void testAggregatedWhere1() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, SUM(SALES) as SALES \n" +
                 "FROM REVENUE\n" +
@@ -1695,11 +1698,11 @@ public class TestDataCube extends TestCa
     /**
      * Tests <b>WHERE</b> clause with multiple fields.
      *
-     * Rows with COUNTRY <> 'US' or YEAR = 2009 will be removed before grouping occurs
+     * Rows with {@code COUNTRY <> 'US' or YEAR = 2009} will be removed before grouping occurs
      *
      * CUBE will produce four groupings:
      * (CHANNEL, YEAR), (CHANNEL), (YEAR), ()
-     **/
+     */
     public void testAggregatedWhere2() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, SUM(SALES) as SALES \n" +
                 "FROM REVENUE\n" +
@@ -1722,9 +1725,11 @@ public class TestDataCube extends TestCa
 
         compareResults(sql, expected, "00000");
     }
+
     //------------------------------------------------------------
     // HAVING CLAUSE TEST
     //------------------------------------------------------------
+
     /**
      * Tests <b>HAVING</b> clause with aggregated column and multiple
      * HAVING conditions
@@ -1732,7 +1737,7 @@ public class TestDataCube extends TestCa
      * ROLLUP will produce four groupings:
      * (CHANNEL, YEAR, COUNTRY), (CHANNEL, YEAR), (CHANNEL), ()
      * which are then filtered by the <B>HAVING</B> condition
-     **/
+     */
     public void testAggregatedHaving() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, COUNTRY, SUM(SALES) \n" +
                 "FROM REVENUE\n" +
@@ -1762,7 +1767,7 @@ public class TestDataCube extends TestCa
      * CUBE will produce four groupings:
      * (CHANNEL, YEAR), (CHANNEL), (YEAR), ()
      * which are then filtered by the <B>HAVING</B> condition
-     **/
+     */
     public void testAggregatedHaving1() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, SUM(SALES) as SALES \n" +
                 "FROM REVENUE\n" +
@@ -1792,7 +1797,7 @@ public class TestDataCube extends TestCa
      * CUBE will produce four groupings:
      * (CHANNEL, YEAR), (CHANNEL), (YEAR), ()
      * which are then filtered by the <B>HAVING</B> condition
-     **/
+     */
     public void testAggregatedHaving2() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, SUM(SALES) as SALES \n" +
                 "FROM REVENUE\n" +
@@ -1813,12 +1818,13 @@ public class TestDataCube extends TestCa
     //------------------------------------------------------------
     // ORDER BY CLAUSE TEST
     //------------------------------------------------------------
+
     /**
      * Tests <b>ORDER BY</b> clause
      *
      * CUBE will produce four groupings:
      * (CHANNEL, YEAR), (CHANNEL), (YEAR),()
-     **/
+     */
     public void testAggregatedOrder() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, SUM(SALES) as SALES \n" +
                 "FROM REVENUE\n" +
@@ -1853,7 +1859,7 @@ public class TestDataCube extends TestCa
      *
      * CUBE will produce four groupings:
      * (CHANNEL, YEAR), (CHANNEL), (YEAR),()
-     **/
+     */
     public void testAggregatedOrder1() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, SUM(SALES) as SALES \n" +
                 "FROM REVENUE\n" +
@@ -1888,7 +1894,7 @@ public class TestDataCube extends TestCa
      *
      * CUBE will produce four groupings:
      * (CHANNEL, YEAR), (CHANNEL), (YEAR),()
-     **/
+     */
     public void testAggregatedOrder2() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, SUM(SALES) as SALES \n" +
                 "FROM REVENUE\n" +
@@ -1917,15 +1923,17 @@ public class TestDataCube extends TestCa
 
         compareResults(sql, expected, "00000");
     }
+
     //------------------------------------------------------------
     // Miscellaneous columns TEST
     //------------------------------------------------------------
+
     /**
      * Tests the interaction with renamed columns with
      * aggregated selection using the CUBE operator with a <b>GROUP_BY</b> clause.
      * The CUBE operator produces four groupings:
      * (CHANNEL, YEAR), (CHANNEL), (YEAR), ()
-     **/
+     */
     public void testAggregatedRename() throws SQLException {
         String sql = "SELECT CHANNEL as ROUTES, YEAR, SUM(SALES) as SALES\n" +
                 "FROM REVENUE \n" +
@@ -1950,6 +1958,7 @@ public class TestDataCube extends TestCa
                 null, Integer.valueOf(2010), Integer.valueOf(2559000)
         },
         };
+
         compareResults(sql, expected, "00000");
     }
 
@@ -1960,7 +1969,7 @@ public class TestDataCube extends TestCa
      *
      * The CUBE operator produces four groupings:
      * (CHANNEL, YEAR), (CHANNEL), ()
-     **/
+     */
     public void testAggregatedRename1() throws SQLException {
         String sql = "SELECT CHANNEL as ROUTES, YEAR as CALENDAR, SUM(SALES) as SALES\n" +
                 "FROM REVENUE \n" +
@@ -1991,7 +2000,7 @@ public class TestDataCube extends TestCa
      *
      * The CUBE operator produces four groupings:
      * (CHANNEL, YEAR), (CHANNEL), (YEAR),()
-     **/
+     */
     public void testAggregatedReorder() throws SQLException {
         String sql = "SELECT YEAR, SUM(SALES) as SALES, CHANNEL\n" +
                 "FROM REVENUE\n" +
@@ -2026,7 +2035,7 @@ public class TestDataCube extends TestCa
      *
      * The CUBE operator produces four groupings:
      * (YEAR, CHANNEL), (YEAR), (CHANNEL), ()
-     **/
+     */
     public void testAggregatedReorder1() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, SUM(SALES) as SALES\n" +
                 "FROM REVENUE \n" +
@@ -2061,7 +2070,7 @@ public class TestDataCube extends TestCa
      *
      * The ROLLUP operator produces four groupings:
      * (YEAR, CHANNEL), (YEAR), ()
-     **/
+     */
     public void testAggregatedReorder2() throws SQLException {
         String sql = "SELECT CHANNEL as ROUTES, SUM(SALES) as SALES, YEAR AS CALENDAR\n" +
                 "FROM REVENUE \n" +
@@ -2091,7 +2100,7 @@ public class TestDataCube extends TestCa
      * with a <b>GROUP_BY</b> clause.
      *
      * Not all columns involved in GROUP BY are displayed
-     **/
+     */
     public void testAggregatedMissingColumns() throws SQLException {
         String sql = "SELECT CHANNEL, COUNTRY, SUM(SALES)\n" +
                 "FROM REVENUE \n" +
@@ -2122,7 +2131,7 @@ public class TestDataCube extends TestCa
      *
      * The ROLLUP operator produces five groupings:
      * (CHANNEL, YEAR), (CHANNEL, YEAR),(CHANNEL, YEAR),(CHANNEL), ()
-     **/
+     */
     public void testAggregatedRepeatedColumns() throws SQLException {
         String sql = "SELECT CHANNEL as ROUTES, YEAR as CALENDAR, SUM(SALES)\n" +
                 "FROM REVENUE \n" +
@@ -2171,7 +2180,7 @@ public class TestDataCube extends TestCa
      * (CHANNEL, YEAR), (CHANNEL, YEAR),(CHANNEL, YEAR),(CHANNEL), ()
      *
      * The duplicate (CHANNEL, YEAR) groupings are eliminated.
-     **/
+     */
     public void testDistinctAggregatedRepeatedColumns() throws SQLException {
         String sql = "SELECT CHANNEL as ROUTES, YEAR as CALENDAR, SUM(SALES)\n" +
                 "FROM REVENUE \n" +
@@ -2201,7 +2210,7 @@ public class TestDataCube extends TestCa
      * columns not in the <b>GROUP BY</b> clause
      *
      * A SQLException should be thrown.
-     **/
+     */
     public void testInvalidMissingColumns() throws SQLException {
         String sql = "SELECT CHANNEL, COUNTRY, SUM(SALES)\n" +
                 "FROM REVENUE \n" +
@@ -2213,12 +2222,13 @@ public class TestDataCube extends TestCa
     //------------------------------------------------------------
     // Aggregate Functions TEST
     //------------------------------------------------------------
+
     /**
      * Tests the data-cube with the MIN aggregate function
      *
      * The CUBE operator produces four groupings:
      * (CHANNEL, YEAR), (CHANNEL), (YEAR), ()
-     **/
+     */
     public void testAggregatedMin() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, MIN(SALES) as SALES \n" +
                 "FROM REVENUE\n" +
@@ -2243,6 +2253,7 @@ public class TestDataCube extends TestCa
                 null, Integer.valueOf(2010), Integer.valueOf(20000)
         },
         };
+
         compareResults(sql, expected, "00000");
     }
 
@@ -2251,7 +2262,7 @@ public class TestDataCube extends TestCa
      *
      * The CUBE operator produces four groupings:
      * (CHANNEL, YEAR), (CHANNEL), (YEAR), ()
-     **/
+     */
     public void testAggregatedCount() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, COUNT(*) \n" +
                 "FROM REVENUE\n" +
@@ -2276,6 +2287,7 @@ public class TestDataCube extends TestCa
                 null, Integer.valueOf(2010), Integer.valueOf(8)
         },
         };
+
         compareResults(sql, expected, "00000");
     }
 
@@ -2284,7 +2296,7 @@ public class TestDataCube extends TestCa
      *
      * The CUBE operator produces two groupings:
      * (CHANNEL), ()
-     **/
+     */
     public void testAggregatedAvg() throws SQLException {
         String sql = "SELECT CHANNEL, AVG(SALES), VAR_SAMP(SALES), STDDEV_SAMP(SALES), VAR_POP (SALES), STDDEV_POP(SALES)\n" +
                 "FROM REVENUE\n" +
@@ -2297,14 +2309,16 @@ public class TestDataCube extends TestCa
                 "DIRECT SALES", Integer.valueOf(472312), 1.7276678125E11, Integer.valueOf(415652), 1.5117093359375E11, 388807
         },
         };
+
         compareResults(sql, expected, "00000");
     }
+
     /**
      * Tests the data-cube without an aggregate function
      *
      * The CUBE operator produces four groupings:
      * (CHANNEL, YEAR), (CHANNEL), (YEAR), ()
-     **/
+     */
     public void testAggregatedMissing() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR \n" +
                 "FROM REVENUE\n" +
@@ -2329,14 +2343,16 @@ public class TestDataCube extends TestCa
                 null, Integer.valueOf(2010)
         },
         };
+
         compareResults(sql, expected, "00000");
     }
+
     /**
      * Tests an invalid <b>GROUP BY</b> clause that contains
      * an aggregate function
      *
      * A SQLException should be thrown.
-     **/
+     */
     public void testInvalidAggregate() throws SQLException {
         String sql = "SELECT CHANNEL, COUNTRY, SUM(SALES)\n" +
                 "FROM REVENUE\n" +
@@ -2344,13 +2360,15 @@ public class TestDataCube extends TestCa
         Object[][] expected = new Object[][]{};
         compareResults(sql, expected, "42572");
     }
+
     //------------------------------------------------------------
     // Functions in GROUP BY TEST
     //------------------------------------------------------------
+
     /**
      * Tests the interaction of functions within the GROUP BY clause
      * and datacube operators.
-     **/
+     */
     public void testFunctionGroupBy() throws SQLException {
         String sql = "SELECT CASE WHEN A.SEL=1 THEN A.NAME2 ELSE A.NAME1 END AS NAME,\n" +
                 "  COUNT(A.NAME1) AS COUNTER FROM TEST A \n" +
@@ -2374,6 +2392,7 @@ public class TestDataCube extends TestCa
         }};
         compareResults(sql, expected, "00000");
     }
+
     public void testFunctionGroupBy1() throws SQLException {
         String sql = "SELECT CASE WHEN A.SEL=1 THEN A.NAME2 ELSE A.NAME1 END AS NAME,\n" +
                 "  COUNT(A.NAME1) AS COUNTER FROM TEST A \n" +
@@ -2403,6 +2422,7 @@ public class TestDataCube extends TestCa
         }};
         compareResults(sql, expected, "00000");
     }
+
     public void testFunctionGroupBy3() throws SQLException {
         String sql = "SELECT A.SEL, COALESCE(A.NAME1, A.NAME2) AS NAME,\n" +
                 "COUNT(A.SEL) AS COUNTER FROM TEST A \n" +
@@ -2427,10 +2447,10 @@ public class TestDataCube extends TestCa
         compareResults(sql, expected, "00000");
     }
 
-
     //------------------------------------------------------------
     // Complex Query TEST
     //------------------------------------------------------------
+
     /**
      * Tests the interaction of multiple features
      * Concatenated grouping, nesting and composite columns
@@ -2438,7 +2458,7 @@ public class TestDataCube extends TestCa
      * Produces seven groupings:
      * (CHANNEL, COUNTRY, PROVINCE), (CHANNEL, COUNTRY), (CHANNEL, PROVINCE), (CHANNEL)
      * (CHANNEL, YEAR, COUNTRY, PROVINCE), (CHANNEL, YEAR), (CHANNEL)
-     **/
+     */
     public void testAggregatedComplex() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, COUNTRY, PROVINCE, SUM(SALES) \n" +
                 "FROM REVENUE\n" +
@@ -2546,7 +2566,7 @@ public class TestDataCube extends TestCa
      * (CHANNEL, YEAR, COUNTRY, PROVINCE), (CHANNEL, YEAR), (CHANNEL)
      *
      * The duplicate are eliminated
-     **/
+     */
     public void testDistinctAggregatedComplex() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, COUNTRY, PROVINCE, SUM(SALES) \n" +
                 "FROM REVENUE\n" +
@@ -2648,7 +2668,7 @@ public class TestDataCube extends TestCa
      * Produces Eight groupings:
      * (CHANNEL, YEAR, COUNTRY), (CHANNEL, YEAR), (CHANNEL, COUNTRY), (CHANNEL)
      * (YEAR, COUNTRY), (YEAR), (COUNTRY), ()
-     **/
+     */
     public void testAggregatedComplex1() throws SQLException {
         String sql = "SELECT CHANNEL, YEAR, COUNTRY, SUM(SALES), SUM(LOSSES)\n" +
                 "FROM REVENUE\n" +
@@ -2675,7 +2695,6 @@ public class TestDataCube extends TestCa
         compareResults(sql, expected, "00000");
     }
 
-
     //------------------------------------------------------------
     // Helper methods
     //------------------------------------------------------------
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/test/TestDatetimeSimple.java 2.7.0-1/hsqldb/src/org/hsqldb/test/TestDatetimeSimple.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/test/TestDatetimeSimple.java	2020-07-10 12:13:42.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/test/TestDatetimeSimple.java	2022-03-26 22:15:26.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -39,13 +39,11 @@ import java.sql.ResultSet;
 import java.sql.SQLException;
 import java.sql.Statement;
 import java.sql.Timestamp;
+import java.util.Calendar;
 import java.util.TimeZone;
 
 import junit.framework.TestCase;
 
-import java.util.Calendar;
-import java.text.DateFormat;
-
 /**
  * Date Test Case.
  */
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/test/TestJavaFunctions.java 2.7.0-1/hsqldb/src/org/hsqldb/test/TestJavaFunctions.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/test/TestJavaFunctions.java	2021-01-25 13:36:02.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/test/TestJavaFunctions.java	2022-03-27 21:17:08.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/test/TestPreparedSubQueries.java 2.7.0-1/hsqldb/src/org/hsqldb/test/TestPreparedSubQueries.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/test/TestPreparedSubQueries.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/test/TestPreparedSubQueries.java	2022-04-21 16:08:00.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -60,7 +60,6 @@ public class TestPreparedSubQueries exte
             update  = u;
         }
     }
-    ;
 
     private sqlStmt[] stmtArray = {
         new sqlStmt("drop table a if exists cascade", false, false),
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/test/TestSchemaParse.java 2.7.0-1/hsqldb/src/org/hsqldb/test/TestSchemaParse.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/test/TestSchemaParse.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/test/TestSchemaParse.java	2022-04-21 16:08:00.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -1018,7 +1018,6 @@ public class TestSchemaParse extends Tes
 
         return newSuite;
     }
-    ;
 
     public void fire(int i, String name, String table, Object[] row1,
                      Object[] row2) {}
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/test/TestScript.java 2.7.0-1/hsqldb/src/org/hsqldb/test/TestScript.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/test/TestScript.java	2021-01-25 14:26:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/test/TestScript.java	2022-06-08 08:24:02.000000000 +0000
@@ -85,8 +85,8 @@ public class TestScript extends TestBase
 //    String path = "TestSelfSysTables.txt";
 //    String path = "TestTemp.txt";
     public TestScript(String name) {
-        super(name, "jdbc:hsqldb:mem:test", false, false);
-//        super(name, "jdbc:hsqldb:file:test1", false, false);
+        super(name, "jdbc:hsqldb:mem:test");
+//        super(name, "jdbc:hsqldb:file:test1");
     }
 
     public void test() throws java.lang.Exception {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/test/TestTextTable.java 2.7.0-1/hsqldb/src/org/hsqldb/test/TestTextTable.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/test/TestTextTable.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/test/TestTextTable.java	2022-04-21 16:08:00.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -163,7 +163,6 @@ public class TestTextTable extends TestB
             statement.execute(setTableSource);
         }
     }
-    ;
 
     TextTableDescriptor m_products = new TextTableDescriptor("products",
         "ID INTEGER PRIMARY KEY, \"name\" VARCHAR(20)", "\t", "\\t",
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/test/TestUtil.java 2.7.0-1/hsqldb/src/org/hsqldb/test/TestUtil.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/test/TestUtil.java	2021-02-04 10:10:36.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/test/TestUtil.java	2022-06-02 18:00:58.000000000 +0000
@@ -677,26 +677,27 @@ abstract class ParsedSection {
          * (note that UPPERCASE codes, while valid are only processed if the
          * system property IgnoreCodeCase has been set to true)
          *
-         * 'u' - update
-         * 'c' - count
+         * ' ' - not a test
+         * 'd' - display this line verbatim
+         * 'o' - dump result set
          * 'e' - exception
-         * 'r' - results
+         * 's' - silent
+         * 'c' - count number of lines in result set
+         * 'r' - result set
+         * 'u' - update count
          * 'w' - wait
          * 'p' - proceed
-         * 's' - silent
-         * 'd' - display   (No reason to use upper-case).
-         * ' ' - not a test
          */
         switch (aCode) {
 
             case ' ' :
-            case 'r' :
+            case 'd' :
             case 'o' :
             case 'e' :
+            case 's' :
             case 'c' :
+            case 'r' :
             case 'u' :
-            case 's' :
-            case 'd' :
             case 'w' :
             case 'p' :
                 return true;
@@ -906,7 +907,7 @@ class ResultSetParsedSection extends Par
                                 String actualS = actual;
 
                                 if (results.getMetaData().getColumnClassName(
-                                        i).equals("java.lang.String")) {
+                                        j).equals("java.lang.String")) {
                                     actualS =
                                         StringConverter.toQuotedString(actualS,
                                                                        '\'',
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/Tokens.java 2.7.0-1/hsqldb/src/org/hsqldb/Tokens.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/Tokens.java	2021-07-15 13:57:30.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/Tokens.java	2022-03-25 12:50:46.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -39,7 +39,7 @@ import org.hsqldb.lib.OrderedIntHashSet;
  * Defines and enumerates reserved and non-reserved SQL keywords.<p>
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.1
+ * @version 2.7.0
  * @since 1.7.2
  */
 public class Tokens {
@@ -220,7 +220,7 @@ public class Tokens {
     public static final String T_LOOP              = "LOOP";
     public static final String T_LOWER             = "LOWER";
     static final String        T_MATCH             = "MATCH";
-    static final String        T_MAX               = "MAX";
+    public static final String T_MAX               = "MAX";
     static final String        T_MAX_CARDINALITY   = "MAX_CARDINALITY";
     static final String        T_MEMBER            = "MEMBER";
     static final String        T_MERGE             = "MERGE";
@@ -281,7 +281,7 @@ public class Tokens {
     static final String        T_RANK              = "RANK";
     static final String        T_READS             = "READS";
     public static final String T_REAL              = "REAL";
-    static final String        T_RECURSIVE         = "RECURSIVE";
+    public static final String T_RECURSIVE         = "RECURSIVE";
     static final String        T_REF               = "REF";
     public static final String T_REFERENCES        = "REFERENCES";
     static final String        T_REFERENCING       = "REFERENCING";
@@ -348,7 +348,7 @@ public class Tokens {
     public static final String T_TIMEZONE_HOUR     = "TIMEZONE_HOUR";
     public static final String T_TIMEZONE_MINUTE   = "TIMEZONE_MINUTE";
     public static final String T_TO                = "TO";
-    static final String        T_TRAILING          = "TRAILING";
+    public static final String T_TRAILING          = "TRAILING";
     public static final String T_TRANSLATE         = "TRANSLATE";
     static final String        T_TRANSLATE_REGEX   = "TRANSLATE_REGEX";
     static final String        T_TRANSLATION       = "TRANSLATION";
@@ -393,12 +393,13 @@ public class Tokens {
     public static final String T_COMMA          = ",";
     static final String        T_CIRCUMFLEX     = "^";
     public static final String T_CLOSEBRACKET   = ")";
-    static final String        T_COLON          = ":";
+    public static final String T_COLON          = ":";
     static final String        T_CONCAT_OP      = "||";
     public static final String T_DIVIDE_OP      = "/";
     static final String        T_EQUALS_OP      = "=";
     static final String        T_GREATER_OP     = ">";
     static final String        T_GREATER_EQUALS = ">=";
+    public static final String T_LEFTBRACE      = "{";
     public static final String T_LEFTBRACKET    = "[";
     static final String        T_LESS_OP        = "<";
     static final String        T_LESS_EQUALS    = "<=";
@@ -409,12 +410,14 @@ public class Tokens {
     static final String        T_NOT_EQUALS_ALT = "!=";
     public static final String T_OPENBRACKET    = "(";
     static final String        T_QUESTION       = "?";
+    public static final String T_RIGHTBRACE     = "}";
     public static final String T_RIGHTBRACKET   = "]";
     static final String        T_SEMICOLON      = ";";
     static final String        T_DOUBLE_COLON   = "::";
 
     // SQL:200n non-reserved word list
     static final String        T_A                    = "A";
+    static final String        T_ABSENT               = "ABSENT";
     static final String        T_ABSOLUTE             = "ABSOLUTE";
     static final String        T_ACTION               = "ACTION";
     static final String        T_ADA                  = "ADA";
@@ -455,6 +458,7 @@ public class Tokens {
     static final String        T_COMPARABLE           = "COMPARABLE";    // SQL/JRT
     static final String        T_CONDITION_IDENTIFIER = "CONDIITON_IDENTIFIER";
     static final String        T_CONDITION_NUMBER     = "CONDITION_NUMBER";
+    static final String        T_CONDITIONAL          = "CONDITIONAL";
     static final String        T_CONNECTION           = "CONNECTION";
     static final String        T_CONNECTION_NAME      = "CONNECTION_NAME";
     static final String        T_CONSTRAINT_CATALOG   = "CONSTRAINT_CATALOG";
@@ -484,7 +488,10 @@ public class Tokens {
     public static final String T_DOMAIN               = "DOMAIN";
     static final String        T_DYNAMIC_FUNCTION     = "DYNAMIC_FUNCTION";
     static final String T_DYNAMIC_FUNCTION_CODE = "DYNAMIC_FUNCTION_CODE";
+    static final String        T_EMPTY                = "EMPTY";
+    static final String        T_ENCODING             = "ENCODING";
     static final String        T_ENFORCED             = "ENFORCED";
+    public static final String T_ERROR                = "ERROR";
     static final String        T_EXCEPTION            = "EXCEPTION";
     static final String        T_EXCLUDE              = "EXCLUDE";
     static final String        T_EXCLUDING            = "EXCLUDING";
@@ -494,6 +501,7 @@ public class Tokens {
     public static final String T_FIRST                = "FIRST";
     static final String        T_FLAG                 = "FLAG";
     static final String        T_FOLLOWING            = "FOLLOWING";
+    static final String        T_FORMAT               = "FORMAT";
     static final String        T_FORTRAN              = "FORTRAN";
     static final String        T_FOUND                = "FOUND";
     public static final String T_G_FACTOR             = "G";
@@ -518,8 +526,19 @@ public class Tokens {
     static final String        T_INVOKER              = "INVOKER";
     public static final String T_ISOLATION            = "ISOLATION";
     public static final String T_JAVA                 = "JAVA";          // SQL/JRT
+    static final String        T_JSON                 = "JSON";
+    static final String        T_JSON_ARRAY           = "JSON_ARRAY";
+    static final String        T_JSON_ARRAYAGG        = "JSON_ARRAYAGG";
+    static final String        T_JSON_EXISTS          = "JSON_EXISTS";
+    static final String        T_JSON_OBJECT          = "JSON_OBJECT";
+    static final String        T_JSON_OBJECTAGG       = "JSON_OBJECTAGG";
+    static final String        T_JSON_QUERY           = "JSON_QUERY";
+    static final String        T_JSON_TABLE           = "JSON_TABLE";
+    static final String        T_JSON_VALUE           = "JSON_VALUE";
     public static final String T_K_FACTOR             = "K";
+    static final String        T_KEEP                 = "KEEP";
     static final String        T_KEY                  = "KEY";
+    static final String        T_KEYS                 = "KEYS";
     static final String        T_KEY_MEMBER           = "KEY_MEMBER";
     static final String        T_KEY_TYPE             = "KEY_TYPE";
     static final String        T_LAST                 = "LAST";
@@ -539,6 +558,7 @@ public class Tokens {
     static final String        T_MUMPS                = "MUMPS";
     public static final String T_NAME                 = "NAME";
     public static final String T_NAMES                = "NAMES";
+    static final String        T_NESTED               = "NESTED";
     static final String        T_NESTING              = "NESTING";
     static final String        T_NEXT                 = "NEXT";
     static final String        T_NFC                  = "NFC";
@@ -551,6 +571,7 @@ public class Tokens {
     static final String        T_NUMBER               = "NUMBER";
     public static final String T_OBJECT               = "OBJECT";
     static final String        T_OCTETS               = "OCTETS";
+    public static final String T_OMIT                 = "OMIT";
     static final String        T_OPTION               = "OPTION";
     static final String        T_OPTIONS              = "OPTIONS";
     static final String        T_ORDERING             = "ORDERING";
@@ -571,6 +592,7 @@ public class Tokens {
     static final String T_PARAMETER_SPEC_SCHEMA = "PARAMETER_SPECIFIC_SCHEMA";
     static final String        T_PARTIAL              = "PARTIAL";
     static final String        T_PASCAL               = "PASCAL";
+    static final String        T_PASSING              = "PASSSING";
     public static final String T_PATH                 = "PATH";
     static final String        T_PLACING              = "PLACING";
     static final String        T_PLI                  = "PLI";
@@ -590,12 +612,14 @@ public class Tokens {
     static final String        T_RETURNED_LENGTH      = "RETURNED_LENGTH";
     static final String T_RETURNED_OCTET_LENGTH = "RETURNED_OCTET_LENGTH";
     static final String        T_RETURNED_SQLSTATE    = "RETURNED_SQLSTATE";
+    static final String        T_RETURNING            = "RETURNING";
     public static final String T_ROLE                 = "ROLE";
     public static final String T_ROUTINE              = "ROUTINE";
     static final String        T_ROUTINE_CATALOG      = "ROUTINE_CATALOG";
     static final String        T_ROUTINE_NAME         = "ROUTINE_NAME";
     static final String        T_ROUTINE_SCHEMA       = "ROUTINE_SCHEMA";
     static final String        T_ROW_COUNT            = "ROW_COUNT";
+    static final String        T_SCALAR               = "SCALAR";
     public static final String T_SCALE                = "SCALE";
     public static final String T_SCHEMA               = "SCHEMA";
     static final String        T_SCHEMA_NAME          = "SCHEMA_NAME";
@@ -640,6 +664,7 @@ public class Tokens {
     static final String        T_TRIGGER_SCHEMA       = "TRIGGER_SCHEMA";
     public static final String T_TYPE                 = "TYPE";
     static final String        T_UNBOUNDED            = "UNBOUNDED";
+    static final String        T_UNCONDITIONAL        = "UNCONDITIONAL";
     static final String        T_UNCOMMITTED          = "UNCOMMITTED";
     static final String        T_UNDER                = "UNDER";
     static final String        T_UNDO                 = "UNDO";
@@ -693,7 +718,6 @@ public class Tokens {
     public static final String T_DIGEST               = "DIGEST";
     static final String        T_DUAL                 = "DUAL";
     static final String        T_DUPLICATE            = "DUPLICATE";
-    public static final String T_ERROR                = "ERROR";
     public static final String T_EVENT                = "EVENT";
     static final String        T_EXCLUSIVE            = "EXCLUSIVE";
     static final String        T_EXPLAIN              = "EXPLAIN";
@@ -702,7 +726,6 @@ public class Tokens {
     static final String        T_FILE                 = "FILE";
     public static final String T_FILES                = "FILES";
     static final String        T_FOLD                 = "FOLD";
-    static final String        T_FORMAT               = "FORMAT";
     static final String        T_GROUP_CONCAT         = "GROUP_CONCAT";
     static final String        T_HEADER               = "HEADER";
     public static final String T_IDENTIFIER           = "IDENTIFIER";
@@ -720,7 +743,6 @@ public class Tokens {
         "IS_READONLY_DATABASE_FILES";
     static final String        T_IS_READONLY_SESSION  = "IS_READONLY_SESSION";
     static final String        T_ISNULL               = "ISNULL";
-    static final String        T_KEEP                 = "KEEP";
     static final String        T_LASTVAL              = "LASTVAL";
     static final String        T_LIMIT                = "LIMIT";
     public static final String T_LOB                  = "LOB";
@@ -1345,327 +1367,346 @@ public class Tokens {
     //
     //SQL 200n Standard non-reserved keywords - full set
     public static final int A                           = 351;
-    public static final int ABSOLUTE                    = 352;
-    public static final int ACTION                      = 353;
-    public static final int ADA                         = 354;
-    public static final int ADD                         = 355;
-    public static final int ADMIN                       = 356;
-    public static final int AFTER                       = 357;
-    public static final int ALWAYS                      = 358;
-    public static final int ASC                         = 359;
-    public static final int ASSERTION                   = 360;
-    public static final int ASSIGNMENT                  = 361;
-    public static final int ATTRIBUTE                   = 362;
-    public static final int ATTRIBUTES                  = 363;
-    public static final int BEFORE                      = 364;
-    public static final int BERNOULLI                   = 365;
-    public static final int BREADTH                     = 366;
-    public static final int C                           = 367;
-    public static final int CASCADE                     = 368;
-    public static final int CATALOG                     = 369;
-    public static final int CATALOG_NAME                = 370;
-    public static final int CHAIN                       = 371;
-    public static final int CHARACTER_SET_CATALOG       = 372;
-    public static final int CHARACTER_SET_NAME          = 373;
-    public static final int CHARACTER_SET_SCHEMA        = 374;
-    public static final int CHARACTERISTICS             = 375;
-    public static final int CHARACTERS                  = 376;
-    public static final int CLASS_ORIGIN                = 377;
-    public static final int COBOL                       = 378;
-    public static final int COLLATION                   = 379;
-    public static final int COLLATION_CATALOG           = 380;
-    public static final int COLLATION_NAME              = 381;
-    public static final int COLLATION_SCHEMA            = 382;
-    public static final int COLUMN_NAME                 = 383;
-    public static final int COMMAND_FUNCTION            = 384;
-    public static final int COMMAND_FUNCTION_CODE       = 385;
-    public static final int COMMITTED                   = 386;
-    public static final int CONDITION_IDENTIFIER        = 387;
-    public static final int CONDITION_NUMBER            = 388;
-    public static final int CONNECTION                  = 389;
-    public static final int CONNECTION_NAME             = 390;
-    public static final int CONSTRAINT_CATALOG          = 391;
-    public static final int CONSTRAINT_NAME             = 392;
-    public static final int CONSTRAINT_SCHEMA           = 393;
-    public static final int CONSTRAINTS                 = 394;
-    public static final int CONSTRUCTOR                 = 395;
-    public static final int XCONTAINS                   = 396;
-    public static final int CONTINUE                    = 397;
-    public static final int CURSOR_NAME                 = 398;
-    public static final int DATA                        = 399;
-    public static final int DATETIME_INTERVAL_CODE      = 400;
-    public static final int DATETIME_INTERVAL_PRECISION = 401;
-    public static final int DEFAULTS                    = 402;
-    public static final int DEFERRABLE                  = 403;
-    public static final int DEFERRED                    = 404;
-    public static final int DEFINED                     = 405;
-    public static final int DEFINER                     = 406;
-    public static final int DEGREE                      = 407;
-    public static final int DEPTH                       = 408;
-    public static final int DERIVED                     = 409;
-    public static final int DESC                        = 410;
-    public static final int DESCRIPTOR                  = 411;
-    public static final int DIAGNOSTICS                 = 412;
-    public static final int DISPATCH                    = 413;
-    public static final int DOMAIN                      = 414;
-    public static final int DYNAMIC_FUNCTION            = 415;
-    public static final int DYNAMIC_FUNCTION_CODE       = 416;
-    public static final int EQUALS_OP                   = 417;
-    public static final int EXCEPTION                   = 418;
-    public static final int EXCLUDE                     = 419;
-    public static final int EXCLUDING                   = 420;
-    public static final int EXPRESSION                  = 421;
-    public static final int FINAL                       = 422;
-    public static final int FIRST                       = 423;
-    public static final int FOLLOWING                   = 424;
-    public static final int FORTRAN                     = 425;
-    public static final int FOUND                       = 426;
-    public static final int G                           = 427;
-    public static final int GENERAL                     = 428;
-    public static final int GENERATED                   = 429;
-    public static final int GO                          = 430;
-    public static final int GOTO                        = 431;
-    public static final int GRANTED                     = 432;
-    public static final int HIERARCHY                   = 433;
-    public static final int IF                          = 434;
-    public static final int IGNORE                      = 435;
-    public static final int IMMEDIATE                   = 436;
-    public static final int IMPLEMENTATION              = 437;
-    public static final int INCLUDING                   = 438;
-    public static final int INCREMENT                   = 439;
-    public static final int INITIALLY                   = 440;
-    public static final int INPUT                       = 441;
-    public static final int INSTANCE                    = 442;
-    public static final int INSTANTIABLE                = 443;
-    public static final int INSTEAD                     = 444;
-    public static final int INVOKER                     = 445;
-    public static final int ISOLATION                   = 446;
-    public static final int JAVA                        = 447;
-    public static final int K                           = 448;
-    public static final int KEY                         = 449;
-    public static final int KEY_MEMBER                  = 450;
-    public static final int KEY_TYPE                    = 451;
-    public static final int LAST                        = 452;
-    public static final int LENGTH                      = 453;
-    public static final int LEVEL                       = 454;
-    public static final int LIBRARY                     = 455;
-    public static final int LOCATOR                     = 456;
-    public static final int M                           = 457;
-    public static final int MAP                         = 458;
-    public static final int MATCHED                     = 459;
-    public static final int MAXVALUE                    = 460;
-    public static final int MESSAGE_LENGTH              = 461;
-    public static final int MESSAGE_OCTET_LENGTH        = 462;
-    public static final int MESSAGE_TEXT                = 463;
-    public static final int MINVALUE                    = 464;
-    public static final int MORE                        = 465;
-    public static final int MUMPS                       = 466;
-    public static final int NAME                        = 467;
-    public static final int NAMES                       = 468;
-    public static final int NESTING                     = 469;
-    public static final int NEXT                        = 470;
-    public static final int NORMALIZED                  = 471;
-    public static final int NULLABLE                    = 472;
-    public static final int NULLS                       = 473;
-    public static final int NUMBER                      = 474;
-    public static final int OBJECT                      = 475;
-    public static final int OCTETS                      = 476;
-    public static final int OPTION                      = 477;
-    public static final int OPTIONS                     = 478;
-    public static final int ORDERING                    = 479;
-    public static final int ORDINALITY                  = 480;
-    public static final int OTHERS                      = 481;
-    public static final int OUTPUT                      = 482;
-    public static final int OVERFLOW                    = 483;
-    public static final int OVERRIDING                  = 484;
-    public static final int P                           = 485;
-    public static final int PAD                         = 486;
-    public static final int PARAMETER_MODE              = 487;
-    public static final int PARAMETER_NAME              = 488;
-    public static final int PARAMETER_ORDINAL_POSITION  = 489;
-    public static final int PARAMETER_SPECIFIC_CATALOG  = 490;
-    public static final int PARAMETER_SPECIFIC_NAME     = 491;
-    public static final int PARAMETER_SPECIFIC_SCHEMA   = 492;
-    public static final int PARTIAL                     = 493;
-    public static final int PASCAL                      = 494;
-    public static final int PATH                        = 495;
-    public static final int PLACING                     = 496;
-    public static final int PLI                         = 497;
-    public static final int PRECEDING                   = 498;
-    public static final int PRESERVE                    = 499;
-    public static final int PRIOR                       = 500;
-    public static final int PRIVILEGES                  = 501;
-    public static final int PUBLIC                      = 502;
-    public static final int READ                        = 503;
-    public static final int RELATIVE                    = 504;
-    public static final int REPEATABLE                  = 505;
-    public static final int RESPECT                     = 506;
-    public static final int RESTART                     = 507;
-    public static final int RESTRICT                    = 508;
-    public static final int RETURNED_CARDINALITY        = 509;
-    public static final int RETURNED_LENGTH             = 510;
-    public static final int RETURNED_OCTET_LENGTH       = 511;
-    public static final int RETURNED_SQLSTATE           = 512;
-    public static final int ROLE                        = 513;
-    public static final int ROUTINE                     = 514;
-    public static final int ROUTINE_CATALOG             = 515;
-    public static final int ROUTINE_NAME                = 516;
-    public static final int ROUTINE_SCHEMA              = 517;
-    public static final int ROW_COUNT                   = 518;
-    public static final int SCALE                       = 519;
-    public static final int SCHEMA                      = 520;
-    public static final int SCHEMA_NAME                 = 521;
-    public static final int SCOPE_CATALOG               = 522;
-    public static final int SCOPE_NAME                  = 523;
-    public static final int SCOPE_SCHEMA                = 524;
-    public static final int SECTION                     = 525;
-    public static final int SECURITY                    = 526;
-    public static final int SELF                        = 527;
-    public static final int SEQUENCE                    = 528;
-    public static final int SERIALIZABLE                = 529;
-    public static final int SERVER_NAME                 = 530;
-    public static final int SESSION                     = 531;
-    public static final int SERVER                      = 532;
-    public static final int SETS                        = 533;
-    public static final int SIMPLE                      = 534;
-    public static final int SIZE                        = 535;
-    public static final int SOURCE                      = 536;
-    public static final int SPACE                       = 537;
-    public static final int SPECIFIC_NAME               = 538;
-    public static final int STATE                       = 539;
-    public static final int STATEMENT                   = 540;
-    public static final int STRUCTURE                   = 541;
-    public static final int STYLE                       = 542;
-    public static final int SUBCLASS_ORIGIN             = 543;
-    public static final int T                           = 544;
-    public static final int TABLE_NAME                  = 545;
-    public static final int TEMPORARY                   = 546;
-    public static final int TIES                        = 547;
-    public static final int TOP_LEVEL_COUNT             = 548;
-    public static final int TRANSACTION                 = 549;
-    public static final int TRANSACTION_ACTIVE          = 550;
-    public static final int TRANSACTIONS_COMMITTED      = 551;
-    public static final int TRANSACTIONS_ROLLED_BACK    = 552;
-    public static final int TRANSFORM                   = 553;
-    public static final int TRANSFORMS                  = 554;
-    public static final int TRIGGER_CATALOG             = 555;
-    public static final int TRIGGER_NAME                = 556;
-    public static final int TRIGGER_SCHEMA              = 557;
-    public static final int TYPE                        = 558;
-    public static final int UNBOUNDED                   = 559;
-    public static final int UNCOMMITTED                 = 560;
-    public static final int UNDER                       = 561;
-    public static final int UNNAMED                     = 562;
-    public static final int USAGE                       = 563;
-    public static final int USER_DEFINED_TYPE_CATALOG   = 564;
-    public static final int USER_DEFINED_TYPE_CODE      = 565;
-    public static final int USER_DEFINED_TYPE_NAME      = 566;
-    public static final int USER_DEFINED_TYPE_SCHEMA    = 567;
-    public static final int VIEW                        = 568;
-    public static final int WORK                        = 569;
-    public static final int WRITE                       = 570;
-    public static final int WRAPPER                     = 571;
-    public static final int ZONE                        = 572;
+    public static final int ABSENT                      = 352;
+    public static final int ABSOLUTE                    = 353;
+    public static final int ACTION                      = 354;
+    public static final int ADA                         = 355;
+    public static final int ADD                         = 356;
+    public static final int ADMIN                       = 357;
+    public static final int AFTER                       = 358;
+    public static final int ALWAYS                      = 359;
+    public static final int ASC                         = 360;
+    public static final int ASSERTION                   = 361;
+    public static final int ASSIGNMENT                  = 362;
+    public static final int ATTRIBUTE                   = 363;
+    public static final int ATTRIBUTES                  = 364;
+    public static final int BEFORE                      = 365;
+    public static final int BERNOULLI                   = 366;
+    public static final int BREADTH                     = 367;
+    public static final int C                           = 368;
+    public static final int CASCADE                     = 369;
+    public static final int CATALOG                     = 370;
+    public static final int CATALOG_NAME                = 371;
+    public static final int CHAIN                       = 372;
+    public static final int CHARACTER_SET_CATALOG       = 373;
+    public static final int CHARACTER_SET_NAME          = 374;
+    public static final int CHARACTER_SET_SCHEMA        = 375;
+    public static final int CHARACTERISTICS             = 376;
+    public static final int CHARACTERS                  = 377;
+    public static final int CLASS_ORIGIN                = 378;
+    public static final int COBOL                       = 379;
+    public static final int COLLATION                   = 380;
+    public static final int COLLATION_CATALOG           = 381;
+    public static final int COLLATION_NAME              = 382;
+    public static final int COLLATION_SCHEMA            = 383;
+    public static final int COLUMN_NAME                 = 384;
+    public static final int COMMAND_FUNCTION            = 385;
+    public static final int COMMAND_FUNCTION_CODE       = 386;
+    public static final int COMMITTED                   = 387;
+    public static final int CONDITION_IDENTIFIER        = 388;
+    public static final int CONDITION_NUMBER            = 389;
+    public static final int CONDITIONAL                 = 390;
+    public static final int CONNECTION                  = 391;
+    public static final int CONNECTION_NAME             = 392;
+    public static final int CONSTRAINT_CATALOG          = 393;
+    public static final int CONSTRAINT_NAME             = 394;
+    public static final int CONSTRAINT_SCHEMA           = 395;
+    public static final int CONSTRAINTS                 = 396;
+    public static final int CONSTRUCTOR                 = 397;
+    public static final int CONTINUE                    = 398;
+    public static final int CURSOR_NAME                 = 399;
+    public static final int DATA                        = 400;
+    public static final int DATETIME_INTERVAL_CODE      = 401;
+    public static final int DATETIME_INTERVAL_PRECISION = 402;
+    public static final int DEFAULTS                    = 403;
+    public static final int DEFERRABLE                  = 404;
+    public static final int DEFERRED                    = 405;
+    public static final int DEFINED                     = 406;
+    public static final int DEFINER                     = 407;
+    public static final int DEGREE                      = 408;
+    public static final int DEPTH                       = 409;
+    public static final int DERIVED                     = 410;
+    public static final int DESC                        = 411;
+    public static final int DESCRIPTOR                  = 412;
+    public static final int DIAGNOSTICS                 = 413;
+    public static final int DISPATCH                    = 414;
+    public static final int DOMAIN                      = 415;
+    public static final int DYNAMIC_FUNCTION            = 416;
+    public static final int DYNAMIC_FUNCTION_CODE       = 417;
+    public static final int EMPTY                       = 418;
+    public static final int ENCODING                    = 419;
+    public static final int EQUALS_OP                   = 420;
+    public static final int ERROR                       = 421;
+    public static final int EXCEPTION                   = 422;
+    public static final int EXCLUDE                     = 423;
+    public static final int EXCLUDING                   = 424;
+    public static final int EXPRESSION                  = 425;
+    public static final int FINAL                       = 426;
+    public static final int FIRST                       = 427;
+    public static final int FOLLOWING                   = 428;
+    public static final int FORMAT                      = 429;
+    public static final int FORTRAN                     = 430;
+    public static final int FOUND                       = 431;
+    public static final int G                           = 432;
+    public static final int GENERAL                     = 433;
+    public static final int GENERATED                   = 434;
+    public static final int GO                          = 435;
+    public static final int GOTO                        = 436;
+    public static final int GRANTED                     = 437;
+    public static final int HIERARCHY                   = 438;
+    public static final int IF                          = 439;
+    public static final int IGNORE                      = 440;
+    public static final int IMMEDIATE                   = 441;
+    public static final int IMPLEMENTATION              = 442;
+    public static final int INCLUDING                   = 443;
+    public static final int INCREMENT                   = 444;
+    public static final int INITIALLY                   = 445;
+    public static final int INPUT                       = 446;
+    public static final int INSTANCE                    = 447;
+    public static final int INSTANTIABLE                = 448;
+    public static final int INSTEAD                     = 449;
+    public static final int INVOKER                     = 450;
+    public static final int ISOLATION                   = 451;
+    public static final int JSON                        = 452;
+    public static final int JSON_ARRAY                  = 453;
+    public static final int JSON_ARRAYAGG               = 454;
+    public static final int JSON_EXISTS                 = 455;
+    public static final int JSON_OBJECT                 = 456;
+    public static final int JSON_OBJECTAGG              = 457;
+    public static final int JSON_QUERY                  = 458;
+    public static final int JSON_TABLE                  = 459;
+    public static final int JSON_VALUE                  = 460;
+    public static final int JAVA                        = 461;
+    public static final int K                           = 462;
+    public static final int KEY                         = 463;
+    public static final int KEY_MEMBER                  = 464;
+    public static final int KEY_TYPE                    = 465;
+    public static final int KEYS                        = 466;
+    public static final int LAST                        = 467;
+    public static final int LENGTH                      = 468;
+    public static final int LEVEL                       = 469;
+    public static final int LIBRARY                     = 470;
+    public static final int LOCATOR                     = 471;
+    public static final int M                           = 472;
+    public static final int MAP                         = 473;
+    public static final int MATCHED                     = 474;
+    public static final int MAXVALUE                    = 475;
+    public static final int MESSAGE_LENGTH              = 476;
+    public static final int MESSAGE_OCTET_LENGTH        = 477;
+    public static final int MESSAGE_TEXT                = 478;
+    public static final int MINVALUE                    = 479;
+    public static final int MORE                        = 480;
+    public static final int MUMPS                       = 481;
+    public static final int NAME                        = 482;
+    public static final int NAMES                       = 483;
+    public static final int NESTED                      = 484;
+    public static final int NESTING                     = 485;
+    public static final int NEXT                        = 486;
+    public static final int NORMALIZED                  = 487;
+    public static final int NULLABLE                    = 488;
+    public static final int NULLS                       = 489;
+    public static final int NUMBER                      = 490;
+    public static final int OBJECT                      = 491;
+    public static final int OCTETS                      = 492;
+    public static final int OMIT                        = 493;
+    public static final int OPTION                      = 494;
+    public static final int OPTIONS                     = 495;
+    public static final int ORDERING                    = 496;
+    public static final int ORDINALITY                  = 497;
+    public static final int OTHERS                      = 498;
+    public static final int OUTPUT                      = 499;
+    public static final int OVERFLOW                    = 500;
+    public static final int OVERRIDING                  = 501;
+    public static final int P                           = 502;
+    public static final int PAD                         = 503;
+    public static final int PARAMETER_MODE              = 504;
+    public static final int PARAMETER_NAME              = 505;
+    public static final int PARAMETER_ORDINAL_POSITION  = 506;
+    public static final int PARAMETER_SPECIFIC_CATALOG  = 507;
+    public static final int PARAMETER_SPECIFIC_NAME     = 508;
+    public static final int PARAMETER_SPECIFIC_SCHEMA   = 509;
+    public static final int PARTIAL                     = 510;
+    public static final int PASCAL                      = 511;
+    public static final int PASSING                     = 512;
+    public static final int PATH                        = 513;
+    public static final int PLACING                     = 514;
+    public static final int PLI                         = 515;
+    public static final int PRECEDING                   = 516;
+    public static final int PRESERVE                    = 517;
+    public static final int PRIOR                       = 518;
+    public static final int PRIVILEGES                  = 519;
+    public static final int PUBLIC                      = 520;
+    public static final int READ                        = 521;
+    public static final int RELATIVE                    = 522;
+    public static final int REPEATABLE                  = 523;
+    public static final int RESPECT                     = 524;
+    public static final int RESTART                     = 525;
+    public static final int RESTRICT                    = 526;
+    public static final int RETURNED_CARDINALITY        = 527;
+    public static final int RETURNED_LENGTH             = 528;
+    public static final int RETURNED_OCTET_LENGTH       = 529;
+    public static final int RETURNED_SQLSTATE           = 530;
+    public static final int RETURNING                   = 531;
+    public static final int ROLE                        = 532;
+    public static final int ROUTINE                     = 533;
+    public static final int ROUTINE_CATALOG             = 534;
+    public static final int ROUTINE_NAME                = 535;
+    public static final int ROUTINE_SCHEMA              = 536;
+    public static final int ROW_COUNT                   = 537;
+    public static final int SCALAR                      = 538;
+    public static final int SCALE                       = 539;
+    public static final int SCHEMA                      = 540;
+    public static final int SCHEMA_NAME                 = 541;
+    public static final int SCOPE_CATALOG               = 542;
+    public static final int SCOPE_NAME                  = 543;
+    public static final int SCOPE_SCHEMA                = 544;
+    public static final int SECTION                     = 545;
+    public static final int SECURITY                    = 546;
+    public static final int SELF                        = 547;
+    public static final int SEQUENCE                    = 548;
+    public static final int SERIALIZABLE                = 549;
+    public static final int SERVER_NAME                 = 550;
+    public static final int SESSION                     = 551;
+    public static final int SERVER                      = 552;
+    public static final int SETS                        = 553;
+    public static final int SIMPLE                      = 554;
+    public static final int SIZE                        = 555;
+    public static final int SOURCE                      = 556;
+    public static final int SPACE                       = 557;
+    public static final int SPECIFIC_NAME               = 558;
+    public static final int STATE                       = 559;
+    public static final int STATEMENT                   = 560;
+    public static final int STRUCTURE                   = 561;
+    public static final int STYLE                       = 562;
+    public static final int SUBCLASS_ORIGIN             = 563;
+    public static final int T                           = 564;
+    public static final int TABLE_NAME                  = 565;
+    public static final int TEMPORARY                   = 566;
+    public static final int TIES                        = 567;
+    public static final int TOP_LEVEL_COUNT             = 568;
+    public static final int TRANSACTION                 = 569;
+    public static final int TRANSACTION_ACTIVE          = 570;
+    public static final int TRANSACTIONS_COMMITTED      = 571;
+    public static final int TRANSACTIONS_ROLLED_BACK    = 572;
+    public static final int TRANSFORM                   = 573;
+    public static final int TRANSFORMS                  = 574;
+    public static final int TRIGGER_CATALOG             = 575;
+    public static final int TRIGGER_NAME                = 576;
+    public static final int TRIGGER_SCHEMA              = 577;
+    public static final int TYPE                        = 578;
+    public static final int UNBOUNDED                   = 579;
+    public static final int UNCOMMITTED                 = 580;
+    public static final int UNCONDITIONAL               = 581;
+    public static final int UNDER                       = 582;
+    public static final int UNNAMED                     = 583;
+    public static final int USAGE                       = 584;
+    public static final int USER_DEFINED_TYPE_CATALOG   = 585;
+    public static final int USER_DEFINED_TYPE_CODE      = 586;
+    public static final int USER_DEFINED_TYPE_NAME      = 587;
+    public static final int USER_DEFINED_TYPE_SCHEMA    = 588;
+    public static final int VIEW                        = 589;
+    public static final int WORK                        = 590;
+    public static final int WRITE                       = 591;
+    public static final int WRAPPER                     = 592;
+    public static final int ZONE                        = 593;
 
     // other token values used as switch cases
-    static final int        ALIAS          = 581;
-    static final int        AGGREGATE      = 582;
-    static final int        AUTOCOMMIT     = 583;
-    static final int        AUTHENTICATION = 584;
-    static final int        BACKUP         = 585;
-    static final int        BINARY_FLOAT   = 586;
-    static final int        BINARY_DOUBLE  = 587;
-    static final int        BIT            = 588;
-    static final int        BLOCKING       = 589;
-    static final int        BODY           = 590;
-    static final int        BYTE           = 591;
-    static final int        CACHE          = 592;
-    static final int        CACHED         = 593;
-    static final int        CASEWHEN       = 594;
-    static final int        CHECKPOINT     = 595;
-    static final int        CITEXT         = 596;
-    static final int        CLASS          = 597;
-    static final int        CLUSTERED      = 598;
-    static final int        COMMENT        = 599;
-    static final int        COMPACT        = 600;
-    static final int        COMPRESSED     = 601;
-    static final int        CONFLICT       = 602;
-    static final int        CONTROL        = 603;
-    static final int        CURRVAL        = 604;
-    static final int        DATABASE       = 605;
-    static final int        DEADLOCK       = 606;
-    static final int        DEFRAG         = 607;
-    static final int        DELAY          = 608;
-    static final int        DIGEST         = 609;
-    static final int        ENUM           = 610;
-    static final int        ERROR          = 611;
-    static final int        EVENT          = 612;
-    static final int        EXPLAIN        = 613;
-    static final int        EXPORT         = 614;
-    static final int        FEATURE        = 615;
-    static final int        FILE           = 616;
-    public static final int FILES          = 617;
-    static final int        FORMAT         = 618;
-    static final int        GC             = 619;
-    static final int        HEADER         = 620;
-    static final int        IDENTIFIER     = 621;
-    static final int        IGNORECASE     = 622;
-    static final int        IMMEDIATELY    = 623;
-    static final int        INTEGRITY      = 624;
-    static final int        INTERRUPT      = 625;
-    static final int        INDEX          = 626;
-    static final int        INDEXER        = 627;
-    static final int        INFINITY       = 628;
-    static final int        INITIAL        = 629;
-    static final int        LASTVAL        = 630;
-    static final int        LIMIT          = 631;
-    static final int        LITERAL        = 632;
-    static final int        LIVE           = 633;
-    static final int        LOAD           = 634;
-    static final int        LOCK           = 635;
-    static final int        LOCKS          = 636;
-    static final int        LONG           = 637;
-    static final int        LONGVAR        = 638;
-    static final int        MAXROWS        = 639;
-    static final int        MEDIAN         = 640;
-    static final int        MEMORY         = 641;
-    static final int        MILLIS         = 642;
-    static final int        MINUS_EXCEPT   = 643;
-    static final int        NAN            = 644;
-    static final int        NEXTVAL        = 645;
-    static final int        NOWAIT         = 646;
-    static final int        NVARCHAR2      = 647;
-    static final int        NVL2           = 648;
-    static final int        OFF            = 649;
-    static final int        PASSWORD       = 650;
-    static final int        PERFORM        = 651;
-    static final int        PLAN           = 652;
-    static final int        PREVVAL        = 653;
-    static final int        PROPERTY       = 654;
-    static final int        RAW            = 655;
-    static final int        READONLY       = 656;
-    static final int        REFERENTIAL    = 657;
-    static final int        REGULAR        = 658;
-    static final int        RENAME         = 659;
-    static final int        RESET          = 660;
-    static final int        ROOTS          = 661;
-    static final int        ROWNUM         = 662;
-    static final int        SCRIPT         = 663;
-    static final int        SEPARATOR      = 664;
-    static final int        SHUTDOWN       = 665;
-    static final int        STOP           = 666;
-    static final int        SYNONYM        = 667;
-    static final int        SYNTAX         = 668;
-    static final int        TDC            = 669;
-    static final int        TEMP           = 670;
-    static final int        TEXT           = 671;
-    static final int        TOP            = 672;
-    static final int        TTI            = 673;
-    static final int        TYPES          = 674;
-    static final int        USE            = 675;
-    static final int        UNLOAD         = 676;
-    static final int        VARCHAR2       = 677;
-    static final int        WRITE_DELAY    = 678;
+    static final int        ALIAS          = 601;
+    static final int        AGGREGATE      = 602;
+    static final int        AUTOCOMMIT     = 603;
+    static final int        AUTHENTICATION = 604;
+    static final int        BACKUP         = 605;
+    static final int        BINARY_FLOAT   = 606;
+    static final int        BINARY_DOUBLE  = 607;
+    static final int        BIT            = 608;
+    static final int        BLOCKING       = 609;
+    static final int        BODY           = 610;
+    static final int        BYTE           = 611;
+    static final int        CACHE          = 612;
+    static final int        CACHED         = 613;
+    static final int        CASEWHEN       = 614;
+    static final int        CHECKPOINT     = 615;
+    static final int        CITEXT         = 616;
+    static final int        CLASS          = 617;
+    static final int        CLUSTERED      = 618;
+    static final int        COMMENT        = 619;
+    static final int        COMPACT        = 620;
+    static final int        COMPRESSED     = 621;
+    static final int        CONFLICT       = 622;
+    static final int        CONTROL        = 623;
+    static final int        CURRVAL        = 624;
+    static final int        DATABASE       = 625;
+    static final int        DEADLOCK       = 626;
+    static final int        DEFRAG         = 627;
+    static final int        DELAY          = 628;
+    static final int        DIGEST         = 629;
+    static final int        ENUM           = 630;
+    static final int        EVENT          = 631;
+    static final int        EXPLAIN        = 632;
+    static final int        EXPORT         = 633;
+    static final int        FEATURE        = 634;
+    static final int        FILE           = 635;
+    public static final int FILES          = 636;
+    static final int        GC             = 637;
+    static final int        HEADER         = 638;
+    static final int        IDENTIFIER     = 639;
+    static final int        IGNORECASE     = 640;
+    static final int        IMMEDIATELY    = 641;
+    static final int        INTEGRITY      = 642;
+    static final int        INTERRUPT      = 643;
+    static final int        INDEX          = 644;
+    static final int        INDEXER        = 645;
+    static final int        INFINITY       = 646;
+    static final int        INITIAL        = 647;
+    static final int        LASTVAL        = 648;
+    static final int        LIMIT          = 649;
+    static final int        LITERAL        = 650;
+    static final int        LIVE           = 651;
+    static final int        LOAD           = 652;
+    static final int        LOCK           = 653;
+    static final int        LOCKS          = 654;
+    static final int        LONG           = 655;
+    static final int        LONGVAR        = 656;
+    static final int        MAXROWS        = 657;
+    static final int        MEDIAN         = 658;
+    static final int        MEMORY         = 659;
+    static final int        MILLIS         = 660;
+    static final int        MINUS_EXCEPT   = 661;
+    static final int        NAN            = 662;
+    static final int        NEXTVAL        = 663;
+    static final int        NOWAIT         = 664;
+    static final int        NVARCHAR2      = 665;
+    static final int        NVL2           = 666;
+    static final int        OFF            = 667;
+    static final int        PASSWORD       = 668;
+    static final int        PERFORM        = 669;
+    static final int        PLAN           = 670;
+    static final int        PREVVAL        = 671;
+    static final int        PROPERTY       = 672;
+    static final int        RAW            = 673;
+    static final int        READONLY       = 674;
+    static final int        REFERENTIAL    = 675;
+    static final int        REGULAR        = 676;
+    static final int        RENAME         = 677;
+    static final int        RESET          = 678;
+    static final int        ROOTS          = 679;
+    static final int        ROWNUM         = 680;
+    static final int        SCRIPT         = 681;
+    static final int        SEPARATOR      = 682;
+    static final int        SHUTDOWN       = 683;
+    static final int        STOP           = 684;
+    static final int        SYNONYM        = 685;
+    static final int        SYNTAX         = 686;
+    static final int        TDC            = 687;
+    static final int        TEMP           = 688;
+    static final int        TEXT           = 689;
+    static final int        TOP            = 690;
+    static final int        TTI            = 691;
+    static final int        TYPES          = 692;
+    static final int        USE            = 693;
+    static final int        UNLOAD         = 694;
+    static final int        VARCHAR2       = 695;
+    static final int        WRITE_DELAY    = 696;
 
     //
     static final int        ACOS                       = 701;
@@ -1846,25 +1887,27 @@ public class Tokens {
     //
     static final int        ASTERISK         = 921;
     static final int        CLOSEBRACKET     = 922;
-    static final int        COLON            = 923;
-    static final int        COMMA            = 924;
+    public static final int COLON            = 923;
+    public static final int COMMA            = 924;
     static final int        CONCAT_OP        = 925;
     static final int        DIVIDE_OP        = 926;
     static final int        DOUBLE_COLON_OP  = 927;
     static final int        DOUBLE_PERIOD_OP = 928;
     static final int        GREATER_OP       = 929;
     static final int        GREATER_EQUALS   = 930;
-    static final int        LEFTBRACKET      = 931;
-    static final int        LESS_OP          = 932;
-    static final int        LESS_EQUALS      = 933;
-    public static final int MINUS_OP         = 934;
-    static final int        NOT_EQUALS       = 935;
-    static final int        OPENBRACKET      = 936;
-    static final int        PLUS_OP          = 937;
-    static final int        QUESTION         = 938;
-    static final int        RIGHT_ARROW_OP   = 939;
-    static final int        RIGHTBRACKET     = 940;
-    static final int        SEMICOLON        = 941;
+    public static final int LEFTBRACE        = 931;
+    public static final int LEFTBRACKET      = 932;
+    static final int        LESS_OP          = 933;
+    static final int        LESS_EQUALS      = 934;
+    public static final int MINUS_OP         = 935;
+    static final int        NOT_EQUALS       = 936;
+    static final int        OPENBRACKET      = 937;
+    static final int        PLUS_OP          = 938;
+    static final int        QUESTION         = 939;
+    static final int        RIGHT_ARROW_OP   = 940;
+    public static final int RIGHTBRACE       = 941;
+    public static final int RIGHTBRACKET     = 942;
+    static final int        SEMICOLON        = 943;
 
     //
     public static final int SQL_BIGINT        = 951;
@@ -2288,6 +2331,7 @@ public class Tokens {
     private static final IntValueHashMap commandSet = new IntValueHashMap(449);
 
     static {
+        commandSet.put(T_ABSENT, ABSENT);
         commandSet.put(T_ACTION, ACTION);
         commandSet.put(T_ADD, ADD);
         commandSet.put(T_ADMIN, ADMIN);
@@ -2345,6 +2389,7 @@ public class Tokens {
         commandSet.put(T_DIAGNOSTICS, DIAGNOSTICS);
         commandSet.put(T_DIGEST, DIGEST);
         commandSet.put(T_DOMAIN, DOMAIN);
+        commandSet.put(T_EMPTY, EMPTY);
         commandSet.put(T_ENUM, ENUM);
         commandSet.put(T_ERROR, ERROR);
         commandSet.put(T_EVENT, EVENT);
@@ -2388,9 +2433,19 @@ public class Tokens {
         commandSet.put(T_IS_READONLY_DATABASE_FILES,
                        IS_READONLY_DATABASE_FILES);
         commandSet.put(T_IS_READONLY_SESSION, IS_READONLY_SESSION);
+        commandSet.put(T_JSON, JSON);
+        commandSet.put(T_JSON_ARRAY, JSON_ARRAY);
+        commandSet.put(T_JSON_ARRAYAGG, JSON_ARRAYAGG);
+        commandSet.put(T_JSON_EXISTS, JSON_EXISTS);
+        commandSet.put(T_JSON_OBJECT, JSON_OBJECT);
+        commandSet.put(T_JSON_OBJECTAGG, JSON_OBJECTAGG);
+        commandSet.put(T_JSON_QUERY, JSON_QUERY);
+        commandSet.put(T_JSON_TABLE, JSON_TABLE);
+        commandSet.put(T_JSON_VALUE, JSON_VALUE);
         commandSet.put(T_JAVA, JAVA);
         commandSet.put(T_K_FACTOR, K);
         commandSet.put(T_KEY, KEY);
+        commandSet.put(T_KEYS, KEYS);
         commandSet.put(T_LAST, LAST);
         commandSet.put(T_LASTVAL, LASTVAL);
         commandSet.put(T_LENGTH, LENGTH);
@@ -2435,6 +2490,7 @@ public class Tokens {
         commandSet.put(T_OBJECT, OBJECT);
         commandSet.put(T_OCTETS, OCTETS);
         commandSet.put(T_OFF, OFF);
+        commandSet.put(T_OMIT, OMIT);
         commandSet.put(T_OPTION, OPTION);
         commandSet.put(T_ORDINALITY, ORDINALITY);
         commandSet.put(T_OTHERS, OTHERS);
@@ -2463,6 +2519,7 @@ public class Tokens {
         commandSet.put(T_RESTART, RESTART);
         commandSet.put(T_RESTRICT, RESTRICT);
         commandSet.put(T_RESULT, RESULT);
+        commandSet.put(T_RETURNING, RETURNING);
         commandSet.put(T_ROLE, ROLE);
         commandSet.put(T_ROUTINE, ROUTINE);
         commandSet.put(T_ROW_COUNT, ROW_COUNT);
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/TransactionManager2PL.java 2.7.0-1/hsqldb/src/org/hsqldb/TransactionManager2PL.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/TransactionManager2PL.java	2021-01-29 13:34:34.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/TransactionManager2PL.java	2022-07-13 14:05:42.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -39,7 +39,7 @@ import org.hsqldb.persist.PersistentStor
  * Manages rows involved in transactions
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 2.0.0
  */
 public class TransactionManager2PL extends TransactionManagerCommon
@@ -53,12 +53,12 @@ implements TransactionManager {
         txModel    = LOCKS;
     }
 
-    public long getGlobalChangeTimestamp() {
-        return globalChangeTimestamp.get();
+    public long getSystemChangeNumber() {
+        return systemChangeNumber.get();
     }
 
-    public void setGlobalChangeTimestamp(long ts) {
-        globalChangeTimestamp.set(ts);
+    public void setSystemChangeNumber(long ts) {
+        systemChangeNumber.set(ts);
     }
 
     public boolean isMVRows() {
@@ -87,7 +87,7 @@ implements TransactionManager {
 
     public boolean prepareCommitActions(Session session) {
 
-        session.actionTimestamp = getNextGlobalChangeTimestamp();
+        session.actionSCN = getNextSystemChangeNumber();
 
         return true;
     }
@@ -104,8 +104,8 @@ implements TransactionManager {
             int limit = session.rowActionList.size();
 
             // new actionTimestamp used for commitTimestamp
-            session.actionTimestamp         = getNextGlobalChangeTimestamp();
-            session.transactionEndTimestamp = session.actionTimestamp;
+            session.actionSCN         = getNextSystemChangeNumber();
+            session.transactionEndSCN = session.actionSCN;
 
             endTransaction(session);
 
@@ -135,11 +135,11 @@ implements TransactionManager {
         writeLock.lock();
 
         try {
-            session.abortTransaction        = false;
-            session.actionTimestamp         = getNextGlobalChangeTimestamp();
-            session.transactionEndTimestamp = session.actionTimestamp;
+            session.abortTransaction  = false;
+            session.actionSCN         = getNextSystemChangeNumber();
+            session.transactionEndSCN = session.actionSCN;
 
-            rollbackPartial(session, 0, session.transactionTimestamp);
+            rollbackPartial(session, 0, session.transactionSCN);
             endTransaction(session);
             session.logSequences();
 
@@ -167,9 +167,7 @@ implements TransactionManager {
     }
 
     public void rollbackAction(Session session) {
-
-        rollbackPartial(session, session.actionIndex,
-                        session.actionStartTimestamp);
+        rollbackPartial(session, session.actionIndex, session.actionStartSCN);
         endActionTPL(session);
     }
 
@@ -317,8 +315,8 @@ implements TransactionManager {
     public void beginActionResume(Session session) {
 
         if (session.isTransaction) {
-            session.actionTimestamp      = getNextGlobalChangeTimestamp();
-            session.actionStartTimestamp = session.actionTimestamp;
+            session.actionSCN      = getNextSystemChangeNumber();
+            session.actionStartSCN = session.actionSCN;
         } else {
             beginTransactionCommon(session);
         }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/TransactionManagerCommon.java 2.7.0-1/hsqldb/src/org/hsqldb/TransactionManagerCommon.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/TransactionManagerCommon.java	2021-07-09 16:52:10.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/TransactionManagerCommon.java	2022-07-13 14:23:52.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -51,7 +51,7 @@ import org.hsqldb.lib.OrderedHashSet;
  * Shared code for TransactionManager classes
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 2.0.0
  */
 class TransactionManagerCommon {
@@ -68,10 +68,10 @@ class TransactionManagerCommon {
     // functional unit - sessions involved in live transactions
 
     /** live transactions keeping committed transactions from being merged */
-    LongDeque liveTransactionTimestamps = new LongDeque();
+    LongDeque liveTransactionSCNs = new LongDeque();
 
     /** global timestamp for database */
-    AtomicLong globalChangeTimestamp = new AtomicLong(1);
+    AtomicLong systemChangeNumber = new AtomicLong(1);
 
     //
     AtomicInteger transactionCount = new AtomicInteger();
@@ -85,7 +85,7 @@ class TransactionManagerCommon {
 
     // functional unit - cached table transactions
 
-    /** Map : rowID -> RowAction */
+    /** Map : rowID maps to: RowAction */
     public LongKeyHashMap rowActionMap;
 
     TransactionManagerCommon(Database database) {
@@ -109,7 +109,7 @@ class TransactionManagerCommon {
 
                 case TransactionManager.MVCC :
                 case TransactionManager.MVLOCKS :
-                    if (liveTransactionTimestamps.size() != 1) {
+                    if (liveTransactionSCNs.size() != 1) {
                         throw Error.error(ErrorCode.X_25001);
                     }
             }
@@ -120,8 +120,7 @@ class TransactionManagerCommon {
                     TransactionManagerMVCC txMan =
                         new TransactionManagerMVCC(database);
 
-                    txMan.liveTransactionTimestamps.addLast(
-                        session.transactionTimestamp);
+                    txMan.liveTransactionSCNs.addLast(session.transactionSCN);
 
                     txMan.catalogWriteSession = session;
                     txMan.isLockedMode        = true;
@@ -141,8 +140,8 @@ class TransactionManagerCommon {
                 case TransactionManager.MVLOCKS : {
                     manager = new TransactionManagerMV2PL(database);
 
-                    manager.liveTransactionTimestamps.addLast(
-                        session.transactionTimestamp);
+                    manager.liveTransactionSCNs.addLast(
+                        session.transactionSCN);
 
                     OrderedHashSet set = session.waitingSessions;
 
@@ -172,7 +171,7 @@ class TransactionManagerCommon {
                                              "TransactionManagerCommon");
             }
 
-            manager.globalChangeTimestamp.set(globalChangeTimestamp.get());
+            manager.systemChangeNumber.set(systemChangeNumber.get());
 
             manager.transactionCount = transactionCount;
             hasExpired               = true;
@@ -184,11 +183,11 @@ class TransactionManagerCommon {
 
     void beginTransactionCommon(Session session) {
 
-        session.actionTimestamp      = getNextGlobalChangeTimestamp();
-        session.actionStartTimestamp = session.actionTimestamp;
-        session.transactionTimestamp = session.actionTimestamp;
-        session.isPreTransaction     = false;
-        session.isTransaction        = true;
+        session.actionSCN        = getNextSystemChangeNumber();
+        session.actionStartSCN   = session.actionSCN;
+        session.transactionSCN   = session.actionSCN;
+        session.isPreTransaction = false;
+        session.isTransaction    = true;
 
         transactionCount.incrementAndGet();
     }
@@ -196,7 +195,7 @@ class TransactionManagerCommon {
     void adjustLobUsage(Session session) {
 
         int  limit               = session.rowActionList.size();
-        long lastActionTimestamp = session.actionTimestamp;
+        long lastActionTimestamp = session.actionSCN;
 
         for (int i = 0; i < limit; i++) {
             RowAction action = (RowAction) session.rowActionList.get(i);
@@ -265,7 +264,7 @@ class TransactionManagerCommon {
                 continue;
             }
 
-            int type = action.getCommitTypeOn(session.actionTimestamp);
+            int type = action.getCommitTypeOn(session.actionSCN);
             Row row  = action.memoryRow;
 
             if (row == null) {
@@ -326,8 +325,8 @@ class TransactionManagerCommon {
     /**
      * gets the next timestamp for an action
      */
-    public long getNextGlobalChangeTimestamp() {
-        return globalChangeTimestamp.incrementAndGet();
+    public long getNextSystemChangeNumber() {
+        return systemChangeNumber.incrementAndGet();
     }
 
     boolean checkDeadlock(Session session, OrderedHashSet newWaits) {
@@ -374,7 +373,7 @@ class TransactionManagerCommon {
         Session[]      sessions = database.sessionManager.getAllSessions();
 
         for (int i = 0; i < sessions.length; i++) {
-            long timestamp = sessions[i].transactionTimestamp;
+            long timestamp = sessions[i].transactionSCN;
 
             if (session != sessions[i] && sessions[i].isTransaction) {
                 set.add(sessions[i]);
@@ -388,7 +387,7 @@ class TransactionManagerCommon {
         Session[]      sessions = database.sessionManager.getAllSessions();
 
         for (int i = 0; i < sessions.length; i++) {
-            long timestamp = sessions[i].transactionTimestamp;
+            long timestamp = sessions[i].transactionSCN;
 
             if (session == sessions[i]) {
                 continue;
@@ -702,9 +701,12 @@ class TransactionManagerCommon {
 
     void setWaitingSessionTPL(Session session) {
 
-        int count = session.tempSet.size();
+        int count      = session.tempSet.size();
+        int latchCount = session.latch.getCount();
 
-        assert session.latch.getCount() <= count + 1;
+        if (latchCount > count + 1) {
+            System.out.println("latch count " + latchCount);
+        }
 
         for (int i = 0; i < count; i++) {
             Session current = (Session) session.tempSet.get(i);
@@ -836,11 +838,11 @@ class TransactionManagerCommon {
 
     long getFirstLiveTransactionTimestamp() {
 
-        if (liveTransactionTimestamps.isEmpty()) {
+        if (liveTransactionSCNs.isEmpty()) {
             return Long.MAX_VALUE;
         }
 
-        return liveTransactionTimestamps.get(0);
+        return liveTransactionSCNs.get(0);
     }
 
     /**
@@ -880,8 +882,8 @@ class TransactionManagerCommon {
                             (RowAction) sessions[i].rowActionList.get(
                                 tIndex[i]);
 
-                        if (current.actionTimestamp < minChangeNo) {
-                            minChangeNo  = current.actionTimestamp;
+                        if (current.actionSCN < minChangeNo) {
+                            minChangeNo  = current.actionSCN;
                             sessionIndex = i;
                         }
 
@@ -901,11 +903,11 @@ class TransactionManagerCommon {
                         (RowAction) currentList.get(tIndex[sessionIndex]);
 
                     // if the next change no is in this session, continue adding
-                    if (current.actionTimestamp == minChangeNo + 1) {
+                    if (current.actionSCN == minChangeNo + 1) {
                         minChangeNo++;
                     }
 
-                    if (current.actionTimestamp == minChangeNo) {
+                    if (current.actionSCN == minChangeNo) {
                         rowActions[rowActionCount++] = current;
 
                         tIndex[sessionIndex]++;
@@ -979,9 +981,8 @@ class TransactionManagerCommon {
                     break;
 
                 case TransactionManager.resetSessionStatement :
-
                     if (statementTimestamp
-                            != targetSession.statementStartTimestamp) {
+                            != targetSession.statementStartSCN) {
                         break;
                     }
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/TransactionManager.java 2.7.0-1/hsqldb/src/org/hsqldb/TransactionManager.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/TransactionManager.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/TransactionManager.java	2022-07-13 15:38:30.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -37,7 +37,7 @@ import org.hsqldb.persist.PersistentStor
  * Manages rows involved in transactions
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.5.1
+ * @version 2.7.0
  * @since 2.0.0
  */
 public interface TransactionManager {
@@ -60,11 +60,11 @@ public interface TransactionManager {
     int resetSessionStatement = 5;
     int resetSessionClose     = 6;
 
-    long getGlobalChangeTimestamp();
+    long getSystemChangeNumber();
 
-    long getNextGlobalChangeTimestamp();
+    long getNextSystemChangeNumber();
 
-    void setGlobalChangeTimestamp(long ts);
+    void setSystemChangeNumber(long ts);
 
     RowAction addDeleteAction(Session session, Table table,
                               PersistentStore store, Row row,
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/TransactionManagerMV2PL.java 2.7.0-1/hsqldb/src/org/hsqldb/TransactionManagerMV2PL.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/TransactionManagerMV2PL.java	2021-01-24 21:01:28.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/TransactionManagerMV2PL.java	2022-07-13 14:23:52.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -41,15 +41,15 @@ import org.hsqldb.persist.PersistentStor
  * Manages rows involved in transactions
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.5.1
+ * @version 2.7.0
  * @since 2.0.0
  */
 public class TransactionManagerMV2PL extends TransactionManagerCommon
 implements TransactionManager {
 
     // functional unit - merged committed transactions
-    HsqlDeque committedTransactions          = new HsqlDeque();
-    LongDeque committedTransactionTimestamps = new LongDeque();
+    HsqlDeque committedTransactions    = new HsqlDeque();
+    LongDeque committedTransactionSCNs = new LongDeque();
 
     public TransactionManagerMV2PL(Database db) {
 
@@ -59,12 +59,12 @@ implements TransactionManager {
         txModel    = MVLOCKS;
     }
 
-    public long getGlobalChangeTimestamp() {
-        return globalChangeTimestamp.get();
+    public long getSystemChangeNumber() {
+        return systemChangeNumber.get();
     }
 
-    public void setGlobalChangeTimestamp(long ts) {
-        globalChangeTimestamp.set(ts);
+    public void setSystemChangeNumber(long ts) {
+        systemChangeNumber.set(ts);
     }
 
     public boolean isMVRows() {
@@ -98,7 +98,7 @@ implements TransactionManager {
         try {
             int limit = session.rowActionList.size();
 
-            session.actionTimestamp = getNextGlobalChangeTimestamp();
+            session.actionSCN = getNextSystemChangeNumber();
 
             for (int i = 0; i < limit; i++) {
                 RowAction action = (RowAction) session.rowActionList.get(i);
@@ -124,8 +124,8 @@ implements TransactionManager {
             int limit = session.rowActionList.size();
 
             // new actionTimestamp used for commitTimestamp
-            session.actionTimestamp         = getNextGlobalChangeTimestamp();
-            session.transactionEndTimestamp = session.actionTimestamp;
+            session.actionSCN         = getNextSystemChangeNumber();
+            session.transactionEndSCN = session.actionSCN;
 
             endTransaction(session);
 
@@ -143,8 +143,7 @@ implements TransactionManager {
             if (newLimit > limit) {
                 Object[] list = session.rowActionList.getArray();
 
-                mergeTransaction(list, limit, newLimit,
-                                 session.actionTimestamp);
+                mergeTransaction(list, limit, newLimit, session.actionSCN);
                 finaliseRows(session, list, limit, newLimit);
                 session.rowActionList.setSize(limit);
             }
@@ -152,10 +151,10 @@ implements TransactionManager {
             // session.actionTimestamp is the committed tx timestamp
             if (session == lobSession
                     || getFirstLiveTransactionTimestamp()
-                       > session.actionTimestamp) {
+                       > session.actionSCN) {
                 Object[] list = session.rowActionList.getArray();
 
-                mergeTransaction(list, 0, limit, session.actionTimestamp);
+                mergeTransaction(list, 0, limit, session.actionSCN);
                 finaliseRows(session, list, 0, limit);
             } else {
                 Object[] list = session.rowActionList.toArray();
@@ -179,11 +178,11 @@ implements TransactionManager {
         writeLock.lock();
 
         try {
-            session.abortTransaction        = false;
-            session.actionTimestamp         = getNextGlobalChangeTimestamp();
-            session.transactionEndTimestamp = session.actionTimestamp;
+            session.abortTransaction  = false;
+            session.actionSCN         = getNextSystemChangeNumber();
+            session.transactionEndSCN = session.actionSCN;
 
-            rollbackPartial(session, 0, session.transactionTimestamp);
+            rollbackPartial(session, 0, session.transactionSCN);
             endTransaction(session);
             session.logSequences();
 
@@ -211,9 +210,7 @@ implements TransactionManager {
     }
 
     public void rollbackAction(Session session) {
-
-        rollbackPartial(session, session.actionIndex,
-                        session.actionStartTimestamp);
+        rollbackPartial(session, session.actionIndex, session.actionStartSCN);
         endActionTPL(session);
     }
 
@@ -341,13 +338,13 @@ implements TransactionManager {
      */
     void addToCommittedQueue(Session session, Object[] list) {
 
-        synchronized (committedTransactionTimestamps) {
+        synchronized (committedTransactionSCNs) {
 
             // add the txList according to commit timestamp
             committedTransactions.addLast(list);
 
             // get session commit timestamp
-            committedTransactionTimestamps.addLast(session.actionTimestamp);
+            committedTransactionSCNs.addLast(session.actionSCN);
 /* debug 190
             if (committedTransactions.size() > 64) {
                 System.out.println("******* excessive transaction queue");
@@ -367,15 +364,15 @@ implements TransactionManager {
             long     commitTimestamp = 0;
             Object[] actions         = null;
 
-            synchronized (committedTransactionTimestamps) {
-                if (committedTransactionTimestamps.isEmpty()) {
+            synchronized (committedTransactionSCNs) {
+                if (committedTransactionSCNs.isEmpty()) {
                     break;
                 }
 
-                commitTimestamp = committedTransactionTimestamps.getFirst();
+                commitTimestamp = committedTransactionSCNs.getFirst();
 
                 if (commitTimestamp < timestamp) {
-                    committedTransactionTimestamps.removeFirst();
+                    committedTransactionSCNs.removeFirst();
 
                     actions = (Object[]) committedTransactions.removeFirst();
                 } else {
@@ -395,8 +392,7 @@ implements TransactionManager {
         try {
             if (!session.isTransaction) {
                 beginTransactionCommon(session);
-                liveTransactionTimestamps.addLast(
-                    session.transactionTimestamp);
+                liveTransactionSCNs.addLast(session.transactionSCN);
             }
         } finally {
             writeLock.unlock();
@@ -454,12 +450,11 @@ implements TransactionManager {
 
         try {
             if (session.isTransaction) {
-                session.actionTimestamp      = getNextGlobalChangeTimestamp();
-                session.actionStartTimestamp = session.actionTimestamp;
+                session.actionSCN      = getNextSystemChangeNumber();
+                session.actionStartSCN = session.actionSCN;
             } else {
                 beginTransactionCommon(session);
-                liveTransactionTimestamps.addLast(
-                    session.transactionTimestamp);
+                liveTransactionSCNs.addLast(session.transactionSCN);
             }
         } finally {
             writeLock.unlock();
@@ -479,12 +474,12 @@ implements TransactionManager {
      */
     private void endTransaction(Session session) {
 
-        long timestamp = session.transactionTimestamp;
-        int  index     = liveTransactionTimestamps.indexOf(timestamp);
+        long timestamp = session.transactionSCN;
+        int  index     = liveTransactionSCNs.indexOf(timestamp);
 
         if (index >= 0) {
             transactionCount.decrementAndGet();
-            liveTransactionTimestamps.remove(index);
+            liveTransactionSCNs.remove(index);
             mergeExpiredTransactions(session);
         }
     }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/TransactionManagerMVCC.java 2.7.0-1/hsqldb/src/org/hsqldb/TransactionManagerMVCC.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/TransactionManagerMVCC.java	2021-01-24 21:01:34.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/TransactionManagerMVCC.java	2022-07-13 14:23:54.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -41,15 +41,15 @@ import org.hsqldb.persist.PersistentStor
  * Manages rows involved in transactions
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.5.1
+ * @version 2.7.0
  * @since 2.0.0
  */
 public class TransactionManagerMVCC extends TransactionManagerCommon
 implements TransactionManager {
 
     // functional unit - merged committed transactions
-    HsqlDeque committedTransactions          = new HsqlDeque();
-    LongDeque committedTransactionTimestamps = new LongDeque();
+    HsqlDeque committedTransactions    = new HsqlDeque();
+    LongDeque committedTransactionSCNs = new LongDeque();
 
     // locks
     boolean isLockedMode;
@@ -73,12 +73,12 @@ implements TransactionManager {
         txModel    = MVCC;
     }
 
-    public long getGlobalChangeTimestamp() {
-        return globalChangeTimestamp.get();
+    public long getSystemChangeNumber() {
+        return systemChangeNumber.get();
     }
 
-    public void setGlobalChangeTimestamp(long ts) {
-        globalChangeTimestamp.set(ts);
+    public void setSystemChangeNumber(long ts) {
+        systemChangeNumber.set(ts);
     }
 
     public boolean isMVRows() {
@@ -126,7 +126,7 @@ implements TransactionManager {
                 }
             }
 
-            session.actionTimestamp = getNextGlobalChangeTimestamp();
+            session.actionSCN = getNextSystemChangeNumber();
 
             for (int i = 0; i < limit; i++) {
                 RowAction action = (RowAction) session.rowActionList.get(i);
@@ -170,8 +170,8 @@ implements TransactionManager {
             }
 
             // new actionTimestamp used for commitTimestamp
-            session.actionTimestamp         = getNextGlobalChangeTimestamp();
-            session.transactionEndTimestamp = session.actionTimestamp;
+            session.actionSCN         = getNextSystemChangeNumber();
+            session.transactionEndSCN = session.actionSCN;
 
             endTransaction(session);
 
@@ -196,8 +196,7 @@ implements TransactionManager {
             if (newLimit > limit) {
                 Object[] list = session.rowActionList.getArray();
 
-                mergeTransaction(list, limit, newLimit,
-                                 session.actionTimestamp);
+                mergeTransaction(list, limit, newLimit, session.actionSCN);
                 finaliseRows(session, list, limit, newLimit);
                 session.rowActionList.setSize(limit);
             }
@@ -205,10 +204,10 @@ implements TransactionManager {
             // session.actionTimestamp is the committed tx timestamp
             if (session == lobSession
                     || getFirstLiveTransactionTimestamp()
-                       > session.actionTimestamp) {
+                       > session.actionSCN) {
                 Object[] list = session.rowActionList.getArray();
 
-                mergeTransaction(list, 0, limit, session.actionTimestamp);
+                mergeTransaction(list, 0, limit, session.actionSCN);
                 finaliseRows(session, list, 0, limit);
             } else {
                 if (session.rowActionList.size() > 0) {
@@ -237,11 +236,11 @@ implements TransactionManager {
         writeLock.lock();
 
         try {
-            session.abortTransaction        = false;
-            session.actionTimestamp         = getNextGlobalChangeTimestamp();
-            session.transactionEndTimestamp = session.actionTimestamp;
+            session.abortTransaction  = false;
+            session.actionSCN         = getNextSystemChangeNumber();
+            session.transactionEndSCN = session.actionSCN;
 
-            rollbackPartial(session, 0, session.transactionTimestamp);
+            rollbackPartial(session, 0, session.transactionSCN);
             endTransaction(session);
             session.logSequences();
             endTransactionTPL(session);
@@ -270,8 +269,7 @@ implements TransactionManager {
     }
 
     public void rollbackAction(Session session) {
-        rollbackPartial(session, session.actionIndex,
-                        session.actionStartTimestamp);
+        rollbackPartial(session, session.actionIndex, session.actionStartSCN);
     }
 
     /**
@@ -467,7 +465,7 @@ implements TransactionManager {
 
             session.actionSet.clear();
 
-            if (otherAction.commitTimestamp != 0) {
+            if (otherAction.commitSCN != 0) {
                 redoWait = false;
             }
 
@@ -585,13 +583,13 @@ implements TransactionManager {
      */
     void addToCommittedQueue(Session session, Object[] list) {
 
-        synchronized (committedTransactionTimestamps) {
+        synchronized (committedTransactionSCNs) {
 
             // add the txList according to commit timestamp
             committedTransactions.addLast(list);
 
             // get session commit timestamp
-            committedTransactionTimestamps.addLast(session.actionTimestamp);
+            committedTransactionSCNs.addLast(session.actionSCN);
 /* debug 190
             if (committedTransactions.size() > 64) {
                 System.out.println("******* excessive transaction queue");
@@ -611,15 +609,15 @@ implements TransactionManager {
             long     commitTimestamp;
             Object[] actions;
 
-            synchronized (committedTransactionTimestamps) {
-                if (committedTransactionTimestamps.isEmpty()) {
+            synchronized (committedTransactionSCNs) {
+                if (committedTransactionSCNs.isEmpty()) {
                     break;
                 }
 
-                commitTimestamp = committedTransactionTimestamps.getFirst();
+                commitTimestamp = committedTransactionSCNs.getFirst();
 
                 if (commitTimestamp < timestamp) {
-                    committedTransactionTimestamps.removeFirst();
+                    committedTransactionSCNs.removeFirst();
 
                     actions = (Object[]) committedTransactions.removeFirst();
                 } else {
@@ -639,8 +637,7 @@ implements TransactionManager {
         try {
             if (!session.isTransaction) {
                 beginTransactionCommon(session);
-                liveTransactionTimestamps.addLast(
-                    session.transactionTimestamp);
+                liveTransactionSCNs.addLast(session.transactionSCN);
             }
         } finally {
             writeLock.unlock();
@@ -700,12 +697,11 @@ implements TransactionManager {
 
         try {
             if (session.isTransaction) {
-                session.actionTimestamp      = getNextGlobalChangeTimestamp();
-                session.actionStartTimestamp = session.actionTimestamp;
+                session.actionSCN      = getNextSystemChangeNumber();
+                session.actionStartSCN = session.actionSCN;
             } else {
                 beginTransactionCommon(session);
-                liveTransactionTimestamps.addLast(
-                    session.transactionTimestamp);
+                liveTransactionSCNs.addLast(session.transactionSCN);
             }
         } finally {
             writeLock.unlock();
@@ -720,12 +716,12 @@ implements TransactionManager {
      */
     void endTransaction(Session session) {
 
-        long timestamp = session.transactionTimestamp;
-        int  index     = liveTransactionTimestamps.indexOf(timestamp);
+        long timestamp = session.transactionSCN;
+        int  index     = liveTransactionSCNs.indexOf(timestamp);
 
         if (index >= 0) {
             transactionCount.decrementAndGet();
-            liveTransactionTimestamps.remove(index);
+            liveTransactionSCNs.remove(index);
             mergeExpiredTransactions(session);
         }
     }
@@ -782,7 +778,7 @@ implements TransactionManager {
             catalogWriteSession = nextSession;
         }
 
-        unlockTxTs      = session.actionTimestamp;
+        unlockTxTs      = session.actionSCN;
         unlockSessionId = session.getId();
     }
 
@@ -798,7 +794,7 @@ implements TransactionManager {
             if (catalogWriteSession == null) {
                 catalogWriteSession = session;
                 isLockedMode        = true;
-                lockTxTs            = session.actionTimestamp;
+                lockTxTs            = session.actionSCN;
                 lockSessionId       = session.getId();
 
                 getTransactionAndPreSessions(session);
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/TypeInvariants.java 2.7.0-1/hsqldb/src/org/hsqldb/TypeInvariants.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/TypeInvariants.java	2020-06-24 09:02:18.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/TypeInvariants.java	2022-04-10 09:21:18.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -43,7 +43,7 @@ import org.hsqldb.types.UserTypeModifier
  * Information Schema types.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.4.0
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class TypeInvariants {
@@ -90,7 +90,7 @@ public class TypeInvariants {
         name = HsqlNameManager.newInfoSchemaObjectName("TIME_STAMP", false,
                 SchemaObject.DOMAIN);
         TIME_STAMP = new DateTimeType(Types.SQL_TIMESTAMP,
-                                      Types.SQL_TIMESTAMP, 6);
+                                      Types.SQL_TIMESTAMP_WITH_TIME_ZONE, 6);
         TIME_STAMP.userTypeModifier = new UserTypeModifier(name,
                 SchemaObject.DOMAIN, TIME_STAMP);
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/types/ArrayType.java 2.7.0-1/hsqldb/src/org/hsqldb/types/ArrayType.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/types/ArrayType.java	2021-01-29 13:34:34.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/types/ArrayType.java	2022-03-04 19:10:58.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -48,12 +48,12 @@ import org.hsqldb.lib.ArraySort;
  * Class for ARRAY type objects.<p>
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 2.0.0
  */
 public class ArrayType extends Type {
 
-    public static final int defaultArrayCardinality      = 1024*1024;
+    public static final int defaultArrayCardinality      = 1024 * 1024;
     public static final int defaultLargeArrayCardinality = Integer.MAX_VALUE;
     final Type              dataType;
     final int               maxCardinality;
@@ -330,6 +330,54 @@ public class ArrayType extends Type {
         return sb.toString();
     }
 
+    public void convertToJSON(Object a, StringBuilder sb) {
+
+        Object[] arra = (Object[]) a;
+
+        if (a == null) {
+            sb.append("null");
+
+            return;
+        }
+
+        sb.append('[');
+
+        for (int i = 0; i < arra.length; i++) {
+            if (i > 0) {
+                sb.append(',');
+            }
+
+            dataType.convertToJSON(arra[i], sb);
+        }
+
+        sb.append(']');
+    }
+
+    public void convertToJSONsimple(Object a, StringBuilder sb) {
+
+        Object[] arra = (Object[]) a;
+
+        if (a == null) {
+            sb.append("null");
+
+            return;
+        }
+
+        sb.append('[');
+
+        for (int i = 0; i < arra.length; i++) {
+            if (i > 0) {
+                sb.append(',');
+            }
+
+            Object value = dataType.convertToString(arra[i]);
+
+            sb.append(value);
+        }
+
+        sb.append(']');
+    }
+
     public boolean canConvertFrom(Type otherType) {
 
         if (otherType == null) {
@@ -348,15 +396,15 @@ public class ArrayType extends Type {
     public int canMoveFrom(Type otherType) {
 
         if (!otherType.isArrayType()) {
-            return -1;
+            return Type.ReType.change;
         }
 
         if (maxCardinality >= ((ArrayType) otherType).maxCardinality) {
             return dataType.canMoveFrom(otherType);
-        } else if (dataType.canMoveFrom(otherType) == 0) {
-            return 1;
+        } else if (dataType.canMoveFrom(otherType) == ReType.keep) {
+            return Type.ReType.check;
         } else {
-            return -1;
+            return Type.ReType.change;
         }
     }
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/types/BinaryType.java 2.7.0-1/hsqldb/src/org/hsqldb/types/BinaryType.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/types/BinaryType.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/types/BinaryType.java	2022-05-22 18:09:56.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -46,17 +46,16 @@ import org.hsqldb.lib.StringConverter;
  * SQL:2008 Standard  specifies silent truncation of zero bytes at the end of the
  * binary strings used for assignment and concatenation.<p>
  *
- * * A binary string of type BINARY VARYING and BLOB when assigned to a column
+ * A binary string of type BINARY VARYING and BLOB when assigned to a column
  * of similar type but shorter maximum length.<p>
  *
- * * The Second operand of a concatenation when the length of the result exceeds
+ * The Second operand of a concatenation when the length of the result exceeds
  * the maximum implementation-dependent length of BINARY VARYING and BLOB
  * binary strings.<p>
  *
  * The behaviour is similar to trimming of space characters from strings of
  * CHARACTER VARYING and CLOB types.<p>
  *
- * <p>
  * In most real-world use-cases, all the bytes of variable-length binary values
  * stored in a database are significant and should not be discarded.<p>
  *
@@ -72,11 +71,11 @@ import org.hsqldb.lib.StringConverter;
  *
  * As an extension to the Standard, HSQLDB supports cast from CHARACTER types
  * to BINARY. The length of the string must be even and all character
- * must be hexadecimal characters.<p>
+ * must be hexadecimal characters.
  *
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.5.1
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class BinaryType extends Type {
@@ -339,15 +338,14 @@ public class BinaryType extends Type {
                             return 1;
                         }
                     }
-
                 } else {
                     for (int i = data1.length; i < data2.length; i++) {
                         if (data2[i] != 0) {
                             return -1;
                         }
                     }
-
                 }
+
                 return 0;
             }
 
@@ -453,13 +451,20 @@ public class BinaryType extends Type {
             b = new BinaryData(bytes, false);
         }
 
-        if (b.length(session) > precision
-                && b.nonZeroLength(session) > precision) {
-            if (!cast) {
-                throw Error.error(ErrorCode.X_22001);
+        if (b.length(session) > precision) {
+            if (!cast && session instanceof Session) {
+                if (!((Session) session).database.sqlTruncateTrailing) {
+                    throw Error.error(ErrorCode.X_22001);
+                }
             }
 
-            session.addWarning(Error.error(ErrorCode.W_01004));
+            if (b.nonZeroLength(session) > precision) {
+                if (!cast) {
+                    throw Error.error(ErrorCode.X_22001);
+                }
+
+                session.addWarning(Error.error(ErrorCode.W_01004));
+            }
         }
 
         switch (typeCode) {
@@ -529,6 +534,19 @@ public class BinaryType extends Type {
             ((BinaryData) a).getBytes());
     }
 
+    public void convertToJSON(Object a, StringBuilder sb) {
+
+        if (a == null) {
+            sb.append("null");
+
+            return;
+        }
+
+        sb.append('"');
+        sb.append(convertToString(a));
+        sb.append('"');
+    }
+
     public boolean canConvertFrom(Type otherType) {
 
         return otherType.typeCode == Types.SQL_ALL_TYPES
@@ -539,46 +557,46 @@ public class BinaryType extends Type {
     public int canMoveFrom(Type otherType) {
 
         if (otherType.isBitType() || otherType.isCharacterType()) {
-            return -1;
+            return ReType.change;
         }
 
         switch (typeCode) {
 
             case Types.SQL_VARBINARY : {
                 if (otherType.typeCode == typeCode) {
-                    return precision >= otherType.precision ? 0
-                                                            : 1;
+                    return precision >= otherType.precision ? ReType.keep
+                                                            : ReType.check;
                 }
 
                 if (otherType.typeCode == Types.SQL_BINARY) {
-                    return precision >= otherType.precision ? 0
-                                                            : -1;
+                    return precision >= otherType.precision ? ReType.keep
+                                                            : ReType.change;
                 }
 
                 if (otherType.typeCode == Types.SQL_GUID) {
-                    return precision >= otherType.precision ? 0
-                                                            : -1;
+                    return precision >= otherType.precision ? ReType.keep
+                                                            : ReType.change;
                 }
 
                 break;
             }
             case Types.SQL_BINARY : {
                 if (otherType.typeCode == typeCode) {
-                    return precision == otherType.precision ? 0
-                                                            : -1;
+                    return precision == otherType.precision ? ReType.keep
+                                                            : ReType.change;
                 }
 
                 if (otherType.typeCode == Types.SQL_GUID) {
-                    return precision == otherType.precision ? 0
-                                                            : -1;
+                    return precision == otherType.precision ? ReType.keep
+                                                            : ReType.change;
                 }
 
                 break;
             }
             case Types.SQL_BLOB : {
                 if (otherType.typeCode == typeCode) {
-                    return precision >= otherType.precision ? 0
-                                                            : -1;
+                    return precision >= otherType.precision ? ReType.keep
+                                                            : ReType.change;
                 }
 
                 break;
@@ -586,7 +604,7 @@ public class BinaryType extends Type {
             default :
         }
 
-        return -1;
+        return ReType.change;
     }
 
     public long position(SessionInterface session, BlobData data,
@@ -608,41 +626,28 @@ public class BinaryType extends Type {
     public BlobData substring(SessionInterface session, BlobData data,
                               long offset, long length, boolean hasLength) {
 
-        long end;
-        long dataLength = data.length(session);
-
-        if (hasLength) {
-            end = offset + length;
-        } else {
-            end = dataLength > offset ? dataLength
-                                      : offset;
-        }
-
-        if (offset > end) {
+        if (length < 0) {
             throw Error.error(ErrorCode.X_22011);
         }
 
-        if (end < 0) {
-
-            // return zero length data
-            offset = 0;
-            end    = 0;
-        }
-
-        if (offset < 0) {
-            offset = 0;
-        }
+        long dataLength = data.length(session);
+        LongPair segment = CharacterType.substringParams(dataLength, offset,
+            length, hasLength);
 
-        if (end > dataLength) {
-            end = dataLength;
-        }
+        offset = segment.a;
+        length = segment.b;
 
-        length = end - offset;
+        if (data instanceof BinaryData) {
+            byte[] bytes = data.getBytes(session, offset, (int) length);
 
-        // change method signature to take long
-        byte[] bytes = data.getBytes(session, offset, (int) length);
+            return new BinaryData(bytes, false);
+        } else if (data instanceof BlobData) {
+            BlobData blob = ((BlobData) data).getBlob(session, offset, length);
 
-        return new BinaryData(bytes, false);
+            return blob;
+        } else {
+            throw Error.runtimeError(ErrorCode.U_S0500, "CharacterType");
+        }
     }
 
     int getRightTrimSize(BlobData data) {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/types/BinaryUUIDType.java 2.7.0-1/hsqldb/src/org/hsqldb/types/BinaryUUIDType.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/types/BinaryUUIDType.java	2020-07-10 09:42:32.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/types/BinaryUUIDType.java	2022-03-26 22:12:46.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -52,7 +52,7 @@ import org.hsqldb.lib.StringConverter;
  * Cast to CHARACTER types converts to a hexadecimal UUID string.
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.5.1
+ * @version 2.7.0
  * @since 2.3.4
  */
 public class BinaryUUIDType extends BinaryType {
@@ -346,22 +346,22 @@ public class BinaryUUIDType extends Bina
     public int canMoveFrom(Type otherType) {
 
         if (otherType == this) {
-            return 0;
+            return ReType.keep;
         }
 
         switch (otherType.typeCode) {
 
             case Types.SQL_GUID :
-                return 0;
+                return ReType.keep;
 
             case Types.SQL_VARBINARY :
             case Types.SQL_BINARY :
             case Types.SQL_CHAR :
             case Types.SQL_VARCHAR :
-                return -1;
+                return ReType.change;
 
             default :
-                return -1;
+                return ReType.change;
         }
     }
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/types/BitType.java 2.7.0-1/hsqldb/src/org/hsqldb/types/BitType.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/types/BitType.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/types/BitType.java	2022-03-04 20:50:54.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -56,7 +56,7 @@ import org.hsqldb.map.BitMap;
  * string<p>
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.5.1
+ * @version 2.7.0
  * @since 1.9.0
  */
 public final class BitType extends BinaryType {
@@ -429,6 +429,20 @@ public final class BitType extends Binar
             (int) ((BinaryData) a).bitLength(null));
     }
 
+    public void convertToJSON(Object a, StringBuilder sb) {
+
+        if (a == null) {
+            sb.append("null");
+
+            return;
+        }
+
+        sb.append('"');
+        sb.append(convertToString(a));
+        sb.append('"');
+    }
+
+
     public boolean canConvertFrom(Type otherType) {
 
         return otherType.typeCode == Types.SQL_ALL_TYPES
@@ -444,19 +458,19 @@ public final class BitType extends Binar
 
             case Types.SQL_BIT : {
                 if (otherType.typeCode == typeCode) {
-                    return precision == otherType.precision ? 0
-                                                            : -1;
+                    return precision == otherType.precision ? ReType.keep
+                                                            : ReType.change;
                 }
 
-                return -1;
+                return ReType.change;
             }
             case Types.SQL_BIT_VARYING : {
                 return otherType.isBitType()
-                       && precision >= otherType.precision ? 0
-                                                           : -1;
+                       && precision >= otherType.precision ? ReType.keep
+                                                           : ReType.change;
             }
             default :
-                return -1;
+                return ReType.change;
         }
     }
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/types/BlobDataID.java 2.7.0-1/hsqldb/src/org/hsqldb/types/BlobDataID.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/types/BlobDataID.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/types/BlobDataID.java	2022-02-21 14:41:50.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -155,7 +155,6 @@ public class BlobDataID implements BlobD
         Result    resultIn  = session.execute(resultOut);
 
         if (resultIn.isError()) {
-
             throw resultIn.getException();
         }
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/types/BlobData.java 2.7.0-1/hsqldb/src/org/hsqldb/types/BlobData.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/types/BlobData.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/types/BlobData.java	2022-02-21 14:41:50.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -68,7 +68,8 @@ public interface BlobData extends LobDat
 
     void setBytes(SessionInterface session, long pos, byte[] bytes);
 
-    void setBytes(SessionInterface session, long pos, BlobData b, long offset, long length);
+    void setBytes(SessionInterface session, long pos, BlobData b, long offset,
+                  long length);
 
     void setBinaryStream(SessionInterface session, long pos, InputStream in);
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/types/BooleanType.java 2.7.0-1/hsqldb/src/org/hsqldb/types/BooleanType.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/types/BooleanType.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/types/BooleanType.java	2022-03-04 20:50:54.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -43,7 +43,7 @@ import org.hsqldb.map.BitMap;
  * Type implementation for BOOLEAN.<p>
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.5.1
+ * @version 2.7.0
  * @since 1.9.0
  */
 public final class BooleanType extends Type {
@@ -282,6 +282,20 @@ public final class BooleanType extends T
                                             : Tokens.T_FALSE;
     }
 
+    public void convertToJSON(Object a, StringBuilder sb) {
+
+        if (a == null) {
+            sb.append("null");
+
+            return;
+        }
+
+        String val = ((Boolean) a).toString();
+
+        sb.append(val);
+    }
+
+
     public boolean canConvertFrom(Type otherType) {
 
         return otherType.typeCode == Types.SQL_ALL_TYPES
@@ -291,8 +305,8 @@ public final class BooleanType extends T
     }
 
     public int canMoveFrom(Type otherType) {
-        return otherType.isBooleanType() ? 0
-                                         : -1;
+        return otherType.isBooleanType() ? ReType.keep
+                                         : ReType.change;
     }
 
     public static BooleanType getBooleanType() {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/types/CharacterType.java 2.7.0-1/hsqldb/src/org/hsqldb/types/CharacterType.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/types/CharacterType.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/types/CharacterType.java	2022-03-04 20:50:54.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -47,7 +47,7 @@ import org.hsqldb.lib.StringUtil;
  * Type subclass for CHARACTER, VARCHAR, etc.<p>
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.5.0
+ * @version 2.7.0
  * @since 1.9.0
  */
 public class CharacterType extends Type {
@@ -281,7 +281,6 @@ public class CharacterType extends Type
             case Types.OTHER :
                 throw Error.error(ErrorCode.X_42562);
             default :
-
                 /*
                  * @todo - this seems to be allowed in SQL-92 (is in NIST)
                  * but is disallowed in SQL:2003
@@ -417,14 +416,18 @@ public class CharacterType extends Type
 
         switch (typeCode) {
 
-            case Types.SQL_CHAR : {
+            case Types.SQL_CHAR :
+            case Types.SQL_VARCHAR : {
                 int slen = ((String) a).length();
 
-                if (slen == precision) {
-                    return a;
-                }
-
                 if (slen > precision) {
+                    if (session instanceof Session) {
+                        if (!((Session) session).database
+                                .sqlTruncateTrailing) {
+                            throw Error.error(ErrorCode.X_22001);
+                        }
+                    }
+
                     if (getRightTrimSize((String) a, ' ') <= precision) {
                         return ((String) a).substring(0, (int) precision);
                     } else {
@@ -432,6 +435,14 @@ public class CharacterType extends Type
                     }
                 }
 
+                if (typeCode == Types.SQL_VARCHAR) {
+                    return a;
+                }
+
+                if (slen == precision) {
+                    return a;
+                }
+
                 char[] b = new char[(int) precision];
 
                 ((String) a).getChars(0, slen, b, 0);
@@ -442,19 +453,6 @@ public class CharacterType extends Type
 
                 return new String(b);
             }
-            case Types.SQL_VARCHAR : {
-                int slen = ((String) a).length();
-
-                if (slen > precision) {
-                    if (getRightTrimSize((String) a, ' ') <= precision) {
-                        return ((String) a).substring(0, (int) precision);
-                    } else {
-                        throw Error.error(ErrorCode.X_22001);
-                    }
-                }
-
-                return a;
-            }
             case Types.SQL_CLOB : {
                 ClobData clob = (ClobData) a;
 
@@ -652,7 +650,7 @@ public class CharacterType extends Type
         } else if (a instanceof java.util.UUID) {
             s = a.toString();
         } else {
-            s = convertJavaTimeObject(session, a);
+            s = convertJavaDateTimeObject(a);
 
             if (s == null) {
                 throw Error.error(ErrorCode.X_42561);
@@ -663,7 +661,7 @@ public class CharacterType extends Type
     }
 
 //#ifdef JAVA8
-    String convertJavaTimeObject(SessionInterface session, Object a) {
+    String convertJavaDateTimeObject(Object a) {
 
         switch(a.getClass().getName()){
             case "java.time.LocalDate":
@@ -680,7 +678,7 @@ public class CharacterType extends Type
 
 //#else
 /*
-    String convertJavaTimeObject(SessionInterface session, Object a) {
+    String convertJavaDateTimeObject(Object a) {
         return null;
     }
 */
@@ -734,6 +732,17 @@ public class CharacterType extends Type
         return StringConverter.toQuotedString(s, '\'', true);
     }
 
+    public void convertToJSON(Object a, StringBuilder sb) {
+
+        if (a == null) {
+            sb.append("null");
+
+            return;
+        }
+
+        StringConverter.toJSONString((String) a, sb);
+    }
+
     public boolean canConvertFrom(Type otherType) {
         return !otherType.isObjectType();
     }
@@ -748,32 +757,32 @@ public class CharacterType extends Type
 
             case Types.SQL_VARCHAR : {
                 if (otherType.typeCode == typeCode) {
-                    return precision >= otherType.precision ? 0
-                                                            : 1;
+                    return precision >= otherType.precision ? ReType.keep
+                                                            : ReType.check;
                 }
 
                 if (otherType.typeCode == Types.SQL_CHAR) {
-                    return precision >= otherType.precision ? 0
-                                                            : -1;
+                    return precision >= otherType.precision ? ReType.keep
+                                                            : ReType.change;
                 }
 
                 return -1;
             }
             case Types.SQL_CLOB : {
                 if (otherType.typeCode == Types.SQL_CLOB) {
-                    return precision >= otherType.precision ? 0
-                                                            : 1;
+                    return precision >= otherType.precision ? ReType.keep
+                                                            : ReType.check;
                 }
 
                 return -1;
             }
             case Types.SQL_CHAR : {
                 return otherType.typeCode == Types.SQL_CHAR
-                       && precision == otherType.precision ? 0
-                                                           : -1;
+                       && precision == otherType.precision ? ReType.keep
+                                                           : ReType.change;
             }
             default :
-                return -1;
+                return ReType.change;
         }
     }
 
@@ -838,66 +847,60 @@ public class CharacterType extends Type
         }
     }
 
-    public Object substring(SessionInterface session, Object data,
-                            long offset, long length, boolean hasLength,
-                            boolean trailing) {
+    /**
+     * length must not be negative
+     */
+    public static LongPair substringParams(long dataLength, long start,
+                                           long length, boolean hasLength) {
 
         long end;
-        long dataLength = typeCode == Types.SQL_CLOB
-                          ? ((ClobData) data).length(session)
-                          : ((String) data).length();
 
-        if (trailing) {
-            end = dataLength;
-
-            if (length > dataLength) {
-                offset = 0;
-            } else {
-                offset = dataLength - length;
-            }
-        } else if (hasLength) {
-            end = offset + length;
+        if (hasLength) {
+            end = start + length;
         } else {
-            end = dataLength > offset ? dataLength
-                                      : offset;
+            end = Math.max(dataLength, start);
         }
 
-        if (end < offset) {
-            throw Error.error(ErrorCode.X_22011);
+        // trim
+        if (start >= dataLength || end < 0) {
+            start  = 0;
+            length = 0;
+        } else {
+            start  = Math.max(start, 0);
+            end    = Math.min(end, dataLength);
+            length = end - start;
         }
 
-        if (end < 0) {
+        return new LongPair(start, length);
+    }
 
-            // return zero length data
-            offset = 0;
-            end    = 0;
-        }
+    public Object substring(SessionInterface session, Object data,
+                            long offset, long length, boolean hasLength,
+                            boolean trailing) {
 
-        if (offset < 0) {
-            offset = 0;
+        if (length < 0) {
+            throw Error.error(ErrorCode.X_22011);
         }
 
-        if (end > dataLength) {
-            end = dataLength;
+        long dataLength = typeCode == Types.SQL_CLOB
+                          ? ((ClobData) data).length(session)
+                          : ((String) data).length();
+
+        if (trailing) {
+            offset = dataLength - offset;
         }
 
-        length = end - offset;
+        LongPair segment = substringParams(dataLength, offset, length,
+                                           hasLength);
+
+        offset = segment.a;
+        length = segment.b;
 
         if (data instanceof String) {
             return ((String) data).substring((int) offset,
                                              (int) (offset + length));
         } else if (data instanceof ClobData) {
-            ClobData clob = session.createClob(length);
-
-            if (length > Integer.MAX_VALUE) {
-                throw Error.error(ErrorCode.X_22001);
-            }
-
-            /* @todo - change to support long strings */
-            String result = ((ClobData) data).getSubString(session, offset,
-                (int) length);
-
-            clob.setString(session, 0, result);
+            ClobData clob = ((ClobData) data).getClob(session, offset, length);
 
             return clob;
         } else {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/types/ClobDataID.java 2.7.0-1/hsqldb/src/org/hsqldb/types/ClobDataID.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/types/ClobDataID.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/types/ClobDataID.java	2022-02-21 14:41:50.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -101,7 +101,6 @@ public class ClobDataID implements ClobD
             length = (int) (clobLength - pos);
         }
 
-
         char[] chars = getChars(session, pos, length);
 
         return new String(chars);
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/types/ClobData.java 2.7.0-1/hsqldb/src/org/hsqldb/types/ClobData.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/types/ClobData.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/types/ClobData.java	2022-02-21 14:41:50.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -62,14 +62,13 @@ public interface ClobData extends LobDat
 
     void setString(SessionInterface session, long pos, String str);
 
-    void setClob(SessionInterface session, long pos, ClobData clob, long offset,
-                  long len);
+    void setClob(SessionInterface session, long pos, ClobData clob,
+                 long offset, long len);
 
-    void setChars(SessionInterface session, long pos, char[] chars, int offset,
-                 int len);
+    void setChars(SessionInterface session, long pos, char[] chars,
+                  int offset, int len);
 
-    void setCharacterStream(SessionInterface session, long pos,
-                                   Reader in);
+    void setCharacterStream(SessionInterface session, long pos, Reader in);
 
     long position(SessionInterface session, String searchstr, long start);
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/types/ClobType.java 2.7.0-1/hsqldb/src/org/hsqldb/types/ClobType.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/types/ClobType.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/types/ClobType.java	2022-02-21 14:41:50.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -144,8 +144,8 @@ public final class ClobType extends Char
         if (b instanceof String) {
             long lobId = ((ClobData) a).getId();
 
-            return session.database.lobManager.compare(collation,
-                    lobId, (String) b);
+            return session.database.lobManager.compare(collation, lobId,
+                    (String) b);
         }
 
         return session.database.lobManager.compare(collation, (ClobData) a,
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/types/Collation.java 2.7.0-1/hsqldb/src/org/hsqldb/types/Collation.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/types/Collation.java	2020-03-25 23:13:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/types/Collation.java	2022-03-26 22:13:46.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -54,12 +54,12 @@ import org.hsqldb.rights.Grantee;
  *
  * @author Frand Schoenheit (frank.schoenheit@sun dot com)
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.5.1
+ * @version 2.7.0
  * @since 1.8.0
  */
 public class Collation implements SchemaObject {
 
-    static String               defaultCollationName = "SQL_TEXT";
+    public static String        defaultCollationName = "SQL_TEXT";
     static String defaultIgnoreCaseCollationName     = "SQL_TEXT_UCC";
     public static final HashMap nameToJavaName       = new HashMap(101);
     public static final HashMap dbNameToJavaName     = new HashMap(101);
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/types/DateTimeType.java 2.7.0-1/hsqldb/src/org/hsqldb/types/DateTimeType.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/types/DateTimeType.java	2021-05-30 14:45:50.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/types/DateTimeType.java	2022-06-29 17:43:38.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -42,11 +42,13 @@ import java.time.LocalTime;
 import java.time.OffsetDateTime;
 import java.time.OffsetTime;
 import java.time.ZoneOffset;
+import java.time.ZonedDateTime;
 import java.time.temporal.ChronoField;
 
 //#endif JAVA8
 import java.util.Calendar;
 import java.util.Date;
+import java.util.TimeZone;
 
 import org.hsqldb.HsqlDateTime;
 import org.hsqldb.HsqlException;
@@ -56,19 +58,18 @@ import org.hsqldb.SessionInterface;
 import org.hsqldb.Tokens;
 import org.hsqldb.error.Error;
 import org.hsqldb.error.ErrorCode;
+import org.hsqldb.lib.HashSet;
 import org.hsqldb.lib.StringConverter;
 
 /**
  * Type subclass for DATE, TIME and TIMESTAMP.<p>
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.1
+ * @version 2.7.0
  * @since 1.9.0
  */
 public final class DateTimeType extends DTIType {
 
-    public final boolean withTimeZone;
-    private String       nameString;
     public static final long epochSeconds =
         HsqlDateTime.getDateSeconds("1-01-01");
     public static final TimestampData epochTimestamp =
@@ -78,6 +79,13 @@ public final class DateTimeType extends
     public static final TimestampData epochLimitTimestamp =
         new TimestampData(epochLimitSeconds);
 
+    // this is used for the lifetime of the JVM - it should not be altered
+    public final static TimeZone systemTimeZone = TimeZone.getDefault();
+    public final static HashSet zoneIDs =
+        new HashSet(TimeZone.getAvailableIDs());
+    public final boolean withTimeZone;
+    private final String nameString;
+
     public DateTimeType(int typeGroup, int type, int scale) {
 
         super(typeGroup, type, 0, scale);
@@ -511,12 +519,10 @@ public final class DateTimeType extends
 
             case Types.SQL_TIME :
             case Types.SQL_TIME_WITH_TIME_ZONE : {
-                diff = ((TimeData) a).getSeconds()
-                       - ((TimeData) b).getSeconds();
+                diff = ((TimeData) a).seconds - ((TimeData) b).seconds;
 
                 if (diff == 0) {
-                    diff = ((TimeData) a).getNanos()
-                           - ((TimeData) b).getNanos();
+                    diff = ((TimeData) a).nanos - ((TimeData) b).nanos;
                 }
 
                 return diff == 0 ? 0
@@ -526,12 +532,12 @@ public final class DateTimeType extends
             case Types.SQL_DATE :
             case Types.SQL_TIMESTAMP :
             case Types.SQL_TIMESTAMP_WITH_TIME_ZONE : {
-                diff = ((TimestampData) a).getSeconds()
-                       - ((TimestampData) b).getSeconds();
+                diff = ((TimestampData) a).seconds
+                       - ((TimestampData) b).seconds;
 
                 if (diff == 0) {
-                    diff = ((TimestampData) a).getNanos()
-                           - ((TimestampData) b).getNanos();
+                    diff = ((TimestampData) a).nanos
+                           - ((TimestampData) b).nanos;
                 }
 
                 return diff == 0 ? 0
@@ -557,22 +563,22 @@ public final class DateTimeType extends
             case Types.SQL_TIME_WITH_TIME_ZONE :
             case Types.SQL_TIME : {
                 TimeData ti       = (TimeData) a;
-                int      nanos    = ti.getNanos();
+                int      nanos    = ti.nanos;
                 int      newNanos = scaleNanos(nanos);
 
                 if (newNanos == nanos) {
                     return ti;
                 }
 
-                return new TimeData(ti.getSeconds(), newNanos, ti.getZone());
+                return new TimeData(ti.seconds, newNanos, ti.zone);
             }
             case Types.SQL_TIMESTAMP_WITH_TIME_ZONE :
             case Types.SQL_TIMESTAMP : {
                 TimestampData ts       = (TimestampData) a;
-                int           nanos    = ts.getNanos();
+                int           nanos    = ts.nanos;
                 int           newNanos = scaleNanos(nanos);
 
-                if (ts.getSeconds() > epochLimitSeconds) {
+                if (ts.seconds > epochLimitSeconds) {
                     throw Error.error(ErrorCode.X_22008);
                 }
 
@@ -580,8 +586,7 @@ public final class DateTimeType extends
                     return ts;
                 }
 
-                return new TimestampData(ts.getSeconds(), newNanos,
-                                         ts.getZone());
+                return new TimestampData(ts.seconds, newNanos, ts.zone);
             }
             default :
                 throw Error.runtimeError(ErrorCode.U_S0500, "DateTimeType");
@@ -649,19 +654,19 @@ public final class DateTimeType extends
                         return a;
 
                     case Types.SQL_TIMESTAMP_WITH_TIME_ZONE : {
-                        long seconds = ((TimestampData) a).getSeconds()
-                                       + ((TimestampData) a).getZone();
-                        long millis = HsqlDateTime.getNormalisedDate(
-                            session.getCalendarGMT(), seconds * 1000);
+                        long seconds = ((TimestampData) a).seconds
+                                       + ((TimestampData) a).zone;
+
+                        seconds = toDateSeconds(seconds);
 
-                        return new TimestampData(millis / 1000);
+                        return new TimestampData(seconds);
                     }
                     case Types.SQL_TIMESTAMP : {
-                        long l = HsqlDateTime.getNormalisedDate(
-                            session.getCalendarGMT(),
-                            ((TimestampData) a).getSeconds() * 1000);
+                        long seconds = ((TimestampData) a).seconds;
 
-                        return new TimestampData(l / 1000);
+                        seconds = DateTimeType.toDateSeconds(seconds);
+
+                        return new TimestampData(seconds);
                     }
                     default :
                         throw Error.error(ErrorCode.X_42561);
@@ -673,36 +678,26 @@ public final class DateTimeType extends
                         return convertToTypeLimits(session, a);
 
                     case Types.SQL_TIME : {
-                        TimeData ti = (TimeData) a;
+                        TimeData ti          = (TimeData) a;
+                        int      zoneSeconds = session.getZoneSeconds();
 
-                        return new TimeData(
-                            ti.getSeconds() - session.getZoneSeconds(),
-                            scaleNanos(ti.getNanos()),
-                            session.getZoneSeconds());
+                        return new TimeData(ti.seconds - zoneSeconds,
+                                            scaleNanos(ti.nanos), zoneSeconds);
                     }
                     case Types.SQL_TIMESTAMP_WITH_TIME_ZONE : {
-                        TimestampData ts = (TimestampData) a;
-                        long seconds =
-                            HsqlDateTime.convertToNormalisedTime(
-                                ts.getSeconds() * 1000) / 1000;
-
-                        return new TimeData((int) (seconds),
-                                            scaleNanos(ts.getNanos()),
-                                            ts.getZone());
+                        TimestampData ts      = (TimestampData) a;
+                        int           seconds = toTimeSeconds(ts.seconds);
+
+                        return new TimeData(seconds, scaleNanos(ts.nanos),
+                                            ts.zone);
                     }
                     case Types.SQL_TIMESTAMP : {
-                        TimestampData ts = (TimestampData) a;
-                        long seconds = ts.getSeconds()
-                                       - session.getZoneSeconds();
+                        TimestampData ts          = (TimestampData) a;
+                        int           zoneSeconds = session.getZoneSeconds();
+                        int seconds = toTimeSeconds(ts.seconds - zoneSeconds);
 
-                        seconds =
-                            HsqlDateTime.convertToNormalisedTime(
-                                session.getCalendarGMT(),
-                                seconds * 1000) / 1000;
-
-                        return new TimeData((int) (seconds),
-                                            scaleNanos(ts.getNanos()),
-                                            session.getZoneSeconds());
+                        return new TimeData(seconds, scaleNanos(ts.nanos),
+                                            zoneSeconds);
                     }
                     default :
                         throw Error.error(ErrorCode.X_42561);
@@ -711,86 +706,59 @@ public final class DateTimeType extends
                 switch (otherType.typeCode) {
 
                     case Types.SQL_TIME_WITH_TIME_ZONE : {
-                        TimeData ti = (TimeData) a;
+                        TimeData ti      = (TimeData) a;
+                        int      seconds = toTimeSeconds(ti.seconds + ti.zone);
 
-                        return new TimeData(ti.getSeconds() + ti.getZone(),
-                                            scaleNanos(ti.getNanos()), 0);
+                        return new TimeData(seconds, scaleNanos(ti.nanos));
                     }
                     case Types.SQL_TIME :
                         return convertToTypeLimits(session, a);
 
                     case Types.SQL_TIMESTAMP_WITH_TIME_ZONE : {
-                        TimestampData ts      = (TimestampData) a;
-                        long          seconds = ts.getSeconds() + ts.getZone();
-
-                        seconds =
-                            HsqlDateTime.convertToNormalisedTime(
-                                session.getCalendarGMT(),
-                                seconds * 1000) / 1000;
-
-                        return new TimeData((int) (seconds),
-                                            scaleNanos(ts.getNanos()), 0);
-                    }
-                    case Types.SQL_TIMESTAMP :
                         TimestampData ts = (TimestampData) a;
-                        long seconds =
-                            HsqlDateTime.convertToNormalisedTime(
-                                session.getCalendarGMT(),
-                                ts.getSeconds() * 1000) / 1000;
+                        int seconds      = toTimeSeconds(ts.seconds + ts.zone);
 
-                        return new TimeData((int) (seconds),
-                                            scaleNanos(ts.getNanos()));
+                        return new TimeData(seconds, scaleNanos(ts.nanos));
+                    }
+                    case Types.SQL_TIMESTAMP : {
+                        TimestampData ts      = (TimestampData) a;
+                        int           seconds = toTimeSeconds(ts.seconds);
 
+                        return new TimeData(seconds, scaleNanos(ts.nanos));
+                    }
                     default :
                         throw Error.error(ErrorCode.X_42561);
                 }
             case Types.SQL_TIMESTAMP_WITH_TIME_ZONE :
                 switch (otherType.typeCode) {
 
-                    case Types.SQL_TIME_WITH_TIME_ZONE : {
-                        TimeData ti = (TimeData) a;
-                        long seconds = session.getCurrentDate().getSeconds()
-                                       + ti.getSeconds();
-
-                        return new TimestampData(seconds,
-                                                 scaleNanos(ti.getNanos()),
-                                                 ti.getZone());
-                    }
+                    case Types.SQL_TIME_WITH_TIME_ZONE :
                     case Types.SQL_TIME : {
                         TimeData ti = (TimeData) a;
-                        long seconds = session.getCurrentDate().getSeconds()
-                                       + ti.getSeconds()
-                                       - session.getZoneSeconds();
 
-                        return new TimestampData(seconds,
-                                                 scaleNanos(ti.getNanos()),
-                                                 session.getZoneSeconds());
+                        return convertTimeToTimestamp(session.getCalendar(),
+                                                      ti.seconds + ti.zone,
+                                                      scaleNanos(ti.nanos));
                     }
                     case Types.SQL_TIMESTAMP_WITH_TIME_ZONE :
                         return convertToTypeLimits(session, a);
 
+                    case Types.SQL_DATE :
                     case Types.SQL_TIMESTAMP : {
                         if (!(a instanceof TimestampData)) {
                             throw Error.error(ErrorCode.X_42561);
                         }
 
-                        TimestampData ts = (TimestampData) a;
-                        long seconds = ts.getSeconds()
-                                       - session.getZoneSeconds();
+                        TimestampData ts       = (TimestampData) a;
+                        Calendar      calendar = session.getCalendar();
+                        long seconds = HsqlDateTime.convertSecondsFromCalendar(
+                            session.getCalendarGMT(), calendar, ts.seconds);
+                        int zoneSeconds =
+                            getZoneSeconds(seconds, calendar.getTimeZone());
 
                         return new TimestampData(seconds,
-                                                 scaleNanos(ts.getNanos()),
-                                                 session.getZoneSeconds());
-                    }
-                    case Types.SQL_DATE : {
-                        if (!(a instanceof TimestampData)) {
-                            throw Error.error(ErrorCode.X_42561);
-                        }
-
-                        TimestampData ts = (TimestampData) a;
-
-                        return new TimestampData(ts.getSeconds(), 0,
-                                                 session.getZoneSeconds());
+                                                 scaleNanos(ts.nanos),
+                                                 zoneSeconds);
                     }
                     default :
                         throw Error.error(ErrorCode.X_42561);
@@ -798,30 +766,20 @@ public final class DateTimeType extends
             case Types.SQL_TIMESTAMP :
                 switch (otherType.typeCode) {
 
-                    case Types.SQL_TIME_WITH_TIME_ZONE : {
-                        TimeData ti = (TimeData) a;
-                        long seconds = session.getCurrentDate().getSeconds()
-                                       + ti.getSeconds()
-                                       - session.getZoneSeconds();
-
-                        return new TimestampData(seconds,
-                                                 scaleNanos(ti.getNanos()),
-                                                 session.getZoneSeconds());
-                    }
+                    case Types.SQL_TIME_WITH_TIME_ZONE :
                     case Types.SQL_TIME : {
                         TimeData ti = (TimeData) a;
-                        long seconds = session.getCurrentDate().getSeconds()
-                                       + ti.getSeconds();
 
-                        return new TimestampData(seconds,
-                                                 scaleNanos(ti.getNanos()));
+                        return convertTimeToTimestamp(session.getCalendar(),
+                                                      ti.seconds + ti.zone,
+                                                      scaleNanos(ti.nanos));
                     }
                     case Types.SQL_TIMESTAMP_WITH_TIME_ZONE : {
                         TimestampData ts      = (TimestampData) a;
-                        long          seconds = ts.getSeconds() + ts.getZone();
+                        long          seconds = ts.seconds + ts.zone;
 
                         return new TimestampData(seconds,
-                                                 scaleNanos(ts.getNanos()));
+                                                 scaleNanos(ts.nanos));
                     }
                     case Types.SQL_TIMESTAMP :
                         return convertToTypeLimits(session, a);
@@ -845,295 +803,149 @@ public final class DateTimeType extends
         return convertToType(session, a, otherType);
     }
 
-    /* @todo - check the time zone conversion */
     public Object convertJavaToSQL(SessionInterface session, Object a) {
+        return convertJavaToSQL(session, a, null);
+    }
+
+    public Object convertJavaToSQL(SessionInterface session, Object a,
+                                   Calendar calendar) {
 
         if (a == null) {
             return null;
         }
 
-        switch (typeCode) {
-
-            case Types.SQL_TIME :
-            case Types.SQL_TIME_WITH_TIME_ZONE :
-                if (a instanceof java.sql.Date) {
-                    break;
-                }
-
-                if (a instanceof java.util.Date) {
-                    long millis;
-                    int  nanos       = 0;
-                    int  zoneSeconds = 0;
-
-                    if (typeCode == Types.SQL_TIME) {
-                        millis = HsqlDateTime.convertMillisFromCalendar(
-                            session.getCalendarGMT(), session.getCalendar(),
-                            ((java.util.Date) a).getTime());
-                    } else {
-                        millis      = ((java.util.Date) a).getTime();
-                        zoneSeconds = session.getZoneSeconds();
-                    }
-
-                    millis = HsqlDateTime.getNormalisedTime(
-                        session.getCalendarGMT(), millis);
-
-                    if (a instanceof java.sql.Timestamp) {
-                        nanos = ((java.sql.Timestamp) a).getNanos();
-                        nanos = normaliseFraction(nanos, scale);
-                    }
-
-                    return new TimeData((int) millis / 1000, nanos,
-                                        zoneSeconds);
-                }
-
-                TimeData time = convertJavaTimeObject(session, a);
-
-                if (time != null) {
-                    return time;
-                }
-                break;
-
-            case Types.SQL_DATE : {
-                if (a instanceof java.sql.Time) {
-                    break;
-                }
-
-                if (a instanceof java.util.Date) {
-                    long millis;
-                    long seconds;
-
-                    millis = HsqlDateTime.convertMillisFromCalendar(
-                        session.getCalendarGMT(), session.getCalendar(),
-                        ((java.util.Date) a).getTime());
-                    millis = HsqlDateTime.getNormalisedDate(
-                        session.getCalendarGMT(), millis);
-                    seconds = millis / 1000;
-
-                    if (seconds < epochSeconds
-                            || seconds > epochLimitSeconds) {
-                        throw Error.error(ErrorCode.X_22008);
-                    }
-
-                    return new TimestampData(seconds);
-                }
-
-                TimestampData timestamp = convertJavaDateTimeObject(session,
-                    a);
-
-                if (timestamp != null) {
-                    return timestamp;
-                }
-
-                break;
-            }
-            case Types.SQL_TIMESTAMP :
-            case Types.SQL_TIMESTAMP_WITH_TIME_ZONE : {
-                if (a instanceof java.sql.Time) {
-                    break;
-                }
-
-                if (a instanceof java.util.Date) {
-                    long millis = ((java.util.Date) a).getTime();
-                    long seconds;
-                    int  nanos;
-                    int  zoneSeconds = 0;
-
-                    if (typeCode == Types.SQL_TIMESTAMP) {
-                        millis = HsqlDateTime.convertMillisFromCalendar(
-                            session.getCalendarGMT(), session.getCalendar(),
-                            millis);
-
-                        if (a instanceof java.sql.Date) {
-                            millis = HsqlDateTime.getNormalisedDate(
-                                session.getCalendarGMT(), millis);
-                        }
-                    } else {
-                        if (a instanceof java.sql.Date) {
-                            millis = HsqlDateTime.getNormalisedDate(
-                                session.getCalendarGMT(), millis);
-                        }
-
-                        zoneSeconds =
-                            HsqlDateTime.getZoneMillis(
-                                session.getCalendar(), millis) / 1000;
-                    }
-
-                    seconds = millis / 1000;
-
-                    if (seconds < epochSeconds
-                            || seconds > epochLimitSeconds) {
-                        throw Error.error(ErrorCode.X_22008);
-                    }
-
-                    if (a instanceof java.sql.Timestamp) {
-                        nanos = ((java.sql.Timestamp) a).getNanos();
-                        nanos = DateTimeType.normaliseFraction(nanos, scale);
-                    } else {
-                        nanos = DateTimeType.normaliseFraction(
-                            (int) (millis % 1000) * 1000000, scale);
-                    }
-
-                    return new TimestampData(seconds, nanos, zoneSeconds);
-                }
-
-                TimestampData timestamp = convertJavaDateTimeObject(session,
-                    a);
-
-                if (timestamp != null) {
-                    return timestamp;
-                }
+        if (calendar == null) {
+            calendar = session.getCalendar();
+        }
 
-                break;
+        long    seconds      = 0;
+        int     nanos        = 0;
+        int     zoneSeconds  = 0;
+        boolean hasZone      = false;
+        boolean isTimeObject = false;
+        boolean isDateObject = false;
+
+        if (a instanceof java.util.Date) {
+            long millis = ((java.util.Date) a).getTime();
+
+            if (a instanceof java.sql.Time) {
+                isTimeObject = true;
+                nanos        = (int) (millis % millisInSecond * nanosInMilli);
+            } else if (a instanceof java.sql.Date) {
+                isDateObject = true;
+            } else if (a instanceof java.sql.Timestamp) {
+                nanos  = ((java.sql.Timestamp) a).getNanos();
+                millis -= (nanos / nanosInMilli);
+            } else {
+                nanos = (int) (millis % millisInSecond * nanosInMilli);
             }
-        }
 
-        throw Error.error(ErrorCode.X_42561);
-    }
+            seconds     = millis / millisInSecond;
+            zoneSeconds = getZoneSeconds(seconds, calendar.getTimeZone());
 
 //#ifdef JAVA8
-    TimestampData convertJavaDateTimeObject(SessionInterface session,
-            Object a) {
-
-        long    seconds;
-        int     nanos       = 0;
-        int     zoneSeconds = 0;
-        boolean timestamp   = this.typeCode != Types.SQL_DATE;
-
-        if (a instanceof java.time.LocalDate) {
+        } else if (a instanceof java.time.LocalDate) {
             LocalDate ld = (LocalDate) a;
 
-            a = ld.atStartOfDay();
-        }
+            setDateComponents(calendar, ld);
 
-        if (a instanceof java.time.OffsetDateTime) {
+            seconds      = calendar.getTimeInMillis() / millisInSecond;
+            zoneSeconds  = getZoneSeconds(seconds, calendar.getTimeZone());
+            nanos        = 0;
+            isDateObject = true;
+        } else if (a instanceof OffsetDateTime) {
             OffsetDateTime odt = (OffsetDateTime) a;
 
-            seconds = odt.toEpochSecond();
-
-            int offset = odt.get(ChronoField.OFFSET_SECONDS);
-
-            if (timestamp) {
-                nanos = odt.getNano();
-                nanos = DateTimeType.normaliseFraction(nanos, scale);
-
-                if (withTimeZone) {
-                    zoneSeconds = offset;
-                } else {
-                    seconds += offset;
-                }
-            } else {
-                seconds += offset;
-                seconds =
-                    HsqlDateTime.getNormalisedDate(
-                        session.getCalendarGMT(), seconds * 1000) / 1000;
-            }
-
-            return new TimestampData(seconds, nanos, zoneSeconds);
+            seconds     = odt.toEpochSecond();
+            zoneSeconds = odt.get(ChronoField.OFFSET_SECONDS);
+            nanos       = odt.getNano();
+            hasZone     = true;
+        } else if (a instanceof ZonedDateTime) {
+            ZonedDateTime zdt = (ZonedDateTime) a;
+
+            seconds     = zdt.toEpochSecond();
+            zoneSeconds = zdt.get(ChronoField.OFFSET_SECONDS);
+            nanos       = zdt.getNano();
+            hasZone     = true;
         } else if (a instanceof java.time.LocalDateTime) {
             LocalDateTime ldt = (LocalDateTime) a;
 
-            seconds = ldt.toEpochSecond(ZoneOffset.UTC);
+            setDateTimeComponents(calendar, ldt);
 
-            if (timestamp) {
-                nanos = ldt.getNano();
-                nanos = DateTimeType.normaliseFraction(nanos, scale);
-
-                if (withTimeZone) {
-                    zoneSeconds = session.getZoneSeconds();
-                    seconds     -= zoneSeconds;
-                }
-            } else {
-                seconds =
-                    HsqlDateTime.getNormalisedDate(
-                        session.getCalendarGMT(), seconds * 1000) / 1000;
-            }
-
-            return new TimestampData(seconds, nanos, zoneSeconds);
+            seconds     = calendar.getTimeInMillis() / millisInSecond;
+            zoneSeconds = getZoneSeconds(seconds, calendar.getTimeZone());
+            nanos       = ldt.getNano();
         } else if (a instanceof java.time.Instant) {
             Instant ins = (Instant) a;
 
-            seconds = ins.getEpochSecond();
-
-            if (timestamp) {
-                nanos   = ins.getNano();
-
-                if (nanos < 0) {
-                    nanos += DTIType.limitNanoseconds;
-
-                    seconds--;
-                }
-                nanos       = DateTimeType.normaliseFraction(nanos, scale);
-                zoneSeconds = session.getZoneSeconds();
+            seconds     = ins.getEpochSecond();
+            zoneSeconds = getZoneSeconds(seconds, calendar.getTimeZone());
+            nanos       = ins.getNano();
+        } else if (a instanceof java.time.OffsetTime) {
+            OffsetTime ot = (OffsetTime) a;
+
+            seconds      = ot.toLocalTime().toSecondOfDay();
+            zoneSeconds  = ot.get(ChronoField.OFFSET_SECONDS);
+            seconds      = seconds - zoneSeconds;
+            nanos        = ot.getNano();
+            isTimeObject = true;
+            hasZone      = true;
+        } else if (a instanceof java.time.LocalTime) {
+            LocalTime lt = (LocalTime) a;
 
-                if (!withTimeZone) {
-                    seconds += zoneSeconds;
-                }
-            } else {
-                seconds += zoneSeconds;
-                seconds =
-                    HsqlDateTime.getNormalisedDate(
-                        session.getCalendarGMT(), seconds * 1000) / 1000;
-            }
+            seconds      = lt.toSecondOfDay();
+            zoneSeconds  = getZoneSeconds(seconds, calendar.getTimeZone());
+            nanos        = lt.getNano();
+            isTimeObject = true;
 
-            return new TimestampData(seconds, nanos, zoneSeconds);
+//#endif JAVA8
+        } else {
+            throw Error.error(ErrorCode.X_42561);
         }
 
-        return null;
-    }
+        if (!withTimeZone) {
+            seconds     += zoneSeconds;
+            zoneSeconds = 0;
+        }
 
-    TimeData convertJavaTimeObject(SessionInterface session, Object a) {
+        switch (typeCode) {
 
-        int seconds;
-        int nanos;
-        int zoneSeconds = 0;
+            case Types.SQL_TIME :
+            case Types.SQL_TIME_WITH_TIME_ZONE : {
+                if (isDateObject) {
+                    throw Error.error(ErrorCode.X_42561);
+                }
 
-        if (a instanceof java.time.OffsetTime) {
-            OffsetTime ot     = (OffsetTime) a;
+                nanos = DateTimeType.normaliseFraction(nanos, scale);
 
-            seconds = ot.toLocalTime().toSecondOfDay();
-            nanos   = ot.getNano();
-            nanos   = DateTimeType.normaliseFraction(nanos, scale);
+                return new TimeData((int) seconds, nanos, zoneSeconds);
+            }
+            case Types.SQL_DATE : {
+                if (isTimeObject) {
+                    throw Error.error(ErrorCode.X_42561);
+                }
 
-            if (withTimeZone) {
-                zoneSeconds = ot.get(ChronoField.OFFSET_SECONDS);
+                seconds = toDateSeconds(seconds);
 
-                seconds -= zoneSeconds;
-                seconds = DateTimeType.normaliseTime(seconds);
+                return new TimestampData(seconds);
             }
+            case Types.SQL_TIMESTAMP :
+            case Types.SQL_TIMESTAMP_WITH_TIME_ZONE : {
+                if (isTimeObject) {
+                    return convertTimeToTimestamp(calendar,
+                                                  seconds + zoneSeconds,
+                                                  nanos);
+                }
 
-            return new TimeData(seconds, nanos, zoneSeconds);
-        } else if (a instanceof java.time.LocalTime) {
-            LocalTime lt = (LocalTime) a;
-
-            seconds = lt.toSecondOfDay();
-            nanos   = lt.getNano();
-            nanos   = DateTimeType.normaliseFraction(nanos, scale);
+                nanos = DateTimeType.normaliseFraction(nanos, scale);
 
-            if (withTimeZone) {
-                zoneSeconds = session.getZoneSeconds();
-                seconds -= zoneSeconds;
-                seconds = DateTimeType.normaliseTime(seconds);
+                return new TimestampData(seconds, nanos, zoneSeconds);
             }
-
-            return new TimeData(seconds, nanos, zoneSeconds);
+            default :
+                throw Error.error(ErrorCode.X_42561);
         }
-
-        return null;
     }
 
-//#else
-/*
-    TimestampData convertJavaDateTimeObject(SessionInterface session,
-            Object a) {
-        return null;
-    }
-
-    TimeData convertJavaTimeObject(SessionInterface session, Object a) {
-        return null;
-    }
-*/
-
-//#endif JAVA8
     public Object convertSQLToJavaGMT(SessionInterface session, Object a) {
 
         long millis;
@@ -1142,23 +954,23 @@ public final class DateTimeType extends
 
             case Types.SQL_TIME :
             case Types.SQL_TIME_WITH_TIME_ZONE :
-                millis = ((TimeData) a).getSeconds() * 1000L;
-                millis += ((TimeData) a).getNanos() / 1000000;
+                millis = ((TimeData) a).seconds * millisInSecond;
+                millis += ((TimeData) a).nanos / nanosInMilli;
 
                 return new java.sql.Time(millis);
 
             case Types.SQL_DATE :
-                millis = ((TimestampData) a).getSeconds() * 1000;
+                millis = ((TimestampData) a).seconds * millisInSecond;
 
                 return new java.sql.Date(millis);
 
             case Types.SQL_TIMESTAMP :
             case Types.SQL_TIMESTAMP_WITH_TIME_ZONE :
-                millis = ((TimestampData) a).getSeconds() * 1000;
+                millis = ((TimestampData) a).seconds * millisInSecond;
 
                 java.sql.Timestamp value = new java.sql.Timestamp(millis);
 
-                value.setNanos(((TimestampData) a).getNanos());
+                value.setNanos(((TimestampData) a).nanos);
 
                 return value;
 
@@ -1169,36 +981,43 @@ public final class DateTimeType extends
 
     public Object convertSQLToJava(SessionInterface session, Object a) {
 
+        Calendar cal = session.getCalendar();
+
+        return convertSQLToJava(session, a, null);
+    }
+
+    public Object convertSQLToJava(SessionInterface session, Object a,
+                                   Calendar cal) {
+
         if (a == null) {
             return null;
         }
 
+        if (cal == null) {
+            cal = session.getCalendar();
+        }
+
         switch (typeCode) {
 
             case Types.SQL_TIME : {
-                Calendar cal = session.getCalendar();
-                long millis = HsqlDateTime.convertMillisToCalendar(cal,
-                    ((TimeData) a).getMillis());
+                TimeData td = ((TimeData) a);
 
-                millis = HsqlDateTime.getNormalisedTime(cal, millis);
+                setTimeComponents(cal, td.seconds);
 
-                java.sql.Time value = new java.sql.Time(millis);
+                long millis = cal.getTimeInMillis() + td.nanos / nanosInMilli;
 
-                return value;
+                return new java.sql.Time(millis);
             }
             case Types.SQL_TIME_WITH_TIME_ZONE : {
 
 //#ifdef JAVA8
-                TimeData   ts   = (TimeData) a;
-                ZoneOffset zone = ZoneOffset.ofTotalSeconds(ts.zone);
-                long millis =
-                    HsqlDateTime.getNormalisedTime((ts.seconds + ts.zone)
-                                                   * 1_000L);
-                long      nanos = millis * 1_000_000L;
-                LocalTime ldt   = LocalTime.ofNanoOfDay(nanos + ts.nanos);
-                Object    value = OffsetTime.of(ldt, zone);
+                TimeData   ts      = (TimeData) a;
+                ZoneOffset zone    = ZoneOffset.ofTotalSeconds(ts.zone);
+                int        seconds = toTimeSeconds(ts.seconds + ts.zone);
+                long       nanos   = seconds * nanosInSecond;
+                LocalTime  ldt     = LocalTime.ofNanoOfDay(nanos + ts.nanos);
 
-                return value;
+                return OffsetTime.of(ldt, zone);
 
 //#else
 /*
@@ -1210,22 +1029,26 @@ public final class DateTimeType extends
 //#endif JAVA8
             }
             case Types.SQL_DATE : {
-                Calendar cal = session.getCalendar();
-                long millis = HsqlDateTime.convertMillisToCalendar(cal,
-                    ((TimestampData) a).getMillis());
+                Calendar calGMT = session.getCalendarGMT();
+                long     millis = ((TimestampData) a).getMillis();
 
-                // millis = HsqlDateTime.getNormalisedDate(cal, millis);
-                java.sql.Date value = new java.sql.Date(millis);
+                HsqlDateTime.convertMillisFromCalendar(calGMT, cal, millis);
+                HsqlDateTime.zeroFromPart(cal, Types.SQL_INTERVAL_DAY);
 
-                return value;
+                millis = cal.getTimeInMillis();
+
+                return new java.sql.Date(millis);
             }
             case Types.SQL_TIMESTAMP : {
-                Calendar cal = session.getCalendar();
-                long millis = HsqlDateTime.convertMillisToCalendar(cal,
-                    ((TimestampData) a).getMillis());
+                Calendar calGMT = session.getCalendarGMT();
+                long     millis = ((TimestampData) a).getMillis();
+
+                millis = HsqlDateTime.convertMillisFromCalendar(calGMT, cal,
+                        millis);
+
                 java.sql.Timestamp value = new java.sql.Timestamp(millis);
 
-                value.setNanos(((TimestampData) a).getNanos());
+                value.setNanos(((TimestampData) a).nanos);
 
                 return value;
             }
@@ -1244,7 +1067,7 @@ public final class DateTimeType extends
                 long               millis = ((TimestampData) a).getMillis();
                 java.sql.Timestamp value  = new java.sql.Timestamp(millis);
 
-                value.setNanos(((TimestampData) a).getNanos());
+                value.setNanos(((TimestampData) a).nanos);
 
                 return value;
 */
@@ -1252,21 +1075,8 @@ public final class DateTimeType extends
 //#endif JAVA8
             }
             default :
-                throw Error.runtimeError(ErrorCode.U_S0500, "DateTimeType");
-        }
-    }
-
-    public static int normaliseTime(int seconds) {
-
-        while (seconds < 0) {
-            seconds += 24 * 60 * 60;
-        }
-
-        if (seconds >= 24 * 60 * 60) {
-            seconds %= 24 * 60 * 60;
+                throw Error.error(ErrorCode.X_42561);
         }
-
-        return seconds;
     }
 
     public String convertToString(Object a) {
@@ -1282,38 +1092,33 @@ public final class DateTimeType extends
         switch (typeCode) {
 
             case Types.SQL_DATE :
-                return HsqlDateTime.getDateString(
-                    ((TimestampData) a).getSeconds());
+                return HsqlDateTime.getDateString(((TimestampData) a).seconds);
 
             case Types.SQL_TIME_WITH_TIME_ZONE :
             case Types.SQL_TIME : {
                 TimeData t       = (TimeData) a;
-                int      seconds = normaliseTime(t.getSeconds() + t.getZone());
+                int      seconds = toTimeSeconds(t.seconds + t.zone);
 
-                s = intervalSecondToString(seconds, t.getNanos(), false);
+                s = intervalSecondToString(seconds, t.nanos, false);
 
                 if (!withTimeZone) {
                     return s;
                 }
 
-                sb = new StringBuilder(s);
-                s = Type.SQL_INTERVAL_HOUR_TO_MINUTE.intervalSecondToString(
-                    ((TimeData) a).getZone(), 0, true);
+                s += Type.SQL_INTERVAL_HOUR_TO_MINUTE.intervalSecondToString(
+                    t.zone, 0, true);
 
-                sb.append(s);
-
-                return sb.toString();
+                return s;
             }
             case Types.SQL_TIMESTAMP_WITH_TIME_ZONE :
             case Types.SQL_TIMESTAMP : {
                 TimestampData ts = (TimestampData) a;
-                String tss = HsqlDateTime.getTimestampString(ts.getSeconds()
-                    + ts.getZone(), ts.getNanos(), scale);
+                String tss = HsqlDateTime.getTimestampString(ts.seconds
+                    + ts.zone, ts.nanos, scale);
 
                 if (withTimeZone) {
                     s = Type.SQL_INTERVAL_HOUR_TO_MINUTE
-                        .intervalSecondToString(((TimestampData) a).getZone(),
-                                                0, true);
+                        .intervalSecondToString(ts.zone, 0, true);
                     tss += s;
                 }
 
@@ -1355,6 +1160,19 @@ public final class DateTimeType extends
         return sb.toString();
     }
 
+    public void convertToJSON(Object a, StringBuilder sb) {
+
+        if (a == null) {
+            sb.append("null");
+
+            return;
+        }
+
+        sb.append('"');
+        sb.append(convertToString(a));
+        sb.append('"');
+    }
+
     public boolean canConvertFrom(Type otherType) {
 
         if (otherType.typeCode == Types.SQL_ALL_TYPES) {
@@ -1381,12 +1199,12 @@ public final class DateTimeType extends
     public int canMoveFrom(Type otherType) {
 
         if (otherType == this) {
-            return 0;
+            return ReType.keep;
         }
 
         if (typeCode == otherType.typeCode) {
-            return scale >= otherType.scale ? 0
-                                            : -1;
+            return scale >= otherType.scale ? ReType.keep
+                                            : ReType.change;
         }
 
         return -1;
@@ -1495,22 +1313,22 @@ public final class DateTimeType extends
         double fraction;
 
         if (a instanceof TimeData) {
-            seconds  = ((TimeData) a).getSeconds();
-            fraction = ((TimeData) a).getNanos() / 1000000000d;
+            seconds  = ((TimeData) a).seconds;
+            fraction = ((TimeData) a).nanos / 1000000000d;
         } else {
-            seconds  = ((TimestampData) a).getSeconds();
-            fraction = ((TimestampData) a).getNanos() / 1000000000d;
+            seconds  = ((TimestampData) a).seconds;
+            fraction = ((TimestampData) a).nanos / 1000000000d;
         }
 
         return seconds + fraction;
     }
 
-    public Object convertFromDouble(Session session, double value) {
+    public TimestampData convertFromDouble(Session session, double value) {
 
         long units = (long) value;
-        int  nanos = (int) ((value - units) * limitNanoseconds);
+        int  nanos = (int) ((value - units) * nanosInSecond);
 
-        return getValue(session, units, nanos, 0);
+        return getDateTimeValue(session, units, nanos);
     }
 
     public Object truncate(Session session, Object a, int part) {
@@ -1519,7 +1337,7 @@ public final class DateTimeType extends
             return null;
         }
 
-        long     millis   = getMillis(a);
+        long     millis   = getTotalMillis(a);
         Calendar calendar = session.getCalendarGMT();
 
         millis = HsqlDateTime.getTruncatedPart(calendar, millis, part);
@@ -1528,18 +1346,17 @@ public final class DateTimeType extends
         switch (typeCode) {
 
             case Types.SQL_TIME_WITH_TIME_ZONE :
+            case Types.SQL_TIME : {
                 millis = HsqlDateTime.getNormalisedTime(calendar, millis);
 
-            //fall through
-            case Types.SQL_TIME : {
-                return new TimeData((int) (millis / 1000), 0,
-                                    ((TimeData) a).getZone());
+                return new TimeData((int) (millis / millisInSecond), 0,
+                                    ((TimeData) a).zone);
             }
             case Types.SQL_DATE :
             case Types.SQL_TIMESTAMP_WITH_TIME_ZONE :
             case Types.SQL_TIMESTAMP : {
-                return new TimestampData(millis / 1000, 0,
-                                         ((TimestampData) a).getZone());
+                return new TimestampData(millis / millisInSecond, 0,
+                                         ((TimestampData) a).zone);
             }
             default :
         }
@@ -1553,7 +1370,7 @@ public final class DateTimeType extends
             return null;
         }
 
-        long     millis   = getMillis(a);
+        long     millis   = getTotalMillis(a);
         Calendar calendar = session.getCalendarGMT();
 
         millis = HsqlDateTime.getRoundedPart(calendar, millis, part);
@@ -1565,14 +1382,14 @@ public final class DateTimeType extends
             case Types.SQL_TIME : {
                 millis = HsqlDateTime.getNormalisedTime(millis);
 
-                return new TimeData((int) (millis / 1000), 0,
-                                    ((TimeData) a).getZone());
+                return new TimeData((int) (millis / millisInSecond), 0,
+                                    ((TimeData) a).zone);
             }
             case Types.SQL_DATE :
             case Types.SQL_TIMESTAMP_WITH_TIME_ZONE :
             case Types.SQL_TIMESTAMP : {
-                return new TimestampData(millis / 1000, 0,
-                                         ((TimestampData) a).getZone());
+                return new TimestampData(millis / millisInSecond, 0,
+                                         ((TimestampData) a).zone);
             }
             default :
         }
@@ -1638,37 +1455,27 @@ public final class DateTimeType extends
                 break;
 
             case Types.DTI_SECONDS_MIDNIGHT : {
-                if (typeCode == Types.SQL_TIME
-                        || typeCode == Types.SQL_TIME_WITH_TIME_ZONE) {}
-                else {
-                    try {
-                        Type target = withTimeZone
-                                      ? Type.SQL_TIME_WITH_TIME_ZONE
-                                      : Type.SQL_TIME;
+                long seconds = getTotalSeconds(dateTime);
 
-                        dateTime = target.castToType(session, dateTime, this);
-                    } catch (HsqlException e) {}
-                }
-
-                return ((TimeData) dateTime).getSeconds();
+                return toTimeSeconds(seconds);
             }
             case Types.DTI_TIMEZONE_HOUR :
                 if (typeCode == Types.SQL_TIMESTAMP_WITH_TIME_ZONE) {
-                    return ((TimestampData) dateTime).getZone() / 3600;
+                    return ((TimestampData) dateTime).zone / 3600;
                 } else {
-                    return ((TimeData) dateTime).getZone() / 3600;
+                    return ((TimeData) dateTime).zone / 3600;
                 }
             case Types.DTI_TIMEZONE_MINUTE :
                 if (typeCode == Types.SQL_TIMESTAMP_WITH_TIME_ZONE) {
-                    return ((TimestampData) dateTime).getZone() / 60 % 60;
+                    return ((TimestampData) dateTime).zone / 60 % 60;
                 } else {
-                    return ((TimeData) dateTime).getZone() / 60 % 60;
+                    return ((TimeData) dateTime).zone / 60 % 60;
                 }
             case Types.DTI_TIMEZONE :
                 if (typeCode == Types.SQL_TIMESTAMP_WITH_TIME_ZONE) {
-                    return ((TimestampData) dateTime).getZone() / 60;
+                    return ((TimestampData) dateTime).zone / 60;
                 } else {
-                    return ((TimeData) dateTime).getZone() / 60;
+                    return ((TimeData) dateTime).zone / 60;
                 }
             case Types.DTI_QUARTER :
                 increment    = 1;
@@ -1682,25 +1489,49 @@ public final class DateTimeType extends
 
             case Types.DTI_MILLISECOND :
                 if (this.isDateOrTimestampType()) {
-                    return ((TimestampData) dateTime).getNanos() / 1000000;
+                    return ((TimestampData) dateTime).nanos
+                           / (int) nanosInMilli;
                 } else {
-                    return ((TimeData) dateTime).getNanos() / 1000000;
+                    return ((TimeData) dateTime).nanos / (int) nanosInMilli;
+                }
+            case Types.DTI_MICROSECOND :
+                if (this.isDateOrTimestampType()) {
+                    return ((TimestampData) dateTime).nanos / 1000;
+                } else {
+                    return ((TimeData) dateTime).nanos / 1000;
                 }
             case Types.DTI_NANOSECOND :
                 if (this.isDateOrTimestampType()) {
-                    return ((TimestampData) dateTime).getNanos();
+                    return ((TimestampData) dateTime).nanos;
                 } else {
-                    return ((TimeData) dateTime).getNanos();
+                    return ((TimeData) dateTime).nanos;
                 }
             default :
                 throw Error.runtimeError(ErrorCode.U_S0500,
                                          "DateTimeType - " + part);
         }
 
-        long millis = getMillis(dateTime);
+        long     millis   = getTotalMillis(dateTime);
+        Calendar calendar = session.getCalendarGMT();
+
+        calendar.setTimeInMillis(millis);
 
-        return HsqlDateTime.getDateTimePart(session.getCalendarGMT(), millis, calendarPart)
-               / divisor + increment;
+        return calendar.get(calendarPart) / divisor + increment;
+    }
+
+    /**
+     * Returns the indicated part of the given millisecond date object.
+     * @param m the millisecond time value from which to extract the indicated part
+     * @param part an integer code corresponding to the desired date part
+     * @return the indicated part of the given <code>java.util.Date</code> object
+     */
+    public static int getDateTimePart(Calendar calendar, long m, int part) {
+
+        synchronized (calendar) {
+            calendar.setTimeInMillis(m);
+
+            return calendar.get(part);
+        }
     }
 
     public Object addMonthsSpecial(Session session, Object dateTime,
@@ -1708,7 +1539,7 @@ public final class DateTimeType extends
 
         TimestampData ts     = (TimestampData) dateTime;
         Calendar      cal    = session.getCalendarGMT();
-        long          millis = (ts.getSeconds() + ts.getZone()) * 1000;
+        long          millis = (ts.seconds + ts.zone) * millisInSecond;
         boolean       lastDay;
 
         HsqlDateTime.setTimeInMillis(cal, millis);
@@ -1729,14 +1560,14 @@ public final class DateTimeType extends
 
         millis = cal.getTimeInMillis();
 
-        return new TimestampData(millis / 1000, 0, 0);
+        return new TimestampData(millis / millisInSecond, 0, 0);
     }
 
     public Object getLastDayOfMonth(Session session, Object dateTime) {
 
         TimestampData ts     = (TimestampData) dateTime;
         Calendar      cal    = session.getCalendarGMT();
-        long          millis = (ts.getSeconds() + ts.getZone()) * 1000;
+        long          millis = (ts.seconds + ts.zone) * millisInSecond;
 
         HsqlDateTime.setTimeInMillis(cal, millis);
         cal.set(Calendar.DAY_OF_MONTH, 1);
@@ -1745,36 +1576,35 @@ public final class DateTimeType extends
 
         millis = cal.getTimeInMillis();
 
-        return new TimestampData(millis / 1000, 0, 0);
+        return new TimestampData(millis / millisInSecond, 0, 0);
     }
 
-    long getMillis(Object dateTime) {
+    long getTotalMillis(Object dateTime) {
+        return getTotalSeconds(dateTime) * millisInSecond;
+    }
 
-        long millis;
+    long getTotalSeconds(Object dateTime) {
 
         if (typeCode == Types.SQL_TIME
                 || typeCode == Types.SQL_TIME_WITH_TIME_ZONE) {
-            millis =
-                (((TimeData) dateTime).getSeconds() + ((TimeData) dateTime)
-                    .getZone()) * 1000L;
+            TimeData td = ((TimeData) dateTime);
+
+            return td.seconds + td.zone;
         } else {
-            millis =
-                (((TimestampData) dateTime)
-                    .getSeconds() + ((TimestampData) dateTime).getZone()) * 1000;
-        }
+            TimestampData ts = ((TimestampData) dateTime);
 
-        return millis;
+            return ts.seconds + ts.zone;
+        }
     }
 
     long getZoneMillis(Object dateTime) {
 
         long millis;
 
-        if (typeCode == Types.SQL_TIME
-                || typeCode == Types.SQL_TIME_WITH_TIME_ZONE) {
-            millis = ((TimeData) dateTime).getZone() * 1000L;
+        if (dateTime instanceof TimeData) {
+            millis = ((TimeData) dateTime).zone * millisInSecond;
         } else {
-            millis = ((TimestampData) dateTime).getZone() * 1000L;
+            millis = ((TimestampData) dateTime).zone * millisInSecond;
         }
 
         return millis;
@@ -1787,10 +1617,10 @@ public final class DateTimeType extends
 
         if (typeCode == Types.SQL_TIMESTAMP
                 || typeCode == Types.SQL_TIMESTAMP_WITH_TIME_ZONE) {
-            nanos = ((TimestampData) dateTime).getNanos();
+            nanos = ((TimestampData) dateTime).nanos;
         } else if (typeCode == Types.SQL_TIME
                    || typeCode == Types.SQL_TIME_WITH_TIME_ZONE) {
-            nanos = ((TimeData) dateTime).getNanos();
+            nanos = ((TimeData) dateTime).nanos;
         }
 
         return getSecondPart(seconds, nanos);
@@ -1822,73 +1652,77 @@ public final class DateTimeType extends
         return format.format(date);
     }
 
-    public Object getValue(Session session, long seconds, int nanos,
-                           int zoneSeconds) {
+    TimestampData convertTimeToTimestamp(Calendar calendar, long seconds,
+                                         int nanos) {
 
-        Calendar calendar = session.getCalendarGMT();
+        calendar.setTimeInMillis(System.currentTimeMillis());
+        setTimeComponentsOnly(calendar, (int) seconds);
 
-        switch (typeCode) {
+        seconds = calendar.getTimeInMillis() / millisInSecond;
 
-            case Types.SQL_DATE :
-                seconds =
-                    HsqlDateTime.getNormalisedDate(
-                        calendar, (seconds + zoneSeconds) * 1000) / 1000;
+        int zoneSeconds = getZoneSeconds(seconds, calendar.getTimeZone());
 
-                return new TimestampData(seconds);
+        if (!withTimeZone) {
+            seconds     += zoneSeconds;
+            zoneSeconds = 0;
+        }
 
-            case Types.SQL_TIME_WITH_TIME_ZONE :
-                seconds =
-                    HsqlDateTime.getNormalisedDate(calendar, seconds * 1000)
-                    / 1000;
+        return new TimestampData(seconds, zoneSeconds, nanos);
+    }
 
-                return new TimeData((int) seconds, nanos, zoneSeconds);
+    /**
+     * Session derivatives of CURRENT_TIMESTAMP
+     */
+    public static TimestampData toLocalTimestampValue(
+            TimestampData tsWithZone) {
+        return new TimestampData(tsWithZone.seconds + tsWithZone.zone,
+                                 tsWithZone.nanos);
+    }
 
-            case Types.SQL_TIME :
-                seconds =
-                    HsqlDateTime.getNormalisedTime(
-                        calendar, (seconds + zoneSeconds) * 1000) / 1000;
+    public static TimestampData toCurrentDateValue(TimestampData tsWithZone) {
 
-                return new TimeData((int) seconds, nanos);
+        long seconds = toDateSeconds(tsWithZone.seconds + tsWithZone.zone);
 
-            case Types.SQL_TIMESTAMP_WITH_TIME_ZONE :
-                return new TimestampData(seconds, nanos, zoneSeconds);
+        return new TimestampData(seconds);
+    }
 
-            case Types.SQL_TIMESTAMP :
-                return new TimestampData(seconds + zoneSeconds, nanos);
+    public static TimeData toCurrentTimeValue(TimestampData tsWithZone) {
 
-            default :
-                throw Error.runtimeError(ErrorCode.U_S0500, "DateTimeType");
-        }
+        int seconds = toTimeSeconds(tsWithZone.seconds + tsWithZone.zone);
+
+        return new TimeData(seconds, tsWithZone.nanos);
     }
 
-    public DateTimeType getDateTimeTypeWithoutZone() {
+    public static TimeData toCurrentTimeWithZoneValue(
+            TimestampData tsWithZone) {
 
-        if (this.withTimeZone) {
-            DateTimeType type;
+        int seconds = toTimeSeconds(tsWithZone.seconds);
 
-            switch (typeCode) {
+        return new TimeData(seconds, tsWithZone.nanos, tsWithZone.zone);
+    }
 
-                case Types.SQL_TIME_WITH_TIME_ZONE :
-                    type = new DateTimeType(Types.SQL_TIME, Types.SQL_TIME,
-                                            scale);
-                    break;
+    public TimestampData getDateTimeValue(SessionInterface session,
+                                          long seconds, int nanos) {
 
-                case Types.SQL_TIMESTAMP_WITH_TIME_ZONE :
-                    type = new DateTimeType(Types.SQL_TIMESTAMP,
-                                            Types.SQL_TIMESTAMP, scale);
-                    break;
+        nanos = DateTimeType.normaliseFraction(nanos, scale);
 
-                default :
-                    throw Error.runtimeError(ErrorCode.U_S0500,
-                                             "DateTimeType");
-            }
+        switch (typeCode) {
 
-            type.nameString = nameString;
+            case Types.SQL_DATE :
+                seconds = toDateSeconds(seconds);
 
-            return type;
-        }
+                return new TimestampData(seconds);
+
+            case Types.SQL_TIMESTAMP :
+                return new TimestampData(seconds, nanos);
+
+            case Types.SQL_TIMESTAMP_WITH_TIME_ZONE :
+                return new TimestampData(seconds, nanos,
+                                         session.getZoneSeconds());
 
-        return this;
+            default :
+                throw Error.runtimeError(ErrorCode.U_S0500, "DateTimeType");
+        }
     }
 
     public static DateTimeType getDateTimeType(int type, int scale) {
@@ -1939,20 +1773,18 @@ public final class DateTimeType extends
         }
     }
 
-    public static Object changeZoneToUTC(Object a) {
+    public Object changeZoneToUTC(Object a) {
 
         if (a instanceof TimestampData) {
             TimestampData ts = (TimestampData) a;
 
-            if (ts.getZone() != 0) {
+            if (ts.zone != 0) {
                 return new TimestampData(ts.seconds, ts.nanos);
             }
-        }
-
-        if (a instanceof TimeData) {
+        } else {
             TimeData ts = (TimeData) a;
 
-            if (ts.getZone() != 0) {
+            if (ts.zone != 0) {
                 return new TimeData(ts.seconds, ts.nanos);
             }
         }
@@ -1960,17 +1792,59 @@ public final class DateTimeType extends
         return a;
     }
 
+    public Object changeZone(Session session, Object a, String zoneString) {
+
+        TimestampData value       = (TimestampData) a;
+        long          seconds     = value.seconds + value.zone;
+        Calendar      calendar    = session.getCalendar();
+        TimeZone      zone        = TimeZone.getTimeZone(zoneString);
+        TimeZone      sessionZone = calendar.getTimeZone();
+
+        calendar.setTimeZone(zone);
+
+        seconds =
+            HsqlDateTime.convertSecondsFromCalendar(session.getCalendarGMT(),
+                calendar, seconds);
+
+        int offset = zone.getOffset(seconds * millisInSecond)
+                     / (int) millisInSecond;
+
+        calendar.setTimeZone(sessionZone);
+
+        return new TimestampData(seconds, value.nanos, offset);
+    }
+
     public Object changeZone(Session session, Object a, Type otherType,
-                             int targetZone, int localZone) {
+                             String zoneString) {
 
-        Calendar calendar = session.getCalendarGMT();
+        TimestampData value    = (TimestampData) a;
+        long          seconds  = value.seconds;
+        Calendar      calendar = session.getCalendar();
+
+        if (!zoneIDs.contains(zoneString)) {
+            throw Error.error(ErrorCode.X_22009, zoneString);
+        }
+
+        if (!otherType.isDateTimeTypeWithZone()) {
+            seconds = HsqlDateTime.convertSecondsFromCalendar(
+                session.getCalendarGMT(), calendar, seconds);
+        }
+
+        TimeZone zone   = TimeZone.getTimeZone(zoneString);
+        int      offset = getZoneSeconds(seconds, zone);
+
+        return new TimestampData(seconds, value.nanos, offset);
+    }
+
+    public Object changeZone(Session session, Object a, Type otherType,
+                             int zoneSeconds, boolean atLocal) {
 
         if (a == null) {
             return null;
         }
 
-        if (targetZone > DTIType.timezoneSecondsLimit
-                || -targetZone > DTIType.timezoneSecondsLimit) {
+        if (zoneSeconds > DTIType.timezoneSecondsLimit
+                || -zoneSeconds > DTIType.timezoneSecondsLimit) {
             throw Error.error(ErrorCode.X_22009);
         }
 
@@ -1979,38 +1853,46 @@ public final class DateTimeType extends
             case Types.SQL_TIME_WITH_TIME_ZONE : {
                 TimeData value = (TimeData) a;
 
+                if (atLocal) {
+                    zoneSeconds = session.getZoneSeconds();
+                }
+
                 if (otherType.isDateTimeTypeWithZone()) {
-                    if (value.zone != targetZone) {
-                        return new TimeData(value.getSeconds(),
-                                            value.getNanos(), targetZone);
+                    if (value.zone == zoneSeconds) {
+                        return value;
                     }
+
+                    return new TimeData(value.seconds, value.nanos,
+                                        zoneSeconds);
                 } else {
-                    int seconds = value.getSeconds() - localZone;
+                    int localZone = session.getZoneSeconds();
+                    int seconds   = value.seconds - localZone;
 
-                    seconds =
-                        (int) (HsqlDateTime.getNormalisedTime(calendar, seconds * 1000L)
-                               / 1000);
+                    seconds = toTimeSeconds(seconds);
 
-                    return new TimeData(seconds, value.getNanos(), targetZone);
+                    return new TimeData(seconds, value.nanos, zoneSeconds);
                 }
-
-                break;
             }
             case Types.SQL_TIMESTAMP_WITH_TIME_ZONE : {
-                TimestampData value   = (TimestampData) a;
-                long          seconds = value.getSeconds();
+                TimestampData value    = (TimestampData) a;
+                long          seconds  = value.seconds;
+                Calendar      calendar = session.getCalendar();
 
                 if (!otherType.isDateTimeTypeWithZone()) {
-                    seconds -= localZone;
+                    seconds = HsqlDateTime.convertSecondsFromCalendar(
+                        session.getCalendarGMT(), calendar, seconds);
                 }
 
-                if (value.getSeconds() != seconds
-                        || value.zone != targetZone) {
-                    return new TimestampData(seconds, value.getNanos(),
-                                             targetZone);
+                if (atLocal) {
+                    zoneSeconds = getZoneSeconds(seconds,
+                                                 calendar.getTimeZone());
                 }
 
-                break;
+                if (value.seconds == seconds && value.zone == zoneSeconds) {
+                    return value;
+                }
+
+                return new TimestampData(seconds, value.nanos, zoneSeconds);
             }
         }
 
@@ -2197,8 +2079,7 @@ public final class DateTimeType extends
      * The predicate "a OVERLAPS b" applies when both a and b are either period
      * names or period constructors.
      * This predicate returns True if the two periods have at least one time
-     * point in common, i.e, if a[0] < b[1] and
-     * a[1] > b[0]. This predicates is commutative: "a OVERLAPS B" must return
+     * point in common, i.e, if {@code a[0] < b[1] && a[1] > b[0]}. This predicate is commutative: "a OVERLAPS B" must return
      * the same result of "b OVERLAPS a"
      * <p>
      *
@@ -2237,8 +2118,7 @@ public final class DateTimeType extends
     /**
      * The predicate "a OVERLAPS b" applies when both a and b are rows.
      * This predicate returns True if the two periods have at least one time
-     * point in common, i.e, if a[0] < b[1] and
-     * a[1] > b[0]. This predicates is commutative: "a OVERLAPS B" must return
+     * point in common, i.e, if {@code a[0] < b[1] && a[1] > b[0]}. This predicate is commutative: "a OVERLAPS B" must return
      * the same result of "b OVERLAPS a"
      * <p>
      * Important: when this method returns, the boundaries of the periods may
@@ -2280,7 +2160,7 @@ public final class DateTimeType extends
      * The predicate "a PRECEDES b" applies when both a and b are either period
      * names or period constructors.
      * In this case, the predicate returns True if the end value of a is less
-     * than or equal to the start value of b, i.e., if ae <= as.
+     * than or equal to the start value of b, i.e., if {@code ae <= as}.
      * <p>
      *
      * @param session  The session
@@ -2373,7 +2253,7 @@ public final class DateTimeType extends
     /**
      * The predicate "x SUCCEEDS y" applies when both x and y are either period names or period constructors.
      * In this case, the predicate returns True if the start value of x is greater than or equal to the end value of y,
-     * i.e., if xs >= ye.
+     * i.e., if {@code xs >= ye}.
      * <p>
      *
      * @param session The session
@@ -2435,9 +2315,9 @@ public final class DateTimeType extends
     /**
      * The predicate "x CONTAINS y" applies when<br>
      * a) both x and y are either period names or period constructors. In this case, the predicate returns True if
-     * x contains every time point in y, i.e., if xs <= ys and xe >= ye.<br>
+     * x contains every time point in y, i.e., if {@code xs <= ys && xe >= ye}.<br>
      * b) x is either a period name or a period constructor and y is a datetime value expression. In this case, the
-     * predicate returns True if x contains y, i.e., if xs <= y and xe > y.
+     * predicate returns True if x contains y, i.e., if {@code xs <= y && xe > y}.
      * <p>
      * The <i>b</i> part of this definition is not supported yet. In order to get the same result, one have to specify
      * a period with the same date time value for the period start and end.
@@ -2468,7 +2348,7 @@ public final class DateTimeType extends
         if (compareStart <= 0 && compareEnd >= 0) {
 
             // if the end of the two period are equals, period a does not
-            // contains period b if it is defined by a single point in time
+            // contain period b if it is defined by a single point in time
             if (pointOfTime) {
                 if (compareEnd == 0) {
                     return Boolean.FALSE;
@@ -2484,8 +2364,8 @@ public final class DateTimeType extends
     public static BigDecimal subtractMonthsSpecial(Session session,
             TimestampData a, TimestampData b) {
 
-        long    s1    = (a.getSeconds() + a.getZone()) * 1000;
-        long    s2    = (b.getSeconds() + b.getZone()) * 1000;
+        long    s1    = (a.seconds + a.zone) * millisInSecond;
+        long    s2    = (b.seconds + b.zone) * millisInSecond;
         boolean minus = false;
 
         if (s1 < s2) {
@@ -2497,11 +2377,11 @@ public final class DateTimeType extends
             s2 = temp;
         }
 
-        s1 = HsqlDateTime.getNormalisedDate(session.getCalendarGMT(), s1);
-        s2 = HsqlDateTime.getNormalisedDate(session.getCalendarGMT(), s2);
-
         Calendar cal = session.getCalendarGMT();
 
+        s1 = HsqlDateTime.getNormalisedDate(cal, s1);
+        s2 = HsqlDateTime.getNormalisedDate(cal, s2);
+
         cal.setTimeInMillis(s1);
 
         int lastDay1;
@@ -2509,16 +2389,9 @@ public final class DateTimeType extends
         int day1    = cal.get(Calendar.DAY_OF_MONTH);
 
         cal.set(Calendar.DAY_OF_MONTH, 1);
-
-        long millis = cal.getTimeInMillis();
-
         cal.add(Calendar.MONTH, 1);
-
-        millis = cal.getTimeInMillis();
-
         cal.add(Calendar.DAY_OF_MONTH, -1);
 
-        millis   = cal.getTimeInMillis();
         lastDay1 = cal.get(Calendar.DAY_OF_MONTH);
 
         cal.setTimeInMillis(s2);
@@ -2528,16 +2401,9 @@ public final class DateTimeType extends
         int day2    = cal.get(Calendar.DAY_OF_MONTH);
 
         cal.set(Calendar.DAY_OF_MONTH, 1);
-
-        millis = cal.getTimeInMillis();
-
         cal.add(Calendar.MONTH, 1);
-
-        millis = cal.getTimeInMillis();
-
         cal.add(Calendar.DAY_OF_MONTH, -1);
 
-        millis   = cal.getTimeInMillis();
         lastDay2 = cal.get(Calendar.DAY_OF_MONTH);
 
         double months;
@@ -2580,7 +2446,7 @@ public final class DateTimeType extends
         Calendar calendar = session.getCalendarGMT();
         boolean  negate   = false;
 
-        if (b.getSeconds() > a.getSeconds()) {
+        if (b.seconds > a.seconds) {
             negate = true;
 
             TimestampData temp = a;
@@ -2589,12 +2455,12 @@ public final class DateTimeType extends
             b = temp;
         }
 
-        calendar.setTimeInMillis(a.getSeconds() * 1000);
+        calendar.setTimeInMillis(a.seconds * millisInSecond);
 
         int months = calendar.get(Calendar.MONTH);
         int years  = calendar.get(Calendar.YEAR);
 
-        calendar.setTimeInMillis(b.getSeconds() * 1000);
+        calendar.setTimeInMillis(b.seconds * millisInSecond);
 
         months -= calendar.get(Calendar.MONTH);
         years  -= calendar.get(Calendar.YEAR);
@@ -2621,7 +2487,7 @@ public final class DateTimeType extends
     public static TimeData addSeconds(TimeData source, long seconds,
                                       int nanos) {
 
-        nanos   += source.getNanos();
+        nanos   += source.nanos;
         seconds += nanos / limitNanoseconds;
         nanos   %= limitNanoseconds;
 
@@ -2631,34 +2497,30 @@ public final class DateTimeType extends
             seconds--;
         }
 
-        seconds += source.getSeconds();
+        seconds += source.seconds;
         seconds %= (24 * 60 * 60);
 
-        TimeData ti = new TimeData((int) seconds, nanos, source.getZone());
-
-        return ti;
+        return new TimeData((int) seconds, nanos, source.zone);
     }
 
     /* @todo - overflow */
     public static TimestampData addMonths(Session session,
                                           TimestampData source, int months) {
 
-        int      n   = source.getNanos();
+        int      n   = source.nanos;
         Calendar cal = session.getCalendarGMT();
 
-        HsqlDateTime.setTimeInMillis(cal, source.getSeconds() * 1000);
+        HsqlDateTime.setTimeInMillis(cal, source.seconds * millisInSecond);
         cal.add(Calendar.MONTH, months);
 
-        TimestampData ts = new TimestampData(cal.getTimeInMillis() / 1000, n,
-                                             source.getZone());
-
-        return ts;
+        return new TimestampData(cal.getTimeInMillis() / millisInSecond, n,
+                                 source.zone);
     }
 
     public static TimestampData addSeconds(TimestampData source, long seconds,
                                            int nanos) {
 
-        nanos   += source.getNanos();
+        nanos   += source.nanos;
         seconds += nanos / limitNanoseconds;
         nanos   %= limitNanoseconds;
 
@@ -2668,11 +2530,9 @@ public final class DateTimeType extends
             seconds--;
         }
 
-        long newSeconds = source.getSeconds() + seconds;
-        TimestampData ts = new TimestampData(newSeconds, nanos,
-                                             source.getZone());
+        long newSeconds = source.seconds + seconds;
 
-        return ts;
+        return new TimestampData(newSeconds, nanos, source.zone);
     }
 
     public static TimestampData convertToDatetimeSpecial(
@@ -2752,7 +2612,7 @@ public final class DateTimeType extends
 
         millis = HsqlDateTime.getNormalisedDate(cal, millis);
 
-        return new TimestampData(millis / 1000);
+        return new TimestampData(millis / millisInSecond);
     }
 
     public static int getDayOfWeek(String name) {
@@ -2799,4 +2659,238 @@ public final class DateTimeType extends
 
         throw Error.error(ErrorCode.X_22007, name);
     }
+
+    public static int toTimeSeconds(long seconds) {
+
+        int timeSeconds = (int) (seconds % secondsInDay);
+
+        if (timeSeconds < 0) {
+            timeSeconds += secondsInDay;
+        }
+
+        return timeSeconds;
+    }
+
+    static long toDateSeconds(long seconds) {
+
+        long timeSeconds = seconds % secondsInDay;
+
+        if (timeSeconds < 0) {
+            timeSeconds += secondsInDay;
+        }
+
+        return seconds - timeSeconds;
+    }
+
+    public static TimestampData newSysDateTimestamp() {
+
+        long millis  = System.currentTimeMillis();
+        long seconds = millis / millisInSecond;
+        int  offset  = systemTimeZone.getOffset(millis) / (int) millisInSecond;
+
+        return new TimestampData(seconds + offset);
+    }
+
+    public static TimestampData newSystemTimestampWithZone() {
+        return newCurrentTimestamp(systemTimeZone);
+    }
+
+    public static int getZoneSeconds(long utcSeconds, TimeZone zone) {
+        return zone.getOffset(utcSeconds * millisInSecond)
+               / (int) millisInSecond;
+    }
+
+    static void setTimeComponents(Calendar calendar, int seconds) {
+
+        seconds %= DTIType.secondsInDay;
+
+        calendar.clear();
+        calendar.set(Calendar.YEAR, 1970);
+        calendar.set(Calendar.MONTH, 0);
+        calendar.set(Calendar.DAY_OF_MONTH, 1);
+        setTimeComponentsOnly(calendar, seconds);
+    }
+
+    static void setTimeComponentsOnly(Calendar calendar, int seconds) {
+
+        seconds = toTimeSeconds(seconds);
+
+        calendar.set(Calendar.HOUR_OF_DAY, seconds / 3600);
+        calendar.set(Calendar.MINUTE, (seconds % 3600) / 60);
+        calendar.set(Calendar.SECOND, seconds % 60);
+    }
+
+//#ifdef JAVA8
+    public static TimestampData newCurrentTimestamp(TimeZone zone) {
+
+        Instant instant = Instant.now();
+        long    seconds = instant.getEpochSecond();
+        int     nanos   = (instant.getNano() / 1000) * 1000;
+        int zoneSeconds = zone.getOffset(seconds * millisInSecond)
+                          / (int) millisInSecond;
+
+        return new TimestampData(seconds, nanos, zoneSeconds);
+    }
+
+    public static TimestampData newSystemTimestampUTC() {
+
+        Instant instant = Instant.now();
+        long    seconds = instant.getEpochSecond();
+        int     nanos   = (instant.getNano() / 1000) * 1000;
+
+        return new TimestampData(seconds, nanos);
+    }
+
+    public static void setDateTimeComponents(Calendar calendar,
+            LocalDateTime ldt) {
+
+        calendar.clear();
+        calendar.set(Calendar.YEAR, ldt.getYear());
+        calendar.set(Calendar.MONTH, ldt.getMonthValue() - 1);
+        calendar.set(Calendar.DAY_OF_MONTH, ldt.getDayOfMonth());
+        calendar.set(Calendar.HOUR_OF_DAY, ldt.getHour());
+        calendar.set(Calendar.MINUTE, ldt.getMinute());
+        calendar.set(Calendar.SECOND, ldt.getSecond());
+    }
+
+    public static void setDateComponents(Calendar calendar, LocalDate ldt) {
+
+        calendar.clear();
+        calendar.set(Calendar.YEAR, ldt.getYear());
+        calendar.set(Calendar.MONTH, ldt.getMonthValue() - 1);
+        calendar.set(Calendar.DAY_OF_MONTH, ldt.getDayOfMonth());
+    }
+
+    public static void setTimeComponents(Calendar calendar, LocalTime ldt) {
+
+        calendar.clear();
+        calendar.set(Calendar.YEAR, 1970);
+        calendar.set(Calendar.MONTH, 0);
+        calendar.set(Calendar.DAY_OF_MONTH, 1);
+        calendar.set(Calendar.HOUR_OF_DAY, ldt.getHour());
+        calendar.set(Calendar.MINUTE, ldt.getMinute());
+        calendar.set(Calendar.SECOND, ldt.getSecond());
+    }
+
+    public Instant toInstant(SessionInterface session, TimestampData v) {
+
+        long seconds;
+
+        if (withTimeZone) {
+            seconds = v.seconds;
+        } else {
+            seconds = HsqlDateTime.convertSecondsFromCalendar(
+                session.getCalendarGMT(), session.getCalendar(), v.seconds);
+        }
+
+        return Instant.ofEpochSecond(seconds, v.nanos);
+    }
+
+    public LocalDate toLocalDate(SessionInterface session, TimestampData v) {
+
+        long     millis = (v.seconds + v.zone) * millisInSecond;
+        Calendar cal    = session.getCalendarGMT();
+
+        cal.setTimeInMillis(millis);
+
+        return LocalDate.of(cal.get(Calendar.YEAR),
+                            cal.get(Calendar.MONTH) + 1,
+                            cal.get(Calendar.DAY_OF_MONTH));
+    }
+
+    public LocalDateTime toLocalDateTime(SessionInterface session,
+                                         TimestampData v) {
+
+        long     millis = (v.seconds + v.zone) * millisInSecond;
+        int      nanos  = v.nanos;
+        Calendar cal    = session.getCalendarGMT();
+
+        cal.setTimeInMillis(millis);
+
+        return LocalDateTime.of(cal.get(Calendar.YEAR),
+                                cal.get(Calendar.MONTH) + 1,
+                                cal.get(Calendar.DAY_OF_MONTH),
+                                cal.get(Calendar.HOUR_OF_DAY),
+                                cal.get(Calendar.MINUTE),
+                                cal.get(Calendar.SECOND), nanos);
+    }
+
+    public LocalTime toLocalTime(SessionInterface session, TimeData v) {
+
+        int seconds = toTimeSeconds(v.seconds + v.zone);
+
+        return LocalTime.ofNanoOfDay(seconds * nanosInSecond + v.nanos);
+    }
+
+    public LocalTime toLocalTime(SessionInterface session, TimestampData v) {
+
+        int seconds = toTimeSeconds(v.getSeconds() + v.zone);
+
+        return LocalTime.ofNanoOfDay(seconds * nanosInSecond + v.nanos);
+    }
+
+    public OffsetTime toOffsetTime(SessionInterface session, TimeData v) {
+
+        int        zoneSeconds = withTimeZone ? v.zone
+                                              : session.getZoneSeconds();
+        ZoneOffset zone        = ZoneOffset.ofTotalSeconds(zoneSeconds);
+        LocalTime  lt          = toLocalTime(session, v);
+
+        return OffsetTime.of(lt, zone);
+    }
+
+    public OffsetTime toOffsetTime(SessionInterface session, TimestampData v) {
+
+        int        zoneSeconds = withTimeZone ? v.zone
+                                              : session.getZoneSeconds();
+        ZoneOffset zone        = ZoneOffset.ofTotalSeconds(zoneSeconds);
+        LocalTime  lt          = toLocalTime(session, v);
+
+        return OffsetTime.of(lt, zone);
+    }
+
+    public OffsetDateTime toOffsetDateTime(SessionInterface session,
+                                           TimestampData v) {
+
+        int zoneSeconds;
+
+        if (withTimeZone) {
+            zoneSeconds = v.zone;
+        } else {
+            long seconds = HsqlDateTime.convertSecondsFromCalendar(
+                session.getCalendarGMT(), session.getCalendar(), v.seconds);
+
+            zoneSeconds = getZoneSeconds(seconds,
+                                         session.getCalendar().getTimeZone());
+        }
+
+        ZoneOffset    zone = ZoneOffset.ofTotalSeconds(zoneSeconds);
+        LocalDateTime lt   = toLocalDateTime(session, v);
+
+        return OffsetDateTime.of(lt, zone);
+    }
+
+//#else
+/*
+    public static TimestampData newCurrentTimestamp(TimeZone zone) {
+
+        long millis      = System.currentTimeMillis();
+        long seconds     = millis / millisInSecond;
+        int  nanos       = (int) (millis % millisInSecond * nanosInMilli);
+        int  zoneSeconds = zone.getOffset(millis) / (int) millisInSecond;
+
+        return new TimestampData(seconds, nanos, zoneSeconds);
+    }
+
+    public static TimestampData newSystemTimestampUTC() {
+
+        long millis  = System.currentTimeMillis();
+        long seconds = millis / millisInSecond;
+        int  nanos   = (int) (millis % millisInSecond * nanosInMilli);
+
+        return new TimestampData(seconds, nanos);
+    }
+*/
+
+//#endif JAVA8
 }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/types/DTIType.java 2.7.0-1/hsqldb/src/org/hsqldb/types/DTIType.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/types/DTIType.java	2021-01-29 13:34:34.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/types/DTIType.java	2022-06-28 17:27:00.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -43,11 +43,16 @@ import org.hsqldb.lib.IntKeyIntValueHash
  * Common elements for Type instances for DATETIME and INTERVAL.<p>
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 1.9.0
  */
 public abstract class DTIType extends Type {
 
+    public static final int secondsInDay = 60 * 60 * 24;
+    public static final long millisInSecond = 1000L;
+    public static final long nanosInMilli = 1000000L;
+    public static final long nanosInSecond = 1000000000L;
+
     public static final byte[] yearToSecondSeparators       = {
         '-', '-', ' ', ':', ':', '.'
     };
@@ -71,7 +76,7 @@ public abstract class DTIType extends Ty
         1000000000, 100000000, 10000000, 1000000, 100000, 10000, 1000, 100, 10,
         1
     };
-    public static final int timezoneSecondsLimit = 14 * 60 * 60;
+    public static final int timezoneSecondsLimit = 18 * 60 * 60;
     static final int[]      intervalParts        = {
         Types.SQL_INTERVAL_YEAR, Types.SQL_INTERVAL_MONTH,
         Types.SQL_INTERVAL_DAY, Types.SQL_INTERVAL_HOUR,
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/types/IntervalType.java 2.7.0-1/hsqldb/src/org/hsqldb/types/IntervalType.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/types/IntervalType.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/types/IntervalType.java	2022-03-04 20:50:54.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -51,7 +51,7 @@ import org.hsqldb.lib.ArrayUtil;
  * Type subclass for various types of INTERVAL.<p>
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.5.1
+ * @version 2.7.0
  * @since 1.9.0
  */
 public final class IntervalType extends DTIType {
@@ -764,6 +764,19 @@ public final class IntervalType extends
         return sb.toString();
     }
 
+    public void convertToJSON(Object a, StringBuilder sb) {
+
+        if (a == null) {
+            sb.append("null");
+
+            return;
+        }
+
+        sb.append('"');
+        sb.append(convertToString(a));
+        sb.append('"');
+    }
+
     public boolean canConvertFrom(Type otherType) {
 
         if (otherType.typeCode == Types.SQL_ALL_TYPES) {
@@ -789,36 +802,36 @@ public final class IntervalType extends
     public int canMoveFrom(Type otherType) {
 
         if (otherType == this) {
-            return 0;
+            return ReType.keep;
         }
 
         if (typeCode == otherType.typeCode) {
-            return scale >= otherType.scale ? 0
-                                            : -1;
+            return scale >= otherType.scale ? ReType.keep
+                                            : ReType.change;
         }
 
         if (!otherType.isIntervalType()) {
-            return -1;
+            return ReType.change;
         }
 
         if (isYearMonth == ((IntervalType) otherType).isYearMonth) {
             if (scale < otherType.scale) {
-                return -1;
+                return ReType.change;
             }
 
             if (endPartIndex >= ((IntervalType) otherType).endPartIndex) {
                 if (precision >= otherType.precision) {
                     if (startPartIndex
                             <= ((IntervalType) otherType).startPartIndex) {
-                        return 0;
+                        return ReType.keep;
                     }
                 }
 
-                return 1;
+                return ReType.check;
             }
         }
 
-        return -1;
+        return ReType.change;
     }
 
     public int compareToTypeRange(Object o) {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/types/LongPair.java 2.7.0-1/hsqldb/src/org/hsqldb/types/LongPair.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/types/LongPair.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/types/LongPair.java	2022-02-21 14:41:50.000000000 +0000
@@ -0,0 +1,43 @@
+/* Copyright (c) 2001-2021, The HSQL Development Group
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *
+ * Redistributions of source code must retain the above copyright notice, this
+ * list of conditions and the following disclaimer.
+ *
+ * Redistributions in binary form must reproduce the above copyright notice,
+ * this list of conditions and the following disclaimer in the documentation
+ * and/or other materials provided with the distribution.
+ *
+ * Neither the name of the HSQL Development Group nor the names of its
+ * contributors may be used to endorse or promote products derived from this
+ * software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL HSQL DEVELOPMENT GROUP, HSQLDB.ORG,
+ * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+ * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+ * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+ * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+ * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+ * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+
+package org.hsqldb.types;
+
+public final class LongPair {
+
+    public long a;
+    public long b;
+
+    public LongPair(long a, long b) {
+        this.a = a;
+        this.b = b;
+    }
+}
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/types/NumberType.java 2.7.0-1/hsqldb/src/org/hsqldb/types/NumberType.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/types/NumberType.java	2021-06-11 15:07:36.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/types/NumberType.java	2022-05-22 18:01:58.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -41,14 +41,13 @@ import org.hsqldb.SessionInterface;
 import org.hsqldb.Tokens;
 import org.hsqldb.error.Error;
 import org.hsqldb.error.ErrorCode;
-import org.hsqldb.lib.java.JavaSystem;
 import org.hsqldb.map.ValuePool;
 
 /**
  * Type subclass for all NUMBER types.<p>
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.6.1
+ * @version 2.7.0
  * @since 1.9.0
  */
 public final class NumberType extends Type {
@@ -65,6 +64,7 @@ public final class NumberType extends Ty
     static final int        decimalLiteralPrecision      = 24;
 
     //
+    public static final int BIT_WIDTH      = 1;
     public static final int TINYINT_WIDTH  = 8;
     public static final int SMALLINT_WIDTH = 16;
     public static final int INTEGER_WIDTH  = 32;
@@ -1285,28 +1285,28 @@ public final class NumberType extends Ty
     public int canMoveFrom(Type otherType) {
 
         if (otherType == this) {
-            return 0;
+            return ReType.keep;
         }
 
         switch (typeCode) {
 
             case Types.TINYINT :
                 if (otherType.typeCode == Types.SQL_SMALLINT) {
-                    return 1;
+                    return ReType.check;
                 }
                 break;
 
             case Types.SQL_SMALLINT :
                 if (otherType.typeCode == typeCode
                         || otherType.typeCode == Types.TINYINT) {
-                    return 0;
+                    return ReType.keep;
                 }
                 break;
 
             case Types.SQL_INTEGER :
             case Types.SQL_BIGINT :
                 if (otherType.typeCode == typeCode) {
-                    return 0;
+                    return ReType.keep;
                 }
                 break;
 
@@ -1316,9 +1316,9 @@ public final class NumberType extends Ty
                         || otherType.typeCode == Types.SQL_NUMERIC) {
                     if (scale == otherType.scale) {
                         if (precision >= otherType.precision) {
-                            return 0;
+                            return ReType.keep;
                         } else {
-                            return 1;
+                            return ReType.check;
                         }
                     }
                 }
@@ -1330,11 +1330,11 @@ public final class NumberType extends Ty
                 if (otherType.typeCode == Types.SQL_REAL
                         || otherType.typeCode == Types.SQL_FLOAT
                         || otherType.typeCode == Types.SQL_DOUBLE) {
-                    return 0;
+                    return ReType.keep;
                 }
         }
 
-        return -1;
+        return ReType.change;
     }
 
     public int compareToTypeRange(Object o) {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/types/RowType.java 2.7.0-1/hsqldb/src/org/hsqldb/types/RowType.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/types/RowType.java	2019-05-24 13:39:04.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/types/RowType.java	2022-03-04 19:14:36.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -43,7 +43,7 @@ import org.hsqldb.error.ErrorCode;
  * Class for ROW type objects.<p>
  *
  * @author Fred Toussi (fredt@users dot sourceforge.net)
- * @version 2.4.1
+ * @version 2.7.0
  * @since 2.0.0
  */
 public class RowType extends Type {
@@ -246,6 +246,29 @@ public class RowType extends Type {
         return sb.toString();
     }
 
+    public void convertToJSON(Object a, StringBuilder sb) {
+
+        Object[] array = (Object[]) a;
+
+        if (a == null) {
+            sb.append("null");
+
+            return;
+        }
+
+        sb.append('{');
+
+        for (int i = 0; i < array.length; i++) {
+            if (i > 0) {
+                sb.append(',');
+            }
+
+            dataTypes[i].convertToJSON(array[i], sb);
+        }
+
+        sb.append('}');
+    }
+
     public boolean canConvertFrom(Type otherType) {
 
         if (otherType == null) {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/types/Type.java 2.7.0-1/hsqldb/src/org/hsqldb/types/Type.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/types/Type.java	2021-01-29 13:34:34.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/types/Type.java	2022-03-04 20:50:54.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -53,6 +53,13 @@ import org.hsqldb.rights.Grantee;
  */
 public abstract class Type implements SchemaObject, Cloneable {
 
+    public interface ReType {
+
+        int keep   = 0;     // only metadata change is required
+        int check  = 1;     // range check is also required
+        int change = -1;    // data conversion is required
+    }
+
     public static final Type[] emptyArray = new Type[]{};
 
     //
@@ -334,6 +341,19 @@ public abstract class Type implements Sc
 
     public abstract String convertToSQLString(Object a);
 
+    public void convertToJSON(Object a, StringBuilder sb) {
+
+        if (a == null) {
+            sb.append("null");
+
+            return;
+        }
+
+        String val = convertToString(a);
+
+        sb.append(val);
+    }
+
     public abstract boolean canConvertFrom(Type otherType);
 
     /**
@@ -343,10 +363,10 @@ public abstract class Type implements Sc
     public int canMoveFrom(Type otherType) {
 
         if (otherType == this) {
-            return 0;
+            return ReType.keep;
         }
 
-        return -1;
+        return ReType.change;
     }
 
     public boolean canBeAssignedFrom(Type otherType) {
@@ -631,6 +651,8 @@ public abstract class Type implements Sc
     public static final CharacterType SQL_VARCHAR_DEFAULT =
         new CharacterType(Types.SQL_VARCHAR,
                           CharacterType.defaultVarcharPrecision);
+    public static final CharacterType SQL_VARCHAR_LONG =
+        new CharacterType(Types.SQL_VARCHAR, ClobType.defaultShortClobSize);
     public static final ClobType SQL_CLOB =
         new ClobType(ClobType.defaultClobSize);
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/CodeSwitcher.java 2.7.0-1/hsqldb/src/org/hsqldb/util/CodeSwitcher.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/CodeSwitcher.java	2021-01-05 23:42:30.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/CodeSwitcher.java	2022-05-23 11:23:28.000000000 +0000
@@ -1,7 +1,7 @@
 /*
  * For work developed by the HSQL Development Group:
  *
- * Copyright (c) 2001-2021, The HSQL Development Group
+ * Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -341,7 +341,7 @@ public class CodeSwitcher {
                 if (line.startsWith("//#")) {
                     if (line.startsWith("//#ifdef ")) {
                         if (state != 0) {
-                            printError("'#ifdef' not allowed inside '#ifdef'");
+                            printError("'#ifdef' not allowed inside '#ifdef' at line " + i);
 
                             return false;
                         }
@@ -350,10 +350,10 @@ public class CodeSwitcher {
 
                         String s = line.substring(9);
 
-                        if (vSwitchOn.indexOf(s) != -1) {
+                        if (vSwitchOn.contains(s)) {
                             working   = true;
                             switchoff = false;
-                        } else if (vSwitchOff.indexOf(s) != -1) {
+                        } else if (vSwitchOff.contains(s)) {
                             working = true;
 
                             v.add(++i, "/*");
@@ -361,7 +361,7 @@ public class CodeSwitcher {
                             switchoff = true;
                         }
 
-                        if (vSwitches.indexOf(s) == -1) {
+                        if (!vSwitches.contains(s)) {
                             vSwitches.add(s);
                         }
                     } else if (line.startsWith("//#ifndef ")) {
@@ -376,10 +376,10 @@ public class CodeSwitcher {
 
                         String s = line.substring(10);
 
-                        if (vSwitchOff.indexOf(s) != -1) {
+                        if (vSwitchOff.contains(s)) {
                             working   = true;
                             switchoff = false;
-                        } else if (vSwitchOn.indexOf(s) != -1) {
+                        } else if (vSwitchOn.contains(s)) {
                             working = true;
 
                             v.add(++i, "/*");
@@ -387,7 +387,7 @@ public class CodeSwitcher {
                             switchoff = true;
                         }
 
-                        if (vSwitches.indexOf(s) == -1) {
+                        if (!vSwitches.contains(s)) {
                             vSwitches.add(s);
                         }
                     } else if (line.startsWith("//#else")) {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/CommonSwing.java 2.7.0-1/hsqldb/src/org/hsqldb/util/CommonSwing.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/CommonSwing.java	2021-01-05 22:06:14.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/CommonSwing.java	2022-05-23 11:22:28.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -56,13 +56,13 @@ import javax.swing.UIManager;
  */
 final class CommonSwing {
 
-    protected static final String messagerHeader =
+    static final String messagerHeader =
         "Database Manager Swing Error";
-    protected static final String Native = "Native";
-    protected static final String Java   = "Java";
-    protected static final String Motif  = "Motif";
-    protected static String       plaf   = "plaf";
-    protected static String       GTK    = "GTK";
+    static final String Native = "Native";
+    static final String Java   = "Java";
+    static final String Motif  = "Motif";
+    static String       plaf   = "plaf";
+    static String       GTK    = "GTK";
 
     // (ulrivo): An actual Image.
     static Image getIcon(String target) {
@@ -106,7 +106,7 @@ final class CommonSwing {
     }
 
     // (weconsultants@users: Callable errorMessage method
-    protected static void errorMessage(String errorMessage) {
+    static void errorMessage(String errorMessage) {
 
         /*
          * Display Jpanel Error messages any text Errors. Overloads
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/ConnectionDialogCommon.java 2.7.0-1/hsqldb/src/org/hsqldb/util/ConnectionDialogCommon.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/ConnectionDialogCommon.java	2021-02-09 04:50:50.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/ConnectionDialogCommon.java	2022-06-03 13:24:24.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -51,7 +51,7 @@ import java.util.Hashtable;
  * New class based on Hypersonic original
  *
  * @author Thomas Mueller (Hypersonic SQL Group)
- * @version 1.7.2
+ * @version 2.7.0
  * @since 1.7.0
  */
 final class ConnectionDialogCommon {
@@ -210,10 +210,10 @@ final class ConnectionDialogCommon {
             // reached end of file -- this is not clean but it works
         } catch (ClassNotFoundException cnfe) {
             throw new IOException("Unrecognized class type "
-                                  + cnfe.getMessage());
+                                  + cnfe.getMessage(), cnfe);
         } catch (ClassCastException cce) {
             throw new IOException("Unrecognized class type "
-                                  + cce.getMessage());
+                                  + cce.getMessage(), cce);
         } catch (Throwable t) {}
         finally {
             if (objStream != null) {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/ConnectionSetting.java 2.7.0-1/hsqldb/src/org/hsqldb/util/ConnectionSetting.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/ConnectionSetting.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/ConnectionSetting.java	2022-04-21 16:08:00.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -63,7 +63,6 @@ public class ConnectionSetting implement
 
     // Constructors
     private ConnectionSetting() {}
-    ;
 
     ConnectionSetting(String name, String driver, String url, String user,
                       String pw) {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/DataAccessPoint.java 2.7.0-1/hsqldb/src/org/hsqldb/util/DataAccessPoint.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/DataAccessPoint.java	2021-02-09 04:49:40.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/DataAccessPoint.java	2022-04-21 16:08:00.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -57,7 +57,7 @@ class DataAccessPoint implements Seriali
         tracer = t;
         helper = HelperFactory.getHelper("");
 
-        helper.set(null, t, "\'");
+        helper.set(null, t, "'");
 
         databaseToConvert = "";
     }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/DatabaseManagerCommon.java 2.7.0-1/hsqldb/src/org/hsqldb/util/DatabaseManagerCommon.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/DatabaseManagerCommon.java	2021-01-05 22:08:12.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/DatabaseManagerCommon.java	2022-04-21 16:08:00.000000000 +0000
@@ -1,7 +1,7 @@
 /*
  * For work developed by the HSQL Development Group:
  *
- * Copyright (c) 2001-2021, The HSQL Development Group
+ * Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -227,9 +227,7 @@ final class DatabaseManagerCommon {
             // drop table may fail
             try {
                 sStatement.execute(demo[i]);
-            } catch (SQLException e) {
-                ;
-            }
+            } catch (SQLException e) {}
         }
     }
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/DatabaseManager.java 2.7.0-1/hsqldb/src/org/hsqldb/util/DatabaseManager.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/DatabaseManager.java	2021-06-17 22:25:54.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/DatabaseManager.java	2022-04-21 16:08:00.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -31,7 +31,6 @@
 
 package org.hsqldb.util;
 
-import java.applet.Applet;
 import java.io.File;
 import java.io.IOException;
 import java.io.PrintWriter;
@@ -43,6 +42,7 @@ import java.sql.ResultSetMetaData;
 import java.sql.SQLException;
 import java.sql.Statement;
 import java.util.ArrayList;
+
 import java.awt.BorderLayout;
 import java.awt.Button;
 import java.awt.Color;
@@ -122,13 +122,13 @@ implements ActionListener, WindowListene
         "See the forums, mailing lists, and HSQLDB User Guide\n"
         + "at http://hsqldb.org.\n\n"
         + "Please paste the following version identifier with any\n"
-        + "problem reports or help requests:  $Revision: 6351 $"
+        + "problem reports or help requests:  $Revision: 6494 $"
         + (TT_AVAILABLE ? ""
                         : ("\n\nTransferTool classes are not in CLASSPATH.\n"
                            + "To enable the Tools menu, add 'transfer.jar' to your class path."));
-    ;
+
     private static final String ABOUT_TEXT =
-        "$Revision: 6351 $ of DatabaseManager\n\n"
+        "$Revision: 6494 $ of DatabaseManager\n\n"
         + "Copyright (c) 1995-2000, The Hypersonic SQL Group.\n"
         + "Copyright (c) 2001-2021, The HSQL Development Group.\n"
         + "http://hsqldb.org  (User Guide available at this site).\n\n\n"
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/DatabaseManagerSwing.java 2.7.0-1/hsqldb/src/org/hsqldb/util/DatabaseManagerSwing.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/DatabaseManagerSwing.java	2021-01-29 13:39:14.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/DatabaseManagerSwing.java	2022-06-03 13:24:24.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -149,7 +149,7 @@ import javax.swing.tree.TreePath;
  *
  * @author dmarshall@users
  * @author Bob Preston (sqlbob@users dot sourceforge.net)
- * @version 2.6.0
+ * @version 2.7.0
  * @since 1.7.0
  */
 public class DatabaseManagerSwing extends JFrame
@@ -195,14 +195,14 @@ implements ActionListener, WindowListene
         "See the HSQLDB Utilities Guide, forums and mailing lists \n"
         + "at http://hsqldb.org.\n\n"
         + "Please paste the following version identifier with any\n"
-        + "problem reports or help requests:  $Revision: 6271 $"
+        + "problem reports or help requests:  $Revision: 6544 $"
         + (TT_AVAILABLE ? ""
                         : ("\n\nTransferTool classes are not in CLASSPATH.\n"
                            + "To enable the Tools menu, add 'transfer.jar' "
                            + "to your class path."));
     private static final String ABOUT_TEXT =
-        "$Revision: 6271 $ of DatabaseManagerSwing\n\n"
-        + "Copyright (c) 2001-2021, The HSQL Development Group.\n"
+        "$Revision: 6544 $ of DatabaseManagerSwing\n\n"
+        + "Copyright (c) 2001-2022, The HSQL Development Group.\n"
         + "http://hsqldb.org  (Utilities Guide available at this site).\n\n\n"
         + "You may use and redistribute according to the HSQLDB\n"
         + "license documented in the source code and at the web\n"
@@ -329,6 +329,7 @@ implements ActionListener, WindowListene
     /**
      * Run with --help switch for usage instructions.
      *
+     * @param arg arguments
      * @throws IllegalArgumentException for the obvious reason
      */
     public static void main(String[] arg) {
@@ -461,9 +462,11 @@ implements ActionListener, WindowListene
     }
 
     /**
-     * This stuff is all quick, except for the refreshTree().
-     * This unit can be kicked off in main Gui thread.  The refreshTree
-     * will be backgrounded and this method will return.
+     * This stuff is all quick, except for the refreshTree(). This unit can be
+     * kicked off in main Gui thread. The refreshTree will be backgrounded and
+     * this method will return.
+     *
+     * @param c Connection
      */
     public void connect(Connection c) {
 
@@ -1999,7 +2002,7 @@ implements ActionListener, WindowListene
                         result    += " WHERE " + quoteObjectName(column);
 
                         if (isChar) {
-                            result += " LIKE \'%%\'";
+                            result += " LIKE '%%'";
                         } else {
                             result += " = ";
                         }
@@ -2037,7 +2040,7 @@ implements ActionListener, WindowListene
                         result    += " WHERE " + quoteObjectName(column);
 
                         if (isChar) {
-                            result += " LIKE \'%%\'";
+                            result += " LIKE '%%'";
                         } else {
                             result += " = ";
                         }
@@ -2087,7 +2090,7 @@ implements ActionListener, WindowListene
                     // in the string.  Makes is more obvious to the user when
                     // they need to use a string
                     if (childName.contains("CHAR")) {
-                        quote = "\'\'";
+                        quote = "''";
                     } else {
                         quote = "";
                     }
@@ -2821,7 +2824,7 @@ implements ActionListener, WindowListene
                 } catch (IOException ioe) {
                     throw new IOException("Failed to read preferences file '"
                                           + prefsFile + "':  "
-                                          + ioe.getMessage());
+                                          + ioe.getMessage(), ioe);
                 }
 
                 tmpString = props.getProperty("autoRefresh");
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/HsqldbTransferHelper.java 2.7.0-1/hsqldb/src/org/hsqldb/util/HsqldbTransferHelper.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/HsqldbTransferHelper.java	2021-02-09 04:49:14.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/HsqldbTransferHelper.java	2022-05-23 11:24:48.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -33,7 +33,6 @@ package org.hsqldb.util;
 
 import java.sql.ResultSet;
 import java.sql.ResultSetMetaData;
-import java.sql.SQLException;
 import java.sql.Types;
 
 // sqlbob@users 20020325 - patch 1.7.0 - reengineering
@@ -93,14 +92,14 @@ class HsqldbTransferHelper extends Trans
 
     String fixupColumnDefRead(String aTableName, ResultSetMetaData meta,
                               String columnType, ResultSet columnDesc,
-                              int columnIndex) throws SQLException {
+                              int columnIndex) {
         return fixupColumnDefRead((TransferTable) null, meta, columnType,
                                   columnDesc, columnIndex);
     }
 
     String fixupColumnDefWrite(String aTableName, ResultSetMetaData meta,
                                String columnType, ResultSet columnDesc,
-                               int columnIndex) throws SQLException {
+                               int columnIndex) {
         return fixupColumnDefWrite((TransferTable) null, meta, columnType,
                                    columnDesc, columnIndex);
     }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/MainInvoker.java 2.7.0-1/hsqldb/src/org/hsqldb/util/MainInvoker.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/MainInvoker.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/MainInvoker.java	2022-05-17 12:18:14.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -42,7 +42,7 @@ import java.util.ArrayList;
  *
  * @author Blaine Simpson (blaine dot simpson at admc dot com)
  * @since    HSQLDB 1.8.0
- * @version  $Revision: 6266 $, $Date: 2021-01-25 16:08:06 +0000 (Mon, 25 Jan 2021) $
+ * @version  $Revision: 6509 $, $Date: 2022-05-17 14:18:08 +0100 (Tue, 17 May 2022) $
  */
 public class MainInvoker {
 
@@ -124,6 +124,13 @@ public class MainInvoker {
 
     /**
      * Invokes the static main(String[]) method from each specified class.
+     *
+     * @param className String
+     * @param args String[]
+     * @throws ClassNotFoundException if not found
+     * @throws NoSuchMethodException if not found
+     * @throws IllegalAccessException on no access
+     * @throws InvocationTargetException on invocation failure
      */
     public static void invoke(String className,
                               String[] args)
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/McKoiTransferHelper.java 2.7.0-1/hsqldb/src/org/hsqldb/util/McKoiTransferHelper.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/McKoiTransferHelper.java	2021-02-09 04:50:32.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/McKoiTransferHelper.java	2022-05-22 18:09:56.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -33,7 +33,6 @@ package org.hsqldb.util;
 
 import java.sql.ResultSet;
 import java.sql.ResultSetMetaData;
-import java.sql.SQLException;
 
 /**
  * Helper class for conversion from a different databases
@@ -51,7 +50,7 @@ class McKoiTransferHelper extends Transf
                               String columnType, ResultSet columnDesc,
                               int columnIndex) {
 
-        String CompareString = "UNIQUEKEY(\'" + t.Stmts.sDestTable + "\'";
+        String CompareString = "UNIQUEKEY('" + t.Stmts.sDestTable + "'";
 
         if (columnType.indexOf(CompareString) > 0) {
 
@@ -71,8 +70,8 @@ class McKoiTransferHelper extends Transf
                                int columnIndex) {
 
         if (columnType.equals("SERIAL")) {
-            columnType = "INTEGER DEFAULT UNIQUEKEY (\'"
-                         + t.Stmts.sSourceTable + "\')";
+            columnType = "INTEGER DEFAULT UNIQUEKEY ('"
+                         + t.Stmts.sSourceTable + "')";
         }
 
         return (columnType);
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/OracleTransferHelper.java 2.7.0-1/hsqldb/src/org/hsqldb/util/OracleTransferHelper.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/OracleTransferHelper.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/OracleTransferHelper.java	2022-04-21 16:08:00.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -50,7 +50,7 @@ class OracleTransferHelper extends Trans
     private static final int HSQLDB = 1;
     String[][]        Funcs  = {
         {
-            "now()", "\'now\'"
+            "now()", "'now'"
         }
     };
 
@@ -155,7 +155,7 @@ class OracleTransferHelper extends Trans
             SeqName = aTableName + SeqName;
         }
 
-        String CompareString = "nextval(\'\"" + SeqName + "\"\'";
+        String CompareString = "nextval('\"" + SeqName + "\"'";
 
         if (columnType.contains(CompareString)) {
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/PostgresTransferHelper.java 2.7.0-1/hsqldb/src/org/hsqldb/util/PostgresTransferHelper.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/PostgresTransferHelper.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/PostgresTransferHelper.java	2022-04-21 16:08:00.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -51,7 +51,7 @@ class PostgresTransferHelper extends Tra
     private static final int HSQLDB     = 1;
     String[][]        Funcs      = {
         {
-            "now()", "\'now\'"
+            "now()", "'now'"
         }
     };
 
@@ -87,7 +87,7 @@ class PostgresTransferHelper extends Tra
             SeqName = t.Stmts.sDestTable + SeqName;
         }
 
-        String CompareString = "nextval(\'\"" + SeqName + "\"\'";
+        String CompareString = "nextval('\"" + SeqName + "\"'";
 
         if (columnType.contains(CompareString)) {
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/preprocessor/AntResolver.java 2.7.0-1/hsqldb/src/org/hsqldb/util/preprocessor/AntResolver.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/preprocessor/AntResolver.java	2018-10-23 07:24:30.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/preprocessor/AntResolver.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,62 +0,0 @@
-/* Copyright (c) 2001-2007, The HSQL Development Group
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions are met:
- *
- * Redistributions of source code must retain the above copyright notice, this
- * list of conditions and the following disclaimer.
- *
- * Redistributions in binary form must reproduce the above copyright notice,
- * this list of conditions and the following disclaimer in the documentation
- * and/or other materials provided with the distribution.
- *
- * Neither the name of the HSQL Development Group nor the names of its
- * contributors may be used to endorse or promote products derived from this
- * software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
- * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED. IN NO EVENT SHALL HSQL DEVELOPMENT GROUP, HSQLDB.ORG,
- * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
- * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
- * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
- * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
- * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
- * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
- * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- */
-
-
-package org.hsqldb.util.preprocessor;
-
-import java.io.File;
-import org.apache.tools.ant.Project;
-
-/* $Id: AntResolver.java 5793 2018-01-06 13:12:38Z fredt $ */
-
-/**
- * Resolves properties and paths using an ANT Project.
- *
- * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
- * @version 1.8.1
- * @since 1.8.1
- */
-class AntResolver implements IResolver {
-
-    private Project project;
-
-    /** Creates a new instance of AntResolver */
-    public AntResolver(Project project) {
-        this.project = project;
-    }
-
-    public String resolveProperties(String expression) {
-        return this.project.replaceProperties(expression);
-    }
-
-    public File resolveFile(String path) {
-        return this.project.resolveFile(path);
-    }
-}
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/preprocessor/BasicResolver.java 2.7.0-1/hsqldb/src/org/hsqldb/util/preprocessor/BasicResolver.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/preprocessor/BasicResolver.java	2018-10-23 07:24:26.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/preprocessor/BasicResolver.java	2022-04-12 08:47:16.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2007, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -34,47 +34,104 @@ package org.hsqldb.util.preprocessor;
 import java.io.File;
 import java.io.IOException;
 
-/* $Id: BasicResolver.java 5793 2018-01-06 13:12:38Z fredt $ */
-
+/*
+ * $Id: BasicResolver.java 6480 2022-04-12 09:46:56Z fredt $
+ */
 /**
  * Resolves paths using a parent directory; does not resolve properties.
  *
  * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
- * @version 1.8.1
+ * @version 2.7.0
  * @since 1.8.1
  */
-class BasicResolver implements IResolver {
-    File parentDir;
+@SuppressWarnings("ClassWithoutLogger")
+public class BasicResolver implements IResolver {
 
-    public BasicResolver(File parentDir) {
+    /**
+     * creates a new resolver rooted at the given path or its parent.
+     *
+     * @param path for resolving other abstract paths.
+     * @return a new instance.
+     * @throws IllegalArgumentException if the path is not a directory, cannot
+     *                                  be created as a directory, does not have
+     *                                  a parent and a parent cannot be created
+     *                                  as a directory, of if the file exist and
+     *                                  is not a file or a directory.
+     *
+     */
+    public static IResolver forPath(final String path) {
+        if (path == null) {
+            return new BasicResolver(null);
+        } else if (path.isEmpty()) {
+            return new BasicResolver(new File(""));
+        }
+        final File file = new File(path);
+        if (!file.exists()) {
+            if (file.mkdirs()) {
+                return new BasicResolver(file);
+            } else {
+                throw new IllegalArgumentException("could not makedirs for: "
+                        + file.getAbsolutePath());
+            }
+        } else if (file.isDirectory()) {
+            return new BasicResolver(file);
+        } else if (file.isFile()) {
+            final File parentFile = file.getParentFile();
+            if (parentFile == null) {
+                throw new IllegalArgumentException("path is not a directory"
+                        + " and has no parent: " + file.getAbsolutePath());
+            } else if (parentFile.isFile()) {
+                throw new IllegalArgumentException("parent path is a file: "
+                        + parentFile.getAbsolutePath());
+            } else if (parentFile.isDirectory()) {
+                return new BasicResolver(file);
+            } else if (parentFile.exists()) {
+                throw new IllegalArgumentException("parent path exists but"
+                        + " is not a file or directory: "
+                        + file.getAbsolutePath());
+            } else if (parentFile.mkdirs()) {
+                return new BasicResolver(parentFile);
+            } else {
+                throw new IllegalArgumentException("could not makedirs for: "
+                        + parentFile.getAbsolutePath());
+            }
+        } else {
+            throw new IllegalArgumentException("path exists but is not a file"
+                    + " or a directory: " + file.getAbsolutePath());
+        }
+    }
+
+    private final File parentDir;
+
+    public BasicResolver() {
+        this(null);
+    }
+
+    public BasicResolver(final File parentDir) {
         this.parentDir = parentDir;
     }
 
-    public String resolveProperties(String expression) {
+    @Override
+    public String resolveProperties(final String expression) {
         return expression;
     }
-    public File resolveFile(String path) {
-        File file = new File(path);
 
-        if (parentDir != null && !file.isAbsolute()) {
+    @Override
+    public File resolveFile(final String path) {
+        final File dir = this.parentDir;
+        final String actualPath = path == null || path.isEmpty() ? "" : path;
+        File file = new File(actualPath);
+        if (dir != null && !file.isAbsolute()) {
             try {
-                path = this.parentDir.getCanonicalPath()
-                       + File.separatorChar
-                       + path;
-
-                file = new File(path);
+                file = new File(dir.getCanonicalFile(), file.getPath());
             } catch (IOException ex) {
-                path = this.parentDir.getAbsolutePath()
-                       + File.separatorChar
-                       + path;
-
-                file = new File(path);
+                file = new File(dir.getAbsoluteFile(), file.getPath());
             }
         }
 
         try {
             return file.getCanonicalFile();
-        } catch (Exception e) {
+        } catch (IOException e) {
             return file.getAbsoluteFile();
         }
     }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/preprocessor/Defines.java 2.7.0-1/hsqldb/src/org/hsqldb/util/preprocessor/Defines.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/preprocessor/Defines.java	2018-10-23 07:24:26.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/preprocessor/Defines.java	2022-06-08 10:09:08.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2007, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -31,118 +31,161 @@
 
 package org.hsqldb.util.preprocessor;
 
-import java.util.Hashtable;
-
-/* $Id: Defines.java 5793 2018-01-06 13:12:38Z fredt $ */
+import java.util.HashMap;
+import java.util.Map;
 
+/*
+ * $Id: Defines.java 6550 2022-06-08 11:09:08Z fredt $
+ */
 /**
- * Simple preprocessor symbol table.
+ * A simple Preprocessor symbol table.
  *
  * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
- * @version 1.8.1
+ * @version 2.7.0
  * @since 1.8.1
  */
-class Defines {
-    private Hashtable symbols = new Hashtable();
+@SuppressWarnings("ClassWithoutLogger")
+public class Defines {
 
-    public Defines() {}
+    private final Map<String, Object> symbols;
 
-    public Defines(String csvExpressions) throws PreprocessorException {
-        defineCSV(csvExpressions);
+    /**
+     * Constructs a new, empty instance.
+     */
+    public Defines() {
+        this.symbols = new HashMap<>(16);
+    }
+
+    /**
+     * Constructs a new instance initially defined using the comma-separated
+     * list of Preprocessor expressions.
+     *
+     * @param csvExpressions a comma-separated list of Preprocessor expressions;
+     *                       may be {@code null} or empty, in which case no
+     *                       symbols are added.
+     * @throws PreprocessorException if the given list contains an illegal
+     *                               expression.
+     * @see #defineCSV(String)
+     */
+    public Defines(final String csvExpressions) throws PreprocessorException {
+        this();
+        if (csvExpressions != null && !csvExpressions.isEmpty()) {
+            final Defines target = this;
+            target.defineCSV(csvExpressions);
+        }
     }
 
+    /**
+     * removes all defined symbols.
+     */
     public void clear() {
         this.symbols.clear();
     }
 
-    public void defineCSV(String csvExpressions)
-    throws PreprocessorException {
-        if (csvExpressions != null) {
-            csvExpressions = csvExpressions + ',';
-
-            int start = 0;
-            int len   = csvExpressions.length();
-
-            while (start < len) {
-                int    end  = csvExpressions.indexOf(',', start);
-                String expr = csvExpressions.substring(start, end).trim();
-
-                if (expr.length() > 0) {
-                    defineSingle(expr);
-                }
-
-                start = end + 1;
-            }
+    /**
+     * adds the given comma-separated list of Preprocessor expressions to the
+     * symbol table.
+     *
+     * @param csvExpressions a comma-separated list of Preprocessor expressions;
+     *                       may be {@code null} or empty, in which case no
+     *                       symbols are added.
+     * @throws PreprocessorException if the given list contains an illegal
+     *                               expression.
+     */
+    public void defineCSV(final String csvExpressions)
+            throws PreprocessorException {
+        if (csvExpressions == null || csvExpressions.isEmpty()) {
+            return;
+        }
+        final String tce = csvExpressions.trim() + ',';
+        int start = 0;
+        int len = tce.length();
+        while (start < len) {
+            final int end = tce.indexOf(',', start);
+            final String expr = tce.substring(start, end).trim();
+            if (!expr.isEmpty()) {
+                defineSingle(expr);
+            }
+            start = end + 1;
         }
     }
 
-    public void defineSingle(String expression) throws PreprocessorException {
-        Tokenizer tokenizer = new Tokenizer(expression);
-
+    /**
+     * adds a single Preprocessor expression to the symbol table.
+     *
+     * @param expression to add; may be {@code null} or empty, in which case no
+     *                   action is taken.
+     * @throws PreprocessorException if the given expression is illegal or has
+     *                               trailing tokens.
+     */
+    public void defineSingle(final String expression) throws PreprocessorException {
+        if (expression == null || expression.isEmpty()) {
+            return;
+        }
+        final Tokenizer tokenizer = new Tokenizer(expression);
         tokenizer.next();
-
         if (!tokenizer.isToken(Token.IDENT)) {
             throw new PreprocessorException("IDENT token required at position: "
                     + tokenizer.getStartIndex()
                     + " in ["
-                    + expression +
-                    "]"); // NOI18N
+                    + expression
+                    + "]"); // NOI18N
         }
 
-        String ident = tokenizer.getIdent();
+        final String ident = tokenizer.getIdent();
 
         int tokenType = tokenizer.next();
 
-        switch(tokenType) {
-            case Token.EOI : {
+        switch (tokenType) {
+            case Token.EOI: {
                 this.symbols.put(ident, ident);
                 return;
             }
-            case Token.ASSIGN : {
+            case Token.ASSIGN: {
                 tokenType = tokenizer.next();
                 break;
             }
-            default : {
+            default: {
                 break;
             }
         }
 
-        switch(tokenType) {
-            case Token.NUMBER : {
-                Number number = tokenizer.getNumber();
+        switch (tokenType) {
+            case Token.NUMBER: {
+                final Number number = tokenizer.getNumber();
 
                 this.symbols.put(ident, number);
 
                 break;
             }
-            case Token.STRING : {
-                String string = tokenizer.getString();
+            case Token.STRING: {
+                final String string = tokenizer.getString();
 
                 this.symbols.put(ident, string);
 
                 break;
             }
-            case Token.IDENT : {
-                String rhsIdent = tokenizer.getIdent();
+            case Token.IDENT: {
+                final String rhsIdent = tokenizer.getIdent();
 
                 if (!isDefined(rhsIdent)) {
-                    throw new PreprocessorException("Right hand side" +
-                            "IDENT token [" + rhsIdent + "] at position: "
+                    throw new PreprocessorException("Right hand side"
+                            + "IDENT token [" + rhsIdent + "] at position: "
                             + tokenizer.getStartIndex()
                             + " is undefined in ["
                             + expression
                             + "]"); // NOI18N
                 }
 
-                Object value = this.symbols.get(rhsIdent);
+                final Object value = this.symbols.get(rhsIdent);
 
                 symbols.put(ident, value);
                 break;
             }
-            default : {
+            default: {
                 throw new PreprocessorException("Right hand side NUMBER,"
-                        + "STRING or IDENT token required at position: " +
-                        + tokenizer.getStartIndex()
+                        + "STRING or IDENT token required at position: "
+                        + +tokenizer.getStartIndex()
                         + " in ["
                         + expression
                         + "]"); // NOI18N
@@ -161,26 +204,32 @@ class Defines {
         }
     }
 
-    public void undefine(String symbol) {
+    public void undefine(final String symbol) {
         this.symbols.remove(symbol);
     }
 
-    public boolean isDefined(String symbol) {
-        return this.symbols.containsKey(symbol);
+    public boolean isDefined(final String symbol) {
+        return symbol == null || symbol.isEmpty()
+                ? false
+                : this.symbols.containsKey(symbol);
     }
 
-    public Object getDefintion(String symbol) {
-        return this.symbols.get(symbol);
+    public Object getDefintion(final String symbol) {
+        return symbol == null || symbol.isEmpty()
+                ? null
+                : this.symbols.get(symbol);
     }
 
-    public boolean evaluate(String expression) throws PreprocessorException {
-        Tokenizer tokenizer = new Tokenizer(expression);
+    public boolean evaluate(final String expression) throws PreprocessorException {
+        if (expression == null || expression.isEmpty()) {
+            return false;
+        }
+        final Tokenizer tokenizer = new Tokenizer(expression);
 
         tokenizer.next();
 
-        Parser parser = new Parser(this, tokenizer);
-
-        boolean result = parser.parseExpression();
+        final Parser parser = new Parser(this, tokenizer);
+        final boolean result = parser.parseExpression();
 
         if (!tokenizer.isToken(Token.EOI)) {
             throw new PreprocessorException("Illegal trailing "
@@ -194,6 +243,7 @@ class Defines {
         return result;
     }
 
+    @Override
     public String toString() {
         return super.toString() + this.symbols.toString();
     }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/preprocessor/Document.java 2.7.0-1/hsqldb/src/org/hsqldb/util/preprocessor/Document.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/preprocessor/Document.java	2018-10-23 07:24:30.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/preprocessor/Document.java	2022-06-08 10:09:08.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2007, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -42,165 +42,354 @@ import java.io.InputStreamReader;
 import java.io.OutputStream;
 import java.io.OutputStreamWriter;
 import java.io.Reader;
-import java.io.UnsupportedEncodingException;
 import java.io.Writer;
-import java.util.Vector;
-
-/* $Id: Document.java 5793 2018-01-06 13:12:38Z fredt $ */
+import java.nio.charset.Charset;
+import java.util.ArrayList;
+import java.util.List;
 
+/*
+ * $Id: Document.java 6550 2022-06-08 11:09:08Z fredt $
+ */
 /**
  * Simple line-oriented text document ADT.
  *
  * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
- * @version 1.8.1
+ * @version 2.7.0
  * @since 1.8.1
  */
-class Document {
-    Vector lines = new Vector();
+@SuppressWarnings("ClassWithoutLogger")
+public class Document {
 
-    Document() {}
-
-    Document(Document source) {
-        this.appendDocument(source);
+    /**
+     * for the given character set name.
+     *
+     * @param charsetName to test; {@code null} returns {@code false}.
+     * @return {@code true} if supported, else {@code false}.
+     */
+    public static boolean isSupportedCharset(final String charsetName) {
+        return charsetName != null
+                && !charsetName.trim().isEmpty()
+                && Charset.isSupported(charsetName);
+    }
+
+    private final List<String> lines;
+
+    /**
+     * constructs a new, empty instance.
+     */
+    public Document() {
+        this.lines = new ArrayList<>(16);
+    }
+
+    /**
+     * Constructs a new instance that is effectively a copy of {@code source}.
+     *
+     * @param source to copy; may be {@code null}, which is treated like an
+     *               {@code empty} instance.
+     */
+    public Document(final Document source) {
+        this();
+        if (source != null) {
+            final Document target = this;
+            target.appendDocument(source);
+        }
     }
 
-    Document addSouceLine(String line) {
+    /**
+     * to this instance.
+     *
+     * @param line to add; must not be {@code null}.
+     * @return this instance.
+     * @throws IllegalArgumentException if {@code line} is {@code null}.
+     */
+    public Document addSouceLine(final String line) {
         if (line == null) {
             throw new IllegalArgumentException("line: null");
         }
-
-        this.lines.addElement(line);
-
+        this.lines.add(line);
         return this;
     }
 
-    Document appendDocument(Document doc) {
-        if (doc != null) {
-            int    count = doc.size();
-            Vector src   = doc.lines;
-            Vector dst   = this.lines;
-
-            for (int i = 0; i < count; i++) {
-                dst.addElement(src.elementAt(i));
-            }
+    /**
+     * to this instance.
+     *
+     * @param source to append; may be {@code null}, which is treated like an
+     *               {@code empty} instance.
+     * @return this instance
+     */
+    @SuppressWarnings("AccessingNonPublicFieldOfAnotherObject")
+    public Document appendDocument(final Document source) {
+        if (source != null && source.size() > 0) {
+            this.lines.addAll(source.lines);
         }
-
         return this;
     }
 
-    Document clear() {
-        this.lines.removeAllElements();
-
+    /**
+     * this instance, making it {@link #isEmpty() empty}.
+     *
+     * @return this instance.
+     */
+    public Document clear() {
+        this.lines.clear();
         return this;
     }
 
-    boolean contains(String pattern) {
-        Vector lines = this.lines;
-        int    size  = lines.size();
-
+    /**
+     * if at least one line in this instance contains the given sequence.
+     * <p>
+     * <b>Note</b>: each line is tested separately; no test is performed to see
+     * if the sequence spans more than one line.
+     * </p>
+     *
+     * @param sequence to test.
+     * @return {@code true} if the condition holds, else {@code false}.
+     */
+    public boolean contains(final CharSequence sequence) {
+        if (sequence == null) {
+            return false;
+        }
+        final String toFind = sequence.toString();
+        final List<String> list = this.lines;
+        final int size = list.size();
         for (int i = 0; i < size; i++) {
-            if (((String)lines.elementAt(i)).indexOf(pattern) >= 0) {
+            if (-1 < list.get(i).indexOf(toFind, 0)) {
                 return true;
             }
         }
-
         return false;
     }
 
-    Document deleteSourceLine(int index) {
-        this.lines.removeElementAt(index);
-
+    /**
+     * from this instance at the given index.
+     *
+     * @param index at which to remove a line.
+     * @return this instance.
+     * @throws IndexOutOfBoundsException if the index is out of range
+     *                                   ({@code index < 0 || index >= size())}
+     */
+    public Document deleteSourceLine(final int index) {
+        this.lines.remove(index);
         return this;
     }
 
-    public boolean equals(Object o) {
-        if (this == o) {
-            return true;
-        } else if (o instanceof Document) {
-            Document other = (Document) o;
-
-            Vector v1 = this.lines;
-            Vector v2 = other.lines;
-
-            if (v1.size() != v2.size()) {
-                return false;
-            }
-
-            for (int i = v1.size() - 1; i >= 0; i--) {
-                if (v1.elementAt(i).equals(v2.elementAt(i))) {
-                    continue;
-                } else {
-                    return false;
-                }
-            }
-
-            return true;
-        } else {
-            return false;
-        }
-    }
-
-    String getSourceLine(int index) {
-        return (String) this.lines.elementAt(index);
-    }
-
-    Document insertSourceLine(int index, String line) {
+    /**
+     * if the given document has effectively the same content as this instance.
+     *
+     * @param document to test; may be {@code null}, which is treated as
+     *                 {@link #isEmpty() empty}.
+     * @return {@code true} if the content of the given {@code document} is
+     *         equal to the content of this instance, as per
+     *         {@link List#equals(Object)}.
+     */
+    @SuppressWarnings("AccessingNonPublicFieldOfAnotherObject")
+    public boolean contentEquals(final Document document) {
+        return (document == this)
+                ? true
+                : document == null
+                        ? this.isEmpty()
+                        : this.lines.equals(document.lines);
+    }
+
+    /**
+     * at the given index.
+     *
+     * @param index at which to retrieve the line.
+     * @return the line at the given index.
+     * @throws IndexOutOfBoundsException if the index is out of range
+     *                                   ({@code index < 0 || index >= size()})
+     */
+    public String getSourceLine(final int index) {
+        return this.lines.get(index);
+    }
+
+    /**
+     * if this instance contains no lines.
+     *
+     * @return {@code true} if {@link #size()} {@code == 0}, else {@code false}.
+     */
+    public boolean isEmpty() {
+        return this.lines.isEmpty();
+    }
+
+    /**
+     * at the specified index.
+     *
+     * @param index at which the specified line is to be inserted
+     * @param line  to be inserted
+     * @return this instance
+     * @throws NullPointerException      if the specified line is {@code null}.
+     * @throws IndexOutOfBoundsException if the index is out of range
+     *                                   ({@code index < 0 || index >= size()})
+     */
+    public Document insertSourceLine(final int index, final String line) {
         if (line == null) {
             throw new IllegalArgumentException("line: null");
         }
-
-        this.lines.insertElementAt(line, index);
-
+        this.lines.add(index, line);
         return this;
     }
 
-    Document replaceWith(Document source) {
+    /**
+     * as if by invoking {@code this.clear().appendDocument(source)}.
+     *
+     * @param source content used to replace the existing content of this
+     *               instance; may be {@code null}, which is treated as
+     *               {@link #isEmpty() empty}.
+     * @return this instance.
+     */
+    public Document replaceWith(final Document source) {
         return this.clear().appendDocument(source);
     }
 
-    Document setSourceLine(int index, String line) {
+    /**
+     * at the specified index in this instance.
+     *
+     * @param index index of the line to replace
+     * @param line  to be stored at the specified index
+     * @return this instance.
+     * @throws NullPointerException      if the specified line is {@code null}.
+     * @throws IndexOutOfBoundsException if the index is out of range
+     *                                   ({@code index < 0 || index >= size()})
+     */
+    public Document setSourceLine(final int index, final String line) {
         if (line == null) {
             throw new IllegalArgumentException("null");
         }
-
-        this.lines.setElementAt(line, index);
-
+        this.lines.set(index, line);
         return this;
     }
 
-    int size() {
+    /**
+     * of this instance, as the number of lines.
+     *
+     * @return the number of lines in this instance.
+     */
+    public int size() {
         return this.lines.size();
     }
 
 // ------------------------ I/O convenience methods ----------------------------
-
-    Document load(Object source, String encoding) throws IOException,
-            UnsupportedEncodingException{
+    /**
+     * this instance from the given input stream using the given character
+     * encoding.
+     * <p>
+     * <b>Note</b>: it is the responsibility of the caller to close the input
+     * stream.
+     * </p>
+     *
+     * @param inputStream from which to load; must not be {@code null}.
+     * @param encoding    {@code null} for the system default.
+     * @return this object.
+     * @throws IOException              if an I/O error occurs.
+     * @throws IllegalArgumentException if the encoding is not supported.
+     * @throws NullPointerException     if the inputStream is {@code null}.
+     */
+    public Document load(final InputStream inputStream, final String encoding) throws IOException,
+            IllegalArgumentException, NullPointerException {
+        return load((Object) inputStream, encoding);
+    }
+
+    /**
+     * this instance from the given reader.
+     * <p>
+     * <b>Note</b>: it is the responsibility of the caller to close the reader.
+     * </p>
+     *
+     * @param reader from which to load; must not be {@code null}.
+     * @return this object.
+     * @throws IOException          in an I/O error occurs.
+     * @throws NullPointerException if the reader is {@code null}.
+     */
+    public Document load(final Reader reader) throws IOException,
+            NullPointerException {
+        return load(reader, null);
+    }
+
+    /**
+     * this instance from the given file using the given character encoding.
+     * <p>
+     * <b>Note</b>: the underlying file input stream is closed automatically.
+     * </p>
+     *
+     * @param file     from which to load; {@code null} is treated the empty
+     *                 path.
+     * @param encoding {@code null} for the system default.
+     * @return this object.
+     * @throws IOException              in an I/O error occurs.
+     * @throws IllegalArgumentException if the encoding is not supported.
+     */
+    public Document load(final File file, final String encoding) throws IOException,
+            IllegalArgumentException {
+        return load((Object) (file == null ? new File("") : file), encoding);
+    }
+
+    /**
+     * this instance from the given abstract file path using the given character
+     * encoding.
+     * <p>
+     * <b>Note</b>: the underlying file input stream is closed automatically.
+     * </p>
+     *
+     * @param path     from which to load; {@code null} is treated the empty
+     *                 path.
+     * @param encoding {@code null} for the system default.
+     * @return this object.
+     * @throws IOException              in an I/O error occurs.
+     * @throws IllegalArgumentException if the encoding is not supported.
+     */
+    public Document load(final String path, final String encoding) throws IOException,
+            IllegalArgumentException {
+        return load((Object) (path == null ? "" : path), encoding);
+    }
+
+    /**
+     * this instance from the given source.
+     * <p>
+     * <b>Note</b>: if the source is an InputStream or Reader, it is the
+     * responsibility of the caller to close; otherwise, the underlying file
+     * input stream is closed automatically.
+     * </p>
+     *
+     * @param source   required; by default, must be an instance of an
+     *                 InputStream, Reader, File, or String denoting an
+     *                 abstract file path.
+     * @param encoding optional; ignored if source is a Writer. {@code null} is
+     *                 taken to be {@link Charset#defaultCharset()}.
+     * @return this instance.
+     * @throws IOException              if an I/O error occurs.
+     * @throws NullPointerException     if source is {@code null}.
+     * @throws IllegalArgumentException if the encoding is not supported.
+     */
+    @SuppressWarnings("NestedAssignment")
+    protected Document load(final Object source, final String encoding) throws IOException,
+            NullPointerException,
+            IllegalArgumentException {
+        if (source == null) {
+            throw new NullPointerException("source must not be null.");
+        }
+        Charset charset = (source instanceof Reader || encoding == null)
+                ? Charset.defaultCharset() : null;
+        if (charset == null && isSupportedCharset(encoding)) {
+            charset = Charset.forName(encoding);
+        } else {
+            throw new IllegalArgumentException("encoding: " + encoding);
+        }
         BufferedReader reader = null;
-        boolean        close  = false;
-
+        boolean close = false;
         if (source instanceof InputStream) {
-            InputStream       is  = (InputStream) source;
-            InputStreamReader isr = isEncoding(encoding)
-                    ? new InputStreamReader(is, encoding)
-                    : new InputStreamReader(is);
-
+            final InputStream is = (InputStream) source;
+            final InputStreamReader isr = new InputStreamReader(is, charset);
             reader = new BufferedReader(isr);
         } else if (source instanceof File) {
-            InputStream       is  = new FileInputStream((File) source);
-            InputStreamReader isr = isEncoding(encoding)
-                    ? new InputStreamReader(is, encoding)
-                    : new InputStreamReader(is);
-
-            close  = true;
+            final InputStream fis = new FileInputStream((File) source);
+            final InputStreamReader isr = new InputStreamReader(fis, charset);
+            close = true;
             reader = new BufferedReader(isr);
         } else if (source instanceof String) {
-            InputStream       is  = new FileInputStream((String) source);
-            InputStreamReader isr = isEncoding(encoding)
-                    ? new InputStreamReader(is, encoding)
-                    : new InputStreamReader(is);
-
-            close  = true;
+            final InputStream fis = new FileInputStream((String) source);
+            final InputStreamReader isr = new InputStreamReader(fis, charset);
+            close = true;
             reader = new BufferedReader(isr);
         } else if (source instanceof BufferedReader) {
             reader = (BufferedReader) source;
@@ -209,84 +398,154 @@ class Document {
         } else {
             throw new IOException("unhandled load source: " + source); // NOI18N
         }
-
         clear();
-
         String line;
-        Vector lines = this.lines;
-
+        final List<String> list = this.lines;
         try {
-            while(null != (line = reader.readLine())) {
-                lines.addElement(line);
+            while (null != (line = reader.readLine())) {
+                list.add(line);
             }
         } finally {
             if (close) {
                 try {
                     reader.close();
-                } catch (IOException ex) {}
+                } catch (IOException ex) {
+                }
             }
         }
-
         return this;
     }
 
-    Document save(Object target, String encoding) throws IOException {
+    /**
+     * to the given output stream using the given character encoding.
+     * <p>
+     * <b>Note</b>: it is the responsibility of the caller to close the output
+     * stream.
+     * </p>
+     *
+     * @param outputStream to which to save; must not be {@code null}.
+     * @param encoding     {@code null} for the system default.
+     * @return this object.
+     * @throws IOException              if an I/O error occurs.
+     * @throws IllegalArgumentException if the encoding is not supported.
+     * @throws NullPointerException     if the output stream is {@code null}.
+     */
+    public Document save(final OutputStream outputStream, final String encoding) throws IOException {
+        return save((Object) outputStream, encoding);
+    }
+
+    /**
+     * to the given file using the given character encoding.
+     *
+     * @param file     to which to save; {@code null} is treated as having an
+     *                 empty path
+     * @param encoding {@code null} for the system default.
+     * @return this object.
+     * @throws IOException              if an I/O error occurs.
+     * @throws IllegalArgumentException if the encoding is not supported.
+     */
+    public Document save(final File file, final String encoding) throws IOException,
+            IllegalArgumentException {
+        return save((Object) (file == null ? new File("") : file), encoding);
+    }
+
+    /**
+     * to the given abstract file path using the given character encoding.
+     *
+     * @param path     to which to save; {@code null} is treated as the empty
+     *                 path;
+     * @param encoding {@code null} for the system default.
+     * @return this object.
+     * @throws IOException              if an I/O error occurs.
+     * @throws IllegalArgumentException if the encoding is not supported.
+     */
+    public Document save(final String path, final String encoding) throws IOException,
+            IllegalArgumentException {
+        return save((Object) (path == null ? "" : path), encoding);
+    }
+
+    /**
+     * to the given writer.
+     * <p>
+     * <b>Note</b>: it is the responsibility of the caller to close the writer.
+     * </p>
+     *
+     * @param writer to which to save; must not be {@code null}.
+     * @return this object.
+     * @throws IOException          if an I/O error occurs.
+     * @throws NullPointerException if the writer is {@code null}.
+     */
+    public Document save(final Writer writer) throws IOException {
+        return save(writer, null);
+    }
+
+    /**
+     * this instance to the given target.
+     * <p>
+     * <b>Note</b>: if the target is an OutputStream or Writer, it is the
+     * responsibility of the caller to close; otherwise, the underlying file
+     * output stream is closed automatically.
+     * </p>
+     *
+     * @param target   required; by default, must be an instance of an
+     *                 OutputStream, Writer, File, or String denoting an
+     *                 abstract file path.
+     * @param encoding optional; does not apply to Writer. {@code null} is taken
+     *                 to be {@link Charset#defaultCharset()}.
+     * @return this instance.
+     * @throws IOException          if an I/O error occurs.
+     * @throws NullPointerException if target is {@code null}.
+     */
+    protected Document save(final Object target, final String encoding) throws IOException {
+        if (target == null) {
+            throw new NullPointerException("target must not be null.");
+        }
+        Charset charset = (target instanceof Writer || encoding == null)
+                ? Charset.defaultCharset() : null;
+        if (charset == null && isSupportedCharset(encoding)) {
+            charset = Charset.forName(encoding);
+        } else {
+            throw new IllegalArgumentException("encoding: " + encoding);
+        }
         BufferedWriter writer = null;
-        boolean        close  = false;
-
+        boolean close = false;
         if (target instanceof OutputStream) {
-            OutputStream       os  = (OutputStream) target;
-            OutputStreamWriter osr = isEncoding(encoding)
-                    ? new OutputStreamWriter(os, encoding)
-                    : new OutputStreamWriter(os);
-
-            writer = new BufferedWriter(osr);
+            final OutputStream os = (OutputStream) target;
+            final OutputStreamWriter osw = new OutputStreamWriter(os, charset);
+            writer = new BufferedWriter(osw);
         } else if (target instanceof File) {
-            OutputStream       os  = new FileOutputStream((File) target);
-            OutputStreamWriter osr = isEncoding(encoding)
-                    ? new OutputStreamWriter(os, encoding)
-                    : new OutputStreamWriter(os);
-
-            close  = true;
-            writer = new BufferedWriter(osr);
+            final OutputStream fos = new FileOutputStream((File) target);
+            final OutputStreamWriter osw = new OutputStreamWriter(fos, charset);
+            close = true;
+            writer = new BufferedWriter(osw);
         } else if (target instanceof String) {
-            OutputStream       os  = new FileOutputStream((String) target);
-            OutputStreamWriter osr = isEncoding(encoding)
-                    ? new OutputStreamWriter(os, encoding)
-                    : new OutputStreamWriter(os);
-
-            close  = true;
-            writer = new BufferedWriter(osr);
+            OutputStream fos = new FileOutputStream((String) target);
+            final OutputStreamWriter osw = new OutputStreamWriter(fos, charset);
+            close = true;
+            writer = new BufferedWriter(osw);
         } else if (target instanceof BufferedWriter) {
             writer = (BufferedWriter) target;
         } else if (target instanceof Writer) {
             writer = new BufferedWriter(writer);
         } else {
-            throw new IOException("unhandled save target: " + target); // NOI18N
+            throw new IOException("unhandled save target: " + target);
         }
-
-        Vector lines = this.lines;
-        int    count = lines.size();
-
+        final List<String> list = this.lines;
+        final int count = list.size();
         try {
             for (int i = 0; i < count; i++) {
-                writer.write((String)lines.elementAt(i));
+                writer.write(list.get(i));
                 writer.newLine();
             }
-
             writer.flush();
         } finally {
             if (close) {
                 try {
                     writer.close();
-                } catch (IOException ex) {}
+                } catch (IOException ignored) {
+                }
             }
         }
-
         return this;
     }
-
-    static boolean isEncoding(String enc) {
-        return enc != null && enc.trim().length() > 0;
-    }
 }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/preprocessor/Line.java 2.7.0-1/hsqldb/src/org/hsqldb/util/preprocessor/Line.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/preprocessor/Line.java	2018-10-23 07:24:26.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/preprocessor/Line.java	2022-04-12 08:47:16.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2007, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -31,30 +31,48 @@
 
 package org.hsqldb.util.preprocessor;
 
-/* $Id: Line.java 5793 2018-01-06 13:12:38Z fredt $ */
-
+/*
+ * $Id: Line.java 6480 2022-04-12 09:46:56Z fredt $
+ */
 /**
- * Preprocessor's view of a line in a text document.
+ * Preprocessor view of a line in a text document.
  *
  * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
- * @version 1.8.1
+ * @version 2.7.0
  * @since 1.8.1
  */
-class Line  {
-    static final String DIRECTIVE_PREFIX = "//#";
-    static final String SPACE_CHARS = " \t";
-    static final int    DIRECTIVE_PREFIX_LENGTH = DIRECTIVE_PREFIX.length();
-    static final int    DIRECTIVE_PREFIX_LENGTH_PLUS_ONE =
-            DIRECTIVE_PREFIX_LENGTH + 1;
-    static final String HIDE_DIRECTIVE = DIRECTIVE_PREFIX + ' ';
-
-    int    type;
-    String sourceText;
-    String indent;
-    String text;
-    String arguments;
+public class Line {
 
-    static int indexOfNonTabOrSpace(String line) {
+    /**
+     * Is {@code "//#"}.
+     */
+    public static final String DIRECTIVE_PREFIX = "//#";
+    /**
+     * Is {@code " \t"}.
+     */
+    public static final String SPACE_CHARS = " \t";
+    /**
+     * Is {@code 3}.
+     */
+    public static final int DIRECTIVE_PREFIX_LENGTH = DIRECTIVE_PREFIX.length();
+    /**
+     * Is {@code 4}.
+     */
+    private static final int DIRECTIVE_PREFIX_LENGTH_PLUS_ONE
+            = DIRECTIVE_PREFIX_LENGTH + 1;
+    /**
+     * Id {@code ' '}.
+     */
+    public static final String HIDE_DIRECTIVE = DIRECTIVE_PREFIX + ' ';
+
+    /**
+     * in the given line.
+     *
+     * @param line to inspect
+     * @return the first index of any non-tab or non-space character.
+     * @throws NullPointerException if line is {@code null}.
+     */
+    public static int indexOfNonTabOrSpace(final String line) {
         int pos = 0;
         int len = line.length();
 
@@ -72,92 +90,144 @@ class Line  {
         return pos;
     }
 
-    static int indexOfTabOrSpace(String s, int fromIndex) {
-        int spos = s.indexOf(' ', fromIndex);
-        int tpos = s.indexOf('\t', fromIndex);
+    /**
+     * in the given, generic string.
+     *
+     * @param string    to inspect
+     * @param fromIndex at which to start the inspection; There is no
+     *                  restriction on the value . If it is negative, it has the
+     *                  same effect as if it were zero: the entire string may be
+     *                  searched. If it is greater than the length of the string,
+     *                  it has the same effect as if it were equal to the length
+     *                  of string: {@code  -1} is returned.
+     * @return the first index of either a tab ort a space character; {@code -1}
+     *         if no such characters are found.
+     * @throws NullPointerException if string is {@code null}.
+     */
+    public static int indexOfTabOrSpace(final String string, final int fromIndex) {
+        final int spos = string.indexOf(' ', fromIndex);
+        final int tpos = string.indexOf('\t', fromIndex);
 
         return (((tpos != -1) && (tpos < spos)) || (spos == -1)) ? tpos : spos;
     }
 
-    Line(String line) throws PreprocessorException {
-        setSourceText(line);
+    private int type;
+    private String sourceText;
+    private String indent;
+    private String text;
+    private String arguments;
+
+    /**
+     * Constructs a new instance from the given line.
+     *
+     * @param line in a Document being Preprocessed.
+     * @throws PreprocessorException
+     * @throws NullPointerException
+     */
+    public Line(String line) throws PreprocessorException, NullPointerException {
+        final Line target = this;
+        target.setSourceText(line);
     }
 
-    void setSourceText(String line) throws PreprocessorException {
+    public void setSourceText(String line) throws PreprocessorException, NullPointerException {
         this.sourceText = line;
-        int pos         = indexOfNonTabOrSpace(line);
-        this.indent     = line.substring(0, pos);
-        line            = line.substring(pos);
+        int pos = indexOfNonTabOrSpace(line);
+        this.indent = line.substring(0, pos);
+        final String subline = line.substring(pos);
 
-        if (!line.startsWith(DIRECTIVE_PREFIX)) {
-            this.text      = line;
+        if (!subline.startsWith(DIRECTIVE_PREFIX)) {
+            this.text = subline;
             this.arguments = null;
-            this.type      = LineType.VISIBLE;
-        } else if (line.length() == DIRECTIVE_PREFIX_LENGTH){
-            this.text      = "";
+            this.type = LineType.VISIBLE;
+        } else if (subline.length() == DIRECTIVE_PREFIX_LENGTH) {
+            this.text = "";
             this.arguments = null;
-            this.type       = LineType.HIDDEN;
-        } else  if (SPACE_CHARS.indexOf(line.
-                charAt(DIRECTIVE_PREFIX_LENGTH)) != -1) {
-            this.text      = line.substring(DIRECTIVE_PREFIX_LENGTH_PLUS_ONE);
+            this.type = LineType.HIDDEN;
+        } else if (SPACE_CHARS.indexOf(subline.charAt(DIRECTIVE_PREFIX_LENGTH)) != -1) {
+            this.text = subline.substring(DIRECTIVE_PREFIX_LENGTH_PLUS_ONE);
             this.arguments = null;
-            this.type      = LineType.HIDDEN;
+            this.type = LineType.HIDDEN;
         } else {
-            pos = indexOfTabOrSpace(line, DIRECTIVE_PREFIX_LENGTH_PLUS_ONE);
-
+            pos = indexOfTabOrSpace(subline, DIRECTIVE_PREFIX_LENGTH_PLUS_ONE);
             if (pos == -1) {
-                this.text      = line;
+                this.text = subline;
                 this.arguments = null;
             } else {
-                this.text      = line.substring(0, pos);
-                this.arguments = line.substring(pos + 1).trim();
+                this.text = subline.substring(0, pos);
+                this.arguments = subline.substring(pos + 1).trim();
             }
-
-            Integer oType = (Integer) LineType.directives().get(text);
-
-            if (oType == null) {
+            final Integer typeId = LineType.id(text);
+            if (typeId == null) {
                 throw new PreprocessorException("Unknown directive ["
-                        + text + "] in [" + line + "]"); // NOI18N
+                        + text + "] in [" + subline + "]"); // NOI18N
             }
-
-            this.type = oType.intValue();
+            this.type = typeId;
         }
 
     }
 
-    String getArguments() throws PreprocessorException {
-        if (arguments == null || arguments.length() == 0) {
-            throw new PreprocessorException("["+ text
+    /**
+     * for this line, if they exist.
+     *
+     * @return the value.
+     * @throws PreprocessorException if the line has no arguments.
+     */
+    public String getArguments() throws PreprocessorException {
+        if (arguments == null || arguments.isEmpty()) {
+            throw new PreprocessorException("[" + text
                     + "]: has no argument(s)"); // NOI18N
         }
-
         return arguments;
     }
 
-    String getSourceText() {
+    /**
+     * which is the original, verbatim value with which this instance was
+     * constructed.
+     *
+     * @return the source text val
+     */
+    public String getSourceText() {
         return sourceText;
     }
 
-    String getIndent() {
+    /**
+     * prefix for this instance, which is any leading space or table characters.
+     *
+     * @return the leading space or table characters for this instance.
+     */
+    public String getIndent() {
         return indent;
     }
 
-    String getText() {
+    /**
+     * which is not the directive or directive arguments portion of the line.
+     * <p>
+     * For visible lines, this is the portion following the indent, if any.
+     * </p>
+     * <p>
+     * For hidden lines, this is the text, if any, following the directive
+     * prefix used to hide the line.
+     * </p>
+     *
+     * @return
+     */
+    public String getText() {
         return text;
     }
 
-    int getType() {
+    public int getType() {
         return type;
     }
 
-    boolean isType(int lineType) {
+    public boolean isType(int lineType) {
         return (this.type == lineType);
     }
 
+    @Override
     public String toString() {
-        return LineType.labels()[this.type] + "(" + this.type + "): indent ["
+        return "" + LineType.label(this.type) + "(" + this.type + "): indent ["
                 + this.indent + "] text [" + this.text
                 + ((this.arguments == null) ? "]" : ("] args ["
-                + this.arguments + "]")) ;
+                        + this.arguments + "]"));
     }
 }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/preprocessor/LineType.java 2.7.0-1/hsqldb/src/org/hsqldb/util/preprocessor/LineType.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/preprocessor/LineType.java	2018-10-23 07:24:30.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/preprocessor/LineType.java	2022-04-12 08:47:16.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2007, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -32,83 +32,82 @@
 package org.hsqldb.util.preprocessor;
 
 import java.lang.reflect.Field;
-import java.util.Hashtable;
+import java.util.HashMap;
 import java.util.Locale;
+import java.util.Map;
 
-/* $Id: LineType.java 5793 2018-01-06 13:12:38Z fredt $ */
-
+/*
+ * $Id: LineType.java 6480 2022-04-12 09:46:56Z fredt $
+ */
 /**
- * Static methods and constants to decode preprocessor line types.
+ * Static methods and constants to decode Preprocessor line types.
  *
  * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
- * @version 1.8.1
+ * @version 2.7.0
  * @since 1.8.1
  */
-class LineType {
-    //
-    static final int UNKNOWN    = 0;
-    static final int DEF        = 1;
-    static final int DEFINE     = 1;
-    static final int ELIF       = 2;
-    static final int ELIFDEF    = 3;
-    static final int ELIFNDEF   = 4;
-    static final int ELSE       = 5;
-    static final int ENDIF      = 6;
-    static final int ENDINCLUDE = 7;
-    static final int HIDDEN     = 8;
-    static final int IF         = 9;
-    static final int IFDEF      = 10;
-    static final int IFNDEF     = 11;
-    static final int INCLUDE    = 12;
-    static final int UNDEF      = 13;
-    static final int UNDEFINE   = 13;
-    static final int VISIBLE    = 14;
+@SuppressWarnings("ClassWithoutLogger")
+public class LineType {
 
     //
-    private static Hashtable directives;
-    private static String[]  labels;
+    public static final int UNKNOWN = 0;
+    public static final int DEF = 1;
+    public static final int DEFINE = 1;
+    public static final int ELIF = 2;
+    public static final int ELIFDEF = 3;
+    public static final int ELIFNDEF = 4;
+    public static final int ELSE = 5;
+    public static final int ENDIF = 6;
+    public static final int ENDINCLUDE = 7;
+    public static final int HIDDEN = 8;
+    public static final int IF = 9;
+    public static final int IFDEF = 10;
+    public static final int IFNDEF = 11;
+    public static final int INCLUDE = 12;
+    public static final int UNDEF = 13;
+    public static final int UNDEFINE = 13;
+    public static final int VISIBLE = 14;
 
-    static synchronized String[] labels() {
-        if (labels == null) {
-            init();
-        }
+    //
+    private static Map<String, Integer> directives;
+    private static Map<Integer, String> labels;
 
-        return labels;
+    static {
+        init();
     }
 
-    static synchronized Hashtable directives() {
-        if (directives == null) {
-            init();
-        }
+    public static String label(final Integer key) {
+        return labels.get(key);
+    }
 
-        return directives;
+    public static Integer id(final String key) {
+        return directives.get(key);
     }
 
     private static void init() {
 
-        directives     = new Hashtable();
-        labels         = new String[17];
-        Field[] fields = LineType.class.getDeclaredFields();
-
+        directives = new HashMap<>(23);
+        labels = new HashMap<>(23);
+        final Field[] fields = LineType.class.getDeclaredFields();
         for (int i = 0, j = 0; i < fields.length; i++) {
-            Field field = fields[i];
+            final Field field = fields[i];
 
             if (field.getType().equals(Integer.TYPE)) {
-                String label = field.getName();
+                final String label = field.getName();
 
                 try {
                     int value = field.getInt(null);
 
-                    labels[value] = label;
+                    labels.put(value, label);
 
-                    switch(value) {
-                        case VISIBLE :
-                        case HIDDEN : {
+                    switch (value) {
+                        case VISIBLE:
+                        case HIDDEN: {
                             // ignore
                             break;
                         }
-                        default : {
-                            String key = Line.DIRECTIVE_PREFIX
+                        default: {
+                            final String key = Line.DIRECTIVE_PREFIX
                                     + label.toLowerCase(Locale.ENGLISH);
 
                             directives.put(key, new Integer(value));
@@ -117,12 +116,14 @@ class LineType {
                         }
                     }
 
-                } catch (IllegalArgumentException ex) {
-                    // ex.printStackTrace();
-                } catch (IllegalAccessException ex) {
+                } catch (IllegalArgumentException | IllegalAccessException ignored) {
                     // ex.printStackTrace();
                 }
             }
         }
     }
+
+    private LineType() {
+        throw new AssertionError("Pure Utiluity Class");
+    }
 }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/preprocessor/Option.java 2.7.0-1/hsqldb/src/org/hsqldb/util/preprocessor/Option.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/preprocessor/Option.java	2018-10-23 07:24:26.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/preprocessor/Option.java	2022-03-09 18:43:38.000000000 +0000
@@ -31,7 +31,7 @@
 
 package org.hsqldb.util.preprocessor;
 
-/* $Id: Option.java 5793 2018-01-06 13:12:38Z fredt $ */
+/* $Id: Option.java 6434 2022-03-06 09:02:19Z campbell-burnet $ */
 
 /**
  * Static methods and constants to decode preprocessor options.
@@ -98,4 +98,15 @@ public class Option {
     public static int setVerbose(int options, boolean verbose) {
         return (verbose) ? (options | VERBOSE) : (options & ~VERBOSE);
     }
+    
+    public static String toOptionsString(int options) {
+        Object[] values = {
+            isBackup(options),
+            isFilter(options), 
+            isIndent(options), 
+            isTestOnly(options), 
+            isVerbose(options)};
+        
+        return String.format("backup: %s, filter: %s, indent: %s, testOnly: %s, verbose: %s", values);
+    }
 }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/preprocessor/package-info.java 2.7.0-1/hsqldb/src/org/hsqldb/util/preprocessor/package-info.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/preprocessor/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/preprocessor/package-info.java	2022-03-09 18:43:38.000000000 +0000
@@ -0,0 +1,11 @@
+/**
+ * Provides a simple text document preprocessor. <p>
+ *
+ * Aims specifically at transforming the HSQLDB code base to one of a small
+ * number of specific build targets, while keeping complexity and external
+ * dependencies to a minimum, yet providing an environment that is
+ * sufficiently powerful to solve most easily imaginable preprocessing
+ * scenarios.
+ * 
+ */
+package org.hsqldb.util.preprocessor;
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/preprocessor/PreprocessorAntTask.java 2.7.0-1/hsqldb/src/org/hsqldb/util/preprocessor/PreprocessorAntTask.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/preprocessor/PreprocessorAntTask.java	2018-10-23 07:24:26.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/preprocessor/PreprocessorAntTask.java	1970-01-01 00:00:00.000000000 +0000
@@ -1,243 +0,0 @@
-/* Copyright (c) 2001-2007, The HSQL Development Group
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions are met:
- *
- * Redistributions of source code must retain the above copyright notice, this
- * list of conditions and the following disclaimer.
- *
- * Redistributions in binary form must reproduce the above copyright notice,
- * this list of conditions and the following disclaimer in the documentation
- * and/or other materials provided with the distribution.
- *
- * Neither the name of the HSQL Development Group nor the names of its
- * contributors may be used to endorse or promote products derived from this
- * software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
- * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED. IN NO EVENT SHALL HSQL DEVELOPMENT GROUP, HSQLDB.ORG,
- * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
- * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
- * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
- * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
- * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
- * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
- * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- */
-
-
-package org.hsqldb.util.preprocessor;
-
-import java.io.File;
-
-import org.apache.tools.ant.BuildException;
-import org.apache.tools.ant.taskdefs.MatchingTask;
-
-/* $Id: PreprocessorAntTask.java 5793 2018-01-06 13:12:38Z fredt $ */
-
-/**
- * Provides a facility for invoking the Preprocessor from ANT. <p>
- *
- * Example ANT target: <p>
- *
- * <pre>
- * <target
- *     name="preprocess"
- *     depends="build-preprocessor">
- *
- *     <taskdef
- *         name="preprocess"
- *         classname="org.hsqldb.util.preprocessor.PreprocessorAntTask"
- *         classpath="${preprocessor.class.path}"/>
- *
- *     <preprocess
- *         srcdir="${src.dir}"
- *         targetdir="${target.dir}"
- *         altext=".pre"
- *         backup="true"
- *         encoding="UTF8"
- *         filter="true"
- *         indent="false"
- *         symbols="java_version=${java.version}, jdbc_version=${jdbc.version}"
- *         testonly="false"
- *         verbose="true"
- *         if="${preprocess.if}"
- *         unless="${preprocess.unless}">
- *     </preprocess>
- *
- * </target>
- * </pre>
- *
- * Task attributes :
- *
- * <table>
- *     <thead>
- *         <tr><td>name</td><td>description</td></tr>
- *     </thead>
- *     <tbody>
- *     <tr>
- *         <td>srcdir (required)</td>
- *         <td>string - directory under which input files are located</td>
- *     </tr>
- *     <tr>
- *         <td>targetdir (required)</td>
- *         <td>string - directory under which output files are to be written</td>
- *     </tr>
- *     <tr>
- *         <td>altext (optional)</td>
- *         <td>string - alternate extension to use for output file names. <br/>
- *         If needed, leading dot should be provided</td>
- *     </tr>
- *     <tr>
- *         <td>backup (optional - default: false)</td>
- *         <td>boolean - whether to back up pre-existing target files. <br/>
- *         When true, pre-existing target files are preserved by renaming with
- *         postfix "~"</td>
- *     </tr>
- *     <tr>
- *         <td>encoding (optional)</td>
- *         <td>string - the encoding with which to read and write file content.<br/>
- *         If specified, must be a valid Java encoding identifier, such as "UTF8". <br/>
- *         When unspecified, the default Java platformn encoding is used.</td>
- *     </tr>
- *     <tr>
- *         <td>filter (optional - default: false)</td>
- *         <td>boolean - whether to exclude directive lines from output.</td>
- *     </tr>
- *     <tr>
- *         <td>indent (optional - default: false)</td>
- *         <td>boolean - whether to indent directive lines in output.</td>
- *     </tr>
- *     <tr>
- *         <td>symbols (optional)</td>
- *         <td>string - CSV list of preprocessor symbols to predefine. <br/>
- *         When specified, each list element must be of the form: <br/>
- *         IDENT (ASSIGN? (STRING | NUMBER | IDENT) )?<br/>
- *         Not that forward assignments are illegal. <br/>
- *         See {@link Preprocessor Preprocessor} for details</td>
- *     </tr>
- *     <tr>
- *         <td>testonly (optional - default: false)</td>
- *         <td>boolean - whether to omit writing output files.</td>
- *     </tr>
- *     <tr>
- *         <td>verbose (optional - default: false)</td>
- *         <td>boolean - whether to log detailed information.</td>
- *     </tr>
- *     <tbody>
- * </table>
- *
- * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
- * @version 1.8.1
- * @since 1.8.1
- */
-public class PreprocessorAntTask extends MatchingTask {
-
-    private String ifExpr;
-    private String unlessExpr;
-    private File   sourceDir;
-    private File   targetDir;
-    private String defines;
-    private String altExt;
-    private String encoding;
-    private int    options = Option.INDENT;
-
-    public void init() {
-        super.init();
-    }
-
-    public void setSrcdir(final File value) {
-        sourceDir = value;
-    }
-
-    public void setTargetdir(final File value) {
-        targetDir = value;
-    }
-
-    public void setSymbols(final String value) {
-        defines = value;
-    }
-
-    public void setVerbose(final boolean verbose) {
-        options = Option.setVerbose(options, verbose);
-    }
-
-    public void setBackup(final boolean backup) {
-        options = Option.setBackup(options, backup);
-    }
-
-    public void setIndent(final boolean indent) {
-        options = Option.setIndent(options, indent);
-    }
-
-    public void setTestonly(final boolean testOnly) {
-        options = Option.setTestOnly(options, testOnly);
-    }
-
-    public void setFilter(final boolean filter) {
-        options = Option.setFilter(options, filter);
-    }
-
-    public void setAltext(final String ext) {
-        this.altExt = ext;
-    }
-
-    public void setEncoding(final String encoding) {
-          this.encoding = encoding;
-    }
-
-    public void setIf(final String expr) {
-        this.ifExpr = expr;
-    }
-
-    public void setUnless(final String expr) {
-        this.unlessExpr = expr;
-    }
-
-    public boolean isActive() {
-        return (this.ifExpr == null
-                || getProject().getProperty(this.ifExpr) != null
-                || this.unlessExpr == null
-                || getProject().getProperty(this.unlessExpr) == null);
-    }
-
-    public void execute() throws BuildException {
-
-        if (!isActive()) {
-            return;
-        }
-
-        checkTargetDir();
-
-        this.sourceDir = getProject().resolveFile("" + this.sourceDir);
-
-        IResolver resolver = new AntResolver(getProject());
-        String[]  files    = getFiles();
-
-        log("Preprocessing " + files.length + " file(s)");
-
-        try {
-            Preprocessor.preprocessBatch(this.sourceDir, this.targetDir, files,
-                    this.altExt, this.encoding, this.options, this.defines,
-                    resolver);
-        } catch (Exception ex) {
-            ex.printStackTrace();
-
-            throw new BuildException("Preprocessing failed: " + ex,
-                    ex);
-        }
-    }
-
-    private String[] getFiles() {
-        return getDirectoryScanner(sourceDir).getIncludedFiles();
-    }
-
-    private void checkTargetDir() throws BuildException {
-        if (targetDir == null) {
-            throw new BuildException("Target directory required.");
-        }
-    }
-}
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/preprocessor/PreprocessorException.java 2.7.0-1/hsqldb/src/org/hsqldb/util/preprocessor/PreprocessorException.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/preprocessor/PreprocessorException.java	2018-10-23 07:24:26.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/preprocessor/PreprocessorException.java	2022-03-09 18:43:38.000000000 +0000
@@ -31,7 +31,7 @@
 
 package org.hsqldb.util.preprocessor;
 
-/* $Id: PreprocessorException.java 5793 2018-01-06 13:12:38Z fredt $ */
+/* $Id: PreprocessorException.java 6434 2022-03-06 09:02:19Z campbell-burnet $ */
 
 /**
  * Thrown when preprocessing fails.
@@ -40,6 +40,7 @@ package org.hsqldb.util.preprocessor;
  * @version 1.8.1
  * @since 1.8.1
  */
+@SuppressWarnings("serial")
 public class PreprocessorException extends Exception {
     public PreprocessorException(String message) {
         super(message);
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/preprocessor/Preprocessor.java 2.7.0-1/hsqldb/src/org/hsqldb/util/preprocessor/Preprocessor.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/preprocessor/Preprocessor.java	2018-10-23 07:24:30.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/preprocessor/Preprocessor.java	2022-06-08 10:09:08.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2007, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -27,7 +27,7 @@
  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  */
-
+ 
 
 package org.hsqldb.util.preprocessor;
 
@@ -36,10 +36,12 @@ import java.io.IOException;
 import java.io.UnsupportedEncodingException;
 import java.util.Stack;
 
-/* $Id: Preprocessor.java 5793 2018-01-06 13:12:38Z fredt $ */
-
+/*
+ * $Id: Preprocessor.java 6550 2022-06-08 11:09:08Z fredt $
+ */
 /**
- * Simple text document preprocessor. <p>
+ * Simple text document preprocessor.
+ * <p>
  *
  * Aims specifically at transforming the HSQLDB codebase to one of a small
  * number of specific build targets, while keeping complexity and external
@@ -47,21 +49,21 @@ import java.util.Stack;
  * sufficiently powerful to solve most easily imaginable preprocessing
  * scenarios.
  *
- * Supports the following (case-sensitive) directives: <p>
+ * Supports the following (case-sensitive) directives:
  *
  * <ul>
- *  <li>//#def[ine] IDENT (ASSIGN? (STRING | NUMBER | IDENT) )?
- *  <li>//#elif BOOLEXPR
- *  <li>//#elifdef IDENT
- *  <li>//#elifndef IDENT
- *  <li>//#else
- *  <li>//#endif
- *  <li>//#endinclude
- *  <li>//#if BOOLEXPR
- *  <li>//#ifdef IDENT
- *  <li>//#ifndef IDENT
- *  <li>//#include FILEPATH
- *  <li>//#undef[ine] IDENT
+ * <li>//#def[ine] IDENT (ASSIGN? (STRING | NUMBER | IDENT) )?
+ * <li>//#elif BOOLEXPR
+ * <li>//#elifdef IDENT
+ * <li>//#elifndef IDENT
+ * <li>//#else
+ * <li>//#endif
+ * <li>//#endinclude
+ * <li>//#if BOOLEXPR
+ * <li>//#ifdef IDENT
+ * <li>//#ifndef IDENT
+ * <li>//#include FILEPATH
+ * <li>//#undef[ine] IDENT
  * </ul>
  *
  * where BOOLEXPR is:
@@ -72,7 +74,7 @@ import java.util.Stack;
  * | BOOLEXPR { OR | XOR | AND } BOOLEXPR
  * | NOT BOOLEXPR
  * | LPAREN BOOLEXPR RPAREN )
- *</pre>
+ * </pre>
  *
  * and VALUE is :
  *
@@ -82,18 +84,18 @@ import java.util.Stack;
  * | IDENT )
  * </pre>
  *
- * and lexographic elements are :
+ * and lexicographic elements are :
  *
  * <pre>
  * ASSIGN     : '='
  * EQ         : '=='
- * LT         : '<'
- * LTE        : '<='
- * GT         : '>'
- * GTE        : '>='
+ * LT         : {@code '<'}
+ * LTE        : {@code '<='}
+ * GT         : {@code '>'}
+ * GTE        : {@code '>='}
  * OR         : ('|' | '||')
  * XOR        : '^'
- * AND        : ('&' | '&&')
+ * AND        : {@code ('&' | '&&')}
  * NOT        : '!'
  * DQUOTE     : '"'
  * LPAREN     : '('
@@ -112,38 +114,43 @@ import java.util.Stack;
  * FILEPATH   : NON_SPACE (ANY_UNICODE_CHARACTER* NON_WS)?     -- i.e. trailing SPACE elements are ignored
  * </pre>
  *
- * The lexographic definitions above use the BNF conventions :
+ * The lexicographic definitions above use the BNF conventions :
  *
  * <pre>
- * '?' -> zero or one
- * '*' -> zero or more
- * '+' -> one or more
+ * '?' : zero or one
+ * '*' : zero or more
+ * '+' : one or more
  * </pre>
  *
  * Directives may be arbitrarily indented; there is an option (INDENT) to set
  * or unset directive indentation on output. There is also an option (FILTER)
- * to remove directive lines from output.  See {@link Option Option} for other
- * preprocessor options. <p>
+ * to remove directive lines from output. See {@link Option Option} for other
+ * preprocessor options.
+ * <p>
  *
  * '//#ifxxx' directives may be nested to arbitrary depth,
  * may be chained with an arbitrary number of '//#elifxxx' directives,
  * may be optionally followed by a single '//#else' directive, and
- * must be terminated by a single '//#endif' directive. <p>
+ * must be terminated by a single '//#endif' directive.
+ * <p>
  *
  * Each '//#include' directive must be terminated by an '//#endinclude'
  * directive; lines between '//#include' and '//#endinclude' are replaced
- * by the content retrieved from the specified FILEPATH. <p>
+ * by the content retrieved from the specified FILEPATH.
+ * <p>
  *
  * Included files are preprocessed in a nested scope that inherits the
  * defined symbols of the including scope. Directive lines in included files
- * are always excluded from output. <p>
+ * are always excluded from output.
+ * <p>
  *
  * <b>Design Notes</b><p>
  *
  * There are many better/more sophisticated preprocessors/templating
- * engines out there.  FreeMaker and Velocity come to mind immediately.
+ * engines out there. FreeMaker and Velocity come to mind immediately.
  * Another--the NetBeans MIDP preprocessor--was the direct inspiration for
- * this class. <p>
+ * this class.
+ * <p>
  *
  * Other options were rejected because the work of creating this class appeared
  * to be less than dealing with the complexity and dependency issues of hooking
@@ -152,10 +159,11 @@ import java.util.Stack;
  * The NetBeans preprocessor, in particular, was rejected because it was
  * not immediately evident how to invoke it independently from the IDE,
  * how to make it available to non-MIDP projects from within the IDE or how to
- * isolate the correct OpenIDE jars to allow stand-alone operation. <p>
+ * isolate the correct OpenIDE jars to allow stand-alone operation.
+ * <p>
  *
  * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
- * @version 1.8.1
+ * @version 2.7.0
  * @since 1.8.1
  */
 public class Preprocessor {
@@ -163,26 +171,34 @@ public class Preprocessor {
     // =========================================================================
     // ------------------------------- Public API ------------------------------
     // =========================================================================
-
     /**
-     * Preprocesses the specified list of files. <p>
+     * Preprocesses the specified list of files.
+     * <p>
      *
      * @param sourceDir under which input files are located
      * @param targetDir under which output files are to be written
      * @param fileNames to be preprocessed
-     * @param altExt to use for output file names
-     * @param encoding with which to write output files
-     * @param options used to control preprocessing
-     * @param defines CSV list of symbol definition expressions
-     * @param resolver with which to perform property and path expansions
+     * @param altExt    to use for output file names
+     * @param encoding  with which to write output files
+     * @param options   used to control preprocessing
+     * @param defines   CSV list of symbol definition expressions
+     * @param resolver  with which to perform property and path expansions
      * @throws PreprocessorException if an error occurs while loading,
-     *      preprocessing or saving the result of preprocessing one of the
-     *      specified input files
+     *                               preprocessing or saving the result of preprocessing one of the
+     *                               specified input files
      */
     public static void preprocessBatch(File sourceDir, File targetDir,
             String[] fileNames, String altExt, String encoding, int options,
             String defines, IResolver resolver) throws PreprocessorException {
 
+//        log("sourceDir: " + sourceDir);
+//        log("targetDir: " + targetDir);
+//        log("fileNames: " + Arrays.asList(fileNames));
+//        log("altExt   : " + altExt);
+//        log("encoding : " + encoding);
+//        log("options  : " + Option.toOptionsString(options));
+//        log("defines  : " + defines);
+//        log("resolver : " + resolver);
         for (int i = 0; i < fileNames.length; i++) {
             String fileName = fileNames[i];
 
@@ -201,44 +217,54 @@ public class Preprocessor {
     }
 
     /**
-     * Preprocesses a single file. <p>
+     * Preprocesses a single file.
+     * <p>
      *
      * @param sourceDir under which the input file is located
      * @param targetDir under which the output file is to be written
-     * @param fileName to be preprocessed
-     * @param altExt to use for output file name
-     * @param encoding with which to write output file
-     * @param options used to control preprocessing
-     * @param defines CSV list of symbol definition expressions
-     * @param resolver with which to perform property and path expansions
+     * @param fileName  to be preprocessed
+     * @param altExt    to use for output file name
+     * @param encoding  with which to write output file
+     * @param options   used to control preprocessing
+     * @param defines   CSV list of symbol definition expressions
+     * @param resolver  with which to perform property and path expansions
      * @throws PreprocessorException if an error occurs while loading,
-     *      preprocessing or saving the result of preprocessing the
-     *      specified input file
+     *                               preprocessing or saving the result of preprocessing the
+     *                               specified input file
      */
     public static void preprocessFile(File sourceDir, File targetDir,
             String fileName, String altExt, String encoding, int options,
             String defines, IResolver resolver) throws PreprocessorException {
 
-        String       sourcePath   = translatePath(sourceDir, fileName, null);
-        String       targetPath   = translatePath(targetDir, fileName, altExt);
-        File         targetFile   = new File(targetPath);
-        File         backupFile   = new File(targetPath + "~");
-        boolean      sameDir      = sourceDir.equals(targetDir);
-        boolean      sameExt      = (altExt ==  null);
-        boolean      verbose      = Option.isVerbose(options);
-        boolean      testOnly     = Option.isTestOnly(options);
-        boolean      backup       = Option.isBackup(options);
+        String sourcePath = translatePath(sourceDir, fileName, null);
+        String targetPath = translatePath(targetDir, fileName, altExt);
+        File targetFile = new File(targetPath);
+        File backupFile = new File(targetPath + "~");
+        boolean sameDir = sourceDir.equals(targetDir);
+        boolean sameExt = (altExt == null);
+        boolean verbose = Option.isVerbose(options);
+        boolean testOnly = Option.isTestOnly(options);
+        boolean backup = Option.isBackup(options);
         Preprocessor preprocessor = new Preprocessor(sourcePath,
                 encoding, options, resolver, defines);
 
         if (verbose) {
-            log("Reading \"" + sourcePath + "\"");
+//        log("sourceDir : " + sourceDir);
+//        log("targetDir : " + targetDir);
+//        log("fileName  : " + fileName);
+//        log("altExt    : " + altExt);
+//        log("encoding  : " + encoding);
+//        log("options   : " + Option.toOptionsString(options));
+//        log("defines   : " + defines);
+//        log("resolver  : " + resolver);
+            log("sourcePath: " + sourcePath);
+            log("targetPath: " + targetPath);
         }
 
         preprocessor.loadDocument();
 
         boolean modified = preprocessor.preprocess();
-        boolean rewrite  = modified || !sameDir || !sameExt;
+        boolean rewrite = modified || !sameDir || !sameExt;
 
         if (!rewrite) {
             if (verbose) {
@@ -268,7 +294,7 @@ public class Preprocessor {
                     + targetFile
                     + "\" => \""
                     + backupFile
-                    +"\"" ); // NOI18N
+                    + "\""); // NOI18N
         }
 
         if (verbose) {
@@ -285,17 +311,16 @@ public class Preprocessor {
     // =========================================================================
     // ----------------------------- Implementation ----------------------------
     // =========================================================================
-
     // Fields
-
     // static
-    static final int CONDITION_NONE      = 0;
-    static final int CONDITION_ARMED     = 1;
-    static final int CONDITION_IN_TRUE   = 2;
+    static final int CONDITION_NONE = 0;
+    static final int CONDITION_ARMED = 1;
+    static final int CONDITION_IN_TRUE = 2;
     static final int CONDITION_TRIGGERED = 3;
 
     // optimization - zero new object burn rate for statePush()
-    static final Integer[] STATES = new Integer[] {
+    @SuppressWarnings("UnnecessaryBoxing")
+    static final Integer[] STATES = new Integer[]{
         new Integer(CONDITION_NONE),
         new Integer(CONDITION_ARMED),
         new Integer(CONDITION_IN_TRUE),
@@ -303,17 +328,16 @@ public class Preprocessor {
     };
 
     // instance
-    private String    documentPath;
-    private String    encoding;
-    private int       options;
-    private IResolver resolver;
-    private Document  document;
-    private Defines   defines;
-    private Stack     stack;
-    private int       state;
+    private final String documentPath;
+    private final String encoding;
+    private final int options;
+    private final IResolver resolver;
+    private final Document document;
+    private final Defines defines;
+    private final Stack stack;
+    private int state;
 
     // Constructors
-
     private Preprocessor(String documentPath,
             String encoding, int options, IResolver resolver,
             String predefined) throws PreprocessorException {
@@ -329,31 +353,30 @@ public class Preprocessor {
         if (predefined == null || predefined.trim().length() == 0) {
             this.defines = new Defines();
         } else {
-            predefined   = this.resolver.resolveProperties(predefined);
+            predefined = this.resolver.resolveProperties(predefined);
             this.defines = new Defines(predefined);
         }
 
         this.documentPath = documentPath;
-        this.encoding     = encoding;
-        this.options      = options;
-        this.document     = new Document();
-        this.stack        = new Stack();
-        this.state        = CONDITION_NONE;
+        this.encoding = encoding;
+        this.options = options;
+        this.document = new Document();
+        this.stack = new Stack();
+        this.state = CONDITION_NONE;
     }
 
     private Preprocessor(Preprocessor other, Document include) {
-        this.document     = include;
-        this.encoding     = other.encoding;
-        this.stack        = new Stack();
-        this.state        = CONDITION_NONE;
-        this.options      = other.options;
+        this.document = include;
+        this.encoding = other.encoding;
+        this.stack = new Stack();
+        this.state = CONDITION_NONE;
+        this.options = other.options;
         this.documentPath = other.documentPath;
-        this.resolver     = other.resolver;
-        this.defines      = other.defines;
+        this.resolver = other.resolver;
+        this.defines = other.defines;
     }
 
     // Main entry point
-
     private boolean preprocess() throws PreprocessorException {
         this.stack.clear();
 
@@ -386,39 +409,39 @@ public class Preprocessor {
             }
         }
 
-        return (!this.document.equals(originalDocument));
+        return (!this.document.contentEquals(originalDocument));
     }
 
     private void preprocessImpl() throws PreprocessorException {
-        int     includeCount = 0;
-        int     lineCount    = 0;
+        int includeCount = 0;
+        int lineCount = 0;
 
         while (lineCount < this.document.size()) {
 
             try {
                 Line line = resolveLine(this.document.getSourceLine(lineCount));
 
-                switch(line.getType()) {
-                    case LineType.INCLUDE : {
+                switch (line.getType()) {
+                    case LineType.INCLUDE: {
                         lineCount = processInclude(lineCount, line);
 
                         break;
                     }
-                    case LineType.VISIBLE :
-                    case LineType.HIDDEN : {
+                    case LineType.VISIBLE:
+                    case LineType.HIDDEN: {
                         this.document.setSourceLine(lineCount,
                                 toSourceLine(line));
 
                         if (Option.isVerbose(options)) {
-                                log((isHidingLines() ? "Commented: "
-                                                     : "Uncommented: ") + line);
+                            log((isHidingLines() ? "Commented: "
+                                    : "Uncommented: ") + line);
                         }
 
                         lineCount++;
 
                         break;
                     }
-                    default : {
+                    default: {
                         processDirective(line);
 
                         lineCount++;
@@ -435,28 +458,27 @@ public class Preprocessor {
     }
 
     // -------------------------- Line-level Handlers --------------------------
-
     private void processIf(boolean condition) {
         statePush();
 
         this.state = isHidingLines() ? CONDITION_TRIGGERED
-                                     : (condition) ? CONDITION_IN_TRUE
-                                                   : CONDITION_ARMED;
+                : (condition) ? CONDITION_IN_TRUE
+                        : CONDITION_ARMED;
     }
 
     private void processElseIf(boolean condition) throws PreprocessorException {
-        switch(state) {
-            case CONDITION_NONE : {
+        switch (state) {
+            case CONDITION_NONE: {
                 throw new PreprocessorException("Unexpected #elif"); // NOI18N
             }
-            case CONDITION_ARMED : {
+            case CONDITION_ARMED: {
                 if (condition) {
                     this.state = CONDITION_IN_TRUE;
                 }
 
                 break;
             }
-            case CONDITION_IN_TRUE : {
+            case CONDITION_IN_TRUE: {
                 this.state = CONDITION_TRIGGERED;
 
                 break;
@@ -465,16 +487,16 @@ public class Preprocessor {
     }
 
     private void processElse() throws PreprocessorException {
-        switch(state) {
-            case CONDITION_NONE : {
+        switch (state) {
+            case CONDITION_NONE: {
                 throw new PreprocessorException("Unexpected #else"); // NOI18N
             }
-            case CONDITION_ARMED : {
+            case CONDITION_ARMED: {
                 this.state = CONDITION_IN_TRUE;
 
                 break;
             }
-            case CONDITION_IN_TRUE : {
+            case CONDITION_IN_TRUE: {
                 this.state = CONDITION_TRIGGERED;
 
                 break;
@@ -491,62 +513,62 @@ public class Preprocessor {
     }
 
     private void processDirective(Line line) throws PreprocessorException {
-        switch(line.getType()) {
-            case LineType.DEFINE : {
+        switch (line.getType()) {
+            case LineType.DEFINE: {
                 if (!isHidingLines()) {
                     this.defines.defineSingle(line.getArguments());
                 }
 
                 break;
             }
-            case LineType.UNDEFINE : {
+            case LineType.UNDEFINE: {
                 if (!isHidingLines()) {
                     this.defines.undefine(line.getArguments());
                 }
 
                 break;
             }
-            case LineType.IF : {
+            case LineType.IF: {
                 processIf(this.defines.evaluate(line.getArguments()));
 
                 break;
             }
-            case LineType.IFDEF : {
+            case LineType.IFDEF: {
                 processIf(this.defines.isDefined(line.getArguments()));
 
                 break;
             }
-            case LineType.IFNDEF : {
+            case LineType.IFNDEF: {
                 processIf(!this.defines.isDefined(line.getArguments()));
 
                 break;
             }
-            case LineType.ELIF : {
+            case LineType.ELIF: {
                 processElseIf(this.defines.evaluate(line.getArguments()));
 
                 break;
             }
-            case LineType.ELIFDEF : {
+            case LineType.ELIFDEF: {
                 processElseIf(this.defines.isDefined(line.getArguments()));
 
                 break;
             }
-            case LineType.ELIFNDEF : {
+            case LineType.ELIFNDEF: {
                 processElseIf(!this.defines.isDefined(line.getArguments()));
 
                 break;
             }
-            case LineType.ELSE : {
+            case LineType.ELSE: {
                 processElse();
 
                 break;
             }
-            case LineType.ENDIF : {
+            case LineType.ENDIF: {
                 processEndIf();
 
                 break;
             }
-            default : {
+            default: {
                 throw new PreprocessorException("Unhandled line type: "
                         + line); // NOI18N
             }
@@ -554,9 +576,9 @@ public class Preprocessor {
     }
 
     private int processInclude(int lineCount, Line line)
-    throws PreprocessorException {
-        String    path   = resolvePath(line.getArguments());
-        boolean   hidden = isHidingLines();
+            throws PreprocessorException {
+        String path = resolvePath(line.getArguments());
+        boolean hidden = isHidingLines();
 
         lineCount++;
 
@@ -575,7 +597,7 @@ public class Preprocessor {
         }
 
         if (!hidden) {
-            Document     include      = loadInclude(path);
+            Document include = loadInclude(path);
             Preprocessor preprocessor = new Preprocessor(this, include);
 
             preprocessor.preprocess();
@@ -597,29 +619,29 @@ public class Preprocessor {
     }
 
     // -------------------------- Preprocessor State ---------------------------
-
     private boolean isHidingLines() {
-        switch(state) {
-            case CONDITION_ARMED :
+        switch (state) {
+            case CONDITION_ARMED:
             case CONDITION_TRIGGERED: {
                 return true;
             }
-            default : {
+            default: {
                 return false;
             }
         }
     }
 
+    @SuppressWarnings("unchecked")
     private void statePush() {
         this.stack.push(STATES[this.state]);
     }
 
+    @SuppressWarnings("UnnecessaryUnboxing")
     private void statePop() {
         this.state = ((Integer) stack.pop()).intValue();
     }
 
     // ------------------------------ Resolution -------------------------------
-
     private Line resolveLine(String line) throws PreprocessorException {
         return new Line(this.resolver.resolveProperties(line));
     }
@@ -629,49 +651,70 @@ public class Preprocessor {
             throw new IllegalArgumentException("path: null");
         }
 
-        String value = this.resolver.resolveProperties(path);
-        File   file  = this.resolver.resolveFile(value);
+        if (Option.isVerbose(options)) {
+            log("resolve path: " + path);
+        }
+
+        if (path.contains("${")) {
+            path = this.resolver.resolveProperties(path);
+
+            if (Option.isVerbose(options)) {
+                log("resolved properties: " + path);
+            }
+        }
+
+
+
+        File file = this.toCanonicalOrAbsoluteFile(path);
+
+        if (Option.isVerbose(options)) {
+            log("resolved file: " + file.getAbsolutePath());
+        }
 
         try {
-            return file.getCanonicalPath();
+            path = file.getCanonicalPath();
         } catch (IOException ex) {
-            return file.getAbsolutePath();
+            path = file.getAbsolutePath();
         }
+
+        if (Option.isVerbose(options)) {
+            log("resolved path: " + path);
+        }
+
+        return path;
     }
 
     // ------------------------------ Conversion -------------------------------
-
-    private String toSourceLine(Line line) {
+    private String toSourceLine(final Line line) {
+        final String indent = line.getIndent();
+        final String text = line.getText();
         return (isHidingLines())
-            ? Option.isIndent(this.options)
-                ? line.indent + Line.HIDE_DIRECTIVE + line.text
-                : Line.HIDE_DIRECTIVE + line.indent + line.text
-            : line.indent + line.text;
+                ? Option.isIndent(this.options)
+                ? indent + Line.HIDE_DIRECTIVE + text
+                : Line.HIDE_DIRECTIVE + indent + text
+                : indent + text;
     }
 
     private File toCanonicalOrAbsoluteFile(String path) {
         File file = new File(path);
 
         if (!file.isAbsolute()) {
-            path = (new File(this.documentPath)).getParent()
-                    + File.separatorChar
-                    + path;
+            File parent = (new File(this.documentPath)).getParentFile();
 
-            file = new File(path);
+            file = new File(parent, path);
         }
 
         try {
             return file.getCanonicalFile();
-        } catch (Exception e) {
+        } catch (IOException e) {
             return file.getAbsoluteFile();
         }
     }
 
     // ------------------------------ Translation ------------------------------
-
     private static String translatePath(File dir, String fileName, String ext) {
         return new StringBuffer(dir.getPath()).append(File.separatorChar).
-                append(translateFileExtension(fileName,ext)).toString();
+                append(translateFileExtension(fileName, ext)).toString();
     }
 
     private static String translateFileExtension(String fileName, String ext) {
@@ -680,17 +723,16 @@ public class Preprocessor {
             int pos = fileName.lastIndexOf('.');
 
             fileName = (pos < 0) ? fileName + ext
-                                 : fileName.substring(0, pos) + ext;
+                    : fileName.substring(0, pos) + ext;
         }
 
         return fileName;
     }
 
     // ---------------------------------- I/O ----------------------------------
-
     private Document loadInclude(String path) throws PreprocessorException {
         Document include = new Document();
-        File     file    = toCanonicalOrAbsoluteFile(path);
+        File file = toCanonicalOrAbsoluteFile(path);
 
         try {
             return include.load(file, this.encoding);
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/preprocessor/Tokenizer.java 2.7.0-1/hsqldb/src/org/hsqldb/util/preprocessor/Tokenizer.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/preprocessor/Tokenizer.java	2018-10-23 07:24:26.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/preprocessor/Tokenizer.java	2022-04-12 08:47:16.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2007, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -31,24 +31,25 @@
 
 package org.hsqldb.util.preprocessor;
 
-/* $Id: Tokenizer.java 5793 2018-01-06 13:12:38Z fredt $ */
+/* $Id: Tokenizer.java 6480 2022-04-12 09:46:56Z fredt $ */
 
 /**
- * Simple preprocessor directive tokenizer.
+ * Simple Preprocessor directive tokenizer.
  *
  * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
  * @version 1.8.1
- * @since 1.8.1
+ * @since 2.7.0
  */
-final class Tokenizer {
+@SuppressWarnings("ClassWithoutLogger")
+public class Tokenizer {
     private final String command;
     private final int    commandLength;
     private int          tokenType;
     private int          startIndex;
     private int          currentIndex;
 
-    Tokenizer(final String cmd) {
-        this.command       = cmd + " ";
+    public Tokenizer(final String cmd) {
+        this.command       = cmd == null || cmd.isEmpty() ? "" : cmd + " ";
         this.commandLength = command.length();
         this.startIndex    = 0;
         this.currentIndex  = 0;
@@ -58,23 +59,14 @@ final class Tokenizer {
     void skipBlanks() {
         final String cmd = this.command;
         final int    len = this.commandLength;
-
-        top:
-            while (currentIndex < len) {
-
-            switch(cmd.charAt(currentIndex)) {
-                case ' '  :
-                case '\t' : {
-                    currentIndex++;
-                    continue top;
-                }
-            }
-
-            break;
-            }
+        int          pos = this.currentIndex;
+        while(pos < len && " \t".indexOf(cmd.charAt(pos)) != -1) {
+            pos++;
+        }
+        this.currentIndex = pos;
     }
 
-    int next() throws PreprocessorException {
+    public int next() throws PreprocessorException {
         skipBlanks();
 
         startIndex = currentIndex;
@@ -145,8 +137,8 @@ final class Tokenizer {
             case Token.XOR :
             case Token.NOT : {
                 currentIndex++;
-
-                return (tokenType = ch);
+                tokenType = ch;
+                return ch;
             }
             case Token.ASSIGN : {
                 currentIndex++;
@@ -198,7 +190,9 @@ final class Tokenizer {
                     currentIndex++;
                 }
 
-                return (tokenType = ch);
+                tokenType = ch;
+
+                return ch;
             }
             default : {
                 throw new PreprocessorException("Syntax error: " +
@@ -207,39 +201,39 @@ final class Tokenizer {
         }
     }
 
-    int getTokenType() {
+    public int getTokenType() {
         return tokenType;
     }
 
-    boolean isToken(final int type) {
+    public boolean isToken(final int type) {
         return (this.tokenType == type);
     }
 
-    String getIdent() {
+    public String getIdent() {
         return isToken(Token.EOI) ? null
                 : this.command.substring(startIndex, currentIndex);
     }
 
-    Number getNumber() {
+    public Number getNumber() {
         return (isToken(Token.EOI)) ? null
                 : new Double(Double.parseDouble(this.command.
                 substring(startIndex, currentIndex)));
     }
 
-    String getString() {
+    public String getString() {
         return isToken(Token.EOI) ? null
                 : this.command.substring(startIndex + 1, currentIndex - 1);
     }
 
-    int getStartIndex() {
+    public int getStartIndex() {
         return this.startIndex;
     }
 
-    int currentIndex() {
+    public int currentIndex() {
         return this.currentIndex;
     }
 
-    String getSource() {
+    public String getSource() {
         return this.command;
     }
 }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/preprocessor/Token.java 2.7.0-1/hsqldb/src/org/hsqldb/util/preprocessor/Token.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/preprocessor/Token.java	2018-10-23 07:24:30.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/preprocessor/Token.java	2022-03-09 18:43:38.000000000 +0000
@@ -31,39 +31,40 @@
 
 package org.hsqldb.util.preprocessor;
 
-/* $Id: Token.java 5793 2018-01-06 13:12:38Z fredt $ */
+/* $Id: Token.java 6434 2022-03-06 09:02:19Z campbell-burnet $ */
 
 /**
- * Static methods and constants to decode directive tokens.
+ * Static methods and constants to decode Preprocessor directive tokens.
  *
  * @author Campbell Burnet (campbell-burnet@users dot sourceforge.net)
  * @version 1.8.1
  * @since 1.8.1
  */
-final class Token {
-    static final int EOI     = -1;
-    static final int UNKNOWN = 0;
-    static final int IDENT   = 1;
-    static final int NUMBER  = 2;
-    static final int STRING  = 3;
-    static final int AND     = '&';
-    static final int OR      = '|';
-    static final int XOR     = '^';
-    static final int NOT     = '!';
-    static final int GT      = '>';
-    static final int GTE     = '>' + '=';
-    static final int LT      = '<';
-    static final int LTE     = '<' + '=';
-    static final int ASSIGN  = '=';
-    static final int EQ      = '=' + '=';
-    static final int LPAREN  = '(';
-    static final int RPAREN  = ')';
+public final class Token {
+    
+    public static final int EOI     = -1;
+    public static final int UNKNOWN = 0;
+    public static final int IDENT   = 1;
+    public static final int NUMBER  = 2;
+    public static final int STRING  = 3;
+    public static final int AND     = '&';
+    public static final int OR      = '|';
+    public static final int XOR     = '^';
+    public static final int NOT     = '!';
+    public static final int GT      = '>';
+    public static final int GTE     = '>' + '=';
+    public static final int LT      = '<';
+    public static final int LTE     = '<' + '=';
+    public static final int ASSIGN  = '=';
+    public static final int EQ      = '=' + '=';
+    public static final int LPAREN  = '(';
+    public static final int RPAREN  = ')';
 
-    static boolean isAssignmentOperator(final int type) {
+    public static boolean isAssignmentOperator(final int type) {
         return (type == ASSIGN);
     }
 
-    static boolean isComparisonOperator(final int type) {
+    public static boolean isComparisonOperator(final int type) {
         switch(type) {
             case EQ :
             case LT :
@@ -78,7 +79,7 @@ final class Token {
         }
     }
 
-    static boolean isLogicalOperator(final int type) {
+    public static boolean isLogicalOperator(final int type) {
         switch(type) {
             case AND :
             case OR :
@@ -92,7 +93,7 @@ final class Token {
         }
     }
 
-    static boolean isValue(final int type) {
+    public static boolean isValue(final int type) {
         switch (type) {
             case IDENT :
             case STRING :
@@ -104,4 +105,8 @@ final class Token {
             }
         }
     }
+
+    private Token() {
+        throw new AssertionError("Pure Utility Class");
+    }
 }
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/RCData.java 2.7.0-1/hsqldb/src/org/hsqldb/util/RCData.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/RCData.java	2021-02-09 16:10:54.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/RCData.java	2022-06-11 09:02:16.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -45,7 +45,7 @@ import java.util.HashSet;
 import java.util.StringTokenizer;
 import java.util.regex.Pattern;
 
-/* $Id: RCData.java 6299 2021-02-09 17:10:48Z fredt $ */
+/* $Id: RCData.java 6555 2022-06-11 10:02:16Z fredt $ */
 
 /**
  * Manages all the details we need to connect up to JDBC database(s),
@@ -58,7 +58,6 @@ import java.util.regex.Pattern;
  * @see <A href="../../../../util-guide/sqltool-chapt.html#sqltool_auth-sect"
  *      target="guide">
  *     The RC File section of the HyperSQL Utilities Guide</A>
- * @see org.hsqldb.sample.SqlFileEmbedder
  * @author Blaine Simpson (blaine dot simpson at admc dot com)
  */
 public class RCData {
@@ -83,6 +82,7 @@ public class RCData {
         System.err.println("urlid: " + id + ", url: " + url + ", username: "
                            + username + ", password: " + password);
     }
+     * @return string representation
      */
 
     public String toString() {
@@ -313,12 +313,11 @@ public class RCData {
      * Gets a JDBC Connection using the data of this RCData object.
      *
      * @return New JDBC Connection
-     * @throws ClassNotFoundException on class not found
      * @throws SQLException on database access error
      * @throws MalformedURLException on malformed URL
      */
     public Connection getConnection()
-    throws ClassNotFoundException, SQLException, MalformedURLException {
+    throws SQLException, MalformedURLException {
         return getConnection(null, null);
     }
 
@@ -329,7 +328,6 @@ public class RCData {
      * @param curDriverIn driver
      * @param curTrustStoreIn trusted store
      * @return New JDBC Connection
-     * @throws ClassNotFoundException on class not found
      * @throws MalformedURLException on malformed URL
      * @throws SQLException on database access error
      */
@@ -423,6 +421,9 @@ public class RCData {
      * Returns a copy of the given String with System property names in the
      * format <code>${system.property}</code> replaced by the corresponding Java
      * System Properties.
+     *
+     * @param inString String
+     * @return formatted string
      */
     public static String expandSysPropVars(String inString) {
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/TransferHelper.java 2.7.0-1/hsqldb/src/org/hsqldb/util/TransferHelper.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/TransferHelper.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/TransferHelper.java	2022-04-21 16:08:00.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -56,7 +56,7 @@ class TransferHelper {
 
         db     = null;
         tracer = null;
-        quote  = "\'";
+        quote  = "'";
         JDBCT  = new JDBCTypes();
     }
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/Transfer.java 2.7.0-1/hsqldb/src/org/hsqldb/util/Transfer.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/Transfer.java	2021-01-25 15:08:24.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/Transfer.java	2022-05-22 18:09:56.000000000 +0000
@@ -1,7 +1,7 @@
 /*
  * For work developed by the HSQL Development Group:
  *
- * Copyright (c) 2001-2021, The HSQL Development Group
+ * Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -70,7 +70,6 @@
 
 package org.hsqldb.util;
 
-import java.applet.Applet;
 import java.util.Enumeration;
 import java.util.Vector;
 
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/TransferSQLText.java 2.7.0-1/hsqldb/src/org/hsqldb/util/TransferSQLText.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/TransferSQLText.java	2021-02-09 04:49:22.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/TransferSQLText.java	2022-04-21 16:08:00.000000000 +0000
@@ -1,4 +1,4 @@
-/* Copyright (c) 2001-2021, The HSQL Development Group
+/* Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -564,17 +564,13 @@ class TransferSQLText extends DataAccess
                     try {
                         while ((Token =
                                 Tokenizer.nextToken()).toUpperCase().equals(
-                                    "INDEX")) {
-                            ;
-                        }
+                                    "INDEX")) {}
 
                         String IndexdropCommand = "DROP INDEX " + Token
                                                   + " ;";
 
                         while ((Token = Tokenizer.nextToken(
-                                " (")).toUpperCase().equals("ON")) {
-                            ;
-                        }
+                                " (")).toUpperCase().equals("ON")) {}
 
                         name = Token;
 
@@ -663,9 +659,7 @@ class TransferSQLText extends DataAccess
         try {
             Tokenizer = new StringTokenizer(statement);
 
-            while (!Tokenizer.nextToken().toUpperCase().equals("FROM")) {
-                ;
-            }
+            while (!Tokenizer.nextToken().toUpperCase().equals("FROM")) {}
 
             tableName = Tokenizer.nextToken(" ;");
         } catch (NoSuchElementException NSE) {
diff -pruN 2.6.1-1/hsqldb/src/org/hsqldb/util/TransferTable.java 2.7.0-1/hsqldb/src/org/hsqldb/util/TransferTable.java
--- 2.6.1-1/hsqldb/src/org/hsqldb/util/TransferTable.java	2021-02-09 04:50:08.000000000 +0000
+++ 2.7.0-1/hsqldb/src/org/hsqldb/util/TransferTable.java	2022-05-23 11:18:44.000000000 +0000
@@ -1,7 +1,7 @@
 /*
  * For work developed by the HSQL Development Group:
  *
- * Copyright (c) 2001-2021, The HSQL Development Group
+ * Copyright (c) 2001-2022, The HSQL Development Group
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -71,7 +71,6 @@
 package org.hsqldb.util;
 
 import java.io.Serializable;
-import java.sql.SQLException;
 import java.util.Hashtable;
 
 // fredt@users 20011220 - patch 481239 by xponsard@users - enhancements
@@ -147,7 +146,7 @@ class TransferTable implements Serializa
             } catch (Exception e) {}
         }
 
-        if (Stmts.bTransfer == false) {
+        if (!Stmts.bTransfer) {
             tracer.trace("Table " + Stmts.sSourceTable + " not transfered");
 
             return;
@@ -362,7 +361,7 @@ class TransferTable implements Serializa
             } catch (Exception e) {}
         }
 
-        if (Stmts.bTransfer == false) {
+        if (!Stmts.bTransfer) {
             tracer.trace("Table " + Stmts.sSourceTable + " not transfered");
 
             return;
diff -pruN 2.6.1-1/hsqldb/testrun/hsqldb/TestSelf3PartNames.txt 2.7.0-1/hsqldb/testrun/hsqldb/TestSelf3PartNames.txt
--- 2.6.1-1/hsqldb/testrun/hsqldb/TestSelf3PartNames.txt	2018-10-23 07:24:54.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/hsqldb/TestSelf3PartNames.txt	2022-02-21 21:18:52.000000000 +0000
@@ -1,4 +1,3 @@
--- $Id: TestSelf3PartNames.txt 610 2008-12-22 15:54:18Z unsaved $
 -- Test 3-part names like:  schemaname.tablename.columname
 --SET PROPERTY "hsqldb.default_table_type" 'cached'
 -- Setup
diff -pruN 2.6.1-1/hsqldb/testrun/hsqldb/TestSelfAlterColumn.txt 2.7.0-1/hsqldb/testrun/hsqldb/TestSelfAlterColumn.txt
--- 2.6.1-1/hsqldb/testrun/hsqldb/TestSelfAlterColumn.txt	2018-10-23 07:24:52.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/hsqldb/TestSelfAlterColumn.txt	2022-02-21 21:18:18.000000000 +0000
@@ -117,13 +117,32 @@ insert into "testac" values (default,9);
  8,8
  9,9
  10,9
-*/select * from "testac";
+*/select * from "testac" order by 1;
 alter table "testac" drop primary key;
 alter table "testac" alter column "a" drop generated
+/*r
+ 4,4
+ 5,5
+ 6,6
+ 7,7
+ 8,8
+ 9,9
+ 10,9
+*/select * from "testac" order by 1;
 insert into "testac" values (null,12);
 /*c8*/select * from "testac";
 /*e*/alter table "testac" alter column "a" not null;
 
+/*r
+ 4,4
+ 5,5
+ 6,6
+ 7,7
+ 8,8
+ 9,9
+ 10,9
+ null,12
+*/select * from "testac" order by 1 nulls last;
 delete from "testac" where "a" is null
 delete from "testac" where "a" > 9
 /*c6*/select * from "testac";
@@ -140,6 +159,15 @@ insert into "testac" values (null,12);
 delete from "testac" where "a" is null
 /*c6*/select * from "testac";
 
+/*r
+ 4,4
+ 5,5
+ 6,6
+ 7,7
+ 8,8
+ 9,9
+*/select * from "testac" order by 1;
+
 -- column with a PK constraint can be added
 alter table "testac" add column "c" integer generated by default as identity primary key
 -- no second IDENTITY or PK
@@ -168,7 +196,7 @@ update "testacc" set "c" = "c" || cast("
  6,6,aa6
  7,7,aa7
  8,8,aa8
-*/select * from "testacc";
+*/select * from "testacc" order by 1;
 alter table "testacc" add primary key ("c")
 /*r
  4,4,aa4
@@ -176,7 +204,7 @@ alter table "testacc" add primary key ("
  6,6,aa6
  7,7,aa7
  8,8,aa8
-*/select * from "testacc";
+*/select * from "testacc" order by 1;
 /*e*/insert into "testacc" values (9,9,'aa9000000');
 alter table "testacc" alter column "c" varchar(10);
 insert into "testacc" values (9,9,'aa9000000');
diff -pruN 2.6.1-1/hsqldb/testrun/hsqldb/TestSelfRoleNesting.txt 2.7.0-1/hsqldb/testrun/hsqldb/TestSelfRoleNesting.txt
--- 2.6.1-1/hsqldb/testrun/hsqldb/TestSelfRoleNesting.txt	2018-10-23 07:24:54.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/hsqldb/TestSelfRoleNesting.txt	2022-02-21 14:42:06.000000000 +0000
@@ -1,5 +1,5 @@
 -- First with a table grant
-
+SET SESSION AUTHORIZATION 'SA'
 /*s*/DROP USER peon1;
 /*s*/DROP USER peon2;
 /*s*/DROP USER peon3;
@@ -228,7 +228,7 @@ CONNECT USER sa PASSWORD "";
 /*s*/DROP ROLE r1 CASCADE;
 /*s*/DROP ROLE r2 CASCADE;
 /*s*/DROP ROLE r3 CASCADE;
-/*U0*/ Workaround for bug where DDL will not Commit
+/*d*/ Workaround for bug where DDL will not Commit
 /*s*/CREATE TABLE bug_workaround (i int);
 /*s*/INSERT INTO bug_workaround VALUES(1);
 /*u0*/SHUTDOWN;
diff -pruN 2.6.1-1/hsqldb/testrun/hsqldb/TestSelfSchemaCasc.txt 2.7.0-1/hsqldb/testrun/hsqldb/TestSelfSchemaCasc.txt
--- 2.6.1-1/hsqldb/testrun/hsqldb/TestSelfSchemaCasc.txt	2018-10-23 07:24:54.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/hsqldb/TestSelfSchemaCasc.txt	2022-02-21 14:42:04.000000000 +0000
@@ -73,7 +73,7 @@
 /*s*/DROP user sa2 CASCADE;
 /*s*/DROP user sa3 CASCADE;
 
-/*U0*/ Workaround for bug where DDL will not Commit
+-- Workaround for bug where DDL will not Commit
 /*s*/CREATE TABLE bug_workaround (i int);
 /*s*/INSERT INTO bug_workaround VALUES(1);
 /*u0*/SHUTDOWN;
diff -pruN 2.6.1-1/hsqldb/testrun/hsqldb/TestSelfSchemaQuoting.txt 2.7.0-1/hsqldb/testrun/hsqldb/TestSelfSchemaQuoting.txt
--- 2.6.1-1/hsqldb/testrun/hsqldb/TestSelfSchemaQuoting.txt	2018-10-23 07:24:54.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/hsqldb/TestSelfSchemaQuoting.txt	2022-02-21 14:42:06.000000000 +0000
@@ -35,7 +35,7 @@
 /*s*/DROP USER u1;
 /*s*/DROP SCHEMA schema1 CASCADE;
 
-/*U0*/ Workaround for bug where DDL will not Commit
+/*d*/ the following lines are workaround for old bug where DDL will not Commit
 /*s*/CREATE TABLE bug_workaround (i int);
 /*s*/INSERT INTO bug_workaround VALUES(1);
 /*u0*/SHUTDOWN;
diff -pruN 2.6.1-1/hsqldb/testrun/hsqldb/TestSelfSeqRightsA.txt 2.7.0-1/hsqldb/testrun/hsqldb/TestSelfSeqRightsA.txt
--- 2.6.1-1/hsqldb/testrun/hsqldb/TestSelfSeqRightsA.txt	2018-10-23 07:24:54.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/hsqldb/TestSelfSeqRightsA.txt	2022-02-21 14:42:06.000000000 +0000
@@ -1,4 +1,4 @@
--- $Id: TestSelfSeqRightsA.txt 5711 2017-02-20 20:51:35Z fredt $
+-- $Id: TestSelfSeqRightsA.txt 6419 2022-02-16 12:30:15Z fredt $
 -- Test Grants/Revokes for Sequences (not ALTER/CREATE/DROP rights, as
 -- tested in the general schema object test scripts).
 -- We are not testing TABLE rights here.  We know that if the table of the
@@ -69,7 +69,7 @@ GRANT ALL ON bsch.bt TO blaine;
 /*e*/GRANT UPDATE ON SEQUENCE public.ps8 TO public;
 SET SCHEMA public;
 
-/*U*/These two are just workarounds for a DELAY 0 BUG:
+/*d*/following 2 lines are just workarounds for a DELAY 0 BUG:
 UPDATE public.pt SET i = 1;
 COMMIT;
 
@@ -83,8 +83,9 @@ SET SCHEMA public;
 /*c1*/SELECT i, next value for ps1 FROM pt;
 SET SCHEMA bsch;
 /*c1*/SELECT i, next value for public.ps2 FROM public.pt;
+
 -- Don't own - previously threw error but now adds a warning
-/*E*/GRANT ALL ON SEQUENCE public.ps2 TO PUBLIC;
+GRANT ALL ON SEQUENCE public.ps2 TO PUBLIC;
 /*u0*/GRANT ALL ON SEQUENCE bsch.bs5 TO PUBLIC;
 -- By virtue of schema ownership
 /*c1*/SELECT i, next value for bs2 FROM bt;
diff -pruN 2.6.1-1/hsqldb/testrun/hsqldb/TestSelfSeqRightsB.txt 2.7.0-1/hsqldb/testrun/hsqldb/TestSelfSeqRightsB.txt
--- 2.6.1-1/hsqldb/testrun/hsqldb/TestSelfSeqRightsB.txt	2018-10-23 07:24:52.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/hsqldb/TestSelfSeqRightsB.txt	2022-02-21 14:42:04.000000000 +0000
@@ -1,4 +1,4 @@
--- $Id: TestSelfSeqRightsB.txt 5711 2017-02-20 20:51:35Z fredt $
+-- $Id: TestSelfSeqRightsB.txt 6419 2022-02-16 12:30:15Z fredt $
 -- Test .log persistence of Sequence rights
 
 CONNECT USER blaine PASSWORD "b";
@@ -12,13 +12,15 @@ SET SCHEMA public;
 /*c1*/SELECT i, next value for ps1 FROM pt;
 SET SCHEMA bsch;
 /*c1*/SELECT i, next value for public.ps2 FROM public.pt;
+
 -- Don't own - previously threw error but now adds a warning
-/*E*/GRANT ALL ON SEQUENCE public.ps2 TO PUBLIC;
+GRANT ALL ON SEQUENCE public.ps2 TO PUBLIC;
 /*u0*/GRANT ALL ON SEQUENCE bsch.bs5 TO PUBLIC;
 -- By virtue of schema ownership
 /*c1*/SELECT i, next value for bs2 FROM bt;
 SET SCHEMA public;
 /*c1*/SELECT i, next value for bsch.bs1 FROM bsch.bt;
+
 -- Enough schema specification testing.  Just use defauls Session schema for
 -- here on in
 /*c1*/SELECT i FROM pt;
diff -pruN 2.6.1-1/hsqldb/testrun/hsqldb/TestSelfSeqRightsC.txt 2.7.0-1/hsqldb/testrun/hsqldb/TestSelfSeqRightsC.txt
--- 2.6.1-1/hsqldb/testrun/hsqldb/TestSelfSeqRightsC.txt	2018-10-23 07:24:52.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/hsqldb/TestSelfSeqRightsC.txt	2022-02-21 14:42:06.000000000 +0000
@@ -1,4 +1,4 @@
--- $Id: TestSelfSeqRightsC.txt 5711 2017-02-20 20:51:35Z fredt $
+-- $Id: TestSelfSeqRightsC.txt 6419 2022-02-16 12:30:15Z fredt $
 -- Test .script persistence of Sequence rights
 
 CONNECT USER blaine PASSWORD "b";
@@ -11,13 +11,16 @@ SET SCHEMA public;
 /*c1*/SELECT i, next value for ps1 FROM pt;
 SET SCHEMA bsch;
 /*c1*/SELECT i, next value for public.ps2 FROM public.pt;
+
 -- Don't own - previously threw error but now adds a warning
-/*E*/GRANT ALL ON SEQUENCE public.ps2 TO PUBLIC;
+GRANT ALL ON SEQUENCE public.ps2 TO PUBLIC;
 /*u0*/GRANT ALL ON SEQUENCE bsch.bs5 TO PUBLIC;
+
 -- By virtue of schema ownership
 /*c1*/SELECT i, next value for bs2 FROM bt;
 SET SCHEMA public;
 /*c1*/SELECT i, next value for bsch.bs1 FROM bsch.bt;
+
 -- Enough schema specification testing.  Just use defauls Session schema for
 -- here on in
 /*c1*/SELECT i FROM pt;
diff -pruN 2.6.1-1/hsqldb/testrun/hsqldb/TestSelf.txt 2.7.0-1/hsqldb/testrun/hsqldb/TestSelf.txt
--- 2.6.1-1/hsqldb/testrun/hsqldb/TestSelf.txt	2020-12-07 23:50:26.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/hsqldb/TestSelf.txt	2022-02-21 14:42:06.000000000 +0000
@@ -11,9 +11,20 @@
 --   r <string>   ResultSet expected with <string> result in first row/column
 --   u <count>    Update count <count> expected
 --   e            Exception must occur
-
+--   see TestUtil code for more details on tags
 --
 set database transaction control locks
+
+-- demonstration of codes used
+/*d* Some demo lines
+/*c1*/select * from information_schema.tables limit 1
+/*r
+ PUBLIC*/select table_catalog from information_schema.tables limit 1
+/*e*/select '''
+/*d* Next section dumps one line of result
+/*o*/select * from information_schema.tables limit 1
+/*C1*/select * from information_schema.tables limit 1
+
 -- Miscelaneous tests by fredt
 -- bug #897591
 /*rgood*/CALL CASEWHEN(CURTIME() BETWEEN CAST('00:00:00'  AS  TIME) AND CAST('23:59:59'  AS TIME), 'good', 'bad')
diff -pruN 2.6.1-1/hsqldb/testrun/hsqldb/TestSelfUnions.txt 2.7.0-1/hsqldb/testrun/hsqldb/TestSelfUnions.txt
--- 2.6.1-1/hsqldb/testrun/hsqldb/TestSelfUnions.txt	2018-10-23 07:24:54.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/hsqldb/TestSelfUnions.txt	2022-02-21 14:42:06.000000000 +0000
@@ -23,6 +23,7 @@ INSERT INTO C VALUES(5)
 -- limits
 /*c5*/SELECT * FROM A UNION SELECT * FROM C ORDER BY ID
 /*c4*/(SELECT * FROM A ORDER BY ID LIMIT 1 OFFSET 0) UNION SELECT * FROM C
+/*c4*/(SELECT * FROM A ORDER BY ID LIMIT 1 OFFSET 0) UNION ALL SELECT * FROM C
 /*c4*/SELECT * FROM A UNION (SELECT * FROM C ORDER BY ID LIMIT 2 OFFSET 0) LIMIT 4 OFFSET 0
 /*r
  2
@@ -92,6 +93,7 @@ CREATE VIEW V3 AS SELECT * FROM A UNION
 /*c3*/SELECT * FROM A WHERE ID IN (SELECT * FROM A UNION SELECT * FROM C INTERSECT (SELECT * FROM B EXCEPT SELECT * FROM B))
 /*c3*/SELECT * FROM A WHERE EXISTS (SELECT * FROM A UNION SELECT * FROM C INTERSECT (SELECT * FROM B EXCEPT SELECT * FROM B))
 /*c0*/SELECT * FROM A WHERE EXISTS (SELECT * FROM A EXCEPT SELECT * FROM C EXCEPT SELECT * FROM B)
+
 --- correlated union
 create table bt1 ( id varchar(10) );
 create table bt2 ( id varchar(10) );
@@ -101,18 +103,21 @@ insert into bt1( id ) values ( 'bbb' );
 insert into bt1( id ) values ( 'ccc' );
 insert into bt2( id ) values ( 'aaa' );
 insert into bt3( id ) values ( 'bbb' );
-/*U*/ the t1.id reference in the next test is not resolved in some runs - only after code changes result in failure
+
+-- the t1.id reference in the next test is not resolved in some runs - only after code changes result in failure
 /*c1*/select * from bt1 as t1
  where not exists(
    select id from bt2 as t2 where t2.id = t1.id
    union all
    select id from bt3 as t3 where t3.id = t1.id );
+
 --- null as column in first select
 create table au (id int, b1 boolean);
 create table bu (id int);
 insert into au values(1,true);
 insert into bu values(2);
 select id, null as b1 from bu union select id, b1 from au;
+
 --
 drop table test if exists;
 create table test(my_col numeric(10));
@@ -122,5 +127,16 @@ select my_col, 0 mycol from test
  union
  select 0 mycol2, my_col from test
 
+SET DATABASE SQL SYNTAX ORA TRUE
 
+/*r
+ 0.0E0
+ 0.0E0
+*/SELECT val FROM (SELECT 0 val FROM dual) UNION ALL SELECT cast(0 AS double) FROM dual;
+
+/*r
+ 0.0E0
+ 0.0E0
+*/SELECT val FROM (SELECT 0 val FROM dual) UNION ALL SELECT 0E0 FROM dual;
 
+SET DATABASE SQL SYNTAX ORA FALSE
diff -pruN 2.6.1-1/hsqldb/testrun/hsqldb/TestTriggers.txt 2.7.0-1/hsqldb/testrun/hsqldb/TestTriggers.txt
--- 2.6.1-1/hsqldb/testrun/hsqldb/TestTriggers.txt	2018-10-23 07:24:54.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/hsqldb/TestTriggers.txt	2022-02-21 14:42:04.000000000 +0000
@@ -1,4 +1,4 @@
-drop table testtrig if exists;
+drop table testtrig if exists cascade;
 create cached table testtrig(c1 integer generated by default as identity, c2 varchar(40), c3 integer);
 create trigger tbir before insert on testtrig referencing new row as newrow
  for each row when (newrow.c2 is not null)
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J001_Embedded_Java/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J001_Embedded_Java/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J001_Embedded_Java/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J001_Embedded_Java/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings.J001_Embedded_Java;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J001_Embedded_Java/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J001_Embedded_Java/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J001_Embedded_Java/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J001_Embedded_Java/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J002_ResultSetIterator_access_to_JDBC_ResultSet/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J002_ResultSetIterator_access_to_JDBC_ResultSet/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J002_ResultSetIterator_access_to_JDBC_ResultSet/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J002_ResultSetIterator_access_to_JDBC_ResultSet/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings.J002_ResultSetIterator_access_to_JDBC_ResultSet;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J002_ResultSetIterator_access_to_JDBC_ResultSet/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J002_ResultSetIterator_access_to_JDBC_ResultSet/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J002_ResultSetIterator_access_to_JDBC_ResultSet/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J002_ResultSetIterator_access_to_JDBC_ResultSet/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J003_Execution_control/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J003_Execution_control/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J003_Execution_control/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J003_Execution_control/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings.J003_Execution_control;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J003_Execution_control/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J003_Execution_control/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J003_Execution_control/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J003_Execution_control/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J004_Batch_update/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J004_Batch_update/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J004_Batch_update/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J004_Batch_update/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings.J004_Batch_update;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J004_Batch_update/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J004_Batch_update/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J004_Batch_update/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J004_Batch_update/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J005_Call_statement/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J005_Call_statement/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J005_Call_statement/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J005_Call_statement/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings.J005_Call_statement;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J005_Call_statement/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J005_Call_statement/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J005_Call_statement/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J005_Call_statement/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J006_Assignment_Function_statement/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J006_Assignment_Function_statement/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J006_Assignment_Function_statement/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J006_Assignment_Function_statement/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings.J006_Assignment_Function_statement;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J006_Assignment_Function_statement/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J006_Assignment_Function_statement/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J006_Assignment_Function_statement/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J006_Assignment_Function_statement/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J007_Compound_statement/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J007_Compound_statement/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J007_Compound_statement/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J007_Compound_statement/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings.J007_Compound_statement;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J007_Compound_statement/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J007_Compound_statement/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J007_Compound_statement/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J007_Compound_statement/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J008_Datalinks_via_SQL_language/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J008_Datalinks_via_SQL_language/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J008_Datalinks_via_SQL_language/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J008_Datalinks_via_SQL_language/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings.J008_Datalinks_via_SQL_language;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J008_Datalinks_via_SQL_language/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J008_Datalinks_via_SQL_language/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J008_Datalinks_via_SQL_language/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J008_Datalinks_via_SQL_language/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J009_Multiple_Open_ResultSets/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J009_Multiple_Open_ResultSets/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J009_Multiple_Open_ResultSets/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J009_Multiple_Open_ResultSets/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings.J009_Multiple_Open_ResultSets;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J009_Multiple_Open_ResultSets/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J009_Multiple_Open_ResultSets/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J009_Multiple_Open_ResultSets/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J009_Multiple_Open_ResultSets/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J010_XML_via_SQL_language/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J010_XML_via_SQL_language/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J010_XML_via_SQL_language/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J010_XML_via_SQL_language/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings.J010_XML_via_SQL_language;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J010_XML_via_SQL_language/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J010_XML_via_SQL_language/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J010_XML_via_SQL_language/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/J010_XML_via_SQL_language/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_10_SQLOLB_Object_Language_Bindings/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F021_Basic_information_schema/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F021_Basic_information_schema/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F021_Basic_information_schema/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F021_Basic_information_schema/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas.F021_Basic_information_schema;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F021_Basic_information_schema/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F021_Basic_information_schema/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F021_Basic_information_schema/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F021_Basic_information_schema/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F231_Privilege_tables/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F231_Privilege_tables/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F231_Privilege_tables/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F231_Privilege_tables/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas.F231_Privilege_tables;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F231_Privilege_tables/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F231_Privilege_tables/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F231_Privilege_tables/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F231_Privilege_tables/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F341_Usage_tables/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F341_Usage_tables/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F341_Usage_tables/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F341_Usage_tables/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas.F341_Usage_tables;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F341_Usage_tables/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F341_Usage_tables/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F341_Usage_tables/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F341_Usage_tables/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F501_Features_and_conformance_views/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F501_Features_and_conformance_views/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F501_Features_and_conformance_views/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F501_Features_and_conformance_views/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas.F501_Features_and_conformance_views;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F501_Features_and_conformance_views/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F501_Features_and_conformance_views/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F501_Features_and_conformance_views/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F501_Features_and_conformance_views/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F502_Enhanced_documentation_tables/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F502_Enhanced_documentation_tables/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F502_Enhanced_documentation_tables/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F502_Enhanced_documentation_tables/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas.F502_Enhanced_documentation_tables;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F502_Enhanced_documentation_tables/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F502_Enhanced_documentation_tables/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F502_Enhanced_documentation_tables/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F502_Enhanced_documentation_tables/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F696_Additional_translation_documentation/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F696_Additional_translation_documentation/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F696_Additional_translation_documentation/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F696_Additional_translation_documentation/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas.F696_Additional_translation_documentation;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F696_Additional_translation_documentation/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F696_Additional_translation_documentation/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F696_Additional_translation_documentation/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/F696_Additional_translation_documentation/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/S011_Distinct_data_types/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/S011_Distinct_data_types/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/S011_Distinct_data_types/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/S011_Distinct_data_types/package-info.java	2022-03-27 12:38:38.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas.S011_Distinct_data_types;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/S011_Distinct_data_types/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/S011_Distinct_data_types/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/S011_Distinct_data_types/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/S011_Distinct_data_types/README.md	2022-03-27 12:38:38.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/T011_Timestamp_in_Information_Schema/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/T011_Timestamp_in_Information_Schema/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/T011_Timestamp_in_Information_Schema/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/T011_Timestamp_in_Information_Schema/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas.T011_Timestamp_in_Information_Schema;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/T011_Timestamp_in_Information_Schema/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/T011_Timestamp_in_Information_Schema/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/T011_Timestamp_in_Information_Schema/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/T011_Timestamp_in_Information_Schema/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/T321_Basic_SQL_invoked_routines/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/T321_Basic_SQL_invoked_routines/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/T321_Basic_SQL_invoked_routines/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/T321_Basic_SQL_invoked_routines/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas.T321_Basic_SQL_invoked_routines;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/T321_Basic_SQL_invoked_routines/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/T321_Basic_SQL_invoked_routines/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/T321_Basic_SQL_invoked_routines/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/T321_Basic_SQL_invoked_routines/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/T322_Declared_data_type_attributes/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/T322_Declared_data_type_attributes/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/T322_Declared_data_type_attributes/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/T322_Declared_data_type_attributes/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas.T322_Declared_data_type_attributes;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/T322_Declared_data_type_attributes/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/T322_Declared_data_type_attributes/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/T322_Declared_data_type_attributes/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_11_SQLSchemata_Information_and_Definition_Schemas/T322_Declared_data_type_attributes/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J511_Commands/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J511_Commands/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J511_Commands/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J511_Commands/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language.J511_Commands;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J511_Commands/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J511_Commands/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J511_Commands/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J511_Commands/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J521_JDBC_data_types/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J521_JDBC_data_types/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J521_JDBC_data_types/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J521_JDBC_data_types/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language.J521_JDBC_data_types;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J521_JDBC_data_types/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J521_JDBC_data_types/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J521_JDBC_data_types/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J521_JDBC_data_types/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J531_Deployment/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J531_Deployment/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J531_Deployment/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J531_Deployment/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language.J531_Deployment;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J531_Deployment/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J531_Deployment/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J531_Deployment/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J531_Deployment/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J541_SERIALIZABLE/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J541_SERIALIZABLE/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J541_SERIALIZABLE/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J541_SERIALIZABLE/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language.J541_SERIALIZABLE;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J541_SERIALIZABLE/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J541_SERIALIZABLE/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J541_SERIALIZABLE/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J541_SERIALIZABLE/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J551_SQLDATA/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J551_SQLDATA/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J551_SQLDATA/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J551_SQLDATA/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language.J551_SQLDATA;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J551_SQLDATA/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J551_SQLDATA/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J551_SQLDATA/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J551_SQLDATA/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J561_JAR_privileges/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J561_JAR_privileges/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J561_JAR_privileges/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J561_JAR_privileges/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language.J561_JAR_privileges;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J561_JAR_privileges/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J561_JAR_privileges/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J561_JAR_privileges/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J561_JAR_privileges/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J571_NEW_operator/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J571_NEW_operator/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J571_NEW_operator/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J571_NEW_operator/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language.J571_NEW_operator;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J571_NEW_operator/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J571_NEW_operator/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J571_NEW_operator/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J571_NEW_operator/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J581_Output_parameters/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J581_Output_parameters/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J581_Output_parameters/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J581_Output_parameters/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language.J581_Output_parameters;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J581_Output_parameters/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J581_Output_parameters/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J581_Output_parameters/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J581_Output_parameters/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J591_Overloading/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J591_Overloading/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J591_Overloading/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J591_Overloading/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language.J591_Overloading;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J591_Overloading/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J591_Overloading/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J591_Overloading/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J591_Overloading/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J601_SQL_Java_paths/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J601_SQL_Java_paths/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J601_SQL_Java_paths/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J601_SQL_Java_paths/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language.J601_SQL_Java_paths;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J601_SQL_Java_paths/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J601_SQL_Java_paths/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J601_SQL_Java_paths/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J601_SQL_Java_paths/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J611_References/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J611_References/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J611_References/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J611_References/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language.J611_References;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J611_References/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J611_References/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J611_References/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J611_References/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J621_external_Java_routines/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J621_external_Java_routines/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J621_external_Java_routines/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J621_external_Java_routines/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language.J621_external_Java_routines;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J621_external_Java_routines/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J621_external_Java_routines/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J621_external_Java_routines/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J621_external_Java_routines/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J622_external_Java_types/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J622_external_Java_types/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J622_external_Java_types/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J622_external_Java_types/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language.J622_external_Java_types;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J622_external_Java_types/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J622_external_Java_types/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J622_external_Java_types/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J622_external_Java_types/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J631_Java_signatures/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J631_Java_signatures/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J631_Java_signatures/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J631_Java_signatures/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language.J631_Java_signatures;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J631_Java_signatures/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J631_Java_signatures/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J631_Java_signatures/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J631_Java_signatures/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J641_Static_fields/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J641_Static_fields/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J641_Static_fields/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J641_Static_fields/package-info.java	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language.J641_Static_fields;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J641_Static_fields/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J641_Static_fields/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J641_Static_fields/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J641_Static_fields/README.md	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J651_SQLJRT_Information_Schema/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J651_SQLJRT_Information_Schema/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J651_SQLJRT_Information_Schema/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J651_SQLJRT_Information_Schema/package-info.java	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language.J651_SQLJRT_Information_Schema;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J651_SQLJRT_Information_Schema/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J651_SQLJRT_Information_Schema/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J651_SQLJRT_Information_Schema/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J651_SQLJRT_Information_Schema/README.md	2022-03-09 18:43:40.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J652_SQLJRT_Usage_tables/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J652_SQLJRT_Usage_tables/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J652_SQLJRT_Usage_tables/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/J652_SQLJRT_Usage_tables/README.md	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/package-info.java	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_13_SQLJRT_SQL_Routines_and_Types_Using_the_Java_Programming_Language/README.md	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_14_SQLXML_Extensible_Markup_Language_Related_Specifications/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_14_SQLXML_Extensible_Markup_Language_Related_Specifications/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_14_SQLXML_Extensible_Markup_Language_Related_Specifications/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_14_SQLXML_Extensible_Markup_Language_Related_Specifications/package-info.java	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_14_SQLXML_Extensible_Markup_Language_Related_Specifications;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_14_SQLXML_Extensible_Markup_Language_Related_Specifications/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_14_SQLXML_Extensible_Markup_Language_Related_Specifications/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_14_SQLXML_Extensible_Markup_Language_Related_Specifications/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_14_SQLXML_Extensible_Markup_Language_Related_Specifications/README.md	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1,142 @@
+# SQL2NNN 9075-14 — Part 14: XML-Related Specifications (SQL/XML)
+## Annex F (informative) Feature taxonomy
+#### Table 16 — Feature taxonomy for optional features
+
+| Feature ID | Feature Name                                                                |
+|------------|-----------------------------------------------------------------------------|
+| X010       | XML type                                                                    |
+| X011       | Arrays of XML type                                                          |
+| X012       | Multisets of XML type                                                       |
+| X013       | Distinct types of XML type                                                  |
+| X014       | Attributes of XML type                                                      |
+| X015       | Fields of XML type                                                          |
+| X016       | Persistent XML values                                                       |
+| X020       | XMLConcat                                                                   |																|
+| X025       | XMLCast                                                                     |
+| X030       | XMLDocument                                                                 |
+| X031       | XMLElement                                                                  |
+| X032       | XMLForest                                                                   |
+| X034       | XMLAgg                                                                      |
+| X035       | XMLAgg: ORDER BY option                                                     |
+| X036       | XMLComment                                                                  |
+| X037       | XMLPI                                                                       |
+| X038       | XMLText                                                                     |
+| X040       | Basic table mapping                                                         |
+| X041       | Basic table mapping: null absent                                            |
+| X042       | Basic table mapping: null as nil                                            |
+| X043       | Basic table mapping: table as forest                                        |
+| X044       | Basic table mapping: table as element                                       |
+| X045       | Basic table mapping: with target namespace                                  |
+| X046       | Basic table mapping: data mapping                                           |
+| X047       | Basic table mapping: metadata mapping                                       |
+| X048       | Basic table mapping: base64 encoding of binary strings                      |
+| X049       | Basic table mapping: hex encoding of binary strings                         |
+| X050       | Advanced table mapping                                                      |
+| X051       | Advanced table mapping: null absent                                         |
+| X052       | Advanced table mapping: null as nil                                         |
+| X053       | Advanced table mapping: table as forest                                     |
+| X054       | Advanced table mapping: table as element                                    |
+| X055       | Advanced table mapping: with target namespace                               |
+| X056       | Advanced table mapping: data mapping                                        |
+| X057       | Advanced table mapping: metadata mapping                                    |
+| X058       | Advanced table mapping: base64 encoding of binary strings                   |
+| X059       | Advanced table mapping: hex encoding of binary strings                      |
+| X060       | XMLParse: Character string input and CONTENT option                         |
+| X061       | XMLParse: Character string input and DOCUMENT option                        |
+| X065       | XMLParse: BLOB input and CONTENT option                                     |
+| X066       | XMLParse: BLOB input and DOCUMENT option                                    |
+| X068       | XMLSerialize: BOM                                                           |
+| X069       | XMLSerialize: INDENT                                                        |
+| X070       | XMLSerialize: Character string serialization and CONTENT option             |
+| X071       | XMLSerialize: Character string serialization and DOCUMENT option            |
+| X072       | XMLSerialize: Character string serialization                                |
+| X073       | XMLSerialize: BLOB serialization and CONTENT option                         |
+| X074       | XMLSerialize: BLOB serialization and DOCUMENT option                        |
+| X075       | XMLSerialize: BLOB serialization                                            |
+| X076       | XMLSerialize: VERSION                                                       |
+| X077       | XMLSerialize: explicit ENCODING option                                      |
+| X078       | XMLSerialize: explicit XML declaration                                      |
+| X080       | Namespaces in XML publishing                                                |
+| X081       | Query-level XML namespace declarations                                      |
+| X082       | XML namespace declarations in DML                                           |
+| X083       | XML namespace declarations in DDL                                           |
+| X084       | XML namespace declarations in compound statements                           |
+| X085       | Predefined namespace prefixes59 X086 XML namespace declarations in XMLTable |
+| X090       | XML document predicate                                                      |
+| X091       | XML content predicate                                                       |
+| X096       | XMLExists                                                                   |
+| X100       | Host language support for XML: CONTENT option                               |
+| X101       | Host language support for XML: DOCUMENT option                              |
+| X110       | Host language support for XML: VARCHAR mapping                              |
+| X111       | Host language support for XML: CLOB mapping                                 |
+| X112       | Host language support for XML: BLOB mapping                                 |
+| X113       | Host language support for XML: STRIP WHITESPACE option                      |
+| X114       | Host language support for XML: PRESERVE WHITESPACE option                   |
+| X120       | XML parameters in SQL routines                                              |
+| X121       | XML parameters in external routines                                         |
+| X131       | Query-level XMLBINARY clause                                                |
+| X132       | XMLBINARY clause in DML                                                     |
+| X133       | XMLBINARY clause in DDL                                                     |
+| X134       | XMLBINARY clause in compound statements                                     |
+| X135       | XMLBINARY clause in subqueries                                              |
+| X141       | IS VALID predicate: data-driven case                                        |
+| X142       | IS VALID predicate: ACCORDING TO clause                                     |
+| X143       | IS VALID predicate: ELEMENT clause                                          |
+| X144       | IS VALID predicate: schema location                                         |
+| X145       | IS VALID predicate outside check constraints                                |
+| X151       | IS VALID predicate with DOCUMENT option                                     |
+| X152       | IS VALID predicate with CONTENT option                                      |
+| X153       | IS VALID predicate with SEQUENCE option                                     |
+| X155       | IS VALID predicate: NAMESPACE without ELEMENT clause                        |
+| X157       | IS VALID predicate: NO NAMESPACE with ELEMENT clause                        |
+| X160       | Basic Information Schema for registered XML Schemas                         |
+| X161       | Advanced Information Schema for registered XML Schemas                      |
+| X170       | XML null handling options                                                   |
+| X171       | NIL ON NO CONTENT option                                                    |
+| X181       | XML(DOCUMENT(UNTYPED)) type                                                 |
+| X182       | XML(DOCUMENT(ANY)) type                                                     |
+| X190       | XML(SEQUENCE) type                                                          |
+| X191       | XML(DOCUMENT(XMLSCHEMA)) type                                               |
+| X192       | XML(CONTENT(XMLSCHEMA)) type                                                |
+| X200       | XMLQuery                                                                    |
+| X201       | XMLQuery: RETURNING CONTENT                                                 |
+| X202       | XMLQuery: RETURNING SEQUENCE                                                |
+| X203       | XMLQuery: passing a context item                                            |
+| X204       | XMLQuery: initializing an XQuery variable                                   |
+| X205       | XMLQuery: EMPTY ON EMPTY option                                             |
+| X206       | XMLQuery: NULL ON EMPTY option                                              |
+| X211       | XML 1.1 support                                                             |
+| X221       | XML passing mechanism BY VALUE                                              |
+| X222       | XML passing mechanism BY REF                                                |
+| X231       | XML(CONTENT(UNTYPED)) type                                                  |
+| X232       | XML(CONTENT(ANY)) type                                                      |
+| X241       | RETURNING CONTENT in XML publishing                                         |
+| X242       | RETURNING SEQUENCE in XML publishing                                        |
+| X251       | Persistent XML values of XML(DOCUMENT(UNTYPED)) type                        |
+| X252       | Persistent XML values of XML(DOCUMENT(ANY)) type                            |
+| X253       | Persistent XML values of XML(CONTENT(UNTYPED)) type                         |
+| X254       | Persistent XML values of XML(CONTENT(ANY)) type                             |
+| X255       | Persistent XML values of XML(SEQUENCE) type                                 |
+| X256       | Persistent XML values of XML(DOCUMENT(XMLSCHEMA)) type                      |
+| X257       | Persistent XML values of XML(CONTENT(XMLSCHEMA)) type                       |
+| X260       | XML type: ELEMENT clause                                                    |
+| X261       | XML type: NAMESPACE without ELEMENT clause                                  |
+| X263       | XML type: NO NAMESPACE with ELEMENT clause                                  |
+| X264       | XML type: schema location                                                   |
+| X271       | XMLValidate: data-driven case                                               |
+| X272       | XMLValidate: ACCORDING TO clause                                            |
+| X273       | XMLValidate: ELEMENT clause                                                 |
+| X274       | XMLValidate: schema location                                                |
+| X281       | XMLValidate: with DOCUMENT option                                           |
+| X282       | XMLValidate with CONTENT option                                             |
+| X283       | XMLValidate with SEQUENCE option                                            |
+| X284       | XMLValidate NAMESPACE without ELEMENT clause                                |
+| X286       | XMLValidate: NO NAMESPACE with ELEMENT clause                               |
+| X300       | XMLTable                                                                    |
+| X301       | XMLTable: derived column list option                                        |
+| X302       | XMLTable: ordinality column option                                          |
+| X303       | XMLTable: column default option                                             |
+| X304       | XMLTable: passing a context item                                            |
+| X305       | XMLTable: initializing an XQuery variable                                   |
+| X400       | Name and identifier mapping                                                 |
+| X410       | Alter column data type: XML type                                            |
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/B021_Direct_SQL/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/B021_Direct_SQL/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/B021_Direct_SQL/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/B021_Direct_SQL/package-info.java	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.B021_Direct_SQL;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/B021_Direct_SQL/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/B021_Direct_SQL/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/B021_Direct_SQL/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/B021_Direct_SQL/README.md	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/B128_Routine_language_SQL/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/B128_Routine_language_SQL/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/B128_Routine_language_SQL/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/B128_Routine_language_SQL/package-info.java	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.B128_Routine_language_SQL;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/B128_Routine_language_SQL/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/B128_Routine_language_SQL/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/B128_Routine_language_SQL/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/B128_Routine_language_SQL/README.md	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/C011_Call_Level_Interface/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/C011_Call_Level_Interface/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/C011_Call_Level_Interface/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/C011_Call_Level_Interface/package-info.java	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.C011_Call_Level_Interface;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/C011_Call_Level_Interface/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/C011_Call_Level_Interface/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/C011_Call_Level_Interface/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/C011_Call_Level_Interface/README.md	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E011_Numeric_data_types/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E011_Numeric_data_types/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E011_Numeric_data_types/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E011_Numeric_data_types/package-info.java	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.E011_Numeric_data_types;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E011_Numeric_data_types/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E011_Numeric_data_types/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E011_Numeric_data_types/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E011_Numeric_data_types/README.md	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E021_Character_data_types/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E021_Character_data_types/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E021_Character_data_types/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E021_Character_data_types/package-info.java	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.E021_Character_data_types;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E021_Character_data_types/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E021_Character_data_types/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E021_Character_data_types/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E021_Character_data_types/README.md	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E021_Character_string_types/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E021_Character_string_types/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E021_Character_string_types/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E021_Character_string_types/package-info.java	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.E021_Character_string_types;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E021_Character_string_types/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E021_Character_string_types/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E021_Character_string_types/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E021_Character_string_types/README.md	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E031_identifiers/E031_Identifiers_03_Trailing_underscore.sql 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E031_identifiers/E031_Identifiers_03_Trailing_underscore.sql
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E031_identifiers/E031_Identifiers_03_Trailing_underscore.sql	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E031_identifiers/E031_Identifiers_03_Trailing_underscore.sql	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1,11 @@
+-- Test of SQL Feasture E03 - Identifiers, Subfeatrure 03 - Trailing underscore
+/*s*/DROP TABLE IF EXISTS TEST_;
+/*s*/CREATE TABLE TEST_(ID_ INT);
+/*c1*/SELECT COUNT(*) AS TABLE_COUNT FROM INFORMATION_SCHEMA.TABLES T WHERE T.TABLE_SCHEMA = 'PUBLIC' AND T.TABLE_NAME = 'TEST_';
+/*s*/ALTER TABLE TEST_ ADD COLUMN VALUE_ VARCHAR(255) NOT NULL;
+/*c1*/SELECT COUNT(*) AS COLUMN_COUNT FROM INFORMATION_SCHEMA.COLUMNS T WHERE T.TABLE_SCHEMA = 'PUBLIC' AND T.TABLE_NAME = 'TEST_' AND T.COLUMN_NAME = 'VALUE_';
+/*s*/ALTER TABLE TEST_ DROP COLUMN VALUE_;
+/*c1*/SELECT COUNT(*)  AS COLUMN_COUNT FROM INFORMATION_SCHEMA.COLUMNS T WHERE T.TABLE_SCHEMA = 'PUBLIC' AND T.TABLE_NAME = 'TEST_' AND T.COLUMN_NAME = 'VALUE_';
+/*s*/DROP TABLE TEST_;
+/*c1*/SELECT COUNT(*) AS TABLE_COUNT FROM INFORMATION_SCHEMA.TABLES T WHERE T.TABLE_SCHEMA = 'PUBLIC' AND T.TABLE_NAME = 'TEST_';
+
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E031_identifiers/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E031_identifiers/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E031_identifiers/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E031_identifiers/package-info.java	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.E031_identifiers;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E031_identifiers/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E031_identifiers/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E031_identifiers/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E031_identifiers/README.md	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E051_Basic_query_specification/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E051_Basic_query_specification/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E051_Basic_query_specification/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E051_Basic_query_specification/package-info.java	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.E051_Basic_query_specification;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E051_Basic_query_specification/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E051_Basic_query_specification/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E051_Basic_query_specification/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E051_Basic_query_specification/README.md	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E061_Basic_predicates_and_search_conditions/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E061_Basic_predicates_and_search_conditions/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E061_Basic_predicates_and_search_conditions/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E061_Basic_predicates_and_search_conditions/package-info.java	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.E061_Basic_predicates_and_search_conditions;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E061_Basic_predicates_and_search_conditions/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E061_Basic_predicates_and_search_conditions/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E061_Basic_predicates_and_search_conditions/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E061_Basic_predicates_and_search_conditions/README.md	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E071_Basic_query_expressions/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E071_Basic_query_expressions/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E071_Basic_query_expressions/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E071_Basic_query_expressions/package-info.java	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.E071_Basic_query_expressions;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E071_Basic_query_expressions/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E071_Basic_query_expressions/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E071_Basic_query_expressions/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E071_Basic_query_expressions/README.md	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E081_Basic_Privileges/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E081_Basic_Privileges/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E081_Basic_Privileges/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E081_Basic_Privileges/package-info.java	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.E081_Basic_Privileges;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E081_Basic_Privileges/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E081_Basic_Privileges/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E081_Basic_Privileges/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E081_Basic_Privileges/README.md	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E091_Set_functions/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E091_Set_functions/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E091_Set_functions/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E091_Set_functions/package-info.java	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.E091_Set_functions;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E091_Set_functions/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E091_Set_functions/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E091_Set_functions/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E091_Set_functions/README.md	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E101_Basic_data_manipulation/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E101_Basic_data_manipulation/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E101_Basic_data_manipulation/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E101_Basic_data_manipulation/package-info.java	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.E101_Basic_data_manipulation;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E101_Basic_data_manipulation/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E101_Basic_data_manipulation/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E101_Basic_data_manipulation/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E101_Basic_data_manipulation/README.md	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E111_Single_row_SELECT_statement/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E111_Single_row_SELECT_statement/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E111_Single_row_SELECT_statement/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E111_Single_row_SELECT_statement/package-info.java	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.E111_Single_row_SELECT_statement;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E111_Single_row_SELECT_statement/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E111_Single_row_SELECT_statement/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E111_Single_row_SELECT_statement/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E111_Single_row_SELECT_statement/README.md	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E121_Basic_cursor_support/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E121_Basic_cursor_support/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E121_Basic_cursor_support/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E121_Basic_cursor_support/package-info.java	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.E121_Basic_cursor_support;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E121_Basic_cursor_support/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E121_Basic_cursor_support/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E121_Basic_cursor_support/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E121_Basic_cursor_support/README.md	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E131_Null_value_support_nulls_in_lieu_of_values/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E131_Null_value_support_nulls_in_lieu_of_values/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E131_Null_value_support_nulls_in_lieu_of_values/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E131_Null_value_support_nulls_in_lieu_of_values/package-info.java	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.E131_Null_value_support_nulls_in_lieu_of_values;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E131_Null_value_support_nulls_in_lieu_of_values/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E131_Null_value_support_nulls_in_lieu_of_values/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E131_Null_value_support_nulls_in_lieu_of_values/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E131_Null_value_support_nulls_in_lieu_of_values/README.md	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E141_Basic_integrity_constraints/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E141_Basic_integrity_constraints/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E141_Basic_integrity_constraints/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E141_Basic_integrity_constraints/package-info.java	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.E141_Basic_integrity_constraints;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E141_Basic_integrity_constraints/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E141_Basic_integrity_constraints/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E141_Basic_integrity_constraints/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E141_Basic_integrity_constraints/README.md	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E151_Transaction_support/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E151_Transaction_support/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E151_Transaction_support/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E151_Transaction_support/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.E151_Transaction_support;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E151_Transaction_support/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E151_Transaction_support/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E151_Transaction_support/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E151_Transaction_support/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E152_Basic_SET_TRANSACTION_statement/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E152_Basic_SET_TRANSACTION_statement/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E152_Basic_SET_TRANSACTION_statement/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E152_Basic_SET_TRANSACTION_statement/package-info.java	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.E152_Basic_SET_TRANSACTION_statement;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E152_Basic_SET_TRANSACTION_statement/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E152_Basic_SET_TRANSACTION_statement/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E152_Basic_SET_TRANSACTION_statement/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E152_Basic_SET_TRANSACTION_statement/README.md	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E153_Updatable_queries_with_subqueries/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E153_Updatable_queries_with_subqueries/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E153_Updatable_queries_with_subqueries/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E153_Updatable_queries_with_subqueries/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.E153_Updatable_queries_with_subqueries;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E153_Updatable_queries_with_subqueries/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E153_Updatable_queries_with_subqueries/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E153_Updatable_queries_with_subqueries/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E153_Updatable_queries_with_subqueries/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E161_SQL_comments_using_leading_double_minus/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E161_SQL_comments_using_leading_double_minus/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E161_SQL_comments_using_leading_double_minus/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E161_SQL_comments_using_leading_double_minus/package-info.java	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.E161_SQL_comments_using_leading_double_minus;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E161_SQL_comments_using_leading_double_minus/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E161_SQL_comments_using_leading_double_minus/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E161_SQL_comments_using_leading_double_minus/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E161_SQL_comments_using_leading_double_minus/README.md	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E171_SQLSTATE_support/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E171_SQLSTATE_support/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E171_SQLSTATE_support/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E171_SQLSTATE_support/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.E171_SQLSTATE_support;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E171_SQLSTATE_support/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E171_SQLSTATE_support/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E171_SQLSTATE_support/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E171_SQLSTATE_support/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E182_Host_language_binding/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E182_Host_language_binding/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E182_Host_language_binding/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E182_Host_language_binding/package-info.java	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.E182_Host_language_binding;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E182_Host_language_binding/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E182_Host_language_binding/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E182_Host_language_binding/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/E182_Host_language_binding/README.md	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F031_Basic_schema_manipulation/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F031_Basic_schema_manipulation/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F031_Basic_schema_manipulation/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F031_Basic_schema_manipulation/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F031_Basic_schema_manipulation;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F031_Basic_schema_manipulation/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F031_Basic_schema_manipulation/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F031_Basic_schema_manipulation/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F031_Basic_schema_manipulation/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F032_CASCADE_drop_behavior/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F032_CASCADE_drop_behavior/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F032_CASCADE_drop_behavior/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F032_CASCADE_drop_behavior/package-info.java	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F032_CASCADE_drop_behavior;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F032_CASCADE_drop_behavior/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F032_CASCADE_drop_behavior/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F032_CASCADE_drop_behavior/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F032_CASCADE_drop_behavior/README.md	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F033_ALTER_TABLE_statement_DROP_COLUMN_clause/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F033_ALTER_TABLE_statement_DROP_COLUMN_clause/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F033_ALTER_TABLE_statement_DROP_COLUMN_clause/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F033_ALTER_TABLE_statement_DROP_COLUMN_clause/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F033_ALTER_TABLE_statement_DROP_COLUMN_clause;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F033_ALTER_TABLE_statement_DROP_COLUMN_clause/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F033_ALTER_TABLE_statement_DROP_COLUMN_clause/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F033_ALTER_TABLE_statement_DROP_COLUMN_clause/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F033_ALTER_TABLE_statement_DROP_COLUMN_clause/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F034_Extended_REVOKE_statement/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F034_Extended_REVOKE_statement/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F034_Extended_REVOKE_statement/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F034_Extended_REVOKE_statement/package-info.java	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F034_Extended_REVOKE_statement;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F034_Extended_REVOKE_statement/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F034_Extended_REVOKE_statement/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F034_Extended_REVOKE_statement/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F034_Extended_REVOKE_statement/README.md	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F041_Basic_joined_table/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F041_Basic_joined_table/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F041_Basic_joined_table/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F041_Basic_joined_table/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F041_Basic_joined_table;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F041_Basic_joined_table/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F041_Basic_joined_table/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F041_Basic_joined_table/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F041_Basic_joined_table/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F051_Basic_date_and_time/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F051_Basic_date_and_time/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F051_Basic_date_and_time/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F051_Basic_date_and_time/package-info.java	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F051_Basic_date_and_time;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F051_Basic_date_and_time/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F051_Basic_date_and_time/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F051_Basic_date_and_time/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F051_Basic_date_and_time/README.md	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F052_Intervals_and_datetime_arithmetic/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F052_Intervals_and_datetime_arithmetic/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F052_Intervals_and_datetime_arithmetic/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F052_Intervals_and_datetime_arithmetic/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F052_Intervals_and_datetime_arithmetic;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F052_Intervals_and_datetime_arithmetic/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F052_Intervals_and_datetime_arithmetic/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F052_Intervals_and_datetime_arithmetic/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F052_Intervals_and_datetime_arithmetic/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F053_OVERLAPS_predicate/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F053_OVERLAPS_predicate/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F053_OVERLAPS_predicate/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F053_OVERLAPS_predicate/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F053_OVERLAPS_predicate;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F053_OVERLAPS_predicate/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F053_OVERLAPS_predicate/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F053_OVERLAPS_predicate/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F053_OVERLAPS_predicate/README.md	2022-03-09 18:43:42.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F081_UNION_and_EXCEPT_in_views/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F081_UNION_and_EXCEPT_in_views/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F081_UNION_and_EXCEPT_in_views/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F081_UNION_and_EXCEPT_in_views/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F081_UNION_and_EXCEPT_in_views;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F081_UNION_and_EXCEPT_in_views/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F081_UNION_and_EXCEPT_in_views/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F081_UNION_and_EXCEPT_in_views/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F081_UNION_and_EXCEPT_in_views/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F111_Isolation_levels_other_than_SERIALIZABLE/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F111_Isolation_levels_other_than_SERIALIZABLE/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F111_Isolation_levels_other_than_SERIALIZABLE/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F111_Isolation_levels_other_than_SERIALIZABLE/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F111_Isolation_levels_other_than_SERIALIZABLE;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F111_Isolation_levels_other_than_SERIALIZABLE/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F111_Isolation_levels_other_than_SERIALIZABLE/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F111_Isolation_levels_other_than_SERIALIZABLE/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F111_Isolation_levels_other_than_SERIALIZABLE/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F121_Basic_diagnostics_management/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F121_Basic_diagnostics_management/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F121_Basic_diagnostics_management/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F121_Basic_diagnostics_management/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F121_Basic_diagnostics_management;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F121_Basic_diagnostics_management/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F121_Basic_diagnostics_management/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F121_Basic_diagnostics_management/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F121_Basic_diagnostics_management/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F131_Grouped_operations/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F131_Grouped_operations/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F131_Grouped_operations/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F131_Grouped_operations/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F131_Grouped_operations;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F131_Grouped_operations/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F131_Grouped_operations/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F131_Grouped_operations/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F131_Grouped_operations/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F171_Multiple_schemas_per_user/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F171_Multiple_schemas_per_user/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F171_Multiple_schemas_per_user/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F171_Multiple_schemas_per_user/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F171_Multiple_schemas_per_user;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F171_Multiple_schemas_per_user/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F171_Multiple_schemas_per_user/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F171_Multiple_schemas_per_user/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F171_Multiple_schemas_per_user/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F191_Referential_delete_actions/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F191_Referential_delete_actions/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F191_Referential_delete_actions/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F191_Referential_delete_actions/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F191_Referential_delete_actions;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F191_Referential_delete_actions/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F191_Referential_delete_actions/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F191_Referential_delete_actions/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F191_Referential_delete_actions/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F201_CAST_function/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F201_CAST_function/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F201_CAST_function/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F201_CAST_function/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F201_CAST_function;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F201_CAST_function/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F201_CAST_function/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F201_CAST_function/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F201_CAST_function/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F221_Explicit_defaults/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F221_Explicit_defaults/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F221_Explicit_defaults/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F221_Explicit_defaults/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F221_Explicit_defaults;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F221_Explicit_defaults/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F221_Explicit_defaults/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F221_Explicit_defaults/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F221_Explicit_defaults/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F222_INSERT_statement_DEFAULT_VALUES_clause/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F222_INSERT_statement_DEFAULT_VALUES_clause/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F222_INSERT_statement_DEFAULT_VALUES_clause/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F222_INSERT_statement_DEFAULT_VALUES_clause/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F222_INSERT_statement_DEFAULT_VALUES_clause;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F222_INSERT_statement_DEFAULT_VALUES_clause/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F222_INSERT_statement_DEFAULT_VALUES_clause/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F222_INSERT_statement_DEFAULT_VALUES_clause/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F222_INSERT_statement_DEFAULT_VALUES_clause/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F231_Privilege_tables/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F231_Privilege_tables/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F231_Privilege_tables/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F231_Privilege_tables/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F231_Privilege_tables;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F231_Privilege_tables/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F231_Privilege_tables/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F231_Privilege_tables/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F231_Privilege_tables/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F251_Domain_support/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F251_Domain_support/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F251_Domain_support/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F251_Domain_support/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F251_Domain_support;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F251_Domain_support/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F251_Domain_support/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F251_Domain_support/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F251_Domain_support/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F261_CASE_expression/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F261_CASE_expression/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F261_CASE_expression/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F261_CASE_expression/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F261_CASE_expression;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F261_CASE_expression/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F261_CASE_expression/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F261_CASE_expression/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F261_CASE_expression/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F262_Extended_CASE_expression/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F262_Extended_CASE_expression/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F262_Extended_CASE_expression/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F262_Extended_CASE_expression/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F262_Extended_CASE_expression;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F262_Extended_CASE_expression/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F262_Extended_CASE_expression/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F262_Extended_CASE_expression/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F262_Extended_CASE_expression/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F263_Comma_separated_predicates_in_simple_CASE_expression/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F263_Comma_separated_predicates_in_simple_CASE_expression/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F263_Comma_separated_predicates_in_simple_CASE_expression/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F263_Comma_separated_predicates_in_simple_CASE_expression/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F263_Comma_separated_predicates_in_simple_CASE_expression;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F263_Comma_separated_predicates_in_simple_CASE_expression/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F263_Comma_separated_predicates_in_simple_CASE_expression/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F263_Comma_separated_predicates_in_simple_CASE_expression/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F263_Comma_separated_predicates_in_simple_CASE_expression/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F271_Compound_character_literals/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F271_Compound_character_literals/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F271_Compound_character_literals/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F271_Compound_character_literals/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F271_Compound_character_literals;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F271_Compound_character_literals/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F271_Compound_character_literals/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F271_Compound_character_literals/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F271_Compound_character_literals/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F281_LIKE_enhancements/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F281_LIKE_enhancements/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F281_LIKE_enhancements/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F281_LIKE_enhancements/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F281_LIKE_enhancements;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F281_LIKE_enhancements/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F281_LIKE_enhancements/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F281_LIKE_enhancements/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F281_LIKE_enhancements/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F291_UNIQUE_predicate/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F291_UNIQUE_predicate/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F291_UNIQUE_predicate/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F291_UNIQUE_predicate/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F291_UNIQUE_predicate;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F291_UNIQUE_predicate/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F291_UNIQUE_predicate/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F291_UNIQUE_predicate/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F291_UNIQUE_predicate/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F301_CORRESPONDING_in_query_expressions/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F301_CORRESPONDING_in_query_expressions/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F301_CORRESPONDING_in_query_expressions/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F301_CORRESPONDING_in_query_expressions/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F301_CORRESPONDING_in_query_expressions;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F301_CORRESPONDING_in_query_expressions/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F301_CORRESPONDING_in_query_expressions/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F301_CORRESPONDING_in_query_expressions/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F301_CORRESPONDING_in_query_expressions/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F302_INTERSECT_table_operator/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F302_INTERSECT_table_operator/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F302_INTERSECT_table_operator/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F302_INTERSECT_table_operator/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F302_INTERSECT_table_operator;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F302_INTERSECT_table_operator/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F302_INTERSECT_table_operator/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F302_INTERSECT_table_operator/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F302_INTERSECT_table_operator/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F304_EXCEPT_ALL_table_operator/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F304_EXCEPT_ALL_table_operator/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F304_EXCEPT_ALL_table_operator/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F304_EXCEPT_ALL_table_operator/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F304_EXCEPT_ALL_table_operator;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F304_EXCEPT_ALL_table_operator/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F304_EXCEPT_ALL_table_operator/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F304_EXCEPT_ALL_table_operator/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F304_EXCEPT_ALL_table_operator/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F311_Schema_definition_statement/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F311_Schema_definition_statement/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F311_Schema_definition_statement/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F311_Schema_definition_statement/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F311_Schema_definition_statement;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F311_Schema_definition_statement/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F311_Schema_definition_statement/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F311_Schema_definition_statement/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F311_Schema_definition_statement/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F312_MERGE_statement/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F312_MERGE_statement/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F312_MERGE_statement/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F312_MERGE_statement/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F312_MERGE_statement;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F312_MERGE_statement/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F312_MERGE_statement/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F312_MERGE_statement/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F312_MERGE_statement/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F321_User_authorization/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F321_User_authorization/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F321_User_authorization/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F321_User_authorization/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F321_User_authorization;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F321_User_authorization/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F321_User_authorization/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F321_User_authorization/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F321_User_authorization/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F361_Subprogram_support/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F361_Subprogram_support/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F361_Subprogram_support/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F361_Subprogram_support/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F361_Subprogram_support;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F361_Subprogram_support/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F361_Subprogram_support/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F361_Subprogram_support/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F361_Subprogram_support/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F381_Extended_schema_manipulation/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F381_Extended_schema_manipulation/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F381_Extended_schema_manipulation/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F381_Extended_schema_manipulation/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F381_Extended_schema_manipulation;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F381_Extended_schema_manipulation/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F381_Extended_schema_manipulation/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F381_Extended_schema_manipulation/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F381_Extended_schema_manipulation/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F391_Long_identifiers/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F391_Long_identifiers/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F391_Long_identifiers/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F391_Long_identifiers/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F391_Long_identifiers;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F391_Long_identifiers/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F391_Long_identifiers/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F391_Long_identifiers/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F391_Long_identifiers/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F392_Unicode_escapes_in_identifiers/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F392_Unicode_escapes_in_identifiers/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F392_Unicode_escapes_in_identifiers/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F392_Unicode_escapes_in_identifiers/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F392_Unicode_escapes_in_identifiers;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F392_Unicode_escapes_in_identifiers/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F392_Unicode_escapes_in_identifiers/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F392_Unicode_escapes_in_identifiers/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F392_Unicode_escapes_in_identifiers/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F393_Unicode_escapes_in_literals/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F393_Unicode_escapes_in_literals/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F393_Unicode_escapes_in_literals/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F393_Unicode_escapes_in_literals/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F393_Unicode_escapes_in_literals;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F393_Unicode_escapes_in_literals/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F393_Unicode_escapes_in_literals/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F393_Unicode_escapes_in_literals/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F393_Unicode_escapes_in_literals/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F401_Extended_joined_table/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F401_Extended_joined_table/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F401_Extended_joined_table/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F401_Extended_joined_table/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F401_Extended_joined_table;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F401_Extended_joined_table/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F401_Extended_joined_table/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F401_Extended_joined_table/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F401_Extended_joined_table/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F402_Named_column_joins_for_LOBs_arrays_and_multisets/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F402_Named_column_joins_for_LOBs_arrays_and_multisets/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F402_Named_column_joins_for_LOBs_arrays_and_multisets/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F402_Named_column_joins_for_LOBs_arrays_and_multisets/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F402_Named_column_joins_for_LOBs_arrays_and_multisets;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F402_Named_column_joins_for_LOBs_arrays_and_multisets/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F402_Named_column_joins_for_LOBs_arrays_and_multisets/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F402_Named_column_joins_for_LOBs_arrays_and_multisets/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F402_Named_column_joins_for_LOBs_arrays_and_multisets/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F411_Time_zone_specification/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F411_Time_zone_specification/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F411_Time_zone_specification/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F411_Time_zone_specification/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F411_Time_zone_specification;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F411_Time_zone_specification/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F411_Time_zone_specification/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F411_Time_zone_specification/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F411_Time_zone_specification/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F421_National_character/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F421_National_character/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F421_National_character/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F421_National_character/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F421_National_character;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F421_National_character/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F421_National_character/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F421_National_character/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F421_National_character/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F441_Extended_set_function_support/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F441_Extended_set_function_support/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F441_Extended_set_function_support/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F441_Extended_set_function_support/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F441_Extended_set_function_support;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F441_Extended_set_function_support/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F441_Extended_set_function_support/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F441_Extended_set_function_support/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F441_Extended_set_function_support/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F442_Mixed_column_references_in_set_functions/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F442_Mixed_column_references_in_set_functions/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F442_Mixed_column_references_in_set_functions/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F442_Mixed_column_references_in_set_functions/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F442_Mixed_column_references_in_set_functions;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F442_Mixed_column_references_in_set_functions/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F442_Mixed_column_references_in_set_functions/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F442_Mixed_column_references_in_set_functions/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F442_Mixed_column_references_in_set_functions/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F451_Character_set_definition/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F451_Character_set_definition/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F451_Character_set_definition/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F451_Character_set_definition/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F451_Character_set_definition;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F451_Character_set_definition/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F451_Character_set_definition/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F451_Character_set_definition/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F451_Character_set_definition/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F461_Named_character_sets/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F461_Named_character_sets/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F461_Named_character_sets/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F461_Named_character_sets/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F461_Named_character_sets;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F461_Named_character_sets/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F461_Named_character_sets/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F461_Named_character_sets/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F461_Named_character_sets/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F471_Scalar_subquery_values/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F471_Scalar_subquery_values/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F471_Scalar_subquery_values/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F471_Scalar_subquery_values/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F471_Scalar_subquery_values;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F471_Scalar_subquery_values/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F471_Scalar_subquery_values/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F471_Scalar_subquery_values/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F471_Scalar_subquery_values/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F481_Expanded_NULL_predicate/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F481_Expanded_NULL_predicate/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F481_Expanded_NULL_predicate/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F481_Expanded_NULL_predicate/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F481_Expanded_NULL_predicate;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F481_Expanded_NULL_predicate/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F481_Expanded_NULL_predicate/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F481_Expanded_NULL_predicate/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F481_Expanded_NULL_predicate/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F491_Constraint_management/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F491_Constraint_management/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F491_Constraint_management/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F491_Constraint_management/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F491_Constraint_management;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F491_Constraint_management/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F491_Constraint_management/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F491_Constraint_management/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F491_Constraint_management/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F531_Temporary_tables/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F531_Temporary_tables/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F531_Temporary_tables/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F531_Temporary_tables/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F531_Temporary_tables;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F531_Temporary_tables/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F531_Temporary_tables/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F531_Temporary_tables/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F531_Temporary_tables/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F555_Enhanced_seconds_precision/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F555_Enhanced_seconds_precision/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F555_Enhanced_seconds_precision/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F555_Enhanced_seconds_precision/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F555_Enhanced_seconds_precision;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F555_Enhanced_seconds_precision/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F555_Enhanced_seconds_precision/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F555_Enhanced_seconds_precision/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F555_Enhanced_seconds_precision/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F561_Full_value_expressions/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F561_Full_value_expressions/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F561_Full_value_expressions/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F561_Full_value_expressions/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F561_Full_value_expressions;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F561_Full_value_expressions/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F561_Full_value_expressions/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F561_Full_value_expressions/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F561_Full_value_expressions/README.md	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F571_Truth_value_tests/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F571_Truth_value_tests/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F571_Truth_value_tests/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F571_Truth_value_tests/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F571_Truth_value_tests;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F571_Truth_value_tests/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F571_Truth_value_tests/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F571_Truth_value_tests/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F571_Truth_value_tests/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F591_Derived_tables/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F591_Derived_tables/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F591_Derived_tables/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F591_Derived_tables/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F591_Derived_tables;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F591_Derived_tables/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F591_Derived_tables/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F591_Derived_tables/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F591_Derived_tables/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F641_Row_and_table_constructors/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F641_Row_and_table_constructors/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F641_Row_and_table_constructors/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F641_Row_and_table_constructors/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F641_Row_and_table_constructors;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F641_Row_and_table_constructors/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F641_Row_and_table_constructors/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F641_Row_and_table_constructors/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F641_Row_and_table_constructors/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F651_Catalog_name_qualifiers/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F651_Catalog_name_qualifiers/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F651_Catalog_name_qualifiers/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F651_Catalog_name_qualifiers/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F651_Catalog_name_qualifiers;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F651_Catalog_name_qualifiers/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F651_Catalog_name_qualifiers/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F651_Catalog_name_qualifiers/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F651_Catalog_name_qualifiers/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F661_Simple_tables/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F661_Simple_tables/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F661_Simple_tables/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F661_Simple_tables/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F661_Simple_tables;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F661_Simple_tables/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F661_Simple_tables/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F661_Simple_tables/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F661_Simple_tables/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F672_Retrospective_check_constraints/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F672_Retrospective_check_constraints/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F672_Retrospective_check_constraints/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F672_Retrospective_check_constraints/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F672_Retrospective_check_constraints;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F672_Retrospective_check_constraints/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F672_Retrospective_check_constraints/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F672_Retrospective_check_constraints/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F672_Retrospective_check_constraints/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F690_Collation_support/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F690_Collation_support/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F690_Collation_support/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F690_Collation_support/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F690_Collation_support;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F690_Collation_support/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F690_Collation_support/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F690_Collation_support/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F690_Collation_support/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F692_Enhanced_collation_support/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F692_Enhanced_collation_support/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F692_Enhanced_collation_support/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F692_Enhanced_collation_support/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F692_Enhanced_collation_support;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F692_Enhanced_collation_support/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F692_Enhanced_collation_support/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F692_Enhanced_collation_support/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F692_Enhanced_collation_support/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F701_Referential_update_actions/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F701_Referential_update_actions/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F701_Referential_update_actions/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F701_Referential_update_actions/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F701_Referential_update_actions;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F701_Referential_update_actions/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F701_Referential_update_actions/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F701_Referential_update_actions/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F701_Referential_update_actions/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F711_ALTER_domain/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F711_ALTER_domain/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F711_ALTER_domain/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F711_ALTER_domain/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F711_ALTER_domain;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F711_ALTER_domain/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F711_ALTER_domain/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F711_ALTER_domain/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F711_ALTER_domain/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F731_INSERT_column_privileges/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F731_INSERT_column_privileges/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F731_INSERT_column_privileges/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F731_INSERT_column_privileges/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F731_INSERT_column_privileges;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F731_INSERT_column_privileges/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F731_INSERT_column_privileges/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F731_INSERT_column_privileges/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F731_INSERT_column_privileges/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F741_Referential_MATCH_types/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F741_Referential_MATCH_types/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F741_Referential_MATCH_types/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F741_Referential_MATCH_types/package-info.java	2022-03-09 18:43:44.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F741_Referential_MATCH_types;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F741_Referential_MATCH_types/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F741_Referential_MATCH_types/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F741_Referential_MATCH_types/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F741_Referential_MATCH_types/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F751_View_CHECK_enhancements/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F751_View_CHECK_enhancements/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F751_View_CHECK_enhancements/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F751_View_CHECK_enhancements/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F751_View_CHECK_enhancements;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F751_View_CHECK_enhancements/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F751_View_CHECK_enhancements/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F751_View_CHECK_enhancements/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F751_View_CHECK_enhancements/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F762_CURRENT_CATALOG/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F762_CURRENT_CATALOG/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F762_CURRENT_CATALOG/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F762_CURRENT_CATALOG/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F762_CURRENT_CATALOG;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F762_CURRENT_CATALOG/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F762_CURRENT_CATALOG/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F762_CURRENT_CATALOG/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F762_CURRENT_CATALOG/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F763_CURRENT_SCHEMA/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F763_CURRENT_SCHEMA/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F763_CURRENT_SCHEMA/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F763_CURRENT_SCHEMA/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F763_CURRENT_SCHEMA;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F763_CURRENT_SCHEMA/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F763_CURRENT_SCHEMA/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F763_CURRENT_SCHEMA/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F763_CURRENT_SCHEMA/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F801_Full_set_function/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F801_Full_set_function/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F801_Full_set_function/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F801_Full_set_function/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F801_Full_set_function;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F801_Full_set_function/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F801_Full_set_function/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F801_Full_set_function/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F801_Full_set_function/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F821_Local_table_references/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F821_Local_table_references/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F821_Local_table_references/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F821_Local_table_references/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F821_Local_table_references;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F821_Local_table_references/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F821_Local_table_references/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F821_Local_table_references/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F821_Local_table_references/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F850_Top_level_order_by_clause_in_query_expression/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F850_Top_level_order_by_clause_in_query_expression/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F850_Top_level_order_by_clause_in_query_expression/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F850_Top_level_order_by_clause_in_query_expression/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F850_Top_level_order_by_clause_in_query_expression;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F850_Top_level_order_by_clause_in_query_expression/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F850_Top_level_order_by_clause_in_query_expression/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F850_Top_level_order_by_clause_in_query_expression/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F850_Top_level_order_by_clause_in_query_expression/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F851_order_by_clause_in_subqueries/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F851_order_by_clause_in_subqueries/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F851_order_by_clause_in_subqueries/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F851_order_by_clause_in_subqueries/package-info.java	2022-03-09 18:43:48.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F851_order_by_clause_in_subqueries;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F851_order_by_clause_in_subqueries/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F851_order_by_clause_in_subqueries/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F851_order_by_clause_in_subqueries/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F851_order_by_clause_in_subqueries/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F852_Top_level_order_by_clause_in_views/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F852_Top_level_order_by_clause_in_views/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F852_Top_level_order_by_clause_in_views/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F852_Top_level_order_by_clause_in_views/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F852_Top_level_order_by_clause_in_views;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F852_Top_level_order_by_clause_in_views/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F852_Top_level_order_by_clause_in_views/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F852_Top_level_order_by_clause_in_views/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F852_Top_level_order_by_clause_in_views/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F855_Nested_order_by_clause_in_query_expression/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F855_Nested_order_by_clause_in_query_expression/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F855_Nested_order_by_clause_in_query_expression/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F855_Nested_order_by_clause_in_query_expression/package-info.java	2022-03-09 18:43:48.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F855_Nested_order_by_clause_in_query_expression;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F855_Nested_order_by_clause_in_query_expression/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F855_Nested_order_by_clause_in_query_expression/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F855_Nested_order_by_clause_in_query_expression/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F855_Nested_order_by_clause_in_query_expression/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F856_Nested_fetch_first_clause_in_query_expression/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F856_Nested_fetch_first_clause_in_query_expression/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F856_Nested_fetch_first_clause_in_query_expression/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F856_Nested_fetch_first_clause_in_query_expression/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F856_Nested_fetch_first_clause_in_query_expression;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F856_Nested_fetch_first_clause_in_query_expression/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F856_Nested_fetch_first_clause_in_query_expression/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F856_Nested_fetch_first_clause_in_query_expression/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F856_Nested_fetch_first_clause_in_query_expression/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F857_Top_level_fetch_first_clause_in_query_expression/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F857_Top_level_fetch_first_clause_in_query_expression/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F857_Top_level_fetch_first_clause_in_query_expression/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F857_Top_level_fetch_first_clause_in_query_expression/package-info.java	2022-03-09 18:43:48.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation.F857_Top_level_fetch_first_clause_in_query_expression;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F857_Top_level_fetch_first_clause_in_query_expression/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F857_Top_level_fetch_first_clause_in_query_expression/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F857_Top_level_fetch_first_clause_in_query_expression/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/F857_Top_level_fetch_first_clause_in_query_expression/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_2_SQL_Foundation;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_2_SQL_Foundation/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_3_SQLCLI_Call_Level_Interface/C011_All_facilities_defined_by this_part_of_9075/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_3_SQLCLI_Call_Level_Interface/C011_All_facilities_defined_by this_part_of_9075/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_3_SQLCLI_Call_Level_Interface/C011_All_facilities_defined_by this_part_of_9075/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_3_SQLCLI_Call_Level_Interface/C011_All_facilities_defined_by this_part_of_9075/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_3_SQLCLI_Call_Level_Interface/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_3_SQLCLI_Call_Level_Interface/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_3_SQLCLI_Call_Level_Interface/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_3_SQLCLI_Call_Level_Interface/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_3_SQLCLI_Call_Level_Interface;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_3_SQLCLI_Call_Level_Interface/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_3_SQLCLI_Call_Level_Interface/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_3_SQLCLI_Call_Level_Interface/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_3_SQLCLI_Call_Level_Interface/README.md	2022-03-09 18:43:48.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P001_Stored_modules/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P001_Stored_modules/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P001_Stored_modules/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P001_Stored_modules/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules.P001_Stored_modules;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P001_Stored_modules/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P001_Stored_modules/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P001_Stored_modules/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P001_Stored_modules/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P002_Computational_completeness/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P002_Computational_completeness/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P002_Computational_completeness/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P002_Computational_completeness/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules.P002_Computational_completeness;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P002_Computational_completeness/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P002_Computational_completeness/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P002_Computational_completeness/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P002_Computational_completeness/README.md	2022-03-09 18:43:48.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P003_Information_Schema_views/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P003_Information_Schema_views/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P003_Information_Schema_views/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P003_Information_Schema_views/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules.P003_Information_Schema_views;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P003_Information_Schema_views/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P003_Information_Schema_views/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P003_Information_Schema_views/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P003_Information_Schema_views/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P004_Extended_CASE_statement/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P004_Extended_CASE_statement/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P004_Extended_CASE_statement/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P004_Extended_CASE_statement/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules.P004_Extended_CASE_statement;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P004_Extended_CASE_statement/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P004_Extended_CASE_statement/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P004_Extended_CASE_statement/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P004_Extended_CASE_statement/README.md	2022-03-09 18:43:48.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P005_Qualified_SQL_variable_references/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P005_Qualified_SQL_variable_references/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P005_Qualified_SQL_variable_references/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P005_Qualified_SQL_variable_references/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules.P005_Qualified_SQL_variable_references;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P005_Qualified_SQL_variable_references/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P005_Qualified_SQL_variable_references/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P005_Qualified_SQL_variable_references/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P005_Qualified_SQL_variable_references/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P006_Multiple_assignment/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P006_Multiple_assignment/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P006_Multiple_assignment/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P006_Multiple_assignment/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules.P006_Multiple_assignment;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P006_Multiple_assignment/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P006_Multiple_assignment/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P006_Multiple_assignment/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P006_Multiple_assignment/README.md	2022-03-09 18:43:48.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P007_Enhanced_diagnostics_management/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P007_Enhanced_diagnostics_management/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P007_Enhanced_diagnostics_management/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P007_Enhanced_diagnostics_management/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules.P007_Enhanced_diagnostics_management;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P007_Enhanced_diagnostics_management/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P007_Enhanced_diagnostics_management/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P007_Enhanced_diagnostics_management/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P007_Enhanced_diagnostics_management/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P008_Commas_separated_predicates_in_a_CASE_statement/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P008_Commas_separated_predicates_in_a_CASE_statement/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P008_Commas_separated_predicates_in_a_CASE_statement/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P008_Commas_separated_predicates_in_a_CASE_statement/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules.P008_Commas_separated_predicates_in_a_CASE_statement;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P008_Commas_separated_predicates_in_a_CASE_statement/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P008_Commas_separated_predicates_in_a_CASE_statement/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P008_Commas_separated_predicates_in_a_CASE_statement/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/P008_Commas_separated_predicates_in_a_CASE_statement/README.md	2022-03-09 18:43:48.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_4_SQLPSM_Persistent_Stored_Modules/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M001_Datalinks/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M001_Datalinks/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M001_Datalinks/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M001_Datalinks/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_9_SQLMED_Management_of_External_Data.M001_Datalinks;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M001_Datalinks/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M001_Datalinks/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M001_Datalinks/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M001_Datalinks/README.md	2022-03-09 18:43:48.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M002_Datalinks_via_SQLCLI/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M002_Datalinks_via_SQLCLI/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M002_Datalinks_via_SQLCLI/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M002_Datalinks_via_SQLCLI/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_9_SQLMED_Management_of_External_Data.M002_Datalinks_via_SQLCLI;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M002_Datalinks_via_SQLCLI/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M002_Datalinks_via_SQLCLI/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M002_Datalinks_via_SQLCLI/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M002_Datalinks_via_SQLCLI/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M003_Datalinks_via_Embedded_SQL/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M003_Datalinks_via_Embedded_SQL/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M003_Datalinks_via_Embedded_SQL/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M003_Datalinks_via_Embedded_SQL/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_9_SQLMED_Management_of_External_Data.M003_Datalinks_via_Embedded_SQL;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M003_Datalinks_via_Embedded_SQL/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M003_Datalinks_via_Embedded_SQL/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M003_Datalinks_via_Embedded_SQL/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M003_Datalinks_via_Embedded_SQL/README.md	2022-03-09 18:43:48.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M004_Foreign_data_support/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M004_Foreign_data_support/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M004_Foreign_data_support/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M004_Foreign_data_support/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_9_SQLMED_Management_of_External_Data.M004_Foreign_data_support;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M004_Foreign_data_support/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M004_Foreign_data_support/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M004_Foreign_data_support/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M004_Foreign_data_support/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M005_Foreign_schema_support/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M005_Foreign_schema_support/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M005_Foreign_schema_support/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M005_Foreign_schema_support/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_9_SQLMED_Management_of_External_Data.M005_Foreign_schema_support;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M005_Foreign_schema_support/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M005_Foreign_schema_support/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M005_Foreign_schema_support/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M005_Foreign_schema_support/README.md	2022-03-09 18:43:48.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M006_GetSQLString_routine/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M006_GetSQLString_routine/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M006_GetSQLString_routine/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M006_GetSQLString_routine/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_9_SQLMED_Management_of_External_Data.M006_GetSQLString_routine;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M006_GetSQLString_routine/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M006_GetSQLString_routine/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M006_GetSQLString_routine/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M006_GetSQLString_routine/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M007_TransmitRequest/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M007_TransmitRequest/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M007_TransmitRequest/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M007_TransmitRequest/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_9_SQLMED_Management_of_External_Data.M007_TransmitRequest;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M007_TransmitRequest/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M007_TransmitRequest/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M007_TransmitRequest/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M007_TransmitRequest/README.md	2022-03-09 18:43:48.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M009_GetOpts_and_GetStatistics_routines/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M009_GetOpts_and_GetStatistics_routines/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M009_GetOpts_and_GetStatistics_routines/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M009_GetOpts_and_GetStatistics_routines/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_9_SQLMED_Management_of_External_Data.M009_GetOpts_and_GetStatistics_routines;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M009_GetOpts_and_GetStatistics_routines/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M009_GetOpts_and_GetStatistics_routines/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M009_GetOpts_and_GetStatistics_routines/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M009_GetOpts_and_GetStatistics_routines/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M010_Foreign_data_wrapper_support/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M010_Foreign_data_wrapper_support/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M010_Foreign_data_wrapper_support/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M010_Foreign_data_wrapper_support/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_9_SQLMED_Management_of_External_Data.M010_Foreign_data_wrapper_support;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M010_Foreign_data_wrapper_support/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M010_Foreign_data_wrapper_support/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M010_Foreign_data_wrapper_support/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M010_Foreign_data_wrapper_support/README.md	2022-03-09 18:43:48.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M030_SQL_server_foreign_data_support/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M030_SQL_server_foreign_data_support/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M030_SQL_server_foreign_data_support/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M030_SQL_server_foreign_data_support/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_9_SQLMED_Management_of_External_Data.M030_SQL_server_foreign_data_support;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M030_SQL_server_foreign_data_support/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M030_SQL_server_foreign_data_support/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M030_SQL_server_foreign_data_support/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M030_SQL_server_foreign_data_support/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M031_Foreign_data_wrapper_general_routines/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M031_Foreign_data_wrapper_general_routines/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M031_Foreign_data_wrapper_general_routines/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M031_Foreign_data_wrapper_general_routines/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_9_SQLMED_Management_of_External_Data.M031_Foreign_data_wrapper_general_routines;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M031_Foreign_data_wrapper_general_routines/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M031_Foreign_data_wrapper_general_routines/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M031_Foreign_data_wrapper_general_routines/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/M031_Foreign_data_wrapper_general_routines/README.md	2022-03-09 18:43:48.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn.ISO_IEC_9075_9_SQLMED_Management_of_External_Data;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/ISO_IEC_9075_9_SQLMED_Management_of_External_Data/README.md	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/package-info.java 2.7.0-1/hsqldb/testrun/sql2nnn/package-info.java
--- 2.6.1-1/hsqldb/testrun/sql2nnn/package-info.java	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/package-info.java	2022-03-09 18:43:46.000000000 +0000
@@ -0,0 +1 @@
+package sql2nnn;
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/README.md 2.7.0-1/hsqldb/testrun/sql2nnn/README.md
--- 2.6.1-1/hsqldb/testrun/sql2nnn/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/README.md	2022-03-09 18:43:48.000000000 +0000
@@ -0,0 +1,3 @@
+@todo - title, description, sql and / or groovy scripts for 9075 feature compliance
+
++ Contrubutions Welcome
diff -pruN 2.6.1-1/hsqldb/testrun/sql2nnn/title.sql 2.7.0-1/hsqldb/testrun/sql2nnn/title.sql
--- 2.6.1-1/hsqldb/testrun/sql2nnn/title.sql	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sql2nnn/title.sql	2022-05-18 07:29:06.000000000 +0000
@@ -0,0 +1 @@
+select 'ISO IEC 9075 feature compliance test suite' as title from (values('')) dual(dummy)
diff -pruN 2.6.1-1/hsqldb/testrun/sqltool/build.gradle 2.7.0-1/hsqldb/testrun/sqltool/build.gradle
--- 2.6.1-1/hsqldb/testrun/sqltool/build.gradle	2018-10-23 07:24:56.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sqltool/build.gradle	1970-01-01 00:00:00.000000000 +0000
@@ -1,14 +0,0 @@
-defaultTasks 'runTests'
-
-task runTests << {
-    def params = ['NO_JVM_EXIT']
-    boolean verbose =
-            project.hasProperty('verbose') && project.property('verbose')
-    if (verbose) params << '-v'
-    if (project.hasProperty('norun') && project.property('norun'))
-        params << '-n'
-    if (project.hasProperty('scripts'))
-        params.addAll(project.property('scripts').split(','))
-    if (!verbose) System.console().writer().print('  ')
-    run(new File('runtests.groovy'), params as String[])
-}
diff -pruN 2.6.1-1/hsqldb/testrun/sqltool/re.inter 2.7.0-1/hsqldb/testrun/sqltool/re.inter
--- 2.6.1-1/hsqldb/testrun/sqltool/re.inter	1970-01-01 00:00:00.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sqltool/re.inter	2022-02-21 14:42:06.000000000 +0000
@@ -0,0 +1,4 @@
+CALL 'token';
+CALL 'other';
+:/tok/;
+*if (*? != token) \q Token is not 'token' but: *{?}
diff -pruN 2.6.1-1/hsqldb/testrun/sqltool/runtests.bash 2.7.0-1/hsqldb/testrun/sqltool/runtests.bash
--- 2.6.1-1/hsqldb/testrun/sqltool/runtests.bash	2018-10-23 07:24:58.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sqltool/runtests.bash	1970-01-01 00:00:00.000000000 +0000
@@ -1,66 +0,0 @@
-#!/bin/bash -p
-PROGNAME="${0##*/}"
-
-# $Id: runtests.bash 4697 2011-11-04 13:32:05Z unsaved $
-# Distribution is permitted under the terms of the HSQLDB license.
-# (c) 2011 The HSQL Development Group
-#
-# Wrapper that serves two purposes:
-# (1) Takes traditional parameters in format: command -switches... filenames...
-#     and converts to a Gradle command of format: Gradle -P x=y...  taskname
-# (2) Invokes the 'gradlew' wrapper script supplied by the HyperSQL
-#     distribution.
-# This script automatically 'cd's to directory .../testrun/sqltool in which
-# it resides, so that it may be safely executed from desktop managers, etc.
-# The main work script, "runtests.groovy" does not have this limitation.
-#
-# author: Blaine Simpson, unsaved@users.sourceforge.net
-# since: HSQLDB 1.8.0.8 / 1.9.x
-# see:  README.txt in this same directory.
-# In November 2011 this script converted from the sole test runner script, to
-# one wrapper for Gradle (w/ "build.gradle") + runtests.groovy.
-
-set +u
-shopt -s xpg_echo   # This will fail for very old implementations of Bash
-
-SYNTAX_MSG="$PROGNAME [-nvh] [testscript.sql...]
-With -v, output from SqlTool will be shown.  Otherwise, only tests and results
-will be shown.
-If no script names are supplied, *.sql and *.nsql from the current directory 
-will be executed.
-Exit value is number of test failures, or 1 for other errors or if number of
-test failures exceeds 255 (shell scripts can't handle exit values > 255).
-
-Non-verbose Result Key:
-    T = Testing
-    + = test Succeeded
-    - = test Failed"
-
-while [ $# -gt 0 ]; do case "$1" in -*)
-    case "$1" in *v*) VERBOSE=1;; esac
-    case "$1" in *n*) NORUN=1;; esac
-    case "$1" in *h*)
-        echo "$SYNTAX_MSG"
-        exit 0
-    ;; esac
-    shift;;
-  *) break 2;;
-esac; done
-
-case "$0" in
-/*) SCRIPTDIR="${0%/*}";; */*) SCRIPTDIR="$PWD/${0%/*}";; *) SCRIPTDIR="$PWD";;
-esac
-case "$SCRIPTDIR" in *?/.) SCRIPTDIR="${SCRIPTDIR%/.}"; esac
-
-cd "$SCRIPTDIR"
-
-scriptsString=
-while [ $# -gt 0 ]; do
-    scriptsString="$scriptsString$1"
-    shift
-    [ $# -gt 0 ] && scriptsString="$scriptsString,"
-done
-
-[ -n "$VERBOSE" ] &&
-echo ../../build/gradlew ${VERBOSE:+-Pverbose=true} ${NORUN:+-Pnorun=true} ${scriptsString:+-Pscripts=$scriptsString}
-exec ../../build/gradlew ${VERBOSE:+-Pverbose=true} ${NORUN:+-Pnorun=true} ${scriptsString:+-Pscripts=$scriptsString}
diff -pruN 2.6.1-1/hsqldb/testrun/sqltool/runtests.groovy 2.7.0-1/hsqldb/testrun/sqltool/runtests.groovy
--- 2.6.1-1/hsqldb/testrun/sqltool/runtests.groovy	2018-10-23 07:24:58.000000000 +0000
+++ 2.7.0-1/hsqldb/testrun/sqltool/runtests.groovy	2022-02-21 14:42:08.000000000 +0000
@@ -1,6 +1,6 @@
-#!/local/groovy/bin/groovy
+#!/usr/bin/env groovy
 /*
- * $Id: runtests.groovy 4809 2011-11-20 21:12:35Z unsaved $
+ * $Id: runtests.groovy 6377 2021-11-18 14:51:35Z unsaved $
  * Distribution is permitted under the terms of the HSQLDB license.
  * (c) 2011 The HSQL Development Group
  */
